# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class S1AP_CommonDataTypes:

    _name_  = u'S1AP-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 21, 3, 1, 1, 3]
    
    _obj_ = [
        u'Criticality',
        u'Presence',
        u'PrivateIE-ID',
        u'ProcedureCode',
        u'ProtocolExtensionID',
        u'ProtocolIE-ID',
        u'TriggeringMessage',
        ]
    _type_ = [
        u'Criticality',
        u'Presence',
        u'PrivateIE-ID',
        u'ProcedureCode',
        u'ProtocolExtensionID',
        u'ProtocolIE-ID',
        u'TriggeringMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Criticality >-----#
    Criticality = ENUM(name=u'Criticality', mode=MODE_TYPE)
    Criticality._cont = ASN1Dict([(u'reject', 0), (u'ignore', 1), (u'notify', 2)])
    Criticality._ext = None
    
    #-----< Presence >-----#
    Presence = ENUM(name=u'Presence', mode=MODE_TYPE)
    Presence._cont = ASN1Dict([(u'optional', 0), (u'conditional', 1), (u'mandatory', 2)])
    Presence._ext = None
    
    #-----< PrivateIE-ID >-----#
    PrivateIE_ID = CHOICE(name=u'PrivateIE-ID', mode=MODE_TYPE)
    _PrivateIE_ID_local = INT(name=u'local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrivateIE_ID_local._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PrivateIE_ID_global_ = OID(name=u'global', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PrivateIE_ID._cont = ASN1Dict([
        (u'local', _PrivateIE_ID_local),
        (u'global', _PrivateIE_ID_global_),
        ])
    PrivateIE_ID._ext = None
    
    #-----< ProcedureCode >-----#
    ProcedureCode = INT(name=u'ProcedureCode', mode=MODE_TYPE)
    ProcedureCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ProtocolExtensionID >-----#
    ProtocolExtensionID = INT(name=u'ProtocolExtensionID', mode=MODE_TYPE)
    ProtocolExtensionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< ProtocolIE-ID >-----#
    ProtocolIE_ID = INT(name=u'ProtocolIE-ID', mode=MODE_TYPE)
    ProtocolIE_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TriggeringMessage >-----#
    TriggeringMessage = ENUM(name=u'TriggeringMessage', mode=MODE_TYPE)
    TriggeringMessage._cont = ASN1Dict([(u'initiating-message', 0), (u'successful-outcome', 1), (u'unsuccessfull-outcome', 2)])
    TriggeringMessage._ext = None
    
    _all_ = [
        Criticality,
        Presence,
        _PrivateIE_ID_local,
        _PrivateIE_ID_global_,
        PrivateIE_ID,
        ProcedureCode,
        ProtocolExtensionID,
        ProtocolIE_ID,
        TriggeringMessage,
    ]

class S1AP_Constants:

    _name_  = u'S1AP-Constants'
    _oid_   = [0, 4, 0, 0, 21, 3, 1, 1, 4]
    
    _obj_ = [
        u'id-HandoverPreparation',
        u'id-HandoverResourceAllocation',
        u'id-HandoverNotification',
        u'id-PathSwitchRequest',
        u'id-HandoverCancel',
        u'id-E-RABSetup',
        u'id-E-RABModify',
        u'id-E-RABRelease',
        u'id-E-RABReleaseIndication',
        u'id-InitialContextSetup',
        u'id-Paging',
        u'id-downlinkNASTransport',
        u'id-initialUEMessage',
        u'id-uplinkNASTransport',
        u'id-Reset',
        u'id-ErrorIndication',
        u'id-NASNonDeliveryIndication',
        u'id-S1Setup',
        u'id-UEContextReleaseRequest',
        u'id-DownlinkS1cdma2000tunnelling',
        u'id-UplinkS1cdma2000tunnelling',
        u'id-UEContextModification',
        u'id-UECapabilityInfoIndication',
        u'id-UEContextRelease',
        u'id-eNBStatusTransfer',
        u'id-MMEStatusTransfer',
        u'id-DeactivateTrace',
        u'id-TraceStart',
        u'id-TraceFailureIndication',
        u'id-ENBConfigurationUpdate',
        u'id-MMEConfigurationUpdate',
        u'id-LocationReportingControl',
        u'id-LocationReportingFailureIndication',
        u'id-LocationReport',
        u'id-OverloadStart',
        u'id-OverloadStop',
        u'id-WriteReplaceWarning',
        u'id-eNBDirectInformationTransfer',
        u'id-MMEDirectInformationTransfer',
        u'id-PrivateMessage',
        u'id-eNBConfigurationTransfer',
        u'id-MMEConfigurationTransfer',
        u'id-CellTrafficTrace',
        u'id-Kill',
        u'id-downlinkUEAssociatedLPPaTransport',
        u'id-uplinkUEAssociatedLPPaTransport',
        u'id-downlinkNonUEAssociatedLPPaTransport',
        u'id-uplinkNonUEAssociatedLPPaTransport',
        u'id-UERadioCapabilityMatch',
        u'id-PWSRestartIndication',
        u'id-E-RABModificationIndication',
        u'id-PWSFailureIndication',
        u'id-RerouteNASRequest',
        u'id-UEContextModificationIndication',
        u'id-ConnectionEstablishmentIndication',
        u'id-UEContextSuspend',
        u'id-UEContextResume',
        u'id-NASDeliveryIndication',
        u'id-RetrieveUEInformation',
        u'id-UEInformationTransfer',
        u'id-eNBCPRelocationIndication',
        u'id-MMECPRelocationIndication',
        u'id-SecondaryRATDataUsageReport',
        u'id-UERadioCapabilityIDMapping',
        u'id-HandoverSuccess',
        u'id-eNBEarlyStatusTransfer',
        u'id-MMEEarlyStatusTransfer',
        u'maxPrivateIEs',
        u'maxProtocolExtensions',
        u'maxProtocolIEs',
        u'maxnoofCSGs',
        u'maxnoofE-RABs',
        u'maxnoofTAIs',
        u'maxnoofTACs',
        u'maxnoofErrors',
        u'maxnoofBPLMNs',
        u'maxnoofPLMNsPerMME',
        u'maxnoofEPLMNs',
        u'maxnoofEPLMNsPlusOne',
        u'maxnoofForbLACs',
        u'maxnoofForbTACs',
        u'maxnoofIndividualS1ConnectionsToReset',
        u'maxnoofCellsinUEHistoryInfo',
        u'maxnoofCellsineNB',
        u'maxnoofTAIforWarning',
        u'maxnoofCellID',
        u'maxnoofDCNs',
        u'maxnoofEmergencyAreaID',
        u'maxnoofCellinTAI',
        u'maxnoofCellinEAI',
        u'maxnoofeNBX2TLAs',
        u'maxnoofeNBX2ExtTLAs',
        u'maxnoofeNBX2GTPTLAs',
        u'maxnoofRATs',
        u'maxnoofGroupIDs',
        u'maxnoofMMECs',
        u'maxnoofCellIDforMDT',
        u'maxnoofTAforMDT',
        u'maxnoofMDTPLMNs',
        u'maxnoofCellsforRestart',
        u'maxnoofRestartTAIs',
        u'maxnoofRestartEmergencyAreaIDs',
        u'maxEARFCN',
        u'maxnoofMBSFNAreaMDT',
        u'maxnoofRecommendedCells',
        u'maxnoofRecommendedENBs',
        u'maxnooftimeperiods',
        u'maxnoofCellIDforQMC',
        u'maxnoofTAforQMC',
        u'maxnoofPLMNforQMC',
        u'maxnoofBluetoothName',
        u'maxnoofWLANName',
        u'maxnoofConnectedengNBs',
        u'maxnoofPC5QoSFlows',
        u'maxnooffrequencies',
        u'maxNARFCN',
        u'maxRS-IndexCellQual',
        u'id-MME-UE-S1AP-ID',
        u'id-HandoverType',
        u'id-Cause',
        u'id-SourceID',
        u'id-TargetID',
        u'id-eNB-UE-S1AP-ID',
        u'id-E-RABSubjecttoDataForwardingList',
        u'id-E-RABtoReleaseListHOCmd',
        u'id-E-RABDataForwardingItem',
        u'id-E-RABReleaseItemBearerRelComp',
        u'id-E-RABToBeSetupListBearerSUReq',
        u'id-E-RABToBeSetupItemBearerSUReq',
        u'id-E-RABAdmittedList',
        u'id-E-RABFailedToSetupListHOReqAck',
        u'id-E-RABAdmittedItem',
        u'id-E-RABFailedtoSetupItemHOReqAck',
        u'id-E-RABToBeSwitchedDLList',
        u'id-E-RABToBeSwitchedDLItem',
        u'id-E-RABToBeSetupListCtxtSUReq',
        u'id-TraceActivation',
        u'id-NAS-PDU',
        u'id-E-RABToBeSetupItemHOReq',
        u'id-E-RABSetupListBearerSURes',
        u'id-E-RABFailedToSetupListBearerSURes',
        u'id-E-RABToBeModifiedListBearerModReq',
        u'id-E-RABModifyListBearerModRes',
        u'id-E-RABFailedToModifyList',
        u'id-E-RABToBeReleasedList',
        u'id-E-RABFailedToReleaseList',
        u'id-E-RABItem',
        u'id-E-RABToBeModifiedItemBearerModReq',
        u'id-E-RABModifyItemBearerModRes',
        u'id-E-RABReleaseItem',
        u'id-E-RABSetupItemBearerSURes',
        u'id-SecurityContext',
        u'id-HandoverRestrictionList',
        u'id-UEPagingID',
        u'id-pagingDRX',
        u'id-TAIList',
        u'id-TAIItem',
        u'id-E-RABFailedToSetupListCtxtSURes',
        u'id-E-RABReleaseItemHOCmd',
        u'id-E-RABSetupItemCtxtSURes',
        u'id-E-RABSetupListCtxtSURes',
        u'id-E-RABToBeSetupItemCtxtSUReq',
        u'id-E-RABToBeSetupListHOReq',
        u'id-GERANtoLTEHOInformationRes',
        u'id-UTRANtoLTEHOInformationRes',
        u'id-CriticalityDiagnostics',
        u'id-Global-ENB-ID',
        u'id-eNBname',
        u'id-MMEname',
        u'id-ServedPLMNs',
        u'id-SupportedTAs',
        u'id-TimeToWait',
        u'id-uEaggregateMaximumBitrate',
        u'id-TAI',
        u'id-E-RABReleaseListBearerRelComp',
        u'id-cdma2000PDU',
        u'id-cdma2000RATType',
        u'id-cdma2000SectorID',
        u'id-SecurityKey',
        u'id-UERadioCapability',
        u'id-GUMMEI-ID',
        u'id-E-RABInformationListItem',
        u'id-Direct-Forwarding-Path-Availability',
        u'id-UEIdentityIndexValue',
        u'id-cdma2000HOStatus',
        u'id-cdma2000HORequiredIndication',
        u'id-E-UTRAN-Trace-ID',
        u'id-RelativeMMECapacity',
        u'id-SourceMME-UE-S1AP-ID',
        u'id-Bearers-SubjectToStatusTransfer-Item',
        u'id-eNB-StatusTransfer-TransparentContainer',
        u'id-UE-associatedLogicalS1-ConnectionItem',
        u'id-ResetType',
        u'id-UE-associatedLogicalS1-ConnectionListResAck',
        u'id-E-RABToBeSwitchedULItem',
        u'id-E-RABToBeSwitchedULList',
        u'id-S-TMSI',
        u'id-cdma2000OneXRAND',
        u'id-RequestType',
        u'id-UE-S1AP-IDs',
        u'id-EUTRAN-CGI',
        u'id-OverloadResponse',
        u'id-cdma2000OneXSRVCCInfo',
        u'id-E-RABFailedToBeReleasedList',
        u'id-Source-ToTarget-TransparentContainer',
        u'id-ServedGUMMEIs',
        u'id-SubscriberProfileIDforRFP',
        u'id-UESecurityCapabilities',
        u'id-CSFallbackIndicator',
        u'id-CNDomain',
        u'id-E-RABReleasedList',
        u'id-MessageIdentifier',
        u'id-SerialNumber',
        u'id-WarningAreaList',
        u'id-RepetitionPeriod',
        u'id-NumberofBroadcastRequest',
        u'id-WarningType',
        u'id-WarningSecurityInfo',
        u'id-DataCodingScheme',
        u'id-WarningMessageContents',
        u'id-BroadcastCompletedAreaList',
        u'id-Inter-SystemInformationTransferTypeEDT',
        u'id-Inter-SystemInformationTransferTypeMDT',
        u'id-Target-ToSource-TransparentContainer',
        u'id-SRVCCOperationPossible',
        u'id-SRVCCHOIndication',
        u'id-NAS-DownlinkCount',
        u'id-CSG-Id',
        u'id-CSG-IdList',
        u'id-SONConfigurationTransferECT',
        u'id-SONConfigurationTransferMCT',
        u'id-TraceCollectionEntityIPAddress',
        u'id-MSClassmark2',
        u'id-MSClassmark3',
        u'id-RRC-Establishment-Cause',
        u'id-NASSecurityParametersfromE-UTRAN',
        u'id-NASSecurityParameterstoE-UTRAN',
        u'id-DefaultPagingDRX',
        u'id-Source-ToTarget-TransparentContainer-Secondary',
        u'id-Target-ToSource-TransparentContainer-Secondary',
        u'id-EUTRANRoundTripDelayEstimationInfo',
        u'id-BroadcastCancelledAreaList',
        u'id-ConcurrentWarningMessageIndicator',
        u'id-Data-Forwarding-Not-Possible',
        u'id-ExtendedRepetitionPeriod',
        u'id-CellAccessMode',
        u'id-CSGMembershipStatus',
        u'id-LPPa-PDU',
        u'id-Routing-ID',
        u'id-Time-Synchronisation-Info',
        u'id-PS-ServiceNotAvailable',
        u'id-PagingPriority',
        u'id-x2TNLConfigurationInfo',
        u'id-eNBX2ExtendedTransportLayerAddresses',
        u'id-GUMMEIList',
        u'id-GW-TransportLayerAddress',
        u'id-Correlation-ID',
        u'id-SourceMME-GUMMEI',
        u'id-MME-UE-S1AP-ID-2',
        u'id-RegisteredLAI',
        u'id-RelayNode-Indicator',
        u'id-TrafficLoadReductionIndication',
        u'id-MDTConfiguration',
        u'id-MMERelaySupportIndicator',
        u'id-GWContextReleaseIndication',
        u'id-ManagementBasedMDTAllowed',
        u'id-PrivacyIndicator',
        u'id-Time-UE-StayedInCell-EnhancedGranularity',
        u'id-HO-Cause',
        u'id-VoiceSupportMatchIndicator',
        u'id-GUMMEIType',
        u'id-M3Configuration',
        u'id-M4Configuration',
        u'id-M5Configuration',
        u'id-MDT-Location-Info',
        u'id-MobilityInformation',
        u'id-Tunnel-Information-for-BBF',
        u'id-ManagementBasedMDTPLMNList',
        u'id-SignallingBasedMDTPLMNList',
        u'id-ULCOUNTValueExtended',
        u'id-DLCOUNTValueExtended',
        u'id-ReceiveStatusOfULPDCPSDUsExtended',
        u'id-ECGIListForRestart',
        u'id-SIPTO-Correlation-ID',
        u'id-SIPTO-L-GW-TransportLayerAddress',
        u'id-TransportInformation',
        u'id-LHN-ID',
        u'id-AdditionalCSFallbackIndicator',
        u'id-TAIListForRestart',
        u'id-UserLocationInformation',
        u'id-EmergencyAreaIDListForRestart',
        u'id-KillAllWarningMessages',
        u'id-Masked-IMEISV',
        u'id-eNBIndirectX2TransportLayerAddresses',
        u'id-uE-HistoryInformationFromTheUE',
        u'id-ProSeAuthorized',
        u'id-ExpectedUEBehaviour',
        u'id-LoggedMBSFNMDT',
        u'id-UERadioCapabilityForPaging',
        u'id-E-RABToBeModifiedListBearerModInd',
        u'id-E-RABToBeModifiedItemBearerModInd',
        u'id-E-RABNotToBeModifiedListBearerModInd',
        u'id-E-RABNotToBeModifiedItemBearerModInd',
        u'id-E-RABModifyListBearerModConf',
        u'id-E-RABModifyItemBearerModConf',
        u'id-E-RABFailedToModifyListBearerModConf',
        u'id-SON-Information-Report',
        u'id-Muting-Availability-Indication',
        u'id-Muting-Pattern-Information',
        u'id-Synchronisation-Information',
        u'id-E-RABToBeReleasedListBearerModConf',
        u'id-AssistanceDataForPaging',
        u'id-CellIdentifierAndCELevelForCECapableUEs',
        u'id-InformationOnRecommendedCellsAndENBsForPaging',
        u'id-RecommendedCellItem',
        u'id-RecommendedENBItem',
        u'id-ProSeUEtoNetworkRelaying',
        u'id-ULCOUNTValuePDCP-SNlength18',
        u'id-DLCOUNTValuePDCP-SNlength18',
        u'id-ReceiveStatusOfULPDCPSDUsPDCP-SNlength18',
        u'id-M6Configuration',
        u'id-M7Configuration',
        u'id-PWSfailedECGIList',
        u'id-MME-Group-ID',
        u'id-Additional-GUTI',
        u'id-S1-Message',
        u'id-CSGMembershipInfo',
        u'id-Paging-eDRXInformation',
        u'id-UE-RetentionInformation',
        u'id-UE-Usage-Type',
        u'id-extended-UEIdentityIndexValue',
        u'id-RAT-Type',
        u'id-BearerType',
        u'id-NB-IoT-DefaultPagingDRX',
        u'id-E-RABFailedToResumeListResumeReq',
        u'id-E-RABFailedToResumeItemResumeReq',
        u'id-E-RABFailedToResumeListResumeRes',
        u'id-E-RABFailedToResumeItemResumeRes',
        u'id-NB-IoT-Paging-eDRXInformation',
        u'id-V2XServicesAuthorized',
        u'id-UEUserPlaneCIoTSupportIndicator',
        u'id-CE-mode-B-SupportIndicator',
        u'id-SRVCCOperationNotPossible',
        u'id-NB-IoT-UEIdentityIndexValue',
        u'id-RRC-Resume-Cause',
        u'id-DCN-ID',
        u'id-ServedDCNs',
        u'id-UESidelinkAggregateMaximumBitrate',
        u'id-DLNASPDUDeliveryAckRequest',
        u'id-Coverage-Level',
        u'id-EnhancedCoverageRestricted',
        u'id-UE-Level-QoS-Parameters',
        u'id-DL-CP-SecurityInformation',
        u'id-UL-CP-SecurityInformation',
        u'id-extended-e-RAB-MaximumBitrateDL',
        u'id-extended-e-RAB-MaximumBitrateUL',
        u'id-extended-e-RAB-GuaranteedBitrateDL',
        u'id-extended-e-RAB-GuaranteedBitrateUL',
        u'id-extended-uEaggregateMaximumBitRateDL',
        u'id-extended-uEaggregateMaximumBitRateUL',
        u'id-NRrestrictioninEPSasSecondaryRAT',
        u'id-UEAppLayerMeasConfig',
        u'id-UE-Application-Layer-Measurement-Capability',
        u'id-SecondaryRATDataUsageReportList',
        u'id-SecondaryRATDataUsageReportItem',
        u'id-HandoverFlag',
        u'id-E-RABUsageReportItem',
        u'id-SecondaryRATDataUsageRequest',
        u'id-NRUESecurityCapabilities',
        u'id-UnlicensedSpectrumRestriction',
        u'id-CE-ModeBRestricted',
        u'id-LTE-M-Indication',
        u'id-DownlinkPacketLossRate',
        u'id-UplinkPacketLossRate',
        u'id-UECapabilityInfoRequest',
        u'id-serviceType',
        u'id-AerialUEsubscriptionInformation',
        u'id-Subscription-Based-UE-DifferentiationInfo',
        u'id-EndIndication',
        u'id-EDT-Session',
        u'id-CNTypeRestrictions',
        u'id-PendingDataIndication',
        u'id-BluetoothMeasurementConfiguration',
        u'id-WLANMeasurementConfiguration',
        u'id-WarningAreaCoordinates',
        u'id-NRrestrictionin5GS',
        u'id-PSCellInformation',
        u'id-LastNG-RANPLMNIdentity',
        u'id-ConnectedengNBList',
        u'id-ConnectedengNBToAddList',
        u'id-ConnectedengNBToRemoveList',
        u'id-EN-DCSONConfigurationTransfer-ECT',
        u'id-EN-DCSONConfigurationTransfer-MCT',
        u'id-IMSvoiceEPSfallbackfrom5G',
        u'id-TimeSinceSecondaryNodeRelease',
        u'id-RequestTypeAdditionalInfo',
        u'id-AdditionalRRMPriorityIndex',
        u'id-ContextatSource',
        u'id-IAB-Authorized',
        u'id-IAB-Node-Indication',
        u'id-IAB-Supported',
        u'id-DataSize',
        u'id-Ethernet-Type',
        u'id-NRV2XServicesAuthorized',
        u'id-NRUESidelinkAggregateMaximumBitrate',
        u'id-PC5QoSParameters',
        u'id-IntersystemSONConfigurationTransferMCT',
        u'id-IntersystemSONConfigurationTransferECT',
        u'id-IntersystemMeasurementConfiguration',
        u'id-SourceNodeID',
        u'id-NB-IoT-RLF-Report-Container',
        u'id-UERadioCapabilityID',
        u'id-UERadioCapability-NR-Format',
        u'id-MDTConfigurationNR',
        u'id-DAPSRequestInfo',
        u'id-DAPSResponseInfoList',
        u'id-DAPSResponseInfoItem',
        u'id-NotifySourceeNB',
        u'id-eNB-EarlyStatusTransfer-TransparentContainer',
        u'id-Bearers-SubjectToEarlyStatusTransfer-Item',
        u'id-WUS-Assistance-Information',
        u'id-NB-IoT-PagingDRX',
        u'id-TraceCollectionEntityURI',
        u'id-EmergencyIndicator',
        u'id-UERadioCapabilityForPaging-NR-Format',
        u'id-SourceTransportLayerAddress',
        u'id-SourceNodeTransportLayerAddress',
        u'id-SourceSNID',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        u'id-HandoverPreparation',
        u'id-HandoverResourceAllocation',
        u'id-HandoverNotification',
        u'id-PathSwitchRequest',
        u'id-HandoverCancel',
        u'id-E-RABSetup',
        u'id-E-RABModify',
        u'id-E-RABRelease',
        u'id-E-RABReleaseIndication',
        u'id-InitialContextSetup',
        u'id-Paging',
        u'id-downlinkNASTransport',
        u'id-initialUEMessage',
        u'id-uplinkNASTransport',
        u'id-Reset',
        u'id-ErrorIndication',
        u'id-NASNonDeliveryIndication',
        u'id-S1Setup',
        u'id-UEContextReleaseRequest',
        u'id-DownlinkS1cdma2000tunnelling',
        u'id-UplinkS1cdma2000tunnelling',
        u'id-UEContextModification',
        u'id-UECapabilityInfoIndication',
        u'id-UEContextRelease',
        u'id-eNBStatusTransfer',
        u'id-MMEStatusTransfer',
        u'id-DeactivateTrace',
        u'id-TraceStart',
        u'id-TraceFailureIndication',
        u'id-ENBConfigurationUpdate',
        u'id-MMEConfigurationUpdate',
        u'id-LocationReportingControl',
        u'id-LocationReportingFailureIndication',
        u'id-LocationReport',
        u'id-OverloadStart',
        u'id-OverloadStop',
        u'id-WriteReplaceWarning',
        u'id-eNBDirectInformationTransfer',
        u'id-MMEDirectInformationTransfer',
        u'id-PrivateMessage',
        u'id-eNBConfigurationTransfer',
        u'id-MMEConfigurationTransfer',
        u'id-CellTrafficTrace',
        u'id-Kill',
        u'id-downlinkUEAssociatedLPPaTransport',
        u'id-uplinkUEAssociatedLPPaTransport',
        u'id-downlinkNonUEAssociatedLPPaTransport',
        u'id-uplinkNonUEAssociatedLPPaTransport',
        u'id-UERadioCapabilityMatch',
        u'id-PWSRestartIndication',
        u'id-E-RABModificationIndication',
        u'id-PWSFailureIndication',
        u'id-RerouteNASRequest',
        u'id-UEContextModificationIndication',
        u'id-ConnectionEstablishmentIndication',
        u'id-UEContextSuspend',
        u'id-UEContextResume',
        u'id-NASDeliveryIndication',
        u'id-RetrieveUEInformation',
        u'id-UEInformationTransfer',
        u'id-eNBCPRelocationIndication',
        u'id-MMECPRelocationIndication',
        u'id-SecondaryRATDataUsageReport',
        u'id-UERadioCapabilityIDMapping',
        u'id-HandoverSuccess',
        u'id-eNBEarlyStatusTransfer',
        u'id-MMEEarlyStatusTransfer',
        u'maxPrivateIEs',
        u'maxProtocolExtensions',
        u'maxProtocolIEs',
        u'maxnoofCSGs',
        u'maxnoofE-RABs',
        u'maxnoofTAIs',
        u'maxnoofTACs',
        u'maxnoofErrors',
        u'maxnoofBPLMNs',
        u'maxnoofPLMNsPerMME',
        u'maxnoofEPLMNs',
        u'maxnoofEPLMNsPlusOne',
        u'maxnoofForbLACs',
        u'maxnoofForbTACs',
        u'maxnoofIndividualS1ConnectionsToReset',
        u'maxnoofCellsinUEHistoryInfo',
        u'maxnoofCellsineNB',
        u'maxnoofTAIforWarning',
        u'maxnoofCellID',
        u'maxnoofDCNs',
        u'maxnoofEmergencyAreaID',
        u'maxnoofCellinTAI',
        u'maxnoofCellinEAI',
        u'maxnoofeNBX2TLAs',
        u'maxnoofeNBX2ExtTLAs',
        u'maxnoofeNBX2GTPTLAs',
        u'maxnoofRATs',
        u'maxnoofGroupIDs',
        u'maxnoofMMECs',
        u'maxnoofCellIDforMDT',
        u'maxnoofTAforMDT',
        u'maxnoofMDTPLMNs',
        u'maxnoofCellsforRestart',
        u'maxnoofRestartTAIs',
        u'maxnoofRestartEmergencyAreaIDs',
        u'maxEARFCN',
        u'maxnoofMBSFNAreaMDT',
        u'maxnoofRecommendedCells',
        u'maxnoofRecommendedENBs',
        u'maxnooftimeperiods',
        u'maxnoofCellIDforQMC',
        u'maxnoofTAforQMC',
        u'maxnoofPLMNforQMC',
        u'maxnoofBluetoothName',
        u'maxnoofWLANName',
        u'maxnoofConnectedengNBs',
        u'maxnoofPC5QoSFlows',
        u'maxnooffrequencies',
        u'maxNARFCN',
        u'maxRS-IndexCellQual',
        u'id-MME-UE-S1AP-ID',
        u'id-HandoverType',
        u'id-Cause',
        u'id-SourceID',
        u'id-TargetID',
        u'id-eNB-UE-S1AP-ID',
        u'id-E-RABSubjecttoDataForwardingList',
        u'id-E-RABtoReleaseListHOCmd',
        u'id-E-RABDataForwardingItem',
        u'id-E-RABReleaseItemBearerRelComp',
        u'id-E-RABToBeSetupListBearerSUReq',
        u'id-E-RABToBeSetupItemBearerSUReq',
        u'id-E-RABAdmittedList',
        u'id-E-RABFailedToSetupListHOReqAck',
        u'id-E-RABAdmittedItem',
        u'id-E-RABFailedtoSetupItemHOReqAck',
        u'id-E-RABToBeSwitchedDLList',
        u'id-E-RABToBeSwitchedDLItem',
        u'id-E-RABToBeSetupListCtxtSUReq',
        u'id-TraceActivation',
        u'id-NAS-PDU',
        u'id-E-RABToBeSetupItemHOReq',
        u'id-E-RABSetupListBearerSURes',
        u'id-E-RABFailedToSetupListBearerSURes',
        u'id-E-RABToBeModifiedListBearerModReq',
        u'id-E-RABModifyListBearerModRes',
        u'id-E-RABFailedToModifyList',
        u'id-E-RABToBeReleasedList',
        u'id-E-RABFailedToReleaseList',
        u'id-E-RABItem',
        u'id-E-RABToBeModifiedItemBearerModReq',
        u'id-E-RABModifyItemBearerModRes',
        u'id-E-RABReleaseItem',
        u'id-E-RABSetupItemBearerSURes',
        u'id-SecurityContext',
        u'id-HandoverRestrictionList',
        u'id-UEPagingID',
        u'id-pagingDRX',
        u'id-TAIList',
        u'id-TAIItem',
        u'id-E-RABFailedToSetupListCtxtSURes',
        u'id-E-RABReleaseItemHOCmd',
        u'id-E-RABSetupItemCtxtSURes',
        u'id-E-RABSetupListCtxtSURes',
        u'id-E-RABToBeSetupItemCtxtSUReq',
        u'id-E-RABToBeSetupListHOReq',
        u'id-GERANtoLTEHOInformationRes',
        u'id-UTRANtoLTEHOInformationRes',
        u'id-CriticalityDiagnostics',
        u'id-Global-ENB-ID',
        u'id-eNBname',
        u'id-MMEname',
        u'id-ServedPLMNs',
        u'id-SupportedTAs',
        u'id-TimeToWait',
        u'id-uEaggregateMaximumBitrate',
        u'id-TAI',
        u'id-E-RABReleaseListBearerRelComp',
        u'id-cdma2000PDU',
        u'id-cdma2000RATType',
        u'id-cdma2000SectorID',
        u'id-SecurityKey',
        u'id-UERadioCapability',
        u'id-GUMMEI-ID',
        u'id-E-RABInformationListItem',
        u'id-Direct-Forwarding-Path-Availability',
        u'id-UEIdentityIndexValue',
        u'id-cdma2000HOStatus',
        u'id-cdma2000HORequiredIndication',
        u'id-E-UTRAN-Trace-ID',
        u'id-RelativeMMECapacity',
        u'id-SourceMME-UE-S1AP-ID',
        u'id-Bearers-SubjectToStatusTransfer-Item',
        u'id-eNB-StatusTransfer-TransparentContainer',
        u'id-UE-associatedLogicalS1-ConnectionItem',
        u'id-ResetType',
        u'id-UE-associatedLogicalS1-ConnectionListResAck',
        u'id-E-RABToBeSwitchedULItem',
        u'id-E-RABToBeSwitchedULList',
        u'id-S-TMSI',
        u'id-cdma2000OneXRAND',
        u'id-RequestType',
        u'id-UE-S1AP-IDs',
        u'id-EUTRAN-CGI',
        u'id-OverloadResponse',
        u'id-cdma2000OneXSRVCCInfo',
        u'id-E-RABFailedToBeReleasedList',
        u'id-Source-ToTarget-TransparentContainer',
        u'id-ServedGUMMEIs',
        u'id-SubscriberProfileIDforRFP',
        u'id-UESecurityCapabilities',
        u'id-CSFallbackIndicator',
        u'id-CNDomain',
        u'id-E-RABReleasedList',
        u'id-MessageIdentifier',
        u'id-SerialNumber',
        u'id-WarningAreaList',
        u'id-RepetitionPeriod',
        u'id-NumberofBroadcastRequest',
        u'id-WarningType',
        u'id-WarningSecurityInfo',
        u'id-DataCodingScheme',
        u'id-WarningMessageContents',
        u'id-BroadcastCompletedAreaList',
        u'id-Inter-SystemInformationTransferTypeEDT',
        u'id-Inter-SystemInformationTransferTypeMDT',
        u'id-Target-ToSource-TransparentContainer',
        u'id-SRVCCOperationPossible',
        u'id-SRVCCHOIndication',
        u'id-NAS-DownlinkCount',
        u'id-CSG-Id',
        u'id-CSG-IdList',
        u'id-SONConfigurationTransferECT',
        u'id-SONConfigurationTransferMCT',
        u'id-TraceCollectionEntityIPAddress',
        u'id-MSClassmark2',
        u'id-MSClassmark3',
        u'id-RRC-Establishment-Cause',
        u'id-NASSecurityParametersfromE-UTRAN',
        u'id-NASSecurityParameterstoE-UTRAN',
        u'id-DefaultPagingDRX',
        u'id-Source-ToTarget-TransparentContainer-Secondary',
        u'id-Target-ToSource-TransparentContainer-Secondary',
        u'id-EUTRANRoundTripDelayEstimationInfo',
        u'id-BroadcastCancelledAreaList',
        u'id-ConcurrentWarningMessageIndicator',
        u'id-Data-Forwarding-Not-Possible',
        u'id-ExtendedRepetitionPeriod',
        u'id-CellAccessMode',
        u'id-CSGMembershipStatus',
        u'id-LPPa-PDU',
        u'id-Routing-ID',
        u'id-Time-Synchronisation-Info',
        u'id-PS-ServiceNotAvailable',
        u'id-PagingPriority',
        u'id-x2TNLConfigurationInfo',
        u'id-eNBX2ExtendedTransportLayerAddresses',
        u'id-GUMMEIList',
        u'id-GW-TransportLayerAddress',
        u'id-Correlation-ID',
        u'id-SourceMME-GUMMEI',
        u'id-MME-UE-S1AP-ID-2',
        u'id-RegisteredLAI',
        u'id-RelayNode-Indicator',
        u'id-TrafficLoadReductionIndication',
        u'id-MDTConfiguration',
        u'id-MMERelaySupportIndicator',
        u'id-GWContextReleaseIndication',
        u'id-ManagementBasedMDTAllowed',
        u'id-PrivacyIndicator',
        u'id-Time-UE-StayedInCell-EnhancedGranularity',
        u'id-HO-Cause',
        u'id-VoiceSupportMatchIndicator',
        u'id-GUMMEIType',
        u'id-M3Configuration',
        u'id-M4Configuration',
        u'id-M5Configuration',
        u'id-MDT-Location-Info',
        u'id-MobilityInformation',
        u'id-Tunnel-Information-for-BBF',
        u'id-ManagementBasedMDTPLMNList',
        u'id-SignallingBasedMDTPLMNList',
        u'id-ULCOUNTValueExtended',
        u'id-DLCOUNTValueExtended',
        u'id-ReceiveStatusOfULPDCPSDUsExtended',
        u'id-ECGIListForRestart',
        u'id-SIPTO-Correlation-ID',
        u'id-SIPTO-L-GW-TransportLayerAddress',
        u'id-TransportInformation',
        u'id-LHN-ID',
        u'id-AdditionalCSFallbackIndicator',
        u'id-TAIListForRestart',
        u'id-UserLocationInformation',
        u'id-EmergencyAreaIDListForRestart',
        u'id-KillAllWarningMessages',
        u'id-Masked-IMEISV',
        u'id-eNBIndirectX2TransportLayerAddresses',
        u'id-uE-HistoryInformationFromTheUE',
        u'id-ProSeAuthorized',
        u'id-ExpectedUEBehaviour',
        u'id-LoggedMBSFNMDT',
        u'id-UERadioCapabilityForPaging',
        u'id-E-RABToBeModifiedListBearerModInd',
        u'id-E-RABToBeModifiedItemBearerModInd',
        u'id-E-RABNotToBeModifiedListBearerModInd',
        u'id-E-RABNotToBeModifiedItemBearerModInd',
        u'id-E-RABModifyListBearerModConf',
        u'id-E-RABModifyItemBearerModConf',
        u'id-E-RABFailedToModifyListBearerModConf',
        u'id-SON-Information-Report',
        u'id-Muting-Availability-Indication',
        u'id-Muting-Pattern-Information',
        u'id-Synchronisation-Information',
        u'id-E-RABToBeReleasedListBearerModConf',
        u'id-AssistanceDataForPaging',
        u'id-CellIdentifierAndCELevelForCECapableUEs',
        u'id-InformationOnRecommendedCellsAndENBsForPaging',
        u'id-RecommendedCellItem',
        u'id-RecommendedENBItem',
        u'id-ProSeUEtoNetworkRelaying',
        u'id-ULCOUNTValuePDCP-SNlength18',
        u'id-DLCOUNTValuePDCP-SNlength18',
        u'id-ReceiveStatusOfULPDCPSDUsPDCP-SNlength18',
        u'id-M6Configuration',
        u'id-M7Configuration',
        u'id-PWSfailedECGIList',
        u'id-MME-Group-ID',
        u'id-Additional-GUTI',
        u'id-S1-Message',
        u'id-CSGMembershipInfo',
        u'id-Paging-eDRXInformation',
        u'id-UE-RetentionInformation',
        u'id-UE-Usage-Type',
        u'id-extended-UEIdentityIndexValue',
        u'id-RAT-Type',
        u'id-BearerType',
        u'id-NB-IoT-DefaultPagingDRX',
        u'id-E-RABFailedToResumeListResumeReq',
        u'id-E-RABFailedToResumeItemResumeReq',
        u'id-E-RABFailedToResumeListResumeRes',
        u'id-E-RABFailedToResumeItemResumeRes',
        u'id-NB-IoT-Paging-eDRXInformation',
        u'id-V2XServicesAuthorized',
        u'id-UEUserPlaneCIoTSupportIndicator',
        u'id-CE-mode-B-SupportIndicator',
        u'id-SRVCCOperationNotPossible',
        u'id-NB-IoT-UEIdentityIndexValue',
        u'id-RRC-Resume-Cause',
        u'id-DCN-ID',
        u'id-ServedDCNs',
        u'id-UESidelinkAggregateMaximumBitrate',
        u'id-DLNASPDUDeliveryAckRequest',
        u'id-Coverage-Level',
        u'id-EnhancedCoverageRestricted',
        u'id-UE-Level-QoS-Parameters',
        u'id-DL-CP-SecurityInformation',
        u'id-UL-CP-SecurityInformation',
        u'id-extended-e-RAB-MaximumBitrateDL',
        u'id-extended-e-RAB-MaximumBitrateUL',
        u'id-extended-e-RAB-GuaranteedBitrateDL',
        u'id-extended-e-RAB-GuaranteedBitrateUL',
        u'id-extended-uEaggregateMaximumBitRateDL',
        u'id-extended-uEaggregateMaximumBitRateUL',
        u'id-NRrestrictioninEPSasSecondaryRAT',
        u'id-UEAppLayerMeasConfig',
        u'id-UE-Application-Layer-Measurement-Capability',
        u'id-SecondaryRATDataUsageReportList',
        u'id-SecondaryRATDataUsageReportItem',
        u'id-HandoverFlag',
        u'id-E-RABUsageReportItem',
        u'id-SecondaryRATDataUsageRequest',
        u'id-NRUESecurityCapabilities',
        u'id-UnlicensedSpectrumRestriction',
        u'id-CE-ModeBRestricted',
        u'id-LTE-M-Indication',
        u'id-DownlinkPacketLossRate',
        u'id-UplinkPacketLossRate',
        u'id-UECapabilityInfoRequest',
        u'id-serviceType',
        u'id-AerialUEsubscriptionInformation',
        u'id-Subscription-Based-UE-DifferentiationInfo',
        u'id-EndIndication',
        u'id-EDT-Session',
        u'id-CNTypeRestrictions',
        u'id-PendingDataIndication',
        u'id-BluetoothMeasurementConfiguration',
        u'id-WLANMeasurementConfiguration',
        u'id-WarningAreaCoordinates',
        u'id-NRrestrictionin5GS',
        u'id-PSCellInformation',
        u'id-LastNG-RANPLMNIdentity',
        u'id-ConnectedengNBList',
        u'id-ConnectedengNBToAddList',
        u'id-ConnectedengNBToRemoveList',
        u'id-EN-DCSONConfigurationTransfer-ECT',
        u'id-EN-DCSONConfigurationTransfer-MCT',
        u'id-IMSvoiceEPSfallbackfrom5G',
        u'id-TimeSinceSecondaryNodeRelease',
        u'id-RequestTypeAdditionalInfo',
        u'id-AdditionalRRMPriorityIndex',
        u'id-ContextatSource',
        u'id-IAB-Authorized',
        u'id-IAB-Node-Indication',
        u'id-IAB-Supported',
        u'id-DataSize',
        u'id-Ethernet-Type',
        u'id-NRV2XServicesAuthorized',
        u'id-NRUESidelinkAggregateMaximumBitrate',
        u'id-PC5QoSParameters',
        u'id-IntersystemSONConfigurationTransferMCT',
        u'id-IntersystemSONConfigurationTransferECT',
        u'id-IntersystemMeasurementConfiguration',
        u'id-SourceNodeID',
        u'id-NB-IoT-RLF-Report-Container',
        u'id-UERadioCapabilityID',
        u'id-UERadioCapability-NR-Format',
        u'id-MDTConfigurationNR',
        u'id-DAPSRequestInfo',
        u'id-DAPSResponseInfoList',
        u'id-DAPSResponseInfoItem',
        u'id-NotifySourceeNB',
        u'id-eNB-EarlyStatusTransfer-TransparentContainer',
        u'id-Bearers-SubjectToEarlyStatusTransfer-Item',
        u'id-WUS-Assistance-Information',
        u'id-NB-IoT-PagingDRX',
        u'id-TraceCollectionEntityURI',
        u'id-EmergencyIndicator',
        u'id-UERadioCapabilityForPaging-NR-Format',
        u'id-SourceTransportLayerAddress',
        u'id-SourceNodeTransportLayerAddress',
        u'id-SourceSNID',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-HandoverPreparation >-----#
    id_HandoverPreparation = INT(name=u'id-HandoverPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_HandoverPreparation._val = 0
    
    #-----< id-HandoverResourceAllocation >-----#
    id_HandoverResourceAllocation = INT(name=u'id-HandoverResourceAllocation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_HandoverResourceAllocation._val = 1
    
    #-----< id-HandoverNotification >-----#
    id_HandoverNotification = INT(name=u'id-HandoverNotification', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_HandoverNotification._val = 2
    
    #-----< id-PathSwitchRequest >-----#
    id_PathSwitchRequest = INT(name=u'id-PathSwitchRequest', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_PathSwitchRequest._val = 3
    
    #-----< id-HandoverCancel >-----#
    id_HandoverCancel = INT(name=u'id-HandoverCancel', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_HandoverCancel._val = 4
    
    #-----< id-E-RABSetup >-----#
    id_E_RABSetup = INT(name=u'id-E-RABSetup', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_E_RABSetup._val = 5
    
    #-----< id-E-RABModify >-----#
    id_E_RABModify = INT(name=u'id-E-RABModify', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_E_RABModify._val = 6
    
    #-----< id-E-RABRelease >-----#
    id_E_RABRelease = INT(name=u'id-E-RABRelease', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_E_RABRelease._val = 7
    
    #-----< id-E-RABReleaseIndication >-----#
    id_E_RABReleaseIndication = INT(name=u'id-E-RABReleaseIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_E_RABReleaseIndication._val = 8
    
    #-----< id-InitialContextSetup >-----#
    id_InitialContextSetup = INT(name=u'id-InitialContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_InitialContextSetup._val = 9
    
    #-----< id-Paging >-----#
    id_Paging = INT(name=u'id-Paging', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_Paging._val = 10
    
    #-----< id-downlinkNASTransport >-----#
    id_downlinkNASTransport = INT(name=u'id-downlinkNASTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_downlinkNASTransport._val = 11
    
    #-----< id-initialUEMessage >-----#
    id_initialUEMessage = INT(name=u'id-initialUEMessage', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_initialUEMessage._val = 12
    
    #-----< id-uplinkNASTransport >-----#
    id_uplinkNASTransport = INT(name=u'id-uplinkNASTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_uplinkNASTransport._val = 13
    
    #-----< id-Reset >-----#
    id_Reset = INT(name=u'id-Reset', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_Reset._val = 14
    
    #-----< id-ErrorIndication >-----#
    id_ErrorIndication = INT(name=u'id-ErrorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_ErrorIndication._val = 15
    
    #-----< id-NASNonDeliveryIndication >-----#
    id_NASNonDeliveryIndication = INT(name=u'id-NASNonDeliveryIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_NASNonDeliveryIndication._val = 16
    
    #-----< id-S1Setup >-----#
    id_S1Setup = INT(name=u'id-S1Setup', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_S1Setup._val = 17
    
    #-----< id-UEContextReleaseRequest >-----#
    id_UEContextReleaseRequest = INT(name=u'id-UEContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextReleaseRequest._val = 18
    
    #-----< id-DownlinkS1cdma2000tunnelling >-----#
    id_DownlinkS1cdma2000tunnelling = INT(name=u'id-DownlinkS1cdma2000tunnelling', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_DownlinkS1cdma2000tunnelling._val = 19
    
    #-----< id-UplinkS1cdma2000tunnelling >-----#
    id_UplinkS1cdma2000tunnelling = INT(name=u'id-UplinkS1cdma2000tunnelling', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UplinkS1cdma2000tunnelling._val = 20
    
    #-----< id-UEContextModification >-----#
    id_UEContextModification = INT(name=u'id-UEContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextModification._val = 21
    
    #-----< id-UECapabilityInfoIndication >-----#
    id_UECapabilityInfoIndication = INT(name=u'id-UECapabilityInfoIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UECapabilityInfoIndication._val = 22
    
    #-----< id-UEContextRelease >-----#
    id_UEContextRelease = INT(name=u'id-UEContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextRelease._val = 23
    
    #-----< id-eNBStatusTransfer >-----#
    id_eNBStatusTransfer = INT(name=u'id-eNBStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_eNBStatusTransfer._val = 24
    
    #-----< id-MMEStatusTransfer >-----#
    id_MMEStatusTransfer = INT(name=u'id-MMEStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_MMEStatusTransfer._val = 25
    
    #-----< id-DeactivateTrace >-----#
    id_DeactivateTrace = INT(name=u'id-DeactivateTrace', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_DeactivateTrace._val = 26
    
    #-----< id-TraceStart >-----#
    id_TraceStart = INT(name=u'id-TraceStart', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_TraceStart._val = 27
    
    #-----< id-TraceFailureIndication >-----#
    id_TraceFailureIndication = INT(name=u'id-TraceFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_TraceFailureIndication._val = 28
    
    #-----< id-ENBConfigurationUpdate >-----#
    id_ENBConfigurationUpdate = INT(name=u'id-ENBConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_ENBConfigurationUpdate._val = 29
    
    #-----< id-MMEConfigurationUpdate >-----#
    id_MMEConfigurationUpdate = INT(name=u'id-MMEConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_MMEConfigurationUpdate._val = 30
    
    #-----< id-LocationReportingControl >-----#
    id_LocationReportingControl = INT(name=u'id-LocationReportingControl', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_LocationReportingControl._val = 31
    
    #-----< id-LocationReportingFailureIndication >-----#
    id_LocationReportingFailureIndication = INT(name=u'id-LocationReportingFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_LocationReportingFailureIndication._val = 32
    
    #-----< id-LocationReport >-----#
    id_LocationReport = INT(name=u'id-LocationReport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_LocationReport._val = 33
    
    #-----< id-OverloadStart >-----#
    id_OverloadStart = INT(name=u'id-OverloadStart', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_OverloadStart._val = 34
    
    #-----< id-OverloadStop >-----#
    id_OverloadStop = INT(name=u'id-OverloadStop', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_OverloadStop._val = 35
    
    #-----< id-WriteReplaceWarning >-----#
    id_WriteReplaceWarning = INT(name=u'id-WriteReplaceWarning', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_WriteReplaceWarning._val = 36
    
    #-----< id-eNBDirectInformationTransfer >-----#
    id_eNBDirectInformationTransfer = INT(name=u'id-eNBDirectInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_eNBDirectInformationTransfer._val = 37
    
    #-----< id-MMEDirectInformationTransfer >-----#
    id_MMEDirectInformationTransfer = INT(name=u'id-MMEDirectInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_MMEDirectInformationTransfer._val = 38
    
    #-----< id-PrivateMessage >-----#
    id_PrivateMessage = INT(name=u'id-PrivateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_PrivateMessage._val = 39
    
    #-----< id-eNBConfigurationTransfer >-----#
    id_eNBConfigurationTransfer = INT(name=u'id-eNBConfigurationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_eNBConfigurationTransfer._val = 40
    
    #-----< id-MMEConfigurationTransfer >-----#
    id_MMEConfigurationTransfer = INT(name=u'id-MMEConfigurationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_MMEConfigurationTransfer._val = 41
    
    #-----< id-CellTrafficTrace >-----#
    id_CellTrafficTrace = INT(name=u'id-CellTrafficTrace', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_CellTrafficTrace._val = 42
    
    #-----< id-Kill >-----#
    id_Kill = INT(name=u'id-Kill', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_Kill._val = 43
    
    #-----< id-downlinkUEAssociatedLPPaTransport >-----#
    id_downlinkUEAssociatedLPPaTransport = INT(name=u'id-downlinkUEAssociatedLPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_downlinkUEAssociatedLPPaTransport._val = 44
    
    #-----< id-uplinkUEAssociatedLPPaTransport >-----#
    id_uplinkUEAssociatedLPPaTransport = INT(name=u'id-uplinkUEAssociatedLPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_uplinkUEAssociatedLPPaTransport._val = 45
    
    #-----< id-downlinkNonUEAssociatedLPPaTransport >-----#
    id_downlinkNonUEAssociatedLPPaTransport = INT(name=u'id-downlinkNonUEAssociatedLPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_downlinkNonUEAssociatedLPPaTransport._val = 46
    
    #-----< id-uplinkNonUEAssociatedLPPaTransport >-----#
    id_uplinkNonUEAssociatedLPPaTransport = INT(name=u'id-uplinkNonUEAssociatedLPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_uplinkNonUEAssociatedLPPaTransport._val = 47
    
    #-----< id-UERadioCapabilityMatch >-----#
    id_UERadioCapabilityMatch = INT(name=u'id-UERadioCapabilityMatch', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UERadioCapabilityMatch._val = 48
    
    #-----< id-PWSRestartIndication >-----#
    id_PWSRestartIndication = INT(name=u'id-PWSRestartIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_PWSRestartIndication._val = 49
    
    #-----< id-E-RABModificationIndication >-----#
    id_E_RABModificationIndication = INT(name=u'id-E-RABModificationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_E_RABModificationIndication._val = 50
    
    #-----< id-PWSFailureIndication >-----#
    id_PWSFailureIndication = INT(name=u'id-PWSFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_PWSFailureIndication._val = 51
    
    #-----< id-RerouteNASRequest >-----#
    id_RerouteNASRequest = INT(name=u'id-RerouteNASRequest', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_RerouteNASRequest._val = 52
    
    #-----< id-UEContextModificationIndication >-----#
    id_UEContextModificationIndication = INT(name=u'id-UEContextModificationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextModificationIndication._val = 53
    
    #-----< id-ConnectionEstablishmentIndication >-----#
    id_ConnectionEstablishmentIndication = INT(name=u'id-ConnectionEstablishmentIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_ConnectionEstablishmentIndication._val = 54
    
    #-----< id-UEContextSuspend >-----#
    id_UEContextSuspend = INT(name=u'id-UEContextSuspend', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextSuspend._val = 55
    
    #-----< id-UEContextResume >-----#
    id_UEContextResume = INT(name=u'id-UEContextResume', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEContextResume._val = 56
    
    #-----< id-NASDeliveryIndication >-----#
    id_NASDeliveryIndication = INT(name=u'id-NASDeliveryIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_NASDeliveryIndication._val = 57
    
    #-----< id-RetrieveUEInformation >-----#
    id_RetrieveUEInformation = INT(name=u'id-RetrieveUEInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_RetrieveUEInformation._val = 58
    
    #-----< id-UEInformationTransfer >-----#
    id_UEInformationTransfer = INT(name=u'id-UEInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UEInformationTransfer._val = 59
    
    #-----< id-eNBCPRelocationIndication >-----#
    id_eNBCPRelocationIndication = INT(name=u'id-eNBCPRelocationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_eNBCPRelocationIndication._val = 60
    
    #-----< id-MMECPRelocationIndication >-----#
    id_MMECPRelocationIndication = INT(name=u'id-MMECPRelocationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_MMECPRelocationIndication._val = 61
    
    #-----< id-SecondaryRATDataUsageReport >-----#
    id_SecondaryRATDataUsageReport = INT(name=u'id-SecondaryRATDataUsageReport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_SecondaryRATDataUsageReport._val = 62
    
    #-----< id-UERadioCapabilityIDMapping >-----#
    id_UERadioCapabilityIDMapping = INT(name=u'id-UERadioCapabilityIDMapping', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_UERadioCapabilityIDMapping._val = 63
    
    #-----< id-HandoverSuccess >-----#
    id_HandoverSuccess = INT(name=u'id-HandoverSuccess', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_HandoverSuccess._val = 64
    
    #-----< id-eNBEarlyStatusTransfer >-----#
    id_eNBEarlyStatusTransfer = INT(name=u'id-eNBEarlyStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_eNBEarlyStatusTransfer._val = 65
    
    #-----< id-MMEEarlyStatusTransfer >-----#
    id_MMEEarlyStatusTransfer = INT(name=u'id-MMEEarlyStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')))
    id_MMEEarlyStatusTransfer._val = 66
    
    #-----< maxPrivateIEs >-----#
    maxPrivateIEs = INT(name=u'maxPrivateIEs', mode=MODE_VALUE)
    maxPrivateIEs._val = 65535
    
    #-----< maxProtocolExtensions >-----#
    maxProtocolExtensions = INT(name=u'maxProtocolExtensions', mode=MODE_VALUE)
    maxProtocolExtensions._val = 65535
    
    #-----< maxProtocolIEs >-----#
    maxProtocolIEs = INT(name=u'maxProtocolIEs', mode=MODE_VALUE)
    maxProtocolIEs._val = 65535
    
    #-----< maxnoofCSGs >-----#
    maxnoofCSGs = INT(name=u'maxnoofCSGs', mode=MODE_VALUE)
    maxnoofCSGs._val = 256
    
    #-----< maxnoofE-RABs >-----#
    maxnoofE_RABs = INT(name=u'maxnoofE-RABs', mode=MODE_VALUE)
    maxnoofE_RABs._val = 256
    
    #-----< maxnoofTAIs >-----#
    maxnoofTAIs = INT(name=u'maxnoofTAIs', mode=MODE_VALUE)
    maxnoofTAIs._val = 256
    
    #-----< maxnoofTACs >-----#
    maxnoofTACs = INT(name=u'maxnoofTACs', mode=MODE_VALUE)
    maxnoofTACs._val = 256
    
    #-----< maxnoofErrors >-----#
    maxnoofErrors = INT(name=u'maxnoofErrors', mode=MODE_VALUE)
    maxnoofErrors._val = 256
    
    #-----< maxnoofBPLMNs >-----#
    maxnoofBPLMNs = INT(name=u'maxnoofBPLMNs', mode=MODE_VALUE)
    maxnoofBPLMNs._val = 6
    
    #-----< maxnoofPLMNsPerMME >-----#
    maxnoofPLMNsPerMME = INT(name=u'maxnoofPLMNsPerMME', mode=MODE_VALUE)
    maxnoofPLMNsPerMME._val = 32
    
    #-----< maxnoofEPLMNs >-----#
    maxnoofEPLMNs = INT(name=u'maxnoofEPLMNs', mode=MODE_VALUE)
    maxnoofEPLMNs._val = 15
    
    #-----< maxnoofEPLMNsPlusOne >-----#
    maxnoofEPLMNsPlusOne = INT(name=u'maxnoofEPLMNsPlusOne', mode=MODE_VALUE)
    maxnoofEPLMNsPlusOne._val = 16
    
    #-----< maxnoofForbLACs >-----#
    maxnoofForbLACs = INT(name=u'maxnoofForbLACs', mode=MODE_VALUE)
    maxnoofForbLACs._val = 4096
    
    #-----< maxnoofForbTACs >-----#
    maxnoofForbTACs = INT(name=u'maxnoofForbTACs', mode=MODE_VALUE)
    maxnoofForbTACs._val = 4096
    
    #-----< maxnoofIndividualS1ConnectionsToReset >-----#
    maxnoofIndividualS1ConnectionsToReset = INT(name=u'maxnoofIndividualS1ConnectionsToReset', mode=MODE_VALUE)
    maxnoofIndividualS1ConnectionsToReset._val = 256
    
    #-----< maxnoofCellsinUEHistoryInfo >-----#
    maxnoofCellsinUEHistoryInfo = INT(name=u'maxnoofCellsinUEHistoryInfo', mode=MODE_VALUE)
    maxnoofCellsinUEHistoryInfo._val = 16
    
    #-----< maxnoofCellsineNB >-----#
    maxnoofCellsineNB = INT(name=u'maxnoofCellsineNB', mode=MODE_VALUE)
    maxnoofCellsineNB._val = 256
    
    #-----< maxnoofTAIforWarning >-----#
    maxnoofTAIforWarning = INT(name=u'maxnoofTAIforWarning', mode=MODE_VALUE)
    maxnoofTAIforWarning._val = 65535
    
    #-----< maxnoofCellID >-----#
    maxnoofCellID = INT(name=u'maxnoofCellID', mode=MODE_VALUE)
    maxnoofCellID._val = 65535
    
    #-----< maxnoofDCNs >-----#
    maxnoofDCNs = INT(name=u'maxnoofDCNs', mode=MODE_VALUE)
    maxnoofDCNs._val = 32
    
    #-----< maxnoofEmergencyAreaID >-----#
    maxnoofEmergencyAreaID = INT(name=u'maxnoofEmergencyAreaID', mode=MODE_VALUE)
    maxnoofEmergencyAreaID._val = 65535
    
    #-----< maxnoofCellinTAI >-----#
    maxnoofCellinTAI = INT(name=u'maxnoofCellinTAI', mode=MODE_VALUE)
    maxnoofCellinTAI._val = 65535
    
    #-----< maxnoofCellinEAI >-----#
    maxnoofCellinEAI = INT(name=u'maxnoofCellinEAI', mode=MODE_VALUE)
    maxnoofCellinEAI._val = 65535
    
    #-----< maxnoofeNBX2TLAs >-----#
    maxnoofeNBX2TLAs = INT(name=u'maxnoofeNBX2TLAs', mode=MODE_VALUE)
    maxnoofeNBX2TLAs._val = 2
    
    #-----< maxnoofeNBX2ExtTLAs >-----#
    maxnoofeNBX2ExtTLAs = INT(name=u'maxnoofeNBX2ExtTLAs', mode=MODE_VALUE)
    maxnoofeNBX2ExtTLAs._val = 16
    
    #-----< maxnoofeNBX2GTPTLAs >-----#
    maxnoofeNBX2GTPTLAs = INT(name=u'maxnoofeNBX2GTPTLAs', mode=MODE_VALUE)
    maxnoofeNBX2GTPTLAs._val = 16
    
    #-----< maxnoofRATs >-----#
    maxnoofRATs = INT(name=u'maxnoofRATs', mode=MODE_VALUE)
    maxnoofRATs._val = 8
    
    #-----< maxnoofGroupIDs >-----#
    maxnoofGroupIDs = INT(name=u'maxnoofGroupIDs', mode=MODE_VALUE)
    maxnoofGroupIDs._val = 65535
    
    #-----< maxnoofMMECs >-----#
    maxnoofMMECs = INT(name=u'maxnoofMMECs', mode=MODE_VALUE)
    maxnoofMMECs._val = 256
    
    #-----< maxnoofCellIDforMDT >-----#
    maxnoofCellIDforMDT = INT(name=u'maxnoofCellIDforMDT', mode=MODE_VALUE)
    maxnoofCellIDforMDT._val = 32
    
    #-----< maxnoofTAforMDT >-----#
    maxnoofTAforMDT = INT(name=u'maxnoofTAforMDT', mode=MODE_VALUE)
    maxnoofTAforMDT._val = 8
    
    #-----< maxnoofMDTPLMNs >-----#
    maxnoofMDTPLMNs = INT(name=u'maxnoofMDTPLMNs', mode=MODE_VALUE)
    maxnoofMDTPLMNs._val = 16
    
    #-----< maxnoofCellsforRestart >-----#
    maxnoofCellsforRestart = INT(name=u'maxnoofCellsforRestart', mode=MODE_VALUE)
    maxnoofCellsforRestart._val = 256
    
    #-----< maxnoofRestartTAIs >-----#
    maxnoofRestartTAIs = INT(name=u'maxnoofRestartTAIs', mode=MODE_VALUE)
    maxnoofRestartTAIs._val = 2048
    
    #-----< maxnoofRestartEmergencyAreaIDs >-----#
    maxnoofRestartEmergencyAreaIDs = INT(name=u'maxnoofRestartEmergencyAreaIDs', mode=MODE_VALUE)
    maxnoofRestartEmergencyAreaIDs._val = 256
    
    #-----< maxEARFCN >-----#
    maxEARFCN = INT(name=u'maxEARFCN', mode=MODE_VALUE)
    maxEARFCN._val = 262143
    
    #-----< maxnoofMBSFNAreaMDT >-----#
    maxnoofMBSFNAreaMDT = INT(name=u'maxnoofMBSFNAreaMDT', mode=MODE_VALUE)
    maxnoofMBSFNAreaMDT._val = 8
    
    #-----< maxnoofRecommendedCells >-----#
    maxnoofRecommendedCells = INT(name=u'maxnoofRecommendedCells', mode=MODE_VALUE)
    maxnoofRecommendedCells._val = 16
    
    #-----< maxnoofRecommendedENBs >-----#
    maxnoofRecommendedENBs = INT(name=u'maxnoofRecommendedENBs', mode=MODE_VALUE)
    maxnoofRecommendedENBs._val = 16
    
    #-----< maxnooftimeperiods >-----#
    maxnooftimeperiods = INT(name=u'maxnooftimeperiods', mode=MODE_VALUE)
    maxnooftimeperiods._val = 2
    
    #-----< maxnoofCellIDforQMC >-----#
    maxnoofCellIDforQMC = INT(name=u'maxnoofCellIDforQMC', mode=MODE_VALUE)
    maxnoofCellIDforQMC._val = 32
    
    #-----< maxnoofTAforQMC >-----#
    maxnoofTAforQMC = INT(name=u'maxnoofTAforQMC', mode=MODE_VALUE)
    maxnoofTAforQMC._val = 8
    
    #-----< maxnoofPLMNforQMC >-----#
    maxnoofPLMNforQMC = INT(name=u'maxnoofPLMNforQMC', mode=MODE_VALUE)
    maxnoofPLMNforQMC._val = 16
    
    #-----< maxnoofBluetoothName >-----#
    maxnoofBluetoothName = INT(name=u'maxnoofBluetoothName', mode=MODE_VALUE)
    maxnoofBluetoothName._val = 4
    
    #-----< maxnoofWLANName >-----#
    maxnoofWLANName = INT(name=u'maxnoofWLANName', mode=MODE_VALUE)
    maxnoofWLANName._val = 4
    
    #-----< maxnoofConnectedengNBs >-----#
    maxnoofConnectedengNBs = INT(name=u'maxnoofConnectedengNBs', mode=MODE_VALUE)
    maxnoofConnectedengNBs._val = 256
    
    #-----< maxnoofPC5QoSFlows >-----#
    maxnoofPC5QoSFlows = INT(name=u'maxnoofPC5QoSFlows', mode=MODE_VALUE)
    maxnoofPC5QoSFlows._val = 2048
    
    #-----< maxnooffrequencies >-----#
    maxnooffrequencies = INT(name=u'maxnooffrequencies', mode=MODE_VALUE)
    maxnooffrequencies._val = 64
    
    #-----< maxNARFCN >-----#
    maxNARFCN = INT(name=u'maxNARFCN', mode=MODE_VALUE)
    maxNARFCN._val = 3279165
    
    #-----< maxRS-IndexCellQual >-----#
    maxRS_IndexCellQual = INT(name=u'maxRS-IndexCellQual', mode=MODE_VALUE)
    maxRS_IndexCellQual._val = 16
    
    #-----< id-MME-UE-S1AP-ID >-----#
    id_MME_UE_S1AP_ID = INT(name=u'id-MME-UE-S1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MME_UE_S1AP_ID._val = 0
    
    #-----< id-HandoverType >-----#
    id_HandoverType = INT(name=u'id-HandoverType', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HandoverType._val = 1
    
    #-----< id-Cause >-----#
    id_Cause = INT(name=u'id-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cause._val = 2
    
    #-----< id-SourceID >-----#
    id_SourceID = INT(name=u'id-SourceID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceID._val = 3
    
    #-----< id-TargetID >-----#
    id_TargetID = INT(name=u'id-TargetID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TargetID._val = 4
    
    #-----< id-eNB-UE-S1AP-ID >-----#
    id_eNB_UE_S1AP_ID = INT(name=u'id-eNB-UE-S1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_eNB_UE_S1AP_ID._val = 8
    
    #-----< id-E-RABSubjecttoDataForwardingList >-----#
    id_E_RABSubjecttoDataForwardingList = INT(name=u'id-E-RABSubjecttoDataForwardingList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABSubjecttoDataForwardingList._val = 12
    
    #-----< id-E-RABtoReleaseListHOCmd >-----#
    id_E_RABtoReleaseListHOCmd = INT(name=u'id-E-RABtoReleaseListHOCmd', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABtoReleaseListHOCmd._val = 13
    
    #-----< id-E-RABDataForwardingItem >-----#
    id_E_RABDataForwardingItem = INT(name=u'id-E-RABDataForwardingItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABDataForwardingItem._val = 14
    
    #-----< id-E-RABReleaseItemBearerRelComp >-----#
    id_E_RABReleaseItemBearerRelComp = INT(name=u'id-E-RABReleaseItemBearerRelComp', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABReleaseItemBearerRelComp._val = 15
    
    #-----< id-E-RABToBeSetupListBearerSUReq >-----#
    id_E_RABToBeSetupListBearerSUReq = INT(name=u'id-E-RABToBeSetupListBearerSUReq', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeSetupListBearerSUReq._val = 16
    
    #-----< id-E-RABToBeSetupItemBearerSUReq >-----#
    id_E_RABToBeSetupItemBearerSUReq = INT(name=u'id-E-RABToBeSetupItemBearerSUReq', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeSetupItemBearerSUReq._val = 17
    
    #-----< id-E-RABAdmittedList >-----#
    id_E_RABAdmittedList = INT(name=u'id-E-RABAdmittedList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABAdmittedList._val = 18
    
    #-----< id-E-RABFailedToSetupListHOReqAck >-----#
    id_E_RABFailedToSetupListHOReqAck = INT(name=u'id-E-RABFailedToSetupListHOReqAck', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToSetupListHOReqAck._val = 19
    
    #-----< id-E-RABAdmittedItem >-----#
    id_E_RABAdmittedItem = INT(name=u'id-E-RABAdmittedItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABAdmittedItem._val = 20
    
    #-----< id-E-RABFailedtoSetupItemHOReqAck >-----#
    id_E_RABFailedtoSetupItemHOReqAck = INT(name=u'id-E-RABFailedtoSetupItemHOReqAck', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedtoSetupItemHOReqAck._val = 21
    
    #-----< id-E-RABToBeSwitchedDLList >-----#
    id_E_RABToBeSwitchedDLList = INT(name=u'id-E-RABToBeSwitchedDLList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeSwitchedDLList._val = 22
    
    #-----< id-E-RABToBeSwitchedDLItem >-----#
    id_E_RABToBeSwitchedDLItem = INT(name=u'id-E-RABToBeSwitchedDLItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeSwitchedDLItem._val = 23
    
    #-----< id-E-RABToBeSetupListCtxtSUReq >-----#
    id_E_RABToBeSetupListCtxtSUReq = INT(name=u'id-E-RABToBeSetupListCtxtSUReq', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeSetupListCtxtSUReq._val = 24
    
    #-----< id-TraceActivation >-----#
    id_TraceActivation = INT(name=u'id-TraceActivation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceActivation._val = 25
    
    #-----< id-NAS-PDU >-----#
    id_NAS_PDU = INT(name=u'id-NAS-PDU', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NAS_PDU._val = 26
    
    #-----< id-E-RABToBeSetupItemHOReq >-----#
    id_E_RABToBeSetupItemHOReq = INT(name=u'id-E-RABToBeSetupItemHOReq', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeSetupItemHOReq._val = 27
    
    #-----< id-E-RABSetupListBearerSURes >-----#
    id_E_RABSetupListBearerSURes = INT(name=u'id-E-RABSetupListBearerSURes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABSetupListBearerSURes._val = 28
    
    #-----< id-E-RABFailedToSetupListBearerSURes >-----#
    id_E_RABFailedToSetupListBearerSURes = INT(name=u'id-E-RABFailedToSetupListBearerSURes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToSetupListBearerSURes._val = 29
    
    #-----< id-E-RABToBeModifiedListBearerModReq >-----#
    id_E_RABToBeModifiedListBearerModReq = INT(name=u'id-E-RABToBeModifiedListBearerModReq', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeModifiedListBearerModReq._val = 30
    
    #-----< id-E-RABModifyListBearerModRes >-----#
    id_E_RABModifyListBearerModRes = INT(name=u'id-E-RABModifyListBearerModRes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABModifyListBearerModRes._val = 31
    
    #-----< id-E-RABFailedToModifyList >-----#
    id_E_RABFailedToModifyList = INT(name=u'id-E-RABFailedToModifyList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToModifyList._val = 32
    
    #-----< id-E-RABToBeReleasedList >-----#
    id_E_RABToBeReleasedList = INT(name=u'id-E-RABToBeReleasedList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeReleasedList._val = 33
    
    #-----< id-E-RABFailedToReleaseList >-----#
    id_E_RABFailedToReleaseList = INT(name=u'id-E-RABFailedToReleaseList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToReleaseList._val = 34
    
    #-----< id-E-RABItem >-----#
    id_E_RABItem = INT(name=u'id-E-RABItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABItem._val = 35
    
    #-----< id-E-RABToBeModifiedItemBearerModReq >-----#
    id_E_RABToBeModifiedItemBearerModReq = INT(name=u'id-E-RABToBeModifiedItemBearerModReq', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeModifiedItemBearerModReq._val = 36
    
    #-----< id-E-RABModifyItemBearerModRes >-----#
    id_E_RABModifyItemBearerModRes = INT(name=u'id-E-RABModifyItemBearerModRes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABModifyItemBearerModRes._val = 37
    
    #-----< id-E-RABReleaseItem >-----#
    id_E_RABReleaseItem = INT(name=u'id-E-RABReleaseItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABReleaseItem._val = 38
    
    #-----< id-E-RABSetupItemBearerSURes >-----#
    id_E_RABSetupItemBearerSURes = INT(name=u'id-E-RABSetupItemBearerSURes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABSetupItemBearerSURes._val = 39
    
    #-----< id-SecurityContext >-----#
    id_SecurityContext = INT(name=u'id-SecurityContext', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecurityContext._val = 40
    
    #-----< id-HandoverRestrictionList >-----#
    id_HandoverRestrictionList = INT(name=u'id-HandoverRestrictionList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HandoverRestrictionList._val = 41
    
    #-----< id-UEPagingID >-----#
    id_UEPagingID = INT(name=u'id-UEPagingID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEPagingID._val = 43
    
    #-----< id-pagingDRX >-----#
    id_pagingDRX = INT(name=u'id-pagingDRX', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_pagingDRX._val = 44
    
    #-----< id-TAIList >-----#
    id_TAIList = INT(name=u'id-TAIList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TAIList._val = 46
    
    #-----< id-TAIItem >-----#
    id_TAIItem = INT(name=u'id-TAIItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TAIItem._val = 47
    
    #-----< id-E-RABFailedToSetupListCtxtSURes >-----#
    id_E_RABFailedToSetupListCtxtSURes = INT(name=u'id-E-RABFailedToSetupListCtxtSURes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToSetupListCtxtSURes._val = 48
    
    #-----< id-E-RABReleaseItemHOCmd >-----#
    id_E_RABReleaseItemHOCmd = INT(name=u'id-E-RABReleaseItemHOCmd', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABReleaseItemHOCmd._val = 49
    
    #-----< id-E-RABSetupItemCtxtSURes >-----#
    id_E_RABSetupItemCtxtSURes = INT(name=u'id-E-RABSetupItemCtxtSURes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABSetupItemCtxtSURes._val = 50
    
    #-----< id-E-RABSetupListCtxtSURes >-----#
    id_E_RABSetupListCtxtSURes = INT(name=u'id-E-RABSetupListCtxtSURes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABSetupListCtxtSURes._val = 51
    
    #-----< id-E-RABToBeSetupItemCtxtSUReq >-----#
    id_E_RABToBeSetupItemCtxtSUReq = INT(name=u'id-E-RABToBeSetupItemCtxtSUReq', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeSetupItemCtxtSUReq._val = 52
    
    #-----< id-E-RABToBeSetupListHOReq >-----#
    id_E_RABToBeSetupListHOReq = INT(name=u'id-E-RABToBeSetupListHOReq', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeSetupListHOReq._val = 53
    
    #-----< id-GERANtoLTEHOInformationRes >-----#
    id_GERANtoLTEHOInformationRes = INT(name=u'id-GERANtoLTEHOInformationRes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GERANtoLTEHOInformationRes._val = 55
    
    #-----< id-UTRANtoLTEHOInformationRes >-----#
    id_UTRANtoLTEHOInformationRes = INT(name=u'id-UTRANtoLTEHOInformationRes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UTRANtoLTEHOInformationRes._val = 57
    
    #-----< id-CriticalityDiagnostics >-----#
    id_CriticalityDiagnostics = INT(name=u'id-CriticalityDiagnostics', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CriticalityDiagnostics._val = 58
    
    #-----< id-Global-ENB-ID >-----#
    id_Global_ENB_ID = INT(name=u'id-Global-ENB-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Global_ENB_ID._val = 59
    
    #-----< id-eNBname >-----#
    id_eNBname = INT(name=u'id-eNBname', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_eNBname._val = 60
    
    #-----< id-MMEname >-----#
    id_MMEname = INT(name=u'id-MMEname', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MMEname._val = 61
    
    #-----< id-ServedPLMNs >-----#
    id_ServedPLMNs = INT(name=u'id-ServedPLMNs', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedPLMNs._val = 63
    
    #-----< id-SupportedTAs >-----#
    id_SupportedTAs = INT(name=u'id-SupportedTAs', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SupportedTAs._val = 64
    
    #-----< id-TimeToWait >-----#
    id_TimeToWait = INT(name=u'id-TimeToWait', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeToWait._val = 65
    
    #-----< id-uEaggregateMaximumBitrate >-----#
    id_uEaggregateMaximumBitrate = INT(name=u'id-uEaggregateMaximumBitrate', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_uEaggregateMaximumBitrate._val = 66
    
    #-----< id-TAI >-----#
    id_TAI = INT(name=u'id-TAI', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TAI._val = 67
    
    #-----< id-E-RABReleaseListBearerRelComp >-----#
    id_E_RABReleaseListBearerRelComp = INT(name=u'id-E-RABReleaseListBearerRelComp', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABReleaseListBearerRelComp._val = 69
    
    #-----< id-cdma2000PDU >-----#
    id_cdma2000PDU = INT(name=u'id-cdma2000PDU', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_cdma2000PDU._val = 70
    
    #-----< id-cdma2000RATType >-----#
    id_cdma2000RATType = INT(name=u'id-cdma2000RATType', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_cdma2000RATType._val = 71
    
    #-----< id-cdma2000SectorID >-----#
    id_cdma2000SectorID = INT(name=u'id-cdma2000SectorID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_cdma2000SectorID._val = 72
    
    #-----< id-SecurityKey >-----#
    id_SecurityKey = INT(name=u'id-SecurityKey', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecurityKey._val = 73
    
    #-----< id-UERadioCapability >-----#
    id_UERadioCapability = INT(name=u'id-UERadioCapability', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapability._val = 74
    
    #-----< id-GUMMEI-ID >-----#
    id_GUMMEI_ID = INT(name=u'id-GUMMEI-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GUMMEI_ID._val = 75
    
    #-----< id-E-RABInformationListItem >-----#
    id_E_RABInformationListItem = INT(name=u'id-E-RABInformationListItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABInformationListItem._val = 78
    
    #-----< id-Direct-Forwarding-Path-Availability >-----#
    id_Direct_Forwarding_Path_Availability = INT(name=u'id-Direct-Forwarding-Path-Availability', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Direct_Forwarding_Path_Availability._val = 79
    
    #-----< id-UEIdentityIndexValue >-----#
    id_UEIdentityIndexValue = INT(name=u'id-UEIdentityIndexValue', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEIdentityIndexValue._val = 80
    
    #-----< id-cdma2000HOStatus >-----#
    id_cdma2000HOStatus = INT(name=u'id-cdma2000HOStatus', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_cdma2000HOStatus._val = 83
    
    #-----< id-cdma2000HORequiredIndication >-----#
    id_cdma2000HORequiredIndication = INT(name=u'id-cdma2000HORequiredIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_cdma2000HORequiredIndication._val = 84
    
    #-----< id-E-UTRAN-Trace-ID >-----#
    id_E_UTRAN_Trace_ID = INT(name=u'id-E-UTRAN-Trace-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_UTRAN_Trace_ID._val = 86
    
    #-----< id-RelativeMMECapacity >-----#
    id_RelativeMMECapacity = INT(name=u'id-RelativeMMECapacity', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RelativeMMECapacity._val = 87
    
    #-----< id-SourceMME-UE-S1AP-ID >-----#
    id_SourceMME_UE_S1AP_ID = INT(name=u'id-SourceMME-UE-S1AP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceMME_UE_S1AP_ID._val = 88
    
    #-----< id-Bearers-SubjectToStatusTransfer-Item >-----#
    id_Bearers_SubjectToStatusTransfer_Item = INT(name=u'id-Bearers-SubjectToStatusTransfer-Item', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Bearers_SubjectToStatusTransfer_Item._val = 89
    
    #-----< id-eNB-StatusTransfer-TransparentContainer >-----#
    id_eNB_StatusTransfer_TransparentContainer = INT(name=u'id-eNB-StatusTransfer-TransparentContainer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_eNB_StatusTransfer_TransparentContainer._val = 90
    
    #-----< id-UE-associatedLogicalS1-ConnectionItem >-----#
    id_UE_associatedLogicalS1_ConnectionItem = INT(name=u'id-UE-associatedLogicalS1-ConnectionItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_associatedLogicalS1_ConnectionItem._val = 91
    
    #-----< id-ResetType >-----#
    id_ResetType = INT(name=u'id-ResetType', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResetType._val = 92
    
    #-----< id-UE-associatedLogicalS1-ConnectionListResAck >-----#
    id_UE_associatedLogicalS1_ConnectionListResAck = INT(name=u'id-UE-associatedLogicalS1-ConnectionListResAck', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_associatedLogicalS1_ConnectionListResAck._val = 93
    
    #-----< id-E-RABToBeSwitchedULItem >-----#
    id_E_RABToBeSwitchedULItem = INT(name=u'id-E-RABToBeSwitchedULItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeSwitchedULItem._val = 94
    
    #-----< id-E-RABToBeSwitchedULList >-----#
    id_E_RABToBeSwitchedULList = INT(name=u'id-E-RABToBeSwitchedULList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeSwitchedULList._val = 95
    
    #-----< id-S-TMSI >-----#
    id_S_TMSI = INT(name=u'id-S-TMSI', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S_TMSI._val = 96
    
    #-----< id-cdma2000OneXRAND >-----#
    id_cdma2000OneXRAND = INT(name=u'id-cdma2000OneXRAND', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_cdma2000OneXRAND._val = 97
    
    #-----< id-RequestType >-----#
    id_RequestType = INT(name=u'id-RequestType', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestType._val = 98
    
    #-----< id-UE-S1AP-IDs >-----#
    id_UE_S1AP_IDs = INT(name=u'id-UE-S1AP-IDs', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_S1AP_IDs._val = 99
    
    #-----< id-EUTRAN-CGI >-----#
    id_EUTRAN_CGI = INT(name=u'id-EUTRAN-CGI', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EUTRAN_CGI._val = 100
    
    #-----< id-OverloadResponse >-----#
    id_OverloadResponse = INT(name=u'id-OverloadResponse', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_OverloadResponse._val = 101
    
    #-----< id-cdma2000OneXSRVCCInfo >-----#
    id_cdma2000OneXSRVCCInfo = INT(name=u'id-cdma2000OneXSRVCCInfo', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_cdma2000OneXSRVCCInfo._val = 102
    
    #-----< id-E-RABFailedToBeReleasedList >-----#
    id_E_RABFailedToBeReleasedList = INT(name=u'id-E-RABFailedToBeReleasedList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToBeReleasedList._val = 103
    
    #-----< id-Source-ToTarget-TransparentContainer >-----#
    id_Source_ToTarget_TransparentContainer = INT(name=u'id-Source-ToTarget-TransparentContainer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Source_ToTarget_TransparentContainer._val = 104
    
    #-----< id-ServedGUMMEIs >-----#
    id_ServedGUMMEIs = INT(name=u'id-ServedGUMMEIs', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedGUMMEIs._val = 105
    
    #-----< id-SubscriberProfileIDforRFP >-----#
    id_SubscriberProfileIDforRFP = INT(name=u'id-SubscriberProfileIDforRFP', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SubscriberProfileIDforRFP._val = 106
    
    #-----< id-UESecurityCapabilities >-----#
    id_UESecurityCapabilities = INT(name=u'id-UESecurityCapabilities', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UESecurityCapabilities._val = 107
    
    #-----< id-CSFallbackIndicator >-----#
    id_CSFallbackIndicator = INT(name=u'id-CSFallbackIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSFallbackIndicator._val = 108
    
    #-----< id-CNDomain >-----#
    id_CNDomain = INT(name=u'id-CNDomain', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNDomain._val = 109
    
    #-----< id-E-RABReleasedList >-----#
    id_E_RABReleasedList = INT(name=u'id-E-RABReleasedList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABReleasedList._val = 110
    
    #-----< id-MessageIdentifier >-----#
    id_MessageIdentifier = INT(name=u'id-MessageIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MessageIdentifier._val = 111
    
    #-----< id-SerialNumber >-----#
    id_SerialNumber = INT(name=u'id-SerialNumber', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SerialNumber._val = 112
    
    #-----< id-WarningAreaList >-----#
    id_WarningAreaList = INT(name=u'id-WarningAreaList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WarningAreaList._val = 113
    
    #-----< id-RepetitionPeriod >-----#
    id_RepetitionPeriod = INT(name=u'id-RepetitionPeriod', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RepetitionPeriod._val = 114
    
    #-----< id-NumberofBroadcastRequest >-----#
    id_NumberofBroadcastRequest = INT(name=u'id-NumberofBroadcastRequest', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NumberofBroadcastRequest._val = 115
    
    #-----< id-WarningType >-----#
    id_WarningType = INT(name=u'id-WarningType', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WarningType._val = 116
    
    #-----< id-WarningSecurityInfo >-----#
    id_WarningSecurityInfo = INT(name=u'id-WarningSecurityInfo', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WarningSecurityInfo._val = 117
    
    #-----< id-DataCodingScheme >-----#
    id_DataCodingScheme = INT(name=u'id-DataCodingScheme', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DataCodingScheme._val = 118
    
    #-----< id-WarningMessageContents >-----#
    id_WarningMessageContents = INT(name=u'id-WarningMessageContents', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WarningMessageContents._val = 119
    
    #-----< id-BroadcastCompletedAreaList >-----#
    id_BroadcastCompletedAreaList = INT(name=u'id-BroadcastCompletedAreaList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastCompletedAreaList._val = 120
    
    #-----< id-Inter-SystemInformationTransferTypeEDT >-----#
    id_Inter_SystemInformationTransferTypeEDT = INT(name=u'id-Inter-SystemInformationTransferTypeEDT', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Inter_SystemInformationTransferTypeEDT._val = 121
    
    #-----< id-Inter-SystemInformationTransferTypeMDT >-----#
    id_Inter_SystemInformationTransferTypeMDT = INT(name=u'id-Inter-SystemInformationTransferTypeMDT', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Inter_SystemInformationTransferTypeMDT._val = 122
    
    #-----< id-Target-ToSource-TransparentContainer >-----#
    id_Target_ToSource_TransparentContainer = INT(name=u'id-Target-ToSource-TransparentContainer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Target_ToSource_TransparentContainer._val = 123
    
    #-----< id-SRVCCOperationPossible >-----#
    id_SRVCCOperationPossible = INT(name=u'id-SRVCCOperationPossible', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRVCCOperationPossible._val = 124
    
    #-----< id-SRVCCHOIndication >-----#
    id_SRVCCHOIndication = INT(name=u'id-SRVCCHOIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRVCCHOIndication._val = 125
    
    #-----< id-NAS-DownlinkCount >-----#
    id_NAS_DownlinkCount = INT(name=u'id-NAS-DownlinkCount', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NAS_DownlinkCount._val = 126
    
    #-----< id-CSG-Id >-----#
    id_CSG_Id = INT(name=u'id-CSG-Id', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSG_Id._val = 127
    
    #-----< id-CSG-IdList >-----#
    id_CSG_IdList = INT(name=u'id-CSG-IdList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSG_IdList._val = 128
    
    #-----< id-SONConfigurationTransferECT >-----#
    id_SONConfigurationTransferECT = INT(name=u'id-SONConfigurationTransferECT', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SONConfigurationTransferECT._val = 129
    
    #-----< id-SONConfigurationTransferMCT >-----#
    id_SONConfigurationTransferMCT = INT(name=u'id-SONConfigurationTransferMCT', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SONConfigurationTransferMCT._val = 130
    
    #-----< id-TraceCollectionEntityIPAddress >-----#
    id_TraceCollectionEntityIPAddress = INT(name=u'id-TraceCollectionEntityIPAddress', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceCollectionEntityIPAddress._val = 131
    
    #-----< id-MSClassmark2 >-----#
    id_MSClassmark2 = INT(name=u'id-MSClassmark2', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MSClassmark2._val = 132
    
    #-----< id-MSClassmark3 >-----#
    id_MSClassmark3 = INT(name=u'id-MSClassmark3', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MSClassmark3._val = 133
    
    #-----< id-RRC-Establishment-Cause >-----#
    id_RRC_Establishment_Cause = INT(name=u'id-RRC-Establishment-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRC_Establishment_Cause._val = 134
    
    #-----< id-NASSecurityParametersfromE-UTRAN >-----#
    id_NASSecurityParametersfromE_UTRAN = INT(name=u'id-NASSecurityParametersfromE-UTRAN', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NASSecurityParametersfromE_UTRAN._val = 135
    
    #-----< id-NASSecurityParameterstoE-UTRAN >-----#
    id_NASSecurityParameterstoE_UTRAN = INT(name=u'id-NASSecurityParameterstoE-UTRAN', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NASSecurityParameterstoE_UTRAN._val = 136
    
    #-----< id-DefaultPagingDRX >-----#
    id_DefaultPagingDRX = INT(name=u'id-DefaultPagingDRX', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DefaultPagingDRX._val = 137
    
    #-----< id-Source-ToTarget-TransparentContainer-Secondary >-----#
    id_Source_ToTarget_TransparentContainer_Secondary = INT(name=u'id-Source-ToTarget-TransparentContainer-Secondary', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Source_ToTarget_TransparentContainer_Secondary._val = 138
    
    #-----< id-Target-ToSource-TransparentContainer-Secondary >-----#
    id_Target_ToSource_TransparentContainer_Secondary = INT(name=u'id-Target-ToSource-TransparentContainer-Secondary', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Target_ToSource_TransparentContainer_Secondary._val = 139
    
    #-----< id-EUTRANRoundTripDelayEstimationInfo >-----#
    id_EUTRANRoundTripDelayEstimationInfo = INT(name=u'id-EUTRANRoundTripDelayEstimationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EUTRANRoundTripDelayEstimationInfo._val = 140
    
    #-----< id-BroadcastCancelledAreaList >-----#
    id_BroadcastCancelledAreaList = INT(name=u'id-BroadcastCancelledAreaList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BroadcastCancelledAreaList._val = 141
    
    #-----< id-ConcurrentWarningMessageIndicator >-----#
    id_ConcurrentWarningMessageIndicator = INT(name=u'id-ConcurrentWarningMessageIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConcurrentWarningMessageIndicator._val = 142
    
    #-----< id-Data-Forwarding-Not-Possible >-----#
    id_Data_Forwarding_Not_Possible = INT(name=u'id-Data-Forwarding-Not-Possible', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Data_Forwarding_Not_Possible._val = 143
    
    #-----< id-ExtendedRepetitionPeriod >-----#
    id_ExtendedRepetitionPeriod = INT(name=u'id-ExtendedRepetitionPeriod', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedRepetitionPeriod._val = 144
    
    #-----< id-CellAccessMode >-----#
    id_CellAccessMode = INT(name=u'id-CellAccessMode', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellAccessMode._val = 145
    
    #-----< id-CSGMembershipStatus >-----#
    id_CSGMembershipStatus = INT(name=u'id-CSGMembershipStatus', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSGMembershipStatus._val = 146
    
    #-----< id-LPPa-PDU >-----#
    id_LPPa_PDU = INT(name=u'id-LPPa-PDU', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LPPa_PDU._val = 147
    
    #-----< id-Routing-ID >-----#
    id_Routing_ID = INT(name=u'id-Routing-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Routing_ID._val = 148
    
    #-----< id-Time-Synchronisation-Info >-----#
    id_Time_Synchronisation_Info = INT(name=u'id-Time-Synchronisation-Info', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Time_Synchronisation_Info._val = 149
    
    #-----< id-PS-ServiceNotAvailable >-----#
    id_PS_ServiceNotAvailable = INT(name=u'id-PS-ServiceNotAvailable', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PS_ServiceNotAvailable._val = 150
    
    #-----< id-PagingPriority >-----#
    id_PagingPriority = INT(name=u'id-PagingPriority', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingPriority._val = 151
    
    #-----< id-x2TNLConfigurationInfo >-----#
    id_x2TNLConfigurationInfo = INT(name=u'id-x2TNLConfigurationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_x2TNLConfigurationInfo._val = 152
    
    #-----< id-eNBX2ExtendedTransportLayerAddresses >-----#
    id_eNBX2ExtendedTransportLayerAddresses = INT(name=u'id-eNBX2ExtendedTransportLayerAddresses', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_eNBX2ExtendedTransportLayerAddresses._val = 153
    
    #-----< id-GUMMEIList >-----#
    id_GUMMEIList = INT(name=u'id-GUMMEIList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GUMMEIList._val = 154
    
    #-----< id-GW-TransportLayerAddress >-----#
    id_GW_TransportLayerAddress = INT(name=u'id-GW-TransportLayerAddress', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GW_TransportLayerAddress._val = 155
    
    #-----< id-Correlation-ID >-----#
    id_Correlation_ID = INT(name=u'id-Correlation-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Correlation_ID._val = 156
    
    #-----< id-SourceMME-GUMMEI >-----#
    id_SourceMME_GUMMEI = INT(name=u'id-SourceMME-GUMMEI', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceMME_GUMMEI._val = 157
    
    #-----< id-MME-UE-S1AP-ID-2 >-----#
    id_MME_UE_S1AP_ID_2 = INT(name=u'id-MME-UE-S1AP-ID-2', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MME_UE_S1AP_ID_2._val = 158
    
    #-----< id-RegisteredLAI >-----#
    id_RegisteredLAI = INT(name=u'id-RegisteredLAI', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RegisteredLAI._val = 159
    
    #-----< id-RelayNode-Indicator >-----#
    id_RelayNode_Indicator = INT(name=u'id-RelayNode-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RelayNode_Indicator._val = 160
    
    #-----< id-TrafficLoadReductionIndication >-----#
    id_TrafficLoadReductionIndication = INT(name=u'id-TrafficLoadReductionIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TrafficLoadReductionIndication._val = 161
    
    #-----< id-MDTConfiguration >-----#
    id_MDTConfiguration = INT(name=u'id-MDTConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MDTConfiguration._val = 162
    
    #-----< id-MMERelaySupportIndicator >-----#
    id_MMERelaySupportIndicator = INT(name=u'id-MMERelaySupportIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MMERelaySupportIndicator._val = 163
    
    #-----< id-GWContextReleaseIndication >-----#
    id_GWContextReleaseIndication = INT(name=u'id-GWContextReleaseIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GWContextReleaseIndication._val = 164
    
    #-----< id-ManagementBasedMDTAllowed >-----#
    id_ManagementBasedMDTAllowed = INT(name=u'id-ManagementBasedMDTAllowed', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ManagementBasedMDTAllowed._val = 165
    
    #-----< id-PrivacyIndicator >-----#
    id_PrivacyIndicator = INT(name=u'id-PrivacyIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrivacyIndicator._val = 166
    
    #-----< id-Time-UE-StayedInCell-EnhancedGranularity >-----#
    id_Time_UE_StayedInCell_EnhancedGranularity = INT(name=u'id-Time-UE-StayedInCell-EnhancedGranularity', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Time_UE_StayedInCell_EnhancedGranularity._val = 167
    
    #-----< id-HO-Cause >-----#
    id_HO_Cause = INT(name=u'id-HO-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HO_Cause._val = 168
    
    #-----< id-VoiceSupportMatchIndicator >-----#
    id_VoiceSupportMatchIndicator = INT(name=u'id-VoiceSupportMatchIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_VoiceSupportMatchIndicator._val = 169
    
    #-----< id-GUMMEIType >-----#
    id_GUMMEIType = INT(name=u'id-GUMMEIType', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GUMMEIType._val = 170
    
    #-----< id-M3Configuration >-----#
    id_M3Configuration = INT(name=u'id-M3Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M3Configuration._val = 171
    
    #-----< id-M4Configuration >-----#
    id_M4Configuration = INT(name=u'id-M4Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M4Configuration._val = 172
    
    #-----< id-M5Configuration >-----#
    id_M5Configuration = INT(name=u'id-M5Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M5Configuration._val = 173
    
    #-----< id-MDT-Location-Info >-----#
    id_MDT_Location_Info = INT(name=u'id-MDT-Location-Info', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MDT_Location_Info._val = 174
    
    #-----< id-MobilityInformation >-----#
    id_MobilityInformation = INT(name=u'id-MobilityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MobilityInformation._val = 175
    
    #-----< id-Tunnel-Information-for-BBF >-----#
    id_Tunnel_Information_for_BBF = INT(name=u'id-Tunnel-Information-for-BBF', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Tunnel_Information_for_BBF._val = 176
    
    #-----< id-ManagementBasedMDTPLMNList >-----#
    id_ManagementBasedMDTPLMNList = INT(name=u'id-ManagementBasedMDTPLMNList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ManagementBasedMDTPLMNList._val = 177
    
    #-----< id-SignallingBasedMDTPLMNList >-----#
    id_SignallingBasedMDTPLMNList = INT(name=u'id-SignallingBasedMDTPLMNList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SignallingBasedMDTPLMNList._val = 178
    
    #-----< id-ULCOUNTValueExtended >-----#
    id_ULCOUNTValueExtended = INT(name=u'id-ULCOUNTValueExtended', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ULCOUNTValueExtended._val = 179
    
    #-----< id-DLCOUNTValueExtended >-----#
    id_DLCOUNTValueExtended = INT(name=u'id-DLCOUNTValueExtended', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DLCOUNTValueExtended._val = 180
    
    #-----< id-ReceiveStatusOfULPDCPSDUsExtended >-----#
    id_ReceiveStatusOfULPDCPSDUsExtended = INT(name=u'id-ReceiveStatusOfULPDCPSDUsExtended', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReceiveStatusOfULPDCPSDUsExtended._val = 181
    
    #-----< id-ECGIListForRestart >-----#
    id_ECGIListForRestart = INT(name=u'id-ECGIListForRestart', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ECGIListForRestart._val = 182
    
    #-----< id-SIPTO-Correlation-ID >-----#
    id_SIPTO_Correlation_ID = INT(name=u'id-SIPTO-Correlation-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SIPTO_Correlation_ID._val = 183
    
    #-----< id-SIPTO-L-GW-TransportLayerAddress >-----#
    id_SIPTO_L_GW_TransportLayerAddress = INT(name=u'id-SIPTO-L-GW-TransportLayerAddress', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SIPTO_L_GW_TransportLayerAddress._val = 184
    
    #-----< id-TransportInformation >-----#
    id_TransportInformation = INT(name=u'id-TransportInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransportInformation._val = 185
    
    #-----< id-LHN-ID >-----#
    id_LHN_ID = INT(name=u'id-LHN-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LHN_ID._val = 186
    
    #-----< id-AdditionalCSFallbackIndicator >-----#
    id_AdditionalCSFallbackIndicator = INT(name=u'id-AdditionalCSFallbackIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalCSFallbackIndicator._val = 187
    
    #-----< id-TAIListForRestart >-----#
    id_TAIListForRestart = INT(name=u'id-TAIListForRestart', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TAIListForRestart._val = 188
    
    #-----< id-UserLocationInformation >-----#
    id_UserLocationInformation = INT(name=u'id-UserLocationInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UserLocationInformation._val = 189
    
    #-----< id-EmergencyAreaIDListForRestart >-----#
    id_EmergencyAreaIDListForRestart = INT(name=u'id-EmergencyAreaIDListForRestart', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EmergencyAreaIDListForRestart._val = 190
    
    #-----< id-KillAllWarningMessages >-----#
    id_KillAllWarningMessages = INT(name=u'id-KillAllWarningMessages', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_KillAllWarningMessages._val = 191
    
    #-----< id-Masked-IMEISV >-----#
    id_Masked_IMEISV = INT(name=u'id-Masked-IMEISV', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Masked_IMEISV._val = 192
    
    #-----< id-eNBIndirectX2TransportLayerAddresses >-----#
    id_eNBIndirectX2TransportLayerAddresses = INT(name=u'id-eNBIndirectX2TransportLayerAddresses', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_eNBIndirectX2TransportLayerAddresses._val = 193
    
    #-----< id-uE-HistoryInformationFromTheUE >-----#
    id_uE_HistoryInformationFromTheUE = INT(name=u'id-uE-HistoryInformationFromTheUE', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_uE_HistoryInformationFromTheUE._val = 194
    
    #-----< id-ProSeAuthorized >-----#
    id_ProSeAuthorized = INT(name=u'id-ProSeAuthorized', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ProSeAuthorized._val = 195
    
    #-----< id-ExpectedUEBehaviour >-----#
    id_ExpectedUEBehaviour = INT(name=u'id-ExpectedUEBehaviour', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExpectedUEBehaviour._val = 196
    
    #-----< id-LoggedMBSFNMDT >-----#
    id_LoggedMBSFNMDT = INT(name=u'id-LoggedMBSFNMDT', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LoggedMBSFNMDT._val = 197
    
    #-----< id-UERadioCapabilityForPaging >-----#
    id_UERadioCapabilityForPaging = INT(name=u'id-UERadioCapabilityForPaging', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapabilityForPaging._val = 198
    
    #-----< id-E-RABToBeModifiedListBearerModInd >-----#
    id_E_RABToBeModifiedListBearerModInd = INT(name=u'id-E-RABToBeModifiedListBearerModInd', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeModifiedListBearerModInd._val = 199
    
    #-----< id-E-RABToBeModifiedItemBearerModInd >-----#
    id_E_RABToBeModifiedItemBearerModInd = INT(name=u'id-E-RABToBeModifiedItemBearerModInd', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeModifiedItemBearerModInd._val = 200
    
    #-----< id-E-RABNotToBeModifiedListBearerModInd >-----#
    id_E_RABNotToBeModifiedListBearerModInd = INT(name=u'id-E-RABNotToBeModifiedListBearerModInd', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABNotToBeModifiedListBearerModInd._val = 201
    
    #-----< id-E-RABNotToBeModifiedItemBearerModInd >-----#
    id_E_RABNotToBeModifiedItemBearerModInd = INT(name=u'id-E-RABNotToBeModifiedItemBearerModInd', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABNotToBeModifiedItemBearerModInd._val = 202
    
    #-----< id-E-RABModifyListBearerModConf >-----#
    id_E_RABModifyListBearerModConf = INT(name=u'id-E-RABModifyListBearerModConf', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABModifyListBearerModConf._val = 203
    
    #-----< id-E-RABModifyItemBearerModConf >-----#
    id_E_RABModifyItemBearerModConf = INT(name=u'id-E-RABModifyItemBearerModConf', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABModifyItemBearerModConf._val = 204
    
    #-----< id-E-RABFailedToModifyListBearerModConf >-----#
    id_E_RABFailedToModifyListBearerModConf = INT(name=u'id-E-RABFailedToModifyListBearerModConf', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToModifyListBearerModConf._val = 205
    
    #-----< id-SON-Information-Report >-----#
    id_SON_Information_Report = INT(name=u'id-SON-Information-Report', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SON_Information_Report._val = 206
    
    #-----< id-Muting-Availability-Indication >-----#
    id_Muting_Availability_Indication = INT(name=u'id-Muting-Availability-Indication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Muting_Availability_Indication._val = 207
    
    #-----< id-Muting-Pattern-Information >-----#
    id_Muting_Pattern_Information = INT(name=u'id-Muting-Pattern-Information', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Muting_Pattern_Information._val = 208
    
    #-----< id-Synchronisation-Information >-----#
    id_Synchronisation_Information = INT(name=u'id-Synchronisation-Information', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Synchronisation_Information._val = 209
    
    #-----< id-E-RABToBeReleasedListBearerModConf >-----#
    id_E_RABToBeReleasedListBearerModConf = INT(name=u'id-E-RABToBeReleasedListBearerModConf', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABToBeReleasedListBearerModConf._val = 210
    
    #-----< id-AssistanceDataForPaging >-----#
    id_AssistanceDataForPaging = INT(name=u'id-AssistanceDataForPaging', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AssistanceDataForPaging._val = 211
    
    #-----< id-CellIdentifierAndCELevelForCECapableUEs >-----#
    id_CellIdentifierAndCELevelForCECapableUEs = INT(name=u'id-CellIdentifierAndCELevelForCECapableUEs', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellIdentifierAndCELevelForCECapableUEs._val = 212
    
    #-----< id-InformationOnRecommendedCellsAndENBsForPaging >-----#
    id_InformationOnRecommendedCellsAndENBsForPaging = INT(name=u'id-InformationOnRecommendedCellsAndENBsForPaging', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InformationOnRecommendedCellsAndENBsForPaging._val = 213
    
    #-----< id-RecommendedCellItem >-----#
    id_RecommendedCellItem = INT(name=u'id-RecommendedCellItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RecommendedCellItem._val = 214
    
    #-----< id-RecommendedENBItem >-----#
    id_RecommendedENBItem = INT(name=u'id-RecommendedENBItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RecommendedENBItem._val = 215
    
    #-----< id-ProSeUEtoNetworkRelaying >-----#
    id_ProSeUEtoNetworkRelaying = INT(name=u'id-ProSeUEtoNetworkRelaying', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ProSeUEtoNetworkRelaying._val = 216
    
    #-----< id-ULCOUNTValuePDCP-SNlength18 >-----#
    id_ULCOUNTValuePDCP_SNlength18 = INT(name=u'id-ULCOUNTValuePDCP-SNlength18', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ULCOUNTValuePDCP_SNlength18._val = 217
    
    #-----< id-DLCOUNTValuePDCP-SNlength18 >-----#
    id_DLCOUNTValuePDCP_SNlength18 = INT(name=u'id-DLCOUNTValuePDCP-SNlength18', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DLCOUNTValuePDCP_SNlength18._val = 218
    
    #-----< id-ReceiveStatusOfULPDCPSDUsPDCP-SNlength18 >-----#
    id_ReceiveStatusOfULPDCPSDUsPDCP_SNlength18 = INT(name=u'id-ReceiveStatusOfULPDCPSDUsPDCP-SNlength18', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReceiveStatusOfULPDCPSDUsPDCP_SNlength18._val = 219
    
    #-----< id-M6Configuration >-----#
    id_M6Configuration = INT(name=u'id-M6Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M6Configuration._val = 220
    
    #-----< id-M7Configuration >-----#
    id_M7Configuration = INT(name=u'id-M7Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_M7Configuration._val = 221
    
    #-----< id-PWSfailedECGIList >-----#
    id_PWSfailedECGIList = INT(name=u'id-PWSfailedECGIList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PWSfailedECGIList._val = 222
    
    #-----< id-MME-Group-ID >-----#
    id_MME_Group_ID = INT(name=u'id-MME-Group-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MME_Group_ID._val = 223
    
    #-----< id-Additional-GUTI >-----#
    id_Additional_GUTI = INT(name=u'id-Additional-GUTI', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_GUTI._val = 224
    
    #-----< id-S1-Message >-----#
    id_S1_Message = INT(name=u'id-S1-Message', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S1_Message._val = 225
    
    #-----< id-CSGMembershipInfo >-----#
    id_CSGMembershipInfo = INT(name=u'id-CSGMembershipInfo', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CSGMembershipInfo._val = 226
    
    #-----< id-Paging-eDRXInformation >-----#
    id_Paging_eDRXInformation = INT(name=u'id-Paging-eDRXInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Paging_eDRXInformation._val = 227
    
    #-----< id-UE-RetentionInformation >-----#
    id_UE_RetentionInformation = INT(name=u'id-UE-RetentionInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_RetentionInformation._val = 228
    
    #-----< id-UE-Usage-Type >-----#
    id_UE_Usage_Type = INT(name=u'id-UE-Usage-Type', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_Usage_Type._val = 230
    
    #-----< id-extended-UEIdentityIndexValue >-----#
    id_extended_UEIdentityIndexValue = INT(name=u'id-extended-UEIdentityIndexValue', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_extended_UEIdentityIndexValue._val = 231
    
    #-----< id-RAT-Type >-----#
    id_RAT_Type = INT(name=u'id-RAT-Type', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RAT_Type._val = 232
    
    #-----< id-BearerType >-----#
    id_BearerType = INT(name=u'id-BearerType', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BearerType._val = 233
    
    #-----< id-NB-IoT-DefaultPagingDRX >-----#
    id_NB_IoT_DefaultPagingDRX = INT(name=u'id-NB-IoT-DefaultPagingDRX', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NB_IoT_DefaultPagingDRX._val = 234
    
    #-----< id-E-RABFailedToResumeListResumeReq >-----#
    id_E_RABFailedToResumeListResumeReq = INT(name=u'id-E-RABFailedToResumeListResumeReq', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToResumeListResumeReq._val = 235
    
    #-----< id-E-RABFailedToResumeItemResumeReq >-----#
    id_E_RABFailedToResumeItemResumeReq = INT(name=u'id-E-RABFailedToResumeItemResumeReq', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToResumeItemResumeReq._val = 236
    
    #-----< id-E-RABFailedToResumeListResumeRes >-----#
    id_E_RABFailedToResumeListResumeRes = INT(name=u'id-E-RABFailedToResumeListResumeRes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToResumeListResumeRes._val = 237
    
    #-----< id-E-RABFailedToResumeItemResumeRes >-----#
    id_E_RABFailedToResumeItemResumeRes = INT(name=u'id-E-RABFailedToResumeItemResumeRes', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABFailedToResumeItemResumeRes._val = 238
    
    #-----< id-NB-IoT-Paging-eDRXInformation >-----#
    id_NB_IoT_Paging_eDRXInformation = INT(name=u'id-NB-IoT-Paging-eDRXInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NB_IoT_Paging_eDRXInformation._val = 239
    
    #-----< id-V2XServicesAuthorized >-----#
    id_V2XServicesAuthorized = INT(name=u'id-V2XServicesAuthorized', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_V2XServicesAuthorized._val = 240
    
    #-----< id-UEUserPlaneCIoTSupportIndicator >-----#
    id_UEUserPlaneCIoTSupportIndicator = INT(name=u'id-UEUserPlaneCIoTSupportIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEUserPlaneCIoTSupportIndicator._val = 241
    
    #-----< id-CE-mode-B-SupportIndicator >-----#
    id_CE_mode_B_SupportIndicator = INT(name=u'id-CE-mode-B-SupportIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CE_mode_B_SupportIndicator._val = 242
    
    #-----< id-SRVCCOperationNotPossible >-----#
    id_SRVCCOperationNotPossible = INT(name=u'id-SRVCCOperationNotPossible', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRVCCOperationNotPossible._val = 243
    
    #-----< id-NB-IoT-UEIdentityIndexValue >-----#
    id_NB_IoT_UEIdentityIndexValue = INT(name=u'id-NB-IoT-UEIdentityIndexValue', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NB_IoT_UEIdentityIndexValue._val = 244
    
    #-----< id-RRC-Resume-Cause >-----#
    id_RRC_Resume_Cause = INT(name=u'id-RRC-Resume-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRC_Resume_Cause._val = 245
    
    #-----< id-DCN-ID >-----#
    id_DCN_ID = INT(name=u'id-DCN-ID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCN_ID._val = 246
    
    #-----< id-ServedDCNs >-----#
    id_ServedDCNs = INT(name=u'id-ServedDCNs', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServedDCNs._val = 247
    
    #-----< id-UESidelinkAggregateMaximumBitrate >-----#
    id_UESidelinkAggregateMaximumBitrate = INT(name=u'id-UESidelinkAggregateMaximumBitrate', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UESidelinkAggregateMaximumBitrate._val = 248
    
    #-----< id-DLNASPDUDeliveryAckRequest >-----#
    id_DLNASPDUDeliveryAckRequest = INT(name=u'id-DLNASPDUDeliveryAckRequest', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DLNASPDUDeliveryAckRequest._val = 249
    
    #-----< id-Coverage-Level >-----#
    id_Coverage_Level = INT(name=u'id-Coverage-Level', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Coverage_Level._val = 250
    
    #-----< id-EnhancedCoverageRestricted >-----#
    id_EnhancedCoverageRestricted = INT(name=u'id-EnhancedCoverageRestricted', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EnhancedCoverageRestricted._val = 251
    
    #-----< id-UE-Level-QoS-Parameters >-----#
    id_UE_Level_QoS_Parameters = INT(name=u'id-UE-Level-QoS-Parameters', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_Level_QoS_Parameters._val = 252
    
    #-----< id-DL-CP-SecurityInformation >-----#
    id_DL_CP_SecurityInformation = INT(name=u'id-DL-CP-SecurityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CP_SecurityInformation._val = 253
    
    #-----< id-UL-CP-SecurityInformation >-----#
    id_UL_CP_SecurityInformation = INT(name=u'id-UL-CP-SecurityInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CP_SecurityInformation._val = 254
    
    #-----< id-extended-e-RAB-MaximumBitrateDL >-----#
    id_extended_e_RAB_MaximumBitrateDL = INT(name=u'id-extended-e-RAB-MaximumBitrateDL', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_extended_e_RAB_MaximumBitrateDL._val = 255
    
    #-----< id-extended-e-RAB-MaximumBitrateUL >-----#
    id_extended_e_RAB_MaximumBitrateUL = INT(name=u'id-extended-e-RAB-MaximumBitrateUL', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_extended_e_RAB_MaximumBitrateUL._val = 256
    
    #-----< id-extended-e-RAB-GuaranteedBitrateDL >-----#
    id_extended_e_RAB_GuaranteedBitrateDL = INT(name=u'id-extended-e-RAB-GuaranteedBitrateDL', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_extended_e_RAB_GuaranteedBitrateDL._val = 257
    
    #-----< id-extended-e-RAB-GuaranteedBitrateUL >-----#
    id_extended_e_RAB_GuaranteedBitrateUL = INT(name=u'id-extended-e-RAB-GuaranteedBitrateUL', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_extended_e_RAB_GuaranteedBitrateUL._val = 258
    
    #-----< id-extended-uEaggregateMaximumBitRateDL >-----#
    id_extended_uEaggregateMaximumBitRateDL = INT(name=u'id-extended-uEaggregateMaximumBitRateDL', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_extended_uEaggregateMaximumBitRateDL._val = 259
    
    #-----< id-extended-uEaggregateMaximumBitRateUL >-----#
    id_extended_uEaggregateMaximumBitRateUL = INT(name=u'id-extended-uEaggregateMaximumBitRateUL', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_extended_uEaggregateMaximumBitRateUL._val = 260
    
    #-----< id-NRrestrictioninEPSasSecondaryRAT >-----#
    id_NRrestrictioninEPSasSecondaryRAT = INT(name=u'id-NRrestrictioninEPSasSecondaryRAT', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRrestrictioninEPSasSecondaryRAT._val = 261
    
    #-----< id-UEAppLayerMeasConfig >-----#
    id_UEAppLayerMeasConfig = INT(name=u'id-UEAppLayerMeasConfig', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEAppLayerMeasConfig._val = 262
    
    #-----< id-UE-Application-Layer-Measurement-Capability >-----#
    id_UE_Application_Layer_Measurement_Capability = INT(name=u'id-UE-Application-Layer-Measurement-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_Application_Layer_Measurement_Capability._val = 263
    
    #-----< id-SecondaryRATDataUsageReportList >-----#
    id_SecondaryRATDataUsageReportList = INT(name=u'id-SecondaryRATDataUsageReportList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecondaryRATDataUsageReportList._val = 264
    
    #-----< id-SecondaryRATDataUsageReportItem >-----#
    id_SecondaryRATDataUsageReportItem = INT(name=u'id-SecondaryRATDataUsageReportItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecondaryRATDataUsageReportItem._val = 265
    
    #-----< id-HandoverFlag >-----#
    id_HandoverFlag = INT(name=u'id-HandoverFlag', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HandoverFlag._val = 266
    
    #-----< id-E-RABUsageReportItem >-----#
    id_E_RABUsageReportItem = INT(name=u'id-E-RABUsageReportItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABUsageReportItem._val = 267
    
    #-----< id-SecondaryRATDataUsageRequest >-----#
    id_SecondaryRATDataUsageRequest = INT(name=u'id-SecondaryRATDataUsageRequest', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SecondaryRATDataUsageRequest._val = 268
    
    #-----< id-NRUESecurityCapabilities >-----#
    id_NRUESecurityCapabilities = INT(name=u'id-NRUESecurityCapabilities', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRUESecurityCapabilities._val = 269
    
    #-----< id-UnlicensedSpectrumRestriction >-----#
    id_UnlicensedSpectrumRestriction = INT(name=u'id-UnlicensedSpectrumRestriction', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UnlicensedSpectrumRestriction._val = 270
    
    #-----< id-CE-ModeBRestricted >-----#
    id_CE_ModeBRestricted = INT(name=u'id-CE-ModeBRestricted', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CE_ModeBRestricted._val = 271
    
    #-----< id-LTE-M-Indication >-----#
    id_LTE_M_Indication = INT(name=u'id-LTE-M-Indication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LTE_M_Indication._val = 272
    
    #-----< id-DownlinkPacketLossRate >-----#
    id_DownlinkPacketLossRate = INT(name=u'id-DownlinkPacketLossRate', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DownlinkPacketLossRate._val = 273
    
    #-----< id-UplinkPacketLossRate >-----#
    id_UplinkPacketLossRate = INT(name=u'id-UplinkPacketLossRate', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UplinkPacketLossRate._val = 274
    
    #-----< id-UECapabilityInfoRequest >-----#
    id_UECapabilityInfoRequest = INT(name=u'id-UECapabilityInfoRequest', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UECapabilityInfoRequest._val = 275
    
    #-----< id-serviceType >-----#
    id_serviceType = INT(name=u'id-serviceType', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_serviceType._val = 276
    
    #-----< id-AerialUEsubscriptionInformation >-----#
    id_AerialUEsubscriptionInformation = INT(name=u'id-AerialUEsubscriptionInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AerialUEsubscriptionInformation._val = 277
    
    #-----< id-Subscription-Based-UE-DifferentiationInfo >-----#
    id_Subscription_Based_UE_DifferentiationInfo = INT(name=u'id-Subscription-Based-UE-DifferentiationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Subscription_Based_UE_DifferentiationInfo._val = 278
    
    #-----< id-EndIndication >-----#
    id_EndIndication = INT(name=u'id-EndIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EndIndication._val = 280
    
    #-----< id-EDT-Session >-----#
    id_EDT_Session = INT(name=u'id-EDT-Session', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDT_Session._val = 281
    
    #-----< id-CNTypeRestrictions >-----#
    id_CNTypeRestrictions = INT(name=u'id-CNTypeRestrictions', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNTypeRestrictions._val = 282
    
    #-----< id-PendingDataIndication >-----#
    id_PendingDataIndication = INT(name=u'id-PendingDataIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PendingDataIndication._val = 283
    
    #-----< id-BluetoothMeasurementConfiguration >-----#
    id_BluetoothMeasurementConfiguration = INT(name=u'id-BluetoothMeasurementConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BluetoothMeasurementConfiguration._val = 284
    
    #-----< id-WLANMeasurementConfiguration >-----#
    id_WLANMeasurementConfiguration = INT(name=u'id-WLANMeasurementConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WLANMeasurementConfiguration._val = 285
    
    #-----< id-WarningAreaCoordinates >-----#
    id_WarningAreaCoordinates = INT(name=u'id-WarningAreaCoordinates', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WarningAreaCoordinates._val = 286
    
    #-----< id-NRrestrictionin5GS >-----#
    id_NRrestrictionin5GS = INT(name=u'id-NRrestrictionin5GS', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRrestrictionin5GS._val = 287
    
    #-----< id-PSCellInformation >-----#
    id_PSCellInformation = INT(name=u'id-PSCellInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PSCellInformation._val = 288
    
    #-----< id-LastNG-RANPLMNIdentity >-----#
    id_LastNG_RANPLMNIdentity = INT(name=u'id-LastNG-RANPLMNIdentity', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LastNG_RANPLMNIdentity._val = 290
    
    #-----< id-ConnectedengNBList >-----#
    id_ConnectedengNBList = INT(name=u'id-ConnectedengNBList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConnectedengNBList._val = 291
    
    #-----< id-ConnectedengNBToAddList >-----#
    id_ConnectedengNBToAddList = INT(name=u'id-ConnectedengNBToAddList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConnectedengNBToAddList._val = 292
    
    #-----< id-ConnectedengNBToRemoveList >-----#
    id_ConnectedengNBToRemoveList = INT(name=u'id-ConnectedengNBToRemoveList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ConnectedengNBToRemoveList._val = 293
    
    #-----< id-EN-DCSONConfigurationTransfer-ECT >-----#
    id_EN_DCSONConfigurationTransfer_ECT = INT(name=u'id-EN-DCSONConfigurationTransfer-ECT', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EN_DCSONConfigurationTransfer_ECT._val = 294
    
    #-----< id-EN-DCSONConfigurationTransfer-MCT >-----#
    id_EN_DCSONConfigurationTransfer_MCT = INT(name=u'id-EN-DCSONConfigurationTransfer-MCT', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EN_DCSONConfigurationTransfer_MCT._val = 295
    
    #-----< id-IMSvoiceEPSfallbackfrom5G >-----#
    id_IMSvoiceEPSfallbackfrom5G = INT(name=u'id-IMSvoiceEPSfallbackfrom5G', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IMSvoiceEPSfallbackfrom5G._val = 296
    
    #-----< id-TimeSinceSecondaryNodeRelease >-----#
    id_TimeSinceSecondaryNodeRelease = INT(name=u'id-TimeSinceSecondaryNodeRelease', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeSinceSecondaryNodeRelease._val = 297
    
    #-----< id-RequestTypeAdditionalInfo >-----#
    id_RequestTypeAdditionalInfo = INT(name=u'id-RequestTypeAdditionalInfo', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestTypeAdditionalInfo._val = 298
    
    #-----< id-AdditionalRRMPriorityIndex >-----#
    id_AdditionalRRMPriorityIndex = INT(name=u'id-AdditionalRRMPriorityIndex', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalRRMPriorityIndex._val = 299
    
    #-----< id-ContextatSource >-----#
    id_ContextatSource = INT(name=u'id-ContextatSource', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ContextatSource._val = 300
    
    #-----< id-IAB-Authorized >-----#
    id_IAB_Authorized = INT(name=u'id-IAB-Authorized', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_Authorized._val = 301
    
    #-----< id-IAB-Node-Indication >-----#
    id_IAB_Node_Indication = INT(name=u'id-IAB-Node-Indication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_Node_Indication._val = 302
    
    #-----< id-IAB-Supported >-----#
    id_IAB_Supported = INT(name=u'id-IAB-Supported', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IAB_Supported._val = 303
    
    #-----< id-DataSize >-----#
    id_DataSize = INT(name=u'id-DataSize', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DataSize._val = 304
    
    #-----< id-Ethernet-Type >-----#
    id_Ethernet_Type = INT(name=u'id-Ethernet-Type', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Ethernet_Type._val = 305
    
    #-----< id-NRV2XServicesAuthorized >-----#
    id_NRV2XServicesAuthorized = INT(name=u'id-NRV2XServicesAuthorized', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRV2XServicesAuthorized._val = 306
    
    #-----< id-NRUESidelinkAggregateMaximumBitrate >-----#
    id_NRUESidelinkAggregateMaximumBitrate = INT(name=u'id-NRUESidelinkAggregateMaximumBitrate', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRUESidelinkAggregateMaximumBitrate._val = 307
    
    #-----< id-PC5QoSParameters >-----#
    id_PC5QoSParameters = INT(name=u'id-PC5QoSParameters', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PC5QoSParameters._val = 308
    
    #-----< id-IntersystemSONConfigurationTransferMCT >-----#
    id_IntersystemSONConfigurationTransferMCT = INT(name=u'id-IntersystemSONConfigurationTransferMCT', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IntersystemSONConfigurationTransferMCT._val = 309
    
    #-----< id-IntersystemSONConfigurationTransferECT >-----#
    id_IntersystemSONConfigurationTransferECT = INT(name=u'id-IntersystemSONConfigurationTransferECT', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IntersystemSONConfigurationTransferECT._val = 310
    
    #-----< id-IntersystemMeasurementConfiguration >-----#
    id_IntersystemMeasurementConfiguration = INT(name=u'id-IntersystemMeasurementConfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IntersystemMeasurementConfiguration._val = 311
    
    #-----< id-SourceNodeID >-----#
    id_SourceNodeID = INT(name=u'id-SourceNodeID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceNodeID._val = 312
    
    #-----< id-NB-IoT-RLF-Report-Container >-----#
    id_NB_IoT_RLF_Report_Container = INT(name=u'id-NB-IoT-RLF-Report-Container', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NB_IoT_RLF_Report_Container._val = 313
    
    #-----< id-UERadioCapabilityID >-----#
    id_UERadioCapabilityID = INT(name=u'id-UERadioCapabilityID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapabilityID._val = 314
    
    #-----< id-UERadioCapability-NR-Format >-----#
    id_UERadioCapability_NR_Format = INT(name=u'id-UERadioCapability-NR-Format', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapability_NR_Format._val = 315
    
    #-----< id-MDTConfigurationNR >-----#
    id_MDTConfigurationNR = INT(name=u'id-MDTConfigurationNR', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MDTConfigurationNR._val = 316
    
    #-----< id-DAPSRequestInfo >-----#
    id_DAPSRequestInfo = INT(name=u'id-DAPSRequestInfo', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DAPSRequestInfo._val = 317
    
    #-----< id-DAPSResponseInfoList >-----#
    id_DAPSResponseInfoList = INT(name=u'id-DAPSResponseInfoList', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DAPSResponseInfoList._val = 318
    
    #-----< id-DAPSResponseInfoItem >-----#
    id_DAPSResponseInfoItem = INT(name=u'id-DAPSResponseInfoItem', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DAPSResponseInfoItem._val = 319
    
    #-----< id-NotifySourceeNB >-----#
    id_NotifySourceeNB = INT(name=u'id-NotifySourceeNB', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NotifySourceeNB._val = 320
    
    #-----< id-eNB-EarlyStatusTransfer-TransparentContainer >-----#
    id_eNB_EarlyStatusTransfer_TransparentContainer = INT(name=u'id-eNB-EarlyStatusTransfer-TransparentContainer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_eNB_EarlyStatusTransfer_TransparentContainer._val = 321
    
    #-----< id-Bearers-SubjectToEarlyStatusTransfer-Item >-----#
    id_Bearers_SubjectToEarlyStatusTransfer_Item = INT(name=u'id-Bearers-SubjectToEarlyStatusTransfer-Item', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Bearers_SubjectToEarlyStatusTransfer_Item._val = 322
    
    #-----< id-WUS-Assistance-Information >-----#
    id_WUS_Assistance_Information = INT(name=u'id-WUS-Assistance-Information', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WUS_Assistance_Information._val = 323
    
    #-----< id-NB-IoT-PagingDRX >-----#
    id_NB_IoT_PagingDRX = INT(name=u'id-NB-IoT-PagingDRX', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NB_IoT_PagingDRX._val = 324
    
    #-----< id-TraceCollectionEntityURI >-----#
    id_TraceCollectionEntityURI = INT(name=u'id-TraceCollectionEntityURI', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceCollectionEntityURI._val = 325
    
    #-----< id-EmergencyIndicator >-----#
    id_EmergencyIndicator = INT(name=u'id-EmergencyIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EmergencyIndicator._val = 326
    
    #-----< id-UERadioCapabilityForPaging-NR-Format >-----#
    id_UERadioCapabilityForPaging_NR_Format = INT(name=u'id-UERadioCapabilityForPaging-NR-Format', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UERadioCapabilityForPaging_NR_Format._val = 327
    
    #-----< id-SourceTransportLayerAddress >-----#
    id_SourceTransportLayerAddress = INT(name=u'id-SourceTransportLayerAddress', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceTransportLayerAddress._val = 328
    
    #-----< id-SourceNodeTransportLayerAddress >-----#
    id_SourceNodeTransportLayerAddress = INT(name=u'id-SourceNodeTransportLayerAddress', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceNodeTransportLayerAddress._val = 340
    
    #-----< id-SourceSNID >-----#
    id_SourceSNID = INT(name=u'id-SourceSNID', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceSNID._val = 343
    
    _all_ = [
        id_HandoverPreparation,
        id_HandoverResourceAllocation,
        id_HandoverNotification,
        id_PathSwitchRequest,
        id_HandoverCancel,
        id_E_RABSetup,
        id_E_RABModify,
        id_E_RABRelease,
        id_E_RABReleaseIndication,
        id_InitialContextSetup,
        id_Paging,
        id_downlinkNASTransport,
        id_initialUEMessage,
        id_uplinkNASTransport,
        id_Reset,
        id_ErrorIndication,
        id_NASNonDeliveryIndication,
        id_S1Setup,
        id_UEContextReleaseRequest,
        id_DownlinkS1cdma2000tunnelling,
        id_UplinkS1cdma2000tunnelling,
        id_UEContextModification,
        id_UECapabilityInfoIndication,
        id_UEContextRelease,
        id_eNBStatusTransfer,
        id_MMEStatusTransfer,
        id_DeactivateTrace,
        id_TraceStart,
        id_TraceFailureIndication,
        id_ENBConfigurationUpdate,
        id_MMEConfigurationUpdate,
        id_LocationReportingControl,
        id_LocationReportingFailureIndication,
        id_LocationReport,
        id_OverloadStart,
        id_OverloadStop,
        id_WriteReplaceWarning,
        id_eNBDirectInformationTransfer,
        id_MMEDirectInformationTransfer,
        id_PrivateMessage,
        id_eNBConfigurationTransfer,
        id_MMEConfigurationTransfer,
        id_CellTrafficTrace,
        id_Kill,
        id_downlinkUEAssociatedLPPaTransport,
        id_uplinkUEAssociatedLPPaTransport,
        id_downlinkNonUEAssociatedLPPaTransport,
        id_uplinkNonUEAssociatedLPPaTransport,
        id_UERadioCapabilityMatch,
        id_PWSRestartIndication,
        id_E_RABModificationIndication,
        id_PWSFailureIndication,
        id_RerouteNASRequest,
        id_UEContextModificationIndication,
        id_ConnectionEstablishmentIndication,
        id_UEContextSuspend,
        id_UEContextResume,
        id_NASDeliveryIndication,
        id_RetrieveUEInformation,
        id_UEInformationTransfer,
        id_eNBCPRelocationIndication,
        id_MMECPRelocationIndication,
        id_SecondaryRATDataUsageReport,
        id_UERadioCapabilityIDMapping,
        id_HandoverSuccess,
        id_eNBEarlyStatusTransfer,
        id_MMEEarlyStatusTransfer,
        maxPrivateIEs,
        maxProtocolExtensions,
        maxProtocolIEs,
        maxnoofCSGs,
        maxnoofE_RABs,
        maxnoofTAIs,
        maxnoofTACs,
        maxnoofErrors,
        maxnoofBPLMNs,
        maxnoofPLMNsPerMME,
        maxnoofEPLMNs,
        maxnoofEPLMNsPlusOne,
        maxnoofForbLACs,
        maxnoofForbTACs,
        maxnoofIndividualS1ConnectionsToReset,
        maxnoofCellsinUEHistoryInfo,
        maxnoofCellsineNB,
        maxnoofTAIforWarning,
        maxnoofCellID,
        maxnoofDCNs,
        maxnoofEmergencyAreaID,
        maxnoofCellinTAI,
        maxnoofCellinEAI,
        maxnoofeNBX2TLAs,
        maxnoofeNBX2ExtTLAs,
        maxnoofeNBX2GTPTLAs,
        maxnoofRATs,
        maxnoofGroupIDs,
        maxnoofMMECs,
        maxnoofCellIDforMDT,
        maxnoofTAforMDT,
        maxnoofMDTPLMNs,
        maxnoofCellsforRestart,
        maxnoofRestartTAIs,
        maxnoofRestartEmergencyAreaIDs,
        maxEARFCN,
        maxnoofMBSFNAreaMDT,
        maxnoofRecommendedCells,
        maxnoofRecommendedENBs,
        maxnooftimeperiods,
        maxnoofCellIDforQMC,
        maxnoofTAforQMC,
        maxnoofPLMNforQMC,
        maxnoofBluetoothName,
        maxnoofWLANName,
        maxnoofConnectedengNBs,
        maxnoofPC5QoSFlows,
        maxnooffrequencies,
        maxNARFCN,
        maxRS_IndexCellQual,
        id_MME_UE_S1AP_ID,
        id_HandoverType,
        id_Cause,
        id_SourceID,
        id_TargetID,
        id_eNB_UE_S1AP_ID,
        id_E_RABSubjecttoDataForwardingList,
        id_E_RABtoReleaseListHOCmd,
        id_E_RABDataForwardingItem,
        id_E_RABReleaseItemBearerRelComp,
        id_E_RABToBeSetupListBearerSUReq,
        id_E_RABToBeSetupItemBearerSUReq,
        id_E_RABAdmittedList,
        id_E_RABFailedToSetupListHOReqAck,
        id_E_RABAdmittedItem,
        id_E_RABFailedtoSetupItemHOReqAck,
        id_E_RABToBeSwitchedDLList,
        id_E_RABToBeSwitchedDLItem,
        id_E_RABToBeSetupListCtxtSUReq,
        id_TraceActivation,
        id_NAS_PDU,
        id_E_RABToBeSetupItemHOReq,
        id_E_RABSetupListBearerSURes,
        id_E_RABFailedToSetupListBearerSURes,
        id_E_RABToBeModifiedListBearerModReq,
        id_E_RABModifyListBearerModRes,
        id_E_RABFailedToModifyList,
        id_E_RABToBeReleasedList,
        id_E_RABFailedToReleaseList,
        id_E_RABItem,
        id_E_RABToBeModifiedItemBearerModReq,
        id_E_RABModifyItemBearerModRes,
        id_E_RABReleaseItem,
        id_E_RABSetupItemBearerSURes,
        id_SecurityContext,
        id_HandoverRestrictionList,
        id_UEPagingID,
        id_pagingDRX,
        id_TAIList,
        id_TAIItem,
        id_E_RABFailedToSetupListCtxtSURes,
        id_E_RABReleaseItemHOCmd,
        id_E_RABSetupItemCtxtSURes,
        id_E_RABSetupListCtxtSURes,
        id_E_RABToBeSetupItemCtxtSUReq,
        id_E_RABToBeSetupListHOReq,
        id_GERANtoLTEHOInformationRes,
        id_UTRANtoLTEHOInformationRes,
        id_CriticalityDiagnostics,
        id_Global_ENB_ID,
        id_eNBname,
        id_MMEname,
        id_ServedPLMNs,
        id_SupportedTAs,
        id_TimeToWait,
        id_uEaggregateMaximumBitrate,
        id_TAI,
        id_E_RABReleaseListBearerRelComp,
        id_cdma2000PDU,
        id_cdma2000RATType,
        id_cdma2000SectorID,
        id_SecurityKey,
        id_UERadioCapability,
        id_GUMMEI_ID,
        id_E_RABInformationListItem,
        id_Direct_Forwarding_Path_Availability,
        id_UEIdentityIndexValue,
        id_cdma2000HOStatus,
        id_cdma2000HORequiredIndication,
        id_E_UTRAN_Trace_ID,
        id_RelativeMMECapacity,
        id_SourceMME_UE_S1AP_ID,
        id_Bearers_SubjectToStatusTransfer_Item,
        id_eNB_StatusTransfer_TransparentContainer,
        id_UE_associatedLogicalS1_ConnectionItem,
        id_ResetType,
        id_UE_associatedLogicalS1_ConnectionListResAck,
        id_E_RABToBeSwitchedULItem,
        id_E_RABToBeSwitchedULList,
        id_S_TMSI,
        id_cdma2000OneXRAND,
        id_RequestType,
        id_UE_S1AP_IDs,
        id_EUTRAN_CGI,
        id_OverloadResponse,
        id_cdma2000OneXSRVCCInfo,
        id_E_RABFailedToBeReleasedList,
        id_Source_ToTarget_TransparentContainer,
        id_ServedGUMMEIs,
        id_SubscriberProfileIDforRFP,
        id_UESecurityCapabilities,
        id_CSFallbackIndicator,
        id_CNDomain,
        id_E_RABReleasedList,
        id_MessageIdentifier,
        id_SerialNumber,
        id_WarningAreaList,
        id_RepetitionPeriod,
        id_NumberofBroadcastRequest,
        id_WarningType,
        id_WarningSecurityInfo,
        id_DataCodingScheme,
        id_WarningMessageContents,
        id_BroadcastCompletedAreaList,
        id_Inter_SystemInformationTransferTypeEDT,
        id_Inter_SystemInformationTransferTypeMDT,
        id_Target_ToSource_TransparentContainer,
        id_SRVCCOperationPossible,
        id_SRVCCHOIndication,
        id_NAS_DownlinkCount,
        id_CSG_Id,
        id_CSG_IdList,
        id_SONConfigurationTransferECT,
        id_SONConfigurationTransferMCT,
        id_TraceCollectionEntityIPAddress,
        id_MSClassmark2,
        id_MSClassmark3,
        id_RRC_Establishment_Cause,
        id_NASSecurityParametersfromE_UTRAN,
        id_NASSecurityParameterstoE_UTRAN,
        id_DefaultPagingDRX,
        id_Source_ToTarget_TransparentContainer_Secondary,
        id_Target_ToSource_TransparentContainer_Secondary,
        id_EUTRANRoundTripDelayEstimationInfo,
        id_BroadcastCancelledAreaList,
        id_ConcurrentWarningMessageIndicator,
        id_Data_Forwarding_Not_Possible,
        id_ExtendedRepetitionPeriod,
        id_CellAccessMode,
        id_CSGMembershipStatus,
        id_LPPa_PDU,
        id_Routing_ID,
        id_Time_Synchronisation_Info,
        id_PS_ServiceNotAvailable,
        id_PagingPriority,
        id_x2TNLConfigurationInfo,
        id_eNBX2ExtendedTransportLayerAddresses,
        id_GUMMEIList,
        id_GW_TransportLayerAddress,
        id_Correlation_ID,
        id_SourceMME_GUMMEI,
        id_MME_UE_S1AP_ID_2,
        id_RegisteredLAI,
        id_RelayNode_Indicator,
        id_TrafficLoadReductionIndication,
        id_MDTConfiguration,
        id_MMERelaySupportIndicator,
        id_GWContextReleaseIndication,
        id_ManagementBasedMDTAllowed,
        id_PrivacyIndicator,
        id_Time_UE_StayedInCell_EnhancedGranularity,
        id_HO_Cause,
        id_VoiceSupportMatchIndicator,
        id_GUMMEIType,
        id_M3Configuration,
        id_M4Configuration,
        id_M5Configuration,
        id_MDT_Location_Info,
        id_MobilityInformation,
        id_Tunnel_Information_for_BBF,
        id_ManagementBasedMDTPLMNList,
        id_SignallingBasedMDTPLMNList,
        id_ULCOUNTValueExtended,
        id_DLCOUNTValueExtended,
        id_ReceiveStatusOfULPDCPSDUsExtended,
        id_ECGIListForRestart,
        id_SIPTO_Correlation_ID,
        id_SIPTO_L_GW_TransportLayerAddress,
        id_TransportInformation,
        id_LHN_ID,
        id_AdditionalCSFallbackIndicator,
        id_TAIListForRestart,
        id_UserLocationInformation,
        id_EmergencyAreaIDListForRestart,
        id_KillAllWarningMessages,
        id_Masked_IMEISV,
        id_eNBIndirectX2TransportLayerAddresses,
        id_uE_HistoryInformationFromTheUE,
        id_ProSeAuthorized,
        id_ExpectedUEBehaviour,
        id_LoggedMBSFNMDT,
        id_UERadioCapabilityForPaging,
        id_E_RABToBeModifiedListBearerModInd,
        id_E_RABToBeModifiedItemBearerModInd,
        id_E_RABNotToBeModifiedListBearerModInd,
        id_E_RABNotToBeModifiedItemBearerModInd,
        id_E_RABModifyListBearerModConf,
        id_E_RABModifyItemBearerModConf,
        id_E_RABFailedToModifyListBearerModConf,
        id_SON_Information_Report,
        id_Muting_Availability_Indication,
        id_Muting_Pattern_Information,
        id_Synchronisation_Information,
        id_E_RABToBeReleasedListBearerModConf,
        id_AssistanceDataForPaging,
        id_CellIdentifierAndCELevelForCECapableUEs,
        id_InformationOnRecommendedCellsAndENBsForPaging,
        id_RecommendedCellItem,
        id_RecommendedENBItem,
        id_ProSeUEtoNetworkRelaying,
        id_ULCOUNTValuePDCP_SNlength18,
        id_DLCOUNTValuePDCP_SNlength18,
        id_ReceiveStatusOfULPDCPSDUsPDCP_SNlength18,
        id_M6Configuration,
        id_M7Configuration,
        id_PWSfailedECGIList,
        id_MME_Group_ID,
        id_Additional_GUTI,
        id_S1_Message,
        id_CSGMembershipInfo,
        id_Paging_eDRXInformation,
        id_UE_RetentionInformation,
        id_UE_Usage_Type,
        id_extended_UEIdentityIndexValue,
        id_RAT_Type,
        id_BearerType,
        id_NB_IoT_DefaultPagingDRX,
        id_E_RABFailedToResumeListResumeReq,
        id_E_RABFailedToResumeItemResumeReq,
        id_E_RABFailedToResumeListResumeRes,
        id_E_RABFailedToResumeItemResumeRes,
        id_NB_IoT_Paging_eDRXInformation,
        id_V2XServicesAuthorized,
        id_UEUserPlaneCIoTSupportIndicator,
        id_CE_mode_B_SupportIndicator,
        id_SRVCCOperationNotPossible,
        id_NB_IoT_UEIdentityIndexValue,
        id_RRC_Resume_Cause,
        id_DCN_ID,
        id_ServedDCNs,
        id_UESidelinkAggregateMaximumBitrate,
        id_DLNASPDUDeliveryAckRequest,
        id_Coverage_Level,
        id_EnhancedCoverageRestricted,
        id_UE_Level_QoS_Parameters,
        id_DL_CP_SecurityInformation,
        id_UL_CP_SecurityInformation,
        id_extended_e_RAB_MaximumBitrateDL,
        id_extended_e_RAB_MaximumBitrateUL,
        id_extended_e_RAB_GuaranteedBitrateDL,
        id_extended_e_RAB_GuaranteedBitrateUL,
        id_extended_uEaggregateMaximumBitRateDL,
        id_extended_uEaggregateMaximumBitRateUL,
        id_NRrestrictioninEPSasSecondaryRAT,
        id_UEAppLayerMeasConfig,
        id_UE_Application_Layer_Measurement_Capability,
        id_SecondaryRATDataUsageReportList,
        id_SecondaryRATDataUsageReportItem,
        id_HandoverFlag,
        id_E_RABUsageReportItem,
        id_SecondaryRATDataUsageRequest,
        id_NRUESecurityCapabilities,
        id_UnlicensedSpectrumRestriction,
        id_CE_ModeBRestricted,
        id_LTE_M_Indication,
        id_DownlinkPacketLossRate,
        id_UplinkPacketLossRate,
        id_UECapabilityInfoRequest,
        id_serviceType,
        id_AerialUEsubscriptionInformation,
        id_Subscription_Based_UE_DifferentiationInfo,
        id_EndIndication,
        id_EDT_Session,
        id_CNTypeRestrictions,
        id_PendingDataIndication,
        id_BluetoothMeasurementConfiguration,
        id_WLANMeasurementConfiguration,
        id_WarningAreaCoordinates,
        id_NRrestrictionin5GS,
        id_PSCellInformation,
        id_LastNG_RANPLMNIdentity,
        id_ConnectedengNBList,
        id_ConnectedengNBToAddList,
        id_ConnectedengNBToRemoveList,
        id_EN_DCSONConfigurationTransfer_ECT,
        id_EN_DCSONConfigurationTransfer_MCT,
        id_IMSvoiceEPSfallbackfrom5G,
        id_TimeSinceSecondaryNodeRelease,
        id_RequestTypeAdditionalInfo,
        id_AdditionalRRMPriorityIndex,
        id_ContextatSource,
        id_IAB_Authorized,
        id_IAB_Node_Indication,
        id_IAB_Supported,
        id_DataSize,
        id_Ethernet_Type,
        id_NRV2XServicesAuthorized,
        id_NRUESidelinkAggregateMaximumBitrate,
        id_PC5QoSParameters,
        id_IntersystemSONConfigurationTransferMCT,
        id_IntersystemSONConfigurationTransferECT,
        id_IntersystemMeasurementConfiguration,
        id_SourceNodeID,
        id_NB_IoT_RLF_Report_Container,
        id_UERadioCapabilityID,
        id_UERadioCapability_NR_Format,
        id_MDTConfigurationNR,
        id_DAPSRequestInfo,
        id_DAPSResponseInfoList,
        id_DAPSResponseInfoItem,
        id_NotifySourceeNB,
        id_eNB_EarlyStatusTransfer_TransparentContainer,
        id_Bearers_SubjectToEarlyStatusTransfer_Item,
        id_WUS_Assistance_Information,
        id_NB_IoT_PagingDRX,
        id_TraceCollectionEntityURI,
        id_EmergencyIndicator,
        id_UERadioCapabilityForPaging_NR_Format,
        id_SourceTransportLayerAddress,
        id_SourceNodeTransportLayerAddress,
        id_SourceSNID,
    ]

class S1AP_Containers:

    _name_  = u'S1AP-Containers'
    _oid_   = [0, 4, 0, 0, 21, 3, 1, 1, 5]
    
    _obj_ = [
        u'S1AP-PROTOCOL-IES',
        u'S1AP-PROTOCOL-IES-PAIR',
        u'S1AP-PROTOCOL-EXTENSION',
        u'S1AP-PRIVATE-IES',
        u'ProtocolIE-Container',
        u'ProtocolIE-SingleContainer',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerPair',
        u'ProtocolIE-FieldPair',
        u'ProtocolIE-ContainerList',
        u'ProtocolIE-ContainerPairList',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    _type_ = [
        u'S1AP-PROTOCOL-IES',
        u'S1AP-PROTOCOL-IES-PAIR',
        u'S1AP-PROTOCOL-EXTENSION',
        u'S1AP-PRIVATE-IES',
        u'ProtocolIE-Container',
        u'ProtocolIE-SingleContainer',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerPair',
        u'ProtocolIE-FieldPair',
        u'ProtocolIE-ContainerList',
        u'ProtocolIE-ContainerPairList',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        u'S1AP-PROTOCOL-IES',
        u'S1AP-PROTOCOL-IES-PAIR',
        u'S1AP-PROTOCOL-EXTENSION',
        u'S1AP-PRIVATE-IES',
        ]
    _param_ = [
        u'ProtocolIE-Container',
        u'ProtocolIE-SingleContainer',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerPair',
        u'ProtocolIE-FieldPair',
        u'ProtocolIE-ContainerList',
        u'ProtocolIE-ContainerPairList',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    
    #-----< S1AP-PROTOCOL-IES >-----#
    S1AP_PROTOCOL_IES = CLASS(name=u'S1AP-PROTOCOL-IES', mode=MODE_TYPE)
    _S1AP_PROTOCOL_IES_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _S1AP_PROTOCOL_IES_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Criticality')))
    _S1AP_PROTOCOL_IES_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    _S1AP_PROTOCOL_IES_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Presence')))
    S1AP_PROTOCOL_IES._cont = ASN1Dict([
        (u'id', _S1AP_PROTOCOL_IES_id),
        (u'criticality', _S1AP_PROTOCOL_IES_criticality),
        (u'Value', _S1AP_PROTOCOL_IES_Value),
        (u'presence', _S1AP_PROTOCOL_IES_presence),
        ])
    
    #-----< S1AP-PROTOCOL-IES-PAIR >-----#
    S1AP_PROTOCOL_IES_PAIR = CLASS(name=u'S1AP-PROTOCOL-IES-PAIR', mode=MODE_TYPE)
    _S1AP_PROTOCOL_IES_PAIR_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _S1AP_PROTOCOL_IES_PAIR_firstCriticality = ENUM(name=u'firstCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Criticality')))
    _S1AP_PROTOCOL_IES_PAIR_FirstValue = OPEN(name=u'FirstValue', mode=MODE_TYPE)
    _S1AP_PROTOCOL_IES_PAIR_secondCriticality = ENUM(name=u'secondCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Criticality')))
    _S1AP_PROTOCOL_IES_PAIR_SecondValue = OPEN(name=u'SecondValue', mode=MODE_TYPE)
    _S1AP_PROTOCOL_IES_PAIR_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Presence')))
    S1AP_PROTOCOL_IES_PAIR._cont = ASN1Dict([
        (u'id', _S1AP_PROTOCOL_IES_PAIR_id),
        (u'firstCriticality', _S1AP_PROTOCOL_IES_PAIR_firstCriticality),
        (u'FirstValue', _S1AP_PROTOCOL_IES_PAIR_FirstValue),
        (u'secondCriticality', _S1AP_PROTOCOL_IES_PAIR_secondCriticality),
        (u'SecondValue', _S1AP_PROTOCOL_IES_PAIR_SecondValue),
        (u'presence', _S1AP_PROTOCOL_IES_PAIR_presence),
        ])
    
    #-----< S1AP-PROTOCOL-EXTENSION >-----#
    S1AP_PROTOCOL_EXTENSION = CLASS(name=u'S1AP-PROTOCOL-EXTENSION', mode=MODE_TYPE)
    _S1AP_PROTOCOL_EXTENSION_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolExtensionID')), uniq=True)
    _S1AP_PROTOCOL_EXTENSION_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Criticality')))
    _S1AP_PROTOCOL_EXTENSION_Extension = OPEN(name=u'Extension', mode=MODE_TYPE)
    _S1AP_PROTOCOL_EXTENSION_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Presence')))
    S1AP_PROTOCOL_EXTENSION._cont = ASN1Dict([
        (u'id', _S1AP_PROTOCOL_EXTENSION_id),
        (u'criticality', _S1AP_PROTOCOL_EXTENSION_criticality),
        (u'Extension', _S1AP_PROTOCOL_EXTENSION_Extension),
        (u'presence', _S1AP_PROTOCOL_EXTENSION_presence),
        ])
    
    #-----< S1AP-PRIVATE-IES >-----#
    S1AP_PRIVATE_IES = CLASS(name=u'S1AP-PRIVATE-IES', mode=MODE_TYPE)
    _S1AP_PRIVATE_IES_id = CHOICE(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'PrivateIE-ID')))
    _S1AP_PRIVATE_IES_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Criticality')))
    _S1AP_PRIVATE_IES_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    _S1AP_PRIVATE_IES_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Presence')))
    S1AP_PRIVATE_IES._cont = ASN1Dict([
        (u'id', _S1AP_PRIVATE_IES_id),
        (u'criticality', _S1AP_PRIVATE_IES_criticality),
        (u'Value', _S1AP_PRIVATE_IES_Value),
        (u'presence', _S1AP_PRIVATE_IES_presence),
        ])
    
    #-----< ProtocolIE-Container >-----#
    ProtocolIE_Container = SEQ_OF(name=u'ProtocolIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-SingleContainer >-----#
    ProtocolIE_SingleContainer = SEQ(name=u'ProtocolIE-SingleContainer', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')), param=True)
    
    #-----< ProtocolIE-Field >-----#
    ProtocolIE_Field = SEQ(name=u'ProtocolIE-Field', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPair >-----#
    ProtocolIE_ContainerPair = SEQ_OF(name=u'ProtocolIE-ContainerPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-FieldPair >-----#
    ProtocolIE_FieldPair = SEQ(name=u'ProtocolIE-FieldPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerList >-----#
    ProtocolIE_ContainerList = SEQ_OF(name=u'ProtocolIE-ContainerList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPairList >-----#
    ProtocolIE_ContainerPairList = SEQ_OF(name=u'ProtocolIE-ContainerPairList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionContainer >-----#
    ProtocolExtensionContainer = SEQ_OF(name=u'ProtocolExtensionContainer', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionField >-----#
    ProtocolExtensionField = SEQ(name=u'ProtocolExtensionField', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Container >-----#
    PrivateIE_Container = SEQ_OF(name=u'PrivateIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Field >-----#
    PrivateIE_Field = SEQ(name=u'PrivateIE-Field', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _S1AP_PROTOCOL_IES_id,
        _S1AP_PROTOCOL_IES_criticality,
        _S1AP_PROTOCOL_IES_Value,
        _S1AP_PROTOCOL_IES_presence,
        S1AP_PROTOCOL_IES,
        _S1AP_PROTOCOL_IES_PAIR_id,
        _S1AP_PROTOCOL_IES_PAIR_firstCriticality,
        _S1AP_PROTOCOL_IES_PAIR_FirstValue,
        _S1AP_PROTOCOL_IES_PAIR_secondCriticality,
        _S1AP_PROTOCOL_IES_PAIR_SecondValue,
        _S1AP_PROTOCOL_IES_PAIR_presence,
        S1AP_PROTOCOL_IES_PAIR,
        _S1AP_PROTOCOL_EXTENSION_id,
        _S1AP_PROTOCOL_EXTENSION_criticality,
        _S1AP_PROTOCOL_EXTENSION_Extension,
        _S1AP_PROTOCOL_EXTENSION_presence,
        S1AP_PROTOCOL_EXTENSION,
        _S1AP_PRIVATE_IES_id,
        _S1AP_PRIVATE_IES_criticality,
        _S1AP_PRIVATE_IES_Value,
        _S1AP_PRIVATE_IES_presence,
        S1AP_PRIVATE_IES,
    ]

class S1AP_IEs:

    _name_  = u'S1AP-IEs'
    _oid_   = [0, 4, 0, 0, 21, 3, 1, 1, 2]
    
    _obj_ = [
        u'Additional-GUTI',
        u'Additional-GUTI-ExtIEs',
        u'AdditionalRRMPriorityIndex',
        u'AerialUEsubscriptionInformation',
        u'AreaScopeOfMDT',
        u'AreaScopeOfQMC',
        u'AllocationAndRetentionPriority',
        u'AllocationAndRetentionPriority-ExtIEs',
        u'AssistanceDataForCECapableUEs',
        u'InformationForCECapableUEs-ExtIEs',
        u'AssistanceDataForPaging',
        u'AssistanceDataForPaging-ExtIEs',
        u'AssistanceDataForRecommendedCells',
        u'AssistanceDataForRecommendedCells-ExtIEs',
        u'Bearers-SubjectToStatusTransferList',
        u'Bearers-SubjectToStatusTransfer-ItemIEs',
        u'Bearers-SubjectToStatusTransfer-Item',
        u'Bearers-SubjectToStatusTransfer-ItemExtIEs',
        u'Bearers-SubjectToEarlyStatusTransferList',
        u'Bearers-SubjectToEarlyStatusTransfer-ItemIEs',
        u'Bearers-SubjectToEarlyStatusTransfer-Item',
        u'Bearers-SubjectToEarlyStatusTransfer-ItemExtIEs',
        u'BearerType',
        u'BitRate',
        u'BluetoothMeasurementConfiguration',
        u'BluetoothMeasurementConfiguration-ExtIEs',
        u'BluetoothMeasConfigNameList',
        u'BluetoothMeasConfig',
        u'BluetoothName',
        u'BPLMNs',
        u'BroadcastCancelledAreaList',
        u'BroadcastCompletedAreaList',
        u'CancelledCellinEAI',
        u'CancelledCellinEAI-Item',
        u'CancelledCellinEAI-Item-ExtIEs',
        u'CancelledCellinTAI',
        u'CancelledCellinTAI-Item',
        u'CancelledCellinTAI-Item-ExtIEs',
        u'Cause',
        u'CauseMisc',
        u'CauseProtocol',
        u'CauseRadioNetwork',
        u'CauseTransport',
        u'CauseNas',
        u'CellAccessMode',
        u'CellIdentifierAndCELevelForCECapableUEs',
        u'CellIdentifierAndCELevelForCECapableUEs-ExtIEs',
        u'CELevel',
        u'CE-mode-B-SupportIndicator',
        u'CellIdentity',
        u'CellID-Broadcast',
        u'CellID-Broadcast-Item',
        u'CellID-Broadcast-Item-ExtIEs',
        u'CellID-Cancelled',
        u'CellID-Cancelled-Item',
        u'CellID-Cancelled-Item-ExtIEs',
        u'CellBasedMDT',
        u'CellBasedMDT-ExtIEs',
        u'CellIdListforMDT',
        u'CellBasedQMC',
        u'CellBasedQMC-ExtIEs',
        u'CellIdListforQMC',
        u'Cdma2000PDU',
        u'Cdma2000RATType',
        u'Cdma2000SectorID',
        u'Cdma2000HOStatus',
        u'Cdma2000HORequiredIndication',
        u'Cdma2000OneXSRVCCInfo',
        u'Cdma2000OneXSRVCCInfo-ExtIEs',
        u'Cdma2000OneXMEID',
        u'Cdma2000OneXMSI',
        u'Cdma2000OneXPilot',
        u'Cdma2000OneXRAND',
        u'Cell-Size',
        u'CellType',
        u'CellType-ExtIEs',
        u'CGI',
        u'CGI-ExtIEs',
        u'CI',
        u'CNDomain',
        u'CNTypeRestrictions',
        u'CNTypeRestrictions-Item',
        u'CNTypeRestrictions-Item-ExtIEs',
        u'CNType',
        u'ConcurrentWarningMessageIndicator',
        u'ConnectedengNBList',
        u'ConnectedengNBItem',
        u'ConnectedengNBItem-ExtIEs',
        u'ContextatSource',
        u'ContextatSource-ExtIEs',
        u'Correlation-ID',
        u'CSFallbackIndicator',
        u'AdditionalCSFallbackIndicator',
        u'CSG-Id',
        u'CSG-IdList',
        u'CSG-IdList-Item',
        u'CSG-IdList-Item-ExtIEs',
        u'CSGMembershipStatus',
        u'COUNTvalue',
        u'COUNTvalue-ExtIEs',
        u'COUNTValueExtended',
        u'COUNTValueExtended-ExtIEs',
        u'COUNTvaluePDCP-SNlength18',
        u'COUNTvaluePDCP-SNlength18-ExtIEs',
        u'Coverage-Level',
        u'CriticalityDiagnostics',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-List',
        u'CriticalityDiagnostics-IE-Item',
        u'CriticalityDiagnostics-IE-Item-ExtIEs',
        u'DAPSRequestInfo',
        u'DAPSRequestInfo-ExtIEs',
        u'DAPSResponseInfoList',
        u'DAPSResponseInfoListIEs',
        u'DAPSResponseInfoItem',
        u'DAPSResponseInfoItem-ExtIEs',
        u'DAPSResponseInfo',
        u'DAPSResponseInfo-ExtIEs',
        u'DataCodingScheme',
        u'DataSize',
        u'DCN-ID',
        u'ServedDCNs',
        u'ServedDCNsItem',
        u'ServedDCNsItem-ExtIEs',
        u'DL-CP-SecurityInformation',
        u'DL-CP-SecurityInformation-ExtIEs',
        u'DL-Forwarding',
        u'DL-NAS-MAC',
        u'DLCOUNT-PDCP-SNlength',
        u'Direct-Forwarding-Path-Availability',
        u'Data-Forwarding-Not-Possible',
        u'DLNASPDUDeliveryAckRequest',
        u'EARFCN',
        u'ECGIList',
        u'PWSfailedECGIList',
        u'EDT-Session',
        u'EmergencyAreaIDList',
        u'EmergencyAreaID',
        u'EmergencyAreaID-Broadcast',
        u'EmergencyAreaID-Broadcast-Item',
        u'EmergencyAreaID-Broadcast-Item-ExtIEs',
        u'EmergencyAreaID-Cancelled',
        u'EmergencyAreaID-Cancelled-Item',
        u'EmergencyAreaID-Cancelled-Item-ExtIEs',
        u'CompletedCellinEAI',
        u'CompletedCellinEAI-Item',
        u'CompletedCellinEAI-Item-ExtIEs',
        u'ECGI-List',
        u'EmergencyAreaIDListForRestart',
        u'EmergencyIndicator',
        u'ENB-EarlyStatusTransfer-TransparentContainer',
        u'ENB-EarlyStatusTransfer-TransparentContainer-ExtIEs',
        u'ENB-ID',
        u'En-gNB-ID',
        u'GERAN-Cell-ID',
        u'GERAN-Cell-ID-ExtIEs',
        u'Global-ENB-ID',
        u'GlobalENB-ID-ExtIEs',
        u'Global-en-gNB-ID',
        u'Global-en-gNB-ID-ExtIEs',
        u'GUMMEIList',
        u'ENB-StatusTransfer-TransparentContainer',
        u'ENB-StatusTransfer-TransparentContainer-ExtIEs',
        u'ENB-UE-S1AP-ID',
        u'ENBname',
        u'ENBX2TLAs',
        u'EncryptionAlgorithms',
        u'EN-DCSONConfigurationTransfer',
        u'EN-DCSONConfigurationTransfer-ExtIEs',
        u'EN-DCSONTransferType',
        u'EN-DCTransferTypeRequest',
        u'EN-DCTransferTypeRequest-ExtIEs',
        u'EN-DCTransferTypeReply',
        u'EN-DCTransferTypeReply-ExtIEs',
        u'EN-DCSONeNBIdentification',
        u'EN-DCSONeNBIdentification-ExtIEs',
        u'EN-DCSONengNBIdentification',
        u'EN-DCSONengNBIdentification-ExtIEs',
        u'EndIndication',
        u'EnhancedCoverageRestricted',
        u'CE-ModeBRestricted',
        u'EPLMNs',
        u'EventType',
        u'E-RAB-ID',
        u'E-RABInformationList',
        u'E-RABInformationListIEs',
        u'E-RABInformationListItem',
        u'E-RABInformationListItem-ExtIEs',
        u'E-RABList',
        u'E-RABItemIEs',
        u'E-RABItem',
        u'E-RABItem-ExtIEs',
        u'E-RABLevelQoSParameters',
        u'E-RABUsageReportList',
        u'E-RABUsageReportItemIEs',
        u'E-RABUsageReportItem',
        u'E-RABUsageReportItem-ExtIEs',
        u'E-RABQoSParameters-ExtIEs',
        u'Ethernet-Type',
        u'EUTRAN-CGI',
        u'EUTRAN-CGI-ExtIEs',
        u'EUTRANRoundTripDelayEstimationInfo',
        u'ExpectedUEBehaviour',
        u'ExpectedUEBehaviour-ExtIEs',
        u'ExpectedUEActivityBehaviour',
        u'ExpectedUEActivityBehaviour-ExtIEs',
        u'ExpectedActivityPeriod',
        u'ExpectedIdlePeriod',
        u'SourceOfUEActivityBehaviourInformation',
        u'ExpectedHOInterval',
        u'ExtendedBitRate',
        u'ExtendedRNC-ID',
        u'ExtendedRepetitionPeriod',
        u'Extended-UEIdentityIndexValue',
        u'FiveGSTAC',
        u'FiveGSTAI',
        u'FiveGSTAI-ExtIEs',
        u'FiveQI',
        u'ForbiddenInterRATs',
        u'ForbiddenTAs',
        u'ForbiddenTAs-Item',
        u'ForbiddenTAs-Item-ExtIEs',
        u'ForbiddenTACs',
        u'ForbiddenLAs',
        u'ForbiddenLAs-Item',
        u'ForbiddenLAs-Item-ExtIEs',
        u'ForbiddenLACs',
        u'GBR-QosInformation',
        u'GBR-QosInformation-ExtIEs',
        u'GTP-TEID',
        u'GUMMEI',
        u'GUMMEI-ExtIEs',
        u'GUMMEIType',
        u'GWContextReleaseIndication',
        u'HandoverFlag',
        u'HandoverRestrictionList',
        u'HandoverRestrictionList-ExtIEs',
        u'HandoverType',
        u'HFN',
        u'HFNModified',
        u'HFNforPDCP-SNlength18',
        u'Masked-IMEISV',
        u'ImmediateMDT',
        u'ImmediateMDT-ExtIEs',
        u'IMSI',
        u'InformationOnRecommendedCellsAndENBsForPaging',
        u'InformationOnRecommendedCellsAndENBsForPaging-ExtIEs',
        u'IntegrityProtectionAlgorithms',
        u'IntendedNumberOfPagingAttempts',
        u'InterfacesToTrace',
        u'IntersystemMeasurementConfiguration',
        u'IntersystemMeasurementConfiguration-ExtIEs',
        u'InterSystemMeasurementParameters',
        u'InterSystemMeasurementParameters-ExtIEs',
        u'InterSystemMeasurementList',
        u'InterSystemMeasurementItem',
        u'InterSystemMeasurementItem-ExtIEs',
        u'IntersystemSONConfigurationTransfer',
        u'IMSvoiceEPSfallbackfrom5G',
        u'IAB-Authorized',
        u'IAB-Node-Indication',
        u'IAB-Supported',
        u'KillAllWarningMessages',
        u'LAC',
        u'LAI',
        u'LAI-ExtIEs',
        u'LastVisitedCell-Item',
        u'LastVisitedEUTRANCellInformation',
        u'LastVisitedEUTRANCellInformation-ExtIEs',
        u'LastVisitedNGRANCellInformation',
        u'LastVisitedUTRANCellInformation',
        u'LastVisitedGERANCellInformation',
        u'L3-Information',
        u'LPPa-PDU',
        u'LHN-ID',
        u'Links-to-log',
        u'ListeningSubframePattern',
        u'ListeningSubframePattern-ExtIEs',
        u'LoggedMDT',
        u'LoggedMDT-ExtIEs',
        u'LoggingInterval',
        u'LoggingDuration',
        u'LoggedMBSFNMDT',
        u'LoggedMBSFNMDT-ExtIEs',
        u'LTE-M-Indication',
        u'M3Configuration',
        u'M3Configuration-ExtIEs',
        u'M3period',
        u'M4Configuration',
        u'M4Configuration-ExtIEs',
        u'M4period',
        u'M5Configuration',
        u'M5Configuration-ExtIEs',
        u'M5period',
        u'M6Configuration',
        u'M6Configuration-ExtIEs',
        u'M6report-Interval',
        u'M6delay-threshold',
        u'M7Configuration',
        u'M7Configuration-ExtIEs',
        u'M7period',
        u'MDT-Activation',
        u'MDT-Location-Info',
        u'MDT-Configuration',
        u'MDT-Configuration-ExtIEs',
        u'ManagementBasedMDTAllowed',
        u'MBSFN-ResultToLog',
        u'MBSFN-ResultToLogInfo',
        u'MBSFN-ResultToLogInfo-ExtIEs',
        u'MDTPLMNList',
        u'PrivacyIndicator',
        u'MDTMode',
        u'MDTMode-Extension',
        u'MDTMode-ExtensionIE',
        u'MeasurementsToActivate',
        u'MeasurementThresholdA2',
        u'MessageIdentifier',
        u'MobilityInformation',
        u'MMEname',
        u'MMEPagingTarget',
        u'MMERelaySupportIndicator',
        u'MME-Group-ID',
        u'MME-Code',
        u'MME-UE-S1AP-ID',
        u'M-TMSI',
        u'MSClassmark2',
        u'MSClassmark3',
        u'MutingAvailabilityIndication',
        u'MutingPatternInformation',
        u'MutingPatternInformation-ExtIEs',
        u'MDT-ConfigurationNR',
        u'NAS-PDU',
        u'NASSecurityParametersfromE-UTRAN',
        u'NASSecurityParameterstoE-UTRAN',
        u'NB-IoT-DefaultPagingDRX',
        u'NB-IoT-PagingDRX',
        u'NB-IoT-Paging-eDRXInformation',
        u'NB-IoT-Paging-eDRXInformation-ExtIEs',
        u'NB-IoT-Paging-eDRX-Cycle',
        u'NB-IoT-PagingTimeWindow',
        u'NB-IoT-RLF-Report-Container',
        u'NB-IoT-UEIdentityIndexValue',
        u'NextPagingAreaScope',
        u'NotifySourceeNB',
        u'NRCellIdentity',
        u'NR-CGI',
        u'NR-CGI-ExtIEs',
        u'NRencryptionAlgorithms',
        u'NRintegrityProtectionAlgorithms',
        u'NRrestrictioninEPSasSecondaryRAT',
        u'NRrestrictionin5GS',
        u'NRUESecurityCapabilities',
        u'NRUESecurityCapabilities-ExtIEs',
        u'NumberofBroadcastRequest',
        u'NumberOfBroadcasts',
        u'NRV2XServicesAuthorized',
        u'NRV2XServicesAuthorized-ExtIEs',
        u'NRUESidelinkAggregateMaximumBitrate',
        u'NRUESidelinkAggregateMaximumBitrate-ExtIEs',
        u'OldBSS-ToNewBSS-Information',
        u'OverloadAction',
        u'OverloadResponse',
        u'Packet-LossRate',
        u'PagingAttemptInformation',
        u'PagingAttemptInformation-ExtIEs',
        u'PagingAttemptCount',
        u'Paging-eDRXInformation',
        u'Paging-eDRXInformation-ExtIEs',
        u'Paging-eDRX-Cycle',
        u'PagingTimeWindow',
        u'PagingDRX',
        u'PagingPriority',
        u'PagingProbabilityInformation',
        u'PC5QoSParameters',
        u'PC5QoSParameters-ExtIEs',
        u'PC5QoSFlowList',
        u'PC5QoSFlowItem',
        u'PC5QoSFlowItem-ExtIEs',
        u'PC5FlowBitRates',
        u'PC5FlowBitRates-ExtIEs',
        u'PDCP-SN',
        u'PDCP-SNExtended',
        u'PDCP-SNlength18',
        u'PendingDataIndication',
        u'M1PeriodicReporting',
        u'M1PeriodicReporting-ExtIEs',
        u'PLMNidentity',
        u'PLMNAreaBasedQMC',
        u'PLMNAreaBasedQMC-ExtIEs',
        u'PLMNListforQMC',
        u'Port-Number',
        u'Pre-emptionCapability',
        u'Pre-emptionVulnerability',
        u'PriorityLevel',
        u'ProSeAuthorized',
        u'ProSeAuthorized-ExtIEs',
        u'ProSeDirectDiscovery',
        u'ProSeUEtoNetworkRelaying',
        u'ProSeDirectCommunication',
        u'PS-ServiceNotAvailable',
        u'PSCellInformation',
        u'PSCellInformation-ExtIEs',
        u'QCI',
        u'RAN-UE-NGAP-ID',
        u'Range',
        u'ReceiveStatusofULPDCPSDUs',
        u'ReceiveStatusOfULPDCPSDUsExtended',
        u'ReceiveStatusOfULPDCPSDUsPDCP-SNlength18',
        u'RecommendedCellsForPaging',
        u'RecommendedCellsForPaging-ExtIEs',
        u'RecommendedCellList',
        u'RecommendedCellItemIEs',
        u'RecommendedCellItem',
        u'RecommendedCellsForPagingItem-ExtIEs',
        u'RecommendedENBsForPaging',
        u'RecommendedENBsForPaging-ExtIEs',
        u'RecommendedENBList',
        u'RecommendedENBItemIEs',
        u'RecommendedENBItem',
        u'RecommendedENBItem-ExtIEs',
        u'RelativeMMECapacity',
        u'RelayNode-Indicator',
        u'RAC',
        u'RAT-Type',
        u'ReportAmountMDT',
        u'ReportIntervalMDT',
        u'M1ReportingTrigger',
        u'RequestType',
        u'RequestType-ExtIEs',
        u'RequestTypeAdditionalInfo',
        u'RIMTransfer',
        u'RIMTransfer-ExtIEs',
        u'RIMInformation',
        u'RIMRoutingAddress',
        u'ReportArea',
        u'RepetitionPeriod',
        u'RLFReportInformation',
        u'RLFReportInformation-ExtIEs',
        u'RNC-ID',
        u'RRC-Container',
        u'RRC-Establishment-Cause',
        u'ECGIListForRestart',
        u'Routing-ID',
        u'SecurityKey',
        u'SecurityContext',
        u'SecurityContext-ExtIEs',
        u'SecondaryRATType',
        u'SecondaryRATDataUsageRequest',
        u'SecondaryRATDataUsageReportList',
        u'SecondaryRATDataUsageReportItemIEs',
        u'SecondaryRATDataUsageReportItem',
        u'SecondaryRATDataUsageReportItem-ExtIEs',
        u'SerialNumber',
        u'ServiceType',
        u'SONInformation',
        u'SONInformation-Extension',
        u'SONInformation-ExtensionIE',
        u'SONInformationRequest',
        u'SONInformationReply',
        u'SONInformationReply-ExtIEs',
        u'SONInformationReport',
        u'SONConfigurationTransfer',
        u'SONConfigurationTransfer-ExtIEs',
        u'SynchronisationInformation',
        u'SynchronisationInformation-ExtIEs',
        u'Source-ToTarget-TransparentContainer',
        u'SourceBSS-ToTargetBSS-TransparentContainer',
        u'SourceeNB-ID',
        u'SourceeNB-ID-ExtIEs',
        u'SRVCCOperationNotPossible',
        u'SRVCCOperationPossible',
        u'SRVCCHOIndication',
        u'SourceNodeID',
        u'SourceNodeID-Extension',
        u'SourceNodeID-ExtensionIE',
        u'SourceeNB-ToTargeteNB-TransparentContainer',
        u'SourceeNB-ToTargeteNB-TransparentContainer-ExtIEs',
        u'SourceNgRanNode-ID',
        u'SourceNgRanNode-ID-ExtIEs',
        u'SourceRNC-ToTargetRNC-TransparentContainer',
        u'SourceNgRanNode-ToTargetNgRanNode-TransparentContainer',
        u'ServedGUMMEIs',
        u'ServedGUMMEIsItem',
        u'ServedGUMMEIsItem-ExtIEs',
        u'ServedGroupIDs',
        u'ServedMMECs',
        u'ServedPLMNs',
        u'SubscriberProfileIDforRFP',
        u'Subscription-Based-UE-DifferentiationInfo',
        u'Subscription-Based-UE-DifferentiationInfo-ExtIEs',
        u'ScheduledCommunicationTime',
        u'ScheduledCommunicationTime-ExtIEs',
        u'SupportedTAs',
        u'SupportedTAs-Item',
        u'SupportedTAs-Item-ExtIEs',
        u'StratumLevel',
        u'SynchronisationStatus',
        u'TimeSynchronisationInfo',
        u'TimeSynchronisationInfo-ExtIEs',
        u'S-TMSI',
        u'S-TMSI-ExtIEs',
        u'TAC',
        u'TAIBasedMDT',
        u'TAIBasedMDT-ExtIEs',
        u'TAIListforMDT',
        u'TAIListforWarning',
        u'TAI',
        u'TAI-ExtIEs',
        u'TAI-Broadcast',
        u'TAI-Broadcast-Item',
        u'TAI-Broadcast-Item-ExtIEs',
        u'TAI-Cancelled',
        u'TAI-Cancelled-Item',
        u'TAI-Cancelled-Item-ExtIEs',
        u'TABasedMDT',
        u'TABasedMDT-ExtIEs',
        u'TAListforMDT',
        u'TABasedQMC',
        u'TABasedQMC-ExtIEs',
        u'TAListforQMC',
        u'TAIBasedQMC',
        u'TAIBasedQMC-ExtIEs',
        u'TAIListforQMC',
        u'CompletedCellinTAI',
        u'CompletedCellinTAI-Item',
        u'CompletedCellinTAI-Item-ExtIEs',
        u'TBCD-STRING',
        u'TargetID',
        u'TargeteNB-ID',
        u'TargeteNB-ID-ExtIEs',
        u'TargetRNC-ID',
        u'TargetRNC-ID-ExtIEs',
        u'TargetNgRanNode-ID',
        u'TargetNgRanNode-ID-ExtIEs',
        u'Global-RAN-NODE-ID',
        u'GNB',
        u'GNB-ExtIEs',
        u'Global-GNB-ID',
        u'Global-GNB-ID-ExtIEs',
        u'GNB-Identity',
        u'NG-eNB',
        u'NG-eNB-ExtIEs',
        u'GNB-ID',
        u'TargeteNB-ToSourceeNB-TransparentContainer',
        u'TargeteNB-ToSourceeNB-TransparentContainer-ExtIEs',
        u'Target-ToSource-TransparentContainer',
        u'TargetRNC-ToSourceRNC-TransparentContainer',
        u'TargetBSS-ToSourceBSS-TransparentContainer',
        u'TargetNgRanNode-ToSourceNgRanNode-TransparentContainer',
        u'M1ThresholdEventA2',
        u'M1ThresholdEventA2-ExtIEs',
        u'Threshold-RSRP',
        u'Threshold-RSRQ',
        u'TimeToWait',
        u'Time-UE-StayedInCell',
        u'Time-UE-StayedInCell-EnhancedGranularity',
        u'TimeSinceSecondaryNodeRelease',
        u'TransportInformation',
        u'TransportLayerAddress',
        u'TraceActivation',
        u'TraceActivation-ExtIEs',
        u'TraceDepth',
        u'E-UTRAN-Trace-ID',
        u'TrafficLoadReductionIndication',
        u'TunnelInformation',
        u'Tunnel-Information-ExtIEs',
        u'TypeOfError',
        u'TAIListForRestart',
        u'UEAggregateMaximumBitrate',
        u'UEAggregate-MaximumBitrates-ExtIEs',
        u'UEAppLayerMeasConfig',
        u'UEAppLayerMeasConfig-ExtIEs',
        u'UECapabilityInfoRequest',
        u'UE-RetentionInformation',
        u'UE-S1AP-IDs',
        u'UE-S1AP-ID-pair',
        u'UE-S1AP-ID-pair-ExtIEs',
        u'UE-associatedLogicalS1-ConnectionItem',
        u'UE-associatedLogicalS1-ConnectionItemExtIEs',
        u'UEIdentityIndexValue',
        u'UE-HistoryInformation',
        u'UE-HistoryInformationFromTheUE',
        u'UEPagingID',
        u'UERadioCapability',
        u'UERadioCapabilityForPaging',
        u'UERadioCapabilityID',
        u'UE-RLF-Report-Container',
        u'UE-RLF-Report-Container-for-extended-bands',
        u'UESecurityCapabilities',
        u'UESecurityCapabilities-ExtIEs',
        u'UESidelinkAggregateMaximumBitrate',
        u'UE-Sidelink-Aggregate-MaximumBitrates-ExtIEs',
        u'UE-Usage-Type',
        u'UL-CP-SecurityInformation',
        u'UL-CP-SecurityInformation-ExtIEs',
        u'UL-NAS-MAC',
        u'UL-NAS-Count',
        u'UnlicensedSpectrumRestriction',
        u'URI-Address',
        u'UserLocationInformation',
        u'UserLocationInformation-ExtIEs',
        u'UEUserPlaneCIoTSupportIndicator',
        u'UE-Application-Layer-Measurement-Capability',
        u'VoiceSupportMatchIndicator',
        u'V2XServicesAuthorized',
        u'V2XServicesAuthorized-ExtIEs',
        u'VehicleUE',
        u'PedestrianUE',
        u'WarningAreaCoordinates',
        u'WarningAreaList',
        u'WarningType',
        u'WarningSecurityInfo',
        u'WarningMessageContents',
        u'WLANMeasurementConfiguration',
        u'WLANMeasurementConfiguration-ExtIEs',
        u'WLANMeasConfigNameList',
        u'WLANMeasConfig',
        u'WLANName',
        u'WUS-Assistance-Information',
        u'WUS-Assistance-Information-ExtIEs',
        u'X2TNLConfigurationInfo',
        u'X2TNLConfigurationInfo-ExtIEs',
        u'ENBX2ExtTLAs',
        u'ENBX2ExtTLA',
        u'ENBX2ExtTLA-ExtIEs',
        u'ENBX2GTPTLAs',
        u'ENBIndirectX2TransportLayerAddresses',
        ]
    _type_ = [
        u'Additional-GUTI',
        u'AdditionalRRMPriorityIndex',
        u'AerialUEsubscriptionInformation',
        u'AreaScopeOfMDT',
        u'AreaScopeOfQMC',
        u'AllocationAndRetentionPriority',
        u'AssistanceDataForCECapableUEs',
        u'AssistanceDataForPaging',
        u'AssistanceDataForRecommendedCells',
        u'Bearers-SubjectToStatusTransferList',
        u'Bearers-SubjectToStatusTransfer-Item',
        u'Bearers-SubjectToEarlyStatusTransferList',
        u'Bearers-SubjectToEarlyStatusTransfer-Item',
        u'BearerType',
        u'BitRate',
        u'BluetoothMeasurementConfiguration',
        u'BluetoothMeasConfigNameList',
        u'BluetoothMeasConfig',
        u'BluetoothName',
        u'BPLMNs',
        u'BroadcastCancelledAreaList',
        u'BroadcastCompletedAreaList',
        u'CancelledCellinEAI',
        u'CancelledCellinEAI-Item',
        u'CancelledCellinTAI',
        u'CancelledCellinTAI-Item',
        u'Cause',
        u'CauseMisc',
        u'CauseProtocol',
        u'CauseRadioNetwork',
        u'CauseTransport',
        u'CauseNas',
        u'CellAccessMode',
        u'CellIdentifierAndCELevelForCECapableUEs',
        u'CELevel',
        u'CE-mode-B-SupportIndicator',
        u'CellIdentity',
        u'CellID-Broadcast',
        u'CellID-Broadcast-Item',
        u'CellID-Cancelled',
        u'CellID-Cancelled-Item',
        u'CellBasedMDT',
        u'CellIdListforMDT',
        u'CellBasedQMC',
        u'CellIdListforQMC',
        u'Cdma2000PDU',
        u'Cdma2000RATType',
        u'Cdma2000SectorID',
        u'Cdma2000HOStatus',
        u'Cdma2000HORequiredIndication',
        u'Cdma2000OneXSRVCCInfo',
        u'Cdma2000OneXMEID',
        u'Cdma2000OneXMSI',
        u'Cdma2000OneXPilot',
        u'Cdma2000OneXRAND',
        u'Cell-Size',
        u'CellType',
        u'CGI',
        u'CI',
        u'CNDomain',
        u'CNTypeRestrictions',
        u'CNTypeRestrictions-Item',
        u'CNType',
        u'ConcurrentWarningMessageIndicator',
        u'ConnectedengNBList',
        u'ConnectedengNBItem',
        u'ContextatSource',
        u'Correlation-ID',
        u'CSFallbackIndicator',
        u'AdditionalCSFallbackIndicator',
        u'CSG-Id',
        u'CSG-IdList',
        u'CSG-IdList-Item',
        u'CSGMembershipStatus',
        u'COUNTvalue',
        u'COUNTValueExtended',
        u'COUNTvaluePDCP-SNlength18',
        u'Coverage-Level',
        u'CriticalityDiagnostics',
        u'CriticalityDiagnostics-IE-List',
        u'CriticalityDiagnostics-IE-Item',
        u'DAPSRequestInfo',
        u'DAPSResponseInfoList',
        u'DAPSResponseInfoItem',
        u'DAPSResponseInfo',
        u'DataCodingScheme',
        u'DataSize',
        u'DCN-ID',
        u'ServedDCNs',
        u'ServedDCNsItem',
        u'DL-CP-SecurityInformation',
        u'DL-Forwarding',
        u'DL-NAS-MAC',
        u'DLCOUNT-PDCP-SNlength',
        u'Direct-Forwarding-Path-Availability',
        u'Data-Forwarding-Not-Possible',
        u'DLNASPDUDeliveryAckRequest',
        u'EARFCN',
        u'ECGIList',
        u'PWSfailedECGIList',
        u'EDT-Session',
        u'EmergencyAreaIDList',
        u'EmergencyAreaID',
        u'EmergencyAreaID-Broadcast',
        u'EmergencyAreaID-Broadcast-Item',
        u'EmergencyAreaID-Cancelled',
        u'EmergencyAreaID-Cancelled-Item',
        u'CompletedCellinEAI',
        u'CompletedCellinEAI-Item',
        u'ECGI-List',
        u'EmergencyAreaIDListForRestart',
        u'EmergencyIndicator',
        u'ENB-EarlyStatusTransfer-TransparentContainer',
        u'ENB-ID',
        u'En-gNB-ID',
        u'GERAN-Cell-ID',
        u'Global-ENB-ID',
        u'Global-en-gNB-ID',
        u'GUMMEIList',
        u'ENB-StatusTransfer-TransparentContainer',
        u'ENB-UE-S1AP-ID',
        u'ENBname',
        u'ENBX2TLAs',
        u'EncryptionAlgorithms',
        u'EN-DCSONConfigurationTransfer',
        u'EN-DCSONTransferType',
        u'EN-DCTransferTypeRequest',
        u'EN-DCTransferTypeReply',
        u'EN-DCSONeNBIdentification',
        u'EN-DCSONengNBIdentification',
        u'EndIndication',
        u'EnhancedCoverageRestricted',
        u'CE-ModeBRestricted',
        u'EPLMNs',
        u'EventType',
        u'E-RAB-ID',
        u'E-RABInformationList',
        u'E-RABInformationListItem',
        u'E-RABList',
        u'E-RABItem',
        u'E-RABLevelQoSParameters',
        u'E-RABUsageReportList',
        u'E-RABUsageReportItem',
        u'Ethernet-Type',
        u'EUTRAN-CGI',
        u'EUTRANRoundTripDelayEstimationInfo',
        u'ExpectedUEBehaviour',
        u'ExpectedUEActivityBehaviour',
        u'ExpectedActivityPeriod',
        u'ExpectedIdlePeriod',
        u'SourceOfUEActivityBehaviourInformation',
        u'ExpectedHOInterval',
        u'ExtendedBitRate',
        u'ExtendedRNC-ID',
        u'ExtendedRepetitionPeriod',
        u'Extended-UEIdentityIndexValue',
        u'FiveGSTAC',
        u'FiveGSTAI',
        u'FiveQI',
        u'ForbiddenInterRATs',
        u'ForbiddenTAs',
        u'ForbiddenTAs-Item',
        u'ForbiddenTACs',
        u'ForbiddenLAs',
        u'ForbiddenLAs-Item',
        u'ForbiddenLACs',
        u'GBR-QosInformation',
        u'GTP-TEID',
        u'GUMMEI',
        u'GUMMEIType',
        u'GWContextReleaseIndication',
        u'HandoverFlag',
        u'HandoverRestrictionList',
        u'HandoverType',
        u'HFN',
        u'HFNModified',
        u'HFNforPDCP-SNlength18',
        u'Masked-IMEISV',
        u'ImmediateMDT',
        u'IMSI',
        u'InformationOnRecommendedCellsAndENBsForPaging',
        u'IntegrityProtectionAlgorithms',
        u'IntendedNumberOfPagingAttempts',
        u'InterfacesToTrace',
        u'IntersystemMeasurementConfiguration',
        u'InterSystemMeasurementParameters',
        u'InterSystemMeasurementList',
        u'InterSystemMeasurementItem',
        u'IntersystemSONConfigurationTransfer',
        u'IMSvoiceEPSfallbackfrom5G',
        u'IAB-Authorized',
        u'IAB-Node-Indication',
        u'IAB-Supported',
        u'KillAllWarningMessages',
        u'LAC',
        u'LAI',
        u'LastVisitedCell-Item',
        u'LastVisitedEUTRANCellInformation',
        u'LastVisitedNGRANCellInformation',
        u'LastVisitedUTRANCellInformation',
        u'LastVisitedGERANCellInformation',
        u'L3-Information',
        u'LPPa-PDU',
        u'LHN-ID',
        u'Links-to-log',
        u'ListeningSubframePattern',
        u'LoggedMDT',
        u'LoggingInterval',
        u'LoggingDuration',
        u'LoggedMBSFNMDT',
        u'LTE-M-Indication',
        u'M3Configuration',
        u'M3period',
        u'M4Configuration',
        u'M4period',
        u'M5Configuration',
        u'M5period',
        u'M6Configuration',
        u'M6report-Interval',
        u'M6delay-threshold',
        u'M7Configuration',
        u'M7period',
        u'MDT-Activation',
        u'MDT-Location-Info',
        u'MDT-Configuration',
        u'ManagementBasedMDTAllowed',
        u'MBSFN-ResultToLog',
        u'MBSFN-ResultToLogInfo',
        u'MDTPLMNList',
        u'PrivacyIndicator',
        u'MDTMode',
        u'MDTMode-Extension',
        u'MeasurementsToActivate',
        u'MeasurementThresholdA2',
        u'MessageIdentifier',
        u'MobilityInformation',
        u'MMEname',
        u'MMEPagingTarget',
        u'MMERelaySupportIndicator',
        u'MME-Group-ID',
        u'MME-Code',
        u'MME-UE-S1AP-ID',
        u'M-TMSI',
        u'MSClassmark2',
        u'MSClassmark3',
        u'MutingAvailabilityIndication',
        u'MutingPatternInformation',
        u'MDT-ConfigurationNR',
        u'NAS-PDU',
        u'NASSecurityParametersfromE-UTRAN',
        u'NASSecurityParameterstoE-UTRAN',
        u'NB-IoT-DefaultPagingDRX',
        u'NB-IoT-PagingDRX',
        u'NB-IoT-Paging-eDRXInformation',
        u'NB-IoT-Paging-eDRX-Cycle',
        u'NB-IoT-PagingTimeWindow',
        u'NB-IoT-RLF-Report-Container',
        u'NB-IoT-UEIdentityIndexValue',
        u'NextPagingAreaScope',
        u'NotifySourceeNB',
        u'NRCellIdentity',
        u'NR-CGI',
        u'NRencryptionAlgorithms',
        u'NRintegrityProtectionAlgorithms',
        u'NRrestrictioninEPSasSecondaryRAT',
        u'NRrestrictionin5GS',
        u'NRUESecurityCapabilities',
        u'NumberofBroadcastRequest',
        u'NumberOfBroadcasts',
        u'NRV2XServicesAuthorized',
        u'NRUESidelinkAggregateMaximumBitrate',
        u'OldBSS-ToNewBSS-Information',
        u'OverloadAction',
        u'OverloadResponse',
        u'Packet-LossRate',
        u'PagingAttemptInformation',
        u'PagingAttemptCount',
        u'Paging-eDRXInformation',
        u'Paging-eDRX-Cycle',
        u'PagingTimeWindow',
        u'PagingDRX',
        u'PagingPriority',
        u'PagingProbabilityInformation',
        u'PC5QoSParameters',
        u'PC5QoSFlowList',
        u'PC5QoSFlowItem',
        u'PC5FlowBitRates',
        u'PDCP-SN',
        u'PDCP-SNExtended',
        u'PDCP-SNlength18',
        u'PendingDataIndication',
        u'M1PeriodicReporting',
        u'PLMNidentity',
        u'PLMNAreaBasedQMC',
        u'PLMNListforQMC',
        u'Port-Number',
        u'Pre-emptionCapability',
        u'Pre-emptionVulnerability',
        u'PriorityLevel',
        u'ProSeAuthorized',
        u'ProSeDirectDiscovery',
        u'ProSeUEtoNetworkRelaying',
        u'ProSeDirectCommunication',
        u'PS-ServiceNotAvailable',
        u'PSCellInformation',
        u'QCI',
        u'RAN-UE-NGAP-ID',
        u'Range',
        u'ReceiveStatusofULPDCPSDUs',
        u'ReceiveStatusOfULPDCPSDUsExtended',
        u'ReceiveStatusOfULPDCPSDUsPDCP-SNlength18',
        u'RecommendedCellsForPaging',
        u'RecommendedCellList',
        u'RecommendedCellItem',
        u'RecommendedENBsForPaging',
        u'RecommendedENBList',
        u'RecommendedENBItem',
        u'RelativeMMECapacity',
        u'RelayNode-Indicator',
        u'RAC',
        u'RAT-Type',
        u'ReportAmountMDT',
        u'ReportIntervalMDT',
        u'M1ReportingTrigger',
        u'RequestType',
        u'RequestTypeAdditionalInfo',
        u'RIMTransfer',
        u'RIMInformation',
        u'RIMRoutingAddress',
        u'ReportArea',
        u'RepetitionPeriod',
        u'RLFReportInformation',
        u'RNC-ID',
        u'RRC-Container',
        u'RRC-Establishment-Cause',
        u'ECGIListForRestart',
        u'Routing-ID',
        u'SecurityKey',
        u'SecurityContext',
        u'SecondaryRATType',
        u'SecondaryRATDataUsageRequest',
        u'SecondaryRATDataUsageReportList',
        u'SecondaryRATDataUsageReportItem',
        u'SerialNumber',
        u'ServiceType',
        u'SONInformation',
        u'SONInformation-Extension',
        u'SONInformationRequest',
        u'SONInformationReply',
        u'SONInformationReport',
        u'SONConfigurationTransfer',
        u'SynchronisationInformation',
        u'Source-ToTarget-TransparentContainer',
        u'SourceBSS-ToTargetBSS-TransparentContainer',
        u'SourceeNB-ID',
        u'SRVCCOperationNotPossible',
        u'SRVCCOperationPossible',
        u'SRVCCHOIndication',
        u'SourceNodeID',
        u'SourceNodeID-Extension',
        u'SourceeNB-ToTargeteNB-TransparentContainer',
        u'SourceNgRanNode-ID',
        u'SourceRNC-ToTargetRNC-TransparentContainer',
        u'SourceNgRanNode-ToTargetNgRanNode-TransparentContainer',
        u'ServedGUMMEIs',
        u'ServedGUMMEIsItem',
        u'ServedGroupIDs',
        u'ServedMMECs',
        u'ServedPLMNs',
        u'SubscriberProfileIDforRFP',
        u'Subscription-Based-UE-DifferentiationInfo',
        u'ScheduledCommunicationTime',
        u'SupportedTAs',
        u'SupportedTAs-Item',
        u'StratumLevel',
        u'SynchronisationStatus',
        u'TimeSynchronisationInfo',
        u'S-TMSI',
        u'TAC',
        u'TAIBasedMDT',
        u'TAIListforMDT',
        u'TAIListforWarning',
        u'TAI',
        u'TAI-Broadcast',
        u'TAI-Broadcast-Item',
        u'TAI-Cancelled',
        u'TAI-Cancelled-Item',
        u'TABasedMDT',
        u'TAListforMDT',
        u'TABasedQMC',
        u'TAListforQMC',
        u'TAIBasedQMC',
        u'TAIListforQMC',
        u'CompletedCellinTAI',
        u'CompletedCellinTAI-Item',
        u'TBCD-STRING',
        u'TargetID',
        u'TargeteNB-ID',
        u'TargetRNC-ID',
        u'TargetNgRanNode-ID',
        u'Global-RAN-NODE-ID',
        u'GNB',
        u'Global-GNB-ID',
        u'GNB-Identity',
        u'NG-eNB',
        u'GNB-ID',
        u'TargeteNB-ToSourceeNB-TransparentContainer',
        u'Target-ToSource-TransparentContainer',
        u'TargetRNC-ToSourceRNC-TransparentContainer',
        u'TargetBSS-ToSourceBSS-TransparentContainer',
        u'TargetNgRanNode-ToSourceNgRanNode-TransparentContainer',
        u'M1ThresholdEventA2',
        u'Threshold-RSRP',
        u'Threshold-RSRQ',
        u'TimeToWait',
        u'Time-UE-StayedInCell',
        u'Time-UE-StayedInCell-EnhancedGranularity',
        u'TimeSinceSecondaryNodeRelease',
        u'TransportInformation',
        u'TransportLayerAddress',
        u'TraceActivation',
        u'TraceDepth',
        u'E-UTRAN-Trace-ID',
        u'TrafficLoadReductionIndication',
        u'TunnelInformation',
        u'TypeOfError',
        u'TAIListForRestart',
        u'UEAggregateMaximumBitrate',
        u'UEAppLayerMeasConfig',
        u'UECapabilityInfoRequest',
        u'UE-RetentionInformation',
        u'UE-S1AP-IDs',
        u'UE-S1AP-ID-pair',
        u'UE-associatedLogicalS1-ConnectionItem',
        u'UEIdentityIndexValue',
        u'UE-HistoryInformation',
        u'UE-HistoryInformationFromTheUE',
        u'UEPagingID',
        u'UERadioCapability',
        u'UERadioCapabilityForPaging',
        u'UERadioCapabilityID',
        u'UE-RLF-Report-Container',
        u'UE-RLF-Report-Container-for-extended-bands',
        u'UESecurityCapabilities',
        u'UESidelinkAggregateMaximumBitrate',
        u'UE-Usage-Type',
        u'UL-CP-SecurityInformation',
        u'UL-NAS-MAC',
        u'UL-NAS-Count',
        u'UnlicensedSpectrumRestriction',
        u'URI-Address',
        u'UserLocationInformation',
        u'UEUserPlaneCIoTSupportIndicator',
        u'UE-Application-Layer-Measurement-Capability',
        u'VoiceSupportMatchIndicator',
        u'V2XServicesAuthorized',
        u'VehicleUE',
        u'PedestrianUE',
        u'WarningAreaCoordinates',
        u'WarningAreaList',
        u'WarningType',
        u'WarningSecurityInfo',
        u'WarningMessageContents',
        u'WLANMeasurementConfiguration',
        u'WLANMeasConfigNameList',
        u'WLANMeasConfig',
        u'WLANName',
        u'WUS-Assistance-Information',
        u'X2TNLConfigurationInfo',
        u'ENBX2ExtTLAs',
        u'ENBX2ExtTLA',
        u'ENBX2GTPTLAs',
        u'ENBIndirectX2TransportLayerAddresses',
        ]
    _set_ = [
        u'Additional-GUTI-ExtIEs',
        u'AllocationAndRetentionPriority-ExtIEs',
        u'InformationForCECapableUEs-ExtIEs',
        u'AssistanceDataForPaging-ExtIEs',
        u'AssistanceDataForRecommendedCells-ExtIEs',
        u'Bearers-SubjectToStatusTransfer-ItemIEs',
        u'Bearers-SubjectToStatusTransfer-ItemExtIEs',
        u'Bearers-SubjectToEarlyStatusTransfer-ItemIEs',
        u'Bearers-SubjectToEarlyStatusTransfer-ItemExtIEs',
        u'BluetoothMeasurementConfiguration-ExtIEs',
        u'CancelledCellinEAI-Item-ExtIEs',
        u'CancelledCellinTAI-Item-ExtIEs',
        u'CellIdentifierAndCELevelForCECapableUEs-ExtIEs',
        u'CellID-Broadcast-Item-ExtIEs',
        u'CellID-Cancelled-Item-ExtIEs',
        u'CellBasedMDT-ExtIEs',
        u'CellBasedQMC-ExtIEs',
        u'Cdma2000OneXSRVCCInfo-ExtIEs',
        u'CellType-ExtIEs',
        u'CGI-ExtIEs',
        u'CNTypeRestrictions-Item-ExtIEs',
        u'ConnectedengNBItem-ExtIEs',
        u'ContextatSource-ExtIEs',
        u'CSG-IdList-Item-ExtIEs',
        u'COUNTvalue-ExtIEs',
        u'COUNTValueExtended-ExtIEs',
        u'COUNTvaluePDCP-SNlength18-ExtIEs',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-Item-ExtIEs',
        u'DAPSRequestInfo-ExtIEs',
        u'DAPSResponseInfoListIEs',
        u'DAPSResponseInfoItem-ExtIEs',
        u'DAPSResponseInfo-ExtIEs',
        u'ServedDCNsItem-ExtIEs',
        u'DL-CP-SecurityInformation-ExtIEs',
        u'EmergencyAreaID-Broadcast-Item-ExtIEs',
        u'EmergencyAreaID-Cancelled-Item-ExtIEs',
        u'CompletedCellinEAI-Item-ExtIEs',
        u'ENB-EarlyStatusTransfer-TransparentContainer-ExtIEs',
        u'GERAN-Cell-ID-ExtIEs',
        u'GlobalENB-ID-ExtIEs',
        u'Global-en-gNB-ID-ExtIEs',
        u'ENB-StatusTransfer-TransparentContainer-ExtIEs',
        u'EN-DCSONConfigurationTransfer-ExtIEs',
        u'EN-DCTransferTypeRequest-ExtIEs',
        u'EN-DCTransferTypeReply-ExtIEs',
        u'EN-DCSONeNBIdentification-ExtIEs',
        u'EN-DCSONengNBIdentification-ExtIEs',
        u'E-RABInformationListIEs',
        u'E-RABInformationListItem-ExtIEs',
        u'E-RABItemIEs',
        u'E-RABItem-ExtIEs',
        u'E-RABUsageReportItemIEs',
        u'E-RABUsageReportItem-ExtIEs',
        u'E-RABQoSParameters-ExtIEs',
        u'EUTRAN-CGI-ExtIEs',
        u'ExpectedUEBehaviour-ExtIEs',
        u'ExpectedUEActivityBehaviour-ExtIEs',
        u'FiveGSTAI-ExtIEs',
        u'ForbiddenTAs-Item-ExtIEs',
        u'ForbiddenLAs-Item-ExtIEs',
        u'GBR-QosInformation-ExtIEs',
        u'GUMMEI-ExtIEs',
        u'HandoverRestrictionList-ExtIEs',
        u'ImmediateMDT-ExtIEs',
        u'InformationOnRecommendedCellsAndENBsForPaging-ExtIEs',
        u'IntersystemMeasurementConfiguration-ExtIEs',
        u'InterSystemMeasurementParameters-ExtIEs',
        u'InterSystemMeasurementItem-ExtIEs',
        u'LAI-ExtIEs',
        u'LastVisitedEUTRANCellInformation-ExtIEs',
        u'ListeningSubframePattern-ExtIEs',
        u'LoggedMDT-ExtIEs',
        u'LoggedMBSFNMDT-ExtIEs',
        u'M3Configuration-ExtIEs',
        u'M4Configuration-ExtIEs',
        u'M5Configuration-ExtIEs',
        u'M6Configuration-ExtIEs',
        u'M7Configuration-ExtIEs',
        u'MDT-Configuration-ExtIEs',
        u'MBSFN-ResultToLogInfo-ExtIEs',
        u'MDTMode-ExtensionIE',
        u'MutingPatternInformation-ExtIEs',
        u'NB-IoT-Paging-eDRXInformation-ExtIEs',
        u'NR-CGI-ExtIEs',
        u'NRUESecurityCapabilities-ExtIEs',
        u'NRV2XServicesAuthorized-ExtIEs',
        u'NRUESidelinkAggregateMaximumBitrate-ExtIEs',
        u'PagingAttemptInformation-ExtIEs',
        u'Paging-eDRXInformation-ExtIEs',
        u'PC5QoSParameters-ExtIEs',
        u'PC5QoSFlowItem-ExtIEs',
        u'PC5FlowBitRates-ExtIEs',
        u'M1PeriodicReporting-ExtIEs',
        u'PLMNAreaBasedQMC-ExtIEs',
        u'ProSeAuthorized-ExtIEs',
        u'PSCellInformation-ExtIEs',
        u'RecommendedCellsForPaging-ExtIEs',
        u'RecommendedCellItemIEs',
        u'RecommendedCellsForPagingItem-ExtIEs',
        u'RecommendedENBsForPaging-ExtIEs',
        u'RecommendedENBItemIEs',
        u'RecommendedENBItem-ExtIEs',
        u'RequestType-ExtIEs',
        u'RIMTransfer-ExtIEs',
        u'RLFReportInformation-ExtIEs',
        u'SecurityContext-ExtIEs',
        u'SecondaryRATDataUsageReportItemIEs',
        u'SecondaryRATDataUsageReportItem-ExtIEs',
        u'SONInformation-ExtensionIE',
        u'SONInformationReply-ExtIEs',
        u'SONConfigurationTransfer-ExtIEs',
        u'SynchronisationInformation-ExtIEs',
        u'SourceeNB-ID-ExtIEs',
        u'SourceNodeID-ExtensionIE',
        u'SourceeNB-ToTargeteNB-TransparentContainer-ExtIEs',
        u'SourceNgRanNode-ID-ExtIEs',
        u'ServedGUMMEIsItem-ExtIEs',
        u'Subscription-Based-UE-DifferentiationInfo-ExtIEs',
        u'ScheduledCommunicationTime-ExtIEs',
        u'SupportedTAs-Item-ExtIEs',
        u'TimeSynchronisationInfo-ExtIEs',
        u'S-TMSI-ExtIEs',
        u'TAIBasedMDT-ExtIEs',
        u'TAI-ExtIEs',
        u'TAI-Broadcast-Item-ExtIEs',
        u'TAI-Cancelled-Item-ExtIEs',
        u'TABasedMDT-ExtIEs',
        u'TABasedQMC-ExtIEs',
        u'TAIBasedQMC-ExtIEs',
        u'CompletedCellinTAI-Item-ExtIEs',
        u'TargeteNB-ID-ExtIEs',
        u'TargetRNC-ID-ExtIEs',
        u'TargetNgRanNode-ID-ExtIEs',
        u'GNB-ExtIEs',
        u'Global-GNB-ID-ExtIEs',
        u'NG-eNB-ExtIEs',
        u'TargeteNB-ToSourceeNB-TransparentContainer-ExtIEs',
        u'M1ThresholdEventA2-ExtIEs',
        u'TraceActivation-ExtIEs',
        u'Tunnel-Information-ExtIEs',
        u'UEAggregate-MaximumBitrates-ExtIEs',
        u'UEAppLayerMeasConfig-ExtIEs',
        u'UE-S1AP-ID-pair-ExtIEs',
        u'UE-associatedLogicalS1-ConnectionItemExtIEs',
        u'UESecurityCapabilities-ExtIEs',
        u'UE-Sidelink-Aggregate-MaximumBitrates-ExtIEs',
        u'UL-CP-SecurityInformation-ExtIEs',
        u'UserLocationInformation-ExtIEs',
        u'V2XServicesAuthorized-ExtIEs',
        u'WLANMeasurementConfiguration-ExtIEs',
        u'WUS-Assistance-Information-ExtIEs',
        u'X2TNLConfigurationInfo-ExtIEs',
        u'ENBX2ExtTLA-ExtIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        u'Additional-GUTI-ExtIEs',
        u'AllocationAndRetentionPriority-ExtIEs',
        u'InformationForCECapableUEs-ExtIEs',
        u'AssistanceDataForPaging-ExtIEs',
        u'AssistanceDataForRecommendedCells-ExtIEs',
        u'Bearers-SubjectToStatusTransfer-ItemIEs',
        u'Bearers-SubjectToStatusTransfer-ItemExtIEs',
        u'Bearers-SubjectToEarlyStatusTransfer-ItemIEs',
        u'Bearers-SubjectToEarlyStatusTransfer-ItemExtIEs',
        u'BluetoothMeasurementConfiguration-ExtIEs',
        u'CancelledCellinEAI-Item-ExtIEs',
        u'CancelledCellinTAI-Item-ExtIEs',
        u'CellIdentifierAndCELevelForCECapableUEs-ExtIEs',
        u'CellID-Broadcast-Item-ExtIEs',
        u'CellID-Cancelled-Item-ExtIEs',
        u'CellBasedMDT-ExtIEs',
        u'CellBasedQMC-ExtIEs',
        u'Cdma2000OneXSRVCCInfo-ExtIEs',
        u'CellType-ExtIEs',
        u'CGI-ExtIEs',
        u'CNTypeRestrictions-Item-ExtIEs',
        u'ConnectedengNBItem-ExtIEs',
        u'ContextatSource-ExtIEs',
        u'CSG-IdList-Item-ExtIEs',
        u'COUNTvalue-ExtIEs',
        u'COUNTValueExtended-ExtIEs',
        u'COUNTvaluePDCP-SNlength18-ExtIEs',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-Item-ExtIEs',
        u'DAPSRequestInfo-ExtIEs',
        u'DAPSResponseInfoListIEs',
        u'DAPSResponseInfoItem-ExtIEs',
        u'DAPSResponseInfo-ExtIEs',
        u'ServedDCNsItem-ExtIEs',
        u'DL-CP-SecurityInformation-ExtIEs',
        u'EmergencyAreaID-Broadcast-Item-ExtIEs',
        u'EmergencyAreaID-Cancelled-Item-ExtIEs',
        u'CompletedCellinEAI-Item-ExtIEs',
        u'ENB-EarlyStatusTransfer-TransparentContainer-ExtIEs',
        u'GERAN-Cell-ID-ExtIEs',
        u'GlobalENB-ID-ExtIEs',
        u'Global-en-gNB-ID-ExtIEs',
        u'ENB-StatusTransfer-TransparentContainer-ExtIEs',
        u'EN-DCSONConfigurationTransfer-ExtIEs',
        u'EN-DCTransferTypeRequest-ExtIEs',
        u'EN-DCTransferTypeReply-ExtIEs',
        u'EN-DCSONeNBIdentification-ExtIEs',
        u'EN-DCSONengNBIdentification-ExtIEs',
        u'E-RABInformationListIEs',
        u'E-RABInformationListItem-ExtIEs',
        u'E-RABItemIEs',
        u'E-RABItem-ExtIEs',
        u'E-RABUsageReportItemIEs',
        u'E-RABUsageReportItem-ExtIEs',
        u'E-RABQoSParameters-ExtIEs',
        u'EUTRAN-CGI-ExtIEs',
        u'ExpectedUEBehaviour-ExtIEs',
        u'ExpectedUEActivityBehaviour-ExtIEs',
        u'FiveGSTAI-ExtIEs',
        u'ForbiddenTAs-Item-ExtIEs',
        u'ForbiddenLAs-Item-ExtIEs',
        u'GBR-QosInformation-ExtIEs',
        u'GUMMEI-ExtIEs',
        u'HandoverRestrictionList-ExtIEs',
        u'ImmediateMDT-ExtIEs',
        u'InformationOnRecommendedCellsAndENBsForPaging-ExtIEs',
        u'IntersystemMeasurementConfiguration-ExtIEs',
        u'InterSystemMeasurementParameters-ExtIEs',
        u'InterSystemMeasurementItem-ExtIEs',
        u'LAI-ExtIEs',
        u'LastVisitedEUTRANCellInformation-ExtIEs',
        u'ListeningSubframePattern-ExtIEs',
        u'LoggedMDT-ExtIEs',
        u'LoggedMBSFNMDT-ExtIEs',
        u'M3Configuration-ExtIEs',
        u'M4Configuration-ExtIEs',
        u'M5Configuration-ExtIEs',
        u'M6Configuration-ExtIEs',
        u'M7Configuration-ExtIEs',
        u'MDT-Configuration-ExtIEs',
        u'MBSFN-ResultToLogInfo-ExtIEs',
        u'MDTMode-ExtensionIE',
        u'MutingPatternInformation-ExtIEs',
        u'NB-IoT-Paging-eDRXInformation-ExtIEs',
        u'NR-CGI-ExtIEs',
        u'NRUESecurityCapabilities-ExtIEs',
        u'NRV2XServicesAuthorized-ExtIEs',
        u'NRUESidelinkAggregateMaximumBitrate-ExtIEs',
        u'PagingAttemptInformation-ExtIEs',
        u'Paging-eDRXInformation-ExtIEs',
        u'PC5QoSParameters-ExtIEs',
        u'PC5QoSFlowItem-ExtIEs',
        u'PC5FlowBitRates-ExtIEs',
        u'M1PeriodicReporting-ExtIEs',
        u'PLMNAreaBasedQMC-ExtIEs',
        u'ProSeAuthorized-ExtIEs',
        u'PSCellInformation-ExtIEs',
        u'RecommendedCellsForPaging-ExtIEs',
        u'RecommendedCellItemIEs',
        u'RecommendedCellsForPagingItem-ExtIEs',
        u'RecommendedENBsForPaging-ExtIEs',
        u'RecommendedENBItemIEs',
        u'RecommendedENBItem-ExtIEs',
        u'RequestType-ExtIEs',
        u'RIMTransfer-ExtIEs',
        u'RLFReportInformation-ExtIEs',
        u'SecurityContext-ExtIEs',
        u'SecondaryRATDataUsageReportItemIEs',
        u'SecondaryRATDataUsageReportItem-ExtIEs',
        u'SONInformation-ExtensionIE',
        u'SONInformationReply-ExtIEs',
        u'SONConfigurationTransfer-ExtIEs',
        u'SynchronisationInformation-ExtIEs',
        u'SourceeNB-ID-ExtIEs',
        u'SourceNodeID-ExtensionIE',
        u'SourceeNB-ToTargeteNB-TransparentContainer-ExtIEs',
        u'SourceNgRanNode-ID-ExtIEs',
        u'ServedGUMMEIsItem-ExtIEs',
        u'Subscription-Based-UE-DifferentiationInfo-ExtIEs',
        u'ScheduledCommunicationTime-ExtIEs',
        u'SupportedTAs-Item-ExtIEs',
        u'TimeSynchronisationInfo-ExtIEs',
        u'S-TMSI-ExtIEs',
        u'TAIBasedMDT-ExtIEs',
        u'TAI-ExtIEs',
        u'TAI-Broadcast-Item-ExtIEs',
        u'TAI-Cancelled-Item-ExtIEs',
        u'TABasedMDT-ExtIEs',
        u'TABasedQMC-ExtIEs',
        u'TAIBasedQMC-ExtIEs',
        u'CompletedCellinTAI-Item-ExtIEs',
        u'TargeteNB-ID-ExtIEs',
        u'TargetRNC-ID-ExtIEs',
        u'TargetNgRanNode-ID-ExtIEs',
        u'GNB-ExtIEs',
        u'Global-GNB-ID-ExtIEs',
        u'NG-eNB-ExtIEs',
        u'TargeteNB-ToSourceeNB-TransparentContainer-ExtIEs',
        u'M1ThresholdEventA2-ExtIEs',
        u'TraceActivation-ExtIEs',
        u'Tunnel-Information-ExtIEs',
        u'UEAggregate-MaximumBitrates-ExtIEs',
        u'UEAppLayerMeasConfig-ExtIEs',
        u'UE-S1AP-ID-pair-ExtIEs',
        u'UE-associatedLogicalS1-ConnectionItemExtIEs',
        u'UESecurityCapabilities-ExtIEs',
        u'UE-Sidelink-Aggregate-MaximumBitrates-ExtIEs',
        u'UL-CP-SecurityInformation-ExtIEs',
        u'UserLocationInformation-ExtIEs',
        u'V2XServicesAuthorized-ExtIEs',
        u'WLANMeasurementConfiguration-ExtIEs',
        u'WUS-Assistance-Information-ExtIEs',
        u'X2TNLConfigurationInfo-ExtIEs',
        u'ENBX2ExtTLA-ExtIEs',
        ]
    _param_ = [
        ]
    
    #-----< Additional-GUTI >-----#
    Additional_GUTI = SEQ(name=u'Additional-GUTI', mode=MODE_TYPE)
    _Additional_GUTI_gUMMEI = SEQ(name=u'gUMMEI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GUMMEI')))
    _Additional_GUTI_m_TMSI = OCT_STR(name=u'm-TMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M-TMSI')))
    _Additional_GUTI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_GUTI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___Additional_GUTI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_GUTI_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Additional_GUTI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_GUTI_iE_Extensions__item__id._const_tab = ____Additional_GUTI_iE_Extensions__item__id_tab
    ___Additional_GUTI_iE_Extensions__item__id._const_tab_at = None
    ___Additional_GUTI_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_GUTI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_GUTI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Additional_GUTI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_GUTI_iE_Extensions__item__criticality._const_tab = ____Additional_GUTI_iE_Extensions__item__criticality_tab
    ___Additional_GUTI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_GUTI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_GUTI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_GUTI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Additional_GUTI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_GUTI_iE_Extensions__item__extensionValue._const_tab = ____Additional_GUTI_iE_Extensions__item__extensionValue_tab
    ___Additional_GUTI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_GUTI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_GUTI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_GUTI_iE_Extensions__item__id),
        (u'criticality', ___Additional_GUTI_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_GUTI_iE_Extensions__item__extensionValue),
        ])
    __Additional_GUTI_iE_Extensions__item_._ext = None
    _Additional_GUTI_iE_Extensions._cont = __Additional_GUTI_iE_Extensions__item_
    _Additional_GUTI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_GUTI._cont = ASN1Dict([
        (u'gUMMEI', _Additional_GUTI_gUMMEI),
        (u'm-TMSI', _Additional_GUTI_m_TMSI),
        (u'iE-Extensions', _Additional_GUTI_iE_Extensions),
        ])
    Additional_GUTI._ext = []
    
    #-----< Additional-GUTI-ExtIEs >-----#
    Additional_GUTI_ExtIEs = CLASS(name=u'Additional-GUTI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    Additional_GUTI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdditionalRRMPriorityIndex >-----#
    AdditionalRRMPriorityIndex = BIT_STR(name=u'AdditionalRRMPriorityIndex', mode=MODE_TYPE)
    AdditionalRRMPriorityIndex._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< AerialUEsubscriptionInformation >-----#
    AerialUEsubscriptionInformation = ENUM(name=u'AerialUEsubscriptionInformation', mode=MODE_TYPE)
    AerialUEsubscriptionInformation._cont = ASN1Dict([(u'allowed', 0), (u'not-allowed', 1)])
    AerialUEsubscriptionInformation._ext = []
    
    #-----< AreaScopeOfMDT >-----#
    AreaScopeOfMDT = CHOICE(name=u'AreaScopeOfMDT', mode=MODE_TYPE)
    _AreaScopeOfMDT_cellBased = SEQ(name=u'cellBased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CellBasedMDT')))
    _AreaScopeOfMDT_tABased = SEQ(name=u'tABased', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TABasedMDT')))
    _AreaScopeOfMDT_pLMNWide = NULL(name=u'pLMNWide', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AreaScopeOfMDT_tAIBased = SEQ(name=u'tAIBased', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAIBasedMDT')))
    AreaScopeOfMDT._cont = ASN1Dict([
        (u'cellBased', _AreaScopeOfMDT_cellBased),
        (u'tABased', _AreaScopeOfMDT_tABased),
        (u'pLMNWide', _AreaScopeOfMDT_pLMNWide),
        (u'tAIBased', _AreaScopeOfMDT_tAIBased),
        ])
    AreaScopeOfMDT._ext = [u'tAIBased']
    
    #-----< AreaScopeOfQMC >-----#
    AreaScopeOfQMC = CHOICE(name=u'AreaScopeOfQMC', mode=MODE_TYPE)
    _AreaScopeOfQMC_cellBased = SEQ(name=u'cellBased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CellBasedQMC')))
    _AreaScopeOfQMC_tABased = SEQ(name=u'tABased', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TABasedQMC')))
    _AreaScopeOfQMC_tAIBased = SEQ(name=u'tAIBased', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAIBasedQMC')))
    _AreaScopeOfQMC_pLMNAreaBased = SEQ(name=u'pLMNAreaBased', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNAreaBasedQMC')))
    AreaScopeOfQMC._cont = ASN1Dict([
        (u'cellBased', _AreaScopeOfQMC_cellBased),
        (u'tABased', _AreaScopeOfQMC_tABased),
        (u'tAIBased', _AreaScopeOfQMC_tAIBased),
        (u'pLMNAreaBased', _AreaScopeOfQMC_pLMNAreaBased),
        ])
    AreaScopeOfQMC._ext = []
    
    #-----< AllocationAndRetentionPriority >-----#
    AllocationAndRetentionPriority = SEQ(name=u'AllocationAndRetentionPriority', mode=MODE_TYPE)
    _AllocationAndRetentionPriority_priorityLevel = INT(name=u'priorityLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PriorityLevel')))
    _AllocationAndRetentionPriority_pre_emptionCapability = ENUM(name=u'pre-emptionCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Pre-emptionCapability')))
    _AllocationAndRetentionPriority_pre_emptionVulnerability = ENUM(name=u'pre-emptionVulnerability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Pre-emptionVulnerability')))
    _AllocationAndRetentionPriority_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AllocationAndRetentionPriority_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___AllocationAndRetentionPriority_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_at = None
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_id = u'id'
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AllocationAndRetentionPriority_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AllocationAndRetentionPriority_iE_Extensions__item__id),
        (u'criticality', ___AllocationAndRetentionPriority_iE_Extensions__item__criticality),
        (u'extensionValue', ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue),
        ])
    __AllocationAndRetentionPriority_iE_Extensions__item_._ext = None
    _AllocationAndRetentionPriority_iE_Extensions._cont = __AllocationAndRetentionPriority_iE_Extensions__item_
    _AllocationAndRetentionPriority_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AllocationAndRetentionPriority._cont = ASN1Dict([
        (u'priorityLevel', _AllocationAndRetentionPriority_priorityLevel),
        (u'pre-emptionCapability', _AllocationAndRetentionPriority_pre_emptionCapability),
        (u'pre-emptionVulnerability', _AllocationAndRetentionPriority_pre_emptionVulnerability),
        (u'iE-Extensions', _AllocationAndRetentionPriority_iE_Extensions),
        ])
    AllocationAndRetentionPriority._ext = []
    
    #-----< AllocationAndRetentionPriority-ExtIEs >-----#
    AllocationAndRetentionPriority_ExtIEs = CLASS(name=u'AllocationAndRetentionPriority-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    AllocationAndRetentionPriority_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AssistanceDataForCECapableUEs >-----#
    AssistanceDataForCECapableUEs = SEQ(name=u'AssistanceDataForCECapableUEs', mode=MODE_TYPE)
    _AssistanceDataForCECapableUEs_cellIdentifierAndCELevelForCECapableUEs = SEQ(name=u'cellIdentifierAndCELevelForCECapableUEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CellIdentifierAndCELevelForCECapableUEs')))
    _AssistanceDataForCECapableUEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AssistanceDataForCECapableUEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____AssistanceDataForCECapableUEs_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForCECapableUEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__id._const_tab = ____AssistanceDataForCECapableUEs_iE_Extensions__item__id_tab
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__id._const_tab_at = None
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AssistanceDataForCECapableUEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForCECapableUEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__criticality._const_tab = ____AssistanceDataForCECapableUEs_iE_Extensions__item__criticality_tab
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AssistanceDataForCECapableUEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForCECapableUEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__extensionValue._const_tab = ____AssistanceDataForCECapableUEs_iE_Extensions__item__extensionValue_tab
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AssistanceDataForCECapableUEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AssistanceDataForCECapableUEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AssistanceDataForCECapableUEs_iE_Extensions__item__id),
        (u'criticality', ___AssistanceDataForCECapableUEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___AssistanceDataForCECapableUEs_iE_Extensions__item__extensionValue),
        ])
    __AssistanceDataForCECapableUEs_iE_Extensions__item_._ext = None
    _AssistanceDataForCECapableUEs_iE_Extensions._cont = __AssistanceDataForCECapableUEs_iE_Extensions__item_
    _AssistanceDataForCECapableUEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AssistanceDataForCECapableUEs._cont = ASN1Dict([
        (u'cellIdentifierAndCELevelForCECapableUEs', _AssistanceDataForCECapableUEs_cellIdentifierAndCELevelForCECapableUEs),
        (u'iE-Extensions', _AssistanceDataForCECapableUEs_iE_Extensions),
        ])
    AssistanceDataForCECapableUEs._ext = []
    
    #-----< InformationForCECapableUEs-ExtIEs >-----#
    InformationForCECapableUEs_ExtIEs = CLASS(name=u'InformationForCECapableUEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    InformationForCECapableUEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AssistanceDataForPaging >-----#
    AssistanceDataForPaging = SEQ(name=u'AssistanceDataForPaging', mode=MODE_TYPE)
    _AssistanceDataForPaging_assistanceDataForRecommendedCells = SEQ(name=u'assistanceDataForRecommendedCells', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'AssistanceDataForRecommendedCells')), opt=True)
    _AssistanceDataForPaging_assistanceDataForCECapableUEs = SEQ(name=u'assistanceDataForCECapableUEs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'AssistanceDataForCECapableUEs')), opt=True)
    _AssistanceDataForPaging_pagingAttemptInformation = SEQ(name=u'pagingAttemptInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PagingAttemptInformation')), opt=True)
    _AssistanceDataForPaging_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AssistanceDataForPaging_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___AssistanceDataForPaging_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____AssistanceDataForPaging_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForPaging_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForPaging_iE_Extensions__item__id._const_tab = ____AssistanceDataForPaging_iE_Extensions__item__id_tab
    ___AssistanceDataForPaging_iE_Extensions__item__id._const_tab_at = None
    ___AssistanceDataForPaging_iE_Extensions__item__id._const_tab_id = u'id'
    ___AssistanceDataForPaging_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AssistanceDataForPaging_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForPaging_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForPaging_iE_Extensions__item__criticality._const_tab = ____AssistanceDataForPaging_iE_Extensions__item__criticality_tab
    ___AssistanceDataForPaging_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AssistanceDataForPaging_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AssistanceDataForPaging_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AssistanceDataForPaging_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForPaging_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForPaging_iE_Extensions__item__extensionValue._const_tab = ____AssistanceDataForPaging_iE_Extensions__item__extensionValue_tab
    ___AssistanceDataForPaging_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AssistanceDataForPaging_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AssistanceDataForPaging_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AssistanceDataForPaging_iE_Extensions__item__id),
        (u'criticality', ___AssistanceDataForPaging_iE_Extensions__item__criticality),
        (u'extensionValue', ___AssistanceDataForPaging_iE_Extensions__item__extensionValue),
        ])
    __AssistanceDataForPaging_iE_Extensions__item_._ext = None
    _AssistanceDataForPaging_iE_Extensions._cont = __AssistanceDataForPaging_iE_Extensions__item_
    _AssistanceDataForPaging_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AssistanceDataForPaging._cont = ASN1Dict([
        (u'assistanceDataForRecommendedCells', _AssistanceDataForPaging_assistanceDataForRecommendedCells),
        (u'assistanceDataForCECapableUEs', _AssistanceDataForPaging_assistanceDataForCECapableUEs),
        (u'pagingAttemptInformation', _AssistanceDataForPaging_pagingAttemptInformation),
        (u'iE-Extensions', _AssistanceDataForPaging_iE_Extensions),
        ])
    AssistanceDataForPaging._ext = []
    
    #-----< AssistanceDataForPaging-ExtIEs >-----#
    AssistanceDataForPaging_ExtIEs = CLASS(name=u'AssistanceDataForPaging-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    AssistanceDataForPaging_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AssistanceDataForRecommendedCells >-----#
    AssistanceDataForRecommendedCells = SEQ(name=u'AssistanceDataForRecommendedCells', mode=MODE_TYPE)
    _AssistanceDataForRecommendedCells_recommendedCellsForPaging = SEQ(name=u'recommendedCellsForPaging', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RecommendedCellsForPaging')))
    _AssistanceDataForRecommendedCells_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AssistanceDataForRecommendedCells_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__id._const_tab = ____AssistanceDataForRecommendedCells_iE_Extensions__item__id_tab
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__id._const_tab_at = None
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__id._const_tab_id = u'id'
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality._const_tab = ____AssistanceDataForRecommendedCells_iE_Extensions__item__criticality_tab
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue._const_tab = ____AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue_tab
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AssistanceDataForRecommendedCells_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AssistanceDataForRecommendedCells_iE_Extensions__item__id),
        (u'criticality', ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality),
        (u'extensionValue', ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue),
        ])
    __AssistanceDataForRecommendedCells_iE_Extensions__item_._ext = None
    _AssistanceDataForRecommendedCells_iE_Extensions._cont = __AssistanceDataForRecommendedCells_iE_Extensions__item_
    _AssistanceDataForRecommendedCells_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AssistanceDataForRecommendedCells._cont = ASN1Dict([
        (u'recommendedCellsForPaging', _AssistanceDataForRecommendedCells_recommendedCellsForPaging),
        (u'iE-Extensions', _AssistanceDataForRecommendedCells_iE_Extensions),
        ])
    AssistanceDataForRecommendedCells._ext = []
    
    #-----< AssistanceDataForRecommendedCells-ExtIEs >-----#
    AssistanceDataForRecommendedCells_ExtIEs = CLASS(name=u'AssistanceDataForRecommendedCells-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    AssistanceDataForRecommendedCells_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Bearers-SubjectToStatusTransferList >-----#
    Bearers_SubjectToStatusTransferList = SEQ_OF(name=u'Bearers-SubjectToStatusTransferList', mode=MODE_TYPE)
    _Bearers_SubjectToStatusTransferList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Bearers_SubjectToStatusTransferList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___Bearers_SubjectToStatusTransferList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____Bearers_SubjectToStatusTransferList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Bearers-SubjectToStatusTransfer-Item')))
    ___Bearers_SubjectToStatusTransferList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 89), (u'criticality', u'ignore'), (u'Value', ____Bearers_SubjectToStatusTransferList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Bearers_SubjectToStatusTransferList__item__id._const_tab = ___Bearers_SubjectToStatusTransferList__item__id_tab
    __Bearers_SubjectToStatusTransferList__item__id._const_tab_at = None
    __Bearers_SubjectToStatusTransferList__item__id._const_tab_id = u'id'
    __Bearers_SubjectToStatusTransferList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __Bearers_SubjectToStatusTransferList__item__criticality._const_tab = ___Bearers_SubjectToStatusTransferList__item__id_tab
    __Bearers_SubjectToStatusTransferList__item__criticality._const_tab_at = ('..', u'id')
    __Bearers_SubjectToStatusTransferList__item__criticality._const_tab_id = u'criticality'
    __Bearers_SubjectToStatusTransferList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __Bearers_SubjectToStatusTransferList__item__value._const_tab = ___Bearers_SubjectToStatusTransferList__item__id_tab
    __Bearers_SubjectToStatusTransferList__item__value._const_tab_at = ('..', u'id')
    __Bearers_SubjectToStatusTransferList__item__value._const_tab_id = u'Value'
    _Bearers_SubjectToStatusTransferList__item_._cont = ASN1Dict([
        (u'id', __Bearers_SubjectToStatusTransferList__item__id),
        (u'criticality', __Bearers_SubjectToStatusTransferList__item__criticality),
        (u'value', __Bearers_SubjectToStatusTransferList__item__value),
        ])
    _Bearers_SubjectToStatusTransferList__item_._ext = None
    Bearers_SubjectToStatusTransferList._cont = _Bearers_SubjectToStatusTransferList__item_
    Bearers_SubjectToStatusTransferList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Bearers-SubjectToStatusTransfer-ItemIEs >-----#
    Bearers_SubjectToStatusTransfer_ItemIEs = CLASS(name=u'Bearers-SubjectToStatusTransfer-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _Bearers_SubjectToStatusTransfer_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Bearers-SubjectToStatusTransfer-Item')))
    Bearers_SubjectToStatusTransfer_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 89), (u'criticality', u'ignore'), (u'Value', _Bearers_SubjectToStatusTransfer_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Bearers-SubjectToStatusTransfer-Item >-----#
    Bearers_SubjectToStatusTransfer_Item = SEQ(name=u'Bearers-SubjectToStatusTransfer-Item', mode=MODE_TYPE)
    _Bearers_SubjectToStatusTransfer_Item_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _Bearers_SubjectToStatusTransfer_Item_uL_COUNTvalue = SEQ(name=u'uL-COUNTvalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'COUNTvalue')))
    _Bearers_SubjectToStatusTransfer_Item_dL_COUNTvalue = SEQ(name=u'dL-COUNTvalue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'COUNTvalue')))
    _Bearers_SubjectToStatusTransfer_Item_receiveStatusofULPDCPSDUs = BIT_STR(name=u'receiveStatusofULPDCPSDUs', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ReceiveStatusofULPDCPSDUs')), opt=True)
    _Bearers_SubjectToStatusTransfer_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'COUNTValueExtended')))
    _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'COUNTValueExtended')))
    _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ReceiveStatusOfULPDCPSDUsExtended')))
    _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'COUNTvaluePDCP-SNlength18')))
    _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'COUNTvaluePDCP-SNlength18')))
    _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_5 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ReceiveStatusOfULPDCPSDUsPDCP-SNlength18')))
    ____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 179), (u'criticality', u'ignore'), (u'Extension', _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 180), (u'criticality', u'ignore'), (u'Extension', _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 181), (u'criticality', u'ignore'), (u'Extension', _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 217), (u'criticality', u'ignore'), (u'Extension', _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 218), (u'criticality', u'ignore'), (u'Extension', _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 219), (u'criticality', u'ignore'), (u'Extension', _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id._const_tab = ____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id._const_tab_at = None
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality._const_tab = ____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue._const_tab = ____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id),
        (u'criticality', ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue),
        ])
    __Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item_._ext = None
    _Bearers_SubjectToStatusTransfer_Item_iE_Extensions._cont = __Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item_
    _Bearers_SubjectToStatusTransfer_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Bearers_SubjectToStatusTransfer_Item._cont = ASN1Dict([
        (u'e-RAB-ID', _Bearers_SubjectToStatusTransfer_Item_e_RAB_ID),
        (u'uL-COUNTvalue', _Bearers_SubjectToStatusTransfer_Item_uL_COUNTvalue),
        (u'dL-COUNTvalue', _Bearers_SubjectToStatusTransfer_Item_dL_COUNTvalue),
        (u'receiveStatusofULPDCPSDUs', _Bearers_SubjectToStatusTransfer_Item_receiveStatusofULPDCPSDUs),
        (u'iE-Extensions', _Bearers_SubjectToStatusTransfer_Item_iE_Extensions),
        ])
    Bearers_SubjectToStatusTransfer_Item._ext = []
    
    #-----< Bearers-SubjectToStatusTransfer-ItemExtIEs >-----#
    Bearers_SubjectToStatusTransfer_ItemExtIEs = CLASS(name=u'Bearers-SubjectToStatusTransfer-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'COUNTValueExtended')))
    _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'COUNTValueExtended')))
    _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ReceiveStatusOfULPDCPSDUsExtended')))
    _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'COUNTvaluePDCP-SNlength18')))
    _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'COUNTvaluePDCP-SNlength18')))
    _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_5 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ReceiveStatusOfULPDCPSDUsPDCP-SNlength18')))
    Bearers_SubjectToStatusTransfer_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 179), (u'criticality', u'ignore'), (u'Extension', _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 180), (u'criticality', u'ignore'), (u'Extension', _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 181), (u'criticality', u'ignore'), (u'Extension', _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 217), (u'criticality', u'ignore'), (u'Extension', _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 218), (u'criticality', u'ignore'), (u'Extension', _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 219), (u'criticality', u'ignore'), (u'Extension', _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Bearers-SubjectToEarlyStatusTransferList >-----#
    Bearers_SubjectToEarlyStatusTransferList = SEQ_OF(name=u'Bearers-SubjectToEarlyStatusTransferList', mode=MODE_TYPE)
    _Bearers_SubjectToEarlyStatusTransferList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __Bearers_SubjectToEarlyStatusTransferList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___Bearers_SubjectToEarlyStatusTransferList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____Bearers_SubjectToEarlyStatusTransferList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Bearers-SubjectToEarlyStatusTransfer-Item')))
    ___Bearers_SubjectToEarlyStatusTransferList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 322), (u'criticality', u'ignore'), (u'Value', ____Bearers_SubjectToEarlyStatusTransferList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Bearers_SubjectToEarlyStatusTransferList__item__id._const_tab = ___Bearers_SubjectToEarlyStatusTransferList__item__id_tab
    __Bearers_SubjectToEarlyStatusTransferList__item__id._const_tab_at = None
    __Bearers_SubjectToEarlyStatusTransferList__item__id._const_tab_id = u'id'
    __Bearers_SubjectToEarlyStatusTransferList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __Bearers_SubjectToEarlyStatusTransferList__item__criticality._const_tab = ___Bearers_SubjectToEarlyStatusTransferList__item__id_tab
    __Bearers_SubjectToEarlyStatusTransferList__item__criticality._const_tab_at = ('..', u'id')
    __Bearers_SubjectToEarlyStatusTransferList__item__criticality._const_tab_id = u'criticality'
    __Bearers_SubjectToEarlyStatusTransferList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __Bearers_SubjectToEarlyStatusTransferList__item__value._const_tab = ___Bearers_SubjectToEarlyStatusTransferList__item__id_tab
    __Bearers_SubjectToEarlyStatusTransferList__item__value._const_tab_at = ('..', u'id')
    __Bearers_SubjectToEarlyStatusTransferList__item__value._const_tab_id = u'Value'
    _Bearers_SubjectToEarlyStatusTransferList__item_._cont = ASN1Dict([
        (u'id', __Bearers_SubjectToEarlyStatusTransferList__item__id),
        (u'criticality', __Bearers_SubjectToEarlyStatusTransferList__item__criticality),
        (u'value', __Bearers_SubjectToEarlyStatusTransferList__item__value),
        ])
    _Bearers_SubjectToEarlyStatusTransferList__item_._ext = None
    Bearers_SubjectToEarlyStatusTransferList._cont = _Bearers_SubjectToEarlyStatusTransferList__item_
    Bearers_SubjectToEarlyStatusTransferList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Bearers-SubjectToEarlyStatusTransfer-ItemIEs >-----#
    Bearers_SubjectToEarlyStatusTransfer_ItemIEs = CLASS(name=u'Bearers-SubjectToEarlyStatusTransfer-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _Bearers_SubjectToEarlyStatusTransfer_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Bearers-SubjectToEarlyStatusTransfer-Item')))
    Bearers_SubjectToEarlyStatusTransfer_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 322), (u'criticality', u'ignore'), (u'Value', _Bearers_SubjectToEarlyStatusTransfer_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Bearers-SubjectToEarlyStatusTransfer-Item >-----#
    Bearers_SubjectToEarlyStatusTransfer_Item = SEQ(name=u'Bearers-SubjectToEarlyStatusTransfer-Item', mode=MODE_TYPE)
    _Bearers_SubjectToEarlyStatusTransfer_Item_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _Bearers_SubjectToEarlyStatusTransfer_Item_dLCOUNT_PDCP_SNlength = CHOICE(name=u'dLCOUNT-PDCP-SNlength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'DLCOUNT-PDCP-SNlength')))
    _Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__id._const_tab = ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__id_tab
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__id._const_tab_at = None
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__criticality._const_tab = ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__criticality_tab
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__extensionValue._const_tab = ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__extensionValue_tab
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__id),
        (u'criticality', ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__extensionValue),
        ])
    __Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item_._ext = None
    _Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions._cont = __Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item_
    _Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Bearers_SubjectToEarlyStatusTransfer_Item._cont = ASN1Dict([
        (u'e-RAB-ID', _Bearers_SubjectToEarlyStatusTransfer_Item_e_RAB_ID),
        (u'dLCOUNT-PDCP-SNlength', _Bearers_SubjectToEarlyStatusTransfer_Item_dLCOUNT_PDCP_SNlength),
        (u'iE-Extensions', _Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions),
        ])
    Bearers_SubjectToEarlyStatusTransfer_Item._ext = []
    
    #-----< Bearers-SubjectToEarlyStatusTransfer-ItemExtIEs >-----#
    Bearers_SubjectToEarlyStatusTransfer_ItemExtIEs = CLASS(name=u'Bearers-SubjectToEarlyStatusTransfer-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    Bearers_SubjectToEarlyStatusTransfer_ItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BearerType >-----#
    BearerType = ENUM(name=u'BearerType', mode=MODE_TYPE)
    BearerType._cont = ASN1Dict([(u'non-IP', 0)])
    BearerType._ext = []
    
    #-----< BitRate >-----#
    BitRate = INT(name=u'BitRate', mode=MODE_TYPE)
    BitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10000000000)], ev=None, er=[])
    
    #-----< BluetoothMeasurementConfiguration >-----#
    BluetoothMeasurementConfiguration = SEQ(name=u'BluetoothMeasurementConfiguration', mode=MODE_TYPE)
    _BluetoothMeasurementConfiguration_bluetoothMeasConfig = ENUM(name=u'bluetoothMeasConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BluetoothMeasConfig')))
    _BluetoothMeasurementConfiguration_bluetoothMeasConfigNameList = SEQ_OF(name=u'bluetoothMeasConfigNameList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BluetoothMeasConfigNameList')), opt=True)
    _BluetoothMeasurementConfiguration_bt_rssi = ENUM(name=u'bt-rssi', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BluetoothMeasurementConfiguration_bt_rssi._cont = ASN1Dict([(u'true', 0)])
    _BluetoothMeasurementConfiguration_bt_rssi._ext = []
    _BluetoothMeasurementConfiguration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BluetoothMeasurementConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__id._const_tab = ____BluetoothMeasurementConfiguration_iE_Extensions__item__id_tab
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__id._const_tab_id = u'id'
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality._const_tab = ____BluetoothMeasurementConfiguration_iE_Extensions__item__criticality_tab
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab = ____BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue_tab
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BluetoothMeasurementConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BluetoothMeasurementConfiguration_iE_Extensions__item__id),
        (u'criticality', ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality),
        (u'extensionValue', ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue),
        ])
    __BluetoothMeasurementConfiguration_iE_Extensions__item_._ext = None
    _BluetoothMeasurementConfiguration_iE_Extensions._cont = __BluetoothMeasurementConfiguration_iE_Extensions__item_
    _BluetoothMeasurementConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BluetoothMeasurementConfiguration._cont = ASN1Dict([
        (u'bluetoothMeasConfig', _BluetoothMeasurementConfiguration_bluetoothMeasConfig),
        (u'bluetoothMeasConfigNameList', _BluetoothMeasurementConfiguration_bluetoothMeasConfigNameList),
        (u'bt-rssi', _BluetoothMeasurementConfiguration_bt_rssi),
        (u'iE-Extensions', _BluetoothMeasurementConfiguration_iE_Extensions),
        ])
    BluetoothMeasurementConfiguration._ext = []
    
    #-----< BluetoothMeasurementConfiguration-ExtIEs >-----#
    BluetoothMeasurementConfiguration_ExtIEs = CLASS(name=u'BluetoothMeasurementConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    BluetoothMeasurementConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BluetoothMeasConfigNameList >-----#
    BluetoothMeasConfigNameList = SEQ_OF(name=u'BluetoothMeasConfigNameList', mode=MODE_TYPE)
    _BluetoothMeasConfigNameList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BluetoothName')))
    BluetoothMeasConfigNameList._cont = _BluetoothMeasConfigNameList__item_
    BluetoothMeasConfigNameList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< BluetoothMeasConfig >-----#
    BluetoothMeasConfig = ENUM(name=u'BluetoothMeasConfig', mode=MODE_TYPE)
    BluetoothMeasConfig._cont = ASN1Dict([(u'setup', 0)])
    BluetoothMeasConfig._ext = []
    
    #-----< BluetoothName >-----#
    BluetoothName = OCT_STR(name=u'BluetoothName', mode=MODE_TYPE)
    BluetoothName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=248)], ev=None, er=[])
    
    #-----< BPLMNs >-----#
    BPLMNs = SEQ_OF(name=u'BPLMNs', mode=MODE_TYPE)
    _BPLMNs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    BPLMNs._cont = _BPLMNs__item_
    BPLMNs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< BroadcastCancelledAreaList >-----#
    BroadcastCancelledAreaList = CHOICE(name=u'BroadcastCancelledAreaList', mode=MODE_TYPE)
    _BroadcastCancelledAreaList_cellID_Cancelled = SEQ_OF(name=u'cellID-Cancelled', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CellID-Cancelled')))
    _BroadcastCancelledAreaList_tAI_Cancelled = SEQ_OF(name=u'tAI-Cancelled', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI-Cancelled')))
    _BroadcastCancelledAreaList_emergencyAreaID_Cancelled = SEQ_OF(name=u'emergencyAreaID-Cancelled', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaID-Cancelled')))
    BroadcastCancelledAreaList._cont = ASN1Dict([
        (u'cellID-Cancelled', _BroadcastCancelledAreaList_cellID_Cancelled),
        (u'tAI-Cancelled', _BroadcastCancelledAreaList_tAI_Cancelled),
        (u'emergencyAreaID-Cancelled', _BroadcastCancelledAreaList_emergencyAreaID_Cancelled),
        ])
    BroadcastCancelledAreaList._ext = []
    
    #-----< BroadcastCompletedAreaList >-----#
    BroadcastCompletedAreaList = CHOICE(name=u'BroadcastCompletedAreaList', mode=MODE_TYPE)
    _BroadcastCompletedAreaList_cellID_Broadcast = SEQ_OF(name=u'cellID-Broadcast', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CellID-Broadcast')))
    _BroadcastCompletedAreaList_tAI_Broadcast = SEQ_OF(name=u'tAI-Broadcast', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI-Broadcast')))
    _BroadcastCompletedAreaList_emergencyAreaID_Broadcast = SEQ_OF(name=u'emergencyAreaID-Broadcast', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaID-Broadcast')))
    BroadcastCompletedAreaList._cont = ASN1Dict([
        (u'cellID-Broadcast', _BroadcastCompletedAreaList_cellID_Broadcast),
        (u'tAI-Broadcast', _BroadcastCompletedAreaList_tAI_Broadcast),
        (u'emergencyAreaID-Broadcast', _BroadcastCompletedAreaList_emergencyAreaID_Broadcast),
        ])
    BroadcastCompletedAreaList._ext = []
    
    #-----< CancelledCellinEAI >-----#
    CancelledCellinEAI = SEQ_OF(name=u'CancelledCellinEAI', mode=MODE_TYPE)
    _CancelledCellinEAI__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CancelledCellinEAI-Item')))
    CancelledCellinEAI._cont = _CancelledCellinEAI__item_
    CancelledCellinEAI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CancelledCellinEAI-Item >-----#
    CancelledCellinEAI_Item = SEQ(name=u'CancelledCellinEAI-Item', mode=MODE_TYPE)
    _CancelledCellinEAI_Item_eCGI = SEQ(name=u'eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _CancelledCellinEAI_Item_numberOfBroadcasts = INT(name=u'numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NumberOfBroadcasts')))
    _CancelledCellinEAI_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CancelledCellinEAI_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CancelledCellinEAI_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CancelledCellinEAI_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CancelledCellinEAI_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellinEAI_Item_iE_Extensions__item__id._const_tab = ____CancelledCellinEAI_Item_iE_Extensions__item__id_tab
    ___CancelledCellinEAI_Item_iE_Extensions__item__id._const_tab_at = None
    ___CancelledCellinEAI_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CancelledCellinEAI_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CancelledCellinEAI_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CancelledCellinEAI_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellinEAI_Item_iE_Extensions__item__criticality._const_tab = ____CancelledCellinEAI_Item_iE_Extensions__item__criticality_tab
    ___CancelledCellinEAI_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CancelledCellinEAI_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CancelledCellinEAI_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CancelledCellinEAI_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CancelledCellinEAI_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellinEAI_Item_iE_Extensions__item__extensionValue._const_tab = ____CancelledCellinEAI_Item_iE_Extensions__item__extensionValue_tab
    ___CancelledCellinEAI_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CancelledCellinEAI_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CancelledCellinEAI_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CancelledCellinEAI_Item_iE_Extensions__item__id),
        (u'criticality', ___CancelledCellinEAI_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CancelledCellinEAI_Item_iE_Extensions__item__extensionValue),
        ])
    __CancelledCellinEAI_Item_iE_Extensions__item_._ext = None
    _CancelledCellinEAI_Item_iE_Extensions._cont = __CancelledCellinEAI_Item_iE_Extensions__item_
    _CancelledCellinEAI_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CancelledCellinEAI_Item._cont = ASN1Dict([
        (u'eCGI', _CancelledCellinEAI_Item_eCGI),
        (u'numberOfBroadcasts', _CancelledCellinEAI_Item_numberOfBroadcasts),
        (u'iE-Extensions', _CancelledCellinEAI_Item_iE_Extensions),
        ])
    CancelledCellinEAI_Item._ext = []
    
    #-----< CancelledCellinEAI-Item-ExtIEs >-----#
    CancelledCellinEAI_Item_ExtIEs = CLASS(name=u'CancelledCellinEAI-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CancelledCellinEAI_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CancelledCellinTAI >-----#
    CancelledCellinTAI = SEQ_OF(name=u'CancelledCellinTAI', mode=MODE_TYPE)
    _CancelledCellinTAI__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CancelledCellinTAI-Item')))
    CancelledCellinTAI._cont = _CancelledCellinTAI__item_
    CancelledCellinTAI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CancelledCellinTAI-Item >-----#
    CancelledCellinTAI_Item = SEQ(name=u'CancelledCellinTAI-Item', mode=MODE_TYPE)
    _CancelledCellinTAI_Item_eCGI = SEQ(name=u'eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _CancelledCellinTAI_Item_numberOfBroadcasts = INT(name=u'numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NumberOfBroadcasts')))
    _CancelledCellinTAI_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CancelledCellinTAI_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CancelledCellinTAI_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CancelledCellinTAI_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CancelledCellinTAI_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellinTAI_Item_iE_Extensions__item__id._const_tab = ____CancelledCellinTAI_Item_iE_Extensions__item__id_tab
    ___CancelledCellinTAI_Item_iE_Extensions__item__id._const_tab_at = None
    ___CancelledCellinTAI_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CancelledCellinTAI_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CancelledCellinTAI_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CancelledCellinTAI_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellinTAI_Item_iE_Extensions__item__criticality._const_tab = ____CancelledCellinTAI_Item_iE_Extensions__item__criticality_tab
    ___CancelledCellinTAI_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CancelledCellinTAI_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CancelledCellinTAI_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CancelledCellinTAI_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CancelledCellinTAI_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CancelledCellinTAI_Item_iE_Extensions__item__extensionValue._const_tab = ____CancelledCellinTAI_Item_iE_Extensions__item__extensionValue_tab
    ___CancelledCellinTAI_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CancelledCellinTAI_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CancelledCellinTAI_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CancelledCellinTAI_Item_iE_Extensions__item__id),
        (u'criticality', ___CancelledCellinTAI_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CancelledCellinTAI_Item_iE_Extensions__item__extensionValue),
        ])
    __CancelledCellinTAI_Item_iE_Extensions__item_._ext = None
    _CancelledCellinTAI_Item_iE_Extensions._cont = __CancelledCellinTAI_Item_iE_Extensions__item_
    _CancelledCellinTAI_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CancelledCellinTAI_Item._cont = ASN1Dict([
        (u'eCGI', _CancelledCellinTAI_Item_eCGI),
        (u'numberOfBroadcasts', _CancelledCellinTAI_Item_numberOfBroadcasts),
        (u'iE-Extensions', _CancelledCellinTAI_Item_iE_Extensions),
        ])
    CancelledCellinTAI_Item._ext = []
    
    #-----< CancelledCellinTAI-Item-ExtIEs >-----#
    CancelledCellinTAI_Item_ExtIEs = CLASS(name=u'CancelledCellinTAI-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CancelledCellinTAI_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cause >-----#
    Cause = CHOICE(name=u'Cause', mode=MODE_TYPE)
    _Cause_radioNetwork = ENUM(name=u'radioNetwork', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CauseRadioNetwork')))
    _Cause_transport = ENUM(name=u'transport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CauseTransport')))
    _Cause_nas = ENUM(name=u'nas', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CauseNas')))
    _Cause_protocol = ENUM(name=u'protocol', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CauseProtocol')))
    _Cause_misc = ENUM(name=u'misc', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CauseMisc')))
    Cause._cont = ASN1Dict([
        (u'radioNetwork', _Cause_radioNetwork),
        (u'transport', _Cause_transport),
        (u'nas', _Cause_nas),
        (u'protocol', _Cause_protocol),
        (u'misc', _Cause_misc),
        ])
    Cause._ext = []
    
    #-----< CauseMisc >-----#
    CauseMisc = ENUM(name=u'CauseMisc', mode=MODE_TYPE)
    CauseMisc._cont = ASN1Dict([(u'control-processing-overload', 0), (u'not-enough-user-plane-processing-resources', 1), (u'hardware-failure', 2), (u'om-intervention', 3), (u'unspecified', 4), (u'unknown-PLMN', 5)])
    CauseMisc._ext = []
    
    #-----< CauseProtocol >-----#
    CauseProtocol = ENUM(name=u'CauseProtocol', mode=MODE_TYPE)
    CauseProtocol._cont = ASN1Dict([(u'transfer-syntax-error', 0), (u'abstract-syntax-error-reject', 1), (u'abstract-syntax-error-ignore-and-notify', 2), (u'message-not-compatible-with-receiver-state', 3), (u'semantic-error', 4), (u'abstract-syntax-error-falsely-constructed-message', 5), (u'unspecified', 6)])
    CauseProtocol._ext = []
    
    #-----< CauseRadioNetwork >-----#
    CauseRadioNetwork = ENUM(name=u'CauseRadioNetwork', mode=MODE_TYPE)
    CauseRadioNetwork._cont = ASN1Dict([(u'unspecified', 0), (u'tx2relocoverall-expiry', 1), (u'successful-handover', 2), (u'release-due-to-eutran-generated-reason', 3), (u'handover-cancelled', 4), (u'partial-handover', 5), (u'ho-failure-in-target-EPC-eNB-or-target-system', 6), (u'ho-target-not-allowed', 7), (u'tS1relocoverall-expiry', 8), (u'tS1relocprep-expiry', 9), (u'cell-not-available', 10), (u'unknown-targetID', 11), (u'no-radio-resources-available-in-target-cell', 12), (u'unknown-mme-ue-s1ap-id', 13), (u'unknown-enb-ue-s1ap-id', 14), (u'unknown-pair-ue-s1ap-id', 15), (u'handover-desirable-for-radio-reason', 16), (u'time-critical-handover', 17), (u'resource-optimisation-handover', 18), (u'reduce-load-in-serving-cell', 19), (u'user-inactivity', 20), (u'radio-connection-with-ue-lost', 21), (u'load-balancing-tau-required', 22), (u'cs-fallback-triggered', 23), (u'ue-not-available-for-ps-service', 24), (u'radio-resources-not-available', 25), (u'failure-in-radio-interface-procedure', 26), (u'invalid-qos-combination', 27), (u'interrat-redirection', 28), (u'interaction-with-other-procedure', 29), (u'unknown-E-RAB-ID', 30), (u'multiple-E-RAB-ID-instances', 31), (u'encryption-and-or-integrity-protection-algorithms-not-supported', 32), (u's1-intra-system-handover-triggered', 33), (u's1-inter-system-handover-triggered', 34), (u'x2-handover-triggered', 35), (u'redirection-towards-1xRTT', 36), (u'not-supported-QCI-value', 37), (u'invalid-CSG-Id', 38), (u'release-due-to-pre-emption', 39), (u'n26-interface-not-available', 40), (u'insufficient-ue-capabilities', 41), (u'maximum-bearer-pre-emption-rate-exceeded', 42)])
    CauseRadioNetwork._ext = [u'redirection-towards-1xRTT', u'not-supported-QCI-value', u'invalid-CSG-Id', u'release-due-to-pre-emption', u'n26-interface-not-available', u'insufficient-ue-capabilities', u'maximum-bearer-pre-emption-rate-exceeded']
    
    #-----< CauseTransport >-----#
    CauseTransport = ENUM(name=u'CauseTransport', mode=MODE_TYPE)
    CauseTransport._cont = ASN1Dict([(u'transport-resource-unavailable', 0), (u'unspecified', 1)])
    CauseTransport._ext = []
    
    #-----< CauseNas >-----#
    CauseNas = ENUM(name=u'CauseNas', mode=MODE_TYPE)
    CauseNas._cont = ASN1Dict([(u'normal-release', 0), (u'authentication-failure', 1), (u'detach', 2), (u'unspecified', 3), (u'csg-subscription-expiry', 4)])
    CauseNas._ext = [u'csg-subscription-expiry']
    
    #-----< CellAccessMode >-----#
    CellAccessMode = ENUM(name=u'CellAccessMode', mode=MODE_TYPE)
    CellAccessMode._cont = ASN1Dict([(u'hybrid', 0)])
    CellAccessMode._ext = []
    
    #-----< CellIdentifierAndCELevelForCECapableUEs >-----#
    CellIdentifierAndCELevelForCECapableUEs = SEQ(name=u'CellIdentifierAndCELevelForCECapableUEs', mode=MODE_TYPE)
    _CellIdentifierAndCELevelForCECapableUEs_global_Cell_ID = SEQ(name=u'global-Cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _CellIdentifierAndCELevelForCECapableUEs_cELevel = OCT_STR(name=u'cELevel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CELevel')))
    _CellIdentifierAndCELevelForCECapableUEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__id._const_tab = ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__id_tab
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__id._const_tab_at = None
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__criticality._const_tab = ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__criticality_tab
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__extensionValue._const_tab = ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__extensionValue_tab
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__id),
        (u'criticality', ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__extensionValue),
        ])
    __CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item_._ext = None
    _CellIdentifierAndCELevelForCECapableUEs_iE_Extensions._cont = __CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item_
    _CellIdentifierAndCELevelForCECapableUEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellIdentifierAndCELevelForCECapableUEs._cont = ASN1Dict([
        (u'global-Cell-ID', _CellIdentifierAndCELevelForCECapableUEs_global_Cell_ID),
        (u'cELevel', _CellIdentifierAndCELevelForCECapableUEs_cELevel),
        (u'iE-Extensions', _CellIdentifierAndCELevelForCECapableUEs_iE_Extensions),
        ])
    CellIdentifierAndCELevelForCECapableUEs._ext = []
    
    #-----< CellIdentifierAndCELevelForCECapableUEs-ExtIEs >-----#
    CellIdentifierAndCELevelForCECapableUEs_ExtIEs = CLASS(name=u'CellIdentifierAndCELevelForCECapableUEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CellIdentifierAndCELevelForCECapableUEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CELevel >-----#
    CELevel = OCT_STR(name=u'CELevel', mode=MODE_TYPE)
    
    #-----< CE-mode-B-SupportIndicator >-----#
    CE_mode_B_SupportIndicator = ENUM(name=u'CE-mode-B-SupportIndicator', mode=MODE_TYPE)
    CE_mode_B_SupportIndicator._cont = ASN1Dict([(u'supported', 0)])
    CE_mode_B_SupportIndicator._ext = []
    
    #-----< CellIdentity >-----#
    CellIdentity = BIT_STR(name=u'CellIdentity', mode=MODE_TYPE)
    CellIdentity._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    
    #-----< CellID-Broadcast >-----#
    CellID_Broadcast = SEQ_OF(name=u'CellID-Broadcast', mode=MODE_TYPE)
    _CellID_Broadcast__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellID-Broadcast-Item')))
    CellID_Broadcast._cont = _CellID_Broadcast__item_
    CellID_Broadcast._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CellID-Broadcast-Item >-----#
    CellID_Broadcast_Item = SEQ(name=u'CellID-Broadcast-Item', mode=MODE_TYPE)
    _CellID_Broadcast_Item_eCGI = SEQ(name=u'eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _CellID_Broadcast_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellID_Broadcast_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CellID_Broadcast_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellID_Broadcast_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellID_Broadcast_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellID_Broadcast_Item_iE_Extensions__item__id._const_tab = ____CellID_Broadcast_Item_iE_Extensions__item__id_tab
    ___CellID_Broadcast_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellID_Broadcast_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellID_Broadcast_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CellID_Broadcast_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellID_Broadcast_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellID_Broadcast_Item_iE_Extensions__item__criticality._const_tab = ____CellID_Broadcast_Item_iE_Extensions__item__criticality_tab
    ___CellID_Broadcast_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellID_Broadcast_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellID_Broadcast_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CellID_Broadcast_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellID_Broadcast_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellID_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab = ____CellID_Broadcast_Item_iE_Extensions__item__extensionValue_tab
    ___CellID_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellID_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellID_Broadcast_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellID_Broadcast_Item_iE_Extensions__item__id),
        (u'criticality', ___CellID_Broadcast_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellID_Broadcast_Item_iE_Extensions__item__extensionValue),
        ])
    __CellID_Broadcast_Item_iE_Extensions__item_._ext = None
    _CellID_Broadcast_Item_iE_Extensions._cont = __CellID_Broadcast_Item_iE_Extensions__item_
    _CellID_Broadcast_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellID_Broadcast_Item._cont = ASN1Dict([
        (u'eCGI', _CellID_Broadcast_Item_eCGI),
        (u'iE-Extensions', _CellID_Broadcast_Item_iE_Extensions),
        ])
    CellID_Broadcast_Item._ext = []
    
    #-----< CellID-Broadcast-Item-ExtIEs >-----#
    CellID_Broadcast_Item_ExtIEs = CLASS(name=u'CellID-Broadcast-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CellID_Broadcast_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellID-Cancelled >-----#
    CellID_Cancelled = SEQ_OF(name=u'CellID-Cancelled', mode=MODE_TYPE)
    _CellID_Cancelled__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellID-Cancelled-Item')))
    CellID_Cancelled._cont = _CellID_Cancelled__item_
    CellID_Cancelled._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CellID-Cancelled-Item >-----#
    CellID_Cancelled_Item = SEQ(name=u'CellID-Cancelled-Item', mode=MODE_TYPE)
    _CellID_Cancelled_Item_eCGI = SEQ(name=u'eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _CellID_Cancelled_Item_numberOfBroadcasts = INT(name=u'numberOfBroadcasts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NumberOfBroadcasts')))
    _CellID_Cancelled_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellID_Cancelled_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CellID_Cancelled_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellID_Cancelled_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellID_Cancelled_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellID_Cancelled_Item_iE_Extensions__item__id._const_tab = ____CellID_Cancelled_Item_iE_Extensions__item__id_tab
    ___CellID_Cancelled_Item_iE_Extensions__item__id._const_tab_at = None
    ___CellID_Cancelled_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellID_Cancelled_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CellID_Cancelled_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellID_Cancelled_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellID_Cancelled_Item_iE_Extensions__item__criticality._const_tab = ____CellID_Cancelled_Item_iE_Extensions__item__criticality_tab
    ___CellID_Cancelled_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellID_Cancelled_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellID_Cancelled_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CellID_Cancelled_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellID_Cancelled_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellID_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab = ____CellID_Cancelled_Item_iE_Extensions__item__extensionValue_tab
    ___CellID_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellID_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellID_Cancelled_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellID_Cancelled_Item_iE_Extensions__item__id),
        (u'criticality', ___CellID_Cancelled_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellID_Cancelled_Item_iE_Extensions__item__extensionValue),
        ])
    __CellID_Cancelled_Item_iE_Extensions__item_._ext = None
    _CellID_Cancelled_Item_iE_Extensions._cont = __CellID_Cancelled_Item_iE_Extensions__item_
    _CellID_Cancelled_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellID_Cancelled_Item._cont = ASN1Dict([
        (u'eCGI', _CellID_Cancelled_Item_eCGI),
        (u'numberOfBroadcasts', _CellID_Cancelled_Item_numberOfBroadcasts),
        (u'iE-Extensions', _CellID_Cancelled_Item_iE_Extensions),
        ])
    CellID_Cancelled_Item._ext = []
    
    #-----< CellID-Cancelled-Item-ExtIEs >-----#
    CellID_Cancelled_Item_ExtIEs = CLASS(name=u'CellID-Cancelled-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CellID_Cancelled_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellBasedMDT >-----#
    CellBasedMDT = SEQ(name=u'CellBasedMDT', mode=MODE_TYPE)
    _CellBasedMDT_cellIdListforMDT = SEQ_OF(name=u'cellIdListforMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CellIdListforMDT')))
    _CellBasedMDT_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellBasedMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CellBasedMDT_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellBasedMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_iE_Extensions__item__id._const_tab = ____CellBasedMDT_iE_Extensions__item__id_tab
    ___CellBasedMDT_iE_Extensions__item__id._const_tab_at = None
    ___CellBasedMDT_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellBasedMDT_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CellBasedMDT_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_iE_Extensions__item__criticality._const_tab = ____CellBasedMDT_iE_Extensions__item__criticality_tab
    ___CellBasedMDT_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellBasedMDT_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellBasedMDT_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CellBasedMDT_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellBasedMDT_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedMDT_iE_Extensions__item__extensionValue._const_tab = ____CellBasedMDT_iE_Extensions__item__extensionValue_tab
    ___CellBasedMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellBasedMDT_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellBasedMDT_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellBasedMDT_iE_Extensions__item__id),
        (u'criticality', ___CellBasedMDT_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellBasedMDT_iE_Extensions__item__extensionValue),
        ])
    __CellBasedMDT_iE_Extensions__item_._ext = None
    _CellBasedMDT_iE_Extensions._cont = __CellBasedMDT_iE_Extensions__item_
    _CellBasedMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellBasedMDT._cont = ASN1Dict([
        (u'cellIdListforMDT', _CellBasedMDT_cellIdListforMDT),
        (u'iE-Extensions', _CellBasedMDT_iE_Extensions),
        ])
    CellBasedMDT._ext = []
    
    #-----< CellBasedMDT-ExtIEs >-----#
    CellBasedMDT_ExtIEs = CLASS(name=u'CellBasedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CellBasedMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellIdListforMDT >-----#
    CellIdListforMDT = SEQ_OF(name=u'CellIdListforMDT', mode=MODE_TYPE)
    _CellIdListforMDT__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    CellIdListforMDT._cont = _CellIdListforMDT__item_
    CellIdListforMDT._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< CellBasedQMC >-----#
    CellBasedQMC = SEQ(name=u'CellBasedQMC', mode=MODE_TYPE)
    _CellBasedQMC_cellIdListforQMC = SEQ_OF(name=u'cellIdListforQMC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CellIdListforQMC')))
    _CellBasedQMC_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellBasedQMC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CellBasedQMC_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellBasedQMC_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellBasedQMC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedQMC_iE_Extensions__item__id._const_tab = ____CellBasedQMC_iE_Extensions__item__id_tab
    ___CellBasedQMC_iE_Extensions__item__id._const_tab_at = None
    ___CellBasedQMC_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellBasedQMC_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CellBasedQMC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellBasedQMC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedQMC_iE_Extensions__item__criticality._const_tab = ____CellBasedQMC_iE_Extensions__item__criticality_tab
    ___CellBasedQMC_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellBasedQMC_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellBasedQMC_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CellBasedQMC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellBasedQMC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBasedQMC_iE_Extensions__item__extensionValue._const_tab = ____CellBasedQMC_iE_Extensions__item__extensionValue_tab
    ___CellBasedQMC_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellBasedQMC_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellBasedQMC_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellBasedQMC_iE_Extensions__item__id),
        (u'criticality', ___CellBasedQMC_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellBasedQMC_iE_Extensions__item__extensionValue),
        ])
    __CellBasedQMC_iE_Extensions__item_._ext = None
    _CellBasedQMC_iE_Extensions._cont = __CellBasedQMC_iE_Extensions__item_
    _CellBasedQMC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellBasedQMC._cont = ASN1Dict([
        (u'cellIdListforQMC', _CellBasedQMC_cellIdListforQMC),
        (u'iE-Extensions', _CellBasedQMC_iE_Extensions),
        ])
    CellBasedQMC._ext = []
    
    #-----< CellBasedQMC-ExtIEs >-----#
    CellBasedQMC_ExtIEs = CLASS(name=u'CellBasedQMC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CellBasedQMC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellIdListforQMC >-----#
    CellIdListforQMC = SEQ_OF(name=u'CellIdListforQMC', mode=MODE_TYPE)
    _CellIdListforQMC__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    CellIdListforQMC._cont = _CellIdListforQMC__item_
    CellIdListforQMC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Cdma2000PDU >-----#
    Cdma2000PDU = OCT_STR(name=u'Cdma2000PDU', mode=MODE_TYPE)
    
    #-----< Cdma2000RATType >-----#
    Cdma2000RATType = ENUM(name=u'Cdma2000RATType', mode=MODE_TYPE)
    Cdma2000RATType._cont = ASN1Dict([(u'hRPD', 0), (u'onexRTT', 1)])
    Cdma2000RATType._ext = []
    
    #-----< Cdma2000SectorID >-----#
    Cdma2000SectorID = OCT_STR(name=u'Cdma2000SectorID', mode=MODE_TYPE)
    
    #-----< Cdma2000HOStatus >-----#
    Cdma2000HOStatus = ENUM(name=u'Cdma2000HOStatus', mode=MODE_TYPE)
    Cdma2000HOStatus._cont = ASN1Dict([(u'hOSuccess', 0), (u'hOFailure', 1)])
    Cdma2000HOStatus._ext = []
    
    #-----< Cdma2000HORequiredIndication >-----#
    Cdma2000HORequiredIndication = ENUM(name=u'Cdma2000HORequiredIndication', mode=MODE_TYPE)
    Cdma2000HORequiredIndication._cont = ASN1Dict([(u'true', 0)])
    Cdma2000HORequiredIndication._ext = []
    
    #-----< Cdma2000OneXSRVCCInfo >-----#
    Cdma2000OneXSRVCCInfo = SEQ(name=u'Cdma2000OneXSRVCCInfo', mode=MODE_TYPE)
    _Cdma2000OneXSRVCCInfo_cdma2000OneXMEID = OCT_STR(name=u'cdma2000OneXMEID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000OneXMEID')))
    _Cdma2000OneXSRVCCInfo_cdma2000OneXMSI = OCT_STR(name=u'cdma2000OneXMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000OneXMSI')))
    _Cdma2000OneXSRVCCInfo_cdma2000OneXPilot = OCT_STR(name=u'cdma2000OneXPilot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000OneXPilot')))
    _Cdma2000OneXSRVCCInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cdma2000OneXSRVCCInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__id._const_tab = ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__id_tab
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__id._const_tab_at = None
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__criticality._const_tab = ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__criticality_tab
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__extensionValue._const_tab = ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__extensionValue_tab
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Cdma2000OneXSRVCCInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__id),
        (u'criticality', ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__extensionValue),
        ])
    __Cdma2000OneXSRVCCInfo_iE_Extensions__item_._ext = None
    _Cdma2000OneXSRVCCInfo_iE_Extensions._cont = __Cdma2000OneXSRVCCInfo_iE_Extensions__item_
    _Cdma2000OneXSRVCCInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cdma2000OneXSRVCCInfo._cont = ASN1Dict([
        (u'cdma2000OneXMEID', _Cdma2000OneXSRVCCInfo_cdma2000OneXMEID),
        (u'cdma2000OneXMSI', _Cdma2000OneXSRVCCInfo_cdma2000OneXMSI),
        (u'cdma2000OneXPilot', _Cdma2000OneXSRVCCInfo_cdma2000OneXPilot),
        (u'iE-Extensions', _Cdma2000OneXSRVCCInfo_iE_Extensions),
        ])
    Cdma2000OneXSRVCCInfo._ext = []
    
    #-----< Cdma2000OneXSRVCCInfo-ExtIEs >-----#
    Cdma2000OneXSRVCCInfo_ExtIEs = CLASS(name=u'Cdma2000OneXSRVCCInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    Cdma2000OneXSRVCCInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cdma2000OneXMEID >-----#
    Cdma2000OneXMEID = OCT_STR(name=u'Cdma2000OneXMEID', mode=MODE_TYPE)
    
    #-----< Cdma2000OneXMSI >-----#
    Cdma2000OneXMSI = OCT_STR(name=u'Cdma2000OneXMSI', mode=MODE_TYPE)
    
    #-----< Cdma2000OneXPilot >-----#
    Cdma2000OneXPilot = OCT_STR(name=u'Cdma2000OneXPilot', mode=MODE_TYPE)
    
    #-----< Cdma2000OneXRAND >-----#
    Cdma2000OneXRAND = OCT_STR(name=u'Cdma2000OneXRAND', mode=MODE_TYPE)
    
    #-----< Cell-Size >-----#
    Cell_Size = ENUM(name=u'Cell-Size', mode=MODE_TYPE)
    Cell_Size._cont = ASN1Dict([(u'verysmall', 0), (u'small', 1), (u'medium', 2), (u'large', 3)])
    Cell_Size._ext = []
    
    #-----< CellType >-----#
    CellType = SEQ(name=u'CellType', mode=MODE_TYPE)
    _CellType_cell_Size = ENUM(name=u'cell-Size', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Cell-Size')))
    _CellType_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellType_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CellType_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellType_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__id._const_tab = ____CellType_iE_Extensions__item__id_tab
    ___CellType_iE_Extensions__item__id._const_tab_at = None
    ___CellType_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellType_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CellType_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__criticality._const_tab = ____CellType_iE_Extensions__item__criticality_tab
    ___CellType_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellType_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellType_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CellType_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CellType_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellType_iE_Extensions__item__extensionValue._const_tab = ____CellType_iE_Extensions__item__extensionValue_tab
    ___CellType_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellType_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellType_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellType_iE_Extensions__item__id),
        (u'criticality', ___CellType_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellType_iE_Extensions__item__extensionValue),
        ])
    __CellType_iE_Extensions__item_._ext = None
    _CellType_iE_Extensions._cont = __CellType_iE_Extensions__item_
    _CellType_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellType._cont = ASN1Dict([
        (u'cell-Size', _CellType_cell_Size),
        (u'iE-Extensions', _CellType_iE_Extensions),
        ])
    CellType._ext = []
    
    #-----< CellType-ExtIEs >-----#
    CellType_ExtIEs = CLASS(name=u'CellType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CellType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CGI >-----#
    CGI = SEQ(name=u'CGI', mode=MODE_TYPE)
    _CGI_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _CGI_lAC = OCT_STR(name=u'lAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LAC')))
    _CGI_cI = OCT_STR(name=u'cI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CI')))
    _CGI_rAC = OCT_STR(name=u'rAC', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RAC')), opt=True)
    _CGI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CGI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CGI_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_iE_Extensions__item__id._const_tab = ____CGI_iE_Extensions__item__id_tab
    ___CGI_iE_Extensions__item__id._const_tab_at = None
    ___CGI_iE_Extensions__item__id._const_tab_id = u'id'
    ___CGI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_iE_Extensions__item__criticality._const_tab = ____CGI_iE_Extensions__item__criticality_tab
    ___CGI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CGI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CGI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_iE_Extensions__item__extensionValue._const_tab = ____CGI_iE_Extensions__item__extensionValue_tab
    ___CGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CGI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CGI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CGI_iE_Extensions__item__id),
        (u'criticality', ___CGI_iE_Extensions__item__criticality),
        (u'extensionValue', ___CGI_iE_Extensions__item__extensionValue),
        ])
    __CGI_iE_Extensions__item_._ext = None
    _CGI_iE_Extensions._cont = __CGI_iE_Extensions__item_
    _CGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CGI._cont = ASN1Dict([
        (u'pLMNidentity', _CGI_pLMNidentity),
        (u'lAC', _CGI_lAC),
        (u'cI', _CGI_cI),
        (u'rAC', _CGI_rAC),
        (u'iE-Extensions', _CGI_iE_Extensions),
        ])
    CGI._ext = []
    
    #-----< CGI-ExtIEs >-----#
    CGI_ExtIEs = CLASS(name=u'CGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CI >-----#
    CI = OCT_STR(name=u'CI', mode=MODE_TYPE)
    CI._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< CNDomain >-----#
    CNDomain = ENUM(name=u'CNDomain', mode=MODE_TYPE)
    CNDomain._cont = ASN1Dict([(u'ps', 0), (u'cs', 1)])
    CNDomain._ext = None
    
    #-----< CNTypeRestrictions >-----#
    CNTypeRestrictions = SEQ_OF(name=u'CNTypeRestrictions', mode=MODE_TYPE)
    _CNTypeRestrictions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CNTypeRestrictions-Item')))
    CNTypeRestrictions._cont = _CNTypeRestrictions__item_
    CNTypeRestrictions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CNTypeRestrictions-Item >-----#
    CNTypeRestrictions_Item = SEQ(name=u'CNTypeRestrictions-Item', mode=MODE_TYPE)
    _CNTypeRestrictions_Item_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _CNTypeRestrictions_Item_cNType = ENUM(name=u'cNType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CNType')))
    _CNTypeRestrictions_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CNTypeRestrictions_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CNTypeRestrictions_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CNTypeRestrictions_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CNTypeRestrictions_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNTypeRestrictions_Item_iE_Extensions__item__id._const_tab = ____CNTypeRestrictions_Item_iE_Extensions__item__id_tab
    ___CNTypeRestrictions_Item_iE_Extensions__item__id._const_tab_at = None
    ___CNTypeRestrictions_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CNTypeRestrictions_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CNTypeRestrictions_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CNTypeRestrictions_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNTypeRestrictions_Item_iE_Extensions__item__criticality._const_tab = ____CNTypeRestrictions_Item_iE_Extensions__item__criticality_tab
    ___CNTypeRestrictions_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CNTypeRestrictions_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CNTypeRestrictions_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CNTypeRestrictions_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CNTypeRestrictions_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNTypeRestrictions_Item_iE_Extensions__item__extensionValue._const_tab = ____CNTypeRestrictions_Item_iE_Extensions__item__extensionValue_tab
    ___CNTypeRestrictions_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CNTypeRestrictions_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CNTypeRestrictions_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CNTypeRestrictions_Item_iE_Extensions__item__id),
        (u'criticality', ___CNTypeRestrictions_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CNTypeRestrictions_Item_iE_Extensions__item__extensionValue),
        ])
    __CNTypeRestrictions_Item_iE_Extensions__item_._ext = None
    _CNTypeRestrictions_Item_iE_Extensions._cont = __CNTypeRestrictions_Item_iE_Extensions__item_
    _CNTypeRestrictions_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CNTypeRestrictions_Item._cont = ASN1Dict([
        (u'pLMN-Identity', _CNTypeRestrictions_Item_pLMN_Identity),
        (u'cNType', _CNTypeRestrictions_Item_cNType),
        (u'iE-Extensions', _CNTypeRestrictions_Item_iE_Extensions),
        ])
    CNTypeRestrictions_Item._ext = []
    
    #-----< CNTypeRestrictions-Item-ExtIEs >-----#
    CNTypeRestrictions_Item_ExtIEs = CLASS(name=u'CNTypeRestrictions-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CNTypeRestrictions_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CNType >-----#
    CNType = ENUM(name=u'CNType', mode=MODE_TYPE)
    CNType._cont = ASN1Dict([(u'fiveGCForbidden', 0), (u'epc-Forbiddden', 1)])
    CNType._ext = [u'epc-Forbiddden']
    
    #-----< ConcurrentWarningMessageIndicator >-----#
    ConcurrentWarningMessageIndicator = ENUM(name=u'ConcurrentWarningMessageIndicator', mode=MODE_TYPE)
    ConcurrentWarningMessageIndicator._cont = ASN1Dict([(u'true', 0)])
    ConcurrentWarningMessageIndicator._ext = None
    
    #-----< ConnectedengNBList >-----#
    ConnectedengNBList = SEQ_OF(name=u'ConnectedengNBList', mode=MODE_TYPE)
    _ConnectedengNBList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ConnectedengNBItem')))
    ConnectedengNBList._cont = _ConnectedengNBList__item_
    ConnectedengNBList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ConnectedengNBItem >-----#
    ConnectedengNBItem = SEQ(name=u'ConnectedengNBItem', mode=MODE_TYPE)
    _ConnectedengNBItem_en_gNB_ID = BIT_STR(name=u'en-gNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'En-gNB-ID')))
    _ConnectedengNBItem_supportedTAs = SEQ_OF(name=u'supportedTAs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SupportedTAs')))
    _ConnectedengNBItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ConnectedengNBItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ConnectedengNBItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ConnectedengNBItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ConnectedengNBItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ConnectedengNBItem_iE_Extensions__item__id._const_tab = ____ConnectedengNBItem_iE_Extensions__item__id_tab
    ___ConnectedengNBItem_iE_Extensions__item__id._const_tab_at = None
    ___ConnectedengNBItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___ConnectedengNBItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ConnectedengNBItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ConnectedengNBItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ConnectedengNBItem_iE_Extensions__item__criticality._const_tab = ____ConnectedengNBItem_iE_Extensions__item__criticality_tab
    ___ConnectedengNBItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ConnectedengNBItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ConnectedengNBItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ConnectedengNBItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ConnectedengNBItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ConnectedengNBItem_iE_Extensions__item__extensionValue._const_tab = ____ConnectedengNBItem_iE_Extensions__item__extensionValue_tab
    ___ConnectedengNBItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ConnectedengNBItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ConnectedengNBItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ConnectedengNBItem_iE_Extensions__item__id),
        (u'criticality', ___ConnectedengNBItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___ConnectedengNBItem_iE_Extensions__item__extensionValue),
        ])
    __ConnectedengNBItem_iE_Extensions__item_._ext = None
    _ConnectedengNBItem_iE_Extensions._cont = __ConnectedengNBItem_iE_Extensions__item_
    _ConnectedengNBItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ConnectedengNBItem._cont = ASN1Dict([
        (u'en-gNB-ID', _ConnectedengNBItem_en_gNB_ID),
        (u'supportedTAs', _ConnectedengNBItem_supportedTAs),
        (u'iE-Extensions', _ConnectedengNBItem_iE_Extensions),
        ])
    ConnectedengNBItem._ext = []
    
    #-----< ConnectedengNBItem-ExtIEs >-----#
    ConnectedengNBItem_ExtIEs = CLASS(name=u'ConnectedengNBItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ConnectedengNBItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ContextatSource >-----#
    ContextatSource = SEQ(name=u'ContextatSource', mode=MODE_TYPE)
    _ContextatSource_sourceNG_RAN_node_ID = CHOICE(name=u'sourceNG-RAN-node-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Global-RAN-NODE-ID')))
    _ContextatSource_rAN_UE_NGAP_ID = INT(name=u'rAN-UE-NGAP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RAN-UE-NGAP-ID')))
    _ContextatSource_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ContextatSource_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ContextatSource_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ContextatSource_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ContextatSource_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContextatSource_iE_Extensions__item__id._const_tab = ____ContextatSource_iE_Extensions__item__id_tab
    ___ContextatSource_iE_Extensions__item__id._const_tab_at = None
    ___ContextatSource_iE_Extensions__item__id._const_tab_id = u'id'
    ___ContextatSource_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ContextatSource_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ContextatSource_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContextatSource_iE_Extensions__item__criticality._const_tab = ____ContextatSource_iE_Extensions__item__criticality_tab
    ___ContextatSource_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ContextatSource_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ContextatSource_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ContextatSource_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ContextatSource_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContextatSource_iE_Extensions__item__extensionValue._const_tab = ____ContextatSource_iE_Extensions__item__extensionValue_tab
    ___ContextatSource_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ContextatSource_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ContextatSource_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ContextatSource_iE_Extensions__item__id),
        (u'criticality', ___ContextatSource_iE_Extensions__item__criticality),
        (u'extensionValue', ___ContextatSource_iE_Extensions__item__extensionValue),
        ])
    __ContextatSource_iE_Extensions__item_._ext = None
    _ContextatSource_iE_Extensions._cont = __ContextatSource_iE_Extensions__item_
    _ContextatSource_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ContextatSource._cont = ASN1Dict([
        (u'sourceNG-RAN-node-ID', _ContextatSource_sourceNG_RAN_node_ID),
        (u'rAN-UE-NGAP-ID', _ContextatSource_rAN_UE_NGAP_ID),
        (u'iE-Extensions', _ContextatSource_iE_Extensions),
        ])
    ContextatSource._ext = []
    
    #-----< ContextatSource-ExtIEs >-----#
    ContextatSource_ExtIEs = CLASS(name=u'ContextatSource-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ContextatSource_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Correlation-ID >-----#
    Correlation_ID = OCT_STR(name=u'Correlation-ID', mode=MODE_TYPE)
    Correlation_ID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< CSFallbackIndicator >-----#
    CSFallbackIndicator = ENUM(name=u'CSFallbackIndicator', mode=MODE_TYPE)
    CSFallbackIndicator._cont = ASN1Dict([(u'cs-fallback-required', 0), (u'cs-fallback-high-priority', 1)])
    CSFallbackIndicator._ext = [u'cs-fallback-high-priority']
    
    #-----< AdditionalCSFallbackIndicator >-----#
    AdditionalCSFallbackIndicator = ENUM(name=u'AdditionalCSFallbackIndicator', mode=MODE_TYPE)
    AdditionalCSFallbackIndicator._cont = ASN1Dict([(u'no-restriction', 0), (u'restriction', 1)])
    AdditionalCSFallbackIndicator._ext = []
    
    #-----< CSG-Id >-----#
    CSG_Id = BIT_STR(name=u'CSG-Id', mode=MODE_TYPE)
    CSG_Id._const_sz = ASN1Set(rv=[27], rr=[], ev=None, er=[])
    
    #-----< CSG-IdList >-----#
    CSG_IdList = SEQ_OF(name=u'CSG-IdList', mode=MODE_TYPE)
    _CSG_IdList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-IdList-Item')))
    CSG_IdList._cont = _CSG_IdList__item_
    CSG_IdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CSG-IdList-Item >-----#
    CSG_IdList_Item = SEQ(name=u'CSG-IdList-Item', mode=MODE_TYPE)
    _CSG_IdList_Item_cSG_Id = BIT_STR(name=u'cSG-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _CSG_IdList_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CSG_IdList_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CSG_IdList_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CSG_IdList_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CSG_IdList_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSG_IdList_Item_iE_Extensions__item__id._const_tab = ____CSG_IdList_Item_iE_Extensions__item__id_tab
    ___CSG_IdList_Item_iE_Extensions__item__id._const_tab_at = None
    ___CSG_IdList_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CSG_IdList_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CSG_IdList_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CSG_IdList_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSG_IdList_Item_iE_Extensions__item__criticality._const_tab = ____CSG_IdList_Item_iE_Extensions__item__criticality_tab
    ___CSG_IdList_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CSG_IdList_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CSG_IdList_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CSG_IdList_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CSG_IdList_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSG_IdList_Item_iE_Extensions__item__extensionValue._const_tab = ____CSG_IdList_Item_iE_Extensions__item__extensionValue_tab
    ___CSG_IdList_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CSG_IdList_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CSG_IdList_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CSG_IdList_Item_iE_Extensions__item__id),
        (u'criticality', ___CSG_IdList_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CSG_IdList_Item_iE_Extensions__item__extensionValue),
        ])
    __CSG_IdList_Item_iE_Extensions__item_._ext = None
    _CSG_IdList_Item_iE_Extensions._cont = __CSG_IdList_Item_iE_Extensions__item_
    _CSG_IdList_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CSG_IdList_Item._cont = ASN1Dict([
        (u'cSG-Id', _CSG_IdList_Item_cSG_Id),
        (u'iE-Extensions', _CSG_IdList_Item_iE_Extensions),
        ])
    CSG_IdList_Item._ext = []
    
    #-----< CSG-IdList-Item-ExtIEs >-----#
    CSG_IdList_Item_ExtIEs = CLASS(name=u'CSG-IdList-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CSG_IdList_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CSGMembershipStatus >-----#
    CSGMembershipStatus = ENUM(name=u'CSGMembershipStatus', mode=MODE_TYPE)
    CSGMembershipStatus._cont = ASN1Dict([(u'member', 0), (u'not-member', 1)])
    CSGMembershipStatus._ext = None
    
    #-----< COUNTvalue >-----#
    COUNTvalue = SEQ(name=u'COUNTvalue', mode=MODE_TYPE)
    _COUNTvalue_pDCP_SN = INT(name=u'pDCP-SN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PDCP-SN')))
    _COUNTvalue_hFN = INT(name=u'hFN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'HFN')))
    _COUNTvalue_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __COUNTvalue_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___COUNTvalue_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____COUNTvalue_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____COUNTvalue_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTvalue_iE_Extensions__item__id._const_tab = ____COUNTvalue_iE_Extensions__item__id_tab
    ___COUNTvalue_iE_Extensions__item__id._const_tab_at = None
    ___COUNTvalue_iE_Extensions__item__id._const_tab_id = u'id'
    ___COUNTvalue_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____COUNTvalue_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____COUNTvalue_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTvalue_iE_Extensions__item__criticality._const_tab = ____COUNTvalue_iE_Extensions__item__criticality_tab
    ___COUNTvalue_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___COUNTvalue_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___COUNTvalue_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____COUNTvalue_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____COUNTvalue_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTvalue_iE_Extensions__item__extensionValue._const_tab = ____COUNTvalue_iE_Extensions__item__extensionValue_tab
    ___COUNTvalue_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___COUNTvalue_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __COUNTvalue_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___COUNTvalue_iE_Extensions__item__id),
        (u'criticality', ___COUNTvalue_iE_Extensions__item__criticality),
        (u'extensionValue', ___COUNTvalue_iE_Extensions__item__extensionValue),
        ])
    __COUNTvalue_iE_Extensions__item_._ext = None
    _COUNTvalue_iE_Extensions._cont = __COUNTvalue_iE_Extensions__item_
    _COUNTvalue_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    COUNTvalue._cont = ASN1Dict([
        (u'pDCP-SN', _COUNTvalue_pDCP_SN),
        (u'hFN', _COUNTvalue_hFN),
        (u'iE-Extensions', _COUNTvalue_iE_Extensions),
        ])
    COUNTvalue._ext = []
    
    #-----< COUNTvalue-ExtIEs >-----#
    COUNTvalue_ExtIEs = CLASS(name=u'COUNTvalue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    COUNTvalue_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< COUNTValueExtended >-----#
    COUNTValueExtended = SEQ(name=u'COUNTValueExtended', mode=MODE_TYPE)
    _COUNTValueExtended_pDCP_SNExtended = INT(name=u'pDCP-SNExtended', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PDCP-SNExtended')))
    _COUNTValueExtended_hFNModified = INT(name=u'hFNModified', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'HFNModified')))
    _COUNTValueExtended_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __COUNTValueExtended_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___COUNTValueExtended_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____COUNTValueExtended_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____COUNTValueExtended_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueExtended_iE_Extensions__item__id._const_tab = ____COUNTValueExtended_iE_Extensions__item__id_tab
    ___COUNTValueExtended_iE_Extensions__item__id._const_tab_at = None
    ___COUNTValueExtended_iE_Extensions__item__id._const_tab_id = u'id'
    ___COUNTValueExtended_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____COUNTValueExtended_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____COUNTValueExtended_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueExtended_iE_Extensions__item__criticality._const_tab = ____COUNTValueExtended_iE_Extensions__item__criticality_tab
    ___COUNTValueExtended_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___COUNTValueExtended_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___COUNTValueExtended_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____COUNTValueExtended_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____COUNTValueExtended_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTValueExtended_iE_Extensions__item__extensionValue._const_tab = ____COUNTValueExtended_iE_Extensions__item__extensionValue_tab
    ___COUNTValueExtended_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___COUNTValueExtended_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __COUNTValueExtended_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___COUNTValueExtended_iE_Extensions__item__id),
        (u'criticality', ___COUNTValueExtended_iE_Extensions__item__criticality),
        (u'extensionValue', ___COUNTValueExtended_iE_Extensions__item__extensionValue),
        ])
    __COUNTValueExtended_iE_Extensions__item_._ext = None
    _COUNTValueExtended_iE_Extensions._cont = __COUNTValueExtended_iE_Extensions__item_
    _COUNTValueExtended_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    COUNTValueExtended._cont = ASN1Dict([
        (u'pDCP-SNExtended', _COUNTValueExtended_pDCP_SNExtended),
        (u'hFNModified', _COUNTValueExtended_hFNModified),
        (u'iE-Extensions', _COUNTValueExtended_iE_Extensions),
        ])
    COUNTValueExtended._ext = []
    
    #-----< COUNTValueExtended-ExtIEs >-----#
    COUNTValueExtended_ExtIEs = CLASS(name=u'COUNTValueExtended-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    COUNTValueExtended_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< COUNTvaluePDCP-SNlength18 >-----#
    COUNTvaluePDCP_SNlength18 = SEQ(name=u'COUNTvaluePDCP-SNlength18', mode=MODE_TYPE)
    _COUNTvaluePDCP_SNlength18_pDCP_SNlength18 = INT(name=u'pDCP-SNlength18', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PDCP-SNlength18')))
    _COUNTvaluePDCP_SNlength18_hFNforPDCP_SNlength18 = INT(name=u'hFNforPDCP-SNlength18', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'HFNforPDCP-SNlength18')))
    _COUNTvaluePDCP_SNlength18_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __COUNTvaluePDCP_SNlength18_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id._const_tab = ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__id_tab
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id._const_tab_at = None
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id._const_tab_id = u'id'
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality._const_tab = ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality_tab
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue._const_tab = ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue_tab
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __COUNTvaluePDCP_SNlength18_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id),
        (u'criticality', ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality),
        (u'extensionValue', ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue),
        ])
    __COUNTvaluePDCP_SNlength18_iE_Extensions__item_._ext = None
    _COUNTvaluePDCP_SNlength18_iE_Extensions._cont = __COUNTvaluePDCP_SNlength18_iE_Extensions__item_
    _COUNTvaluePDCP_SNlength18_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    COUNTvaluePDCP_SNlength18._cont = ASN1Dict([
        (u'pDCP-SNlength18', _COUNTvaluePDCP_SNlength18_pDCP_SNlength18),
        (u'hFNforPDCP-SNlength18', _COUNTvaluePDCP_SNlength18_hFNforPDCP_SNlength18),
        (u'iE-Extensions', _COUNTvaluePDCP_SNlength18_iE_Extensions),
        ])
    COUNTvaluePDCP_SNlength18._ext = []
    
    #-----< COUNTvaluePDCP-SNlength18-ExtIEs >-----#
    COUNTvaluePDCP_SNlength18_ExtIEs = CLASS(name=u'COUNTvaluePDCP-SNlength18-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    COUNTvaluePDCP_SNlength18_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Coverage-Level >-----#
    Coverage_Level = ENUM(name=u'Coverage-Level', mode=MODE_TYPE)
    Coverage_Level._cont = ASN1Dict([(u'extendedcoverage', 0)])
    Coverage_Level._ext = []
    
    #-----< CriticalityDiagnostics >-----#
    CriticalityDiagnostics = SEQ(name=u'CriticalityDiagnostics', mode=MODE_TYPE)
    _CriticalityDiagnostics_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')), opt=True)
    _CriticalityDiagnostics_triggeringMessage = ENUM(name=u'triggeringMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-CommonDataTypes', 'TriggeringMessage')), opt=True)
    _CriticalityDiagnostics_procedureCriticality = ENUM(name=u'procedureCriticality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Criticality')), opt=True)
    _CriticalityDiagnostics_iEsCriticalityDiagnostics = SEQ_OF(name=u'iEsCriticalityDiagnostics', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics-IE-List')), opt=True)
    _CriticalityDiagnostics_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_id = u'id'
    ___CriticalityDiagnostics_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CriticalityDiagnostics_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CriticalityDiagnostics_iE_Extensions__item__id),
        (u'criticality', ___CriticalityDiagnostics_iE_Extensions__item__criticality),
        (u'extensionValue', ___CriticalityDiagnostics_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_iE_Extensions._cont = __CriticalityDiagnostics_iE_Extensions__item_
    _CriticalityDiagnostics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics._cont = ASN1Dict([
        (u'procedureCode', _CriticalityDiagnostics_procedureCode),
        (u'triggeringMessage', _CriticalityDiagnostics_triggeringMessage),
        (u'procedureCriticality', _CriticalityDiagnostics_procedureCriticality),
        (u'iEsCriticalityDiagnostics', _CriticalityDiagnostics_iEsCriticalityDiagnostics),
        (u'iE-Extensions', _CriticalityDiagnostics_iE_Extensions),
        ])
    CriticalityDiagnostics._ext = []
    
    #-----< CriticalityDiagnostics-ExtIEs >-----#
    CriticalityDiagnostics_ExtIEs = CLASS(name=u'CriticalityDiagnostics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics-IE-List >-----#
    CriticalityDiagnostics_IE_List = SEQ_OF(name=u'CriticalityDiagnostics-IE-List', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics-IE-Item')))
    CriticalityDiagnostics_IE_List._cont = _CriticalityDiagnostics_IE_List__item_
    CriticalityDiagnostics_IE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CriticalityDiagnostics-IE-Item >-----#
    CriticalityDiagnostics_IE_Item = SEQ(name=u'CriticalityDiagnostics-IE-Item', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_Item_iECriticality = ENUM(name=u'iECriticality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Criticality')))
    _CriticalityDiagnostics_IE_Item_iE_ID = INT(name=u'iE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProtocolIE-ID')))
    _CriticalityDiagnostics_IE_Item_typeOfError = ENUM(name=u'typeOfError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TypeOfError')))
    _CriticalityDiagnostics_IE_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_IE_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CriticalityDiagnostics_IE_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id),
        (u'criticality', ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_IE_Item_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_IE_Item_iE_Extensions._cont = __CriticalityDiagnostics_IE_Item_iE_Extensions__item_
    _CriticalityDiagnostics_IE_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics_IE_Item._cont = ASN1Dict([
        (u'iECriticality', _CriticalityDiagnostics_IE_Item_iECriticality),
        (u'iE-ID', _CriticalityDiagnostics_IE_Item_iE_ID),
        (u'typeOfError', _CriticalityDiagnostics_IE_Item_typeOfError),
        (u'iE-Extensions', _CriticalityDiagnostics_IE_Item_iE_Extensions),
        ])
    CriticalityDiagnostics_IE_Item._ext = []
    
    #-----< CriticalityDiagnostics-IE-Item-ExtIEs >-----#
    CriticalityDiagnostics_IE_Item_ExtIEs = CLASS(name=u'CriticalityDiagnostics-IE-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_IE_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DAPSRequestInfo >-----#
    DAPSRequestInfo = SEQ(name=u'DAPSRequestInfo', mode=MODE_TYPE)
    _DAPSRequestInfo_dAPSIndicator = ENUM(name=u'dAPSIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DAPSRequestInfo_dAPSIndicator._cont = ASN1Dict([(u'dAPS-HO-required', 0)])
    _DAPSRequestInfo_dAPSIndicator._ext = []
    _DAPSRequestInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DAPSRequestInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___DAPSRequestInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DAPSRequestInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DAPSRequestInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSRequestInfo_iE_Extensions__item__id._const_tab = ____DAPSRequestInfo_iE_Extensions__item__id_tab
    ___DAPSRequestInfo_iE_Extensions__item__id._const_tab_at = None
    ___DAPSRequestInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___DAPSRequestInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DAPSRequestInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DAPSRequestInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSRequestInfo_iE_Extensions__item__criticality._const_tab = ____DAPSRequestInfo_iE_Extensions__item__criticality_tab
    ___DAPSRequestInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DAPSRequestInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue._const_tab = ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DAPSRequestInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DAPSRequestInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DAPSRequestInfo_iE_Extensions__item__id),
        (u'criticality', ___DAPSRequestInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___DAPSRequestInfo_iE_Extensions__item__extensionValue),
        ])
    __DAPSRequestInfo_iE_Extensions__item_._ext = None
    _DAPSRequestInfo_iE_Extensions._cont = __DAPSRequestInfo_iE_Extensions__item_
    _DAPSRequestInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DAPSRequestInfo._cont = ASN1Dict([
        (u'dAPSIndicator', _DAPSRequestInfo_dAPSIndicator),
        (u'iE-Extensions', _DAPSRequestInfo_iE_Extensions),
        ])
    DAPSRequestInfo._ext = []
    
    #-----< DAPSRequestInfo-ExtIEs >-----#
    DAPSRequestInfo_ExtIEs = CLASS(name=u'DAPSRequestInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    DAPSRequestInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DAPSResponseInfoList >-----#
    DAPSResponseInfoList = SEQ_OF(name=u'DAPSResponseInfoList', mode=MODE_TYPE)
    _DAPSResponseInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __DAPSResponseInfoList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___DAPSResponseInfoList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____DAPSResponseInfoList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DAPSResponseInfoItem')))
    ___DAPSResponseInfoList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 319), (u'criticality', u'ignore'), (u'Value', ____DAPSResponseInfoList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DAPSResponseInfoList__item__id._const_tab = ___DAPSResponseInfoList__item__id_tab
    __DAPSResponseInfoList__item__id._const_tab_at = None
    __DAPSResponseInfoList__item__id._const_tab_id = u'id'
    __DAPSResponseInfoList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __DAPSResponseInfoList__item__criticality._const_tab = ___DAPSResponseInfoList__item__id_tab
    __DAPSResponseInfoList__item__criticality._const_tab_at = ('..', u'id')
    __DAPSResponseInfoList__item__criticality._const_tab_id = u'criticality'
    __DAPSResponseInfoList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __DAPSResponseInfoList__item__value._const_tab = ___DAPSResponseInfoList__item__id_tab
    __DAPSResponseInfoList__item__value._const_tab_at = ('..', u'id')
    __DAPSResponseInfoList__item__value._const_tab_id = u'Value'
    _DAPSResponseInfoList__item_._cont = ASN1Dict([
        (u'id', __DAPSResponseInfoList__item__id),
        (u'criticality', __DAPSResponseInfoList__item__criticality),
        (u'value', __DAPSResponseInfoList__item__value),
        ])
    _DAPSResponseInfoList__item_._ext = None
    DAPSResponseInfoList._cont = _DAPSResponseInfoList__item_
    DAPSResponseInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< DAPSResponseInfoListIEs >-----#
    DAPSResponseInfoListIEs = CLASS(name=u'DAPSResponseInfoListIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _DAPSResponseInfoListIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DAPSResponseInfoItem')))
    DAPSResponseInfoListIEs._val = ASN1Set(rv=[dict([(u'id', 319), (u'criticality', u'ignore'), (u'Value', _DAPSResponseInfoListIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DAPSResponseInfoItem >-----#
    DAPSResponseInfoItem = SEQ(name=u'DAPSResponseInfoItem', mode=MODE_TYPE)
    _DAPSResponseInfoItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _DAPSResponseInfoItem_dAPSResponseInfo = SEQ(name=u'dAPSResponseInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'DAPSResponseInfo')))
    _DAPSResponseInfoItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DAPSResponseInfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___DAPSResponseInfoItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DAPSResponseInfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfoItem_iE_Extensions__item__id._const_tab = ____DAPSResponseInfoItem_iE_Extensions__item__id_tab
    ___DAPSResponseInfoItem_iE_Extensions__item__id._const_tab_at = None
    ___DAPSResponseInfoItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___DAPSResponseInfoItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DAPSResponseInfoItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfoItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfoItem_iE_Extensions__item__criticality._const_tab = ____DAPSResponseInfoItem_iE_Extensions__item__criticality_tab
    ___DAPSResponseInfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DAPSResponseInfoItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DAPSResponseInfoItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DAPSResponseInfoItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfoItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfoItem_iE_Extensions__item__extensionValue._const_tab = ____DAPSResponseInfoItem_iE_Extensions__item__extensionValue_tab
    ___DAPSResponseInfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DAPSResponseInfoItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DAPSResponseInfoItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DAPSResponseInfoItem_iE_Extensions__item__id),
        (u'criticality', ___DAPSResponseInfoItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___DAPSResponseInfoItem_iE_Extensions__item__extensionValue),
        ])
    __DAPSResponseInfoItem_iE_Extensions__item_._ext = None
    _DAPSResponseInfoItem_iE_Extensions._cont = __DAPSResponseInfoItem_iE_Extensions__item_
    _DAPSResponseInfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DAPSResponseInfoItem._cont = ASN1Dict([
        (u'e-RAB-ID', _DAPSResponseInfoItem_e_RAB_ID),
        (u'dAPSResponseInfo', _DAPSResponseInfoItem_dAPSResponseInfo),
        (u'iE-Extensions', _DAPSResponseInfoItem_iE_Extensions),
        ])
    DAPSResponseInfoItem._ext = []
    
    #-----< DAPSResponseInfoItem-ExtIEs >-----#
    DAPSResponseInfoItem_ExtIEs = CLASS(name=u'DAPSResponseInfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    DAPSResponseInfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DAPSResponseInfo >-----#
    DAPSResponseInfo = SEQ(name=u'DAPSResponseInfo', mode=MODE_TYPE)
    _DAPSResponseInfo_dapsresponseindicator = ENUM(name=u'dapsresponseindicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DAPSResponseInfo_dapsresponseindicator._cont = ASN1Dict([(u'dAPS-HO-accepted', 0), (u'dAPS-HO-not-accepted', 1)])
    _DAPSResponseInfo_dapsresponseindicator._ext = []
    _DAPSResponseInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DAPSResponseInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___DAPSResponseInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DAPSResponseInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfo_iE_Extensions__item__id._const_tab = ____DAPSResponseInfo_iE_Extensions__item__id_tab
    ___DAPSResponseInfo_iE_Extensions__item__id._const_tab_at = None
    ___DAPSResponseInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___DAPSResponseInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DAPSResponseInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfo_iE_Extensions__item__criticality._const_tab = ____DAPSResponseInfo_iE_Extensions__item__criticality_tab
    ___DAPSResponseInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DAPSResponseInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DAPSResponseInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DAPSResponseInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DAPSResponseInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DAPSResponseInfo_iE_Extensions__item__extensionValue._const_tab = ____DAPSResponseInfo_iE_Extensions__item__extensionValue_tab
    ___DAPSResponseInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DAPSResponseInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DAPSResponseInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DAPSResponseInfo_iE_Extensions__item__id),
        (u'criticality', ___DAPSResponseInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___DAPSResponseInfo_iE_Extensions__item__extensionValue),
        ])
    __DAPSResponseInfo_iE_Extensions__item_._ext = None
    _DAPSResponseInfo_iE_Extensions._cont = __DAPSResponseInfo_iE_Extensions__item_
    _DAPSResponseInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DAPSResponseInfo._cont = ASN1Dict([
        (u'dapsresponseindicator', _DAPSResponseInfo_dapsresponseindicator),
        (u'iE-Extensions', _DAPSResponseInfo_iE_Extensions),
        ])
    DAPSResponseInfo._ext = []
    
    #-----< DAPSResponseInfo-ExtIEs >-----#
    DAPSResponseInfo_ExtIEs = CLASS(name=u'DAPSResponseInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    DAPSResponseInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DataCodingScheme >-----#
    DataCodingScheme = BIT_STR(name=u'DataCodingScheme', mode=MODE_TYPE)
    DataCodingScheme._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< DataSize >-----#
    DataSize = INT(name=u'DataSize', mode=MODE_TYPE)
    DataSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    
    #-----< DCN-ID >-----#
    DCN_ID = INT(name=u'DCN-ID', mode=MODE_TYPE)
    DCN_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< ServedDCNs >-----#
    ServedDCNs = SEQ_OF(name=u'ServedDCNs', mode=MODE_TYPE)
    _ServedDCNs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServedDCNsItem')))
    ServedDCNs._cont = _ServedDCNs__item_
    ServedDCNs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    
    #-----< ServedDCNsItem >-----#
    ServedDCNsItem = SEQ(name=u'ServedDCNsItem', mode=MODE_TYPE)
    _ServedDCNsItem_dCN_ID = INT(name=u'dCN-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'DCN-ID')))
    _ServedDCNsItem_relativeDCNCapacity = INT(name=u'relativeDCNCapacity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RelativeMMECapacity')))
    _ServedDCNsItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServedDCNsItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ServedDCNsItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ServedDCNsItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ServedDCNsItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServedDCNsItem_iE_Extensions__item__id._const_tab = ____ServedDCNsItem_iE_Extensions__item__id_tab
    ___ServedDCNsItem_iE_Extensions__item__id._const_tab_at = None
    ___ServedDCNsItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___ServedDCNsItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ServedDCNsItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ServedDCNsItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServedDCNsItem_iE_Extensions__item__criticality._const_tab = ____ServedDCNsItem_iE_Extensions__item__criticality_tab
    ___ServedDCNsItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ServedDCNsItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ServedDCNsItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ServedDCNsItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ServedDCNsItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ServedDCNsItem_iE_Extensions__item__extensionValue._const_tab = ____ServedDCNsItem_iE_Extensions__item__extensionValue_tab
    ___ServedDCNsItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ServedDCNsItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ServedDCNsItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ServedDCNsItem_iE_Extensions__item__id),
        (u'criticality', ___ServedDCNsItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___ServedDCNsItem_iE_Extensions__item__extensionValue),
        ])
    __ServedDCNsItem_iE_Extensions__item_._ext = None
    _ServedDCNsItem_iE_Extensions._cont = __ServedDCNsItem_iE_Extensions__item_
    _ServedDCNsItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServedDCNsItem._cont = ASN1Dict([
        (u'dCN-ID', _ServedDCNsItem_dCN_ID),
        (u'relativeDCNCapacity', _ServedDCNsItem_relativeDCNCapacity),
        (u'iE-Extensions', _ServedDCNsItem_iE_Extensions),
        ])
    ServedDCNsItem._ext = []
    
    #-----< ServedDCNsItem-ExtIEs >-----#
    ServedDCNsItem_ExtIEs = CLASS(name=u'ServedDCNsItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ServedDCNsItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CP-SecurityInformation >-----#
    DL_CP_SecurityInformation = SEQ(name=u'DL-CP-SecurityInformation', mode=MODE_TYPE)
    _DL_CP_SecurityInformation_dl_NAS_MAC = BIT_STR(name=u'dl-NAS-MAC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'DL-NAS-MAC')))
    _DL_CP_SecurityInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CP_SecurityInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___DL_CP_SecurityInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_CP_SecurityInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DL_CP_SecurityInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CP_SecurityInformation_iE_Extensions__item__id._const_tab = ____DL_CP_SecurityInformation_iE_Extensions__item__id_tab
    ___DL_CP_SecurityInformation_iE_Extensions__item__id._const_tab_at = None
    ___DL_CP_SecurityInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_CP_SecurityInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_CP_SecurityInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DL_CP_SecurityInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab = ____DL_CP_SecurityInformation_iE_Extensions__item__criticality_tab
    ___DL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____DL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab = ____DL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab
    ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_CP_SecurityInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_CP_SecurityInformation_iE_Extensions__item__id),
        (u'criticality', ___DL_CP_SecurityInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue),
        ])
    __DL_CP_SecurityInformation_iE_Extensions__item_._ext = None
    _DL_CP_SecurityInformation_iE_Extensions._cont = __DL_CP_SecurityInformation_iE_Extensions__item_
    _DL_CP_SecurityInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CP_SecurityInformation._cont = ASN1Dict([
        (u'dl-NAS-MAC', _DL_CP_SecurityInformation_dl_NAS_MAC),
        (u'iE-Extensions', _DL_CP_SecurityInformation_iE_Extensions),
        ])
    DL_CP_SecurityInformation._ext = []
    
    #-----< DL-CP-SecurityInformation-ExtIEs >-----#
    DL_CP_SecurityInformation_ExtIEs = CLASS(name=u'DL-CP-SecurityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    DL_CP_SecurityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Forwarding >-----#
    DL_Forwarding = ENUM(name=u'DL-Forwarding', mode=MODE_TYPE)
    DL_Forwarding._cont = ASN1Dict([(u'dL-Forwarding-proposed', 0)])
    DL_Forwarding._ext = []
    
    #-----< DL-NAS-MAC >-----#
    DL_NAS_MAC = BIT_STR(name=u'DL-NAS-MAC', mode=MODE_TYPE)
    DL_NAS_MAC._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< DLCOUNT-PDCP-SNlength >-----#
    DLCOUNT_PDCP_SNlength = CHOICE(name=u'DLCOUNT-PDCP-SNlength', mode=MODE_TYPE)
    _DLCOUNT_PDCP_SNlength_dLCOUNTValuePDCP_SNlength12 = SEQ(name=u'dLCOUNTValuePDCP-SNlength12', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'COUNTvalue')))
    _DLCOUNT_PDCP_SNlength_dLCOUNTValuePDCP_SNlength15 = SEQ(name=u'dLCOUNTValuePDCP-SNlength15', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'COUNTValueExtended')))
    _DLCOUNT_PDCP_SNlength_dLCOUNTValuePDCP_SNlength18 = SEQ(name=u'dLCOUNTValuePDCP-SNlength18', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'COUNTvaluePDCP-SNlength18')))
    DLCOUNT_PDCP_SNlength._cont = ASN1Dict([
        (u'dLCOUNTValuePDCP-SNlength12', _DLCOUNT_PDCP_SNlength_dLCOUNTValuePDCP_SNlength12),
        (u'dLCOUNTValuePDCP-SNlength15', _DLCOUNT_PDCP_SNlength_dLCOUNTValuePDCP_SNlength15),
        (u'dLCOUNTValuePDCP-SNlength18', _DLCOUNT_PDCP_SNlength_dLCOUNTValuePDCP_SNlength18),
        ])
    DLCOUNT_PDCP_SNlength._ext = []
    
    #-----< Direct-Forwarding-Path-Availability >-----#
    Direct_Forwarding_Path_Availability = ENUM(name=u'Direct-Forwarding-Path-Availability', mode=MODE_TYPE)
    Direct_Forwarding_Path_Availability._cont = ASN1Dict([(u'directPathAvailable', 0)])
    Direct_Forwarding_Path_Availability._ext = []
    
    #-----< Data-Forwarding-Not-Possible >-----#
    Data_Forwarding_Not_Possible = ENUM(name=u'Data-Forwarding-Not-Possible', mode=MODE_TYPE)
    Data_Forwarding_Not_Possible._cont = ASN1Dict([(u'data-Forwarding-not-Possible', 0)])
    Data_Forwarding_Not_Possible._ext = []
    
    #-----< DLNASPDUDeliveryAckRequest >-----#
    DLNASPDUDeliveryAckRequest = ENUM(name=u'DLNASPDUDeliveryAckRequest', mode=MODE_TYPE)
    DLNASPDUDeliveryAckRequest._cont = ASN1Dict([(u'requested', 0)])
    DLNASPDUDeliveryAckRequest._ext = []
    
    #-----< EARFCN >-----#
    EARFCN = INT(name=u'EARFCN', mode=MODE_TYPE)
    EARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=[], er=[])
    
    #-----< ECGIList >-----#
    ECGIList = SEQ_OF(name=u'ECGIList', mode=MODE_TYPE)
    _ECGIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    ECGIList._cont = _ECGIList__item_
    ECGIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< PWSfailedECGIList >-----#
    PWSfailedECGIList = SEQ_OF(name=u'PWSfailedECGIList', mode=MODE_TYPE)
    _PWSfailedECGIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    PWSfailedECGIList._cont = _PWSfailedECGIList__item_
    PWSfailedECGIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< EDT-Session >-----#
    EDT_Session = ENUM(name=u'EDT-Session', mode=MODE_TYPE)
    EDT_Session._cont = ASN1Dict([(u'true', 0)])
    EDT_Session._ext = []
    
    #-----< EmergencyAreaIDList >-----#
    EmergencyAreaIDList = SEQ_OF(name=u'EmergencyAreaIDList', mode=MODE_TYPE)
    _EmergencyAreaIDList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaID')))
    EmergencyAreaIDList._cont = _EmergencyAreaIDList__item_
    EmergencyAreaIDList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< EmergencyAreaID >-----#
    EmergencyAreaID = OCT_STR(name=u'EmergencyAreaID', mode=MODE_TYPE)
    EmergencyAreaID._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< EmergencyAreaID-Broadcast >-----#
    EmergencyAreaID_Broadcast = SEQ_OF(name=u'EmergencyAreaID-Broadcast', mode=MODE_TYPE)
    _EmergencyAreaID_Broadcast__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaID-Broadcast-Item')))
    EmergencyAreaID_Broadcast._cont = _EmergencyAreaID_Broadcast__item_
    EmergencyAreaID_Broadcast._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< EmergencyAreaID-Broadcast-Item >-----#
    EmergencyAreaID_Broadcast_Item = SEQ(name=u'EmergencyAreaID-Broadcast-Item', mode=MODE_TYPE)
    _EmergencyAreaID_Broadcast_Item_emergencyAreaID = OCT_STR(name=u'emergencyAreaID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaID')))
    _EmergencyAreaID_Broadcast_Item_completedCellinEAI = SEQ_OF(name=u'completedCellinEAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CompletedCellinEAI')))
    _EmergencyAreaID_Broadcast_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EmergencyAreaID_Broadcast_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__id._const_tab = ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__id_tab
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__id._const_tab_at = None
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__criticality._const_tab = ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__criticality_tab
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab = ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__extensionValue_tab
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EmergencyAreaID_Broadcast_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__id),
        (u'criticality', ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__extensionValue),
        ])
    __EmergencyAreaID_Broadcast_Item_iE_Extensions__item_._ext = None
    _EmergencyAreaID_Broadcast_Item_iE_Extensions._cont = __EmergencyAreaID_Broadcast_Item_iE_Extensions__item_
    _EmergencyAreaID_Broadcast_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EmergencyAreaID_Broadcast_Item._cont = ASN1Dict([
        (u'emergencyAreaID', _EmergencyAreaID_Broadcast_Item_emergencyAreaID),
        (u'completedCellinEAI', _EmergencyAreaID_Broadcast_Item_completedCellinEAI),
        (u'iE-Extensions', _EmergencyAreaID_Broadcast_Item_iE_Extensions),
        ])
    EmergencyAreaID_Broadcast_Item._ext = []
    
    #-----< EmergencyAreaID-Broadcast-Item-ExtIEs >-----#
    EmergencyAreaID_Broadcast_Item_ExtIEs = CLASS(name=u'EmergencyAreaID-Broadcast-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    EmergencyAreaID_Broadcast_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EmergencyAreaID-Cancelled >-----#
    EmergencyAreaID_Cancelled = SEQ_OF(name=u'EmergencyAreaID-Cancelled', mode=MODE_TYPE)
    _EmergencyAreaID_Cancelled__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaID-Cancelled-Item')))
    EmergencyAreaID_Cancelled._cont = _EmergencyAreaID_Cancelled__item_
    EmergencyAreaID_Cancelled._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< EmergencyAreaID-Cancelled-Item >-----#
    EmergencyAreaID_Cancelled_Item = SEQ(name=u'EmergencyAreaID-Cancelled-Item', mode=MODE_TYPE)
    _EmergencyAreaID_Cancelled_Item_emergencyAreaID = OCT_STR(name=u'emergencyAreaID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaID')))
    _EmergencyAreaID_Cancelled_Item_cancelledCellinEAI = SEQ_OF(name=u'cancelledCellinEAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CancelledCellinEAI')))
    _EmergencyAreaID_Cancelled_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EmergencyAreaID_Cancelled_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__id._const_tab = ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__id_tab
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__id._const_tab_at = None
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__criticality._const_tab = ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__criticality_tab
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab = ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__extensionValue_tab
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EmergencyAreaID_Cancelled_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__id),
        (u'criticality', ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__extensionValue),
        ])
    __EmergencyAreaID_Cancelled_Item_iE_Extensions__item_._ext = None
    _EmergencyAreaID_Cancelled_Item_iE_Extensions._cont = __EmergencyAreaID_Cancelled_Item_iE_Extensions__item_
    _EmergencyAreaID_Cancelled_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EmergencyAreaID_Cancelled_Item._cont = ASN1Dict([
        (u'emergencyAreaID', _EmergencyAreaID_Cancelled_Item_emergencyAreaID),
        (u'cancelledCellinEAI', _EmergencyAreaID_Cancelled_Item_cancelledCellinEAI),
        (u'iE-Extensions', _EmergencyAreaID_Cancelled_Item_iE_Extensions),
        ])
    EmergencyAreaID_Cancelled_Item._ext = []
    
    #-----< EmergencyAreaID-Cancelled-Item-ExtIEs >-----#
    EmergencyAreaID_Cancelled_Item_ExtIEs = CLASS(name=u'EmergencyAreaID-Cancelled-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    EmergencyAreaID_Cancelled_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CompletedCellinEAI >-----#
    CompletedCellinEAI = SEQ_OF(name=u'CompletedCellinEAI', mode=MODE_TYPE)
    _CompletedCellinEAI__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CompletedCellinEAI-Item')))
    CompletedCellinEAI._cont = _CompletedCellinEAI__item_
    CompletedCellinEAI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CompletedCellinEAI-Item >-----#
    CompletedCellinEAI_Item = SEQ(name=u'CompletedCellinEAI-Item', mode=MODE_TYPE)
    _CompletedCellinEAI_Item_eCGI = SEQ(name=u'eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _CompletedCellinEAI_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompletedCellinEAI_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CompletedCellinEAI_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CompletedCellinEAI_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CompletedCellinEAI_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellinEAI_Item_iE_Extensions__item__id._const_tab = ____CompletedCellinEAI_Item_iE_Extensions__item__id_tab
    ___CompletedCellinEAI_Item_iE_Extensions__item__id._const_tab_at = None
    ___CompletedCellinEAI_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CompletedCellinEAI_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CompletedCellinEAI_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CompletedCellinEAI_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellinEAI_Item_iE_Extensions__item__criticality._const_tab = ____CompletedCellinEAI_Item_iE_Extensions__item__criticality_tab
    ___CompletedCellinEAI_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CompletedCellinEAI_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CompletedCellinEAI_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CompletedCellinEAI_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CompletedCellinEAI_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellinEAI_Item_iE_Extensions__item__extensionValue._const_tab = ____CompletedCellinEAI_Item_iE_Extensions__item__extensionValue_tab
    ___CompletedCellinEAI_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CompletedCellinEAI_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CompletedCellinEAI_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CompletedCellinEAI_Item_iE_Extensions__item__id),
        (u'criticality', ___CompletedCellinEAI_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CompletedCellinEAI_Item_iE_Extensions__item__extensionValue),
        ])
    __CompletedCellinEAI_Item_iE_Extensions__item_._ext = None
    _CompletedCellinEAI_Item_iE_Extensions._cont = __CompletedCellinEAI_Item_iE_Extensions__item_
    _CompletedCellinEAI_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompletedCellinEAI_Item._cont = ASN1Dict([
        (u'eCGI', _CompletedCellinEAI_Item_eCGI),
        (u'iE-Extensions', _CompletedCellinEAI_Item_iE_Extensions),
        ])
    CompletedCellinEAI_Item._ext = []
    
    #-----< CompletedCellinEAI-Item-ExtIEs >-----#
    CompletedCellinEAI_Item_ExtIEs = CLASS(name=u'CompletedCellinEAI-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CompletedCellinEAI_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ECGI-List >-----#
    ECGI_List = SEQ_OF(name=u'ECGI-List', mode=MODE_TYPE)
    _ECGI_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    ECGI_List._cont = _ECGI_List__item_
    ECGI_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< EmergencyAreaIDListForRestart >-----#
    EmergencyAreaIDListForRestart = SEQ_OF(name=u'EmergencyAreaIDListForRestart', mode=MODE_TYPE)
    _EmergencyAreaIDListForRestart__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaID')))
    EmergencyAreaIDListForRestart._cont = _EmergencyAreaIDListForRestart__item_
    EmergencyAreaIDListForRestart._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< EmergencyIndicator >-----#
    EmergencyIndicator = ENUM(name=u'EmergencyIndicator', mode=MODE_TYPE)
    EmergencyIndicator._cont = ASN1Dict([(u'true', 0)])
    EmergencyIndicator._ext = []
    
    #-----< ENB-EarlyStatusTransfer-TransparentContainer >-----#
    ENB_EarlyStatusTransfer_TransparentContainer = SEQ(name=u'ENB-EarlyStatusTransfer-TransparentContainer', mode=MODE_TYPE)
    _ENB_EarlyStatusTransfer_TransparentContainer_bearers_SubjectToEarlyStatusTransferList = SEQ_OF(name=u'bearers-SubjectToEarlyStatusTransferList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Bearers-SubjectToEarlyStatusTransferList')))
    _ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab = ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab_id = u'id'
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id),
        (u'criticality', ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality),
        (u'extensionValue', ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item_._ext = None
    _ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions._cont = __ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item_
    _ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ENB_EarlyStatusTransfer_TransparentContainer._cont = ASN1Dict([
        (u'bearers-SubjectToEarlyStatusTransferList', _ENB_EarlyStatusTransfer_TransparentContainer_bearers_SubjectToEarlyStatusTransferList),
        (u'iE-Extensions', _ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions),
        ])
    ENB_EarlyStatusTransfer_TransparentContainer._ext = []
    
    #-----< ENB-EarlyStatusTransfer-TransparentContainer-ExtIEs >-----#
    ENB_EarlyStatusTransfer_TransparentContainer_ExtIEs = CLASS(name=u'ENB-EarlyStatusTransfer-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ENB_EarlyStatusTransfer_TransparentContainer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ENB-ID >-----#
    ENB_ID = CHOICE(name=u'ENB-ID', mode=MODE_TYPE)
    _ENB_ID_macroENB_ID = BIT_STR(name=u'macroENB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_macroENB_ID._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _ENB_ID_homeENB_ID = BIT_STR(name=u'homeENB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_homeENB_ID._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    _ENB_ID_short_macroENB_ID = BIT_STR(name=u'short-macroENB-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_short_macroENB_ID._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _ENB_ID_long_macroENB_ID = BIT_STR(name=u'long-macroENB-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_long_macroENB_ID._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    ENB_ID._cont = ASN1Dict([
        (u'macroENB-ID', _ENB_ID_macroENB_ID),
        (u'homeENB-ID', _ENB_ID_homeENB_ID),
        (u'short-macroENB-ID', _ENB_ID_short_macroENB_ID),
        (u'long-macroENB-ID', _ENB_ID_long_macroENB_ID),
        ])
    ENB_ID._ext = [u'short-macroENB-ID', u'long-macroENB-ID']
    
    #-----< En-gNB-ID >-----#
    En_gNB_ID = BIT_STR(name=u'En-gNB-ID', mode=MODE_TYPE)
    En_gNB_ID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=22, ub=32)], ev=[], er=[])
    
    #-----< GERAN-Cell-ID >-----#
    GERAN_Cell_ID = SEQ(name=u'GERAN-Cell-ID', mode=MODE_TYPE)
    _GERAN_Cell_ID_lAI = SEQ(name=u'lAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LAI')))
    _GERAN_Cell_ID_rAC = OCT_STR(name=u'rAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RAC')))
    _GERAN_Cell_ID_cI = OCT_STR(name=u'cI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CI')))
    _GERAN_Cell_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GERAN_Cell_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___GERAN_Cell_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GERAN_Cell_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____GERAN_Cell_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERAN_Cell_ID_iE_Extensions__item__id._const_tab = ____GERAN_Cell_ID_iE_Extensions__item__id_tab
    ___GERAN_Cell_ID_iE_Extensions__item__id._const_tab_at = None
    ___GERAN_Cell_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___GERAN_Cell_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GERAN_Cell_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____GERAN_Cell_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERAN_Cell_ID_iE_Extensions__item__criticality._const_tab = ____GERAN_Cell_ID_iE_Extensions__item__criticality_tab
    ___GERAN_Cell_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GERAN_Cell_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GERAN_Cell_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GERAN_Cell_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____GERAN_Cell_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERAN_Cell_ID_iE_Extensions__item__extensionValue._const_tab = ____GERAN_Cell_ID_iE_Extensions__item__extensionValue_tab
    ___GERAN_Cell_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GERAN_Cell_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GERAN_Cell_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GERAN_Cell_ID_iE_Extensions__item__id),
        (u'criticality', ___GERAN_Cell_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___GERAN_Cell_ID_iE_Extensions__item__extensionValue),
        ])
    __GERAN_Cell_ID_iE_Extensions__item_._ext = None
    _GERAN_Cell_ID_iE_Extensions._cont = __GERAN_Cell_ID_iE_Extensions__item_
    _GERAN_Cell_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GERAN_Cell_ID._cont = ASN1Dict([
        (u'lAI', _GERAN_Cell_ID_lAI),
        (u'rAC', _GERAN_Cell_ID_rAC),
        (u'cI', _GERAN_Cell_ID_cI),
        (u'iE-Extensions', _GERAN_Cell_ID_iE_Extensions),
        ])
    GERAN_Cell_ID._ext = []
    
    #-----< GERAN-Cell-ID-ExtIEs >-----#
    GERAN_Cell_ID_ExtIEs = CLASS(name=u'GERAN-Cell-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    GERAN_Cell_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Global-ENB-ID >-----#
    Global_ENB_ID = SEQ(name=u'Global-ENB-ID', mode=MODE_TYPE)
    _Global_ENB_ID_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _Global_ENB_ID_eNB_ID = CHOICE(name=u'eNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ENB-ID')))
    _Global_ENB_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Global_ENB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___Global_ENB_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Global_ENB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Global_ENB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Global_ENB_ID_iE_Extensions__item__id._const_tab = ____Global_ENB_ID_iE_Extensions__item__id_tab
    ___Global_ENB_ID_iE_Extensions__item__id._const_tab_at = None
    ___Global_ENB_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___Global_ENB_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Global_ENB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Global_ENB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Global_ENB_ID_iE_Extensions__item__criticality._const_tab = ____Global_ENB_ID_iE_Extensions__item__criticality_tab
    ___Global_ENB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Global_ENB_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Global_ENB_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Global_ENB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Global_ENB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Global_ENB_ID_iE_Extensions__item__extensionValue._const_tab = ____Global_ENB_ID_iE_Extensions__item__extensionValue_tab
    ___Global_ENB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Global_ENB_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Global_ENB_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Global_ENB_ID_iE_Extensions__item__id),
        (u'criticality', ___Global_ENB_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___Global_ENB_ID_iE_Extensions__item__extensionValue),
        ])
    __Global_ENB_ID_iE_Extensions__item_._ext = None
    _Global_ENB_ID_iE_Extensions._cont = __Global_ENB_ID_iE_Extensions__item_
    _Global_ENB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Global_ENB_ID._cont = ASN1Dict([
        (u'pLMNidentity', _Global_ENB_ID_pLMNidentity),
        (u'eNB-ID', _Global_ENB_ID_eNB_ID),
        (u'iE-Extensions', _Global_ENB_ID_iE_Extensions),
        ])
    Global_ENB_ID._ext = []
    
    #-----< GlobalENB-ID-ExtIEs >-----#
    GlobalENB_ID_ExtIEs = CLASS(name=u'GlobalENB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    GlobalENB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Global-en-gNB-ID >-----#
    Global_en_gNB_ID = SEQ(name=u'Global-en-gNB-ID', mode=MODE_TYPE)
    _Global_en_gNB_ID_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _Global_en_gNB_ID_en_gNB_ID = BIT_STR(name=u'en-gNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'En-gNB-ID')))
    _Global_en_gNB_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Global_en_gNB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___Global_en_gNB_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Global_en_gNB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Global_en_gNB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Global_en_gNB_ID_iE_Extensions__item__id._const_tab = ____Global_en_gNB_ID_iE_Extensions__item__id_tab
    ___Global_en_gNB_ID_iE_Extensions__item__id._const_tab_at = None
    ___Global_en_gNB_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___Global_en_gNB_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Global_en_gNB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Global_en_gNB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Global_en_gNB_ID_iE_Extensions__item__criticality._const_tab = ____Global_en_gNB_ID_iE_Extensions__item__criticality_tab
    ___Global_en_gNB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Global_en_gNB_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Global_en_gNB_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Global_en_gNB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Global_en_gNB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Global_en_gNB_ID_iE_Extensions__item__extensionValue._const_tab = ____Global_en_gNB_ID_iE_Extensions__item__extensionValue_tab
    ___Global_en_gNB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Global_en_gNB_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Global_en_gNB_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Global_en_gNB_ID_iE_Extensions__item__id),
        (u'criticality', ___Global_en_gNB_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___Global_en_gNB_ID_iE_Extensions__item__extensionValue),
        ])
    __Global_en_gNB_ID_iE_Extensions__item_._ext = None
    _Global_en_gNB_ID_iE_Extensions._cont = __Global_en_gNB_ID_iE_Extensions__item_
    _Global_en_gNB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Global_en_gNB_ID._cont = ASN1Dict([
        (u'pLMNidentity', _Global_en_gNB_ID_pLMNidentity),
        (u'en-gNB-ID', _Global_en_gNB_ID_en_gNB_ID),
        (u'iE-Extensions', _Global_en_gNB_ID_iE_Extensions),
        ])
    Global_en_gNB_ID._ext = []
    
    #-----< Global-en-gNB-ID-ExtIEs >-----#
    Global_en_gNB_ID_ExtIEs = CLASS(name=u'Global-en-gNB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    Global_en_gNB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GUMMEIList >-----#
    GUMMEIList = SEQ_OF(name=u'GUMMEIList', mode=MODE_TYPE)
    _GUMMEIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEI')))
    GUMMEIList._cont = _GUMMEIList__item_
    GUMMEIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ENB-StatusTransfer-TransparentContainer >-----#
    ENB_StatusTransfer_TransparentContainer = SEQ(name=u'ENB-StatusTransfer-TransparentContainer', mode=MODE_TYPE)
    _ENB_StatusTransfer_TransparentContainer_bearers_SubjectToStatusTransferList = SEQ_OF(name=u'bearers-SubjectToStatusTransferList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Bearers-SubjectToStatusTransferList')))
    _ENB_StatusTransfer_TransparentContainer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ENB_StatusTransfer_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab = ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__id_tab
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__id._const_tab_id = u'id'
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ENB_StatusTransfer_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__id),
        (u'criticality', ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__criticality),
        (u'extensionValue', ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __ENB_StatusTransfer_TransparentContainer_iE_Extensions__item_._ext = None
    _ENB_StatusTransfer_TransparentContainer_iE_Extensions._cont = __ENB_StatusTransfer_TransparentContainer_iE_Extensions__item_
    _ENB_StatusTransfer_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ENB_StatusTransfer_TransparentContainer._cont = ASN1Dict([
        (u'bearers-SubjectToStatusTransferList', _ENB_StatusTransfer_TransparentContainer_bearers_SubjectToStatusTransferList),
        (u'iE-Extensions', _ENB_StatusTransfer_TransparentContainer_iE_Extensions),
        ])
    ENB_StatusTransfer_TransparentContainer._ext = []
    
    #-----< ENB-StatusTransfer-TransparentContainer-ExtIEs >-----#
    ENB_StatusTransfer_TransparentContainer_ExtIEs = CLASS(name=u'ENB-StatusTransfer-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ENB_StatusTransfer_TransparentContainer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ENB-UE-S1AP-ID >-----#
    ENB_UE_S1AP_ID = INT(name=u'ENB-UE-S1AP-ID', mode=MODE_TYPE)
    ENB_UE_S1AP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    
    #-----< ENBname >-----#
    ENBname = STR_PRINT(name=u'ENBname', mode=MODE_TYPE)
    ENBname._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< ENBX2TLAs >-----#
    ENBX2TLAs = SEQ_OF(name=u'ENBX2TLAs', mode=MODE_TYPE)
    _ENBX2TLAs__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    ENBX2TLAs._cont = _ENBX2TLAs__item_
    ENBX2TLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< EncryptionAlgorithms >-----#
    EncryptionAlgorithms = BIT_STR(name=u'EncryptionAlgorithms', mode=MODE_TYPE)
    EncryptionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< EN-DCSONConfigurationTransfer >-----#
    EN_DCSONConfigurationTransfer = SEQ(name=u'EN-DCSONConfigurationTransfer', mode=MODE_TYPE)
    _EN_DCSONConfigurationTransfer_transfertype = CHOICE(name=u'transfertype', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EN-DCSONTransferType')))
    _EN_DCSONConfigurationTransfer_sONInformation = CHOICE(name=u'sONInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SONInformation')))
    _EN_DCSONConfigurationTransfer_x2TNLConfigInfo = SEQ(name=u'x2TNLConfigInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'X2TNLConfigurationInfo')), opt=True)
    _EN_DCSONConfigurationTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EN_DCSONConfigurationTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____EN_DCSONConfigurationTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCSONConfigurationTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__id._const_tab = ____EN_DCSONConfigurationTransfer_iE_Extensions__item__id_tab
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__id._const_tab_at = None
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EN_DCSONConfigurationTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCSONConfigurationTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__criticality._const_tab = ____EN_DCSONConfigurationTransfer_iE_Extensions__item__criticality_tab
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EN_DCSONConfigurationTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCSONConfigurationTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab = ____EN_DCSONConfigurationTransfer_iE_Extensions__item__extensionValue_tab
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EN_DCSONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EN_DCSONConfigurationTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EN_DCSONConfigurationTransfer_iE_Extensions__item__id),
        (u'criticality', ___EN_DCSONConfigurationTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___EN_DCSONConfigurationTransfer_iE_Extensions__item__extensionValue),
        ])
    __EN_DCSONConfigurationTransfer_iE_Extensions__item_._ext = None
    _EN_DCSONConfigurationTransfer_iE_Extensions._cont = __EN_DCSONConfigurationTransfer_iE_Extensions__item_
    _EN_DCSONConfigurationTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EN_DCSONConfigurationTransfer._cont = ASN1Dict([
        (u'transfertype', _EN_DCSONConfigurationTransfer_transfertype),
        (u'sONInformation', _EN_DCSONConfigurationTransfer_sONInformation),
        (u'x2TNLConfigInfo', _EN_DCSONConfigurationTransfer_x2TNLConfigInfo),
        (u'iE-Extensions', _EN_DCSONConfigurationTransfer_iE_Extensions),
        ])
    EN_DCSONConfigurationTransfer._ext = []
    
    #-----< EN-DCSONConfigurationTransfer-ExtIEs >-----#
    EN_DCSONConfigurationTransfer_ExtIEs = CLASS(name=u'EN-DCSONConfigurationTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    EN_DCSONConfigurationTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EN-DCSONTransferType >-----#
    EN_DCSONTransferType = CHOICE(name=u'EN-DCSONTransferType', mode=MODE_TYPE)
    _EN_DCSONTransferType_request = SEQ(name=u'request', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EN-DCTransferTypeRequest')))
    _EN_DCSONTransferType_reply = SEQ(name=u'reply', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EN-DCTransferTypeReply')))
    EN_DCSONTransferType._cont = ASN1Dict([
        (u'request', _EN_DCSONTransferType_request),
        (u'reply', _EN_DCSONTransferType_reply),
        ])
    EN_DCSONTransferType._ext = []
    
    #-----< EN-DCTransferTypeRequest >-----#
    EN_DCTransferTypeRequest = SEQ(name=u'EN-DCTransferTypeRequest', mode=MODE_TYPE)
    _EN_DCTransferTypeRequest_sourceeNB = SEQ(name=u'sourceeNB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EN-DCSONeNBIdentification')))
    _EN_DCTransferTypeRequest_targetengNB = SEQ(name=u'targetengNB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EN-DCSONengNBIdentification')))
    _EN_DCTransferTypeRequest_targeteNB = SEQ(name=u'targeteNB', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EN-DCSONeNBIdentification')), opt=True)
    _EN_DCTransferTypeRequest_associatedTAI = SEQ(name=u'associatedTAI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI')), opt=True)
    _EN_DCTransferTypeRequest_broadcast5GSTAI = SEQ(name=u'broadcast5GSTAI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'FiveGSTAI')), opt=True)
    _EN_DCTransferTypeRequest_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EN_DCTransferTypeRequest_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___EN_DCTransferTypeRequest_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____EN_DCTransferTypeRequest_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCTransferTypeRequest_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCTransferTypeRequest_iE_Extensions__item__id._const_tab = ____EN_DCTransferTypeRequest_iE_Extensions__item__id_tab
    ___EN_DCTransferTypeRequest_iE_Extensions__item__id._const_tab_at = None
    ___EN_DCTransferTypeRequest_iE_Extensions__item__id._const_tab_id = u'id'
    ___EN_DCTransferTypeRequest_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EN_DCTransferTypeRequest_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCTransferTypeRequest_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCTransferTypeRequest_iE_Extensions__item__criticality._const_tab = ____EN_DCTransferTypeRequest_iE_Extensions__item__criticality_tab
    ___EN_DCTransferTypeRequest_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EN_DCTransferTypeRequest_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EN_DCTransferTypeRequest_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EN_DCTransferTypeRequest_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCTransferTypeRequest_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCTransferTypeRequest_iE_Extensions__item__extensionValue._const_tab = ____EN_DCTransferTypeRequest_iE_Extensions__item__extensionValue_tab
    ___EN_DCTransferTypeRequest_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EN_DCTransferTypeRequest_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EN_DCTransferTypeRequest_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EN_DCTransferTypeRequest_iE_Extensions__item__id),
        (u'criticality', ___EN_DCTransferTypeRequest_iE_Extensions__item__criticality),
        (u'extensionValue', ___EN_DCTransferTypeRequest_iE_Extensions__item__extensionValue),
        ])
    __EN_DCTransferTypeRequest_iE_Extensions__item_._ext = None
    _EN_DCTransferTypeRequest_iE_Extensions._cont = __EN_DCTransferTypeRequest_iE_Extensions__item_
    _EN_DCTransferTypeRequest_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EN_DCTransferTypeRequest._cont = ASN1Dict([
        (u'sourceeNB', _EN_DCTransferTypeRequest_sourceeNB),
        (u'targetengNB', _EN_DCTransferTypeRequest_targetengNB),
        (u'targeteNB', _EN_DCTransferTypeRequest_targeteNB),
        (u'associatedTAI', _EN_DCTransferTypeRequest_associatedTAI),
        (u'broadcast5GSTAI', _EN_DCTransferTypeRequest_broadcast5GSTAI),
        (u'iE-Extensions', _EN_DCTransferTypeRequest_iE_Extensions),
        ])
    EN_DCTransferTypeRequest._ext = []
    
    #-----< EN-DCTransferTypeRequest-ExtIEs >-----#
    EN_DCTransferTypeRequest_ExtIEs = CLASS(name=u'EN-DCTransferTypeRequest-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    EN_DCTransferTypeRequest_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EN-DCTransferTypeReply >-----#
    EN_DCTransferTypeReply = SEQ(name=u'EN-DCTransferTypeReply', mode=MODE_TYPE)
    _EN_DCTransferTypeReply_sourceengNB = SEQ(name=u'sourceengNB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EN-DCSONengNBIdentification')))
    _EN_DCTransferTypeReply_targeteNB = SEQ(name=u'targeteNB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EN-DCSONeNBIdentification')))
    _EN_DCTransferTypeReply_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EN_DCTransferTypeReply_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___EN_DCTransferTypeReply_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____EN_DCTransferTypeReply_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCTransferTypeReply_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCTransferTypeReply_iE_Extensions__item__id._const_tab = ____EN_DCTransferTypeReply_iE_Extensions__item__id_tab
    ___EN_DCTransferTypeReply_iE_Extensions__item__id._const_tab_at = None
    ___EN_DCTransferTypeReply_iE_Extensions__item__id._const_tab_id = u'id'
    ___EN_DCTransferTypeReply_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EN_DCTransferTypeReply_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCTransferTypeReply_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCTransferTypeReply_iE_Extensions__item__criticality._const_tab = ____EN_DCTransferTypeReply_iE_Extensions__item__criticality_tab
    ___EN_DCTransferTypeReply_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EN_DCTransferTypeReply_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EN_DCTransferTypeReply_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EN_DCTransferTypeReply_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCTransferTypeReply_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCTransferTypeReply_iE_Extensions__item__extensionValue._const_tab = ____EN_DCTransferTypeReply_iE_Extensions__item__extensionValue_tab
    ___EN_DCTransferTypeReply_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EN_DCTransferTypeReply_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EN_DCTransferTypeReply_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EN_DCTransferTypeReply_iE_Extensions__item__id),
        (u'criticality', ___EN_DCTransferTypeReply_iE_Extensions__item__criticality),
        (u'extensionValue', ___EN_DCTransferTypeReply_iE_Extensions__item__extensionValue),
        ])
    __EN_DCTransferTypeReply_iE_Extensions__item_._ext = None
    _EN_DCTransferTypeReply_iE_Extensions._cont = __EN_DCTransferTypeReply_iE_Extensions__item_
    _EN_DCTransferTypeReply_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EN_DCTransferTypeReply._cont = ASN1Dict([
        (u'sourceengNB', _EN_DCTransferTypeReply_sourceengNB),
        (u'targeteNB', _EN_DCTransferTypeReply_targeteNB),
        (u'iE-Extensions', _EN_DCTransferTypeReply_iE_Extensions),
        ])
    EN_DCTransferTypeReply._ext = []
    
    #-----< EN-DCTransferTypeReply-ExtIEs >-----#
    EN_DCTransferTypeReply_ExtIEs = CLASS(name=u'EN-DCTransferTypeReply-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    EN_DCTransferTypeReply_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EN-DCSONeNBIdentification >-----#
    EN_DCSONeNBIdentification = SEQ(name=u'EN-DCSONeNBIdentification', mode=MODE_TYPE)
    _EN_DCSONeNBIdentification_globaleNBID = SEQ(name=u'globaleNBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    _EN_DCSONeNBIdentification_selectedTAI = SEQ(name=u'selectedTAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _EN_DCSONeNBIdentification_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EN_DCSONeNBIdentification_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___EN_DCSONeNBIdentification_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____EN_DCSONeNBIdentification_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCSONeNBIdentification_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCSONeNBIdentification_iE_Extensions__item__id._const_tab = ____EN_DCSONeNBIdentification_iE_Extensions__item__id_tab
    ___EN_DCSONeNBIdentification_iE_Extensions__item__id._const_tab_at = None
    ___EN_DCSONeNBIdentification_iE_Extensions__item__id._const_tab_id = u'id'
    ___EN_DCSONeNBIdentification_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EN_DCSONeNBIdentification_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCSONeNBIdentification_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCSONeNBIdentification_iE_Extensions__item__criticality._const_tab = ____EN_DCSONeNBIdentification_iE_Extensions__item__criticality_tab
    ___EN_DCSONeNBIdentification_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EN_DCSONeNBIdentification_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EN_DCSONeNBIdentification_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EN_DCSONeNBIdentification_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCSONeNBIdentification_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCSONeNBIdentification_iE_Extensions__item__extensionValue._const_tab = ____EN_DCSONeNBIdentification_iE_Extensions__item__extensionValue_tab
    ___EN_DCSONeNBIdentification_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EN_DCSONeNBIdentification_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EN_DCSONeNBIdentification_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EN_DCSONeNBIdentification_iE_Extensions__item__id),
        (u'criticality', ___EN_DCSONeNBIdentification_iE_Extensions__item__criticality),
        (u'extensionValue', ___EN_DCSONeNBIdentification_iE_Extensions__item__extensionValue),
        ])
    __EN_DCSONeNBIdentification_iE_Extensions__item_._ext = None
    _EN_DCSONeNBIdentification_iE_Extensions._cont = __EN_DCSONeNBIdentification_iE_Extensions__item_
    _EN_DCSONeNBIdentification_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EN_DCSONeNBIdentification._cont = ASN1Dict([
        (u'globaleNBID', _EN_DCSONeNBIdentification_globaleNBID),
        (u'selectedTAI', _EN_DCSONeNBIdentification_selectedTAI),
        (u'iE-Extensions', _EN_DCSONeNBIdentification_iE_Extensions),
        ])
    EN_DCSONeNBIdentification._ext = []
    
    #-----< EN-DCSONeNBIdentification-ExtIEs >-----#
    EN_DCSONeNBIdentification_ExtIEs = CLASS(name=u'EN-DCSONeNBIdentification-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    EN_DCSONeNBIdentification_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EN-DCSONengNBIdentification >-----#
    EN_DCSONengNBIdentification = SEQ(name=u'EN-DCSONengNBIdentification', mode=MODE_TYPE)
    _EN_DCSONengNBIdentification_globalengNBID = SEQ(name=u'globalengNBID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Global-en-gNB-ID')))
    _EN_DCSONengNBIdentification_selectedTAI = SEQ(name=u'selectedTAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _EN_DCSONengNBIdentification_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EN_DCSONengNBIdentification_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___EN_DCSONengNBIdentification_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____EN_DCSONengNBIdentification_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCSONengNBIdentification_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCSONengNBIdentification_iE_Extensions__item__id._const_tab = ____EN_DCSONengNBIdentification_iE_Extensions__item__id_tab
    ___EN_DCSONengNBIdentification_iE_Extensions__item__id._const_tab_at = None
    ___EN_DCSONengNBIdentification_iE_Extensions__item__id._const_tab_id = u'id'
    ___EN_DCSONengNBIdentification_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EN_DCSONengNBIdentification_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCSONengNBIdentification_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCSONengNBIdentification_iE_Extensions__item__criticality._const_tab = ____EN_DCSONengNBIdentification_iE_Extensions__item__criticality_tab
    ___EN_DCSONengNBIdentification_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EN_DCSONengNBIdentification_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EN_DCSONengNBIdentification_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EN_DCSONengNBIdentification_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EN_DCSONengNBIdentification_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EN_DCSONengNBIdentification_iE_Extensions__item__extensionValue._const_tab = ____EN_DCSONengNBIdentification_iE_Extensions__item__extensionValue_tab
    ___EN_DCSONengNBIdentification_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EN_DCSONengNBIdentification_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EN_DCSONengNBIdentification_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EN_DCSONengNBIdentification_iE_Extensions__item__id),
        (u'criticality', ___EN_DCSONengNBIdentification_iE_Extensions__item__criticality),
        (u'extensionValue', ___EN_DCSONengNBIdentification_iE_Extensions__item__extensionValue),
        ])
    __EN_DCSONengNBIdentification_iE_Extensions__item_._ext = None
    _EN_DCSONengNBIdentification_iE_Extensions._cont = __EN_DCSONengNBIdentification_iE_Extensions__item_
    _EN_DCSONengNBIdentification_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EN_DCSONengNBIdentification._cont = ASN1Dict([
        (u'globalengNBID', _EN_DCSONengNBIdentification_globalengNBID),
        (u'selectedTAI', _EN_DCSONengNBIdentification_selectedTAI),
        (u'iE-Extensions', _EN_DCSONengNBIdentification_iE_Extensions),
        ])
    EN_DCSONengNBIdentification._ext = []
    
    #-----< EN-DCSONengNBIdentification-ExtIEs >-----#
    EN_DCSONengNBIdentification_ExtIEs = CLASS(name=u'EN-DCSONengNBIdentification-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    EN_DCSONengNBIdentification_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EndIndication >-----#
    EndIndication = ENUM(name=u'EndIndication', mode=MODE_TYPE)
    EndIndication._cont = ASN1Dict([(u'no-further-data', 0), (u'further-data-exists', 1)])
    EndIndication._ext = []
    
    #-----< EnhancedCoverageRestricted >-----#
    EnhancedCoverageRestricted = ENUM(name=u'EnhancedCoverageRestricted', mode=MODE_TYPE)
    EnhancedCoverageRestricted._cont = ASN1Dict([(u'restricted', 0)])
    EnhancedCoverageRestricted._ext = []
    
    #-----< CE-ModeBRestricted >-----#
    CE_ModeBRestricted = ENUM(name=u'CE-ModeBRestricted', mode=MODE_TYPE)
    CE_ModeBRestricted._cont = ASN1Dict([(u'restricted', 0), (u'not-restricted', 1)])
    CE_ModeBRestricted._ext = []
    
    #-----< EPLMNs >-----#
    EPLMNs = SEQ_OF(name=u'EPLMNs', mode=MODE_TYPE)
    _EPLMNs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    EPLMNs._cont = _EPLMNs__item_
    EPLMNs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< EventType >-----#
    EventType = ENUM(name=u'EventType', mode=MODE_TYPE)
    EventType._cont = ASN1Dict([(u'direct', 0), (u'change-of-serve-cell', 1), (u'stop-change-of-serve-cell', 2)])
    EventType._ext = []
    
    #-----< E-RAB-ID >-----#
    E_RAB_ID = INT(name=u'E-RAB-ID', mode=MODE_TYPE)
    E_RAB_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    
    #-----< E-RABInformationList >-----#
    E_RABInformationList = SEQ_OF(name=u'E-RABInformationList', mode=MODE_TYPE)
    _E_RABInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABInformationList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___E_RABInformationList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABInformationList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABInformationListItem')))
    ___E_RABInformationList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'ignore'), (u'Value', ____E_RABInformationList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABInformationList__item__id._const_tab = ___E_RABInformationList__item__id_tab
    __E_RABInformationList__item__id._const_tab_at = None
    __E_RABInformationList__item__id._const_tab_id = u'id'
    __E_RABInformationList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABInformationList__item__criticality._const_tab = ___E_RABInformationList__item__id_tab
    __E_RABInformationList__item__criticality._const_tab_at = ('..', u'id')
    __E_RABInformationList__item__criticality._const_tab_id = u'criticality'
    __E_RABInformationList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __E_RABInformationList__item__value._const_tab = ___E_RABInformationList__item__id_tab
    __E_RABInformationList__item__value._const_tab_at = ('..', u'id')
    __E_RABInformationList__item__value._const_tab_id = u'Value'
    _E_RABInformationList__item_._cont = ASN1Dict([
        (u'id', __E_RABInformationList__item__id),
        (u'criticality', __E_RABInformationList__item__criticality),
        (u'value', __E_RABInformationList__item__value),
        ])
    _E_RABInformationList__item_._ext = None
    E_RABInformationList._cont = _E_RABInformationList__item_
    E_RABInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABInformationListIEs >-----#
    E_RABInformationListIEs = CLASS(name=u'E-RABInformationListIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABInformationListIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABInformationListItem')))
    E_RABInformationListIEs._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'ignore'), (u'Value', _E_RABInformationListIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABInformationListItem >-----#
    E_RABInformationListItem = SEQ(name=u'E-RABInformationListItem', mode=MODE_TYPE)
    _E_RABInformationListItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABInformationListItem_dL_Forwarding = ENUM(name=u'dL-Forwarding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'DL-Forwarding')), opt=True)
    _E_RABInformationListItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABInformationListItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABInformationListItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABInformationListItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____E_RABInformationListItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DAPSRequestInfo')))
    _____E_RABInformationListItem_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _____E_RABInformationListItem_iE_Extensions__item__id_tab_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    ____E_RABInformationListItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 317), (u'criticality', u'ignore'), (u'Extension', _____E_RABInformationListItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 328), (u'criticality', u'ignore'), (u'Extension', _____E_RABInformationListItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 340), (u'criticality', u'ignore'), (u'Extension', _____E_RABInformationListItem_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABInformationListItem_iE_Extensions__item__id._const_tab = ____E_RABInformationListItem_iE_Extensions__item__id_tab
    ___E_RABInformationListItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABInformationListItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABInformationListItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABInformationListItem_iE_Extensions__item__criticality._const_tab = ____E_RABInformationListItem_iE_Extensions__item__id_tab
    ___E_RABInformationListItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABInformationListItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABInformationListItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABInformationListItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABInformationListItem_iE_Extensions__item__id_tab
    ___E_RABInformationListItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABInformationListItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABInformationListItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABInformationListItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABInformationListItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABInformationListItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABInformationListItem_iE_Extensions__item_._ext = None
    _E_RABInformationListItem_iE_Extensions._cont = __E_RABInformationListItem_iE_Extensions__item_
    _E_RABInformationListItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABInformationListItem._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABInformationListItem_e_RAB_ID),
        (u'dL-Forwarding', _E_RABInformationListItem_dL_Forwarding),
        (u'iE-Extensions', _E_RABInformationListItem_iE_Extensions),
        ])
    E_RABInformationListItem._ext = []
    
    #-----< E-RABInformationListItem-ExtIEs >-----#
    E_RABInformationListItem_ExtIEs = CLASS(name=u'E-RABInformationListItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _E_RABInformationListItem_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DAPSRequestInfo')))
    _E_RABInformationListItem_ExtIEs_val_Extension_1 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABInformationListItem_ExtIEs_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    E_RABInformationListItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 317), (u'criticality', u'ignore'), (u'Extension', _E_RABInformationListItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 328), (u'criticality', u'ignore'), (u'Extension', _E_RABInformationListItem_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 340), (u'criticality', u'ignore'), (u'Extension', _E_RABInformationListItem_ExtIEs_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABList >-----#
    E_RABList = SEQ_OF(name=u'E-RABList', mode=MODE_TYPE)
    _E_RABList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___E_RABList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABItem')))
    ___E_RABList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 35), (u'criticality', u'ignore'), (u'Value', ____E_RABList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABList__item__id._const_tab = ___E_RABList__item__id_tab
    __E_RABList__item__id._const_tab_at = None
    __E_RABList__item__id._const_tab_id = u'id'
    __E_RABList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABList__item__criticality._const_tab = ___E_RABList__item__id_tab
    __E_RABList__item__criticality._const_tab_at = ('..', u'id')
    __E_RABList__item__criticality._const_tab_id = u'criticality'
    __E_RABList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __E_RABList__item__value._const_tab = ___E_RABList__item__id_tab
    __E_RABList__item__value._const_tab_at = ('..', u'id')
    __E_RABList__item__value._const_tab_id = u'Value'
    _E_RABList__item_._cont = ASN1Dict([
        (u'id', __E_RABList__item__id),
        (u'criticality', __E_RABList__item__criticality),
        (u'value', __E_RABList__item__value),
        ])
    _E_RABList__item_._ext = None
    E_RABList._cont = _E_RABList__item_
    E_RABList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABItemIEs >-----#
    E_RABItemIEs = CLASS(name=u'E-RABItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABItem')))
    E_RABItemIEs._val = ASN1Set(rv=[dict([(u'id', 35), (u'criticality', u'ignore'), (u'Value', _E_RABItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABItem >-----#
    E_RABItem = SEQ(name=u'E-RABItem', mode=MODE_TYPE)
    _E_RABItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABItem_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _E_RABItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABItem_iE_Extensions__item__id._const_tab = ____E_RABItem_iE_Extensions__item__id_tab
    ___E_RABItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABItem_iE_Extensions__item__criticality._const_tab = ____E_RABItem_iE_Extensions__item__criticality_tab
    ___E_RABItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABItem_iE_Extensions__item__extensionValue_tab
    ___E_RABItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABItem_iE_Extensions__item_._ext = None
    _E_RABItem_iE_Extensions._cont = __E_RABItem_iE_Extensions__item_
    _E_RABItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABItem._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABItem_e_RAB_ID),
        (u'cause', _E_RABItem_cause),
        (u'iE-Extensions', _E_RABItem_iE_Extensions),
        ])
    E_RABItem._ext = []
    
    #-----< E-RABItem-ExtIEs >-----#
    E_RABItem_ExtIEs = CLASS(name=u'E-RABItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABLevelQoSParameters >-----#
    E_RABLevelQoSParameters = SEQ(name=u'E-RABLevelQoSParameters', mode=MODE_TYPE)
    _E_RABLevelQoSParameters_qCI = INT(name=u'qCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'QCI')))
    _E_RABLevelQoSParameters_allocationRetentionPriority = SEQ(name=u'allocationRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'AllocationAndRetentionPriority')))
    _E_RABLevelQoSParameters_gbrQosInformation = SEQ(name=u'gbrQosInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GBR-QosInformation')), opt=True)
    _E_RABLevelQoSParameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABLevelQoSParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABLevelQoSParameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABLevelQoSParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____E_RABLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Packet-LossRate')))
    _____E_RABLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Packet-LossRate')))
    ____E_RABLevelQoSParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 273), (u'criticality', u'ignore'), (u'Extension', _____E_RABLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 274), (u'criticality', u'ignore'), (u'Extension', _____E_RABLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABLevelQoSParameters_iE_Extensions__item__id._const_tab = ____E_RABLevelQoSParameters_iE_Extensions__item__id_tab
    ___E_RABLevelQoSParameters_iE_Extensions__item__id._const_tab_at = None
    ___E_RABLevelQoSParameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABLevelQoSParameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABLevelQoSParameters_iE_Extensions__item__criticality._const_tab = ____E_RABLevelQoSParameters_iE_Extensions__item__id_tab
    ___E_RABLevelQoSParameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABLevelQoSParameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABLevelQoSParameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABLevelQoSParameters_iE_Extensions__item__extensionValue._const_tab = ____E_RABLevelQoSParameters_iE_Extensions__item__id_tab
    ___E_RABLevelQoSParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABLevelQoSParameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABLevelQoSParameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABLevelQoSParameters_iE_Extensions__item__id),
        (u'criticality', ___E_RABLevelQoSParameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABLevelQoSParameters_iE_Extensions__item__extensionValue),
        ])
    __E_RABLevelQoSParameters_iE_Extensions__item_._ext = None
    _E_RABLevelQoSParameters_iE_Extensions._cont = __E_RABLevelQoSParameters_iE_Extensions__item_
    _E_RABLevelQoSParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABLevelQoSParameters._cont = ASN1Dict([
        (u'qCI', _E_RABLevelQoSParameters_qCI),
        (u'allocationRetentionPriority', _E_RABLevelQoSParameters_allocationRetentionPriority),
        (u'gbrQosInformation', _E_RABLevelQoSParameters_gbrQosInformation),
        (u'iE-Extensions', _E_RABLevelQoSParameters_iE_Extensions),
        ])
    E_RABLevelQoSParameters._ext = []
    
    #-----< E-RABUsageReportList >-----#
    E_RABUsageReportList = SEQ_OF(name=u'E-RABUsageReportList', mode=MODE_TYPE)
    _E_RABUsageReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABUsageReportList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___E_RABUsageReportList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABUsageReportList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABUsageReportItem')))
    ___E_RABUsageReportList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 267), (u'criticality', u'ignore'), (u'Value', ____E_RABUsageReportList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABUsageReportList__item__id._const_tab = ___E_RABUsageReportList__item__id_tab
    __E_RABUsageReportList__item__id._const_tab_at = None
    __E_RABUsageReportList__item__id._const_tab_id = u'id'
    __E_RABUsageReportList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABUsageReportList__item__criticality._const_tab = ___E_RABUsageReportList__item__id_tab
    __E_RABUsageReportList__item__criticality._const_tab_at = ('..', u'id')
    __E_RABUsageReportList__item__criticality._const_tab_id = u'criticality'
    __E_RABUsageReportList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __E_RABUsageReportList__item__value._const_tab = ___E_RABUsageReportList__item__id_tab
    __E_RABUsageReportList__item__value._const_tab_at = ('..', u'id')
    __E_RABUsageReportList__item__value._const_tab_id = u'Value'
    _E_RABUsageReportList__item_._cont = ASN1Dict([
        (u'id', __E_RABUsageReportList__item__id),
        (u'criticality', __E_RABUsageReportList__item__criticality),
        (u'value', __E_RABUsageReportList__item__value),
        ])
    _E_RABUsageReportList__item_._ext = None
    E_RABUsageReportList._cont = _E_RABUsageReportList__item_
    E_RABUsageReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< E-RABUsageReportItemIEs >-----#
    E_RABUsageReportItemIEs = CLASS(name=u'E-RABUsageReportItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABUsageReportItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABUsageReportItem')))
    E_RABUsageReportItemIEs._val = ASN1Set(rv=[dict([(u'id', 267), (u'criticality', u'ignore'), (u'Value', _E_RABUsageReportItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABUsageReportItem >-----#
    E_RABUsageReportItem = SEQ(name=u'E-RABUsageReportItem', mode=MODE_TYPE)
    _E_RABUsageReportItem_startTimestamp = OCT_STR(name=u'startTimestamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_RABUsageReportItem_startTimestamp._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _E_RABUsageReportItem_endTimestamp = OCT_STR(name=u'endTimestamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_RABUsageReportItem_endTimestamp._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _E_RABUsageReportItem_usageCountUL = INT(name=u'usageCountUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_RABUsageReportItem_usageCountUL._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=18446744073709551615)], ev=None, er=[])
    _E_RABUsageReportItem_usageCountDL = INT(name=u'usageCountDL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_RABUsageReportItem_usageCountDL._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=18446744073709551615)], ev=None, er=[])
    _E_RABUsageReportItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABUsageReportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABUsageReportItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABUsageReportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABUsageReportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABUsageReportItem_iE_Extensions__item__id._const_tab = ____E_RABUsageReportItem_iE_Extensions__item__id_tab
    ___E_RABUsageReportItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABUsageReportItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABUsageReportItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABUsageReportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABUsageReportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABUsageReportItem_iE_Extensions__item__criticality._const_tab = ____E_RABUsageReportItem_iE_Extensions__item__criticality_tab
    ___E_RABUsageReportItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABUsageReportItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABUsageReportItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABUsageReportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABUsageReportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABUsageReportItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABUsageReportItem_iE_Extensions__item__extensionValue_tab
    ___E_RABUsageReportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABUsageReportItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABUsageReportItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABUsageReportItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABUsageReportItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABUsageReportItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABUsageReportItem_iE_Extensions__item_._ext = None
    _E_RABUsageReportItem_iE_Extensions._cont = __E_RABUsageReportItem_iE_Extensions__item_
    _E_RABUsageReportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABUsageReportItem._cont = ASN1Dict([
        (u'startTimestamp', _E_RABUsageReportItem_startTimestamp),
        (u'endTimestamp', _E_RABUsageReportItem_endTimestamp),
        (u'usageCountUL', _E_RABUsageReportItem_usageCountUL),
        (u'usageCountDL', _E_RABUsageReportItem_usageCountDL),
        (u'iE-Extensions', _E_RABUsageReportItem_iE_Extensions),
        ])
    E_RABUsageReportItem._ext = []
    
    #-----< E-RABUsageReportItem-ExtIEs >-----#
    E_RABUsageReportItem_ExtIEs = CLASS(name=u'E-RABUsageReportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABUsageReportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABQoSParameters-ExtIEs >-----#
    E_RABQoSParameters_ExtIEs = CLASS(name=u'E-RABQoSParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _E_RABQoSParameters_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Packet-LossRate')))
    _E_RABQoSParameters_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Packet-LossRate')))
    E_RABQoSParameters_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 273), (u'criticality', u'ignore'), (u'Extension', _E_RABQoSParameters_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 274), (u'criticality', u'ignore'), (u'Extension', _E_RABQoSParameters_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Ethernet-Type >-----#
    Ethernet_Type = ENUM(name=u'Ethernet-Type', mode=MODE_TYPE)
    Ethernet_Type._cont = ASN1Dict([(u'true', 0)])
    Ethernet_Type._ext = []
    
    #-----< EUTRAN-CGI >-----#
    EUTRAN_CGI = SEQ(name=u'EUTRAN-CGI', mode=MODE_TYPE)
    _EUTRAN_CGI_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _EUTRAN_CGI_cell_ID = BIT_STR(name=u'cell-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CellIdentity')))
    _EUTRAN_CGI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EUTRAN_CGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___EUTRAN_CGI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____EUTRAN_CGI_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EUTRAN_CGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_CGI_iE_Extensions__item__id._const_tab = ____EUTRAN_CGI_iE_Extensions__item__id_tab
    ___EUTRAN_CGI_iE_Extensions__item__id._const_tab_at = None
    ___EUTRAN_CGI_iE_Extensions__item__id._const_tab_id = u'id'
    ___EUTRAN_CGI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EUTRAN_CGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EUTRAN_CGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_CGI_iE_Extensions__item__criticality._const_tab = ____EUTRAN_CGI_iE_Extensions__item__criticality_tab
    ___EUTRAN_CGI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EUTRAN_CGI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EUTRAN_CGI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EUTRAN_CGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____EUTRAN_CGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EUTRAN_CGI_iE_Extensions__item__extensionValue._const_tab = ____EUTRAN_CGI_iE_Extensions__item__extensionValue_tab
    ___EUTRAN_CGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EUTRAN_CGI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EUTRAN_CGI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EUTRAN_CGI_iE_Extensions__item__id),
        (u'criticality', ___EUTRAN_CGI_iE_Extensions__item__criticality),
        (u'extensionValue', ___EUTRAN_CGI_iE_Extensions__item__extensionValue),
        ])
    __EUTRAN_CGI_iE_Extensions__item_._ext = None
    _EUTRAN_CGI_iE_Extensions._cont = __EUTRAN_CGI_iE_Extensions__item_
    _EUTRAN_CGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EUTRAN_CGI._cont = ASN1Dict([
        (u'pLMNidentity', _EUTRAN_CGI_pLMNidentity),
        (u'cell-ID', _EUTRAN_CGI_cell_ID),
        (u'iE-Extensions', _EUTRAN_CGI_iE_Extensions),
        ])
    EUTRAN_CGI._ext = []
    
    #-----< EUTRAN-CGI-ExtIEs >-----#
    EUTRAN_CGI_ExtIEs = CLASS(name=u'EUTRAN-CGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    EUTRAN_CGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EUTRANRoundTripDelayEstimationInfo >-----#
    EUTRANRoundTripDelayEstimationInfo = INT(name=u'EUTRANRoundTripDelayEstimationInfo', mode=MODE_TYPE)
    EUTRANRoundTripDelayEstimationInfo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2047)], ev=None, er=[])
    
    #-----< ExpectedUEBehaviour >-----#
    ExpectedUEBehaviour = SEQ(name=u'ExpectedUEBehaviour', mode=MODE_TYPE)
    _ExpectedUEBehaviour_expectedActivity = SEQ(name=u'expectedActivity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ExpectedUEActivityBehaviour')), opt=True)
    _ExpectedUEBehaviour_expectedHOInterval = ENUM(name=u'expectedHOInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ExpectedHOInterval')), opt=True)
    _ExpectedUEBehaviour_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExpectedUEBehaviour_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ExpectedUEBehaviour_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ExpectedUEBehaviour_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ExpectedUEBehaviour_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEBehaviour_iE_Extensions__item__id._const_tab = ____ExpectedUEBehaviour_iE_Extensions__item__id_tab
    ___ExpectedUEBehaviour_iE_Extensions__item__id._const_tab_at = None
    ___ExpectedUEBehaviour_iE_Extensions__item__id._const_tab_id = u'id'
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ExpectedUEBehaviour_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ExpectedUEBehaviour_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality._const_tab = ____ExpectedUEBehaviour_iE_Extensions__item__criticality_tab
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ExpectedUEBehaviour_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ExpectedUEBehaviour_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ExpectedUEBehaviour_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue._const_tab = ____ExpectedUEBehaviour_iE_Extensions__item__extensionValue_tab
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ExpectedUEBehaviour_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ExpectedUEBehaviour_iE_Extensions__item__id),
        (u'criticality', ___ExpectedUEBehaviour_iE_Extensions__item__criticality),
        (u'extensionValue', ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue),
        ])
    __ExpectedUEBehaviour_iE_Extensions__item_._ext = None
    _ExpectedUEBehaviour_iE_Extensions._cont = __ExpectedUEBehaviour_iE_Extensions__item_
    _ExpectedUEBehaviour_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExpectedUEBehaviour._cont = ASN1Dict([
        (u'expectedActivity', _ExpectedUEBehaviour_expectedActivity),
        (u'expectedHOInterval', _ExpectedUEBehaviour_expectedHOInterval),
        (u'iE-Extensions', _ExpectedUEBehaviour_iE_Extensions),
        ])
    ExpectedUEBehaviour._ext = []
    
    #-----< ExpectedUEBehaviour-ExtIEs >-----#
    ExpectedUEBehaviour_ExtIEs = CLASS(name=u'ExpectedUEBehaviour-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ExpectedUEBehaviour_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExpectedUEActivityBehaviour >-----#
    ExpectedUEActivityBehaviour = SEQ(name=u'ExpectedUEActivityBehaviour', mode=MODE_TYPE)
    _ExpectedUEActivityBehaviour_expectedActivityPeriod = INT(name=u'expectedActivityPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ExpectedActivityPeriod')), opt=True)
    _ExpectedUEActivityBehaviour_expectedIdlePeriod = INT(name=u'expectedIdlePeriod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ExpectedIdlePeriod')), opt=True)
    _ExpectedUEActivityBehaviour_sourceofUEActivityBehaviourInformation = ENUM(name=u'sourceofUEActivityBehaviourInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SourceOfUEActivityBehaviourInformation')), opt=True)
    _ExpectedUEActivityBehaviour_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExpectedUEActivityBehaviour_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id._const_tab = ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id._const_tab_at = None
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__id._const_tab_id = u'id'
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality._const_tab = ____ExpectedUEActivityBehaviour_iE_Extensions__item__criticality_tab
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue._const_tab = ____ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue_tab
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ExpectedUEActivityBehaviour_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ExpectedUEActivityBehaviour_iE_Extensions__item__id),
        (u'criticality', ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality),
        (u'extensionValue', ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue),
        ])
    __ExpectedUEActivityBehaviour_iE_Extensions__item_._ext = None
    _ExpectedUEActivityBehaviour_iE_Extensions._cont = __ExpectedUEActivityBehaviour_iE_Extensions__item_
    _ExpectedUEActivityBehaviour_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExpectedUEActivityBehaviour._cont = ASN1Dict([
        (u'expectedActivityPeriod', _ExpectedUEActivityBehaviour_expectedActivityPeriod),
        (u'expectedIdlePeriod', _ExpectedUEActivityBehaviour_expectedIdlePeriod),
        (u'sourceofUEActivityBehaviourInformation', _ExpectedUEActivityBehaviour_sourceofUEActivityBehaviourInformation),
        (u'iE-Extensions', _ExpectedUEActivityBehaviour_iE_Extensions),
        ])
    ExpectedUEActivityBehaviour._ext = []
    
    #-----< ExpectedUEActivityBehaviour-ExtIEs >-----#
    ExpectedUEActivityBehaviour_ExtIEs = CLASS(name=u'ExpectedUEActivityBehaviour-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ExpectedUEActivityBehaviour_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExpectedActivityPeriod >-----#
    ExpectedActivityPeriod = INT(name=u'ExpectedActivityPeriod', mode=MODE_TYPE)
    ExpectedActivityPeriod._const_val = ASN1Set(rv=[40, 50, 60, 80, 100, 120, 150, 180, 181], rr=[ASN1RangeInt(lb=1, ub=30)], ev=[], er=[])
    
    #-----< ExpectedIdlePeriod >-----#
    ExpectedIdlePeriod = INT(name=u'ExpectedIdlePeriod', mode=MODE_TYPE)
    ExpectedIdlePeriod._const_val = ASN1Set(rv=[40, 50, 60, 80, 100, 120, 150, 180, 181], rr=[ASN1RangeInt(lb=1, ub=30)], ev=[], er=[])
    
    #-----< SourceOfUEActivityBehaviourInformation >-----#
    SourceOfUEActivityBehaviourInformation = ENUM(name=u'SourceOfUEActivityBehaviourInformation', mode=MODE_TYPE)
    SourceOfUEActivityBehaviourInformation._cont = ASN1Dict([(u'subscription-information', 0), (u'statistics', 1)])
    SourceOfUEActivityBehaviourInformation._ext = []
    
    #-----< ExpectedHOInterval >-----#
    ExpectedHOInterval = ENUM(name=u'ExpectedHOInterval', mode=MODE_TYPE)
    ExpectedHOInterval._cont = ASN1Dict([(u'sec15', 0), (u'sec30', 1), (u'sec60', 2), (u'sec90', 3), (u'sec120', 4), (u'sec180', 5), (u'long-time', 6)])
    ExpectedHOInterval._ext = []
    
    #-----< ExtendedBitRate >-----#
    ExtendedBitRate = INT(name=u'ExtendedBitRate', mode=MODE_TYPE)
    ExtendedBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=10000000001, ub=4000000000000)], ev=[], er=[])
    
    #-----< ExtendedRNC-ID >-----#
    ExtendedRNC_ID = INT(name=u'ExtendedRNC-ID', mode=MODE_TYPE)
    ExtendedRNC_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4096, ub=65535)], ev=None, er=[])
    
    #-----< ExtendedRepetitionPeriod >-----#
    ExtendedRepetitionPeriod = INT(name=u'ExtendedRepetitionPeriod', mode=MODE_TYPE)
    ExtendedRepetitionPeriod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4096, ub=131071)], ev=None, er=[])
    
    #-----< Extended-UEIdentityIndexValue >-----#
    Extended_UEIdentityIndexValue = BIT_STR(name=u'Extended-UEIdentityIndexValue', mode=MODE_TYPE)
    Extended_UEIdentityIndexValue._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    
    #-----< FiveGSTAC >-----#
    FiveGSTAC = OCT_STR(name=u'FiveGSTAC', mode=MODE_TYPE)
    FiveGSTAC._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< FiveGSTAI >-----#
    FiveGSTAI = SEQ(name=u'FiveGSTAI', mode=MODE_TYPE)
    _FiveGSTAI_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _FiveGSTAI_fiveGSTAC = OCT_STR(name=u'fiveGSTAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'FiveGSTAC')))
    _FiveGSTAI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FiveGSTAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___FiveGSTAI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____FiveGSTAI_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____FiveGSTAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveGSTAI_iE_Extensions__item__id._const_tab = ____FiveGSTAI_iE_Extensions__item__id_tab
    ___FiveGSTAI_iE_Extensions__item__id._const_tab_at = None
    ___FiveGSTAI_iE_Extensions__item__id._const_tab_id = u'id'
    ___FiveGSTAI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____FiveGSTAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____FiveGSTAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveGSTAI_iE_Extensions__item__criticality._const_tab = ____FiveGSTAI_iE_Extensions__item__criticality_tab
    ___FiveGSTAI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___FiveGSTAI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___FiveGSTAI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____FiveGSTAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____FiveGSTAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FiveGSTAI_iE_Extensions__item__extensionValue._const_tab = ____FiveGSTAI_iE_Extensions__item__extensionValue_tab
    ___FiveGSTAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___FiveGSTAI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __FiveGSTAI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___FiveGSTAI_iE_Extensions__item__id),
        (u'criticality', ___FiveGSTAI_iE_Extensions__item__criticality),
        (u'extensionValue', ___FiveGSTAI_iE_Extensions__item__extensionValue),
        ])
    __FiveGSTAI_iE_Extensions__item_._ext = None
    _FiveGSTAI_iE_Extensions._cont = __FiveGSTAI_iE_Extensions__item_
    _FiveGSTAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FiveGSTAI._cont = ASN1Dict([
        (u'pLMNidentity', _FiveGSTAI_pLMNidentity),
        (u'fiveGSTAC', _FiveGSTAI_fiveGSTAC),
        (u'iE-Extensions', _FiveGSTAI_iE_Extensions),
        ])
    FiveGSTAI._ext = []
    
    #-----< FiveGSTAI-ExtIEs >-----#
    FiveGSTAI_ExtIEs = CLASS(name=u'FiveGSTAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    FiveGSTAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FiveQI >-----#
    FiveQI = INT(name=u'FiveQI', mode=MODE_TYPE)
    FiveQI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< ForbiddenInterRATs >-----#
    ForbiddenInterRATs = ENUM(name=u'ForbiddenInterRATs', mode=MODE_TYPE)
    ForbiddenInterRATs._cont = ASN1Dict([(u'all', 0), (u'geran', 1), (u'utran', 2), (u'cdma2000', 3), (u'geranandutran', 4), (u'cdma2000andutran', 5)])
    ForbiddenInterRATs._ext = [u'geranandutran', u'cdma2000andutran']
    
    #-----< ForbiddenTAs >-----#
    ForbiddenTAs = SEQ_OF(name=u'ForbiddenTAs', mode=MODE_TYPE)
    _ForbiddenTAs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ForbiddenTAs-Item')))
    ForbiddenTAs._cont = _ForbiddenTAs__item_
    ForbiddenTAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ForbiddenTAs-Item >-----#
    ForbiddenTAs_Item = SEQ(name=u'ForbiddenTAs-Item', mode=MODE_TYPE)
    _ForbiddenTAs_Item_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _ForbiddenTAs_Item_forbiddenTACs = SEQ_OF(name=u'forbiddenTACs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ForbiddenTACs')))
    _ForbiddenTAs_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ForbiddenTAs_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ForbiddenTAs_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ForbiddenTAs_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ForbiddenTAs_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenTAs_Item_iE_Extensions__item__id._const_tab = ____ForbiddenTAs_Item_iE_Extensions__item__id_tab
    ___ForbiddenTAs_Item_iE_Extensions__item__id._const_tab_at = None
    ___ForbiddenTAs_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ForbiddenTAs_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ForbiddenTAs_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ForbiddenTAs_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenTAs_Item_iE_Extensions__item__criticality._const_tab = ____ForbiddenTAs_Item_iE_Extensions__item__criticality_tab
    ___ForbiddenTAs_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ForbiddenTAs_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ForbiddenTAs_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ForbiddenTAs_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue._const_tab = ____ForbiddenTAs_Item_iE_Extensions__item__extensionValue_tab
    ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ForbiddenTAs_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ForbiddenTAs_Item_iE_Extensions__item__id),
        (u'criticality', ___ForbiddenTAs_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue),
        ])
    __ForbiddenTAs_Item_iE_Extensions__item_._ext = None
    _ForbiddenTAs_Item_iE_Extensions._cont = __ForbiddenTAs_Item_iE_Extensions__item_
    _ForbiddenTAs_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ForbiddenTAs_Item._cont = ASN1Dict([
        (u'pLMN-Identity', _ForbiddenTAs_Item_pLMN_Identity),
        (u'forbiddenTACs', _ForbiddenTAs_Item_forbiddenTACs),
        (u'iE-Extensions', _ForbiddenTAs_Item_iE_Extensions),
        ])
    ForbiddenTAs_Item._ext = []
    
    #-----< ForbiddenTAs-Item-ExtIEs >-----#
    ForbiddenTAs_Item_ExtIEs = CLASS(name=u'ForbiddenTAs-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ForbiddenTAs_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ForbiddenTACs >-----#
    ForbiddenTACs = SEQ_OF(name=u'ForbiddenTACs', mode=MODE_TYPE)
    _ForbiddenTACs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAC')))
    ForbiddenTACs._cont = _ForbiddenTACs__item_
    ForbiddenTACs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    
    #-----< ForbiddenLAs >-----#
    ForbiddenLAs = SEQ_OF(name=u'ForbiddenLAs', mode=MODE_TYPE)
    _ForbiddenLAs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ForbiddenLAs-Item')))
    ForbiddenLAs._cont = _ForbiddenLAs__item_
    ForbiddenLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ForbiddenLAs-Item >-----#
    ForbiddenLAs_Item = SEQ(name=u'ForbiddenLAs-Item', mode=MODE_TYPE)
    _ForbiddenLAs_Item_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _ForbiddenLAs_Item_forbiddenLACs = SEQ_OF(name=u'forbiddenLACs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ForbiddenLACs')))
    _ForbiddenLAs_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ForbiddenLAs_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ForbiddenLAs_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ForbiddenLAs_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ForbiddenLAs_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenLAs_Item_iE_Extensions__item__id._const_tab = ____ForbiddenLAs_Item_iE_Extensions__item__id_tab
    ___ForbiddenLAs_Item_iE_Extensions__item__id._const_tab_at = None
    ___ForbiddenLAs_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ForbiddenLAs_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ForbiddenLAs_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ForbiddenLAs_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenLAs_Item_iE_Extensions__item__criticality._const_tab = ____ForbiddenLAs_Item_iE_Extensions__item__criticality_tab
    ___ForbiddenLAs_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ForbiddenLAs_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ForbiddenLAs_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ForbiddenLAs_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue._const_tab = ____ForbiddenLAs_Item_iE_Extensions__item__extensionValue_tab
    ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ForbiddenLAs_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ForbiddenLAs_Item_iE_Extensions__item__id),
        (u'criticality', ___ForbiddenLAs_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue),
        ])
    __ForbiddenLAs_Item_iE_Extensions__item_._ext = None
    _ForbiddenLAs_Item_iE_Extensions._cont = __ForbiddenLAs_Item_iE_Extensions__item_
    _ForbiddenLAs_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ForbiddenLAs_Item._cont = ASN1Dict([
        (u'pLMN-Identity', _ForbiddenLAs_Item_pLMN_Identity),
        (u'forbiddenLACs', _ForbiddenLAs_Item_forbiddenLACs),
        (u'iE-Extensions', _ForbiddenLAs_Item_iE_Extensions),
        ])
    ForbiddenLAs_Item._ext = []
    
    #-----< ForbiddenLAs-Item-ExtIEs >-----#
    ForbiddenLAs_Item_ExtIEs = CLASS(name=u'ForbiddenLAs-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ForbiddenLAs_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ForbiddenLACs >-----#
    ForbiddenLACs = SEQ_OF(name=u'ForbiddenLACs', mode=MODE_TYPE)
    _ForbiddenLACs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LAC')))
    ForbiddenLACs._cont = _ForbiddenLACs__item_
    ForbiddenLACs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    
    #-----< GBR-QosInformation >-----#
    GBR_QosInformation = SEQ(name=u'GBR-QosInformation', mode=MODE_TYPE)
    _GBR_QosInformation_e_RAB_MaximumBitrateDL = INT(name=u'e-RAB-MaximumBitrateDL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_MaximumBitrateUL = INT(name=u'e-RAB-MaximumBitrateUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_GuaranteedBitrateDL = INT(name=u'e-RAB-GuaranteedBitrateDL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_GuaranteedBitrateUL = INT(name=u'e-RAB-GuaranteedBitrateUL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')))
    _GBR_QosInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GBR_QosInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___GBR_QosInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GBR_QosInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    ____GBR_QosInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 255), (u'criticality', u'ignore'), (u'Extension', _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 256), (u'criticality', u'ignore'), (u'Extension', _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 257), (u'criticality', u'ignore'), (u'Extension', _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 258), (u'criticality', u'ignore'), (u'Extension', _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab_at = None
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___GBR_QosInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GBR_QosInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GBR_QosInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GBR_QosInformation_iE_Extensions__item__id),
        (u'criticality', ___GBR_QosInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___GBR_QosInformation_iE_Extensions__item__extensionValue),
        ])
    __GBR_QosInformation_iE_Extensions__item_._ext = None
    _GBR_QosInformation_iE_Extensions._cont = __GBR_QosInformation_iE_Extensions__item_
    _GBR_QosInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GBR_QosInformation._cont = ASN1Dict([
        (u'e-RAB-MaximumBitrateDL', _GBR_QosInformation_e_RAB_MaximumBitrateDL),
        (u'e-RAB-MaximumBitrateUL', _GBR_QosInformation_e_RAB_MaximumBitrateUL),
        (u'e-RAB-GuaranteedBitrateDL', _GBR_QosInformation_e_RAB_GuaranteedBitrateDL),
        (u'e-RAB-GuaranteedBitrateUL', _GBR_QosInformation_e_RAB_GuaranteedBitrateUL),
        (u'iE-Extensions', _GBR_QosInformation_iE_Extensions),
        ])
    GBR_QosInformation._ext = []
    
    #-----< GBR-QosInformation-ExtIEs >-----#
    GBR_QosInformation_ExtIEs = CLASS(name=u'GBR-QosInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _GBR_QosInformation_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    _GBR_QosInformation_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    _GBR_QosInformation_ExtIEs_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    _GBR_QosInformation_ExtIEs_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    GBR_QosInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 255), (u'criticality', u'ignore'), (u'Extension', _GBR_QosInformation_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 256), (u'criticality', u'ignore'), (u'Extension', _GBR_QosInformation_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 257), (u'criticality', u'ignore'), (u'Extension', _GBR_QosInformation_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 258), (u'criticality', u'ignore'), (u'Extension', _GBR_QosInformation_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GTP-TEID >-----#
    GTP_TEID = OCT_STR(name=u'GTP-TEID', mode=MODE_TYPE)
    GTP_TEID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< GUMMEI >-----#
    GUMMEI = SEQ(name=u'GUMMEI', mode=MODE_TYPE)
    _GUMMEI_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _GUMMEI_mME_Group_ID = OCT_STR(name=u'mME-Group-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MME-Group-ID')))
    _GUMMEI_mME_Code = OCT_STR(name=u'mME-Code', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MME-Code')))
    _GUMMEI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GUMMEI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___GUMMEI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GUMMEI_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____GUMMEI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GUMMEI_iE_Extensions__item__id._const_tab = ____GUMMEI_iE_Extensions__item__id_tab
    ___GUMMEI_iE_Extensions__item__id._const_tab_at = None
    ___GUMMEI_iE_Extensions__item__id._const_tab_id = u'id'
    ___GUMMEI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GUMMEI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____GUMMEI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GUMMEI_iE_Extensions__item__criticality._const_tab = ____GUMMEI_iE_Extensions__item__criticality_tab
    ___GUMMEI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GUMMEI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GUMMEI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GUMMEI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____GUMMEI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GUMMEI_iE_Extensions__item__extensionValue._const_tab = ____GUMMEI_iE_Extensions__item__extensionValue_tab
    ___GUMMEI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GUMMEI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GUMMEI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GUMMEI_iE_Extensions__item__id),
        (u'criticality', ___GUMMEI_iE_Extensions__item__criticality),
        (u'extensionValue', ___GUMMEI_iE_Extensions__item__extensionValue),
        ])
    __GUMMEI_iE_Extensions__item_._ext = None
    _GUMMEI_iE_Extensions._cont = __GUMMEI_iE_Extensions__item_
    _GUMMEI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GUMMEI._cont = ASN1Dict([
        (u'pLMN-Identity', _GUMMEI_pLMN_Identity),
        (u'mME-Group-ID', _GUMMEI_mME_Group_ID),
        (u'mME-Code', _GUMMEI_mME_Code),
        (u'iE-Extensions', _GUMMEI_iE_Extensions),
        ])
    GUMMEI._ext = []
    
    #-----< GUMMEI-ExtIEs >-----#
    GUMMEI_ExtIEs = CLASS(name=u'GUMMEI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    GUMMEI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GUMMEIType >-----#
    GUMMEIType = ENUM(name=u'GUMMEIType', mode=MODE_TYPE)
    GUMMEIType._cont = ASN1Dict([(u'native', 0), (u'mapped', 1), (u'mappedFrom5G', 2)])
    GUMMEIType._ext = [u'mappedFrom5G']
    
    #-----< GWContextReleaseIndication >-----#
    GWContextReleaseIndication = ENUM(name=u'GWContextReleaseIndication', mode=MODE_TYPE)
    GWContextReleaseIndication._cont = ASN1Dict([(u'true', 0)])
    GWContextReleaseIndication._ext = []
    
    #-----< HandoverFlag >-----#
    HandoverFlag = ENUM(name=u'HandoverFlag', mode=MODE_TYPE)
    HandoverFlag._cont = ASN1Dict([(u'handoverPreparation', 0)])
    HandoverFlag._ext = []
    
    #-----< HandoverRestrictionList >-----#
    HandoverRestrictionList = SEQ(name=u'HandoverRestrictionList', mode=MODE_TYPE)
    _HandoverRestrictionList_servingPLMN = OCT_STR(name=u'servingPLMN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _HandoverRestrictionList_equivalentPLMNs = SEQ_OF(name=u'equivalentPLMNs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EPLMNs')), opt=True)
    _HandoverRestrictionList_forbiddenTAs = SEQ_OF(name=u'forbiddenTAs', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ForbiddenTAs')), opt=True)
    _HandoverRestrictionList_forbiddenLAs = SEQ_OF(name=u'forbiddenLAs', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ForbiddenLAs')), opt=True)
    _HandoverRestrictionList_forbiddenInterRATs = ENUM(name=u'forbiddenInterRATs', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ForbiddenInterRATs')), opt=True)
    _HandoverRestrictionList_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HandoverRestrictionList_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___HandoverRestrictionList_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____HandoverRestrictionList_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRrestrictioninEPSasSecondaryRAT')))
    _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UnlicensedSpectrumRestriction')))
    _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CNTypeRestrictions')))
    _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRrestrictionin5GS')))
    _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_4 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    ____HandoverRestrictionList_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 261), (u'criticality', u'ignore'), (u'Extension', _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 270), (u'criticality', u'ignore'), (u'Extension', _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 282), (u'criticality', u'ignore'), (u'Extension', _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 287), (u'criticality', u'ignore'), (u'Extension', _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 290), (u'criticality', u'ignore'), (u'Extension', _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverRestrictionList_iE_Extensions__item__id._const_tab = ____HandoverRestrictionList_iE_Extensions__item__id_tab
    ___HandoverRestrictionList_iE_Extensions__item__id._const_tab_at = None
    ___HandoverRestrictionList_iE_Extensions__item__id._const_tab_id = u'id'
    ___HandoverRestrictionList_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HandoverRestrictionList_iE_Extensions__item__criticality._const_tab = ____HandoverRestrictionList_iE_Extensions__item__id_tab
    ___HandoverRestrictionList_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverRestrictionList_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HandoverRestrictionList_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HandoverRestrictionList_iE_Extensions__item__extensionValue._const_tab = ____HandoverRestrictionList_iE_Extensions__item__id_tab
    ___HandoverRestrictionList_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HandoverRestrictionList_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HandoverRestrictionList_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HandoverRestrictionList_iE_Extensions__item__id),
        (u'criticality', ___HandoverRestrictionList_iE_Extensions__item__criticality),
        (u'extensionValue', ___HandoverRestrictionList_iE_Extensions__item__extensionValue),
        ])
    __HandoverRestrictionList_iE_Extensions__item_._ext = None
    _HandoverRestrictionList_iE_Extensions._cont = __HandoverRestrictionList_iE_Extensions__item_
    _HandoverRestrictionList_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HandoverRestrictionList._cont = ASN1Dict([
        (u'servingPLMN', _HandoverRestrictionList_servingPLMN),
        (u'equivalentPLMNs', _HandoverRestrictionList_equivalentPLMNs),
        (u'forbiddenTAs', _HandoverRestrictionList_forbiddenTAs),
        (u'forbiddenLAs', _HandoverRestrictionList_forbiddenLAs),
        (u'forbiddenInterRATs', _HandoverRestrictionList_forbiddenInterRATs),
        (u'iE-Extensions', _HandoverRestrictionList_iE_Extensions),
        ])
    HandoverRestrictionList._ext = []
    
    #-----< HandoverRestrictionList-ExtIEs >-----#
    HandoverRestrictionList_ExtIEs = CLASS(name=u'HandoverRestrictionList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _HandoverRestrictionList_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRrestrictioninEPSasSecondaryRAT')))
    _HandoverRestrictionList_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UnlicensedSpectrumRestriction')))
    _HandoverRestrictionList_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CNTypeRestrictions')))
    _HandoverRestrictionList_ExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRrestrictionin5GS')))
    _HandoverRestrictionList_ExtIEs_val_Extension_4 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    HandoverRestrictionList_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 261), (u'criticality', u'ignore'), (u'Extension', _HandoverRestrictionList_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 270), (u'criticality', u'ignore'), (u'Extension', _HandoverRestrictionList_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 282), (u'criticality', u'ignore'), (u'Extension', _HandoverRestrictionList_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 287), (u'criticality', u'ignore'), (u'Extension', _HandoverRestrictionList_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 290), (u'criticality', u'ignore'), (u'Extension', _HandoverRestrictionList_ExtIEs_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverType >-----#
    HandoverType = ENUM(name=u'HandoverType', mode=MODE_TYPE)
    HandoverType._cont = ASN1Dict([(u'intralte', 0), (u'ltetoutran', 1), (u'ltetogeran', 2), (u'utrantolte', 3), (u'gerantolte', 4), (u'eps-to-5gs', 5), (u'fivegs-to-eps', 6)])
    HandoverType._ext = [u'eps-to-5gs', u'fivegs-to-eps']
    
    #-----< HFN >-----#
    HFN = INT(name=u'HFN', mode=MODE_TYPE)
    HFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    
    #-----< HFNModified >-----#
    HFNModified = INT(name=u'HFNModified', mode=MODE_TYPE)
    HFNModified._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=131071)], ev=None, er=[])
    
    #-----< HFNforPDCP-SNlength18 >-----#
    HFNforPDCP_SNlength18 = INT(name=u'HFNforPDCP-SNlength18', mode=MODE_TYPE)
    HFNforPDCP_SNlength18._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    
    #-----< Masked-IMEISV >-----#
    Masked_IMEISV = BIT_STR(name=u'Masked-IMEISV', mode=MODE_TYPE)
    Masked_IMEISV._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    
    #-----< ImmediateMDT >-----#
    ImmediateMDT = SEQ(name=u'ImmediateMDT', mode=MODE_TYPE)
    _ImmediateMDT_measurementsToActivate = BIT_STR(name=u'measurementsToActivate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MeasurementsToActivate')))
    _ImmediateMDT_m1reportingTrigger = ENUM(name=u'm1reportingTrigger', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M1ReportingTrigger')))
    _ImmediateMDT_m1thresholdeventA2 = SEQ(name=u'm1thresholdeventA2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M1ThresholdEventA2')), opt=True)
    _ImmediateMDT_m1periodicReporting = SEQ(name=u'm1periodicReporting', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M1PeriodicReporting')), opt=True)
    _ImmediateMDT_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ImmediateMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ImmediateMDT_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ImmediateMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'M3Configuration')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'M4Configuration')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'M5Configuration')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDT-Location-Info')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'M6Configuration')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'M7Configuration')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BluetoothMeasurementConfiguration')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WLANMeasurementConfiguration')))
    ____ImmediateMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'ignore'), (u'Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'conditional')]), dict([(u'id', 172), (u'criticality', u'ignore'), (u'Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'conditional')]), dict([(u'id', 173), (u'criticality', u'ignore'), (u'Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'conditional')]), dict([(u'id', 174), (u'criticality', u'ignore'), (u'Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 220), (u'criticality', u'ignore'), (u'Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'conditional')]), dict([(u'id', 221), (u'criticality', u'ignore'), (u'Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'conditional')]), dict([(u'id', 284), (u'criticality', u'ignore'), (u'Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 285), (u'criticality', u'ignore'), (u'Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ImmediateMDT_iE_Extensions__item__id._const_tab = ____ImmediateMDT_iE_Extensions__item__id_tab
    ___ImmediateMDT_iE_Extensions__item__id._const_tab_at = None
    ___ImmediateMDT_iE_Extensions__item__id._const_tab_id = u'id'
    ___ImmediateMDT_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ImmediateMDT_iE_Extensions__item__criticality._const_tab = ____ImmediateMDT_iE_Extensions__item__id_tab
    ___ImmediateMDT_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ImmediateMDT_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ImmediateMDT_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ImmediateMDT_iE_Extensions__item__extensionValue._const_tab = ____ImmediateMDT_iE_Extensions__item__id_tab
    ___ImmediateMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ImmediateMDT_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ImmediateMDT_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ImmediateMDT_iE_Extensions__item__id),
        (u'criticality', ___ImmediateMDT_iE_Extensions__item__criticality),
        (u'extensionValue', ___ImmediateMDT_iE_Extensions__item__extensionValue),
        ])
    __ImmediateMDT_iE_Extensions__item_._ext = None
    _ImmediateMDT_iE_Extensions._cont = __ImmediateMDT_iE_Extensions__item_
    _ImmediateMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ImmediateMDT._cont = ASN1Dict([
        (u'measurementsToActivate', _ImmediateMDT_measurementsToActivate),
        (u'm1reportingTrigger', _ImmediateMDT_m1reportingTrigger),
        (u'm1thresholdeventA2', _ImmediateMDT_m1thresholdeventA2),
        (u'm1periodicReporting', _ImmediateMDT_m1periodicReporting),
        (u'iE-Extensions', _ImmediateMDT_iE_Extensions),
        ])
    ImmediateMDT._ext = []
    
    #-----< ImmediateMDT-ExtIEs >-----#
    ImmediateMDT_ExtIEs = CLASS(name=u'ImmediateMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _ImmediateMDT_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'M3Configuration')))
    _ImmediateMDT_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'M4Configuration')))
    _ImmediateMDT_ExtIEs_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'M5Configuration')))
    _ImmediateMDT_ExtIEs_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDT-Location-Info')))
    _ImmediateMDT_ExtIEs_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'M6Configuration')))
    _ImmediateMDT_ExtIEs_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'M7Configuration')))
    _ImmediateMDT_ExtIEs_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BluetoothMeasurementConfiguration')))
    _ImmediateMDT_ExtIEs_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WLANMeasurementConfiguration')))
    ImmediateMDT_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'ignore'), (u'Extension', _ImmediateMDT_ExtIEs_val_Extension_0), (u'presence', u'conditional')]), dict([(u'id', 172), (u'criticality', u'ignore'), (u'Extension', _ImmediateMDT_ExtIEs_val_Extension_1), (u'presence', u'conditional')]), dict([(u'id', 173), (u'criticality', u'ignore'), (u'Extension', _ImmediateMDT_ExtIEs_val_Extension_2), (u'presence', u'conditional')]), dict([(u'id', 174), (u'criticality', u'ignore'), (u'Extension', _ImmediateMDT_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 220), (u'criticality', u'ignore'), (u'Extension', _ImmediateMDT_ExtIEs_val_Extension_4), (u'presence', u'conditional')]), dict([(u'id', 221), (u'criticality', u'ignore'), (u'Extension', _ImmediateMDT_ExtIEs_val_Extension_5), (u'presence', u'conditional')]), dict([(u'id', 284), (u'criticality', u'ignore'), (u'Extension', _ImmediateMDT_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 285), (u'criticality', u'ignore'), (u'Extension', _ImmediateMDT_ExtIEs_val_Extension_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< IMSI >-----#
    IMSI = OCT_STR(name=u'IMSI', mode=MODE_TYPE)
    IMSI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< InformationOnRecommendedCellsAndENBsForPaging >-----#
    InformationOnRecommendedCellsAndENBsForPaging = SEQ(name=u'InformationOnRecommendedCellsAndENBsForPaging', mode=MODE_TYPE)
    _InformationOnRecommendedCellsAndENBsForPaging_recommendedCellsForPaging = SEQ(name=u'recommendedCellsForPaging', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RecommendedCellsForPaging')))
    _InformationOnRecommendedCellsAndENBsForPaging_recommendENBsForPaging = SEQ(name=u'recommendENBsForPaging', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RecommendedENBsForPaging')))
    _InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__id._const_tab = ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__id_tab
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__id._const_tab_at = None
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__id._const_tab_id = u'id'
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__criticality._const_tab = ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__criticality_tab
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__extensionValue._const_tab = ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__extensionValue_tab
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__id),
        (u'criticality', ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__criticality),
        (u'extensionValue', ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__extensionValue),
        ])
    __InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item_._ext = None
    _InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions._cont = __InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item_
    _InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationOnRecommendedCellsAndENBsForPaging._cont = ASN1Dict([
        (u'recommendedCellsForPaging', _InformationOnRecommendedCellsAndENBsForPaging_recommendedCellsForPaging),
        (u'recommendENBsForPaging', _InformationOnRecommendedCellsAndENBsForPaging_recommendENBsForPaging),
        (u'iE-Extensions', _InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions),
        ])
    InformationOnRecommendedCellsAndENBsForPaging._ext = []
    
    #-----< InformationOnRecommendedCellsAndENBsForPaging-ExtIEs >-----#
    InformationOnRecommendedCellsAndENBsForPaging_ExtIEs = CLASS(name=u'InformationOnRecommendedCellsAndENBsForPaging-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    InformationOnRecommendedCellsAndENBsForPaging_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntegrityProtectionAlgorithms >-----#
    IntegrityProtectionAlgorithms = BIT_STR(name=u'IntegrityProtectionAlgorithms', mode=MODE_TYPE)
    IntegrityProtectionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< IntendedNumberOfPagingAttempts >-----#
    IntendedNumberOfPagingAttempts = INT(name=u'IntendedNumberOfPagingAttempts', mode=MODE_TYPE)
    IntendedNumberOfPagingAttempts._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    
    #-----< InterfacesToTrace >-----#
    InterfacesToTrace = BIT_STR(name=u'InterfacesToTrace', mode=MODE_TYPE)
    InterfacesToTrace._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< IntersystemMeasurementConfiguration >-----#
    IntersystemMeasurementConfiguration = SEQ(name=u'IntersystemMeasurementConfiguration', mode=MODE_TYPE)
    _IntersystemMeasurementConfiguration_rSRP = INT(name=u'rSRP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IntersystemMeasurementConfiguration_rSRP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _IntersystemMeasurementConfiguration_rSRQ = INT(name=u'rSRQ', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IntersystemMeasurementConfiguration_rSRQ._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _IntersystemMeasurementConfiguration_sINR = INT(name=u'sINR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IntersystemMeasurementConfiguration_sINR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _IntersystemMeasurementConfiguration_interSystemMeasurementParameters = SEQ(name=u'interSystemMeasurementParameters', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'InterSystemMeasurementParameters')))
    _IntersystemMeasurementConfiguration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IntersystemMeasurementConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____IntersystemMeasurementConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____IntersystemMeasurementConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__id._const_tab = ____IntersystemMeasurementConfiguration_iE_Extensions__item__id_tab
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__id._const_tab_id = u'id'
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IntersystemMeasurementConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____IntersystemMeasurementConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__criticality._const_tab = ____IntersystemMeasurementConfiguration_iE_Extensions__item__criticality_tab
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IntersystemMeasurementConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____IntersystemMeasurementConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab = ____IntersystemMeasurementConfiguration_iE_Extensions__item__extensionValue_tab
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IntersystemMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IntersystemMeasurementConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IntersystemMeasurementConfiguration_iE_Extensions__item__id),
        (u'criticality', ___IntersystemMeasurementConfiguration_iE_Extensions__item__criticality),
        (u'extensionValue', ___IntersystemMeasurementConfiguration_iE_Extensions__item__extensionValue),
        ])
    __IntersystemMeasurementConfiguration_iE_Extensions__item_._ext = None
    _IntersystemMeasurementConfiguration_iE_Extensions._cont = __IntersystemMeasurementConfiguration_iE_Extensions__item_
    _IntersystemMeasurementConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IntersystemMeasurementConfiguration._cont = ASN1Dict([
        (u'rSRP', _IntersystemMeasurementConfiguration_rSRP),
        (u'rSRQ', _IntersystemMeasurementConfiguration_rSRQ),
        (u'sINR', _IntersystemMeasurementConfiguration_sINR),
        (u'interSystemMeasurementParameters', _IntersystemMeasurementConfiguration_interSystemMeasurementParameters),
        (u'iE-Extensions', _IntersystemMeasurementConfiguration_iE_Extensions),
        ])
    IntersystemMeasurementConfiguration._ext = []
    
    #-----< IntersystemMeasurementConfiguration-ExtIEs >-----#
    IntersystemMeasurementConfiguration_ExtIEs = CLASS(name=u'IntersystemMeasurementConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    IntersystemMeasurementConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InterSystemMeasurementParameters >-----#
    InterSystemMeasurementParameters = SEQ(name=u'InterSystemMeasurementParameters', mode=MODE_TYPE)
    _InterSystemMeasurementParameters_measurementDuration = INT(name=u'measurementDuration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InterSystemMeasurementParameters_measurementDuration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _InterSystemMeasurementParameters_interSystemMeasurementList = SEQ_OF(name=u'interSystemMeasurementList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'InterSystemMeasurementList')), opt=True)
    _InterSystemMeasurementParameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InterSystemMeasurementParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___InterSystemMeasurementParameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____InterSystemMeasurementParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____InterSystemMeasurementParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemMeasurementParameters_iE_Extensions__item__id._const_tab = ____InterSystemMeasurementParameters_iE_Extensions__item__id_tab
    ___InterSystemMeasurementParameters_iE_Extensions__item__id._const_tab_at = None
    ___InterSystemMeasurementParameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___InterSystemMeasurementParameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____InterSystemMeasurementParameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____InterSystemMeasurementParameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemMeasurementParameters_iE_Extensions__item__criticality._const_tab = ____InterSystemMeasurementParameters_iE_Extensions__item__criticality_tab
    ___InterSystemMeasurementParameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___InterSystemMeasurementParameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___InterSystemMeasurementParameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____InterSystemMeasurementParameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____InterSystemMeasurementParameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemMeasurementParameters_iE_Extensions__item__extensionValue._const_tab = ____InterSystemMeasurementParameters_iE_Extensions__item__extensionValue_tab
    ___InterSystemMeasurementParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InterSystemMeasurementParameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __InterSystemMeasurementParameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___InterSystemMeasurementParameters_iE_Extensions__item__id),
        (u'criticality', ___InterSystemMeasurementParameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___InterSystemMeasurementParameters_iE_Extensions__item__extensionValue),
        ])
    __InterSystemMeasurementParameters_iE_Extensions__item_._ext = None
    _InterSystemMeasurementParameters_iE_Extensions._cont = __InterSystemMeasurementParameters_iE_Extensions__item_
    _InterSystemMeasurementParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InterSystemMeasurementParameters._cont = ASN1Dict([
        (u'measurementDuration', _InterSystemMeasurementParameters_measurementDuration),
        (u'interSystemMeasurementList', _InterSystemMeasurementParameters_interSystemMeasurementList),
        (u'iE-Extensions', _InterSystemMeasurementParameters_iE_Extensions),
        ])
    InterSystemMeasurementParameters._ext = []
    
    #-----< InterSystemMeasurementParameters-ExtIEs >-----#
    InterSystemMeasurementParameters_ExtIEs = CLASS(name=u'InterSystemMeasurementParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    InterSystemMeasurementParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InterSystemMeasurementList >-----#
    InterSystemMeasurementList = SEQ_OF(name=u'InterSystemMeasurementList', mode=MODE_TYPE)
    _InterSystemMeasurementList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'InterSystemMeasurementItem')))
    InterSystemMeasurementList._cont = _InterSystemMeasurementList__item_
    InterSystemMeasurementList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< InterSystemMeasurementItem >-----#
    InterSystemMeasurementItem = SEQ(name=u'InterSystemMeasurementItem', mode=MODE_TYPE)
    _InterSystemMeasurementItem_freqBandIndicatorNR = INT(name=u'freqBandIndicatorNR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InterSystemMeasurementItem_freqBandIndicatorNR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    _InterSystemMeasurementItem_sSBfrequencies = INT(name=u'sSBfrequencies', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InterSystemMeasurementItem_sSBfrequencies._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3279165)], ev=None, er=[])
    _InterSystemMeasurementItem_subcarrierSpacingSSB = ENUM(name=u'subcarrierSpacingSSB', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InterSystemMeasurementItem_subcarrierSpacingSSB._cont = ASN1Dict([(u'kHz15', 0), (u'kHz30', 1), (u'kHz60', 2), (u'kHz120', 3), (u'kHz240', 4)])
    _InterSystemMeasurementItem_subcarrierSpacingSSB._ext = []
    _InterSystemMeasurementItem_maxRSIndexCellQual = INT(name=u'maxRSIndexCellQual', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InterSystemMeasurementItem_maxRSIndexCellQual._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _InterSystemMeasurementItem_sMTC = OCT_STR(name=u'sMTC', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InterSystemMeasurementItem_threshRS_Index_r15 = OCT_STR(name=u'threshRS-Index-r15', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InterSystemMeasurementItem_sSBToMeasure = OCT_STR(name=u'sSBToMeasure', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InterSystemMeasurementItem_sSRSSIMeasurement = OCT_STR(name=u'sSRSSIMeasurement', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InterSystemMeasurementItem_quantityConfigNR_R15 = OCT_STR(name=u'quantityConfigNR-R15', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InterSystemMeasurementItem_blackCellsToAddModList = OCT_STR(name=u'blackCellsToAddModList', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InterSystemMeasurementItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InterSystemMeasurementItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___InterSystemMeasurementItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____InterSystemMeasurementItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____InterSystemMeasurementItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemMeasurementItem_iE_Extensions__item__id._const_tab = ____InterSystemMeasurementItem_iE_Extensions__item__id_tab
    ___InterSystemMeasurementItem_iE_Extensions__item__id._const_tab_at = None
    ___InterSystemMeasurementItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___InterSystemMeasurementItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____InterSystemMeasurementItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____InterSystemMeasurementItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemMeasurementItem_iE_Extensions__item__criticality._const_tab = ____InterSystemMeasurementItem_iE_Extensions__item__criticality_tab
    ___InterSystemMeasurementItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___InterSystemMeasurementItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___InterSystemMeasurementItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____InterSystemMeasurementItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____InterSystemMeasurementItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemMeasurementItem_iE_Extensions__item__extensionValue._const_tab = ____InterSystemMeasurementItem_iE_Extensions__item__extensionValue_tab
    ___InterSystemMeasurementItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InterSystemMeasurementItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __InterSystemMeasurementItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___InterSystemMeasurementItem_iE_Extensions__item__id),
        (u'criticality', ___InterSystemMeasurementItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___InterSystemMeasurementItem_iE_Extensions__item__extensionValue),
        ])
    __InterSystemMeasurementItem_iE_Extensions__item_._ext = None
    _InterSystemMeasurementItem_iE_Extensions._cont = __InterSystemMeasurementItem_iE_Extensions__item_
    _InterSystemMeasurementItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InterSystemMeasurementItem._cont = ASN1Dict([
        (u'freqBandIndicatorNR', _InterSystemMeasurementItem_freqBandIndicatorNR),
        (u'sSBfrequencies', _InterSystemMeasurementItem_sSBfrequencies),
        (u'subcarrierSpacingSSB', _InterSystemMeasurementItem_subcarrierSpacingSSB),
        (u'maxRSIndexCellQual', _InterSystemMeasurementItem_maxRSIndexCellQual),
        (u'sMTC', _InterSystemMeasurementItem_sMTC),
        (u'threshRS-Index-r15', _InterSystemMeasurementItem_threshRS_Index_r15),
        (u'sSBToMeasure', _InterSystemMeasurementItem_sSBToMeasure),
        (u'sSRSSIMeasurement', _InterSystemMeasurementItem_sSRSSIMeasurement),
        (u'quantityConfigNR-R15', _InterSystemMeasurementItem_quantityConfigNR_R15),
        (u'blackCellsToAddModList', _InterSystemMeasurementItem_blackCellsToAddModList),
        (u'iE-Extensions', _InterSystemMeasurementItem_iE_Extensions),
        ])
    InterSystemMeasurementItem._ext = None
    
    #-----< InterSystemMeasurementItem-ExtIEs >-----#
    InterSystemMeasurementItem_ExtIEs = CLASS(name=u'InterSystemMeasurementItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    InterSystemMeasurementItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntersystemSONConfigurationTransfer >-----#
    IntersystemSONConfigurationTransfer = OCT_STR(name=u'IntersystemSONConfigurationTransfer', mode=MODE_TYPE)
    
    #-----< IMSvoiceEPSfallbackfrom5G >-----#
    IMSvoiceEPSfallbackfrom5G = ENUM(name=u'IMSvoiceEPSfallbackfrom5G', mode=MODE_TYPE)
    IMSvoiceEPSfallbackfrom5G._cont = ASN1Dict([(u'true', 0)])
    IMSvoiceEPSfallbackfrom5G._ext = []
    
    #-----< IAB-Authorized >-----#
    IAB_Authorized = ENUM(name=u'IAB-Authorized', mode=MODE_TYPE)
    IAB_Authorized._cont = ASN1Dict([(u'authorized', 0), (u'not-authorized', 1)])
    IAB_Authorized._ext = []
    
    #-----< IAB-Node-Indication >-----#
    IAB_Node_Indication = ENUM(name=u'IAB-Node-Indication', mode=MODE_TYPE)
    IAB_Node_Indication._cont = ASN1Dict([(u'true', 0)])
    IAB_Node_Indication._ext = []
    
    #-----< IAB-Supported >-----#
    IAB_Supported = ENUM(name=u'IAB-Supported', mode=MODE_TYPE)
    IAB_Supported._cont = ASN1Dict([(u'true', 0)])
    IAB_Supported._ext = []
    
    #-----< KillAllWarningMessages >-----#
    KillAllWarningMessages = ENUM(name=u'KillAllWarningMessages', mode=MODE_TYPE)
    KillAllWarningMessages._cont = ASN1Dict([(u'true', 0)])
    KillAllWarningMessages._ext = None
    
    #-----< LAC >-----#
    LAC = OCT_STR(name=u'LAC', mode=MODE_TYPE)
    LAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< LAI >-----#
    LAI = SEQ(name=u'LAI', mode=MODE_TYPE)
    _LAI_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _LAI_lAC = OCT_STR(name=u'lAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LAC')))
    _LAI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___LAI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____LAI_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____LAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LAI_iE_Extensions__item__id._const_tab = ____LAI_iE_Extensions__item__id_tab
    ___LAI_iE_Extensions__item__id._const_tab_at = None
    ___LAI_iE_Extensions__item__id._const_tab_id = u'id'
    ___LAI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____LAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LAI_iE_Extensions__item__criticality._const_tab = ____LAI_iE_Extensions__item__criticality_tab
    ___LAI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LAI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LAI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____LAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LAI_iE_Extensions__item__extensionValue._const_tab = ____LAI_iE_Extensions__item__extensionValue_tab
    ___LAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LAI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LAI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LAI_iE_Extensions__item__id),
        (u'criticality', ___LAI_iE_Extensions__item__criticality),
        (u'extensionValue', ___LAI_iE_Extensions__item__extensionValue),
        ])
    __LAI_iE_Extensions__item_._ext = None
    _LAI_iE_Extensions._cont = __LAI_iE_Extensions__item_
    _LAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LAI._cont = ASN1Dict([
        (u'pLMNidentity', _LAI_pLMNidentity),
        (u'lAC', _LAI_lAC),
        (u'iE-Extensions', _LAI_iE_Extensions),
        ])
    LAI._ext = []
    
    #-----< LAI-ExtIEs >-----#
    LAI_ExtIEs = CLASS(name=u'LAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    LAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LastVisitedCell-Item >-----#
    LastVisitedCell_Item = CHOICE(name=u'LastVisitedCell-Item', mode=MODE_TYPE)
    _LastVisitedCell_Item_e_UTRAN_Cell = SEQ(name=u'e-UTRAN-Cell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LastVisitedEUTRANCellInformation')))
    _LastVisitedCell_Item_uTRAN_Cell = OCT_STR(name=u'uTRAN-Cell', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LastVisitedUTRANCellInformation')))
    _LastVisitedCell_Item_gERAN_Cell = CHOICE(name=u'gERAN-Cell', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LastVisitedGERANCellInformation')))
    _LastVisitedCell_Item_nG_RAN_Cell = OCT_STR(name=u'nG-RAN-Cell', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LastVisitedNGRANCellInformation')))
    LastVisitedCell_Item._cont = ASN1Dict([
        (u'e-UTRAN-Cell', _LastVisitedCell_Item_e_UTRAN_Cell),
        (u'uTRAN-Cell', _LastVisitedCell_Item_uTRAN_Cell),
        (u'gERAN-Cell', _LastVisitedCell_Item_gERAN_Cell),
        (u'nG-RAN-Cell', _LastVisitedCell_Item_nG_RAN_Cell),
        ])
    LastVisitedCell_Item._ext = [u'nG-RAN-Cell']
    
    #-----< LastVisitedEUTRANCellInformation >-----#
    LastVisitedEUTRANCellInformation = SEQ(name=u'LastVisitedEUTRANCellInformation', mode=MODE_TYPE)
    _LastVisitedEUTRANCellInformation_global_Cell_ID = SEQ(name=u'global-Cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _LastVisitedEUTRANCellInformation_cellType = SEQ(name=u'cellType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CellType')))
    _LastVisitedEUTRANCellInformation_time_UE_StayedInCell = INT(name=u'time-UE-StayedInCell', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Time-UE-StayedInCell')))
    _LastVisitedEUTRANCellInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LastVisitedEUTRANCellInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Time-UE-StayedInCell-EnhancedGranularity')))
    _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 167), (u'criticality', u'ignore'), (u'Extension', _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 168), (u'criticality', u'ignore'), (u'Extension', _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id._const_tab = ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id._const_tab_at = None
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality._const_tab = ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue._const_tab = ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LastVisitedEUTRANCellInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id),
        (u'criticality', ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue),
        ])
    __LastVisitedEUTRANCellInformation_iE_Extensions__item_._ext = None
    _LastVisitedEUTRANCellInformation_iE_Extensions._cont = __LastVisitedEUTRANCellInformation_iE_Extensions__item_
    _LastVisitedEUTRANCellInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LastVisitedEUTRANCellInformation._cont = ASN1Dict([
        (u'global-Cell-ID', _LastVisitedEUTRANCellInformation_global_Cell_ID),
        (u'cellType', _LastVisitedEUTRANCellInformation_cellType),
        (u'time-UE-StayedInCell', _LastVisitedEUTRANCellInformation_time_UE_StayedInCell),
        (u'iE-Extensions', _LastVisitedEUTRANCellInformation_iE_Extensions),
        ])
    LastVisitedEUTRANCellInformation._ext = []
    
    #-----< LastVisitedEUTRANCellInformation-ExtIEs >-----#
    LastVisitedEUTRANCellInformation_ExtIEs = CLASS(name=u'LastVisitedEUTRANCellInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Time-UE-StayedInCell-EnhancedGranularity')))
    _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    LastVisitedEUTRANCellInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 167), (u'criticality', u'ignore'), (u'Extension', _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 168), (u'criticality', u'ignore'), (u'Extension', _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< LastVisitedNGRANCellInformation >-----#
    LastVisitedNGRANCellInformation = OCT_STR(name=u'LastVisitedNGRANCellInformation', mode=MODE_TYPE)
    
    #-----< LastVisitedUTRANCellInformation >-----#
    LastVisitedUTRANCellInformation = OCT_STR(name=u'LastVisitedUTRANCellInformation', mode=MODE_TYPE)
    
    #-----< LastVisitedGERANCellInformation >-----#
    LastVisitedGERANCellInformation = CHOICE(name=u'LastVisitedGERANCellInformation', mode=MODE_TYPE)
    _LastVisitedGERANCellInformation_undefined = NULL(name=u'undefined', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    LastVisitedGERANCellInformation._cont = ASN1Dict([
        (u'undefined', _LastVisitedGERANCellInformation_undefined),
        ])
    LastVisitedGERANCellInformation._ext = []
    
    #-----< L3-Information >-----#
    L3_Information = OCT_STR(name=u'L3-Information', mode=MODE_TYPE)
    
    #-----< LPPa-PDU >-----#
    LPPa_PDU = OCT_STR(name=u'LPPa-PDU', mode=MODE_TYPE)
    
    #-----< LHN-ID >-----#
    LHN_ID = OCT_STR(name=u'LHN-ID', mode=MODE_TYPE)
    LHN_ID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=32, ub=256)], ev=None, er=[])
    
    #-----< Links-to-log >-----#
    Links_to_log = ENUM(name=u'Links-to-log', mode=MODE_TYPE)
    Links_to_log._cont = ASN1Dict([(u'uplink', 0), (u'downlink', 1), (u'both-uplink-and-downlink', 2)])
    Links_to_log._ext = []
    
    #-----< ListeningSubframePattern >-----#
    ListeningSubframePattern = SEQ(name=u'ListeningSubframePattern', mode=MODE_TYPE)
    _ListeningSubframePattern_pattern_period = ENUM(name=u'pattern-period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ListeningSubframePattern_pattern_period._cont = ASN1Dict([(u'ms1280', 0), (u'ms2560', 1), (u'ms5120', 2), (u'ms10240', 3)])
    _ListeningSubframePattern_pattern_period._ext = []
    _ListeningSubframePattern_pattern_offset = INT(name=u'pattern-offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ListeningSubframePattern_pattern_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10239)], ev=[], er=[])
    _ListeningSubframePattern_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ListeningSubframePattern_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ListeningSubframePattern_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ListeningSubframePattern_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ListeningSubframePattern_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ListeningSubframePattern_iE_Extensions__item__id._const_tab = ____ListeningSubframePattern_iE_Extensions__item__id_tab
    ___ListeningSubframePattern_iE_Extensions__item__id._const_tab_at = None
    ___ListeningSubframePattern_iE_Extensions__item__id._const_tab_id = u'id'
    ___ListeningSubframePattern_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ListeningSubframePattern_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ListeningSubframePattern_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ListeningSubframePattern_iE_Extensions__item__criticality._const_tab = ____ListeningSubframePattern_iE_Extensions__item__criticality_tab
    ___ListeningSubframePattern_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ListeningSubframePattern_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ListeningSubframePattern_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ListeningSubframePattern_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ListeningSubframePattern_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ListeningSubframePattern_iE_Extensions__item__extensionValue._const_tab = ____ListeningSubframePattern_iE_Extensions__item__extensionValue_tab
    ___ListeningSubframePattern_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ListeningSubframePattern_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ListeningSubframePattern_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ListeningSubframePattern_iE_Extensions__item__id),
        (u'criticality', ___ListeningSubframePattern_iE_Extensions__item__criticality),
        (u'extensionValue', ___ListeningSubframePattern_iE_Extensions__item__extensionValue),
        ])
    __ListeningSubframePattern_iE_Extensions__item_._ext = None
    _ListeningSubframePattern_iE_Extensions._cont = __ListeningSubframePattern_iE_Extensions__item_
    _ListeningSubframePattern_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ListeningSubframePattern._cont = ASN1Dict([
        (u'pattern-period', _ListeningSubframePattern_pattern_period),
        (u'pattern-offset', _ListeningSubframePattern_pattern_offset),
        (u'iE-Extensions', _ListeningSubframePattern_iE_Extensions),
        ])
    ListeningSubframePattern._ext = []
    
    #-----< ListeningSubframePattern-ExtIEs >-----#
    ListeningSubframePattern_ExtIEs = CLASS(name=u'ListeningSubframePattern-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ListeningSubframePattern_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LoggedMDT >-----#
    LoggedMDT = SEQ(name=u'LoggedMDT', mode=MODE_TYPE)
    _LoggedMDT_loggingInterval = ENUM(name=u'loggingInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LoggingInterval')))
    _LoggedMDT_loggingDuration = ENUM(name=u'loggingDuration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LoggingDuration')))
    _LoggedMDT_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LoggedMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___LoggedMDT_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____LoggedMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____LoggedMDT_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BluetoothMeasurementConfiguration')))
    _____LoggedMDT_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WLANMeasurementConfiguration')))
    ____LoggedMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 284), (u'criticality', u'ignore'), (u'Extension', _____LoggedMDT_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 285), (u'criticality', u'ignore'), (u'Extension', _____LoggedMDT_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___LoggedMDT_iE_Extensions__item__id._const_tab = ____LoggedMDT_iE_Extensions__item__id_tab
    ___LoggedMDT_iE_Extensions__item__id._const_tab_at = None
    ___LoggedMDT_iE_Extensions__item__id._const_tab_id = u'id'
    ___LoggedMDT_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___LoggedMDT_iE_Extensions__item__criticality._const_tab = ____LoggedMDT_iE_Extensions__item__id_tab
    ___LoggedMDT_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LoggedMDT_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LoggedMDT_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___LoggedMDT_iE_Extensions__item__extensionValue._const_tab = ____LoggedMDT_iE_Extensions__item__id_tab
    ___LoggedMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LoggedMDT_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LoggedMDT_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LoggedMDT_iE_Extensions__item__id),
        (u'criticality', ___LoggedMDT_iE_Extensions__item__criticality),
        (u'extensionValue', ___LoggedMDT_iE_Extensions__item__extensionValue),
        ])
    __LoggedMDT_iE_Extensions__item_._ext = None
    _LoggedMDT_iE_Extensions._cont = __LoggedMDT_iE_Extensions__item_
    _LoggedMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LoggedMDT._cont = ASN1Dict([
        (u'loggingInterval', _LoggedMDT_loggingInterval),
        (u'loggingDuration', _LoggedMDT_loggingDuration),
        (u'iE-Extensions', _LoggedMDT_iE_Extensions),
        ])
    LoggedMDT._ext = []
    
    #-----< LoggedMDT-ExtIEs >-----#
    LoggedMDT_ExtIEs = CLASS(name=u'LoggedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _LoggedMDT_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BluetoothMeasurementConfiguration')))
    _LoggedMDT_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WLANMeasurementConfiguration')))
    LoggedMDT_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 284), (u'criticality', u'ignore'), (u'Extension', _LoggedMDT_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 285), (u'criticality', u'ignore'), (u'Extension', _LoggedMDT_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< LoggingInterval >-----#
    LoggingInterval = ENUM(name=u'LoggingInterval', mode=MODE_TYPE)
    LoggingInterval._cont = ASN1Dict([(u'ms128', 0), (u'ms256', 1), (u'ms512', 2), (u'ms1024', 3), (u'ms2048', 4), (u'ms3072', 5), (u'ms4096', 6), (u'ms6144', 7)])
    LoggingInterval._ext = None
    
    #-----< LoggingDuration >-----#
    LoggingDuration = ENUM(name=u'LoggingDuration', mode=MODE_TYPE)
    LoggingDuration._cont = ASN1Dict([(u'm10', 0), (u'm20', 1), (u'm40', 2), (u'm60', 3), (u'm90', 4), (u'm120', 5)])
    LoggingDuration._ext = None
    
    #-----< LoggedMBSFNMDT >-----#
    LoggedMBSFNMDT = SEQ(name=u'LoggedMBSFNMDT', mode=MODE_TYPE)
    _LoggedMBSFNMDT_loggingInterval = ENUM(name=u'loggingInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LoggingInterval')))
    _LoggedMBSFNMDT_loggingDuration = ENUM(name=u'loggingDuration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LoggingDuration')))
    _LoggedMBSFNMDT_mBSFN_ResultToLog = SEQ_OF(name=u'mBSFN-ResultToLog', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MBSFN-ResultToLog')), opt=True)
    _LoggedMBSFNMDT_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LoggedMBSFNMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___LoggedMBSFNMDT_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____LoggedMBSFNMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____LoggedMBSFNMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LoggedMBSFNMDT_iE_Extensions__item__id._const_tab = ____LoggedMBSFNMDT_iE_Extensions__item__id_tab
    ___LoggedMBSFNMDT_iE_Extensions__item__id._const_tab_at = None
    ___LoggedMBSFNMDT_iE_Extensions__item__id._const_tab_id = u'id'
    ___LoggedMBSFNMDT_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LoggedMBSFNMDT_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____LoggedMBSFNMDT_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LoggedMBSFNMDT_iE_Extensions__item__criticality._const_tab = ____LoggedMBSFNMDT_iE_Extensions__item__criticality_tab
    ___LoggedMBSFNMDT_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LoggedMBSFNMDT_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LoggedMBSFNMDT_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LoggedMBSFNMDT_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____LoggedMBSFNMDT_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LoggedMBSFNMDT_iE_Extensions__item__extensionValue._const_tab = ____LoggedMBSFNMDT_iE_Extensions__item__extensionValue_tab
    ___LoggedMBSFNMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LoggedMBSFNMDT_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LoggedMBSFNMDT_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LoggedMBSFNMDT_iE_Extensions__item__id),
        (u'criticality', ___LoggedMBSFNMDT_iE_Extensions__item__criticality),
        (u'extensionValue', ___LoggedMBSFNMDT_iE_Extensions__item__extensionValue),
        ])
    __LoggedMBSFNMDT_iE_Extensions__item_._ext = None
    _LoggedMBSFNMDT_iE_Extensions._cont = __LoggedMBSFNMDT_iE_Extensions__item_
    _LoggedMBSFNMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LoggedMBSFNMDT._cont = ASN1Dict([
        (u'loggingInterval', _LoggedMBSFNMDT_loggingInterval),
        (u'loggingDuration', _LoggedMBSFNMDT_loggingDuration),
        (u'mBSFN-ResultToLog', _LoggedMBSFNMDT_mBSFN_ResultToLog),
        (u'iE-Extensions', _LoggedMBSFNMDT_iE_Extensions),
        ])
    LoggedMBSFNMDT._ext = []
    
    #-----< LoggedMBSFNMDT-ExtIEs >-----#
    LoggedMBSFNMDT_ExtIEs = CLASS(name=u'LoggedMBSFNMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    LoggedMBSFNMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LTE-M-Indication >-----#
    LTE_M_Indication = ENUM(name=u'LTE-M-Indication', mode=MODE_TYPE)
    LTE_M_Indication._cont = ASN1Dict([(u'lte-m', 0)])
    LTE_M_Indication._ext = []
    
    #-----< M3Configuration >-----#
    M3Configuration = SEQ(name=u'M3Configuration', mode=MODE_TYPE)
    _M3Configuration_m3period = ENUM(name=u'm3period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M3period')))
    _M3Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M3Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___M3Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____M3Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M3Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M3Configuration_iE_Extensions__item__id._const_tab = ____M3Configuration_iE_Extensions__item__id_tab
    ___M3Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M3Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___M3Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____M3Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M3Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M3Configuration_iE_Extensions__item__criticality._const_tab = ____M3Configuration_iE_Extensions__item__criticality_tab
    ___M3Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M3Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M3Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____M3Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M3Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M3Configuration_iE_Extensions__item__extensionValue._const_tab = ____M3Configuration_iE_Extensions__item__extensionValue_tab
    ___M3Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M3Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M3Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M3Configuration_iE_Extensions__item__id),
        (u'criticality', ___M3Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___M3Configuration_iE_Extensions__item__extensionValue),
        ])
    __M3Configuration_iE_Extensions__item_._ext = None
    _M3Configuration_iE_Extensions._cont = __M3Configuration_iE_Extensions__item_
    _M3Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M3Configuration._cont = ASN1Dict([
        (u'm3period', _M3Configuration_m3period),
        (u'iE-Extensions', _M3Configuration_iE_Extensions),
        ])
    M3Configuration._ext = []
    
    #-----< M3Configuration-ExtIEs >-----#
    M3Configuration_ExtIEs = CLASS(name=u'M3Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    M3Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M3period >-----#
    M3period = ENUM(name=u'M3period', mode=MODE_TYPE)
    M3period._cont = ASN1Dict([(u'ms100', 0), (u'ms1000', 1), (u'ms10000', 2), (u'ms1024', 3), (u'ms1280', 4), (u'ms2048', 5), (u'ms2560', 6), (u'ms5120', 7), (u'ms10240', 8), (u'min1', 9)])
    M3period._ext = [u'ms1024', u'ms1280', u'ms2048', u'ms2560', u'ms5120', u'ms10240', u'min1']
    
    #-----< M4Configuration >-----#
    M4Configuration = SEQ(name=u'M4Configuration', mode=MODE_TYPE)
    _M4Configuration_m4period = ENUM(name=u'm4period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M4period')))
    _M4Configuration_m4_links_to_log = ENUM(name=u'm4-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Links-to-log')))
    _M4Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M4Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___M4Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____M4Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M4Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M4Configuration_iE_Extensions__item__id._const_tab = ____M4Configuration_iE_Extensions__item__id_tab
    ___M4Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M4Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___M4Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____M4Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M4Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M4Configuration_iE_Extensions__item__criticality._const_tab = ____M4Configuration_iE_Extensions__item__criticality_tab
    ___M4Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M4Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M4Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____M4Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M4Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M4Configuration_iE_Extensions__item__extensionValue._const_tab = ____M4Configuration_iE_Extensions__item__extensionValue_tab
    ___M4Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M4Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M4Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M4Configuration_iE_Extensions__item__id),
        (u'criticality', ___M4Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___M4Configuration_iE_Extensions__item__extensionValue),
        ])
    __M4Configuration_iE_Extensions__item_._ext = None
    _M4Configuration_iE_Extensions._cont = __M4Configuration_iE_Extensions__item_
    _M4Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M4Configuration._cont = ASN1Dict([
        (u'm4period', _M4Configuration_m4period),
        (u'm4-links-to-log', _M4Configuration_m4_links_to_log),
        (u'iE-Extensions', _M4Configuration_iE_Extensions),
        ])
    M4Configuration._ext = []
    
    #-----< M4Configuration-ExtIEs >-----#
    M4Configuration_ExtIEs = CLASS(name=u'M4Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    M4Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M4period >-----#
    M4period = ENUM(name=u'M4period', mode=MODE_TYPE)
    M4period._cont = ASN1Dict([(u'ms1024', 0), (u'ms2048', 1), (u'ms5120', 2), (u'ms10240', 3), (u'min1', 4)])
    M4period._ext = []
    
    #-----< M5Configuration >-----#
    M5Configuration = SEQ(name=u'M5Configuration', mode=MODE_TYPE)
    _M5Configuration_m5period = ENUM(name=u'm5period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M5period')))
    _M5Configuration_m5_links_to_log = ENUM(name=u'm5-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Links-to-log')))
    _M5Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M5Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___M5Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____M5Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M5Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M5Configuration_iE_Extensions__item__id._const_tab = ____M5Configuration_iE_Extensions__item__id_tab
    ___M5Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M5Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___M5Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____M5Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M5Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M5Configuration_iE_Extensions__item__criticality._const_tab = ____M5Configuration_iE_Extensions__item__criticality_tab
    ___M5Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M5Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M5Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____M5Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M5Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab = ____M5Configuration_iE_Extensions__item__extensionValue_tab
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M5Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M5Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M5Configuration_iE_Extensions__item__id),
        (u'criticality', ___M5Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___M5Configuration_iE_Extensions__item__extensionValue),
        ])
    __M5Configuration_iE_Extensions__item_._ext = None
    _M5Configuration_iE_Extensions._cont = __M5Configuration_iE_Extensions__item_
    _M5Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M5Configuration._cont = ASN1Dict([
        (u'm5period', _M5Configuration_m5period),
        (u'm5-links-to-log', _M5Configuration_m5_links_to_log),
        (u'iE-Extensions', _M5Configuration_iE_Extensions),
        ])
    M5Configuration._ext = []
    
    #-----< M5Configuration-ExtIEs >-----#
    M5Configuration_ExtIEs = CLASS(name=u'M5Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    M5Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M5period >-----#
    M5period = ENUM(name=u'M5period', mode=MODE_TYPE)
    M5period._cont = ASN1Dict([(u'ms1024', 0), (u'ms2048', 1), (u'ms5120', 2), (u'ms10240', 3), (u'min1', 4)])
    M5period._ext = []
    
    #-----< M6Configuration >-----#
    M6Configuration = SEQ(name=u'M6Configuration', mode=MODE_TYPE)
    _M6Configuration_m6report_Interval = ENUM(name=u'm6report-Interval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M6report-Interval')))
    _M6Configuration_m6delay_threshold = ENUM(name=u'm6delay-threshold', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M6delay-threshold')), opt=True)
    _M6Configuration_m6_links_to_log = ENUM(name=u'm6-links-to-log', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Links-to-log')))
    _M6Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M6Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___M6Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____M6Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M6Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Configuration_iE_Extensions__item__id._const_tab = ____M6Configuration_iE_Extensions__item__id_tab
    ___M6Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M6Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___M6Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____M6Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M6Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Configuration_iE_Extensions__item__criticality._const_tab = ____M6Configuration_iE_Extensions__item__criticality_tab
    ___M6Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M6Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M6Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____M6Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M6Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab = ____M6Configuration_iE_Extensions__item__extensionValue_tab
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M6Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M6Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M6Configuration_iE_Extensions__item__id),
        (u'criticality', ___M6Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___M6Configuration_iE_Extensions__item__extensionValue),
        ])
    __M6Configuration_iE_Extensions__item_._ext = None
    _M6Configuration_iE_Extensions._cont = __M6Configuration_iE_Extensions__item_
    _M6Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M6Configuration._cont = ASN1Dict([
        (u'm6report-Interval', _M6Configuration_m6report_Interval),
        (u'm6delay-threshold', _M6Configuration_m6delay_threshold),
        (u'm6-links-to-log', _M6Configuration_m6_links_to_log),
        (u'iE-Extensions', _M6Configuration_iE_Extensions),
        ])
    M6Configuration._ext = []
    
    #-----< M6Configuration-ExtIEs >-----#
    M6Configuration_ExtIEs = CLASS(name=u'M6Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    M6Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M6report-Interval >-----#
    M6report_Interval = ENUM(name=u'M6report-Interval', mode=MODE_TYPE)
    M6report_Interval._cont = ASN1Dict([(u'ms1024', 0), (u'ms2048', 1), (u'ms5120', 2), (u'ms10240', 3)])
    M6report_Interval._ext = []
    
    #-----< M6delay-threshold >-----#
    M6delay_threshold = ENUM(name=u'M6delay-threshold', mode=MODE_TYPE)
    M6delay_threshold._cont = ASN1Dict([(u'ms30', 0), (u'ms40', 1), (u'ms50', 2), (u'ms60', 3), (u'ms70', 4), (u'ms80', 5), (u'ms90', 6), (u'ms100', 7), (u'ms150', 8), (u'ms300', 9), (u'ms500', 10), (u'ms750', 11)])
    M6delay_threshold._ext = []
    
    #-----< M7Configuration >-----#
    M7Configuration = SEQ(name=u'M7Configuration', mode=MODE_TYPE)
    _M7Configuration_m7period = INT(name=u'm7period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M7period')))
    _M7Configuration_m7_links_to_log = ENUM(name=u'm7-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Links-to-log')))
    _M7Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M7Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___M7Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____M7Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M7Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Configuration_iE_Extensions__item__id._const_tab = ____M7Configuration_iE_Extensions__item__id_tab
    ___M7Configuration_iE_Extensions__item__id._const_tab_at = None
    ___M7Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___M7Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____M7Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M7Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Configuration_iE_Extensions__item__criticality._const_tab = ____M7Configuration_iE_Extensions__item__criticality_tab
    ___M7Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M7Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M7Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____M7Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M7Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab = ____M7Configuration_iE_Extensions__item__extensionValue_tab
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M7Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M7Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M7Configuration_iE_Extensions__item__id),
        (u'criticality', ___M7Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___M7Configuration_iE_Extensions__item__extensionValue),
        ])
    __M7Configuration_iE_Extensions__item_._ext = None
    _M7Configuration_iE_Extensions._cont = __M7Configuration_iE_Extensions__item_
    _M7Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M7Configuration._cont = ASN1Dict([
        (u'm7period', _M7Configuration_m7period),
        (u'm7-links-to-log', _M7Configuration_m7_links_to_log),
        (u'iE-Extensions', _M7Configuration_iE_Extensions),
        ])
    M7Configuration._ext = []
    
    #-----< M7Configuration-ExtIEs >-----#
    M7Configuration_ExtIEs = CLASS(name=u'M7Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    M7Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M7period >-----#
    M7period = INT(name=u'M7period', mode=MODE_TYPE)
    M7period._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=60)], ev=[], er=[])
    
    #-----< MDT-Activation >-----#
    MDT_Activation = ENUM(name=u'MDT-Activation', mode=MODE_TYPE)
    MDT_Activation._cont = ASN1Dict([(u'immediate-MDT-only', 0), (u'immediate-MDT-and-Trace', 1), (u'logged-MDT-only', 2), (u'logged-MBSFN-MDT', 3)])
    MDT_Activation._ext = [u'logged-MBSFN-MDT']
    
    #-----< MDT-Location-Info >-----#
    MDT_Location_Info = BIT_STR(name=u'MDT-Location-Info', mode=MODE_TYPE)
    MDT_Location_Info._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< MDT-Configuration >-----#
    MDT_Configuration = SEQ(name=u'MDT-Configuration', mode=MODE_TYPE)
    _MDT_Configuration_mdt_Activation = ENUM(name=u'mdt-Activation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MDT-Activation')))
    _MDT_Configuration_areaScopeOfMDT = CHOICE(name=u'areaScopeOfMDT', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'AreaScopeOfMDT')))
    _MDT_Configuration_mDTMode = CHOICE(name=u'mDTMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MDTMode')))
    _MDT_Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MDT_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___MDT_Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____MDT_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDTPLMNList')))
    ____MDT_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 178), (u'criticality', u'ignore'), (u'Extension', _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MDT_Configuration_iE_Extensions__item__id._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___MDT_Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___MDT_Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MDT_Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MDT_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MDT_Configuration_iE_Extensions__item__id),
        (u'criticality', ___MDT_Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___MDT_Configuration_iE_Extensions__item__extensionValue),
        ])
    __MDT_Configuration_iE_Extensions__item_._ext = None
    _MDT_Configuration_iE_Extensions._cont = __MDT_Configuration_iE_Extensions__item_
    _MDT_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MDT_Configuration._cont = ASN1Dict([
        (u'mdt-Activation', _MDT_Configuration_mdt_Activation),
        (u'areaScopeOfMDT', _MDT_Configuration_areaScopeOfMDT),
        (u'mDTMode', _MDT_Configuration_mDTMode),
        (u'iE-Extensions', _MDT_Configuration_iE_Extensions),
        ])
    MDT_Configuration._ext = []
    
    #-----< MDT-Configuration-ExtIEs >-----#
    MDT_Configuration_ExtIEs = CLASS(name=u'MDT-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _MDT_Configuration_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDTPLMNList')))
    MDT_Configuration_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 178), (u'criticality', u'ignore'), (u'Extension', _MDT_Configuration_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ManagementBasedMDTAllowed >-----#
    ManagementBasedMDTAllowed = ENUM(name=u'ManagementBasedMDTAllowed', mode=MODE_TYPE)
    ManagementBasedMDTAllowed._cont = ASN1Dict([(u'allowed', 0)])
    ManagementBasedMDTAllowed._ext = []
    
    #-----< MBSFN-ResultToLog >-----#
    MBSFN_ResultToLog = SEQ_OF(name=u'MBSFN-ResultToLog', mode=MODE_TYPE)
    _MBSFN_ResultToLog__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MBSFN-ResultToLogInfo')))
    MBSFN_ResultToLog._cont = _MBSFN_ResultToLog__item_
    MBSFN_ResultToLog._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MBSFN-ResultToLogInfo >-----#
    MBSFN_ResultToLogInfo = SEQ(name=u'MBSFN-ResultToLogInfo', mode=MODE_TYPE)
    _MBSFN_ResultToLogInfo_mBSFN_AreaId = INT(name=u'mBSFN-AreaId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MBSFN_ResultToLogInfo_mBSFN_AreaId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _MBSFN_ResultToLogInfo_carrierFreq = INT(name=u'carrierFreq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EARFCN')))
    _MBSFN_ResultToLogInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSFN_ResultToLogInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBSFN_ResultToLogInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____MBSFN_ResultToLogInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__id._const_tab = ____MBSFN_ResultToLogInfo_iE_Extensions__item__id_tab
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__id._const_tab_at = None
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBSFN_ResultToLogInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____MBSFN_ResultToLogInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__criticality._const_tab = ____MBSFN_ResultToLogInfo_iE_Extensions__item__criticality_tab
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBSFN_ResultToLogInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____MBSFN_ResultToLogInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__extensionValue._const_tab = ____MBSFN_ResultToLogInfo_iE_Extensions__item__extensionValue_tab
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBSFN_ResultToLogInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBSFN_ResultToLogInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBSFN_ResultToLogInfo_iE_Extensions__item__id),
        (u'criticality', ___MBSFN_ResultToLogInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBSFN_ResultToLogInfo_iE_Extensions__item__extensionValue),
        ])
    __MBSFN_ResultToLogInfo_iE_Extensions__item_._ext = None
    _MBSFN_ResultToLogInfo_iE_Extensions._cont = __MBSFN_ResultToLogInfo_iE_Extensions__item_
    _MBSFN_ResultToLogInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSFN_ResultToLogInfo._cont = ASN1Dict([
        (u'mBSFN-AreaId', _MBSFN_ResultToLogInfo_mBSFN_AreaId),
        (u'carrierFreq', _MBSFN_ResultToLogInfo_carrierFreq),
        (u'iE-Extensions', _MBSFN_ResultToLogInfo_iE_Extensions),
        ])
    MBSFN_ResultToLogInfo._ext = []
    
    #-----< MBSFN-ResultToLogInfo-ExtIEs >-----#
    MBSFN_ResultToLogInfo_ExtIEs = CLASS(name=u'MBSFN-ResultToLogInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    MBSFN_ResultToLogInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MDTPLMNList >-----#
    MDTPLMNList = SEQ_OF(name=u'MDTPLMNList', mode=MODE_TYPE)
    _MDTPLMNList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    MDTPLMNList._cont = _MDTPLMNList__item_
    MDTPLMNList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PrivacyIndicator >-----#
    PrivacyIndicator = ENUM(name=u'PrivacyIndicator', mode=MODE_TYPE)
    PrivacyIndicator._cont = ASN1Dict([(u'immediate-MDT', 0), (u'logged-MDT', 1)])
    PrivacyIndicator._ext = []
    
    #-----< MDTMode >-----#
    MDTMode = CHOICE(name=u'MDTMode', mode=MODE_TYPE)
    _MDTMode_immediateMDT = SEQ(name=u'immediateMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ImmediateMDT')))
    _MDTMode_loggedMDT = SEQ(name=u'loggedMDT', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LoggedMDT')))
    _MDTMode_mDTMode_Extension = SEQ(name=u'mDTMode-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MDTMode-Extension')))
    MDTMode._cont = ASN1Dict([
        (u'immediateMDT', _MDTMode_immediateMDT),
        (u'loggedMDT', _MDTMode_loggedMDT),
        (u'mDTMode-Extension', _MDTMode_mDTMode_Extension),
        ])
    MDTMode._ext = [u'mDTMode-Extension']
    
    #-----< MDTMode-Extension >-----#
    MDTMode_Extension = SEQ(name=u'MDTMode-Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    _MDTMode_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    __MDTMode_Extension_id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ___MDTMode_Extension_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LoggedMBSFNMDT')))
    __MDTMode_Extension_id_tab._val = ASN1Set(rv=[dict([(u'id', 197), (u'criticality', u'ignore'), (u'Value', ___MDTMode_Extension_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _MDTMode_Extension_id._const_tab = __MDTMode_Extension_id_tab
    _MDTMode_Extension_id._const_tab_at = None
    _MDTMode_Extension_id._const_tab_id = u'id'
    _MDTMode_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    _MDTMode_Extension_criticality._const_tab = __MDTMode_Extension_id_tab
    _MDTMode_Extension_criticality._const_tab_at = ('..', u'id')
    _MDTMode_Extension_criticality._const_tab_id = u'criticality'
    _MDTMode_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    _MDTMode_Extension_value._const_tab = __MDTMode_Extension_id_tab
    _MDTMode_Extension_value._const_tab_at = ('..', u'id')
    _MDTMode_Extension_value._const_tab_id = u'Value'
    MDTMode_Extension._cont = ASN1Dict([
        (u'id', _MDTMode_Extension_id),
        (u'criticality', _MDTMode_Extension_criticality),
        (u'value', _MDTMode_Extension_value),
        ])
    MDTMode_Extension._ext = None
    
    #-----< MDTMode-ExtensionIE >-----#
    MDTMode_ExtensionIE = CLASS(name=u'MDTMode-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _MDTMode_ExtensionIE_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LoggedMBSFNMDT')))
    MDTMode_ExtensionIE._val = ASN1Set(rv=[dict([(u'id', 197), (u'criticality', u'ignore'), (u'Value', _MDTMode_ExtensionIE_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< MeasurementsToActivate >-----#
    MeasurementsToActivate = BIT_STR(name=u'MeasurementsToActivate', mode=MODE_TYPE)
    MeasurementsToActivate._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< MeasurementThresholdA2 >-----#
    MeasurementThresholdA2 = CHOICE(name=u'MeasurementThresholdA2', mode=MODE_TYPE)
    _MeasurementThresholdA2_threshold_RSRP = INT(name=u'threshold-RSRP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Threshold-RSRP')))
    _MeasurementThresholdA2_threshold_RSRQ = INT(name=u'threshold-RSRQ', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Threshold-RSRQ')))
    MeasurementThresholdA2._cont = ASN1Dict([
        (u'threshold-RSRP', _MeasurementThresholdA2_threshold_RSRP),
        (u'threshold-RSRQ', _MeasurementThresholdA2_threshold_RSRQ),
        ])
    MeasurementThresholdA2._ext = []
    
    #-----< MessageIdentifier >-----#
    MessageIdentifier = BIT_STR(name=u'MessageIdentifier', mode=MODE_TYPE)
    MessageIdentifier._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< MobilityInformation >-----#
    MobilityInformation = BIT_STR(name=u'MobilityInformation', mode=MODE_TYPE)
    MobilityInformation._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< MMEname >-----#
    MMEname = STR_PRINT(name=u'MMEname', mode=MODE_TYPE)
    MMEname._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=150)], ev=[], er=[])
    
    #-----< MMEPagingTarget >-----#
    MMEPagingTarget = CHOICE(name=u'MMEPagingTarget', mode=MODE_TYPE)
    _MMEPagingTarget_global_ENB_ID = SEQ(name=u'global-ENB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    _MMEPagingTarget_tAI = SEQ(name=u'tAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    MMEPagingTarget._cont = ASN1Dict([
        (u'global-ENB-ID', _MMEPagingTarget_global_ENB_ID),
        (u'tAI', _MMEPagingTarget_tAI),
        ])
    MMEPagingTarget._ext = []
    
    #-----< MMERelaySupportIndicator >-----#
    MMERelaySupportIndicator = ENUM(name=u'MMERelaySupportIndicator', mode=MODE_TYPE)
    MMERelaySupportIndicator._cont = ASN1Dict([(u'true', 0)])
    MMERelaySupportIndicator._ext = []
    
    #-----< MME-Group-ID >-----#
    MME_Group_ID = OCT_STR(name=u'MME-Group-ID', mode=MODE_TYPE)
    MME_Group_ID._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< MME-Code >-----#
    MME_Code = OCT_STR(name=u'MME-Code', mode=MODE_TYPE)
    MME_Code._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< MME-UE-S1AP-ID >-----#
    MME_UE_S1AP_ID = INT(name=u'MME-UE-S1AP-ID', mode=MODE_TYPE)
    MME_UE_S1AP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< M-TMSI >-----#
    M_TMSI = OCT_STR(name=u'M-TMSI', mode=MODE_TYPE)
    M_TMSI._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< MSClassmark2 >-----#
    MSClassmark2 = OCT_STR(name=u'MSClassmark2', mode=MODE_TYPE)
    
    #-----< MSClassmark3 >-----#
    MSClassmark3 = OCT_STR(name=u'MSClassmark3', mode=MODE_TYPE)
    
    #-----< MutingAvailabilityIndication >-----#
    MutingAvailabilityIndication = ENUM(name=u'MutingAvailabilityIndication', mode=MODE_TYPE)
    MutingAvailabilityIndication._cont = ASN1Dict([(u'available', 0), (u'unavailable', 1)])
    MutingAvailabilityIndication._ext = []
    
    #-----< MutingPatternInformation >-----#
    MutingPatternInformation = SEQ(name=u'MutingPatternInformation', mode=MODE_TYPE)
    _MutingPatternInformation_muting_pattern_period = ENUM(name=u'muting-pattern-period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MutingPatternInformation_muting_pattern_period._cont = ASN1Dict([(u'ms0', 0), (u'ms1280', 1), (u'ms2560', 2), (u'ms5120', 3), (u'ms10240', 4)])
    _MutingPatternInformation_muting_pattern_period._ext = []
    _MutingPatternInformation_muting_pattern_offset = INT(name=u'muting-pattern-offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MutingPatternInformation_muting_pattern_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10239)], ev=[], er=[])
    _MutingPatternInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MutingPatternInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___MutingPatternInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____MutingPatternInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____MutingPatternInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MutingPatternInformation_iE_Extensions__item__id._const_tab = ____MutingPatternInformation_iE_Extensions__item__id_tab
    ___MutingPatternInformation_iE_Extensions__item__id._const_tab_at = None
    ___MutingPatternInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___MutingPatternInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MutingPatternInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____MutingPatternInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MutingPatternInformation_iE_Extensions__item__criticality._const_tab = ____MutingPatternInformation_iE_Extensions__item__criticality_tab
    ___MutingPatternInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MutingPatternInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MutingPatternInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MutingPatternInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____MutingPatternInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MutingPatternInformation_iE_Extensions__item__extensionValue._const_tab = ____MutingPatternInformation_iE_Extensions__item__extensionValue_tab
    ___MutingPatternInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MutingPatternInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MutingPatternInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MutingPatternInformation_iE_Extensions__item__id),
        (u'criticality', ___MutingPatternInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___MutingPatternInformation_iE_Extensions__item__extensionValue),
        ])
    __MutingPatternInformation_iE_Extensions__item_._ext = None
    _MutingPatternInformation_iE_Extensions._cont = __MutingPatternInformation_iE_Extensions__item_
    _MutingPatternInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MutingPatternInformation._cont = ASN1Dict([
        (u'muting-pattern-period', _MutingPatternInformation_muting_pattern_period),
        (u'muting-pattern-offset', _MutingPatternInformation_muting_pattern_offset),
        (u'iE-Extensions', _MutingPatternInformation_iE_Extensions),
        ])
    MutingPatternInformation._ext = []
    
    #-----< MutingPatternInformation-ExtIEs >-----#
    MutingPatternInformation_ExtIEs = CLASS(name=u'MutingPatternInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    MutingPatternInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MDT-ConfigurationNR >-----#
    MDT_ConfigurationNR = OCT_STR(name=u'MDT-ConfigurationNR', mode=MODE_TYPE)
    
    #-----< NAS-PDU >-----#
    NAS_PDU = OCT_STR(name=u'NAS-PDU', mode=MODE_TYPE)
    
    #-----< NASSecurityParametersfromE-UTRAN >-----#
    NASSecurityParametersfromE_UTRAN = OCT_STR(name=u'NASSecurityParametersfromE-UTRAN', mode=MODE_TYPE)
    
    #-----< NASSecurityParameterstoE-UTRAN >-----#
    NASSecurityParameterstoE_UTRAN = OCT_STR(name=u'NASSecurityParameterstoE-UTRAN', mode=MODE_TYPE)
    
    #-----< NB-IoT-DefaultPagingDRX >-----#
    NB_IoT_DefaultPagingDRX = ENUM(name=u'NB-IoT-DefaultPagingDRX', mode=MODE_TYPE)
    NB_IoT_DefaultPagingDRX._cont = ASN1Dict([(u'v128', 0), (u'v256', 1), (u'v512', 2), (u'v1024', 3)])
    NB_IoT_DefaultPagingDRX._ext = []
    
    #-----< NB-IoT-PagingDRX >-----#
    NB_IoT_PagingDRX = ENUM(name=u'NB-IoT-PagingDRX', mode=MODE_TYPE)
    NB_IoT_PagingDRX._cont = ASN1Dict([(u'v32', 0), (u'v64', 1), (u'v128', 2), (u'v256', 3), (u'v512', 4), (u'v1024', 5)])
    NB_IoT_PagingDRX._ext = []
    
    #-----< NB-IoT-Paging-eDRXInformation >-----#
    NB_IoT_Paging_eDRXInformation = SEQ(name=u'NB-IoT-Paging-eDRXInformation', mode=MODE_TYPE)
    _NB_IoT_Paging_eDRXInformation_nB_IoT_paging_eDRX_Cycle = ENUM(name=u'nB-IoT-paging-eDRX-Cycle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-Paging-eDRX-Cycle')))
    _NB_IoT_Paging_eDRXInformation_nB_IoT_pagingTimeWindow = ENUM(name=u'nB-IoT-pagingTimeWindow', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-PagingTimeWindow')), opt=True)
    _NB_IoT_Paging_eDRXInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NB_IoT_Paging_eDRXInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__id._const_tab = ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__id_tab
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__id._const_tab_at = None
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__criticality._const_tab = ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__criticality_tab
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__extensionValue._const_tab = ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__extensionValue_tab
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NB_IoT_Paging_eDRXInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__id),
        (u'criticality', ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__extensionValue),
        ])
    __NB_IoT_Paging_eDRXInformation_iE_Extensions__item_._ext = None
    _NB_IoT_Paging_eDRXInformation_iE_Extensions._cont = __NB_IoT_Paging_eDRXInformation_iE_Extensions__item_
    _NB_IoT_Paging_eDRXInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NB_IoT_Paging_eDRXInformation._cont = ASN1Dict([
        (u'nB-IoT-paging-eDRX-Cycle', _NB_IoT_Paging_eDRXInformation_nB_IoT_paging_eDRX_Cycle),
        (u'nB-IoT-pagingTimeWindow', _NB_IoT_Paging_eDRXInformation_nB_IoT_pagingTimeWindow),
        (u'iE-Extensions', _NB_IoT_Paging_eDRXInformation_iE_Extensions),
        ])
    NB_IoT_Paging_eDRXInformation._ext = []
    
    #-----< NB-IoT-Paging-eDRXInformation-ExtIEs >-----#
    NB_IoT_Paging_eDRXInformation_ExtIEs = CLASS(name=u'NB-IoT-Paging-eDRXInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    NB_IoT_Paging_eDRXInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NB-IoT-Paging-eDRX-Cycle >-----#
    NB_IoT_Paging_eDRX_Cycle = ENUM(name=u'NB-IoT-Paging-eDRX-Cycle', mode=MODE_TYPE)
    NB_IoT_Paging_eDRX_Cycle._cont = ASN1Dict([(u'hf2', 0), (u'hf4', 1), (u'hf6', 2), (u'hf8', 3), (u'hf10', 4), (u'hf12', 5), (u'hf14', 6), (u'hf16', 7), (u'hf32', 8), (u'hf64', 9), (u'hf128', 10), (u'hf256', 11), (u'hf512', 12), (u'hf1024', 13)])
    NB_IoT_Paging_eDRX_Cycle._ext = []
    
    #-----< NB-IoT-PagingTimeWindow >-----#
    NB_IoT_PagingTimeWindow = ENUM(name=u'NB-IoT-PagingTimeWindow', mode=MODE_TYPE)
    NB_IoT_PagingTimeWindow._cont = ASN1Dict([(u's1', 0), (u's2', 1), (u's3', 2), (u's4', 3), (u's5', 4), (u's6', 5), (u's7', 6), (u's8', 7), (u's9', 8), (u's10', 9), (u's11', 10), (u's12', 11), (u's13', 12), (u's14', 13), (u's15', 14), (u's16', 15)])
    NB_IoT_PagingTimeWindow._ext = []
    
    #-----< NB-IoT-RLF-Report-Container >-----#
    NB_IoT_RLF_Report_Container = OCT_STR(name=u'NB-IoT-RLF-Report-Container', mode=MODE_TYPE)
    
    #-----< NB-IoT-UEIdentityIndexValue >-----#
    NB_IoT_UEIdentityIndexValue = BIT_STR(name=u'NB-IoT-UEIdentityIndexValue', mode=MODE_TYPE)
    NB_IoT_UEIdentityIndexValue._const_sz = ASN1Set(rv=[12], rr=[], ev=None, er=[])
    
    #-----< NextPagingAreaScope >-----#
    NextPagingAreaScope = ENUM(name=u'NextPagingAreaScope', mode=MODE_TYPE)
    NextPagingAreaScope._cont = ASN1Dict([(u'same', 0), (u'changed', 1)])
    NextPagingAreaScope._ext = []
    
    #-----< NotifySourceeNB >-----#
    NotifySourceeNB = ENUM(name=u'NotifySourceeNB', mode=MODE_TYPE)
    NotifySourceeNB._cont = ASN1Dict([(u'notifySource', 0)])
    NotifySourceeNB._ext = []
    
    #-----< NRCellIdentity >-----#
    NRCellIdentity = BIT_STR(name=u'NRCellIdentity', mode=MODE_TYPE)
    NRCellIdentity._const_sz = ASN1Set(rv=[36], rr=[], ev=None, er=[])
    
    #-----< NR-CGI >-----#
    NR_CGI = SEQ(name=u'NR-CGI', mode=MODE_TYPE)
    _NR_CGI_pLMNIdentity = OCT_STR(name=u'pLMNIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _NR_CGI_nRCellIdentity = BIT_STR(name=u'nRCellIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NRCellIdentity')))
    _NR_CGI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NR_CGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___NR_CGI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NR_CGI_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NR_CGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_iE_Extensions__item__id._const_tab = ____NR_CGI_iE_Extensions__item__id_tab
    ___NR_CGI_iE_Extensions__item__id._const_tab_at = None
    ___NR_CGI_iE_Extensions__item__id._const_tab_id = u'id'
    ___NR_CGI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NR_CGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NR_CGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_iE_Extensions__item__criticality._const_tab = ____NR_CGI_iE_Extensions__item__criticality_tab
    ___NR_CGI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NR_CGI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NR_CGI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NR_CGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NR_CGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NR_CGI_iE_Extensions__item__extensionValue._const_tab = ____NR_CGI_iE_Extensions__item__extensionValue_tab
    ___NR_CGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NR_CGI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NR_CGI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NR_CGI_iE_Extensions__item__id),
        (u'criticality', ___NR_CGI_iE_Extensions__item__criticality),
        (u'extensionValue', ___NR_CGI_iE_Extensions__item__extensionValue),
        ])
    __NR_CGI_iE_Extensions__item_._ext = None
    _NR_CGI_iE_Extensions._cont = __NR_CGI_iE_Extensions__item_
    _NR_CGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NR_CGI._cont = ASN1Dict([
        (u'pLMNIdentity', _NR_CGI_pLMNIdentity),
        (u'nRCellIdentity', _NR_CGI_nRCellIdentity),
        (u'iE-Extensions', _NR_CGI_iE_Extensions),
        ])
    NR_CGI._ext = []
    
    #-----< NR-CGI-ExtIEs >-----#
    NR_CGI_ExtIEs = CLASS(name=u'NR-CGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    NR_CGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRencryptionAlgorithms >-----#
    NRencryptionAlgorithms = BIT_STR(name=u'NRencryptionAlgorithms', mode=MODE_TYPE)
    NRencryptionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< NRintegrityProtectionAlgorithms >-----#
    NRintegrityProtectionAlgorithms = BIT_STR(name=u'NRintegrityProtectionAlgorithms', mode=MODE_TYPE)
    NRintegrityProtectionAlgorithms._const_sz = ASN1Set(rv=[16], rr=[], ev=[], er=[])
    
    #-----< NRrestrictioninEPSasSecondaryRAT >-----#
    NRrestrictioninEPSasSecondaryRAT = ENUM(name=u'NRrestrictioninEPSasSecondaryRAT', mode=MODE_TYPE)
    NRrestrictioninEPSasSecondaryRAT._cont = ASN1Dict([(u'nRrestrictedinEPSasSecondaryRAT', 0)])
    NRrestrictioninEPSasSecondaryRAT._ext = []
    
    #-----< NRrestrictionin5GS >-----#
    NRrestrictionin5GS = ENUM(name=u'NRrestrictionin5GS', mode=MODE_TYPE)
    NRrestrictionin5GS._cont = ASN1Dict([(u'nRrestrictedin5GS', 0)])
    NRrestrictionin5GS._ext = []
    
    #-----< NRUESecurityCapabilities >-----#
    NRUESecurityCapabilities = SEQ(name=u'NRUESecurityCapabilities', mode=MODE_TYPE)
    _NRUESecurityCapabilities_nRencryptionAlgorithms = BIT_STR(name=u'nRencryptionAlgorithms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NRencryptionAlgorithms')))
    _NRUESecurityCapabilities_nRintegrityProtectionAlgorithms = BIT_STR(name=u'nRintegrityProtectionAlgorithms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NRintegrityProtectionAlgorithms')))
    _NRUESecurityCapabilities_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRUESecurityCapabilities_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___NRUESecurityCapabilities_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NRUESecurityCapabilities_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NRUESecurityCapabilities_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESecurityCapabilities_iE_Extensions__item__id._const_tab = ____NRUESecurityCapabilities_iE_Extensions__item__id_tab
    ___NRUESecurityCapabilities_iE_Extensions__item__id._const_tab_at = None
    ___NRUESecurityCapabilities_iE_Extensions__item__id._const_tab_id = u'id'
    ___NRUESecurityCapabilities_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NRUESecurityCapabilities_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NRUESecurityCapabilities_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESecurityCapabilities_iE_Extensions__item__criticality._const_tab = ____NRUESecurityCapabilities_iE_Extensions__item__criticality_tab
    ___NRUESecurityCapabilities_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NRUESecurityCapabilities_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NRUESecurityCapabilities_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NRUESecurityCapabilities_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NRUESecurityCapabilities_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab = ____NRUESecurityCapabilities_iE_Extensions__item__extensionValue_tab
    ___NRUESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NRUESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NRUESecurityCapabilities_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NRUESecurityCapabilities_iE_Extensions__item__id),
        (u'criticality', ___NRUESecurityCapabilities_iE_Extensions__item__criticality),
        (u'extensionValue', ___NRUESecurityCapabilities_iE_Extensions__item__extensionValue),
        ])
    __NRUESecurityCapabilities_iE_Extensions__item_._ext = None
    _NRUESecurityCapabilities_iE_Extensions._cont = __NRUESecurityCapabilities_iE_Extensions__item_
    _NRUESecurityCapabilities_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRUESecurityCapabilities._cont = ASN1Dict([
        (u'nRencryptionAlgorithms', _NRUESecurityCapabilities_nRencryptionAlgorithms),
        (u'nRintegrityProtectionAlgorithms', _NRUESecurityCapabilities_nRintegrityProtectionAlgorithms),
        (u'iE-Extensions', _NRUESecurityCapabilities_iE_Extensions),
        ])
    NRUESecurityCapabilities._ext = []
    
    #-----< NRUESecurityCapabilities-ExtIEs >-----#
    NRUESecurityCapabilities_ExtIEs = CLASS(name=u'NRUESecurityCapabilities-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    NRUESecurityCapabilities_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NumberofBroadcastRequest >-----#
    NumberofBroadcastRequest = INT(name=u'NumberofBroadcastRequest', mode=MODE_TYPE)
    NumberofBroadcastRequest._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< NumberOfBroadcasts >-----#
    NumberOfBroadcasts = INT(name=u'NumberOfBroadcasts', mode=MODE_TYPE)
    NumberOfBroadcasts._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< NRV2XServicesAuthorized >-----#
    NRV2XServicesAuthorized = SEQ(name=u'NRV2XServicesAuthorized', mode=MODE_TYPE)
    _NRV2XServicesAuthorized_vehicleUE = ENUM(name=u'vehicleUE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'VehicleUE')), opt=True)
    _NRV2XServicesAuthorized_pedestrianUE = ENUM(name=u'pedestrianUE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PedestrianUE')), opt=True)
    _NRV2XServicesAuthorized_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRV2XServicesAuthorized_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___NRV2XServicesAuthorized_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRV2XServicesAuthorized_iE_Extensions__item__id._const_tab = ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab
    ___NRV2XServicesAuthorized_iE_Extensions__item__id._const_tab_at = None
    ___NRV2XServicesAuthorized_iE_Extensions__item__id._const_tab_id = u'id'
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab = ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NRV2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab = ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NRV2XServicesAuthorized_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NRV2XServicesAuthorized_iE_Extensions__item__id),
        (u'criticality', ___NRV2XServicesAuthorized_iE_Extensions__item__criticality),
        (u'extensionValue', ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue),
        ])
    __NRV2XServicesAuthorized_iE_Extensions__item_._ext = None
    _NRV2XServicesAuthorized_iE_Extensions._cont = __NRV2XServicesAuthorized_iE_Extensions__item_
    _NRV2XServicesAuthorized_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRV2XServicesAuthorized._cont = ASN1Dict([
        (u'vehicleUE', _NRV2XServicesAuthorized_vehicleUE),
        (u'pedestrianUE', _NRV2XServicesAuthorized_pedestrianUE),
        (u'iE-Extensions', _NRV2XServicesAuthorized_iE_Extensions),
        ])
    NRV2XServicesAuthorized._ext = []
    
    #-----< NRV2XServicesAuthorized-ExtIEs >-----#
    NRV2XServicesAuthorized_ExtIEs = CLASS(name=u'NRV2XServicesAuthorized-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    NRV2XServicesAuthorized_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NRUESidelinkAggregateMaximumBitrate >-----#
    NRUESidelinkAggregateMaximumBitrate = SEQ(name=u'NRUESidelinkAggregateMaximumBitrate', mode=MODE_TYPE)
    _NRUESidelinkAggregateMaximumBitrate_uEaggregateMaximumBitRate = INT(name=u'uEaggregateMaximumBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')))
    _NRUESidelinkAggregateMaximumBitrate_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab = ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_at = None
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_id = u'id'
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab = ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab = ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id),
        (u'criticality', ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality),
        (u'extensionValue', ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue),
        ])
    __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_._ext = None
    _NRUESidelinkAggregateMaximumBitrate_iE_Extensions._cont = __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_
    _NRUESidelinkAggregateMaximumBitrate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NRUESidelinkAggregateMaximumBitrate._cont = ASN1Dict([
        (u'uEaggregateMaximumBitRate', _NRUESidelinkAggregateMaximumBitrate_uEaggregateMaximumBitRate),
        (u'iE-Extensions', _NRUESidelinkAggregateMaximumBitrate_iE_Extensions),
        ])
    NRUESidelinkAggregateMaximumBitrate._ext = []
    
    #-----< NRUESidelinkAggregateMaximumBitrate-ExtIEs >-----#
    NRUESidelinkAggregateMaximumBitrate_ExtIEs = CLASS(name=u'NRUESidelinkAggregateMaximumBitrate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    NRUESidelinkAggregateMaximumBitrate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< OldBSS-ToNewBSS-Information >-----#
    OldBSS_ToNewBSS_Information = OCT_STR(name=u'OldBSS-ToNewBSS-Information', mode=MODE_TYPE)
    
    #-----< OverloadAction >-----#
    OverloadAction = ENUM(name=u'OverloadAction', mode=MODE_TYPE)
    OverloadAction._cont = ASN1Dict([(u'reject-non-emergency-mo-dt', 0), (u'reject-rrc-cr-signalling', 1), (u'permit-emergency-sessions-and-mobile-terminated-services-only', 2), (u'permit-high-priority-sessions-and-mobile-terminated-services-only', 3), (u'reject-delay-tolerant-access', 4), (u'permit-high-priority-sessions-and-exception-reporting-and-mobile-terminated-services-only', 5), (u'not-accept-mo-data-or-delay-tolerant-access-from-CP-CIoT', 6)])
    OverloadAction._ext = [u'permit-high-priority-sessions-and-mobile-terminated-services-only', u'reject-delay-tolerant-access', u'permit-high-priority-sessions-and-exception-reporting-and-mobile-terminated-services-only', u'not-accept-mo-data-or-delay-tolerant-access-from-CP-CIoT']
    
    #-----< OverloadResponse >-----#
    OverloadResponse = CHOICE(name=u'OverloadResponse', mode=MODE_TYPE)
    _OverloadResponse_overloadAction = ENUM(name=u'overloadAction', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'OverloadAction')))
    OverloadResponse._cont = ASN1Dict([
        (u'overloadAction', _OverloadResponse_overloadAction),
        ])
    OverloadResponse._ext = []
    
    #-----< Packet-LossRate >-----#
    Packet_LossRate = INT(name=u'Packet-LossRate', mode=MODE_TYPE)
    Packet_LossRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1000)], ev=None, er=[])
    
    #-----< PagingAttemptInformation >-----#
    PagingAttemptInformation = SEQ(name=u'PagingAttemptInformation', mode=MODE_TYPE)
    _PagingAttemptInformation_pagingAttemptCount = INT(name=u'pagingAttemptCount', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PagingAttemptCount')))
    _PagingAttemptInformation_intendedNumberOfPagingAttempts = INT(name=u'intendedNumberOfPagingAttempts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'IntendedNumberOfPagingAttempts')))
    _PagingAttemptInformation_nextPagingAreaScope = ENUM(name=u'nextPagingAreaScope', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NextPagingAreaScope')), opt=True)
    _PagingAttemptInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PagingAttemptInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___PagingAttemptInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PagingAttemptInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PagingAttemptInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingAttemptInformation_iE_Extensions__item__id._const_tab = ____PagingAttemptInformation_iE_Extensions__item__id_tab
    ___PagingAttemptInformation_iE_Extensions__item__id._const_tab_at = None
    ___PagingAttemptInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___PagingAttemptInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PagingAttemptInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PagingAttemptInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingAttemptInformation_iE_Extensions__item__criticality._const_tab = ____PagingAttemptInformation_iE_Extensions__item__criticality_tab
    ___PagingAttemptInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PagingAttemptInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PagingAttemptInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PagingAttemptInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PagingAttemptInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PagingAttemptInformation_iE_Extensions__item__extensionValue._const_tab = ____PagingAttemptInformation_iE_Extensions__item__extensionValue_tab
    ___PagingAttemptInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PagingAttemptInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PagingAttemptInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PagingAttemptInformation_iE_Extensions__item__id),
        (u'criticality', ___PagingAttemptInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___PagingAttemptInformation_iE_Extensions__item__extensionValue),
        ])
    __PagingAttemptInformation_iE_Extensions__item_._ext = None
    _PagingAttemptInformation_iE_Extensions._cont = __PagingAttemptInformation_iE_Extensions__item_
    _PagingAttemptInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PagingAttemptInformation._cont = ASN1Dict([
        (u'pagingAttemptCount', _PagingAttemptInformation_pagingAttemptCount),
        (u'intendedNumberOfPagingAttempts', _PagingAttemptInformation_intendedNumberOfPagingAttempts),
        (u'nextPagingAreaScope', _PagingAttemptInformation_nextPagingAreaScope),
        (u'iE-Extensions', _PagingAttemptInformation_iE_Extensions),
        ])
    PagingAttemptInformation._ext = []
    
    #-----< PagingAttemptInformation-ExtIEs >-----#
    PagingAttemptInformation_ExtIEs = CLASS(name=u'PagingAttemptInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    PagingAttemptInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PagingAttemptCount >-----#
    PagingAttemptCount = INT(name=u'PagingAttemptCount', mode=MODE_TYPE)
    PagingAttemptCount._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    
    #-----< Paging-eDRXInformation >-----#
    Paging_eDRXInformation = SEQ(name=u'Paging-eDRXInformation', mode=MODE_TYPE)
    _Paging_eDRXInformation_paging_eDRX_Cycle = ENUM(name=u'paging-eDRX-Cycle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Paging-eDRX-Cycle')))
    _Paging_eDRXInformation_pagingTimeWindow = ENUM(name=u'pagingTimeWindow', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PagingTimeWindow')), opt=True)
    _Paging_eDRXInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Paging_eDRXInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___Paging_eDRXInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Paging_eDRXInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Paging_eDRXInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Paging_eDRXInformation_iE_Extensions__item__id._const_tab = ____Paging_eDRXInformation_iE_Extensions__item__id_tab
    ___Paging_eDRXInformation_iE_Extensions__item__id._const_tab_at = None
    ___Paging_eDRXInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___Paging_eDRXInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Paging_eDRXInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Paging_eDRXInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Paging_eDRXInformation_iE_Extensions__item__criticality._const_tab = ____Paging_eDRXInformation_iE_Extensions__item__criticality_tab
    ___Paging_eDRXInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Paging_eDRXInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Paging_eDRXInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Paging_eDRXInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Paging_eDRXInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Paging_eDRXInformation_iE_Extensions__item__extensionValue._const_tab = ____Paging_eDRXInformation_iE_Extensions__item__extensionValue_tab
    ___Paging_eDRXInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Paging_eDRXInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Paging_eDRXInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Paging_eDRXInformation_iE_Extensions__item__id),
        (u'criticality', ___Paging_eDRXInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___Paging_eDRXInformation_iE_Extensions__item__extensionValue),
        ])
    __Paging_eDRXInformation_iE_Extensions__item_._ext = None
    _Paging_eDRXInformation_iE_Extensions._cont = __Paging_eDRXInformation_iE_Extensions__item_
    _Paging_eDRXInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Paging_eDRXInformation._cont = ASN1Dict([
        (u'paging-eDRX-Cycle', _Paging_eDRXInformation_paging_eDRX_Cycle),
        (u'pagingTimeWindow', _Paging_eDRXInformation_pagingTimeWindow),
        (u'iE-Extensions', _Paging_eDRXInformation_iE_Extensions),
        ])
    Paging_eDRXInformation._ext = []
    
    #-----< Paging-eDRXInformation-ExtIEs >-----#
    Paging_eDRXInformation_ExtIEs = CLASS(name=u'Paging-eDRXInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    Paging_eDRXInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Paging-eDRX-Cycle >-----#
    Paging_eDRX_Cycle = ENUM(name=u'Paging-eDRX-Cycle', mode=MODE_TYPE)
    Paging_eDRX_Cycle._cont = ASN1Dict([(u'hfhalf', 0), (u'hf1', 1), (u'hf2', 2), (u'hf4', 3), (u'hf6', 4), (u'hf8', 5), (u'hf10', 6), (u'hf12', 7), (u'hf14', 8), (u'hf16', 9), (u'hf32', 10), (u'hf64', 11), (u'hf128', 12), (u'hf256', 13)])
    Paging_eDRX_Cycle._ext = []
    
    #-----< PagingTimeWindow >-----#
    PagingTimeWindow = ENUM(name=u'PagingTimeWindow', mode=MODE_TYPE)
    PagingTimeWindow._cont = ASN1Dict([(u's1', 0), (u's2', 1), (u's3', 2), (u's4', 3), (u's5', 4), (u's6', 5), (u's7', 6), (u's8', 7), (u's9', 8), (u's10', 9), (u's11', 10), (u's12', 11), (u's13', 12), (u's14', 13), (u's15', 14), (u's16', 15)])
    PagingTimeWindow._ext = []
    
    #-----< PagingDRX >-----#
    PagingDRX = ENUM(name=u'PagingDRX', mode=MODE_TYPE)
    PagingDRX._cont = ASN1Dict([(u'v32', 0), (u'v64', 1), (u'v128', 2), (u'v256', 3)])
    PagingDRX._ext = []
    
    #-----< PagingPriority >-----#
    PagingPriority = ENUM(name=u'PagingPriority', mode=MODE_TYPE)
    PagingPriority._cont = ASN1Dict([(u'priolevel1', 0), (u'priolevel2', 1), (u'priolevel3', 2), (u'priolevel4', 3), (u'priolevel5', 4), (u'priolevel6', 5), (u'priolevel7', 6), (u'priolevel8', 7)])
    PagingPriority._ext = []
    
    #-----< PagingProbabilityInformation >-----#
    PagingProbabilityInformation = ENUM(name=u'PagingProbabilityInformation', mode=MODE_TYPE)
    PagingProbabilityInformation._cont = ASN1Dict([(u'p00', 0), (u'p05', 1), (u'p10', 2), (u'p15', 3), (u'p20', 4), (u'p25', 5), (u'p30', 6), (u'p35', 7), (u'p40', 8), (u'p45', 9), (u'p50', 10), (u'p55', 11), (u'p60', 12), (u'p65', 13), (u'p70', 14), (u'p75', 15), (u'p80', 16), (u'p85', 17), (u'p90', 18), (u'p95', 19), (u'p100', 20)])
    PagingProbabilityInformation._ext = []
    
    #-----< PC5QoSParameters >-----#
    PC5QoSParameters = SEQ(name=u'PC5QoSParameters', mode=MODE_TYPE)
    _PC5QoSParameters_pc5QoSFlowList = SEQ_OF(name=u'pc5QoSFlowList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PC5QoSFlowList')))
    _PC5QoSParameters_pc5LinkAggregatedBitRates = INT(name=u'pc5LinkAggregatedBitRates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')), opt=True)
    _PC5QoSParameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5QoSParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___PC5QoSParameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PC5QoSParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PC5QoSParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSParameters_iE_Extensions__item__id._const_tab = ____PC5QoSParameters_iE_Extensions__item__id_tab
    ___PC5QoSParameters_iE_Extensions__item__id._const_tab_at = None
    ___PC5QoSParameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___PC5QoSParameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PC5QoSParameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PC5QoSParameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSParameters_iE_Extensions__item__criticality._const_tab = ____PC5QoSParameters_iE_Extensions__item__criticality_tab
    ___PC5QoSParameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PC5QoSParameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PC5QoSParameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSParameters_iE_Extensions__item__extensionValue._const_tab = ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab
    ___PC5QoSParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PC5QoSParameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PC5QoSParameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PC5QoSParameters_iE_Extensions__item__id),
        (u'criticality', ___PC5QoSParameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___PC5QoSParameters_iE_Extensions__item__extensionValue),
        ])
    __PC5QoSParameters_iE_Extensions__item_._ext = None
    _PC5QoSParameters_iE_Extensions._cont = __PC5QoSParameters_iE_Extensions__item_
    _PC5QoSParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5QoSParameters._cont = ASN1Dict([
        (u'pc5QoSFlowList', _PC5QoSParameters_pc5QoSFlowList),
        (u'pc5LinkAggregatedBitRates', _PC5QoSParameters_pc5LinkAggregatedBitRates),
        (u'iE-Extensions', _PC5QoSParameters_iE_Extensions),
        ])
    PC5QoSParameters._ext = []
    
    #-----< PC5QoSParameters-ExtIEs >-----#
    PC5QoSParameters_ExtIEs = CLASS(name=u'PC5QoSParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    PC5QoSParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5QoSFlowList >-----#
    PC5QoSFlowList = SEQ_OF(name=u'PC5QoSFlowList', mode=MODE_TYPE)
    _PC5QoSFlowList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PC5QoSFlowItem')))
    PC5QoSFlowList._cont = _PC5QoSFlowList__item_
    PC5QoSFlowList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    
    #-----< PC5QoSFlowItem >-----#
    PC5QoSFlowItem = SEQ(name=u'PC5QoSFlowItem', mode=MODE_TYPE)
    _PC5QoSFlowItem_pQI = INT(name=u'pQI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'FiveQI')))
    _PC5QoSFlowItem_pc5FlowBitRates = SEQ(name=u'pc5FlowBitRates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PC5FlowBitRates')), opt=True)
    _PC5QoSFlowItem_range = ENUM(name=u'range', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Range')), opt=True)
    _PC5QoSFlowItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5QoSFlowItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___PC5QoSFlowItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PC5QoSFlowItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PC5QoSFlowItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSFlowItem_iE_Extensions__item__id._const_tab = ____PC5QoSFlowItem_iE_Extensions__item__id_tab
    ___PC5QoSFlowItem_iE_Extensions__item__id._const_tab_at = None
    ___PC5QoSFlowItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___PC5QoSFlowItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PC5QoSFlowItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PC5QoSFlowItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSFlowItem_iE_Extensions__item__criticality._const_tab = ____PC5QoSFlowItem_iE_Extensions__item__criticality_tab
    ___PC5QoSFlowItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PC5QoSFlowItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PC5QoSFlowItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PC5QoSFlowItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PC5QoSFlowItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5QoSFlowItem_iE_Extensions__item__extensionValue._const_tab = ____PC5QoSFlowItem_iE_Extensions__item__extensionValue_tab
    ___PC5QoSFlowItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PC5QoSFlowItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PC5QoSFlowItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PC5QoSFlowItem_iE_Extensions__item__id),
        (u'criticality', ___PC5QoSFlowItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___PC5QoSFlowItem_iE_Extensions__item__extensionValue),
        ])
    __PC5QoSFlowItem_iE_Extensions__item_._ext = None
    _PC5QoSFlowItem_iE_Extensions._cont = __PC5QoSFlowItem_iE_Extensions__item_
    _PC5QoSFlowItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5QoSFlowItem._cont = ASN1Dict([
        (u'pQI', _PC5QoSFlowItem_pQI),
        (u'pc5FlowBitRates', _PC5QoSFlowItem_pc5FlowBitRates),
        (u'range', _PC5QoSFlowItem_range),
        (u'iE-Extensions', _PC5QoSFlowItem_iE_Extensions),
        ])
    PC5QoSFlowItem._ext = []
    
    #-----< PC5QoSFlowItem-ExtIEs >-----#
    PC5QoSFlowItem_ExtIEs = CLASS(name=u'PC5QoSFlowItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    PC5QoSFlowItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC5FlowBitRates >-----#
    PC5FlowBitRates = SEQ(name=u'PC5FlowBitRates', mode=MODE_TYPE)
    _PC5FlowBitRates_guaranteedFlowBitRate = INT(name=u'guaranteedFlowBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')))
    _PC5FlowBitRates_maximumFlowBitRate = INT(name=u'maximumFlowBitRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')))
    _PC5FlowBitRates_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PC5FlowBitRates_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___PC5FlowBitRates_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PC5FlowBitRates_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PC5FlowBitRates_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5FlowBitRates_iE_Extensions__item__id._const_tab = ____PC5FlowBitRates_iE_Extensions__item__id_tab
    ___PC5FlowBitRates_iE_Extensions__item__id._const_tab_at = None
    ___PC5FlowBitRates_iE_Extensions__item__id._const_tab_id = u'id'
    ___PC5FlowBitRates_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PC5FlowBitRates_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PC5FlowBitRates_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5FlowBitRates_iE_Extensions__item__criticality._const_tab = ____PC5FlowBitRates_iE_Extensions__item__criticality_tab
    ___PC5FlowBitRates_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PC5FlowBitRates_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab = ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PC5FlowBitRates_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PC5FlowBitRates_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PC5FlowBitRates_iE_Extensions__item__id),
        (u'criticality', ___PC5FlowBitRates_iE_Extensions__item__criticality),
        (u'extensionValue', ___PC5FlowBitRates_iE_Extensions__item__extensionValue),
        ])
    __PC5FlowBitRates_iE_Extensions__item_._ext = None
    _PC5FlowBitRates_iE_Extensions._cont = __PC5FlowBitRates_iE_Extensions__item_
    _PC5FlowBitRates_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PC5FlowBitRates._cont = ASN1Dict([
        (u'guaranteedFlowBitRate', _PC5FlowBitRates_guaranteedFlowBitRate),
        (u'maximumFlowBitRate', _PC5FlowBitRates_maximumFlowBitRate),
        (u'iE-Extensions', _PC5FlowBitRates_iE_Extensions),
        ])
    PC5FlowBitRates._ext = []
    
    #-----< PC5FlowBitRates-ExtIEs >-----#
    PC5FlowBitRates_ExtIEs = CLASS(name=u'PC5FlowBitRates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    PC5FlowBitRates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PDCP-SN >-----#
    PDCP_SN = INT(name=u'PDCP-SN', mode=MODE_TYPE)
    PDCP_SN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< PDCP-SNExtended >-----#
    PDCP_SNExtended = INT(name=u'PDCP-SNExtended', mode=MODE_TYPE)
    PDCP_SNExtended._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    
    #-----< PDCP-SNlength18 >-----#
    PDCP_SNlength18 = INT(name=u'PDCP-SNlength18', mode=MODE_TYPE)
    PDCP_SNlength18._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=None, er=[])
    
    #-----< PendingDataIndication >-----#
    PendingDataIndication = ENUM(name=u'PendingDataIndication', mode=MODE_TYPE)
    PendingDataIndication._cont = ASN1Dict([(u'true', 0)])
    PendingDataIndication._ext = []
    
    #-----< M1PeriodicReporting >-----#
    M1PeriodicReporting = SEQ(name=u'M1PeriodicReporting', mode=MODE_TYPE)
    _M1PeriodicReporting_reportInterval = ENUM(name=u'reportInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ReportIntervalMDT')))
    _M1PeriodicReporting_reportAmount = ENUM(name=u'reportAmount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ReportAmountMDT')))
    _M1PeriodicReporting_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M1PeriodicReporting_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___M1PeriodicReporting_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____M1PeriodicReporting_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M1PeriodicReporting_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1PeriodicReporting_iE_Extensions__item__id._const_tab = ____M1PeriodicReporting_iE_Extensions__item__id_tab
    ___M1PeriodicReporting_iE_Extensions__item__id._const_tab_at = None
    ___M1PeriodicReporting_iE_Extensions__item__id._const_tab_id = u'id'
    ___M1PeriodicReporting_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____M1PeriodicReporting_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M1PeriodicReporting_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1PeriodicReporting_iE_Extensions__item__criticality._const_tab = ____M1PeriodicReporting_iE_Extensions__item__criticality_tab
    ___M1PeriodicReporting_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M1PeriodicReporting_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____M1PeriodicReporting_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M1PeriodicReporting_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue._const_tab = ____M1PeriodicReporting_iE_Extensions__item__extensionValue_tab
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M1PeriodicReporting_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M1PeriodicReporting_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M1PeriodicReporting_iE_Extensions__item__id),
        (u'criticality', ___M1PeriodicReporting_iE_Extensions__item__criticality),
        (u'extensionValue', ___M1PeriodicReporting_iE_Extensions__item__extensionValue),
        ])
    __M1PeriodicReporting_iE_Extensions__item_._ext = None
    _M1PeriodicReporting_iE_Extensions._cont = __M1PeriodicReporting_iE_Extensions__item_
    _M1PeriodicReporting_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M1PeriodicReporting._cont = ASN1Dict([
        (u'reportInterval', _M1PeriodicReporting_reportInterval),
        (u'reportAmount', _M1PeriodicReporting_reportAmount),
        (u'iE-Extensions', _M1PeriodicReporting_iE_Extensions),
        ])
    M1PeriodicReporting._ext = []
    
    #-----< M1PeriodicReporting-ExtIEs >-----#
    M1PeriodicReporting_ExtIEs = CLASS(name=u'M1PeriodicReporting-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    M1PeriodicReporting_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PLMNidentity >-----#
    PLMNidentity = OCT_STR(name=u'PLMNidentity', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TBCD-STRING')))
    
    #-----< PLMNAreaBasedQMC >-----#
    PLMNAreaBasedQMC = SEQ(name=u'PLMNAreaBasedQMC', mode=MODE_TYPE)
    _PLMNAreaBasedQMC_plmnListforQMC = SEQ_OF(name=u'plmnListforQMC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNListforQMC')))
    _PLMNAreaBasedQMC_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PLMNAreaBasedQMC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___PLMNAreaBasedQMC_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PLMNAreaBasedQMC_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PLMNAreaBasedQMC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLMNAreaBasedQMC_iE_Extensions__item__id._const_tab = ____PLMNAreaBasedQMC_iE_Extensions__item__id_tab
    ___PLMNAreaBasedQMC_iE_Extensions__item__id._const_tab_at = None
    ___PLMNAreaBasedQMC_iE_Extensions__item__id._const_tab_id = u'id'
    ___PLMNAreaBasedQMC_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PLMNAreaBasedQMC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PLMNAreaBasedQMC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLMNAreaBasedQMC_iE_Extensions__item__criticality._const_tab = ____PLMNAreaBasedQMC_iE_Extensions__item__criticality_tab
    ___PLMNAreaBasedQMC_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PLMNAreaBasedQMC_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PLMNAreaBasedQMC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PLMNAreaBasedQMC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue._const_tab = ____PLMNAreaBasedQMC_iE_Extensions__item__extensionValue_tab
    ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PLMNAreaBasedQMC_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PLMNAreaBasedQMC_iE_Extensions__item__id),
        (u'criticality', ___PLMNAreaBasedQMC_iE_Extensions__item__criticality),
        (u'extensionValue', ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue),
        ])
    __PLMNAreaBasedQMC_iE_Extensions__item_._ext = None
    _PLMNAreaBasedQMC_iE_Extensions._cont = __PLMNAreaBasedQMC_iE_Extensions__item_
    _PLMNAreaBasedQMC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PLMNAreaBasedQMC._cont = ASN1Dict([
        (u'plmnListforQMC', _PLMNAreaBasedQMC_plmnListforQMC),
        (u'iE-Extensions', _PLMNAreaBasedQMC_iE_Extensions),
        ])
    PLMNAreaBasedQMC._ext = []
    
    #-----< PLMNAreaBasedQMC-ExtIEs >-----#
    PLMNAreaBasedQMC_ExtIEs = CLASS(name=u'PLMNAreaBasedQMC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    PLMNAreaBasedQMC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PLMNListforQMC >-----#
    PLMNListforQMC = SEQ_OF(name=u'PLMNListforQMC', mode=MODE_TYPE)
    _PLMNListforQMC__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    PLMNListforQMC._cont = _PLMNListforQMC__item_
    PLMNListforQMC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Port-Number >-----#
    Port_Number = OCT_STR(name=u'Port-Number', mode=MODE_TYPE)
    Port_Number._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< Pre-emptionCapability >-----#
    Pre_emptionCapability = ENUM(name=u'Pre-emptionCapability', mode=MODE_TYPE)
    Pre_emptionCapability._cont = ASN1Dict([(u'shall-not-trigger-pre-emption', 0), (u'may-trigger-pre-emption', 1)])
    Pre_emptionCapability._ext = None
    
    #-----< Pre-emptionVulnerability >-----#
    Pre_emptionVulnerability = ENUM(name=u'Pre-emptionVulnerability', mode=MODE_TYPE)
    Pre_emptionVulnerability._cont = ASN1Dict([(u'not-pre-emptable', 0), (u'pre-emptable', 1)])
    Pre_emptionVulnerability._ext = None
    
    #-----< PriorityLevel >-----#
    PriorityLevel = INT(name=u'PriorityLevel', mode=MODE_TYPE)
    PriorityLevel._cont = ASN1Dict([(u'spare', 0), (u'highest', 1), (u'lowest', 14), (u'no-priority', 15)])
    PriorityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< ProSeAuthorized >-----#
    ProSeAuthorized = SEQ(name=u'ProSeAuthorized', mode=MODE_TYPE)
    _ProSeAuthorized_proSeDirectDiscovery = ENUM(name=u'proSeDirectDiscovery', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ProSeDirectDiscovery')), opt=True)
    _ProSeAuthorized_proSeDirectCommunication = ENUM(name=u'proSeDirectCommunication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ProSeDirectCommunication')), opt=True)
    _ProSeAuthorized_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ProSeAuthorized_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ProSeAuthorized_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ProSeAuthorized_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____ProSeAuthorized_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ProSeUEtoNetworkRelaying')))
    ____ProSeAuthorized_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 216), (u'criticality', u'ignore'), (u'Extension', _____ProSeAuthorized_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ProSeAuthorized_iE_Extensions__item__id._const_tab = ____ProSeAuthorized_iE_Extensions__item__id_tab
    ___ProSeAuthorized_iE_Extensions__item__id._const_tab_at = None
    ___ProSeAuthorized_iE_Extensions__item__id._const_tab_id = u'id'
    ___ProSeAuthorized_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ProSeAuthorized_iE_Extensions__item__criticality._const_tab = ____ProSeAuthorized_iE_Extensions__item__id_tab
    ___ProSeAuthorized_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ProSeAuthorized_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ProSeAuthorized_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ProSeAuthorized_iE_Extensions__item__extensionValue._const_tab = ____ProSeAuthorized_iE_Extensions__item__id_tab
    ___ProSeAuthorized_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ProSeAuthorized_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ProSeAuthorized_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ProSeAuthorized_iE_Extensions__item__id),
        (u'criticality', ___ProSeAuthorized_iE_Extensions__item__criticality),
        (u'extensionValue', ___ProSeAuthorized_iE_Extensions__item__extensionValue),
        ])
    __ProSeAuthorized_iE_Extensions__item_._ext = None
    _ProSeAuthorized_iE_Extensions._cont = __ProSeAuthorized_iE_Extensions__item_
    _ProSeAuthorized_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ProSeAuthorized._cont = ASN1Dict([
        (u'proSeDirectDiscovery', _ProSeAuthorized_proSeDirectDiscovery),
        (u'proSeDirectCommunication', _ProSeAuthorized_proSeDirectCommunication),
        (u'iE-Extensions', _ProSeAuthorized_iE_Extensions),
        ])
    ProSeAuthorized._ext = []
    
    #-----< ProSeAuthorized-ExtIEs >-----#
    ProSeAuthorized_ExtIEs = CLASS(name=u'ProSeAuthorized-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _ProSeAuthorized_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ProSeUEtoNetworkRelaying')))
    ProSeAuthorized_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 216), (u'criticality', u'ignore'), (u'Extension', _ProSeAuthorized_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ProSeDirectDiscovery >-----#
    ProSeDirectDiscovery = ENUM(name=u'ProSeDirectDiscovery', mode=MODE_TYPE)
    ProSeDirectDiscovery._cont = ASN1Dict([(u'authorized', 0), (u'not-authorized', 1)])
    ProSeDirectDiscovery._ext = []
    
    #-----< ProSeUEtoNetworkRelaying >-----#
    ProSeUEtoNetworkRelaying = ENUM(name=u'ProSeUEtoNetworkRelaying', mode=MODE_TYPE)
    ProSeUEtoNetworkRelaying._cont = ASN1Dict([(u'authorized', 0), (u'not-authorized', 1)])
    ProSeUEtoNetworkRelaying._ext = []
    
    #-----< ProSeDirectCommunication >-----#
    ProSeDirectCommunication = ENUM(name=u'ProSeDirectCommunication', mode=MODE_TYPE)
    ProSeDirectCommunication._cont = ASN1Dict([(u'authorized', 0), (u'not-authorized', 1)])
    ProSeDirectCommunication._ext = []
    
    #-----< PS-ServiceNotAvailable >-----#
    PS_ServiceNotAvailable = ENUM(name=u'PS-ServiceNotAvailable', mode=MODE_TYPE)
    PS_ServiceNotAvailable._cont = ASN1Dict([(u'ps-service-not-available', 0)])
    PS_ServiceNotAvailable._ext = []
    
    #-----< PSCellInformation >-----#
    PSCellInformation = SEQ(name=u'PSCellInformation', mode=MODE_TYPE)
    _PSCellInformation_nCGI = SEQ(name=u'nCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NR-CGI')))
    _PSCellInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PSCellInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___PSCellInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____PSCellInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PSCellInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PSCellInformation_iE_Extensions__item__id._const_tab = ____PSCellInformation_iE_Extensions__item__id_tab
    ___PSCellInformation_iE_Extensions__item__id._const_tab_at = None
    ___PSCellInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___PSCellInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PSCellInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PSCellInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PSCellInformation_iE_Extensions__item__criticality._const_tab = ____PSCellInformation_iE_Extensions__item__criticality_tab
    ___PSCellInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PSCellInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PSCellInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PSCellInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____PSCellInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PSCellInformation_iE_Extensions__item__extensionValue._const_tab = ____PSCellInformation_iE_Extensions__item__extensionValue_tab
    ___PSCellInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PSCellInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PSCellInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PSCellInformation_iE_Extensions__item__id),
        (u'criticality', ___PSCellInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___PSCellInformation_iE_Extensions__item__extensionValue),
        ])
    __PSCellInformation_iE_Extensions__item_._ext = None
    _PSCellInformation_iE_Extensions._cont = __PSCellInformation_iE_Extensions__item_
    _PSCellInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PSCellInformation._cont = ASN1Dict([
        (u'nCGI', _PSCellInformation_nCGI),
        (u'iE-Extensions', _PSCellInformation_iE_Extensions),
        ])
    PSCellInformation._ext = []
    
    #-----< PSCellInformation-ExtIEs >-----#
    PSCellInformation_ExtIEs = CLASS(name=u'PSCellInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    PSCellInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< QCI >-----#
    QCI = INT(name=u'QCI', mode=MODE_TYPE)
    QCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< RAN-UE-NGAP-ID >-----#
    RAN_UE_NGAP_ID = INT(name=u'RAN-UE-NGAP-ID', mode=MODE_TYPE)
    RAN_UE_NGAP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< Range >-----#
    Range = ENUM(name=u'Range', mode=MODE_TYPE)
    Range._cont = ASN1Dict([(u'm50', 0), (u'm80', 1), (u'm180', 2), (u'm200', 3), (u'm350', 4), (u'm400', 5), (u'm500', 6), (u'm700', 7), (u'm1000', 8)])
    Range._ext = []
    
    #-----< ReceiveStatusofULPDCPSDUs >-----#
    ReceiveStatusofULPDCPSDUs = BIT_STR(name=u'ReceiveStatusofULPDCPSDUs', mode=MODE_TYPE)
    ReceiveStatusofULPDCPSDUs._const_sz = ASN1Set(rv=[4096], rr=[], ev=None, er=[])
    
    #-----< ReceiveStatusOfULPDCPSDUsExtended >-----#
    ReceiveStatusOfULPDCPSDUsExtended = BIT_STR(name=u'ReceiveStatusOfULPDCPSDUsExtended', mode=MODE_TYPE)
    ReceiveStatusOfULPDCPSDUsExtended._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16384)], ev=None, er=[])
    
    #-----< ReceiveStatusOfULPDCPSDUsPDCP-SNlength18 >-----#
    ReceiveStatusOfULPDCPSDUsPDCP_SNlength18 = BIT_STR(name=u'ReceiveStatusOfULPDCPSDUsPDCP-SNlength18', mode=MODE_TYPE)
    ReceiveStatusOfULPDCPSDUsPDCP_SNlength18._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=131072)], ev=None, er=[])
    
    #-----< RecommendedCellsForPaging >-----#
    RecommendedCellsForPaging = SEQ(name=u'RecommendedCellsForPaging', mode=MODE_TYPE)
    _RecommendedCellsForPaging_recommendedCellList = SEQ_OF(name=u'recommendedCellList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RecommendedCellList')))
    _RecommendedCellsForPaging_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RecommendedCellsForPaging_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___RecommendedCellsForPaging_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RecommendedCellsForPaging_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedCellsForPaging_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellsForPaging_iE_Extensions__item__id._const_tab = ____RecommendedCellsForPaging_iE_Extensions__item__id_tab
    ___RecommendedCellsForPaging_iE_Extensions__item__id._const_tab_at = None
    ___RecommendedCellsForPaging_iE_Extensions__item__id._const_tab_id = u'id'
    ___RecommendedCellsForPaging_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RecommendedCellsForPaging_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedCellsForPaging_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellsForPaging_iE_Extensions__item__criticality._const_tab = ____RecommendedCellsForPaging_iE_Extensions__item__criticality_tab
    ___RecommendedCellsForPaging_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RecommendedCellsForPaging_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RecommendedCellsForPaging_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedCellsForPaging_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue._const_tab = ____RecommendedCellsForPaging_iE_Extensions__item__extensionValue_tab
    ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RecommendedCellsForPaging_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RecommendedCellsForPaging_iE_Extensions__item__id),
        (u'criticality', ___RecommendedCellsForPaging_iE_Extensions__item__criticality),
        (u'extensionValue', ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue),
        ])
    __RecommendedCellsForPaging_iE_Extensions__item_._ext = None
    _RecommendedCellsForPaging_iE_Extensions._cont = __RecommendedCellsForPaging_iE_Extensions__item_
    _RecommendedCellsForPaging_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RecommendedCellsForPaging._cont = ASN1Dict([
        (u'recommendedCellList', _RecommendedCellsForPaging_recommendedCellList),
        (u'iE-Extensions', _RecommendedCellsForPaging_iE_Extensions),
        ])
    RecommendedCellsForPaging._ext = []
    
    #-----< RecommendedCellsForPaging-ExtIEs >-----#
    RecommendedCellsForPaging_ExtIEs = CLASS(name=u'RecommendedCellsForPaging-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    RecommendedCellsForPaging_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RecommendedCellList >-----#
    RecommendedCellList = SEQ_OF(name=u'RecommendedCellList', mode=MODE_TYPE)
    _RecommendedCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __RecommendedCellList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___RecommendedCellList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____RecommendedCellList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RecommendedCellItem')))
    ___RecommendedCellList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 214), (u'criticality', u'ignore'), (u'Value', ____RecommendedCellList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RecommendedCellList__item__id._const_tab = ___RecommendedCellList__item__id_tab
    __RecommendedCellList__item__id._const_tab_at = None
    __RecommendedCellList__item__id._const_tab_id = u'id'
    __RecommendedCellList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __RecommendedCellList__item__criticality._const_tab = ___RecommendedCellList__item__id_tab
    __RecommendedCellList__item__criticality._const_tab_at = ('..', u'id')
    __RecommendedCellList__item__criticality._const_tab_id = u'criticality'
    __RecommendedCellList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __RecommendedCellList__item__value._const_tab = ___RecommendedCellList__item__id_tab
    __RecommendedCellList__item__value._const_tab_at = ('..', u'id')
    __RecommendedCellList__item__value._const_tab_id = u'Value'
    _RecommendedCellList__item_._cont = ASN1Dict([
        (u'id', __RecommendedCellList__item__id),
        (u'criticality', __RecommendedCellList__item__criticality),
        (u'value', __RecommendedCellList__item__value),
        ])
    _RecommendedCellList__item_._ext = None
    RecommendedCellList._cont = _RecommendedCellList__item_
    RecommendedCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RecommendedCellItemIEs >-----#
    RecommendedCellItemIEs = CLASS(name=u'RecommendedCellItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _RecommendedCellItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RecommendedCellItem')))
    RecommendedCellItemIEs._val = ASN1Set(rv=[dict([(u'id', 214), (u'criticality', u'ignore'), (u'Value', _RecommendedCellItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RecommendedCellItem >-----#
    RecommendedCellItem = SEQ(name=u'RecommendedCellItem', mode=MODE_TYPE)
    _RecommendedCellItem_eUTRAN_CGI = SEQ(name=u'eUTRAN-CGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _RecommendedCellItem_timeStayedInCell = INT(name=u'timeStayedInCell', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RecommendedCellItem_timeStayedInCell._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _RecommendedCellItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RecommendedCellItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___RecommendedCellItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RecommendedCellItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedCellItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellItem_iE_Extensions__item__id._const_tab = ____RecommendedCellItem_iE_Extensions__item__id_tab
    ___RecommendedCellItem_iE_Extensions__item__id._const_tab_at = None
    ___RecommendedCellItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___RecommendedCellItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RecommendedCellItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedCellItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellItem_iE_Extensions__item__criticality._const_tab = ____RecommendedCellItem_iE_Extensions__item__criticality_tab
    ___RecommendedCellItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RecommendedCellItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RecommendedCellItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RecommendedCellItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedCellItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedCellItem_iE_Extensions__item__extensionValue._const_tab = ____RecommendedCellItem_iE_Extensions__item__extensionValue_tab
    ___RecommendedCellItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RecommendedCellItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RecommendedCellItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RecommendedCellItem_iE_Extensions__item__id),
        (u'criticality', ___RecommendedCellItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___RecommendedCellItem_iE_Extensions__item__extensionValue),
        ])
    __RecommendedCellItem_iE_Extensions__item_._ext = None
    _RecommendedCellItem_iE_Extensions._cont = __RecommendedCellItem_iE_Extensions__item_
    _RecommendedCellItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RecommendedCellItem._cont = ASN1Dict([
        (u'eUTRAN-CGI', _RecommendedCellItem_eUTRAN_CGI),
        (u'timeStayedInCell', _RecommendedCellItem_timeStayedInCell),
        (u'iE-Extensions', _RecommendedCellItem_iE_Extensions),
        ])
    RecommendedCellItem._ext = []
    
    #-----< RecommendedCellsForPagingItem-ExtIEs >-----#
    RecommendedCellsForPagingItem_ExtIEs = CLASS(name=u'RecommendedCellsForPagingItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    RecommendedCellsForPagingItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RecommendedENBsForPaging >-----#
    RecommendedENBsForPaging = SEQ(name=u'RecommendedENBsForPaging', mode=MODE_TYPE)
    _RecommendedENBsForPaging_recommendedENBList = SEQ_OF(name=u'recommendedENBList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RecommendedENBList')))
    _RecommendedENBsForPaging_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RecommendedENBsForPaging_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___RecommendedENBsForPaging_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RecommendedENBsForPaging_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedENBsForPaging_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedENBsForPaging_iE_Extensions__item__id._const_tab = ____RecommendedENBsForPaging_iE_Extensions__item__id_tab
    ___RecommendedENBsForPaging_iE_Extensions__item__id._const_tab_at = None
    ___RecommendedENBsForPaging_iE_Extensions__item__id._const_tab_id = u'id'
    ___RecommendedENBsForPaging_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RecommendedENBsForPaging_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedENBsForPaging_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedENBsForPaging_iE_Extensions__item__criticality._const_tab = ____RecommendedENBsForPaging_iE_Extensions__item__criticality_tab
    ___RecommendedENBsForPaging_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RecommendedENBsForPaging_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RecommendedENBsForPaging_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RecommendedENBsForPaging_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedENBsForPaging_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedENBsForPaging_iE_Extensions__item__extensionValue._const_tab = ____RecommendedENBsForPaging_iE_Extensions__item__extensionValue_tab
    ___RecommendedENBsForPaging_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RecommendedENBsForPaging_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RecommendedENBsForPaging_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RecommendedENBsForPaging_iE_Extensions__item__id),
        (u'criticality', ___RecommendedENBsForPaging_iE_Extensions__item__criticality),
        (u'extensionValue', ___RecommendedENBsForPaging_iE_Extensions__item__extensionValue),
        ])
    __RecommendedENBsForPaging_iE_Extensions__item_._ext = None
    _RecommendedENBsForPaging_iE_Extensions._cont = __RecommendedENBsForPaging_iE_Extensions__item_
    _RecommendedENBsForPaging_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RecommendedENBsForPaging._cont = ASN1Dict([
        (u'recommendedENBList', _RecommendedENBsForPaging_recommendedENBList),
        (u'iE-Extensions', _RecommendedENBsForPaging_iE_Extensions),
        ])
    RecommendedENBsForPaging._ext = []
    
    #-----< RecommendedENBsForPaging-ExtIEs >-----#
    RecommendedENBsForPaging_ExtIEs = CLASS(name=u'RecommendedENBsForPaging-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    RecommendedENBsForPaging_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RecommendedENBList >-----#
    RecommendedENBList = SEQ_OF(name=u'RecommendedENBList', mode=MODE_TYPE)
    _RecommendedENBList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __RecommendedENBList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___RecommendedENBList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____RecommendedENBList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RecommendedENBItem')))
    ___RecommendedENBList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 215), (u'criticality', u'ignore'), (u'Value', ____RecommendedENBList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RecommendedENBList__item__id._const_tab = ___RecommendedENBList__item__id_tab
    __RecommendedENBList__item__id._const_tab_at = None
    __RecommendedENBList__item__id._const_tab_id = u'id'
    __RecommendedENBList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __RecommendedENBList__item__criticality._const_tab = ___RecommendedENBList__item__id_tab
    __RecommendedENBList__item__criticality._const_tab_at = ('..', u'id')
    __RecommendedENBList__item__criticality._const_tab_id = u'criticality'
    __RecommendedENBList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __RecommendedENBList__item__value._const_tab = ___RecommendedENBList__item__id_tab
    __RecommendedENBList__item__value._const_tab_at = ('..', u'id')
    __RecommendedENBList__item__value._const_tab_id = u'Value'
    _RecommendedENBList__item_._cont = ASN1Dict([
        (u'id', __RecommendedENBList__item__id),
        (u'criticality', __RecommendedENBList__item__criticality),
        (u'value', __RecommendedENBList__item__value),
        ])
    _RecommendedENBList__item_._ext = None
    RecommendedENBList._cont = _RecommendedENBList__item_
    RecommendedENBList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RecommendedENBItemIEs >-----#
    RecommendedENBItemIEs = CLASS(name=u'RecommendedENBItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _RecommendedENBItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RecommendedENBItem')))
    RecommendedENBItemIEs._val = ASN1Set(rv=[dict([(u'id', 215), (u'criticality', u'ignore'), (u'Value', _RecommendedENBItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RecommendedENBItem >-----#
    RecommendedENBItem = SEQ(name=u'RecommendedENBItem', mode=MODE_TYPE)
    _RecommendedENBItem_mMEPagingTarget = CHOICE(name=u'mMEPagingTarget', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MMEPagingTarget')))
    _RecommendedENBItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RecommendedENBItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___RecommendedENBItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RecommendedENBItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedENBItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedENBItem_iE_Extensions__item__id._const_tab = ____RecommendedENBItem_iE_Extensions__item__id_tab
    ___RecommendedENBItem_iE_Extensions__item__id._const_tab_at = None
    ___RecommendedENBItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___RecommendedENBItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RecommendedENBItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedENBItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedENBItem_iE_Extensions__item__criticality._const_tab = ____RecommendedENBItem_iE_Extensions__item__criticality_tab
    ___RecommendedENBItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RecommendedENBItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RecommendedENBItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RecommendedENBItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RecommendedENBItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RecommendedENBItem_iE_Extensions__item__extensionValue._const_tab = ____RecommendedENBItem_iE_Extensions__item__extensionValue_tab
    ___RecommendedENBItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RecommendedENBItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RecommendedENBItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RecommendedENBItem_iE_Extensions__item__id),
        (u'criticality', ___RecommendedENBItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___RecommendedENBItem_iE_Extensions__item__extensionValue),
        ])
    __RecommendedENBItem_iE_Extensions__item_._ext = None
    _RecommendedENBItem_iE_Extensions._cont = __RecommendedENBItem_iE_Extensions__item_
    _RecommendedENBItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RecommendedENBItem._cont = ASN1Dict([
        (u'mMEPagingTarget', _RecommendedENBItem_mMEPagingTarget),
        (u'iE-Extensions', _RecommendedENBItem_iE_Extensions),
        ])
    RecommendedENBItem._ext = []
    
    #-----< RecommendedENBItem-ExtIEs >-----#
    RecommendedENBItem_ExtIEs = CLASS(name=u'RecommendedENBItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    RecommendedENBItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelativeMMECapacity >-----#
    RelativeMMECapacity = INT(name=u'RelativeMMECapacity', mode=MODE_TYPE)
    RelativeMMECapacity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< RelayNode-Indicator >-----#
    RelayNode_Indicator = ENUM(name=u'RelayNode-Indicator', mode=MODE_TYPE)
    RelayNode_Indicator._cont = ASN1Dict([(u'true', 0)])
    RelayNode_Indicator._ext = []
    
    #-----< RAC >-----#
    RAC = OCT_STR(name=u'RAC', mode=MODE_TYPE)
    RAC._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< RAT-Type >-----#
    RAT_Type = ENUM(name=u'RAT-Type', mode=MODE_TYPE)
    RAT_Type._cont = ASN1Dict([(u'nbiot', 0)])
    RAT_Type._ext = []
    
    #-----< ReportAmountMDT >-----#
    ReportAmountMDT = ENUM(name=u'ReportAmountMDT', mode=MODE_TYPE)
    ReportAmountMDT._cont = ASN1Dict([(u'r1', 0), (u'r2', 1), (u'r4', 2), (u'r8', 3), (u'r16', 4), (u'r32', 5), (u'r64', 6), (u'rinfinity', 7)])
    ReportAmountMDT._ext = None
    
    #-----< ReportIntervalMDT >-----#
    ReportIntervalMDT = ENUM(name=u'ReportIntervalMDT', mode=MODE_TYPE)
    ReportIntervalMDT._cont = ASN1Dict([(u'ms120', 0), (u'ms240', 1), (u'ms480', 2), (u'ms640', 3), (u'ms1024', 4), (u'ms2048', 5), (u'ms5120', 6), (u'ms10240', 7), (u'min1', 8), (u'min6', 9), (u'min12', 10), (u'min30', 11), (u'min60', 12)])
    ReportIntervalMDT._ext = None
    
    #-----< M1ReportingTrigger >-----#
    M1ReportingTrigger = ENUM(name=u'M1ReportingTrigger', mode=MODE_TYPE)
    M1ReportingTrigger._cont = ASN1Dict([(u'periodic', 0), (u'a2eventtriggered', 1), (u'a2eventtriggered-periodic', 2)])
    M1ReportingTrigger._ext = [u'a2eventtriggered-periodic']
    
    #-----< RequestType >-----#
    RequestType = SEQ(name=u'RequestType', mode=MODE_TYPE)
    _RequestType_eventType = ENUM(name=u'eventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EventType')))
    _RequestType_reportArea = ENUM(name=u'reportArea', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ReportArea')))
    _RequestType_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RequestType_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___RequestType_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RequestType_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____RequestType_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RequestTypeAdditionalInfo')))
    ____RequestType_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 298), (u'criticality', u'ignore'), (u'Extension', _____RequestType_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RequestType_iE_Extensions__item__id._const_tab = ____RequestType_iE_Extensions__item__id_tab
    ___RequestType_iE_Extensions__item__id._const_tab_at = None
    ___RequestType_iE_Extensions__item__id._const_tab_id = u'id'
    ___RequestType_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RequestType_iE_Extensions__item__criticality._const_tab = ____RequestType_iE_Extensions__item__id_tab
    ___RequestType_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RequestType_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RequestType_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RequestType_iE_Extensions__item__extensionValue._const_tab = ____RequestType_iE_Extensions__item__id_tab
    ___RequestType_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RequestType_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RequestType_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RequestType_iE_Extensions__item__id),
        (u'criticality', ___RequestType_iE_Extensions__item__criticality),
        (u'extensionValue', ___RequestType_iE_Extensions__item__extensionValue),
        ])
    __RequestType_iE_Extensions__item_._ext = None
    _RequestType_iE_Extensions._cont = __RequestType_iE_Extensions__item_
    _RequestType_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RequestType._cont = ASN1Dict([
        (u'eventType', _RequestType_eventType),
        (u'reportArea', _RequestType_reportArea),
        (u'iE-Extensions', _RequestType_iE_Extensions),
        ])
    RequestType._ext = []
    
    #-----< RequestType-ExtIEs >-----#
    RequestType_ExtIEs = CLASS(name=u'RequestType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _RequestType_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RequestTypeAdditionalInfo')))
    RequestType_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 298), (u'criticality', u'ignore'), (u'Extension', _RequestType_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RequestTypeAdditionalInfo >-----#
    RequestTypeAdditionalInfo = ENUM(name=u'RequestTypeAdditionalInfo', mode=MODE_TYPE)
    RequestTypeAdditionalInfo._cont = ASN1Dict([(u'includePSCell', 0)])
    RequestTypeAdditionalInfo._ext = []
    
    #-----< RIMTransfer >-----#
    RIMTransfer = SEQ(name=u'RIMTransfer', mode=MODE_TYPE)
    _RIMTransfer_rIMInformation = OCT_STR(name=u'rIMInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RIMInformation')))
    _RIMTransfer_rIMRoutingAddress = CHOICE(name=u'rIMRoutingAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RIMRoutingAddress')), opt=True)
    _RIMTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RIMTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___RIMTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RIMTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RIMTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIMTransfer_iE_Extensions__item__id._const_tab = ____RIMTransfer_iE_Extensions__item__id_tab
    ___RIMTransfer_iE_Extensions__item__id._const_tab_at = None
    ___RIMTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___RIMTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RIMTransfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RIMTransfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIMTransfer_iE_Extensions__item__criticality._const_tab = ____RIMTransfer_iE_Extensions__item__criticality_tab
    ___RIMTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RIMTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RIMTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RIMTransfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____RIMTransfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIMTransfer_iE_Extensions__item__extensionValue._const_tab = ____RIMTransfer_iE_Extensions__item__extensionValue_tab
    ___RIMTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RIMTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RIMTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RIMTransfer_iE_Extensions__item__id),
        (u'criticality', ___RIMTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___RIMTransfer_iE_Extensions__item__extensionValue),
        ])
    __RIMTransfer_iE_Extensions__item_._ext = None
    _RIMTransfer_iE_Extensions._cont = __RIMTransfer_iE_Extensions__item_
    _RIMTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RIMTransfer._cont = ASN1Dict([
        (u'rIMInformation', _RIMTransfer_rIMInformation),
        (u'rIMRoutingAddress', _RIMTransfer_rIMRoutingAddress),
        (u'iE-Extensions', _RIMTransfer_iE_Extensions),
        ])
    RIMTransfer._ext = []
    
    #-----< RIMTransfer-ExtIEs >-----#
    RIMTransfer_ExtIEs = CLASS(name=u'RIMTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    RIMTransfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RIMInformation >-----#
    RIMInformation = OCT_STR(name=u'RIMInformation', mode=MODE_TYPE)
    
    #-----< RIMRoutingAddress >-----#
    RIMRoutingAddress = CHOICE(name=u'RIMRoutingAddress', mode=MODE_TYPE)
    _RIMRoutingAddress_gERAN_Cell_ID = SEQ(name=u'gERAN-Cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GERAN-Cell-ID')))
    _RIMRoutingAddress_targetRNC_ID = SEQ(name=u'targetRNC-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TargetRNC-ID')))
    _RIMRoutingAddress_eHRPD_Sector_ID = OCT_STR(name=u'eHRPD-Sector-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RIMRoutingAddress_eHRPD_Sector_ID._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    RIMRoutingAddress._cont = ASN1Dict([
        (u'gERAN-Cell-ID', _RIMRoutingAddress_gERAN_Cell_ID),
        (u'targetRNC-ID', _RIMRoutingAddress_targetRNC_ID),
        (u'eHRPD-Sector-ID', _RIMRoutingAddress_eHRPD_Sector_ID),
        ])
    RIMRoutingAddress._ext = [u'targetRNC-ID', u'eHRPD-Sector-ID']
    
    #-----< ReportArea >-----#
    ReportArea = ENUM(name=u'ReportArea', mode=MODE_TYPE)
    ReportArea._cont = ASN1Dict([(u'ecgi', 0)])
    ReportArea._ext = []
    
    #-----< RepetitionPeriod >-----#
    RepetitionPeriod = INT(name=u'RepetitionPeriod', mode=MODE_TYPE)
    RepetitionPeriod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< RLFReportInformation >-----#
    RLFReportInformation = SEQ(name=u'RLFReportInformation', mode=MODE_TYPE)
    _RLFReportInformation_uE_RLF_Report_Container = OCT_STR(name=u'uE-RLF-Report-Container', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'UE-RLF-Report-Container')))
    _RLFReportInformation_uE_RLF_Report_Container_for_extended_bands = OCT_STR(name=u'uE-RLF-Report-Container-for-extended-bands', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'UE-RLF-Report-Container-for-extended-bands')), opt=True)
    _RLFReportInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLFReportInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___RLFReportInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____RLFReportInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____RLFReportInformation_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-RLF-Report-Container')))
    ____RLFReportInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 313), (u'criticality', u'ignore'), (u'Extension', _____RLFReportInformation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RLFReportInformation_iE_Extensions__item__id._const_tab = ____RLFReportInformation_iE_Extensions__item__id_tab
    ___RLFReportInformation_iE_Extensions__item__id._const_tab_at = None
    ___RLFReportInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___RLFReportInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RLFReportInformation_iE_Extensions__item__criticality._const_tab = ____RLFReportInformation_iE_Extensions__item__id_tab
    ___RLFReportInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RLFReportInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RLFReportInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RLFReportInformation_iE_Extensions__item__extensionValue._const_tab = ____RLFReportInformation_iE_Extensions__item__id_tab
    ___RLFReportInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RLFReportInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RLFReportInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RLFReportInformation_iE_Extensions__item__id),
        (u'criticality', ___RLFReportInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___RLFReportInformation_iE_Extensions__item__extensionValue),
        ])
    __RLFReportInformation_iE_Extensions__item_._ext = None
    _RLFReportInformation_iE_Extensions._cont = __RLFReportInformation_iE_Extensions__item_
    _RLFReportInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLFReportInformation._cont = ASN1Dict([
        (u'uE-RLF-Report-Container', _RLFReportInformation_uE_RLF_Report_Container),
        (u'uE-RLF-Report-Container-for-extended-bands', _RLFReportInformation_uE_RLF_Report_Container_for_extended_bands),
        (u'iE-Extensions', _RLFReportInformation_iE_Extensions),
        ])
    RLFReportInformation._ext = []
    
    #-----< RLFReportInformation-ExtIEs >-----#
    RLFReportInformation_ExtIEs = CLASS(name=u'RLFReportInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _RLFReportInformation_ExtIEs_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-RLF-Report-Container')))
    RLFReportInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 313), (u'criticality', u'ignore'), (u'Extension', _RLFReportInformation_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RNC-ID >-----#
    RNC_ID = INT(name=u'RNC-ID', mode=MODE_TYPE)
    RNC_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< RRC-Container >-----#
    RRC_Container = OCT_STR(name=u'RRC-Container', mode=MODE_TYPE)
    
    #-----< RRC-Establishment-Cause >-----#
    RRC_Establishment_Cause = ENUM(name=u'RRC-Establishment-Cause', mode=MODE_TYPE)
    RRC_Establishment_Cause._cont = ASN1Dict([(u'emergency', 0), (u'highPriorityAccess', 1), (u'mt-Access', 2), (u'mo-Signalling', 3), (u'mo-Data', 4), (u'delay-TolerantAccess', 5), (u'mo-VoiceCall', 6), (u'mo-ExceptionData', 7)])
    RRC_Establishment_Cause._ext = [u'delay-TolerantAccess', u'mo-VoiceCall', u'mo-ExceptionData']
    
    #-----< ECGIListForRestart >-----#
    ECGIListForRestart = SEQ_OF(name=u'ECGIListForRestart', mode=MODE_TYPE)
    _ECGIListForRestart__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    ECGIListForRestart._cont = _ECGIListForRestart__item_
    ECGIListForRestart._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Routing-ID >-----#
    Routing_ID = INT(name=u'Routing-ID', mode=MODE_TYPE)
    Routing_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< SecurityKey >-----#
    SecurityKey = BIT_STR(name=u'SecurityKey', mode=MODE_TYPE)
    SecurityKey._const_sz = ASN1Set(rv=[256], rr=[], ev=None, er=[])
    
    #-----< SecurityContext >-----#
    SecurityContext = SEQ(name=u'SecurityContext', mode=MODE_TYPE)
    _SecurityContext_nextHopChainingCount = INT(name=u'nextHopChainingCount', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SecurityContext_nextHopChainingCount._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _SecurityContext_nextHopParameter = BIT_STR(name=u'nextHopParameter', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SecurityKey')))
    _SecurityContext_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityContext_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SecurityContext_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SecurityContext_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SecurityContext_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityContext_iE_Extensions__item__id._const_tab = ____SecurityContext_iE_Extensions__item__id_tab
    ___SecurityContext_iE_Extensions__item__id._const_tab_at = None
    ___SecurityContext_iE_Extensions__item__id._const_tab_id = u'id'
    ___SecurityContext_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SecurityContext_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SecurityContext_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityContext_iE_Extensions__item__criticality._const_tab = ____SecurityContext_iE_Extensions__item__criticality_tab
    ___SecurityContext_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SecurityContext_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SecurityContext_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SecurityContext_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SecurityContext_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityContext_iE_Extensions__item__extensionValue._const_tab = ____SecurityContext_iE_Extensions__item__extensionValue_tab
    ___SecurityContext_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SecurityContext_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SecurityContext_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SecurityContext_iE_Extensions__item__id),
        (u'criticality', ___SecurityContext_iE_Extensions__item__criticality),
        (u'extensionValue', ___SecurityContext_iE_Extensions__item__extensionValue),
        ])
    __SecurityContext_iE_Extensions__item_._ext = None
    _SecurityContext_iE_Extensions._cont = __SecurityContext_iE_Extensions__item_
    _SecurityContext_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityContext._cont = ASN1Dict([
        (u'nextHopChainingCount', _SecurityContext_nextHopChainingCount),
        (u'nextHopParameter', _SecurityContext_nextHopParameter),
        (u'iE-Extensions', _SecurityContext_iE_Extensions),
        ])
    SecurityContext._ext = []
    
    #-----< SecurityContext-ExtIEs >-----#
    SecurityContext_ExtIEs = CLASS(name=u'SecurityContext-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    SecurityContext_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecondaryRATType >-----#
    SecondaryRATType = ENUM(name=u'SecondaryRATType', mode=MODE_TYPE)
    SecondaryRATType._cont = ASN1Dict([(u'nR', 0), (u'unlicensed', 1)])
    SecondaryRATType._ext = [u'unlicensed']
    
    #-----< SecondaryRATDataUsageRequest >-----#
    SecondaryRATDataUsageRequest = ENUM(name=u'SecondaryRATDataUsageRequest', mode=MODE_TYPE)
    SecondaryRATDataUsageRequest._cont = ASN1Dict([(u'requested', 0)])
    SecondaryRATDataUsageRequest._ext = []
    
    #-----< SecondaryRATDataUsageReportList >-----#
    SecondaryRATDataUsageReportList = SEQ_OF(name=u'SecondaryRATDataUsageReportList', mode=MODE_TYPE)
    _SecondaryRATDataUsageReportList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __SecondaryRATDataUsageReportList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___SecondaryRATDataUsageReportList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____SecondaryRATDataUsageReportList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportItem')))
    ___SecondaryRATDataUsageReportList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 265), (u'criticality', u'ignore'), (u'Value', ____SecondaryRATDataUsageReportList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SecondaryRATDataUsageReportList__item__id._const_tab = ___SecondaryRATDataUsageReportList__item__id_tab
    __SecondaryRATDataUsageReportList__item__id._const_tab_at = None
    __SecondaryRATDataUsageReportList__item__id._const_tab_id = u'id'
    __SecondaryRATDataUsageReportList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __SecondaryRATDataUsageReportList__item__criticality._const_tab = ___SecondaryRATDataUsageReportList__item__id_tab
    __SecondaryRATDataUsageReportList__item__criticality._const_tab_at = ('..', u'id')
    __SecondaryRATDataUsageReportList__item__criticality._const_tab_id = u'criticality'
    __SecondaryRATDataUsageReportList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __SecondaryRATDataUsageReportList__item__value._const_tab = ___SecondaryRATDataUsageReportList__item__id_tab
    __SecondaryRATDataUsageReportList__item__value._const_tab_at = ('..', u'id')
    __SecondaryRATDataUsageReportList__item__value._const_tab_id = u'Value'
    _SecondaryRATDataUsageReportList__item_._cont = ASN1Dict([
        (u'id', __SecondaryRATDataUsageReportList__item__id),
        (u'criticality', __SecondaryRATDataUsageReportList__item__criticality),
        (u'value', __SecondaryRATDataUsageReportList__item__value),
        ])
    _SecondaryRATDataUsageReportList__item_._ext = None
    SecondaryRATDataUsageReportList._cont = _SecondaryRATDataUsageReportList__item_
    SecondaryRATDataUsageReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< SecondaryRATDataUsageReportItemIEs >-----#
    SecondaryRATDataUsageReportItemIEs = CLASS(name=u'SecondaryRATDataUsageReportItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _SecondaryRATDataUsageReportItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportItem')))
    SecondaryRATDataUsageReportItemIEs._val = ASN1Set(rv=[dict([(u'id', 265), (u'criticality', u'ignore'), (u'Value', _SecondaryRATDataUsageReportItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SecondaryRATDataUsageReportItem >-----#
    SecondaryRATDataUsageReportItem = SEQ(name=u'SecondaryRATDataUsageReportItem', mode=MODE_TYPE)
    _SecondaryRATDataUsageReportItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _SecondaryRATDataUsageReportItem_secondaryRATType = ENUM(name=u'secondaryRATType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATType')))
    _SecondaryRATDataUsageReportItem_e_RABUsageReportList = SEQ_OF(name=u'e-RABUsageReportList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RABUsageReportList')))
    _SecondaryRATDataUsageReportItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecondaryRATDataUsageReportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SecondaryRATDataUsageReportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SecondaryRATDataUsageReportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__id._const_tab = ____SecondaryRATDataUsageReportItem_iE_Extensions__item__id_tab
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__id._const_tab_at = None
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SecondaryRATDataUsageReportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SecondaryRATDataUsageReportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__criticality._const_tab = ____SecondaryRATDataUsageReportItem_iE_Extensions__item__criticality_tab
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SecondaryRATDataUsageReportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SecondaryRATDataUsageReportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__extensionValue._const_tab = ____SecondaryRATDataUsageReportItem_iE_Extensions__item__extensionValue_tab
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SecondaryRATDataUsageReportItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SecondaryRATDataUsageReportItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SecondaryRATDataUsageReportItem_iE_Extensions__item__id),
        (u'criticality', ___SecondaryRATDataUsageReportItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SecondaryRATDataUsageReportItem_iE_Extensions__item__extensionValue),
        ])
    __SecondaryRATDataUsageReportItem_iE_Extensions__item_._ext = None
    _SecondaryRATDataUsageReportItem_iE_Extensions._cont = __SecondaryRATDataUsageReportItem_iE_Extensions__item_
    _SecondaryRATDataUsageReportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecondaryRATDataUsageReportItem._cont = ASN1Dict([
        (u'e-RAB-ID', _SecondaryRATDataUsageReportItem_e_RAB_ID),
        (u'secondaryRATType', _SecondaryRATDataUsageReportItem_secondaryRATType),
        (u'e-RABUsageReportList', _SecondaryRATDataUsageReportItem_e_RABUsageReportList),
        (u'iE-Extensions', _SecondaryRATDataUsageReportItem_iE_Extensions),
        ])
    SecondaryRATDataUsageReportItem._ext = []
    
    #-----< SecondaryRATDataUsageReportItem-ExtIEs >-----#
    SecondaryRATDataUsageReportItem_ExtIEs = CLASS(name=u'SecondaryRATDataUsageReportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    SecondaryRATDataUsageReportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SerialNumber >-----#
    SerialNumber = BIT_STR(name=u'SerialNumber', mode=MODE_TYPE)
    SerialNumber._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< ServiceType >-----#
    ServiceType = ENUM(name=u'ServiceType', mode=MODE_TYPE)
    ServiceType._cont = ASN1Dict([(u'qMC-for-streaming-service', 0), (u'qMC-for-MTSI-service', 1)])
    ServiceType._ext = []
    
    #-----< SONInformation >-----#
    SONInformation = CHOICE(name=u'SONInformation', mode=MODE_TYPE)
    _SONInformation_sONInformationRequest = ENUM(name=u'sONInformationRequest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SONInformationRequest')))
    _SONInformation_sONInformationReply = SEQ(name=u'sONInformationReply', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SONInformationReply')))
    _SONInformation_sONInformation_Extension = SEQ(name=u'sONInformation-Extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SONInformation-Extension')))
    SONInformation._cont = ASN1Dict([
        (u'sONInformationRequest', _SONInformation_sONInformationRequest),
        (u'sONInformationReply', _SONInformation_sONInformationReply),
        (u'sONInformation-Extension', _SONInformation_sONInformation_Extension),
        ])
    SONInformation._ext = [u'sONInformation-Extension']
    
    #-----< SONInformation-Extension >-----#
    SONInformation_Extension = SEQ(name=u'SONInformation-Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    _SONInformation_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    __SONInformation_Extension_id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ___SONInformation_Extension_id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SONInformationReport')))
    __SONInformation_Extension_id_tab._val = ASN1Set(rv=[dict([(u'id', 206), (u'criticality', u'ignore'), (u'Value', ___SONInformation_Extension_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _SONInformation_Extension_id._const_tab = __SONInformation_Extension_id_tab
    _SONInformation_Extension_id._const_tab_at = None
    _SONInformation_Extension_id._const_tab_id = u'id'
    _SONInformation_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    _SONInformation_Extension_criticality._const_tab = __SONInformation_Extension_id_tab
    _SONInformation_Extension_criticality._const_tab_at = ('..', u'id')
    _SONInformation_Extension_criticality._const_tab_id = u'criticality'
    _SONInformation_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    _SONInformation_Extension_value._const_tab = __SONInformation_Extension_id_tab
    _SONInformation_Extension_value._const_tab_at = ('..', u'id')
    _SONInformation_Extension_value._const_tab_id = u'Value'
    SONInformation_Extension._cont = ASN1Dict([
        (u'id', _SONInformation_Extension_id),
        (u'criticality', _SONInformation_Extension_criticality),
        (u'value', _SONInformation_Extension_value),
        ])
    SONInformation_Extension._ext = None
    
    #-----< SONInformation-ExtensionIE >-----#
    SONInformation_ExtensionIE = CLASS(name=u'SONInformation-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _SONInformation_ExtensionIE_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SONInformationReport')))
    SONInformation_ExtensionIE._val = ASN1Set(rv=[dict([(u'id', 206), (u'criticality', u'ignore'), (u'Value', _SONInformation_ExtensionIE_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< SONInformationRequest >-----#
    SONInformationRequest = ENUM(name=u'SONInformationRequest', mode=MODE_TYPE)
    SONInformationRequest._cont = ASN1Dict([(u'x2TNL-Configuration-Info', 0), (u'time-Synchronisation-Info', 1), (u'activate-Muting', 2), (u'deactivate-Muting', 3)])
    SONInformationRequest._ext = [u'time-Synchronisation-Info', u'activate-Muting', u'deactivate-Muting']
    
    #-----< SONInformationReply >-----#
    SONInformationReply = SEQ(name=u'SONInformationReply', mode=MODE_TYPE)
    _SONInformationReply_x2TNLConfigurationInfo = SEQ(name=u'x2TNLConfigurationInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'X2TNLConfigurationInfo')), opt=True)
    _SONInformationReply_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SONInformationReply_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SONInformationReply_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SONInformationReply_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____SONInformationReply_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeSynchronisationInfo')))
    _____SONInformationReply_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MutingPatternInformation')))
    ____SONInformationReply_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 149), (u'criticality', u'ignore'), (u'Extension', _____SONInformationReply_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[dict([(u'id', 208), (u'criticality', u'ignore'), (u'Extension', _____SONInformationReply_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], er=[])
    ___SONInformationReply_iE_Extensions__item__id._const_tab = ____SONInformationReply_iE_Extensions__item__id_tab
    ___SONInformationReply_iE_Extensions__item__id._const_tab_at = None
    ___SONInformationReply_iE_Extensions__item__id._const_tab_id = u'id'
    ___SONInformationReply_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SONInformationReply_iE_Extensions__item__criticality._const_tab = ____SONInformationReply_iE_Extensions__item__id_tab
    ___SONInformationReply_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SONInformationReply_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SONInformationReply_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SONInformationReply_iE_Extensions__item__extensionValue._const_tab = ____SONInformationReply_iE_Extensions__item__id_tab
    ___SONInformationReply_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SONInformationReply_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SONInformationReply_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SONInformationReply_iE_Extensions__item__id),
        (u'criticality', ___SONInformationReply_iE_Extensions__item__criticality),
        (u'extensionValue', ___SONInformationReply_iE_Extensions__item__extensionValue),
        ])
    __SONInformationReply_iE_Extensions__item_._ext = None
    _SONInformationReply_iE_Extensions._cont = __SONInformationReply_iE_Extensions__item_
    _SONInformationReply_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SONInformationReply._cont = ASN1Dict([
        (u'x2TNLConfigurationInfo', _SONInformationReply_x2TNLConfigurationInfo),
        (u'iE-Extensions', _SONInformationReply_iE_Extensions),
        ])
    SONInformationReply._ext = []
    
    #-----< SONInformationReply-ExtIEs >-----#
    SONInformationReply_ExtIEs = CLASS(name=u'SONInformationReply-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _SONInformationReply_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeSynchronisationInfo')))
    _SONInformationReply_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MutingPatternInformation')))
    SONInformationReply_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 149), (u'criticality', u'ignore'), (u'Extension', _SONInformationReply_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[dict([(u'id', 208), (u'criticality', u'ignore'), (u'Extension', _SONInformationReply_ExtIEs_val_Extension_1), (u'presence', u'optional')])], er=[])
    
    #-----< SONInformationReport >-----#
    SONInformationReport = CHOICE(name=u'SONInformationReport', mode=MODE_TYPE)
    _SONInformationReport_rLFReportInformation = SEQ(name=u'rLFReportInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RLFReportInformation')))
    SONInformationReport._cont = ASN1Dict([
        (u'rLFReportInformation', _SONInformationReport_rLFReportInformation),
        ])
    SONInformationReport._ext = []
    
    #-----< SONConfigurationTransfer >-----#
    SONConfigurationTransfer = SEQ(name=u'SONConfigurationTransfer', mode=MODE_TYPE)
    _SONConfigurationTransfer_targeteNB_ID = SEQ(name=u'targeteNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TargeteNB-ID')))
    _SONConfigurationTransfer_sourceeNB_ID = SEQ(name=u'sourceeNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SourceeNB-ID')))
    _SONConfigurationTransfer_sONInformation = CHOICE(name=u'sONInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SONInformation')))
    _SONConfigurationTransfer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SONConfigurationTransfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SONConfigurationTransfer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SONConfigurationTransfer_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____SONConfigurationTransfer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'X2TNLConfigurationInfo')))
    _____SONConfigurationTransfer_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SynchronisationInformation')))
    ____SONConfigurationTransfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 152), (u'criticality', u'ignore'), (u'Extension', _____SONConfigurationTransfer_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'conditional')]), dict([(u'id', 209), (u'criticality', u'ignore'), (u'Extension', _____SONConfigurationTransfer_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'conditional')])], rr=[], ev=None, er=[])
    ___SONConfigurationTransfer_iE_Extensions__item__id._const_tab = ____SONConfigurationTransfer_iE_Extensions__item__id_tab
    ___SONConfigurationTransfer_iE_Extensions__item__id._const_tab_at = None
    ___SONConfigurationTransfer_iE_Extensions__item__id._const_tab_id = u'id'
    ___SONConfigurationTransfer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SONConfigurationTransfer_iE_Extensions__item__criticality._const_tab = ____SONConfigurationTransfer_iE_Extensions__item__id_tab
    ___SONConfigurationTransfer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SONConfigurationTransfer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SONConfigurationTransfer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab = ____SONConfigurationTransfer_iE_Extensions__item__id_tab
    ___SONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SONConfigurationTransfer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SONConfigurationTransfer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SONConfigurationTransfer_iE_Extensions__item__id),
        (u'criticality', ___SONConfigurationTransfer_iE_Extensions__item__criticality),
        (u'extensionValue', ___SONConfigurationTransfer_iE_Extensions__item__extensionValue),
        ])
    __SONConfigurationTransfer_iE_Extensions__item_._ext = None
    _SONConfigurationTransfer_iE_Extensions._cont = __SONConfigurationTransfer_iE_Extensions__item_
    _SONConfigurationTransfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SONConfigurationTransfer._cont = ASN1Dict([
        (u'targeteNB-ID', _SONConfigurationTransfer_targeteNB_ID),
        (u'sourceeNB-ID', _SONConfigurationTransfer_sourceeNB_ID),
        (u'sONInformation', _SONConfigurationTransfer_sONInformation),
        (u'iE-Extensions', _SONConfigurationTransfer_iE_Extensions),
        ])
    SONConfigurationTransfer._ext = []
    
    #-----< SONConfigurationTransfer-ExtIEs >-----#
    SONConfigurationTransfer_ExtIEs = CLASS(name=u'SONConfigurationTransfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _SONConfigurationTransfer_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'X2TNLConfigurationInfo')))
    _SONConfigurationTransfer_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SynchronisationInformation')))
    SONConfigurationTransfer_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 152), (u'criticality', u'ignore'), (u'Extension', _SONConfigurationTransfer_ExtIEs_val_Extension_0), (u'presence', u'conditional')]), dict([(u'id', 209), (u'criticality', u'ignore'), (u'Extension', _SONConfigurationTransfer_ExtIEs_val_Extension_1), (u'presence', u'conditional')])], rr=[], ev=[], er=[])
    
    #-----< SynchronisationInformation >-----#
    SynchronisationInformation = SEQ(name=u'SynchronisationInformation', mode=MODE_TYPE)
    _SynchronisationInformation_sourceStratumLevel = INT(name=u'sourceStratumLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'StratumLevel')), opt=True)
    _SynchronisationInformation_listeningSubframePattern = SEQ(name=u'listeningSubframePattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ListeningSubframePattern')), opt=True)
    _SynchronisationInformation_aggressoreCGI_List = SEQ_OF(name=u'aggressoreCGI-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ECGI-List')), opt=True)
    _SynchronisationInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SynchronisationInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SynchronisationInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SynchronisationInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SynchronisationInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SynchronisationInformation_iE_Extensions__item__id._const_tab = ____SynchronisationInformation_iE_Extensions__item__id_tab
    ___SynchronisationInformation_iE_Extensions__item__id._const_tab_at = None
    ___SynchronisationInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___SynchronisationInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SynchronisationInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SynchronisationInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SynchronisationInformation_iE_Extensions__item__criticality._const_tab = ____SynchronisationInformation_iE_Extensions__item__criticality_tab
    ___SynchronisationInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SynchronisationInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SynchronisationInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SynchronisationInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SynchronisationInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SynchronisationInformation_iE_Extensions__item__extensionValue._const_tab = ____SynchronisationInformation_iE_Extensions__item__extensionValue_tab
    ___SynchronisationInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SynchronisationInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SynchronisationInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SynchronisationInformation_iE_Extensions__item__id),
        (u'criticality', ___SynchronisationInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___SynchronisationInformation_iE_Extensions__item__extensionValue),
        ])
    __SynchronisationInformation_iE_Extensions__item_._ext = None
    _SynchronisationInformation_iE_Extensions._cont = __SynchronisationInformation_iE_Extensions__item_
    _SynchronisationInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SynchronisationInformation._cont = ASN1Dict([
        (u'sourceStratumLevel', _SynchronisationInformation_sourceStratumLevel),
        (u'listeningSubframePattern', _SynchronisationInformation_listeningSubframePattern),
        (u'aggressoreCGI-List', _SynchronisationInformation_aggressoreCGI_List),
        (u'iE-Extensions', _SynchronisationInformation_iE_Extensions),
        ])
    SynchronisationInformation._ext = []
    
    #-----< SynchronisationInformation-ExtIEs >-----#
    SynchronisationInformation_ExtIEs = CLASS(name=u'SynchronisationInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    SynchronisationInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Source-ToTarget-TransparentContainer >-----#
    Source_ToTarget_TransparentContainer = OCT_STR(name=u'Source-ToTarget-TransparentContainer', mode=MODE_TYPE)
    
    #-----< SourceBSS-ToTargetBSS-TransparentContainer >-----#
    SourceBSS_ToTargetBSS_TransparentContainer = OCT_STR(name=u'SourceBSS-ToTargetBSS-TransparentContainer', mode=MODE_TYPE)
    
    #-----< SourceeNB-ID >-----#
    SourceeNB_ID = SEQ(name=u'SourceeNB-ID', mode=MODE_TYPE)
    _SourceeNB_ID_global_ENB_ID = SEQ(name=u'global-ENB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    _SourceeNB_ID_selected_TAI = SEQ(name=u'selected-TAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _SourceeNB_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SourceeNB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SourceeNB_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SourceeNB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SourceeNB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceeNB_ID_iE_Extensions__item__id._const_tab = ____SourceeNB_ID_iE_Extensions__item__id_tab
    ___SourceeNB_ID_iE_Extensions__item__id._const_tab_at = None
    ___SourceeNB_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___SourceeNB_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SourceeNB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SourceeNB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceeNB_ID_iE_Extensions__item__criticality._const_tab = ____SourceeNB_ID_iE_Extensions__item__criticality_tab
    ___SourceeNB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SourceeNB_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SourceeNB_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SourceeNB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SourceeNB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceeNB_ID_iE_Extensions__item__extensionValue._const_tab = ____SourceeNB_ID_iE_Extensions__item__extensionValue_tab
    ___SourceeNB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SourceeNB_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SourceeNB_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SourceeNB_ID_iE_Extensions__item__id),
        (u'criticality', ___SourceeNB_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___SourceeNB_ID_iE_Extensions__item__extensionValue),
        ])
    __SourceeNB_ID_iE_Extensions__item_._ext = None
    _SourceeNB_ID_iE_Extensions._cont = __SourceeNB_ID_iE_Extensions__item_
    _SourceeNB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SourceeNB_ID._cont = ASN1Dict([
        (u'global-ENB-ID', _SourceeNB_ID_global_ENB_ID),
        (u'selected-TAI', _SourceeNB_ID_selected_TAI),
        (u'iE-Extensions', _SourceeNB_ID_iE_Extensions),
        ])
    SourceeNB_ID._ext = None
    
    #-----< SourceeNB-ID-ExtIEs >-----#
    SourceeNB_ID_ExtIEs = CLASS(name=u'SourceeNB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    SourceeNB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRVCCOperationNotPossible >-----#
    SRVCCOperationNotPossible = ENUM(name=u'SRVCCOperationNotPossible', mode=MODE_TYPE)
    SRVCCOperationNotPossible._cont = ASN1Dict([(u'notPossible', 0)])
    SRVCCOperationNotPossible._ext = []
    
    #-----< SRVCCOperationPossible >-----#
    SRVCCOperationPossible = ENUM(name=u'SRVCCOperationPossible', mode=MODE_TYPE)
    SRVCCOperationPossible._cont = ASN1Dict([(u'possible', 0)])
    SRVCCOperationPossible._ext = []
    
    #-----< SRVCCHOIndication >-----#
    SRVCCHOIndication = ENUM(name=u'SRVCCHOIndication', mode=MODE_TYPE)
    SRVCCHOIndication._cont = ASN1Dict([(u'pSandCS', 0), (u'cSonly', 1)])
    SRVCCHOIndication._ext = []
    
    #-----< SourceNodeID >-----#
    SourceNodeID = CHOICE(name=u'SourceNodeID', mode=MODE_TYPE)
    _SourceNodeID_sourceNgRanNode_ID = SEQ(name=u'sourceNgRanNode-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SourceNgRanNode-ID')))
    _SourceNodeID_sourceNodeID_Extension = SEQ(name=u'sourceNodeID-Extension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SourceNodeID-Extension')))
    SourceNodeID._cont = ASN1Dict([
        (u'sourceNgRanNode-ID', _SourceNodeID_sourceNgRanNode_ID),
        (u'sourceNodeID-Extension', _SourceNodeID_sourceNodeID_Extension),
        ])
    SourceNodeID._ext = None
    
    #-----< SourceNodeID-Extension >-----#
    SourceNodeID_Extension = SEQ(name=u'SourceNodeID-Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    _SourceNodeID_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    __SourceNodeID_Extension_id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    __SourceNodeID_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _SourceNodeID_Extension_id._const_tab = __SourceNodeID_Extension_id_tab
    _SourceNodeID_Extension_id._const_tab_at = None
    _SourceNodeID_Extension_id._const_tab_id = u'id'
    _SourceNodeID_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __SourceNodeID_Extension_criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    __SourceNodeID_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _SourceNodeID_Extension_criticality._const_tab = __SourceNodeID_Extension_criticality_tab
    _SourceNodeID_Extension_criticality._const_tab_at = ('..', u'id')
    _SourceNodeID_Extension_criticality._const_tab_id = u'criticality'
    _SourceNodeID_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __SourceNodeID_Extension_value_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    __SourceNodeID_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _SourceNodeID_Extension_value._const_tab = __SourceNodeID_Extension_value_tab
    _SourceNodeID_Extension_value._const_tab_at = ('..', u'id')
    _SourceNodeID_Extension_value._const_tab_id = u'Value'
    SourceNodeID_Extension._cont = ASN1Dict([
        (u'id', _SourceNodeID_Extension_id),
        (u'criticality', _SourceNodeID_Extension_criticality),
        (u'value', _SourceNodeID_Extension_value),
        ])
    SourceNodeID_Extension._ext = None
    
    #-----< SourceNodeID-ExtensionIE >-----#
    SourceNodeID_ExtensionIE = CLASS(name=u'SourceNodeID-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    SourceNodeID_ExtensionIE._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SourceeNB-ToTargeteNB-TransparentContainer >-----#
    SourceeNB_ToTargeteNB_TransparentContainer = SEQ(name=u'SourceeNB-ToTargeteNB-TransparentContainer', mode=MODE_TYPE)
    _SourceeNB_ToTargeteNB_TransparentContainer_rRC_Container = OCT_STR(name=u'rRC-Container', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RRC-Container')))
    _SourceeNB_ToTargeteNB_TransparentContainer_e_RABInformationList = SEQ_OF(name=u'e-RABInformationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RABInformationList')), opt=True)
    _SourceeNB_ToTargeteNB_TransparentContainer_targetCell_ID = SEQ(name=u'targetCell-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _SourceeNB_ToTargeteNB_TransparentContainer_subscriberProfileIDforRFP = INT(name=u'subscriberProfileIDforRFP', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SubscriberProfileIDforRFP')), opt=True)
    _SourceeNB_ToTargeteNB_TransparentContainer_uE_HistoryInformation = SEQ_OF(name=u'uE-HistoryInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'UE-HistoryInformation')))
    _SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MobilityInformation')))
    _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-HistoryInformationFromTheUE')))
    _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IMSvoiceEPSfallbackfrom5G')))
    _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ContextatSource')))
    _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IntersystemMeasurementConfiguration')))
    _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_6 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SourceNodeID')))
    _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_7 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EmergencyIndicator')))
    _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_8 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Direct-Forwarding-Path-Availability')))
    _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_9 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Global-RAN-NODE-ID')))
    ____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 175), (u'criticality', u'ignore'), (u'Extension', _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 194), (u'criticality', u'ignore'), (u'Extension', _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 296), (u'criticality', u'ignore'), (u'Extension', _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 299), (u'criticality', u'ignore'), (u'Extension', _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 300), (u'criticality', u'ignore'), (u'Extension', _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 312), (u'criticality', u'ignore'), (u'Extension', _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 326), (u'criticality', u'ignore'), (u'Extension', _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 79), (u'criticality', u'ignore'), (u'Extension', _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 343), (u'criticality', u'ignore'), (u'Extension', _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id._const_tab = ____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id._const_tab_id = u'id'
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id),
        (u'criticality', ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__criticality),
        (u'extensionValue', ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item_._ext = None
    _SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions._cont = __SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item_
    _SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SourceeNB_ToTargeteNB_TransparentContainer._cont = ASN1Dict([
        (u'rRC-Container', _SourceeNB_ToTargeteNB_TransparentContainer_rRC_Container),
        (u'e-RABInformationList', _SourceeNB_ToTargeteNB_TransparentContainer_e_RABInformationList),
        (u'targetCell-ID', _SourceeNB_ToTargeteNB_TransparentContainer_targetCell_ID),
        (u'subscriberProfileIDforRFP', _SourceeNB_ToTargeteNB_TransparentContainer_subscriberProfileIDforRFP),
        (u'uE-HistoryInformation', _SourceeNB_ToTargeteNB_TransparentContainer_uE_HistoryInformation),
        (u'iE-Extensions', _SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions),
        ])
    SourceeNB_ToTargeteNB_TransparentContainer._ext = []
    
    #-----< SourceeNB-ToTargeteNB-TransparentContainer-ExtIEs >-----#
    SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs = CLASS(name=u'SourceeNB-ToTargeteNB-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MobilityInformation')))
    _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-HistoryInformationFromTheUE')))
    _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IMSvoiceEPSfallbackfrom5G')))
    _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ContextatSource')))
    _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IntersystemMeasurementConfiguration')))
    _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_6 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SourceNodeID')))
    _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_7 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EmergencyIndicator')))
    _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_8 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Direct-Forwarding-Path-Availability')))
    _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_9 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Global-RAN-NODE-ID')))
    SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 175), (u'criticality', u'ignore'), (u'Extension', _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 194), (u'criticality', u'ignore'), (u'Extension', _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 296), (u'criticality', u'ignore'), (u'Extension', _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 299), (u'criticality', u'ignore'), (u'Extension', _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 300), (u'criticality', u'ignore'), (u'Extension', _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 312), (u'criticality', u'ignore'), (u'Extension', _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 326), (u'criticality', u'ignore'), (u'Extension', _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 79), (u'criticality', u'ignore'), (u'Extension', _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 343), (u'criticality', u'ignore'), (u'Extension', _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_9), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SourceNgRanNode-ID >-----#
    SourceNgRanNode_ID = SEQ(name=u'SourceNgRanNode-ID', mode=MODE_TYPE)
    _SourceNgRanNode_ID_global_RAN_NODE_ID = CHOICE(name=u'global-RAN-NODE-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Global-RAN-NODE-ID')))
    _SourceNgRanNode_ID_selected_TAI = SEQ(name=u'selected-TAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'FiveGSTAI')))
    _SourceNgRanNode_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SourceNgRanNode_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SourceNgRanNode_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SourceNgRanNode_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SourceNgRanNode_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceNgRanNode_ID_iE_Extensions__item__id._const_tab = ____SourceNgRanNode_ID_iE_Extensions__item__id_tab
    ___SourceNgRanNode_ID_iE_Extensions__item__id._const_tab_at = None
    ___SourceNgRanNode_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___SourceNgRanNode_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SourceNgRanNode_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SourceNgRanNode_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceNgRanNode_ID_iE_Extensions__item__criticality._const_tab = ____SourceNgRanNode_ID_iE_Extensions__item__criticality_tab
    ___SourceNgRanNode_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SourceNgRanNode_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SourceNgRanNode_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SourceNgRanNode_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____SourceNgRanNode_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceNgRanNode_ID_iE_Extensions__item__extensionValue._const_tab = ____SourceNgRanNode_ID_iE_Extensions__item__extensionValue_tab
    ___SourceNgRanNode_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SourceNgRanNode_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SourceNgRanNode_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SourceNgRanNode_ID_iE_Extensions__item__id),
        (u'criticality', ___SourceNgRanNode_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___SourceNgRanNode_ID_iE_Extensions__item__extensionValue),
        ])
    __SourceNgRanNode_ID_iE_Extensions__item_._ext = None
    _SourceNgRanNode_ID_iE_Extensions._cont = __SourceNgRanNode_ID_iE_Extensions__item_
    _SourceNgRanNode_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SourceNgRanNode_ID._cont = ASN1Dict([
        (u'global-RAN-NODE-ID', _SourceNgRanNode_ID_global_RAN_NODE_ID),
        (u'selected-TAI', _SourceNgRanNode_ID_selected_TAI),
        (u'iE-Extensions', _SourceNgRanNode_ID_iE_Extensions),
        ])
    SourceNgRanNode_ID._ext = []
    
    #-----< SourceNgRanNode-ID-ExtIEs >-----#
    SourceNgRanNode_ID_ExtIEs = CLASS(name=u'SourceNgRanNode-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    SourceNgRanNode_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SourceRNC-ToTargetRNC-TransparentContainer >-----#
    SourceRNC_ToTargetRNC_TransparentContainer = OCT_STR(name=u'SourceRNC-ToTargetRNC-TransparentContainer', mode=MODE_TYPE)
    
    #-----< SourceNgRanNode-ToTargetNgRanNode-TransparentContainer >-----#
    SourceNgRanNode_ToTargetNgRanNode_TransparentContainer = OCT_STR(name=u'SourceNgRanNode-ToTargetNgRanNode-TransparentContainer', mode=MODE_TYPE)
    
    #-----< ServedGUMMEIs >-----#
    ServedGUMMEIs = SEQ_OF(name=u'ServedGUMMEIs', mode=MODE_TYPE)
    _ServedGUMMEIs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServedGUMMEIsItem')))
    ServedGUMMEIs._cont = _ServedGUMMEIs__item_
    ServedGUMMEIs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ServedGUMMEIsItem >-----#
    ServedGUMMEIsItem = SEQ(name=u'ServedGUMMEIsItem', mode=MODE_TYPE)
    _ServedGUMMEIsItem_servedPLMNs = SEQ_OF(name=u'servedPLMNs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ServedPLMNs')))
    _ServedGUMMEIsItem_servedGroupIDs = SEQ_OF(name=u'servedGroupIDs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ServedGroupIDs')))
    _ServedGUMMEIsItem_servedMMECs = SEQ_OF(name=u'servedMMECs', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ServedMMECs')))
    _ServedGUMMEIsItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ServedGUMMEIsItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ServedGUMMEIsItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ServedGUMMEIsItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____ServedGUMMEIsItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEIType')))
    ____ServedGUMMEIsItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 170), (u'criticality', u'ignore'), (u'Extension', _____ServedGUMMEIsItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ServedGUMMEIsItem_iE_Extensions__item__id._const_tab = ____ServedGUMMEIsItem_iE_Extensions__item__id_tab
    ___ServedGUMMEIsItem_iE_Extensions__item__id._const_tab_at = None
    ___ServedGUMMEIsItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___ServedGUMMEIsItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ServedGUMMEIsItem_iE_Extensions__item__criticality._const_tab = ____ServedGUMMEIsItem_iE_Extensions__item__id_tab
    ___ServedGUMMEIsItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ServedGUMMEIsItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ServedGUMMEIsItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ServedGUMMEIsItem_iE_Extensions__item__extensionValue._const_tab = ____ServedGUMMEIsItem_iE_Extensions__item__id_tab
    ___ServedGUMMEIsItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ServedGUMMEIsItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ServedGUMMEIsItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ServedGUMMEIsItem_iE_Extensions__item__id),
        (u'criticality', ___ServedGUMMEIsItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___ServedGUMMEIsItem_iE_Extensions__item__extensionValue),
        ])
    __ServedGUMMEIsItem_iE_Extensions__item_._ext = None
    _ServedGUMMEIsItem_iE_Extensions._cont = __ServedGUMMEIsItem_iE_Extensions__item_
    _ServedGUMMEIsItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ServedGUMMEIsItem._cont = ASN1Dict([
        (u'servedPLMNs', _ServedGUMMEIsItem_servedPLMNs),
        (u'servedGroupIDs', _ServedGUMMEIsItem_servedGroupIDs),
        (u'servedMMECs', _ServedGUMMEIsItem_servedMMECs),
        (u'iE-Extensions', _ServedGUMMEIsItem_iE_Extensions),
        ])
    ServedGUMMEIsItem._ext = []
    
    #-----< ServedGUMMEIsItem-ExtIEs >-----#
    ServedGUMMEIsItem_ExtIEs = CLASS(name=u'ServedGUMMEIsItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _ServedGUMMEIsItem_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEIType')))
    ServedGUMMEIsItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 170), (u'criticality', u'ignore'), (u'Extension', _ServedGUMMEIsItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ServedGroupIDs >-----#
    ServedGroupIDs = SEQ_OF(name=u'ServedGroupIDs', mode=MODE_TYPE)
    _ServedGroupIDs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-Group-ID')))
    ServedGroupIDs._cont = _ServedGroupIDs__item_
    ServedGroupIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< ServedMMECs >-----#
    ServedMMECs = SEQ_OF(name=u'ServedMMECs', mode=MODE_TYPE)
    _ServedMMECs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-Code')))
    ServedMMECs._cont = _ServedMMECs__item_
    ServedMMECs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ServedPLMNs >-----#
    ServedPLMNs = SEQ_OF(name=u'ServedPLMNs', mode=MODE_TYPE)
    _ServedPLMNs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    ServedPLMNs._cont = _ServedPLMNs__item_
    ServedPLMNs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SubscriberProfileIDforRFP >-----#
    SubscriberProfileIDforRFP = INT(name=u'SubscriberProfileIDforRFP', mode=MODE_TYPE)
    SubscriberProfileIDforRFP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Subscription-Based-UE-DifferentiationInfo >-----#
    Subscription_Based_UE_DifferentiationInfo = SEQ(name=u'Subscription-Based-UE-DifferentiationInfo', mode=MODE_TYPE)
    _Subscription_Based_UE_DifferentiationInfo_periodicCommunicationIndicator = ENUM(name=u'periodicCommunicationIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Subscription_Based_UE_DifferentiationInfo_periodicCommunicationIndicator._cont = ASN1Dict([(u'periodically', 0), (u'ondemand', 1)])
    _Subscription_Based_UE_DifferentiationInfo_periodicCommunicationIndicator._ext = []
    _Subscription_Based_UE_DifferentiationInfo_periodicTime = INT(name=u'periodicTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Subscription_Based_UE_DifferentiationInfo_periodicTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3600)], ev=[], er=[])
    _Subscription_Based_UE_DifferentiationInfo_scheduledCommunicationTime = SEQ(name=u'scheduledCommunicationTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ScheduledCommunicationTime')), opt=True)
    _Subscription_Based_UE_DifferentiationInfo_stationaryIndication = ENUM(name=u'stationaryIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Subscription_Based_UE_DifferentiationInfo_stationaryIndication._cont = ASN1Dict([(u'stationary', 0), (u'mobile', 1)])
    _Subscription_Based_UE_DifferentiationInfo_stationaryIndication._ext = []
    _Subscription_Based_UE_DifferentiationInfo_trafficProfile = ENUM(name=u'trafficProfile', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Subscription_Based_UE_DifferentiationInfo_trafficProfile._cont = ASN1Dict([(u'single-packet', 0), (u'dual-packets', 1), (u'multiple-packets', 2)])
    _Subscription_Based_UE_DifferentiationInfo_trafficProfile._ext = []
    _Subscription_Based_UE_DifferentiationInfo_batteryIndication = ENUM(name=u'batteryIndication', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Subscription_Based_UE_DifferentiationInfo_batteryIndication._cont = ASN1Dict([(u'battery-powered', 0), (u'battery-powered-not-rechargeable-or-replaceable', 1), (u'not-battery-powered', 2)])
    _Subscription_Based_UE_DifferentiationInfo_batteryIndication._ext = []
    _Subscription_Based_UE_DifferentiationInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id._const_tab = ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id_tab
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id._const_tab_at = None
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality._const_tab = ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality_tab
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue._const_tab = ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue_tab
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id),
        (u'criticality', ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue),
        ])
    __Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item_._ext = None
    _Subscription_Based_UE_DifferentiationInfo_iE_Extensions._cont = __Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item_
    _Subscription_Based_UE_DifferentiationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Subscription_Based_UE_DifferentiationInfo._cont = ASN1Dict([
        (u'periodicCommunicationIndicator', _Subscription_Based_UE_DifferentiationInfo_periodicCommunicationIndicator),
        (u'periodicTime', _Subscription_Based_UE_DifferentiationInfo_periodicTime),
        (u'scheduledCommunicationTime', _Subscription_Based_UE_DifferentiationInfo_scheduledCommunicationTime),
        (u'stationaryIndication', _Subscription_Based_UE_DifferentiationInfo_stationaryIndication),
        (u'trafficProfile', _Subscription_Based_UE_DifferentiationInfo_trafficProfile),
        (u'batteryIndication', _Subscription_Based_UE_DifferentiationInfo_batteryIndication),
        (u'iE-Extensions', _Subscription_Based_UE_DifferentiationInfo_iE_Extensions),
        ])
    Subscription_Based_UE_DifferentiationInfo._ext = []
    
    #-----< Subscription-Based-UE-DifferentiationInfo-ExtIEs >-----#
    Subscription_Based_UE_DifferentiationInfo_ExtIEs = CLASS(name=u'Subscription-Based-UE-DifferentiationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    Subscription_Based_UE_DifferentiationInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ScheduledCommunicationTime >-----#
    ScheduledCommunicationTime = SEQ(name=u'ScheduledCommunicationTime', mode=MODE_TYPE)
    _ScheduledCommunicationTime_dayofWeek = BIT_STR(name=u'dayofWeek', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScheduledCommunicationTime_dayofWeek._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _ScheduledCommunicationTime_timeofDayStart = INT(name=u'timeofDayStart', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScheduledCommunicationTime_timeofDayStart._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86399)], ev=[], er=[])
    _ScheduledCommunicationTime_timeofDayEnd = INT(name=u'timeofDayEnd', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScheduledCommunicationTime_timeofDayEnd._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86399)], ev=[], er=[])
    _ScheduledCommunicationTime_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ScheduledCommunicationTime_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ScheduledCommunicationTime_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ScheduledCommunicationTime_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ScheduledCommunicationTime_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ScheduledCommunicationTime_iE_Extensions__item__id._const_tab = ____ScheduledCommunicationTime_iE_Extensions__item__id_tab
    ___ScheduledCommunicationTime_iE_Extensions__item__id._const_tab_at = None
    ___ScheduledCommunicationTime_iE_Extensions__item__id._const_tab_id = u'id'
    ___ScheduledCommunicationTime_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ScheduledCommunicationTime_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ScheduledCommunicationTime_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ScheduledCommunicationTime_iE_Extensions__item__criticality._const_tab = ____ScheduledCommunicationTime_iE_Extensions__item__criticality_tab
    ___ScheduledCommunicationTime_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ScheduledCommunicationTime_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ScheduledCommunicationTime_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ScheduledCommunicationTime_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue._const_tab = ____ScheduledCommunicationTime_iE_Extensions__item__extensionValue_tab
    ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ScheduledCommunicationTime_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ScheduledCommunicationTime_iE_Extensions__item__id),
        (u'criticality', ___ScheduledCommunicationTime_iE_Extensions__item__criticality),
        (u'extensionValue', ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue),
        ])
    __ScheduledCommunicationTime_iE_Extensions__item_._ext = None
    _ScheduledCommunicationTime_iE_Extensions._cont = __ScheduledCommunicationTime_iE_Extensions__item_
    _ScheduledCommunicationTime_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ScheduledCommunicationTime._cont = ASN1Dict([
        (u'dayofWeek', _ScheduledCommunicationTime_dayofWeek),
        (u'timeofDayStart', _ScheduledCommunicationTime_timeofDayStart),
        (u'timeofDayEnd', _ScheduledCommunicationTime_timeofDayEnd),
        (u'iE-Extensions', _ScheduledCommunicationTime_iE_Extensions),
        ])
    ScheduledCommunicationTime._ext = []
    
    #-----< ScheduledCommunicationTime-ExtIEs >-----#
    ScheduledCommunicationTime_ExtIEs = CLASS(name=u'ScheduledCommunicationTime-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ScheduledCommunicationTime_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SupportedTAs >-----#
    SupportedTAs = SEQ_OF(name=u'SupportedTAs', mode=MODE_TYPE)
    _SupportedTAs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SupportedTAs-Item')))
    SupportedTAs._cont = _SupportedTAs__item_
    SupportedTAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< SupportedTAs-Item >-----#
    SupportedTAs_Item = SEQ(name=u'SupportedTAs-Item', mode=MODE_TYPE)
    _SupportedTAs_Item_tAC = OCT_STR(name=u'tAC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAC')))
    _SupportedTAs_Item_broadcastPLMNs = SEQ_OF(name=u'broadcastPLMNs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BPLMNs')))
    _SupportedTAs_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SupportedTAs_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___SupportedTAs_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____SupportedTAs_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____SupportedTAs_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RAT-Type')))
    ____SupportedTAs_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 232), (u'criticality', u'reject'), (u'Extension', _____SupportedTAs_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SupportedTAs_Item_iE_Extensions__item__id._const_tab = ____SupportedTAs_Item_iE_Extensions__item__id_tab
    ___SupportedTAs_Item_iE_Extensions__item__id._const_tab_at = None
    ___SupportedTAs_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___SupportedTAs_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SupportedTAs_Item_iE_Extensions__item__criticality._const_tab = ____SupportedTAs_Item_iE_Extensions__item__id_tab
    ___SupportedTAs_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SupportedTAs_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SupportedTAs_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SupportedTAs_Item_iE_Extensions__item__extensionValue._const_tab = ____SupportedTAs_Item_iE_Extensions__item__id_tab
    ___SupportedTAs_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SupportedTAs_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SupportedTAs_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SupportedTAs_Item_iE_Extensions__item__id),
        (u'criticality', ___SupportedTAs_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___SupportedTAs_Item_iE_Extensions__item__extensionValue),
        ])
    __SupportedTAs_Item_iE_Extensions__item_._ext = None
    _SupportedTAs_Item_iE_Extensions._cont = __SupportedTAs_Item_iE_Extensions__item_
    _SupportedTAs_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SupportedTAs_Item._cont = ASN1Dict([
        (u'tAC', _SupportedTAs_Item_tAC),
        (u'broadcastPLMNs', _SupportedTAs_Item_broadcastPLMNs),
        (u'iE-Extensions', _SupportedTAs_Item_iE_Extensions),
        ])
    SupportedTAs_Item._ext = []
    
    #-----< SupportedTAs-Item-ExtIEs >-----#
    SupportedTAs_Item_ExtIEs = CLASS(name=u'SupportedTAs-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _SupportedTAs_Item_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RAT-Type')))
    SupportedTAs_Item_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 232), (u'criticality', u'reject'), (u'Extension', _SupportedTAs_Item_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< StratumLevel >-----#
    StratumLevel = INT(name=u'StratumLevel', mode=MODE_TYPE)
    StratumLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=[], er=[])
    
    #-----< SynchronisationStatus >-----#
    SynchronisationStatus = ENUM(name=u'SynchronisationStatus', mode=MODE_TYPE)
    SynchronisationStatus._cont = ASN1Dict([(u'synchronous', 0), (u'asynchronous', 1)])
    SynchronisationStatus._ext = []
    
    #-----< TimeSynchronisationInfo >-----#
    TimeSynchronisationInfo = SEQ(name=u'TimeSynchronisationInfo', mode=MODE_TYPE)
    _TimeSynchronisationInfo_stratumLevel = INT(name=u'stratumLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'StratumLevel')))
    _TimeSynchronisationInfo_synchronisationStatus = ENUM(name=u'synchronisationStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'SynchronisationStatus')))
    _TimeSynchronisationInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TimeSynchronisationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TimeSynchronisationInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TimeSynchronisationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____TimeSynchronisationInfo_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MutingAvailabilityIndication')))
    ____TimeSynchronisationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 207), (u'criticality', u'ignore'), (u'Extension', _____TimeSynchronisationInfo_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TimeSynchronisationInfo_iE_Extensions__item__id._const_tab = ____TimeSynchronisationInfo_iE_Extensions__item__id_tab
    ___TimeSynchronisationInfo_iE_Extensions__item__id._const_tab_at = None
    ___TimeSynchronisationInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___TimeSynchronisationInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TimeSynchronisationInfo_iE_Extensions__item__criticality._const_tab = ____TimeSynchronisationInfo_iE_Extensions__item__id_tab
    ___TimeSynchronisationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TimeSynchronisationInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TimeSynchronisationInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TimeSynchronisationInfo_iE_Extensions__item__extensionValue._const_tab = ____TimeSynchronisationInfo_iE_Extensions__item__id_tab
    ___TimeSynchronisationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TimeSynchronisationInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TimeSynchronisationInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TimeSynchronisationInfo_iE_Extensions__item__id),
        (u'criticality', ___TimeSynchronisationInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___TimeSynchronisationInfo_iE_Extensions__item__extensionValue),
        ])
    __TimeSynchronisationInfo_iE_Extensions__item_._ext = None
    _TimeSynchronisationInfo_iE_Extensions._cont = __TimeSynchronisationInfo_iE_Extensions__item_
    _TimeSynchronisationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TimeSynchronisationInfo._cont = ASN1Dict([
        (u'stratumLevel', _TimeSynchronisationInfo_stratumLevel),
        (u'synchronisationStatus', _TimeSynchronisationInfo_synchronisationStatus),
        (u'iE-Extensions', _TimeSynchronisationInfo_iE_Extensions),
        ])
    TimeSynchronisationInfo._ext = []
    
    #-----< TimeSynchronisationInfo-ExtIEs >-----#
    TimeSynchronisationInfo_ExtIEs = CLASS(name=u'TimeSynchronisationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _TimeSynchronisationInfo_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MutingAvailabilityIndication')))
    TimeSynchronisationInfo_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 207), (u'criticality', u'ignore'), (u'Extension', _TimeSynchronisationInfo_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< S-TMSI >-----#
    S_TMSI = SEQ(name=u'S-TMSI', mode=MODE_TYPE)
    _S_TMSI_mMEC = OCT_STR(name=u'mMEC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MME-Code')))
    _S_TMSI_m_TMSI = OCT_STR(name=u'm-TMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'M-TMSI')))
    _S_TMSI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __S_TMSI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___S_TMSI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____S_TMSI_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____S_TMSI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___S_TMSI_iE_Extensions__item__id._const_tab = ____S_TMSI_iE_Extensions__item__id_tab
    ___S_TMSI_iE_Extensions__item__id._const_tab_at = None
    ___S_TMSI_iE_Extensions__item__id._const_tab_id = u'id'
    ___S_TMSI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____S_TMSI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____S_TMSI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___S_TMSI_iE_Extensions__item__criticality._const_tab = ____S_TMSI_iE_Extensions__item__criticality_tab
    ___S_TMSI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___S_TMSI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___S_TMSI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____S_TMSI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____S_TMSI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___S_TMSI_iE_Extensions__item__extensionValue._const_tab = ____S_TMSI_iE_Extensions__item__extensionValue_tab
    ___S_TMSI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___S_TMSI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __S_TMSI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___S_TMSI_iE_Extensions__item__id),
        (u'criticality', ___S_TMSI_iE_Extensions__item__criticality),
        (u'extensionValue', ___S_TMSI_iE_Extensions__item__extensionValue),
        ])
    __S_TMSI_iE_Extensions__item_._ext = None
    _S_TMSI_iE_Extensions._cont = __S_TMSI_iE_Extensions__item_
    _S_TMSI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    S_TMSI._cont = ASN1Dict([
        (u'mMEC', _S_TMSI_mMEC),
        (u'm-TMSI', _S_TMSI_m_TMSI),
        (u'iE-Extensions', _S_TMSI_iE_Extensions),
        ])
    S_TMSI._ext = []
    
    #-----< S-TMSI-ExtIEs >-----#
    S_TMSI_ExtIEs = CLASS(name=u'S-TMSI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    S_TMSI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAC >-----#
    TAC = OCT_STR(name=u'TAC', mode=MODE_TYPE)
    TAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< TAIBasedMDT >-----#
    TAIBasedMDT = SEQ(name=u'TAIBasedMDT', mode=MODE_TYPE)
    _TAIBasedMDT_tAIListforMDT = SEQ_OF(name=u'tAIListforMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAIListforMDT')))
    _TAIBasedMDT_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAIBasedMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TAIBasedMDT_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TAIBasedMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAIBasedMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedMDT_iE_Extensions__item__id._const_tab = ____TAIBasedMDT_iE_Extensions__item__id_tab
    ___TAIBasedMDT_iE_Extensions__item__id._const_tab_at = None
    ___TAIBasedMDT_iE_Extensions__item__id._const_tab_id = u'id'
    ___TAIBasedMDT_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TAIBasedMDT_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAIBasedMDT_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedMDT_iE_Extensions__item__criticality._const_tab = ____TAIBasedMDT_iE_Extensions__item__criticality_tab
    ___TAIBasedMDT_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TAIBasedMDT_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TAIBasedMDT_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TAIBasedMDT_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAIBasedMDT_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedMDT_iE_Extensions__item__extensionValue._const_tab = ____TAIBasedMDT_iE_Extensions__item__extensionValue_tab
    ___TAIBasedMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TAIBasedMDT_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TAIBasedMDT_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TAIBasedMDT_iE_Extensions__item__id),
        (u'criticality', ___TAIBasedMDT_iE_Extensions__item__criticality),
        (u'extensionValue', ___TAIBasedMDT_iE_Extensions__item__extensionValue),
        ])
    __TAIBasedMDT_iE_Extensions__item_._ext = None
    _TAIBasedMDT_iE_Extensions._cont = __TAIBasedMDT_iE_Extensions__item_
    _TAIBasedMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAIBasedMDT._cont = ASN1Dict([
        (u'tAIListforMDT', _TAIBasedMDT_tAIListforMDT),
        (u'iE-Extensions', _TAIBasedMDT_iE_Extensions),
        ])
    TAIBasedMDT._ext = []
    
    #-----< TAIBasedMDT-ExtIEs >-----#
    TAIBasedMDT_ExtIEs = CLASS(name=u'TAIBasedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TAIBasedMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAIListforMDT >-----#
    TAIListforMDT = SEQ_OF(name=u'TAIListforMDT', mode=MODE_TYPE)
    _TAIListforMDT__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    TAIListforMDT._cont = _TAIListforMDT__item_
    TAIListforMDT._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TAIListforWarning >-----#
    TAIListforWarning = SEQ_OF(name=u'TAIListforWarning', mode=MODE_TYPE)
    _TAIListforWarning__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    TAIListforWarning._cont = _TAIListforWarning__item_
    TAIListforWarning._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TAI >-----#
    TAI = SEQ(name=u'TAI', mode=MODE_TYPE)
    _TAI_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _TAI_tAC = OCT_STR(name=u'tAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAC')))
    _TAI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TAI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TAI_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_iE_Extensions__item__id._const_tab = ____TAI_iE_Extensions__item__id_tab
    ___TAI_iE_Extensions__item__id._const_tab_at = None
    ___TAI_iE_Extensions__item__id._const_tab_id = u'id'
    ___TAI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_iE_Extensions__item__criticality._const_tab = ____TAI_iE_Extensions__item__criticality_tab
    ___TAI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TAI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TAI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_iE_Extensions__item__extensionValue._const_tab = ____TAI_iE_Extensions__item__extensionValue_tab
    ___TAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TAI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TAI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TAI_iE_Extensions__item__id),
        (u'criticality', ___TAI_iE_Extensions__item__criticality),
        (u'extensionValue', ___TAI_iE_Extensions__item__extensionValue),
        ])
    __TAI_iE_Extensions__item_._ext = None
    _TAI_iE_Extensions._cont = __TAI_iE_Extensions__item_
    _TAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAI._cont = ASN1Dict([
        (u'pLMNidentity', _TAI_pLMNidentity),
        (u'tAC', _TAI_tAC),
        (u'iE-Extensions', _TAI_iE_Extensions),
        ])
    TAI._ext = []
    
    #-----< TAI-ExtIEs >-----#
    TAI_ExtIEs = CLASS(name=u'TAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAI-Broadcast >-----#
    TAI_Broadcast = SEQ_OF(name=u'TAI-Broadcast', mode=MODE_TYPE)
    _TAI_Broadcast__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI-Broadcast-Item')))
    TAI_Broadcast._cont = _TAI_Broadcast__item_
    TAI_Broadcast._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TAI-Broadcast-Item >-----#
    TAI_Broadcast_Item = SEQ(name=u'TAI-Broadcast-Item', mode=MODE_TYPE)
    _TAI_Broadcast_Item_tAI = SEQ(name=u'tAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _TAI_Broadcast_Item_completedCellinTAI = SEQ_OF(name=u'completedCellinTAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CompletedCellinTAI')))
    _TAI_Broadcast_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAI_Broadcast_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TAI_Broadcast_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TAI_Broadcast_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAI_Broadcast_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_Broadcast_Item_iE_Extensions__item__id._const_tab = ____TAI_Broadcast_Item_iE_Extensions__item__id_tab
    ___TAI_Broadcast_Item_iE_Extensions__item__id._const_tab_at = None
    ___TAI_Broadcast_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___TAI_Broadcast_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TAI_Broadcast_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAI_Broadcast_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_Broadcast_Item_iE_Extensions__item__criticality._const_tab = ____TAI_Broadcast_Item_iE_Extensions__item__criticality_tab
    ___TAI_Broadcast_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TAI_Broadcast_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TAI_Broadcast_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TAI_Broadcast_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAI_Broadcast_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab = ____TAI_Broadcast_Item_iE_Extensions__item__extensionValue_tab
    ___TAI_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TAI_Broadcast_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TAI_Broadcast_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TAI_Broadcast_Item_iE_Extensions__item__id),
        (u'criticality', ___TAI_Broadcast_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___TAI_Broadcast_Item_iE_Extensions__item__extensionValue),
        ])
    __TAI_Broadcast_Item_iE_Extensions__item_._ext = None
    _TAI_Broadcast_Item_iE_Extensions._cont = __TAI_Broadcast_Item_iE_Extensions__item_
    _TAI_Broadcast_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAI_Broadcast_Item._cont = ASN1Dict([
        (u'tAI', _TAI_Broadcast_Item_tAI),
        (u'completedCellinTAI', _TAI_Broadcast_Item_completedCellinTAI),
        (u'iE-Extensions', _TAI_Broadcast_Item_iE_Extensions),
        ])
    TAI_Broadcast_Item._ext = []
    
    #-----< TAI-Broadcast-Item-ExtIEs >-----#
    TAI_Broadcast_Item_ExtIEs = CLASS(name=u'TAI-Broadcast-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TAI_Broadcast_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAI-Cancelled >-----#
    TAI_Cancelled = SEQ_OF(name=u'TAI-Cancelled', mode=MODE_TYPE)
    _TAI_Cancelled__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI-Cancelled-Item')))
    TAI_Cancelled._cont = _TAI_Cancelled__item_
    TAI_Cancelled._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< TAI-Cancelled-Item >-----#
    TAI_Cancelled_Item = SEQ(name=u'TAI-Cancelled-Item', mode=MODE_TYPE)
    _TAI_Cancelled_Item_tAI = SEQ(name=u'tAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _TAI_Cancelled_Item_cancelledCellinTAI = SEQ_OF(name=u'cancelledCellinTAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CancelledCellinTAI')))
    _TAI_Cancelled_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAI_Cancelled_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TAI_Cancelled_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TAI_Cancelled_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAI_Cancelled_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_Cancelled_Item_iE_Extensions__item__id._const_tab = ____TAI_Cancelled_Item_iE_Extensions__item__id_tab
    ___TAI_Cancelled_Item_iE_Extensions__item__id._const_tab_at = None
    ___TAI_Cancelled_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___TAI_Cancelled_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TAI_Cancelled_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAI_Cancelled_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_Cancelled_Item_iE_Extensions__item__criticality._const_tab = ____TAI_Cancelled_Item_iE_Extensions__item__criticality_tab
    ___TAI_Cancelled_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TAI_Cancelled_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TAI_Cancelled_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TAI_Cancelled_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAI_Cancelled_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab = ____TAI_Cancelled_Item_iE_Extensions__item__extensionValue_tab
    ___TAI_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TAI_Cancelled_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TAI_Cancelled_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TAI_Cancelled_Item_iE_Extensions__item__id),
        (u'criticality', ___TAI_Cancelled_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___TAI_Cancelled_Item_iE_Extensions__item__extensionValue),
        ])
    __TAI_Cancelled_Item_iE_Extensions__item_._ext = None
    _TAI_Cancelled_Item_iE_Extensions._cont = __TAI_Cancelled_Item_iE_Extensions__item_
    _TAI_Cancelled_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAI_Cancelled_Item._cont = ASN1Dict([
        (u'tAI', _TAI_Cancelled_Item_tAI),
        (u'cancelledCellinTAI', _TAI_Cancelled_Item_cancelledCellinTAI),
        (u'iE-Extensions', _TAI_Cancelled_Item_iE_Extensions),
        ])
    TAI_Cancelled_Item._ext = []
    
    #-----< TAI-Cancelled-Item-ExtIEs >-----#
    TAI_Cancelled_Item_ExtIEs = CLASS(name=u'TAI-Cancelled-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TAI_Cancelled_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TABasedMDT >-----#
    TABasedMDT = SEQ(name=u'TABasedMDT', mode=MODE_TYPE)
    _TABasedMDT_tAListforMDT = SEQ_OF(name=u'tAListforMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAListforMDT')))
    _TABasedMDT_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TABasedMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TABasedMDT_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TABasedMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TABasedMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedMDT_iE_Extensions__item__id._const_tab = ____TABasedMDT_iE_Extensions__item__id_tab
    ___TABasedMDT_iE_Extensions__item__id._const_tab_at = None
    ___TABasedMDT_iE_Extensions__item__id._const_tab_id = u'id'
    ___TABasedMDT_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TABasedMDT_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TABasedMDT_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedMDT_iE_Extensions__item__criticality._const_tab = ____TABasedMDT_iE_Extensions__item__criticality_tab
    ___TABasedMDT_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TABasedMDT_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TABasedMDT_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TABasedMDT_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TABasedMDT_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedMDT_iE_Extensions__item__extensionValue._const_tab = ____TABasedMDT_iE_Extensions__item__extensionValue_tab
    ___TABasedMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TABasedMDT_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TABasedMDT_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TABasedMDT_iE_Extensions__item__id),
        (u'criticality', ___TABasedMDT_iE_Extensions__item__criticality),
        (u'extensionValue', ___TABasedMDT_iE_Extensions__item__extensionValue),
        ])
    __TABasedMDT_iE_Extensions__item_._ext = None
    _TABasedMDT_iE_Extensions._cont = __TABasedMDT_iE_Extensions__item_
    _TABasedMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TABasedMDT._cont = ASN1Dict([
        (u'tAListforMDT', _TABasedMDT_tAListforMDT),
        (u'iE-Extensions', _TABasedMDT_iE_Extensions),
        ])
    TABasedMDT._ext = []
    
    #-----< TABasedMDT-ExtIEs >-----#
    TABasedMDT_ExtIEs = CLASS(name=u'TABasedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TABasedMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAListforMDT >-----#
    TAListforMDT = SEQ_OF(name=u'TAListforMDT', mode=MODE_TYPE)
    _TAListforMDT__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAC')))
    TAListforMDT._cont = _TAListforMDT__item_
    TAListforMDT._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TABasedQMC >-----#
    TABasedQMC = SEQ(name=u'TABasedQMC', mode=MODE_TYPE)
    _TABasedQMC_tAListforQMC = SEQ_OF(name=u'tAListforQMC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAListforQMC')))
    _TABasedQMC_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TABasedQMC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TABasedQMC_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TABasedQMC_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TABasedQMC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedQMC_iE_Extensions__item__id._const_tab = ____TABasedQMC_iE_Extensions__item__id_tab
    ___TABasedQMC_iE_Extensions__item__id._const_tab_at = None
    ___TABasedQMC_iE_Extensions__item__id._const_tab_id = u'id'
    ___TABasedQMC_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TABasedQMC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TABasedQMC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedQMC_iE_Extensions__item__criticality._const_tab = ____TABasedQMC_iE_Extensions__item__criticality_tab
    ___TABasedQMC_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TABasedQMC_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TABasedQMC_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TABasedQMC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TABasedQMC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TABasedQMC_iE_Extensions__item__extensionValue._const_tab = ____TABasedQMC_iE_Extensions__item__extensionValue_tab
    ___TABasedQMC_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TABasedQMC_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TABasedQMC_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TABasedQMC_iE_Extensions__item__id),
        (u'criticality', ___TABasedQMC_iE_Extensions__item__criticality),
        (u'extensionValue', ___TABasedQMC_iE_Extensions__item__extensionValue),
        ])
    __TABasedQMC_iE_Extensions__item_._ext = None
    _TABasedQMC_iE_Extensions._cont = __TABasedQMC_iE_Extensions__item_
    _TABasedQMC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TABasedQMC._cont = ASN1Dict([
        (u'tAListforQMC', _TABasedQMC_tAListforQMC),
        (u'iE-Extensions', _TABasedQMC_iE_Extensions),
        ])
    TABasedQMC._ext = []
    
    #-----< TABasedQMC-ExtIEs >-----#
    TABasedQMC_ExtIEs = CLASS(name=u'TABasedQMC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TABasedQMC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAListforQMC >-----#
    TAListforQMC = SEQ_OF(name=u'TAListforQMC', mode=MODE_TYPE)
    _TAListforQMC__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAC')))
    TAListforQMC._cont = _TAListforQMC__item_
    TAListforQMC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TAIBasedQMC >-----#
    TAIBasedQMC = SEQ(name=u'TAIBasedQMC', mode=MODE_TYPE)
    _TAIBasedQMC_tAIListforQMC = SEQ_OF(name=u'tAIListforQMC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAIListforQMC')))
    _TAIBasedQMC_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAIBasedQMC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TAIBasedQMC_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TAIBasedQMC_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAIBasedQMC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedQMC_iE_Extensions__item__id._const_tab = ____TAIBasedQMC_iE_Extensions__item__id_tab
    ___TAIBasedQMC_iE_Extensions__item__id._const_tab_at = None
    ___TAIBasedQMC_iE_Extensions__item__id._const_tab_id = u'id'
    ___TAIBasedQMC_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TAIBasedQMC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAIBasedQMC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedQMC_iE_Extensions__item__criticality._const_tab = ____TAIBasedQMC_iE_Extensions__item__criticality_tab
    ___TAIBasedQMC_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TAIBasedQMC_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TAIBasedQMC_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TAIBasedQMC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAIBasedQMC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIBasedQMC_iE_Extensions__item__extensionValue._const_tab = ____TAIBasedQMC_iE_Extensions__item__extensionValue_tab
    ___TAIBasedQMC_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TAIBasedQMC_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TAIBasedQMC_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TAIBasedQMC_iE_Extensions__item__id),
        (u'criticality', ___TAIBasedQMC_iE_Extensions__item__criticality),
        (u'extensionValue', ___TAIBasedQMC_iE_Extensions__item__extensionValue),
        ])
    __TAIBasedQMC_iE_Extensions__item_._ext = None
    _TAIBasedQMC_iE_Extensions._cont = __TAIBasedQMC_iE_Extensions__item_
    _TAIBasedQMC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAIBasedQMC._cont = ASN1Dict([
        (u'tAIListforQMC', _TAIBasedQMC_tAIListforQMC),
        (u'iE-Extensions', _TAIBasedQMC_iE_Extensions),
        ])
    TAIBasedQMC._ext = []
    
    #-----< TAIBasedQMC-ExtIEs >-----#
    TAIBasedQMC_ExtIEs = CLASS(name=u'TAIBasedQMC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TAIBasedQMC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TAIListforQMC >-----#
    TAIListforQMC = SEQ_OF(name=u'TAIListforQMC', mode=MODE_TYPE)
    _TAIListforQMC__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    TAIListforQMC._cont = _TAIListforQMC__item_
    TAIListforQMC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< CompletedCellinTAI >-----#
    CompletedCellinTAI = SEQ_OF(name=u'CompletedCellinTAI', mode=MODE_TYPE)
    _CompletedCellinTAI__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CompletedCellinTAI-Item')))
    CompletedCellinTAI._cont = _CompletedCellinTAI__item_
    CompletedCellinTAI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    
    #-----< CompletedCellinTAI-Item >-----#
    CompletedCellinTAI_Item = SEQ(name=u'CompletedCellinTAI-Item', mode=MODE_TYPE)
    _CompletedCellinTAI_Item_eCGI = SEQ(name=u'eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _CompletedCellinTAI_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompletedCellinTAI_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CompletedCellinTAI_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CompletedCellinTAI_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CompletedCellinTAI_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellinTAI_Item_iE_Extensions__item__id._const_tab = ____CompletedCellinTAI_Item_iE_Extensions__item__id_tab
    ___CompletedCellinTAI_Item_iE_Extensions__item__id._const_tab_at = None
    ___CompletedCellinTAI_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CompletedCellinTAI_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CompletedCellinTAI_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CompletedCellinTAI_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellinTAI_Item_iE_Extensions__item__criticality._const_tab = ____CompletedCellinTAI_Item_iE_Extensions__item__criticality_tab
    ___CompletedCellinTAI_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CompletedCellinTAI_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CompletedCellinTAI_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CompletedCellinTAI_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CompletedCellinTAI_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompletedCellinTAI_Item_iE_Extensions__item__extensionValue._const_tab = ____CompletedCellinTAI_Item_iE_Extensions__item__extensionValue_tab
    ___CompletedCellinTAI_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CompletedCellinTAI_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CompletedCellinTAI_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CompletedCellinTAI_Item_iE_Extensions__item__id),
        (u'criticality', ___CompletedCellinTAI_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CompletedCellinTAI_Item_iE_Extensions__item__extensionValue),
        ])
    __CompletedCellinTAI_Item_iE_Extensions__item_._ext = None
    _CompletedCellinTAI_Item_iE_Extensions._cont = __CompletedCellinTAI_Item_iE_Extensions__item_
    _CompletedCellinTAI_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompletedCellinTAI_Item._cont = ASN1Dict([
        (u'eCGI', _CompletedCellinTAI_Item_eCGI),
        (u'iE-Extensions', _CompletedCellinTAI_Item_iE_Extensions),
        ])
    CompletedCellinTAI_Item._ext = []
    
    #-----< CompletedCellinTAI-Item-ExtIEs >-----#
    CompletedCellinTAI_Item_ExtIEs = CLASS(name=u'CompletedCellinTAI-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CompletedCellinTAI_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TBCD-STRING >-----#
    TBCD_STRING = OCT_STR(name=u'TBCD-STRING', mode=MODE_TYPE)
    TBCD_STRING._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< TargetID >-----#
    TargetID = CHOICE(name=u'TargetID', mode=MODE_TYPE)
    _TargetID_targeteNB_ID = SEQ(name=u'targeteNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TargeteNB-ID')))
    _TargetID_targetRNC_ID = SEQ(name=u'targetRNC-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TargetRNC-ID')))
    _TargetID_cGI = SEQ(name=u'cGI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CGI')))
    _TargetID_targetgNgRanNode_ID = SEQ(name=u'targetgNgRanNode-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TargetNgRanNode-ID')))
    TargetID._cont = ASN1Dict([
        (u'targeteNB-ID', _TargetID_targeteNB_ID),
        (u'targetRNC-ID', _TargetID_targetRNC_ID),
        (u'cGI', _TargetID_cGI),
        (u'targetgNgRanNode-ID', _TargetID_targetgNgRanNode_ID),
        ])
    TargetID._ext = [u'targetgNgRanNode-ID']
    
    #-----< TargeteNB-ID >-----#
    TargeteNB_ID = SEQ(name=u'TargeteNB-ID', mode=MODE_TYPE)
    _TargeteNB_ID_global_ENB_ID = SEQ(name=u'global-ENB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    _TargeteNB_ID_selected_TAI = SEQ(name=u'selected-TAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _TargeteNB_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargeteNB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TargeteNB_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TargeteNB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TargeteNB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargeteNB_ID_iE_Extensions__item__id._const_tab = ____TargeteNB_ID_iE_Extensions__item__id_tab
    ___TargeteNB_ID_iE_Extensions__item__id._const_tab_at = None
    ___TargeteNB_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___TargeteNB_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TargeteNB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TargeteNB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargeteNB_ID_iE_Extensions__item__criticality._const_tab = ____TargeteNB_ID_iE_Extensions__item__criticality_tab
    ___TargeteNB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TargeteNB_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TargeteNB_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TargeteNB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TargeteNB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargeteNB_ID_iE_Extensions__item__extensionValue._const_tab = ____TargeteNB_ID_iE_Extensions__item__extensionValue_tab
    ___TargeteNB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TargeteNB_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TargeteNB_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TargeteNB_ID_iE_Extensions__item__id),
        (u'criticality', ___TargeteNB_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___TargeteNB_ID_iE_Extensions__item__extensionValue),
        ])
    __TargeteNB_ID_iE_Extensions__item_._ext = None
    _TargeteNB_ID_iE_Extensions._cont = __TargeteNB_ID_iE_Extensions__item_
    _TargeteNB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargeteNB_ID._cont = ASN1Dict([
        (u'global-ENB-ID', _TargeteNB_ID_global_ENB_ID),
        (u'selected-TAI', _TargeteNB_ID_selected_TAI),
        (u'iE-Extensions', _TargeteNB_ID_iE_Extensions),
        ])
    TargeteNB_ID._ext = []
    
    #-----< TargeteNB-ID-ExtIEs >-----#
    TargeteNB_ID_ExtIEs = CLASS(name=u'TargeteNB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TargeteNB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TargetRNC-ID >-----#
    TargetRNC_ID = SEQ(name=u'TargetRNC-ID', mode=MODE_TYPE)
    _TargetRNC_ID_lAI = SEQ(name=u'lAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'LAI')))
    _TargetRNC_ID_rAC = OCT_STR(name=u'rAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RAC')), opt=True)
    _TargetRNC_ID_rNC_ID = INT(name=u'rNC-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RNC-ID')))
    _TargetRNC_ID_extendedRNC_ID = INT(name=u'extendedRNC-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ExtendedRNC-ID')), opt=True)
    _TargetRNC_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetRNC_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TargetRNC_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TargetRNC_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TargetRNC_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetRNC_ID_iE_Extensions__item__id._const_tab = ____TargetRNC_ID_iE_Extensions__item__id_tab
    ___TargetRNC_ID_iE_Extensions__item__id._const_tab_at = None
    ___TargetRNC_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___TargetRNC_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TargetRNC_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TargetRNC_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetRNC_ID_iE_Extensions__item__criticality._const_tab = ____TargetRNC_ID_iE_Extensions__item__criticality_tab
    ___TargetRNC_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TargetRNC_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TargetRNC_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TargetRNC_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TargetRNC_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetRNC_ID_iE_Extensions__item__extensionValue._const_tab = ____TargetRNC_ID_iE_Extensions__item__extensionValue_tab
    ___TargetRNC_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TargetRNC_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TargetRNC_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TargetRNC_ID_iE_Extensions__item__id),
        (u'criticality', ___TargetRNC_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___TargetRNC_ID_iE_Extensions__item__extensionValue),
        ])
    __TargetRNC_ID_iE_Extensions__item_._ext = None
    _TargetRNC_ID_iE_Extensions._cont = __TargetRNC_ID_iE_Extensions__item_
    _TargetRNC_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetRNC_ID._cont = ASN1Dict([
        (u'lAI', _TargetRNC_ID_lAI),
        (u'rAC', _TargetRNC_ID_rAC),
        (u'rNC-ID', _TargetRNC_ID_rNC_ID),
        (u'extendedRNC-ID', _TargetRNC_ID_extendedRNC_ID),
        (u'iE-Extensions', _TargetRNC_ID_iE_Extensions),
        ])
    TargetRNC_ID._ext = []
    
    #-----< TargetRNC-ID-ExtIEs >-----#
    TargetRNC_ID_ExtIEs = CLASS(name=u'TargetRNC-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TargetRNC_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TargetNgRanNode-ID >-----#
    TargetNgRanNode_ID = SEQ(name=u'TargetNgRanNode-ID', mode=MODE_TYPE)
    _TargetNgRanNode_ID_global_RAN_NODE_ID = CHOICE(name=u'global-RAN-NODE-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Global-RAN-NODE-ID')))
    _TargetNgRanNode_ID_selected_TAI = SEQ(name=u'selected-TAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'FiveGSTAI')))
    _TargetNgRanNode_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetNgRanNode_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TargetNgRanNode_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TargetNgRanNode_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TargetNgRanNode_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetNgRanNode_ID_iE_Extensions__item__id._const_tab = ____TargetNgRanNode_ID_iE_Extensions__item__id_tab
    ___TargetNgRanNode_ID_iE_Extensions__item__id._const_tab_at = None
    ___TargetNgRanNode_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___TargetNgRanNode_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TargetNgRanNode_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TargetNgRanNode_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetNgRanNode_ID_iE_Extensions__item__criticality._const_tab = ____TargetNgRanNode_ID_iE_Extensions__item__criticality_tab
    ___TargetNgRanNode_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TargetNgRanNode_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TargetNgRanNode_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TargetNgRanNode_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TargetNgRanNode_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetNgRanNode_ID_iE_Extensions__item__extensionValue._const_tab = ____TargetNgRanNode_ID_iE_Extensions__item__extensionValue_tab
    ___TargetNgRanNode_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TargetNgRanNode_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TargetNgRanNode_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TargetNgRanNode_ID_iE_Extensions__item__id),
        (u'criticality', ___TargetNgRanNode_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___TargetNgRanNode_ID_iE_Extensions__item__extensionValue),
        ])
    __TargetNgRanNode_ID_iE_Extensions__item_._ext = None
    _TargetNgRanNode_ID_iE_Extensions._cont = __TargetNgRanNode_ID_iE_Extensions__item_
    _TargetNgRanNode_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetNgRanNode_ID._cont = ASN1Dict([
        (u'global-RAN-NODE-ID', _TargetNgRanNode_ID_global_RAN_NODE_ID),
        (u'selected-TAI', _TargetNgRanNode_ID_selected_TAI),
        (u'iE-Extensions', _TargetNgRanNode_ID_iE_Extensions),
        ])
    TargetNgRanNode_ID._ext = []
    
    #-----< TargetNgRanNode-ID-ExtIEs >-----#
    TargetNgRanNode_ID_ExtIEs = CLASS(name=u'TargetNgRanNode-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TargetNgRanNode_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Global-RAN-NODE-ID >-----#
    Global_RAN_NODE_ID = CHOICE(name=u'Global-RAN-NODE-ID', mode=MODE_TYPE)
    _Global_RAN_NODE_ID_gNB = SEQ(name=u'gNB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GNB')))
    _Global_RAN_NODE_ID_ng_eNB = SEQ(name=u'ng-eNB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NG-eNB')))
    Global_RAN_NODE_ID._cont = ASN1Dict([
        (u'gNB', _Global_RAN_NODE_ID_gNB),
        (u'ng-eNB', _Global_RAN_NODE_ID_ng_eNB),
        ])
    Global_RAN_NODE_ID._ext = []
    
    #-----< GNB >-----#
    GNB = SEQ(name=u'GNB', mode=MODE_TYPE)
    _GNB_global_gNB_ID = SEQ(name=u'global-gNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Global-GNB-ID')))
    _GNB_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GNB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___GNB_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____GNB_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____GNB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_iE_Extensions__item__id._const_tab = ____GNB_iE_Extensions__item__id_tab
    ___GNB_iE_Extensions__item__id._const_tab_at = None
    ___GNB_iE_Extensions__item__id._const_tab_id = u'id'
    ___GNB_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GNB_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____GNB_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_iE_Extensions__item__criticality._const_tab = ____GNB_iE_Extensions__item__criticality_tab
    ___GNB_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GNB_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GNB_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GNB_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____GNB_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GNB_iE_Extensions__item__extensionValue._const_tab = ____GNB_iE_Extensions__item__extensionValue_tab
    ___GNB_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GNB_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GNB_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GNB_iE_Extensions__item__id),
        (u'criticality', ___GNB_iE_Extensions__item__criticality),
        (u'extensionValue', ___GNB_iE_Extensions__item__extensionValue),
        ])
    __GNB_iE_Extensions__item_._ext = None
    _GNB_iE_Extensions._cont = __GNB_iE_Extensions__item_
    _GNB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GNB._cont = ASN1Dict([
        (u'global-gNB-ID', _GNB_global_gNB_ID),
        (u'iE-Extensions', _GNB_iE_Extensions),
        ])
    GNB._ext = []
    
    #-----< GNB-ExtIEs >-----#
    GNB_ExtIEs = CLASS(name=u'GNB-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    GNB_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Global-GNB-ID >-----#
    Global_GNB_ID = SEQ(name=u'Global-GNB-ID', mode=MODE_TYPE)
    _Global_GNB_ID_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')))
    _Global_GNB_ID_gNB_ID = CHOICE(name=u'gNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GNB-Identity')))
    _Global_GNB_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Global_GNB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___Global_GNB_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____Global_GNB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Global_GNB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Global_GNB_ID_iE_Extensions__item__id._const_tab = ____Global_GNB_ID_iE_Extensions__item__id_tab
    ___Global_GNB_ID_iE_Extensions__item__id._const_tab_at = None
    ___Global_GNB_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___Global_GNB_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Global_GNB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Global_GNB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Global_GNB_ID_iE_Extensions__item__criticality._const_tab = ____Global_GNB_ID_iE_Extensions__item__criticality_tab
    ___Global_GNB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Global_GNB_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Global_GNB_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Global_GNB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____Global_GNB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Global_GNB_ID_iE_Extensions__item__extensionValue._const_tab = ____Global_GNB_ID_iE_Extensions__item__extensionValue_tab
    ___Global_GNB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Global_GNB_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Global_GNB_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Global_GNB_ID_iE_Extensions__item__id),
        (u'criticality', ___Global_GNB_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___Global_GNB_ID_iE_Extensions__item__extensionValue),
        ])
    __Global_GNB_ID_iE_Extensions__item_._ext = None
    _Global_GNB_ID_iE_Extensions._cont = __Global_GNB_ID_iE_Extensions__item_
    _Global_GNB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Global_GNB_ID._cont = ASN1Dict([
        (u'pLMN-Identity', _Global_GNB_ID_pLMN_Identity),
        (u'gNB-ID', _Global_GNB_ID_gNB_ID),
        (u'iE-Extensions', _Global_GNB_ID_iE_Extensions),
        ])
    Global_GNB_ID._ext = []
    
    #-----< Global-GNB-ID-ExtIEs >-----#
    Global_GNB_ID_ExtIEs = CLASS(name=u'Global-GNB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    Global_GNB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-Identity >-----#
    GNB_Identity = CHOICE(name=u'GNB-Identity', mode=MODE_TYPE)
    _GNB_Identity_gNB_ID = BIT_STR(name=u'gNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GNB-ID')))
    GNB_Identity._cont = ASN1Dict([
        (u'gNB-ID', _GNB_Identity_gNB_ID),
        ])
    GNB_Identity._ext = []
    
    #-----< NG-eNB >-----#
    NG_eNB = SEQ(name=u'NG-eNB', mode=MODE_TYPE)
    _NG_eNB_global_ng_eNB_ID = SEQ(name=u'global-ng-eNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    _NG_eNB_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NG_eNB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___NG_eNB_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____NG_eNB_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NG_eNB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NG_eNB_iE_Extensions__item__id._const_tab = ____NG_eNB_iE_Extensions__item__id_tab
    ___NG_eNB_iE_Extensions__item__id._const_tab_at = None
    ___NG_eNB_iE_Extensions__item__id._const_tab_id = u'id'
    ___NG_eNB_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NG_eNB_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NG_eNB_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NG_eNB_iE_Extensions__item__criticality._const_tab = ____NG_eNB_iE_Extensions__item__criticality_tab
    ___NG_eNB_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NG_eNB_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NG_eNB_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NG_eNB_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____NG_eNB_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NG_eNB_iE_Extensions__item__extensionValue._const_tab = ____NG_eNB_iE_Extensions__item__extensionValue_tab
    ___NG_eNB_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NG_eNB_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NG_eNB_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NG_eNB_iE_Extensions__item__id),
        (u'criticality', ___NG_eNB_iE_Extensions__item__criticality),
        (u'extensionValue', ___NG_eNB_iE_Extensions__item__extensionValue),
        ])
    __NG_eNB_iE_Extensions__item_._ext = None
    _NG_eNB_iE_Extensions._cont = __NG_eNB_iE_Extensions__item_
    _NG_eNB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NG_eNB._cont = ASN1Dict([
        (u'global-ng-eNB-ID', _NG_eNB_global_ng_eNB_ID),
        (u'iE-Extensions', _NG_eNB_iE_Extensions),
        ])
    NG_eNB._ext = []
    
    #-----< NG-eNB-ExtIEs >-----#
    NG_eNB_ExtIEs = CLASS(name=u'NG-eNB-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    NG_eNB_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GNB-ID >-----#
    GNB_ID = BIT_STR(name=u'GNB-ID', mode=MODE_TYPE)
    GNB_ID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=22, ub=32)], ev=None, er=[])
    
    #-----< TargeteNB-ToSourceeNB-TransparentContainer >-----#
    TargeteNB_ToSourceeNB_TransparentContainer = SEQ(name=u'TargeteNB-ToSourceeNB-TransparentContainer', mode=MODE_TYPE)
    _TargeteNB_ToSourceeNB_TransparentContainer_rRC_Container = OCT_STR(name=u'rRC-Container', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RRC-Container')))
    _TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DAPSResponseInfoList')))
    _____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Direct-Forwarding-Path-Availability')))
    ____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 318), (u'criticality', u'ignore'), (u'Extension', _____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 79), (u'criticality', u'ignore'), (u'Extension', _____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id._const_tab = ____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id._const_tab_id = u'id'
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id),
        (u'criticality', ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__criticality),
        (u'extensionValue', ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item_._ext = None
    _TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions._cont = __TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item_
    _TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargeteNB_ToSourceeNB_TransparentContainer._cont = ASN1Dict([
        (u'rRC-Container', _TargeteNB_ToSourceeNB_TransparentContainer_rRC_Container),
        (u'iE-Extensions', _TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions),
        ])
    TargeteNB_ToSourceeNB_TransparentContainer._ext = []
    
    #-----< TargeteNB-ToSourceeNB-TransparentContainer-ExtIEs >-----#
    TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs = CLASS(name=u'TargeteNB-ToSourceeNB-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DAPSResponseInfoList')))
    _TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Direct-Forwarding-Path-Availability')))
    TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 318), (u'criticality', u'ignore'), (u'Extension', _TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 79), (u'criticality', u'ignore'), (u'Extension', _TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Target-ToSource-TransparentContainer >-----#
    Target_ToSource_TransparentContainer = OCT_STR(name=u'Target-ToSource-TransparentContainer', mode=MODE_TYPE)
    
    #-----< TargetRNC-ToSourceRNC-TransparentContainer >-----#
    TargetRNC_ToSourceRNC_TransparentContainer = OCT_STR(name=u'TargetRNC-ToSourceRNC-TransparentContainer', mode=MODE_TYPE)
    
    #-----< TargetBSS-ToSourceBSS-TransparentContainer >-----#
    TargetBSS_ToSourceBSS_TransparentContainer = OCT_STR(name=u'TargetBSS-ToSourceBSS-TransparentContainer', mode=MODE_TYPE)
    
    #-----< TargetNgRanNode-ToSourceNgRanNode-TransparentContainer >-----#
    TargetNgRanNode_ToSourceNgRanNode_TransparentContainer = OCT_STR(name=u'TargetNgRanNode-ToSourceNgRanNode-TransparentContainer', mode=MODE_TYPE)
    
    #-----< M1ThresholdEventA2 >-----#
    M1ThresholdEventA2 = SEQ(name=u'M1ThresholdEventA2', mode=MODE_TYPE)
    _M1ThresholdEventA2_measurementThreshold = CHOICE(name=u'measurementThreshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MeasurementThresholdA2')))
    _M1ThresholdEventA2_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M1ThresholdEventA2_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___M1ThresholdEventA2_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____M1ThresholdEventA2_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M1ThresholdEventA2_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1ThresholdEventA2_iE_Extensions__item__id._const_tab = ____M1ThresholdEventA2_iE_Extensions__item__id_tab
    ___M1ThresholdEventA2_iE_Extensions__item__id._const_tab_at = None
    ___M1ThresholdEventA2_iE_Extensions__item__id._const_tab_id = u'id'
    ___M1ThresholdEventA2_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____M1ThresholdEventA2_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M1ThresholdEventA2_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1ThresholdEventA2_iE_Extensions__item__criticality._const_tab = ____M1ThresholdEventA2_iE_Extensions__item__criticality_tab
    ___M1ThresholdEventA2_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___M1ThresholdEventA2_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____M1ThresholdEventA2_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____M1ThresholdEventA2_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue._const_tab = ____M1ThresholdEventA2_iE_Extensions__item__extensionValue_tab
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___M1ThresholdEventA2_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __M1ThresholdEventA2_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___M1ThresholdEventA2_iE_Extensions__item__id),
        (u'criticality', ___M1ThresholdEventA2_iE_Extensions__item__criticality),
        (u'extensionValue', ___M1ThresholdEventA2_iE_Extensions__item__extensionValue),
        ])
    __M1ThresholdEventA2_iE_Extensions__item_._ext = None
    _M1ThresholdEventA2_iE_Extensions._cont = __M1ThresholdEventA2_iE_Extensions__item_
    _M1ThresholdEventA2_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M1ThresholdEventA2._cont = ASN1Dict([
        (u'measurementThreshold', _M1ThresholdEventA2_measurementThreshold),
        (u'iE-Extensions', _M1ThresholdEventA2_iE_Extensions),
        ])
    M1ThresholdEventA2._ext = []
    
    #-----< M1ThresholdEventA2-ExtIEs >-----#
    M1ThresholdEventA2_ExtIEs = CLASS(name=u'M1ThresholdEventA2-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    M1ThresholdEventA2_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Threshold-RSRP >-----#
    Threshold_RSRP = INT(name=u'Threshold-RSRP', mode=MODE_TYPE)
    Threshold_RSRP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=97)], ev=None, er=[])
    
    #-----< Threshold-RSRQ >-----#
    Threshold_RSRQ = INT(name=u'Threshold-RSRQ', mode=MODE_TYPE)
    Threshold_RSRQ._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=34)], ev=None, er=[])
    
    #-----< TimeToWait >-----#
    TimeToWait = ENUM(name=u'TimeToWait', mode=MODE_TYPE)
    TimeToWait._cont = ASN1Dict([(u'v1s', 0), (u'v2s', 1), (u'v5s', 2), (u'v10s', 3), (u'v20s', 4), (u'v60s', 5)])
    TimeToWait._ext = []
    
    #-----< Time-UE-StayedInCell >-----#
    Time_UE_StayedInCell = INT(name=u'Time-UE-StayedInCell', mode=MODE_TYPE)
    Time_UE_StayedInCell._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< Time-UE-StayedInCell-EnhancedGranularity >-----#
    Time_UE_StayedInCell_EnhancedGranularity = INT(name=u'Time-UE-StayedInCell-EnhancedGranularity', mode=MODE_TYPE)
    Time_UE_StayedInCell_EnhancedGranularity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=40950)], ev=None, er=[])
    
    #-----< TimeSinceSecondaryNodeRelease >-----#
    TimeSinceSecondaryNodeRelease = OCT_STR(name=u'TimeSinceSecondaryNodeRelease', mode=MODE_TYPE)
    TimeSinceSecondaryNodeRelease._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< TransportInformation >-----#
    TransportInformation = SEQ(name=u'TransportInformation', mode=MODE_TYPE)
    _TransportInformation_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _TransportInformation_uL_GTP_TEID = OCT_STR(name=u'uL-GTP-TEID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    TransportInformation._cont = ASN1Dict([
        (u'transportLayerAddress', _TransportInformation_transportLayerAddress),
        (u'uL-GTP-TEID', _TransportInformation_uL_GTP_TEID),
        ])
    TransportInformation._ext = []
    
    #-----< TransportLayerAddress >-----#
    TransportLayerAddress = BIT_STR(name=u'TransportLayerAddress', mode=MODE_TYPE)
    TransportLayerAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=[], er=[])
    
    #-----< TraceActivation >-----#
    TraceActivation = SEQ(name=u'TraceActivation', mode=MODE_TYPE)
    _TraceActivation_e_UTRAN_Trace_ID = OCT_STR(name=u'e-UTRAN-Trace-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-UTRAN-Trace-ID')))
    _TraceActivation_interfacesToTrace = BIT_STR(name=u'interfacesToTrace', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'InterfacesToTrace')))
    _TraceActivation_traceDepth = ENUM(name=u'traceDepth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TraceDepth')))
    _TraceActivation_traceCollectionEntityIPAddress = BIT_STR(name=u'traceCollectionEntityIPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _TraceActivation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TraceActivation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TraceActivation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TraceActivation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDT-Configuration')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAppLayerMeasConfig')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_2 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDT-ConfigurationNR')))
    _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_3 = STR_VIS(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'URI-Address')))
    ____TraceActivation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 162), (u'criticality', u'ignore'), (u'Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 262), (u'criticality', u'ignore'), (u'Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 316), (u'criticality', u'ignore'), (u'Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 325), (u'criticality', u'ignore'), (u'Extension', _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TraceActivation_iE_Extensions__item__id._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__id._const_tab_at = None
    ___TraceActivation_iE_Extensions__item__id._const_tab_id = u'id'
    ___TraceActivation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TraceActivation_iE_Extensions__item__criticality._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TraceActivation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TraceActivation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab = ____TraceActivation_iE_Extensions__item__id_tab
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TraceActivation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TraceActivation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TraceActivation_iE_Extensions__item__id),
        (u'criticality', ___TraceActivation_iE_Extensions__item__criticality),
        (u'extensionValue', ___TraceActivation_iE_Extensions__item__extensionValue),
        ])
    __TraceActivation_iE_Extensions__item_._ext = None
    _TraceActivation_iE_Extensions._cont = __TraceActivation_iE_Extensions__item_
    _TraceActivation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TraceActivation._cont = ASN1Dict([
        (u'e-UTRAN-Trace-ID', _TraceActivation_e_UTRAN_Trace_ID),
        (u'interfacesToTrace', _TraceActivation_interfacesToTrace),
        (u'traceDepth', _TraceActivation_traceDepth),
        (u'traceCollectionEntityIPAddress', _TraceActivation_traceCollectionEntityIPAddress),
        (u'iE-Extensions', _TraceActivation_iE_Extensions),
        ])
    TraceActivation._ext = []
    
    #-----< TraceActivation-ExtIEs >-----#
    TraceActivation_ExtIEs = CLASS(name=u'TraceActivation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _TraceActivation_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDT-Configuration')))
    _TraceActivation_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAppLayerMeasConfig')))
    _TraceActivation_ExtIEs_val_Extension_2 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDT-ConfigurationNR')))
    _TraceActivation_ExtIEs_val_Extension_3 = STR_VIS(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'URI-Address')))
    TraceActivation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 162), (u'criticality', u'ignore'), (u'Extension', _TraceActivation_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 262), (u'criticality', u'ignore'), (u'Extension', _TraceActivation_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 316), (u'criticality', u'ignore'), (u'Extension', _TraceActivation_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 325), (u'criticality', u'ignore'), (u'Extension', _TraceActivation_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< TraceDepth >-----#
    TraceDepth = ENUM(name=u'TraceDepth', mode=MODE_TYPE)
    TraceDepth._cont = ASN1Dict([(u'minimum', 0), (u'medium', 1), (u'maximum', 2), (u'minimumWithoutVendorSpecificExtension', 3), (u'mediumWithoutVendorSpecificExtension', 4), (u'maximumWithoutVendorSpecificExtension', 5)])
    TraceDepth._ext = []
    
    #-----< E-UTRAN-Trace-ID >-----#
    E_UTRAN_Trace_ID = OCT_STR(name=u'E-UTRAN-Trace-ID', mode=MODE_TYPE)
    E_UTRAN_Trace_ID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< TrafficLoadReductionIndication >-----#
    TrafficLoadReductionIndication = INT(name=u'TrafficLoadReductionIndication', mode=MODE_TYPE)
    TrafficLoadReductionIndication._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=99)], ev=None, er=[])
    
    #-----< TunnelInformation >-----#
    TunnelInformation = SEQ(name=u'TunnelInformation', mode=MODE_TYPE)
    _TunnelInformation_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _TunnelInformation_uDP_Port_Number = OCT_STR(name=u'uDP-Port-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Port-Number')), opt=True)
    _TunnelInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TunnelInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TunnelInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TunnelInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TunnelInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TunnelInformation_iE_Extensions__item__id._const_tab = ____TunnelInformation_iE_Extensions__item__id_tab
    ___TunnelInformation_iE_Extensions__item__id._const_tab_at = None
    ___TunnelInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___TunnelInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TunnelInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TunnelInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TunnelInformation_iE_Extensions__item__criticality._const_tab = ____TunnelInformation_iE_Extensions__item__criticality_tab
    ___TunnelInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TunnelInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TunnelInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TunnelInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TunnelInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TunnelInformation_iE_Extensions__item__extensionValue._const_tab = ____TunnelInformation_iE_Extensions__item__extensionValue_tab
    ___TunnelInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TunnelInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TunnelInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TunnelInformation_iE_Extensions__item__id),
        (u'criticality', ___TunnelInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___TunnelInformation_iE_Extensions__item__extensionValue),
        ])
    __TunnelInformation_iE_Extensions__item_._ext = None
    _TunnelInformation_iE_Extensions._cont = __TunnelInformation_iE_Extensions__item_
    _TunnelInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TunnelInformation._cont = ASN1Dict([
        (u'transportLayerAddress', _TunnelInformation_transportLayerAddress),
        (u'uDP-Port-Number', _TunnelInformation_uDP_Port_Number),
        (u'iE-Extensions', _TunnelInformation_iE_Extensions),
        ])
    TunnelInformation._ext = []
    
    #-----< Tunnel-Information-ExtIEs >-----#
    Tunnel_Information_ExtIEs = CLASS(name=u'Tunnel-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    Tunnel_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TypeOfError >-----#
    TypeOfError = ENUM(name=u'TypeOfError', mode=MODE_TYPE)
    TypeOfError._cont = ASN1Dict([(u'not-understood', 0), (u'missing', 1)])
    TypeOfError._ext = []
    
    #-----< TAIListForRestart >-----#
    TAIListForRestart = SEQ_OF(name=u'TAIListForRestart', mode=MODE_TYPE)
    _TAIListForRestart__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    TAIListForRestart._cont = _TAIListForRestart__item_
    TAIListForRestart._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    
    #-----< UEAggregateMaximumBitrate >-----#
    UEAggregateMaximumBitrate = SEQ(name=u'UEAggregateMaximumBitrate', mode=MODE_TYPE)
    _UEAggregateMaximumBitrate_uEaggregateMaximumBitRateDL = INT(name=u'uEaggregateMaximumBitRateDL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')))
    _UEAggregateMaximumBitrate_uEaggregateMaximumBitRateUL = INT(name=u'uEaggregateMaximumBitRateUL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')))
    _UEAggregateMaximumBitrate_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEAggregateMaximumBitrate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___UEAggregateMaximumBitrate_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    _____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    ____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 259), (u'criticality', u'ignore'), (u'Extension', _____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 260), (u'criticality', u'ignore'), (u'Extension', _____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEAggregateMaximumBitrate_iE_Extensions__item__id._const_tab = ____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab
    ___UEAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_at = None
    ___UEAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEAggregateMaximumBitrate_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UEAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab = ____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab
    ___UEAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEAggregateMaximumBitrate_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UEAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab = ____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab
    ___UEAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEAggregateMaximumBitrate_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEAggregateMaximumBitrate_iE_Extensions__item__id),
        (u'criticality', ___UEAggregateMaximumBitrate_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEAggregateMaximumBitrate_iE_Extensions__item__extensionValue),
        ])
    __UEAggregateMaximumBitrate_iE_Extensions__item_._ext = None
    _UEAggregateMaximumBitrate_iE_Extensions._cont = __UEAggregateMaximumBitrate_iE_Extensions__item_
    _UEAggregateMaximumBitrate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEAggregateMaximumBitrate._cont = ASN1Dict([
        (u'uEaggregateMaximumBitRateDL', _UEAggregateMaximumBitrate_uEaggregateMaximumBitRateDL),
        (u'uEaggregateMaximumBitRateUL', _UEAggregateMaximumBitrate_uEaggregateMaximumBitRateUL),
        (u'iE-Extensions', _UEAggregateMaximumBitrate_iE_Extensions),
        ])
    UEAggregateMaximumBitrate._ext = []
    
    #-----< UEAggregate-MaximumBitrates-ExtIEs >-----#
    UEAggregate_MaximumBitrates_ExtIEs = CLASS(name=u'UEAggregate-MaximumBitrates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _UEAggregate_MaximumBitrates_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    _UEAggregate_MaximumBitrates_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedBitRate')))
    UEAggregate_MaximumBitrates_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 259), (u'criticality', u'ignore'), (u'Extension', _UEAggregate_MaximumBitrates_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 260), (u'criticality', u'ignore'), (u'Extension', _UEAggregate_MaximumBitrates_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEAppLayerMeasConfig >-----#
    UEAppLayerMeasConfig = SEQ(name=u'UEAppLayerMeasConfig', mode=MODE_TYPE)
    _UEAppLayerMeasConfig_containerForAppLayerMeasConfig = OCT_STR(name=u'containerForAppLayerMeasConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UEAppLayerMeasConfig_containerForAppLayerMeasConfig._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000)], ev=None, er=[])
    _UEAppLayerMeasConfig_areaScopeOfQMC = CHOICE(name=u'areaScopeOfQMC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'AreaScopeOfQMC')))
    _UEAppLayerMeasConfig_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEAppLayerMeasConfig_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___UEAppLayerMeasConfig_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEAppLayerMeasConfig_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____UEAppLayerMeasConfig_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServiceType')))
    ____UEAppLayerMeasConfig_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 276), (u'criticality', u'ignore'), (u'Extension', _____UEAppLayerMeasConfig_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEAppLayerMeasConfig_iE_Extensions__item__id._const_tab = ____UEAppLayerMeasConfig_iE_Extensions__item__id_tab
    ___UEAppLayerMeasConfig_iE_Extensions__item__id._const_tab_at = None
    ___UEAppLayerMeasConfig_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEAppLayerMeasConfig_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UEAppLayerMeasConfig_iE_Extensions__item__criticality._const_tab = ____UEAppLayerMeasConfig_iE_Extensions__item__id_tab
    ___UEAppLayerMeasConfig_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEAppLayerMeasConfig_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEAppLayerMeasConfig_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UEAppLayerMeasConfig_iE_Extensions__item__extensionValue._const_tab = ____UEAppLayerMeasConfig_iE_Extensions__item__id_tab
    ___UEAppLayerMeasConfig_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEAppLayerMeasConfig_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEAppLayerMeasConfig_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEAppLayerMeasConfig_iE_Extensions__item__id),
        (u'criticality', ___UEAppLayerMeasConfig_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEAppLayerMeasConfig_iE_Extensions__item__extensionValue),
        ])
    __UEAppLayerMeasConfig_iE_Extensions__item_._ext = None
    _UEAppLayerMeasConfig_iE_Extensions._cont = __UEAppLayerMeasConfig_iE_Extensions__item_
    _UEAppLayerMeasConfig_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEAppLayerMeasConfig._cont = ASN1Dict([
        (u'containerForAppLayerMeasConfig', _UEAppLayerMeasConfig_containerForAppLayerMeasConfig),
        (u'areaScopeOfQMC', _UEAppLayerMeasConfig_areaScopeOfQMC),
        (u'iE-Extensions', _UEAppLayerMeasConfig_iE_Extensions),
        ])
    UEAppLayerMeasConfig._ext = []
    
    #-----< UEAppLayerMeasConfig-ExtIEs >-----#
    UEAppLayerMeasConfig_ExtIEs = CLASS(name=u'UEAppLayerMeasConfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _UEAppLayerMeasConfig_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServiceType')))
    UEAppLayerMeasConfig_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 276), (u'criticality', u'ignore'), (u'Extension', _UEAppLayerMeasConfig_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UECapabilityInfoRequest >-----#
    UECapabilityInfoRequest = ENUM(name=u'UECapabilityInfoRequest', mode=MODE_TYPE)
    UECapabilityInfoRequest._cont = ASN1Dict([(u'requested', 0)])
    UECapabilityInfoRequest._ext = []
    
    #-----< UE-RetentionInformation >-----#
    UE_RetentionInformation = ENUM(name=u'UE-RetentionInformation', mode=MODE_TYPE)
    UE_RetentionInformation._cont = ASN1Dict([(u'ues-retained', 0)])
    UE_RetentionInformation._ext = []
    
    #-----< UE-S1AP-IDs >-----#
    UE_S1AP_IDs = CHOICE(name=u'UE-S1AP-IDs', mode=MODE_TYPE)
    _UE_S1AP_IDs_uE_S1AP_ID_pair = SEQ(name=u'uE-S1AP-ID-pair', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'UE-S1AP-ID-pair')))
    _UE_S1AP_IDs_mME_UE_S1AP_ID = INT(name=u'mME-UE-S1AP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    UE_S1AP_IDs._cont = ASN1Dict([
        (u'uE-S1AP-ID-pair', _UE_S1AP_IDs_uE_S1AP_ID_pair),
        (u'mME-UE-S1AP-ID', _UE_S1AP_IDs_mME_UE_S1AP_ID),
        ])
    UE_S1AP_IDs._ext = []
    
    #-----< UE-S1AP-ID-pair >-----#
    UE_S1AP_ID_pair = SEQ(name=u'UE-S1AP-ID-pair', mode=MODE_TYPE)
    _UE_S1AP_ID_pair_mME_UE_S1AP_ID = INT(name=u'mME-UE-S1AP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UE_S1AP_ID_pair_eNB_UE_S1AP_ID = INT(name=u'eNB-UE-S1AP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UE_S1AP_ID_pair_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_S1AP_ID_pair_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___UE_S1AP_ID_pair_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UE_S1AP_ID_pair_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UE_S1AP_ID_pair_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_S1AP_ID_pair_iE_Extensions__item__id._const_tab = ____UE_S1AP_ID_pair_iE_Extensions__item__id_tab
    ___UE_S1AP_ID_pair_iE_Extensions__item__id._const_tab_at = None
    ___UE_S1AP_ID_pair_iE_Extensions__item__id._const_tab_id = u'id'
    ___UE_S1AP_ID_pair_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UE_S1AP_ID_pair_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UE_S1AP_ID_pair_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_S1AP_ID_pair_iE_Extensions__item__criticality._const_tab = ____UE_S1AP_ID_pair_iE_Extensions__item__criticality_tab
    ___UE_S1AP_ID_pair_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UE_S1AP_ID_pair_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UE_S1AP_ID_pair_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UE_S1AP_ID_pair_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UE_S1AP_ID_pair_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_S1AP_ID_pair_iE_Extensions__item__extensionValue._const_tab = ____UE_S1AP_ID_pair_iE_Extensions__item__extensionValue_tab
    ___UE_S1AP_ID_pair_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UE_S1AP_ID_pair_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UE_S1AP_ID_pair_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UE_S1AP_ID_pair_iE_Extensions__item__id),
        (u'criticality', ___UE_S1AP_ID_pair_iE_Extensions__item__criticality),
        (u'extensionValue', ___UE_S1AP_ID_pair_iE_Extensions__item__extensionValue),
        ])
    __UE_S1AP_ID_pair_iE_Extensions__item_._ext = None
    _UE_S1AP_ID_pair_iE_Extensions._cont = __UE_S1AP_ID_pair_iE_Extensions__item_
    _UE_S1AP_ID_pair_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_S1AP_ID_pair._cont = ASN1Dict([
        (u'mME-UE-S1AP-ID', _UE_S1AP_ID_pair_mME_UE_S1AP_ID),
        (u'eNB-UE-S1AP-ID', _UE_S1AP_ID_pair_eNB_UE_S1AP_ID),
        (u'iE-Extensions', _UE_S1AP_ID_pair_iE_Extensions),
        ])
    UE_S1AP_ID_pair._ext = []
    
    #-----< UE-S1AP-ID-pair-ExtIEs >-----#
    UE_S1AP_ID_pair_ExtIEs = CLASS(name=u'UE-S1AP-ID-pair-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    UE_S1AP_ID_pair_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-associatedLogicalS1-ConnectionItem >-----#
    UE_associatedLogicalS1_ConnectionItem = SEQ(name=u'UE-associatedLogicalS1-ConnectionItem', mode=MODE_TYPE)
    _UE_associatedLogicalS1_ConnectionItem_mME_UE_S1AP_ID = INT(name=u'mME-UE-S1AP-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')), opt=True)
    _UE_associatedLogicalS1_ConnectionItem_eNB_UE_S1AP_ID = INT(name=u'eNB-UE-S1AP-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')), opt=True)
    _UE_associatedLogicalS1_ConnectionItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__id._const_tab = ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__id_tab
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__id._const_tab_at = None
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__criticality._const_tab = ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__criticality_tab
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__extensionValue._const_tab = ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__extensionValue_tab
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__id),
        (u'criticality', ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__extensionValue),
        ])
    __UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item_._ext = None
    _UE_associatedLogicalS1_ConnectionItem_iE_Extensions._cont = __UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item_
    _UE_associatedLogicalS1_ConnectionItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_associatedLogicalS1_ConnectionItem._cont = ASN1Dict([
        (u'mME-UE-S1AP-ID', _UE_associatedLogicalS1_ConnectionItem_mME_UE_S1AP_ID),
        (u'eNB-UE-S1AP-ID', _UE_associatedLogicalS1_ConnectionItem_eNB_UE_S1AP_ID),
        (u'iE-Extensions', _UE_associatedLogicalS1_ConnectionItem_iE_Extensions),
        ])
    UE_associatedLogicalS1_ConnectionItem._ext = []
    
    #-----< UE-associatedLogicalS1-ConnectionItemExtIEs >-----#
    UE_associatedLogicalS1_ConnectionItemExtIEs = CLASS(name=u'UE-associatedLogicalS1-ConnectionItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    UE_associatedLogicalS1_ConnectionItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEIdentityIndexValue >-----#
    UEIdentityIndexValue = BIT_STR(name=u'UEIdentityIndexValue', mode=MODE_TYPE)
    UEIdentityIndexValue._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    
    #-----< UE-HistoryInformation >-----#
    UE_HistoryInformation = SEQ_OF(name=u'UE-HistoryInformation', mode=MODE_TYPE)
    _UE_HistoryInformation__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LastVisitedCell-Item')))
    UE_HistoryInformation._cont = _UE_HistoryInformation__item_
    UE_HistoryInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UE-HistoryInformationFromTheUE >-----#
    UE_HistoryInformationFromTheUE = OCT_STR(name=u'UE-HistoryInformationFromTheUE', mode=MODE_TYPE)
    
    #-----< UEPagingID >-----#
    UEPagingID = CHOICE(name=u'UEPagingID', mode=MODE_TYPE)
    _UEPagingID_s_TMSI = SEQ(name=u's-TMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    _UEPagingID_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'IMSI')))
    UEPagingID._cont = ASN1Dict([
        (u's-TMSI', _UEPagingID_s_TMSI),
        (u'iMSI', _UEPagingID_iMSI),
        ])
    UEPagingID._ext = []
    
    #-----< UERadioCapability >-----#
    UERadioCapability = OCT_STR(name=u'UERadioCapability', mode=MODE_TYPE)
    
    #-----< UERadioCapabilityForPaging >-----#
    UERadioCapabilityForPaging = OCT_STR(name=u'UERadioCapabilityForPaging', mode=MODE_TYPE)
    
    #-----< UERadioCapabilityID >-----#
    UERadioCapabilityID = OCT_STR(name=u'UERadioCapabilityID', mode=MODE_TYPE)
    
    #-----< UE-RLF-Report-Container >-----#
    UE_RLF_Report_Container = OCT_STR(name=u'UE-RLF-Report-Container', mode=MODE_TYPE)
    
    #-----< UE-RLF-Report-Container-for-extended-bands >-----#
    UE_RLF_Report_Container_for_extended_bands = OCT_STR(name=u'UE-RLF-Report-Container-for-extended-bands', mode=MODE_TYPE)
    
    #-----< UESecurityCapabilities >-----#
    UESecurityCapabilities = SEQ(name=u'UESecurityCapabilities', mode=MODE_TYPE)
    _UESecurityCapabilities_encryptionAlgorithms = BIT_STR(name=u'encryptionAlgorithms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EncryptionAlgorithms')))
    _UESecurityCapabilities_integrityProtectionAlgorithms = BIT_STR(name=u'integrityProtectionAlgorithms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'IntegrityProtectionAlgorithms')))
    _UESecurityCapabilities_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UESecurityCapabilities_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___UESecurityCapabilities_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UESecurityCapabilities_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UESecurityCapabilities_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESecurityCapabilities_iE_Extensions__item__id._const_tab = ____UESecurityCapabilities_iE_Extensions__item__id_tab
    ___UESecurityCapabilities_iE_Extensions__item__id._const_tab_at = None
    ___UESecurityCapabilities_iE_Extensions__item__id._const_tab_id = u'id'
    ___UESecurityCapabilities_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UESecurityCapabilities_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UESecurityCapabilities_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESecurityCapabilities_iE_Extensions__item__criticality._const_tab = ____UESecurityCapabilities_iE_Extensions__item__criticality_tab
    ___UESecurityCapabilities_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UESecurityCapabilities_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UESecurityCapabilities_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UESecurityCapabilities_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab = ____UESecurityCapabilities_iE_Extensions__item__extensionValue_tab
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UESecurityCapabilities_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UESecurityCapabilities_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UESecurityCapabilities_iE_Extensions__item__id),
        (u'criticality', ___UESecurityCapabilities_iE_Extensions__item__criticality),
        (u'extensionValue', ___UESecurityCapabilities_iE_Extensions__item__extensionValue),
        ])
    __UESecurityCapabilities_iE_Extensions__item_._ext = None
    _UESecurityCapabilities_iE_Extensions._cont = __UESecurityCapabilities_iE_Extensions__item_
    _UESecurityCapabilities_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UESecurityCapabilities._cont = ASN1Dict([
        (u'encryptionAlgorithms', _UESecurityCapabilities_encryptionAlgorithms),
        (u'integrityProtectionAlgorithms', _UESecurityCapabilities_integrityProtectionAlgorithms),
        (u'iE-Extensions', _UESecurityCapabilities_iE_Extensions),
        ])
    UESecurityCapabilities._ext = []
    
    #-----< UESecurityCapabilities-ExtIEs >-----#
    UESecurityCapabilities_ExtIEs = CLASS(name=u'UESecurityCapabilities-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    UESecurityCapabilities_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UESidelinkAggregateMaximumBitrate >-----#
    UESidelinkAggregateMaximumBitrate = SEQ(name=u'UESidelinkAggregateMaximumBitrate', mode=MODE_TYPE)
    _UESidelinkAggregateMaximumBitrate_uESidelinkAggregateMaximumBitRate = INT(name=u'uESidelinkAggregateMaximumBitRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'BitRate')))
    _UESidelinkAggregateMaximumBitrate_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UESidelinkAggregateMaximumBitrate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab = ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_at = None
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__id._const_tab_id = u'id'
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab = ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab = ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UESidelinkAggregateMaximumBitrate_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__id),
        (u'criticality', ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality),
        (u'extensionValue', ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue),
        ])
    __UESidelinkAggregateMaximumBitrate_iE_Extensions__item_._ext = None
    _UESidelinkAggregateMaximumBitrate_iE_Extensions._cont = __UESidelinkAggregateMaximumBitrate_iE_Extensions__item_
    _UESidelinkAggregateMaximumBitrate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UESidelinkAggregateMaximumBitrate._cont = ASN1Dict([
        (u'uESidelinkAggregateMaximumBitRate', _UESidelinkAggregateMaximumBitrate_uESidelinkAggregateMaximumBitRate),
        (u'iE-Extensions', _UESidelinkAggregateMaximumBitrate_iE_Extensions),
        ])
    UESidelinkAggregateMaximumBitrate._ext = []
    
    #-----< UE-Sidelink-Aggregate-MaximumBitrates-ExtIEs >-----#
    UE_Sidelink_Aggregate_MaximumBitrates_ExtIEs = CLASS(name=u'UE-Sidelink-Aggregate-MaximumBitrates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    UE_Sidelink_Aggregate_MaximumBitrates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-Usage-Type >-----#
    UE_Usage_Type = INT(name=u'UE-Usage-Type', mode=MODE_TYPE)
    UE_Usage_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< UL-CP-SecurityInformation >-----#
    UL_CP_SecurityInformation = SEQ(name=u'UL-CP-SecurityInformation', mode=MODE_TYPE)
    _UL_CP_SecurityInformation_ul_NAS_MAC = BIT_STR(name=u'ul-NAS-MAC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'UL-NAS-MAC')))
    _UL_CP_SecurityInformation_ul_NAS_Count = BIT_STR(name=u'ul-NAS-Count', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'UL-NAS-Count')))
    _UL_CP_SecurityInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CP_SecurityInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___UL_CP_SecurityInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_CP_SecurityInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UL_CP_SecurityInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CP_SecurityInformation_iE_Extensions__item__id._const_tab = ____UL_CP_SecurityInformation_iE_Extensions__item__id_tab
    ___UL_CP_SecurityInformation_iE_Extensions__item__id._const_tab_at = None
    ___UL_CP_SecurityInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_CP_SecurityInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_CP_SecurityInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UL_CP_SecurityInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab = ____UL_CP_SecurityInformation_iE_Extensions__item__criticality_tab
    ___UL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_CP_SecurityInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____UL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab = ____UL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab
    ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_CP_SecurityInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_CP_SecurityInformation_iE_Extensions__item__id),
        (u'criticality', ___UL_CP_SecurityInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue),
        ])
    __UL_CP_SecurityInformation_iE_Extensions__item_._ext = None
    _UL_CP_SecurityInformation_iE_Extensions._cont = __UL_CP_SecurityInformation_iE_Extensions__item_
    _UL_CP_SecurityInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CP_SecurityInformation._cont = ASN1Dict([
        (u'ul-NAS-MAC', _UL_CP_SecurityInformation_ul_NAS_MAC),
        (u'ul-NAS-Count', _UL_CP_SecurityInformation_ul_NAS_Count),
        (u'iE-Extensions', _UL_CP_SecurityInformation_iE_Extensions),
        ])
    UL_CP_SecurityInformation._ext = []
    
    #-----< UL-CP-SecurityInformation-ExtIEs >-----#
    UL_CP_SecurityInformation_ExtIEs = CLASS(name=u'UL-CP-SecurityInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    UL_CP_SecurityInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-NAS-MAC >-----#
    UL_NAS_MAC = BIT_STR(name=u'UL-NAS-MAC', mode=MODE_TYPE)
    UL_NAS_MAC._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< UL-NAS-Count >-----#
    UL_NAS_Count = BIT_STR(name=u'UL-NAS-Count', mode=MODE_TYPE)
    UL_NAS_Count._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    
    #-----< UnlicensedSpectrumRestriction >-----#
    UnlicensedSpectrumRestriction = ENUM(name=u'UnlicensedSpectrumRestriction', mode=MODE_TYPE)
    UnlicensedSpectrumRestriction._cont = ASN1Dict([(u'unlicensed-restricted', 0)])
    UnlicensedSpectrumRestriction._ext = []
    
    #-----< URI-Address >-----#
    URI_Address = STR_VIS(name=u'URI-Address', mode=MODE_TYPE)
    
    #-----< UserLocationInformation >-----#
    UserLocationInformation = SEQ(name=u'UserLocationInformation', mode=MODE_TYPE)
    _UserLocationInformation_eutran_cgi = SEQ(name=u'eutran-cgi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _UserLocationInformation_tai = SEQ(name=u'tai', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _UserLocationInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UserLocationInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___UserLocationInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____UserLocationInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____UserLocationInformation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PSCellInformation')))
    ____UserLocationInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 288), (u'criticality', u'ignore'), (u'Extension', _____UserLocationInformation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UserLocationInformation_iE_Extensions__item__id._const_tab = ____UserLocationInformation_iE_Extensions__item__id_tab
    ___UserLocationInformation_iE_Extensions__item__id._const_tab_at = None
    ___UserLocationInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___UserLocationInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UserLocationInformation_iE_Extensions__item__criticality._const_tab = ____UserLocationInformation_iE_Extensions__item__id_tab
    ___UserLocationInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UserLocationInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UserLocationInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UserLocationInformation_iE_Extensions__item__extensionValue._const_tab = ____UserLocationInformation_iE_Extensions__item__id_tab
    ___UserLocationInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UserLocationInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UserLocationInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UserLocationInformation_iE_Extensions__item__id),
        (u'criticality', ___UserLocationInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___UserLocationInformation_iE_Extensions__item__extensionValue),
        ])
    __UserLocationInformation_iE_Extensions__item_._ext = None
    _UserLocationInformation_iE_Extensions._cont = __UserLocationInformation_iE_Extensions__item_
    _UserLocationInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UserLocationInformation._cont = ASN1Dict([
        (u'eutran-cgi', _UserLocationInformation_eutran_cgi),
        (u'tai', _UserLocationInformation_tai),
        (u'iE-Extensions', _UserLocationInformation_iE_Extensions),
        ])
    UserLocationInformation._ext = []
    
    #-----< UserLocationInformation-ExtIEs >-----#
    UserLocationInformation_ExtIEs = CLASS(name=u'UserLocationInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _UserLocationInformation_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PSCellInformation')))
    UserLocationInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 288), (u'criticality', u'ignore'), (u'Extension', _UserLocationInformation_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEUserPlaneCIoTSupportIndicator >-----#
    UEUserPlaneCIoTSupportIndicator = ENUM(name=u'UEUserPlaneCIoTSupportIndicator', mode=MODE_TYPE)
    UEUserPlaneCIoTSupportIndicator._cont = ASN1Dict([(u'supported', 0)])
    UEUserPlaneCIoTSupportIndicator._ext = []
    
    #-----< UE-Application-Layer-Measurement-Capability >-----#
    UE_Application_Layer_Measurement_Capability = BIT_STR(name=u'UE-Application-Layer-Measurement-Capability', mode=MODE_TYPE)
    UE_Application_Layer_Measurement_Capability._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< VoiceSupportMatchIndicator >-----#
    VoiceSupportMatchIndicator = ENUM(name=u'VoiceSupportMatchIndicator', mode=MODE_TYPE)
    VoiceSupportMatchIndicator._cont = ASN1Dict([(u'supported', 0), (u'not-supported', 1)])
    VoiceSupportMatchIndicator._ext = []
    
    #-----< V2XServicesAuthorized >-----#
    V2XServicesAuthorized = SEQ(name=u'V2XServicesAuthorized', mode=MODE_TYPE)
    _V2XServicesAuthorized_vehicleUE = ENUM(name=u'vehicleUE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'VehicleUE')), opt=True)
    _V2XServicesAuthorized_pedestrianUE = ENUM(name=u'pedestrianUE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PedestrianUE')), opt=True)
    _V2XServicesAuthorized_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __V2XServicesAuthorized_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___V2XServicesAuthorized_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____V2XServicesAuthorized_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____V2XServicesAuthorized_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___V2XServicesAuthorized_iE_Extensions__item__id._const_tab = ____V2XServicesAuthorized_iE_Extensions__item__id_tab
    ___V2XServicesAuthorized_iE_Extensions__item__id._const_tab_at = None
    ___V2XServicesAuthorized_iE_Extensions__item__id._const_tab_id = u'id'
    ___V2XServicesAuthorized_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____V2XServicesAuthorized_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____V2XServicesAuthorized_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___V2XServicesAuthorized_iE_Extensions__item__criticality._const_tab = ____V2XServicesAuthorized_iE_Extensions__item__criticality_tab
    ___V2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___V2XServicesAuthorized_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___V2XServicesAuthorized_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____V2XServicesAuthorized_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____V2XServicesAuthorized_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___V2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab = ____V2XServicesAuthorized_iE_Extensions__item__extensionValue_tab
    ___V2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___V2XServicesAuthorized_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __V2XServicesAuthorized_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___V2XServicesAuthorized_iE_Extensions__item__id),
        (u'criticality', ___V2XServicesAuthorized_iE_Extensions__item__criticality),
        (u'extensionValue', ___V2XServicesAuthorized_iE_Extensions__item__extensionValue),
        ])
    __V2XServicesAuthorized_iE_Extensions__item_._ext = None
    _V2XServicesAuthorized_iE_Extensions._cont = __V2XServicesAuthorized_iE_Extensions__item_
    _V2XServicesAuthorized_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    V2XServicesAuthorized._cont = ASN1Dict([
        (u'vehicleUE', _V2XServicesAuthorized_vehicleUE),
        (u'pedestrianUE', _V2XServicesAuthorized_pedestrianUE),
        (u'iE-Extensions', _V2XServicesAuthorized_iE_Extensions),
        ])
    V2XServicesAuthorized._ext = []
    
    #-----< V2XServicesAuthorized-ExtIEs >-----#
    V2XServicesAuthorized_ExtIEs = CLASS(name=u'V2XServicesAuthorized-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    V2XServicesAuthorized_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< VehicleUE >-----#
    VehicleUE = ENUM(name=u'VehicleUE', mode=MODE_TYPE)
    VehicleUE._cont = ASN1Dict([(u'authorized', 0), (u'not-authorized', 1)])
    VehicleUE._ext = []
    
    #-----< PedestrianUE >-----#
    PedestrianUE = ENUM(name=u'PedestrianUE', mode=MODE_TYPE)
    PedestrianUE._cont = ASN1Dict([(u'authorized', 0), (u'not-authorized', 1)])
    PedestrianUE._ext = []
    
    #-----< WarningAreaCoordinates >-----#
    WarningAreaCoordinates = OCT_STR(name=u'WarningAreaCoordinates', mode=MODE_TYPE)
    WarningAreaCoordinates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< WarningAreaList >-----#
    WarningAreaList = CHOICE(name=u'WarningAreaList', mode=MODE_TYPE)
    _WarningAreaList_cellIDList = SEQ_OF(name=u'cellIDList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ECGIList')))
    _WarningAreaList_trackingAreaListforWarning = SEQ_OF(name=u'trackingAreaListforWarning', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAIListforWarning')))
    _WarningAreaList_emergencyAreaIDList = SEQ_OF(name=u'emergencyAreaIDList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaIDList')))
    WarningAreaList._cont = ASN1Dict([
        (u'cellIDList', _WarningAreaList_cellIDList),
        (u'trackingAreaListforWarning', _WarningAreaList_trackingAreaListforWarning),
        (u'emergencyAreaIDList', _WarningAreaList_emergencyAreaIDList),
        ])
    WarningAreaList._ext = []
    
    #-----< WarningType >-----#
    WarningType = OCT_STR(name=u'WarningType', mode=MODE_TYPE)
    WarningType._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< WarningSecurityInfo >-----#
    WarningSecurityInfo = OCT_STR(name=u'WarningSecurityInfo', mode=MODE_TYPE)
    WarningSecurityInfo._const_sz = ASN1Set(rv=[50], rr=[], ev=None, er=[])
    
    #-----< WarningMessageContents >-----#
    WarningMessageContents = OCT_STR(name=u'WarningMessageContents', mode=MODE_TYPE)
    WarningMessageContents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9600)], ev=None, er=[])
    
    #-----< WLANMeasurementConfiguration >-----#
    WLANMeasurementConfiguration = SEQ(name=u'WLANMeasurementConfiguration', mode=MODE_TYPE)
    _WLANMeasurementConfiguration_wlanMeasConfig = ENUM(name=u'wlanMeasConfig', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'WLANMeasConfig')))
    _WLANMeasurementConfiguration_wlanMeasConfigNameList = SEQ_OF(name=u'wlanMeasConfigNameList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'WLANMeasConfigNameList')), opt=True)
    _WLANMeasurementConfiguration_wlan_rssi = ENUM(name=u'wlan-rssi', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLANMeasurementConfiguration_wlan_rssi._cont = ASN1Dict([(u'true', 0)])
    _WLANMeasurementConfiguration_wlan_rssi._ext = []
    _WLANMeasurementConfiguration_wlan_rtt = ENUM(name=u'wlan-rtt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLANMeasurementConfiguration_wlan_rtt._cont = ASN1Dict([(u'true', 0)])
    _WLANMeasurementConfiguration_wlan_rtt._ext = []
    _WLANMeasurementConfiguration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WLANMeasurementConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___WLANMeasurementConfiguration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____WLANMeasurementConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____WLANMeasurementConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementConfiguration_iE_Extensions__item__id._const_tab = ____WLANMeasurementConfiguration_iE_Extensions__item__id_tab
    ___WLANMeasurementConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___WLANMeasurementConfiguration_iE_Extensions__item__id._const_tab_id = u'id'
    ___WLANMeasurementConfiguration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____WLANMeasurementConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____WLANMeasurementConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementConfiguration_iE_Extensions__item__criticality._const_tab = ____WLANMeasurementConfiguration_iE_Extensions__item__criticality_tab
    ___WLANMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___WLANMeasurementConfiguration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____WLANMeasurementConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____WLANMeasurementConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab = ____WLANMeasurementConfiguration_iE_Extensions__item__extensionValue_tab
    ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __WLANMeasurementConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___WLANMeasurementConfiguration_iE_Extensions__item__id),
        (u'criticality', ___WLANMeasurementConfiguration_iE_Extensions__item__criticality),
        (u'extensionValue', ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue),
        ])
    __WLANMeasurementConfiguration_iE_Extensions__item_._ext = None
    _WLANMeasurementConfiguration_iE_Extensions._cont = __WLANMeasurementConfiguration_iE_Extensions__item_
    _WLANMeasurementConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WLANMeasurementConfiguration._cont = ASN1Dict([
        (u'wlanMeasConfig', _WLANMeasurementConfiguration_wlanMeasConfig),
        (u'wlanMeasConfigNameList', _WLANMeasurementConfiguration_wlanMeasConfigNameList),
        (u'wlan-rssi', _WLANMeasurementConfiguration_wlan_rssi),
        (u'wlan-rtt', _WLANMeasurementConfiguration_wlan_rtt),
        (u'iE-Extensions', _WLANMeasurementConfiguration_iE_Extensions),
        ])
    WLANMeasurementConfiguration._ext = []
    
    #-----< WLANMeasurementConfiguration-ExtIEs >-----#
    WLANMeasurementConfiguration_ExtIEs = CLASS(name=u'WLANMeasurementConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    WLANMeasurementConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WLANMeasConfigNameList >-----#
    WLANMeasConfigNameList = SEQ_OF(name=u'WLANMeasConfigNameList', mode=MODE_TYPE)
    _WLANMeasConfigNameList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WLANName')))
    WLANMeasConfigNameList._cont = _WLANMeasConfigNameList__item_
    WLANMeasConfigNameList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< WLANMeasConfig >-----#
    WLANMeasConfig = ENUM(name=u'WLANMeasConfig', mode=MODE_TYPE)
    WLANMeasConfig._cont = ASN1Dict([(u'setup', 0)])
    WLANMeasConfig._ext = []
    
    #-----< WLANName >-----#
    WLANName = OCT_STR(name=u'WLANName', mode=MODE_TYPE)
    WLANName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< WUS-Assistance-Information >-----#
    WUS_Assistance_Information = SEQ(name=u'WUS-Assistance-Information', mode=MODE_TYPE)
    _WUS_Assistance_Information_pagingProbabilityInformation = ENUM(name=u'pagingProbabilityInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PagingProbabilityInformation')))
    _WUS_Assistance_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WUS_Assistance_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___WUS_Assistance_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____WUS_Assistance_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____WUS_Assistance_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WUS_Assistance_Information_iE_Extensions__item__id._const_tab = ____WUS_Assistance_Information_iE_Extensions__item__id_tab
    ___WUS_Assistance_Information_iE_Extensions__item__id._const_tab_at = None
    ___WUS_Assistance_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___WUS_Assistance_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____WUS_Assistance_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____WUS_Assistance_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WUS_Assistance_Information_iE_Extensions__item__criticality._const_tab = ____WUS_Assistance_Information_iE_Extensions__item__criticality_tab
    ___WUS_Assistance_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___WUS_Assistance_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___WUS_Assistance_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____WUS_Assistance_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____WUS_Assistance_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WUS_Assistance_Information_iE_Extensions__item__extensionValue._const_tab = ____WUS_Assistance_Information_iE_Extensions__item__extensionValue_tab
    ___WUS_Assistance_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___WUS_Assistance_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __WUS_Assistance_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___WUS_Assistance_Information_iE_Extensions__item__id),
        (u'criticality', ___WUS_Assistance_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___WUS_Assistance_Information_iE_Extensions__item__extensionValue),
        ])
    __WUS_Assistance_Information_iE_Extensions__item_._ext = None
    _WUS_Assistance_Information_iE_Extensions._cont = __WUS_Assistance_Information_iE_Extensions__item_
    _WUS_Assistance_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WUS_Assistance_Information._cont = ASN1Dict([
        (u'pagingProbabilityInformation', _WUS_Assistance_Information_pagingProbabilityInformation),
        (u'iE-Extensions', _WUS_Assistance_Information_iE_Extensions),
        ])
    WUS_Assistance_Information._ext = []
    
    #-----< WUS-Assistance-Information-ExtIEs >-----#
    WUS_Assistance_Information_ExtIEs = CLASS(name=u'WUS-Assistance-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    WUS_Assistance_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< X2TNLConfigurationInfo >-----#
    X2TNLConfigurationInfo = SEQ(name=u'X2TNLConfigurationInfo', mode=MODE_TYPE)
    _X2TNLConfigurationInfo_eNBX2TransportLayerAddresses = SEQ_OF(name=u'eNBX2TransportLayerAddresses', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ENBX2TLAs')))
    _X2TNLConfigurationInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __X2TNLConfigurationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___X2TNLConfigurationInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____X2TNLConfigurationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____X2TNLConfigurationInfo_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENBX2ExtTLAs')))
    _____X2TNLConfigurationInfo_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENBIndirectX2TransportLayerAddresses')))
    ____X2TNLConfigurationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 153), (u'criticality', u'ignore'), (u'Extension', _____X2TNLConfigurationInfo_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 193), (u'criticality', u'ignore'), (u'Extension', _____X2TNLConfigurationInfo_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___X2TNLConfigurationInfo_iE_Extensions__item__id._const_tab = ____X2TNLConfigurationInfo_iE_Extensions__item__id_tab
    ___X2TNLConfigurationInfo_iE_Extensions__item__id._const_tab_at = None
    ___X2TNLConfigurationInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___X2TNLConfigurationInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___X2TNLConfigurationInfo_iE_Extensions__item__criticality._const_tab = ____X2TNLConfigurationInfo_iE_Extensions__item__id_tab
    ___X2TNLConfigurationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___X2TNLConfigurationInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___X2TNLConfigurationInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___X2TNLConfigurationInfo_iE_Extensions__item__extensionValue._const_tab = ____X2TNLConfigurationInfo_iE_Extensions__item__id_tab
    ___X2TNLConfigurationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___X2TNLConfigurationInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __X2TNLConfigurationInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___X2TNLConfigurationInfo_iE_Extensions__item__id),
        (u'criticality', ___X2TNLConfigurationInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___X2TNLConfigurationInfo_iE_Extensions__item__extensionValue),
        ])
    __X2TNLConfigurationInfo_iE_Extensions__item_._ext = None
    _X2TNLConfigurationInfo_iE_Extensions._cont = __X2TNLConfigurationInfo_iE_Extensions__item_
    _X2TNLConfigurationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    X2TNLConfigurationInfo._cont = ASN1Dict([
        (u'eNBX2TransportLayerAddresses', _X2TNLConfigurationInfo_eNBX2TransportLayerAddresses),
        (u'iE-Extensions', _X2TNLConfigurationInfo_iE_Extensions),
        ])
    X2TNLConfigurationInfo._ext = []
    
    #-----< X2TNLConfigurationInfo-ExtIEs >-----#
    X2TNLConfigurationInfo_ExtIEs = CLASS(name=u'X2TNLConfigurationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _X2TNLConfigurationInfo_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENBX2ExtTLAs')))
    _X2TNLConfigurationInfo_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENBIndirectX2TransportLayerAddresses')))
    X2TNLConfigurationInfo_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 153), (u'criticality', u'ignore'), (u'Extension', _X2TNLConfigurationInfo_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 193), (u'criticality', u'ignore'), (u'Extension', _X2TNLConfigurationInfo_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENBX2ExtTLAs >-----#
    ENBX2ExtTLAs = SEQ_OF(name=u'ENBX2ExtTLAs', mode=MODE_TYPE)
    _ENBX2ExtTLAs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENBX2ExtTLA')))
    ENBX2ExtTLAs._cont = _ENBX2ExtTLAs__item_
    ENBX2ExtTLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ENBX2ExtTLA >-----#
    ENBX2ExtTLA = SEQ(name=u'ENBX2ExtTLA', mode=MODE_TYPE)
    _ENBX2ExtTLA_iPsecTLA = BIT_STR(name=u'iPsecTLA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')), opt=True)
    _ENBX2ExtTLA_gTPTLAa = SEQ_OF(name=u'gTPTLAa', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'ENBX2GTPTLAs')), opt=True)
    _ENBX2ExtTLA_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ENBX2ExtTLA_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___ENBX2ExtTLA_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____ENBX2ExtTLA_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ENBX2ExtTLA_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ENBX2ExtTLA_iE_Extensions__item__id._const_tab = ____ENBX2ExtTLA_iE_Extensions__item__id_tab
    ___ENBX2ExtTLA_iE_Extensions__item__id._const_tab_at = None
    ___ENBX2ExtTLA_iE_Extensions__item__id._const_tab_id = u'id'
    ___ENBX2ExtTLA_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ENBX2ExtTLA_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ENBX2ExtTLA_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ENBX2ExtTLA_iE_Extensions__item__criticality._const_tab = ____ENBX2ExtTLA_iE_Extensions__item__criticality_tab
    ___ENBX2ExtTLA_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ENBX2ExtTLA_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ENBX2ExtTLA_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ENBX2ExtTLA_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____ENBX2ExtTLA_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ENBX2ExtTLA_iE_Extensions__item__extensionValue._const_tab = ____ENBX2ExtTLA_iE_Extensions__item__extensionValue_tab
    ___ENBX2ExtTLA_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ENBX2ExtTLA_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ENBX2ExtTLA_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ENBX2ExtTLA_iE_Extensions__item__id),
        (u'criticality', ___ENBX2ExtTLA_iE_Extensions__item__criticality),
        (u'extensionValue', ___ENBX2ExtTLA_iE_Extensions__item__extensionValue),
        ])
    __ENBX2ExtTLA_iE_Extensions__item_._ext = None
    _ENBX2ExtTLA_iE_Extensions._cont = __ENBX2ExtTLA_iE_Extensions__item_
    _ENBX2ExtTLA_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ENBX2ExtTLA._cont = ASN1Dict([
        (u'iPsecTLA', _ENBX2ExtTLA_iPsecTLA),
        (u'gTPTLAa', _ENBX2ExtTLA_gTPTLAa),
        (u'iE-Extensions', _ENBX2ExtTLA_iE_Extensions),
        ])
    ENBX2ExtTLA._ext = []
    
    #-----< ENBX2ExtTLA-ExtIEs >-----#
    ENBX2ExtTLA_ExtIEs = CLASS(name=u'ENBX2ExtTLA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ENBX2ExtTLA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ENBX2GTPTLAs >-----#
    ENBX2GTPTLAs = SEQ_OF(name=u'ENBX2GTPTLAs', mode=MODE_TYPE)
    _ENBX2GTPTLAs__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    ENBX2GTPTLAs._cont = _ENBX2GTPTLAs__item_
    ENBX2GTPTLAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ENBIndirectX2TransportLayerAddresses >-----#
    ENBIndirectX2TransportLayerAddresses = SEQ_OF(name=u'ENBIndirectX2TransportLayerAddresses', mode=MODE_TYPE)
    _ENBIndirectX2TransportLayerAddresses__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    ENBIndirectX2TransportLayerAddresses._cont = _ENBIndirectX2TransportLayerAddresses__item_
    ENBIndirectX2TransportLayerAddresses._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    _all_ = [
        _Additional_GUTI_gUMMEI,
        _Additional_GUTI_m_TMSI,
        ____Additional_GUTI_iE_Extensions__item__id_tab,
        ___Additional_GUTI_iE_Extensions__item__id,
        ____Additional_GUTI_iE_Extensions__item__criticality_tab,
        ___Additional_GUTI_iE_Extensions__item__criticality,
        ____Additional_GUTI_iE_Extensions__item__extensionValue_tab,
        ___Additional_GUTI_iE_Extensions__item__extensionValue,
        __Additional_GUTI_iE_Extensions__item_,
        _Additional_GUTI_iE_Extensions,
        Additional_GUTI,
        Additional_GUTI_ExtIEs,
        AdditionalRRMPriorityIndex,
        AerialUEsubscriptionInformation,
        _AreaScopeOfMDT_cellBased,
        _AreaScopeOfMDT_tABased,
        _AreaScopeOfMDT_pLMNWide,
        _AreaScopeOfMDT_tAIBased,
        AreaScopeOfMDT,
        _AreaScopeOfQMC_cellBased,
        _AreaScopeOfQMC_tABased,
        _AreaScopeOfQMC_tAIBased,
        _AreaScopeOfQMC_pLMNAreaBased,
        AreaScopeOfQMC,
        _AllocationAndRetentionPriority_priorityLevel,
        _AllocationAndRetentionPriority_pre_emptionCapability,
        _AllocationAndRetentionPriority_pre_emptionVulnerability,
        ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__id,
        ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__criticality,
        ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue,
        __AllocationAndRetentionPriority_iE_Extensions__item_,
        _AllocationAndRetentionPriority_iE_Extensions,
        AllocationAndRetentionPriority,
        AllocationAndRetentionPriority_ExtIEs,
        _AssistanceDataForCECapableUEs_cellIdentifierAndCELevelForCECapableUEs,
        ____AssistanceDataForCECapableUEs_iE_Extensions__item__id_tab,
        ___AssistanceDataForCECapableUEs_iE_Extensions__item__id,
        ____AssistanceDataForCECapableUEs_iE_Extensions__item__criticality_tab,
        ___AssistanceDataForCECapableUEs_iE_Extensions__item__criticality,
        ____AssistanceDataForCECapableUEs_iE_Extensions__item__extensionValue_tab,
        ___AssistanceDataForCECapableUEs_iE_Extensions__item__extensionValue,
        __AssistanceDataForCECapableUEs_iE_Extensions__item_,
        _AssistanceDataForCECapableUEs_iE_Extensions,
        AssistanceDataForCECapableUEs,
        InformationForCECapableUEs_ExtIEs,
        _AssistanceDataForPaging_assistanceDataForRecommendedCells,
        _AssistanceDataForPaging_assistanceDataForCECapableUEs,
        _AssistanceDataForPaging_pagingAttemptInformation,
        ____AssistanceDataForPaging_iE_Extensions__item__id_tab,
        ___AssistanceDataForPaging_iE_Extensions__item__id,
        ____AssistanceDataForPaging_iE_Extensions__item__criticality_tab,
        ___AssistanceDataForPaging_iE_Extensions__item__criticality,
        ____AssistanceDataForPaging_iE_Extensions__item__extensionValue_tab,
        ___AssistanceDataForPaging_iE_Extensions__item__extensionValue,
        __AssistanceDataForPaging_iE_Extensions__item_,
        _AssistanceDataForPaging_iE_Extensions,
        AssistanceDataForPaging,
        AssistanceDataForPaging_ExtIEs,
        _AssistanceDataForRecommendedCells_recommendedCellsForPaging,
        ____AssistanceDataForRecommendedCells_iE_Extensions__item__id_tab,
        ___AssistanceDataForRecommendedCells_iE_Extensions__item__id,
        ____AssistanceDataForRecommendedCells_iE_Extensions__item__criticality_tab,
        ___AssistanceDataForRecommendedCells_iE_Extensions__item__criticality,
        ____AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue_tab,
        ___AssistanceDataForRecommendedCells_iE_Extensions__item__extensionValue,
        __AssistanceDataForRecommendedCells_iE_Extensions__item_,
        _AssistanceDataForRecommendedCells_iE_Extensions,
        AssistanceDataForRecommendedCells,
        AssistanceDataForRecommendedCells_ExtIEs,
        ___Bearers_SubjectToStatusTransferList__item__id_tab,
        ____Bearers_SubjectToStatusTransferList__item__id_tab_val_Value_0,
        __Bearers_SubjectToStatusTransferList__item__id,
        __Bearers_SubjectToStatusTransferList__item__criticality,
        __Bearers_SubjectToStatusTransferList__item__value,
        _Bearers_SubjectToStatusTransferList__item_,
        Bearers_SubjectToStatusTransferList,
        Bearers_SubjectToStatusTransfer_ItemIEs,
        _Bearers_SubjectToStatusTransfer_ItemIEs_val_Value_0,
        _Bearers_SubjectToStatusTransfer_Item_e_RAB_ID,
        _Bearers_SubjectToStatusTransfer_Item_uL_COUNTvalue,
        _Bearers_SubjectToStatusTransfer_Item_dL_COUNTvalue,
        _Bearers_SubjectToStatusTransfer_Item_receiveStatusofULPDCPSDUs,
        ____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab,
        _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_2,
        _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_3,
        _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_4,
        _____Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id_tab_val_Extension_5,
        ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__id,
        ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__criticality,
        ___Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item__extensionValue,
        __Bearers_SubjectToStatusTransfer_Item_iE_Extensions__item_,
        _Bearers_SubjectToStatusTransfer_Item_iE_Extensions,
        Bearers_SubjectToStatusTransfer_Item,
        Bearers_SubjectToStatusTransfer_ItemExtIEs,
        _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_0,
        _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_1,
        _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_2,
        _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_3,
        _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_4,
        _Bearers_SubjectToStatusTransfer_ItemExtIEs_val_Extension_5,
        ___Bearers_SubjectToEarlyStatusTransferList__item__id_tab,
        ____Bearers_SubjectToEarlyStatusTransferList__item__id_tab_val_Value_0,
        __Bearers_SubjectToEarlyStatusTransferList__item__id,
        __Bearers_SubjectToEarlyStatusTransferList__item__criticality,
        __Bearers_SubjectToEarlyStatusTransferList__item__value,
        _Bearers_SubjectToEarlyStatusTransferList__item_,
        Bearers_SubjectToEarlyStatusTransferList,
        Bearers_SubjectToEarlyStatusTransfer_ItemIEs,
        _Bearers_SubjectToEarlyStatusTransfer_ItemIEs_val_Value_0,
        _Bearers_SubjectToEarlyStatusTransfer_Item_e_RAB_ID,
        _Bearers_SubjectToEarlyStatusTransfer_Item_dLCOUNT_PDCP_SNlength,
        ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__id_tab,
        ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__id,
        ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__criticality_tab,
        ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__criticality,
        ____Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__extensionValue_tab,
        ___Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item__extensionValue,
        __Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions__item_,
        _Bearers_SubjectToEarlyStatusTransfer_Item_iE_Extensions,
        Bearers_SubjectToEarlyStatusTransfer_Item,
        Bearers_SubjectToEarlyStatusTransfer_ItemExtIEs,
        BearerType,
        BitRate,
        _BluetoothMeasurementConfiguration_bluetoothMeasConfig,
        _BluetoothMeasurementConfiguration_bluetoothMeasConfigNameList,
        _BluetoothMeasurementConfiguration_bt_rssi,
        ____BluetoothMeasurementConfiguration_iE_Extensions__item__id_tab,
        ___BluetoothMeasurementConfiguration_iE_Extensions__item__id,
        ____BluetoothMeasurementConfiguration_iE_Extensions__item__criticality_tab,
        ___BluetoothMeasurementConfiguration_iE_Extensions__item__criticality,
        ____BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue_tab,
        ___BluetoothMeasurementConfiguration_iE_Extensions__item__extensionValue,
        __BluetoothMeasurementConfiguration_iE_Extensions__item_,
        _BluetoothMeasurementConfiguration_iE_Extensions,
        BluetoothMeasurementConfiguration,
        BluetoothMeasurementConfiguration_ExtIEs,
        _BluetoothMeasConfigNameList__item_,
        BluetoothMeasConfigNameList,
        BluetoothMeasConfig,
        BluetoothName,
        _BPLMNs__item_,
        BPLMNs,
        _BroadcastCancelledAreaList_cellID_Cancelled,
        _BroadcastCancelledAreaList_tAI_Cancelled,
        _BroadcastCancelledAreaList_emergencyAreaID_Cancelled,
        BroadcastCancelledAreaList,
        _BroadcastCompletedAreaList_cellID_Broadcast,
        _BroadcastCompletedAreaList_tAI_Broadcast,
        _BroadcastCompletedAreaList_emergencyAreaID_Broadcast,
        BroadcastCompletedAreaList,
        _CancelledCellinEAI__item_,
        CancelledCellinEAI,
        _CancelledCellinEAI_Item_eCGI,
        _CancelledCellinEAI_Item_numberOfBroadcasts,
        ____CancelledCellinEAI_Item_iE_Extensions__item__id_tab,
        ___CancelledCellinEAI_Item_iE_Extensions__item__id,
        ____CancelledCellinEAI_Item_iE_Extensions__item__criticality_tab,
        ___CancelledCellinEAI_Item_iE_Extensions__item__criticality,
        ____CancelledCellinEAI_Item_iE_Extensions__item__extensionValue_tab,
        ___CancelledCellinEAI_Item_iE_Extensions__item__extensionValue,
        __CancelledCellinEAI_Item_iE_Extensions__item_,
        _CancelledCellinEAI_Item_iE_Extensions,
        CancelledCellinEAI_Item,
        CancelledCellinEAI_Item_ExtIEs,
        _CancelledCellinTAI__item_,
        CancelledCellinTAI,
        _CancelledCellinTAI_Item_eCGI,
        _CancelledCellinTAI_Item_numberOfBroadcasts,
        ____CancelledCellinTAI_Item_iE_Extensions__item__id_tab,
        ___CancelledCellinTAI_Item_iE_Extensions__item__id,
        ____CancelledCellinTAI_Item_iE_Extensions__item__criticality_tab,
        ___CancelledCellinTAI_Item_iE_Extensions__item__criticality,
        ____CancelledCellinTAI_Item_iE_Extensions__item__extensionValue_tab,
        ___CancelledCellinTAI_Item_iE_Extensions__item__extensionValue,
        __CancelledCellinTAI_Item_iE_Extensions__item_,
        _CancelledCellinTAI_Item_iE_Extensions,
        CancelledCellinTAI_Item,
        CancelledCellinTAI_Item_ExtIEs,
        _Cause_radioNetwork,
        _Cause_transport,
        _Cause_nas,
        _Cause_protocol,
        _Cause_misc,
        Cause,
        CauseMisc,
        CauseProtocol,
        CauseRadioNetwork,
        CauseTransport,
        CauseNas,
        CellAccessMode,
        _CellIdentifierAndCELevelForCECapableUEs_global_Cell_ID,
        _CellIdentifierAndCELevelForCECapableUEs_cELevel,
        ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__id_tab,
        ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__id,
        ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__criticality_tab,
        ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__criticality,
        ____CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__extensionValue_tab,
        ___CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item__extensionValue,
        __CellIdentifierAndCELevelForCECapableUEs_iE_Extensions__item_,
        _CellIdentifierAndCELevelForCECapableUEs_iE_Extensions,
        CellIdentifierAndCELevelForCECapableUEs,
        CellIdentifierAndCELevelForCECapableUEs_ExtIEs,
        CELevel,
        CE_mode_B_SupportIndicator,
        CellIdentity,
        _CellID_Broadcast__item_,
        CellID_Broadcast,
        _CellID_Broadcast_Item_eCGI,
        ____CellID_Broadcast_Item_iE_Extensions__item__id_tab,
        ___CellID_Broadcast_Item_iE_Extensions__item__id,
        ____CellID_Broadcast_Item_iE_Extensions__item__criticality_tab,
        ___CellID_Broadcast_Item_iE_Extensions__item__criticality,
        ____CellID_Broadcast_Item_iE_Extensions__item__extensionValue_tab,
        ___CellID_Broadcast_Item_iE_Extensions__item__extensionValue,
        __CellID_Broadcast_Item_iE_Extensions__item_,
        _CellID_Broadcast_Item_iE_Extensions,
        CellID_Broadcast_Item,
        CellID_Broadcast_Item_ExtIEs,
        _CellID_Cancelled__item_,
        CellID_Cancelled,
        _CellID_Cancelled_Item_eCGI,
        _CellID_Cancelled_Item_numberOfBroadcasts,
        ____CellID_Cancelled_Item_iE_Extensions__item__id_tab,
        ___CellID_Cancelled_Item_iE_Extensions__item__id,
        ____CellID_Cancelled_Item_iE_Extensions__item__criticality_tab,
        ___CellID_Cancelled_Item_iE_Extensions__item__criticality,
        ____CellID_Cancelled_Item_iE_Extensions__item__extensionValue_tab,
        ___CellID_Cancelled_Item_iE_Extensions__item__extensionValue,
        __CellID_Cancelled_Item_iE_Extensions__item_,
        _CellID_Cancelled_Item_iE_Extensions,
        CellID_Cancelled_Item,
        CellID_Cancelled_Item_ExtIEs,
        _CellBasedMDT_cellIdListforMDT,
        ____CellBasedMDT_iE_Extensions__item__id_tab,
        ___CellBasedMDT_iE_Extensions__item__id,
        ____CellBasedMDT_iE_Extensions__item__criticality_tab,
        ___CellBasedMDT_iE_Extensions__item__criticality,
        ____CellBasedMDT_iE_Extensions__item__extensionValue_tab,
        ___CellBasedMDT_iE_Extensions__item__extensionValue,
        __CellBasedMDT_iE_Extensions__item_,
        _CellBasedMDT_iE_Extensions,
        CellBasedMDT,
        CellBasedMDT_ExtIEs,
        _CellIdListforMDT__item_,
        CellIdListforMDT,
        _CellBasedQMC_cellIdListforQMC,
        ____CellBasedQMC_iE_Extensions__item__id_tab,
        ___CellBasedQMC_iE_Extensions__item__id,
        ____CellBasedQMC_iE_Extensions__item__criticality_tab,
        ___CellBasedQMC_iE_Extensions__item__criticality,
        ____CellBasedQMC_iE_Extensions__item__extensionValue_tab,
        ___CellBasedQMC_iE_Extensions__item__extensionValue,
        __CellBasedQMC_iE_Extensions__item_,
        _CellBasedQMC_iE_Extensions,
        CellBasedQMC,
        CellBasedQMC_ExtIEs,
        _CellIdListforQMC__item_,
        CellIdListforQMC,
        Cdma2000PDU,
        Cdma2000RATType,
        Cdma2000SectorID,
        Cdma2000HOStatus,
        Cdma2000HORequiredIndication,
        _Cdma2000OneXSRVCCInfo_cdma2000OneXMEID,
        _Cdma2000OneXSRVCCInfo_cdma2000OneXMSI,
        _Cdma2000OneXSRVCCInfo_cdma2000OneXPilot,
        ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__id_tab,
        ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__id,
        ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__criticality_tab,
        ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__criticality,
        ____Cdma2000OneXSRVCCInfo_iE_Extensions__item__extensionValue_tab,
        ___Cdma2000OneXSRVCCInfo_iE_Extensions__item__extensionValue,
        __Cdma2000OneXSRVCCInfo_iE_Extensions__item_,
        _Cdma2000OneXSRVCCInfo_iE_Extensions,
        Cdma2000OneXSRVCCInfo,
        Cdma2000OneXSRVCCInfo_ExtIEs,
        Cdma2000OneXMEID,
        Cdma2000OneXMSI,
        Cdma2000OneXPilot,
        Cdma2000OneXRAND,
        Cell_Size,
        _CellType_cell_Size,
        ____CellType_iE_Extensions__item__id_tab,
        ___CellType_iE_Extensions__item__id,
        ____CellType_iE_Extensions__item__criticality_tab,
        ___CellType_iE_Extensions__item__criticality,
        ____CellType_iE_Extensions__item__extensionValue_tab,
        ___CellType_iE_Extensions__item__extensionValue,
        __CellType_iE_Extensions__item_,
        _CellType_iE_Extensions,
        CellType,
        CellType_ExtIEs,
        _CGI_pLMNidentity,
        _CGI_lAC,
        _CGI_cI,
        _CGI_rAC,
        ____CGI_iE_Extensions__item__id_tab,
        ___CGI_iE_Extensions__item__id,
        ____CGI_iE_Extensions__item__criticality_tab,
        ___CGI_iE_Extensions__item__criticality,
        ____CGI_iE_Extensions__item__extensionValue_tab,
        ___CGI_iE_Extensions__item__extensionValue,
        __CGI_iE_Extensions__item_,
        _CGI_iE_Extensions,
        CGI,
        CGI_ExtIEs,
        CI,
        CNDomain,
        _CNTypeRestrictions__item_,
        CNTypeRestrictions,
        _CNTypeRestrictions_Item_pLMN_Identity,
        _CNTypeRestrictions_Item_cNType,
        ____CNTypeRestrictions_Item_iE_Extensions__item__id_tab,
        ___CNTypeRestrictions_Item_iE_Extensions__item__id,
        ____CNTypeRestrictions_Item_iE_Extensions__item__criticality_tab,
        ___CNTypeRestrictions_Item_iE_Extensions__item__criticality,
        ____CNTypeRestrictions_Item_iE_Extensions__item__extensionValue_tab,
        ___CNTypeRestrictions_Item_iE_Extensions__item__extensionValue,
        __CNTypeRestrictions_Item_iE_Extensions__item_,
        _CNTypeRestrictions_Item_iE_Extensions,
        CNTypeRestrictions_Item,
        CNTypeRestrictions_Item_ExtIEs,
        CNType,
        ConcurrentWarningMessageIndicator,
        _ConnectedengNBList__item_,
        ConnectedengNBList,
        _ConnectedengNBItem_en_gNB_ID,
        _ConnectedengNBItem_supportedTAs,
        ____ConnectedengNBItem_iE_Extensions__item__id_tab,
        ___ConnectedengNBItem_iE_Extensions__item__id,
        ____ConnectedengNBItem_iE_Extensions__item__criticality_tab,
        ___ConnectedengNBItem_iE_Extensions__item__criticality,
        ____ConnectedengNBItem_iE_Extensions__item__extensionValue_tab,
        ___ConnectedengNBItem_iE_Extensions__item__extensionValue,
        __ConnectedengNBItem_iE_Extensions__item_,
        _ConnectedengNBItem_iE_Extensions,
        ConnectedengNBItem,
        ConnectedengNBItem_ExtIEs,
        _ContextatSource_sourceNG_RAN_node_ID,
        _ContextatSource_rAN_UE_NGAP_ID,
        ____ContextatSource_iE_Extensions__item__id_tab,
        ___ContextatSource_iE_Extensions__item__id,
        ____ContextatSource_iE_Extensions__item__criticality_tab,
        ___ContextatSource_iE_Extensions__item__criticality,
        ____ContextatSource_iE_Extensions__item__extensionValue_tab,
        ___ContextatSource_iE_Extensions__item__extensionValue,
        __ContextatSource_iE_Extensions__item_,
        _ContextatSource_iE_Extensions,
        ContextatSource,
        ContextatSource_ExtIEs,
        Correlation_ID,
        CSFallbackIndicator,
        AdditionalCSFallbackIndicator,
        CSG_Id,
        _CSG_IdList__item_,
        CSG_IdList,
        _CSG_IdList_Item_cSG_Id,
        ____CSG_IdList_Item_iE_Extensions__item__id_tab,
        ___CSG_IdList_Item_iE_Extensions__item__id,
        ____CSG_IdList_Item_iE_Extensions__item__criticality_tab,
        ___CSG_IdList_Item_iE_Extensions__item__criticality,
        ____CSG_IdList_Item_iE_Extensions__item__extensionValue_tab,
        ___CSG_IdList_Item_iE_Extensions__item__extensionValue,
        __CSG_IdList_Item_iE_Extensions__item_,
        _CSG_IdList_Item_iE_Extensions,
        CSG_IdList_Item,
        CSG_IdList_Item_ExtIEs,
        CSGMembershipStatus,
        _COUNTvalue_pDCP_SN,
        _COUNTvalue_hFN,
        ____COUNTvalue_iE_Extensions__item__id_tab,
        ___COUNTvalue_iE_Extensions__item__id,
        ____COUNTvalue_iE_Extensions__item__criticality_tab,
        ___COUNTvalue_iE_Extensions__item__criticality,
        ____COUNTvalue_iE_Extensions__item__extensionValue_tab,
        ___COUNTvalue_iE_Extensions__item__extensionValue,
        __COUNTvalue_iE_Extensions__item_,
        _COUNTvalue_iE_Extensions,
        COUNTvalue,
        COUNTvalue_ExtIEs,
        _COUNTValueExtended_pDCP_SNExtended,
        _COUNTValueExtended_hFNModified,
        ____COUNTValueExtended_iE_Extensions__item__id_tab,
        ___COUNTValueExtended_iE_Extensions__item__id,
        ____COUNTValueExtended_iE_Extensions__item__criticality_tab,
        ___COUNTValueExtended_iE_Extensions__item__criticality,
        ____COUNTValueExtended_iE_Extensions__item__extensionValue_tab,
        ___COUNTValueExtended_iE_Extensions__item__extensionValue,
        __COUNTValueExtended_iE_Extensions__item_,
        _COUNTValueExtended_iE_Extensions,
        COUNTValueExtended,
        COUNTValueExtended_ExtIEs,
        _COUNTvaluePDCP_SNlength18_pDCP_SNlength18,
        _COUNTvaluePDCP_SNlength18_hFNforPDCP_SNlength18,
        ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__id_tab,
        ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__id,
        ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality_tab,
        ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__criticality,
        ____COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue_tab,
        ___COUNTvaluePDCP_SNlength18_iE_Extensions__item__extensionValue,
        __COUNTvaluePDCP_SNlength18_iE_Extensions__item_,
        _COUNTvaluePDCP_SNlength18_iE_Extensions,
        COUNTvaluePDCP_SNlength18,
        COUNTvaluePDCP_SNlength18_ExtIEs,
        Coverage_Level,
        _CriticalityDiagnostics_procedureCode,
        _CriticalityDiagnostics_triggeringMessage,
        _CriticalityDiagnostics_procedureCriticality,
        _CriticalityDiagnostics_iEsCriticalityDiagnostics,
        ____CriticalityDiagnostics_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__id,
        ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_iE_Extensions__item_,
        _CriticalityDiagnostics_iE_Extensions,
        CriticalityDiagnostics,
        CriticalityDiagnostics_ExtIEs,
        _CriticalityDiagnostics_IE_List__item_,
        CriticalityDiagnostics_IE_List,
        _CriticalityDiagnostics_IE_Item_iECriticality,
        _CriticalityDiagnostics_IE_Item_iE_ID,
        _CriticalityDiagnostics_IE_Item_typeOfError,
        ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id,
        ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_IE_Item_iE_Extensions__item_,
        _CriticalityDiagnostics_IE_Item_iE_Extensions,
        CriticalityDiagnostics_IE_Item,
        CriticalityDiagnostics_IE_Item_ExtIEs,
        _DAPSRequestInfo_dAPSIndicator,
        ____DAPSRequestInfo_iE_Extensions__item__id_tab,
        ___DAPSRequestInfo_iE_Extensions__item__id,
        ____DAPSRequestInfo_iE_Extensions__item__criticality_tab,
        ___DAPSRequestInfo_iE_Extensions__item__criticality,
        ____DAPSRequestInfo_iE_Extensions__item__extensionValue_tab,
        ___DAPSRequestInfo_iE_Extensions__item__extensionValue,
        __DAPSRequestInfo_iE_Extensions__item_,
        _DAPSRequestInfo_iE_Extensions,
        DAPSRequestInfo,
        DAPSRequestInfo_ExtIEs,
        ___DAPSResponseInfoList__item__id_tab,
        ____DAPSResponseInfoList__item__id_tab_val_Value_0,
        __DAPSResponseInfoList__item__id,
        __DAPSResponseInfoList__item__criticality,
        __DAPSResponseInfoList__item__value,
        _DAPSResponseInfoList__item_,
        DAPSResponseInfoList,
        DAPSResponseInfoListIEs,
        _DAPSResponseInfoListIEs_val_Value_0,
        _DAPSResponseInfoItem_e_RAB_ID,
        _DAPSResponseInfoItem_dAPSResponseInfo,
        ____DAPSResponseInfoItem_iE_Extensions__item__id_tab,
        ___DAPSResponseInfoItem_iE_Extensions__item__id,
        ____DAPSResponseInfoItem_iE_Extensions__item__criticality_tab,
        ___DAPSResponseInfoItem_iE_Extensions__item__criticality,
        ____DAPSResponseInfoItem_iE_Extensions__item__extensionValue_tab,
        ___DAPSResponseInfoItem_iE_Extensions__item__extensionValue,
        __DAPSResponseInfoItem_iE_Extensions__item_,
        _DAPSResponseInfoItem_iE_Extensions,
        DAPSResponseInfoItem,
        DAPSResponseInfoItem_ExtIEs,
        _DAPSResponseInfo_dapsresponseindicator,
        ____DAPSResponseInfo_iE_Extensions__item__id_tab,
        ___DAPSResponseInfo_iE_Extensions__item__id,
        ____DAPSResponseInfo_iE_Extensions__item__criticality_tab,
        ___DAPSResponseInfo_iE_Extensions__item__criticality,
        ____DAPSResponseInfo_iE_Extensions__item__extensionValue_tab,
        ___DAPSResponseInfo_iE_Extensions__item__extensionValue,
        __DAPSResponseInfo_iE_Extensions__item_,
        _DAPSResponseInfo_iE_Extensions,
        DAPSResponseInfo,
        DAPSResponseInfo_ExtIEs,
        DataCodingScheme,
        DataSize,
        DCN_ID,
        _ServedDCNs__item_,
        ServedDCNs,
        _ServedDCNsItem_dCN_ID,
        _ServedDCNsItem_relativeDCNCapacity,
        ____ServedDCNsItem_iE_Extensions__item__id_tab,
        ___ServedDCNsItem_iE_Extensions__item__id,
        ____ServedDCNsItem_iE_Extensions__item__criticality_tab,
        ___ServedDCNsItem_iE_Extensions__item__criticality,
        ____ServedDCNsItem_iE_Extensions__item__extensionValue_tab,
        ___ServedDCNsItem_iE_Extensions__item__extensionValue,
        __ServedDCNsItem_iE_Extensions__item_,
        _ServedDCNsItem_iE_Extensions,
        ServedDCNsItem,
        ServedDCNsItem_ExtIEs,
        _DL_CP_SecurityInformation_dl_NAS_MAC,
        ____DL_CP_SecurityInformation_iE_Extensions__item__id_tab,
        ___DL_CP_SecurityInformation_iE_Extensions__item__id,
        ____DL_CP_SecurityInformation_iE_Extensions__item__criticality_tab,
        ___DL_CP_SecurityInformation_iE_Extensions__item__criticality,
        ____DL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab,
        ___DL_CP_SecurityInformation_iE_Extensions__item__extensionValue,
        __DL_CP_SecurityInformation_iE_Extensions__item_,
        _DL_CP_SecurityInformation_iE_Extensions,
        DL_CP_SecurityInformation,
        DL_CP_SecurityInformation_ExtIEs,
        DL_Forwarding,
        DL_NAS_MAC,
        _DLCOUNT_PDCP_SNlength_dLCOUNTValuePDCP_SNlength12,
        _DLCOUNT_PDCP_SNlength_dLCOUNTValuePDCP_SNlength15,
        _DLCOUNT_PDCP_SNlength_dLCOUNTValuePDCP_SNlength18,
        DLCOUNT_PDCP_SNlength,
        Direct_Forwarding_Path_Availability,
        Data_Forwarding_Not_Possible,
        DLNASPDUDeliveryAckRequest,
        EARFCN,
        _ECGIList__item_,
        ECGIList,
        _PWSfailedECGIList__item_,
        PWSfailedECGIList,
        EDT_Session,
        _EmergencyAreaIDList__item_,
        EmergencyAreaIDList,
        EmergencyAreaID,
        _EmergencyAreaID_Broadcast__item_,
        EmergencyAreaID_Broadcast,
        _EmergencyAreaID_Broadcast_Item_emergencyAreaID,
        _EmergencyAreaID_Broadcast_Item_completedCellinEAI,
        ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__id_tab,
        ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__id,
        ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__criticality_tab,
        ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__criticality,
        ____EmergencyAreaID_Broadcast_Item_iE_Extensions__item__extensionValue_tab,
        ___EmergencyAreaID_Broadcast_Item_iE_Extensions__item__extensionValue,
        __EmergencyAreaID_Broadcast_Item_iE_Extensions__item_,
        _EmergencyAreaID_Broadcast_Item_iE_Extensions,
        EmergencyAreaID_Broadcast_Item,
        EmergencyAreaID_Broadcast_Item_ExtIEs,
        _EmergencyAreaID_Cancelled__item_,
        EmergencyAreaID_Cancelled,
        _EmergencyAreaID_Cancelled_Item_emergencyAreaID,
        _EmergencyAreaID_Cancelled_Item_cancelledCellinEAI,
        ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__id_tab,
        ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__id,
        ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__criticality_tab,
        ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__criticality,
        ____EmergencyAreaID_Cancelled_Item_iE_Extensions__item__extensionValue_tab,
        ___EmergencyAreaID_Cancelled_Item_iE_Extensions__item__extensionValue,
        __EmergencyAreaID_Cancelled_Item_iE_Extensions__item_,
        _EmergencyAreaID_Cancelled_Item_iE_Extensions,
        EmergencyAreaID_Cancelled_Item,
        EmergencyAreaID_Cancelled_Item_ExtIEs,
        _CompletedCellinEAI__item_,
        CompletedCellinEAI,
        _CompletedCellinEAI_Item_eCGI,
        ____CompletedCellinEAI_Item_iE_Extensions__item__id_tab,
        ___CompletedCellinEAI_Item_iE_Extensions__item__id,
        ____CompletedCellinEAI_Item_iE_Extensions__item__criticality_tab,
        ___CompletedCellinEAI_Item_iE_Extensions__item__criticality,
        ____CompletedCellinEAI_Item_iE_Extensions__item__extensionValue_tab,
        ___CompletedCellinEAI_Item_iE_Extensions__item__extensionValue,
        __CompletedCellinEAI_Item_iE_Extensions__item_,
        _CompletedCellinEAI_Item_iE_Extensions,
        CompletedCellinEAI_Item,
        CompletedCellinEAI_Item_ExtIEs,
        _ECGI_List__item_,
        ECGI_List,
        _EmergencyAreaIDListForRestart__item_,
        EmergencyAreaIDListForRestart,
        EmergencyIndicator,
        _ENB_EarlyStatusTransfer_TransparentContainer_bearers_SubjectToEarlyStatusTransferList,
        ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id_tab,
        ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__id,
        ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab,
        ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__criticality,
        ____ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab,
        ___ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue,
        __ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions__item_,
        _ENB_EarlyStatusTransfer_TransparentContainer_iE_Extensions,
        ENB_EarlyStatusTransfer_TransparentContainer,
        ENB_EarlyStatusTransfer_TransparentContainer_ExtIEs,
        _ENB_ID_macroENB_ID,
        _ENB_ID_homeENB_ID,
        _ENB_ID_short_macroENB_ID,
        _ENB_ID_long_macroENB_ID,
        ENB_ID,
        En_gNB_ID,
        _GERAN_Cell_ID_lAI,
        _GERAN_Cell_ID_rAC,
        _GERAN_Cell_ID_cI,
        ____GERAN_Cell_ID_iE_Extensions__item__id_tab,
        ___GERAN_Cell_ID_iE_Extensions__item__id,
        ____GERAN_Cell_ID_iE_Extensions__item__criticality_tab,
        ___GERAN_Cell_ID_iE_Extensions__item__criticality,
        ____GERAN_Cell_ID_iE_Extensions__item__extensionValue_tab,
        ___GERAN_Cell_ID_iE_Extensions__item__extensionValue,
        __GERAN_Cell_ID_iE_Extensions__item_,
        _GERAN_Cell_ID_iE_Extensions,
        GERAN_Cell_ID,
        GERAN_Cell_ID_ExtIEs,
        _Global_ENB_ID_pLMNidentity,
        _Global_ENB_ID_eNB_ID,
        ____Global_ENB_ID_iE_Extensions__item__id_tab,
        ___Global_ENB_ID_iE_Extensions__item__id,
        ____Global_ENB_ID_iE_Extensions__item__criticality_tab,
        ___Global_ENB_ID_iE_Extensions__item__criticality,
        ____Global_ENB_ID_iE_Extensions__item__extensionValue_tab,
        ___Global_ENB_ID_iE_Extensions__item__extensionValue,
        __Global_ENB_ID_iE_Extensions__item_,
        _Global_ENB_ID_iE_Extensions,
        Global_ENB_ID,
        GlobalENB_ID_ExtIEs,
        _Global_en_gNB_ID_pLMNidentity,
        _Global_en_gNB_ID_en_gNB_ID,
        ____Global_en_gNB_ID_iE_Extensions__item__id_tab,
        ___Global_en_gNB_ID_iE_Extensions__item__id,
        ____Global_en_gNB_ID_iE_Extensions__item__criticality_tab,
        ___Global_en_gNB_ID_iE_Extensions__item__criticality,
        ____Global_en_gNB_ID_iE_Extensions__item__extensionValue_tab,
        ___Global_en_gNB_ID_iE_Extensions__item__extensionValue,
        __Global_en_gNB_ID_iE_Extensions__item_,
        _Global_en_gNB_ID_iE_Extensions,
        Global_en_gNB_ID,
        Global_en_gNB_ID_ExtIEs,
        _GUMMEIList__item_,
        GUMMEIList,
        _ENB_StatusTransfer_TransparentContainer_bearers_SubjectToStatusTransferList,
        ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__id_tab,
        ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__id,
        ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__criticality_tab,
        ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__criticality,
        ____ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue_tab,
        ___ENB_StatusTransfer_TransparentContainer_iE_Extensions__item__extensionValue,
        __ENB_StatusTransfer_TransparentContainer_iE_Extensions__item_,
        _ENB_StatusTransfer_TransparentContainer_iE_Extensions,
        ENB_StatusTransfer_TransparentContainer,
        ENB_StatusTransfer_TransparentContainer_ExtIEs,
        ENB_UE_S1AP_ID,
        ENBname,
        _ENBX2TLAs__item_,
        ENBX2TLAs,
        EncryptionAlgorithms,
        _EN_DCSONConfigurationTransfer_transfertype,
        _EN_DCSONConfigurationTransfer_sONInformation,
        _EN_DCSONConfigurationTransfer_x2TNLConfigInfo,
        ____EN_DCSONConfigurationTransfer_iE_Extensions__item__id_tab,
        ___EN_DCSONConfigurationTransfer_iE_Extensions__item__id,
        ____EN_DCSONConfigurationTransfer_iE_Extensions__item__criticality_tab,
        ___EN_DCSONConfigurationTransfer_iE_Extensions__item__criticality,
        ____EN_DCSONConfigurationTransfer_iE_Extensions__item__extensionValue_tab,
        ___EN_DCSONConfigurationTransfer_iE_Extensions__item__extensionValue,
        __EN_DCSONConfigurationTransfer_iE_Extensions__item_,
        _EN_DCSONConfigurationTransfer_iE_Extensions,
        EN_DCSONConfigurationTransfer,
        EN_DCSONConfigurationTransfer_ExtIEs,
        _EN_DCSONTransferType_request,
        _EN_DCSONTransferType_reply,
        EN_DCSONTransferType,
        _EN_DCTransferTypeRequest_sourceeNB,
        _EN_DCTransferTypeRequest_targetengNB,
        _EN_DCTransferTypeRequest_targeteNB,
        _EN_DCTransferTypeRequest_associatedTAI,
        _EN_DCTransferTypeRequest_broadcast5GSTAI,
        ____EN_DCTransferTypeRequest_iE_Extensions__item__id_tab,
        ___EN_DCTransferTypeRequest_iE_Extensions__item__id,
        ____EN_DCTransferTypeRequest_iE_Extensions__item__criticality_tab,
        ___EN_DCTransferTypeRequest_iE_Extensions__item__criticality,
        ____EN_DCTransferTypeRequest_iE_Extensions__item__extensionValue_tab,
        ___EN_DCTransferTypeRequest_iE_Extensions__item__extensionValue,
        __EN_DCTransferTypeRequest_iE_Extensions__item_,
        _EN_DCTransferTypeRequest_iE_Extensions,
        EN_DCTransferTypeRequest,
        EN_DCTransferTypeRequest_ExtIEs,
        _EN_DCTransferTypeReply_sourceengNB,
        _EN_DCTransferTypeReply_targeteNB,
        ____EN_DCTransferTypeReply_iE_Extensions__item__id_tab,
        ___EN_DCTransferTypeReply_iE_Extensions__item__id,
        ____EN_DCTransferTypeReply_iE_Extensions__item__criticality_tab,
        ___EN_DCTransferTypeReply_iE_Extensions__item__criticality,
        ____EN_DCTransferTypeReply_iE_Extensions__item__extensionValue_tab,
        ___EN_DCTransferTypeReply_iE_Extensions__item__extensionValue,
        __EN_DCTransferTypeReply_iE_Extensions__item_,
        _EN_DCTransferTypeReply_iE_Extensions,
        EN_DCTransferTypeReply,
        EN_DCTransferTypeReply_ExtIEs,
        _EN_DCSONeNBIdentification_globaleNBID,
        _EN_DCSONeNBIdentification_selectedTAI,
        ____EN_DCSONeNBIdentification_iE_Extensions__item__id_tab,
        ___EN_DCSONeNBIdentification_iE_Extensions__item__id,
        ____EN_DCSONeNBIdentification_iE_Extensions__item__criticality_tab,
        ___EN_DCSONeNBIdentification_iE_Extensions__item__criticality,
        ____EN_DCSONeNBIdentification_iE_Extensions__item__extensionValue_tab,
        ___EN_DCSONeNBIdentification_iE_Extensions__item__extensionValue,
        __EN_DCSONeNBIdentification_iE_Extensions__item_,
        _EN_DCSONeNBIdentification_iE_Extensions,
        EN_DCSONeNBIdentification,
        EN_DCSONeNBIdentification_ExtIEs,
        _EN_DCSONengNBIdentification_globalengNBID,
        _EN_DCSONengNBIdentification_selectedTAI,
        ____EN_DCSONengNBIdentification_iE_Extensions__item__id_tab,
        ___EN_DCSONengNBIdentification_iE_Extensions__item__id,
        ____EN_DCSONengNBIdentification_iE_Extensions__item__criticality_tab,
        ___EN_DCSONengNBIdentification_iE_Extensions__item__criticality,
        ____EN_DCSONengNBIdentification_iE_Extensions__item__extensionValue_tab,
        ___EN_DCSONengNBIdentification_iE_Extensions__item__extensionValue,
        __EN_DCSONengNBIdentification_iE_Extensions__item_,
        _EN_DCSONengNBIdentification_iE_Extensions,
        EN_DCSONengNBIdentification,
        EN_DCSONengNBIdentification_ExtIEs,
        EndIndication,
        EnhancedCoverageRestricted,
        CE_ModeBRestricted,
        _EPLMNs__item_,
        EPLMNs,
        EventType,
        E_RAB_ID,
        ___E_RABInformationList__item__id_tab,
        ____E_RABInformationList__item__id_tab_val_Value_0,
        __E_RABInformationList__item__id,
        __E_RABInformationList__item__criticality,
        __E_RABInformationList__item__value,
        _E_RABInformationList__item_,
        E_RABInformationList,
        E_RABInformationListIEs,
        _E_RABInformationListIEs_val_Value_0,
        _E_RABInformationListItem_e_RAB_ID,
        _E_RABInformationListItem_dL_Forwarding,
        ____E_RABInformationListItem_iE_Extensions__item__id_tab,
        _____E_RABInformationListItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABInformationListItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABInformationListItem_iE_Extensions__item__id_tab_val_Extension_2,
        ___E_RABInformationListItem_iE_Extensions__item__id,
        ___E_RABInformationListItem_iE_Extensions__item__criticality,
        ___E_RABInformationListItem_iE_Extensions__item__extensionValue,
        __E_RABInformationListItem_iE_Extensions__item_,
        _E_RABInformationListItem_iE_Extensions,
        E_RABInformationListItem,
        E_RABInformationListItem_ExtIEs,
        _E_RABInformationListItem_ExtIEs_val_Extension_0,
        _E_RABInformationListItem_ExtIEs_val_Extension_1,
        _E_RABInformationListItem_ExtIEs_val_Extension_2,
        ___E_RABList__item__id_tab,
        ____E_RABList__item__id_tab_val_Value_0,
        __E_RABList__item__id,
        __E_RABList__item__criticality,
        __E_RABList__item__value,
        _E_RABList__item_,
        E_RABList,
        E_RABItemIEs,
        _E_RABItemIEs_val_Value_0,
        _E_RABItem_e_RAB_ID,
        _E_RABItem_cause,
        ____E_RABItem_iE_Extensions__item__id_tab,
        ___E_RABItem_iE_Extensions__item__id,
        ____E_RABItem_iE_Extensions__item__criticality_tab,
        ___E_RABItem_iE_Extensions__item__criticality,
        ____E_RABItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABItem_iE_Extensions__item__extensionValue,
        __E_RABItem_iE_Extensions__item_,
        _E_RABItem_iE_Extensions,
        E_RABItem,
        E_RABItem_ExtIEs,
        _E_RABLevelQoSParameters_qCI,
        _E_RABLevelQoSParameters_allocationRetentionPriority,
        _E_RABLevelQoSParameters_gbrQosInformation,
        ____E_RABLevelQoSParameters_iE_Extensions__item__id_tab,
        _____E_RABLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABLevelQoSParameters_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_RABLevelQoSParameters_iE_Extensions__item__id,
        ___E_RABLevelQoSParameters_iE_Extensions__item__criticality,
        ___E_RABLevelQoSParameters_iE_Extensions__item__extensionValue,
        __E_RABLevelQoSParameters_iE_Extensions__item_,
        _E_RABLevelQoSParameters_iE_Extensions,
        E_RABLevelQoSParameters,
        ___E_RABUsageReportList__item__id_tab,
        ____E_RABUsageReportList__item__id_tab_val_Value_0,
        __E_RABUsageReportList__item__id,
        __E_RABUsageReportList__item__criticality,
        __E_RABUsageReportList__item__value,
        _E_RABUsageReportList__item_,
        E_RABUsageReportList,
        E_RABUsageReportItemIEs,
        _E_RABUsageReportItemIEs_val_Value_0,
        _E_RABUsageReportItem_startTimestamp,
        _E_RABUsageReportItem_endTimestamp,
        _E_RABUsageReportItem_usageCountUL,
        _E_RABUsageReportItem_usageCountDL,
        ____E_RABUsageReportItem_iE_Extensions__item__id_tab,
        ___E_RABUsageReportItem_iE_Extensions__item__id,
        ____E_RABUsageReportItem_iE_Extensions__item__criticality_tab,
        ___E_RABUsageReportItem_iE_Extensions__item__criticality,
        ____E_RABUsageReportItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABUsageReportItem_iE_Extensions__item__extensionValue,
        __E_RABUsageReportItem_iE_Extensions__item_,
        _E_RABUsageReportItem_iE_Extensions,
        E_RABUsageReportItem,
        E_RABUsageReportItem_ExtIEs,
        E_RABQoSParameters_ExtIEs,
        _E_RABQoSParameters_ExtIEs_val_Extension_0,
        _E_RABQoSParameters_ExtIEs_val_Extension_1,
        Ethernet_Type,
        _EUTRAN_CGI_pLMNidentity,
        _EUTRAN_CGI_cell_ID,
        ____EUTRAN_CGI_iE_Extensions__item__id_tab,
        ___EUTRAN_CGI_iE_Extensions__item__id,
        ____EUTRAN_CGI_iE_Extensions__item__criticality_tab,
        ___EUTRAN_CGI_iE_Extensions__item__criticality,
        ____EUTRAN_CGI_iE_Extensions__item__extensionValue_tab,
        ___EUTRAN_CGI_iE_Extensions__item__extensionValue,
        __EUTRAN_CGI_iE_Extensions__item_,
        _EUTRAN_CGI_iE_Extensions,
        EUTRAN_CGI,
        EUTRAN_CGI_ExtIEs,
        EUTRANRoundTripDelayEstimationInfo,
        _ExpectedUEBehaviour_expectedActivity,
        _ExpectedUEBehaviour_expectedHOInterval,
        ____ExpectedUEBehaviour_iE_Extensions__item__id_tab,
        ___ExpectedUEBehaviour_iE_Extensions__item__id,
        ____ExpectedUEBehaviour_iE_Extensions__item__criticality_tab,
        ___ExpectedUEBehaviour_iE_Extensions__item__criticality,
        ____ExpectedUEBehaviour_iE_Extensions__item__extensionValue_tab,
        ___ExpectedUEBehaviour_iE_Extensions__item__extensionValue,
        __ExpectedUEBehaviour_iE_Extensions__item_,
        _ExpectedUEBehaviour_iE_Extensions,
        ExpectedUEBehaviour,
        ExpectedUEBehaviour_ExtIEs,
        _ExpectedUEActivityBehaviour_expectedActivityPeriod,
        _ExpectedUEActivityBehaviour_expectedIdlePeriod,
        _ExpectedUEActivityBehaviour_sourceofUEActivityBehaviourInformation,
        ____ExpectedUEActivityBehaviour_iE_Extensions__item__id_tab,
        ___ExpectedUEActivityBehaviour_iE_Extensions__item__id,
        ____ExpectedUEActivityBehaviour_iE_Extensions__item__criticality_tab,
        ___ExpectedUEActivityBehaviour_iE_Extensions__item__criticality,
        ____ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue_tab,
        ___ExpectedUEActivityBehaviour_iE_Extensions__item__extensionValue,
        __ExpectedUEActivityBehaviour_iE_Extensions__item_,
        _ExpectedUEActivityBehaviour_iE_Extensions,
        ExpectedUEActivityBehaviour,
        ExpectedUEActivityBehaviour_ExtIEs,
        ExpectedActivityPeriod,
        ExpectedIdlePeriod,
        SourceOfUEActivityBehaviourInformation,
        ExpectedHOInterval,
        ExtendedBitRate,
        ExtendedRNC_ID,
        ExtendedRepetitionPeriod,
        Extended_UEIdentityIndexValue,
        FiveGSTAC,
        _FiveGSTAI_pLMNidentity,
        _FiveGSTAI_fiveGSTAC,
        ____FiveGSTAI_iE_Extensions__item__id_tab,
        ___FiveGSTAI_iE_Extensions__item__id,
        ____FiveGSTAI_iE_Extensions__item__criticality_tab,
        ___FiveGSTAI_iE_Extensions__item__criticality,
        ____FiveGSTAI_iE_Extensions__item__extensionValue_tab,
        ___FiveGSTAI_iE_Extensions__item__extensionValue,
        __FiveGSTAI_iE_Extensions__item_,
        _FiveGSTAI_iE_Extensions,
        FiveGSTAI,
        FiveGSTAI_ExtIEs,
        FiveQI,
        ForbiddenInterRATs,
        _ForbiddenTAs__item_,
        ForbiddenTAs,
        _ForbiddenTAs_Item_pLMN_Identity,
        _ForbiddenTAs_Item_forbiddenTACs,
        ____ForbiddenTAs_Item_iE_Extensions__item__id_tab,
        ___ForbiddenTAs_Item_iE_Extensions__item__id,
        ____ForbiddenTAs_Item_iE_Extensions__item__criticality_tab,
        ___ForbiddenTAs_Item_iE_Extensions__item__criticality,
        ____ForbiddenTAs_Item_iE_Extensions__item__extensionValue_tab,
        ___ForbiddenTAs_Item_iE_Extensions__item__extensionValue,
        __ForbiddenTAs_Item_iE_Extensions__item_,
        _ForbiddenTAs_Item_iE_Extensions,
        ForbiddenTAs_Item,
        ForbiddenTAs_Item_ExtIEs,
        _ForbiddenTACs__item_,
        ForbiddenTACs,
        _ForbiddenLAs__item_,
        ForbiddenLAs,
        _ForbiddenLAs_Item_pLMN_Identity,
        _ForbiddenLAs_Item_forbiddenLACs,
        ____ForbiddenLAs_Item_iE_Extensions__item__id_tab,
        ___ForbiddenLAs_Item_iE_Extensions__item__id,
        ____ForbiddenLAs_Item_iE_Extensions__item__criticality_tab,
        ___ForbiddenLAs_Item_iE_Extensions__item__criticality,
        ____ForbiddenLAs_Item_iE_Extensions__item__extensionValue_tab,
        ___ForbiddenLAs_Item_iE_Extensions__item__extensionValue,
        __ForbiddenLAs_Item_iE_Extensions__item_,
        _ForbiddenLAs_Item_iE_Extensions,
        ForbiddenLAs_Item,
        ForbiddenLAs_Item_ExtIEs,
        _ForbiddenLACs__item_,
        ForbiddenLACs,
        _GBR_QosInformation_e_RAB_MaximumBitrateDL,
        _GBR_QosInformation_e_RAB_MaximumBitrateUL,
        _GBR_QosInformation_e_RAB_GuaranteedBitrateDL,
        _GBR_QosInformation_e_RAB_GuaranteedBitrateUL,
        ____GBR_QosInformation_iE_Extensions__item__id_tab,
        _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_1,
        _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_2,
        _____GBR_QosInformation_iE_Extensions__item__id_tab_val_Extension_3,
        ___GBR_QosInformation_iE_Extensions__item__id,
        ___GBR_QosInformation_iE_Extensions__item__criticality,
        ___GBR_QosInformation_iE_Extensions__item__extensionValue,
        __GBR_QosInformation_iE_Extensions__item_,
        _GBR_QosInformation_iE_Extensions,
        GBR_QosInformation,
        GBR_QosInformation_ExtIEs,
        _GBR_QosInformation_ExtIEs_val_Extension_0,
        _GBR_QosInformation_ExtIEs_val_Extension_1,
        _GBR_QosInformation_ExtIEs_val_Extension_2,
        _GBR_QosInformation_ExtIEs_val_Extension_3,
        GTP_TEID,
        _GUMMEI_pLMN_Identity,
        _GUMMEI_mME_Group_ID,
        _GUMMEI_mME_Code,
        ____GUMMEI_iE_Extensions__item__id_tab,
        ___GUMMEI_iE_Extensions__item__id,
        ____GUMMEI_iE_Extensions__item__criticality_tab,
        ___GUMMEI_iE_Extensions__item__criticality,
        ____GUMMEI_iE_Extensions__item__extensionValue_tab,
        ___GUMMEI_iE_Extensions__item__extensionValue,
        __GUMMEI_iE_Extensions__item_,
        _GUMMEI_iE_Extensions,
        GUMMEI,
        GUMMEI_ExtIEs,
        GUMMEIType,
        GWContextReleaseIndication,
        HandoverFlag,
        _HandoverRestrictionList_servingPLMN,
        _HandoverRestrictionList_equivalentPLMNs,
        _HandoverRestrictionList_forbiddenTAs,
        _HandoverRestrictionList_forbiddenLAs,
        _HandoverRestrictionList_forbiddenInterRATs,
        ____HandoverRestrictionList_iE_Extensions__item__id_tab,
        _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_0,
        _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_1,
        _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_2,
        _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_3,
        _____HandoverRestrictionList_iE_Extensions__item__id_tab_val_Extension_4,
        ___HandoverRestrictionList_iE_Extensions__item__id,
        ___HandoverRestrictionList_iE_Extensions__item__criticality,
        ___HandoverRestrictionList_iE_Extensions__item__extensionValue,
        __HandoverRestrictionList_iE_Extensions__item_,
        _HandoverRestrictionList_iE_Extensions,
        HandoverRestrictionList,
        HandoverRestrictionList_ExtIEs,
        _HandoverRestrictionList_ExtIEs_val_Extension_0,
        _HandoverRestrictionList_ExtIEs_val_Extension_1,
        _HandoverRestrictionList_ExtIEs_val_Extension_2,
        _HandoverRestrictionList_ExtIEs_val_Extension_3,
        _HandoverRestrictionList_ExtIEs_val_Extension_4,
        HandoverType,
        HFN,
        HFNModified,
        HFNforPDCP_SNlength18,
        Masked_IMEISV,
        _ImmediateMDT_measurementsToActivate,
        _ImmediateMDT_m1reportingTrigger,
        _ImmediateMDT_m1thresholdeventA2,
        _ImmediateMDT_m1periodicReporting,
        ____ImmediateMDT_iE_Extensions__item__id_tab,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_0,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_1,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_2,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_3,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_4,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_5,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_6,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_7,
        ___ImmediateMDT_iE_Extensions__item__id,
        ___ImmediateMDT_iE_Extensions__item__criticality,
        ___ImmediateMDT_iE_Extensions__item__extensionValue,
        __ImmediateMDT_iE_Extensions__item_,
        _ImmediateMDT_iE_Extensions,
        ImmediateMDT,
        ImmediateMDT_ExtIEs,
        _ImmediateMDT_ExtIEs_val_Extension_0,
        _ImmediateMDT_ExtIEs_val_Extension_1,
        _ImmediateMDT_ExtIEs_val_Extension_2,
        _ImmediateMDT_ExtIEs_val_Extension_3,
        _ImmediateMDT_ExtIEs_val_Extension_4,
        _ImmediateMDT_ExtIEs_val_Extension_5,
        _ImmediateMDT_ExtIEs_val_Extension_6,
        _ImmediateMDT_ExtIEs_val_Extension_7,
        IMSI,
        _InformationOnRecommendedCellsAndENBsForPaging_recommendedCellsForPaging,
        _InformationOnRecommendedCellsAndENBsForPaging_recommendENBsForPaging,
        ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__id_tab,
        ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__id,
        ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__criticality_tab,
        ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__criticality,
        ____InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__extensionValue_tab,
        ___InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item__extensionValue,
        __InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions__item_,
        _InformationOnRecommendedCellsAndENBsForPaging_iE_Extensions,
        InformationOnRecommendedCellsAndENBsForPaging,
        InformationOnRecommendedCellsAndENBsForPaging_ExtIEs,
        IntegrityProtectionAlgorithms,
        IntendedNumberOfPagingAttempts,
        InterfacesToTrace,
        _IntersystemMeasurementConfiguration_rSRP,
        _IntersystemMeasurementConfiguration_rSRQ,
        _IntersystemMeasurementConfiguration_sINR,
        _IntersystemMeasurementConfiguration_interSystemMeasurementParameters,
        ____IntersystemMeasurementConfiguration_iE_Extensions__item__id_tab,
        ___IntersystemMeasurementConfiguration_iE_Extensions__item__id,
        ____IntersystemMeasurementConfiguration_iE_Extensions__item__criticality_tab,
        ___IntersystemMeasurementConfiguration_iE_Extensions__item__criticality,
        ____IntersystemMeasurementConfiguration_iE_Extensions__item__extensionValue_tab,
        ___IntersystemMeasurementConfiguration_iE_Extensions__item__extensionValue,
        __IntersystemMeasurementConfiguration_iE_Extensions__item_,
        _IntersystemMeasurementConfiguration_iE_Extensions,
        IntersystemMeasurementConfiguration,
        IntersystemMeasurementConfiguration_ExtIEs,
        _InterSystemMeasurementParameters_measurementDuration,
        _InterSystemMeasurementParameters_interSystemMeasurementList,
        ____InterSystemMeasurementParameters_iE_Extensions__item__id_tab,
        ___InterSystemMeasurementParameters_iE_Extensions__item__id,
        ____InterSystemMeasurementParameters_iE_Extensions__item__criticality_tab,
        ___InterSystemMeasurementParameters_iE_Extensions__item__criticality,
        ____InterSystemMeasurementParameters_iE_Extensions__item__extensionValue_tab,
        ___InterSystemMeasurementParameters_iE_Extensions__item__extensionValue,
        __InterSystemMeasurementParameters_iE_Extensions__item_,
        _InterSystemMeasurementParameters_iE_Extensions,
        InterSystemMeasurementParameters,
        InterSystemMeasurementParameters_ExtIEs,
        _InterSystemMeasurementList__item_,
        InterSystemMeasurementList,
        _InterSystemMeasurementItem_freqBandIndicatorNR,
        _InterSystemMeasurementItem_sSBfrequencies,
        _InterSystemMeasurementItem_subcarrierSpacingSSB,
        _InterSystemMeasurementItem_maxRSIndexCellQual,
        _InterSystemMeasurementItem_sMTC,
        _InterSystemMeasurementItem_threshRS_Index_r15,
        _InterSystemMeasurementItem_sSBToMeasure,
        _InterSystemMeasurementItem_sSRSSIMeasurement,
        _InterSystemMeasurementItem_quantityConfigNR_R15,
        _InterSystemMeasurementItem_blackCellsToAddModList,
        ____InterSystemMeasurementItem_iE_Extensions__item__id_tab,
        ___InterSystemMeasurementItem_iE_Extensions__item__id,
        ____InterSystemMeasurementItem_iE_Extensions__item__criticality_tab,
        ___InterSystemMeasurementItem_iE_Extensions__item__criticality,
        ____InterSystemMeasurementItem_iE_Extensions__item__extensionValue_tab,
        ___InterSystemMeasurementItem_iE_Extensions__item__extensionValue,
        __InterSystemMeasurementItem_iE_Extensions__item_,
        _InterSystemMeasurementItem_iE_Extensions,
        InterSystemMeasurementItem,
        InterSystemMeasurementItem_ExtIEs,
        IntersystemSONConfigurationTransfer,
        IMSvoiceEPSfallbackfrom5G,
        IAB_Authorized,
        IAB_Node_Indication,
        IAB_Supported,
        KillAllWarningMessages,
        LAC,
        _LAI_pLMNidentity,
        _LAI_lAC,
        ____LAI_iE_Extensions__item__id_tab,
        ___LAI_iE_Extensions__item__id,
        ____LAI_iE_Extensions__item__criticality_tab,
        ___LAI_iE_Extensions__item__criticality,
        ____LAI_iE_Extensions__item__extensionValue_tab,
        ___LAI_iE_Extensions__item__extensionValue,
        __LAI_iE_Extensions__item_,
        _LAI_iE_Extensions,
        LAI,
        LAI_ExtIEs,
        _LastVisitedCell_Item_e_UTRAN_Cell,
        _LastVisitedCell_Item_uTRAN_Cell,
        _LastVisitedCell_Item_gERAN_Cell,
        _LastVisitedCell_Item_nG_RAN_Cell,
        LastVisitedCell_Item,
        _LastVisitedEUTRANCellInformation_global_Cell_ID,
        _LastVisitedEUTRANCellInformation_cellType,
        _LastVisitedEUTRANCellInformation_time_UE_StayedInCell,
        ____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab,
        _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____LastVisitedEUTRANCellInformation_iE_Extensions__item__id_tab_val_Extension_1,
        ___LastVisitedEUTRANCellInformation_iE_Extensions__item__id,
        ___LastVisitedEUTRANCellInformation_iE_Extensions__item__criticality,
        ___LastVisitedEUTRANCellInformation_iE_Extensions__item__extensionValue,
        __LastVisitedEUTRANCellInformation_iE_Extensions__item_,
        _LastVisitedEUTRANCellInformation_iE_Extensions,
        LastVisitedEUTRANCellInformation,
        LastVisitedEUTRANCellInformation_ExtIEs,
        _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_0,
        _LastVisitedEUTRANCellInformation_ExtIEs_val_Extension_1,
        LastVisitedNGRANCellInformation,
        LastVisitedUTRANCellInformation,
        _LastVisitedGERANCellInformation_undefined,
        LastVisitedGERANCellInformation,
        L3_Information,
        LPPa_PDU,
        LHN_ID,
        Links_to_log,
        _ListeningSubframePattern_pattern_period,
        _ListeningSubframePattern_pattern_offset,
        ____ListeningSubframePattern_iE_Extensions__item__id_tab,
        ___ListeningSubframePattern_iE_Extensions__item__id,
        ____ListeningSubframePattern_iE_Extensions__item__criticality_tab,
        ___ListeningSubframePattern_iE_Extensions__item__criticality,
        ____ListeningSubframePattern_iE_Extensions__item__extensionValue_tab,
        ___ListeningSubframePattern_iE_Extensions__item__extensionValue,
        __ListeningSubframePattern_iE_Extensions__item_,
        _ListeningSubframePattern_iE_Extensions,
        ListeningSubframePattern,
        ListeningSubframePattern_ExtIEs,
        _LoggedMDT_loggingInterval,
        _LoggedMDT_loggingDuration,
        ____LoggedMDT_iE_Extensions__item__id_tab,
        _____LoggedMDT_iE_Extensions__item__id_tab_val_Extension_0,
        _____LoggedMDT_iE_Extensions__item__id_tab_val_Extension_1,
        ___LoggedMDT_iE_Extensions__item__id,
        ___LoggedMDT_iE_Extensions__item__criticality,
        ___LoggedMDT_iE_Extensions__item__extensionValue,
        __LoggedMDT_iE_Extensions__item_,
        _LoggedMDT_iE_Extensions,
        LoggedMDT,
        LoggedMDT_ExtIEs,
        _LoggedMDT_ExtIEs_val_Extension_0,
        _LoggedMDT_ExtIEs_val_Extension_1,
        LoggingInterval,
        LoggingDuration,
        _LoggedMBSFNMDT_loggingInterval,
        _LoggedMBSFNMDT_loggingDuration,
        _LoggedMBSFNMDT_mBSFN_ResultToLog,
        ____LoggedMBSFNMDT_iE_Extensions__item__id_tab,
        ___LoggedMBSFNMDT_iE_Extensions__item__id,
        ____LoggedMBSFNMDT_iE_Extensions__item__criticality_tab,
        ___LoggedMBSFNMDT_iE_Extensions__item__criticality,
        ____LoggedMBSFNMDT_iE_Extensions__item__extensionValue_tab,
        ___LoggedMBSFNMDT_iE_Extensions__item__extensionValue,
        __LoggedMBSFNMDT_iE_Extensions__item_,
        _LoggedMBSFNMDT_iE_Extensions,
        LoggedMBSFNMDT,
        LoggedMBSFNMDT_ExtIEs,
        LTE_M_Indication,
        _M3Configuration_m3period,
        ____M3Configuration_iE_Extensions__item__id_tab,
        ___M3Configuration_iE_Extensions__item__id,
        ____M3Configuration_iE_Extensions__item__criticality_tab,
        ___M3Configuration_iE_Extensions__item__criticality,
        ____M3Configuration_iE_Extensions__item__extensionValue_tab,
        ___M3Configuration_iE_Extensions__item__extensionValue,
        __M3Configuration_iE_Extensions__item_,
        _M3Configuration_iE_Extensions,
        M3Configuration,
        M3Configuration_ExtIEs,
        M3period,
        _M4Configuration_m4period,
        _M4Configuration_m4_links_to_log,
        ____M4Configuration_iE_Extensions__item__id_tab,
        ___M4Configuration_iE_Extensions__item__id,
        ____M4Configuration_iE_Extensions__item__criticality_tab,
        ___M4Configuration_iE_Extensions__item__criticality,
        ____M4Configuration_iE_Extensions__item__extensionValue_tab,
        ___M4Configuration_iE_Extensions__item__extensionValue,
        __M4Configuration_iE_Extensions__item_,
        _M4Configuration_iE_Extensions,
        M4Configuration,
        M4Configuration_ExtIEs,
        M4period,
        _M5Configuration_m5period,
        _M5Configuration_m5_links_to_log,
        ____M5Configuration_iE_Extensions__item__id_tab,
        ___M5Configuration_iE_Extensions__item__id,
        ____M5Configuration_iE_Extensions__item__criticality_tab,
        ___M5Configuration_iE_Extensions__item__criticality,
        ____M5Configuration_iE_Extensions__item__extensionValue_tab,
        ___M5Configuration_iE_Extensions__item__extensionValue,
        __M5Configuration_iE_Extensions__item_,
        _M5Configuration_iE_Extensions,
        M5Configuration,
        M5Configuration_ExtIEs,
        M5period,
        _M6Configuration_m6report_Interval,
        _M6Configuration_m6delay_threshold,
        _M6Configuration_m6_links_to_log,
        ____M6Configuration_iE_Extensions__item__id_tab,
        ___M6Configuration_iE_Extensions__item__id,
        ____M6Configuration_iE_Extensions__item__criticality_tab,
        ___M6Configuration_iE_Extensions__item__criticality,
        ____M6Configuration_iE_Extensions__item__extensionValue_tab,
        ___M6Configuration_iE_Extensions__item__extensionValue,
        __M6Configuration_iE_Extensions__item_,
        _M6Configuration_iE_Extensions,
        M6Configuration,
        M6Configuration_ExtIEs,
        M6report_Interval,
        M6delay_threshold,
        _M7Configuration_m7period,
        _M7Configuration_m7_links_to_log,
        ____M7Configuration_iE_Extensions__item__id_tab,
        ___M7Configuration_iE_Extensions__item__id,
        ____M7Configuration_iE_Extensions__item__criticality_tab,
        ___M7Configuration_iE_Extensions__item__criticality,
        ____M7Configuration_iE_Extensions__item__extensionValue_tab,
        ___M7Configuration_iE_Extensions__item__extensionValue,
        __M7Configuration_iE_Extensions__item_,
        _M7Configuration_iE_Extensions,
        M7Configuration,
        M7Configuration_ExtIEs,
        M7period,
        MDT_Activation,
        MDT_Location_Info,
        _MDT_Configuration_mdt_Activation,
        _MDT_Configuration_areaScopeOfMDT,
        _MDT_Configuration_mDTMode,
        ____MDT_Configuration_iE_Extensions__item__id_tab,
        _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_0,
        ___MDT_Configuration_iE_Extensions__item__id,
        ___MDT_Configuration_iE_Extensions__item__criticality,
        ___MDT_Configuration_iE_Extensions__item__extensionValue,
        __MDT_Configuration_iE_Extensions__item_,
        _MDT_Configuration_iE_Extensions,
        MDT_Configuration,
        MDT_Configuration_ExtIEs,
        _MDT_Configuration_ExtIEs_val_Extension_0,
        ManagementBasedMDTAllowed,
        _MBSFN_ResultToLog__item_,
        MBSFN_ResultToLog,
        _MBSFN_ResultToLogInfo_mBSFN_AreaId,
        _MBSFN_ResultToLogInfo_carrierFreq,
        ____MBSFN_ResultToLogInfo_iE_Extensions__item__id_tab,
        ___MBSFN_ResultToLogInfo_iE_Extensions__item__id,
        ____MBSFN_ResultToLogInfo_iE_Extensions__item__criticality_tab,
        ___MBSFN_ResultToLogInfo_iE_Extensions__item__criticality,
        ____MBSFN_ResultToLogInfo_iE_Extensions__item__extensionValue_tab,
        ___MBSFN_ResultToLogInfo_iE_Extensions__item__extensionValue,
        __MBSFN_ResultToLogInfo_iE_Extensions__item_,
        _MBSFN_ResultToLogInfo_iE_Extensions,
        MBSFN_ResultToLogInfo,
        MBSFN_ResultToLogInfo_ExtIEs,
        _MDTPLMNList__item_,
        MDTPLMNList,
        PrivacyIndicator,
        _MDTMode_immediateMDT,
        _MDTMode_loggedMDT,
        _MDTMode_mDTMode_Extension,
        MDTMode,
        __MDTMode_Extension_id_tab,
        ___MDTMode_Extension_id_tab_val_Value_0,
        _MDTMode_Extension_id,
        _MDTMode_Extension_criticality,
        _MDTMode_Extension_value,
        MDTMode_Extension,
        MDTMode_ExtensionIE,
        _MDTMode_ExtensionIE_val_Value_0,
        MeasurementsToActivate,
        _MeasurementThresholdA2_threshold_RSRP,
        _MeasurementThresholdA2_threshold_RSRQ,
        MeasurementThresholdA2,
        MessageIdentifier,
        MobilityInformation,
        MMEname,
        _MMEPagingTarget_global_ENB_ID,
        _MMEPagingTarget_tAI,
        MMEPagingTarget,
        MMERelaySupportIndicator,
        MME_Group_ID,
        MME_Code,
        MME_UE_S1AP_ID,
        M_TMSI,
        MSClassmark2,
        MSClassmark3,
        MutingAvailabilityIndication,
        _MutingPatternInformation_muting_pattern_period,
        _MutingPatternInformation_muting_pattern_offset,
        ____MutingPatternInformation_iE_Extensions__item__id_tab,
        ___MutingPatternInformation_iE_Extensions__item__id,
        ____MutingPatternInformation_iE_Extensions__item__criticality_tab,
        ___MutingPatternInformation_iE_Extensions__item__criticality,
        ____MutingPatternInformation_iE_Extensions__item__extensionValue_tab,
        ___MutingPatternInformation_iE_Extensions__item__extensionValue,
        __MutingPatternInformation_iE_Extensions__item_,
        _MutingPatternInformation_iE_Extensions,
        MutingPatternInformation,
        MutingPatternInformation_ExtIEs,
        MDT_ConfigurationNR,
        NAS_PDU,
        NASSecurityParametersfromE_UTRAN,
        NASSecurityParameterstoE_UTRAN,
        NB_IoT_DefaultPagingDRX,
        NB_IoT_PagingDRX,
        _NB_IoT_Paging_eDRXInformation_nB_IoT_paging_eDRX_Cycle,
        _NB_IoT_Paging_eDRXInformation_nB_IoT_pagingTimeWindow,
        ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__id_tab,
        ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__id,
        ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__criticality_tab,
        ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__criticality,
        ____NB_IoT_Paging_eDRXInformation_iE_Extensions__item__extensionValue_tab,
        ___NB_IoT_Paging_eDRXInformation_iE_Extensions__item__extensionValue,
        __NB_IoT_Paging_eDRXInformation_iE_Extensions__item_,
        _NB_IoT_Paging_eDRXInformation_iE_Extensions,
        NB_IoT_Paging_eDRXInformation,
        NB_IoT_Paging_eDRXInformation_ExtIEs,
        NB_IoT_Paging_eDRX_Cycle,
        NB_IoT_PagingTimeWindow,
        NB_IoT_RLF_Report_Container,
        NB_IoT_UEIdentityIndexValue,
        NextPagingAreaScope,
        NotifySourceeNB,
        NRCellIdentity,
        _NR_CGI_pLMNIdentity,
        _NR_CGI_nRCellIdentity,
        ____NR_CGI_iE_Extensions__item__id_tab,
        ___NR_CGI_iE_Extensions__item__id,
        ____NR_CGI_iE_Extensions__item__criticality_tab,
        ___NR_CGI_iE_Extensions__item__criticality,
        ____NR_CGI_iE_Extensions__item__extensionValue_tab,
        ___NR_CGI_iE_Extensions__item__extensionValue,
        __NR_CGI_iE_Extensions__item_,
        _NR_CGI_iE_Extensions,
        NR_CGI,
        NR_CGI_ExtIEs,
        NRencryptionAlgorithms,
        NRintegrityProtectionAlgorithms,
        NRrestrictioninEPSasSecondaryRAT,
        NRrestrictionin5GS,
        _NRUESecurityCapabilities_nRencryptionAlgorithms,
        _NRUESecurityCapabilities_nRintegrityProtectionAlgorithms,
        ____NRUESecurityCapabilities_iE_Extensions__item__id_tab,
        ___NRUESecurityCapabilities_iE_Extensions__item__id,
        ____NRUESecurityCapabilities_iE_Extensions__item__criticality_tab,
        ___NRUESecurityCapabilities_iE_Extensions__item__criticality,
        ____NRUESecurityCapabilities_iE_Extensions__item__extensionValue_tab,
        ___NRUESecurityCapabilities_iE_Extensions__item__extensionValue,
        __NRUESecurityCapabilities_iE_Extensions__item_,
        _NRUESecurityCapabilities_iE_Extensions,
        NRUESecurityCapabilities,
        NRUESecurityCapabilities_ExtIEs,
        NumberofBroadcastRequest,
        NumberOfBroadcasts,
        _NRV2XServicesAuthorized_vehicleUE,
        _NRV2XServicesAuthorized_pedestrianUE,
        ____NRV2XServicesAuthorized_iE_Extensions__item__id_tab,
        ___NRV2XServicesAuthorized_iE_Extensions__item__id,
        ____NRV2XServicesAuthorized_iE_Extensions__item__criticality_tab,
        ___NRV2XServicesAuthorized_iE_Extensions__item__criticality,
        ____NRV2XServicesAuthorized_iE_Extensions__item__extensionValue_tab,
        ___NRV2XServicesAuthorized_iE_Extensions__item__extensionValue,
        __NRV2XServicesAuthorized_iE_Extensions__item_,
        _NRV2XServicesAuthorized_iE_Extensions,
        NRV2XServicesAuthorized,
        NRV2XServicesAuthorized_ExtIEs,
        _NRUESidelinkAggregateMaximumBitrate_uEaggregateMaximumBitRate,
        ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab,
        ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__id,
        ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab,
        ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality,
        ____NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab,
        ___NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue,
        __NRUESidelinkAggregateMaximumBitrate_iE_Extensions__item_,
        _NRUESidelinkAggregateMaximumBitrate_iE_Extensions,
        NRUESidelinkAggregateMaximumBitrate,
        NRUESidelinkAggregateMaximumBitrate_ExtIEs,
        OldBSS_ToNewBSS_Information,
        OverloadAction,
        _OverloadResponse_overloadAction,
        OverloadResponse,
        Packet_LossRate,
        _PagingAttemptInformation_pagingAttemptCount,
        _PagingAttemptInformation_intendedNumberOfPagingAttempts,
        _PagingAttemptInformation_nextPagingAreaScope,
        ____PagingAttemptInformation_iE_Extensions__item__id_tab,
        ___PagingAttemptInformation_iE_Extensions__item__id,
        ____PagingAttemptInformation_iE_Extensions__item__criticality_tab,
        ___PagingAttemptInformation_iE_Extensions__item__criticality,
        ____PagingAttemptInformation_iE_Extensions__item__extensionValue_tab,
        ___PagingAttemptInformation_iE_Extensions__item__extensionValue,
        __PagingAttemptInformation_iE_Extensions__item_,
        _PagingAttemptInformation_iE_Extensions,
        PagingAttemptInformation,
        PagingAttemptInformation_ExtIEs,
        PagingAttemptCount,
        _Paging_eDRXInformation_paging_eDRX_Cycle,
        _Paging_eDRXInformation_pagingTimeWindow,
        ____Paging_eDRXInformation_iE_Extensions__item__id_tab,
        ___Paging_eDRXInformation_iE_Extensions__item__id,
        ____Paging_eDRXInformation_iE_Extensions__item__criticality_tab,
        ___Paging_eDRXInformation_iE_Extensions__item__criticality,
        ____Paging_eDRXInformation_iE_Extensions__item__extensionValue_tab,
        ___Paging_eDRXInformation_iE_Extensions__item__extensionValue,
        __Paging_eDRXInformation_iE_Extensions__item_,
        _Paging_eDRXInformation_iE_Extensions,
        Paging_eDRXInformation,
        Paging_eDRXInformation_ExtIEs,
        Paging_eDRX_Cycle,
        PagingTimeWindow,
        PagingDRX,
        PagingPriority,
        PagingProbabilityInformation,
        _PC5QoSParameters_pc5QoSFlowList,
        _PC5QoSParameters_pc5LinkAggregatedBitRates,
        ____PC5QoSParameters_iE_Extensions__item__id_tab,
        ___PC5QoSParameters_iE_Extensions__item__id,
        ____PC5QoSParameters_iE_Extensions__item__criticality_tab,
        ___PC5QoSParameters_iE_Extensions__item__criticality,
        ____PC5QoSParameters_iE_Extensions__item__extensionValue_tab,
        ___PC5QoSParameters_iE_Extensions__item__extensionValue,
        __PC5QoSParameters_iE_Extensions__item_,
        _PC5QoSParameters_iE_Extensions,
        PC5QoSParameters,
        PC5QoSParameters_ExtIEs,
        _PC5QoSFlowList__item_,
        PC5QoSFlowList,
        _PC5QoSFlowItem_pQI,
        _PC5QoSFlowItem_pc5FlowBitRates,
        _PC5QoSFlowItem_range,
        ____PC5QoSFlowItem_iE_Extensions__item__id_tab,
        ___PC5QoSFlowItem_iE_Extensions__item__id,
        ____PC5QoSFlowItem_iE_Extensions__item__criticality_tab,
        ___PC5QoSFlowItem_iE_Extensions__item__criticality,
        ____PC5QoSFlowItem_iE_Extensions__item__extensionValue_tab,
        ___PC5QoSFlowItem_iE_Extensions__item__extensionValue,
        __PC5QoSFlowItem_iE_Extensions__item_,
        _PC5QoSFlowItem_iE_Extensions,
        PC5QoSFlowItem,
        PC5QoSFlowItem_ExtIEs,
        _PC5FlowBitRates_guaranteedFlowBitRate,
        _PC5FlowBitRates_maximumFlowBitRate,
        ____PC5FlowBitRates_iE_Extensions__item__id_tab,
        ___PC5FlowBitRates_iE_Extensions__item__id,
        ____PC5FlowBitRates_iE_Extensions__item__criticality_tab,
        ___PC5FlowBitRates_iE_Extensions__item__criticality,
        ____PC5FlowBitRates_iE_Extensions__item__extensionValue_tab,
        ___PC5FlowBitRates_iE_Extensions__item__extensionValue,
        __PC5FlowBitRates_iE_Extensions__item_,
        _PC5FlowBitRates_iE_Extensions,
        PC5FlowBitRates,
        PC5FlowBitRates_ExtIEs,
        PDCP_SN,
        PDCP_SNExtended,
        PDCP_SNlength18,
        PendingDataIndication,
        _M1PeriodicReporting_reportInterval,
        _M1PeriodicReporting_reportAmount,
        ____M1PeriodicReporting_iE_Extensions__item__id_tab,
        ___M1PeriodicReporting_iE_Extensions__item__id,
        ____M1PeriodicReporting_iE_Extensions__item__criticality_tab,
        ___M1PeriodicReporting_iE_Extensions__item__criticality,
        ____M1PeriodicReporting_iE_Extensions__item__extensionValue_tab,
        ___M1PeriodicReporting_iE_Extensions__item__extensionValue,
        __M1PeriodicReporting_iE_Extensions__item_,
        _M1PeriodicReporting_iE_Extensions,
        M1PeriodicReporting,
        M1PeriodicReporting_ExtIEs,
        PLMNidentity,
        _PLMNAreaBasedQMC_plmnListforQMC,
        ____PLMNAreaBasedQMC_iE_Extensions__item__id_tab,
        ___PLMNAreaBasedQMC_iE_Extensions__item__id,
        ____PLMNAreaBasedQMC_iE_Extensions__item__criticality_tab,
        ___PLMNAreaBasedQMC_iE_Extensions__item__criticality,
        ____PLMNAreaBasedQMC_iE_Extensions__item__extensionValue_tab,
        ___PLMNAreaBasedQMC_iE_Extensions__item__extensionValue,
        __PLMNAreaBasedQMC_iE_Extensions__item_,
        _PLMNAreaBasedQMC_iE_Extensions,
        PLMNAreaBasedQMC,
        PLMNAreaBasedQMC_ExtIEs,
        _PLMNListforQMC__item_,
        PLMNListforQMC,
        Port_Number,
        Pre_emptionCapability,
        Pre_emptionVulnerability,
        PriorityLevel,
        _ProSeAuthorized_proSeDirectDiscovery,
        _ProSeAuthorized_proSeDirectCommunication,
        ____ProSeAuthorized_iE_Extensions__item__id_tab,
        _____ProSeAuthorized_iE_Extensions__item__id_tab_val_Extension_0,
        ___ProSeAuthorized_iE_Extensions__item__id,
        ___ProSeAuthorized_iE_Extensions__item__criticality,
        ___ProSeAuthorized_iE_Extensions__item__extensionValue,
        __ProSeAuthorized_iE_Extensions__item_,
        _ProSeAuthorized_iE_Extensions,
        ProSeAuthorized,
        ProSeAuthorized_ExtIEs,
        _ProSeAuthorized_ExtIEs_val_Extension_0,
        ProSeDirectDiscovery,
        ProSeUEtoNetworkRelaying,
        ProSeDirectCommunication,
        PS_ServiceNotAvailable,
        _PSCellInformation_nCGI,
        ____PSCellInformation_iE_Extensions__item__id_tab,
        ___PSCellInformation_iE_Extensions__item__id,
        ____PSCellInformation_iE_Extensions__item__criticality_tab,
        ___PSCellInformation_iE_Extensions__item__criticality,
        ____PSCellInformation_iE_Extensions__item__extensionValue_tab,
        ___PSCellInformation_iE_Extensions__item__extensionValue,
        __PSCellInformation_iE_Extensions__item_,
        _PSCellInformation_iE_Extensions,
        PSCellInformation,
        PSCellInformation_ExtIEs,
        QCI,
        RAN_UE_NGAP_ID,
        Range,
        ReceiveStatusofULPDCPSDUs,
        ReceiveStatusOfULPDCPSDUsExtended,
        ReceiveStatusOfULPDCPSDUsPDCP_SNlength18,
        _RecommendedCellsForPaging_recommendedCellList,
        ____RecommendedCellsForPaging_iE_Extensions__item__id_tab,
        ___RecommendedCellsForPaging_iE_Extensions__item__id,
        ____RecommendedCellsForPaging_iE_Extensions__item__criticality_tab,
        ___RecommendedCellsForPaging_iE_Extensions__item__criticality,
        ____RecommendedCellsForPaging_iE_Extensions__item__extensionValue_tab,
        ___RecommendedCellsForPaging_iE_Extensions__item__extensionValue,
        __RecommendedCellsForPaging_iE_Extensions__item_,
        _RecommendedCellsForPaging_iE_Extensions,
        RecommendedCellsForPaging,
        RecommendedCellsForPaging_ExtIEs,
        ___RecommendedCellList__item__id_tab,
        ____RecommendedCellList__item__id_tab_val_Value_0,
        __RecommendedCellList__item__id,
        __RecommendedCellList__item__criticality,
        __RecommendedCellList__item__value,
        _RecommendedCellList__item_,
        RecommendedCellList,
        RecommendedCellItemIEs,
        _RecommendedCellItemIEs_val_Value_0,
        _RecommendedCellItem_eUTRAN_CGI,
        _RecommendedCellItem_timeStayedInCell,
        ____RecommendedCellItem_iE_Extensions__item__id_tab,
        ___RecommendedCellItem_iE_Extensions__item__id,
        ____RecommendedCellItem_iE_Extensions__item__criticality_tab,
        ___RecommendedCellItem_iE_Extensions__item__criticality,
        ____RecommendedCellItem_iE_Extensions__item__extensionValue_tab,
        ___RecommendedCellItem_iE_Extensions__item__extensionValue,
        __RecommendedCellItem_iE_Extensions__item_,
        _RecommendedCellItem_iE_Extensions,
        RecommendedCellItem,
        RecommendedCellsForPagingItem_ExtIEs,
        _RecommendedENBsForPaging_recommendedENBList,
        ____RecommendedENBsForPaging_iE_Extensions__item__id_tab,
        ___RecommendedENBsForPaging_iE_Extensions__item__id,
        ____RecommendedENBsForPaging_iE_Extensions__item__criticality_tab,
        ___RecommendedENBsForPaging_iE_Extensions__item__criticality,
        ____RecommendedENBsForPaging_iE_Extensions__item__extensionValue_tab,
        ___RecommendedENBsForPaging_iE_Extensions__item__extensionValue,
        __RecommendedENBsForPaging_iE_Extensions__item_,
        _RecommendedENBsForPaging_iE_Extensions,
        RecommendedENBsForPaging,
        RecommendedENBsForPaging_ExtIEs,
        ___RecommendedENBList__item__id_tab,
        ____RecommendedENBList__item__id_tab_val_Value_0,
        __RecommendedENBList__item__id,
        __RecommendedENBList__item__criticality,
        __RecommendedENBList__item__value,
        _RecommendedENBList__item_,
        RecommendedENBList,
        RecommendedENBItemIEs,
        _RecommendedENBItemIEs_val_Value_0,
        _RecommendedENBItem_mMEPagingTarget,
        ____RecommendedENBItem_iE_Extensions__item__id_tab,
        ___RecommendedENBItem_iE_Extensions__item__id,
        ____RecommendedENBItem_iE_Extensions__item__criticality_tab,
        ___RecommendedENBItem_iE_Extensions__item__criticality,
        ____RecommendedENBItem_iE_Extensions__item__extensionValue_tab,
        ___RecommendedENBItem_iE_Extensions__item__extensionValue,
        __RecommendedENBItem_iE_Extensions__item_,
        _RecommendedENBItem_iE_Extensions,
        RecommendedENBItem,
        RecommendedENBItem_ExtIEs,
        RelativeMMECapacity,
        RelayNode_Indicator,
        RAC,
        RAT_Type,
        ReportAmountMDT,
        ReportIntervalMDT,
        M1ReportingTrigger,
        _RequestType_eventType,
        _RequestType_reportArea,
        ____RequestType_iE_Extensions__item__id_tab,
        _____RequestType_iE_Extensions__item__id_tab_val_Extension_0,
        ___RequestType_iE_Extensions__item__id,
        ___RequestType_iE_Extensions__item__criticality,
        ___RequestType_iE_Extensions__item__extensionValue,
        __RequestType_iE_Extensions__item_,
        _RequestType_iE_Extensions,
        RequestType,
        RequestType_ExtIEs,
        _RequestType_ExtIEs_val_Extension_0,
        RequestTypeAdditionalInfo,
        _RIMTransfer_rIMInformation,
        _RIMTransfer_rIMRoutingAddress,
        ____RIMTransfer_iE_Extensions__item__id_tab,
        ___RIMTransfer_iE_Extensions__item__id,
        ____RIMTransfer_iE_Extensions__item__criticality_tab,
        ___RIMTransfer_iE_Extensions__item__criticality,
        ____RIMTransfer_iE_Extensions__item__extensionValue_tab,
        ___RIMTransfer_iE_Extensions__item__extensionValue,
        __RIMTransfer_iE_Extensions__item_,
        _RIMTransfer_iE_Extensions,
        RIMTransfer,
        RIMTransfer_ExtIEs,
        RIMInformation,
        _RIMRoutingAddress_gERAN_Cell_ID,
        _RIMRoutingAddress_targetRNC_ID,
        _RIMRoutingAddress_eHRPD_Sector_ID,
        RIMRoutingAddress,
        ReportArea,
        RepetitionPeriod,
        _RLFReportInformation_uE_RLF_Report_Container,
        _RLFReportInformation_uE_RLF_Report_Container_for_extended_bands,
        ____RLFReportInformation_iE_Extensions__item__id_tab,
        _____RLFReportInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___RLFReportInformation_iE_Extensions__item__id,
        ___RLFReportInformation_iE_Extensions__item__criticality,
        ___RLFReportInformation_iE_Extensions__item__extensionValue,
        __RLFReportInformation_iE_Extensions__item_,
        _RLFReportInformation_iE_Extensions,
        RLFReportInformation,
        RLFReportInformation_ExtIEs,
        _RLFReportInformation_ExtIEs_val_Extension_0,
        RNC_ID,
        RRC_Container,
        RRC_Establishment_Cause,
        _ECGIListForRestart__item_,
        ECGIListForRestart,
        Routing_ID,
        SecurityKey,
        _SecurityContext_nextHopChainingCount,
        _SecurityContext_nextHopParameter,
        ____SecurityContext_iE_Extensions__item__id_tab,
        ___SecurityContext_iE_Extensions__item__id,
        ____SecurityContext_iE_Extensions__item__criticality_tab,
        ___SecurityContext_iE_Extensions__item__criticality,
        ____SecurityContext_iE_Extensions__item__extensionValue_tab,
        ___SecurityContext_iE_Extensions__item__extensionValue,
        __SecurityContext_iE_Extensions__item_,
        _SecurityContext_iE_Extensions,
        SecurityContext,
        SecurityContext_ExtIEs,
        SecondaryRATType,
        SecondaryRATDataUsageRequest,
        ___SecondaryRATDataUsageReportList__item__id_tab,
        ____SecondaryRATDataUsageReportList__item__id_tab_val_Value_0,
        __SecondaryRATDataUsageReportList__item__id,
        __SecondaryRATDataUsageReportList__item__criticality,
        __SecondaryRATDataUsageReportList__item__value,
        _SecondaryRATDataUsageReportList__item_,
        SecondaryRATDataUsageReportList,
        SecondaryRATDataUsageReportItemIEs,
        _SecondaryRATDataUsageReportItemIEs_val_Value_0,
        _SecondaryRATDataUsageReportItem_e_RAB_ID,
        _SecondaryRATDataUsageReportItem_secondaryRATType,
        _SecondaryRATDataUsageReportItem_e_RABUsageReportList,
        ____SecondaryRATDataUsageReportItem_iE_Extensions__item__id_tab,
        ___SecondaryRATDataUsageReportItem_iE_Extensions__item__id,
        ____SecondaryRATDataUsageReportItem_iE_Extensions__item__criticality_tab,
        ___SecondaryRATDataUsageReportItem_iE_Extensions__item__criticality,
        ____SecondaryRATDataUsageReportItem_iE_Extensions__item__extensionValue_tab,
        ___SecondaryRATDataUsageReportItem_iE_Extensions__item__extensionValue,
        __SecondaryRATDataUsageReportItem_iE_Extensions__item_,
        _SecondaryRATDataUsageReportItem_iE_Extensions,
        SecondaryRATDataUsageReportItem,
        SecondaryRATDataUsageReportItem_ExtIEs,
        SerialNumber,
        ServiceType,
        _SONInformation_sONInformationRequest,
        _SONInformation_sONInformationReply,
        _SONInformation_sONInformation_Extension,
        SONInformation,
        __SONInformation_Extension_id_tab,
        ___SONInformation_Extension_id_tab_val_Value_0,
        _SONInformation_Extension_id,
        _SONInformation_Extension_criticality,
        _SONInformation_Extension_value,
        SONInformation_Extension,
        SONInformation_ExtensionIE,
        _SONInformation_ExtensionIE_val_Value_0,
        SONInformationRequest,
        _SONInformationReply_x2TNLConfigurationInfo,
        ____SONInformationReply_iE_Extensions__item__id_tab,
        _____SONInformationReply_iE_Extensions__item__id_tab_val_Extension_0,
        _____SONInformationReply_iE_Extensions__item__id_tab_val_Extension_1,
        ___SONInformationReply_iE_Extensions__item__id,
        ___SONInformationReply_iE_Extensions__item__criticality,
        ___SONInformationReply_iE_Extensions__item__extensionValue,
        __SONInformationReply_iE_Extensions__item_,
        _SONInformationReply_iE_Extensions,
        SONInformationReply,
        SONInformationReply_ExtIEs,
        _SONInformationReply_ExtIEs_val_Extension_0,
        _SONInformationReply_ExtIEs_val_Extension_1,
        _SONInformationReport_rLFReportInformation,
        SONInformationReport,
        _SONConfigurationTransfer_targeteNB_ID,
        _SONConfigurationTransfer_sourceeNB_ID,
        _SONConfigurationTransfer_sONInformation,
        ____SONConfigurationTransfer_iE_Extensions__item__id_tab,
        _____SONConfigurationTransfer_iE_Extensions__item__id_tab_val_Extension_0,
        _____SONConfigurationTransfer_iE_Extensions__item__id_tab_val_Extension_1,
        ___SONConfigurationTransfer_iE_Extensions__item__id,
        ___SONConfigurationTransfer_iE_Extensions__item__criticality,
        ___SONConfigurationTransfer_iE_Extensions__item__extensionValue,
        __SONConfigurationTransfer_iE_Extensions__item_,
        _SONConfigurationTransfer_iE_Extensions,
        SONConfigurationTransfer,
        SONConfigurationTransfer_ExtIEs,
        _SONConfigurationTransfer_ExtIEs_val_Extension_0,
        _SONConfigurationTransfer_ExtIEs_val_Extension_1,
        _SynchronisationInformation_sourceStratumLevel,
        _SynchronisationInformation_listeningSubframePattern,
        _SynchronisationInformation_aggressoreCGI_List,
        ____SynchronisationInformation_iE_Extensions__item__id_tab,
        ___SynchronisationInformation_iE_Extensions__item__id,
        ____SynchronisationInformation_iE_Extensions__item__criticality_tab,
        ___SynchronisationInformation_iE_Extensions__item__criticality,
        ____SynchronisationInformation_iE_Extensions__item__extensionValue_tab,
        ___SynchronisationInformation_iE_Extensions__item__extensionValue,
        __SynchronisationInformation_iE_Extensions__item_,
        _SynchronisationInformation_iE_Extensions,
        SynchronisationInformation,
        SynchronisationInformation_ExtIEs,
        Source_ToTarget_TransparentContainer,
        SourceBSS_ToTargetBSS_TransparentContainer,
        _SourceeNB_ID_global_ENB_ID,
        _SourceeNB_ID_selected_TAI,
        ____SourceeNB_ID_iE_Extensions__item__id_tab,
        ___SourceeNB_ID_iE_Extensions__item__id,
        ____SourceeNB_ID_iE_Extensions__item__criticality_tab,
        ___SourceeNB_ID_iE_Extensions__item__criticality,
        ____SourceeNB_ID_iE_Extensions__item__extensionValue_tab,
        ___SourceeNB_ID_iE_Extensions__item__extensionValue,
        __SourceeNB_ID_iE_Extensions__item_,
        _SourceeNB_ID_iE_Extensions,
        SourceeNB_ID,
        SourceeNB_ID_ExtIEs,
        SRVCCOperationNotPossible,
        SRVCCOperationPossible,
        SRVCCHOIndication,
        _SourceNodeID_sourceNgRanNode_ID,
        _SourceNodeID_sourceNodeID_Extension,
        SourceNodeID,
        __SourceNodeID_Extension_id_tab,
        _SourceNodeID_Extension_id,
        __SourceNodeID_Extension_criticality_tab,
        _SourceNodeID_Extension_criticality,
        __SourceNodeID_Extension_value_tab,
        _SourceNodeID_Extension_value,
        SourceNodeID_Extension,
        SourceNodeID_ExtensionIE,
        _SourceeNB_ToTargeteNB_TransparentContainer_rRC_Container,
        _SourceeNB_ToTargeteNB_TransparentContainer_e_RABInformationList,
        _SourceeNB_ToTargeteNB_TransparentContainer_targetCell_ID,
        _SourceeNB_ToTargeteNB_TransparentContainer_subscriberProfileIDforRFP,
        _SourceeNB_ToTargeteNB_TransparentContainer_uE_HistoryInformation,
        ____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab,
        _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0,
        _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1,
        _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2,
        _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_3,
        _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_4,
        _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_5,
        _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_6,
        _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_7,
        _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_8,
        _____SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_9,
        ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__id,
        ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__criticality,
        ___SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item__extensionValue,
        __SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions__item_,
        _SourceeNB_ToTargeteNB_TransparentContainer_iE_Extensions,
        SourceeNB_ToTargeteNB_TransparentContainer,
        SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs,
        _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_0,
        _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_1,
        _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_2,
        _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_3,
        _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_4,
        _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_5,
        _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_6,
        _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_7,
        _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_8,
        _SourceeNB_ToTargeteNB_TransparentContainer_ExtIEs_val_Extension_9,
        _SourceNgRanNode_ID_global_RAN_NODE_ID,
        _SourceNgRanNode_ID_selected_TAI,
        ____SourceNgRanNode_ID_iE_Extensions__item__id_tab,
        ___SourceNgRanNode_ID_iE_Extensions__item__id,
        ____SourceNgRanNode_ID_iE_Extensions__item__criticality_tab,
        ___SourceNgRanNode_ID_iE_Extensions__item__criticality,
        ____SourceNgRanNode_ID_iE_Extensions__item__extensionValue_tab,
        ___SourceNgRanNode_ID_iE_Extensions__item__extensionValue,
        __SourceNgRanNode_ID_iE_Extensions__item_,
        _SourceNgRanNode_ID_iE_Extensions,
        SourceNgRanNode_ID,
        SourceNgRanNode_ID_ExtIEs,
        SourceRNC_ToTargetRNC_TransparentContainer,
        SourceNgRanNode_ToTargetNgRanNode_TransparentContainer,
        _ServedGUMMEIs__item_,
        ServedGUMMEIs,
        _ServedGUMMEIsItem_servedPLMNs,
        _ServedGUMMEIsItem_servedGroupIDs,
        _ServedGUMMEIsItem_servedMMECs,
        ____ServedGUMMEIsItem_iE_Extensions__item__id_tab,
        _____ServedGUMMEIsItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___ServedGUMMEIsItem_iE_Extensions__item__id,
        ___ServedGUMMEIsItem_iE_Extensions__item__criticality,
        ___ServedGUMMEIsItem_iE_Extensions__item__extensionValue,
        __ServedGUMMEIsItem_iE_Extensions__item_,
        _ServedGUMMEIsItem_iE_Extensions,
        ServedGUMMEIsItem,
        ServedGUMMEIsItem_ExtIEs,
        _ServedGUMMEIsItem_ExtIEs_val_Extension_0,
        _ServedGroupIDs__item_,
        ServedGroupIDs,
        _ServedMMECs__item_,
        ServedMMECs,
        _ServedPLMNs__item_,
        ServedPLMNs,
        SubscriberProfileIDforRFP,
        _Subscription_Based_UE_DifferentiationInfo_periodicCommunicationIndicator,
        _Subscription_Based_UE_DifferentiationInfo_periodicTime,
        _Subscription_Based_UE_DifferentiationInfo_scheduledCommunicationTime,
        _Subscription_Based_UE_DifferentiationInfo_stationaryIndication,
        _Subscription_Based_UE_DifferentiationInfo_trafficProfile,
        _Subscription_Based_UE_DifferentiationInfo_batteryIndication,
        ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id_tab,
        ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__id,
        ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality_tab,
        ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__criticality,
        ____Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue_tab,
        ___Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item__extensionValue,
        __Subscription_Based_UE_DifferentiationInfo_iE_Extensions__item_,
        _Subscription_Based_UE_DifferentiationInfo_iE_Extensions,
        Subscription_Based_UE_DifferentiationInfo,
        Subscription_Based_UE_DifferentiationInfo_ExtIEs,
        _ScheduledCommunicationTime_dayofWeek,
        _ScheduledCommunicationTime_timeofDayStart,
        _ScheduledCommunicationTime_timeofDayEnd,
        ____ScheduledCommunicationTime_iE_Extensions__item__id_tab,
        ___ScheduledCommunicationTime_iE_Extensions__item__id,
        ____ScheduledCommunicationTime_iE_Extensions__item__criticality_tab,
        ___ScheduledCommunicationTime_iE_Extensions__item__criticality,
        ____ScheduledCommunicationTime_iE_Extensions__item__extensionValue_tab,
        ___ScheduledCommunicationTime_iE_Extensions__item__extensionValue,
        __ScheduledCommunicationTime_iE_Extensions__item_,
        _ScheduledCommunicationTime_iE_Extensions,
        ScheduledCommunicationTime,
        ScheduledCommunicationTime_ExtIEs,
        _SupportedTAs__item_,
        SupportedTAs,
        _SupportedTAs_Item_tAC,
        _SupportedTAs_Item_broadcastPLMNs,
        ____SupportedTAs_Item_iE_Extensions__item__id_tab,
        _____SupportedTAs_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___SupportedTAs_Item_iE_Extensions__item__id,
        ___SupportedTAs_Item_iE_Extensions__item__criticality,
        ___SupportedTAs_Item_iE_Extensions__item__extensionValue,
        __SupportedTAs_Item_iE_Extensions__item_,
        _SupportedTAs_Item_iE_Extensions,
        SupportedTAs_Item,
        SupportedTAs_Item_ExtIEs,
        _SupportedTAs_Item_ExtIEs_val_Extension_0,
        StratumLevel,
        SynchronisationStatus,
        _TimeSynchronisationInfo_stratumLevel,
        _TimeSynchronisationInfo_synchronisationStatus,
        ____TimeSynchronisationInfo_iE_Extensions__item__id_tab,
        _____TimeSynchronisationInfo_iE_Extensions__item__id_tab_val_Extension_0,
        ___TimeSynchronisationInfo_iE_Extensions__item__id,
        ___TimeSynchronisationInfo_iE_Extensions__item__criticality,
        ___TimeSynchronisationInfo_iE_Extensions__item__extensionValue,
        __TimeSynchronisationInfo_iE_Extensions__item_,
        _TimeSynchronisationInfo_iE_Extensions,
        TimeSynchronisationInfo,
        TimeSynchronisationInfo_ExtIEs,
        _TimeSynchronisationInfo_ExtIEs_val_Extension_0,
        _S_TMSI_mMEC,
        _S_TMSI_m_TMSI,
        ____S_TMSI_iE_Extensions__item__id_tab,
        ___S_TMSI_iE_Extensions__item__id,
        ____S_TMSI_iE_Extensions__item__criticality_tab,
        ___S_TMSI_iE_Extensions__item__criticality,
        ____S_TMSI_iE_Extensions__item__extensionValue_tab,
        ___S_TMSI_iE_Extensions__item__extensionValue,
        __S_TMSI_iE_Extensions__item_,
        _S_TMSI_iE_Extensions,
        S_TMSI,
        S_TMSI_ExtIEs,
        TAC,
        _TAIBasedMDT_tAIListforMDT,
        ____TAIBasedMDT_iE_Extensions__item__id_tab,
        ___TAIBasedMDT_iE_Extensions__item__id,
        ____TAIBasedMDT_iE_Extensions__item__criticality_tab,
        ___TAIBasedMDT_iE_Extensions__item__criticality,
        ____TAIBasedMDT_iE_Extensions__item__extensionValue_tab,
        ___TAIBasedMDT_iE_Extensions__item__extensionValue,
        __TAIBasedMDT_iE_Extensions__item_,
        _TAIBasedMDT_iE_Extensions,
        TAIBasedMDT,
        TAIBasedMDT_ExtIEs,
        _TAIListforMDT__item_,
        TAIListforMDT,
        _TAIListforWarning__item_,
        TAIListforWarning,
        _TAI_pLMNidentity,
        _TAI_tAC,
        ____TAI_iE_Extensions__item__id_tab,
        ___TAI_iE_Extensions__item__id,
        ____TAI_iE_Extensions__item__criticality_tab,
        ___TAI_iE_Extensions__item__criticality,
        ____TAI_iE_Extensions__item__extensionValue_tab,
        ___TAI_iE_Extensions__item__extensionValue,
        __TAI_iE_Extensions__item_,
        _TAI_iE_Extensions,
        TAI,
        TAI_ExtIEs,
        _TAI_Broadcast__item_,
        TAI_Broadcast,
        _TAI_Broadcast_Item_tAI,
        _TAI_Broadcast_Item_completedCellinTAI,
        ____TAI_Broadcast_Item_iE_Extensions__item__id_tab,
        ___TAI_Broadcast_Item_iE_Extensions__item__id,
        ____TAI_Broadcast_Item_iE_Extensions__item__criticality_tab,
        ___TAI_Broadcast_Item_iE_Extensions__item__criticality,
        ____TAI_Broadcast_Item_iE_Extensions__item__extensionValue_tab,
        ___TAI_Broadcast_Item_iE_Extensions__item__extensionValue,
        __TAI_Broadcast_Item_iE_Extensions__item_,
        _TAI_Broadcast_Item_iE_Extensions,
        TAI_Broadcast_Item,
        TAI_Broadcast_Item_ExtIEs,
        _TAI_Cancelled__item_,
        TAI_Cancelled,
        _TAI_Cancelled_Item_tAI,
        _TAI_Cancelled_Item_cancelledCellinTAI,
        ____TAI_Cancelled_Item_iE_Extensions__item__id_tab,
        ___TAI_Cancelled_Item_iE_Extensions__item__id,
        ____TAI_Cancelled_Item_iE_Extensions__item__criticality_tab,
        ___TAI_Cancelled_Item_iE_Extensions__item__criticality,
        ____TAI_Cancelled_Item_iE_Extensions__item__extensionValue_tab,
        ___TAI_Cancelled_Item_iE_Extensions__item__extensionValue,
        __TAI_Cancelled_Item_iE_Extensions__item_,
        _TAI_Cancelled_Item_iE_Extensions,
        TAI_Cancelled_Item,
        TAI_Cancelled_Item_ExtIEs,
        _TABasedMDT_tAListforMDT,
        ____TABasedMDT_iE_Extensions__item__id_tab,
        ___TABasedMDT_iE_Extensions__item__id,
        ____TABasedMDT_iE_Extensions__item__criticality_tab,
        ___TABasedMDT_iE_Extensions__item__criticality,
        ____TABasedMDT_iE_Extensions__item__extensionValue_tab,
        ___TABasedMDT_iE_Extensions__item__extensionValue,
        __TABasedMDT_iE_Extensions__item_,
        _TABasedMDT_iE_Extensions,
        TABasedMDT,
        TABasedMDT_ExtIEs,
        _TAListforMDT__item_,
        TAListforMDT,
        _TABasedQMC_tAListforQMC,
        ____TABasedQMC_iE_Extensions__item__id_tab,
        ___TABasedQMC_iE_Extensions__item__id,
        ____TABasedQMC_iE_Extensions__item__criticality_tab,
        ___TABasedQMC_iE_Extensions__item__criticality,
        ____TABasedQMC_iE_Extensions__item__extensionValue_tab,
        ___TABasedQMC_iE_Extensions__item__extensionValue,
        __TABasedQMC_iE_Extensions__item_,
        _TABasedQMC_iE_Extensions,
        TABasedQMC,
        TABasedQMC_ExtIEs,
        _TAListforQMC__item_,
        TAListforQMC,
        _TAIBasedQMC_tAIListforQMC,
        ____TAIBasedQMC_iE_Extensions__item__id_tab,
        ___TAIBasedQMC_iE_Extensions__item__id,
        ____TAIBasedQMC_iE_Extensions__item__criticality_tab,
        ___TAIBasedQMC_iE_Extensions__item__criticality,
        ____TAIBasedQMC_iE_Extensions__item__extensionValue_tab,
        ___TAIBasedQMC_iE_Extensions__item__extensionValue,
        __TAIBasedQMC_iE_Extensions__item_,
        _TAIBasedQMC_iE_Extensions,
        TAIBasedQMC,
        TAIBasedQMC_ExtIEs,
        _TAIListforQMC__item_,
        TAIListforQMC,
        _CompletedCellinTAI__item_,
        CompletedCellinTAI,
        _CompletedCellinTAI_Item_eCGI,
        ____CompletedCellinTAI_Item_iE_Extensions__item__id_tab,
        ___CompletedCellinTAI_Item_iE_Extensions__item__id,
        ____CompletedCellinTAI_Item_iE_Extensions__item__criticality_tab,
        ___CompletedCellinTAI_Item_iE_Extensions__item__criticality,
        ____CompletedCellinTAI_Item_iE_Extensions__item__extensionValue_tab,
        ___CompletedCellinTAI_Item_iE_Extensions__item__extensionValue,
        __CompletedCellinTAI_Item_iE_Extensions__item_,
        _CompletedCellinTAI_Item_iE_Extensions,
        CompletedCellinTAI_Item,
        CompletedCellinTAI_Item_ExtIEs,
        TBCD_STRING,
        _TargetID_targeteNB_ID,
        _TargetID_targetRNC_ID,
        _TargetID_cGI,
        _TargetID_targetgNgRanNode_ID,
        TargetID,
        _TargeteNB_ID_global_ENB_ID,
        _TargeteNB_ID_selected_TAI,
        ____TargeteNB_ID_iE_Extensions__item__id_tab,
        ___TargeteNB_ID_iE_Extensions__item__id,
        ____TargeteNB_ID_iE_Extensions__item__criticality_tab,
        ___TargeteNB_ID_iE_Extensions__item__criticality,
        ____TargeteNB_ID_iE_Extensions__item__extensionValue_tab,
        ___TargeteNB_ID_iE_Extensions__item__extensionValue,
        __TargeteNB_ID_iE_Extensions__item_,
        _TargeteNB_ID_iE_Extensions,
        TargeteNB_ID,
        TargeteNB_ID_ExtIEs,
        _TargetRNC_ID_lAI,
        _TargetRNC_ID_rAC,
        _TargetRNC_ID_rNC_ID,
        _TargetRNC_ID_extendedRNC_ID,
        ____TargetRNC_ID_iE_Extensions__item__id_tab,
        ___TargetRNC_ID_iE_Extensions__item__id,
        ____TargetRNC_ID_iE_Extensions__item__criticality_tab,
        ___TargetRNC_ID_iE_Extensions__item__criticality,
        ____TargetRNC_ID_iE_Extensions__item__extensionValue_tab,
        ___TargetRNC_ID_iE_Extensions__item__extensionValue,
        __TargetRNC_ID_iE_Extensions__item_,
        _TargetRNC_ID_iE_Extensions,
        TargetRNC_ID,
        TargetRNC_ID_ExtIEs,
        _TargetNgRanNode_ID_global_RAN_NODE_ID,
        _TargetNgRanNode_ID_selected_TAI,
        ____TargetNgRanNode_ID_iE_Extensions__item__id_tab,
        ___TargetNgRanNode_ID_iE_Extensions__item__id,
        ____TargetNgRanNode_ID_iE_Extensions__item__criticality_tab,
        ___TargetNgRanNode_ID_iE_Extensions__item__criticality,
        ____TargetNgRanNode_ID_iE_Extensions__item__extensionValue_tab,
        ___TargetNgRanNode_ID_iE_Extensions__item__extensionValue,
        __TargetNgRanNode_ID_iE_Extensions__item_,
        _TargetNgRanNode_ID_iE_Extensions,
        TargetNgRanNode_ID,
        TargetNgRanNode_ID_ExtIEs,
        _Global_RAN_NODE_ID_gNB,
        _Global_RAN_NODE_ID_ng_eNB,
        Global_RAN_NODE_ID,
        _GNB_global_gNB_ID,
        ____GNB_iE_Extensions__item__id_tab,
        ___GNB_iE_Extensions__item__id,
        ____GNB_iE_Extensions__item__criticality_tab,
        ___GNB_iE_Extensions__item__criticality,
        ____GNB_iE_Extensions__item__extensionValue_tab,
        ___GNB_iE_Extensions__item__extensionValue,
        __GNB_iE_Extensions__item_,
        _GNB_iE_Extensions,
        GNB,
        GNB_ExtIEs,
        _Global_GNB_ID_pLMN_Identity,
        _Global_GNB_ID_gNB_ID,
        ____Global_GNB_ID_iE_Extensions__item__id_tab,
        ___Global_GNB_ID_iE_Extensions__item__id,
        ____Global_GNB_ID_iE_Extensions__item__criticality_tab,
        ___Global_GNB_ID_iE_Extensions__item__criticality,
        ____Global_GNB_ID_iE_Extensions__item__extensionValue_tab,
        ___Global_GNB_ID_iE_Extensions__item__extensionValue,
        __Global_GNB_ID_iE_Extensions__item_,
        _Global_GNB_ID_iE_Extensions,
        Global_GNB_ID,
        Global_GNB_ID_ExtIEs,
        _GNB_Identity_gNB_ID,
        GNB_Identity,
        _NG_eNB_global_ng_eNB_ID,
        ____NG_eNB_iE_Extensions__item__id_tab,
        ___NG_eNB_iE_Extensions__item__id,
        ____NG_eNB_iE_Extensions__item__criticality_tab,
        ___NG_eNB_iE_Extensions__item__criticality,
        ____NG_eNB_iE_Extensions__item__extensionValue_tab,
        ___NG_eNB_iE_Extensions__item__extensionValue,
        __NG_eNB_iE_Extensions__item_,
        _NG_eNB_iE_Extensions,
        NG_eNB,
        NG_eNB_ExtIEs,
        GNB_ID,
        _TargeteNB_ToSourceeNB_TransparentContainer_rRC_Container,
        ____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab,
        _____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0,
        _____TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1,
        ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__id,
        ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__criticality,
        ___TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item__extensionValue,
        __TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions__item_,
        _TargeteNB_ToSourceeNB_TransparentContainer_iE_Extensions,
        TargeteNB_ToSourceeNB_TransparentContainer,
        TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs,
        _TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs_val_Extension_0,
        _TargeteNB_ToSourceeNB_TransparentContainer_ExtIEs_val_Extension_1,
        Target_ToSource_TransparentContainer,
        TargetRNC_ToSourceRNC_TransparentContainer,
        TargetBSS_ToSourceBSS_TransparentContainer,
        TargetNgRanNode_ToSourceNgRanNode_TransparentContainer,
        _M1ThresholdEventA2_measurementThreshold,
        ____M1ThresholdEventA2_iE_Extensions__item__id_tab,
        ___M1ThresholdEventA2_iE_Extensions__item__id,
        ____M1ThresholdEventA2_iE_Extensions__item__criticality_tab,
        ___M1ThresholdEventA2_iE_Extensions__item__criticality,
        ____M1ThresholdEventA2_iE_Extensions__item__extensionValue_tab,
        ___M1ThresholdEventA2_iE_Extensions__item__extensionValue,
        __M1ThresholdEventA2_iE_Extensions__item_,
        _M1ThresholdEventA2_iE_Extensions,
        M1ThresholdEventA2,
        M1ThresholdEventA2_ExtIEs,
        Threshold_RSRP,
        Threshold_RSRQ,
        TimeToWait,
        Time_UE_StayedInCell,
        Time_UE_StayedInCell_EnhancedGranularity,
        TimeSinceSecondaryNodeRelease,
        _TransportInformation_transportLayerAddress,
        _TransportInformation_uL_GTP_TEID,
        TransportInformation,
        TransportLayerAddress,
        _TraceActivation_e_UTRAN_Trace_ID,
        _TraceActivation_interfacesToTrace,
        _TraceActivation_traceDepth,
        _TraceActivation_traceCollectionEntityIPAddress,
        ____TraceActivation_iE_Extensions__item__id_tab,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_0,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_1,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_2,
        _____TraceActivation_iE_Extensions__item__id_tab_val_Extension_3,
        ___TraceActivation_iE_Extensions__item__id,
        ___TraceActivation_iE_Extensions__item__criticality,
        ___TraceActivation_iE_Extensions__item__extensionValue,
        __TraceActivation_iE_Extensions__item_,
        _TraceActivation_iE_Extensions,
        TraceActivation,
        TraceActivation_ExtIEs,
        _TraceActivation_ExtIEs_val_Extension_0,
        _TraceActivation_ExtIEs_val_Extension_1,
        _TraceActivation_ExtIEs_val_Extension_2,
        _TraceActivation_ExtIEs_val_Extension_3,
        TraceDepth,
        E_UTRAN_Trace_ID,
        TrafficLoadReductionIndication,
        _TunnelInformation_transportLayerAddress,
        _TunnelInformation_uDP_Port_Number,
        ____TunnelInformation_iE_Extensions__item__id_tab,
        ___TunnelInformation_iE_Extensions__item__id,
        ____TunnelInformation_iE_Extensions__item__criticality_tab,
        ___TunnelInformation_iE_Extensions__item__criticality,
        ____TunnelInformation_iE_Extensions__item__extensionValue_tab,
        ___TunnelInformation_iE_Extensions__item__extensionValue,
        __TunnelInformation_iE_Extensions__item_,
        _TunnelInformation_iE_Extensions,
        TunnelInformation,
        Tunnel_Information_ExtIEs,
        TypeOfError,
        _TAIListForRestart__item_,
        TAIListForRestart,
        _UEAggregateMaximumBitrate_uEaggregateMaximumBitRateDL,
        _UEAggregateMaximumBitrate_uEaggregateMaximumBitRateUL,
        ____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab,
        _____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab_val_Extension_0,
        _____UEAggregateMaximumBitrate_iE_Extensions__item__id_tab_val_Extension_1,
        ___UEAggregateMaximumBitrate_iE_Extensions__item__id,
        ___UEAggregateMaximumBitrate_iE_Extensions__item__criticality,
        ___UEAggregateMaximumBitrate_iE_Extensions__item__extensionValue,
        __UEAggregateMaximumBitrate_iE_Extensions__item_,
        _UEAggregateMaximumBitrate_iE_Extensions,
        UEAggregateMaximumBitrate,
        UEAggregate_MaximumBitrates_ExtIEs,
        _UEAggregate_MaximumBitrates_ExtIEs_val_Extension_0,
        _UEAggregate_MaximumBitrates_ExtIEs_val_Extension_1,
        _UEAppLayerMeasConfig_containerForAppLayerMeasConfig,
        _UEAppLayerMeasConfig_areaScopeOfQMC,
        ____UEAppLayerMeasConfig_iE_Extensions__item__id_tab,
        _____UEAppLayerMeasConfig_iE_Extensions__item__id_tab_val_Extension_0,
        ___UEAppLayerMeasConfig_iE_Extensions__item__id,
        ___UEAppLayerMeasConfig_iE_Extensions__item__criticality,
        ___UEAppLayerMeasConfig_iE_Extensions__item__extensionValue,
        __UEAppLayerMeasConfig_iE_Extensions__item_,
        _UEAppLayerMeasConfig_iE_Extensions,
        UEAppLayerMeasConfig,
        UEAppLayerMeasConfig_ExtIEs,
        _UEAppLayerMeasConfig_ExtIEs_val_Extension_0,
        UECapabilityInfoRequest,
        UE_RetentionInformation,
        _UE_S1AP_IDs_uE_S1AP_ID_pair,
        _UE_S1AP_IDs_mME_UE_S1AP_ID,
        UE_S1AP_IDs,
        _UE_S1AP_ID_pair_mME_UE_S1AP_ID,
        _UE_S1AP_ID_pair_eNB_UE_S1AP_ID,
        ____UE_S1AP_ID_pair_iE_Extensions__item__id_tab,
        ___UE_S1AP_ID_pair_iE_Extensions__item__id,
        ____UE_S1AP_ID_pair_iE_Extensions__item__criticality_tab,
        ___UE_S1AP_ID_pair_iE_Extensions__item__criticality,
        ____UE_S1AP_ID_pair_iE_Extensions__item__extensionValue_tab,
        ___UE_S1AP_ID_pair_iE_Extensions__item__extensionValue,
        __UE_S1AP_ID_pair_iE_Extensions__item_,
        _UE_S1AP_ID_pair_iE_Extensions,
        UE_S1AP_ID_pair,
        UE_S1AP_ID_pair_ExtIEs,
        _UE_associatedLogicalS1_ConnectionItem_mME_UE_S1AP_ID,
        _UE_associatedLogicalS1_ConnectionItem_eNB_UE_S1AP_ID,
        ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__id_tab,
        ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__id,
        ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__criticality_tab,
        ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__criticality,
        ____UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__extensionValue_tab,
        ___UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item__extensionValue,
        __UE_associatedLogicalS1_ConnectionItem_iE_Extensions__item_,
        _UE_associatedLogicalS1_ConnectionItem_iE_Extensions,
        UE_associatedLogicalS1_ConnectionItem,
        UE_associatedLogicalS1_ConnectionItemExtIEs,
        UEIdentityIndexValue,
        _UE_HistoryInformation__item_,
        UE_HistoryInformation,
        UE_HistoryInformationFromTheUE,
        _UEPagingID_s_TMSI,
        _UEPagingID_iMSI,
        UEPagingID,
        UERadioCapability,
        UERadioCapabilityForPaging,
        UERadioCapabilityID,
        UE_RLF_Report_Container,
        UE_RLF_Report_Container_for_extended_bands,
        _UESecurityCapabilities_encryptionAlgorithms,
        _UESecurityCapabilities_integrityProtectionAlgorithms,
        ____UESecurityCapabilities_iE_Extensions__item__id_tab,
        ___UESecurityCapabilities_iE_Extensions__item__id,
        ____UESecurityCapabilities_iE_Extensions__item__criticality_tab,
        ___UESecurityCapabilities_iE_Extensions__item__criticality,
        ____UESecurityCapabilities_iE_Extensions__item__extensionValue_tab,
        ___UESecurityCapabilities_iE_Extensions__item__extensionValue,
        __UESecurityCapabilities_iE_Extensions__item_,
        _UESecurityCapabilities_iE_Extensions,
        UESecurityCapabilities,
        UESecurityCapabilities_ExtIEs,
        _UESidelinkAggregateMaximumBitrate_uESidelinkAggregateMaximumBitRate,
        ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__id_tab,
        ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__id,
        ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality_tab,
        ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__criticality,
        ____UESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue_tab,
        ___UESidelinkAggregateMaximumBitrate_iE_Extensions__item__extensionValue,
        __UESidelinkAggregateMaximumBitrate_iE_Extensions__item_,
        _UESidelinkAggregateMaximumBitrate_iE_Extensions,
        UESidelinkAggregateMaximumBitrate,
        UE_Sidelink_Aggregate_MaximumBitrates_ExtIEs,
        UE_Usage_Type,
        _UL_CP_SecurityInformation_ul_NAS_MAC,
        _UL_CP_SecurityInformation_ul_NAS_Count,
        ____UL_CP_SecurityInformation_iE_Extensions__item__id_tab,
        ___UL_CP_SecurityInformation_iE_Extensions__item__id,
        ____UL_CP_SecurityInformation_iE_Extensions__item__criticality_tab,
        ___UL_CP_SecurityInformation_iE_Extensions__item__criticality,
        ____UL_CP_SecurityInformation_iE_Extensions__item__extensionValue_tab,
        ___UL_CP_SecurityInformation_iE_Extensions__item__extensionValue,
        __UL_CP_SecurityInformation_iE_Extensions__item_,
        _UL_CP_SecurityInformation_iE_Extensions,
        UL_CP_SecurityInformation,
        UL_CP_SecurityInformation_ExtIEs,
        UL_NAS_MAC,
        UL_NAS_Count,
        UnlicensedSpectrumRestriction,
        URI_Address,
        _UserLocationInformation_eutran_cgi,
        _UserLocationInformation_tai,
        ____UserLocationInformation_iE_Extensions__item__id_tab,
        _____UserLocationInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___UserLocationInformation_iE_Extensions__item__id,
        ___UserLocationInformation_iE_Extensions__item__criticality,
        ___UserLocationInformation_iE_Extensions__item__extensionValue,
        __UserLocationInformation_iE_Extensions__item_,
        _UserLocationInformation_iE_Extensions,
        UserLocationInformation,
        UserLocationInformation_ExtIEs,
        _UserLocationInformation_ExtIEs_val_Extension_0,
        UEUserPlaneCIoTSupportIndicator,
        UE_Application_Layer_Measurement_Capability,
        VoiceSupportMatchIndicator,
        _V2XServicesAuthorized_vehicleUE,
        _V2XServicesAuthorized_pedestrianUE,
        ____V2XServicesAuthorized_iE_Extensions__item__id_tab,
        ___V2XServicesAuthorized_iE_Extensions__item__id,
        ____V2XServicesAuthorized_iE_Extensions__item__criticality_tab,
        ___V2XServicesAuthorized_iE_Extensions__item__criticality,
        ____V2XServicesAuthorized_iE_Extensions__item__extensionValue_tab,
        ___V2XServicesAuthorized_iE_Extensions__item__extensionValue,
        __V2XServicesAuthorized_iE_Extensions__item_,
        _V2XServicesAuthorized_iE_Extensions,
        V2XServicesAuthorized,
        V2XServicesAuthorized_ExtIEs,
        VehicleUE,
        PedestrianUE,
        WarningAreaCoordinates,
        _WarningAreaList_cellIDList,
        _WarningAreaList_trackingAreaListforWarning,
        _WarningAreaList_emergencyAreaIDList,
        WarningAreaList,
        WarningType,
        WarningSecurityInfo,
        WarningMessageContents,
        _WLANMeasurementConfiguration_wlanMeasConfig,
        _WLANMeasurementConfiguration_wlanMeasConfigNameList,
        _WLANMeasurementConfiguration_wlan_rssi,
        _WLANMeasurementConfiguration_wlan_rtt,
        ____WLANMeasurementConfiguration_iE_Extensions__item__id_tab,
        ___WLANMeasurementConfiguration_iE_Extensions__item__id,
        ____WLANMeasurementConfiguration_iE_Extensions__item__criticality_tab,
        ___WLANMeasurementConfiguration_iE_Extensions__item__criticality,
        ____WLANMeasurementConfiguration_iE_Extensions__item__extensionValue_tab,
        ___WLANMeasurementConfiguration_iE_Extensions__item__extensionValue,
        __WLANMeasurementConfiguration_iE_Extensions__item_,
        _WLANMeasurementConfiguration_iE_Extensions,
        WLANMeasurementConfiguration,
        WLANMeasurementConfiguration_ExtIEs,
        _WLANMeasConfigNameList__item_,
        WLANMeasConfigNameList,
        WLANMeasConfig,
        WLANName,
        _WUS_Assistance_Information_pagingProbabilityInformation,
        ____WUS_Assistance_Information_iE_Extensions__item__id_tab,
        ___WUS_Assistance_Information_iE_Extensions__item__id,
        ____WUS_Assistance_Information_iE_Extensions__item__criticality_tab,
        ___WUS_Assistance_Information_iE_Extensions__item__criticality,
        ____WUS_Assistance_Information_iE_Extensions__item__extensionValue_tab,
        ___WUS_Assistance_Information_iE_Extensions__item__extensionValue,
        __WUS_Assistance_Information_iE_Extensions__item_,
        _WUS_Assistance_Information_iE_Extensions,
        WUS_Assistance_Information,
        WUS_Assistance_Information_ExtIEs,
        _X2TNLConfigurationInfo_eNBX2TransportLayerAddresses,
        ____X2TNLConfigurationInfo_iE_Extensions__item__id_tab,
        _____X2TNLConfigurationInfo_iE_Extensions__item__id_tab_val_Extension_0,
        _____X2TNLConfigurationInfo_iE_Extensions__item__id_tab_val_Extension_1,
        ___X2TNLConfigurationInfo_iE_Extensions__item__id,
        ___X2TNLConfigurationInfo_iE_Extensions__item__criticality,
        ___X2TNLConfigurationInfo_iE_Extensions__item__extensionValue,
        __X2TNLConfigurationInfo_iE_Extensions__item_,
        _X2TNLConfigurationInfo_iE_Extensions,
        X2TNLConfigurationInfo,
        X2TNLConfigurationInfo_ExtIEs,
        _X2TNLConfigurationInfo_ExtIEs_val_Extension_0,
        _X2TNLConfigurationInfo_ExtIEs_val_Extension_1,
        _ENBX2ExtTLAs__item_,
        ENBX2ExtTLAs,
        _ENBX2ExtTLA_iPsecTLA,
        _ENBX2ExtTLA_gTPTLAa,
        ____ENBX2ExtTLA_iE_Extensions__item__id_tab,
        ___ENBX2ExtTLA_iE_Extensions__item__id,
        ____ENBX2ExtTLA_iE_Extensions__item__criticality_tab,
        ___ENBX2ExtTLA_iE_Extensions__item__criticality,
        ____ENBX2ExtTLA_iE_Extensions__item__extensionValue_tab,
        ___ENBX2ExtTLA_iE_Extensions__item__extensionValue,
        __ENBX2ExtTLA_iE_Extensions__item_,
        _ENBX2ExtTLA_iE_Extensions,
        ENBX2ExtTLA,
        ENBX2ExtTLA_ExtIEs,
        _ENBX2GTPTLAs__item_,
        ENBX2GTPTLAs,
        _ENBIndirectX2TransportLayerAddresses__item_,
        ENBIndirectX2TransportLayerAddresses,
    ]

class S1AP_PDU_Contents:

    _name_  = u'S1AP-PDU-Contents'
    _oid_   = [0, 4, 0, 0, 21, 3, 1, 1, 1]
    
    _obj_ = [
        u'E-RAB-IE-ContainerList',
        u'E-RAB-IE-ContainerPairList',
        u'ProtocolError-IE-ContainerList',
        u'HandoverRequired',
        u'HandoverRequiredIEs',
        u'HandoverCommand',
        u'HandoverCommandIEs',
        u'E-RABSubjecttoDataForwardingList',
        u'E-RABDataForwardingItemIEs',
        u'E-RABDataForwardingItem',
        u'E-RABDataForwardingItem-ExtIEs',
        u'HandoverPreparationFailure',
        u'HandoverPreparationFailureIEs',
        u'HandoverRequest',
        u'HandoverRequestIEs',
        u'E-RABToBeSetupListHOReq',
        u'E-RABToBeSetupItemHOReqIEs',
        u'E-RABToBeSetupItemHOReq',
        u'E-RABToBeSetupItemHOReq-ExtIEs',
        u'HandoverRequestAcknowledge',
        u'HandoverRequestAcknowledgeIEs',
        u'E-RABAdmittedList',
        u'E-RABAdmittedItemIEs',
        u'E-RABAdmittedItem',
        u'E-RABAdmittedItem-ExtIEs',
        u'E-RABFailedtoSetupListHOReqAck',
        u'E-RABFailedtoSetupItemHOReqAckIEs',
        u'E-RABFailedToSetupItemHOReqAck',
        u'E-RABFailedToSetupItemHOReqAckExtIEs',
        u'HandoverFailure',
        u'HandoverFailureIEs',
        u'HandoverNotify',
        u'HandoverNotifyIEs',
        u'PathSwitchRequest',
        u'PathSwitchRequestIEs',
        u'E-RABToBeSwitchedDLList',
        u'E-RABToBeSwitchedDLItemIEs',
        u'E-RABToBeSwitchedDLItem',
        u'E-RABToBeSwitchedDLItem-ExtIEs',
        u'PathSwitchRequestAcknowledge',
        u'PathSwitchRequestAcknowledgeIEs',
        u'E-RABToBeSwitchedULList',
        u'E-RABToBeSwitchedULItemIEs',
        u'E-RABToBeSwitchedULItem',
        u'E-RABToBeSwitchedULItem-ExtIEs',
        u'PathSwitchRequestFailure',
        u'PathSwitchRequestFailureIEs',
        u'HandoverCancel',
        u'HandoverCancelIEs',
        u'HandoverCancelAcknowledge',
        u'HandoverCancelAcknowledgeIEs',
        u'HandoverSuccess',
        u'HandoverSuccessIEs',
        u'ENBEarlyStatusTransfer',
        u'ENBEarlyStatusTransferIEs',
        u'MMEEarlyStatusTransfer',
        u'MMEEarlyStatusTransferIEs',
        u'E-RABSetupRequest',
        u'E-RABSetupRequestIEs',
        u'E-RABToBeSetupListBearerSUReq',
        u'E-RABToBeSetupItemBearerSUReqIEs',
        u'E-RABToBeSetupItemBearerSUReq',
        u'E-RABToBeSetupItemBearerSUReqExtIEs',
        u'E-RABSetupResponse',
        u'E-RABSetupResponseIEs',
        u'E-RABSetupListBearerSURes',
        u'E-RABSetupItemBearerSUResIEs',
        u'E-RABSetupItemBearerSURes',
        u'E-RABSetupItemBearerSUResExtIEs',
        u'E-RABModifyRequest',
        u'E-RABModifyRequestIEs',
        u'E-RABToBeModifiedListBearerModReq',
        u'E-RABToBeModifiedItemBearerModReqIEs',
        u'E-RABToBeModifiedItemBearerModReq',
        u'E-RABToBeModifyItemBearerModReqExtIEs',
        u'E-RABModifyResponse',
        u'E-RABModifyResponseIEs',
        u'E-RABModifyListBearerModRes',
        u'E-RABModifyItemBearerModResIEs',
        u'E-RABModifyItemBearerModRes',
        u'E-RABModifyItemBearerModResExtIEs',
        u'E-RABReleaseCommand',
        u'E-RABReleaseCommandIEs',
        u'E-RABReleaseResponse',
        u'E-RABReleaseResponseIEs',
        u'E-RABReleaseListBearerRelComp',
        u'E-RABReleaseItemBearerRelCompIEs',
        u'E-RABReleaseItemBearerRelComp',
        u'E-RABReleaseItemBearerRelCompExtIEs',
        u'E-RABReleaseIndication',
        u'E-RABReleaseIndicationIEs',
        u'InitialContextSetupRequest',
        u'InitialContextSetupRequestIEs',
        u'E-RABToBeSetupListCtxtSUReq',
        u'E-RABToBeSetupItemCtxtSUReqIEs',
        u'E-RABToBeSetupItemCtxtSUReq',
        u'E-RABToBeSetupItemCtxtSUReqExtIEs',
        u'InitialContextSetupResponse',
        u'InitialContextSetupResponseIEs',
        u'E-RABSetupListCtxtSURes',
        u'E-RABSetupItemCtxtSUResIEs',
        u'E-RABSetupItemCtxtSURes',
        u'E-RABSetupItemCtxtSUResExtIEs',
        u'InitialContextSetupFailure',
        u'InitialContextSetupFailureIEs',
        u'Paging',
        u'PagingIEs',
        u'TAIList',
        u'TAIItemIEs',
        u'TAIItem',
        u'TAIItemExtIEs',
        u'UEContextReleaseRequest',
        u'UEContextReleaseRequest-IEs',
        u'UEContextReleaseCommand',
        u'UEContextReleaseCommand-IEs',
        u'UEContextReleaseComplete',
        u'UEContextReleaseComplete-IEs',
        u'UEContextModificationRequest',
        u'UEContextModificationRequestIEs',
        u'UEContextModificationResponse',
        u'UEContextModificationResponseIEs',
        u'UEContextModificationFailure',
        u'UEContextModificationFailureIEs',
        u'UERadioCapabilityMatchRequest',
        u'UERadioCapabilityMatchRequestIEs',
        u'UERadioCapabilityMatchResponse',
        u'UERadioCapabilityMatchResponseIEs',
        u'DownlinkNASTransport',
        u'DownlinkNASTransport-IEs',
        u'InitialUEMessage',
        u'InitialUEMessage-IEs',
        u'UplinkNASTransport',
        u'UplinkNASTransport-IEs',
        u'NASNonDeliveryIndication',
        u'NASNonDeliveryIndication-IEs',
        u'RerouteNASRequest',
        u'RerouteNASRequest-IEs',
        u'NASDeliveryIndication',
        u'NASDeliveryIndicationIEs',
        u'Reset',
        u'ResetIEs',
        u'ResetType',
        u'ResetAll',
        u'UE-associatedLogicalS1-ConnectionListRes',
        u'UE-associatedLogicalS1-ConnectionItemRes',
        u'ResetAcknowledge',
        u'ResetAcknowledgeIEs',
        u'UE-associatedLogicalS1-ConnectionListResAck',
        u'UE-associatedLogicalS1-ConnectionItemResAck',
        u'ErrorIndication',
        u'ErrorIndicationIEs',
        u'S1SetupRequest',
        u'S1SetupRequestIEs',
        u'S1SetupResponse',
        u'S1SetupResponseIEs',
        u'S1SetupFailure',
        u'S1SetupFailureIEs',
        u'ENBConfigurationUpdate',
        u'ENBConfigurationUpdateIEs',
        u'ENBConfigurationUpdateAcknowledge',
        u'ENBConfigurationUpdateAcknowledgeIEs',
        u'ENBConfigurationUpdateFailure',
        u'ENBConfigurationUpdateFailureIEs',
        u'MMEConfigurationUpdate',
        u'MMEConfigurationUpdateIEs',
        u'MMEConfigurationUpdateAcknowledge',
        u'MMEConfigurationUpdateAcknowledgeIEs',
        u'MMEConfigurationUpdateFailure',
        u'MMEConfigurationUpdateFailureIEs',
        u'DownlinkS1cdma2000tunnelling',
        u'DownlinkS1cdma2000tunnellingIEs',
        u'UplinkS1cdma2000tunnelling',
        u'UplinkS1cdma2000tunnellingIEs',
        u'UECapabilityInfoIndication',
        u'UECapabilityInfoIndicationIEs',
        u'ENBStatusTransfer',
        u'ENBStatusTransferIEs',
        u'MMEStatusTransfer',
        u'MMEStatusTransferIEs',
        u'TraceStart',
        u'TraceStartIEs',
        u'TraceFailureIndication',
        u'TraceFailureIndicationIEs',
        u'DeactivateTrace',
        u'DeactivateTraceIEs',
        u'CellTrafficTrace',
        u'CellTrafficTraceIEs',
        u'LocationReportingControl',
        u'LocationReportingControlIEs',
        u'LocationReportingFailureIndication',
        u'LocationReportingFailureIndicationIEs',
        u'LocationReport',
        u'LocationReportIEs',
        u'OverloadStart',
        u'OverloadStartIEs',
        u'OverloadStop',
        u'OverloadStopIEs',
        u'WriteReplaceWarningRequest',
        u'WriteReplaceWarningRequestIEs',
        u'WriteReplaceWarningResponse',
        u'WriteReplaceWarningResponseIEs',
        u'ENBDirectInformationTransfer',
        u'ENBDirectInformationTransferIEs',
        u'Inter-SystemInformationTransferType',
        u'MMEDirectInformationTransfer',
        u'MMEDirectInformationTransferIEs',
        u'ENBConfigurationTransfer',
        u'ENBConfigurationTransferIEs',
        u'MMEConfigurationTransfer',
        u'MMEConfigurationTransferIEs',
        u'PrivateMessage',
        u'PrivateMessageIEs',
        u'KillRequest',
        u'KillRequestIEs',
        u'KillResponse',
        u'KillResponseIEs',
        u'PWSRestartIndication',
        u'PWSRestartIndicationIEs',
        u'PWSFailureIndication',
        u'PWSFailureIndicationIEs',
        u'DownlinkUEAssociatedLPPaTransport',
        u'DownlinkUEAssociatedLPPaTransport-IEs',
        u'UplinkUEAssociatedLPPaTransport',
        u'UplinkUEAssociatedLPPaTransport-IEs',
        u'DownlinkNonUEAssociatedLPPaTransport',
        u'DownlinkNonUEAssociatedLPPaTransport-IEs',
        u'UplinkNonUEAssociatedLPPaTransport',
        u'UplinkNonUEAssociatedLPPaTransport-IEs',
        u'E-RABModificationIndication',
        u'E-RABModificationIndicationIEs',
        u'E-RABToBeModifiedListBearerModInd',
        u'E-RABToBeModifiedItemBearerModIndIEs',
        u'E-RABToBeModifiedItemBearerModInd',
        u'E-RABToBeModifiedItemBearerModInd-ExtIEs',
        u'E-RABNotToBeModifiedListBearerModInd',
        u'E-RABNotToBeModifiedItemBearerModIndIEs',
        u'E-RABNotToBeModifiedItemBearerModInd',
        u'E-RABNotToBeModifiedItemBearerModInd-ExtIEs',
        u'CSGMembershipInfo',
        u'CSGMembershipInfo-ExtIEs',
        u'E-RABModificationConfirm',
        u'E-RABModificationConfirmIEs',
        u'E-RABModifyListBearerModConf',
        u'E-RABModifyItemBearerModConfIEs',
        u'E-RABModifyItemBearerModConf',
        u'E-RABModifyItemBearerModConfExtIEs',
        u'UEContextModificationIndication',
        u'UEContextModificationIndicationIEs',
        u'UEContextModificationConfirm',
        u'UEContextModificationConfirmIEs',
        u'UEContextSuspendRequest',
        u'UEContextSuspendRequestIEs',
        u'UEContextSuspendResponse',
        u'UEContextSuspendResponseIEs',
        u'UEContextResumeRequest',
        u'UEContextResumeRequestIEs',
        u'E-RABFailedToResumeListResumeReq',
        u'E-RABFailedToResumeItemResumeReqIEs',
        u'E-RABFailedToResumeItemResumeReq',
        u'E-RABFailedToResumeItemResumeReq-ExtIEs',
        u'UEContextResumeResponse',
        u'UEContextResumeResponseIEs',
        u'E-RABFailedToResumeListResumeRes',
        u'E-RABFailedToResumeItemResumeResIEs',
        u'E-RABFailedToResumeItemResumeRes',
        u'E-RABFailedToResumeItemResumeRes-ExtIEs',
        u'UEContextResumeFailure',
        u'UEContextResumeFailureIEs',
        u'ConnectionEstablishmentIndication',
        u'ConnectionEstablishmentIndicationIEs',
        u'RetrieveUEInformation',
        u'RetrieveUEInformationIEs',
        u'UEInformationTransfer',
        u'UEInformationTransferIEs',
        u'ENBCPRelocationIndication',
        u'ENBCPRelocationIndicationIEs',
        u'MMECPRelocationIndication',
        u'MMECPRelocationIndicationIEs',
        u'SecondaryRATDataUsageReport',
        u'SecondaryRATDataUsageReportIEs',
        u'UERadioCapabilityIDMappingRequest',
        u'UERadioCapabilityIDMappingRequestIEs',
        u'UERadioCapabilityIDMappingResponse',
        u'UERadioCapabilityIDMappingResponseIEs',
        ]
    _type_ = [
        u'E-RAB-IE-ContainerList',
        u'E-RAB-IE-ContainerPairList',
        u'ProtocolError-IE-ContainerList',
        u'HandoverRequired',
        u'HandoverCommand',
        u'E-RABSubjecttoDataForwardingList',
        u'E-RABDataForwardingItem',
        u'HandoverPreparationFailure',
        u'HandoverRequest',
        u'E-RABToBeSetupListHOReq',
        u'E-RABToBeSetupItemHOReq',
        u'HandoverRequestAcknowledge',
        u'E-RABAdmittedList',
        u'E-RABAdmittedItem',
        u'E-RABFailedtoSetupListHOReqAck',
        u'E-RABFailedToSetupItemHOReqAck',
        u'HandoverFailure',
        u'HandoverNotify',
        u'PathSwitchRequest',
        u'E-RABToBeSwitchedDLList',
        u'E-RABToBeSwitchedDLItem',
        u'PathSwitchRequestAcknowledge',
        u'E-RABToBeSwitchedULList',
        u'E-RABToBeSwitchedULItem',
        u'PathSwitchRequestFailure',
        u'HandoverCancel',
        u'HandoverCancelAcknowledge',
        u'HandoverSuccess',
        u'ENBEarlyStatusTransfer',
        u'MMEEarlyStatusTransfer',
        u'E-RABSetupRequest',
        u'E-RABToBeSetupListBearerSUReq',
        u'E-RABToBeSetupItemBearerSUReq',
        u'E-RABSetupResponse',
        u'E-RABSetupListBearerSURes',
        u'E-RABSetupItemBearerSURes',
        u'E-RABModifyRequest',
        u'E-RABToBeModifiedListBearerModReq',
        u'E-RABToBeModifiedItemBearerModReq',
        u'E-RABModifyResponse',
        u'E-RABModifyListBearerModRes',
        u'E-RABModifyItemBearerModRes',
        u'E-RABReleaseCommand',
        u'E-RABReleaseResponse',
        u'E-RABReleaseListBearerRelComp',
        u'E-RABReleaseItemBearerRelComp',
        u'E-RABReleaseIndication',
        u'InitialContextSetupRequest',
        u'E-RABToBeSetupListCtxtSUReq',
        u'E-RABToBeSetupItemCtxtSUReq',
        u'InitialContextSetupResponse',
        u'E-RABSetupListCtxtSURes',
        u'E-RABSetupItemCtxtSURes',
        u'InitialContextSetupFailure',
        u'Paging',
        u'TAIList',
        u'TAIItem',
        u'UEContextReleaseRequest',
        u'UEContextReleaseCommand',
        u'UEContextReleaseComplete',
        u'UEContextModificationRequest',
        u'UEContextModificationResponse',
        u'UEContextModificationFailure',
        u'UERadioCapabilityMatchRequest',
        u'UERadioCapabilityMatchResponse',
        u'DownlinkNASTransport',
        u'InitialUEMessage',
        u'UplinkNASTransport',
        u'NASNonDeliveryIndication',
        u'RerouteNASRequest',
        u'NASDeliveryIndication',
        u'Reset',
        u'ResetType',
        u'ResetAll',
        u'UE-associatedLogicalS1-ConnectionListRes',
        u'ResetAcknowledge',
        u'UE-associatedLogicalS1-ConnectionListResAck',
        u'ErrorIndication',
        u'S1SetupRequest',
        u'S1SetupResponse',
        u'S1SetupFailure',
        u'ENBConfigurationUpdate',
        u'ENBConfigurationUpdateAcknowledge',
        u'ENBConfigurationUpdateFailure',
        u'MMEConfigurationUpdate',
        u'MMEConfigurationUpdateAcknowledge',
        u'MMEConfigurationUpdateFailure',
        u'DownlinkS1cdma2000tunnelling',
        u'UplinkS1cdma2000tunnelling',
        u'UECapabilityInfoIndication',
        u'ENBStatusTransfer',
        u'MMEStatusTransfer',
        u'TraceStart',
        u'TraceFailureIndication',
        u'DeactivateTrace',
        u'CellTrafficTrace',
        u'LocationReportingControl',
        u'LocationReportingFailureIndication',
        u'LocationReport',
        u'OverloadStart',
        u'OverloadStop',
        u'WriteReplaceWarningRequest',
        u'WriteReplaceWarningResponse',
        u'ENBDirectInformationTransfer',
        u'Inter-SystemInformationTransferType',
        u'MMEDirectInformationTransfer',
        u'ENBConfigurationTransfer',
        u'MMEConfigurationTransfer',
        u'PrivateMessage',
        u'KillRequest',
        u'KillResponse',
        u'PWSRestartIndication',
        u'PWSFailureIndication',
        u'DownlinkUEAssociatedLPPaTransport',
        u'UplinkUEAssociatedLPPaTransport',
        u'DownlinkNonUEAssociatedLPPaTransport',
        u'UplinkNonUEAssociatedLPPaTransport',
        u'E-RABModificationIndication',
        u'E-RABToBeModifiedListBearerModInd',
        u'E-RABToBeModifiedItemBearerModInd',
        u'E-RABNotToBeModifiedListBearerModInd',
        u'E-RABNotToBeModifiedItemBearerModInd',
        u'CSGMembershipInfo',
        u'E-RABModificationConfirm',
        u'E-RABModifyListBearerModConf',
        u'E-RABModifyItemBearerModConf',
        u'UEContextModificationIndication',
        u'UEContextModificationConfirm',
        u'UEContextSuspendRequest',
        u'UEContextSuspendResponse',
        u'UEContextResumeRequest',
        u'E-RABFailedToResumeListResumeReq',
        u'E-RABFailedToResumeItemResumeReq',
        u'UEContextResumeResponse',
        u'E-RABFailedToResumeListResumeRes',
        u'E-RABFailedToResumeItemResumeRes',
        u'UEContextResumeFailure',
        u'ConnectionEstablishmentIndication',
        u'RetrieveUEInformation',
        u'UEInformationTransfer',
        u'ENBCPRelocationIndication',
        u'MMECPRelocationIndication',
        u'SecondaryRATDataUsageReport',
        u'UERadioCapabilityIDMappingRequest',
        u'UERadioCapabilityIDMappingResponse',
        ]
    _set_ = [
        u'HandoverRequiredIEs',
        u'HandoverCommandIEs',
        u'E-RABDataForwardingItemIEs',
        u'E-RABDataForwardingItem-ExtIEs',
        u'HandoverPreparationFailureIEs',
        u'HandoverRequestIEs',
        u'E-RABToBeSetupItemHOReqIEs',
        u'E-RABToBeSetupItemHOReq-ExtIEs',
        u'HandoverRequestAcknowledgeIEs',
        u'E-RABAdmittedItemIEs',
        u'E-RABAdmittedItem-ExtIEs',
        u'E-RABFailedtoSetupItemHOReqAckIEs',
        u'E-RABFailedToSetupItemHOReqAckExtIEs',
        u'HandoverFailureIEs',
        u'HandoverNotifyIEs',
        u'PathSwitchRequestIEs',
        u'E-RABToBeSwitchedDLItemIEs',
        u'E-RABToBeSwitchedDLItem-ExtIEs',
        u'PathSwitchRequestAcknowledgeIEs',
        u'E-RABToBeSwitchedULItemIEs',
        u'E-RABToBeSwitchedULItem-ExtIEs',
        u'PathSwitchRequestFailureIEs',
        u'HandoverCancelIEs',
        u'HandoverCancelAcknowledgeIEs',
        u'HandoverSuccessIEs',
        u'ENBEarlyStatusTransferIEs',
        u'MMEEarlyStatusTransferIEs',
        u'E-RABSetupRequestIEs',
        u'E-RABToBeSetupItemBearerSUReqIEs',
        u'E-RABToBeSetupItemBearerSUReqExtIEs',
        u'E-RABSetupResponseIEs',
        u'E-RABSetupItemBearerSUResIEs',
        u'E-RABSetupItemBearerSUResExtIEs',
        u'E-RABModifyRequestIEs',
        u'E-RABToBeModifiedItemBearerModReqIEs',
        u'E-RABToBeModifyItemBearerModReqExtIEs',
        u'E-RABModifyResponseIEs',
        u'E-RABModifyItemBearerModResIEs',
        u'E-RABModifyItemBearerModResExtIEs',
        u'E-RABReleaseCommandIEs',
        u'E-RABReleaseResponseIEs',
        u'E-RABReleaseItemBearerRelCompIEs',
        u'E-RABReleaseItemBearerRelCompExtIEs',
        u'E-RABReleaseIndicationIEs',
        u'InitialContextSetupRequestIEs',
        u'E-RABToBeSetupItemCtxtSUReqIEs',
        u'E-RABToBeSetupItemCtxtSUReqExtIEs',
        u'InitialContextSetupResponseIEs',
        u'E-RABSetupItemCtxtSUResIEs',
        u'E-RABSetupItemCtxtSUResExtIEs',
        u'InitialContextSetupFailureIEs',
        u'PagingIEs',
        u'TAIItemIEs',
        u'TAIItemExtIEs',
        u'UEContextReleaseRequest-IEs',
        u'UEContextReleaseCommand-IEs',
        u'UEContextReleaseComplete-IEs',
        u'UEContextModificationRequestIEs',
        u'UEContextModificationResponseIEs',
        u'UEContextModificationFailureIEs',
        u'UERadioCapabilityMatchRequestIEs',
        u'UERadioCapabilityMatchResponseIEs',
        u'DownlinkNASTransport-IEs',
        u'InitialUEMessage-IEs',
        u'UplinkNASTransport-IEs',
        u'NASNonDeliveryIndication-IEs',
        u'RerouteNASRequest-IEs',
        u'NASDeliveryIndicationIEs',
        u'ResetIEs',
        u'UE-associatedLogicalS1-ConnectionItemRes',
        u'ResetAcknowledgeIEs',
        u'UE-associatedLogicalS1-ConnectionItemResAck',
        u'ErrorIndicationIEs',
        u'S1SetupRequestIEs',
        u'S1SetupResponseIEs',
        u'S1SetupFailureIEs',
        u'ENBConfigurationUpdateIEs',
        u'ENBConfigurationUpdateAcknowledgeIEs',
        u'ENBConfigurationUpdateFailureIEs',
        u'MMEConfigurationUpdateIEs',
        u'MMEConfigurationUpdateAcknowledgeIEs',
        u'MMEConfigurationUpdateFailureIEs',
        u'DownlinkS1cdma2000tunnellingIEs',
        u'UplinkS1cdma2000tunnellingIEs',
        u'UECapabilityInfoIndicationIEs',
        u'ENBStatusTransferIEs',
        u'MMEStatusTransferIEs',
        u'TraceStartIEs',
        u'TraceFailureIndicationIEs',
        u'DeactivateTraceIEs',
        u'CellTrafficTraceIEs',
        u'LocationReportingControlIEs',
        u'LocationReportingFailureIndicationIEs',
        u'LocationReportIEs',
        u'OverloadStartIEs',
        u'OverloadStopIEs',
        u'WriteReplaceWarningRequestIEs',
        u'WriteReplaceWarningResponseIEs',
        u'ENBDirectInformationTransferIEs',
        u'MMEDirectInformationTransferIEs',
        u'ENBConfigurationTransferIEs',
        u'MMEConfigurationTransferIEs',
        u'PrivateMessageIEs',
        u'KillRequestIEs',
        u'KillResponseIEs',
        u'PWSRestartIndicationIEs',
        u'PWSFailureIndicationIEs',
        u'DownlinkUEAssociatedLPPaTransport-IEs',
        u'UplinkUEAssociatedLPPaTransport-IEs',
        u'DownlinkNonUEAssociatedLPPaTransport-IEs',
        u'UplinkNonUEAssociatedLPPaTransport-IEs',
        u'E-RABModificationIndicationIEs',
        u'E-RABToBeModifiedItemBearerModIndIEs',
        u'E-RABToBeModifiedItemBearerModInd-ExtIEs',
        u'E-RABNotToBeModifiedItemBearerModIndIEs',
        u'E-RABNotToBeModifiedItemBearerModInd-ExtIEs',
        u'CSGMembershipInfo-ExtIEs',
        u'E-RABModificationConfirmIEs',
        u'E-RABModifyItemBearerModConfIEs',
        u'E-RABModifyItemBearerModConfExtIEs',
        u'UEContextModificationIndicationIEs',
        u'UEContextModificationConfirmIEs',
        u'UEContextSuspendRequestIEs',
        u'UEContextSuspendResponseIEs',
        u'UEContextResumeRequestIEs',
        u'E-RABFailedToResumeItemResumeReqIEs',
        u'E-RABFailedToResumeItemResumeReq-ExtIEs',
        u'UEContextResumeResponseIEs',
        u'E-RABFailedToResumeItemResumeResIEs',
        u'E-RABFailedToResumeItemResumeRes-ExtIEs',
        u'UEContextResumeFailureIEs',
        u'ConnectionEstablishmentIndicationIEs',
        u'RetrieveUEInformationIEs',
        u'UEInformationTransferIEs',
        u'ENBCPRelocationIndicationIEs',
        u'MMECPRelocationIndicationIEs',
        u'SecondaryRATDataUsageReportIEs',
        u'UERadioCapabilityIDMappingRequestIEs',
        u'UERadioCapabilityIDMappingResponseIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        u'HandoverRequiredIEs',
        u'HandoverCommandIEs',
        u'E-RABDataForwardingItemIEs',
        u'E-RABDataForwardingItem-ExtIEs',
        u'HandoverPreparationFailureIEs',
        u'HandoverRequestIEs',
        u'E-RABToBeSetupItemHOReqIEs',
        u'E-RABToBeSetupItemHOReq-ExtIEs',
        u'HandoverRequestAcknowledgeIEs',
        u'E-RABAdmittedItemIEs',
        u'E-RABAdmittedItem-ExtIEs',
        u'E-RABFailedtoSetupItemHOReqAckIEs',
        u'E-RABFailedToSetupItemHOReqAckExtIEs',
        u'HandoverFailureIEs',
        u'HandoverNotifyIEs',
        u'PathSwitchRequestIEs',
        u'E-RABToBeSwitchedDLItemIEs',
        u'E-RABToBeSwitchedDLItem-ExtIEs',
        u'PathSwitchRequestAcknowledgeIEs',
        u'E-RABToBeSwitchedULItemIEs',
        u'E-RABToBeSwitchedULItem-ExtIEs',
        u'PathSwitchRequestFailureIEs',
        u'HandoverCancelIEs',
        u'HandoverCancelAcknowledgeIEs',
        u'HandoverSuccessIEs',
        u'ENBEarlyStatusTransferIEs',
        u'MMEEarlyStatusTransferIEs',
        u'E-RABSetupRequestIEs',
        u'E-RABToBeSetupItemBearerSUReqIEs',
        u'E-RABToBeSetupItemBearerSUReqExtIEs',
        u'E-RABSetupResponseIEs',
        u'E-RABSetupItemBearerSUResIEs',
        u'E-RABSetupItemBearerSUResExtIEs',
        u'E-RABModifyRequestIEs',
        u'E-RABToBeModifiedItemBearerModReqIEs',
        u'E-RABToBeModifyItemBearerModReqExtIEs',
        u'E-RABModifyResponseIEs',
        u'E-RABModifyItemBearerModResIEs',
        u'E-RABModifyItemBearerModResExtIEs',
        u'E-RABReleaseCommandIEs',
        u'E-RABReleaseResponseIEs',
        u'E-RABReleaseItemBearerRelCompIEs',
        u'E-RABReleaseItemBearerRelCompExtIEs',
        u'E-RABReleaseIndicationIEs',
        u'InitialContextSetupRequestIEs',
        u'E-RABToBeSetupItemCtxtSUReqIEs',
        u'E-RABToBeSetupItemCtxtSUReqExtIEs',
        u'InitialContextSetupResponseIEs',
        u'E-RABSetupItemCtxtSUResIEs',
        u'E-RABSetupItemCtxtSUResExtIEs',
        u'InitialContextSetupFailureIEs',
        u'PagingIEs',
        u'TAIItemIEs',
        u'TAIItemExtIEs',
        u'UEContextReleaseRequest-IEs',
        u'UEContextReleaseCommand-IEs',
        u'UEContextReleaseComplete-IEs',
        u'UEContextModificationRequestIEs',
        u'UEContextModificationResponseIEs',
        u'UEContextModificationFailureIEs',
        u'UERadioCapabilityMatchRequestIEs',
        u'UERadioCapabilityMatchResponseIEs',
        u'DownlinkNASTransport-IEs',
        u'InitialUEMessage-IEs',
        u'UplinkNASTransport-IEs',
        u'NASNonDeliveryIndication-IEs',
        u'RerouteNASRequest-IEs',
        u'NASDeliveryIndicationIEs',
        u'ResetIEs',
        u'UE-associatedLogicalS1-ConnectionItemRes',
        u'ResetAcknowledgeIEs',
        u'UE-associatedLogicalS1-ConnectionItemResAck',
        u'ErrorIndicationIEs',
        u'S1SetupRequestIEs',
        u'S1SetupResponseIEs',
        u'S1SetupFailureIEs',
        u'ENBConfigurationUpdateIEs',
        u'ENBConfigurationUpdateAcknowledgeIEs',
        u'ENBConfigurationUpdateFailureIEs',
        u'MMEConfigurationUpdateIEs',
        u'MMEConfigurationUpdateAcknowledgeIEs',
        u'MMEConfigurationUpdateFailureIEs',
        u'DownlinkS1cdma2000tunnellingIEs',
        u'UplinkS1cdma2000tunnellingIEs',
        u'UECapabilityInfoIndicationIEs',
        u'ENBStatusTransferIEs',
        u'MMEStatusTransferIEs',
        u'TraceStartIEs',
        u'TraceFailureIndicationIEs',
        u'DeactivateTraceIEs',
        u'CellTrafficTraceIEs',
        u'LocationReportingControlIEs',
        u'LocationReportingFailureIndicationIEs',
        u'LocationReportIEs',
        u'OverloadStartIEs',
        u'OverloadStopIEs',
        u'WriteReplaceWarningRequestIEs',
        u'WriteReplaceWarningResponseIEs',
        u'ENBDirectInformationTransferIEs',
        u'MMEDirectInformationTransferIEs',
        u'ENBConfigurationTransferIEs',
        u'MMEConfigurationTransferIEs',
        u'PrivateMessageIEs',
        u'KillRequestIEs',
        u'KillResponseIEs',
        u'PWSRestartIndicationIEs',
        u'PWSFailureIndicationIEs',
        u'DownlinkUEAssociatedLPPaTransport-IEs',
        u'UplinkUEAssociatedLPPaTransport-IEs',
        u'DownlinkNonUEAssociatedLPPaTransport-IEs',
        u'UplinkNonUEAssociatedLPPaTransport-IEs',
        u'E-RABModificationIndicationIEs',
        u'E-RABToBeModifiedItemBearerModIndIEs',
        u'E-RABToBeModifiedItemBearerModInd-ExtIEs',
        u'E-RABNotToBeModifiedItemBearerModIndIEs',
        u'E-RABNotToBeModifiedItemBearerModInd-ExtIEs',
        u'CSGMembershipInfo-ExtIEs',
        u'E-RABModificationConfirmIEs',
        u'E-RABModifyItemBearerModConfIEs',
        u'E-RABModifyItemBearerModConfExtIEs',
        u'UEContextModificationIndicationIEs',
        u'UEContextModificationConfirmIEs',
        u'UEContextSuspendRequestIEs',
        u'UEContextSuspendResponseIEs',
        u'UEContextResumeRequestIEs',
        u'E-RABFailedToResumeItemResumeReqIEs',
        u'E-RABFailedToResumeItemResumeReq-ExtIEs',
        u'UEContextResumeResponseIEs',
        u'E-RABFailedToResumeItemResumeResIEs',
        u'E-RABFailedToResumeItemResumeRes-ExtIEs',
        u'UEContextResumeFailureIEs',
        u'ConnectionEstablishmentIndicationIEs',
        u'RetrieveUEInformationIEs',
        u'UEInformationTransferIEs',
        u'ENBCPRelocationIndicationIEs',
        u'MMECPRelocationIndicationIEs',
        u'SecondaryRATDataUsageReportIEs',
        u'UERadioCapabilityIDMappingRequestIEs',
        u'UERadioCapabilityIDMappingResponseIEs',
        ]
    _param_ = [
        u'E-RAB-IE-ContainerList',
        u'E-RAB-IE-ContainerPairList',
        u'ProtocolError-IE-ContainerList',
        ]
    
    #-----< E-RAB-IE-ContainerList >-----#
    E_RAB_IE_ContainerList = SEQ_OF(name=u'E-RAB-IE-ContainerList', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-ContainerList')), param=True)
    
    #-----< E-RAB-IE-ContainerPairList >-----#
    E_RAB_IE_ContainerPairList = SEQ_OF(name=u'E-RAB-IE-ContainerPairList', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-ContainerPairList')), param=True)
    
    #-----< ProtocolError-IE-ContainerList >-----#
    ProtocolError_IE_ContainerList = SEQ_OF(name=u'ProtocolError-IE-ContainerList', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-ContainerList')), param=True)
    
    #-----< HandoverRequired >-----#
    HandoverRequired = SEQ(name=u'HandoverRequired', mode=MODE_TYPE)
    _HandoverRequired_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __HandoverRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___HandoverRequired_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____HandoverRequired_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverType')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TargetID')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Direct-Forwarding-Path-Availability')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCHOIndication')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Source-ToTarget-TransparentContainer')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Source-ToTarget-TransparentContainer')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_9 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MSClassmark2')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_10 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MSClassmark3')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_11 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_12 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellAccessMode')))
    _____HandoverRequired_protocolIEs__item__id_tab_val_Value_13 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PS-ServiceNotAvailable')))
    ____HandoverRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'reject'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 79), (u'criticality', u'ignore'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 125), (u'criticality', u'reject'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 104), (u'criticality', u'reject'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 138), (u'criticality', u'reject'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 132), (u'criticality', u'reject'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'conditional')]), dict([(u'id', 133), (u'criticality', u'ignore'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'conditional')]), dict([(u'id', 127), (u'criticality', u'reject'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 145), (u'criticality', u'reject'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 150), (u'criticality', u'ignore'), (u'Value', _____HandoverRequired_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverRequired_protocolIEs__item__id._const_tab = ____HandoverRequired_protocolIEs__item__id_tab
    ___HandoverRequired_protocolIEs__item__id._const_tab_at = None
    ___HandoverRequired_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverRequired_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverRequired_protocolIEs__item__criticality._const_tab = ____HandoverRequired_protocolIEs__item__id_tab
    ___HandoverRequired_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverRequired_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverRequired_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___HandoverRequired_protocolIEs__item__value._const_tab = ____HandoverRequired_protocolIEs__item__id_tab
    ___HandoverRequired_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverRequired_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverRequired_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverRequired_protocolIEs__item__id),
        (u'criticality', ___HandoverRequired_protocolIEs__item__criticality),
        (u'value', ___HandoverRequired_protocolIEs__item__value),
        ])
    __HandoverRequired_protocolIEs__item_._ext = None
    _HandoverRequired_protocolIEs._cont = __HandoverRequired_protocolIEs__item_
    _HandoverRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverRequired._cont = ASN1Dict([
        (u'protocolIEs', _HandoverRequired_protocolIEs),
        ])
    HandoverRequired._ext = []
    
    #-----< HandoverRequiredIEs >-----#
    HandoverRequiredIEs = CLASS(name=u'HandoverRequiredIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _HandoverRequiredIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverRequiredIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _HandoverRequiredIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverType')))
    _HandoverRequiredIEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _HandoverRequiredIEs_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TargetID')))
    _HandoverRequiredIEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Direct-Forwarding-Path-Availability')))
    _HandoverRequiredIEs_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCHOIndication')))
    _HandoverRequiredIEs_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Source-ToTarget-TransparentContainer')))
    _HandoverRequiredIEs_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Source-ToTarget-TransparentContainer')))
    _HandoverRequiredIEs_val_Value_9 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MSClassmark2')))
    _HandoverRequiredIEs_val_Value_10 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MSClassmark3')))
    _HandoverRequiredIEs_val_Value_11 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _HandoverRequiredIEs_val_Value_12 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellAccessMode')))
    _HandoverRequiredIEs_val_Value_13 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PS-ServiceNotAvailable')))
    HandoverRequiredIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _HandoverRequiredIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _HandoverRequiredIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'reject'), (u'Value', _HandoverRequiredIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _HandoverRequiredIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', _HandoverRequiredIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 79), (u'criticality', u'ignore'), (u'Value', _HandoverRequiredIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 125), (u'criticality', u'reject'), (u'Value', _HandoverRequiredIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 104), (u'criticality', u'reject'), (u'Value', _HandoverRequiredIEs_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 138), (u'criticality', u'reject'), (u'Value', _HandoverRequiredIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 132), (u'criticality', u'reject'), (u'Value', _HandoverRequiredIEs_val_Value_9), (u'presence', u'conditional')]), dict([(u'id', 133), (u'criticality', u'ignore'), (u'Value', _HandoverRequiredIEs_val_Value_10), (u'presence', u'conditional')]), dict([(u'id', 127), (u'criticality', u'reject'), (u'Value', _HandoverRequiredIEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 145), (u'criticality', u'reject'), (u'Value', _HandoverRequiredIEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 150), (u'criticality', u'ignore'), (u'Value', _HandoverRequiredIEs_val_Value_13), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverCommand >-----#
    HandoverCommand = SEQ(name=u'HandoverCommand', mode=MODE_TYPE)
    _HandoverCommand_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __HandoverCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___HandoverCommand_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____HandoverCommand_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverType')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NASSecurityParametersfromE-UTRAN')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSubjecttoDataForwardingList')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Target-ToSource-TransparentContainer')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Target-ToSource-TransparentContainer')))
    _____HandoverCommand_protocolIEs__item__id_tab_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____HandoverCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'reject'), (u'Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 135), (u'criticality', u'reject'), (u'Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'conditional')]), dict([(u'id', 12), (u'criticality', u'ignore'), (u'Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 13), (u'criticality', u'ignore'), (u'Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 123), (u'criticality', u'reject'), (u'Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 139), (u'criticality', u'reject'), (u'Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____HandoverCommand_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverCommand_protocolIEs__item__id._const_tab = ____HandoverCommand_protocolIEs__item__id_tab
    ___HandoverCommand_protocolIEs__item__id._const_tab_at = None
    ___HandoverCommand_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverCommand_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverCommand_protocolIEs__item__criticality._const_tab = ____HandoverCommand_protocolIEs__item__id_tab
    ___HandoverCommand_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverCommand_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverCommand_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___HandoverCommand_protocolIEs__item__value._const_tab = ____HandoverCommand_protocolIEs__item__id_tab
    ___HandoverCommand_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverCommand_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverCommand_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverCommand_protocolIEs__item__id),
        (u'criticality', ___HandoverCommand_protocolIEs__item__criticality),
        (u'value', ___HandoverCommand_protocolIEs__item__value),
        ])
    __HandoverCommand_protocolIEs__item_._ext = None
    _HandoverCommand_protocolIEs._cont = __HandoverCommand_protocolIEs__item_
    _HandoverCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverCommand._cont = ASN1Dict([
        (u'protocolIEs', _HandoverCommand_protocolIEs),
        ])
    HandoverCommand._ext = []
    
    #-----< HandoverCommandIEs >-----#
    HandoverCommandIEs = CLASS(name=u'HandoverCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _HandoverCommandIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverCommandIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _HandoverCommandIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverType')))
    _HandoverCommandIEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NASSecurityParametersfromE-UTRAN')))
    _HandoverCommandIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSubjecttoDataForwardingList')))
    _HandoverCommandIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _HandoverCommandIEs_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Target-ToSource-TransparentContainer')))
    _HandoverCommandIEs_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Target-ToSource-TransparentContainer')))
    _HandoverCommandIEs_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    HandoverCommandIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _HandoverCommandIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _HandoverCommandIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'reject'), (u'Value', _HandoverCommandIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 135), (u'criticality', u'reject'), (u'Value', _HandoverCommandIEs_val_Value_3), (u'presence', u'conditional')]), dict([(u'id', 12), (u'criticality', u'ignore'), (u'Value', _HandoverCommandIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 13), (u'criticality', u'ignore'), (u'Value', _HandoverCommandIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 123), (u'criticality', u'reject'), (u'Value', _HandoverCommandIEs_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 139), (u'criticality', u'reject'), (u'Value', _HandoverCommandIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _HandoverCommandIEs_val_Value_8), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABSubjecttoDataForwardingList >-----#
    E_RABSubjecttoDataForwardingList = SEQ_OF(name=u'E-RABSubjecttoDataForwardingList', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RAB-IE-ContainerList')))
    _E_RABSubjecttoDataForwardingList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABSubjecttoDataForwardingList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___E_RABSubjecttoDataForwardingList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABSubjecttoDataForwardingList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABDataForwardingItem')))
    ___E_RABSubjecttoDataForwardingList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 14), (u'criticality', u'ignore'), (u'Value', ____E_RABSubjecttoDataForwardingList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABSubjecttoDataForwardingList__item__id._const_tab = ___E_RABSubjecttoDataForwardingList__item__id_tab
    __E_RABSubjecttoDataForwardingList__item__id._const_tab_at = None
    __E_RABSubjecttoDataForwardingList__item__id._const_tab_id = u'id'
    __E_RABSubjecttoDataForwardingList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABSubjecttoDataForwardingList__item__criticality._const_tab = ___E_RABSubjecttoDataForwardingList__item__id_tab
    __E_RABSubjecttoDataForwardingList__item__criticality._const_tab_at = ('..', u'id')
    __E_RABSubjecttoDataForwardingList__item__criticality._const_tab_id = u'criticality'
    __E_RABSubjecttoDataForwardingList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __E_RABSubjecttoDataForwardingList__item__value._const_tab = ___E_RABSubjecttoDataForwardingList__item__id_tab
    __E_RABSubjecttoDataForwardingList__item__value._const_tab_at = ('..', u'id')
    __E_RABSubjecttoDataForwardingList__item__value._const_tab_id = u'Value'
    _E_RABSubjecttoDataForwardingList__item_._cont = ASN1Dict([
        (u'id', __E_RABSubjecttoDataForwardingList__item__id),
        (u'criticality', __E_RABSubjecttoDataForwardingList__item__criticality),
        (u'value', __E_RABSubjecttoDataForwardingList__item__value),
        ])
    _E_RABSubjecttoDataForwardingList__item_._ext = None
    E_RABSubjecttoDataForwardingList._cont = _E_RABSubjecttoDataForwardingList__item_
    E_RABSubjecttoDataForwardingList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABDataForwardingItemIEs >-----#
    E_RABDataForwardingItemIEs = CLASS(name=u'E-RABDataForwardingItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABDataForwardingItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABDataForwardingItem')))
    E_RABDataForwardingItemIEs._val = ASN1Set(rv=[dict([(u'id', 14), (u'criticality', u'ignore'), (u'Value', _E_RABDataForwardingItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABDataForwardingItem >-----#
    E_RABDataForwardingItem = SEQ(name=u'E-RABDataForwardingItem', mode=MODE_TYPE)
    _E_RABDataForwardingItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABDataForwardingItem_dL_transportLayerAddress = BIT_STR(name=u'dL-transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')), opt=True)
    _E_RABDataForwardingItem_dL_gTP_TEID = OCT_STR(name=u'dL-gTP-TEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')), opt=True)
    _E_RABDataForwardingItem_uL_TransportLayerAddress = BIT_STR(name=u'uL-TransportLayerAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')), opt=True)
    _E_RABDataForwardingItem_uL_GTP_TEID = OCT_STR(name=u'uL-GTP-TEID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')), opt=True)
    _E_RABDataForwardingItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABDataForwardingItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABDataForwardingItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABDataForwardingItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABDataForwardingItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABDataForwardingItem_iE_Extensions__item__id._const_tab = ____E_RABDataForwardingItem_iE_Extensions__item__id_tab
    ___E_RABDataForwardingItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABDataForwardingItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABDataForwardingItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABDataForwardingItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABDataForwardingItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABDataForwardingItem_iE_Extensions__item__criticality._const_tab = ____E_RABDataForwardingItem_iE_Extensions__item__criticality_tab
    ___E_RABDataForwardingItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABDataForwardingItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABDataForwardingItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABDataForwardingItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABDataForwardingItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABDataForwardingItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABDataForwardingItem_iE_Extensions__item__extensionValue_tab
    ___E_RABDataForwardingItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABDataForwardingItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABDataForwardingItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABDataForwardingItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABDataForwardingItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABDataForwardingItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABDataForwardingItem_iE_Extensions__item_._ext = None
    _E_RABDataForwardingItem_iE_Extensions._cont = __E_RABDataForwardingItem_iE_Extensions__item_
    _E_RABDataForwardingItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABDataForwardingItem._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABDataForwardingItem_e_RAB_ID),
        (u'dL-transportLayerAddress', _E_RABDataForwardingItem_dL_transportLayerAddress),
        (u'dL-gTP-TEID', _E_RABDataForwardingItem_dL_gTP_TEID),
        (u'uL-TransportLayerAddress', _E_RABDataForwardingItem_uL_TransportLayerAddress),
        (u'uL-GTP-TEID', _E_RABDataForwardingItem_uL_GTP_TEID),
        (u'iE-Extensions', _E_RABDataForwardingItem_iE_Extensions),
        ])
    E_RABDataForwardingItem._ext = []
    
    #-----< E-RABDataForwardingItem-ExtIEs >-----#
    E_RABDataForwardingItem_ExtIEs = CLASS(name=u'E-RABDataForwardingItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABDataForwardingItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HandoverPreparationFailure >-----#
    HandoverPreparationFailure = SEQ(name=u'HandoverPreparationFailure', mode=MODE_TYPE)
    _HandoverPreparationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __HandoverPreparationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___HandoverPreparationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____HandoverPreparationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____HandoverPreparationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverPreparationFailure_protocolIEs__item__id._const_tab = ____HandoverPreparationFailure_protocolIEs__item__id_tab
    ___HandoverPreparationFailure_protocolIEs__item__id._const_tab_at = None
    ___HandoverPreparationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverPreparationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverPreparationFailure_protocolIEs__item__criticality._const_tab = ____HandoverPreparationFailure_protocolIEs__item__id_tab
    ___HandoverPreparationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverPreparationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverPreparationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___HandoverPreparationFailure_protocolIEs__item__value._const_tab = ____HandoverPreparationFailure_protocolIEs__item__id_tab
    ___HandoverPreparationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverPreparationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverPreparationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverPreparationFailure_protocolIEs__item__id),
        (u'criticality', ___HandoverPreparationFailure_protocolIEs__item__criticality),
        (u'value', ___HandoverPreparationFailure_protocolIEs__item__value),
        ])
    __HandoverPreparationFailure_protocolIEs__item_._ext = None
    _HandoverPreparationFailure_protocolIEs._cont = __HandoverPreparationFailure_protocolIEs__item_
    _HandoverPreparationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverPreparationFailure._cont = ASN1Dict([
        (u'protocolIEs', _HandoverPreparationFailure_protocolIEs),
        ])
    HandoverPreparationFailure._ext = []
    
    #-----< HandoverPreparationFailureIEs >-----#
    HandoverPreparationFailureIEs = CLASS(name=u'HandoverPreparationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _HandoverPreparationFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverPreparationFailureIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _HandoverPreparationFailureIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _HandoverPreparationFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    HandoverPreparationFailureIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _HandoverPreparationFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _HandoverPreparationFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _HandoverPreparationFailureIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _HandoverPreparationFailureIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverRequest >-----#
    HandoverRequest = SEQ(name=u'HandoverRequest', mode=MODE_TYPE)
    _HandoverRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __HandoverRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___HandoverRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____HandoverRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverType')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupListHOReq')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Source-ToTarget-TransparentContainer')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESecurityCapabilities')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverRestrictionList')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TraceActivation')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_9 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RequestType')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCOperationPossible')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityContext')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_12 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NASSecurityParameterstoE-UTRAN')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_13 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_14 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_15 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEI')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_16 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_17 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ManagementBasedMDTAllowed')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_18 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDTPLMNList')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_19 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Masked-IMEISV')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_20 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExpectedUEBehaviour')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_21 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ProSeAuthorized')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_22 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEUserPlaneCIoTSupportIndicator')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_23 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'V2XServicesAuthorized')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_24 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESidelinkAggregateMaximumBitrate')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_25 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_26 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_27 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_28 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AerialUEsubscriptionInformation')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_29 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_30 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_31 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_32 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IAB-Authorized')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_33 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRV2XServicesAuthorized')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_34 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_35 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PC5QoSParameters')))
    _____HandoverRequest_protocolIEs__item__id_tab_val_Value_36 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    ____HandoverRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 66), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 53), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 104), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 107), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 98), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 124), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'mandatory')]), dict([(u'id', 136), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'conditional')]), dict([(u'id', 127), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 75), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_17), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 192), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 196), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 241), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_22), (u'presence', u'optional')]), dict([(u'id', 240), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_23), (u'presence', u'optional')]), dict([(u'id', 248), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_24), (u'presence', u'optional')]), dict([(u'id', 251), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_25), (u'presence', u'optional')]), dict([(u'id', 269), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_26), (u'presence', u'optional')]), dict([(u'id', 271), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_27), (u'presence', u'optional')]), dict([(u'id', 277), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_28), (u'presence', u'optional')]), dict([(u'id', 283), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_29), (u'presence', u'optional')]), dict([(u'id', 278), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_30), (u'presence', u'optional')]), dict([(u'id', 299), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_31), (u'presence', u'optional')]), dict([(u'id', 301), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_32), (u'presence', u'optional')]), dict([(u'id', 306), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_33), (u'presence', u'optional')]), dict([(u'id', 307), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_34), (u'presence', u'optional')]), dict([(u'id', 308), (u'criticality', u'ignore'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_35), (u'presence', u'optional')]), dict([(u'id', 314), (u'criticality', u'reject'), (u'Value', _____HandoverRequest_protocolIEs__item__id_tab_val_Value_36), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverRequest_protocolIEs__item__id._const_tab = ____HandoverRequest_protocolIEs__item__id_tab
    ___HandoverRequest_protocolIEs__item__id._const_tab_at = None
    ___HandoverRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverRequest_protocolIEs__item__criticality._const_tab = ____HandoverRequest_protocolIEs__item__id_tab
    ___HandoverRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___HandoverRequest_protocolIEs__item__value._const_tab = ____HandoverRequest_protocolIEs__item__id_tab
    ___HandoverRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverRequest_protocolIEs__item__id),
        (u'criticality', ___HandoverRequest_protocolIEs__item__criticality),
        (u'value', ___HandoverRequest_protocolIEs__item__value),
        ])
    __HandoverRequest_protocolIEs__item_._ext = None
    _HandoverRequest_protocolIEs._cont = __HandoverRequest_protocolIEs__item_
    _HandoverRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverRequest._cont = ASN1Dict([
        (u'protocolIEs', _HandoverRequest_protocolIEs),
        ])
    HandoverRequest._ext = []
    
    #-----< HandoverRequestIEs >-----#
    HandoverRequestIEs = CLASS(name=u'HandoverRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _HandoverRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverRequestIEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverType')))
    _HandoverRequestIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _HandoverRequestIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _HandoverRequestIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupListHOReq')))
    _HandoverRequestIEs_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Source-ToTarget-TransparentContainer')))
    _HandoverRequestIEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESecurityCapabilities')))
    _HandoverRequestIEs_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverRestrictionList')))
    _HandoverRequestIEs_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TraceActivation')))
    _HandoverRequestIEs_val_Value_9 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RequestType')))
    _HandoverRequestIEs_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCOperationPossible')))
    _HandoverRequestIEs_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityContext')))
    _HandoverRequestIEs_val_Value_12 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NASSecurityParameterstoE-UTRAN')))
    _HandoverRequestIEs_val_Value_13 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _HandoverRequestIEs_val_Value_14 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _HandoverRequestIEs_val_Value_15 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEI')))
    _HandoverRequestIEs_val_Value_16 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverRequestIEs_val_Value_17 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ManagementBasedMDTAllowed')))
    _HandoverRequestIEs_val_Value_18 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDTPLMNList')))
    _HandoverRequestIEs_val_Value_19 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Masked-IMEISV')))
    _HandoverRequestIEs_val_Value_20 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExpectedUEBehaviour')))
    _HandoverRequestIEs_val_Value_21 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ProSeAuthorized')))
    _HandoverRequestIEs_val_Value_22 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEUserPlaneCIoTSupportIndicator')))
    _HandoverRequestIEs_val_Value_23 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'V2XServicesAuthorized')))
    _HandoverRequestIEs_val_Value_24 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESidelinkAggregateMaximumBitrate')))
    _HandoverRequestIEs_val_Value_25 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _HandoverRequestIEs_val_Value_26 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _HandoverRequestIEs_val_Value_27 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _HandoverRequestIEs_val_Value_28 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AerialUEsubscriptionInformation')))
    _HandoverRequestIEs_val_Value_29 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    _HandoverRequestIEs_val_Value_30 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _HandoverRequestIEs_val_Value_31 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _HandoverRequestIEs_val_Value_32 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IAB-Authorized')))
    _HandoverRequestIEs_val_Value_33 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRV2XServicesAuthorized')))
    _HandoverRequestIEs_val_Value_34 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _HandoverRequestIEs_val_Value_35 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PC5QoSParameters')))
    _HandoverRequestIEs_val_Value_36 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    HandoverRequestIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 66), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 53), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 104), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 107), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 98), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 124), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_11), (u'presence', u'mandatory')]), dict([(u'id', 136), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_12), (u'presence', u'conditional')]), dict([(u'id', 127), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 75), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_17), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 192), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 196), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 241), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_22), (u'presence', u'optional')]), dict([(u'id', 240), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_23), (u'presence', u'optional')]), dict([(u'id', 248), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_24), (u'presence', u'optional')]), dict([(u'id', 251), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_25), (u'presence', u'optional')]), dict([(u'id', 269), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_26), (u'presence', u'optional')]), dict([(u'id', 271), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_27), (u'presence', u'optional')]), dict([(u'id', 277), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_28), (u'presence', u'optional')]), dict([(u'id', 283), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_29), (u'presence', u'optional')]), dict([(u'id', 278), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_30), (u'presence', u'optional')]), dict([(u'id', 299), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_31), (u'presence', u'optional')]), dict([(u'id', 301), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_32), (u'presence', u'optional')]), dict([(u'id', 306), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_33), (u'presence', u'optional')]), dict([(u'id', 307), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_34), (u'presence', u'optional')]), dict([(u'id', 308), (u'criticality', u'ignore'), (u'Value', _HandoverRequestIEs_val_Value_35), (u'presence', u'optional')]), dict([(u'id', 314), (u'criticality', u'reject'), (u'Value', _HandoverRequestIEs_val_Value_36), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeSetupListHOReq >-----#
    E_RABToBeSetupListHOReq = SEQ_OF(name=u'E-RABToBeSetupListHOReq', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RAB-IE-ContainerList')))
    _E_RABToBeSetupListHOReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABToBeSetupListHOReq__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___E_RABToBeSetupListHOReq__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABToBeSetupListHOReq__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupItemHOReq')))
    ___E_RABToBeSetupListHOReq__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 27), (u'criticality', u'reject'), (u'Value', ____E_RABToBeSetupListHOReq__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABToBeSetupListHOReq__item__id._const_tab = ___E_RABToBeSetupListHOReq__item__id_tab
    __E_RABToBeSetupListHOReq__item__id._const_tab_at = None
    __E_RABToBeSetupListHOReq__item__id._const_tab_id = u'id'
    __E_RABToBeSetupListHOReq__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABToBeSetupListHOReq__item__criticality._const_tab = ___E_RABToBeSetupListHOReq__item__id_tab
    __E_RABToBeSetupListHOReq__item__criticality._const_tab_at = ('..', u'id')
    __E_RABToBeSetupListHOReq__item__criticality._const_tab_id = u'criticality'
    __E_RABToBeSetupListHOReq__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __E_RABToBeSetupListHOReq__item__value._const_tab = ___E_RABToBeSetupListHOReq__item__id_tab
    __E_RABToBeSetupListHOReq__item__value._const_tab_at = ('..', u'id')
    __E_RABToBeSetupListHOReq__item__value._const_tab_id = u'Value'
    _E_RABToBeSetupListHOReq__item_._cont = ASN1Dict([
        (u'id', __E_RABToBeSetupListHOReq__item__id),
        (u'criticality', __E_RABToBeSetupListHOReq__item__criticality),
        (u'value', __E_RABToBeSetupListHOReq__item__value),
        ])
    _E_RABToBeSetupListHOReq__item_._ext = None
    E_RABToBeSetupListHOReq._cont = _E_RABToBeSetupListHOReq__item_
    E_RABToBeSetupListHOReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABToBeSetupItemHOReqIEs >-----#
    E_RABToBeSetupItemHOReqIEs = CLASS(name=u'E-RABToBeSetupItemHOReqIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABToBeSetupItemHOReqIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupItemHOReq')))
    E_RABToBeSetupItemHOReqIEs._val = ASN1Set(rv=[dict([(u'id', 27), (u'criticality', u'reject'), (u'Value', _E_RABToBeSetupItemHOReqIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeSetupItemHOReq >-----#
    E_RABToBeSetupItemHOReq = SEQ(name=u'E-RABToBeSetupItemHOReq', mode=MODE_TYPE)
    _E_RABToBeSetupItemHOReq_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABToBeSetupItemHOReq_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABToBeSetupItemHOReq_gTP_TEID = OCT_STR(name=u'gTP-TEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    _E_RABToBeSetupItemHOReq_e_RABlevelQosParameters = SEQ(name=u'e-RABlevelQosParameters', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RABLevelQoSParameters')))
    _E_RABToBeSetupItemHOReq_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABToBeSetupItemHOReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Data-Forwarding-Not-Possible')))
    _____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BearerType')))
    _____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Ethernet-Type')))
    ____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 143), (u'criticality', u'ignore'), (u'Extension', _____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 233), (u'criticality', u'reject'), (u'Extension', _____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 305), (u'criticality', u'ignore'), (u'Extension', _____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__id._const_tab = ____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__id._const_tab_at = None
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__criticality._const_tab = ____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__extensionValue._const_tab = ____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABToBeSetupItemHOReq_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABToBeSetupItemHOReq_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABToBeSetupItemHOReq_iE_Extensions__item__id),
        (u'criticality', ___E_RABToBeSetupItemHOReq_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABToBeSetupItemHOReq_iE_Extensions__item__extensionValue),
        ])
    __E_RABToBeSetupItemHOReq_iE_Extensions__item_._ext = None
    _E_RABToBeSetupItemHOReq_iE_Extensions._cont = __E_RABToBeSetupItemHOReq_iE_Extensions__item_
    _E_RABToBeSetupItemHOReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABToBeSetupItemHOReq._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABToBeSetupItemHOReq_e_RAB_ID),
        (u'transportLayerAddress', _E_RABToBeSetupItemHOReq_transportLayerAddress),
        (u'gTP-TEID', _E_RABToBeSetupItemHOReq_gTP_TEID),
        (u'e-RABlevelQosParameters', _E_RABToBeSetupItemHOReq_e_RABlevelQosParameters),
        (u'iE-Extensions', _E_RABToBeSetupItemHOReq_iE_Extensions),
        ])
    E_RABToBeSetupItemHOReq._ext = []
    
    #-----< E-RABToBeSetupItemHOReq-ExtIEs >-----#
    E_RABToBeSetupItemHOReq_ExtIEs = CLASS(name=u'E-RABToBeSetupItemHOReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _E_RABToBeSetupItemHOReq_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Data-Forwarding-Not-Possible')))
    _E_RABToBeSetupItemHOReq_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BearerType')))
    _E_RABToBeSetupItemHOReq_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Ethernet-Type')))
    E_RABToBeSetupItemHOReq_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 143), (u'criticality', u'ignore'), (u'Extension', _E_RABToBeSetupItemHOReq_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 233), (u'criticality', u'reject'), (u'Extension', _E_RABToBeSetupItemHOReq_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 305), (u'criticality', u'ignore'), (u'Extension', _E_RABToBeSetupItemHOReq_ExtIEs_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverRequestAcknowledge >-----#
    HandoverRequestAcknowledge = SEQ(name=u'HandoverRequestAcknowledge', mode=MODE_TYPE)
    _HandoverRequestAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __HandoverRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___HandoverRequestAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____HandoverRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABAdmittedList')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedtoSetupListHOReqAck')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Target-ToSource-TransparentContainer')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellAccessMode')))
    _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-mode-B-SupportIndicator')))
    ____HandoverRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 18), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 123), (u'criticality', u'reject'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 127), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 145), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 242), (u'criticality', u'ignore'), (u'Value', _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverRequestAcknowledge_protocolIEs__item__id._const_tab = ____HandoverRequestAcknowledge_protocolIEs__item__id_tab
    ___HandoverRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___HandoverRequestAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____HandoverRequestAcknowledge_protocolIEs__item__id_tab
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverRequestAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___HandoverRequestAcknowledge_protocolIEs__item__value._const_tab = ____HandoverRequestAcknowledge_protocolIEs__item__id_tab
    ___HandoverRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverRequestAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverRequestAcknowledge_protocolIEs__item__id),
        (u'criticality', ___HandoverRequestAcknowledge_protocolIEs__item__criticality),
        (u'value', ___HandoverRequestAcknowledge_protocolIEs__item__value),
        ])
    __HandoverRequestAcknowledge_protocolIEs__item_._ext = None
    _HandoverRequestAcknowledge_protocolIEs._cont = __HandoverRequestAcknowledge_protocolIEs__item_
    _HandoverRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverRequestAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _HandoverRequestAcknowledge_protocolIEs),
        ])
    HandoverRequestAcknowledge._ext = []
    
    #-----< HandoverRequestAcknowledgeIEs >-----#
    HandoverRequestAcknowledgeIEs = CLASS(name=u'HandoverRequestAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _HandoverRequestAcknowledgeIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverRequestAcknowledgeIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _HandoverRequestAcknowledgeIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABAdmittedList')))
    _HandoverRequestAcknowledgeIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedtoSetupListHOReqAck')))
    _HandoverRequestAcknowledgeIEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Target-ToSource-TransparentContainer')))
    _HandoverRequestAcknowledgeIEs_val_Value_5 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _HandoverRequestAcknowledgeIEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _HandoverRequestAcknowledgeIEs_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellAccessMode')))
    _HandoverRequestAcknowledgeIEs_val_Value_8 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-mode-B-SupportIndicator')))
    HandoverRequestAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledgeIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledgeIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 18), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledgeIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledgeIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 123), (u'criticality', u'reject'), (u'Value', _HandoverRequestAcknowledgeIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 127), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledgeIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledgeIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 145), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledgeIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 242), (u'criticality', u'ignore'), (u'Value', _HandoverRequestAcknowledgeIEs_val_Value_8), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABAdmittedList >-----#
    E_RABAdmittedList = SEQ_OF(name=u'E-RABAdmittedList', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RAB-IE-ContainerList')))
    _E_RABAdmittedList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABAdmittedList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___E_RABAdmittedList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABAdmittedList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABAdmittedItem')))
    ___E_RABAdmittedList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', ____E_RABAdmittedList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABAdmittedList__item__id._const_tab = ___E_RABAdmittedList__item__id_tab
    __E_RABAdmittedList__item__id._const_tab_at = None
    __E_RABAdmittedList__item__id._const_tab_id = u'id'
    __E_RABAdmittedList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABAdmittedList__item__criticality._const_tab = ___E_RABAdmittedList__item__id_tab
    __E_RABAdmittedList__item__criticality._const_tab_at = ('..', u'id')
    __E_RABAdmittedList__item__criticality._const_tab_id = u'criticality'
    __E_RABAdmittedList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __E_RABAdmittedList__item__value._const_tab = ___E_RABAdmittedList__item__id_tab
    __E_RABAdmittedList__item__value._const_tab_at = ('..', u'id')
    __E_RABAdmittedList__item__value._const_tab_id = u'Value'
    _E_RABAdmittedList__item_._cont = ASN1Dict([
        (u'id', __E_RABAdmittedList__item__id),
        (u'criticality', __E_RABAdmittedList__item__criticality),
        (u'value', __E_RABAdmittedList__item__value),
        ])
    _E_RABAdmittedList__item_._ext = None
    E_RABAdmittedList._cont = _E_RABAdmittedList__item_
    E_RABAdmittedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABAdmittedItemIEs >-----#
    E_RABAdmittedItemIEs = CLASS(name=u'E-RABAdmittedItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABAdmittedItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABAdmittedItem')))
    E_RABAdmittedItemIEs._val = ASN1Set(rv=[dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _E_RABAdmittedItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABAdmittedItem >-----#
    E_RABAdmittedItem = SEQ(name=u'E-RABAdmittedItem', mode=MODE_TYPE)
    _E_RABAdmittedItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABAdmittedItem_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABAdmittedItem_gTP_TEID = OCT_STR(name=u'gTP-TEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    _E_RABAdmittedItem_dL_transportLayerAddress = BIT_STR(name=u'dL-transportLayerAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')), opt=True)
    _E_RABAdmittedItem_dL_gTP_TEID = OCT_STR(name=u'dL-gTP-TEID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')), opt=True)
    _E_RABAdmittedItem_uL_TransportLayerAddress = BIT_STR(name=u'uL-TransportLayerAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')), opt=True)
    _E_RABAdmittedItem_uL_GTP_TEID = OCT_STR(name=u'uL-GTP-TEID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')), opt=True)
    _E_RABAdmittedItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABAdmittedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABAdmittedItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABAdmittedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABAdmittedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABAdmittedItem_iE_Extensions__item__id._const_tab = ____E_RABAdmittedItem_iE_Extensions__item__id_tab
    ___E_RABAdmittedItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABAdmittedItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABAdmittedItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABAdmittedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABAdmittedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABAdmittedItem_iE_Extensions__item__criticality._const_tab = ____E_RABAdmittedItem_iE_Extensions__item__criticality_tab
    ___E_RABAdmittedItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABAdmittedItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABAdmittedItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABAdmittedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABAdmittedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABAdmittedItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABAdmittedItem_iE_Extensions__item__extensionValue_tab
    ___E_RABAdmittedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABAdmittedItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABAdmittedItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABAdmittedItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABAdmittedItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABAdmittedItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABAdmittedItem_iE_Extensions__item_._ext = None
    _E_RABAdmittedItem_iE_Extensions._cont = __E_RABAdmittedItem_iE_Extensions__item_
    _E_RABAdmittedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABAdmittedItem._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABAdmittedItem_e_RAB_ID),
        (u'transportLayerAddress', _E_RABAdmittedItem_transportLayerAddress),
        (u'gTP-TEID', _E_RABAdmittedItem_gTP_TEID),
        (u'dL-transportLayerAddress', _E_RABAdmittedItem_dL_transportLayerAddress),
        (u'dL-gTP-TEID', _E_RABAdmittedItem_dL_gTP_TEID),
        (u'uL-TransportLayerAddress', _E_RABAdmittedItem_uL_TransportLayerAddress),
        (u'uL-GTP-TEID', _E_RABAdmittedItem_uL_GTP_TEID),
        (u'iE-Extensions', _E_RABAdmittedItem_iE_Extensions),
        ])
    E_RABAdmittedItem._ext = []
    
    #-----< E-RABAdmittedItem-ExtIEs >-----#
    E_RABAdmittedItem_ExtIEs = CLASS(name=u'E-RABAdmittedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABAdmittedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABFailedtoSetupListHOReqAck >-----#
    E_RABFailedtoSetupListHOReqAck = SEQ_OF(name=u'E-RABFailedtoSetupListHOReqAck', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RAB-IE-ContainerList')))
    _E_RABFailedtoSetupListHOReqAck__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABFailedtoSetupListHOReqAck__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___E_RABFailedtoSetupListHOReqAck__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABFailedtoSetupListHOReqAck__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedToSetupItemHOReqAck')))
    ___E_RABFailedtoSetupListHOReqAck__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', ____E_RABFailedtoSetupListHOReqAck__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABFailedtoSetupListHOReqAck__item__id._const_tab = ___E_RABFailedtoSetupListHOReqAck__item__id_tab
    __E_RABFailedtoSetupListHOReqAck__item__id._const_tab_at = None
    __E_RABFailedtoSetupListHOReqAck__item__id._const_tab_id = u'id'
    __E_RABFailedtoSetupListHOReqAck__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABFailedtoSetupListHOReqAck__item__criticality._const_tab = ___E_RABFailedtoSetupListHOReqAck__item__id_tab
    __E_RABFailedtoSetupListHOReqAck__item__criticality._const_tab_at = ('..', u'id')
    __E_RABFailedtoSetupListHOReqAck__item__criticality._const_tab_id = u'criticality'
    __E_RABFailedtoSetupListHOReqAck__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __E_RABFailedtoSetupListHOReqAck__item__value._const_tab = ___E_RABFailedtoSetupListHOReqAck__item__id_tab
    __E_RABFailedtoSetupListHOReqAck__item__value._const_tab_at = ('..', u'id')
    __E_RABFailedtoSetupListHOReqAck__item__value._const_tab_id = u'Value'
    _E_RABFailedtoSetupListHOReqAck__item_._cont = ASN1Dict([
        (u'id', __E_RABFailedtoSetupListHOReqAck__item__id),
        (u'criticality', __E_RABFailedtoSetupListHOReqAck__item__criticality),
        (u'value', __E_RABFailedtoSetupListHOReqAck__item__value),
        ])
    _E_RABFailedtoSetupListHOReqAck__item_._ext = None
    E_RABFailedtoSetupListHOReqAck._cont = _E_RABFailedtoSetupListHOReqAck__item_
    E_RABFailedtoSetupListHOReqAck._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABFailedtoSetupItemHOReqAckIEs >-----#
    E_RABFailedtoSetupItemHOReqAckIEs = CLASS(name=u'E-RABFailedtoSetupItemHOReqAckIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABFailedtoSetupItemHOReqAckIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedToSetupItemHOReqAck')))
    E_RABFailedtoSetupItemHOReqAckIEs._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _E_RABFailedtoSetupItemHOReqAckIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABFailedToSetupItemHOReqAck >-----#
    E_RABFailedToSetupItemHOReqAck = SEQ(name=u'E-RABFailedToSetupItemHOReqAck', mode=MODE_TYPE)
    _E_RABFailedToSetupItemHOReqAck_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABFailedToSetupItemHOReqAck_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _E_RABFailedToSetupItemHOReqAck_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABFailedToSetupItemHOReqAck_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__id._const_tab = ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__id_tab
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__id._const_tab_at = None
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__criticality._const_tab = ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__criticality_tab
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__extensionValue._const_tab = ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__extensionValue_tab
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABFailedToSetupItemHOReqAck_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__id),
        (u'criticality', ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__extensionValue),
        ])
    __E_RABFailedToSetupItemHOReqAck_iE_Extensions__item_._ext = None
    _E_RABFailedToSetupItemHOReqAck_iE_Extensions._cont = __E_RABFailedToSetupItemHOReqAck_iE_Extensions__item_
    _E_RABFailedToSetupItemHOReqAck_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABFailedToSetupItemHOReqAck._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABFailedToSetupItemHOReqAck_e_RAB_ID),
        (u'cause', _E_RABFailedToSetupItemHOReqAck_cause),
        (u'iE-Extensions', _E_RABFailedToSetupItemHOReqAck_iE_Extensions),
        ])
    E_RABFailedToSetupItemHOReqAck._ext = []
    
    #-----< E-RABFailedToSetupItemHOReqAckExtIEs >-----#
    E_RABFailedToSetupItemHOReqAckExtIEs = CLASS(name=u'E-RABFailedToSetupItemHOReqAckExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABFailedToSetupItemHOReqAckExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HandoverFailure >-----#
    HandoverFailure = SEQ(name=u'HandoverFailure', mode=MODE_TYPE)
    _HandoverFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __HandoverFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___HandoverFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____HandoverFailure_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____HandoverFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____HandoverFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____HandoverFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____HandoverFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _____HandoverFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____HandoverFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverFailure_protocolIEs__item__id._const_tab = ____HandoverFailure_protocolIEs__item__id_tab
    ___HandoverFailure_protocolIEs__item__id._const_tab_at = None
    ___HandoverFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverFailure_protocolIEs__item__criticality._const_tab = ____HandoverFailure_protocolIEs__item__id_tab
    ___HandoverFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___HandoverFailure_protocolIEs__item__value._const_tab = ____HandoverFailure_protocolIEs__item__id_tab
    ___HandoverFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverFailure_protocolIEs__item__id),
        (u'criticality', ___HandoverFailure_protocolIEs__item__criticality),
        (u'value', ___HandoverFailure_protocolIEs__item__value),
        ])
    __HandoverFailure_protocolIEs__item_._ext = None
    _HandoverFailure_protocolIEs._cont = __HandoverFailure_protocolIEs__item_
    _HandoverFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverFailure._cont = ASN1Dict([
        (u'protocolIEs', _HandoverFailure_protocolIEs),
        ])
    HandoverFailure._ext = []
    
    #-----< HandoverFailureIEs >-----#
    HandoverFailureIEs = CLASS(name=u'HandoverFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _HandoverFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverFailureIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _HandoverFailureIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    HandoverFailureIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _HandoverFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _HandoverFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _HandoverFailureIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverNotify >-----#
    HandoverNotify = SEQ(name=u'HandoverNotify', mode=MODE_TYPE)
    _HandoverNotify_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __HandoverNotify_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___HandoverNotify_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____HandoverNotify_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TunnelInformation')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LHN-ID')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PSCellInformation')))
    _____HandoverNotify_protocolIEs__item__id_tab_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NotifySourceeNB')))
    ____HandoverNotify_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 100), (u'criticality', u'ignore'), (u'Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 67), (u'criticality', u'ignore'), (u'Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 176), (u'criticality', u'ignore'), (u'Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 186), (u'criticality', u'ignore'), (u'Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 288), (u'criticality', u'ignore'), (u'Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 320), (u'criticality', u'ignore'), (u'Value', _____HandoverNotify_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverNotify_protocolIEs__item__id._const_tab = ____HandoverNotify_protocolIEs__item__id_tab
    ___HandoverNotify_protocolIEs__item__id._const_tab_at = None
    ___HandoverNotify_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverNotify_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverNotify_protocolIEs__item__criticality._const_tab = ____HandoverNotify_protocolIEs__item__id_tab
    ___HandoverNotify_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverNotify_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverNotify_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___HandoverNotify_protocolIEs__item__value._const_tab = ____HandoverNotify_protocolIEs__item__id_tab
    ___HandoverNotify_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverNotify_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverNotify_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverNotify_protocolIEs__item__id),
        (u'criticality', ___HandoverNotify_protocolIEs__item__criticality),
        (u'value', ___HandoverNotify_protocolIEs__item__value),
        ])
    __HandoverNotify_protocolIEs__item_._ext = None
    _HandoverNotify_protocolIEs._cont = __HandoverNotify_protocolIEs__item_
    _HandoverNotify_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverNotify._cont = ASN1Dict([
        (u'protocolIEs', _HandoverNotify_protocolIEs),
        ])
    HandoverNotify._ext = []
    
    #-----< HandoverNotifyIEs >-----#
    HandoverNotifyIEs = CLASS(name=u'HandoverNotifyIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _HandoverNotifyIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverNotifyIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _HandoverNotifyIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _HandoverNotifyIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _HandoverNotifyIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TunnelInformation')))
    _HandoverNotifyIEs_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LHN-ID')))
    _HandoverNotifyIEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PSCellInformation')))
    _HandoverNotifyIEs_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NotifySourceeNB')))
    HandoverNotifyIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _HandoverNotifyIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _HandoverNotifyIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 100), (u'criticality', u'ignore'), (u'Value', _HandoverNotifyIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 67), (u'criticality', u'ignore'), (u'Value', _HandoverNotifyIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 176), (u'criticality', u'ignore'), (u'Value', _HandoverNotifyIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 186), (u'criticality', u'ignore'), (u'Value', _HandoverNotifyIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 288), (u'criticality', u'ignore'), (u'Value', _HandoverNotifyIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 320), (u'criticality', u'ignore'), (u'Value', _HandoverNotifyIEs_val_Value_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PathSwitchRequest >-----#
    PathSwitchRequest = SEQ(name=u'PathSwitchRequest', mode=MODE_TYPE)
    _PathSwitchRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __PathSwitchRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___PathSwitchRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____PathSwitchRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSwitchedDLList')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESecurityCapabilities')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_6 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellAccessMode')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEI')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_9 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TunnelInformation')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_11 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LHN-ID')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_12 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RRC-Establishment-Cause')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_13 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_14 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PSCellInformation')))
    ____PathSwitchRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 22), (u'criticality', u'reject'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 88), (u'criticality', u'reject'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 100), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 67), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 107), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 127), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 145), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 176), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 186), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 245), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 269), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 288), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_14), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PathSwitchRequest_protocolIEs__item__id._const_tab = ____PathSwitchRequest_protocolIEs__item__id_tab
    ___PathSwitchRequest_protocolIEs__item__id._const_tab_at = None
    ___PathSwitchRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___PathSwitchRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___PathSwitchRequest_protocolIEs__item__criticality._const_tab = ____PathSwitchRequest_protocolIEs__item__id_tab
    ___PathSwitchRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PathSwitchRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PathSwitchRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___PathSwitchRequest_protocolIEs__item__value._const_tab = ____PathSwitchRequest_protocolIEs__item__id_tab
    ___PathSwitchRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PathSwitchRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __PathSwitchRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PathSwitchRequest_protocolIEs__item__id),
        (u'criticality', ___PathSwitchRequest_protocolIEs__item__criticality),
        (u'value', ___PathSwitchRequest_protocolIEs__item__value),
        ])
    __PathSwitchRequest_protocolIEs__item_._ext = None
    _PathSwitchRequest_protocolIEs._cont = __PathSwitchRequest_protocolIEs__item_
    _PathSwitchRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PathSwitchRequest._cont = ASN1Dict([
        (u'protocolIEs', _PathSwitchRequest_protocolIEs),
        ])
    PathSwitchRequest._ext = []
    
    #-----< PathSwitchRequestIEs >-----#
    PathSwitchRequestIEs = CLASS(name=u'PathSwitchRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _PathSwitchRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _PathSwitchRequestIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSwitchedDLList')))
    _PathSwitchRequestIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _PathSwitchRequestIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _PathSwitchRequestIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _PathSwitchRequestIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESecurityCapabilities')))
    _PathSwitchRequestIEs_val_Value_6 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _PathSwitchRequestIEs_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellAccessMode')))
    _PathSwitchRequestIEs_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEI')))
    _PathSwitchRequestIEs_val_Value_9 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _PathSwitchRequestIEs_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TunnelInformation')))
    _PathSwitchRequestIEs_val_Value_11 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LHN-ID')))
    _PathSwitchRequestIEs_val_Value_12 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RRC-Establishment-Cause')))
    _PathSwitchRequestIEs_val_Value_13 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _PathSwitchRequestIEs_val_Value_14 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PSCellInformation')))
    PathSwitchRequestIEs._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _PathSwitchRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 22), (u'criticality', u'reject'), (u'Value', _PathSwitchRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 88), (u'criticality', u'reject'), (u'Value', _PathSwitchRequestIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 100), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 67), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 107), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestIEs_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 127), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 145), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 176), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 186), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestIEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 245), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestIEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 269), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestIEs_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 288), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestIEs_val_Value_14), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeSwitchedDLList >-----#
    E_RABToBeSwitchedDLList = SEQ_OF(name=u'E-RABToBeSwitchedDLList', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RAB-IE-ContainerList')))
    _E_RABToBeSwitchedDLList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABToBeSwitchedDLList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___E_RABToBeSwitchedDLList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABToBeSwitchedDLList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSwitchedDLItem')))
    ___E_RABToBeSwitchedDLList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 23), (u'criticality', u'reject'), (u'Value', ____E_RABToBeSwitchedDLList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABToBeSwitchedDLList__item__id._const_tab = ___E_RABToBeSwitchedDLList__item__id_tab
    __E_RABToBeSwitchedDLList__item__id._const_tab_at = None
    __E_RABToBeSwitchedDLList__item__id._const_tab_id = u'id'
    __E_RABToBeSwitchedDLList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABToBeSwitchedDLList__item__criticality._const_tab = ___E_RABToBeSwitchedDLList__item__id_tab
    __E_RABToBeSwitchedDLList__item__criticality._const_tab_at = ('..', u'id')
    __E_RABToBeSwitchedDLList__item__criticality._const_tab_id = u'criticality'
    __E_RABToBeSwitchedDLList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __E_RABToBeSwitchedDLList__item__value._const_tab = ___E_RABToBeSwitchedDLList__item__id_tab
    __E_RABToBeSwitchedDLList__item__value._const_tab_at = ('..', u'id')
    __E_RABToBeSwitchedDLList__item__value._const_tab_id = u'Value'
    _E_RABToBeSwitchedDLList__item_._cont = ASN1Dict([
        (u'id', __E_RABToBeSwitchedDLList__item__id),
        (u'criticality', __E_RABToBeSwitchedDLList__item__criticality),
        (u'value', __E_RABToBeSwitchedDLList__item__value),
        ])
    _E_RABToBeSwitchedDLList__item_._ext = None
    E_RABToBeSwitchedDLList._cont = _E_RABToBeSwitchedDLList__item_
    E_RABToBeSwitchedDLList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABToBeSwitchedDLItemIEs >-----#
    E_RABToBeSwitchedDLItemIEs = CLASS(name=u'E-RABToBeSwitchedDLItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABToBeSwitchedDLItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSwitchedDLItem')))
    E_RABToBeSwitchedDLItemIEs._val = ASN1Set(rv=[dict([(u'id', 23), (u'criticality', u'reject'), (u'Value', _E_RABToBeSwitchedDLItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeSwitchedDLItem >-----#
    E_RABToBeSwitchedDLItem = SEQ(name=u'E-RABToBeSwitchedDLItem', mode=MODE_TYPE)
    _E_RABToBeSwitchedDLItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABToBeSwitchedDLItem_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABToBeSwitchedDLItem_gTP_TEID = OCT_STR(name=u'gTP-TEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    _E_RABToBeSwitchedDLItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABToBeSwitchedDLItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABToBeSwitchedDLItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABToBeSwitchedDLItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__id._const_tab = ____E_RABToBeSwitchedDLItem_iE_Extensions__item__id_tab
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABToBeSwitchedDLItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABToBeSwitchedDLItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__criticality._const_tab = ____E_RABToBeSwitchedDLItem_iE_Extensions__item__criticality_tab
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABToBeSwitchedDLItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABToBeSwitchedDLItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABToBeSwitchedDLItem_iE_Extensions__item__extensionValue_tab
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABToBeSwitchedDLItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABToBeSwitchedDLItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABToBeSwitchedDLItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABToBeSwitchedDLItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABToBeSwitchedDLItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABToBeSwitchedDLItem_iE_Extensions__item_._ext = None
    _E_RABToBeSwitchedDLItem_iE_Extensions._cont = __E_RABToBeSwitchedDLItem_iE_Extensions__item_
    _E_RABToBeSwitchedDLItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABToBeSwitchedDLItem._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABToBeSwitchedDLItem_e_RAB_ID),
        (u'transportLayerAddress', _E_RABToBeSwitchedDLItem_transportLayerAddress),
        (u'gTP-TEID', _E_RABToBeSwitchedDLItem_gTP_TEID),
        (u'iE-Extensions', _E_RABToBeSwitchedDLItem_iE_Extensions),
        ])
    E_RABToBeSwitchedDLItem._ext = []
    
    #-----< E-RABToBeSwitchedDLItem-ExtIEs >-----#
    E_RABToBeSwitchedDLItem_ExtIEs = CLASS(name=u'E-RABToBeSwitchedDLItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABToBeSwitchedDLItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PathSwitchRequestAcknowledge >-----#
    PathSwitchRequestAcknowledge = SEQ(name=u'PathSwitchRequestAcknowledge', mode=MODE_TYPE)
    _PathSwitchRequestAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __PathSwitchRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___PathSwitchRequestAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSwitchedULList')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityContext')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ProSeAuthorized')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEUserPlaneCIoTSupportIndicator')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'V2XServicesAuthorized')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_12 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESidelinkAggregateMaximumBitrate')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_13 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_14 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_15 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_16 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AerialUEsubscriptionInformation')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_17 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_18 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_19 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverRestrictionList')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_20 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_21 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRV2XServicesAuthorized')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_22 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_23 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PC5QoSParameters')))
    _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_24 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 66), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 95), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 33), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 241), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 240), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 248), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 251), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 269), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 271), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 277), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 283), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_17), (u'presence', u'optional')]), dict([(u'id', 278), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 41), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 299), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 306), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 307), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_22), (u'presence', u'optional')]), dict([(u'id', 308), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_23), (u'presence', u'optional')]), dict([(u'id', 314), (u'criticality', u'reject'), (u'Value', _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_24), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PathSwitchRequestAcknowledge_protocolIEs__item__id._const_tab = ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab
    ___PathSwitchRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___PathSwitchRequestAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab
    ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PathSwitchRequestAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___PathSwitchRequestAcknowledge_protocolIEs__item__value._const_tab = ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab
    ___PathSwitchRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PathSwitchRequestAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __PathSwitchRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PathSwitchRequestAcknowledge_protocolIEs__item__id),
        (u'criticality', ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality),
        (u'value', ___PathSwitchRequestAcknowledge_protocolIEs__item__value),
        ])
    __PathSwitchRequestAcknowledge_protocolIEs__item_._ext = None
    _PathSwitchRequestAcknowledge_protocolIEs._cont = __PathSwitchRequestAcknowledge_protocolIEs__item_
    _PathSwitchRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PathSwitchRequestAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _PathSwitchRequestAcknowledge_protocolIEs),
        ])
    PathSwitchRequestAcknowledge._ext = []
    
    #-----< PathSwitchRequestAcknowledgeIEs >-----#
    PathSwitchRequestAcknowledgeIEs = CLASS(name=u'PathSwitchRequestAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSwitchedULList')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityContext')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_7 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_8 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_9 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ProSeAuthorized')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEUserPlaneCIoTSupportIndicator')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'V2XServicesAuthorized')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_12 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESidelinkAggregateMaximumBitrate')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_13 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_14 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_15 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_16 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AerialUEsubscriptionInformation')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_17 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_18 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_19 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverRestrictionList')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_20 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_21 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRV2XServicesAuthorized')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_22 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_23 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PC5QoSParameters')))
    _PathSwitchRequestAcknowledgeIEs_val_Value_24 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    PathSwitchRequestAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 66), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 95), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 33), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 241), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 240), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 248), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 251), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 269), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 271), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 277), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 283), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_17), (u'presence', u'optional')]), dict([(u'id', 278), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 41), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 299), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 306), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 307), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_22), (u'presence', u'optional')]), dict([(u'id', 308), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_23), (u'presence', u'optional')]), dict([(u'id', 314), (u'criticality', u'reject'), (u'Value', _PathSwitchRequestAcknowledgeIEs_val_Value_24), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeSwitchedULList >-----#
    E_RABToBeSwitchedULList = SEQ_OF(name=u'E-RABToBeSwitchedULList', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RAB-IE-ContainerList')))
    _E_RABToBeSwitchedULList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABToBeSwitchedULList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___E_RABToBeSwitchedULList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABToBeSwitchedULList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSwitchedULItem')))
    ___E_RABToBeSwitchedULList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 94), (u'criticality', u'ignore'), (u'Value', ____E_RABToBeSwitchedULList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABToBeSwitchedULList__item__id._const_tab = ___E_RABToBeSwitchedULList__item__id_tab
    __E_RABToBeSwitchedULList__item__id._const_tab_at = None
    __E_RABToBeSwitchedULList__item__id._const_tab_id = u'id'
    __E_RABToBeSwitchedULList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABToBeSwitchedULList__item__criticality._const_tab = ___E_RABToBeSwitchedULList__item__id_tab
    __E_RABToBeSwitchedULList__item__criticality._const_tab_at = ('..', u'id')
    __E_RABToBeSwitchedULList__item__criticality._const_tab_id = u'criticality'
    __E_RABToBeSwitchedULList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __E_RABToBeSwitchedULList__item__value._const_tab = ___E_RABToBeSwitchedULList__item__id_tab
    __E_RABToBeSwitchedULList__item__value._const_tab_at = ('..', u'id')
    __E_RABToBeSwitchedULList__item__value._const_tab_id = u'Value'
    _E_RABToBeSwitchedULList__item_._cont = ASN1Dict([
        (u'id', __E_RABToBeSwitchedULList__item__id),
        (u'criticality', __E_RABToBeSwitchedULList__item__criticality),
        (u'value', __E_RABToBeSwitchedULList__item__value),
        ])
    _E_RABToBeSwitchedULList__item_._ext = None
    E_RABToBeSwitchedULList._cont = _E_RABToBeSwitchedULList__item_
    E_RABToBeSwitchedULList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABToBeSwitchedULItemIEs >-----#
    E_RABToBeSwitchedULItemIEs = CLASS(name=u'E-RABToBeSwitchedULItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABToBeSwitchedULItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSwitchedULItem')))
    E_RABToBeSwitchedULItemIEs._val = ASN1Set(rv=[dict([(u'id', 94), (u'criticality', u'ignore'), (u'Value', _E_RABToBeSwitchedULItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeSwitchedULItem >-----#
    E_RABToBeSwitchedULItem = SEQ(name=u'E-RABToBeSwitchedULItem', mode=MODE_TYPE)
    _E_RABToBeSwitchedULItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABToBeSwitchedULItem_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABToBeSwitchedULItem_gTP_TEID = OCT_STR(name=u'gTP-TEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    _E_RABToBeSwitchedULItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABToBeSwitchedULItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABToBeSwitchedULItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABToBeSwitchedULItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__id._const_tab = ____E_RABToBeSwitchedULItem_iE_Extensions__item__id_tab
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABToBeSwitchedULItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABToBeSwitchedULItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__criticality._const_tab = ____E_RABToBeSwitchedULItem_iE_Extensions__item__criticality_tab
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABToBeSwitchedULItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABToBeSwitchedULItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABToBeSwitchedULItem_iE_Extensions__item__extensionValue_tab
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABToBeSwitchedULItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABToBeSwitchedULItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABToBeSwitchedULItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABToBeSwitchedULItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABToBeSwitchedULItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABToBeSwitchedULItem_iE_Extensions__item_._ext = None
    _E_RABToBeSwitchedULItem_iE_Extensions._cont = __E_RABToBeSwitchedULItem_iE_Extensions__item_
    _E_RABToBeSwitchedULItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABToBeSwitchedULItem._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABToBeSwitchedULItem_e_RAB_ID),
        (u'transportLayerAddress', _E_RABToBeSwitchedULItem_transportLayerAddress),
        (u'gTP-TEID', _E_RABToBeSwitchedULItem_gTP_TEID),
        (u'iE-Extensions', _E_RABToBeSwitchedULItem_iE_Extensions),
        ])
    E_RABToBeSwitchedULItem._ext = []
    
    #-----< E-RABToBeSwitchedULItem-ExtIEs >-----#
    E_RABToBeSwitchedULItem_ExtIEs = CLASS(name=u'E-RABToBeSwitchedULItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABToBeSwitchedULItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PathSwitchRequestFailure >-----#
    PathSwitchRequestFailure = SEQ(name=u'PathSwitchRequestFailure', mode=MODE_TYPE)
    _PathSwitchRequestFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __PathSwitchRequestFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___PathSwitchRequestFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____PathSwitchRequestFailure_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____PathSwitchRequestFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PathSwitchRequestFailure_protocolIEs__item__id._const_tab = ____PathSwitchRequestFailure_protocolIEs__item__id_tab
    ___PathSwitchRequestFailure_protocolIEs__item__id._const_tab_at = None
    ___PathSwitchRequestFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___PathSwitchRequestFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___PathSwitchRequestFailure_protocolIEs__item__criticality._const_tab = ____PathSwitchRequestFailure_protocolIEs__item__id_tab
    ___PathSwitchRequestFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PathSwitchRequestFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PathSwitchRequestFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___PathSwitchRequestFailure_protocolIEs__item__value._const_tab = ____PathSwitchRequestFailure_protocolIEs__item__id_tab
    ___PathSwitchRequestFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PathSwitchRequestFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __PathSwitchRequestFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PathSwitchRequestFailure_protocolIEs__item__id),
        (u'criticality', ___PathSwitchRequestFailure_protocolIEs__item__criticality),
        (u'value', ___PathSwitchRequestFailure_protocolIEs__item__value),
        ])
    __PathSwitchRequestFailure_protocolIEs__item_._ext = None
    _PathSwitchRequestFailure_protocolIEs._cont = __PathSwitchRequestFailure_protocolIEs__item_
    _PathSwitchRequestFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PathSwitchRequestFailure._cont = ASN1Dict([
        (u'protocolIEs', _PathSwitchRequestFailure_protocolIEs),
        ])
    PathSwitchRequestFailure._ext = []
    
    #-----< PathSwitchRequestFailureIEs >-----#
    PathSwitchRequestFailureIEs = CLASS(name=u'PathSwitchRequestFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _PathSwitchRequestFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _PathSwitchRequestFailureIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _PathSwitchRequestFailureIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _PathSwitchRequestFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    PathSwitchRequestFailureIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestFailureIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _PathSwitchRequestFailureIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverCancel >-----#
    HandoverCancel = SEQ(name=u'HandoverCancel', mode=MODE_TYPE)
    _HandoverCancel_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __HandoverCancel_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___HandoverCancel_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____HandoverCancel_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____HandoverCancel_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    ____HandoverCancel_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _____HandoverCancel_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___HandoverCancel_protocolIEs__item__id._const_tab = ____HandoverCancel_protocolIEs__item__id_tab
    ___HandoverCancel_protocolIEs__item__id._const_tab_at = None
    ___HandoverCancel_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverCancel_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverCancel_protocolIEs__item__criticality._const_tab = ____HandoverCancel_protocolIEs__item__id_tab
    ___HandoverCancel_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverCancel_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverCancel_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___HandoverCancel_protocolIEs__item__value._const_tab = ____HandoverCancel_protocolIEs__item__id_tab
    ___HandoverCancel_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverCancel_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverCancel_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverCancel_protocolIEs__item__id),
        (u'criticality', ___HandoverCancel_protocolIEs__item__criticality),
        (u'value', ___HandoverCancel_protocolIEs__item__value),
        ])
    __HandoverCancel_protocolIEs__item_._ext = None
    _HandoverCancel_protocolIEs._cont = __HandoverCancel_protocolIEs__item_
    _HandoverCancel_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverCancel._cont = ASN1Dict([
        (u'protocolIEs', _HandoverCancel_protocolIEs),
        ])
    HandoverCancel._ext = []
    
    #-----< HandoverCancelIEs >-----#
    HandoverCancelIEs = CLASS(name=u'HandoverCancelIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _HandoverCancelIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverCancelIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _HandoverCancelIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    HandoverCancelIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _HandoverCancelIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _HandoverCancelIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _HandoverCancelIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< HandoverCancelAcknowledge >-----#
    HandoverCancelAcknowledge = SEQ(name=u'HandoverCancelAcknowledge', mode=MODE_TYPE)
    _HandoverCancelAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __HandoverCancelAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___HandoverCancelAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____HandoverCancelAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____HandoverCancelAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HandoverCancelAcknowledge_protocolIEs__item__id._const_tab = ____HandoverCancelAcknowledge_protocolIEs__item__id_tab
    ___HandoverCancelAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___HandoverCancelAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverCancelAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverCancelAcknowledge_protocolIEs__item__criticality._const_tab = ____HandoverCancelAcknowledge_protocolIEs__item__id_tab
    ___HandoverCancelAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverCancelAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverCancelAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___HandoverCancelAcknowledge_protocolIEs__item__value._const_tab = ____HandoverCancelAcknowledge_protocolIEs__item__id_tab
    ___HandoverCancelAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverCancelAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverCancelAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverCancelAcknowledge_protocolIEs__item__id),
        (u'criticality', ___HandoverCancelAcknowledge_protocolIEs__item__criticality),
        (u'value', ___HandoverCancelAcknowledge_protocolIEs__item__value),
        ])
    __HandoverCancelAcknowledge_protocolIEs__item_._ext = None
    _HandoverCancelAcknowledge_protocolIEs._cont = __HandoverCancelAcknowledge_protocolIEs__item_
    _HandoverCancelAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverCancelAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _HandoverCancelAcknowledge_protocolIEs),
        ])
    HandoverCancelAcknowledge._ext = []
    
    #-----< HandoverCancelAcknowledgeIEs >-----#
    HandoverCancelAcknowledgeIEs = CLASS(name=u'HandoverCancelAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _HandoverCancelAcknowledgeIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverCancelAcknowledgeIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _HandoverCancelAcknowledgeIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    HandoverCancelAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _HandoverCancelAcknowledgeIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _HandoverCancelAcknowledgeIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _HandoverCancelAcknowledgeIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HandoverSuccess >-----#
    HandoverSuccess = SEQ(name=u'HandoverSuccess', mode=MODE_TYPE)
    _HandoverSuccess_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __HandoverSuccess_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___HandoverSuccess_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____HandoverSuccess_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    ____HandoverSuccess_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___HandoverSuccess_protocolIEs__item__id._const_tab = ____HandoverSuccess_protocolIEs__item__id_tab
    ___HandoverSuccess_protocolIEs__item__id._const_tab_at = None
    ___HandoverSuccess_protocolIEs__item__id._const_tab_id = u'id'
    ___HandoverSuccess_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___HandoverSuccess_protocolIEs__item__criticality._const_tab = ____HandoverSuccess_protocolIEs__item__id_tab
    ___HandoverSuccess_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___HandoverSuccess_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___HandoverSuccess_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___HandoverSuccess_protocolIEs__item__value._const_tab = ____HandoverSuccess_protocolIEs__item__id_tab
    ___HandoverSuccess_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___HandoverSuccess_protocolIEs__item__value._const_tab_id = u'Value'
    __HandoverSuccess_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___HandoverSuccess_protocolIEs__item__id),
        (u'criticality', ___HandoverSuccess_protocolIEs__item__criticality),
        (u'value', ___HandoverSuccess_protocolIEs__item__value),
        ])
    __HandoverSuccess_protocolIEs__item_._ext = None
    _HandoverSuccess_protocolIEs._cont = __HandoverSuccess_protocolIEs__item_
    _HandoverSuccess_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    HandoverSuccess._cont = ASN1Dict([
        (u'protocolIEs', _HandoverSuccess_protocolIEs),
        ])
    HandoverSuccess._ext = []
    
    #-----< HandoverSuccessIEs >-----#
    HandoverSuccessIEs = CLASS(name=u'HandoverSuccessIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _HandoverSuccessIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _HandoverSuccessIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    HandoverSuccessIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _HandoverSuccessIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _HandoverSuccessIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ENBEarlyStatusTransfer >-----#
    ENBEarlyStatusTransfer = SEQ(name=u'ENBEarlyStatusTransfer', mode=MODE_TYPE)
    _ENBEarlyStatusTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ENBEarlyStatusTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ENBEarlyStatusTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____ENBEarlyStatusTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ENBEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____ENBEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____ENBEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-EarlyStatusTransfer-TransparentContainer')))
    ____ENBEarlyStatusTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____ENBEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____ENBEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 321), (u'criticality', u'reject'), (u'Value', _____ENBEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___ENBEarlyStatusTransfer_protocolIEs__item__id._const_tab = ____ENBEarlyStatusTransfer_protocolIEs__item__id_tab
    ___ENBEarlyStatusTransfer_protocolIEs__item__id._const_tab_at = None
    ___ENBEarlyStatusTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___ENBEarlyStatusTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___ENBEarlyStatusTransfer_protocolIEs__item__criticality._const_tab = ____ENBEarlyStatusTransfer_protocolIEs__item__id_tab
    ___ENBEarlyStatusTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ENBEarlyStatusTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ENBEarlyStatusTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___ENBEarlyStatusTransfer_protocolIEs__item__value._const_tab = ____ENBEarlyStatusTransfer_protocolIEs__item__id_tab
    ___ENBEarlyStatusTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ENBEarlyStatusTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __ENBEarlyStatusTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ENBEarlyStatusTransfer_protocolIEs__item__id),
        (u'criticality', ___ENBEarlyStatusTransfer_protocolIEs__item__criticality),
        (u'value', ___ENBEarlyStatusTransfer_protocolIEs__item__value),
        ])
    __ENBEarlyStatusTransfer_protocolIEs__item_._ext = None
    _ENBEarlyStatusTransfer_protocolIEs._cont = __ENBEarlyStatusTransfer_protocolIEs__item_
    _ENBEarlyStatusTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBEarlyStatusTransfer._cont = ASN1Dict([
        (u'protocolIEs', _ENBEarlyStatusTransfer_protocolIEs),
        ])
    ENBEarlyStatusTransfer._ext = []
    
    #-----< ENBEarlyStatusTransferIEs >-----#
    ENBEarlyStatusTransferIEs = CLASS(name=u'ENBEarlyStatusTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ENBEarlyStatusTransferIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _ENBEarlyStatusTransferIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _ENBEarlyStatusTransferIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-EarlyStatusTransfer-TransparentContainer')))
    ENBEarlyStatusTransferIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _ENBEarlyStatusTransferIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _ENBEarlyStatusTransferIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 321), (u'criticality', u'reject'), (u'Value', _ENBEarlyStatusTransferIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MMEEarlyStatusTransfer >-----#
    MMEEarlyStatusTransfer = SEQ(name=u'MMEEarlyStatusTransfer', mode=MODE_TYPE)
    _MMEEarlyStatusTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __MMEEarlyStatusTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___MMEEarlyStatusTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____MMEEarlyStatusTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____MMEEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____MMEEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____MMEEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-EarlyStatusTransfer-TransparentContainer')))
    ____MMEEarlyStatusTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____MMEEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____MMEEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 321), (u'criticality', u'reject'), (u'Value', _____MMEEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___MMEEarlyStatusTransfer_protocolIEs__item__id._const_tab = ____MMEEarlyStatusTransfer_protocolIEs__item__id_tab
    ___MMEEarlyStatusTransfer_protocolIEs__item__id._const_tab_at = None
    ___MMEEarlyStatusTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___MMEEarlyStatusTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___MMEEarlyStatusTransfer_protocolIEs__item__criticality._const_tab = ____MMEEarlyStatusTransfer_protocolIEs__item__id_tab
    ___MMEEarlyStatusTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MMEEarlyStatusTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MMEEarlyStatusTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___MMEEarlyStatusTransfer_protocolIEs__item__value._const_tab = ____MMEEarlyStatusTransfer_protocolIEs__item__id_tab
    ___MMEEarlyStatusTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MMEEarlyStatusTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __MMEEarlyStatusTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MMEEarlyStatusTransfer_protocolIEs__item__id),
        (u'criticality', ___MMEEarlyStatusTransfer_protocolIEs__item__criticality),
        (u'value', ___MMEEarlyStatusTransfer_protocolIEs__item__value),
        ])
    __MMEEarlyStatusTransfer_protocolIEs__item_._ext = None
    _MMEEarlyStatusTransfer_protocolIEs._cont = __MMEEarlyStatusTransfer_protocolIEs__item_
    _MMEEarlyStatusTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MMEEarlyStatusTransfer._cont = ASN1Dict([
        (u'protocolIEs', _MMEEarlyStatusTransfer_protocolIEs),
        ])
    MMEEarlyStatusTransfer._ext = []
    
    #-----< MMEEarlyStatusTransferIEs >-----#
    MMEEarlyStatusTransferIEs = CLASS(name=u'MMEEarlyStatusTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _MMEEarlyStatusTransferIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _MMEEarlyStatusTransferIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _MMEEarlyStatusTransferIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-EarlyStatusTransfer-TransparentContainer')))
    MMEEarlyStatusTransferIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _MMEEarlyStatusTransferIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _MMEEarlyStatusTransferIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 321), (u'criticality', u'reject'), (u'Value', _MMEEarlyStatusTransferIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABSetupRequest >-----#
    E_RABSetupRequest = SEQ(name=u'E-RABSetupRequest', mode=MODE_TYPE)
    _E_RABSetupRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __E_RABSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___E_RABSetupRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____E_RABSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupListBearerSUReq')))
    ____E_RABSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 66), (u'criticality', u'reject'), (u'Value', _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 16), (u'criticality', u'reject'), (u'Value', _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___E_RABSetupRequest_protocolIEs__item__id._const_tab = ____E_RABSetupRequest_protocolIEs__item__id_tab
    ___E_RABSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___E_RABSetupRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___E_RABSetupRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___E_RABSetupRequest_protocolIEs__item__criticality._const_tab = ____E_RABSetupRequest_protocolIEs__item__id_tab
    ___E_RABSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABSetupRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___E_RABSetupRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___E_RABSetupRequest_protocolIEs__item__value._const_tab = ____E_RABSetupRequest_protocolIEs__item__id_tab
    ___E_RABSetupRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___E_RABSetupRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __E_RABSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___E_RABSetupRequest_protocolIEs__item__id),
        (u'criticality', ___E_RABSetupRequest_protocolIEs__item__criticality),
        (u'value', ___E_RABSetupRequest_protocolIEs__item__value),
        ])
    __E_RABSetupRequest_protocolIEs__item_._ext = None
    _E_RABSetupRequest_protocolIEs._cont = __E_RABSetupRequest_protocolIEs__item_
    _E_RABSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_RABSetupRequest._cont = ASN1Dict([
        (u'protocolIEs', _E_RABSetupRequest_protocolIEs),
        ])
    E_RABSetupRequest._ext = []
    
    #-----< E-RABSetupRequestIEs >-----#
    E_RABSetupRequestIEs = CLASS(name=u'E-RABSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABSetupRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _E_RABSetupRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _E_RABSetupRequestIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _E_RABSetupRequestIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupListBearerSUReq')))
    E_RABSetupRequestIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _E_RABSetupRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _E_RABSetupRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 66), (u'criticality', u'reject'), (u'Value', _E_RABSetupRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 16), (u'criticality', u'reject'), (u'Value', _E_RABSetupRequestIEs_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeSetupListBearerSUReq >-----#
    E_RABToBeSetupListBearerSUReq = SEQ_OF(name=u'E-RABToBeSetupListBearerSUReq', mode=MODE_TYPE)
    _E_RABToBeSetupListBearerSUReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABToBeSetupListBearerSUReq__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___E_RABToBeSetupListBearerSUReq__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABToBeSetupListBearerSUReq__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupItemBearerSUReq')))
    ___E_RABToBeSetupListBearerSUReq__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 17), (u'criticality', u'reject'), (u'Value', ____E_RABToBeSetupListBearerSUReq__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABToBeSetupListBearerSUReq__item__id._const_tab = ___E_RABToBeSetupListBearerSUReq__item__id_tab
    __E_RABToBeSetupListBearerSUReq__item__id._const_tab_at = None
    __E_RABToBeSetupListBearerSUReq__item__id._const_tab_id = u'id'
    __E_RABToBeSetupListBearerSUReq__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABToBeSetupListBearerSUReq__item__criticality._const_tab = ___E_RABToBeSetupListBearerSUReq__item__id_tab
    __E_RABToBeSetupListBearerSUReq__item__criticality._const_tab_at = ('..', u'id')
    __E_RABToBeSetupListBearerSUReq__item__criticality._const_tab_id = u'criticality'
    __E_RABToBeSetupListBearerSUReq__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __E_RABToBeSetupListBearerSUReq__item__value._const_tab = ___E_RABToBeSetupListBearerSUReq__item__id_tab
    __E_RABToBeSetupListBearerSUReq__item__value._const_tab_at = ('..', u'id')
    __E_RABToBeSetupListBearerSUReq__item__value._const_tab_id = u'Value'
    _E_RABToBeSetupListBearerSUReq__item_._cont = ASN1Dict([
        (u'id', __E_RABToBeSetupListBearerSUReq__item__id),
        (u'criticality', __E_RABToBeSetupListBearerSUReq__item__criticality),
        (u'value', __E_RABToBeSetupListBearerSUReq__item__value),
        ])
    _E_RABToBeSetupListBearerSUReq__item_._ext = None
    E_RABToBeSetupListBearerSUReq._cont = _E_RABToBeSetupListBearerSUReq__item_
    E_RABToBeSetupListBearerSUReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABToBeSetupItemBearerSUReqIEs >-----#
    E_RABToBeSetupItemBearerSUReqIEs = CLASS(name=u'E-RABToBeSetupItemBearerSUReqIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABToBeSetupItemBearerSUReqIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupItemBearerSUReq')))
    E_RABToBeSetupItemBearerSUReqIEs._val = ASN1Set(rv=[dict([(u'id', 17), (u'criticality', u'reject'), (u'Value', _E_RABToBeSetupItemBearerSUReqIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeSetupItemBearerSUReq >-----#
    E_RABToBeSetupItemBearerSUReq = SEQ(name=u'E-RABToBeSetupItemBearerSUReq', mode=MODE_TYPE)
    _E_RABToBeSetupItemBearerSUReq_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABToBeSetupItemBearerSUReq_e_RABlevelQoSParameters = SEQ(name=u'e-RABlevelQoSParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RABLevelQoSParameters')))
    _E_RABToBeSetupItemBearerSUReq_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABToBeSetupItemBearerSUReq_gTP_TEID = OCT_STR(name=u'gTP-TEID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    _E_RABToBeSetupItemBearerSUReq_nAS_PDU = OCT_STR(name=u'nAS-PDU', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    _E_RABToBeSetupItemBearerSUReq_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABToBeSetupItemBearerSUReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Correlation-ID')))
    _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Correlation-ID')))
    _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BearerType')))
    _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Ethernet-Type')))
    ____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 156), (u'criticality', u'ignore'), (u'Extension', _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 183), (u'criticality', u'ignore'), (u'Extension', _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 233), (u'criticality', u'reject'), (u'Extension', _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 305), (u'criticality', u'ignore'), (u'Extension', _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id._const_tab = ____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id._const_tab_at = None
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__criticality._const_tab = ____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__extensionValue._const_tab = ____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABToBeSetupItemBearerSUReq_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id),
        (u'criticality', ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__extensionValue),
        ])
    __E_RABToBeSetupItemBearerSUReq_iE_Extensions__item_._ext = None
    _E_RABToBeSetupItemBearerSUReq_iE_Extensions._cont = __E_RABToBeSetupItemBearerSUReq_iE_Extensions__item_
    _E_RABToBeSetupItemBearerSUReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABToBeSetupItemBearerSUReq._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABToBeSetupItemBearerSUReq_e_RAB_ID),
        (u'e-RABlevelQoSParameters', _E_RABToBeSetupItemBearerSUReq_e_RABlevelQoSParameters),
        (u'transportLayerAddress', _E_RABToBeSetupItemBearerSUReq_transportLayerAddress),
        (u'gTP-TEID', _E_RABToBeSetupItemBearerSUReq_gTP_TEID),
        (u'nAS-PDU', _E_RABToBeSetupItemBearerSUReq_nAS_PDU),
        (u'iE-Extensions', _E_RABToBeSetupItemBearerSUReq_iE_Extensions),
        ])
    E_RABToBeSetupItemBearerSUReq._ext = []
    
    #-----< E-RABToBeSetupItemBearerSUReqExtIEs >-----#
    E_RABToBeSetupItemBearerSUReqExtIEs = CLASS(name=u'E-RABToBeSetupItemBearerSUReqExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Correlation-ID')))
    _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Correlation-ID')))
    _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BearerType')))
    _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Ethernet-Type')))
    E_RABToBeSetupItemBearerSUReqExtIEs._val = ASN1Set(rv=[dict([(u'id', 156), (u'criticality', u'ignore'), (u'Extension', _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 183), (u'criticality', u'ignore'), (u'Extension', _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 233), (u'criticality', u'reject'), (u'Extension', _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 305), (u'criticality', u'ignore'), (u'Extension', _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABSetupResponse >-----#
    E_RABSetupResponse = SEQ(name=u'E-RABSetupResponse', mode=MODE_TYPE)
    _E_RABSetupResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __E_RABSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___E_RABSetupResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____E_RABSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupListBearerSURes')))
    _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____E_RABSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 28), (u'criticality', u'ignore'), (u'Value', _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 29), (u'criticality', u'ignore'), (u'Value', _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABSetupResponse_protocolIEs__item__id._const_tab = ____E_RABSetupResponse_protocolIEs__item__id_tab
    ___E_RABSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___E_RABSetupResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___E_RABSetupResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___E_RABSetupResponse_protocolIEs__item__criticality._const_tab = ____E_RABSetupResponse_protocolIEs__item__id_tab
    ___E_RABSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABSetupResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___E_RABSetupResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___E_RABSetupResponse_protocolIEs__item__value._const_tab = ____E_RABSetupResponse_protocolIEs__item__id_tab
    ___E_RABSetupResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___E_RABSetupResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __E_RABSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___E_RABSetupResponse_protocolIEs__item__id),
        (u'criticality', ___E_RABSetupResponse_protocolIEs__item__criticality),
        (u'value', ___E_RABSetupResponse_protocolIEs__item__value),
        ])
    __E_RABSetupResponse_protocolIEs__item_._ext = None
    _E_RABSetupResponse_protocolIEs._cont = __E_RABSetupResponse_protocolIEs__item_
    _E_RABSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_RABSetupResponse._cont = ASN1Dict([
        (u'protocolIEs', _E_RABSetupResponse_protocolIEs),
        ])
    E_RABSetupResponse._ext = []
    
    #-----< E-RABSetupResponseIEs >-----#
    E_RABSetupResponseIEs = CLASS(name=u'E-RABSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABSetupResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _E_RABSetupResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _E_RABSetupResponseIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupListBearerSURes')))
    _E_RABSetupResponseIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _E_RABSetupResponseIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    E_RABSetupResponseIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _E_RABSetupResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _E_RABSetupResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 28), (u'criticality', u'ignore'), (u'Value', _E_RABSetupResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 29), (u'criticality', u'ignore'), (u'Value', _E_RABSetupResponseIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _E_RABSetupResponseIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABSetupListBearerSURes >-----#
    E_RABSetupListBearerSURes = SEQ_OF(name=u'E-RABSetupListBearerSURes', mode=MODE_TYPE)
    _E_RABSetupListBearerSURes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABSetupListBearerSURes__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___E_RABSetupListBearerSURes__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABSetupListBearerSURes__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupItemBearerSURes')))
    ___E_RABSetupListBearerSURes__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'ignore'), (u'Value', ____E_RABSetupListBearerSURes__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABSetupListBearerSURes__item__id._const_tab = ___E_RABSetupListBearerSURes__item__id_tab
    __E_RABSetupListBearerSURes__item__id._const_tab_at = None
    __E_RABSetupListBearerSURes__item__id._const_tab_id = u'id'
    __E_RABSetupListBearerSURes__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABSetupListBearerSURes__item__criticality._const_tab = ___E_RABSetupListBearerSURes__item__id_tab
    __E_RABSetupListBearerSURes__item__criticality._const_tab_at = ('..', u'id')
    __E_RABSetupListBearerSURes__item__criticality._const_tab_id = u'criticality'
    __E_RABSetupListBearerSURes__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __E_RABSetupListBearerSURes__item__value._const_tab = ___E_RABSetupListBearerSURes__item__id_tab
    __E_RABSetupListBearerSURes__item__value._const_tab_at = ('..', u'id')
    __E_RABSetupListBearerSURes__item__value._const_tab_id = u'Value'
    _E_RABSetupListBearerSURes__item_._cont = ASN1Dict([
        (u'id', __E_RABSetupListBearerSURes__item__id),
        (u'criticality', __E_RABSetupListBearerSURes__item__criticality),
        (u'value', __E_RABSetupListBearerSURes__item__value),
        ])
    _E_RABSetupListBearerSURes__item_._ext = None
    E_RABSetupListBearerSURes._cont = _E_RABSetupListBearerSURes__item_
    E_RABSetupListBearerSURes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABSetupItemBearerSUResIEs >-----#
    E_RABSetupItemBearerSUResIEs = CLASS(name=u'E-RABSetupItemBearerSUResIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABSetupItemBearerSUResIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupItemBearerSURes')))
    E_RABSetupItemBearerSUResIEs._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'ignore'), (u'Value', _E_RABSetupItemBearerSUResIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABSetupItemBearerSURes >-----#
    E_RABSetupItemBearerSURes = SEQ(name=u'E-RABSetupItemBearerSURes', mode=MODE_TYPE)
    _E_RABSetupItemBearerSURes_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABSetupItemBearerSURes_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABSetupItemBearerSURes_gTP_TEID = OCT_STR(name=u'gTP-TEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    _E_RABSetupItemBearerSURes_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABSetupItemBearerSURes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABSetupItemBearerSURes_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABSetupItemBearerSURes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__id._const_tab = ____E_RABSetupItemBearerSURes_iE_Extensions__item__id_tab
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__id._const_tab_at = None
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABSetupItemBearerSURes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABSetupItemBearerSURes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__criticality._const_tab = ____E_RABSetupItemBearerSURes_iE_Extensions__item__criticality_tab
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABSetupItemBearerSURes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABSetupItemBearerSURes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__extensionValue._const_tab = ____E_RABSetupItemBearerSURes_iE_Extensions__item__extensionValue_tab
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABSetupItemBearerSURes_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABSetupItemBearerSURes_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABSetupItemBearerSURes_iE_Extensions__item__id),
        (u'criticality', ___E_RABSetupItemBearerSURes_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABSetupItemBearerSURes_iE_Extensions__item__extensionValue),
        ])
    __E_RABSetupItemBearerSURes_iE_Extensions__item_._ext = None
    _E_RABSetupItemBearerSURes_iE_Extensions._cont = __E_RABSetupItemBearerSURes_iE_Extensions__item_
    _E_RABSetupItemBearerSURes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABSetupItemBearerSURes._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABSetupItemBearerSURes_e_RAB_ID),
        (u'transportLayerAddress', _E_RABSetupItemBearerSURes_transportLayerAddress),
        (u'gTP-TEID', _E_RABSetupItemBearerSURes_gTP_TEID),
        (u'iE-Extensions', _E_RABSetupItemBearerSURes_iE_Extensions),
        ])
    E_RABSetupItemBearerSURes._ext = []
    
    #-----< E-RABSetupItemBearerSUResExtIEs >-----#
    E_RABSetupItemBearerSUResExtIEs = CLASS(name=u'E-RABSetupItemBearerSUResExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABSetupItemBearerSUResExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABModifyRequest >-----#
    E_RABModifyRequest = SEQ(name=u'E-RABModifyRequest', mode=MODE_TYPE)
    _E_RABModifyRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __E_RABModifyRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___E_RABModifyRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____E_RABModifyRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeModifiedListBearerModReq')))
    _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageRequest')))
    ____E_RABModifyRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 66), (u'criticality', u'reject'), (u'Value', _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 30), (u'criticality', u'reject'), (u'Value', _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 268), (u'criticality', u'ignore'), (u'Value', _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABModifyRequest_protocolIEs__item__id._const_tab = ____E_RABModifyRequest_protocolIEs__item__id_tab
    ___E_RABModifyRequest_protocolIEs__item__id._const_tab_at = None
    ___E_RABModifyRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___E_RABModifyRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___E_RABModifyRequest_protocolIEs__item__criticality._const_tab = ____E_RABModifyRequest_protocolIEs__item__id_tab
    ___E_RABModifyRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABModifyRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___E_RABModifyRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___E_RABModifyRequest_protocolIEs__item__value._const_tab = ____E_RABModifyRequest_protocolIEs__item__id_tab
    ___E_RABModifyRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___E_RABModifyRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __E_RABModifyRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___E_RABModifyRequest_protocolIEs__item__id),
        (u'criticality', ___E_RABModifyRequest_protocolIEs__item__criticality),
        (u'value', ___E_RABModifyRequest_protocolIEs__item__value),
        ])
    __E_RABModifyRequest_protocolIEs__item_._ext = None
    _E_RABModifyRequest_protocolIEs._cont = __E_RABModifyRequest_protocolIEs__item_
    _E_RABModifyRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_RABModifyRequest._cont = ASN1Dict([
        (u'protocolIEs', _E_RABModifyRequest_protocolIEs),
        ])
    E_RABModifyRequest._ext = []
    
    #-----< E-RABModifyRequestIEs >-----#
    E_RABModifyRequestIEs = CLASS(name=u'E-RABModifyRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABModifyRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _E_RABModifyRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _E_RABModifyRequestIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _E_RABModifyRequestIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeModifiedListBearerModReq')))
    _E_RABModifyRequestIEs_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageRequest')))
    E_RABModifyRequestIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _E_RABModifyRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _E_RABModifyRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 66), (u'criticality', u'reject'), (u'Value', _E_RABModifyRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 30), (u'criticality', u'reject'), (u'Value', _E_RABModifyRequestIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 268), (u'criticality', u'ignore'), (u'Value', _E_RABModifyRequestIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeModifiedListBearerModReq >-----#
    E_RABToBeModifiedListBearerModReq = SEQ_OF(name=u'E-RABToBeModifiedListBearerModReq', mode=MODE_TYPE)
    _E_RABToBeModifiedListBearerModReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABToBeModifiedListBearerModReq__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___E_RABToBeModifiedListBearerModReq__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABToBeModifiedListBearerModReq__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeModifiedItemBearerModReq')))
    ___E_RABToBeModifiedListBearerModReq__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 36), (u'criticality', u'reject'), (u'Value', ____E_RABToBeModifiedListBearerModReq__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABToBeModifiedListBearerModReq__item__id._const_tab = ___E_RABToBeModifiedListBearerModReq__item__id_tab
    __E_RABToBeModifiedListBearerModReq__item__id._const_tab_at = None
    __E_RABToBeModifiedListBearerModReq__item__id._const_tab_id = u'id'
    __E_RABToBeModifiedListBearerModReq__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABToBeModifiedListBearerModReq__item__criticality._const_tab = ___E_RABToBeModifiedListBearerModReq__item__id_tab
    __E_RABToBeModifiedListBearerModReq__item__criticality._const_tab_at = ('..', u'id')
    __E_RABToBeModifiedListBearerModReq__item__criticality._const_tab_id = u'criticality'
    __E_RABToBeModifiedListBearerModReq__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __E_RABToBeModifiedListBearerModReq__item__value._const_tab = ___E_RABToBeModifiedListBearerModReq__item__id_tab
    __E_RABToBeModifiedListBearerModReq__item__value._const_tab_at = ('..', u'id')
    __E_RABToBeModifiedListBearerModReq__item__value._const_tab_id = u'Value'
    _E_RABToBeModifiedListBearerModReq__item_._cont = ASN1Dict([
        (u'id', __E_RABToBeModifiedListBearerModReq__item__id),
        (u'criticality', __E_RABToBeModifiedListBearerModReq__item__criticality),
        (u'value', __E_RABToBeModifiedListBearerModReq__item__value),
        ])
    _E_RABToBeModifiedListBearerModReq__item_._ext = None
    E_RABToBeModifiedListBearerModReq._cont = _E_RABToBeModifiedListBearerModReq__item_
    E_RABToBeModifiedListBearerModReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABToBeModifiedItemBearerModReqIEs >-----#
    E_RABToBeModifiedItemBearerModReqIEs = CLASS(name=u'E-RABToBeModifiedItemBearerModReqIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABToBeModifiedItemBearerModReqIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeModifiedItemBearerModReq')))
    E_RABToBeModifiedItemBearerModReqIEs._val = ASN1Set(rv=[dict([(u'id', 36), (u'criticality', u'reject'), (u'Value', _E_RABToBeModifiedItemBearerModReqIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeModifiedItemBearerModReq >-----#
    E_RABToBeModifiedItemBearerModReq = SEQ(name=u'E-RABToBeModifiedItemBearerModReq', mode=MODE_TYPE)
    _E_RABToBeModifiedItemBearerModReq_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABToBeModifiedItemBearerModReq_e_RABLevelQoSParameters = SEQ(name=u'e-RABLevelQoSParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RABLevelQoSParameters')))
    _E_RABToBeModifiedItemBearerModReq_nAS_PDU = OCT_STR(name=u'nAS-PDU', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    _E_RABToBeModifiedItemBearerModReq_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABToBeModifiedItemBearerModReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportInformation')))
    ____E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 185), (u'criticality', u'reject'), (u'Extension', _____E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id._const_tab = ____E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id_tab
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id._const_tab_at = None
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__criticality._const_tab = ____E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id_tab
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__extensionValue._const_tab = ____E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id_tab
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABToBeModifiedItemBearerModReq_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id),
        (u'criticality', ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__extensionValue),
        ])
    __E_RABToBeModifiedItemBearerModReq_iE_Extensions__item_._ext = None
    _E_RABToBeModifiedItemBearerModReq_iE_Extensions._cont = __E_RABToBeModifiedItemBearerModReq_iE_Extensions__item_
    _E_RABToBeModifiedItemBearerModReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABToBeModifiedItemBearerModReq._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABToBeModifiedItemBearerModReq_e_RAB_ID),
        (u'e-RABLevelQoSParameters', _E_RABToBeModifiedItemBearerModReq_e_RABLevelQoSParameters),
        (u'nAS-PDU', _E_RABToBeModifiedItemBearerModReq_nAS_PDU),
        (u'iE-Extensions', _E_RABToBeModifiedItemBearerModReq_iE_Extensions),
        ])
    E_RABToBeModifiedItemBearerModReq._ext = []
    
    #-----< E-RABToBeModifyItemBearerModReqExtIEs >-----#
    E_RABToBeModifyItemBearerModReqExtIEs = CLASS(name=u'E-RABToBeModifyItemBearerModReqExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _E_RABToBeModifyItemBearerModReqExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportInformation')))
    E_RABToBeModifyItemBearerModReqExtIEs._val = ASN1Set(rv=[dict([(u'id', 185), (u'criticality', u'reject'), (u'Extension', _E_RABToBeModifyItemBearerModReqExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABModifyResponse >-----#
    E_RABModifyResponse = SEQ(name=u'E-RABModifyResponse', mode=MODE_TYPE)
    _E_RABModifyResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __E_RABModifyResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___E_RABModifyResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____E_RABModifyResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyListBearerModRes')))
    _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    ____E_RABModifyResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 31), (u'criticality', u'ignore'), (u'Value', _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 32), (u'criticality', u'ignore'), (u'Value', _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'ignore'), (u'Value', _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABModifyResponse_protocolIEs__item__id._const_tab = ____E_RABModifyResponse_protocolIEs__item__id_tab
    ___E_RABModifyResponse_protocolIEs__item__id._const_tab_at = None
    ___E_RABModifyResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___E_RABModifyResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___E_RABModifyResponse_protocolIEs__item__criticality._const_tab = ____E_RABModifyResponse_protocolIEs__item__id_tab
    ___E_RABModifyResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABModifyResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___E_RABModifyResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___E_RABModifyResponse_protocolIEs__item__value._const_tab = ____E_RABModifyResponse_protocolIEs__item__id_tab
    ___E_RABModifyResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___E_RABModifyResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __E_RABModifyResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___E_RABModifyResponse_protocolIEs__item__id),
        (u'criticality', ___E_RABModifyResponse_protocolIEs__item__criticality),
        (u'value', ___E_RABModifyResponse_protocolIEs__item__value),
        ])
    __E_RABModifyResponse_protocolIEs__item_._ext = None
    _E_RABModifyResponse_protocolIEs._cont = __E_RABModifyResponse_protocolIEs__item_
    _E_RABModifyResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_RABModifyResponse._cont = ASN1Dict([
        (u'protocolIEs', _E_RABModifyResponse_protocolIEs),
        ])
    E_RABModifyResponse._ext = []
    
    #-----< E-RABModifyResponseIEs >-----#
    E_RABModifyResponseIEs = CLASS(name=u'E-RABModifyResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABModifyResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _E_RABModifyResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _E_RABModifyResponseIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyListBearerModRes')))
    _E_RABModifyResponseIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _E_RABModifyResponseIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _E_RABModifyResponseIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    E_RABModifyResponseIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _E_RABModifyResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _E_RABModifyResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 31), (u'criticality', u'ignore'), (u'Value', _E_RABModifyResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 32), (u'criticality', u'ignore'), (u'Value', _E_RABModifyResponseIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _E_RABModifyResponseIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'ignore'), (u'Value', _E_RABModifyResponseIEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABModifyListBearerModRes >-----#
    E_RABModifyListBearerModRes = SEQ_OF(name=u'E-RABModifyListBearerModRes', mode=MODE_TYPE)
    _E_RABModifyListBearerModRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABModifyListBearerModRes__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___E_RABModifyListBearerModRes__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABModifyListBearerModRes__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyItemBearerModRes')))
    ___E_RABModifyListBearerModRes__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 37), (u'criticality', u'ignore'), (u'Value', ____E_RABModifyListBearerModRes__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABModifyListBearerModRes__item__id._const_tab = ___E_RABModifyListBearerModRes__item__id_tab
    __E_RABModifyListBearerModRes__item__id._const_tab_at = None
    __E_RABModifyListBearerModRes__item__id._const_tab_id = u'id'
    __E_RABModifyListBearerModRes__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABModifyListBearerModRes__item__criticality._const_tab = ___E_RABModifyListBearerModRes__item__id_tab
    __E_RABModifyListBearerModRes__item__criticality._const_tab_at = ('..', u'id')
    __E_RABModifyListBearerModRes__item__criticality._const_tab_id = u'criticality'
    __E_RABModifyListBearerModRes__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __E_RABModifyListBearerModRes__item__value._const_tab = ___E_RABModifyListBearerModRes__item__id_tab
    __E_RABModifyListBearerModRes__item__value._const_tab_at = ('..', u'id')
    __E_RABModifyListBearerModRes__item__value._const_tab_id = u'Value'
    _E_RABModifyListBearerModRes__item_._cont = ASN1Dict([
        (u'id', __E_RABModifyListBearerModRes__item__id),
        (u'criticality', __E_RABModifyListBearerModRes__item__criticality),
        (u'value', __E_RABModifyListBearerModRes__item__value),
        ])
    _E_RABModifyListBearerModRes__item_._ext = None
    E_RABModifyListBearerModRes._cont = _E_RABModifyListBearerModRes__item_
    E_RABModifyListBearerModRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABModifyItemBearerModResIEs >-----#
    E_RABModifyItemBearerModResIEs = CLASS(name=u'E-RABModifyItemBearerModResIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABModifyItemBearerModResIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyItemBearerModRes')))
    E_RABModifyItemBearerModResIEs._val = ASN1Set(rv=[dict([(u'id', 37), (u'criticality', u'ignore'), (u'Value', _E_RABModifyItemBearerModResIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABModifyItemBearerModRes >-----#
    E_RABModifyItemBearerModRes = SEQ(name=u'E-RABModifyItemBearerModRes', mode=MODE_TYPE)
    _E_RABModifyItemBearerModRes_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABModifyItemBearerModRes_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABModifyItemBearerModRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABModifyItemBearerModRes_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABModifyItemBearerModRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__id._const_tab = ____E_RABModifyItemBearerModRes_iE_Extensions__item__id_tab
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__id._const_tab_at = None
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABModifyItemBearerModRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABModifyItemBearerModRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__criticality._const_tab = ____E_RABModifyItemBearerModRes_iE_Extensions__item__criticality_tab
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABModifyItemBearerModRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABModifyItemBearerModRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__extensionValue._const_tab = ____E_RABModifyItemBearerModRes_iE_Extensions__item__extensionValue_tab
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABModifyItemBearerModRes_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABModifyItemBearerModRes_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABModifyItemBearerModRes_iE_Extensions__item__id),
        (u'criticality', ___E_RABModifyItemBearerModRes_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABModifyItemBearerModRes_iE_Extensions__item__extensionValue),
        ])
    __E_RABModifyItemBearerModRes_iE_Extensions__item_._ext = None
    _E_RABModifyItemBearerModRes_iE_Extensions._cont = __E_RABModifyItemBearerModRes_iE_Extensions__item_
    _E_RABModifyItemBearerModRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABModifyItemBearerModRes._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABModifyItemBearerModRes_e_RAB_ID),
        (u'iE-Extensions', _E_RABModifyItemBearerModRes_iE_Extensions),
        ])
    E_RABModifyItemBearerModRes._ext = []
    
    #-----< E-RABModifyItemBearerModResExtIEs >-----#
    E_RABModifyItemBearerModResExtIEs = CLASS(name=u'E-RABModifyItemBearerModResExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABModifyItemBearerModResExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABReleaseCommand >-----#
    E_RABReleaseCommand = SEQ(name=u'E-RABReleaseCommand', mode=MODE_TYPE)
    _E_RABReleaseCommand_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __E_RABReleaseCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___E_RABReleaseCommand_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____E_RABReleaseCommand_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    ____E_RABReleaseCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 66), (u'criticality', u'reject'), (u'Value', _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 33), (u'criticality', u'ignore'), (u'Value', _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABReleaseCommand_protocolIEs__item__id._const_tab = ____E_RABReleaseCommand_protocolIEs__item__id_tab
    ___E_RABReleaseCommand_protocolIEs__item__id._const_tab_at = None
    ___E_RABReleaseCommand_protocolIEs__item__id._const_tab_id = u'id'
    ___E_RABReleaseCommand_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___E_RABReleaseCommand_protocolIEs__item__criticality._const_tab = ____E_RABReleaseCommand_protocolIEs__item__id_tab
    ___E_RABReleaseCommand_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABReleaseCommand_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___E_RABReleaseCommand_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___E_RABReleaseCommand_protocolIEs__item__value._const_tab = ____E_RABReleaseCommand_protocolIEs__item__id_tab
    ___E_RABReleaseCommand_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___E_RABReleaseCommand_protocolIEs__item__value._const_tab_id = u'Value'
    __E_RABReleaseCommand_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___E_RABReleaseCommand_protocolIEs__item__id),
        (u'criticality', ___E_RABReleaseCommand_protocolIEs__item__criticality),
        (u'value', ___E_RABReleaseCommand_protocolIEs__item__value),
        ])
    __E_RABReleaseCommand_protocolIEs__item_._ext = None
    _E_RABReleaseCommand_protocolIEs._cont = __E_RABReleaseCommand_protocolIEs__item_
    _E_RABReleaseCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_RABReleaseCommand._cont = ASN1Dict([
        (u'protocolIEs', _E_RABReleaseCommand_protocolIEs),
        ])
    E_RABReleaseCommand._ext = []
    
    #-----< E-RABReleaseCommandIEs >-----#
    E_RABReleaseCommandIEs = CLASS(name=u'E-RABReleaseCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABReleaseCommandIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _E_RABReleaseCommandIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _E_RABReleaseCommandIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _E_RABReleaseCommandIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _E_RABReleaseCommandIEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    E_RABReleaseCommandIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _E_RABReleaseCommandIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _E_RABReleaseCommandIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 66), (u'criticality', u'reject'), (u'Value', _E_RABReleaseCommandIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 33), (u'criticality', u'ignore'), (u'Value', _E_RABReleaseCommandIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _E_RABReleaseCommandIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABReleaseResponse >-----#
    E_RABReleaseResponse = SEQ(name=u'E-RABReleaseResponse', mode=MODE_TYPE)
    _E_RABReleaseResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __E_RABReleaseResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___E_RABReleaseResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____E_RABReleaseResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseListBearerRelComp')))
    _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    ____E_RABReleaseResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 69), (u'criticality', u'ignore'), (u'Value', _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 34), (u'criticality', u'ignore'), (u'Value', _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 189), (u'criticality', u'ignore'), (u'Value', _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'ignore'), (u'Value', _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABReleaseResponse_protocolIEs__item__id._const_tab = ____E_RABReleaseResponse_protocolIEs__item__id_tab
    ___E_RABReleaseResponse_protocolIEs__item__id._const_tab_at = None
    ___E_RABReleaseResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___E_RABReleaseResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___E_RABReleaseResponse_protocolIEs__item__criticality._const_tab = ____E_RABReleaseResponse_protocolIEs__item__id_tab
    ___E_RABReleaseResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABReleaseResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___E_RABReleaseResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___E_RABReleaseResponse_protocolIEs__item__value._const_tab = ____E_RABReleaseResponse_protocolIEs__item__id_tab
    ___E_RABReleaseResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___E_RABReleaseResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __E_RABReleaseResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___E_RABReleaseResponse_protocolIEs__item__id),
        (u'criticality', ___E_RABReleaseResponse_protocolIEs__item__criticality),
        (u'value', ___E_RABReleaseResponse_protocolIEs__item__value),
        ])
    __E_RABReleaseResponse_protocolIEs__item_._ext = None
    _E_RABReleaseResponse_protocolIEs._cont = __E_RABReleaseResponse_protocolIEs__item_
    _E_RABReleaseResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_RABReleaseResponse._cont = ASN1Dict([
        (u'protocolIEs', _E_RABReleaseResponse_protocolIEs),
        ])
    E_RABReleaseResponse._ext = []
    
    #-----< E-RABReleaseResponseIEs >-----#
    E_RABReleaseResponseIEs = CLASS(name=u'E-RABReleaseResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABReleaseResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _E_RABReleaseResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _E_RABReleaseResponseIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseListBearerRelComp')))
    _E_RABReleaseResponseIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _E_RABReleaseResponseIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _E_RABReleaseResponseIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    _E_RABReleaseResponseIEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    E_RABReleaseResponseIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _E_RABReleaseResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _E_RABReleaseResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 69), (u'criticality', u'ignore'), (u'Value', _E_RABReleaseResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 34), (u'criticality', u'ignore'), (u'Value', _E_RABReleaseResponseIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _E_RABReleaseResponseIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 189), (u'criticality', u'ignore'), (u'Value', _E_RABReleaseResponseIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'ignore'), (u'Value', _E_RABReleaseResponseIEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABReleaseListBearerRelComp >-----#
    E_RABReleaseListBearerRelComp = SEQ_OF(name=u'E-RABReleaseListBearerRelComp', mode=MODE_TYPE)
    _E_RABReleaseListBearerRelComp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABReleaseListBearerRelComp__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___E_RABReleaseListBearerRelComp__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABReleaseListBearerRelComp__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseItemBearerRelComp')))
    ___E_RABReleaseListBearerRelComp__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', ____E_RABReleaseListBearerRelComp__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABReleaseListBearerRelComp__item__id._const_tab = ___E_RABReleaseListBearerRelComp__item__id_tab
    __E_RABReleaseListBearerRelComp__item__id._const_tab_at = None
    __E_RABReleaseListBearerRelComp__item__id._const_tab_id = u'id'
    __E_RABReleaseListBearerRelComp__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABReleaseListBearerRelComp__item__criticality._const_tab = ___E_RABReleaseListBearerRelComp__item__id_tab
    __E_RABReleaseListBearerRelComp__item__criticality._const_tab_at = ('..', u'id')
    __E_RABReleaseListBearerRelComp__item__criticality._const_tab_id = u'criticality'
    __E_RABReleaseListBearerRelComp__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __E_RABReleaseListBearerRelComp__item__value._const_tab = ___E_RABReleaseListBearerRelComp__item__id_tab
    __E_RABReleaseListBearerRelComp__item__value._const_tab_at = ('..', u'id')
    __E_RABReleaseListBearerRelComp__item__value._const_tab_id = u'Value'
    _E_RABReleaseListBearerRelComp__item_._cont = ASN1Dict([
        (u'id', __E_RABReleaseListBearerRelComp__item__id),
        (u'criticality', __E_RABReleaseListBearerRelComp__item__criticality),
        (u'value', __E_RABReleaseListBearerRelComp__item__value),
        ])
    _E_RABReleaseListBearerRelComp__item_._ext = None
    E_RABReleaseListBearerRelComp._cont = _E_RABReleaseListBearerRelComp__item_
    E_RABReleaseListBearerRelComp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABReleaseItemBearerRelCompIEs >-----#
    E_RABReleaseItemBearerRelCompIEs = CLASS(name=u'E-RABReleaseItemBearerRelCompIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABReleaseItemBearerRelCompIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseItemBearerRelComp')))
    E_RABReleaseItemBearerRelCompIEs._val = ASN1Set(rv=[dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _E_RABReleaseItemBearerRelCompIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABReleaseItemBearerRelComp >-----#
    E_RABReleaseItemBearerRelComp = SEQ(name=u'E-RABReleaseItemBearerRelComp', mode=MODE_TYPE)
    _E_RABReleaseItemBearerRelComp_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABReleaseItemBearerRelComp_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABReleaseItemBearerRelComp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__id._const_tab = ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__id_tab
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__id._const_tab_at = None
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__criticality._const_tab = ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__criticality_tab
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__extensionValue._const_tab = ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__extensionValue_tab
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABReleaseItemBearerRelComp_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__id),
        (u'criticality', ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__extensionValue),
        ])
    __E_RABReleaseItemBearerRelComp_iE_Extensions__item_._ext = None
    _E_RABReleaseItemBearerRelComp_iE_Extensions._cont = __E_RABReleaseItemBearerRelComp_iE_Extensions__item_
    _E_RABReleaseItemBearerRelComp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABReleaseItemBearerRelComp._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABReleaseItemBearerRelComp_e_RAB_ID),
        (u'iE-Extensions', _E_RABReleaseItemBearerRelComp_iE_Extensions),
        ])
    E_RABReleaseItemBearerRelComp._ext = []
    
    #-----< E-RABReleaseItemBearerRelCompExtIEs >-----#
    E_RABReleaseItemBearerRelCompExtIEs = CLASS(name=u'E-RABReleaseItemBearerRelCompExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABReleaseItemBearerRelCompExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABReleaseIndication >-----#
    E_RABReleaseIndication = SEQ(name=u'E-RABReleaseIndication', mode=MODE_TYPE)
    _E_RABReleaseIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __E_RABReleaseIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___E_RABReleaseIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____E_RABReleaseIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    ____E_RABReleaseIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 110), (u'criticality', u'ignore'), (u'Value', _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 189), (u'criticality', u'ignore'), (u'Value', _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'ignore'), (u'Value', _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABReleaseIndication_protocolIEs__item__id._const_tab = ____E_RABReleaseIndication_protocolIEs__item__id_tab
    ___E_RABReleaseIndication_protocolIEs__item__id._const_tab_at = None
    ___E_RABReleaseIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___E_RABReleaseIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___E_RABReleaseIndication_protocolIEs__item__criticality._const_tab = ____E_RABReleaseIndication_protocolIEs__item__id_tab
    ___E_RABReleaseIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABReleaseIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___E_RABReleaseIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___E_RABReleaseIndication_protocolIEs__item__value._const_tab = ____E_RABReleaseIndication_protocolIEs__item__id_tab
    ___E_RABReleaseIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___E_RABReleaseIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __E_RABReleaseIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___E_RABReleaseIndication_protocolIEs__item__id),
        (u'criticality', ___E_RABReleaseIndication_protocolIEs__item__criticality),
        (u'value', ___E_RABReleaseIndication_protocolIEs__item__value),
        ])
    __E_RABReleaseIndication_protocolIEs__item_._ext = None
    _E_RABReleaseIndication_protocolIEs._cont = __E_RABReleaseIndication_protocolIEs__item_
    _E_RABReleaseIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_RABReleaseIndication._cont = ASN1Dict([
        (u'protocolIEs', _E_RABReleaseIndication_protocolIEs),
        ])
    E_RABReleaseIndication._ext = []
    
    #-----< E-RABReleaseIndicationIEs >-----#
    E_RABReleaseIndicationIEs = CLASS(name=u'E-RABReleaseIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABReleaseIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _E_RABReleaseIndicationIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _E_RABReleaseIndicationIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _E_RABReleaseIndicationIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    _E_RABReleaseIndicationIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    E_RABReleaseIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _E_RABReleaseIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _E_RABReleaseIndicationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 110), (u'criticality', u'ignore'), (u'Value', _E_RABReleaseIndicationIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 189), (u'criticality', u'ignore'), (u'Value', _E_RABReleaseIndicationIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'ignore'), (u'Value', _E_RABReleaseIndicationIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< InitialContextSetupRequest >-----#
    InitialContextSetupRequest = SEQ(name=u'InitialContextSetupRequest', mode=MODE_TYPE)
    _InitialContextSetupRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __InitialContextSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___InitialContextSetupRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____InitialContextSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupListCtxtSUReq')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESecurityCapabilities')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_5 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityKey')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TraceActivation')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverRestrictionList')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_9 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SubscriberProfileIDforRFP')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSFallbackIndicator')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_11 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCOperationPossible')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_12 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_13 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LAI')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_14 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEI')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_15 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_16 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ManagementBasedMDTAllowed')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_17 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDTPLMNList')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_18 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalCSFallbackIndicator')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_19 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Masked-IMEISV')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_20 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExpectedUEBehaviour')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_21 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ProSeAuthorized')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_22 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEUserPlaneCIoTSupportIndicator')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_23 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'V2XServicesAuthorized')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_24 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESidelinkAggregateMaximumBitrate')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_25 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_26 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_27 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_28 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AerialUEsubscriptionInformation')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_29 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_30 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_31 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_32 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IAB-Authorized')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_33 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRV2XServicesAuthorized')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_34 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_35 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PC5QoSParameters')))
    _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_36 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    ____InitialContextSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 66), (u'criticality', u'reject'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 24), (u'criticality', u'reject'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 107), (u'criticality', u'reject'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 73), (u'criticality', u'reject'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 41), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 74), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 106), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 108), (u'criticality', u'reject'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 124), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 159), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 75), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_17), (u'presence', u'optional')]), dict([(u'id', 187), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_18), (u'presence', u'conditional')]), dict([(u'id', 192), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 196), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 241), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_22), (u'presence', u'optional')]), dict([(u'id', 240), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_23), (u'presence', u'optional')]), dict([(u'id', 248), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_24), (u'presence', u'optional')]), dict([(u'id', 251), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_25), (u'presence', u'optional')]), dict([(u'id', 269), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_26), (u'presence', u'optional')]), dict([(u'id', 271), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_27), (u'presence', u'optional')]), dict([(u'id', 277), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_28), (u'presence', u'optional')]), dict([(u'id', 283), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_29), (u'presence', u'optional')]), dict([(u'id', 278), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_30), (u'presence', u'optional')]), dict([(u'id', 299), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_31), (u'presence', u'optional')]), dict([(u'id', 301), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_32), (u'presence', u'optional')]), dict([(u'id', 306), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_33), (u'presence', u'optional')]), dict([(u'id', 307), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_34), (u'presence', u'optional')]), dict([(u'id', 308), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_35), (u'presence', u'optional')]), dict([(u'id', 314), (u'criticality', u'reject'), (u'Value', _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_36), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___InitialContextSetupRequest_protocolIEs__item__id._const_tab = ____InitialContextSetupRequest_protocolIEs__item__id_tab
    ___InitialContextSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___InitialContextSetupRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___InitialContextSetupRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___InitialContextSetupRequest_protocolIEs__item__criticality._const_tab = ____InitialContextSetupRequest_protocolIEs__item__id_tab
    ___InitialContextSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___InitialContextSetupRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___InitialContextSetupRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___InitialContextSetupRequest_protocolIEs__item__value._const_tab = ____InitialContextSetupRequest_protocolIEs__item__id_tab
    ___InitialContextSetupRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___InitialContextSetupRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __InitialContextSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___InitialContextSetupRequest_protocolIEs__item__id),
        (u'criticality', ___InitialContextSetupRequest_protocolIEs__item__criticality),
        (u'value', ___InitialContextSetupRequest_protocolIEs__item__value),
        ])
    __InitialContextSetupRequest_protocolIEs__item_._ext = None
    _InitialContextSetupRequest_protocolIEs._cont = __InitialContextSetupRequest_protocolIEs__item_
    _InitialContextSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitialContextSetupRequest._cont = ASN1Dict([
        (u'protocolIEs', _InitialContextSetupRequest_protocolIEs),
        ])
    InitialContextSetupRequest._ext = []
    
    #-----< InitialContextSetupRequestIEs >-----#
    InitialContextSetupRequestIEs = CLASS(name=u'InitialContextSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _InitialContextSetupRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _InitialContextSetupRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _InitialContextSetupRequestIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _InitialContextSetupRequestIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupListCtxtSUReq')))
    _InitialContextSetupRequestIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESecurityCapabilities')))
    _InitialContextSetupRequestIEs_val_Value_5 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityKey')))
    _InitialContextSetupRequestIEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TraceActivation')))
    _InitialContextSetupRequestIEs_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverRestrictionList')))
    _InitialContextSetupRequestIEs_val_Value_8 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _InitialContextSetupRequestIEs_val_Value_9 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SubscriberProfileIDforRFP')))
    _InitialContextSetupRequestIEs_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSFallbackIndicator')))
    _InitialContextSetupRequestIEs_val_Value_11 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCOperationPossible')))
    _InitialContextSetupRequestIEs_val_Value_12 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _InitialContextSetupRequestIEs_val_Value_13 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LAI')))
    _InitialContextSetupRequestIEs_val_Value_14 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEI')))
    _InitialContextSetupRequestIEs_val_Value_15 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _InitialContextSetupRequestIEs_val_Value_16 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ManagementBasedMDTAllowed')))
    _InitialContextSetupRequestIEs_val_Value_17 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MDTPLMNList')))
    _InitialContextSetupRequestIEs_val_Value_18 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalCSFallbackIndicator')))
    _InitialContextSetupRequestIEs_val_Value_19 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Masked-IMEISV')))
    _InitialContextSetupRequestIEs_val_Value_20 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExpectedUEBehaviour')))
    _InitialContextSetupRequestIEs_val_Value_21 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ProSeAuthorized')))
    _InitialContextSetupRequestIEs_val_Value_22 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEUserPlaneCIoTSupportIndicator')))
    _InitialContextSetupRequestIEs_val_Value_23 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'V2XServicesAuthorized')))
    _InitialContextSetupRequestIEs_val_Value_24 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESidelinkAggregateMaximumBitrate')))
    _InitialContextSetupRequestIEs_val_Value_25 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _InitialContextSetupRequestIEs_val_Value_26 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _InitialContextSetupRequestIEs_val_Value_27 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _InitialContextSetupRequestIEs_val_Value_28 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AerialUEsubscriptionInformation')))
    _InitialContextSetupRequestIEs_val_Value_29 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    _InitialContextSetupRequestIEs_val_Value_30 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _InitialContextSetupRequestIEs_val_Value_31 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _InitialContextSetupRequestIEs_val_Value_32 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IAB-Authorized')))
    _InitialContextSetupRequestIEs_val_Value_33 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRV2XServicesAuthorized')))
    _InitialContextSetupRequestIEs_val_Value_34 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _InitialContextSetupRequestIEs_val_Value_35 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PC5QoSParameters')))
    _InitialContextSetupRequestIEs_val_Value_36 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    InitialContextSetupRequestIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _InitialContextSetupRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _InitialContextSetupRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 66), (u'criticality', u'reject'), (u'Value', _InitialContextSetupRequestIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 24), (u'criticality', u'reject'), (u'Value', _InitialContextSetupRequestIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 107), (u'criticality', u'reject'), (u'Value', _InitialContextSetupRequestIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 73), (u'criticality', u'reject'), (u'Value', _InitialContextSetupRequestIEs_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 41), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 74), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 106), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 108), (u'criticality', u'reject'), (u'Value', _InitialContextSetupRequestIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 124), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 159), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 75), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_17), (u'presence', u'optional')]), dict([(u'id', 187), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_18), (u'presence', u'conditional')]), dict([(u'id', 192), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 196), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 241), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_22), (u'presence', u'optional')]), dict([(u'id', 240), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_23), (u'presence', u'optional')]), dict([(u'id', 248), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_24), (u'presence', u'optional')]), dict([(u'id', 251), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_25), (u'presence', u'optional')]), dict([(u'id', 269), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_26), (u'presence', u'optional')]), dict([(u'id', 271), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_27), (u'presence', u'optional')]), dict([(u'id', 277), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_28), (u'presence', u'optional')]), dict([(u'id', 283), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_29), (u'presence', u'optional')]), dict([(u'id', 278), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_30), (u'presence', u'optional')]), dict([(u'id', 299), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_31), (u'presence', u'optional')]), dict([(u'id', 301), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_32), (u'presence', u'optional')]), dict([(u'id', 306), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_33), (u'presence', u'optional')]), dict([(u'id', 307), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_34), (u'presence', u'optional')]), dict([(u'id', 308), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupRequestIEs_val_Value_35), (u'presence', u'optional')]), dict([(u'id', 314), (u'criticality', u'reject'), (u'Value', _InitialContextSetupRequestIEs_val_Value_36), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeSetupListCtxtSUReq >-----#
    E_RABToBeSetupListCtxtSUReq = SEQ_OF(name=u'E-RABToBeSetupListCtxtSUReq', mode=MODE_TYPE)
    _E_RABToBeSetupListCtxtSUReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABToBeSetupListCtxtSUReq__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___E_RABToBeSetupListCtxtSUReq__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABToBeSetupListCtxtSUReq__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupItemCtxtSUReq')))
    ___E_RABToBeSetupListCtxtSUReq__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 52), (u'criticality', u'reject'), (u'Value', ____E_RABToBeSetupListCtxtSUReq__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABToBeSetupListCtxtSUReq__item__id._const_tab = ___E_RABToBeSetupListCtxtSUReq__item__id_tab
    __E_RABToBeSetupListCtxtSUReq__item__id._const_tab_at = None
    __E_RABToBeSetupListCtxtSUReq__item__id._const_tab_id = u'id'
    __E_RABToBeSetupListCtxtSUReq__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABToBeSetupListCtxtSUReq__item__criticality._const_tab = ___E_RABToBeSetupListCtxtSUReq__item__id_tab
    __E_RABToBeSetupListCtxtSUReq__item__criticality._const_tab_at = ('..', u'id')
    __E_RABToBeSetupListCtxtSUReq__item__criticality._const_tab_id = u'criticality'
    __E_RABToBeSetupListCtxtSUReq__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __E_RABToBeSetupListCtxtSUReq__item__value._const_tab = ___E_RABToBeSetupListCtxtSUReq__item__id_tab
    __E_RABToBeSetupListCtxtSUReq__item__value._const_tab_at = ('..', u'id')
    __E_RABToBeSetupListCtxtSUReq__item__value._const_tab_id = u'Value'
    _E_RABToBeSetupListCtxtSUReq__item_._cont = ASN1Dict([
        (u'id', __E_RABToBeSetupListCtxtSUReq__item__id),
        (u'criticality', __E_RABToBeSetupListCtxtSUReq__item__criticality),
        (u'value', __E_RABToBeSetupListCtxtSUReq__item__value),
        ])
    _E_RABToBeSetupListCtxtSUReq__item_._ext = None
    E_RABToBeSetupListCtxtSUReq._cont = _E_RABToBeSetupListCtxtSUReq__item_
    E_RABToBeSetupListCtxtSUReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABToBeSetupItemCtxtSUReqIEs >-----#
    E_RABToBeSetupItemCtxtSUReqIEs = CLASS(name=u'E-RABToBeSetupItemCtxtSUReqIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABToBeSetupItemCtxtSUReqIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeSetupItemCtxtSUReq')))
    E_RABToBeSetupItemCtxtSUReqIEs._val = ASN1Set(rv=[dict([(u'id', 52), (u'criticality', u'reject'), (u'Value', _E_RABToBeSetupItemCtxtSUReqIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeSetupItemCtxtSUReq >-----#
    E_RABToBeSetupItemCtxtSUReq = SEQ(name=u'E-RABToBeSetupItemCtxtSUReq', mode=MODE_TYPE)
    _E_RABToBeSetupItemCtxtSUReq_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABToBeSetupItemCtxtSUReq_e_RABlevelQoSParameters = SEQ(name=u'e-RABlevelQoSParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RABLevelQoSParameters')))
    _E_RABToBeSetupItemCtxtSUReq_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABToBeSetupItemCtxtSUReq_gTP_TEID = OCT_STR(name=u'gTP-TEID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    _E_RABToBeSetupItemCtxtSUReq_nAS_PDU = OCT_STR(name=u'nAS-PDU', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')), opt=True)
    _E_RABToBeSetupItemCtxtSUReq_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Correlation-ID')))
    _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Correlation-ID')))
    _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BearerType')))
    _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Ethernet-Type')))
    ____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 156), (u'criticality', u'ignore'), (u'Extension', _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 183), (u'criticality', u'ignore'), (u'Extension', _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 233), (u'criticality', u'reject'), (u'Extension', _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 305), (u'criticality', u'ignore'), (u'Extension', _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id._const_tab = ____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id._const_tab_at = None
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__criticality._const_tab = ____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__extensionValue._const_tab = ____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id),
        (u'criticality', ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__extensionValue),
        ])
    __E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item_._ext = None
    _E_RABToBeSetupItemCtxtSUReq_iE_Extensions._cont = __E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item_
    _E_RABToBeSetupItemCtxtSUReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABToBeSetupItemCtxtSUReq._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABToBeSetupItemCtxtSUReq_e_RAB_ID),
        (u'e-RABlevelQoSParameters', _E_RABToBeSetupItemCtxtSUReq_e_RABlevelQoSParameters),
        (u'transportLayerAddress', _E_RABToBeSetupItemCtxtSUReq_transportLayerAddress),
        (u'gTP-TEID', _E_RABToBeSetupItemCtxtSUReq_gTP_TEID),
        (u'nAS-PDU', _E_RABToBeSetupItemCtxtSUReq_nAS_PDU),
        (u'iE-Extensions', _E_RABToBeSetupItemCtxtSUReq_iE_Extensions),
        ])
    E_RABToBeSetupItemCtxtSUReq._ext = []
    
    #-----< E-RABToBeSetupItemCtxtSUReqExtIEs >-----#
    E_RABToBeSetupItemCtxtSUReqExtIEs = CLASS(name=u'E-RABToBeSetupItemCtxtSUReqExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_0 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Correlation-ID')))
    _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Correlation-ID')))
    _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BearerType')))
    _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Ethernet-Type')))
    E_RABToBeSetupItemCtxtSUReqExtIEs._val = ASN1Set(rv=[dict([(u'id', 156), (u'criticality', u'ignore'), (u'Extension', _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 183), (u'criticality', u'ignore'), (u'Extension', _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 233), (u'criticality', u'reject'), (u'Extension', _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 305), (u'criticality', u'ignore'), (u'Extension', _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< InitialContextSetupResponse >-----#
    InitialContextSetupResponse = SEQ(name=u'InitialContextSetupResponse', mode=MODE_TYPE)
    _InitialContextSetupResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __InitialContextSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___InitialContextSetupResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____InitialContextSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupListCtxtSURes')))
    _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____InitialContextSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 51), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 48), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___InitialContextSetupResponse_protocolIEs__item__id._const_tab = ____InitialContextSetupResponse_protocolIEs__item__id_tab
    ___InitialContextSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___InitialContextSetupResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___InitialContextSetupResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___InitialContextSetupResponse_protocolIEs__item__criticality._const_tab = ____InitialContextSetupResponse_protocolIEs__item__id_tab
    ___InitialContextSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___InitialContextSetupResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___InitialContextSetupResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___InitialContextSetupResponse_protocolIEs__item__value._const_tab = ____InitialContextSetupResponse_protocolIEs__item__id_tab
    ___InitialContextSetupResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___InitialContextSetupResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __InitialContextSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___InitialContextSetupResponse_protocolIEs__item__id),
        (u'criticality', ___InitialContextSetupResponse_protocolIEs__item__criticality),
        (u'value', ___InitialContextSetupResponse_protocolIEs__item__value),
        ])
    __InitialContextSetupResponse_protocolIEs__item_._ext = None
    _InitialContextSetupResponse_protocolIEs._cont = __InitialContextSetupResponse_protocolIEs__item_
    _InitialContextSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitialContextSetupResponse._cont = ASN1Dict([
        (u'protocolIEs', _InitialContextSetupResponse_protocolIEs),
        ])
    InitialContextSetupResponse._ext = []
    
    #-----< InitialContextSetupResponseIEs >-----#
    InitialContextSetupResponseIEs = CLASS(name=u'InitialContextSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _InitialContextSetupResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _InitialContextSetupResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _InitialContextSetupResponseIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupListCtxtSURes')))
    _InitialContextSetupResponseIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _InitialContextSetupResponseIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    InitialContextSetupResponseIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 51), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupResponseIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 48), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupResponseIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupResponseIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABSetupListCtxtSURes >-----#
    E_RABSetupListCtxtSURes = SEQ_OF(name=u'E-RABSetupListCtxtSURes', mode=MODE_TYPE)
    _E_RABSetupListCtxtSURes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABSetupListCtxtSURes__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___E_RABSetupListCtxtSURes__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABSetupListCtxtSURes__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupItemCtxtSURes')))
    ___E_RABSetupListCtxtSURes__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', ____E_RABSetupListCtxtSURes__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABSetupListCtxtSURes__item__id._const_tab = ___E_RABSetupListCtxtSURes__item__id_tab
    __E_RABSetupListCtxtSURes__item__id._const_tab_at = None
    __E_RABSetupListCtxtSURes__item__id._const_tab_id = u'id'
    __E_RABSetupListCtxtSURes__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABSetupListCtxtSURes__item__criticality._const_tab = ___E_RABSetupListCtxtSURes__item__id_tab
    __E_RABSetupListCtxtSURes__item__criticality._const_tab_at = ('..', u'id')
    __E_RABSetupListCtxtSURes__item__criticality._const_tab_id = u'criticality'
    __E_RABSetupListCtxtSURes__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __E_RABSetupListCtxtSURes__item__value._const_tab = ___E_RABSetupListCtxtSURes__item__id_tab
    __E_RABSetupListCtxtSURes__item__value._const_tab_at = ('..', u'id')
    __E_RABSetupListCtxtSURes__item__value._const_tab_id = u'Value'
    _E_RABSetupListCtxtSURes__item_._cont = ASN1Dict([
        (u'id', __E_RABSetupListCtxtSURes__item__id),
        (u'criticality', __E_RABSetupListCtxtSURes__item__criticality),
        (u'value', __E_RABSetupListCtxtSURes__item__value),
        ])
    _E_RABSetupListCtxtSURes__item_._ext = None
    E_RABSetupListCtxtSURes._cont = _E_RABSetupListCtxtSURes__item_
    E_RABSetupListCtxtSURes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABSetupItemCtxtSUResIEs >-----#
    E_RABSetupItemCtxtSUResIEs = CLASS(name=u'E-RABSetupItemCtxtSUResIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABSetupItemCtxtSUResIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupItemCtxtSURes')))
    E_RABSetupItemCtxtSUResIEs._val = ASN1Set(rv=[dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', _E_RABSetupItemCtxtSUResIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABSetupItemCtxtSURes >-----#
    E_RABSetupItemCtxtSURes = SEQ(name=u'E-RABSetupItemCtxtSURes', mode=MODE_TYPE)
    _E_RABSetupItemCtxtSURes_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABSetupItemCtxtSURes_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABSetupItemCtxtSURes_gTP_TEID = OCT_STR(name=u'gTP-TEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    _E_RABSetupItemCtxtSURes_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABSetupItemCtxtSURes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABSetupItemCtxtSURes_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABSetupItemCtxtSURes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__id._const_tab = ____E_RABSetupItemCtxtSURes_iE_Extensions__item__id_tab
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__id._const_tab_at = None
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABSetupItemCtxtSURes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABSetupItemCtxtSURes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__criticality._const_tab = ____E_RABSetupItemCtxtSURes_iE_Extensions__item__criticality_tab
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABSetupItemCtxtSURes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABSetupItemCtxtSURes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__extensionValue._const_tab = ____E_RABSetupItemCtxtSURes_iE_Extensions__item__extensionValue_tab
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABSetupItemCtxtSURes_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABSetupItemCtxtSURes_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABSetupItemCtxtSURes_iE_Extensions__item__id),
        (u'criticality', ___E_RABSetupItemCtxtSURes_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABSetupItemCtxtSURes_iE_Extensions__item__extensionValue),
        ])
    __E_RABSetupItemCtxtSURes_iE_Extensions__item_._ext = None
    _E_RABSetupItemCtxtSURes_iE_Extensions._cont = __E_RABSetupItemCtxtSURes_iE_Extensions__item_
    _E_RABSetupItemCtxtSURes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABSetupItemCtxtSURes._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABSetupItemCtxtSURes_e_RAB_ID),
        (u'transportLayerAddress', _E_RABSetupItemCtxtSURes_transportLayerAddress),
        (u'gTP-TEID', _E_RABSetupItemCtxtSURes_gTP_TEID),
        (u'iE-Extensions', _E_RABSetupItemCtxtSURes_iE_Extensions),
        ])
    E_RABSetupItemCtxtSURes._ext = []
    
    #-----< E-RABSetupItemCtxtSUResExtIEs >-----#
    E_RABSetupItemCtxtSUResExtIEs = CLASS(name=u'E-RABSetupItemCtxtSUResExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABSetupItemCtxtSUResExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InitialContextSetupFailure >-----#
    InitialContextSetupFailure = SEQ(name=u'InitialContextSetupFailure', mode=MODE_TYPE)
    _InitialContextSetupFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __InitialContextSetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___InitialContextSetupFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____InitialContextSetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____InitialContextSetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___InitialContextSetupFailure_protocolIEs__item__id._const_tab = ____InitialContextSetupFailure_protocolIEs__item__id_tab
    ___InitialContextSetupFailure_protocolIEs__item__id._const_tab_at = None
    ___InitialContextSetupFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___InitialContextSetupFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___InitialContextSetupFailure_protocolIEs__item__criticality._const_tab = ____InitialContextSetupFailure_protocolIEs__item__id_tab
    ___InitialContextSetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___InitialContextSetupFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___InitialContextSetupFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___InitialContextSetupFailure_protocolIEs__item__value._const_tab = ____InitialContextSetupFailure_protocolIEs__item__id_tab
    ___InitialContextSetupFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___InitialContextSetupFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __InitialContextSetupFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___InitialContextSetupFailure_protocolIEs__item__id),
        (u'criticality', ___InitialContextSetupFailure_protocolIEs__item__criticality),
        (u'value', ___InitialContextSetupFailure_protocolIEs__item__value),
        ])
    __InitialContextSetupFailure_protocolIEs__item_._ext = None
    _InitialContextSetupFailure_protocolIEs._cont = __InitialContextSetupFailure_protocolIEs__item_
    _InitialContextSetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitialContextSetupFailure._cont = ASN1Dict([
        (u'protocolIEs', _InitialContextSetupFailure_protocolIEs),
        ])
    InitialContextSetupFailure._ext = []
    
    #-----< InitialContextSetupFailureIEs >-----#
    InitialContextSetupFailureIEs = CLASS(name=u'InitialContextSetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _InitialContextSetupFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _InitialContextSetupFailureIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _InitialContextSetupFailureIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _InitialContextSetupFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    InitialContextSetupFailureIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupFailureIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _InitialContextSetupFailureIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Paging >-----#
    Paging = SEQ(name=u'Paging', mode=MODE_TYPE)
    _Paging_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __Paging_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___Paging_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____Paging_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____Paging_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEIdentityIndexValue')))
    _____Paging_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEPagingID')))
    _____Paging_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PagingDRX')))
    _____Paging_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CNDomain')))
    _____Paging_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TAIList')))
    _____Paging_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-IdList')))
    _____Paging_protocolIEs__item__id_tab_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PagingPriority')))
    _____Paging_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityForPaging')))
    _____Paging_protocolIEs__item__id_tab_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AssistanceDataForPaging')))
    _____Paging_protocolIEs__item__id_tab_val_Value_9 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Paging-eDRXInformation')))
    _____Paging_protocolIEs__item__id_tab_val_Value_10 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Extended-UEIdentityIndexValue')))
    _____Paging_protocolIEs__item__id_tab_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-Paging-eDRXInformation')))
    _____Paging_protocolIEs__item__id_tab_val_Value_12 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-UEIdentityIndexValue')))
    _____Paging_protocolIEs__item__id_tab_val_Value_13 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _____Paging_protocolIEs__item__id_tab_val_Value_14 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _____Paging_protocolIEs__item__id_tab_val_Value_15 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DataSize')))
    _____Paging_protocolIEs__item__id_tab_val_Value_16 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WUS-Assistance-Information')))
    _____Paging_protocolIEs__item__id_tab_val_Value_17 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-PagingDRX')))
    ____Paging_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 80), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 44), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 109), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 46), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 128), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 151), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 198), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 211), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 227), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 231), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 239), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 244), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 251), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 271), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 304), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 323), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 324), (u'criticality', u'ignore'), (u'Value', _____Paging_protocolIEs__item__id_tab_val_Value_17), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Paging_protocolIEs__item__id._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__id._const_tab_at = None
    ___Paging_protocolIEs__item__id._const_tab_id = u'id'
    ___Paging_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___Paging_protocolIEs__item__criticality._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___Paging_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___Paging_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___Paging_protocolIEs__item__value._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___Paging_protocolIEs__item__value._const_tab_id = u'Value'
    __Paging_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___Paging_protocolIEs__item__id),
        (u'criticality', ___Paging_protocolIEs__item__criticality),
        (u'value', ___Paging_protocolIEs__item__value),
        ])
    __Paging_protocolIEs__item_._ext = None
    _Paging_protocolIEs._cont = __Paging_protocolIEs__item_
    _Paging_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    Paging._cont = ASN1Dict([
        (u'protocolIEs', _Paging_protocolIEs),
        ])
    Paging._ext = []
    
    #-----< PagingIEs >-----#
    PagingIEs = CLASS(name=u'PagingIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _PagingIEs_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEIdentityIndexValue')))
    _PagingIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEPagingID')))
    _PagingIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PagingDRX')))
    _PagingIEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CNDomain')))
    _PagingIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TAIList')))
    _PagingIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-IdList')))
    _PagingIEs_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PagingPriority')))
    _PagingIEs_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityForPaging')))
    _PagingIEs_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AssistanceDataForPaging')))
    _PagingIEs_val_Value_9 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Paging-eDRXInformation')))
    _PagingIEs_val_Value_10 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Extended-UEIdentityIndexValue')))
    _PagingIEs_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-Paging-eDRXInformation')))
    _PagingIEs_val_Value_12 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-UEIdentityIndexValue')))
    _PagingIEs_val_Value_13 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _PagingIEs_val_Value_14 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _PagingIEs_val_Value_15 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DataSize')))
    _PagingIEs_val_Value_16 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WUS-Assistance-Information')))
    _PagingIEs_val_Value_17 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-PagingDRX')))
    PagingIEs._val = ASN1Set(rv=[dict([(u'id', 80), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 44), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 109), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 46), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 128), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 151), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 198), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 211), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 227), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 231), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 239), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 244), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 251), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 271), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 304), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 323), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 324), (u'criticality', u'ignore'), (u'Value', _PagingIEs_val_Value_17), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< TAIList >-----#
    TAIList = SEQ_OF(name=u'TAIList', mode=MODE_TYPE)
    _TAIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __TAIList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___TAIList__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____TAIList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TAIItem')))
    ___TAIList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 47), (u'criticality', u'ignore'), (u'Value', ____TAIList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __TAIList__item__id._const_tab = ___TAIList__item__id_tab
    __TAIList__item__id._const_tab_at = None
    __TAIList__item__id._const_tab_id = u'id'
    __TAIList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __TAIList__item__criticality._const_tab = ___TAIList__item__id_tab
    __TAIList__item__criticality._const_tab_at = ('..', u'id')
    __TAIList__item__criticality._const_tab_id = u'criticality'
    __TAIList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __TAIList__item__value._const_tab = ___TAIList__item__id_tab
    __TAIList__item__value._const_tab_at = ('..', u'id')
    __TAIList__item__value._const_tab_id = u'Value'
    _TAIList__item_._cont = ASN1Dict([
        (u'id', __TAIList__item__id),
        (u'criticality', __TAIList__item__criticality),
        (u'value', __TAIList__item__value),
        ])
    _TAIList__item_._ext = None
    TAIList._cont = _TAIList__item_
    TAIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< TAIItemIEs >-----#
    TAIItemIEs = CLASS(name=u'TAIItemIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _TAIItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TAIItem')))
    TAIItemIEs._val = ASN1Set(rv=[dict([(u'id', 47), (u'criticality', u'ignore'), (u'Value', _TAIItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TAIItem >-----#
    TAIItem = SEQ(name=u'TAIItem', mode=MODE_TYPE)
    _TAIItem_tAI = SEQ(name=u'tAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _TAIItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAIItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___TAIItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____TAIItem_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAIItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIItem_iE_Extensions__item__id._const_tab = ____TAIItem_iE_Extensions__item__id_tab
    ___TAIItem_iE_Extensions__item__id._const_tab_at = None
    ___TAIItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___TAIItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TAIItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAIItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIItem_iE_Extensions__item__criticality._const_tab = ____TAIItem_iE_Extensions__item__criticality_tab
    ___TAIItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TAIItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TAIItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TAIItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____TAIItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAIItem_iE_Extensions__item__extensionValue._const_tab = ____TAIItem_iE_Extensions__item__extensionValue_tab
    ___TAIItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TAIItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TAIItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TAIItem_iE_Extensions__item__id),
        (u'criticality', ___TAIItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___TAIItem_iE_Extensions__item__extensionValue),
        ])
    __TAIItem_iE_Extensions__item_._ext = None
    _TAIItem_iE_Extensions._cont = __TAIItem_iE_Extensions__item_
    _TAIItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAIItem._cont = ASN1Dict([
        (u'tAI', _TAIItem_tAI),
        (u'iE-Extensions', _TAIItem_iE_Extensions),
        ])
    TAIItem._ext = []
    
    #-----< TAIItemExtIEs >-----#
    TAIItemExtIEs = CLASS(name=u'TAIItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    TAIItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEContextReleaseRequest >-----#
    UEContextReleaseRequest = SEQ(name=u'UEContextReleaseRequest', mode=MODE_TYPE)
    _UEContextReleaseRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextReleaseRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GWContextReleaseIndication')))
    _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    ____UEContextReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 164), (u'criticality', u'reject'), (u'Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextReleaseRequest_protocolIEs__item__id._const_tab = ____UEContextReleaseRequest_protocolIEs__item__id_tab
    ___UEContextReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextReleaseRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextReleaseRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextReleaseRequest_protocolIEs__item__criticality._const_tab = ____UEContextReleaseRequest_protocolIEs__item__id_tab
    ___UEContextReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextReleaseRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextReleaseRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextReleaseRequest_protocolIEs__item__value._const_tab = ____UEContextReleaseRequest_protocolIEs__item__id_tab
    ___UEContextReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextReleaseRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextReleaseRequest_protocolIEs__item__id),
        (u'criticality', ___UEContextReleaseRequest_protocolIEs__item__criticality),
        (u'value', ___UEContextReleaseRequest_protocolIEs__item__value),
        ])
    __UEContextReleaseRequest_protocolIEs__item_._ext = None
    _UEContextReleaseRequest_protocolIEs._cont = __UEContextReleaseRequest_protocolIEs__item_
    _UEContextReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextReleaseRequest._cont = ASN1Dict([
        (u'protocolIEs', _UEContextReleaseRequest_protocolIEs),
        ])
    UEContextReleaseRequest._ext = []
    
    #-----< UEContextReleaseRequest-IEs >-----#
    UEContextReleaseRequest_IEs = CLASS(name=u'UEContextReleaseRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextReleaseRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextReleaseRequest_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextReleaseRequest_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _UEContextReleaseRequest_IEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GWContextReleaseIndication')))
    _UEContextReleaseRequest_IEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    UEContextReleaseRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _UEContextReleaseRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _UEContextReleaseRequest_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseRequest_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 164), (u'criticality', u'reject'), (u'Value', _UEContextReleaseRequest_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseRequest_IEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextReleaseCommand >-----#
    UEContextReleaseCommand = SEQ(name=u'UEContextReleaseCommand', mode=MODE_TYPE)
    _UEContextReleaseCommand_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextReleaseCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextReleaseCommand_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextReleaseCommand_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-S1AP-IDs')))
    _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    ____UEContextReleaseCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 99), (u'criticality', u'reject'), (u'Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___UEContextReleaseCommand_protocolIEs__item__id._const_tab = ____UEContextReleaseCommand_protocolIEs__item__id_tab
    ___UEContextReleaseCommand_protocolIEs__item__id._const_tab_at = None
    ___UEContextReleaseCommand_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextReleaseCommand_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextReleaseCommand_protocolIEs__item__criticality._const_tab = ____UEContextReleaseCommand_protocolIEs__item__id_tab
    ___UEContextReleaseCommand_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextReleaseCommand_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextReleaseCommand_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextReleaseCommand_protocolIEs__item__value._const_tab = ____UEContextReleaseCommand_protocolIEs__item__id_tab
    ___UEContextReleaseCommand_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextReleaseCommand_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextReleaseCommand_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextReleaseCommand_protocolIEs__item__id),
        (u'criticality', ___UEContextReleaseCommand_protocolIEs__item__criticality),
        (u'value', ___UEContextReleaseCommand_protocolIEs__item__value),
        ])
    __UEContextReleaseCommand_protocolIEs__item_._ext = None
    _UEContextReleaseCommand_protocolIEs._cont = __UEContextReleaseCommand_protocolIEs__item_
    _UEContextReleaseCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextReleaseCommand._cont = ASN1Dict([
        (u'protocolIEs', _UEContextReleaseCommand_protocolIEs),
        ])
    UEContextReleaseCommand._ext = []
    
    #-----< UEContextReleaseCommand-IEs >-----#
    UEContextReleaseCommand_IEs = CLASS(name=u'UEContextReleaseCommand-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextReleaseCommand_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-S1AP-IDs')))
    _UEContextReleaseCommand_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    UEContextReleaseCommand_IEs._val = ASN1Set(rv=[dict([(u'id', 99), (u'criticality', u'reject'), (u'Value', _UEContextReleaseCommand_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseCommand_IEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEContextReleaseComplete >-----#
    UEContextReleaseComplete = SEQ(name=u'UEContextReleaseComplete', mode=MODE_TYPE)
    _UEContextReleaseComplete_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextReleaseComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextReleaseComplete_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextReleaseComplete_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'InformationOnRecommendedCellsAndENBsForPaging')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellIdentifierAndCELevelForCECapableUEs')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeSinceSecondaryNodeRelease')))
    ____UEContextReleaseComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 189), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 213), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 212), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 297), (u'criticality', u'ignore'), (u'Value', _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextReleaseComplete_protocolIEs__item__id._const_tab = ____UEContextReleaseComplete_protocolIEs__item__id_tab
    ___UEContextReleaseComplete_protocolIEs__item__id._const_tab_at = None
    ___UEContextReleaseComplete_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextReleaseComplete_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextReleaseComplete_protocolIEs__item__criticality._const_tab = ____UEContextReleaseComplete_protocolIEs__item__id_tab
    ___UEContextReleaseComplete_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextReleaseComplete_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextReleaseComplete_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextReleaseComplete_protocolIEs__item__value._const_tab = ____UEContextReleaseComplete_protocolIEs__item__id_tab
    ___UEContextReleaseComplete_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextReleaseComplete_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextReleaseComplete_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextReleaseComplete_protocolIEs__item__id),
        (u'criticality', ___UEContextReleaseComplete_protocolIEs__item__criticality),
        (u'value', ___UEContextReleaseComplete_protocolIEs__item__value),
        ])
    __UEContextReleaseComplete_protocolIEs__item_._ext = None
    _UEContextReleaseComplete_protocolIEs._cont = __UEContextReleaseComplete_protocolIEs__item_
    _UEContextReleaseComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextReleaseComplete._cont = ASN1Dict([
        (u'protocolIEs', _UEContextReleaseComplete_protocolIEs),
        ])
    UEContextReleaseComplete._ext = []
    
    #-----< UEContextReleaseComplete-IEs >-----#
    UEContextReleaseComplete_IEs = CLASS(name=u'UEContextReleaseComplete-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextReleaseComplete_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextReleaseComplete_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextReleaseComplete_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _UEContextReleaseComplete_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    _UEContextReleaseComplete_IEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'InformationOnRecommendedCellsAndENBsForPaging')))
    _UEContextReleaseComplete_IEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellIdentifierAndCELevelForCECapableUEs')))
    _UEContextReleaseComplete_IEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    _UEContextReleaseComplete_IEs_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeSinceSecondaryNodeRelease')))
    UEContextReleaseComplete_IEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseComplete_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseComplete_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseComplete_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 189), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseComplete_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 213), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseComplete_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 212), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseComplete_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseComplete_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 297), (u'criticality', u'ignore'), (u'Value', _UEContextReleaseComplete_IEs_val_Value_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationRequest >-----#
    UEContextModificationRequest = SEQ(name=u'UEContextModificationRequest', mode=MODE_TYPE)
    _UEContextModificationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextModificationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_2 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityKey')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SubscriberProfileIDforRFP')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSFallbackIndicator')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESecurityCapabilities')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LAI')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_9 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalCSFallbackIndicator')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ProSeAuthorized')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_11 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCOperationPossible')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_12 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCOperationNotPossible')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_13 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'V2XServicesAuthorized')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_14 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESidelinkAggregateMaximumBitrate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_15 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_16 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AerialUEsubscriptionInformation')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_17 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_18 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IAB-Authorized')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_19 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRV2XServicesAuthorized')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_20 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_21 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PC5QoSParameters')))
    _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_22 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    ____UEContextModificationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 73), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 106), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 66), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 108), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 107), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 159), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 187), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'conditional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 124), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 243), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 240), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 248), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 269), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 277), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 299), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_17), (u'presence', u'optional')]), dict([(u'id', 301), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 306), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 307), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 308), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 314), (u'criticality', u'reject'), (u'Value', _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_22), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationRequest_protocolIEs__item__id._const_tab = ____UEContextModificationRequest_protocolIEs__item__id_tab
    ___UEContextModificationRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextModificationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextModificationRequest_protocolIEs__item__criticality._const_tab = ____UEContextModificationRequest_protocolIEs__item__id_tab
    ___UEContextModificationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextModificationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextModificationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextModificationRequest_protocolIEs__item__value._const_tab = ____UEContextModificationRequest_protocolIEs__item__id_tab
    ___UEContextModificationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextModificationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextModificationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextModificationRequest_protocolIEs__item__id),
        (u'criticality', ___UEContextModificationRequest_protocolIEs__item__criticality),
        (u'value', ___UEContextModificationRequest_protocolIEs__item__value),
        ])
    __UEContextModificationRequest_protocolIEs__item_._ext = None
    _UEContextModificationRequest_protocolIEs._cont = __UEContextModificationRequest_protocolIEs__item_
    _UEContextModificationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationRequest._cont = ASN1Dict([
        (u'protocolIEs', _UEContextModificationRequest_protocolIEs),
        ])
    UEContextModificationRequest._ext = []
    
    #-----< UEContextModificationRequestIEs >-----#
    UEContextModificationRequestIEs = CLASS(name=u'UEContextModificationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextModificationRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextModificationRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextModificationRequestIEs_val_Value_2 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityKey')))
    _UEContextModificationRequestIEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SubscriberProfileIDforRFP')))
    _UEContextModificationRequestIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UEAggregateMaximumBitrate')))
    _UEContextModificationRequestIEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSFallbackIndicator')))
    _UEContextModificationRequestIEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESecurityCapabilities')))
    _UEContextModificationRequestIEs_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _UEContextModificationRequestIEs_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LAI')))
    _UEContextModificationRequestIEs_val_Value_9 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalCSFallbackIndicator')))
    _UEContextModificationRequestIEs_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ProSeAuthorized')))
    _UEContextModificationRequestIEs_val_Value_11 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCOperationPossible')))
    _UEContextModificationRequestIEs_val_Value_12 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCOperationNotPossible')))
    _UEContextModificationRequestIEs_val_Value_13 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'V2XServicesAuthorized')))
    _UEContextModificationRequestIEs_val_Value_14 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UESidelinkAggregateMaximumBitrate')))
    _UEContextModificationRequestIEs_val_Value_15 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _UEContextModificationRequestIEs_val_Value_16 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AerialUEsubscriptionInformation')))
    _UEContextModificationRequestIEs_val_Value_17 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _UEContextModificationRequestIEs_val_Value_18 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IAB-Authorized')))
    _UEContextModificationRequestIEs_val_Value_19 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRV2XServicesAuthorized')))
    _UEContextModificationRequestIEs_val_Value_20 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESidelinkAggregateMaximumBitrate')))
    _UEContextModificationRequestIEs_val_Value_21 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PC5QoSParameters')))
    _UEContextModificationRequestIEs_val_Value_22 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    UEContextModificationRequestIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 73), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 106), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 66), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 108), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 107), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 159), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 187), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_9), (u'presence', u'conditional')]), dict([(u'id', 195), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 124), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 243), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 240), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 248), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 269), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 277), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 299), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_17), (u'presence', u'optional')]), dict([(u'id', 301), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 306), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 307), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 308), (u'criticality', u'ignore'), (u'Value', _UEContextModificationRequestIEs_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 314), (u'criticality', u'reject'), (u'Value', _UEContextModificationRequestIEs_val_Value_22), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationResponse >-----#
    UEContextModificationResponse = SEQ(name=u'UEContextModificationResponse', mode=MODE_TYPE)
    _UEContextModificationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextModificationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____UEContextModificationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationResponse_protocolIEs__item__id._const_tab = ____UEContextModificationResponse_protocolIEs__item__id_tab
    ___UEContextModificationResponse_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextModificationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextModificationResponse_protocolIEs__item__criticality._const_tab = ____UEContextModificationResponse_protocolIEs__item__id_tab
    ___UEContextModificationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextModificationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextModificationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextModificationResponse_protocolIEs__item__value._const_tab = ____UEContextModificationResponse_protocolIEs__item__id_tab
    ___UEContextModificationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextModificationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextModificationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextModificationResponse_protocolIEs__item__id),
        (u'criticality', ___UEContextModificationResponse_protocolIEs__item__criticality),
        (u'value', ___UEContextModificationResponse_protocolIEs__item__value),
        ])
    __UEContextModificationResponse_protocolIEs__item_._ext = None
    _UEContextModificationResponse_protocolIEs._cont = __UEContextModificationResponse_protocolIEs__item_
    _UEContextModificationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationResponse._cont = ASN1Dict([
        (u'protocolIEs', _UEContextModificationResponse_protocolIEs),
        ])
    UEContextModificationResponse._ext = []
    
    #-----< UEContextModificationResponseIEs >-----#
    UEContextModificationResponseIEs = CLASS(name=u'UEContextModificationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextModificationResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextModificationResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextModificationResponseIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    UEContextModificationResponseIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _UEContextModificationResponseIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationFailure >-----#
    UEContextModificationFailure = SEQ(name=u'UEContextModificationFailure', mode=MODE_TYPE)
    _UEContextModificationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextModificationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____UEContextModificationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationFailure_protocolIEs__item__id._const_tab = ____UEContextModificationFailure_protocolIEs__item__id_tab
    ___UEContextModificationFailure_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextModificationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextModificationFailure_protocolIEs__item__criticality._const_tab = ____UEContextModificationFailure_protocolIEs__item__id_tab
    ___UEContextModificationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextModificationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextModificationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextModificationFailure_protocolIEs__item__value._const_tab = ____UEContextModificationFailure_protocolIEs__item__id_tab
    ___UEContextModificationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextModificationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextModificationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextModificationFailure_protocolIEs__item__id),
        (u'criticality', ___UEContextModificationFailure_protocolIEs__item__criticality),
        (u'value', ___UEContextModificationFailure_protocolIEs__item__value),
        ])
    __UEContextModificationFailure_protocolIEs__item_._ext = None
    _UEContextModificationFailure_protocolIEs._cont = __UEContextModificationFailure_protocolIEs__item_
    _UEContextModificationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationFailure._cont = ASN1Dict([
        (u'protocolIEs', _UEContextModificationFailure_protocolIEs),
        ])
    UEContextModificationFailure._ext = []
    
    #-----< UEContextModificationFailureIEs >-----#
    UEContextModificationFailureIEs = CLASS(name=u'UEContextModificationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextModificationFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextModificationFailureIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextModificationFailureIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _UEContextModificationFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    UEContextModificationFailureIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _UEContextModificationFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _UEContextModificationFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _UEContextModificationFailureIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _UEContextModificationFailureIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityMatchRequest >-----#
    UERadioCapabilityMatchRequest = SEQ(name=u'UERadioCapabilityMatchRequest', mode=MODE_TYPE)
    _UERadioCapabilityMatchRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UERadioCapabilityMatchRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UERadioCapabilityMatchRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    ____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 74), (u'criticality', u'ignore'), (u'Value', _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 314), (u'criticality', u'reject'), (u'Value', _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityMatchRequest_protocolIEs__item__id._const_tab = ____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityMatchRequest_protocolIEs__item__id._const_tab_at = None
    ___UERadioCapabilityMatchRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___UERadioCapabilityMatchRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UERadioCapabilityMatchRequest_protocolIEs__item__criticality._const_tab = ____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityMatchRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UERadioCapabilityMatchRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UERadioCapabilityMatchRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UERadioCapabilityMatchRequest_protocolIEs__item__value._const_tab = ____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityMatchRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UERadioCapabilityMatchRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __UERadioCapabilityMatchRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UERadioCapabilityMatchRequest_protocolIEs__item__id),
        (u'criticality', ___UERadioCapabilityMatchRequest_protocolIEs__item__criticality),
        (u'value', ___UERadioCapabilityMatchRequest_protocolIEs__item__value),
        ])
    __UERadioCapabilityMatchRequest_protocolIEs__item_._ext = None
    _UERadioCapabilityMatchRequest_protocolIEs._cont = __UERadioCapabilityMatchRequest_protocolIEs__item_
    _UERadioCapabilityMatchRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UERadioCapabilityMatchRequest._cont = ASN1Dict([
        (u'protocolIEs', _UERadioCapabilityMatchRequest_protocolIEs),
        ])
    UERadioCapabilityMatchRequest._ext = []
    
    #-----< UERadioCapabilityMatchRequestIEs >-----#
    UERadioCapabilityMatchRequestIEs = CLASS(name=u'UERadioCapabilityMatchRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UERadioCapabilityMatchRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UERadioCapabilityMatchRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UERadioCapabilityMatchRequestIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _UERadioCapabilityMatchRequestIEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    UERadioCapabilityMatchRequestIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _UERadioCapabilityMatchRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _UERadioCapabilityMatchRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 74), (u'criticality', u'ignore'), (u'Value', _UERadioCapabilityMatchRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 314), (u'criticality', u'reject'), (u'Value', _UERadioCapabilityMatchRequestIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityMatchResponse >-----#
    UERadioCapabilityMatchResponse = SEQ(name=u'UERadioCapabilityMatchResponse', mode=MODE_TYPE)
    _UERadioCapabilityMatchResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UERadioCapabilityMatchResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UERadioCapabilityMatchResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'VoiceSupportMatchIndicator')))
    _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 169), (u'criticality', u'reject'), (u'Value', _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityMatchResponse_protocolIEs__item__id._const_tab = ____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityMatchResponse_protocolIEs__item__id._const_tab_at = None
    ___UERadioCapabilityMatchResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___UERadioCapabilityMatchResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UERadioCapabilityMatchResponse_protocolIEs__item__criticality._const_tab = ____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityMatchResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UERadioCapabilityMatchResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UERadioCapabilityMatchResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UERadioCapabilityMatchResponse_protocolIEs__item__value._const_tab = ____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityMatchResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UERadioCapabilityMatchResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __UERadioCapabilityMatchResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UERadioCapabilityMatchResponse_protocolIEs__item__id),
        (u'criticality', ___UERadioCapabilityMatchResponse_protocolIEs__item__criticality),
        (u'value', ___UERadioCapabilityMatchResponse_protocolIEs__item__value),
        ])
    __UERadioCapabilityMatchResponse_protocolIEs__item_._ext = None
    _UERadioCapabilityMatchResponse_protocolIEs._cont = __UERadioCapabilityMatchResponse_protocolIEs__item_
    _UERadioCapabilityMatchResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UERadioCapabilityMatchResponse._cont = ASN1Dict([
        (u'protocolIEs', _UERadioCapabilityMatchResponse_protocolIEs),
        ])
    UERadioCapabilityMatchResponse._ext = []
    
    #-----< UERadioCapabilityMatchResponseIEs >-----#
    UERadioCapabilityMatchResponseIEs = CLASS(name=u'UERadioCapabilityMatchResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UERadioCapabilityMatchResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UERadioCapabilityMatchResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UERadioCapabilityMatchResponseIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'VoiceSupportMatchIndicator')))
    _UERadioCapabilityMatchResponseIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    UERadioCapabilityMatchResponseIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _UERadioCapabilityMatchResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _UERadioCapabilityMatchResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 169), (u'criticality', u'reject'), (u'Value', _UERadioCapabilityMatchResponseIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _UERadioCapabilityMatchResponseIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkNASTransport >-----#
    DownlinkNASTransport = SEQ(name=u'DownlinkNASTransport', mode=MODE_TYPE)
    _DownlinkNASTransport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __DownlinkNASTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___DownlinkNASTransport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____DownlinkNASTransport_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverRestrictionList')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SubscriberProfileIDforRFP')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCOperationPossible')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DLNASPDUDeliveryAckRequest')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_8 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_9 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_11 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UECapabilityInfoRequest')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_12 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EndIndication')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_13 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_14 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_15 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_16 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    ____DownlinkNASTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 106), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 124), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 74), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 249), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 251), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 269), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 271), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 275), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 280), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 283), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 278), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 299), (u'criticality', u'ignore'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 314), (u'criticality', u'reject'), (u'Value', _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_16), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DownlinkNASTransport_protocolIEs__item__id._const_tab = ____DownlinkNASTransport_protocolIEs__item__id_tab
    ___DownlinkNASTransport_protocolIEs__item__id._const_tab_at = None
    ___DownlinkNASTransport_protocolIEs__item__id._const_tab_id = u'id'
    ___DownlinkNASTransport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___DownlinkNASTransport_protocolIEs__item__criticality._const_tab = ____DownlinkNASTransport_protocolIEs__item__id_tab
    ___DownlinkNASTransport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DownlinkNASTransport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DownlinkNASTransport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___DownlinkNASTransport_protocolIEs__item__value._const_tab = ____DownlinkNASTransport_protocolIEs__item__id_tab
    ___DownlinkNASTransport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DownlinkNASTransport_protocolIEs__item__value._const_tab_id = u'Value'
    __DownlinkNASTransport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DownlinkNASTransport_protocolIEs__item__id),
        (u'criticality', ___DownlinkNASTransport_protocolIEs__item__criticality),
        (u'value', ___DownlinkNASTransport_protocolIEs__item__value),
        ])
    __DownlinkNASTransport_protocolIEs__item_._ext = None
    _DownlinkNASTransport_protocolIEs._cont = __DownlinkNASTransport_protocolIEs__item_
    _DownlinkNASTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkNASTransport._cont = ASN1Dict([
        (u'protocolIEs', _DownlinkNASTransport_protocolIEs),
        ])
    DownlinkNASTransport._ext = []
    
    #-----< DownlinkNASTransport-IEs >-----#
    DownlinkNASTransport_IEs = CLASS(name=u'DownlinkNASTransport-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _DownlinkNASTransport_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _DownlinkNASTransport_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _DownlinkNASTransport_IEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    _DownlinkNASTransport_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverRestrictionList')))
    _DownlinkNASTransport_IEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SubscriberProfileIDforRFP')))
    _DownlinkNASTransport_IEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SRVCCOperationPossible')))
    _DownlinkNASTransport_IEs_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _DownlinkNASTransport_IEs_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DLNASPDUDeliveryAckRequest')))
    _DownlinkNASTransport_IEs_val_Value_8 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _DownlinkNASTransport_IEs_val_Value_9 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NRUESecurityCapabilities')))
    _DownlinkNASTransport_IEs_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _DownlinkNASTransport_IEs_val_Value_11 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UECapabilityInfoRequest')))
    _DownlinkNASTransport_IEs_val_Value_12 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EndIndication')))
    _DownlinkNASTransport_IEs_val_Value_13 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    _DownlinkNASTransport_IEs_val_Value_14 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _DownlinkNASTransport_IEs_val_Value_15 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'AdditionalRRMPriorityIndex')))
    _DownlinkNASTransport_IEs_val_Value_16 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    DownlinkNASTransport_IEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _DownlinkNASTransport_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _DownlinkNASTransport_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _DownlinkNASTransport_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 41), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 106), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 124), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 74), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 249), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 251), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 269), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 271), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 275), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 280), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 283), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 278), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 299), (u'criticality', u'ignore'), (u'Value', _DownlinkNASTransport_IEs_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 314), (u'criticality', u'reject'), (u'Value', _DownlinkNASTransport_IEs_val_Value_16), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< InitialUEMessage >-----#
    InitialUEMessage = SEQ(name=u'InitialUEMessage', mode=MODE_TYPE)
    _InitialUEMessage_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __InitialUEMessage_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___InitialUEMessage_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____InitialUEMessage_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RRC-Establishment-Cause')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_6 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEI')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_8 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellAccessMode')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_9 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RelayNode-Indicator')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_11 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEIType')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_12 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TunnelInformation')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_13 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_14 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LHN-ID')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_15 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-Group-ID')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_16 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-Usage-Type')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_17 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-mode-B-SupportIndicator')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_18 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DCN-ID')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_19 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Coverage-Level')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_20 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-Application-Layer-Measurement-Capability')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_21 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EDT-Session')))
    _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_22 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IAB-Node-Indication')))
    ____InitialUEMessage_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 67), (u'criticality', u'reject'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 100), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 134), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 96), (u'criticality', u'reject'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 127), (u'criticality', u'reject'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 75), (u'criticality', u'reject'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 145), (u'criticality', u'reject'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 160), (u'criticality', u'reject'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 170), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 176), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 186), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 223), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 230), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 242), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_17), (u'presence', u'optional')]), dict([(u'id', 246), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 250), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 263), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 281), (u'criticality', u'ignore'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 302), (u'criticality', u'reject'), (u'Value', _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_22), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___InitialUEMessage_protocolIEs__item__id._const_tab = ____InitialUEMessage_protocolIEs__item__id_tab
    ___InitialUEMessage_protocolIEs__item__id._const_tab_at = None
    ___InitialUEMessage_protocolIEs__item__id._const_tab_id = u'id'
    ___InitialUEMessage_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___InitialUEMessage_protocolIEs__item__criticality._const_tab = ____InitialUEMessage_protocolIEs__item__id_tab
    ___InitialUEMessage_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___InitialUEMessage_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___InitialUEMessage_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___InitialUEMessage_protocolIEs__item__value._const_tab = ____InitialUEMessage_protocolIEs__item__id_tab
    ___InitialUEMessage_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___InitialUEMessage_protocolIEs__item__value._const_tab_id = u'Value'
    __InitialUEMessage_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___InitialUEMessage_protocolIEs__item__id),
        (u'criticality', ___InitialUEMessage_protocolIEs__item__criticality),
        (u'value', ___InitialUEMessage_protocolIEs__item__value),
        ])
    __InitialUEMessage_protocolIEs__item_._ext = None
    _InitialUEMessage_protocolIEs._cont = __InitialUEMessage_protocolIEs__item_
    _InitialUEMessage_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    InitialUEMessage._cont = ASN1Dict([
        (u'protocolIEs', _InitialUEMessage_protocolIEs),
        ])
    InitialUEMessage._ext = []
    
    #-----< InitialUEMessage-IEs >-----#
    InitialUEMessage_IEs = CLASS(name=u'InitialUEMessage-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _InitialUEMessage_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _InitialUEMessage_IEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    _InitialUEMessage_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _InitialUEMessage_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _InitialUEMessage_IEs_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RRC-Establishment-Cause')))
    _InitialUEMessage_IEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    _InitialUEMessage_IEs_val_Value_6 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _InitialUEMessage_IEs_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEI')))
    _InitialUEMessage_IEs_val_Value_8 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellAccessMode')))
    _InitialUEMessage_IEs_val_Value_9 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _InitialUEMessage_IEs_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RelayNode-Indicator')))
    _InitialUEMessage_IEs_val_Value_11 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEIType')))
    _InitialUEMessage_IEs_val_Value_12 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TunnelInformation')))
    _InitialUEMessage_IEs_val_Value_13 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _InitialUEMessage_IEs_val_Value_14 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LHN-ID')))
    _InitialUEMessage_IEs_val_Value_15 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-Group-ID')))
    _InitialUEMessage_IEs_val_Value_16 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-Usage-Type')))
    _InitialUEMessage_IEs_val_Value_17 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-mode-B-SupportIndicator')))
    _InitialUEMessage_IEs_val_Value_18 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DCN-ID')))
    _InitialUEMessage_IEs_val_Value_19 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Coverage-Level')))
    _InitialUEMessage_IEs_val_Value_20 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-Application-Layer-Measurement-Capability')))
    _InitialUEMessage_IEs_val_Value_21 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EDT-Session')))
    _InitialUEMessage_IEs_val_Value_22 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IAB-Node-Indication')))
    InitialUEMessage_IEs._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _InitialUEMessage_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _InitialUEMessage_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 67), (u'criticality', u'reject'), (u'Value', _InitialUEMessage_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 100), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 134), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 96), (u'criticality', u'reject'), (u'Value', _InitialUEMessage_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 127), (u'criticality', u'reject'), (u'Value', _InitialUEMessage_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 75), (u'criticality', u'reject'), (u'Value', _InitialUEMessage_IEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 145), (u'criticality', u'reject'), (u'Value', _InitialUEMessage_IEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 160), (u'criticality', u'reject'), (u'Value', _InitialUEMessage_IEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 170), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 176), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 186), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 223), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_15), (u'presence', u'optional')]), dict([(u'id', 230), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_16), (u'presence', u'optional')]), dict([(u'id', 242), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_17), (u'presence', u'optional')]), dict([(u'id', 246), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_18), (u'presence', u'optional')]), dict([(u'id', 250), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_19), (u'presence', u'optional')]), dict([(u'id', 263), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_20), (u'presence', u'optional')]), dict([(u'id', 281), (u'criticality', u'ignore'), (u'Value', _InitialUEMessage_IEs_val_Value_21), (u'presence', u'optional')]), dict([(u'id', 302), (u'criticality', u'reject'), (u'Value', _InitialUEMessage_IEs_val_Value_22), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UplinkNASTransport >-----#
    UplinkNASTransport = SEQ(name=u'UplinkNASTransport', mode=MODE_TYPE)
    _UplinkNASTransport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UplinkNASTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UplinkNASTransport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UplinkNASTransport_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_5 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_6 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LHN-ID')))
    _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PSCellInformation')))
    ____UplinkNASTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 100), (u'criticality', u'ignore'), (u'Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 67), (u'criticality', u'ignore'), (u'Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 186), (u'criticality', u'ignore'), (u'Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 288), (u'criticality', u'ignore'), (u'Value', _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UplinkNASTransport_protocolIEs__item__id._const_tab = ____UplinkNASTransport_protocolIEs__item__id_tab
    ___UplinkNASTransport_protocolIEs__item__id._const_tab_at = None
    ___UplinkNASTransport_protocolIEs__item__id._const_tab_id = u'id'
    ___UplinkNASTransport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UplinkNASTransport_protocolIEs__item__criticality._const_tab = ____UplinkNASTransport_protocolIEs__item__id_tab
    ___UplinkNASTransport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UplinkNASTransport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UplinkNASTransport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UplinkNASTransport_protocolIEs__item__value._const_tab = ____UplinkNASTransport_protocolIEs__item__id_tab
    ___UplinkNASTransport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UplinkNASTransport_protocolIEs__item__value._const_tab_id = u'Value'
    __UplinkNASTransport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UplinkNASTransport_protocolIEs__item__id),
        (u'criticality', ___UplinkNASTransport_protocolIEs__item__criticality),
        (u'value', ___UplinkNASTransport_protocolIEs__item__value),
        ])
    __UplinkNASTransport_protocolIEs__item_._ext = None
    _UplinkNASTransport_protocolIEs._cont = __UplinkNASTransport_protocolIEs__item_
    _UplinkNASTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkNASTransport._cont = ASN1Dict([
        (u'protocolIEs', _UplinkNASTransport_protocolIEs),
        ])
    UplinkNASTransport._ext = []
    
    #-----< UplinkNASTransport-IEs >-----#
    UplinkNASTransport_IEs = CLASS(name=u'UplinkNASTransport-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UplinkNASTransport_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UplinkNASTransport_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UplinkNASTransport_IEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    _UplinkNASTransport_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _UplinkNASTransport_IEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _UplinkNASTransport_IEs_val_Value_5 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _UplinkNASTransport_IEs_val_Value_6 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _UplinkNASTransport_IEs_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LHN-ID')))
    _UplinkNASTransport_IEs_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PSCellInformation')))
    UplinkNASTransport_IEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _UplinkNASTransport_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _UplinkNASTransport_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _UplinkNASTransport_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 100), (u'criticality', u'ignore'), (u'Value', _UplinkNASTransport_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 67), (u'criticality', u'ignore'), (u'Value', _UplinkNASTransport_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _UplinkNASTransport_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Value', _UplinkNASTransport_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 186), (u'criticality', u'ignore'), (u'Value', _UplinkNASTransport_IEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 288), (u'criticality', u'ignore'), (u'Value', _UplinkNASTransport_IEs_val_Value_8), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< NASNonDeliveryIndication >-----#
    NASNonDeliveryIndication = SEQ(name=u'NASNonDeliveryIndication', mode=MODE_TYPE)
    _NASNonDeliveryIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __NASNonDeliveryIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___NASNonDeliveryIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____NASNonDeliveryIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    ____NASNonDeliveryIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___NASNonDeliveryIndication_protocolIEs__item__id._const_tab = ____NASNonDeliveryIndication_protocolIEs__item__id_tab
    ___NASNonDeliveryIndication_protocolIEs__item__id._const_tab_at = None
    ___NASNonDeliveryIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___NASNonDeliveryIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___NASNonDeliveryIndication_protocolIEs__item__criticality._const_tab = ____NASNonDeliveryIndication_protocolIEs__item__id_tab
    ___NASNonDeliveryIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___NASNonDeliveryIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___NASNonDeliveryIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___NASNonDeliveryIndication_protocolIEs__item__value._const_tab = ____NASNonDeliveryIndication_protocolIEs__item__id_tab
    ___NASNonDeliveryIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___NASNonDeliveryIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __NASNonDeliveryIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___NASNonDeliveryIndication_protocolIEs__item__id),
        (u'criticality', ___NASNonDeliveryIndication_protocolIEs__item__criticality),
        (u'value', ___NASNonDeliveryIndication_protocolIEs__item__value),
        ])
    __NASNonDeliveryIndication_protocolIEs__item_._ext = None
    _NASNonDeliveryIndication_protocolIEs._cont = __NASNonDeliveryIndication_protocolIEs__item_
    _NASNonDeliveryIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    NASNonDeliveryIndication._cont = ASN1Dict([
        (u'protocolIEs', _NASNonDeliveryIndication_protocolIEs),
        ])
    NASNonDeliveryIndication._ext = []
    
    #-----< NASNonDeliveryIndication-IEs >-----#
    NASNonDeliveryIndication_IEs = CLASS(name=u'NASNonDeliveryIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _NASNonDeliveryIndication_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _NASNonDeliveryIndication_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _NASNonDeliveryIndication_IEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NAS-PDU')))
    _NASNonDeliveryIndication_IEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    NASNonDeliveryIndication_IEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _NASNonDeliveryIndication_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _NASNonDeliveryIndication_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _NASNonDeliveryIndication_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _NASNonDeliveryIndication_IEs_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RerouteNASRequest >-----#
    RerouteNASRequest = SEQ(name=u'RerouteNASRequest', mode=MODE_TYPE)
    _RerouteNASRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __RerouteNASRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___RerouteNASRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____RerouteNASRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE)
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-Group-ID')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Additional-GUTI')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-Usage-Type')))
    ____RerouteNASRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 225), (u'criticality', u'reject'), (u'Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 223), (u'criticality', u'reject'), (u'Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 224), (u'criticality', u'ignore'), (u'Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 230), (u'criticality', u'ignore'), (u'Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RerouteNASRequest_protocolIEs__item__id._const_tab = ____RerouteNASRequest_protocolIEs__item__id_tab
    ___RerouteNASRequest_protocolIEs__item__id._const_tab_at = None
    ___RerouteNASRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___RerouteNASRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___RerouteNASRequest_protocolIEs__item__criticality._const_tab = ____RerouteNASRequest_protocolIEs__item__id_tab
    ___RerouteNASRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RerouteNASRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RerouteNASRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___RerouteNASRequest_protocolIEs__item__value._const_tab = ____RerouteNASRequest_protocolIEs__item__id_tab
    ___RerouteNASRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RerouteNASRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __RerouteNASRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RerouteNASRequest_protocolIEs__item__id),
        (u'criticality', ___RerouteNASRequest_protocolIEs__item__criticality),
        (u'value', ___RerouteNASRequest_protocolIEs__item__value),
        ])
    __RerouteNASRequest_protocolIEs__item_._ext = None
    _RerouteNASRequest_protocolIEs._cont = __RerouteNASRequest_protocolIEs__item_
    _RerouteNASRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RerouteNASRequest._cont = ASN1Dict([
        (u'protocolIEs', _RerouteNASRequest_protocolIEs),
        ])
    RerouteNASRequest._ext = []
    
    #-----< RerouteNASRequest-IEs >-----#
    RerouteNASRequest_IEs = CLASS(name=u'RerouteNASRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _RerouteNASRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _RerouteNASRequest_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _RerouteNASRequest_IEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE)
    _RerouteNASRequest_IEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-Group-ID')))
    _RerouteNASRequest_IEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Additional-GUTI')))
    _RerouteNASRequest_IEs_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-Usage-Type')))
    RerouteNASRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _RerouteNASRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _RerouteNASRequest_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 225), (u'criticality', u'reject'), (u'Value', _RerouteNASRequest_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 223), (u'criticality', u'reject'), (u'Value', _RerouteNASRequest_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 224), (u'criticality', u'ignore'), (u'Value', _RerouteNASRequest_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 230), (u'criticality', u'ignore'), (u'Value', _RerouteNASRequest_IEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< NASDeliveryIndication >-----#
    NASDeliveryIndication = SEQ(name=u'NASDeliveryIndication', mode=MODE_TYPE)
    _NASDeliveryIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __NASDeliveryIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___NASDeliveryIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____NASDeliveryIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____NASDeliveryIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____NASDeliveryIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    ____NASDeliveryIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____NASDeliveryIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____NASDeliveryIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___NASDeliveryIndication_protocolIEs__item__id._const_tab = ____NASDeliveryIndication_protocolIEs__item__id_tab
    ___NASDeliveryIndication_protocolIEs__item__id._const_tab_at = None
    ___NASDeliveryIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___NASDeliveryIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___NASDeliveryIndication_protocolIEs__item__criticality._const_tab = ____NASDeliveryIndication_protocolIEs__item__id_tab
    ___NASDeliveryIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___NASDeliveryIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___NASDeliveryIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___NASDeliveryIndication_protocolIEs__item__value._const_tab = ____NASDeliveryIndication_protocolIEs__item__id_tab
    ___NASDeliveryIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___NASDeliveryIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __NASDeliveryIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___NASDeliveryIndication_protocolIEs__item__id),
        (u'criticality', ___NASDeliveryIndication_protocolIEs__item__criticality),
        (u'value', ___NASDeliveryIndication_protocolIEs__item__value),
        ])
    __NASDeliveryIndication_protocolIEs__item_._ext = None
    _NASDeliveryIndication_protocolIEs._cont = __NASDeliveryIndication_protocolIEs__item_
    _NASDeliveryIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    NASDeliveryIndication._cont = ASN1Dict([
        (u'protocolIEs', _NASDeliveryIndication_protocolIEs),
        ])
    NASDeliveryIndication._ext = []
    
    #-----< NASDeliveryIndicationIEs >-----#
    NASDeliveryIndicationIEs = CLASS(name=u'NASDeliveryIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _NASDeliveryIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _NASDeliveryIndicationIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    NASDeliveryIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _NASDeliveryIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _NASDeliveryIndicationIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Reset >-----#
    Reset = SEQ(name=u'Reset', mode=MODE_TYPE)
    _Reset_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __Reset_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___Reset_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____Reset_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____Reset_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____Reset_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ResetType')))
    ____Reset_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _____Reset_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 92), (u'criticality', u'reject'), (u'Value', _____Reset_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___Reset_protocolIEs__item__id._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__id._const_tab_at = None
    ___Reset_protocolIEs__item__id._const_tab_id = u'id'
    ___Reset_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___Reset_protocolIEs__item__criticality._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___Reset_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___Reset_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___Reset_protocolIEs__item__value._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___Reset_protocolIEs__item__value._const_tab_id = u'Value'
    __Reset_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___Reset_protocolIEs__item__id),
        (u'criticality', ___Reset_protocolIEs__item__criticality),
        (u'value', ___Reset_protocolIEs__item__value),
        ])
    __Reset_protocolIEs__item_._ext = None
    _Reset_protocolIEs._cont = __Reset_protocolIEs__item_
    _Reset_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    Reset._cont = ASN1Dict([
        (u'protocolIEs', _Reset_protocolIEs),
        ])
    Reset._ext = []
    
    #-----< ResetIEs >-----#
    ResetIEs = CLASS(name=u'ResetIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ResetIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _ResetIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ResetType')))
    ResetIEs._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _ResetIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 92), (u'criticality', u'reject'), (u'Value', _ResetIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ResetType >-----#
    ResetType = CHOICE(name=u'ResetType', mode=MODE_TYPE)
    _ResetType_s1_Interface = ENUM(name=u's1-Interface', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-PDU-Contents', 'ResetAll')))
    _ResetType_partOfS1_Interface = SEQ_OF(name=u'partOfS1-Interface', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-PDU-Contents', 'UE-associatedLogicalS1-ConnectionListRes')))
    ResetType._cont = ASN1Dict([
        (u's1-Interface', _ResetType_s1_Interface),
        (u'partOfS1-Interface', _ResetType_partOfS1_Interface),
        ])
    ResetType._ext = []
    
    #-----< ResetAll >-----#
    ResetAll = ENUM(name=u'ResetAll', mode=MODE_TYPE)
    ResetAll._cont = ASN1Dict([(u'reset-all', 0)])
    ResetAll._ext = []
    
    #-----< UE-associatedLogicalS1-ConnectionListRes >-----#
    UE_associatedLogicalS1_ConnectionListRes = SEQ_OF(name=u'UE-associatedLogicalS1-ConnectionListRes', mode=MODE_TYPE)
    _UE_associatedLogicalS1_ConnectionListRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UE_associatedLogicalS1_ConnectionListRes__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___UE_associatedLogicalS1_ConnectionListRes__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____UE_associatedLogicalS1_ConnectionListRes__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-associatedLogicalS1-ConnectionItem')))
    ___UE_associatedLogicalS1_ConnectionListRes__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 91), (u'criticality', u'reject'), (u'Value', ____UE_associatedLogicalS1_ConnectionListRes__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __UE_associatedLogicalS1_ConnectionListRes__item__id._const_tab = ___UE_associatedLogicalS1_ConnectionListRes__item__id_tab
    __UE_associatedLogicalS1_ConnectionListRes__item__id._const_tab_at = None
    __UE_associatedLogicalS1_ConnectionListRes__item__id._const_tab_id = u'id'
    __UE_associatedLogicalS1_ConnectionListRes__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __UE_associatedLogicalS1_ConnectionListRes__item__criticality._const_tab = ___UE_associatedLogicalS1_ConnectionListRes__item__id_tab
    __UE_associatedLogicalS1_ConnectionListRes__item__criticality._const_tab_at = ('..', u'id')
    __UE_associatedLogicalS1_ConnectionListRes__item__criticality._const_tab_id = u'criticality'
    __UE_associatedLogicalS1_ConnectionListRes__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __UE_associatedLogicalS1_ConnectionListRes__item__value._const_tab = ___UE_associatedLogicalS1_ConnectionListRes__item__id_tab
    __UE_associatedLogicalS1_ConnectionListRes__item__value._const_tab_at = ('..', u'id')
    __UE_associatedLogicalS1_ConnectionListRes__item__value._const_tab_id = u'Value'
    _UE_associatedLogicalS1_ConnectionListRes__item_._cont = ASN1Dict([
        (u'id', __UE_associatedLogicalS1_ConnectionListRes__item__id),
        (u'criticality', __UE_associatedLogicalS1_ConnectionListRes__item__criticality),
        (u'value', __UE_associatedLogicalS1_ConnectionListRes__item__value),
        ])
    _UE_associatedLogicalS1_ConnectionListRes__item_._ext = None
    UE_associatedLogicalS1_ConnectionListRes._cont = _UE_associatedLogicalS1_ConnectionListRes__item_
    UE_associatedLogicalS1_ConnectionListRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< UE-associatedLogicalS1-ConnectionItemRes >-----#
    UE_associatedLogicalS1_ConnectionItemRes = CLASS(name=u'UE-associatedLogicalS1-ConnectionItemRes', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UE_associatedLogicalS1_ConnectionItemRes_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-associatedLogicalS1-ConnectionItem')))
    UE_associatedLogicalS1_ConnectionItemRes._val = ASN1Set(rv=[dict([(u'id', 91), (u'criticality', u'reject'), (u'Value', _UE_associatedLogicalS1_ConnectionItemRes_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ResetAcknowledge >-----#
    ResetAcknowledge = SEQ(name=u'ResetAcknowledge', mode=MODE_TYPE)
    _ResetAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ResetAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ResetAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____ResetAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UE-associatedLogicalS1-ConnectionListResAck')))
    _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____ResetAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResetAcknowledge_protocolIEs__item__id._const_tab = ____ResetAcknowledge_protocolIEs__item__id_tab
    ___ResetAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___ResetAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___ResetAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___ResetAcknowledge_protocolIEs__item__criticality._const_tab = ____ResetAcknowledge_protocolIEs__item__id_tab
    ___ResetAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ResetAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ResetAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___ResetAcknowledge_protocolIEs__item__value._const_tab = ____ResetAcknowledge_protocolIEs__item__id_tab
    ___ResetAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ResetAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __ResetAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ResetAcknowledge_protocolIEs__item__id),
        (u'criticality', ___ResetAcknowledge_protocolIEs__item__criticality),
        (u'value', ___ResetAcknowledge_protocolIEs__item__value),
        ])
    __ResetAcknowledge_protocolIEs__item_._ext = None
    _ResetAcknowledge_protocolIEs._cont = __ResetAcknowledge_protocolIEs__item_
    _ResetAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResetAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _ResetAcknowledge_protocolIEs),
        ])
    ResetAcknowledge._ext = []
    
    #-----< ResetAcknowledgeIEs >-----#
    ResetAcknowledgeIEs = CLASS(name=u'ResetAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ResetAcknowledgeIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UE-associatedLogicalS1-ConnectionListResAck')))
    _ResetAcknowledgeIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ResetAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _ResetAcknowledgeIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _ResetAcknowledgeIEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UE-associatedLogicalS1-ConnectionListResAck >-----#
    UE_associatedLogicalS1_ConnectionListResAck = SEQ_OF(name=u'UE-associatedLogicalS1-ConnectionListResAck', mode=MODE_TYPE)
    _UE_associatedLogicalS1_ConnectionListResAck__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __UE_associatedLogicalS1_ConnectionListResAck__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___UE_associatedLogicalS1_ConnectionListResAck__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____UE_associatedLogicalS1_ConnectionListResAck__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-associatedLogicalS1-ConnectionItem')))
    ___UE_associatedLogicalS1_ConnectionListResAck__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 91), (u'criticality', u'ignore'), (u'Value', ____UE_associatedLogicalS1_ConnectionListResAck__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __UE_associatedLogicalS1_ConnectionListResAck__item__id._const_tab = ___UE_associatedLogicalS1_ConnectionListResAck__item__id_tab
    __UE_associatedLogicalS1_ConnectionListResAck__item__id._const_tab_at = None
    __UE_associatedLogicalS1_ConnectionListResAck__item__id._const_tab_id = u'id'
    __UE_associatedLogicalS1_ConnectionListResAck__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __UE_associatedLogicalS1_ConnectionListResAck__item__criticality._const_tab = ___UE_associatedLogicalS1_ConnectionListResAck__item__id_tab
    __UE_associatedLogicalS1_ConnectionListResAck__item__criticality._const_tab_at = ('..', u'id')
    __UE_associatedLogicalS1_ConnectionListResAck__item__criticality._const_tab_id = u'criticality'
    __UE_associatedLogicalS1_ConnectionListResAck__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __UE_associatedLogicalS1_ConnectionListResAck__item__value._const_tab = ___UE_associatedLogicalS1_ConnectionListResAck__item__id_tab
    __UE_associatedLogicalS1_ConnectionListResAck__item__value._const_tab_at = ('..', u'id')
    __UE_associatedLogicalS1_ConnectionListResAck__item__value._const_tab_id = u'Value'
    _UE_associatedLogicalS1_ConnectionListResAck__item_._cont = ASN1Dict([
        (u'id', __UE_associatedLogicalS1_ConnectionListResAck__item__id),
        (u'criticality', __UE_associatedLogicalS1_ConnectionListResAck__item__criticality),
        (u'value', __UE_associatedLogicalS1_ConnectionListResAck__item__value),
        ])
    _UE_associatedLogicalS1_ConnectionListResAck__item_._ext = None
    UE_associatedLogicalS1_ConnectionListResAck._cont = _UE_associatedLogicalS1_ConnectionListResAck__item_
    UE_associatedLogicalS1_ConnectionListResAck._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< UE-associatedLogicalS1-ConnectionItemResAck >-----#
    UE_associatedLogicalS1_ConnectionItemResAck = CLASS(name=u'UE-associatedLogicalS1-ConnectionItemResAck', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UE_associatedLogicalS1_ConnectionItemResAck_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-associatedLogicalS1-ConnectionItem')))
    UE_associatedLogicalS1_ConnectionItemResAck._val = ASN1Set(rv=[dict([(u'id', 91), (u'criticality', u'ignore'), (u'Value', _UE_associatedLogicalS1_ConnectionItemResAck_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication >-----#
    ErrorIndication = SEQ(name=u'ErrorIndication', mode=MODE_TYPE)
    _ErrorIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ErrorIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ErrorIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____ErrorIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    ____ErrorIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 96), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolIEs__item__id._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__id._const_tab_at = None
    ___ErrorIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___ErrorIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___ErrorIndication_protocolIEs__item__criticality._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ErrorIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___ErrorIndication_protocolIEs__item__value._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ErrorIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __ErrorIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ErrorIndication_protocolIEs__item__id),
        (u'criticality', ___ErrorIndication_protocolIEs__item__criticality),
        (u'value', ___ErrorIndication_protocolIEs__item__value),
        ])
    __ErrorIndication_protocolIEs__item_._ext = None
    _ErrorIndication_protocolIEs._cont = __ErrorIndication_protocolIEs__item_
    _ErrorIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ErrorIndication._cont = ASN1Dict([
        (u'protocolIEs', _ErrorIndication_protocolIEs),
        ])
    ErrorIndication._ext = []
    
    #-----< ErrorIndicationIEs >-----#
    ErrorIndicationIEs = CLASS(name=u'ErrorIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ErrorIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _ErrorIndicationIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _ErrorIndicationIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _ErrorIndicationIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _ErrorIndicationIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    ErrorIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _ErrorIndicationIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _ErrorIndicationIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _ErrorIndicationIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _ErrorIndicationIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 96), (u'criticality', u'ignore'), (u'Value', _ErrorIndicationIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< S1SetupRequest >-----#
    S1SetupRequest = SEQ(name=u'S1SetupRequest', mode=MODE_TYPE)
    _S1SetupRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __S1SetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___S1SetupRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____S1SetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_1 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENBname')))
    _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SupportedTAs')))
    _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PagingDRX')))
    _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-IdList')))
    _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-RetentionInformation')))
    _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-DefaultPagingDRX')))
    _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ConnectedengNBList')))
    ____S1SetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 59), (u'criticality', u'reject'), (u'Value', _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 60), (u'criticality', u'ignore'), (u'Value', _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 64), (u'criticality', u'reject'), (u'Value', _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 137), (u'criticality', u'ignore'), (u'Value', _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 128), (u'criticality', u'reject'), (u'Value', _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 228), (u'criticality', u'ignore'), (u'Value', _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 234), (u'criticality', u'ignore'), (u'Value', _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 291), (u'criticality', u'ignore'), (u'Value', _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___S1SetupRequest_protocolIEs__item__id._const_tab = ____S1SetupRequest_protocolIEs__item__id_tab
    ___S1SetupRequest_protocolIEs__item__id._const_tab_at = None
    ___S1SetupRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___S1SetupRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___S1SetupRequest_protocolIEs__item__criticality._const_tab = ____S1SetupRequest_protocolIEs__item__id_tab
    ___S1SetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___S1SetupRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___S1SetupRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___S1SetupRequest_protocolIEs__item__value._const_tab = ____S1SetupRequest_protocolIEs__item__id_tab
    ___S1SetupRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___S1SetupRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __S1SetupRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___S1SetupRequest_protocolIEs__item__id),
        (u'criticality', ___S1SetupRequest_protocolIEs__item__criticality),
        (u'value', ___S1SetupRequest_protocolIEs__item__value),
        ])
    __S1SetupRequest_protocolIEs__item_._ext = None
    _S1SetupRequest_protocolIEs._cont = __S1SetupRequest_protocolIEs__item_
    _S1SetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    S1SetupRequest._cont = ASN1Dict([
        (u'protocolIEs', _S1SetupRequest_protocolIEs),
        ])
    S1SetupRequest._ext = []
    
    #-----< S1SetupRequestIEs >-----#
    S1SetupRequestIEs = CLASS(name=u'S1SetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _S1SetupRequestIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    _S1SetupRequestIEs_val_Value_1 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENBname')))
    _S1SetupRequestIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SupportedTAs')))
    _S1SetupRequestIEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PagingDRX')))
    _S1SetupRequestIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-IdList')))
    _S1SetupRequestIEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-RetentionInformation')))
    _S1SetupRequestIEs_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-DefaultPagingDRX')))
    _S1SetupRequestIEs_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ConnectedengNBList')))
    S1SetupRequestIEs._val = ASN1Set(rv=[dict([(u'id', 59), (u'criticality', u'reject'), (u'Value', _S1SetupRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 60), (u'criticality', u'ignore'), (u'Value', _S1SetupRequestIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 64), (u'criticality', u'reject'), (u'Value', _S1SetupRequestIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 137), (u'criticality', u'ignore'), (u'Value', _S1SetupRequestIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 128), (u'criticality', u'reject'), (u'Value', _S1SetupRequestIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 228), (u'criticality', u'ignore'), (u'Value', _S1SetupRequestIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 234), (u'criticality', u'ignore'), (u'Value', _S1SetupRequestIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 291), (u'criticality', u'ignore'), (u'Value', _S1SetupRequestIEs_val_Value_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< S1SetupResponse >-----#
    S1SetupResponse = SEQ(name=u'S1SetupResponse', mode=MODE_TYPE)
    _S1SetupResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __S1SetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___S1SetupResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____S1SetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_0 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MMEname')))
    _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServedGUMMEIs')))
    _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RelativeMMECapacity')))
    _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MMERelaySupportIndicator')))
    _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-RetentionInformation')))
    _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServedDCNs')))
    _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IAB-Supported')))
    ____S1SetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 61), (u'criticality', u'ignore'), (u'Value', _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 105), (u'criticality', u'reject'), (u'Value', _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 87), (u'criticality', u'ignore'), (u'Value', _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 163), (u'criticality', u'ignore'), (u'Value', _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 228), (u'criticality', u'ignore'), (u'Value', _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 247), (u'criticality', u'ignore'), (u'Value', _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 303), (u'criticality', u'ignore'), (u'Value', _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___S1SetupResponse_protocolIEs__item__id._const_tab = ____S1SetupResponse_protocolIEs__item__id_tab
    ___S1SetupResponse_protocolIEs__item__id._const_tab_at = None
    ___S1SetupResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___S1SetupResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___S1SetupResponse_protocolIEs__item__criticality._const_tab = ____S1SetupResponse_protocolIEs__item__id_tab
    ___S1SetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___S1SetupResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___S1SetupResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___S1SetupResponse_protocolIEs__item__value._const_tab = ____S1SetupResponse_protocolIEs__item__id_tab
    ___S1SetupResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___S1SetupResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __S1SetupResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___S1SetupResponse_protocolIEs__item__id),
        (u'criticality', ___S1SetupResponse_protocolIEs__item__criticality),
        (u'value', ___S1SetupResponse_protocolIEs__item__value),
        ])
    __S1SetupResponse_protocolIEs__item_._ext = None
    _S1SetupResponse_protocolIEs._cont = __S1SetupResponse_protocolIEs__item_
    _S1SetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    S1SetupResponse._cont = ASN1Dict([
        (u'protocolIEs', _S1SetupResponse_protocolIEs),
        ])
    S1SetupResponse._ext = []
    
    #-----< S1SetupResponseIEs >-----#
    S1SetupResponseIEs = CLASS(name=u'S1SetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _S1SetupResponseIEs_val_Value_0 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MMEname')))
    _S1SetupResponseIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServedGUMMEIs')))
    _S1SetupResponseIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RelativeMMECapacity')))
    _S1SetupResponseIEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MMERelaySupportIndicator')))
    _S1SetupResponseIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _S1SetupResponseIEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-RetentionInformation')))
    _S1SetupResponseIEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServedDCNs')))
    _S1SetupResponseIEs_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IAB-Supported')))
    S1SetupResponseIEs._val = ASN1Set(rv=[dict([(u'id', 61), (u'criticality', u'ignore'), (u'Value', _S1SetupResponseIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 105), (u'criticality', u'reject'), (u'Value', _S1SetupResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 87), (u'criticality', u'ignore'), (u'Value', _S1SetupResponseIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 163), (u'criticality', u'ignore'), (u'Value', _S1SetupResponseIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _S1SetupResponseIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 228), (u'criticality', u'ignore'), (u'Value', _S1SetupResponseIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 247), (u'criticality', u'ignore'), (u'Value', _S1SetupResponseIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 303), (u'criticality', u'ignore'), (u'Value', _S1SetupResponseIEs_val_Value_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< S1SetupFailure >-----#
    S1SetupFailure = SEQ(name=u'S1SetupFailure', mode=MODE_TYPE)
    _S1SetupFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __S1SetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___S1SetupFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____S1SetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____S1SetupFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____S1SetupFailure_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeToWait')))
    _____S1SetupFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____S1SetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _____S1SetupFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 65), (u'criticality', u'ignore'), (u'Value', _____S1SetupFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____S1SetupFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___S1SetupFailure_protocolIEs__item__id._const_tab = ____S1SetupFailure_protocolIEs__item__id_tab
    ___S1SetupFailure_protocolIEs__item__id._const_tab_at = None
    ___S1SetupFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___S1SetupFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___S1SetupFailure_protocolIEs__item__criticality._const_tab = ____S1SetupFailure_protocolIEs__item__id_tab
    ___S1SetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___S1SetupFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___S1SetupFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___S1SetupFailure_protocolIEs__item__value._const_tab = ____S1SetupFailure_protocolIEs__item__id_tab
    ___S1SetupFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___S1SetupFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __S1SetupFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___S1SetupFailure_protocolIEs__item__id),
        (u'criticality', ___S1SetupFailure_protocolIEs__item__criticality),
        (u'value', ___S1SetupFailure_protocolIEs__item__value),
        ])
    __S1SetupFailure_protocolIEs__item_._ext = None
    _S1SetupFailure_protocolIEs._cont = __S1SetupFailure_protocolIEs__item_
    _S1SetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    S1SetupFailure._cont = ASN1Dict([
        (u'protocolIEs', _S1SetupFailure_protocolIEs),
        ])
    S1SetupFailure._ext = []
    
    #-----< S1SetupFailureIEs >-----#
    S1SetupFailureIEs = CLASS(name=u'S1SetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _S1SetupFailureIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _S1SetupFailureIEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeToWait')))
    _S1SetupFailureIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    S1SetupFailureIEs._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _S1SetupFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 65), (u'criticality', u'ignore'), (u'Value', _S1SetupFailureIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _S1SetupFailureIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENBConfigurationUpdate >-----#
    ENBConfigurationUpdate = SEQ(name=u'ENBConfigurationUpdate', mode=MODE_TYPE)
    _ENBConfigurationUpdate_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ENBConfigurationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ENBConfigurationUpdate_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____ENBConfigurationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENBname')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SupportedTAs')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-IdList')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PagingDRX')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-DefaultPagingDRX')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ConnectedengNBList')))
    _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ConnectedengNBList')))
    ____ENBConfigurationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 60), (u'criticality', u'ignore'), (u'Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 64), (u'criticality', u'reject'), (u'Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 128), (u'criticality', u'reject'), (u'Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 137), (u'criticality', u'ignore'), (u'Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 234), (u'criticality', u'ignore'), (u'Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 292), (u'criticality', u'ignore'), (u'Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 293), (u'criticality', u'ignore'), (u'Value', _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ENBConfigurationUpdate_protocolIEs__item__id._const_tab = ____ENBConfigurationUpdate_protocolIEs__item__id_tab
    ___ENBConfigurationUpdate_protocolIEs__item__id._const_tab_at = None
    ___ENBConfigurationUpdate_protocolIEs__item__id._const_tab_id = u'id'
    ___ENBConfigurationUpdate_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___ENBConfigurationUpdate_protocolIEs__item__criticality._const_tab = ____ENBConfigurationUpdate_protocolIEs__item__id_tab
    ___ENBConfigurationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ENBConfigurationUpdate_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ENBConfigurationUpdate_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___ENBConfigurationUpdate_protocolIEs__item__value._const_tab = ____ENBConfigurationUpdate_protocolIEs__item__id_tab
    ___ENBConfigurationUpdate_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ENBConfigurationUpdate_protocolIEs__item__value._const_tab_id = u'Value'
    __ENBConfigurationUpdate_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ENBConfigurationUpdate_protocolIEs__item__id),
        (u'criticality', ___ENBConfigurationUpdate_protocolIEs__item__criticality),
        (u'value', ___ENBConfigurationUpdate_protocolIEs__item__value),
        ])
    __ENBConfigurationUpdate_protocolIEs__item_._ext = None
    _ENBConfigurationUpdate_protocolIEs._cont = __ENBConfigurationUpdate_protocolIEs__item_
    _ENBConfigurationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBConfigurationUpdate._cont = ASN1Dict([
        (u'protocolIEs', _ENBConfigurationUpdate_protocolIEs),
        ])
    ENBConfigurationUpdate._ext = []
    
    #-----< ENBConfigurationUpdateIEs >-----#
    ENBConfigurationUpdateIEs = CLASS(name=u'ENBConfigurationUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ENBConfigurationUpdateIEs_val_Value_0 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENBname')))
    _ENBConfigurationUpdateIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SupportedTAs')))
    _ENBConfigurationUpdateIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSG-IdList')))
    _ENBConfigurationUpdateIEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PagingDRX')))
    _ENBConfigurationUpdateIEs_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NB-IoT-DefaultPagingDRX')))
    _ENBConfigurationUpdateIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ConnectedengNBList')))
    _ENBConfigurationUpdateIEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ConnectedengNBList')))
    ENBConfigurationUpdateIEs._val = ASN1Set(rv=[dict([(u'id', 60), (u'criticality', u'ignore'), (u'Value', _ENBConfigurationUpdateIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 64), (u'criticality', u'reject'), (u'Value', _ENBConfigurationUpdateIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 128), (u'criticality', u'reject'), (u'Value', _ENBConfigurationUpdateIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 137), (u'criticality', u'ignore'), (u'Value', _ENBConfigurationUpdateIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 234), (u'criticality', u'ignore'), (u'Value', _ENBConfigurationUpdateIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 292), (u'criticality', u'ignore'), (u'Value', _ENBConfigurationUpdateIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 293), (u'criticality', u'ignore'), (u'Value', _ENBConfigurationUpdateIEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENBConfigurationUpdateAcknowledge >-----#
    ENBConfigurationUpdateAcknowledge = SEQ(name=u'ENBConfigurationUpdateAcknowledge', mode=MODE_TYPE)
    _ENBConfigurationUpdateAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ENBConfigurationUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab = ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab = ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __ENBConfigurationUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id),
        (u'criticality', ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality),
        (u'value', ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value),
        ])
    __ENBConfigurationUpdateAcknowledge_protocolIEs__item_._ext = None
    _ENBConfigurationUpdateAcknowledge_protocolIEs._cont = __ENBConfigurationUpdateAcknowledge_protocolIEs__item_
    _ENBConfigurationUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBConfigurationUpdateAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _ENBConfigurationUpdateAcknowledge_protocolIEs),
        ])
    ENBConfigurationUpdateAcknowledge._ext = []
    
    #-----< ENBConfigurationUpdateAcknowledgeIEs >-----#
    ENBConfigurationUpdateAcknowledgeIEs = CLASS(name=u'ENBConfigurationUpdateAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ENBConfigurationUpdateAcknowledgeIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ENBConfigurationUpdateAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _ENBConfigurationUpdateAcknowledgeIEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENBConfigurationUpdateFailure >-----#
    ENBConfigurationUpdateFailure = SEQ(name=u'ENBConfigurationUpdateFailure', mode=MODE_TYPE)
    _ENBConfigurationUpdateFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ENBConfigurationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ENBConfigurationUpdateFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeToWait')))
    _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 65), (u'criticality', u'ignore'), (u'Value', _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ENBConfigurationUpdateFailure_protocolIEs__item__id._const_tab = ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___ENBConfigurationUpdateFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab = ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ENBConfigurationUpdateFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___ENBConfigurationUpdateFailure_protocolIEs__item__value._const_tab = ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___ENBConfigurationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ENBConfigurationUpdateFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __ENBConfigurationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ENBConfigurationUpdateFailure_protocolIEs__item__id),
        (u'criticality', ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality),
        (u'value', ___ENBConfigurationUpdateFailure_protocolIEs__item__value),
        ])
    __ENBConfigurationUpdateFailure_protocolIEs__item_._ext = None
    _ENBConfigurationUpdateFailure_protocolIEs._cont = __ENBConfigurationUpdateFailure_protocolIEs__item_
    _ENBConfigurationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBConfigurationUpdateFailure._cont = ASN1Dict([
        (u'protocolIEs', _ENBConfigurationUpdateFailure_protocolIEs),
        ])
    ENBConfigurationUpdateFailure._ext = []
    
    #-----< ENBConfigurationUpdateFailureIEs >-----#
    ENBConfigurationUpdateFailureIEs = CLASS(name=u'ENBConfigurationUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ENBConfigurationUpdateFailureIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _ENBConfigurationUpdateFailureIEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeToWait')))
    _ENBConfigurationUpdateFailureIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ENBConfigurationUpdateFailureIEs._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _ENBConfigurationUpdateFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 65), (u'criticality', u'ignore'), (u'Value', _ENBConfigurationUpdateFailureIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _ENBConfigurationUpdateFailureIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MMEConfigurationUpdate >-----#
    MMEConfigurationUpdate = SEQ(name=u'MMEConfigurationUpdate', mode=MODE_TYPE)
    _MMEConfigurationUpdate_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __MMEConfigurationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___MMEConfigurationUpdate_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____MMEConfigurationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MMEname')))
    _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServedGUMMEIs')))
    _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RelativeMMECapacity')))
    _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServedDCNs')))
    ____MMEConfigurationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 61), (u'criticality', u'ignore'), (u'Value', _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 105), (u'criticality', u'reject'), (u'Value', _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 87), (u'criticality', u'reject'), (u'Value', _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 247), (u'criticality', u'ignore'), (u'Value', _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MMEConfigurationUpdate_protocolIEs__item__id._const_tab = ____MMEConfigurationUpdate_protocolIEs__item__id_tab
    ___MMEConfigurationUpdate_protocolIEs__item__id._const_tab_at = None
    ___MMEConfigurationUpdate_protocolIEs__item__id._const_tab_id = u'id'
    ___MMEConfigurationUpdate_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___MMEConfigurationUpdate_protocolIEs__item__criticality._const_tab = ____MMEConfigurationUpdate_protocolIEs__item__id_tab
    ___MMEConfigurationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MMEConfigurationUpdate_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MMEConfigurationUpdate_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___MMEConfigurationUpdate_protocolIEs__item__value._const_tab = ____MMEConfigurationUpdate_protocolIEs__item__id_tab
    ___MMEConfigurationUpdate_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MMEConfigurationUpdate_protocolIEs__item__value._const_tab_id = u'Value'
    __MMEConfigurationUpdate_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MMEConfigurationUpdate_protocolIEs__item__id),
        (u'criticality', ___MMEConfigurationUpdate_protocolIEs__item__criticality),
        (u'value', ___MMEConfigurationUpdate_protocolIEs__item__value),
        ])
    __MMEConfigurationUpdate_protocolIEs__item_._ext = None
    _MMEConfigurationUpdate_protocolIEs._cont = __MMEConfigurationUpdate_protocolIEs__item_
    _MMEConfigurationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MMEConfigurationUpdate._cont = ASN1Dict([
        (u'protocolIEs', _MMEConfigurationUpdate_protocolIEs),
        ])
    MMEConfigurationUpdate._ext = []
    
    #-----< MMEConfigurationUpdateIEs >-----#
    MMEConfigurationUpdateIEs = CLASS(name=u'MMEConfigurationUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _MMEConfigurationUpdateIEs_val_Value_0 = STR_PRINT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MMEname')))
    _MMEConfigurationUpdateIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServedGUMMEIs')))
    _MMEConfigurationUpdateIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RelativeMMECapacity')))
    _MMEConfigurationUpdateIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ServedDCNs')))
    MMEConfigurationUpdateIEs._val = ASN1Set(rv=[dict([(u'id', 61), (u'criticality', u'ignore'), (u'Value', _MMEConfigurationUpdateIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 105), (u'criticality', u'reject'), (u'Value', _MMEConfigurationUpdateIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 87), (u'criticality', u'reject'), (u'Value', _MMEConfigurationUpdateIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 247), (u'criticality', u'ignore'), (u'Value', _MMEConfigurationUpdateIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MMEConfigurationUpdateAcknowledge >-----#
    MMEConfigurationUpdateAcknowledge = SEQ(name=u'MMEConfigurationUpdateAcknowledge', mode=MODE_TYPE)
    _MMEConfigurationUpdateAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __MMEConfigurationUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____MMEConfigurationUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____MMEConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____MMEConfigurationUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____MMEConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab = ____MMEConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____MMEConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab = ____MMEConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __MMEConfigurationUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__id),
        (u'criticality', ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__criticality),
        (u'value', ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__value),
        ])
    __MMEConfigurationUpdateAcknowledge_protocolIEs__item_._ext = None
    _MMEConfigurationUpdateAcknowledge_protocolIEs._cont = __MMEConfigurationUpdateAcknowledge_protocolIEs__item_
    _MMEConfigurationUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MMEConfigurationUpdateAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _MMEConfigurationUpdateAcknowledge_protocolIEs),
        ])
    MMEConfigurationUpdateAcknowledge._ext = []
    
    #-----< MMEConfigurationUpdateAcknowledgeIEs >-----#
    MMEConfigurationUpdateAcknowledgeIEs = CLASS(name=u'MMEConfigurationUpdateAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _MMEConfigurationUpdateAcknowledgeIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    MMEConfigurationUpdateAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _MMEConfigurationUpdateAcknowledgeIEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MMEConfigurationUpdateFailure >-----#
    MMEConfigurationUpdateFailure = SEQ(name=u'MMEConfigurationUpdateFailure', mode=MODE_TYPE)
    _MMEConfigurationUpdateFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __MMEConfigurationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___MMEConfigurationUpdateFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeToWait')))
    _____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 65), (u'criticality', u'ignore'), (u'Value', _____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MMEConfigurationUpdateFailure_protocolIEs__item__id._const_tab = ____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___MMEConfigurationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___MMEConfigurationUpdateFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___MMEConfigurationUpdateFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___MMEConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab = ____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___MMEConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MMEConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MMEConfigurationUpdateFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___MMEConfigurationUpdateFailure_protocolIEs__item__value._const_tab = ____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___MMEConfigurationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MMEConfigurationUpdateFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __MMEConfigurationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MMEConfigurationUpdateFailure_protocolIEs__item__id),
        (u'criticality', ___MMEConfigurationUpdateFailure_protocolIEs__item__criticality),
        (u'value', ___MMEConfigurationUpdateFailure_protocolIEs__item__value),
        ])
    __MMEConfigurationUpdateFailure_protocolIEs__item_._ext = None
    _MMEConfigurationUpdateFailure_protocolIEs._cont = __MMEConfigurationUpdateFailure_protocolIEs__item_
    _MMEConfigurationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MMEConfigurationUpdateFailure._cont = ASN1Dict([
        (u'protocolIEs', _MMEConfigurationUpdateFailure_protocolIEs),
        ])
    MMEConfigurationUpdateFailure._ext = []
    
    #-----< MMEConfigurationUpdateFailureIEs >-----#
    MMEConfigurationUpdateFailureIEs = CLASS(name=u'MMEConfigurationUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _MMEConfigurationUpdateFailureIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _MMEConfigurationUpdateFailureIEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeToWait')))
    _MMEConfigurationUpdateFailureIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    MMEConfigurationUpdateFailureIEs._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _MMEConfigurationUpdateFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 65), (u'criticality', u'ignore'), (u'Value', _MMEConfigurationUpdateFailureIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _MMEConfigurationUpdateFailureIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkS1cdma2000tunnelling >-----#
    DownlinkS1cdma2000tunnelling = SEQ(name=u'DownlinkS1cdma2000tunnelling', mode=MODE_TYPE)
    _DownlinkS1cdma2000tunnelling_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __DownlinkS1cdma2000tunnelling_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSubjecttoDataForwardingList')))
    _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000HOStatus')))
    _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000RATType')))
    _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000PDU')))
    ____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 12), (u'criticality', u'ignore'), (u'Value', _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 83), (u'criticality', u'ignore'), (u'Value', _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 71), (u'criticality', u'reject'), (u'Value', _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 70), (u'criticality', u'reject'), (u'Value', _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__id._const_tab = ____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__id._const_tab_at = None
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__id._const_tab_id = u'id'
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__criticality._const_tab = ____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__value._const_tab = ____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DownlinkS1cdma2000tunnelling_protocolIEs__item__value._const_tab_id = u'Value'
    __DownlinkS1cdma2000tunnelling_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DownlinkS1cdma2000tunnelling_protocolIEs__item__id),
        (u'criticality', ___DownlinkS1cdma2000tunnelling_protocolIEs__item__criticality),
        (u'value', ___DownlinkS1cdma2000tunnelling_protocolIEs__item__value),
        ])
    __DownlinkS1cdma2000tunnelling_protocolIEs__item_._ext = None
    _DownlinkS1cdma2000tunnelling_protocolIEs._cont = __DownlinkS1cdma2000tunnelling_protocolIEs__item_
    _DownlinkS1cdma2000tunnelling_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkS1cdma2000tunnelling._cont = ASN1Dict([
        (u'protocolIEs', _DownlinkS1cdma2000tunnelling_protocolIEs),
        ])
    DownlinkS1cdma2000tunnelling._ext = []
    
    #-----< DownlinkS1cdma2000tunnellingIEs >-----#
    DownlinkS1cdma2000tunnellingIEs = CLASS(name=u'DownlinkS1cdma2000tunnellingIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _DownlinkS1cdma2000tunnellingIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _DownlinkS1cdma2000tunnellingIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _DownlinkS1cdma2000tunnellingIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSubjecttoDataForwardingList')))
    _DownlinkS1cdma2000tunnellingIEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000HOStatus')))
    _DownlinkS1cdma2000tunnellingIEs_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000RATType')))
    _DownlinkS1cdma2000tunnellingIEs_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000PDU')))
    DownlinkS1cdma2000tunnellingIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _DownlinkS1cdma2000tunnellingIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _DownlinkS1cdma2000tunnellingIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 12), (u'criticality', u'ignore'), (u'Value', _DownlinkS1cdma2000tunnellingIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 83), (u'criticality', u'ignore'), (u'Value', _DownlinkS1cdma2000tunnellingIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 71), (u'criticality', u'reject'), (u'Value', _DownlinkS1cdma2000tunnellingIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 70), (u'criticality', u'reject'), (u'Value', _DownlinkS1cdma2000tunnellingIEs_val_Value_5), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UplinkS1cdma2000tunnelling >-----#
    UplinkS1cdma2000tunnelling = SEQ(name=u'UplinkS1cdma2000tunnelling', mode=MODE_TYPE)
    _UplinkS1cdma2000tunnelling_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UplinkS1cdma2000tunnelling_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000RATType')))
    _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000SectorID')))
    _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000HORequiredIndication')))
    _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000OneXSRVCCInfo')))
    _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000OneXRAND')))
    _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000PDU')))
    _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_8 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRANRoundTripDelayEstimationInfo')))
    ____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 71), (u'criticality', u'reject'), (u'Value', _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 72), (u'criticality', u'reject'), (u'Value', _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 84), (u'criticality', u'ignore'), (u'Value', _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 102), (u'criticality', u'reject'), (u'Value', _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 97), (u'criticality', u'reject'), (u'Value', _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 70), (u'criticality', u'reject'), (u'Value', _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 140), (u'criticality', u'ignore'), (u'Value', _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__id._const_tab = ____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__id._const_tab_at = None
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__id._const_tab_id = u'id'
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__criticality._const_tab = ____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__value._const_tab = ____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UplinkS1cdma2000tunnelling_protocolIEs__item__value._const_tab_id = u'Value'
    __UplinkS1cdma2000tunnelling_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UplinkS1cdma2000tunnelling_protocolIEs__item__id),
        (u'criticality', ___UplinkS1cdma2000tunnelling_protocolIEs__item__criticality),
        (u'value', ___UplinkS1cdma2000tunnelling_protocolIEs__item__value),
        ])
    __UplinkS1cdma2000tunnelling_protocolIEs__item_._ext = None
    _UplinkS1cdma2000tunnelling_protocolIEs._cont = __UplinkS1cdma2000tunnelling_protocolIEs__item_
    _UplinkS1cdma2000tunnelling_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkS1cdma2000tunnelling._cont = ASN1Dict([
        (u'protocolIEs', _UplinkS1cdma2000tunnelling_protocolIEs),
        ])
    UplinkS1cdma2000tunnelling._ext = []
    
    #-----< UplinkS1cdma2000tunnellingIEs >-----#
    UplinkS1cdma2000tunnellingIEs = CLASS(name=u'UplinkS1cdma2000tunnellingIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UplinkS1cdma2000tunnellingIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UplinkS1cdma2000tunnellingIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UplinkS1cdma2000tunnellingIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000RATType')))
    _UplinkS1cdma2000tunnellingIEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000SectorID')))
    _UplinkS1cdma2000tunnellingIEs_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000HORequiredIndication')))
    _UplinkS1cdma2000tunnellingIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000OneXSRVCCInfo')))
    _UplinkS1cdma2000tunnellingIEs_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000OneXRAND')))
    _UplinkS1cdma2000tunnellingIEs_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cdma2000PDU')))
    _UplinkS1cdma2000tunnellingIEs_val_Value_8 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRANRoundTripDelayEstimationInfo')))
    UplinkS1cdma2000tunnellingIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _UplinkS1cdma2000tunnellingIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _UplinkS1cdma2000tunnellingIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 71), (u'criticality', u'reject'), (u'Value', _UplinkS1cdma2000tunnellingIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 72), (u'criticality', u'reject'), (u'Value', _UplinkS1cdma2000tunnellingIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 84), (u'criticality', u'ignore'), (u'Value', _UplinkS1cdma2000tunnellingIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 102), (u'criticality', u'reject'), (u'Value', _UplinkS1cdma2000tunnellingIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 97), (u'criticality', u'reject'), (u'Value', _UplinkS1cdma2000tunnellingIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 70), (u'criticality', u'reject'), (u'Value', _UplinkS1cdma2000tunnellingIEs_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 140), (u'criticality', u'ignore'), (u'Value', _UplinkS1cdma2000tunnellingIEs_val_Value_8), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UECapabilityInfoIndication >-----#
    UECapabilityInfoIndication = SEQ(name=u'UECapabilityInfoIndication', mode=MODE_TYPE)
    _UECapabilityInfoIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UECapabilityInfoIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UECapabilityInfoIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UECapabilityInfoIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityForPaging')))
    _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_4 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-Application-Layer-Measurement-Capability')))
    _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LTE-M-Indication')))
    _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityForPaging')))
    ____UECapabilityInfoIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 74), (u'criticality', u'ignore'), (u'Value', _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 198), (u'criticality', u'ignore'), (u'Value', _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 263), (u'criticality', u'ignore'), (u'Value', _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 272), (u'criticality', u'ignore'), (u'Value', _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 315), (u'criticality', u'ignore'), (u'Value', _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 327), (u'criticality', u'ignore'), (u'Value', _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UECapabilityInfoIndication_protocolIEs__item__id._const_tab = ____UECapabilityInfoIndication_protocolIEs__item__id_tab
    ___UECapabilityInfoIndication_protocolIEs__item__id._const_tab_at = None
    ___UECapabilityInfoIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___UECapabilityInfoIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UECapabilityInfoIndication_protocolIEs__item__criticality._const_tab = ____UECapabilityInfoIndication_protocolIEs__item__id_tab
    ___UECapabilityInfoIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UECapabilityInfoIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UECapabilityInfoIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UECapabilityInfoIndication_protocolIEs__item__value._const_tab = ____UECapabilityInfoIndication_protocolIEs__item__id_tab
    ___UECapabilityInfoIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UECapabilityInfoIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __UECapabilityInfoIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UECapabilityInfoIndication_protocolIEs__item__id),
        (u'criticality', ___UECapabilityInfoIndication_protocolIEs__item__criticality),
        (u'value', ___UECapabilityInfoIndication_protocolIEs__item__value),
        ])
    __UECapabilityInfoIndication_protocolIEs__item_._ext = None
    _UECapabilityInfoIndication_protocolIEs._cont = __UECapabilityInfoIndication_protocolIEs__item_
    _UECapabilityInfoIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UECapabilityInfoIndication._cont = ASN1Dict([
        (u'protocolIEs', _UECapabilityInfoIndication_protocolIEs),
        ])
    UECapabilityInfoIndication._ext = []
    
    #-----< UECapabilityInfoIndicationIEs >-----#
    UECapabilityInfoIndicationIEs = CLASS(name=u'UECapabilityInfoIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UECapabilityInfoIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UECapabilityInfoIndicationIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UECapabilityInfoIndicationIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _UECapabilityInfoIndicationIEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityForPaging')))
    _UECapabilityInfoIndicationIEs_val_Value_4 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UE-Application-Layer-Measurement-Capability')))
    _UECapabilityInfoIndicationIEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LTE-M-Indication')))
    _UECapabilityInfoIndicationIEs_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _UECapabilityInfoIndicationIEs_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityForPaging')))
    UECapabilityInfoIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _UECapabilityInfoIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _UECapabilityInfoIndicationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 74), (u'criticality', u'ignore'), (u'Value', _UECapabilityInfoIndicationIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 198), (u'criticality', u'ignore'), (u'Value', _UECapabilityInfoIndicationIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 263), (u'criticality', u'ignore'), (u'Value', _UECapabilityInfoIndicationIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 272), (u'criticality', u'ignore'), (u'Value', _UECapabilityInfoIndicationIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 315), (u'criticality', u'ignore'), (u'Value', _UECapabilityInfoIndicationIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 327), (u'criticality', u'ignore'), (u'Value', _UECapabilityInfoIndicationIEs_val_Value_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENBStatusTransfer >-----#
    ENBStatusTransfer = SEQ(name=u'ENBStatusTransfer', mode=MODE_TYPE)
    _ENBStatusTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ENBStatusTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ENBStatusTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____ENBStatusTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ENBStatusTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____ENBStatusTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____ENBStatusTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-StatusTransfer-TransparentContainer')))
    ____ENBStatusTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____ENBStatusTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____ENBStatusTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 90), (u'criticality', u'reject'), (u'Value', _____ENBStatusTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___ENBStatusTransfer_protocolIEs__item__id._const_tab = ____ENBStatusTransfer_protocolIEs__item__id_tab
    ___ENBStatusTransfer_protocolIEs__item__id._const_tab_at = None
    ___ENBStatusTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___ENBStatusTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___ENBStatusTransfer_protocolIEs__item__criticality._const_tab = ____ENBStatusTransfer_protocolIEs__item__id_tab
    ___ENBStatusTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ENBStatusTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ENBStatusTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___ENBStatusTransfer_protocolIEs__item__value._const_tab = ____ENBStatusTransfer_protocolIEs__item__id_tab
    ___ENBStatusTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ENBStatusTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __ENBStatusTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ENBStatusTransfer_protocolIEs__item__id),
        (u'criticality', ___ENBStatusTransfer_protocolIEs__item__criticality),
        (u'value', ___ENBStatusTransfer_protocolIEs__item__value),
        ])
    __ENBStatusTransfer_protocolIEs__item_._ext = None
    _ENBStatusTransfer_protocolIEs._cont = __ENBStatusTransfer_protocolIEs__item_
    _ENBStatusTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBStatusTransfer._cont = ASN1Dict([
        (u'protocolIEs', _ENBStatusTransfer_protocolIEs),
        ])
    ENBStatusTransfer._ext = []
    
    #-----< ENBStatusTransferIEs >-----#
    ENBStatusTransferIEs = CLASS(name=u'ENBStatusTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ENBStatusTransferIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _ENBStatusTransferIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _ENBStatusTransferIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-StatusTransfer-TransparentContainer')))
    ENBStatusTransferIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _ENBStatusTransferIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _ENBStatusTransferIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 90), (u'criticality', u'reject'), (u'Value', _ENBStatusTransferIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MMEStatusTransfer >-----#
    MMEStatusTransfer = SEQ(name=u'MMEStatusTransfer', mode=MODE_TYPE)
    _MMEStatusTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __MMEStatusTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___MMEStatusTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____MMEStatusTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____MMEStatusTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____MMEStatusTransfer_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____MMEStatusTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-StatusTransfer-TransparentContainer')))
    ____MMEStatusTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____MMEStatusTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____MMEStatusTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 90), (u'criticality', u'reject'), (u'Value', _____MMEStatusTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___MMEStatusTransfer_protocolIEs__item__id._const_tab = ____MMEStatusTransfer_protocolIEs__item__id_tab
    ___MMEStatusTransfer_protocolIEs__item__id._const_tab_at = None
    ___MMEStatusTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___MMEStatusTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___MMEStatusTransfer_protocolIEs__item__criticality._const_tab = ____MMEStatusTransfer_protocolIEs__item__id_tab
    ___MMEStatusTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MMEStatusTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MMEStatusTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___MMEStatusTransfer_protocolIEs__item__value._const_tab = ____MMEStatusTransfer_protocolIEs__item__id_tab
    ___MMEStatusTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MMEStatusTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __MMEStatusTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MMEStatusTransfer_protocolIEs__item__id),
        (u'criticality', ___MMEStatusTransfer_protocolIEs__item__criticality),
        (u'value', ___MMEStatusTransfer_protocolIEs__item__value),
        ])
    __MMEStatusTransfer_protocolIEs__item_._ext = None
    _MMEStatusTransfer_protocolIEs._cont = __MMEStatusTransfer_protocolIEs__item_
    _MMEStatusTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MMEStatusTransfer._cont = ASN1Dict([
        (u'protocolIEs', _MMEStatusTransfer_protocolIEs),
        ])
    MMEStatusTransfer._ext = []
    
    #-----< MMEStatusTransferIEs >-----#
    MMEStatusTransferIEs = CLASS(name=u'MMEStatusTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _MMEStatusTransferIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _MMEStatusTransferIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _MMEStatusTransferIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-StatusTransfer-TransparentContainer')))
    MMEStatusTransferIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _MMEStatusTransferIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _MMEStatusTransferIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 90), (u'criticality', u'reject'), (u'Value', _MMEStatusTransferIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TraceStart >-----#
    TraceStart = SEQ(name=u'TraceStart', mode=MODE_TYPE)
    _TraceStart_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __TraceStart_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___TraceStart_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____TraceStart_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____TraceStart_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TraceActivation')))
    ____TraceStart_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _____TraceStart_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___TraceStart_protocolIEs__item__id._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__id._const_tab_at = None
    ___TraceStart_protocolIEs__item__id._const_tab_id = u'id'
    ___TraceStart_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___TraceStart_protocolIEs__item__criticality._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___TraceStart_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___TraceStart_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___TraceStart_protocolIEs__item__value._const_tab = ____TraceStart_protocolIEs__item__id_tab
    ___TraceStart_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___TraceStart_protocolIEs__item__value._const_tab_id = u'Value'
    __TraceStart_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___TraceStart_protocolIEs__item__id),
        (u'criticality', ___TraceStart_protocolIEs__item__criticality),
        (u'value', ___TraceStart_protocolIEs__item__value),
        ])
    __TraceStart_protocolIEs__item_._ext = None
    _TraceStart_protocolIEs._cont = __TraceStart_protocolIEs__item_
    _TraceStart_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TraceStart._cont = ASN1Dict([
        (u'protocolIEs', _TraceStart_protocolIEs),
        ])
    TraceStart._ext = []
    
    #-----< TraceStartIEs >-----#
    TraceStartIEs = CLASS(name=u'TraceStartIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _TraceStartIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _TraceStartIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _TraceStartIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TraceActivation')))
    TraceStartIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _TraceStartIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _TraceStartIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _TraceStartIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< TraceFailureIndication >-----#
    TraceFailureIndication = SEQ(name=u'TraceFailureIndication', mode=MODE_TYPE)
    _TraceFailureIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __TraceFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___TraceFailureIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____TraceFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-UTRAN-Trace-ID')))
    _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    ____TraceFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___TraceFailureIndication_protocolIEs__item__id._const_tab = ____TraceFailureIndication_protocolIEs__item__id_tab
    ___TraceFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___TraceFailureIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___TraceFailureIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___TraceFailureIndication_protocolIEs__item__criticality._const_tab = ____TraceFailureIndication_protocolIEs__item__id_tab
    ___TraceFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___TraceFailureIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___TraceFailureIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___TraceFailureIndication_protocolIEs__item__value._const_tab = ____TraceFailureIndication_protocolIEs__item__id_tab
    ___TraceFailureIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___TraceFailureIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __TraceFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___TraceFailureIndication_protocolIEs__item__id),
        (u'criticality', ___TraceFailureIndication_protocolIEs__item__criticality),
        (u'value', ___TraceFailureIndication_protocolIEs__item__value),
        ])
    __TraceFailureIndication_protocolIEs__item_._ext = None
    _TraceFailureIndication_protocolIEs._cont = __TraceFailureIndication_protocolIEs__item_
    _TraceFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    TraceFailureIndication._cont = ASN1Dict([
        (u'protocolIEs', _TraceFailureIndication_protocolIEs),
        ])
    TraceFailureIndication._ext = []
    
    #-----< TraceFailureIndicationIEs >-----#
    TraceFailureIndicationIEs = CLASS(name=u'TraceFailureIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _TraceFailureIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _TraceFailureIndicationIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _TraceFailureIndicationIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-UTRAN-Trace-ID')))
    _TraceFailureIndicationIEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    TraceFailureIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _TraceFailureIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _TraceFailureIndicationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _TraceFailureIndicationIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _TraceFailureIndicationIEs_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DeactivateTrace >-----#
    DeactivateTrace = SEQ(name=u'DeactivateTrace', mode=MODE_TYPE)
    _DeactivateTrace_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __DeactivateTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___DeactivateTrace_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____DeactivateTrace_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-UTRAN-Trace-ID')))
    ____DeactivateTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___DeactivateTrace_protocolIEs__item__id._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__id._const_tab_at = None
    ___DeactivateTrace_protocolIEs__item__id._const_tab_id = u'id'
    ___DeactivateTrace_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DeactivateTrace_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DeactivateTrace_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___DeactivateTrace_protocolIEs__item__value._const_tab = ____DeactivateTrace_protocolIEs__item__id_tab
    ___DeactivateTrace_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DeactivateTrace_protocolIEs__item__value._const_tab_id = u'Value'
    __DeactivateTrace_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DeactivateTrace_protocolIEs__item__id),
        (u'criticality', ___DeactivateTrace_protocolIEs__item__criticality),
        (u'value', ___DeactivateTrace_protocolIEs__item__value),
        ])
    __DeactivateTrace_protocolIEs__item_._ext = None
    _DeactivateTrace_protocolIEs._cont = __DeactivateTrace_protocolIEs__item_
    _DeactivateTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DeactivateTrace._cont = ASN1Dict([
        (u'protocolIEs', _DeactivateTrace_protocolIEs),
        ])
    DeactivateTrace._ext = []
    
    #-----< DeactivateTraceIEs >-----#
    DeactivateTraceIEs = CLASS(name=u'DeactivateTraceIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _DeactivateTraceIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _DeactivateTraceIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _DeactivateTraceIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-UTRAN-Trace-ID')))
    DeactivateTraceIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _DeactivateTraceIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _DeactivateTraceIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _DeactivateTraceIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CellTrafficTrace >-----#
    CellTrafficTrace = SEQ(name=u'CellTrafficTrace', mode=MODE_TYPE)
    _CellTrafficTrace_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __CellTrafficTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___CellTrafficTrace_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____CellTrafficTrace_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-UTRAN-Trace-ID')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PrivacyIndicator')))
    ____CellTrafficTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 100), (u'criticality', u'ignore'), (u'Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 131), (u'criticality', u'ignore'), (u'Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 166), (u'criticality', u'ignore'), (u'Value', _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CellTrafficTrace_protocolIEs__item__id._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__id._const_tab_at = None
    ___CellTrafficTrace_protocolIEs__item__id._const_tab_id = u'id'
    ___CellTrafficTrace_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CellTrafficTrace_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CellTrafficTrace_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___CellTrafficTrace_protocolIEs__item__value._const_tab = ____CellTrafficTrace_protocolIEs__item__id_tab
    ___CellTrafficTrace_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CellTrafficTrace_protocolIEs__item__value._const_tab_id = u'Value'
    __CellTrafficTrace_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CellTrafficTrace_protocolIEs__item__id),
        (u'criticality', ___CellTrafficTrace_protocolIEs__item__criticality),
        (u'value', ___CellTrafficTrace_protocolIEs__item__value),
        ])
    __CellTrafficTrace_protocolIEs__item_._ext = None
    _CellTrafficTrace_protocolIEs._cont = __CellTrafficTrace_protocolIEs__item_
    _CellTrafficTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    CellTrafficTrace._cont = ASN1Dict([
        (u'protocolIEs', _CellTrafficTrace_protocolIEs),
        ])
    CellTrafficTrace._ext = []
    
    #-----< CellTrafficTraceIEs >-----#
    CellTrafficTraceIEs = CLASS(name=u'CellTrafficTraceIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _CellTrafficTraceIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _CellTrafficTraceIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _CellTrafficTraceIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-UTRAN-Trace-ID')))
    _CellTrafficTraceIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _CellTrafficTraceIEs_val_Value_4 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _CellTrafficTraceIEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PrivacyIndicator')))
    CellTrafficTraceIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _CellTrafficTraceIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _CellTrafficTraceIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 86), (u'criticality', u'ignore'), (u'Value', _CellTrafficTraceIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 100), (u'criticality', u'ignore'), (u'Value', _CellTrafficTraceIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 131), (u'criticality', u'ignore'), (u'Value', _CellTrafficTraceIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 166), (u'criticality', u'ignore'), (u'Value', _CellTrafficTraceIEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< LocationReportingControl >-----#
    LocationReportingControl = SEQ(name=u'LocationReportingControl', mode=MODE_TYPE)
    _LocationReportingControl_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __LocationReportingControl_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___LocationReportingControl_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____LocationReportingControl_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RequestType')))
    ____LocationReportingControl_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 98), (u'criticality', u'ignore'), (u'Value', _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___LocationReportingControl_protocolIEs__item__id._const_tab = ____LocationReportingControl_protocolIEs__item__id_tab
    ___LocationReportingControl_protocolIEs__item__id._const_tab_at = None
    ___LocationReportingControl_protocolIEs__item__id._const_tab_id = u'id'
    ___LocationReportingControl_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___LocationReportingControl_protocolIEs__item__criticality._const_tab = ____LocationReportingControl_protocolIEs__item__id_tab
    ___LocationReportingControl_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___LocationReportingControl_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___LocationReportingControl_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___LocationReportingControl_protocolIEs__item__value._const_tab = ____LocationReportingControl_protocolIEs__item__id_tab
    ___LocationReportingControl_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___LocationReportingControl_protocolIEs__item__value._const_tab_id = u'Value'
    __LocationReportingControl_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___LocationReportingControl_protocolIEs__item__id),
        (u'criticality', ___LocationReportingControl_protocolIEs__item__criticality),
        (u'value', ___LocationReportingControl_protocolIEs__item__value),
        ])
    __LocationReportingControl_protocolIEs__item_._ext = None
    _LocationReportingControl_protocolIEs._cont = __LocationReportingControl_protocolIEs__item_
    _LocationReportingControl_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LocationReportingControl._cont = ASN1Dict([
        (u'protocolIEs', _LocationReportingControl_protocolIEs),
        ])
    LocationReportingControl._ext = []
    
    #-----< LocationReportingControlIEs >-----#
    LocationReportingControlIEs = CLASS(name=u'LocationReportingControlIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _LocationReportingControlIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _LocationReportingControlIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _LocationReportingControlIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RequestType')))
    LocationReportingControlIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _LocationReportingControlIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _LocationReportingControlIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 98), (u'criticality', u'ignore'), (u'Value', _LocationReportingControlIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< LocationReportingFailureIndication >-----#
    LocationReportingFailureIndication = SEQ(name=u'LocationReportingFailureIndication', mode=MODE_TYPE)
    _LocationReportingFailureIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __LocationReportingFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___LocationReportingFailureIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____LocationReportingFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    ____LocationReportingFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___LocationReportingFailureIndication_protocolIEs__item__id._const_tab = ____LocationReportingFailureIndication_protocolIEs__item__id_tab
    ___LocationReportingFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___LocationReportingFailureIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___LocationReportingFailureIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___LocationReportingFailureIndication_protocolIEs__item__criticality._const_tab = ____LocationReportingFailureIndication_protocolIEs__item__id_tab
    ___LocationReportingFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___LocationReportingFailureIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___LocationReportingFailureIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___LocationReportingFailureIndication_protocolIEs__item__value._const_tab = ____LocationReportingFailureIndication_protocolIEs__item__id_tab
    ___LocationReportingFailureIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___LocationReportingFailureIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __LocationReportingFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___LocationReportingFailureIndication_protocolIEs__item__id),
        (u'criticality', ___LocationReportingFailureIndication_protocolIEs__item__criticality),
        (u'value', ___LocationReportingFailureIndication_protocolIEs__item__value),
        ])
    __LocationReportingFailureIndication_protocolIEs__item_._ext = None
    _LocationReportingFailureIndication_protocolIEs._cont = __LocationReportingFailureIndication_protocolIEs__item_
    _LocationReportingFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LocationReportingFailureIndication._cont = ASN1Dict([
        (u'protocolIEs', _LocationReportingFailureIndication_protocolIEs),
        ])
    LocationReportingFailureIndication._ext = []
    
    #-----< LocationReportingFailureIndicationIEs >-----#
    LocationReportingFailureIndicationIEs = CLASS(name=u'LocationReportingFailureIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _LocationReportingFailureIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _LocationReportingFailureIndicationIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _LocationReportingFailureIndicationIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    LocationReportingFailureIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _LocationReportingFailureIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _LocationReportingFailureIndicationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _LocationReportingFailureIndicationIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< LocationReport >-----#
    LocationReport = SEQ(name=u'LocationReport', mode=MODE_TYPE)
    _LocationReport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __LocationReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___LocationReport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____LocationReport_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RequestType')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PSCellInformation')))
    ____LocationReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 100), (u'criticality', u'ignore'), (u'Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 67), (u'criticality', u'ignore'), (u'Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 98), (u'criticality', u'ignore'), (u'Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 288), (u'criticality', u'ignore'), (u'Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___LocationReport_protocolIEs__item__id._const_tab = ____LocationReport_protocolIEs__item__id_tab
    ___LocationReport_protocolIEs__item__id._const_tab_at = None
    ___LocationReport_protocolIEs__item__id._const_tab_id = u'id'
    ___LocationReport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___LocationReport_protocolIEs__item__criticality._const_tab = ____LocationReport_protocolIEs__item__id_tab
    ___LocationReport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___LocationReport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___LocationReport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___LocationReport_protocolIEs__item__value._const_tab = ____LocationReport_protocolIEs__item__id_tab
    ___LocationReport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___LocationReport_protocolIEs__item__value._const_tab_id = u'Value'
    __LocationReport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___LocationReport_protocolIEs__item__id),
        (u'criticality', ___LocationReport_protocolIEs__item__criticality),
        (u'value', ___LocationReport_protocolIEs__item__value),
        ])
    __LocationReport_protocolIEs__item_._ext = None
    _LocationReport_protocolIEs._cont = __LocationReport_protocolIEs__item_
    _LocationReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LocationReport._cont = ASN1Dict([
        (u'protocolIEs', _LocationReport_protocolIEs),
        ])
    LocationReport._ext = []
    
    #-----< LocationReportIEs >-----#
    LocationReportIEs = CLASS(name=u'LocationReportIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _LocationReportIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _LocationReportIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _LocationReportIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _LocationReportIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _LocationReportIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RequestType')))
    _LocationReportIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PSCellInformation')))
    LocationReportIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _LocationReportIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _LocationReportIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 100), (u'criticality', u'ignore'), (u'Value', _LocationReportIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 67), (u'criticality', u'ignore'), (u'Value', _LocationReportIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 98), (u'criticality', u'ignore'), (u'Value', _LocationReportIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 288), (u'criticality', u'ignore'), (u'Value', _LocationReportIEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< OverloadStart >-----#
    OverloadStart = SEQ(name=u'OverloadStart', mode=MODE_TYPE)
    _OverloadStart_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __OverloadStart_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___OverloadStart_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____OverloadStart_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____OverloadStart_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'OverloadResponse')))
    _____OverloadStart_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEIList')))
    _____OverloadStart_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TrafficLoadReductionIndication')))
    ____OverloadStart_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 101), (u'criticality', u'reject'), (u'Value', _____OverloadStart_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 154), (u'criticality', u'ignore'), (u'Value', _____OverloadStart_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 161), (u'criticality', u'ignore'), (u'Value', _____OverloadStart_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___OverloadStart_protocolIEs__item__id._const_tab = ____OverloadStart_protocolIEs__item__id_tab
    ___OverloadStart_protocolIEs__item__id._const_tab_at = None
    ___OverloadStart_protocolIEs__item__id._const_tab_id = u'id'
    ___OverloadStart_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___OverloadStart_protocolIEs__item__criticality._const_tab = ____OverloadStart_protocolIEs__item__id_tab
    ___OverloadStart_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___OverloadStart_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___OverloadStart_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___OverloadStart_protocolIEs__item__value._const_tab = ____OverloadStart_protocolIEs__item__id_tab
    ___OverloadStart_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___OverloadStart_protocolIEs__item__value._const_tab_id = u'Value'
    __OverloadStart_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___OverloadStart_protocolIEs__item__id),
        (u'criticality', ___OverloadStart_protocolIEs__item__criticality),
        (u'value', ___OverloadStart_protocolIEs__item__value),
        ])
    __OverloadStart_protocolIEs__item_._ext = None
    _OverloadStart_protocolIEs._cont = __OverloadStart_protocolIEs__item_
    _OverloadStart_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    OverloadStart._cont = ASN1Dict([
        (u'protocolIEs', _OverloadStart_protocolIEs),
        ])
    OverloadStart._ext = []
    
    #-----< OverloadStartIEs >-----#
    OverloadStartIEs = CLASS(name=u'OverloadStartIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _OverloadStartIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'OverloadResponse')))
    _OverloadStartIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEIList')))
    _OverloadStartIEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TrafficLoadReductionIndication')))
    OverloadStartIEs._val = ASN1Set(rv=[dict([(u'id', 101), (u'criticality', u'reject'), (u'Value', _OverloadStartIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 154), (u'criticality', u'ignore'), (u'Value', _OverloadStartIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 161), (u'criticality', u'ignore'), (u'Value', _OverloadStartIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< OverloadStop >-----#
    OverloadStop = SEQ(name=u'OverloadStop', mode=MODE_TYPE)
    _OverloadStop_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __OverloadStop_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___OverloadStop_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____OverloadStop_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____OverloadStop_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEIList')))
    ____OverloadStop_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 154), (u'criticality', u'ignore'), (u'Value', _____OverloadStop_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___OverloadStop_protocolIEs__item__id._const_tab = ____OverloadStop_protocolIEs__item__id_tab
    ___OverloadStop_protocolIEs__item__id._const_tab_at = None
    ___OverloadStop_protocolIEs__item__id._const_tab_id = u'id'
    ___OverloadStop_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___OverloadStop_protocolIEs__item__criticality._const_tab = ____OverloadStop_protocolIEs__item__id_tab
    ___OverloadStop_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___OverloadStop_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___OverloadStop_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___OverloadStop_protocolIEs__item__value._const_tab = ____OverloadStop_protocolIEs__item__id_tab
    ___OverloadStop_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___OverloadStop_protocolIEs__item__value._const_tab_id = u'Value'
    __OverloadStop_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___OverloadStop_protocolIEs__item__id),
        (u'criticality', ___OverloadStop_protocolIEs__item__criticality),
        (u'value', ___OverloadStop_protocolIEs__item__value),
        ])
    __OverloadStop_protocolIEs__item_._ext = None
    _OverloadStop_protocolIEs._cont = __OverloadStop_protocolIEs__item_
    _OverloadStop_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    OverloadStop._cont = ASN1Dict([
        (u'protocolIEs', _OverloadStop_protocolIEs),
        ])
    OverloadStop._ext = []
    
    #-----< OverloadStopIEs >-----#
    OverloadStopIEs = CLASS(name=u'OverloadStopIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _OverloadStopIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'GUMMEIList')))
    OverloadStopIEs._val = ASN1Set(rv=[dict([(u'id', 154), (u'criticality', u'ignore'), (u'Value', _OverloadStopIEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< WriteReplaceWarningRequest >-----#
    WriteReplaceWarningRequest = SEQ(name=u'WriteReplaceWarningRequest', mode=MODE_TYPE)
    _WriteReplaceWarningRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __WriteReplaceWarningRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___WriteReplaceWarningRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____WriteReplaceWarningRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MessageIdentifier')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SerialNumber')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningAreaList')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RepetitionPeriod')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedRepetitionPeriod')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NumberofBroadcastRequest')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningType')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningSecurityInfo')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_8 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DataCodingScheme')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_9 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningMessageContents')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ConcurrentWarningMessageIndicator')))
    _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_11 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningAreaCoordinates')))
    ____WriteReplaceWarningRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 113), (u'criticality', u'ignore'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 114), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 144), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 115), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 116), (u'criticality', u'ignore'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 117), (u'criticality', u'ignore'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 118), (u'criticality', u'ignore'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 119), (u'criticality', u'ignore'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 142), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 286), (u'criticality', u'ignore'), (u'Value', _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WriteReplaceWarningRequest_protocolIEs__item__id._const_tab = ____WriteReplaceWarningRequest_protocolIEs__item__id_tab
    ___WriteReplaceWarningRequest_protocolIEs__item__id._const_tab_at = None
    ___WriteReplaceWarningRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality._const_tab = ____WriteReplaceWarningRequest_protocolIEs__item__id_tab
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WriteReplaceWarningRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WriteReplaceWarningRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___WriteReplaceWarningRequest_protocolIEs__item__value._const_tab = ____WriteReplaceWarningRequest_protocolIEs__item__id_tab
    ___WriteReplaceWarningRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WriteReplaceWarningRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __WriteReplaceWarningRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WriteReplaceWarningRequest_protocolIEs__item__id),
        (u'criticality', ___WriteReplaceWarningRequest_protocolIEs__item__criticality),
        (u'value', ___WriteReplaceWarningRequest_protocolIEs__item__value),
        ])
    __WriteReplaceWarningRequest_protocolIEs__item_._ext = None
    _WriteReplaceWarningRequest_protocolIEs._cont = __WriteReplaceWarningRequest_protocolIEs__item_
    _WriteReplaceWarningRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WriteReplaceWarningRequest._cont = ASN1Dict([
        (u'protocolIEs', _WriteReplaceWarningRequest_protocolIEs),
        ])
    WriteReplaceWarningRequest._ext = []
    
    #-----< WriteReplaceWarningRequestIEs >-----#
    WriteReplaceWarningRequestIEs = CLASS(name=u'WriteReplaceWarningRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _WriteReplaceWarningRequestIEs_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MessageIdentifier')))
    _WriteReplaceWarningRequestIEs_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SerialNumber')))
    _WriteReplaceWarningRequestIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningAreaList')))
    _WriteReplaceWarningRequestIEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RepetitionPeriod')))
    _WriteReplaceWarningRequestIEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ExtendedRepetitionPeriod')))
    _WriteReplaceWarningRequestIEs_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'NumberofBroadcastRequest')))
    _WriteReplaceWarningRequestIEs_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningType')))
    _WriteReplaceWarningRequestIEs_val_Value_7 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningSecurityInfo')))
    _WriteReplaceWarningRequestIEs_val_Value_8 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DataCodingScheme')))
    _WriteReplaceWarningRequestIEs_val_Value_9 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningMessageContents')))
    _WriteReplaceWarningRequestIEs_val_Value_10 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ConcurrentWarningMessageIndicator')))
    _WriteReplaceWarningRequestIEs_val_Value_11 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningAreaCoordinates')))
    WriteReplaceWarningRequestIEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 113), (u'criticality', u'ignore'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 114), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 144), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 115), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 116), (u'criticality', u'ignore'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 117), (u'criticality', u'ignore'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 118), (u'criticality', u'ignore'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 119), (u'criticality', u'ignore'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 142), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 286), (u'criticality', u'ignore'), (u'Value', _WriteReplaceWarningRequestIEs_val_Value_11), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< WriteReplaceWarningResponse >-----#
    WriteReplaceWarningResponse = SEQ(name=u'WriteReplaceWarningResponse', mode=MODE_TYPE)
    _WriteReplaceWarningResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __WriteReplaceWarningResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___WriteReplaceWarningResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____WriteReplaceWarningResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MessageIdentifier')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SerialNumber')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BroadcastCompletedAreaList')))
    _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____WriteReplaceWarningResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 120), (u'criticality', u'ignore'), (u'Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WriteReplaceWarningResponse_protocolIEs__item__id._const_tab = ____WriteReplaceWarningResponse_protocolIEs__item__id_tab
    ___WriteReplaceWarningResponse_protocolIEs__item__id._const_tab_at = None
    ___WriteReplaceWarningResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality._const_tab = ____WriteReplaceWarningResponse_protocolIEs__item__id_tab
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WriteReplaceWarningResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WriteReplaceWarningResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___WriteReplaceWarningResponse_protocolIEs__item__value._const_tab = ____WriteReplaceWarningResponse_protocolIEs__item__id_tab
    ___WriteReplaceWarningResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WriteReplaceWarningResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __WriteReplaceWarningResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WriteReplaceWarningResponse_protocolIEs__item__id),
        (u'criticality', ___WriteReplaceWarningResponse_protocolIEs__item__criticality),
        (u'value', ___WriteReplaceWarningResponse_protocolIEs__item__value),
        ])
    __WriteReplaceWarningResponse_protocolIEs__item_._ext = None
    _WriteReplaceWarningResponse_protocolIEs._cont = __WriteReplaceWarningResponse_protocolIEs__item_
    _WriteReplaceWarningResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WriteReplaceWarningResponse._cont = ASN1Dict([
        (u'protocolIEs', _WriteReplaceWarningResponse_protocolIEs),
        ])
    WriteReplaceWarningResponse._ext = []
    
    #-----< WriteReplaceWarningResponseIEs >-----#
    WriteReplaceWarningResponseIEs = CLASS(name=u'WriteReplaceWarningResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _WriteReplaceWarningResponseIEs_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MessageIdentifier')))
    _WriteReplaceWarningResponseIEs_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SerialNumber')))
    _WriteReplaceWarningResponseIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BroadcastCompletedAreaList')))
    _WriteReplaceWarningResponseIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    WriteReplaceWarningResponseIEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _WriteReplaceWarningResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 120), (u'criticality', u'ignore'), (u'Value', _WriteReplaceWarningResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _WriteReplaceWarningResponseIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENBDirectInformationTransfer >-----#
    ENBDirectInformationTransfer = SEQ(name=u'ENBDirectInformationTransfer', mode=MODE_TYPE)
    _ENBDirectInformationTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ENBDirectInformationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ENBDirectInformationTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____ENBDirectInformationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ENBDirectInformationTransfer_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Inter-SystemInformationTransferType')))
    ____ENBDirectInformationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 121), (u'criticality', u'reject'), (u'Value', _____ENBDirectInformationTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___ENBDirectInformationTransfer_protocolIEs__item__id._const_tab = ____ENBDirectInformationTransfer_protocolIEs__item__id_tab
    ___ENBDirectInformationTransfer_protocolIEs__item__id._const_tab_at = None
    ___ENBDirectInformationTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___ENBDirectInformationTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___ENBDirectInformationTransfer_protocolIEs__item__criticality._const_tab = ____ENBDirectInformationTransfer_protocolIEs__item__id_tab
    ___ENBDirectInformationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ENBDirectInformationTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ENBDirectInformationTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___ENBDirectInformationTransfer_protocolIEs__item__value._const_tab = ____ENBDirectInformationTransfer_protocolIEs__item__id_tab
    ___ENBDirectInformationTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ENBDirectInformationTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __ENBDirectInformationTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ENBDirectInformationTransfer_protocolIEs__item__id),
        (u'criticality', ___ENBDirectInformationTransfer_protocolIEs__item__criticality),
        (u'value', ___ENBDirectInformationTransfer_protocolIEs__item__value),
        ])
    __ENBDirectInformationTransfer_protocolIEs__item_._ext = None
    _ENBDirectInformationTransfer_protocolIEs._cont = __ENBDirectInformationTransfer_protocolIEs__item_
    _ENBDirectInformationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBDirectInformationTransfer._cont = ASN1Dict([
        (u'protocolIEs', _ENBDirectInformationTransfer_protocolIEs),
        ])
    ENBDirectInformationTransfer._ext = []
    
    #-----< ENBDirectInformationTransferIEs >-----#
    ENBDirectInformationTransferIEs = CLASS(name=u'ENBDirectInformationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ENBDirectInformationTransferIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Inter-SystemInformationTransferType')))
    ENBDirectInformationTransferIEs._val = ASN1Set(rv=[dict([(u'id', 121), (u'criticality', u'reject'), (u'Value', _ENBDirectInformationTransferIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Inter-SystemInformationTransferType >-----#
    Inter_SystemInformationTransferType = CHOICE(name=u'Inter-SystemInformationTransferType', mode=MODE_TYPE)
    _Inter_SystemInformationTransferType_rIMTransfer = SEQ(name=u'rIMTransfer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'RIMTransfer')))
    Inter_SystemInformationTransferType._cont = ASN1Dict([
        (u'rIMTransfer', _Inter_SystemInformationTransferType_rIMTransfer),
        ])
    Inter_SystemInformationTransferType._ext = []
    
    #-----< MMEDirectInformationTransfer >-----#
    MMEDirectInformationTransfer = SEQ(name=u'MMEDirectInformationTransfer', mode=MODE_TYPE)
    _MMEDirectInformationTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __MMEDirectInformationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___MMEDirectInformationTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____MMEDirectInformationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____MMEDirectInformationTransfer_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Inter-SystemInformationTransferType')))
    ____MMEDirectInformationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 122), (u'criticality', u'reject'), (u'Value', _____MMEDirectInformationTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___MMEDirectInformationTransfer_protocolIEs__item__id._const_tab = ____MMEDirectInformationTransfer_protocolIEs__item__id_tab
    ___MMEDirectInformationTransfer_protocolIEs__item__id._const_tab_at = None
    ___MMEDirectInformationTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___MMEDirectInformationTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___MMEDirectInformationTransfer_protocolIEs__item__criticality._const_tab = ____MMEDirectInformationTransfer_protocolIEs__item__id_tab
    ___MMEDirectInformationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MMEDirectInformationTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MMEDirectInformationTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___MMEDirectInformationTransfer_protocolIEs__item__value._const_tab = ____MMEDirectInformationTransfer_protocolIEs__item__id_tab
    ___MMEDirectInformationTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MMEDirectInformationTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __MMEDirectInformationTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MMEDirectInformationTransfer_protocolIEs__item__id),
        (u'criticality', ___MMEDirectInformationTransfer_protocolIEs__item__criticality),
        (u'value', ___MMEDirectInformationTransfer_protocolIEs__item__value),
        ])
    __MMEDirectInformationTransfer_protocolIEs__item_._ext = None
    _MMEDirectInformationTransfer_protocolIEs._cont = __MMEDirectInformationTransfer_protocolIEs__item_
    _MMEDirectInformationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MMEDirectInformationTransfer._cont = ASN1Dict([
        (u'protocolIEs', _MMEDirectInformationTransfer_protocolIEs),
        ])
    MMEDirectInformationTransfer._ext = []
    
    #-----< MMEDirectInformationTransferIEs >-----#
    MMEDirectInformationTransferIEs = CLASS(name=u'MMEDirectInformationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _MMEDirectInformationTransferIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Inter-SystemInformationTransferType')))
    MMEDirectInformationTransferIEs._val = ASN1Set(rv=[dict([(u'id', 122), (u'criticality', u'reject'), (u'Value', _MMEDirectInformationTransferIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ENBConfigurationTransfer >-----#
    ENBConfigurationTransfer = SEQ(name=u'ENBConfigurationTransfer', mode=MODE_TYPE)
    _ENBConfigurationTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ENBConfigurationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ENBConfigurationTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____ENBConfigurationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ENBConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SONConfigurationTransfer')))
    _____ENBConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EN-DCSONConfigurationTransfer')))
    _____ENBConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IntersystemSONConfigurationTransfer')))
    ____ENBConfigurationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 129), (u'criticality', u'ignore'), (u'Value', _____ENBConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 294), (u'criticality', u'ignore'), (u'Value', _____ENBConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 310), (u'criticality', u'ignore'), (u'Value', _____ENBConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ENBConfigurationTransfer_protocolIEs__item__id._const_tab = ____ENBConfigurationTransfer_protocolIEs__item__id_tab
    ___ENBConfigurationTransfer_protocolIEs__item__id._const_tab_at = None
    ___ENBConfigurationTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___ENBConfigurationTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___ENBConfigurationTransfer_protocolIEs__item__criticality._const_tab = ____ENBConfigurationTransfer_protocolIEs__item__id_tab
    ___ENBConfigurationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ENBConfigurationTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ENBConfigurationTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___ENBConfigurationTransfer_protocolIEs__item__value._const_tab = ____ENBConfigurationTransfer_protocolIEs__item__id_tab
    ___ENBConfigurationTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ENBConfigurationTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __ENBConfigurationTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ENBConfigurationTransfer_protocolIEs__item__id),
        (u'criticality', ___ENBConfigurationTransfer_protocolIEs__item__criticality),
        (u'value', ___ENBConfigurationTransfer_protocolIEs__item__value),
        ])
    __ENBConfigurationTransfer_protocolIEs__item_._ext = None
    _ENBConfigurationTransfer_protocolIEs._cont = __ENBConfigurationTransfer_protocolIEs__item_
    _ENBConfigurationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBConfigurationTransfer._cont = ASN1Dict([
        (u'protocolIEs', _ENBConfigurationTransfer_protocolIEs),
        ])
    ENBConfigurationTransfer._ext = []
    
    #-----< ENBConfigurationTransferIEs >-----#
    ENBConfigurationTransferIEs = CLASS(name=u'ENBConfigurationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ENBConfigurationTransferIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SONConfigurationTransfer')))
    _ENBConfigurationTransferIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EN-DCSONConfigurationTransfer')))
    _ENBConfigurationTransferIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IntersystemSONConfigurationTransfer')))
    ENBConfigurationTransferIEs._val = ASN1Set(rv=[dict([(u'id', 129), (u'criticality', u'ignore'), (u'Value', _ENBConfigurationTransferIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 294), (u'criticality', u'ignore'), (u'Value', _ENBConfigurationTransferIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 310), (u'criticality', u'ignore'), (u'Value', _ENBConfigurationTransferIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MMEConfigurationTransfer >-----#
    MMEConfigurationTransfer = SEQ(name=u'MMEConfigurationTransfer', mode=MODE_TYPE)
    _MMEConfigurationTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __MMEConfigurationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___MMEConfigurationTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____MMEConfigurationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____MMEConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SONConfigurationTransfer')))
    _____MMEConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EN-DCSONConfigurationTransfer')))
    _____MMEConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IntersystemSONConfigurationTransfer')))
    ____MMEConfigurationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 130), (u'criticality', u'ignore'), (u'Value', _____MMEConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 295), (u'criticality', u'ignore'), (u'Value', _____MMEConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 309), (u'criticality', u'ignore'), (u'Value', _____MMEConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MMEConfigurationTransfer_protocolIEs__item__id._const_tab = ____MMEConfigurationTransfer_protocolIEs__item__id_tab
    ___MMEConfigurationTransfer_protocolIEs__item__id._const_tab_at = None
    ___MMEConfigurationTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___MMEConfigurationTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___MMEConfigurationTransfer_protocolIEs__item__criticality._const_tab = ____MMEConfigurationTransfer_protocolIEs__item__id_tab
    ___MMEConfigurationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MMEConfigurationTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MMEConfigurationTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___MMEConfigurationTransfer_protocolIEs__item__value._const_tab = ____MMEConfigurationTransfer_protocolIEs__item__id_tab
    ___MMEConfigurationTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MMEConfigurationTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __MMEConfigurationTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MMEConfigurationTransfer_protocolIEs__item__id),
        (u'criticality', ___MMEConfigurationTransfer_protocolIEs__item__criticality),
        (u'value', ___MMEConfigurationTransfer_protocolIEs__item__value),
        ])
    __MMEConfigurationTransfer_protocolIEs__item_._ext = None
    _MMEConfigurationTransfer_protocolIEs._cont = __MMEConfigurationTransfer_protocolIEs__item_
    _MMEConfigurationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MMEConfigurationTransfer._cont = ASN1Dict([
        (u'protocolIEs', _MMEConfigurationTransfer_protocolIEs),
        ])
    MMEConfigurationTransfer._ext = []
    
    #-----< MMEConfigurationTransferIEs >-----#
    MMEConfigurationTransferIEs = CLASS(name=u'MMEConfigurationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _MMEConfigurationTransferIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SONConfigurationTransfer')))
    _MMEConfigurationTransferIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EN-DCSONConfigurationTransfer')))
    _MMEConfigurationTransferIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'IntersystemSONConfigurationTransfer')))
    MMEConfigurationTransferIEs._val = ASN1Set(rv=[dict([(u'id', 130), (u'criticality', u'ignore'), (u'Value', _MMEConfigurationTransferIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 295), (u'criticality', u'ignore'), (u'Value', _MMEConfigurationTransferIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 309), (u'criticality', u'ignore'), (u'Value', _MMEConfigurationTransferIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PrivateMessage >-----#
    PrivateMessage = SEQ(name=u'PrivateMessage', mode=MODE_TYPE)
    _PrivateMessage_privateIEs = SEQ_OF(name=u'privateIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'PrivateIE-Container')))
    __PrivateMessage_privateIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'PrivateIE-Field')))
    ___PrivateMessage_privateIEs__item__id = CHOICE(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PRIVATE-IES'), [u'id']))
    ____PrivateMessage_privateIEs__item__id_tab = CLASS(name='_tab_S1AP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__id._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__id._const_tab_at = None
    ___PrivateMessage_privateIEs__item__id._const_tab_id = u'id'
    ___PrivateMessage_privateIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PRIVATE-IES'), [u'criticality']))
    ____PrivateMessage_privateIEs__item__criticality_tab = CLASS(name='_tab_S1AP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__criticality._const_tab = ____PrivateMessage_privateIEs__item__criticality_tab
    ___PrivateMessage_privateIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PrivateMessage_privateIEs__item__criticality._const_tab_id = u'criticality'
    ___PrivateMessage_privateIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PRIVATE-IES'), [u'Value']))
    ____PrivateMessage_privateIEs__item__value_tab = CLASS(name='_tab_S1AP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__value._const_tab = ____PrivateMessage_privateIEs__item__value_tab
    ___PrivateMessage_privateIEs__item__value._const_tab_at = ('..', u'id')
    ___PrivateMessage_privateIEs__item__value._const_tab_id = u'Value'
    __PrivateMessage_privateIEs__item_._cont = ASN1Dict([
        (u'id', ___PrivateMessage_privateIEs__item__id),
        (u'criticality', ___PrivateMessage_privateIEs__item__criticality),
        (u'value', ___PrivateMessage_privateIEs__item__value),
        ])
    __PrivateMessage_privateIEs__item_._ext = None
    _PrivateMessage_privateIEs._cont = __PrivateMessage_privateIEs__item_
    _PrivateMessage_privateIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrivateMessage._cont = ASN1Dict([
        (u'privateIEs', _PrivateMessage_privateIEs),
        ])
    PrivateMessage._ext = []
    
    #-----< PrivateMessageIEs >-----#
    PrivateMessageIEs = CLASS(name=u'PrivateMessageIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PRIVATE-IES')))
    PrivateMessageIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< KillRequest >-----#
    KillRequest = SEQ(name=u'KillRequest', mode=MODE_TYPE)
    _KillRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __KillRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___KillRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____KillRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____KillRequest_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MessageIdentifier')))
    _____KillRequest_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SerialNumber')))
    _____KillRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningAreaList')))
    _____KillRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'KillAllWarningMessages')))
    ____KillRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _____KillRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _____KillRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 113), (u'criticality', u'ignore'), (u'Value', _____KillRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 191), (u'criticality', u'reject'), (u'Value', _____KillRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___KillRequest_protocolIEs__item__id._const_tab = ____KillRequest_protocolIEs__item__id_tab
    ___KillRequest_protocolIEs__item__id._const_tab_at = None
    ___KillRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___KillRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___KillRequest_protocolIEs__item__criticality._const_tab = ____KillRequest_protocolIEs__item__id_tab
    ___KillRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___KillRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___KillRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___KillRequest_protocolIEs__item__value._const_tab = ____KillRequest_protocolIEs__item__id_tab
    ___KillRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___KillRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __KillRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___KillRequest_protocolIEs__item__id),
        (u'criticality', ___KillRequest_protocolIEs__item__criticality),
        (u'value', ___KillRequest_protocolIEs__item__value),
        ])
    __KillRequest_protocolIEs__item_._ext = None
    _KillRequest_protocolIEs._cont = __KillRequest_protocolIEs__item_
    _KillRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    KillRequest._cont = ASN1Dict([
        (u'protocolIEs', _KillRequest_protocolIEs),
        ])
    KillRequest._ext = []
    
    #-----< KillRequestIEs >-----#
    KillRequestIEs = CLASS(name=u'KillRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _KillRequestIEs_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MessageIdentifier')))
    _KillRequestIEs_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SerialNumber')))
    _KillRequestIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'WarningAreaList')))
    _KillRequestIEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'KillAllWarningMessages')))
    KillRequestIEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _KillRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _KillRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 113), (u'criticality', u'ignore'), (u'Value', _KillRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 191), (u'criticality', u'reject'), (u'Value', _KillRequestIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< KillResponse >-----#
    KillResponse = SEQ(name=u'KillResponse', mode=MODE_TYPE)
    _KillResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __KillResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___KillResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____KillResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____KillResponse_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MessageIdentifier')))
    _____KillResponse_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SerialNumber')))
    _____KillResponse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BroadcastCancelledAreaList')))
    _____KillResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____KillResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _____KillResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _____KillResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 141), (u'criticality', u'ignore'), (u'Value', _____KillResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____KillResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___KillResponse_protocolIEs__item__id._const_tab = ____KillResponse_protocolIEs__item__id_tab
    ___KillResponse_protocolIEs__item__id._const_tab_at = None
    ___KillResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___KillResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___KillResponse_protocolIEs__item__criticality._const_tab = ____KillResponse_protocolIEs__item__id_tab
    ___KillResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___KillResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___KillResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___KillResponse_protocolIEs__item__value._const_tab = ____KillResponse_protocolIEs__item__id_tab
    ___KillResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___KillResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __KillResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___KillResponse_protocolIEs__item__id),
        (u'criticality', ___KillResponse_protocolIEs__item__criticality),
        (u'value', ___KillResponse_protocolIEs__item__value),
        ])
    __KillResponse_protocolIEs__item_._ext = None
    _KillResponse_protocolIEs._cont = __KillResponse_protocolIEs__item_
    _KillResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    KillResponse._cont = ASN1Dict([
        (u'protocolIEs', _KillResponse_protocolIEs),
        ])
    KillResponse._ext = []
    
    #-----< KillResponseIEs >-----#
    KillResponseIEs = CLASS(name=u'KillResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _KillResponseIEs_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MessageIdentifier')))
    _KillResponseIEs_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SerialNumber')))
    _KillResponseIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'BroadcastCancelledAreaList')))
    _KillResponseIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    KillResponseIEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _KillResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 112), (u'criticality', u'reject'), (u'Value', _KillResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 141), (u'criticality', u'ignore'), (u'Value', _KillResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _KillResponseIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PWSRestartIndication >-----#
    PWSRestartIndication = SEQ(name=u'PWSRestartIndication', mode=MODE_TYPE)
    _PWSRestartIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __PWSRestartIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___PWSRestartIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____PWSRestartIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ECGIListForRestart')))
    _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAIListForRestart')))
    _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaIDListForRestart')))
    ____PWSRestartIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 182), (u'criticality', u'reject'), (u'Value', _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 59), (u'criticality', u'reject'), (u'Value', _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 188), (u'criticality', u'reject'), (u'Value', _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 190), (u'criticality', u'reject'), (u'Value', _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PWSRestartIndication_protocolIEs__item__id._const_tab = ____PWSRestartIndication_protocolIEs__item__id_tab
    ___PWSRestartIndication_protocolIEs__item__id._const_tab_at = None
    ___PWSRestartIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___PWSRestartIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___PWSRestartIndication_protocolIEs__item__criticality._const_tab = ____PWSRestartIndication_protocolIEs__item__id_tab
    ___PWSRestartIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PWSRestartIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PWSRestartIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___PWSRestartIndication_protocolIEs__item__value._const_tab = ____PWSRestartIndication_protocolIEs__item__id_tab
    ___PWSRestartIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PWSRestartIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __PWSRestartIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PWSRestartIndication_protocolIEs__item__id),
        (u'criticality', ___PWSRestartIndication_protocolIEs__item__criticality),
        (u'value', ___PWSRestartIndication_protocolIEs__item__value),
        ])
    __PWSRestartIndication_protocolIEs__item_._ext = None
    _PWSRestartIndication_protocolIEs._cont = __PWSRestartIndication_protocolIEs__item_
    _PWSRestartIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PWSRestartIndication._cont = ASN1Dict([
        (u'protocolIEs', _PWSRestartIndication_protocolIEs),
        ])
    PWSRestartIndication._ext = []
    
    #-----< PWSRestartIndicationIEs >-----#
    PWSRestartIndicationIEs = CLASS(name=u'PWSRestartIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _PWSRestartIndicationIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ECGIListForRestart')))
    _PWSRestartIndicationIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    _PWSRestartIndicationIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAIListForRestart')))
    _PWSRestartIndicationIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EmergencyAreaIDListForRestart')))
    PWSRestartIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 182), (u'criticality', u'reject'), (u'Value', _PWSRestartIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 59), (u'criticality', u'reject'), (u'Value', _PWSRestartIndicationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 188), (u'criticality', u'reject'), (u'Value', _PWSRestartIndicationIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 190), (u'criticality', u'reject'), (u'Value', _PWSRestartIndicationIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PWSFailureIndication >-----#
    PWSFailureIndication = SEQ(name=u'PWSFailureIndication', mode=MODE_TYPE)
    _PWSFailureIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __PWSFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___PWSFailureIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____PWSFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PWSfailedECGIList')))
    _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    ____PWSFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 222), (u'criticality', u'reject'), (u'Value', _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 59), (u'criticality', u'reject'), (u'Value', _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___PWSFailureIndication_protocolIEs__item__id._const_tab = ____PWSFailureIndication_protocolIEs__item__id_tab
    ___PWSFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___PWSFailureIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___PWSFailureIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___PWSFailureIndication_protocolIEs__item__criticality._const_tab = ____PWSFailureIndication_protocolIEs__item__id_tab
    ___PWSFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PWSFailureIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PWSFailureIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___PWSFailureIndication_protocolIEs__item__value._const_tab = ____PWSFailureIndication_protocolIEs__item__id_tab
    ___PWSFailureIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PWSFailureIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __PWSFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PWSFailureIndication_protocolIEs__item__id),
        (u'criticality', ___PWSFailureIndication_protocolIEs__item__criticality),
        (u'value', ___PWSFailureIndication_protocolIEs__item__value),
        ])
    __PWSFailureIndication_protocolIEs__item_._ext = None
    _PWSFailureIndication_protocolIEs._cont = __PWSFailureIndication_protocolIEs__item_
    _PWSFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    PWSFailureIndication._cont = ASN1Dict([
        (u'protocolIEs', _PWSFailureIndication_protocolIEs),
        ])
    PWSFailureIndication._ext = []
    
    #-----< PWSFailureIndicationIEs >-----#
    PWSFailureIndicationIEs = CLASS(name=u'PWSFailureIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _PWSFailureIndicationIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PWSfailedECGIList')))
    _PWSFailureIndicationIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Global-ENB-ID')))
    PWSFailureIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 222), (u'criticality', u'reject'), (u'Value', _PWSFailureIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 59), (u'criticality', u'reject'), (u'Value', _PWSFailureIndicationIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkUEAssociatedLPPaTransport >-----#
    DownlinkUEAssociatedLPPaTransport = SEQ(name=u'DownlinkUEAssociatedLPPaTransport', mode=MODE_TYPE)
    _DownlinkUEAssociatedLPPaTransport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __DownlinkUEAssociatedLPPaTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Routing-ID')))
    _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LPPa-PDU')))
    ____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 148), (u'criticality', u'reject'), (u'Value', _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 147), (u'criticality', u'reject'), (u'Value', _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab = ____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab_at = None
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab_id = u'id'
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab = ____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab = ____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab_id = u'Value'
    __DownlinkUEAssociatedLPPaTransport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id),
        (u'criticality', ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__criticality),
        (u'value', ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__value),
        ])
    __DownlinkUEAssociatedLPPaTransport_protocolIEs__item_._ext = None
    _DownlinkUEAssociatedLPPaTransport_protocolIEs._cont = __DownlinkUEAssociatedLPPaTransport_protocolIEs__item_
    _DownlinkUEAssociatedLPPaTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkUEAssociatedLPPaTransport._cont = ASN1Dict([
        (u'protocolIEs', _DownlinkUEAssociatedLPPaTransport_protocolIEs),
        ])
    DownlinkUEAssociatedLPPaTransport._ext = []
    
    #-----< DownlinkUEAssociatedLPPaTransport-IEs >-----#
    DownlinkUEAssociatedLPPaTransport_IEs = CLASS(name=u'DownlinkUEAssociatedLPPaTransport-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Routing-ID')))
    _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LPPa-PDU')))
    DownlinkUEAssociatedLPPaTransport_IEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 148), (u'criticality', u'reject'), (u'Value', _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 147), (u'criticality', u'reject'), (u'Value', _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UplinkUEAssociatedLPPaTransport >-----#
    UplinkUEAssociatedLPPaTransport = SEQ(name=u'UplinkUEAssociatedLPPaTransport', mode=MODE_TYPE)
    _UplinkUEAssociatedLPPaTransport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UplinkUEAssociatedLPPaTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Routing-ID')))
    _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LPPa-PDU')))
    ____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 148), (u'criticality', u'reject'), (u'Value', _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 147), (u'criticality', u'reject'), (u'Value', _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab = ____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab_at = None
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab_id = u'id'
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab = ____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab = ____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab_id = u'Value'
    __UplinkUEAssociatedLPPaTransport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__id),
        (u'criticality', ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__criticality),
        (u'value', ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__value),
        ])
    __UplinkUEAssociatedLPPaTransport_protocolIEs__item_._ext = None
    _UplinkUEAssociatedLPPaTransport_protocolIEs._cont = __UplinkUEAssociatedLPPaTransport_protocolIEs__item_
    _UplinkUEAssociatedLPPaTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkUEAssociatedLPPaTransport._cont = ASN1Dict([
        (u'protocolIEs', _UplinkUEAssociatedLPPaTransport_protocolIEs),
        ])
    UplinkUEAssociatedLPPaTransport._ext = []
    
    #-----< UplinkUEAssociatedLPPaTransport-IEs >-----#
    UplinkUEAssociatedLPPaTransport_IEs = CLASS(name=u'UplinkUEAssociatedLPPaTransport-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UplinkUEAssociatedLPPaTransport_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UplinkUEAssociatedLPPaTransport_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UplinkUEAssociatedLPPaTransport_IEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Routing-ID')))
    _UplinkUEAssociatedLPPaTransport_IEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LPPa-PDU')))
    UplinkUEAssociatedLPPaTransport_IEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _UplinkUEAssociatedLPPaTransport_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _UplinkUEAssociatedLPPaTransport_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 148), (u'criticality', u'reject'), (u'Value', _UplinkUEAssociatedLPPaTransport_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 147), (u'criticality', u'reject'), (u'Value', _UplinkUEAssociatedLPPaTransport_IEs_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkNonUEAssociatedLPPaTransport >-----#
    DownlinkNonUEAssociatedLPPaTransport = SEQ(name=u'DownlinkNonUEAssociatedLPPaTransport', mode=MODE_TYPE)
    _DownlinkNonUEAssociatedLPPaTransport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Routing-ID')))
    _____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LPPa-PDU')))
    ____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 148), (u'criticality', u'reject'), (u'Value', _____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 147), (u'criticality', u'reject'), (u'Value', _____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab = ____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab_at = None
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab_id = u'id'
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab = ____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab = ____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab_id = u'Value'
    __DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id),
        (u'criticality', ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality),
        (u'value', ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__value),
        ])
    __DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item_._ext = None
    _DownlinkNonUEAssociatedLPPaTransport_protocolIEs._cont = __DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item_
    _DownlinkNonUEAssociatedLPPaTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DownlinkNonUEAssociatedLPPaTransport._cont = ASN1Dict([
        (u'protocolIEs', _DownlinkNonUEAssociatedLPPaTransport_protocolIEs),
        ])
    DownlinkNonUEAssociatedLPPaTransport._ext = []
    
    #-----< DownlinkNonUEAssociatedLPPaTransport-IEs >-----#
    DownlinkNonUEAssociatedLPPaTransport_IEs = CLASS(name=u'DownlinkNonUEAssociatedLPPaTransport-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _DownlinkNonUEAssociatedLPPaTransport_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Routing-ID')))
    _DownlinkNonUEAssociatedLPPaTransport_IEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LPPa-PDU')))
    DownlinkNonUEAssociatedLPPaTransport_IEs._val = ASN1Set(rv=[dict([(u'id', 148), (u'criticality', u'reject'), (u'Value', _DownlinkNonUEAssociatedLPPaTransport_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 147), (u'criticality', u'reject'), (u'Value', _DownlinkNonUEAssociatedLPPaTransport_IEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UplinkNonUEAssociatedLPPaTransport >-----#
    UplinkNonUEAssociatedLPPaTransport = SEQ(name=u'UplinkNonUEAssociatedLPPaTransport', mode=MODE_TYPE)
    _UplinkNonUEAssociatedLPPaTransport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UplinkNonUEAssociatedLPPaTransport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Routing-ID')))
    _____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LPPa-PDU')))
    ____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 148), (u'criticality', u'reject'), (u'Value', _____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 147), (u'criticality', u'reject'), (u'Value', _____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab = ____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab_at = None
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id._const_tab_id = u'id'
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab = ____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab = ____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__value._const_tab_id = u'Value'
    __UplinkNonUEAssociatedLPPaTransport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id),
        (u'criticality', ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality),
        (u'value', ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__value),
        ])
    __UplinkNonUEAssociatedLPPaTransport_protocolIEs__item_._ext = None
    _UplinkNonUEAssociatedLPPaTransport_protocolIEs._cont = __UplinkNonUEAssociatedLPPaTransport_protocolIEs__item_
    _UplinkNonUEAssociatedLPPaTransport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UplinkNonUEAssociatedLPPaTransport._cont = ASN1Dict([
        (u'protocolIEs', _UplinkNonUEAssociatedLPPaTransport_protocolIEs),
        ])
    UplinkNonUEAssociatedLPPaTransport._ext = []
    
    #-----< UplinkNonUEAssociatedLPPaTransport-IEs >-----#
    UplinkNonUEAssociatedLPPaTransport_IEs = CLASS(name=u'UplinkNonUEAssociatedLPPaTransport-IEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UplinkNonUEAssociatedLPPaTransport_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Routing-ID')))
    _UplinkNonUEAssociatedLPPaTransport_IEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'LPPa-PDU')))
    UplinkNonUEAssociatedLPPaTransport_IEs._val = ASN1Set(rv=[dict([(u'id', 148), (u'criticality', u'reject'), (u'Value', _UplinkNonUEAssociatedLPPaTransport_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 147), (u'criticality', u'reject'), (u'Value', _UplinkNonUEAssociatedLPPaTransport_IEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABModificationIndication >-----#
    E_RABModificationIndication = SEQ(name=u'E-RABModificationIndication', mode=MODE_TYPE)
    _E_RABModificationIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __E_RABModificationIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___E_RABModificationIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____E_RABModificationIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeModifiedListBearerModInd')))
    _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABNotToBeModifiedListBearerModInd')))
    _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'CSGMembershipInfo')))
    _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TunnelInformation')))
    _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    ____E_RABModificationIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 199), (u'criticality', u'reject'), (u'Value', _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 201), (u'criticality', u'reject'), (u'Value', _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 226), (u'criticality', u'reject'), (u'Value', _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 176), (u'criticality', u'ignore'), (u'Value', _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'ignore'), (u'Value', _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 189), (u'criticality', u'ignore'), (u'Value', _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABModificationIndication_protocolIEs__item__id._const_tab = ____E_RABModificationIndication_protocolIEs__item__id_tab
    ___E_RABModificationIndication_protocolIEs__item__id._const_tab_at = None
    ___E_RABModificationIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___E_RABModificationIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___E_RABModificationIndication_protocolIEs__item__criticality._const_tab = ____E_RABModificationIndication_protocolIEs__item__id_tab
    ___E_RABModificationIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABModificationIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___E_RABModificationIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___E_RABModificationIndication_protocolIEs__item__value._const_tab = ____E_RABModificationIndication_protocolIEs__item__id_tab
    ___E_RABModificationIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___E_RABModificationIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __E_RABModificationIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___E_RABModificationIndication_protocolIEs__item__id),
        (u'criticality', ___E_RABModificationIndication_protocolIEs__item__criticality),
        (u'value', ___E_RABModificationIndication_protocolIEs__item__value),
        ])
    __E_RABModificationIndication_protocolIEs__item_._ext = None
    _E_RABModificationIndication_protocolIEs._cont = __E_RABModificationIndication_protocolIEs__item_
    _E_RABModificationIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_RABModificationIndication._cont = ASN1Dict([
        (u'protocolIEs', _E_RABModificationIndication_protocolIEs),
        ])
    E_RABModificationIndication._ext = []
    
    #-----< E-RABModificationIndicationIEs >-----#
    E_RABModificationIndicationIEs = CLASS(name=u'E-RABModificationIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABModificationIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _E_RABModificationIndicationIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _E_RABModificationIndicationIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeModifiedListBearerModInd')))
    _E_RABModificationIndicationIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABNotToBeModifiedListBearerModInd')))
    _E_RABModificationIndicationIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'CSGMembershipInfo')))
    _E_RABModificationIndicationIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TunnelInformation')))
    _E_RABModificationIndicationIEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    _E_RABModificationIndicationIEs_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    E_RABModificationIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _E_RABModificationIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _E_RABModificationIndicationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 199), (u'criticality', u'reject'), (u'Value', _E_RABModificationIndicationIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 201), (u'criticality', u'reject'), (u'Value', _E_RABModificationIndicationIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 226), (u'criticality', u'reject'), (u'Value', _E_RABModificationIndicationIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 176), (u'criticality', u'ignore'), (u'Value', _E_RABModificationIndicationIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'ignore'), (u'Value', _E_RABModificationIndicationIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 189), (u'criticality', u'ignore'), (u'Value', _E_RABModificationIndicationIEs_val_Value_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeModifiedListBearerModInd >-----#
    E_RABToBeModifiedListBearerModInd = SEQ_OF(name=u'E-RABToBeModifiedListBearerModInd', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RAB-IE-ContainerList')))
    _E_RABToBeModifiedListBearerModInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABToBeModifiedListBearerModInd__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___E_RABToBeModifiedListBearerModInd__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABToBeModifiedListBearerModInd__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeModifiedItemBearerModInd')))
    ___E_RABToBeModifiedListBearerModInd__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 200), (u'criticality', u'reject'), (u'Value', ____E_RABToBeModifiedListBearerModInd__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABToBeModifiedListBearerModInd__item__id._const_tab = ___E_RABToBeModifiedListBearerModInd__item__id_tab
    __E_RABToBeModifiedListBearerModInd__item__id._const_tab_at = None
    __E_RABToBeModifiedListBearerModInd__item__id._const_tab_id = u'id'
    __E_RABToBeModifiedListBearerModInd__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABToBeModifiedListBearerModInd__item__criticality._const_tab = ___E_RABToBeModifiedListBearerModInd__item__id_tab
    __E_RABToBeModifiedListBearerModInd__item__criticality._const_tab_at = ('..', u'id')
    __E_RABToBeModifiedListBearerModInd__item__criticality._const_tab_id = u'criticality'
    __E_RABToBeModifiedListBearerModInd__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __E_RABToBeModifiedListBearerModInd__item__value._const_tab = ___E_RABToBeModifiedListBearerModInd__item__id_tab
    __E_RABToBeModifiedListBearerModInd__item__value._const_tab_at = ('..', u'id')
    __E_RABToBeModifiedListBearerModInd__item__value._const_tab_id = u'Value'
    _E_RABToBeModifiedListBearerModInd__item_._cont = ASN1Dict([
        (u'id', __E_RABToBeModifiedListBearerModInd__item__id),
        (u'criticality', __E_RABToBeModifiedListBearerModInd__item__criticality),
        (u'value', __E_RABToBeModifiedListBearerModInd__item__value),
        ])
    _E_RABToBeModifiedListBearerModInd__item_._ext = None
    E_RABToBeModifiedListBearerModInd._cont = _E_RABToBeModifiedListBearerModInd__item_
    E_RABToBeModifiedListBearerModInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABToBeModifiedItemBearerModIndIEs >-----#
    E_RABToBeModifiedItemBearerModIndIEs = CLASS(name=u'E-RABToBeModifiedItemBearerModIndIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABToBeModifiedItemBearerModIndIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABToBeModifiedItemBearerModInd')))
    E_RABToBeModifiedItemBearerModIndIEs._val = ASN1Set(rv=[dict([(u'id', 200), (u'criticality', u'reject'), (u'Value', _E_RABToBeModifiedItemBearerModIndIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABToBeModifiedItemBearerModInd >-----#
    E_RABToBeModifiedItemBearerModInd = SEQ(name=u'E-RABToBeModifiedItemBearerModInd', mode=MODE_TYPE)
    _E_RABToBeModifiedItemBearerModInd_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABToBeModifiedItemBearerModInd_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABToBeModifiedItemBearerModInd_dL_GTP_TEID = OCT_STR(name=u'dL-GTP-TEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    _E_RABToBeModifiedItemBearerModInd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABToBeModifiedItemBearerModInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__id._const_tab = ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__id_tab
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__id._const_tab_at = None
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__criticality._const_tab = ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__criticality_tab
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue._const_tab = ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue_tab
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABToBeModifiedItemBearerModInd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__id),
        (u'criticality', ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue),
        ])
    __E_RABToBeModifiedItemBearerModInd_iE_Extensions__item_._ext = None
    _E_RABToBeModifiedItemBearerModInd_iE_Extensions._cont = __E_RABToBeModifiedItemBearerModInd_iE_Extensions__item_
    _E_RABToBeModifiedItemBearerModInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABToBeModifiedItemBearerModInd._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABToBeModifiedItemBearerModInd_e_RAB_ID),
        (u'transportLayerAddress', _E_RABToBeModifiedItemBearerModInd_transportLayerAddress),
        (u'dL-GTP-TEID', _E_RABToBeModifiedItemBearerModInd_dL_GTP_TEID),
        (u'iE-Extensions', _E_RABToBeModifiedItemBearerModInd_iE_Extensions),
        ])
    E_RABToBeModifiedItemBearerModInd._ext = []
    
    #-----< E-RABToBeModifiedItemBearerModInd-ExtIEs >-----#
    E_RABToBeModifiedItemBearerModInd_ExtIEs = CLASS(name=u'E-RABToBeModifiedItemBearerModInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABToBeModifiedItemBearerModInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABNotToBeModifiedListBearerModInd >-----#
    E_RABNotToBeModifiedListBearerModInd = SEQ_OF(name=u'E-RABNotToBeModifiedListBearerModInd', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RAB-IE-ContainerList')))
    _E_RABNotToBeModifiedListBearerModInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABNotToBeModifiedListBearerModInd__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___E_RABNotToBeModifiedListBearerModInd__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABNotToBeModifiedListBearerModInd__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABNotToBeModifiedItemBearerModInd')))
    ___E_RABNotToBeModifiedListBearerModInd__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 202), (u'criticality', u'reject'), (u'Value', ____E_RABNotToBeModifiedListBearerModInd__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABNotToBeModifiedListBearerModInd__item__id._const_tab = ___E_RABNotToBeModifiedListBearerModInd__item__id_tab
    __E_RABNotToBeModifiedListBearerModInd__item__id._const_tab_at = None
    __E_RABNotToBeModifiedListBearerModInd__item__id._const_tab_id = u'id'
    __E_RABNotToBeModifiedListBearerModInd__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABNotToBeModifiedListBearerModInd__item__criticality._const_tab = ___E_RABNotToBeModifiedListBearerModInd__item__id_tab
    __E_RABNotToBeModifiedListBearerModInd__item__criticality._const_tab_at = ('..', u'id')
    __E_RABNotToBeModifiedListBearerModInd__item__criticality._const_tab_id = u'criticality'
    __E_RABNotToBeModifiedListBearerModInd__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __E_RABNotToBeModifiedListBearerModInd__item__value._const_tab = ___E_RABNotToBeModifiedListBearerModInd__item__id_tab
    __E_RABNotToBeModifiedListBearerModInd__item__value._const_tab_at = ('..', u'id')
    __E_RABNotToBeModifiedListBearerModInd__item__value._const_tab_id = u'Value'
    _E_RABNotToBeModifiedListBearerModInd__item_._cont = ASN1Dict([
        (u'id', __E_RABNotToBeModifiedListBearerModInd__item__id),
        (u'criticality', __E_RABNotToBeModifiedListBearerModInd__item__criticality),
        (u'value', __E_RABNotToBeModifiedListBearerModInd__item__value),
        ])
    _E_RABNotToBeModifiedListBearerModInd__item_._ext = None
    E_RABNotToBeModifiedListBearerModInd._cont = _E_RABNotToBeModifiedListBearerModInd__item_
    E_RABNotToBeModifiedListBearerModInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABNotToBeModifiedItemBearerModIndIEs >-----#
    E_RABNotToBeModifiedItemBearerModIndIEs = CLASS(name=u'E-RABNotToBeModifiedItemBearerModIndIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABNotToBeModifiedItemBearerModIndIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABNotToBeModifiedItemBearerModInd')))
    E_RABNotToBeModifiedItemBearerModIndIEs._val = ASN1Set(rv=[dict([(u'id', 202), (u'criticality', u'reject'), (u'Value', _E_RABNotToBeModifiedItemBearerModIndIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABNotToBeModifiedItemBearerModInd >-----#
    E_RABNotToBeModifiedItemBearerModInd = SEQ(name=u'E-RABNotToBeModifiedItemBearerModInd', mode=MODE_TYPE)
    _E_RABNotToBeModifiedItemBearerModInd_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABNotToBeModifiedItemBearerModInd_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'TransportLayerAddress')))
    _E_RABNotToBeModifiedItemBearerModInd_dL_GTP_TEID = OCT_STR(name=u'dL-GTP-TEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'GTP-TEID')))
    _E_RABNotToBeModifiedItemBearerModInd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__id._const_tab = ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__id_tab
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__id._const_tab_at = None
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__criticality._const_tab = ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__criticality_tab
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue._const_tab = ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue_tab
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__id),
        (u'criticality', ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue),
        ])
    __E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item_._ext = None
    _E_RABNotToBeModifiedItemBearerModInd_iE_Extensions._cont = __E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item_
    _E_RABNotToBeModifiedItemBearerModInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABNotToBeModifiedItemBearerModInd._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABNotToBeModifiedItemBearerModInd_e_RAB_ID),
        (u'transportLayerAddress', _E_RABNotToBeModifiedItemBearerModInd_transportLayerAddress),
        (u'dL-GTP-TEID', _E_RABNotToBeModifiedItemBearerModInd_dL_GTP_TEID),
        (u'iE-Extensions', _E_RABNotToBeModifiedItemBearerModInd_iE_Extensions),
        ])
    E_RABNotToBeModifiedItemBearerModInd._ext = []
    
    #-----< E-RABNotToBeModifiedItemBearerModInd-ExtIEs >-----#
    E_RABNotToBeModifiedItemBearerModInd_ExtIEs = CLASS(name=u'E-RABNotToBeModifiedItemBearerModInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABNotToBeModifiedItemBearerModInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CSGMembershipInfo >-----#
    CSGMembershipInfo = SEQ(name=u'CSGMembershipInfo', mode=MODE_TYPE)
    _CSGMembershipInfo_cSGMembershipStatus = ENUM(name=u'cSGMembershipStatus', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _CSGMembershipInfo_cSG_Id = BIT_STR(name=u'cSG-Id', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CSG-Id')))
    _CSGMembershipInfo_cellAccessMode = ENUM(name=u'cellAccessMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'CellAccessMode')), opt=True)
    _CSGMembershipInfo_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'PLMNidentity')), opt=True)
    _CSGMembershipInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CSGMembershipInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___CSGMembershipInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____CSGMembershipInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CSGMembershipInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSGMembershipInfo_iE_Extensions__item__id._const_tab = ____CSGMembershipInfo_iE_Extensions__item__id_tab
    ___CSGMembershipInfo_iE_Extensions__item__id._const_tab_at = None
    ___CSGMembershipInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___CSGMembershipInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CSGMembershipInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CSGMembershipInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSGMembershipInfo_iE_Extensions__item__criticality._const_tab = ____CSGMembershipInfo_iE_Extensions__item__criticality_tab
    ___CSGMembershipInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CSGMembershipInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CSGMembershipInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CSGMembershipInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____CSGMembershipInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CSGMembershipInfo_iE_Extensions__item__extensionValue._const_tab = ____CSGMembershipInfo_iE_Extensions__item__extensionValue_tab
    ___CSGMembershipInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CSGMembershipInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CSGMembershipInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CSGMembershipInfo_iE_Extensions__item__id),
        (u'criticality', ___CSGMembershipInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___CSGMembershipInfo_iE_Extensions__item__extensionValue),
        ])
    __CSGMembershipInfo_iE_Extensions__item_._ext = None
    _CSGMembershipInfo_iE_Extensions._cont = __CSGMembershipInfo_iE_Extensions__item_
    _CSGMembershipInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CSGMembershipInfo._cont = ASN1Dict([
        (u'cSGMembershipStatus', _CSGMembershipInfo_cSGMembershipStatus),
        (u'cSG-Id', _CSGMembershipInfo_cSG_Id),
        (u'cellAccessMode', _CSGMembershipInfo_cellAccessMode),
        (u'pLMNidentity', _CSGMembershipInfo_pLMNidentity),
        (u'iE-Extensions', _CSGMembershipInfo_iE_Extensions),
        ])
    CSGMembershipInfo._ext = []
    
    #-----< CSGMembershipInfo-ExtIEs >-----#
    CSGMembershipInfo_ExtIEs = CLASS(name=u'CSGMembershipInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    CSGMembershipInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABModificationConfirm >-----#
    E_RABModificationConfirm = SEQ(name=u'E-RABModificationConfirm', mode=MODE_TYPE)
    _E_RABModificationConfirm_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __E_RABModificationConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___E_RABModificationConfirm_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____E_RABModificationConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyListBearerModConf')))
    _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    ____E_RABModificationConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 203), (u'criticality', u'ignore'), (u'Value', _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 205), (u'criticality', u'ignore'), (u'Value', _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 210), (u'criticality', u'ignore'), (u'Value', _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABModificationConfirm_protocolIEs__item__id._const_tab = ____E_RABModificationConfirm_protocolIEs__item__id_tab
    ___E_RABModificationConfirm_protocolIEs__item__id._const_tab_at = None
    ___E_RABModificationConfirm_protocolIEs__item__id._const_tab_id = u'id'
    ___E_RABModificationConfirm_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___E_RABModificationConfirm_protocolIEs__item__criticality._const_tab = ____E_RABModificationConfirm_protocolIEs__item__id_tab
    ___E_RABModificationConfirm_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABModificationConfirm_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___E_RABModificationConfirm_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___E_RABModificationConfirm_protocolIEs__item__value._const_tab = ____E_RABModificationConfirm_protocolIEs__item__id_tab
    ___E_RABModificationConfirm_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___E_RABModificationConfirm_protocolIEs__item__value._const_tab_id = u'Value'
    __E_RABModificationConfirm_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___E_RABModificationConfirm_protocolIEs__item__id),
        (u'criticality', ___E_RABModificationConfirm_protocolIEs__item__criticality),
        (u'value', ___E_RABModificationConfirm_protocolIEs__item__value),
        ])
    __E_RABModificationConfirm_protocolIEs__item_._ext = None
    _E_RABModificationConfirm_protocolIEs._cont = __E_RABModificationConfirm_protocolIEs__item_
    _E_RABModificationConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    E_RABModificationConfirm._cont = ASN1Dict([
        (u'protocolIEs', _E_RABModificationConfirm_protocolIEs),
        ])
    E_RABModificationConfirm._ext = []
    
    #-----< E-RABModificationConfirmIEs >-----#
    E_RABModificationConfirmIEs = CLASS(name=u'E-RABModificationConfirmIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABModificationConfirmIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _E_RABModificationConfirmIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _E_RABModificationConfirmIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyListBearerModConf')))
    _E_RABModificationConfirmIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _E_RABModificationConfirmIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABList')))
    _E_RABModificationConfirmIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _E_RABModificationConfirmIEs_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    E_RABModificationConfirmIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _E_RABModificationConfirmIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _E_RABModificationConfirmIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 203), (u'criticality', u'ignore'), (u'Value', _E_RABModificationConfirmIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 205), (u'criticality', u'ignore'), (u'Value', _E_RABModificationConfirmIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 210), (u'criticality', u'ignore'), (u'Value', _E_RABModificationConfirmIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _E_RABModificationConfirmIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', _E_RABModificationConfirmIEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABModifyListBearerModConf >-----#
    E_RABModifyListBearerModConf = SEQ_OF(name=u'E-RABModifyListBearerModConf', mode=MODE_TYPE)
    _E_RABModifyListBearerModConf__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABModifyListBearerModConf__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___E_RABModifyListBearerModConf__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABModifyListBearerModConf__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyItemBearerModConf')))
    ___E_RABModifyListBearerModConf__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 204), (u'criticality', u'ignore'), (u'Value', ____E_RABModifyListBearerModConf__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABModifyListBearerModConf__item__id._const_tab = ___E_RABModifyListBearerModConf__item__id_tab
    __E_RABModifyListBearerModConf__item__id._const_tab_at = None
    __E_RABModifyListBearerModConf__item__id._const_tab_id = u'id'
    __E_RABModifyListBearerModConf__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABModifyListBearerModConf__item__criticality._const_tab = ___E_RABModifyListBearerModConf__item__id_tab
    __E_RABModifyListBearerModConf__item__criticality._const_tab_at = ('..', u'id')
    __E_RABModifyListBearerModConf__item__criticality._const_tab_id = u'criticality'
    __E_RABModifyListBearerModConf__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __E_RABModifyListBearerModConf__item__value._const_tab = ___E_RABModifyListBearerModConf__item__id_tab
    __E_RABModifyListBearerModConf__item__value._const_tab_at = ('..', u'id')
    __E_RABModifyListBearerModConf__item__value._const_tab_id = u'Value'
    _E_RABModifyListBearerModConf__item_._cont = ASN1Dict([
        (u'id', __E_RABModifyListBearerModConf__item__id),
        (u'criticality', __E_RABModifyListBearerModConf__item__criticality),
        (u'value', __E_RABModifyListBearerModConf__item__value),
        ])
    _E_RABModifyListBearerModConf__item_._ext = None
    E_RABModifyListBearerModConf._cont = _E_RABModifyListBearerModConf__item_
    E_RABModifyListBearerModConf._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABModifyItemBearerModConfIEs >-----#
    E_RABModifyItemBearerModConfIEs = CLASS(name=u'E-RABModifyItemBearerModConfIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABModifyItemBearerModConfIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyItemBearerModConf')))
    E_RABModifyItemBearerModConfIEs._val = ASN1Set(rv=[dict([(u'id', 204), (u'criticality', u'ignore'), (u'Value', _E_RABModifyItemBearerModConfIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABModifyItemBearerModConf >-----#
    E_RABModifyItemBearerModConf = SEQ(name=u'E-RABModifyItemBearerModConf', mode=MODE_TYPE)
    _E_RABModifyItemBearerModConf_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABModifyItemBearerModConf_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABModifyItemBearerModConf_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABModifyItemBearerModConf_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABModifyItemBearerModConf_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__id._const_tab = ____E_RABModifyItemBearerModConf_iE_Extensions__item__id_tab
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__id._const_tab_at = None
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABModifyItemBearerModConf_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABModifyItemBearerModConf_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__criticality._const_tab = ____E_RABModifyItemBearerModConf_iE_Extensions__item__criticality_tab
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABModifyItemBearerModConf_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABModifyItemBearerModConf_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__extensionValue._const_tab = ____E_RABModifyItemBearerModConf_iE_Extensions__item__extensionValue_tab
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABModifyItemBearerModConf_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABModifyItemBearerModConf_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABModifyItemBearerModConf_iE_Extensions__item__id),
        (u'criticality', ___E_RABModifyItemBearerModConf_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABModifyItemBearerModConf_iE_Extensions__item__extensionValue),
        ])
    __E_RABModifyItemBearerModConf_iE_Extensions__item_._ext = None
    _E_RABModifyItemBearerModConf_iE_Extensions._cont = __E_RABModifyItemBearerModConf_iE_Extensions__item_
    _E_RABModifyItemBearerModConf_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABModifyItemBearerModConf._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABModifyItemBearerModConf_e_RAB_ID),
        (u'iE-Extensions', _E_RABModifyItemBearerModConf_iE_Extensions),
        ])
    E_RABModifyItemBearerModConf._ext = []
    
    #-----< E-RABModifyItemBearerModConfExtIEs >-----#
    E_RABModifyItemBearerModConfExtIEs = CLASS(name=u'E-RABModifyItemBearerModConfExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABModifyItemBearerModConfExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationIndication >-----#
    UEContextModificationIndication = SEQ(name=u'UEContextModificationIndication', mode=MODE_TYPE)
    _UEContextModificationIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextModificationIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextModificationIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextModificationIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextModificationIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'CSGMembershipInfo')))
    ____UEContextModificationIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____UEContextModificationIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____UEContextModificationIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 226), (u'criticality', u'reject'), (u'Value', _____UEContextModificationIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationIndication_protocolIEs__item__id._const_tab = ____UEContextModificationIndication_protocolIEs__item__id_tab
    ___UEContextModificationIndication_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextModificationIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextModificationIndication_protocolIEs__item__criticality._const_tab = ____UEContextModificationIndication_protocolIEs__item__id_tab
    ___UEContextModificationIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextModificationIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextModificationIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextModificationIndication_protocolIEs__item__value._const_tab = ____UEContextModificationIndication_protocolIEs__item__id_tab
    ___UEContextModificationIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextModificationIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextModificationIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextModificationIndication_protocolIEs__item__id),
        (u'criticality', ___UEContextModificationIndication_protocolIEs__item__criticality),
        (u'value', ___UEContextModificationIndication_protocolIEs__item__value),
        ])
    __UEContextModificationIndication_protocolIEs__item_._ext = None
    _UEContextModificationIndication_protocolIEs._cont = __UEContextModificationIndication_protocolIEs__item_
    _UEContextModificationIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationIndication._cont = ASN1Dict([
        (u'protocolIEs', _UEContextModificationIndication_protocolIEs),
        ])
    UEContextModificationIndication._ext = []
    
    #-----< UEContextModificationIndicationIEs >-----#
    UEContextModificationIndicationIEs = CLASS(name=u'UEContextModificationIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextModificationIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextModificationIndicationIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextModificationIndicationIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'CSGMembershipInfo')))
    UEContextModificationIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _UEContextModificationIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _UEContextModificationIndicationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 226), (u'criticality', u'reject'), (u'Value', _UEContextModificationIndicationIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextModificationConfirm >-----#
    UEContextModificationConfirm = SEQ(name=u'UEContextModificationConfirm', mode=MODE_TYPE)
    _UEContextModificationConfirm_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextModificationConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextModificationConfirm_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextModificationConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____UEContextModificationConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextModificationConfirm_protocolIEs__item__id._const_tab = ____UEContextModificationConfirm_protocolIEs__item__id_tab
    ___UEContextModificationConfirm_protocolIEs__item__id._const_tab_at = None
    ___UEContextModificationConfirm_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextModificationConfirm_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextModificationConfirm_protocolIEs__item__criticality._const_tab = ____UEContextModificationConfirm_protocolIEs__item__id_tab
    ___UEContextModificationConfirm_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextModificationConfirm_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextModificationConfirm_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextModificationConfirm_protocolIEs__item__value._const_tab = ____UEContextModificationConfirm_protocolIEs__item__id_tab
    ___UEContextModificationConfirm_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextModificationConfirm_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextModificationConfirm_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextModificationConfirm_protocolIEs__item__id),
        (u'criticality', ___UEContextModificationConfirm_protocolIEs__item__criticality),
        (u'value', ___UEContextModificationConfirm_protocolIEs__item__value),
        ])
    __UEContextModificationConfirm_protocolIEs__item_._ext = None
    _UEContextModificationConfirm_protocolIEs._cont = __UEContextModificationConfirm_protocolIEs__item_
    _UEContextModificationConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextModificationConfirm._cont = ASN1Dict([
        (u'protocolIEs', _UEContextModificationConfirm_protocolIEs),
        ])
    UEContextModificationConfirm._ext = []
    
    #-----< UEContextModificationConfirmIEs >-----#
    UEContextModificationConfirmIEs = CLASS(name=u'UEContextModificationConfirmIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextModificationConfirmIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextModificationConfirmIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextModificationConfirmIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CSGMembershipStatus')))
    _UEContextModificationConfirmIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    UEContextModificationConfirmIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _UEContextModificationConfirmIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _UEContextModificationConfirmIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', _UEContextModificationConfirmIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _UEContextModificationConfirmIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextSuspendRequest >-----#
    UEContextSuspendRequest = SEQ(name=u'UEContextSuspendRequest', mode=MODE_TYPE)
    _UEContextSuspendRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextSuspendRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextSuspendRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextSuspendRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'InformationOnRecommendedCellsAndENBsForPaging')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellIdentifierAndCELevelForCECapableUEs')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeSinceSecondaryNodeRelease')))
    ____UEContextSuspendRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 213), (u'criticality', u'ignore'), (u'Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 212), (u'criticality', u'ignore'), (u'Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'ignore'), (u'Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 189), (u'criticality', u'ignore'), (u'Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 297), (u'criticality', u'ignore'), (u'Value', _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextSuspendRequest_protocolIEs__item__id._const_tab = ____UEContextSuspendRequest_protocolIEs__item__id_tab
    ___UEContextSuspendRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextSuspendRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextSuspendRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextSuspendRequest_protocolIEs__item__criticality._const_tab = ____UEContextSuspendRequest_protocolIEs__item__id_tab
    ___UEContextSuspendRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextSuspendRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextSuspendRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextSuspendRequest_protocolIEs__item__value._const_tab = ____UEContextSuspendRequest_protocolIEs__item__id_tab
    ___UEContextSuspendRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextSuspendRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextSuspendRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextSuspendRequest_protocolIEs__item__id),
        (u'criticality', ___UEContextSuspendRequest_protocolIEs__item__criticality),
        (u'value', ___UEContextSuspendRequest_protocolIEs__item__value),
        ])
    __UEContextSuspendRequest_protocolIEs__item_._ext = None
    _UEContextSuspendRequest_protocolIEs._cont = __UEContextSuspendRequest_protocolIEs__item_
    _UEContextSuspendRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextSuspendRequest._cont = ASN1Dict([
        (u'protocolIEs', _UEContextSuspendRequest_protocolIEs),
        ])
    UEContextSuspendRequest._ext = []
    
    #-----< UEContextSuspendRequestIEs >-----#
    UEContextSuspendRequestIEs = CLASS(name=u'UEContextSuspendRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextSuspendRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextSuspendRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextSuspendRequestIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'InformationOnRecommendedCellsAndENBsForPaging')))
    _UEContextSuspendRequestIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CellIdentifierAndCELevelForCECapableUEs')))
    _UEContextSuspendRequestIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    _UEContextSuspendRequestIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    _UEContextSuspendRequestIEs_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeSinceSecondaryNodeRelease')))
    UEContextSuspendRequestIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _UEContextSuspendRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _UEContextSuspendRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 213), (u'criticality', u'ignore'), (u'Value', _UEContextSuspendRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 212), (u'criticality', u'ignore'), (u'Value', _UEContextSuspendRequestIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 264), (u'criticality', u'ignore'), (u'Value', _UEContextSuspendRequestIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 189), (u'criticality', u'ignore'), (u'Value', _UEContextSuspendRequestIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 297), (u'criticality', u'ignore'), (u'Value', _UEContextSuspendRequestIEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextSuspendResponse >-----#
    UEContextSuspendResponse = SEQ(name=u'UEContextSuspendResponse', mode=MODE_TYPE)
    _UEContextSuspendResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextSuspendResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextSuspendResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextSuspendResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityContext')))
    ____UEContextSuspendResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextSuspendResponse_protocolIEs__item__id._const_tab = ____UEContextSuspendResponse_protocolIEs__item__id_tab
    ___UEContextSuspendResponse_protocolIEs__item__id._const_tab_at = None
    ___UEContextSuspendResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextSuspendResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextSuspendResponse_protocolIEs__item__criticality._const_tab = ____UEContextSuspendResponse_protocolIEs__item__id_tab
    ___UEContextSuspendResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextSuspendResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextSuspendResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextSuspendResponse_protocolIEs__item__value._const_tab = ____UEContextSuspendResponse_protocolIEs__item__id_tab
    ___UEContextSuspendResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextSuspendResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextSuspendResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextSuspendResponse_protocolIEs__item__id),
        (u'criticality', ___UEContextSuspendResponse_protocolIEs__item__criticality),
        (u'value', ___UEContextSuspendResponse_protocolIEs__item__value),
        ])
    __UEContextSuspendResponse_protocolIEs__item_._ext = None
    _UEContextSuspendResponse_protocolIEs._cont = __UEContextSuspendResponse_protocolIEs__item_
    _UEContextSuspendResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextSuspendResponse._cont = ASN1Dict([
        (u'protocolIEs', _UEContextSuspendResponse_protocolIEs),
        ])
    UEContextSuspendResponse._ext = []
    
    #-----< UEContextSuspendResponseIEs >-----#
    UEContextSuspendResponseIEs = CLASS(name=u'UEContextSuspendResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextSuspendResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextSuspendResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextSuspendResponseIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _UEContextSuspendResponseIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityContext')))
    UEContextSuspendResponseIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _UEContextSuspendResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _UEContextSuspendResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _UEContextSuspendResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _UEContextSuspendResponseIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEContextResumeRequest >-----#
    UEContextResumeRequest = SEQ(name=u'UEContextResumeRequest', mode=MODE_TYPE)
    _UEContextResumeRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextResumeRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextResumeRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextResumeRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedToResumeListResumeReq')))
    _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RRC-Establishment-Cause')))
    ____UEContextResumeRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 235), (u'criticality', u'reject'), (u'Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 245), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextResumeRequest_protocolIEs__item__id._const_tab = ____UEContextResumeRequest_protocolIEs__item__id_tab
    ___UEContextResumeRequest_protocolIEs__item__id._const_tab_at = None
    ___UEContextResumeRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextResumeRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextResumeRequest_protocolIEs__item__criticality._const_tab = ____UEContextResumeRequest_protocolIEs__item__id_tab
    ___UEContextResumeRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextResumeRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextResumeRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextResumeRequest_protocolIEs__item__value._const_tab = ____UEContextResumeRequest_protocolIEs__item__id_tab
    ___UEContextResumeRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextResumeRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextResumeRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextResumeRequest_protocolIEs__item__id),
        (u'criticality', ___UEContextResumeRequest_protocolIEs__item__criticality),
        (u'value', ___UEContextResumeRequest_protocolIEs__item__value),
        ])
    __UEContextResumeRequest_protocolIEs__item_._ext = None
    _UEContextResumeRequest_protocolIEs._cont = __UEContextResumeRequest_protocolIEs__item_
    _UEContextResumeRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextResumeRequest._cont = ASN1Dict([
        (u'protocolIEs', _UEContextResumeRequest_protocolIEs),
        ])
    UEContextResumeRequest._ext = []
    
    #-----< UEContextResumeRequestIEs >-----#
    UEContextResumeRequestIEs = CLASS(name=u'UEContextResumeRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextResumeRequestIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextResumeRequestIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextResumeRequestIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedToResumeListResumeReq')))
    _UEContextResumeRequestIEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'RRC-Establishment-Cause')))
    UEContextResumeRequestIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _UEContextResumeRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _UEContextResumeRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 235), (u'criticality', u'reject'), (u'Value', _UEContextResumeRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 245), (u'criticality', u'ignore'), (u'Value', _UEContextResumeRequestIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABFailedToResumeListResumeReq >-----#
    E_RABFailedToResumeListResumeReq = SEQ_OF(name=u'E-RABFailedToResumeListResumeReq', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RAB-IE-ContainerList')))
    _E_RABFailedToResumeListResumeReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABFailedToResumeListResumeReq__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___E_RABFailedToResumeListResumeReq__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABFailedToResumeListResumeReq__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedToResumeItemResumeReq')))
    ___E_RABFailedToResumeListResumeReq__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 236), (u'criticality', u'reject'), (u'Value', ____E_RABFailedToResumeListResumeReq__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABFailedToResumeListResumeReq__item__id._const_tab = ___E_RABFailedToResumeListResumeReq__item__id_tab
    __E_RABFailedToResumeListResumeReq__item__id._const_tab_at = None
    __E_RABFailedToResumeListResumeReq__item__id._const_tab_id = u'id'
    __E_RABFailedToResumeListResumeReq__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABFailedToResumeListResumeReq__item__criticality._const_tab = ___E_RABFailedToResumeListResumeReq__item__id_tab
    __E_RABFailedToResumeListResumeReq__item__criticality._const_tab_at = ('..', u'id')
    __E_RABFailedToResumeListResumeReq__item__criticality._const_tab_id = u'criticality'
    __E_RABFailedToResumeListResumeReq__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __E_RABFailedToResumeListResumeReq__item__value._const_tab = ___E_RABFailedToResumeListResumeReq__item__id_tab
    __E_RABFailedToResumeListResumeReq__item__value._const_tab_at = ('..', u'id')
    __E_RABFailedToResumeListResumeReq__item__value._const_tab_id = u'Value'
    _E_RABFailedToResumeListResumeReq__item_._cont = ASN1Dict([
        (u'id', __E_RABFailedToResumeListResumeReq__item__id),
        (u'criticality', __E_RABFailedToResumeListResumeReq__item__criticality),
        (u'value', __E_RABFailedToResumeListResumeReq__item__value),
        ])
    _E_RABFailedToResumeListResumeReq__item_._ext = None
    E_RABFailedToResumeListResumeReq._cont = _E_RABFailedToResumeListResumeReq__item_
    E_RABFailedToResumeListResumeReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABFailedToResumeItemResumeReqIEs >-----#
    E_RABFailedToResumeItemResumeReqIEs = CLASS(name=u'E-RABFailedToResumeItemResumeReqIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABFailedToResumeItemResumeReqIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedToResumeItemResumeReq')))
    E_RABFailedToResumeItemResumeReqIEs._val = ASN1Set(rv=[dict([(u'id', 236), (u'criticality', u'reject'), (u'Value', _E_RABFailedToResumeItemResumeReqIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABFailedToResumeItemResumeReq >-----#
    E_RABFailedToResumeItemResumeReq = SEQ(name=u'E-RABFailedToResumeItemResumeReq', mode=MODE_TYPE)
    _E_RABFailedToResumeItemResumeReq_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABFailedToResumeItemResumeReq_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _E_RABFailedToResumeItemResumeReq_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABFailedToResumeItemResumeReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__id._const_tab = ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__id_tab
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__id._const_tab_at = None
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__criticality._const_tab = ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__criticality_tab
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__extensionValue._const_tab = ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__extensionValue_tab
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABFailedToResumeItemResumeReq_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__id),
        (u'criticality', ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__extensionValue),
        ])
    __E_RABFailedToResumeItemResumeReq_iE_Extensions__item_._ext = None
    _E_RABFailedToResumeItemResumeReq_iE_Extensions._cont = __E_RABFailedToResumeItemResumeReq_iE_Extensions__item_
    _E_RABFailedToResumeItemResumeReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABFailedToResumeItemResumeReq._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABFailedToResumeItemResumeReq_e_RAB_ID),
        (u'cause', _E_RABFailedToResumeItemResumeReq_cause),
        (u'iE-Extensions', _E_RABFailedToResumeItemResumeReq_iE_Extensions),
        ])
    E_RABFailedToResumeItemResumeReq._ext = []
    
    #-----< E-RABFailedToResumeItemResumeReq-ExtIEs >-----#
    E_RABFailedToResumeItemResumeReq_ExtIEs = CLASS(name=u'E-RABFailedToResumeItemResumeReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABFailedToResumeItemResumeReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEContextResumeResponse >-----#
    UEContextResumeResponse = SEQ(name=u'UEContextResumeResponse', mode=MODE_TYPE)
    _UEContextResumeResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextResumeResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextResumeResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextResumeResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedToResumeListResumeRes')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityContext')))
    _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    ____UEContextResumeResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 237), (u'criticality', u'reject'), (u'Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 283), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextResumeResponse_protocolIEs__item__id._const_tab = ____UEContextResumeResponse_protocolIEs__item__id_tab
    ___UEContextResumeResponse_protocolIEs__item__id._const_tab_at = None
    ___UEContextResumeResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextResumeResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextResumeResponse_protocolIEs__item__criticality._const_tab = ____UEContextResumeResponse_protocolIEs__item__id_tab
    ___UEContextResumeResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextResumeResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextResumeResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextResumeResponse_protocolIEs__item__value._const_tab = ____UEContextResumeResponse_protocolIEs__item__id_tab
    ___UEContextResumeResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextResumeResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextResumeResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextResumeResponse_protocolIEs__item__id),
        (u'criticality', ___UEContextResumeResponse_protocolIEs__item__criticality),
        (u'value', ___UEContextResumeResponse_protocolIEs__item__value),
        ])
    __UEContextResumeResponse_protocolIEs__item_._ext = None
    _UEContextResumeResponse_protocolIEs._cont = __UEContextResumeResponse_protocolIEs__item_
    _UEContextResumeResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextResumeResponse._cont = ASN1Dict([
        (u'protocolIEs', _UEContextResumeResponse_protocolIEs),
        ])
    UEContextResumeResponse._ext = []
    
    #-----< UEContextResumeResponseIEs >-----#
    UEContextResumeResponseIEs = CLASS(name=u'UEContextResumeResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextResumeResponseIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextResumeResponseIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextResumeResponseIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedToResumeListResumeRes')))
    _UEContextResumeResponseIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    _UEContextResumeResponseIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecurityContext')))
    _UEContextResumeResponseIEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    UEContextResumeResponseIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _UEContextResumeResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _UEContextResumeResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 237), (u'criticality', u'reject'), (u'Value', _UEContextResumeResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _UEContextResumeResponseIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _UEContextResumeResponseIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 283), (u'criticality', u'ignore'), (u'Value', _UEContextResumeResponseIEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABFailedToResumeListResumeRes >-----#
    E_RABFailedToResumeListResumeRes = SEQ_OF(name=u'E-RABFailedToResumeListResumeRes', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RAB-IE-ContainerList')))
    _E_RABFailedToResumeListResumeRes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABFailedToResumeListResumeRes__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ___E_RABFailedToResumeListResumeRes__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    ____E_RABFailedToResumeListResumeRes__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedToResumeItemResumeRes')))
    ___E_RABFailedToResumeListResumeRes__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 238), (u'criticality', u'reject'), (u'Value', ____E_RABFailedToResumeListResumeRes__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABFailedToResumeListResumeRes__item__id._const_tab = ___E_RABFailedToResumeListResumeRes__item__id_tab
    __E_RABFailedToResumeListResumeRes__item__id._const_tab_at = None
    __E_RABFailedToResumeListResumeRes__item__id._const_tab_id = u'id'
    __E_RABFailedToResumeListResumeRes__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    __E_RABFailedToResumeListResumeRes__item__criticality._const_tab = ___E_RABFailedToResumeListResumeRes__item__id_tab
    __E_RABFailedToResumeListResumeRes__item__criticality._const_tab_at = ('..', u'id')
    __E_RABFailedToResumeListResumeRes__item__criticality._const_tab_id = u'criticality'
    __E_RABFailedToResumeListResumeRes__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    __E_RABFailedToResumeListResumeRes__item__value._const_tab = ___E_RABFailedToResumeListResumeRes__item__id_tab
    __E_RABFailedToResumeListResumeRes__item__value._const_tab_at = ('..', u'id')
    __E_RABFailedToResumeListResumeRes__item__value._const_tab_id = u'Value'
    _E_RABFailedToResumeListResumeRes__item_._cont = ASN1Dict([
        (u'id', __E_RABFailedToResumeListResumeRes__item__id),
        (u'criticality', __E_RABFailedToResumeListResumeRes__item__criticality),
        (u'value', __E_RABFailedToResumeListResumeRes__item__value),
        ])
    _E_RABFailedToResumeListResumeRes__item_._ext = None
    E_RABFailedToResumeListResumeRes._cont = _E_RABFailedToResumeListResumeRes__item_
    E_RABFailedToResumeListResumeRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABFailedToResumeItemResumeResIEs >-----#
    E_RABFailedToResumeItemResumeResIEs = CLASS(name=u'E-RABFailedToResumeItemResumeResIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _E_RABFailedToResumeItemResumeResIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABFailedToResumeItemResumeRes')))
    E_RABFailedToResumeItemResumeResIEs._val = ASN1Set(rv=[dict([(u'id', 238), (u'criticality', u'reject'), (u'Value', _E_RABFailedToResumeItemResumeResIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABFailedToResumeItemResumeRes >-----#
    E_RABFailedToResumeItemResumeRes = SEQ(name=u'E-RABFailedToResumeItemResumeRes', mode=MODE_TYPE)
    _E_RABFailedToResumeItemResumeRes_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'E-RAB-ID')))
    _E_RABFailedToResumeItemResumeRes_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _E_RABFailedToResumeItemResumeRes_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABFailedToResumeItemResumeRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolExtensionField')))
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__id._const_tab = ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__id_tab
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__id._const_tab_at = None
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__criticality._const_tab = ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__criticality_tab
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_S1AP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__extensionValue._const_tab = ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__extensionValue_tab
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABFailedToResumeItemResumeRes_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__id),
        (u'criticality', ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__extensionValue),
        ])
    __E_RABFailedToResumeItemResumeRes_iE_Extensions__item_._ext = None
    _E_RABFailedToResumeItemResumeRes_iE_Extensions._cont = __E_RABFailedToResumeItemResumeRes_iE_Extensions__item_
    _E_RABFailedToResumeItemResumeRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABFailedToResumeItemResumeRes._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABFailedToResumeItemResumeRes_e_RAB_ID),
        (u'cause', _E_RABFailedToResumeItemResumeRes_cause),
        (u'iE-Extensions', _E_RABFailedToResumeItemResumeRes_iE_Extensions),
        ])
    E_RABFailedToResumeItemResumeRes._ext = []
    
    #-----< E-RABFailedToResumeItemResumeRes-ExtIEs >-----#
    E_RABFailedToResumeItemResumeRes_ExtIEs = CLASS(name=u'E-RABFailedToResumeItemResumeRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-EXTENSION')))
    E_RABFailedToResumeItemResumeRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEContextResumeFailure >-----#
    UEContextResumeFailure = SEQ(name=u'UEContextResumeFailure', mode=MODE_TYPE)
    _UEContextResumeFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEContextResumeFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEContextResumeFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UEContextResumeFailure_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____UEContextResumeFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEContextResumeFailure_protocolIEs__item__id._const_tab = ____UEContextResumeFailure_protocolIEs__item__id_tab
    ___UEContextResumeFailure_protocolIEs__item__id._const_tab_at = None
    ___UEContextResumeFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___UEContextResumeFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEContextResumeFailure_protocolIEs__item__criticality._const_tab = ____UEContextResumeFailure_protocolIEs__item__id_tab
    ___UEContextResumeFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEContextResumeFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEContextResumeFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UEContextResumeFailure_protocolIEs__item__value._const_tab = ____UEContextResumeFailure_protocolIEs__item__id_tab
    ___UEContextResumeFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEContextResumeFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __UEContextResumeFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEContextResumeFailure_protocolIEs__item__id),
        (u'criticality', ___UEContextResumeFailure_protocolIEs__item__criticality),
        (u'value', ___UEContextResumeFailure_protocolIEs__item__value),
        ])
    __UEContextResumeFailure_protocolIEs__item_._ext = None
    _UEContextResumeFailure_protocolIEs._cont = __UEContextResumeFailure_protocolIEs__item_
    _UEContextResumeFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEContextResumeFailure._cont = ASN1Dict([
        (u'protocolIEs', _UEContextResumeFailure_protocolIEs),
        ])
    UEContextResumeFailure._ext = []
    
    #-----< UEContextResumeFailureIEs >-----#
    UEContextResumeFailureIEs = CLASS(name=u'UEContextResumeFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEContextResumeFailureIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _UEContextResumeFailureIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _UEContextResumeFailureIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Cause')))
    _UEContextResumeFailureIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    UEContextResumeFailureIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _UEContextResumeFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _UEContextResumeFailureIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _UEContextResumeFailureIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _UEContextResumeFailureIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ConnectionEstablishmentIndication >-----#
    ConnectionEstablishmentIndication = SEQ(name=u'ConnectionEstablishmentIndication', mode=MODE_TYPE)
    _ConnectionEstablishmentIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ConnectionEstablishmentIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ConnectionEstablishmentIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DL-CP-SecurityInformation')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EndIndication')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABLevelQoSParameters')))
    _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_9 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 74), (u'criticality', u'ignore'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 251), (u'criticality', u'ignore'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 253), (u'criticality', u'ignore'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 271), (u'criticality', u'ignore'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 280), (u'criticality', u'ignore'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 278), (u'criticality', u'ignore'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 252), (u'criticality', u'ignore'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 314), (u'criticality', u'reject'), (u'Value', _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ConnectionEstablishmentIndication_protocolIEs__item__id._const_tab = ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab
    ___ConnectionEstablishmentIndication_protocolIEs__item__id._const_tab_at = None
    ___ConnectionEstablishmentIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___ConnectionEstablishmentIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___ConnectionEstablishmentIndication_protocolIEs__item__criticality._const_tab = ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab
    ___ConnectionEstablishmentIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ConnectionEstablishmentIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ConnectionEstablishmentIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___ConnectionEstablishmentIndication_protocolIEs__item__value._const_tab = ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab
    ___ConnectionEstablishmentIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ConnectionEstablishmentIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __ConnectionEstablishmentIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ConnectionEstablishmentIndication_protocolIEs__item__id),
        (u'criticality', ___ConnectionEstablishmentIndication_protocolIEs__item__criticality),
        (u'value', ___ConnectionEstablishmentIndication_protocolIEs__item__value),
        ])
    __ConnectionEstablishmentIndication_protocolIEs__item_._ext = None
    _ConnectionEstablishmentIndication_protocolIEs._cont = __ConnectionEstablishmentIndication_protocolIEs__item_
    _ConnectionEstablishmentIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ConnectionEstablishmentIndication._cont = ASN1Dict([
        (u'protocolIEs', _ConnectionEstablishmentIndication_protocolIEs),
        ])
    ConnectionEstablishmentIndication._ext = []
    
    #-----< ConnectionEstablishmentIndicationIEs >-----#
    ConnectionEstablishmentIndicationIEs = CLASS(name=u'ConnectionEstablishmentIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ConnectionEstablishmentIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _ConnectionEstablishmentIndicationIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _ConnectionEstablishmentIndicationIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _ConnectionEstablishmentIndicationIEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EnhancedCoverageRestricted')))
    _ConnectionEstablishmentIndicationIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'DL-CP-SecurityInformation')))
    _ConnectionEstablishmentIndicationIEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CE-ModeBRestricted')))
    _ConnectionEstablishmentIndicationIEs_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EndIndication')))
    _ConnectionEstablishmentIndicationIEs_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _ConnectionEstablishmentIndicationIEs_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABLevelQoSParameters')))
    _ConnectionEstablishmentIndicationIEs_val_Value_9 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    ConnectionEstablishmentIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 74), (u'criticality', u'ignore'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 251), (u'criticality', u'ignore'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 253), (u'criticality', u'ignore'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 271), (u'criticality', u'ignore'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 280), (u'criticality', u'ignore'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 278), (u'criticality', u'ignore'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 252), (u'criticality', u'ignore'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 314), (u'criticality', u'reject'), (u'Value', _ConnectionEstablishmentIndicationIEs_val_Value_9), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RetrieveUEInformation >-----#
    RetrieveUEInformation = SEQ(name=u'RetrieveUEInformation', mode=MODE_TYPE)
    _RetrieveUEInformation_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __RetrieveUEInformation_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___RetrieveUEInformation_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____RetrieveUEInformation_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____RetrieveUEInformation_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    ____RetrieveUEInformation_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 96), (u'criticality', u'reject'), (u'Value', _____RetrieveUEInformation_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RetrieveUEInformation_protocolIEs__item__id._const_tab = ____RetrieveUEInformation_protocolIEs__item__id_tab
    ___RetrieveUEInformation_protocolIEs__item__id._const_tab_at = None
    ___RetrieveUEInformation_protocolIEs__item__id._const_tab_id = u'id'
    ___RetrieveUEInformation_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___RetrieveUEInformation_protocolIEs__item__criticality._const_tab = ____RetrieveUEInformation_protocolIEs__item__id_tab
    ___RetrieveUEInformation_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RetrieveUEInformation_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RetrieveUEInformation_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___RetrieveUEInformation_protocolIEs__item__value._const_tab = ____RetrieveUEInformation_protocolIEs__item__id_tab
    ___RetrieveUEInformation_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RetrieveUEInformation_protocolIEs__item__value._const_tab_id = u'Value'
    __RetrieveUEInformation_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RetrieveUEInformation_protocolIEs__item__id),
        (u'criticality', ___RetrieveUEInformation_protocolIEs__item__criticality),
        (u'value', ___RetrieveUEInformation_protocolIEs__item__value),
        ])
    __RetrieveUEInformation_protocolIEs__item_._ext = None
    _RetrieveUEInformation_protocolIEs._cont = __RetrieveUEInformation_protocolIEs__item_
    _RetrieveUEInformation_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RetrieveUEInformation._cont = ASN1Dict([
        (u'protocolIEs', _RetrieveUEInformation_protocolIEs),
        ])
    RetrieveUEInformation._ext = []
    
    #-----< RetrieveUEInformationIEs >-----#
    RetrieveUEInformationIEs = CLASS(name=u'RetrieveUEInformationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _RetrieveUEInformationIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    RetrieveUEInformationIEs._val = ASN1Set(rv=[dict([(u'id', 96), (u'criticality', u'reject'), (u'Value', _RetrieveUEInformationIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEInformationTransfer >-----#
    UEInformationTransfer = SEQ(name=u'UEInformationTransfer', mode=MODE_TYPE)
    _UEInformationTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UEInformationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UEInformationTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UEInformationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABLevelQoSParameters')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    ____UEInformationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 96), (u'criticality', u'reject'), (u'Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 252), (u'criticality', u'ignore'), (u'Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 74), (u'criticality', u'ignore'), (u'Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 278), (u'criticality', u'ignore'), (u'Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 283), (u'criticality', u'ignore'), (u'Value', _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEInformationTransfer_protocolIEs__item__id._const_tab = ____UEInformationTransfer_protocolIEs__item__id_tab
    ___UEInformationTransfer_protocolIEs__item__id._const_tab_at = None
    ___UEInformationTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___UEInformationTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UEInformationTransfer_protocolIEs__item__criticality._const_tab = ____UEInformationTransfer_protocolIEs__item__id_tab
    ___UEInformationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEInformationTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEInformationTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UEInformationTransfer_protocolIEs__item__value._const_tab = ____UEInformationTransfer_protocolIEs__item__id_tab
    ___UEInformationTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEInformationTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __UEInformationTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEInformationTransfer_protocolIEs__item__id),
        (u'criticality', ___UEInformationTransfer_protocolIEs__item__criticality),
        (u'value', ___UEInformationTransfer_protocolIEs__item__value),
        ])
    __UEInformationTransfer_protocolIEs__item_._ext = None
    _UEInformationTransfer_protocolIEs._cont = __UEInformationTransfer_protocolIEs__item_
    _UEInformationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UEInformationTransfer._cont = ASN1Dict([
        (u'protocolIEs', _UEInformationTransfer_protocolIEs),
        ])
    UEInformationTransfer._ext = []
    
    #-----< UEInformationTransferIEs >-----#
    UEInformationTransferIEs = CLASS(name=u'UEInformationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UEInformationTransferIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    _UEInformationTransferIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'E-RABLevelQoSParameters')))
    _UEInformationTransferIEs_val_Value_2 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _UEInformationTransferIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'Subscription-Based-UE-DifferentiationInfo')))
    _UEInformationTransferIEs_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'PendingDataIndication')))
    UEInformationTransferIEs._val = ASN1Set(rv=[dict([(u'id', 96), (u'criticality', u'reject'), (u'Value', _UEInformationTransferIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 252), (u'criticality', u'ignore'), (u'Value', _UEInformationTransferIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 74), (u'criticality', u'ignore'), (u'Value', _UEInformationTransferIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 278), (u'criticality', u'ignore'), (u'Value', _UEInformationTransferIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 283), (u'criticality', u'ignore'), (u'Value', _UEInformationTransferIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ENBCPRelocationIndication >-----#
    ENBCPRelocationIndication = SEQ(name=u'ENBCPRelocationIndication', mode=MODE_TYPE)
    _ENBCPRelocationIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __ENBCPRelocationIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___ENBCPRelocationIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____ENBCPRelocationIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UL-CP-SecurityInformation')))
    ____ENBCPRelocationIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 96), (u'criticality', u'reject'), (u'Value', _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 100), (u'criticality', u'ignore'), (u'Value', _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 67), (u'criticality', u'ignore'), (u'Value', _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 254), (u'criticality', u'reject'), (u'Value', _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___ENBCPRelocationIndication_protocolIEs__item__id._const_tab = ____ENBCPRelocationIndication_protocolIEs__item__id_tab
    ___ENBCPRelocationIndication_protocolIEs__item__id._const_tab_at = None
    ___ENBCPRelocationIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___ENBCPRelocationIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___ENBCPRelocationIndication_protocolIEs__item__criticality._const_tab = ____ENBCPRelocationIndication_protocolIEs__item__id_tab
    ___ENBCPRelocationIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ENBCPRelocationIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ENBCPRelocationIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___ENBCPRelocationIndication_protocolIEs__item__value._const_tab = ____ENBCPRelocationIndication_protocolIEs__item__id_tab
    ___ENBCPRelocationIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ENBCPRelocationIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __ENBCPRelocationIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ENBCPRelocationIndication_protocolIEs__item__id),
        (u'criticality', ___ENBCPRelocationIndication_protocolIEs__item__criticality),
        (u'value', ___ENBCPRelocationIndication_protocolIEs__item__value),
        ])
    __ENBCPRelocationIndication_protocolIEs__item_._ext = None
    _ENBCPRelocationIndication_protocolIEs._cont = __ENBCPRelocationIndication_protocolIEs__item_
    _ENBCPRelocationIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ENBCPRelocationIndication._cont = ASN1Dict([
        (u'protocolIEs', _ENBCPRelocationIndication_protocolIEs),
        ])
    ENBCPRelocationIndication._ext = []
    
    #-----< ENBCPRelocationIndicationIEs >-----#
    ENBCPRelocationIndicationIEs = CLASS(name=u'ENBCPRelocationIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _ENBCPRelocationIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _ENBCPRelocationIndicationIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'S-TMSI')))
    _ENBCPRelocationIndicationIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'EUTRAN-CGI')))
    _ENBCPRelocationIndicationIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TAI')))
    _ENBCPRelocationIndicationIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UL-CP-SecurityInformation')))
    ENBCPRelocationIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _ENBCPRelocationIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 96), (u'criticality', u'reject'), (u'Value', _ENBCPRelocationIndicationIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 100), (u'criticality', u'ignore'), (u'Value', _ENBCPRelocationIndicationIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 67), (u'criticality', u'ignore'), (u'Value', _ENBCPRelocationIndicationIEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 254), (u'criticality', u'reject'), (u'Value', _ENBCPRelocationIndicationIEs_val_Value_4), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MMECPRelocationIndication >-----#
    MMECPRelocationIndication = SEQ(name=u'MMECPRelocationIndication', mode=MODE_TYPE)
    _MMECPRelocationIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __MMECPRelocationIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___MMECPRelocationIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____MMECPRelocationIndication_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____MMECPRelocationIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____MMECPRelocationIndication_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    ____MMECPRelocationIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _____MMECPRelocationIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____MMECPRelocationIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___MMECPRelocationIndication_protocolIEs__item__id._const_tab = ____MMECPRelocationIndication_protocolIEs__item__id_tab
    ___MMECPRelocationIndication_protocolIEs__item__id._const_tab_at = None
    ___MMECPRelocationIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___MMECPRelocationIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___MMECPRelocationIndication_protocolIEs__item__criticality._const_tab = ____MMECPRelocationIndication_protocolIEs__item__id_tab
    ___MMECPRelocationIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MMECPRelocationIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MMECPRelocationIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___MMECPRelocationIndication_protocolIEs__item__value._const_tab = ____MMECPRelocationIndication_protocolIEs__item__id_tab
    ___MMECPRelocationIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MMECPRelocationIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __MMECPRelocationIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MMECPRelocationIndication_protocolIEs__item__id),
        (u'criticality', ___MMECPRelocationIndication_protocolIEs__item__criticality),
        (u'value', ___MMECPRelocationIndication_protocolIEs__item__value),
        ])
    __MMECPRelocationIndication_protocolIEs__item_._ext = None
    _MMECPRelocationIndication_protocolIEs._cont = __MMECPRelocationIndication_protocolIEs__item_
    _MMECPRelocationIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    MMECPRelocationIndication._cont = ASN1Dict([
        (u'protocolIEs', _MMECPRelocationIndication_protocolIEs),
        ])
    MMECPRelocationIndication._ext = []
    
    #-----< MMECPRelocationIndicationIEs >-----#
    MMECPRelocationIndicationIEs = CLASS(name=u'MMECPRelocationIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _MMECPRelocationIndicationIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _MMECPRelocationIndicationIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    MMECPRelocationIndicationIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'reject'), (u'Value', _MMECPRelocationIndicationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _MMECPRelocationIndicationIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SecondaryRATDataUsageReport >-----#
    SecondaryRATDataUsageReport = SEQ(name=u'SecondaryRATDataUsageReport', mode=MODE_TYPE)
    _SecondaryRATDataUsageReport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __SecondaryRATDataUsageReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___SecondaryRATDataUsageReport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverFlag')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeSinceSecondaryNodeRelease')))
    ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 264), (u'criticality', u'ignore'), (u'Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 266), (u'criticality', u'ignore'), (u'Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 189), (u'criticality', u'ignore'), (u'Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 297), (u'criticality', u'ignore'), (u'Value', _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SecondaryRATDataUsageReport_protocolIEs__item__id._const_tab = ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab
    ___SecondaryRATDataUsageReport_protocolIEs__item__id._const_tab_at = None
    ___SecondaryRATDataUsageReport_protocolIEs__item__id._const_tab_id = u'id'
    ___SecondaryRATDataUsageReport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___SecondaryRATDataUsageReport_protocolIEs__item__criticality._const_tab = ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab
    ___SecondaryRATDataUsageReport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SecondaryRATDataUsageReport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SecondaryRATDataUsageReport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___SecondaryRATDataUsageReport_protocolIEs__item__value._const_tab = ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab
    ___SecondaryRATDataUsageReport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SecondaryRATDataUsageReport_protocolIEs__item__value._const_tab_id = u'Value'
    __SecondaryRATDataUsageReport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SecondaryRATDataUsageReport_protocolIEs__item__id),
        (u'criticality', ___SecondaryRATDataUsageReport_protocolIEs__item__criticality),
        (u'value', ___SecondaryRATDataUsageReport_protocolIEs__item__value),
        ])
    __SecondaryRATDataUsageReport_protocolIEs__item_._ext = None
    _SecondaryRATDataUsageReport_protocolIEs._cont = __SecondaryRATDataUsageReport_protocolIEs__item_
    _SecondaryRATDataUsageReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    SecondaryRATDataUsageReport._cont = ASN1Dict([
        (u'protocolIEs', _SecondaryRATDataUsageReport_protocolIEs),
        ])
    SecondaryRATDataUsageReport._ext = []
    
    #-----< SecondaryRATDataUsageReportIEs >-----#
    SecondaryRATDataUsageReportIEs = CLASS(name=u'SecondaryRATDataUsageReportIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _SecondaryRATDataUsageReportIEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'MME-UE-S1AP-ID')))
    _SecondaryRATDataUsageReportIEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'ENB-UE-S1AP-ID')))
    _SecondaryRATDataUsageReportIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'SecondaryRATDataUsageReportList')))
    _SecondaryRATDataUsageReportIEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'HandoverFlag')))
    _SecondaryRATDataUsageReportIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UserLocationInformation')))
    _SecondaryRATDataUsageReportIEs_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'TimeSinceSecondaryNodeRelease')))
    SecondaryRATDataUsageReportIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _SecondaryRATDataUsageReportIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _SecondaryRATDataUsageReportIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 264), (u'criticality', u'ignore'), (u'Value', _SecondaryRATDataUsageReportIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 266), (u'criticality', u'ignore'), (u'Value', _SecondaryRATDataUsageReportIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 189), (u'criticality', u'ignore'), (u'Value', _SecondaryRATDataUsageReportIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 297), (u'criticality', u'ignore'), (u'Value', _SecondaryRATDataUsageReportIEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityIDMappingRequest >-----#
    UERadioCapabilityIDMappingRequest = SEQ(name=u'UERadioCapabilityIDMappingRequest', mode=MODE_TYPE)
    _UERadioCapabilityIDMappingRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UERadioCapabilityIDMappingRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 314), (u'criticality', u'reject'), (u'Value', _____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id._const_tab = ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id._const_tab_at = None
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality._const_tab = ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value._const_tab = ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __UERadioCapabilityIDMappingRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id),
        (u'criticality', ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality),
        (u'value', ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value),
        ])
    __UERadioCapabilityIDMappingRequest_protocolIEs__item_._ext = None
    _UERadioCapabilityIDMappingRequest_protocolIEs._cont = __UERadioCapabilityIDMappingRequest_protocolIEs__item_
    _UERadioCapabilityIDMappingRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UERadioCapabilityIDMappingRequest._cont = ASN1Dict([
        (u'protocolIEs', _UERadioCapabilityIDMappingRequest_protocolIEs),
        ])
    UERadioCapabilityIDMappingRequest._ext = []
    
    #-----< UERadioCapabilityIDMappingRequestIEs >-----#
    UERadioCapabilityIDMappingRequestIEs = CLASS(name=u'UERadioCapabilityIDMappingRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UERadioCapabilityIDMappingRequestIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    UERadioCapabilityIDMappingRequestIEs._val = ASN1Set(rv=[dict([(u'id', 314), (u'criticality', u'reject'), (u'Value', _UERadioCapabilityIDMappingRequestIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UERadioCapabilityIDMappingResponse >-----#
    UERadioCapabilityIDMappingResponse = SEQ(name=u'UERadioCapabilityIDMappingResponse', mode=MODE_TYPE)
    _UERadioCapabilityIDMappingResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Container')))
    __UERadioCapabilityIDMappingResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-Containers', 'ProtocolIE-Field')))
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'id']))
    ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab = CLASS(name='_tab_S1AP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 314), (u'criticality', u'reject'), (u'Value', _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 74), (u'criticality', u'ignore'), (u'Value', _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id._const_tab = ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id._const_tab_at = None
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'criticality']))
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality._const_tab = ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-Containers', 'S1AP-PROTOCOL-IES'), [u'Value']))
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value._const_tab = ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __UERadioCapabilityIDMappingResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id),
        (u'criticality', ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality),
        (u'value', ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value),
        ])
    __UERadioCapabilityIDMappingResponse_protocolIEs__item_._ext = None
    _UERadioCapabilityIDMappingResponse_protocolIEs._cont = __UERadioCapabilityIDMappingResponse_protocolIEs__item_
    _UERadioCapabilityIDMappingResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    UERadioCapabilityIDMappingResponse._cont = ASN1Dict([
        (u'protocolIEs', _UERadioCapabilityIDMappingResponse_protocolIEs),
        ])
    UERadioCapabilityIDMappingResponse._ext = []
    
    #-----< UERadioCapabilityIDMappingResponseIEs >-----#
    UERadioCapabilityIDMappingResponseIEs = CLASS(name=u'UERadioCapabilityIDMappingResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('S1AP-Containers', 'S1AP-PROTOCOL-IES')))
    _UERadioCapabilityIDMappingResponseIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapabilityID')))
    _UERadioCapabilityIDMappingResponseIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'UERadioCapability')))
    _UERadioCapabilityIDMappingResponseIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-IEs', 'CriticalityDiagnostics')))
    UERadioCapabilityIDMappingResponseIEs._val = ASN1Set(rv=[dict([(u'id', 314), (u'criticality', u'reject'), (u'Value', _UERadioCapabilityIDMappingResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 74), (u'criticality', u'ignore'), (u'Value', _UERadioCapabilityIDMappingResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _UERadioCapabilityIDMappingResponseIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    _all_ = [
        ____HandoverRequired_protocolIEs__item__id_tab,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_7,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_8,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_9,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_10,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_11,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_12,
        _____HandoverRequired_protocolIEs__item__id_tab_val_Value_13,
        ___HandoverRequired_protocolIEs__item__id,
        ___HandoverRequired_protocolIEs__item__criticality,
        ___HandoverRequired_protocolIEs__item__value,
        __HandoverRequired_protocolIEs__item_,
        _HandoverRequired_protocolIEs,
        HandoverRequired,
        HandoverRequiredIEs,
        _HandoverRequiredIEs_val_Value_0,
        _HandoverRequiredIEs_val_Value_1,
        _HandoverRequiredIEs_val_Value_2,
        _HandoverRequiredIEs_val_Value_3,
        _HandoverRequiredIEs_val_Value_4,
        _HandoverRequiredIEs_val_Value_5,
        _HandoverRequiredIEs_val_Value_6,
        _HandoverRequiredIEs_val_Value_7,
        _HandoverRequiredIEs_val_Value_8,
        _HandoverRequiredIEs_val_Value_9,
        _HandoverRequiredIEs_val_Value_10,
        _HandoverRequiredIEs_val_Value_11,
        _HandoverRequiredIEs_val_Value_12,
        _HandoverRequiredIEs_val_Value_13,
        ____HandoverCommand_protocolIEs__item__id_tab,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_7,
        _____HandoverCommand_protocolIEs__item__id_tab_val_Value_8,
        ___HandoverCommand_protocolIEs__item__id,
        ___HandoverCommand_protocolIEs__item__criticality,
        ___HandoverCommand_protocolIEs__item__value,
        __HandoverCommand_protocolIEs__item_,
        _HandoverCommand_protocolIEs,
        HandoverCommand,
        HandoverCommandIEs,
        _HandoverCommandIEs_val_Value_0,
        _HandoverCommandIEs_val_Value_1,
        _HandoverCommandIEs_val_Value_2,
        _HandoverCommandIEs_val_Value_3,
        _HandoverCommandIEs_val_Value_4,
        _HandoverCommandIEs_val_Value_5,
        _HandoverCommandIEs_val_Value_6,
        _HandoverCommandIEs_val_Value_7,
        _HandoverCommandIEs_val_Value_8,
        ___E_RABSubjecttoDataForwardingList__item__id_tab,
        ____E_RABSubjecttoDataForwardingList__item__id_tab_val_Value_0,
        __E_RABSubjecttoDataForwardingList__item__id,
        __E_RABSubjecttoDataForwardingList__item__criticality,
        __E_RABSubjecttoDataForwardingList__item__value,
        _E_RABSubjecttoDataForwardingList__item_,
        E_RABSubjecttoDataForwardingList,
        E_RABDataForwardingItemIEs,
        _E_RABDataForwardingItemIEs_val_Value_0,
        _E_RABDataForwardingItem_e_RAB_ID,
        _E_RABDataForwardingItem_dL_transportLayerAddress,
        _E_RABDataForwardingItem_dL_gTP_TEID,
        _E_RABDataForwardingItem_uL_TransportLayerAddress,
        _E_RABDataForwardingItem_uL_GTP_TEID,
        ____E_RABDataForwardingItem_iE_Extensions__item__id_tab,
        ___E_RABDataForwardingItem_iE_Extensions__item__id,
        ____E_RABDataForwardingItem_iE_Extensions__item__criticality_tab,
        ___E_RABDataForwardingItem_iE_Extensions__item__criticality,
        ____E_RABDataForwardingItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABDataForwardingItem_iE_Extensions__item__extensionValue,
        __E_RABDataForwardingItem_iE_Extensions__item_,
        _E_RABDataForwardingItem_iE_Extensions,
        E_RABDataForwardingItem,
        E_RABDataForwardingItem_ExtIEs,
        ____HandoverPreparationFailure_protocolIEs__item__id_tab,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverPreparationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___HandoverPreparationFailure_protocolIEs__item__id,
        ___HandoverPreparationFailure_protocolIEs__item__criticality,
        ___HandoverPreparationFailure_protocolIEs__item__value,
        __HandoverPreparationFailure_protocolIEs__item_,
        _HandoverPreparationFailure_protocolIEs,
        HandoverPreparationFailure,
        HandoverPreparationFailureIEs,
        _HandoverPreparationFailureIEs_val_Value_0,
        _HandoverPreparationFailureIEs_val_Value_1,
        _HandoverPreparationFailureIEs_val_Value_2,
        _HandoverPreparationFailureIEs_val_Value_3,
        ____HandoverRequest_protocolIEs__item__id_tab,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_7,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_8,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_9,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_10,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_11,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_12,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_13,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_14,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_15,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_16,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_17,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_18,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_19,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_20,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_21,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_22,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_23,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_24,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_25,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_26,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_27,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_28,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_29,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_30,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_31,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_32,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_33,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_34,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_35,
        _____HandoverRequest_protocolIEs__item__id_tab_val_Value_36,
        ___HandoverRequest_protocolIEs__item__id,
        ___HandoverRequest_protocolIEs__item__criticality,
        ___HandoverRequest_protocolIEs__item__value,
        __HandoverRequest_protocolIEs__item_,
        _HandoverRequest_protocolIEs,
        HandoverRequest,
        HandoverRequestIEs,
        _HandoverRequestIEs_val_Value_0,
        _HandoverRequestIEs_val_Value_1,
        _HandoverRequestIEs_val_Value_2,
        _HandoverRequestIEs_val_Value_3,
        _HandoverRequestIEs_val_Value_4,
        _HandoverRequestIEs_val_Value_5,
        _HandoverRequestIEs_val_Value_6,
        _HandoverRequestIEs_val_Value_7,
        _HandoverRequestIEs_val_Value_8,
        _HandoverRequestIEs_val_Value_9,
        _HandoverRequestIEs_val_Value_10,
        _HandoverRequestIEs_val_Value_11,
        _HandoverRequestIEs_val_Value_12,
        _HandoverRequestIEs_val_Value_13,
        _HandoverRequestIEs_val_Value_14,
        _HandoverRequestIEs_val_Value_15,
        _HandoverRequestIEs_val_Value_16,
        _HandoverRequestIEs_val_Value_17,
        _HandoverRequestIEs_val_Value_18,
        _HandoverRequestIEs_val_Value_19,
        _HandoverRequestIEs_val_Value_20,
        _HandoverRequestIEs_val_Value_21,
        _HandoverRequestIEs_val_Value_22,
        _HandoverRequestIEs_val_Value_23,
        _HandoverRequestIEs_val_Value_24,
        _HandoverRequestIEs_val_Value_25,
        _HandoverRequestIEs_val_Value_26,
        _HandoverRequestIEs_val_Value_27,
        _HandoverRequestIEs_val_Value_28,
        _HandoverRequestIEs_val_Value_29,
        _HandoverRequestIEs_val_Value_30,
        _HandoverRequestIEs_val_Value_31,
        _HandoverRequestIEs_val_Value_32,
        _HandoverRequestIEs_val_Value_33,
        _HandoverRequestIEs_val_Value_34,
        _HandoverRequestIEs_val_Value_35,
        _HandoverRequestIEs_val_Value_36,
        ___E_RABToBeSetupListHOReq__item__id_tab,
        ____E_RABToBeSetupListHOReq__item__id_tab_val_Value_0,
        __E_RABToBeSetupListHOReq__item__id,
        __E_RABToBeSetupListHOReq__item__criticality,
        __E_RABToBeSetupListHOReq__item__value,
        _E_RABToBeSetupListHOReq__item_,
        E_RABToBeSetupListHOReq,
        E_RABToBeSetupItemHOReqIEs,
        _E_RABToBeSetupItemHOReqIEs_val_Value_0,
        _E_RABToBeSetupItemHOReq_e_RAB_ID,
        _E_RABToBeSetupItemHOReq_transportLayerAddress,
        _E_RABToBeSetupItemHOReq_gTP_TEID,
        _E_RABToBeSetupItemHOReq_e_RABlevelQosParameters,
        ____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab,
        _____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABToBeSetupItemHOReq_iE_Extensions__item__id_tab_val_Extension_2,
        ___E_RABToBeSetupItemHOReq_iE_Extensions__item__id,
        ___E_RABToBeSetupItemHOReq_iE_Extensions__item__criticality,
        ___E_RABToBeSetupItemHOReq_iE_Extensions__item__extensionValue,
        __E_RABToBeSetupItemHOReq_iE_Extensions__item_,
        _E_RABToBeSetupItemHOReq_iE_Extensions,
        E_RABToBeSetupItemHOReq,
        E_RABToBeSetupItemHOReq_ExtIEs,
        _E_RABToBeSetupItemHOReq_ExtIEs_val_Extension_0,
        _E_RABToBeSetupItemHOReq_ExtIEs_val_Extension_1,
        _E_RABToBeSetupItemHOReq_ExtIEs_val_Extension_2,
        ____HandoverRequestAcknowledge_protocolIEs__item__id_tab,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7,
        _____HandoverRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8,
        ___HandoverRequestAcknowledge_protocolIEs__item__id,
        ___HandoverRequestAcknowledge_protocolIEs__item__criticality,
        ___HandoverRequestAcknowledge_protocolIEs__item__value,
        __HandoverRequestAcknowledge_protocolIEs__item_,
        _HandoverRequestAcknowledge_protocolIEs,
        HandoverRequestAcknowledge,
        HandoverRequestAcknowledgeIEs,
        _HandoverRequestAcknowledgeIEs_val_Value_0,
        _HandoverRequestAcknowledgeIEs_val_Value_1,
        _HandoverRequestAcknowledgeIEs_val_Value_2,
        _HandoverRequestAcknowledgeIEs_val_Value_3,
        _HandoverRequestAcknowledgeIEs_val_Value_4,
        _HandoverRequestAcknowledgeIEs_val_Value_5,
        _HandoverRequestAcknowledgeIEs_val_Value_6,
        _HandoverRequestAcknowledgeIEs_val_Value_7,
        _HandoverRequestAcknowledgeIEs_val_Value_8,
        ___E_RABAdmittedList__item__id_tab,
        ____E_RABAdmittedList__item__id_tab_val_Value_0,
        __E_RABAdmittedList__item__id,
        __E_RABAdmittedList__item__criticality,
        __E_RABAdmittedList__item__value,
        _E_RABAdmittedList__item_,
        E_RABAdmittedList,
        E_RABAdmittedItemIEs,
        _E_RABAdmittedItemIEs_val_Value_0,
        _E_RABAdmittedItem_e_RAB_ID,
        _E_RABAdmittedItem_transportLayerAddress,
        _E_RABAdmittedItem_gTP_TEID,
        _E_RABAdmittedItem_dL_transportLayerAddress,
        _E_RABAdmittedItem_dL_gTP_TEID,
        _E_RABAdmittedItem_uL_TransportLayerAddress,
        _E_RABAdmittedItem_uL_GTP_TEID,
        ____E_RABAdmittedItem_iE_Extensions__item__id_tab,
        ___E_RABAdmittedItem_iE_Extensions__item__id,
        ____E_RABAdmittedItem_iE_Extensions__item__criticality_tab,
        ___E_RABAdmittedItem_iE_Extensions__item__criticality,
        ____E_RABAdmittedItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABAdmittedItem_iE_Extensions__item__extensionValue,
        __E_RABAdmittedItem_iE_Extensions__item_,
        _E_RABAdmittedItem_iE_Extensions,
        E_RABAdmittedItem,
        E_RABAdmittedItem_ExtIEs,
        ___E_RABFailedtoSetupListHOReqAck__item__id_tab,
        ____E_RABFailedtoSetupListHOReqAck__item__id_tab_val_Value_0,
        __E_RABFailedtoSetupListHOReqAck__item__id,
        __E_RABFailedtoSetupListHOReqAck__item__criticality,
        __E_RABFailedtoSetupListHOReqAck__item__value,
        _E_RABFailedtoSetupListHOReqAck__item_,
        E_RABFailedtoSetupListHOReqAck,
        E_RABFailedtoSetupItemHOReqAckIEs,
        _E_RABFailedtoSetupItemHOReqAckIEs_val_Value_0,
        _E_RABFailedToSetupItemHOReqAck_e_RAB_ID,
        _E_RABFailedToSetupItemHOReqAck_cause,
        ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__id_tab,
        ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__id,
        ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__criticality_tab,
        ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__criticality,
        ____E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__extensionValue_tab,
        ___E_RABFailedToSetupItemHOReqAck_iE_Extensions__item__extensionValue,
        __E_RABFailedToSetupItemHOReqAck_iE_Extensions__item_,
        _E_RABFailedToSetupItemHOReqAck_iE_Extensions,
        E_RABFailedToSetupItemHOReqAck,
        E_RABFailedToSetupItemHOReqAckExtIEs,
        ____HandoverFailure_protocolIEs__item__id_tab,
        _____HandoverFailure_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverFailure_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverFailure_protocolIEs__item__id_tab_val_Value_2,
        ___HandoverFailure_protocolIEs__item__id,
        ___HandoverFailure_protocolIEs__item__criticality,
        ___HandoverFailure_protocolIEs__item__value,
        __HandoverFailure_protocolIEs__item_,
        _HandoverFailure_protocolIEs,
        HandoverFailure,
        HandoverFailureIEs,
        _HandoverFailureIEs_val_Value_0,
        _HandoverFailureIEs_val_Value_1,
        _HandoverFailureIEs_val_Value_2,
        ____HandoverNotify_protocolIEs__item__id_tab,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_2,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_3,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_4,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_5,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_6,
        _____HandoverNotify_protocolIEs__item__id_tab_val_Value_7,
        ___HandoverNotify_protocolIEs__item__id,
        ___HandoverNotify_protocolIEs__item__criticality,
        ___HandoverNotify_protocolIEs__item__value,
        __HandoverNotify_protocolIEs__item_,
        _HandoverNotify_protocolIEs,
        HandoverNotify,
        HandoverNotifyIEs,
        _HandoverNotifyIEs_val_Value_0,
        _HandoverNotifyIEs_val_Value_1,
        _HandoverNotifyIEs_val_Value_2,
        _HandoverNotifyIEs_val_Value_3,
        _HandoverNotifyIEs_val_Value_4,
        _HandoverNotifyIEs_val_Value_5,
        _HandoverNotifyIEs_val_Value_6,
        _HandoverNotifyIEs_val_Value_7,
        ____PathSwitchRequest_protocolIEs__item__id_tab,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_3,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_4,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_5,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_6,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_7,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_8,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_9,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_10,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_11,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_12,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_13,
        _____PathSwitchRequest_protocolIEs__item__id_tab_val_Value_14,
        ___PathSwitchRequest_protocolIEs__item__id,
        ___PathSwitchRequest_protocolIEs__item__criticality,
        ___PathSwitchRequest_protocolIEs__item__value,
        __PathSwitchRequest_protocolIEs__item_,
        _PathSwitchRequest_protocolIEs,
        PathSwitchRequest,
        PathSwitchRequestIEs,
        _PathSwitchRequestIEs_val_Value_0,
        _PathSwitchRequestIEs_val_Value_1,
        _PathSwitchRequestIEs_val_Value_2,
        _PathSwitchRequestIEs_val_Value_3,
        _PathSwitchRequestIEs_val_Value_4,
        _PathSwitchRequestIEs_val_Value_5,
        _PathSwitchRequestIEs_val_Value_6,
        _PathSwitchRequestIEs_val_Value_7,
        _PathSwitchRequestIEs_val_Value_8,
        _PathSwitchRequestIEs_val_Value_9,
        _PathSwitchRequestIEs_val_Value_10,
        _PathSwitchRequestIEs_val_Value_11,
        _PathSwitchRequestIEs_val_Value_12,
        _PathSwitchRequestIEs_val_Value_13,
        _PathSwitchRequestIEs_val_Value_14,
        ___E_RABToBeSwitchedDLList__item__id_tab,
        ____E_RABToBeSwitchedDLList__item__id_tab_val_Value_0,
        __E_RABToBeSwitchedDLList__item__id,
        __E_RABToBeSwitchedDLList__item__criticality,
        __E_RABToBeSwitchedDLList__item__value,
        _E_RABToBeSwitchedDLList__item_,
        E_RABToBeSwitchedDLList,
        E_RABToBeSwitchedDLItemIEs,
        _E_RABToBeSwitchedDLItemIEs_val_Value_0,
        _E_RABToBeSwitchedDLItem_e_RAB_ID,
        _E_RABToBeSwitchedDLItem_transportLayerAddress,
        _E_RABToBeSwitchedDLItem_gTP_TEID,
        ____E_RABToBeSwitchedDLItem_iE_Extensions__item__id_tab,
        ___E_RABToBeSwitchedDLItem_iE_Extensions__item__id,
        ____E_RABToBeSwitchedDLItem_iE_Extensions__item__criticality_tab,
        ___E_RABToBeSwitchedDLItem_iE_Extensions__item__criticality,
        ____E_RABToBeSwitchedDLItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABToBeSwitchedDLItem_iE_Extensions__item__extensionValue,
        __E_RABToBeSwitchedDLItem_iE_Extensions__item_,
        _E_RABToBeSwitchedDLItem_iE_Extensions,
        E_RABToBeSwitchedDLItem,
        E_RABToBeSwitchedDLItem_ExtIEs,
        ____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_7,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_8,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_9,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_10,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_11,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_12,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_13,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_14,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_15,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_16,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_17,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_18,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_19,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_20,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_21,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_22,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_23,
        _____PathSwitchRequestAcknowledge_protocolIEs__item__id_tab_val_Value_24,
        ___PathSwitchRequestAcknowledge_protocolIEs__item__id,
        ___PathSwitchRequestAcknowledge_protocolIEs__item__criticality,
        ___PathSwitchRequestAcknowledge_protocolIEs__item__value,
        __PathSwitchRequestAcknowledge_protocolIEs__item_,
        _PathSwitchRequestAcknowledge_protocolIEs,
        PathSwitchRequestAcknowledge,
        PathSwitchRequestAcknowledgeIEs,
        _PathSwitchRequestAcknowledgeIEs_val_Value_0,
        _PathSwitchRequestAcknowledgeIEs_val_Value_1,
        _PathSwitchRequestAcknowledgeIEs_val_Value_2,
        _PathSwitchRequestAcknowledgeIEs_val_Value_3,
        _PathSwitchRequestAcknowledgeIEs_val_Value_4,
        _PathSwitchRequestAcknowledgeIEs_val_Value_5,
        _PathSwitchRequestAcknowledgeIEs_val_Value_6,
        _PathSwitchRequestAcknowledgeIEs_val_Value_7,
        _PathSwitchRequestAcknowledgeIEs_val_Value_8,
        _PathSwitchRequestAcknowledgeIEs_val_Value_9,
        _PathSwitchRequestAcknowledgeIEs_val_Value_10,
        _PathSwitchRequestAcknowledgeIEs_val_Value_11,
        _PathSwitchRequestAcknowledgeIEs_val_Value_12,
        _PathSwitchRequestAcknowledgeIEs_val_Value_13,
        _PathSwitchRequestAcknowledgeIEs_val_Value_14,
        _PathSwitchRequestAcknowledgeIEs_val_Value_15,
        _PathSwitchRequestAcknowledgeIEs_val_Value_16,
        _PathSwitchRequestAcknowledgeIEs_val_Value_17,
        _PathSwitchRequestAcknowledgeIEs_val_Value_18,
        _PathSwitchRequestAcknowledgeIEs_val_Value_19,
        _PathSwitchRequestAcknowledgeIEs_val_Value_20,
        _PathSwitchRequestAcknowledgeIEs_val_Value_21,
        _PathSwitchRequestAcknowledgeIEs_val_Value_22,
        _PathSwitchRequestAcknowledgeIEs_val_Value_23,
        _PathSwitchRequestAcknowledgeIEs_val_Value_24,
        ___E_RABToBeSwitchedULList__item__id_tab,
        ____E_RABToBeSwitchedULList__item__id_tab_val_Value_0,
        __E_RABToBeSwitchedULList__item__id,
        __E_RABToBeSwitchedULList__item__criticality,
        __E_RABToBeSwitchedULList__item__value,
        _E_RABToBeSwitchedULList__item_,
        E_RABToBeSwitchedULList,
        E_RABToBeSwitchedULItemIEs,
        _E_RABToBeSwitchedULItemIEs_val_Value_0,
        _E_RABToBeSwitchedULItem_e_RAB_ID,
        _E_RABToBeSwitchedULItem_transportLayerAddress,
        _E_RABToBeSwitchedULItem_gTP_TEID,
        ____E_RABToBeSwitchedULItem_iE_Extensions__item__id_tab,
        ___E_RABToBeSwitchedULItem_iE_Extensions__item__id,
        ____E_RABToBeSwitchedULItem_iE_Extensions__item__criticality_tab,
        ___E_RABToBeSwitchedULItem_iE_Extensions__item__criticality,
        ____E_RABToBeSwitchedULItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABToBeSwitchedULItem_iE_Extensions__item__extensionValue,
        __E_RABToBeSwitchedULItem_iE_Extensions__item_,
        _E_RABToBeSwitchedULItem_iE_Extensions,
        E_RABToBeSwitchedULItem,
        E_RABToBeSwitchedULItem_ExtIEs,
        ____PathSwitchRequestFailure_protocolIEs__item__id_tab,
        _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_1,
        _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_2,
        _____PathSwitchRequestFailure_protocolIEs__item__id_tab_val_Value_3,
        ___PathSwitchRequestFailure_protocolIEs__item__id,
        ___PathSwitchRequestFailure_protocolIEs__item__criticality,
        ___PathSwitchRequestFailure_protocolIEs__item__value,
        __PathSwitchRequestFailure_protocolIEs__item_,
        _PathSwitchRequestFailure_protocolIEs,
        PathSwitchRequestFailure,
        PathSwitchRequestFailureIEs,
        _PathSwitchRequestFailureIEs_val_Value_0,
        _PathSwitchRequestFailureIEs_val_Value_1,
        _PathSwitchRequestFailureIEs_val_Value_2,
        _PathSwitchRequestFailureIEs_val_Value_3,
        ____HandoverCancel_protocolIEs__item__id_tab,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverCancel_protocolIEs__item__id_tab_val_Value_2,
        ___HandoverCancel_protocolIEs__item__id,
        ___HandoverCancel_protocolIEs__item__criticality,
        ___HandoverCancel_protocolIEs__item__value,
        __HandoverCancel_protocolIEs__item_,
        _HandoverCancel_protocolIEs,
        HandoverCancel,
        HandoverCancelIEs,
        _HandoverCancelIEs_val_Value_0,
        _HandoverCancelIEs_val_Value_1,
        _HandoverCancelIEs_val_Value_2,
        ____HandoverCancelAcknowledge_protocolIEs__item__id_tab,
        _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____HandoverCancelAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        ___HandoverCancelAcknowledge_protocolIEs__item__id,
        ___HandoverCancelAcknowledge_protocolIEs__item__criticality,
        ___HandoverCancelAcknowledge_protocolIEs__item__value,
        __HandoverCancelAcknowledge_protocolIEs__item_,
        _HandoverCancelAcknowledge_protocolIEs,
        HandoverCancelAcknowledge,
        HandoverCancelAcknowledgeIEs,
        _HandoverCancelAcknowledgeIEs_val_Value_0,
        _HandoverCancelAcknowledgeIEs_val_Value_1,
        _HandoverCancelAcknowledgeIEs_val_Value_2,
        ____HandoverSuccess_protocolIEs__item__id_tab,
        _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_0,
        _____HandoverSuccess_protocolIEs__item__id_tab_val_Value_1,
        ___HandoverSuccess_protocolIEs__item__id,
        ___HandoverSuccess_protocolIEs__item__criticality,
        ___HandoverSuccess_protocolIEs__item__value,
        __HandoverSuccess_protocolIEs__item_,
        _HandoverSuccess_protocolIEs,
        HandoverSuccess,
        HandoverSuccessIEs,
        _HandoverSuccessIEs_val_Value_0,
        _HandoverSuccessIEs_val_Value_1,
        ____ENBEarlyStatusTransfer_protocolIEs__item__id_tab,
        _____ENBEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____ENBEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____ENBEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___ENBEarlyStatusTransfer_protocolIEs__item__id,
        ___ENBEarlyStatusTransfer_protocolIEs__item__criticality,
        ___ENBEarlyStatusTransfer_protocolIEs__item__value,
        __ENBEarlyStatusTransfer_protocolIEs__item_,
        _ENBEarlyStatusTransfer_protocolIEs,
        ENBEarlyStatusTransfer,
        ENBEarlyStatusTransferIEs,
        _ENBEarlyStatusTransferIEs_val_Value_0,
        _ENBEarlyStatusTransferIEs_val_Value_1,
        _ENBEarlyStatusTransferIEs_val_Value_2,
        ____MMEEarlyStatusTransfer_protocolIEs__item__id_tab,
        _____MMEEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____MMEEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____MMEEarlyStatusTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___MMEEarlyStatusTransfer_protocolIEs__item__id,
        ___MMEEarlyStatusTransfer_protocolIEs__item__criticality,
        ___MMEEarlyStatusTransfer_protocolIEs__item__value,
        __MMEEarlyStatusTransfer_protocolIEs__item_,
        _MMEEarlyStatusTransfer_protocolIEs,
        MMEEarlyStatusTransfer,
        MMEEarlyStatusTransferIEs,
        _MMEEarlyStatusTransferIEs_val_Value_0,
        _MMEEarlyStatusTransferIEs_val_Value_1,
        _MMEEarlyStatusTransferIEs_val_Value_2,
        ____E_RABSetupRequest_protocolIEs__item__id_tab,
        _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____E_RABSetupRequest_protocolIEs__item__id_tab_val_Value_3,
        ___E_RABSetupRequest_protocolIEs__item__id,
        ___E_RABSetupRequest_protocolIEs__item__criticality,
        ___E_RABSetupRequest_protocolIEs__item__value,
        __E_RABSetupRequest_protocolIEs__item_,
        _E_RABSetupRequest_protocolIEs,
        E_RABSetupRequest,
        E_RABSetupRequestIEs,
        _E_RABSetupRequestIEs_val_Value_0,
        _E_RABSetupRequestIEs_val_Value_1,
        _E_RABSetupRequestIEs_val_Value_2,
        _E_RABSetupRequestIEs_val_Value_3,
        ___E_RABToBeSetupListBearerSUReq__item__id_tab,
        ____E_RABToBeSetupListBearerSUReq__item__id_tab_val_Value_0,
        __E_RABToBeSetupListBearerSUReq__item__id,
        __E_RABToBeSetupListBearerSUReq__item__criticality,
        __E_RABToBeSetupListBearerSUReq__item__value,
        _E_RABToBeSetupListBearerSUReq__item_,
        E_RABToBeSetupListBearerSUReq,
        E_RABToBeSetupItemBearerSUReqIEs,
        _E_RABToBeSetupItemBearerSUReqIEs_val_Value_0,
        _E_RABToBeSetupItemBearerSUReq_e_RAB_ID,
        _E_RABToBeSetupItemBearerSUReq_e_RABlevelQoSParameters,
        _E_RABToBeSetupItemBearerSUReq_transportLayerAddress,
        _E_RABToBeSetupItemBearerSUReq_gTP_TEID,
        _E_RABToBeSetupItemBearerSUReq_nAS_PDU,
        ____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab,
        _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_2,
        _____E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id_tab_val_Extension_3,
        ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__id,
        ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__criticality,
        ___E_RABToBeSetupItemBearerSUReq_iE_Extensions__item__extensionValue,
        __E_RABToBeSetupItemBearerSUReq_iE_Extensions__item_,
        _E_RABToBeSetupItemBearerSUReq_iE_Extensions,
        E_RABToBeSetupItemBearerSUReq,
        E_RABToBeSetupItemBearerSUReqExtIEs,
        _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_0,
        _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_1,
        _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_2,
        _E_RABToBeSetupItemBearerSUReqExtIEs_val_Extension_3,
        ____E_RABSetupResponse_protocolIEs__item__id_tab,
        _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____E_RABSetupResponse_protocolIEs__item__id_tab_val_Value_4,
        ___E_RABSetupResponse_protocolIEs__item__id,
        ___E_RABSetupResponse_protocolIEs__item__criticality,
        ___E_RABSetupResponse_protocolIEs__item__value,
        __E_RABSetupResponse_protocolIEs__item_,
        _E_RABSetupResponse_protocolIEs,
        E_RABSetupResponse,
        E_RABSetupResponseIEs,
        _E_RABSetupResponseIEs_val_Value_0,
        _E_RABSetupResponseIEs_val_Value_1,
        _E_RABSetupResponseIEs_val_Value_2,
        _E_RABSetupResponseIEs_val_Value_3,
        _E_RABSetupResponseIEs_val_Value_4,
        ___E_RABSetupListBearerSURes__item__id_tab,
        ____E_RABSetupListBearerSURes__item__id_tab_val_Value_0,
        __E_RABSetupListBearerSURes__item__id,
        __E_RABSetupListBearerSURes__item__criticality,
        __E_RABSetupListBearerSURes__item__value,
        _E_RABSetupListBearerSURes__item_,
        E_RABSetupListBearerSURes,
        E_RABSetupItemBearerSUResIEs,
        _E_RABSetupItemBearerSUResIEs_val_Value_0,
        _E_RABSetupItemBearerSURes_e_RAB_ID,
        _E_RABSetupItemBearerSURes_transportLayerAddress,
        _E_RABSetupItemBearerSURes_gTP_TEID,
        ____E_RABSetupItemBearerSURes_iE_Extensions__item__id_tab,
        ___E_RABSetupItemBearerSURes_iE_Extensions__item__id,
        ____E_RABSetupItemBearerSURes_iE_Extensions__item__criticality_tab,
        ___E_RABSetupItemBearerSURes_iE_Extensions__item__criticality,
        ____E_RABSetupItemBearerSURes_iE_Extensions__item__extensionValue_tab,
        ___E_RABSetupItemBearerSURes_iE_Extensions__item__extensionValue,
        __E_RABSetupItemBearerSURes_iE_Extensions__item_,
        _E_RABSetupItemBearerSURes_iE_Extensions,
        E_RABSetupItemBearerSURes,
        E_RABSetupItemBearerSUResExtIEs,
        ____E_RABModifyRequest_protocolIEs__item__id_tab,
        _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_0,
        _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_1,
        _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_2,
        _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_3,
        _____E_RABModifyRequest_protocolIEs__item__id_tab_val_Value_4,
        ___E_RABModifyRequest_protocolIEs__item__id,
        ___E_RABModifyRequest_protocolIEs__item__criticality,
        ___E_RABModifyRequest_protocolIEs__item__value,
        __E_RABModifyRequest_protocolIEs__item_,
        _E_RABModifyRequest_protocolIEs,
        E_RABModifyRequest,
        E_RABModifyRequestIEs,
        _E_RABModifyRequestIEs_val_Value_0,
        _E_RABModifyRequestIEs_val_Value_1,
        _E_RABModifyRequestIEs_val_Value_2,
        _E_RABModifyRequestIEs_val_Value_3,
        _E_RABModifyRequestIEs_val_Value_4,
        ___E_RABToBeModifiedListBearerModReq__item__id_tab,
        ____E_RABToBeModifiedListBearerModReq__item__id_tab_val_Value_0,
        __E_RABToBeModifiedListBearerModReq__item__id,
        __E_RABToBeModifiedListBearerModReq__item__criticality,
        __E_RABToBeModifiedListBearerModReq__item__value,
        _E_RABToBeModifiedListBearerModReq__item_,
        E_RABToBeModifiedListBearerModReq,
        E_RABToBeModifiedItemBearerModReqIEs,
        _E_RABToBeModifiedItemBearerModReqIEs_val_Value_0,
        _E_RABToBeModifiedItemBearerModReq_e_RAB_ID,
        _E_RABToBeModifiedItemBearerModReq_e_RABLevelQoSParameters,
        _E_RABToBeModifiedItemBearerModReq_nAS_PDU,
        ____E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id_tab,
        _____E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__id,
        ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__criticality,
        ___E_RABToBeModifiedItemBearerModReq_iE_Extensions__item__extensionValue,
        __E_RABToBeModifiedItemBearerModReq_iE_Extensions__item_,
        _E_RABToBeModifiedItemBearerModReq_iE_Extensions,
        E_RABToBeModifiedItemBearerModReq,
        E_RABToBeModifyItemBearerModReqExtIEs,
        _E_RABToBeModifyItemBearerModReqExtIEs_val_Extension_0,
        ____E_RABModifyResponse_protocolIEs__item__id_tab,
        _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_0,
        _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_1,
        _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_2,
        _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_3,
        _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_4,
        _____E_RABModifyResponse_protocolIEs__item__id_tab_val_Value_5,
        ___E_RABModifyResponse_protocolIEs__item__id,
        ___E_RABModifyResponse_protocolIEs__item__criticality,
        ___E_RABModifyResponse_protocolIEs__item__value,
        __E_RABModifyResponse_protocolIEs__item_,
        _E_RABModifyResponse_protocolIEs,
        E_RABModifyResponse,
        E_RABModifyResponseIEs,
        _E_RABModifyResponseIEs_val_Value_0,
        _E_RABModifyResponseIEs_val_Value_1,
        _E_RABModifyResponseIEs_val_Value_2,
        _E_RABModifyResponseIEs_val_Value_3,
        _E_RABModifyResponseIEs_val_Value_4,
        _E_RABModifyResponseIEs_val_Value_5,
        ___E_RABModifyListBearerModRes__item__id_tab,
        ____E_RABModifyListBearerModRes__item__id_tab_val_Value_0,
        __E_RABModifyListBearerModRes__item__id,
        __E_RABModifyListBearerModRes__item__criticality,
        __E_RABModifyListBearerModRes__item__value,
        _E_RABModifyListBearerModRes__item_,
        E_RABModifyListBearerModRes,
        E_RABModifyItemBearerModResIEs,
        _E_RABModifyItemBearerModResIEs_val_Value_0,
        _E_RABModifyItemBearerModRes_e_RAB_ID,
        ____E_RABModifyItemBearerModRes_iE_Extensions__item__id_tab,
        ___E_RABModifyItemBearerModRes_iE_Extensions__item__id,
        ____E_RABModifyItemBearerModRes_iE_Extensions__item__criticality_tab,
        ___E_RABModifyItemBearerModRes_iE_Extensions__item__criticality,
        ____E_RABModifyItemBearerModRes_iE_Extensions__item__extensionValue_tab,
        ___E_RABModifyItemBearerModRes_iE_Extensions__item__extensionValue,
        __E_RABModifyItemBearerModRes_iE_Extensions__item_,
        _E_RABModifyItemBearerModRes_iE_Extensions,
        E_RABModifyItemBearerModRes,
        E_RABModifyItemBearerModResExtIEs,
        ____E_RABReleaseCommand_protocolIEs__item__id_tab,
        _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_0,
        _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_1,
        _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_2,
        _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_3,
        _____E_RABReleaseCommand_protocolIEs__item__id_tab_val_Value_4,
        ___E_RABReleaseCommand_protocolIEs__item__id,
        ___E_RABReleaseCommand_protocolIEs__item__criticality,
        ___E_RABReleaseCommand_protocolIEs__item__value,
        __E_RABReleaseCommand_protocolIEs__item_,
        _E_RABReleaseCommand_protocolIEs,
        E_RABReleaseCommand,
        E_RABReleaseCommandIEs,
        _E_RABReleaseCommandIEs_val_Value_0,
        _E_RABReleaseCommandIEs_val_Value_1,
        _E_RABReleaseCommandIEs_val_Value_2,
        _E_RABReleaseCommandIEs_val_Value_3,
        _E_RABReleaseCommandIEs_val_Value_4,
        ____E_RABReleaseResponse_protocolIEs__item__id_tab,
        _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_0,
        _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_1,
        _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_2,
        _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_3,
        _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_4,
        _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_5,
        _____E_RABReleaseResponse_protocolIEs__item__id_tab_val_Value_6,
        ___E_RABReleaseResponse_protocolIEs__item__id,
        ___E_RABReleaseResponse_protocolIEs__item__criticality,
        ___E_RABReleaseResponse_protocolIEs__item__value,
        __E_RABReleaseResponse_protocolIEs__item_,
        _E_RABReleaseResponse_protocolIEs,
        E_RABReleaseResponse,
        E_RABReleaseResponseIEs,
        _E_RABReleaseResponseIEs_val_Value_0,
        _E_RABReleaseResponseIEs_val_Value_1,
        _E_RABReleaseResponseIEs_val_Value_2,
        _E_RABReleaseResponseIEs_val_Value_3,
        _E_RABReleaseResponseIEs_val_Value_4,
        _E_RABReleaseResponseIEs_val_Value_5,
        _E_RABReleaseResponseIEs_val_Value_6,
        ___E_RABReleaseListBearerRelComp__item__id_tab,
        ____E_RABReleaseListBearerRelComp__item__id_tab_val_Value_0,
        __E_RABReleaseListBearerRelComp__item__id,
        __E_RABReleaseListBearerRelComp__item__criticality,
        __E_RABReleaseListBearerRelComp__item__value,
        _E_RABReleaseListBearerRelComp__item_,
        E_RABReleaseListBearerRelComp,
        E_RABReleaseItemBearerRelCompIEs,
        _E_RABReleaseItemBearerRelCompIEs_val_Value_0,
        _E_RABReleaseItemBearerRelComp_e_RAB_ID,
        ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__id_tab,
        ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__id,
        ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__criticality_tab,
        ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__criticality,
        ____E_RABReleaseItemBearerRelComp_iE_Extensions__item__extensionValue_tab,
        ___E_RABReleaseItemBearerRelComp_iE_Extensions__item__extensionValue,
        __E_RABReleaseItemBearerRelComp_iE_Extensions__item_,
        _E_RABReleaseItemBearerRelComp_iE_Extensions,
        E_RABReleaseItemBearerRelComp,
        E_RABReleaseItemBearerRelCompExtIEs,
        ____E_RABReleaseIndication_protocolIEs__item__id_tab,
        _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_0,
        _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_1,
        _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_2,
        _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_3,
        _____E_RABReleaseIndication_protocolIEs__item__id_tab_val_Value_4,
        ___E_RABReleaseIndication_protocolIEs__item__id,
        ___E_RABReleaseIndication_protocolIEs__item__criticality,
        ___E_RABReleaseIndication_protocolIEs__item__value,
        __E_RABReleaseIndication_protocolIEs__item_,
        _E_RABReleaseIndication_protocolIEs,
        E_RABReleaseIndication,
        E_RABReleaseIndicationIEs,
        _E_RABReleaseIndicationIEs_val_Value_0,
        _E_RABReleaseIndicationIEs_val_Value_1,
        _E_RABReleaseIndicationIEs_val_Value_2,
        _E_RABReleaseIndicationIEs_val_Value_3,
        _E_RABReleaseIndicationIEs_val_Value_4,
        ____InitialContextSetupRequest_protocolIEs__item__id_tab,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_3,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_4,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_5,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_6,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_7,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_8,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_9,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_10,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_11,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_12,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_13,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_14,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_15,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_16,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_17,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_18,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_19,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_20,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_21,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_22,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_23,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_24,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_25,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_26,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_27,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_28,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_29,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_30,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_31,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_32,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_33,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_34,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_35,
        _____InitialContextSetupRequest_protocolIEs__item__id_tab_val_Value_36,
        ___InitialContextSetupRequest_protocolIEs__item__id,
        ___InitialContextSetupRequest_protocolIEs__item__criticality,
        ___InitialContextSetupRequest_protocolIEs__item__value,
        __InitialContextSetupRequest_protocolIEs__item_,
        _InitialContextSetupRequest_protocolIEs,
        InitialContextSetupRequest,
        InitialContextSetupRequestIEs,
        _InitialContextSetupRequestIEs_val_Value_0,
        _InitialContextSetupRequestIEs_val_Value_1,
        _InitialContextSetupRequestIEs_val_Value_2,
        _InitialContextSetupRequestIEs_val_Value_3,
        _InitialContextSetupRequestIEs_val_Value_4,
        _InitialContextSetupRequestIEs_val_Value_5,
        _InitialContextSetupRequestIEs_val_Value_6,
        _InitialContextSetupRequestIEs_val_Value_7,
        _InitialContextSetupRequestIEs_val_Value_8,
        _InitialContextSetupRequestIEs_val_Value_9,
        _InitialContextSetupRequestIEs_val_Value_10,
        _InitialContextSetupRequestIEs_val_Value_11,
        _InitialContextSetupRequestIEs_val_Value_12,
        _InitialContextSetupRequestIEs_val_Value_13,
        _InitialContextSetupRequestIEs_val_Value_14,
        _InitialContextSetupRequestIEs_val_Value_15,
        _InitialContextSetupRequestIEs_val_Value_16,
        _InitialContextSetupRequestIEs_val_Value_17,
        _InitialContextSetupRequestIEs_val_Value_18,
        _InitialContextSetupRequestIEs_val_Value_19,
        _InitialContextSetupRequestIEs_val_Value_20,
        _InitialContextSetupRequestIEs_val_Value_21,
        _InitialContextSetupRequestIEs_val_Value_22,
        _InitialContextSetupRequestIEs_val_Value_23,
        _InitialContextSetupRequestIEs_val_Value_24,
        _InitialContextSetupRequestIEs_val_Value_25,
        _InitialContextSetupRequestIEs_val_Value_26,
        _InitialContextSetupRequestIEs_val_Value_27,
        _InitialContextSetupRequestIEs_val_Value_28,
        _InitialContextSetupRequestIEs_val_Value_29,
        _InitialContextSetupRequestIEs_val_Value_30,
        _InitialContextSetupRequestIEs_val_Value_31,
        _InitialContextSetupRequestIEs_val_Value_32,
        _InitialContextSetupRequestIEs_val_Value_33,
        _InitialContextSetupRequestIEs_val_Value_34,
        _InitialContextSetupRequestIEs_val_Value_35,
        _InitialContextSetupRequestIEs_val_Value_36,
        ___E_RABToBeSetupListCtxtSUReq__item__id_tab,
        ____E_RABToBeSetupListCtxtSUReq__item__id_tab_val_Value_0,
        __E_RABToBeSetupListCtxtSUReq__item__id,
        __E_RABToBeSetupListCtxtSUReq__item__criticality,
        __E_RABToBeSetupListCtxtSUReq__item__value,
        _E_RABToBeSetupListCtxtSUReq__item_,
        E_RABToBeSetupListCtxtSUReq,
        E_RABToBeSetupItemCtxtSUReqIEs,
        _E_RABToBeSetupItemCtxtSUReqIEs_val_Value_0,
        _E_RABToBeSetupItemCtxtSUReq_e_RAB_ID,
        _E_RABToBeSetupItemCtxtSUReq_e_RABlevelQoSParameters,
        _E_RABToBeSetupItemCtxtSUReq_transportLayerAddress,
        _E_RABToBeSetupItemCtxtSUReq_gTP_TEID,
        _E_RABToBeSetupItemCtxtSUReq_nAS_PDU,
        ____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab,
        _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_2,
        _____E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id_tab_val_Extension_3,
        ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__id,
        ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__criticality,
        ___E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item__extensionValue,
        __E_RABToBeSetupItemCtxtSUReq_iE_Extensions__item_,
        _E_RABToBeSetupItemCtxtSUReq_iE_Extensions,
        E_RABToBeSetupItemCtxtSUReq,
        E_RABToBeSetupItemCtxtSUReqExtIEs,
        _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_0,
        _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_1,
        _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_2,
        _E_RABToBeSetupItemCtxtSUReqExtIEs_val_Extension_3,
        ____InitialContextSetupResponse_protocolIEs__item__id_tab,
        _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____InitialContextSetupResponse_protocolIEs__item__id_tab_val_Value_4,
        ___InitialContextSetupResponse_protocolIEs__item__id,
        ___InitialContextSetupResponse_protocolIEs__item__criticality,
        ___InitialContextSetupResponse_protocolIEs__item__value,
        __InitialContextSetupResponse_protocolIEs__item_,
        _InitialContextSetupResponse_protocolIEs,
        InitialContextSetupResponse,
        InitialContextSetupResponseIEs,
        _InitialContextSetupResponseIEs_val_Value_0,
        _InitialContextSetupResponseIEs_val_Value_1,
        _InitialContextSetupResponseIEs_val_Value_2,
        _InitialContextSetupResponseIEs_val_Value_3,
        _InitialContextSetupResponseIEs_val_Value_4,
        ___E_RABSetupListCtxtSURes__item__id_tab,
        ____E_RABSetupListCtxtSURes__item__id_tab_val_Value_0,
        __E_RABSetupListCtxtSURes__item__id,
        __E_RABSetupListCtxtSURes__item__criticality,
        __E_RABSetupListCtxtSURes__item__value,
        _E_RABSetupListCtxtSURes__item_,
        E_RABSetupListCtxtSURes,
        E_RABSetupItemCtxtSUResIEs,
        _E_RABSetupItemCtxtSUResIEs_val_Value_0,
        _E_RABSetupItemCtxtSURes_e_RAB_ID,
        _E_RABSetupItemCtxtSURes_transportLayerAddress,
        _E_RABSetupItemCtxtSURes_gTP_TEID,
        ____E_RABSetupItemCtxtSURes_iE_Extensions__item__id_tab,
        ___E_RABSetupItemCtxtSURes_iE_Extensions__item__id,
        ____E_RABSetupItemCtxtSURes_iE_Extensions__item__criticality_tab,
        ___E_RABSetupItemCtxtSURes_iE_Extensions__item__criticality,
        ____E_RABSetupItemCtxtSURes_iE_Extensions__item__extensionValue_tab,
        ___E_RABSetupItemCtxtSURes_iE_Extensions__item__extensionValue,
        __E_RABSetupItemCtxtSURes_iE_Extensions__item_,
        _E_RABSetupItemCtxtSURes_iE_Extensions,
        E_RABSetupItemCtxtSURes,
        E_RABSetupItemCtxtSUResExtIEs,
        ____InitialContextSetupFailure_protocolIEs__item__id_tab,
        _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_2,
        _____InitialContextSetupFailure_protocolIEs__item__id_tab_val_Value_3,
        ___InitialContextSetupFailure_protocolIEs__item__id,
        ___InitialContextSetupFailure_protocolIEs__item__criticality,
        ___InitialContextSetupFailure_protocolIEs__item__value,
        __InitialContextSetupFailure_protocolIEs__item_,
        _InitialContextSetupFailure_protocolIEs,
        InitialContextSetupFailure,
        InitialContextSetupFailureIEs,
        _InitialContextSetupFailureIEs_val_Value_0,
        _InitialContextSetupFailureIEs_val_Value_1,
        _InitialContextSetupFailureIEs_val_Value_2,
        _InitialContextSetupFailureIEs_val_Value_3,
        ____Paging_protocolIEs__item__id_tab,
        _____Paging_protocolIEs__item__id_tab_val_Value_0,
        _____Paging_protocolIEs__item__id_tab_val_Value_1,
        _____Paging_protocolIEs__item__id_tab_val_Value_2,
        _____Paging_protocolIEs__item__id_tab_val_Value_3,
        _____Paging_protocolIEs__item__id_tab_val_Value_4,
        _____Paging_protocolIEs__item__id_tab_val_Value_5,
        _____Paging_protocolIEs__item__id_tab_val_Value_6,
        _____Paging_protocolIEs__item__id_tab_val_Value_7,
        _____Paging_protocolIEs__item__id_tab_val_Value_8,
        _____Paging_protocolIEs__item__id_tab_val_Value_9,
        _____Paging_protocolIEs__item__id_tab_val_Value_10,
        _____Paging_protocolIEs__item__id_tab_val_Value_11,
        _____Paging_protocolIEs__item__id_tab_val_Value_12,
        _____Paging_protocolIEs__item__id_tab_val_Value_13,
        _____Paging_protocolIEs__item__id_tab_val_Value_14,
        _____Paging_protocolIEs__item__id_tab_val_Value_15,
        _____Paging_protocolIEs__item__id_tab_val_Value_16,
        _____Paging_protocolIEs__item__id_tab_val_Value_17,
        ___Paging_protocolIEs__item__id,
        ___Paging_protocolIEs__item__criticality,
        ___Paging_protocolIEs__item__value,
        __Paging_protocolIEs__item_,
        _Paging_protocolIEs,
        Paging,
        PagingIEs,
        _PagingIEs_val_Value_0,
        _PagingIEs_val_Value_1,
        _PagingIEs_val_Value_2,
        _PagingIEs_val_Value_3,
        _PagingIEs_val_Value_4,
        _PagingIEs_val_Value_5,
        _PagingIEs_val_Value_6,
        _PagingIEs_val_Value_7,
        _PagingIEs_val_Value_8,
        _PagingIEs_val_Value_9,
        _PagingIEs_val_Value_10,
        _PagingIEs_val_Value_11,
        _PagingIEs_val_Value_12,
        _PagingIEs_val_Value_13,
        _PagingIEs_val_Value_14,
        _PagingIEs_val_Value_15,
        _PagingIEs_val_Value_16,
        _PagingIEs_val_Value_17,
        ___TAIList__item__id_tab,
        ____TAIList__item__id_tab_val_Value_0,
        __TAIList__item__id,
        __TAIList__item__criticality,
        __TAIList__item__value,
        _TAIList__item_,
        TAIList,
        TAIItemIEs,
        _TAIItemIEs_val_Value_0,
        _TAIItem_tAI,
        ____TAIItem_iE_Extensions__item__id_tab,
        ___TAIItem_iE_Extensions__item__id,
        ____TAIItem_iE_Extensions__item__criticality_tab,
        ___TAIItem_iE_Extensions__item__criticality,
        ____TAIItem_iE_Extensions__item__extensionValue_tab,
        ___TAIItem_iE_Extensions__item__extensionValue,
        __TAIItem_iE_Extensions__item_,
        _TAIItem_iE_Extensions,
        TAIItem,
        TAIItemExtIEs,
        ____UEContextReleaseRequest_protocolIEs__item__id_tab,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextReleaseRequest_protocolIEs__item__id_tab_val_Value_4,
        ___UEContextReleaseRequest_protocolIEs__item__id,
        ___UEContextReleaseRequest_protocolIEs__item__criticality,
        ___UEContextReleaseRequest_protocolIEs__item__value,
        __UEContextReleaseRequest_protocolIEs__item_,
        _UEContextReleaseRequest_protocolIEs,
        UEContextReleaseRequest,
        UEContextReleaseRequest_IEs,
        _UEContextReleaseRequest_IEs_val_Value_0,
        _UEContextReleaseRequest_IEs_val_Value_1,
        _UEContextReleaseRequest_IEs_val_Value_2,
        _UEContextReleaseRequest_IEs_val_Value_3,
        _UEContextReleaseRequest_IEs_val_Value_4,
        ____UEContextReleaseCommand_protocolIEs__item__id_tab,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextReleaseCommand_protocolIEs__item__id_tab_val_Value_1,
        ___UEContextReleaseCommand_protocolIEs__item__id,
        ___UEContextReleaseCommand_protocolIEs__item__criticality,
        ___UEContextReleaseCommand_protocolIEs__item__value,
        __UEContextReleaseCommand_protocolIEs__item_,
        _UEContextReleaseCommand_protocolIEs,
        UEContextReleaseCommand,
        UEContextReleaseCommand_IEs,
        _UEContextReleaseCommand_IEs_val_Value_0,
        _UEContextReleaseCommand_IEs_val_Value_1,
        ____UEContextReleaseComplete_protocolIEs__item__id_tab,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextReleaseComplete_protocolIEs__item__id_tab_val_Value_7,
        ___UEContextReleaseComplete_protocolIEs__item__id,
        ___UEContextReleaseComplete_protocolIEs__item__criticality,
        ___UEContextReleaseComplete_protocolIEs__item__value,
        __UEContextReleaseComplete_protocolIEs__item_,
        _UEContextReleaseComplete_protocolIEs,
        UEContextReleaseComplete,
        UEContextReleaseComplete_IEs,
        _UEContextReleaseComplete_IEs_val_Value_0,
        _UEContextReleaseComplete_IEs_val_Value_1,
        _UEContextReleaseComplete_IEs_val_Value_2,
        _UEContextReleaseComplete_IEs_val_Value_3,
        _UEContextReleaseComplete_IEs_val_Value_4,
        _UEContextReleaseComplete_IEs_val_Value_5,
        _UEContextReleaseComplete_IEs_val_Value_6,
        _UEContextReleaseComplete_IEs_val_Value_7,
        ____UEContextModificationRequest_protocolIEs__item__id_tab,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_6,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_7,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_8,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_9,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_10,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_11,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_12,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_13,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_14,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_15,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_16,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_17,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_18,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_19,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_20,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_21,
        _____UEContextModificationRequest_protocolIEs__item__id_tab_val_Value_22,
        ___UEContextModificationRequest_protocolIEs__item__id,
        ___UEContextModificationRequest_protocolIEs__item__criticality,
        ___UEContextModificationRequest_protocolIEs__item__value,
        __UEContextModificationRequest_protocolIEs__item_,
        _UEContextModificationRequest_protocolIEs,
        UEContextModificationRequest,
        UEContextModificationRequestIEs,
        _UEContextModificationRequestIEs_val_Value_0,
        _UEContextModificationRequestIEs_val_Value_1,
        _UEContextModificationRequestIEs_val_Value_2,
        _UEContextModificationRequestIEs_val_Value_3,
        _UEContextModificationRequestIEs_val_Value_4,
        _UEContextModificationRequestIEs_val_Value_5,
        _UEContextModificationRequestIEs_val_Value_6,
        _UEContextModificationRequestIEs_val_Value_7,
        _UEContextModificationRequestIEs_val_Value_8,
        _UEContextModificationRequestIEs_val_Value_9,
        _UEContextModificationRequestIEs_val_Value_10,
        _UEContextModificationRequestIEs_val_Value_11,
        _UEContextModificationRequestIEs_val_Value_12,
        _UEContextModificationRequestIEs_val_Value_13,
        _UEContextModificationRequestIEs_val_Value_14,
        _UEContextModificationRequestIEs_val_Value_15,
        _UEContextModificationRequestIEs_val_Value_16,
        _UEContextModificationRequestIEs_val_Value_17,
        _UEContextModificationRequestIEs_val_Value_18,
        _UEContextModificationRequestIEs_val_Value_19,
        _UEContextModificationRequestIEs_val_Value_20,
        _UEContextModificationRequestIEs_val_Value_21,
        _UEContextModificationRequestIEs_val_Value_22,
        ____UEContextModificationResponse_protocolIEs__item__id_tab,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationResponse_protocolIEs__item__id_tab_val_Value_2,
        ___UEContextModificationResponse_protocolIEs__item__id,
        ___UEContextModificationResponse_protocolIEs__item__criticality,
        ___UEContextModificationResponse_protocolIEs__item__value,
        __UEContextModificationResponse_protocolIEs__item_,
        _UEContextModificationResponse_protocolIEs,
        UEContextModificationResponse,
        UEContextModificationResponseIEs,
        _UEContextModificationResponseIEs_val_Value_0,
        _UEContextModificationResponseIEs_val_Value_1,
        _UEContextModificationResponseIEs_val_Value_2,
        ____UEContextModificationFailure_protocolIEs__item__id_tab,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextModificationFailure_protocolIEs__item__id,
        ___UEContextModificationFailure_protocolIEs__item__criticality,
        ___UEContextModificationFailure_protocolIEs__item__value,
        __UEContextModificationFailure_protocolIEs__item_,
        _UEContextModificationFailure_protocolIEs,
        UEContextModificationFailure,
        UEContextModificationFailureIEs,
        _UEContextModificationFailureIEs_val_Value_0,
        _UEContextModificationFailureIEs_val_Value_1,
        _UEContextModificationFailureIEs_val_Value_2,
        _UEContextModificationFailureIEs_val_Value_3,
        ____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab,
        _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UERadioCapabilityMatchRequest_protocolIEs__item__id_tab_val_Value_3,
        ___UERadioCapabilityMatchRequest_protocolIEs__item__id,
        ___UERadioCapabilityMatchRequest_protocolIEs__item__criticality,
        ___UERadioCapabilityMatchRequest_protocolIEs__item__value,
        __UERadioCapabilityMatchRequest_protocolIEs__item_,
        _UERadioCapabilityMatchRequest_protocolIEs,
        UERadioCapabilityMatchRequest,
        UERadioCapabilityMatchRequestIEs,
        _UERadioCapabilityMatchRequestIEs_val_Value_0,
        _UERadioCapabilityMatchRequestIEs_val_Value_1,
        _UERadioCapabilityMatchRequestIEs_val_Value_2,
        _UERadioCapabilityMatchRequestIEs_val_Value_3,
        ____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab,
        _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_2,
        _____UERadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_3,
        ___UERadioCapabilityMatchResponse_protocolIEs__item__id,
        ___UERadioCapabilityMatchResponse_protocolIEs__item__criticality,
        ___UERadioCapabilityMatchResponse_protocolIEs__item__value,
        __UERadioCapabilityMatchResponse_protocolIEs__item_,
        _UERadioCapabilityMatchResponse_protocolIEs,
        UERadioCapabilityMatchResponse,
        UERadioCapabilityMatchResponseIEs,
        _UERadioCapabilityMatchResponseIEs_val_Value_0,
        _UERadioCapabilityMatchResponseIEs_val_Value_1,
        _UERadioCapabilityMatchResponseIEs_val_Value_2,
        _UERadioCapabilityMatchResponseIEs_val_Value_3,
        ____DownlinkNASTransport_protocolIEs__item__id_tab,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_0,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_1,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_2,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_3,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_4,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_5,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_6,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_7,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_8,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_9,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_10,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_11,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_12,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_13,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_14,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_15,
        _____DownlinkNASTransport_protocolIEs__item__id_tab_val_Value_16,
        ___DownlinkNASTransport_protocolIEs__item__id,
        ___DownlinkNASTransport_protocolIEs__item__criticality,
        ___DownlinkNASTransport_protocolIEs__item__value,
        __DownlinkNASTransport_protocolIEs__item_,
        _DownlinkNASTransport_protocolIEs,
        DownlinkNASTransport,
        DownlinkNASTransport_IEs,
        _DownlinkNASTransport_IEs_val_Value_0,
        _DownlinkNASTransport_IEs_val_Value_1,
        _DownlinkNASTransport_IEs_val_Value_2,
        _DownlinkNASTransport_IEs_val_Value_3,
        _DownlinkNASTransport_IEs_val_Value_4,
        _DownlinkNASTransport_IEs_val_Value_5,
        _DownlinkNASTransport_IEs_val_Value_6,
        _DownlinkNASTransport_IEs_val_Value_7,
        _DownlinkNASTransport_IEs_val_Value_8,
        _DownlinkNASTransport_IEs_val_Value_9,
        _DownlinkNASTransport_IEs_val_Value_10,
        _DownlinkNASTransport_IEs_val_Value_11,
        _DownlinkNASTransport_IEs_val_Value_12,
        _DownlinkNASTransport_IEs_val_Value_13,
        _DownlinkNASTransport_IEs_val_Value_14,
        _DownlinkNASTransport_IEs_val_Value_15,
        _DownlinkNASTransport_IEs_val_Value_16,
        ____InitialUEMessage_protocolIEs__item__id_tab,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_0,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_1,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_2,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_3,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_4,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_5,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_6,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_7,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_8,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_9,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_10,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_11,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_12,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_13,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_14,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_15,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_16,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_17,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_18,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_19,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_20,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_21,
        _____InitialUEMessage_protocolIEs__item__id_tab_val_Value_22,
        ___InitialUEMessage_protocolIEs__item__id,
        ___InitialUEMessage_protocolIEs__item__criticality,
        ___InitialUEMessage_protocolIEs__item__value,
        __InitialUEMessage_protocolIEs__item_,
        _InitialUEMessage_protocolIEs,
        InitialUEMessage,
        InitialUEMessage_IEs,
        _InitialUEMessage_IEs_val_Value_0,
        _InitialUEMessage_IEs_val_Value_1,
        _InitialUEMessage_IEs_val_Value_2,
        _InitialUEMessage_IEs_val_Value_3,
        _InitialUEMessage_IEs_val_Value_4,
        _InitialUEMessage_IEs_val_Value_5,
        _InitialUEMessage_IEs_val_Value_6,
        _InitialUEMessage_IEs_val_Value_7,
        _InitialUEMessage_IEs_val_Value_8,
        _InitialUEMessage_IEs_val_Value_9,
        _InitialUEMessage_IEs_val_Value_10,
        _InitialUEMessage_IEs_val_Value_11,
        _InitialUEMessage_IEs_val_Value_12,
        _InitialUEMessage_IEs_val_Value_13,
        _InitialUEMessage_IEs_val_Value_14,
        _InitialUEMessage_IEs_val_Value_15,
        _InitialUEMessage_IEs_val_Value_16,
        _InitialUEMessage_IEs_val_Value_17,
        _InitialUEMessage_IEs_val_Value_18,
        _InitialUEMessage_IEs_val_Value_19,
        _InitialUEMessage_IEs_val_Value_20,
        _InitialUEMessage_IEs_val_Value_21,
        _InitialUEMessage_IEs_val_Value_22,
        ____UplinkNASTransport_protocolIEs__item__id_tab,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_2,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_3,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_4,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_5,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_6,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_7,
        _____UplinkNASTransport_protocolIEs__item__id_tab_val_Value_8,
        ___UplinkNASTransport_protocolIEs__item__id,
        ___UplinkNASTransport_protocolIEs__item__criticality,
        ___UplinkNASTransport_protocolIEs__item__value,
        __UplinkNASTransport_protocolIEs__item_,
        _UplinkNASTransport_protocolIEs,
        UplinkNASTransport,
        UplinkNASTransport_IEs,
        _UplinkNASTransport_IEs_val_Value_0,
        _UplinkNASTransport_IEs_val_Value_1,
        _UplinkNASTransport_IEs_val_Value_2,
        _UplinkNASTransport_IEs_val_Value_3,
        _UplinkNASTransport_IEs_val_Value_4,
        _UplinkNASTransport_IEs_val_Value_5,
        _UplinkNASTransport_IEs_val_Value_6,
        _UplinkNASTransport_IEs_val_Value_7,
        _UplinkNASTransport_IEs_val_Value_8,
        ____NASNonDeliveryIndication_protocolIEs__item__id_tab,
        _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_0,
        _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_1,
        _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_2,
        _____NASNonDeliveryIndication_protocolIEs__item__id_tab_val_Value_3,
        ___NASNonDeliveryIndication_protocolIEs__item__id,
        ___NASNonDeliveryIndication_protocolIEs__item__criticality,
        ___NASNonDeliveryIndication_protocolIEs__item__value,
        __NASNonDeliveryIndication_protocolIEs__item_,
        _NASNonDeliveryIndication_protocolIEs,
        NASNonDeliveryIndication,
        NASNonDeliveryIndication_IEs,
        _NASNonDeliveryIndication_IEs_val_Value_0,
        _NASNonDeliveryIndication_IEs_val_Value_1,
        _NASNonDeliveryIndication_IEs_val_Value_2,
        _NASNonDeliveryIndication_IEs_val_Value_3,
        ____RerouteNASRequest_protocolIEs__item__id_tab,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_0,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_1,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_2,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_3,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_4,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_5,
        ___RerouteNASRequest_protocolIEs__item__id,
        ___RerouteNASRequest_protocolIEs__item__criticality,
        ___RerouteNASRequest_protocolIEs__item__value,
        __RerouteNASRequest_protocolIEs__item_,
        _RerouteNASRequest_protocolIEs,
        RerouteNASRequest,
        RerouteNASRequest_IEs,
        _RerouteNASRequest_IEs_val_Value_0,
        _RerouteNASRequest_IEs_val_Value_1,
        _RerouteNASRequest_IEs_val_Value_2,
        _RerouteNASRequest_IEs_val_Value_3,
        _RerouteNASRequest_IEs_val_Value_4,
        _RerouteNASRequest_IEs_val_Value_5,
        ____NASDeliveryIndication_protocolIEs__item__id_tab,
        _____NASDeliveryIndication_protocolIEs__item__id_tab_val_Value_0,
        _____NASDeliveryIndication_protocolIEs__item__id_tab_val_Value_1,
        ___NASDeliveryIndication_protocolIEs__item__id,
        ___NASDeliveryIndication_protocolIEs__item__criticality,
        ___NASDeliveryIndication_protocolIEs__item__value,
        __NASDeliveryIndication_protocolIEs__item_,
        _NASDeliveryIndication_protocolIEs,
        NASDeliveryIndication,
        NASDeliveryIndicationIEs,
        _NASDeliveryIndicationIEs_val_Value_0,
        _NASDeliveryIndicationIEs_val_Value_1,
        ____Reset_protocolIEs__item__id_tab,
        _____Reset_protocolIEs__item__id_tab_val_Value_0,
        _____Reset_protocolIEs__item__id_tab_val_Value_1,
        ___Reset_protocolIEs__item__id,
        ___Reset_protocolIEs__item__criticality,
        ___Reset_protocolIEs__item__value,
        __Reset_protocolIEs__item_,
        _Reset_protocolIEs,
        Reset,
        ResetIEs,
        _ResetIEs_val_Value_0,
        _ResetIEs_val_Value_1,
        _ResetType_s1_Interface,
        _ResetType_partOfS1_Interface,
        ResetType,
        ResetAll,
        ___UE_associatedLogicalS1_ConnectionListRes__item__id_tab,
        ____UE_associatedLogicalS1_ConnectionListRes__item__id_tab_val_Value_0,
        __UE_associatedLogicalS1_ConnectionListRes__item__id,
        __UE_associatedLogicalS1_ConnectionListRes__item__criticality,
        __UE_associatedLogicalS1_ConnectionListRes__item__value,
        _UE_associatedLogicalS1_ConnectionListRes__item_,
        UE_associatedLogicalS1_ConnectionListRes,
        UE_associatedLogicalS1_ConnectionItemRes,
        _UE_associatedLogicalS1_ConnectionItemRes_val_Value_0,
        ____ResetAcknowledge_protocolIEs__item__id_tab,
        _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        ___ResetAcknowledge_protocolIEs__item__id,
        ___ResetAcknowledge_protocolIEs__item__criticality,
        ___ResetAcknowledge_protocolIEs__item__value,
        __ResetAcknowledge_protocolIEs__item_,
        _ResetAcknowledge_protocolIEs,
        ResetAcknowledge,
        ResetAcknowledgeIEs,
        _ResetAcknowledgeIEs_val_Value_0,
        _ResetAcknowledgeIEs_val_Value_1,
        ___UE_associatedLogicalS1_ConnectionListResAck__item__id_tab,
        ____UE_associatedLogicalS1_ConnectionListResAck__item__id_tab_val_Value_0,
        __UE_associatedLogicalS1_ConnectionListResAck__item__id,
        __UE_associatedLogicalS1_ConnectionListResAck__item__criticality,
        __UE_associatedLogicalS1_ConnectionListResAck__item__value,
        _UE_associatedLogicalS1_ConnectionListResAck__item_,
        UE_associatedLogicalS1_ConnectionListResAck,
        UE_associatedLogicalS1_ConnectionItemResAck,
        _UE_associatedLogicalS1_ConnectionItemResAck_val_Value_0,
        ____ErrorIndication_protocolIEs__item__id_tab,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_4,
        ___ErrorIndication_protocolIEs__item__id,
        ___ErrorIndication_protocolIEs__item__criticality,
        ___ErrorIndication_protocolIEs__item__value,
        __ErrorIndication_protocolIEs__item_,
        _ErrorIndication_protocolIEs,
        ErrorIndication,
        ErrorIndicationIEs,
        _ErrorIndicationIEs_val_Value_0,
        _ErrorIndicationIEs_val_Value_1,
        _ErrorIndicationIEs_val_Value_2,
        _ErrorIndicationIEs_val_Value_3,
        _ErrorIndicationIEs_val_Value_4,
        ____S1SetupRequest_protocolIEs__item__id_tab,
        _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_0,
        _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_1,
        _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_2,
        _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_3,
        _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_4,
        _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_5,
        _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_6,
        _____S1SetupRequest_protocolIEs__item__id_tab_val_Value_7,
        ___S1SetupRequest_protocolIEs__item__id,
        ___S1SetupRequest_protocolIEs__item__criticality,
        ___S1SetupRequest_protocolIEs__item__value,
        __S1SetupRequest_protocolIEs__item_,
        _S1SetupRequest_protocolIEs,
        S1SetupRequest,
        S1SetupRequestIEs,
        _S1SetupRequestIEs_val_Value_0,
        _S1SetupRequestIEs_val_Value_1,
        _S1SetupRequestIEs_val_Value_2,
        _S1SetupRequestIEs_val_Value_3,
        _S1SetupRequestIEs_val_Value_4,
        _S1SetupRequestIEs_val_Value_5,
        _S1SetupRequestIEs_val_Value_6,
        _S1SetupRequestIEs_val_Value_7,
        ____S1SetupResponse_protocolIEs__item__id_tab,
        _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_3,
        _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_4,
        _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_5,
        _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_6,
        _____S1SetupResponse_protocolIEs__item__id_tab_val_Value_7,
        ___S1SetupResponse_protocolIEs__item__id,
        ___S1SetupResponse_protocolIEs__item__criticality,
        ___S1SetupResponse_protocolIEs__item__value,
        __S1SetupResponse_protocolIEs__item_,
        _S1SetupResponse_protocolIEs,
        S1SetupResponse,
        S1SetupResponseIEs,
        _S1SetupResponseIEs_val_Value_0,
        _S1SetupResponseIEs_val_Value_1,
        _S1SetupResponseIEs_val_Value_2,
        _S1SetupResponseIEs_val_Value_3,
        _S1SetupResponseIEs_val_Value_4,
        _S1SetupResponseIEs_val_Value_5,
        _S1SetupResponseIEs_val_Value_6,
        _S1SetupResponseIEs_val_Value_7,
        ____S1SetupFailure_protocolIEs__item__id_tab,
        _____S1SetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____S1SetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____S1SetupFailure_protocolIEs__item__id_tab_val_Value_2,
        ___S1SetupFailure_protocolIEs__item__id,
        ___S1SetupFailure_protocolIEs__item__criticality,
        ___S1SetupFailure_protocolIEs__item__value,
        __S1SetupFailure_protocolIEs__item_,
        _S1SetupFailure_protocolIEs,
        S1SetupFailure,
        S1SetupFailureIEs,
        _S1SetupFailureIEs_val_Value_0,
        _S1SetupFailureIEs_val_Value_1,
        _S1SetupFailureIEs_val_Value_2,
        ____ENBConfigurationUpdate_protocolIEs__item__id_tab,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_5,
        _____ENBConfigurationUpdate_protocolIEs__item__id_tab_val_Value_6,
        ___ENBConfigurationUpdate_protocolIEs__item__id,
        ___ENBConfigurationUpdate_protocolIEs__item__criticality,
        ___ENBConfigurationUpdate_protocolIEs__item__value,
        __ENBConfigurationUpdate_protocolIEs__item_,
        _ENBConfigurationUpdate_protocolIEs,
        ENBConfigurationUpdate,
        ENBConfigurationUpdateIEs,
        _ENBConfigurationUpdateIEs_val_Value_0,
        _ENBConfigurationUpdateIEs_val_Value_1,
        _ENBConfigurationUpdateIEs_val_Value_2,
        _ENBConfigurationUpdateIEs_val_Value_3,
        _ENBConfigurationUpdateIEs_val_Value_4,
        _ENBConfigurationUpdateIEs_val_Value_5,
        _ENBConfigurationUpdateIEs_val_Value_6,
        ____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab,
        _____ENBConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__id,
        ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__criticality,
        ___ENBConfigurationUpdateAcknowledge_protocolIEs__item__value,
        __ENBConfigurationUpdateAcknowledge_protocolIEs__item_,
        _ENBConfigurationUpdateAcknowledge_protocolIEs,
        ENBConfigurationUpdateAcknowledge,
        ENBConfigurationUpdateAcknowledgeIEs,
        _ENBConfigurationUpdateAcknowledgeIEs_val_Value_0,
        ____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab,
        _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____ENBConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        ___ENBConfigurationUpdateFailure_protocolIEs__item__id,
        ___ENBConfigurationUpdateFailure_protocolIEs__item__criticality,
        ___ENBConfigurationUpdateFailure_protocolIEs__item__value,
        __ENBConfigurationUpdateFailure_protocolIEs__item_,
        _ENBConfigurationUpdateFailure_protocolIEs,
        ENBConfigurationUpdateFailure,
        ENBConfigurationUpdateFailureIEs,
        _ENBConfigurationUpdateFailureIEs_val_Value_0,
        _ENBConfigurationUpdateFailureIEs_val_Value_1,
        _ENBConfigurationUpdateFailureIEs_val_Value_2,
        ____MMEConfigurationUpdate_protocolIEs__item__id_tab,
        _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____MMEConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3,
        ___MMEConfigurationUpdate_protocolIEs__item__id,
        ___MMEConfigurationUpdate_protocolIEs__item__criticality,
        ___MMEConfigurationUpdate_protocolIEs__item__value,
        __MMEConfigurationUpdate_protocolIEs__item_,
        _MMEConfigurationUpdate_protocolIEs,
        MMEConfigurationUpdate,
        MMEConfigurationUpdateIEs,
        _MMEConfigurationUpdateIEs_val_Value_0,
        _MMEConfigurationUpdateIEs_val_Value_1,
        _MMEConfigurationUpdateIEs_val_Value_2,
        _MMEConfigurationUpdateIEs_val_Value_3,
        ____MMEConfigurationUpdateAcknowledge_protocolIEs__item__id_tab,
        _____MMEConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__id,
        ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__criticality,
        ___MMEConfigurationUpdateAcknowledge_protocolIEs__item__value,
        __MMEConfigurationUpdateAcknowledge_protocolIEs__item_,
        _MMEConfigurationUpdateAcknowledge_protocolIEs,
        MMEConfigurationUpdateAcknowledge,
        MMEConfigurationUpdateAcknowledgeIEs,
        _MMEConfigurationUpdateAcknowledgeIEs_val_Value_0,
        ____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab,
        _____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____MMEConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        ___MMEConfigurationUpdateFailure_protocolIEs__item__id,
        ___MMEConfigurationUpdateFailure_protocolIEs__item__criticality,
        ___MMEConfigurationUpdateFailure_protocolIEs__item__value,
        __MMEConfigurationUpdateFailure_protocolIEs__item_,
        _MMEConfigurationUpdateFailure_protocolIEs,
        MMEConfigurationUpdateFailure,
        MMEConfigurationUpdateFailureIEs,
        _MMEConfigurationUpdateFailureIEs_val_Value_0,
        _MMEConfigurationUpdateFailureIEs_val_Value_1,
        _MMEConfigurationUpdateFailureIEs_val_Value_2,
        ____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab,
        _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_0,
        _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_1,
        _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_2,
        _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_3,
        _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_4,
        _____DownlinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_5,
        ___DownlinkS1cdma2000tunnelling_protocolIEs__item__id,
        ___DownlinkS1cdma2000tunnelling_protocolIEs__item__criticality,
        ___DownlinkS1cdma2000tunnelling_protocolIEs__item__value,
        __DownlinkS1cdma2000tunnelling_protocolIEs__item_,
        _DownlinkS1cdma2000tunnelling_protocolIEs,
        DownlinkS1cdma2000tunnelling,
        DownlinkS1cdma2000tunnellingIEs,
        _DownlinkS1cdma2000tunnellingIEs_val_Value_0,
        _DownlinkS1cdma2000tunnellingIEs_val_Value_1,
        _DownlinkS1cdma2000tunnellingIEs_val_Value_2,
        _DownlinkS1cdma2000tunnellingIEs_val_Value_3,
        _DownlinkS1cdma2000tunnellingIEs_val_Value_4,
        _DownlinkS1cdma2000tunnellingIEs_val_Value_5,
        ____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab,
        _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_2,
        _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_3,
        _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_4,
        _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_5,
        _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_6,
        _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_7,
        _____UplinkS1cdma2000tunnelling_protocolIEs__item__id_tab_val_Value_8,
        ___UplinkS1cdma2000tunnelling_protocolIEs__item__id,
        ___UplinkS1cdma2000tunnelling_protocolIEs__item__criticality,
        ___UplinkS1cdma2000tunnelling_protocolIEs__item__value,
        __UplinkS1cdma2000tunnelling_protocolIEs__item_,
        _UplinkS1cdma2000tunnelling_protocolIEs,
        UplinkS1cdma2000tunnelling,
        UplinkS1cdma2000tunnellingIEs,
        _UplinkS1cdma2000tunnellingIEs_val_Value_0,
        _UplinkS1cdma2000tunnellingIEs_val_Value_1,
        _UplinkS1cdma2000tunnellingIEs_val_Value_2,
        _UplinkS1cdma2000tunnellingIEs_val_Value_3,
        _UplinkS1cdma2000tunnellingIEs_val_Value_4,
        _UplinkS1cdma2000tunnellingIEs_val_Value_5,
        _UplinkS1cdma2000tunnellingIEs_val_Value_6,
        _UplinkS1cdma2000tunnellingIEs_val_Value_7,
        _UplinkS1cdma2000tunnellingIEs_val_Value_8,
        ____UECapabilityInfoIndication_protocolIEs__item__id_tab,
        _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_0,
        _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_1,
        _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_2,
        _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_3,
        _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_4,
        _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_5,
        _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_6,
        _____UECapabilityInfoIndication_protocolIEs__item__id_tab_val_Value_7,
        ___UECapabilityInfoIndication_protocolIEs__item__id,
        ___UECapabilityInfoIndication_protocolIEs__item__criticality,
        ___UECapabilityInfoIndication_protocolIEs__item__value,
        __UECapabilityInfoIndication_protocolIEs__item_,
        _UECapabilityInfoIndication_protocolIEs,
        UECapabilityInfoIndication,
        UECapabilityInfoIndicationIEs,
        _UECapabilityInfoIndicationIEs_val_Value_0,
        _UECapabilityInfoIndicationIEs_val_Value_1,
        _UECapabilityInfoIndicationIEs_val_Value_2,
        _UECapabilityInfoIndicationIEs_val_Value_3,
        _UECapabilityInfoIndicationIEs_val_Value_4,
        _UECapabilityInfoIndicationIEs_val_Value_5,
        _UECapabilityInfoIndicationIEs_val_Value_6,
        _UECapabilityInfoIndicationIEs_val_Value_7,
        ____ENBStatusTransfer_protocolIEs__item__id_tab,
        _____ENBStatusTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____ENBStatusTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____ENBStatusTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___ENBStatusTransfer_protocolIEs__item__id,
        ___ENBStatusTransfer_protocolIEs__item__criticality,
        ___ENBStatusTransfer_protocolIEs__item__value,
        __ENBStatusTransfer_protocolIEs__item_,
        _ENBStatusTransfer_protocolIEs,
        ENBStatusTransfer,
        ENBStatusTransferIEs,
        _ENBStatusTransferIEs_val_Value_0,
        _ENBStatusTransferIEs_val_Value_1,
        _ENBStatusTransferIEs_val_Value_2,
        ____MMEStatusTransfer_protocolIEs__item__id_tab,
        _____MMEStatusTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____MMEStatusTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____MMEStatusTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___MMEStatusTransfer_protocolIEs__item__id,
        ___MMEStatusTransfer_protocolIEs__item__criticality,
        ___MMEStatusTransfer_protocolIEs__item__value,
        __MMEStatusTransfer_protocolIEs__item_,
        _MMEStatusTransfer_protocolIEs,
        MMEStatusTransfer,
        MMEStatusTransferIEs,
        _MMEStatusTransferIEs_val_Value_0,
        _MMEStatusTransferIEs_val_Value_1,
        _MMEStatusTransferIEs_val_Value_2,
        ____TraceStart_protocolIEs__item__id_tab,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_0,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_1,
        _____TraceStart_protocolIEs__item__id_tab_val_Value_2,
        ___TraceStart_protocolIEs__item__id,
        ___TraceStart_protocolIEs__item__criticality,
        ___TraceStart_protocolIEs__item__value,
        __TraceStart_protocolIEs__item_,
        _TraceStart_protocolIEs,
        TraceStart,
        TraceStartIEs,
        _TraceStartIEs_val_Value_0,
        _TraceStartIEs_val_Value_1,
        _TraceStartIEs_val_Value_2,
        ____TraceFailureIndication_protocolIEs__item__id_tab,
        _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_2,
        _____TraceFailureIndication_protocolIEs__item__id_tab_val_Value_3,
        ___TraceFailureIndication_protocolIEs__item__id,
        ___TraceFailureIndication_protocolIEs__item__criticality,
        ___TraceFailureIndication_protocolIEs__item__value,
        __TraceFailureIndication_protocolIEs__item_,
        _TraceFailureIndication_protocolIEs,
        TraceFailureIndication,
        TraceFailureIndicationIEs,
        _TraceFailureIndicationIEs_val_Value_0,
        _TraceFailureIndicationIEs_val_Value_1,
        _TraceFailureIndicationIEs_val_Value_2,
        _TraceFailureIndicationIEs_val_Value_3,
        ____DeactivateTrace_protocolIEs__item__id_tab,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_0,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_1,
        _____DeactivateTrace_protocolIEs__item__id_tab_val_Value_2,
        ___DeactivateTrace_protocolIEs__item__id,
        ___DeactivateTrace_protocolIEs__item__criticality,
        ___DeactivateTrace_protocolIEs__item__value,
        __DeactivateTrace_protocolIEs__item_,
        _DeactivateTrace_protocolIEs,
        DeactivateTrace,
        DeactivateTraceIEs,
        _DeactivateTraceIEs_val_Value_0,
        _DeactivateTraceIEs_val_Value_1,
        _DeactivateTraceIEs_val_Value_2,
        ____CellTrafficTrace_protocolIEs__item__id_tab,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_0,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_1,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_2,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_3,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_4,
        _____CellTrafficTrace_protocolIEs__item__id_tab_val_Value_5,
        ___CellTrafficTrace_protocolIEs__item__id,
        ___CellTrafficTrace_protocolIEs__item__criticality,
        ___CellTrafficTrace_protocolIEs__item__value,
        __CellTrafficTrace_protocolIEs__item_,
        _CellTrafficTrace_protocolIEs,
        CellTrafficTrace,
        CellTrafficTraceIEs,
        _CellTrafficTraceIEs_val_Value_0,
        _CellTrafficTraceIEs_val_Value_1,
        _CellTrafficTraceIEs_val_Value_2,
        _CellTrafficTraceIEs_val_Value_3,
        _CellTrafficTraceIEs_val_Value_4,
        _CellTrafficTraceIEs_val_Value_5,
        ____LocationReportingControl_protocolIEs__item__id_tab,
        _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_0,
        _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_1,
        _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_2,
        ___LocationReportingControl_protocolIEs__item__id,
        ___LocationReportingControl_protocolIEs__item__criticality,
        ___LocationReportingControl_protocolIEs__item__value,
        __LocationReportingControl_protocolIEs__item_,
        _LocationReportingControl_protocolIEs,
        LocationReportingControl,
        LocationReportingControlIEs,
        _LocationReportingControlIEs_val_Value_0,
        _LocationReportingControlIEs_val_Value_1,
        _LocationReportingControlIEs_val_Value_2,
        ____LocationReportingFailureIndication_protocolIEs__item__id_tab,
        _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        _____LocationReportingFailureIndication_protocolIEs__item__id_tab_val_Value_2,
        ___LocationReportingFailureIndication_protocolIEs__item__id,
        ___LocationReportingFailureIndication_protocolIEs__item__criticality,
        ___LocationReportingFailureIndication_protocolIEs__item__value,
        __LocationReportingFailureIndication_protocolIEs__item_,
        _LocationReportingFailureIndication_protocolIEs,
        LocationReportingFailureIndication,
        LocationReportingFailureIndicationIEs,
        _LocationReportingFailureIndicationIEs_val_Value_0,
        _LocationReportingFailureIndicationIEs_val_Value_1,
        _LocationReportingFailureIndicationIEs_val_Value_2,
        ____LocationReport_protocolIEs__item__id_tab,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_0,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_1,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_2,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_3,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_4,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_5,
        ___LocationReport_protocolIEs__item__id,
        ___LocationReport_protocolIEs__item__criticality,
        ___LocationReport_protocolIEs__item__value,
        __LocationReport_protocolIEs__item_,
        _LocationReport_protocolIEs,
        LocationReport,
        LocationReportIEs,
        _LocationReportIEs_val_Value_0,
        _LocationReportIEs_val_Value_1,
        _LocationReportIEs_val_Value_2,
        _LocationReportIEs_val_Value_3,
        _LocationReportIEs_val_Value_4,
        _LocationReportIEs_val_Value_5,
        ____OverloadStart_protocolIEs__item__id_tab,
        _____OverloadStart_protocolIEs__item__id_tab_val_Value_0,
        _____OverloadStart_protocolIEs__item__id_tab_val_Value_1,
        _____OverloadStart_protocolIEs__item__id_tab_val_Value_2,
        ___OverloadStart_protocolIEs__item__id,
        ___OverloadStart_protocolIEs__item__criticality,
        ___OverloadStart_protocolIEs__item__value,
        __OverloadStart_protocolIEs__item_,
        _OverloadStart_protocolIEs,
        OverloadStart,
        OverloadStartIEs,
        _OverloadStartIEs_val_Value_0,
        _OverloadStartIEs_val_Value_1,
        _OverloadStartIEs_val_Value_2,
        ____OverloadStop_protocolIEs__item__id_tab,
        _____OverloadStop_protocolIEs__item__id_tab_val_Value_0,
        ___OverloadStop_protocolIEs__item__id,
        ___OverloadStop_protocolIEs__item__criticality,
        ___OverloadStop_protocolIEs__item__value,
        __OverloadStop_protocolIEs__item_,
        _OverloadStop_protocolIEs,
        OverloadStop,
        OverloadStopIEs,
        _OverloadStopIEs_val_Value_0,
        ____WriteReplaceWarningRequest_protocolIEs__item__id_tab,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_0,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_1,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_2,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_3,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_4,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_5,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_6,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_7,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_8,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_9,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_10,
        _____WriteReplaceWarningRequest_protocolIEs__item__id_tab_val_Value_11,
        ___WriteReplaceWarningRequest_protocolIEs__item__id,
        ___WriteReplaceWarningRequest_protocolIEs__item__criticality,
        ___WriteReplaceWarningRequest_protocolIEs__item__value,
        __WriteReplaceWarningRequest_protocolIEs__item_,
        _WriteReplaceWarningRequest_protocolIEs,
        WriteReplaceWarningRequest,
        WriteReplaceWarningRequestIEs,
        _WriteReplaceWarningRequestIEs_val_Value_0,
        _WriteReplaceWarningRequestIEs_val_Value_1,
        _WriteReplaceWarningRequestIEs_val_Value_2,
        _WriteReplaceWarningRequestIEs_val_Value_3,
        _WriteReplaceWarningRequestIEs_val_Value_4,
        _WriteReplaceWarningRequestIEs_val_Value_5,
        _WriteReplaceWarningRequestIEs_val_Value_6,
        _WriteReplaceWarningRequestIEs_val_Value_7,
        _WriteReplaceWarningRequestIEs_val_Value_8,
        _WriteReplaceWarningRequestIEs_val_Value_9,
        _WriteReplaceWarningRequestIEs_val_Value_10,
        _WriteReplaceWarningRequestIEs_val_Value_11,
        ____WriteReplaceWarningResponse_protocolIEs__item__id_tab,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_0,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_1,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_2,
        _____WriteReplaceWarningResponse_protocolIEs__item__id_tab_val_Value_3,
        ___WriteReplaceWarningResponse_protocolIEs__item__id,
        ___WriteReplaceWarningResponse_protocolIEs__item__criticality,
        ___WriteReplaceWarningResponse_protocolIEs__item__value,
        __WriteReplaceWarningResponse_protocolIEs__item_,
        _WriteReplaceWarningResponse_protocolIEs,
        WriteReplaceWarningResponse,
        WriteReplaceWarningResponseIEs,
        _WriteReplaceWarningResponseIEs_val_Value_0,
        _WriteReplaceWarningResponseIEs_val_Value_1,
        _WriteReplaceWarningResponseIEs_val_Value_2,
        _WriteReplaceWarningResponseIEs_val_Value_3,
        ____ENBDirectInformationTransfer_protocolIEs__item__id_tab,
        _____ENBDirectInformationTransfer_protocolIEs__item__id_tab_val_Value_0,
        ___ENBDirectInformationTransfer_protocolIEs__item__id,
        ___ENBDirectInformationTransfer_protocolIEs__item__criticality,
        ___ENBDirectInformationTransfer_protocolIEs__item__value,
        __ENBDirectInformationTransfer_protocolIEs__item_,
        _ENBDirectInformationTransfer_protocolIEs,
        ENBDirectInformationTransfer,
        ENBDirectInformationTransferIEs,
        _ENBDirectInformationTransferIEs_val_Value_0,
        _Inter_SystemInformationTransferType_rIMTransfer,
        Inter_SystemInformationTransferType,
        ____MMEDirectInformationTransfer_protocolIEs__item__id_tab,
        _____MMEDirectInformationTransfer_protocolIEs__item__id_tab_val_Value_0,
        ___MMEDirectInformationTransfer_protocolIEs__item__id,
        ___MMEDirectInformationTransfer_protocolIEs__item__criticality,
        ___MMEDirectInformationTransfer_protocolIEs__item__value,
        __MMEDirectInformationTransfer_protocolIEs__item_,
        _MMEDirectInformationTransfer_protocolIEs,
        MMEDirectInformationTransfer,
        MMEDirectInformationTransferIEs,
        _MMEDirectInformationTransferIEs_val_Value_0,
        ____ENBConfigurationTransfer_protocolIEs__item__id_tab,
        _____ENBConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____ENBConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____ENBConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___ENBConfigurationTransfer_protocolIEs__item__id,
        ___ENBConfigurationTransfer_protocolIEs__item__criticality,
        ___ENBConfigurationTransfer_protocolIEs__item__value,
        __ENBConfigurationTransfer_protocolIEs__item_,
        _ENBConfigurationTransfer_protocolIEs,
        ENBConfigurationTransfer,
        ENBConfigurationTransferIEs,
        _ENBConfigurationTransferIEs_val_Value_0,
        _ENBConfigurationTransferIEs_val_Value_1,
        _ENBConfigurationTransferIEs_val_Value_2,
        ____MMEConfigurationTransfer_protocolIEs__item__id_tab,
        _____MMEConfigurationTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____MMEConfigurationTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____MMEConfigurationTransfer_protocolIEs__item__id_tab_val_Value_2,
        ___MMEConfigurationTransfer_protocolIEs__item__id,
        ___MMEConfigurationTransfer_protocolIEs__item__criticality,
        ___MMEConfigurationTransfer_protocolIEs__item__value,
        __MMEConfigurationTransfer_protocolIEs__item_,
        _MMEConfigurationTransfer_protocolIEs,
        MMEConfigurationTransfer,
        MMEConfigurationTransferIEs,
        _MMEConfigurationTransferIEs_val_Value_0,
        _MMEConfigurationTransferIEs_val_Value_1,
        _MMEConfigurationTransferIEs_val_Value_2,
        ____PrivateMessage_privateIEs__item__id_tab,
        ___PrivateMessage_privateIEs__item__id,
        ____PrivateMessage_privateIEs__item__criticality_tab,
        ___PrivateMessage_privateIEs__item__criticality,
        ____PrivateMessage_privateIEs__item__value_tab,
        ___PrivateMessage_privateIEs__item__value,
        __PrivateMessage_privateIEs__item_,
        _PrivateMessage_privateIEs,
        PrivateMessage,
        PrivateMessageIEs,
        ____KillRequest_protocolIEs__item__id_tab,
        _____KillRequest_protocolIEs__item__id_tab_val_Value_0,
        _____KillRequest_protocolIEs__item__id_tab_val_Value_1,
        _____KillRequest_protocolIEs__item__id_tab_val_Value_2,
        _____KillRequest_protocolIEs__item__id_tab_val_Value_3,
        ___KillRequest_protocolIEs__item__id,
        ___KillRequest_protocolIEs__item__criticality,
        ___KillRequest_protocolIEs__item__value,
        __KillRequest_protocolIEs__item_,
        _KillRequest_protocolIEs,
        KillRequest,
        KillRequestIEs,
        _KillRequestIEs_val_Value_0,
        _KillRequestIEs_val_Value_1,
        _KillRequestIEs_val_Value_2,
        _KillRequestIEs_val_Value_3,
        ____KillResponse_protocolIEs__item__id_tab,
        _____KillResponse_protocolIEs__item__id_tab_val_Value_0,
        _____KillResponse_protocolIEs__item__id_tab_val_Value_1,
        _____KillResponse_protocolIEs__item__id_tab_val_Value_2,
        _____KillResponse_protocolIEs__item__id_tab_val_Value_3,
        ___KillResponse_protocolIEs__item__id,
        ___KillResponse_protocolIEs__item__criticality,
        ___KillResponse_protocolIEs__item__value,
        __KillResponse_protocolIEs__item_,
        _KillResponse_protocolIEs,
        KillResponse,
        KillResponseIEs,
        _KillResponseIEs_val_Value_0,
        _KillResponseIEs_val_Value_1,
        _KillResponseIEs_val_Value_2,
        _KillResponseIEs_val_Value_3,
        ____PWSRestartIndication_protocolIEs__item__id_tab,
        _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_0,
        _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_1,
        _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_2,
        _____PWSRestartIndication_protocolIEs__item__id_tab_val_Value_3,
        ___PWSRestartIndication_protocolIEs__item__id,
        ___PWSRestartIndication_protocolIEs__item__criticality,
        ___PWSRestartIndication_protocolIEs__item__value,
        __PWSRestartIndication_protocolIEs__item_,
        _PWSRestartIndication_protocolIEs,
        PWSRestartIndication,
        PWSRestartIndicationIEs,
        _PWSRestartIndicationIEs_val_Value_0,
        _PWSRestartIndicationIEs_val_Value_1,
        _PWSRestartIndicationIEs_val_Value_2,
        _PWSRestartIndicationIEs_val_Value_3,
        ____PWSFailureIndication_protocolIEs__item__id_tab,
        _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____PWSFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        ___PWSFailureIndication_protocolIEs__item__id,
        ___PWSFailureIndication_protocolIEs__item__criticality,
        ___PWSFailureIndication_protocolIEs__item__value,
        __PWSFailureIndication_protocolIEs__item_,
        _PWSFailureIndication_protocolIEs,
        PWSFailureIndication,
        PWSFailureIndicationIEs,
        _PWSFailureIndicationIEs_val_Value_0,
        _PWSFailureIndicationIEs_val_Value_1,
        ____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab,
        _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0,
        _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1,
        _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_2,
        _____DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_3,
        ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__id,
        ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__criticality,
        ___DownlinkUEAssociatedLPPaTransport_protocolIEs__item__value,
        __DownlinkUEAssociatedLPPaTransport_protocolIEs__item_,
        _DownlinkUEAssociatedLPPaTransport_protocolIEs,
        DownlinkUEAssociatedLPPaTransport,
        DownlinkUEAssociatedLPPaTransport_IEs,
        _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_0,
        _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_1,
        _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_2,
        _DownlinkUEAssociatedLPPaTransport_IEs_val_Value_3,
        ____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab,
        _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_2,
        _____UplinkUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_3,
        ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__id,
        ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__criticality,
        ___UplinkUEAssociatedLPPaTransport_protocolIEs__item__value,
        __UplinkUEAssociatedLPPaTransport_protocolIEs__item_,
        _UplinkUEAssociatedLPPaTransport_protocolIEs,
        UplinkUEAssociatedLPPaTransport,
        UplinkUEAssociatedLPPaTransport_IEs,
        _UplinkUEAssociatedLPPaTransport_IEs_val_Value_0,
        _UplinkUEAssociatedLPPaTransport_IEs_val_Value_1,
        _UplinkUEAssociatedLPPaTransport_IEs_val_Value_2,
        _UplinkUEAssociatedLPPaTransport_IEs_val_Value_3,
        ____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab,
        _____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0,
        _____DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1,
        ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__id,
        ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality,
        ___DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item__value,
        __DownlinkNonUEAssociatedLPPaTransport_protocolIEs__item_,
        _DownlinkNonUEAssociatedLPPaTransport_protocolIEs,
        DownlinkNonUEAssociatedLPPaTransport,
        DownlinkNonUEAssociatedLPPaTransport_IEs,
        _DownlinkNonUEAssociatedLPPaTransport_IEs_val_Value_0,
        _DownlinkNonUEAssociatedLPPaTransport_IEs_val_Value_1,
        ____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab,
        _____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id_tab_val_Value_1,
        ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__id,
        ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__criticality,
        ___UplinkNonUEAssociatedLPPaTransport_protocolIEs__item__value,
        __UplinkNonUEAssociatedLPPaTransport_protocolIEs__item_,
        _UplinkNonUEAssociatedLPPaTransport_protocolIEs,
        UplinkNonUEAssociatedLPPaTransport,
        UplinkNonUEAssociatedLPPaTransport_IEs,
        _UplinkNonUEAssociatedLPPaTransport_IEs_val_Value_0,
        _UplinkNonUEAssociatedLPPaTransport_IEs_val_Value_1,
        ____E_RABModificationIndication_protocolIEs__item__id_tab,
        _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_0,
        _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_1,
        _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_2,
        _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_3,
        _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_4,
        _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_5,
        _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_6,
        _____E_RABModificationIndication_protocolIEs__item__id_tab_val_Value_7,
        ___E_RABModificationIndication_protocolIEs__item__id,
        ___E_RABModificationIndication_protocolIEs__item__criticality,
        ___E_RABModificationIndication_protocolIEs__item__value,
        __E_RABModificationIndication_protocolIEs__item_,
        _E_RABModificationIndication_protocolIEs,
        E_RABModificationIndication,
        E_RABModificationIndicationIEs,
        _E_RABModificationIndicationIEs_val_Value_0,
        _E_RABModificationIndicationIEs_val_Value_1,
        _E_RABModificationIndicationIEs_val_Value_2,
        _E_RABModificationIndicationIEs_val_Value_3,
        _E_RABModificationIndicationIEs_val_Value_4,
        _E_RABModificationIndicationIEs_val_Value_5,
        _E_RABModificationIndicationIEs_val_Value_6,
        _E_RABModificationIndicationIEs_val_Value_7,
        ___E_RABToBeModifiedListBearerModInd__item__id_tab,
        ____E_RABToBeModifiedListBearerModInd__item__id_tab_val_Value_0,
        __E_RABToBeModifiedListBearerModInd__item__id,
        __E_RABToBeModifiedListBearerModInd__item__criticality,
        __E_RABToBeModifiedListBearerModInd__item__value,
        _E_RABToBeModifiedListBearerModInd__item_,
        E_RABToBeModifiedListBearerModInd,
        E_RABToBeModifiedItemBearerModIndIEs,
        _E_RABToBeModifiedItemBearerModIndIEs_val_Value_0,
        _E_RABToBeModifiedItemBearerModInd_e_RAB_ID,
        _E_RABToBeModifiedItemBearerModInd_transportLayerAddress,
        _E_RABToBeModifiedItemBearerModInd_dL_GTP_TEID,
        ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__id_tab,
        ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__id,
        ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__criticality_tab,
        ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__criticality,
        ____E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue_tab,
        ___E_RABToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue,
        __E_RABToBeModifiedItemBearerModInd_iE_Extensions__item_,
        _E_RABToBeModifiedItemBearerModInd_iE_Extensions,
        E_RABToBeModifiedItemBearerModInd,
        E_RABToBeModifiedItemBearerModInd_ExtIEs,
        ___E_RABNotToBeModifiedListBearerModInd__item__id_tab,
        ____E_RABNotToBeModifiedListBearerModInd__item__id_tab_val_Value_0,
        __E_RABNotToBeModifiedListBearerModInd__item__id,
        __E_RABNotToBeModifiedListBearerModInd__item__criticality,
        __E_RABNotToBeModifiedListBearerModInd__item__value,
        _E_RABNotToBeModifiedListBearerModInd__item_,
        E_RABNotToBeModifiedListBearerModInd,
        E_RABNotToBeModifiedItemBearerModIndIEs,
        _E_RABNotToBeModifiedItemBearerModIndIEs_val_Value_0,
        _E_RABNotToBeModifiedItemBearerModInd_e_RAB_ID,
        _E_RABNotToBeModifiedItemBearerModInd_transportLayerAddress,
        _E_RABNotToBeModifiedItemBearerModInd_dL_GTP_TEID,
        ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__id_tab,
        ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__id,
        ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__criticality_tab,
        ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__criticality,
        ____E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue_tab,
        ___E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item__extensionValue,
        __E_RABNotToBeModifiedItemBearerModInd_iE_Extensions__item_,
        _E_RABNotToBeModifiedItemBearerModInd_iE_Extensions,
        E_RABNotToBeModifiedItemBearerModInd,
        E_RABNotToBeModifiedItemBearerModInd_ExtIEs,
        _CSGMembershipInfo_cSGMembershipStatus,
        _CSGMembershipInfo_cSG_Id,
        _CSGMembershipInfo_cellAccessMode,
        _CSGMembershipInfo_pLMNidentity,
        ____CSGMembershipInfo_iE_Extensions__item__id_tab,
        ___CSGMembershipInfo_iE_Extensions__item__id,
        ____CSGMembershipInfo_iE_Extensions__item__criticality_tab,
        ___CSGMembershipInfo_iE_Extensions__item__criticality,
        ____CSGMembershipInfo_iE_Extensions__item__extensionValue_tab,
        ___CSGMembershipInfo_iE_Extensions__item__extensionValue,
        __CSGMembershipInfo_iE_Extensions__item_,
        _CSGMembershipInfo_iE_Extensions,
        CSGMembershipInfo,
        CSGMembershipInfo_ExtIEs,
        ____E_RABModificationConfirm_protocolIEs__item__id_tab,
        _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_3,
        _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_4,
        _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_5,
        _____E_RABModificationConfirm_protocolIEs__item__id_tab_val_Value_6,
        ___E_RABModificationConfirm_protocolIEs__item__id,
        ___E_RABModificationConfirm_protocolIEs__item__criticality,
        ___E_RABModificationConfirm_protocolIEs__item__value,
        __E_RABModificationConfirm_protocolIEs__item_,
        _E_RABModificationConfirm_protocolIEs,
        E_RABModificationConfirm,
        E_RABModificationConfirmIEs,
        _E_RABModificationConfirmIEs_val_Value_0,
        _E_RABModificationConfirmIEs_val_Value_1,
        _E_RABModificationConfirmIEs_val_Value_2,
        _E_RABModificationConfirmIEs_val_Value_3,
        _E_RABModificationConfirmIEs_val_Value_4,
        _E_RABModificationConfirmIEs_val_Value_5,
        _E_RABModificationConfirmIEs_val_Value_6,
        ___E_RABModifyListBearerModConf__item__id_tab,
        ____E_RABModifyListBearerModConf__item__id_tab_val_Value_0,
        __E_RABModifyListBearerModConf__item__id,
        __E_RABModifyListBearerModConf__item__criticality,
        __E_RABModifyListBearerModConf__item__value,
        _E_RABModifyListBearerModConf__item_,
        E_RABModifyListBearerModConf,
        E_RABModifyItemBearerModConfIEs,
        _E_RABModifyItemBearerModConfIEs_val_Value_0,
        _E_RABModifyItemBearerModConf_e_RAB_ID,
        ____E_RABModifyItemBearerModConf_iE_Extensions__item__id_tab,
        ___E_RABModifyItemBearerModConf_iE_Extensions__item__id,
        ____E_RABModifyItemBearerModConf_iE_Extensions__item__criticality_tab,
        ___E_RABModifyItemBearerModConf_iE_Extensions__item__criticality,
        ____E_RABModifyItemBearerModConf_iE_Extensions__item__extensionValue_tab,
        ___E_RABModifyItemBearerModConf_iE_Extensions__item__extensionValue,
        __E_RABModifyItemBearerModConf_iE_Extensions__item_,
        _E_RABModifyItemBearerModConf_iE_Extensions,
        E_RABModifyItemBearerModConf,
        E_RABModifyItemBearerModConfExtIEs,
        ____UEContextModificationIndication_protocolIEs__item__id_tab,
        _____UEContextModificationIndication_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationIndication_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationIndication_protocolIEs__item__id_tab_val_Value_2,
        ___UEContextModificationIndication_protocolIEs__item__id,
        ___UEContextModificationIndication_protocolIEs__item__criticality,
        ___UEContextModificationIndication_protocolIEs__item__value,
        __UEContextModificationIndication_protocolIEs__item_,
        _UEContextModificationIndication_protocolIEs,
        UEContextModificationIndication,
        UEContextModificationIndicationIEs,
        _UEContextModificationIndicationIEs_val_Value_0,
        _UEContextModificationIndicationIEs_val_Value_1,
        _UEContextModificationIndicationIEs_val_Value_2,
        ____UEContextModificationConfirm_protocolIEs__item__id_tab,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextModificationConfirm_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextModificationConfirm_protocolIEs__item__id,
        ___UEContextModificationConfirm_protocolIEs__item__criticality,
        ___UEContextModificationConfirm_protocolIEs__item__value,
        __UEContextModificationConfirm_protocolIEs__item_,
        _UEContextModificationConfirm_protocolIEs,
        UEContextModificationConfirm,
        UEContextModificationConfirmIEs,
        _UEContextModificationConfirmIEs_val_Value_0,
        _UEContextModificationConfirmIEs_val_Value_1,
        _UEContextModificationConfirmIEs_val_Value_2,
        _UEContextModificationConfirmIEs_val_Value_3,
        ____UEContextSuspendRequest_protocolIEs__item__id_tab,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_5,
        _____UEContextSuspendRequest_protocolIEs__item__id_tab_val_Value_6,
        ___UEContextSuspendRequest_protocolIEs__item__id,
        ___UEContextSuspendRequest_protocolIEs__item__criticality,
        ___UEContextSuspendRequest_protocolIEs__item__value,
        __UEContextSuspendRequest_protocolIEs__item_,
        _UEContextSuspendRequest_protocolIEs,
        UEContextSuspendRequest,
        UEContextSuspendRequestIEs,
        _UEContextSuspendRequestIEs_val_Value_0,
        _UEContextSuspendRequestIEs_val_Value_1,
        _UEContextSuspendRequestIEs_val_Value_2,
        _UEContextSuspendRequestIEs_val_Value_3,
        _UEContextSuspendRequestIEs_val_Value_4,
        _UEContextSuspendRequestIEs_val_Value_5,
        _UEContextSuspendRequestIEs_val_Value_6,
        ____UEContextSuspendResponse_protocolIEs__item__id_tab,
        _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextSuspendResponse_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextSuspendResponse_protocolIEs__item__id,
        ___UEContextSuspendResponse_protocolIEs__item__criticality,
        ___UEContextSuspendResponse_protocolIEs__item__value,
        __UEContextSuspendResponse_protocolIEs__item_,
        _UEContextSuspendResponse_protocolIEs,
        UEContextSuspendResponse,
        UEContextSuspendResponseIEs,
        _UEContextSuspendResponseIEs_val_Value_0,
        _UEContextSuspendResponseIEs_val_Value_1,
        _UEContextSuspendResponseIEs_val_Value_2,
        _UEContextSuspendResponseIEs_val_Value_3,
        ____UEContextResumeRequest_protocolIEs__item__id_tab,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextResumeRequest_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextResumeRequest_protocolIEs__item__id,
        ___UEContextResumeRequest_protocolIEs__item__criticality,
        ___UEContextResumeRequest_protocolIEs__item__value,
        __UEContextResumeRequest_protocolIEs__item_,
        _UEContextResumeRequest_protocolIEs,
        UEContextResumeRequest,
        UEContextResumeRequestIEs,
        _UEContextResumeRequestIEs_val_Value_0,
        _UEContextResumeRequestIEs_val_Value_1,
        _UEContextResumeRequestIEs_val_Value_2,
        _UEContextResumeRequestIEs_val_Value_3,
        ___E_RABFailedToResumeListResumeReq__item__id_tab,
        ____E_RABFailedToResumeListResumeReq__item__id_tab_val_Value_0,
        __E_RABFailedToResumeListResumeReq__item__id,
        __E_RABFailedToResumeListResumeReq__item__criticality,
        __E_RABFailedToResumeListResumeReq__item__value,
        _E_RABFailedToResumeListResumeReq__item_,
        E_RABFailedToResumeListResumeReq,
        E_RABFailedToResumeItemResumeReqIEs,
        _E_RABFailedToResumeItemResumeReqIEs_val_Value_0,
        _E_RABFailedToResumeItemResumeReq_e_RAB_ID,
        _E_RABFailedToResumeItemResumeReq_cause,
        ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__id_tab,
        ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__id,
        ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__criticality_tab,
        ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__criticality,
        ____E_RABFailedToResumeItemResumeReq_iE_Extensions__item__extensionValue_tab,
        ___E_RABFailedToResumeItemResumeReq_iE_Extensions__item__extensionValue,
        __E_RABFailedToResumeItemResumeReq_iE_Extensions__item_,
        _E_RABFailedToResumeItemResumeReq_iE_Extensions,
        E_RABFailedToResumeItemResumeReq,
        E_RABFailedToResumeItemResumeReq_ExtIEs,
        ____UEContextResumeResponse_protocolIEs__item__id_tab,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_3,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_4,
        _____UEContextResumeResponse_protocolIEs__item__id_tab_val_Value_5,
        ___UEContextResumeResponse_protocolIEs__item__id,
        ___UEContextResumeResponse_protocolIEs__item__criticality,
        ___UEContextResumeResponse_protocolIEs__item__value,
        __UEContextResumeResponse_protocolIEs__item_,
        _UEContextResumeResponse_protocolIEs,
        UEContextResumeResponse,
        UEContextResumeResponseIEs,
        _UEContextResumeResponseIEs_val_Value_0,
        _UEContextResumeResponseIEs_val_Value_1,
        _UEContextResumeResponseIEs_val_Value_2,
        _UEContextResumeResponseIEs_val_Value_3,
        _UEContextResumeResponseIEs_val_Value_4,
        _UEContextResumeResponseIEs_val_Value_5,
        ___E_RABFailedToResumeListResumeRes__item__id_tab,
        ____E_RABFailedToResumeListResumeRes__item__id_tab_val_Value_0,
        __E_RABFailedToResumeListResumeRes__item__id,
        __E_RABFailedToResumeListResumeRes__item__criticality,
        __E_RABFailedToResumeListResumeRes__item__value,
        _E_RABFailedToResumeListResumeRes__item_,
        E_RABFailedToResumeListResumeRes,
        E_RABFailedToResumeItemResumeResIEs,
        _E_RABFailedToResumeItemResumeResIEs_val_Value_0,
        _E_RABFailedToResumeItemResumeRes_e_RAB_ID,
        _E_RABFailedToResumeItemResumeRes_cause,
        ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__id_tab,
        ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__id,
        ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__criticality_tab,
        ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__criticality,
        ____E_RABFailedToResumeItemResumeRes_iE_Extensions__item__extensionValue_tab,
        ___E_RABFailedToResumeItemResumeRes_iE_Extensions__item__extensionValue,
        __E_RABFailedToResumeItemResumeRes_iE_Extensions__item_,
        _E_RABFailedToResumeItemResumeRes_iE_Extensions,
        E_RABFailedToResumeItemResumeRes,
        E_RABFailedToResumeItemResumeRes_ExtIEs,
        ____UEContextResumeFailure_protocolIEs__item__id_tab,
        _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_0,
        _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_1,
        _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_2,
        _____UEContextResumeFailure_protocolIEs__item__id_tab_val_Value_3,
        ___UEContextResumeFailure_protocolIEs__item__id,
        ___UEContextResumeFailure_protocolIEs__item__criticality,
        ___UEContextResumeFailure_protocolIEs__item__value,
        __UEContextResumeFailure_protocolIEs__item_,
        _UEContextResumeFailure_protocolIEs,
        UEContextResumeFailure,
        UEContextResumeFailureIEs,
        _UEContextResumeFailureIEs_val_Value_0,
        _UEContextResumeFailureIEs_val_Value_1,
        _UEContextResumeFailureIEs_val_Value_2,
        _UEContextResumeFailureIEs_val_Value_3,
        ____ConnectionEstablishmentIndication_protocolIEs__item__id_tab,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_1,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_2,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_3,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_4,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_5,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_6,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_7,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_8,
        _____ConnectionEstablishmentIndication_protocolIEs__item__id_tab_val_Value_9,
        ___ConnectionEstablishmentIndication_protocolIEs__item__id,
        ___ConnectionEstablishmentIndication_protocolIEs__item__criticality,
        ___ConnectionEstablishmentIndication_protocolIEs__item__value,
        __ConnectionEstablishmentIndication_protocolIEs__item_,
        _ConnectionEstablishmentIndication_protocolIEs,
        ConnectionEstablishmentIndication,
        ConnectionEstablishmentIndicationIEs,
        _ConnectionEstablishmentIndicationIEs_val_Value_0,
        _ConnectionEstablishmentIndicationIEs_val_Value_1,
        _ConnectionEstablishmentIndicationIEs_val_Value_2,
        _ConnectionEstablishmentIndicationIEs_val_Value_3,
        _ConnectionEstablishmentIndicationIEs_val_Value_4,
        _ConnectionEstablishmentIndicationIEs_val_Value_5,
        _ConnectionEstablishmentIndicationIEs_val_Value_6,
        _ConnectionEstablishmentIndicationIEs_val_Value_7,
        _ConnectionEstablishmentIndicationIEs_val_Value_8,
        _ConnectionEstablishmentIndicationIEs_val_Value_9,
        ____RetrieveUEInformation_protocolIEs__item__id_tab,
        _____RetrieveUEInformation_protocolIEs__item__id_tab_val_Value_0,
        ___RetrieveUEInformation_protocolIEs__item__id,
        ___RetrieveUEInformation_protocolIEs__item__criticality,
        ___RetrieveUEInformation_protocolIEs__item__value,
        __RetrieveUEInformation_protocolIEs__item_,
        _RetrieveUEInformation_protocolIEs,
        RetrieveUEInformation,
        RetrieveUEInformationIEs,
        _RetrieveUEInformationIEs_val_Value_0,
        ____UEInformationTransfer_protocolIEs__item__id_tab,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_3,
        _____UEInformationTransfer_protocolIEs__item__id_tab_val_Value_4,
        ___UEInformationTransfer_protocolIEs__item__id,
        ___UEInformationTransfer_protocolIEs__item__criticality,
        ___UEInformationTransfer_protocolIEs__item__value,
        __UEInformationTransfer_protocolIEs__item_,
        _UEInformationTransfer_protocolIEs,
        UEInformationTransfer,
        UEInformationTransferIEs,
        _UEInformationTransferIEs_val_Value_0,
        _UEInformationTransferIEs_val_Value_1,
        _UEInformationTransferIEs_val_Value_2,
        _UEInformationTransferIEs_val_Value_3,
        _UEInformationTransferIEs_val_Value_4,
        ____ENBCPRelocationIndication_protocolIEs__item__id_tab,
        _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_1,
        _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_2,
        _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_3,
        _____ENBCPRelocationIndication_protocolIEs__item__id_tab_val_Value_4,
        ___ENBCPRelocationIndication_protocolIEs__item__id,
        ___ENBCPRelocationIndication_protocolIEs__item__criticality,
        ___ENBCPRelocationIndication_protocolIEs__item__value,
        __ENBCPRelocationIndication_protocolIEs__item_,
        _ENBCPRelocationIndication_protocolIEs,
        ENBCPRelocationIndication,
        ENBCPRelocationIndicationIEs,
        _ENBCPRelocationIndicationIEs_val_Value_0,
        _ENBCPRelocationIndicationIEs_val_Value_1,
        _ENBCPRelocationIndicationIEs_val_Value_2,
        _ENBCPRelocationIndicationIEs_val_Value_3,
        _ENBCPRelocationIndicationIEs_val_Value_4,
        ____MMECPRelocationIndication_protocolIEs__item__id_tab,
        _____MMECPRelocationIndication_protocolIEs__item__id_tab_val_Value_0,
        _____MMECPRelocationIndication_protocolIEs__item__id_tab_val_Value_1,
        ___MMECPRelocationIndication_protocolIEs__item__id,
        ___MMECPRelocationIndication_protocolIEs__item__criticality,
        ___MMECPRelocationIndication_protocolIEs__item__value,
        __MMECPRelocationIndication_protocolIEs__item_,
        _MMECPRelocationIndication_protocolIEs,
        MMECPRelocationIndication,
        MMECPRelocationIndicationIEs,
        _MMECPRelocationIndicationIEs_val_Value_0,
        _MMECPRelocationIndicationIEs_val_Value_1,
        ____SecondaryRATDataUsageReport_protocolIEs__item__id_tab,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_0,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_1,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_2,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_3,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_4,
        _____SecondaryRATDataUsageReport_protocolIEs__item__id_tab_val_Value_5,
        ___SecondaryRATDataUsageReport_protocolIEs__item__id,
        ___SecondaryRATDataUsageReport_protocolIEs__item__criticality,
        ___SecondaryRATDataUsageReport_protocolIEs__item__value,
        __SecondaryRATDataUsageReport_protocolIEs__item_,
        _SecondaryRATDataUsageReport_protocolIEs,
        SecondaryRATDataUsageReport,
        SecondaryRATDataUsageReportIEs,
        _SecondaryRATDataUsageReportIEs_val_Value_0,
        _SecondaryRATDataUsageReportIEs_val_Value_1,
        _SecondaryRATDataUsageReportIEs_val_Value_2,
        _SecondaryRATDataUsageReportIEs_val_Value_3,
        _SecondaryRATDataUsageReportIEs_val_Value_4,
        _SecondaryRATDataUsageReportIEs_val_Value_5,
        ____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab,
        _____UERadioCapabilityIDMappingRequest_protocolIEs__item__id_tab_val_Value_0,
        ___UERadioCapabilityIDMappingRequest_protocolIEs__item__id,
        ___UERadioCapabilityIDMappingRequest_protocolIEs__item__criticality,
        ___UERadioCapabilityIDMappingRequest_protocolIEs__item__value,
        __UERadioCapabilityIDMappingRequest_protocolIEs__item_,
        _UERadioCapabilityIDMappingRequest_protocolIEs,
        UERadioCapabilityIDMappingRequest,
        UERadioCapabilityIDMappingRequestIEs,
        _UERadioCapabilityIDMappingRequestIEs_val_Value_0,
        ____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab,
        _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UERadioCapabilityIDMappingResponse_protocolIEs__item__id_tab_val_Value_2,
        ___UERadioCapabilityIDMappingResponse_protocolIEs__item__id,
        ___UERadioCapabilityIDMappingResponse_protocolIEs__item__criticality,
        ___UERadioCapabilityIDMappingResponse_protocolIEs__item__value,
        __UERadioCapabilityIDMappingResponse_protocolIEs__item_,
        _UERadioCapabilityIDMappingResponse_protocolIEs,
        UERadioCapabilityIDMappingResponse,
        UERadioCapabilityIDMappingResponseIEs,
        _UERadioCapabilityIDMappingResponseIEs_val_Value_0,
        _UERadioCapabilityIDMappingResponseIEs_val_Value_1,
        _UERadioCapabilityIDMappingResponseIEs_val_Value_2,
    ]

class S1AP_PDU_Descriptions:

    _name_  = u'S1AP-PDU-Descriptions'
    _oid_   = [0, 4, 0, 0, 21, 3, 1, 1, 0]
    
    _obj_ = [
        u'S1AP-ELEMENTARY-PROCEDURE',
        u'S1AP-PDU',
        u'InitiatingMessage',
        u'SuccessfulOutcome',
        u'UnsuccessfulOutcome',
        u'S1AP-ELEMENTARY-PROCEDURES',
        u'S1AP-ELEMENTARY-PROCEDURES-CLASS-1',
        u'S1AP-ELEMENTARY-PROCEDURES-CLASS-2',
        u'handoverPreparation',
        u'handoverResourceAllocation',
        u'handoverNotification',
        u'pathSwitchRequest',
        u'e-RABSetup',
        u'e-RABModify',
        u'e-RABRelease',
        u'e-RABReleaseIndication',
        u'initialContextSetup',
        u'uEContextReleaseRequest',
        u'paging',
        u'downlinkNASTransport',
        u'initialUEMessage',
        u'uplinkNASTransport',
        u'nASNonDeliveryIndication',
        u'handoverCancel',
        u'reset',
        u'errorIndication',
        u's1Setup',
        u'eNBConfigurationUpdate',
        u'mMEConfigurationUpdate',
        u'downlinkS1cdma2000tunnelling',
        u'uplinkS1cdma2000tunnelling',
        u'uEContextModification',
        u'uECapabilityInfoIndication',
        u'uEContextRelease',
        u'eNBStatusTransfer',
        u'mMEStatusTransfer',
        u'deactivateTrace',
        u'traceStart',
        u'traceFailureIndication',
        u'cellTrafficTrace',
        u'locationReportingControl',
        u'locationReportingFailureIndication',
        u'locationReport',
        u'overloadStart',
        u'overloadStop',
        u'writeReplaceWarning',
        u'eNBDirectInformationTransfer',
        u'mMEDirectInformationTransfer',
        u'eNBConfigurationTransfer',
        u'mMEConfigurationTransfer',
        u'privateMessage',
        u'pWSRestartIndication',
        u'kill',
        u'downlinkUEAssociatedLPPaTransport',
        u'uplinkUEAssociatedLPPaTransport',
        u'downlinkNonUEAssociatedLPPaTransport',
        u'uplinkNonUEAssociatedLPPaTransport',
        u'uERadioCapabilityMatch',
        u'e-RABModificationIndication',
        u'uEContextModificationIndication',
        u'rerouteNASRequest',
        u'pWSFailureIndication',
        u'uEContextSuspend',
        u'uEContextResume',
        u'connectionEstablishmentIndication',
        u'nASDeliveryIndication',
        u'retrieveUEInformation',
        u'uEInformationTransfer',
        u'eNBCPRelocationIndication',
        u'mMECPRelocationIndication',
        u'secondaryRATDataUsageReport',
        u'uERadioCapabilityIDMapping',
        u'handoverSuccess',
        u'eNBEarlyStatusTransfer',
        u'mMEEarlyStatusTransfer',
        ]
    _type_ = [
        u'S1AP-ELEMENTARY-PROCEDURE',
        u'S1AP-PDU',
        u'InitiatingMessage',
        u'SuccessfulOutcome',
        u'UnsuccessfulOutcome',
        ]
    _set_ = [
        u'S1AP-ELEMENTARY-PROCEDURES',
        u'S1AP-ELEMENTARY-PROCEDURES-CLASS-1',
        u'S1AP-ELEMENTARY-PROCEDURES-CLASS-2',
        ]
    _val_ = [
        u'handoverPreparation',
        u'handoverResourceAllocation',
        u'handoverNotification',
        u'pathSwitchRequest',
        u'e-RABSetup',
        u'e-RABModify',
        u'e-RABRelease',
        u'e-RABReleaseIndication',
        u'initialContextSetup',
        u'uEContextReleaseRequest',
        u'paging',
        u'downlinkNASTransport',
        u'initialUEMessage',
        u'uplinkNASTransport',
        u'nASNonDeliveryIndication',
        u'handoverCancel',
        u'reset',
        u'errorIndication',
        u's1Setup',
        u'eNBConfigurationUpdate',
        u'mMEConfigurationUpdate',
        u'downlinkS1cdma2000tunnelling',
        u'uplinkS1cdma2000tunnelling',
        u'uEContextModification',
        u'uECapabilityInfoIndication',
        u'uEContextRelease',
        u'eNBStatusTransfer',
        u'mMEStatusTransfer',
        u'deactivateTrace',
        u'traceStart',
        u'traceFailureIndication',
        u'cellTrafficTrace',
        u'locationReportingControl',
        u'locationReportingFailureIndication',
        u'locationReport',
        u'overloadStart',
        u'overloadStop',
        u'writeReplaceWarning',
        u'eNBDirectInformationTransfer',
        u'mMEDirectInformationTransfer',
        u'eNBConfigurationTransfer',
        u'mMEConfigurationTransfer',
        u'privateMessage',
        u'pWSRestartIndication',
        u'kill',
        u'downlinkUEAssociatedLPPaTransport',
        u'uplinkUEAssociatedLPPaTransport',
        u'downlinkNonUEAssociatedLPPaTransport',
        u'uplinkNonUEAssociatedLPPaTransport',
        u'uERadioCapabilityMatch',
        u'e-RABModificationIndication',
        u'uEContextModificationIndication',
        u'rerouteNASRequest',
        u'pWSFailureIndication',
        u'uEContextSuspend',
        u'uEContextResume',
        u'connectionEstablishmentIndication',
        u'nASDeliveryIndication',
        u'retrieveUEInformation',
        u'uEInformationTransfer',
        u'eNBCPRelocationIndication',
        u'mMECPRelocationIndication',
        u'secondaryRATDataUsageReport',
        u'uERadioCapabilityIDMapping',
        u'handoverSuccess',
        u'eNBEarlyStatusTransfer',
        u'mMEEarlyStatusTransfer',
        ]
    _class_ = [
        u'S1AP-ELEMENTARY-PROCEDURE',
        u'S1AP-ELEMENTARY-PROCEDURES',
        u'S1AP-ELEMENTARY-PROCEDURES-CLASS-1',
        u'S1AP-ELEMENTARY-PROCEDURES-CLASS-2',
        u'handoverPreparation',
        u'handoverResourceAllocation',
        u'handoverNotification',
        u'pathSwitchRequest',
        u'e-RABSetup',
        u'e-RABModify',
        u'e-RABRelease',
        u'e-RABReleaseIndication',
        u'initialContextSetup',
        u'uEContextReleaseRequest',
        u'paging',
        u'downlinkNASTransport',
        u'initialUEMessage',
        u'uplinkNASTransport',
        u'nASNonDeliveryIndication',
        u'handoverCancel',
        u'reset',
        u'errorIndication',
        u's1Setup',
        u'eNBConfigurationUpdate',
        u'mMEConfigurationUpdate',
        u'downlinkS1cdma2000tunnelling',
        u'uplinkS1cdma2000tunnelling',
        u'uEContextModification',
        u'uECapabilityInfoIndication',
        u'uEContextRelease',
        u'eNBStatusTransfer',
        u'mMEStatusTransfer',
        u'deactivateTrace',
        u'traceStart',
        u'traceFailureIndication',
        u'cellTrafficTrace',
        u'locationReportingControl',
        u'locationReportingFailureIndication',
        u'locationReport',
        u'overloadStart',
        u'overloadStop',
        u'writeReplaceWarning',
        u'eNBDirectInformationTransfer',
        u'mMEDirectInformationTransfer',
        u'eNBConfigurationTransfer',
        u'mMEConfigurationTransfer',
        u'privateMessage',
        u'pWSRestartIndication',
        u'kill',
        u'downlinkUEAssociatedLPPaTransport',
        u'uplinkUEAssociatedLPPaTransport',
        u'downlinkNonUEAssociatedLPPaTransport',
        u'uplinkNonUEAssociatedLPPaTransport',
        u'uERadioCapabilityMatch',
        u'e-RABModificationIndication',
        u'uEContextModificationIndication',
        u'rerouteNASRequest',
        u'pWSFailureIndication',
        u'uEContextSuspend',
        u'uEContextResume',
        u'connectionEstablishmentIndication',
        u'nASDeliveryIndication',
        u'retrieveUEInformation',
        u'uEInformationTransfer',
        u'eNBCPRelocationIndication',
        u'mMECPRelocationIndication',
        u'secondaryRATDataUsageReport',
        u'uERadioCapabilityIDMapping',
        u'handoverSuccess',
        u'eNBEarlyStatusTransfer',
        u'mMEEarlyStatusTransfer',
        ]
    _param_ = [
        ]
    
    #-----< S1AP-ELEMENTARY-PROCEDURE >-----#
    S1AP_ELEMENTARY_PROCEDURE = CLASS(name=u'S1AP-ELEMENTARY-PROCEDURE', mode=MODE_TYPE)
    _S1AP_ELEMENTARY_PROCEDURE_InitiatingMessage = OPEN(name=u'InitiatingMessage', mode=MODE_TYPE)
    _S1AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome = OPEN(name=u'SuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _S1AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome = OPEN(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _S1AP_ELEMENTARY_PROCEDURE_procedureCode = INT(name=u'procedureCode', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'ProcedureCode')), uniq=True)
    _S1AP_ELEMENTARY_PROCEDURE_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-CommonDataTypes', 'Criticality')), default=u'ignore')
    S1AP_ELEMENTARY_PROCEDURE._cont = ASN1Dict([
        (u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURE_InitiatingMessage),
        (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome),
        (u'UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome),
        (u'procedureCode', _S1AP_ELEMENTARY_PROCEDURE_procedureCode),
        (u'criticality', _S1AP_ELEMENTARY_PROCEDURE_criticality),
        ])
    
    #-----< S1AP-PDU >-----#
    S1AP_PDU = CHOICE(name=u'S1AP-PDU', mode=MODE_TYPE)
    _S1AP_PDU_initiatingMessage = SEQ(name=u'initiatingMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'InitiatingMessage')))
    _S1AP_PDU_successfulOutcome = SEQ(name=u'successfulOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'SuccessfulOutcome')))
    _S1AP_PDU_unsuccessfulOutcome = SEQ(name=u'unsuccessfulOutcome', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'UnsuccessfulOutcome')))
    S1AP_PDU._cont = ASN1Dict([
        (u'initiatingMessage', _S1AP_PDU_initiatingMessage),
        (u'successfulOutcome', _S1AP_PDU_successfulOutcome),
        (u'unsuccessfulOutcome', _S1AP_PDU_unsuccessfulOutcome),
        ])
    S1AP_PDU._ext = []
    
    #-----< InitiatingMessage >-----#
    InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE)
    _InitiatingMessage_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __InitiatingMessage_procedureCode_tab = CLASS(name='_tab_S1AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCommand')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverPreparationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseCommand')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancel')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancelAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Reset')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ResetAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_10 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseCommand')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseComplete')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_14 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverNotify')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Paging')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNASTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialUEMessage')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNASTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASNonDeliveryIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkS1cdma2000tunnelling')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkS1cdma2000tunnelling')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UECapabilityInfoIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBStatusTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEStatusTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DeactivateTrace')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceStart')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'CellTrafficTrace')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingControl')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStart')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStop')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBDirectInformationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEDirectInformationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PrivateMessage')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_44 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationIndication')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_45 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationIndication')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_46 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_47 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_48 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_48 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_49 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_49 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_50 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkUEAssociatedLPPaTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_51 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkUEAssociatedLPPaTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_52 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNonUEAssociatedLPPaTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_53 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNonUEAssociatedLPPaTransport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_54 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSRestartIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_55 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RerouteNASRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_56 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_57 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_58 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASDeliveryIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_59 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RetrieveUEInformation')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_60 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEInformationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_61 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBCPRelocationIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_62 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMECPRelocationIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_63 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_64 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverSuccess')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_65 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBEarlyStatusTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_66 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEEarlyStatusTransfer')))
    __InitiatingMessage_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1), (u'procedureCode', 1), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 3), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6), (u'procedureCode', 9), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7), (u'procedureCode', 4), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8), (u'procedureCode', 43), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9), (u'procedureCode', 14), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_10), (u'procedureCode', 17), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_11), (u'procedureCode', 21), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12), (u'procedureCode', 23), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_13), (u'procedureCode', 29), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_14), (u'procedureCode', 30), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15), (u'procedureCode', 36), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16), (u'procedureCode', 2), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17), (u'procedureCode', 8), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23), (u'procedureCode', 16), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24), (u'procedureCode', 18), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25), (u'procedureCode', 19), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26), (u'procedureCode', 20), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27), (u'procedureCode', 22), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28), (u'procedureCode', 24), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29), (u'procedureCode', 25), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30), (u'procedureCode', 26), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31), (u'procedureCode', 27), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32), (u'procedureCode', 28), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33), (u'procedureCode', 42), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34), (u'procedureCode', 31), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35), (u'procedureCode', 32), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36), (u'procedureCode', 33), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37), (u'procedureCode', 34), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38), (u'procedureCode', 35), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39), (u'procedureCode', 37), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40), (u'procedureCode', 38), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41), (u'procedureCode', 40), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42), (u'procedureCode', 41), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43), (u'procedureCode', 39), (u'criticality', u'ignore')])], rr=[], ev=[dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_44), (u'procedureCode', 48), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_45), (u'procedureCode', 50), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_46), (u'procedureCode', 53), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_47), (u'procedureCode', 55), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_48), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_48), (u'procedureCode', 56), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_49), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_49), (u'procedureCode', 63), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_50), (u'procedureCode', 44), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_51), (u'procedureCode', 45), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_52), (u'procedureCode', 46), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_53), (u'procedureCode', 47), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_54), (u'procedureCode', 49), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_55), (u'procedureCode', 52), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_56), (u'procedureCode', 51), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_57), (u'procedureCode', 54), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_58), (u'procedureCode', 57), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_59), (u'procedureCode', 58), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_60), (u'procedureCode', 59), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_61), (u'procedureCode', 60), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_62), (u'procedureCode', 61), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_63), (u'procedureCode', 62), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_64), (u'procedureCode', 64), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_65), (u'procedureCode', 65), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_66), (u'procedureCode', 66), (u'criticality', u'ignore')])], er=[])
    _InitiatingMessage_procedureCode._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_procedureCode._const_tab_at = None
    _InitiatingMessage_procedureCode._const_tab_id = u'procedureCode'
    _InitiatingMessage_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _InitiatingMessage_criticality._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_criticality._const_tab_at = ('..', u'procedureCode')
    _InitiatingMessage_criticality._const_tab_id = u'criticality'
    _InitiatingMessage_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE'), [u'InitiatingMessage']))
    _InitiatingMessage_value._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_value._const_tab_at = ('..', u'procedureCode')
    _InitiatingMessage_value._const_tab_id = u'InitiatingMessage'
    InitiatingMessage._cont = ASN1Dict([
        (u'procedureCode', _InitiatingMessage_procedureCode),
        (u'criticality', _InitiatingMessage_criticality),
        (u'value', _InitiatingMessage_value),
        ])
    InitiatingMessage._ext = None
    
    #-----< SuccessfulOutcome >-----#
    SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE)
    _SuccessfulOutcome_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __SuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_S1AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverPreparationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancel')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancelAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Reset')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ResetAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseComplete')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverNotify')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Paging')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNASTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialUEMessage')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNASTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASNonDeliveryIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkS1cdma2000tunnelling')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkS1cdma2000tunnelling')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UECapabilityInfoIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBStatusTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEStatusTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DeactivateTrace')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceStart')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'CellTrafficTrace')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingControl')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStart')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStop')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBDirectInformationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEDirectInformationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PrivateMessage')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_44 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_45 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_46 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_47 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_48 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_48 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_49 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkUEAssociatedLPPaTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkUEAssociatedLPPaTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNonUEAssociatedLPPaTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNonUEAssociatedLPPaTransport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSRestartIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RerouteNASRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASDeliveryIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RetrieveUEInformation')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEInformationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBCPRelocationIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMECPRelocationIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverSuccess')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBEarlyStatusTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEEarlyStatusTransfer')))
    __SuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), (u'procedureCode', 1), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 3), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), (u'procedureCode', 9), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), (u'procedureCode', 4), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), (u'procedureCode', 43), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), (u'procedureCode', 14), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10), (u'procedureCode', 17), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11), (u'procedureCode', 21), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12), (u'procedureCode', 23), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13), (u'procedureCode', 29), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14), (u'procedureCode', 30), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15), (u'procedureCode', 36), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), (u'procedureCode', 2), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), (u'procedureCode', 8), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), (u'procedureCode', 16), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), (u'procedureCode', 18), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), (u'procedureCode', 19), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), (u'procedureCode', 20), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27), (u'procedureCode', 22), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28), (u'procedureCode', 24), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29), (u'procedureCode', 25), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30), (u'procedureCode', 26), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31), (u'procedureCode', 27), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32), (u'procedureCode', 28), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33), (u'procedureCode', 42), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34), (u'procedureCode', 31), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35), (u'procedureCode', 32), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36), (u'procedureCode', 33), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37), (u'procedureCode', 34), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38), (u'procedureCode', 35), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39), (u'procedureCode', 37), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40), (u'procedureCode', 38), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41), (u'procedureCode', 40), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42), (u'procedureCode', 41), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43), (u'procedureCode', 39), (u'criticality', u'ignore')])], rr=[], ev=[dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_44), (u'procedureCode', 48), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_45), (u'procedureCode', 50), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_46), (u'procedureCode', 53), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_47), (u'procedureCode', 55), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_48), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_48), (u'procedureCode', 56), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_49), (u'procedureCode', 63), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50), (u'procedureCode', 44), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51), (u'procedureCode', 45), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52), (u'procedureCode', 46), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53), (u'procedureCode', 47), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54), (u'procedureCode', 49), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55), (u'procedureCode', 52), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56), (u'procedureCode', 51), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57), (u'procedureCode', 54), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58), (u'procedureCode', 57), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59), (u'procedureCode', 58), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60), (u'procedureCode', 59), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61), (u'procedureCode', 60), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62), (u'procedureCode', 61), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63), (u'procedureCode', 62), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64), (u'procedureCode', 64), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65), (u'procedureCode', 65), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66), (u'procedureCode', 66), (u'criticality', u'ignore')])], er=[])
    _SuccessfulOutcome_procedureCode._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_procedureCode._const_tab_at = None
    _SuccessfulOutcome_procedureCode._const_tab_id = u'procedureCode'
    _SuccessfulOutcome_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _SuccessfulOutcome_criticality._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_criticality._const_tab_at = ('..', u'procedureCode')
    _SuccessfulOutcome_criticality._const_tab_id = u'criticality'
    _SuccessfulOutcome_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE'), [u'SuccessfulOutcome']))
    _SuccessfulOutcome_value._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_value._const_tab_at = ('..', u'procedureCode')
    _SuccessfulOutcome_value._const_tab_id = u'SuccessfulOutcome'
    SuccessfulOutcome._cont = ASN1Dict([
        (u'procedureCode', _SuccessfulOutcome_procedureCode),
        (u'criticality', _SuccessfulOutcome_criticality),
        (u'value', _SuccessfulOutcome_value),
        ])
    SuccessfulOutcome._ext = None
    
    #-----< UnsuccessfulOutcome >-----#
    UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE)
    _UnsuccessfulOutcome_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __UnsuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_S1AP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverPreparationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancel')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancelAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Reset')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ResetAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseComplete')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverNotify')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Paging')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNASTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialUEMessage')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNASTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASNonDeliveryIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkS1cdma2000tunnelling')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkS1cdma2000tunnelling')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UECapabilityInfoIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBStatusTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEStatusTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DeactivateTrace')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceStart')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'CellTrafficTrace')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingControl')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStart')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStop')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBDirectInformationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEDirectInformationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PrivateMessage')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_44 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_45 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_46 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_47 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_48 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_48 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_49 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkUEAssociatedLPPaTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkUEAssociatedLPPaTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNonUEAssociatedLPPaTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNonUEAssociatedLPPaTransport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSRestartIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RerouteNASRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASDeliveryIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RetrieveUEInformation')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEInformationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBCPRelocationIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMECPRelocationIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverSuccess')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBEarlyStatusTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEEarlyStatusTransfer')))
    __UnsuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), (u'procedureCode', 1), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 3), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), (u'procedureCode', 9), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), (u'procedureCode', 4), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), (u'procedureCode', 43), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), (u'procedureCode', 14), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10), (u'procedureCode', 17), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11), (u'procedureCode', 21), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12), (u'procedureCode', 23), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13), (u'procedureCode', 29), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14), (u'procedureCode', 30), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15), (u'procedureCode', 36), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), (u'procedureCode', 2), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), (u'procedureCode', 8), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), (u'procedureCode', 16), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), (u'procedureCode', 18), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), (u'procedureCode', 19), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), (u'procedureCode', 20), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27), (u'procedureCode', 22), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28), (u'procedureCode', 24), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29), (u'procedureCode', 25), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30), (u'procedureCode', 26), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31), (u'procedureCode', 27), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32), (u'procedureCode', 28), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33), (u'procedureCode', 42), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34), (u'procedureCode', 31), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35), (u'procedureCode', 32), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36), (u'procedureCode', 33), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37), (u'procedureCode', 34), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38), (u'procedureCode', 35), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39), (u'procedureCode', 37), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40), (u'procedureCode', 38), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41), (u'procedureCode', 40), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42), (u'procedureCode', 41), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43), (u'procedureCode', 39), (u'criticality', u'ignore')])], rr=[], ev=[dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_44), (u'procedureCode', 48), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_45), (u'procedureCode', 50), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_46), (u'procedureCode', 53), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_47), (u'procedureCode', 55), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_48), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_48), (u'procedureCode', 56), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_49), (u'procedureCode', 63), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50), (u'procedureCode', 44), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51), (u'procedureCode', 45), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52), (u'procedureCode', 46), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53), (u'procedureCode', 47), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54), (u'procedureCode', 49), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55), (u'procedureCode', 52), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56), (u'procedureCode', 51), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57), (u'procedureCode', 54), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58), (u'procedureCode', 57), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59), (u'procedureCode', 58), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60), (u'procedureCode', 59), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61), (u'procedureCode', 60), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62), (u'procedureCode', 61), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63), (u'procedureCode', 62), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64), (u'procedureCode', 64), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65), (u'procedureCode', 65), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66), (u'procedureCode', 66), (u'criticality', u'ignore')])], er=[])
    _UnsuccessfulOutcome_procedureCode._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_procedureCode._const_tab_at = None
    _UnsuccessfulOutcome_procedureCode._const_tab_id = u'procedureCode'
    _UnsuccessfulOutcome_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _UnsuccessfulOutcome_criticality._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_criticality._const_tab_at = ('..', u'procedureCode')
    _UnsuccessfulOutcome_criticality._const_tab_id = u'criticality'
    _UnsuccessfulOutcome_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE'), [u'UnsuccessfulOutcome']))
    _UnsuccessfulOutcome_value._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_value._const_tab_at = ('..', u'procedureCode')
    _UnsuccessfulOutcome_value._const_tab_id = u'UnsuccessfulOutcome'
    UnsuccessfulOutcome._cont = ASN1Dict([
        (u'procedureCode', _UnsuccessfulOutcome_procedureCode),
        (u'criticality', _UnsuccessfulOutcome_criticality),
        (u'value', _UnsuccessfulOutcome_value),
        ])
    UnsuccessfulOutcome._ext = None
    
    #-----< S1AP-ELEMENTARY-PROCEDURES >-----#
    S1AP_ELEMENTARY_PROCEDURES = CLASS(name=u'S1AP-ELEMENTARY-PROCEDURES', mode=MODE_SET, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequired')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCommand')))
    _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverPreparationFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseCommand')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancel')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancelAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Reset')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ResetAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_10 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseCommand')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseComplete')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdate')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdate')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverNotify')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Paging')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNASTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialUEMessage')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNASTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ErrorIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASNonDeliveryIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkS1cdma2000tunnelling')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkS1cdma2000tunnelling')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UECapabilityInfoIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBStatusTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEStatusTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DeactivateTrace')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceStart')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceFailureIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'CellTrafficTrace')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingControl')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingFailureIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReport')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStart')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStop')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBDirectInformationTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEDirectInformationTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PrivateMessage')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_44 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_45 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationConfirm')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_46 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationConfirm')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_47 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_48 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_48 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_49 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkUEAssociatedLPPaTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkUEAssociatedLPPaTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNonUEAssociatedLPPaTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNonUEAssociatedLPPaTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSRestartIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RerouteNASRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSFailureIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASDeliveryIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_59 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RetrieveUEInformation')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_60 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEInformationTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_61 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBCPRelocationIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_62 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMECPRelocationIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_63 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_64 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverSuccess')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_65 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBEarlyStatusTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_66 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEEarlyStatusTransfer')))
    S1AP_ELEMENTARY_PROCEDURES._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1), (u'procedureCode', 1), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2), (u'procedureCode', 3), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6), (u'procedureCode', 9), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7), (u'procedureCode', 4), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8), (u'procedureCode', 43), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9), (u'procedureCode', 14), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10), (u'UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_10), (u'procedureCode', 17), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11), (u'procedureCode', 21), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12), (u'procedureCode', 23), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13), (u'procedureCode', 29), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14), (u'UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14), (u'procedureCode', 30), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15), (u'procedureCode', 36), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16), (u'procedureCode', 2), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17), (u'procedureCode', 8), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23), (u'procedureCode', 16), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24), (u'procedureCode', 18), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25), (u'procedureCode', 19), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26), (u'procedureCode', 20), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27), (u'procedureCode', 22), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28), (u'procedureCode', 24), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29), (u'procedureCode', 25), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30), (u'procedureCode', 26), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31), (u'procedureCode', 27), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32), (u'procedureCode', 28), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33), (u'procedureCode', 42), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34), (u'procedureCode', 31), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35), (u'procedureCode', 32), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36), (u'procedureCode', 33), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37), (u'procedureCode', 34), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38), (u'procedureCode', 35), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39), (u'procedureCode', 37), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40), (u'procedureCode', 38), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41), (u'procedureCode', 40), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42), (u'procedureCode', 41), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43), (u'procedureCode', 39), (u'criticality', u'ignore')])], rr=[], ev=[dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_44), (u'procedureCode', 48), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_45), (u'procedureCode', 50), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_46), (u'procedureCode', 53), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_47), (u'procedureCode', 55), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_48), (u'UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_48), (u'procedureCode', 56), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_49), (u'procedureCode', 63), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50), (u'procedureCode', 44), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51), (u'procedureCode', 45), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52), (u'procedureCode', 46), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53), (u'procedureCode', 47), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54), (u'procedureCode', 49), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55), (u'procedureCode', 52), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56), (u'procedureCode', 51), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57), (u'procedureCode', 54), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58), (u'procedureCode', 57), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_59), (u'procedureCode', 58), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_60), (u'procedureCode', 59), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_61), (u'procedureCode', 60), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_62), (u'procedureCode', 61), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_63), (u'procedureCode', 62), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_64), (u'procedureCode', 64), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_65), (u'procedureCode', 65), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_66), (u'procedureCode', 66), (u'criticality', u'ignore')])], er=[])
    
    #-----< S1AP-ELEMENTARY-PROCEDURES-CLASS-1 >-----#
    S1AP_ELEMENTARY_PROCEDURES_CLASS_1 = CLASS(name=u'S1AP-ELEMENTARY-PROCEDURES-CLASS-1', mode=MODE_SET, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequired')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCommand')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverPreparationFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseCommand')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancel')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancelAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Reset')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ResetAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseCommand')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseComplete')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdate')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdate')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateAcknowledge')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationConfirm')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationConfirm')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeResponse')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_20 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeFailure')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_21 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    S1AP_ELEMENTARY_PROCEDURES_CLASS_1._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1), (u'procedureCode', 1), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2), (u'procedureCode', 3), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6), (u'procedureCode', 9), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7), (u'procedureCode', 4), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8), (u'procedureCode', 43), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9), (u'procedureCode', 14), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10), (u'UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10), (u'procedureCode', 17), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11), (u'procedureCode', 21), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12), (u'procedureCode', 23), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13), (u'procedureCode', 29), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14), (u'UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14), (u'procedureCode', 30), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15), (u'procedureCode', 36), (u'criticality', u'reject')])], rr=[], ev=[dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16), (u'procedureCode', 48), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17), (u'procedureCode', 50), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18), (u'procedureCode', 53), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19), (u'procedureCode', 55), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20), (u'UnsuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_20), (u'procedureCode', 56), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21), (u'SuccessfulOutcome', _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_21), (u'procedureCode', 63), (u'criticality', u'reject')])], er=[])
    
    #-----< S1AP-ELEMENTARY-PROCEDURES-CLASS-2 >-----#
    S1AP_ELEMENTARY_PROCEDURES_CLASS_2 = CLASS(name=u'S1AP-ELEMENTARY-PROCEDURES-CLASS-2', mode=MODE_SET, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverNotify')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Paging')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNASTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialUEMessage')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNASTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ErrorIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASNonDeliveryIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkS1cdma2000tunnelling')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkS1cdma2000tunnelling')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UECapabilityInfoIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBStatusTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEStatusTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DeactivateTrace')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceStart')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceFailureIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'CellTrafficTrace')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingControl')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingFailureIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReport')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStart')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStop')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBDirectInformationTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEDirectInformationTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PrivateMessage')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkUEAssociatedLPPaTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkUEAssociatedLPPaTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNonUEAssociatedLPPaTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNonUEAssociatedLPPaTransport')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSRestartIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RerouteNASRequest')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSFailureIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASDeliveryIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RetrieveUEInformation')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEInformationTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBCPRelocationIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMECPRelocationIndication')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverSuccess')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBEarlyStatusTransfer')))
    _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEEarlyStatusTransfer')))
    S1AP_ELEMENTARY_PROCEDURES_CLASS_2._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0), (u'procedureCode', 2), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1), (u'procedureCode', 8), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2), (u'procedureCode', 10), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5), (u'procedureCode', 13), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6), (u'procedureCode', 15), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7), (u'procedureCode', 16), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8), (u'procedureCode', 18), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9), (u'procedureCode', 19), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10), (u'procedureCode', 20), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11), (u'procedureCode', 22), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12), (u'procedureCode', 24), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13), (u'procedureCode', 25), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14), (u'procedureCode', 26), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15), (u'procedureCode', 27), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16), (u'procedureCode', 28), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17), (u'procedureCode', 42), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18), (u'procedureCode', 31), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19), (u'procedureCode', 32), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20), (u'procedureCode', 33), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21), (u'procedureCode', 34), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22), (u'procedureCode', 35), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23), (u'procedureCode', 37), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24), (u'procedureCode', 38), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25), (u'procedureCode', 40), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26), (u'procedureCode', 41), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27), (u'procedureCode', 39), (u'criticality', u'ignore')])], rr=[], ev=[dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28), (u'procedureCode', 44), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29), (u'procedureCode', 45), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30), (u'procedureCode', 46), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31), (u'procedureCode', 47), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32), (u'procedureCode', 49), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33), (u'procedureCode', 52), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34), (u'procedureCode', 51), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35), (u'procedureCode', 54), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_36), (u'procedureCode', 57), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_37), (u'procedureCode', 58), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_38), (u'procedureCode', 59), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_39), (u'procedureCode', 60), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_40), (u'procedureCode', 61), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_41), (u'procedureCode', 62), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_42), (u'procedureCode', 64), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_43), (u'procedureCode', 65), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_44), (u'procedureCode', 66), (u'criticality', u'ignore')])], er=[])
    
    #-----< handoverPreparation >-----#
    handoverPreparation = CLASS(name=u'handoverPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _handoverPreparation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequired')))
    _handoverPreparation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCommand')))
    _handoverPreparation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverPreparationFailure')))
    handoverPreparation._val = dict([(u'InitiatingMessage', _handoverPreparation_val_InitiatingMessage), (u'SuccessfulOutcome', _handoverPreparation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _handoverPreparation_val_UnsuccessfulOutcome), (u'procedureCode', 0), (u'criticality', u'reject')])
    
    #-----< handoverResourceAllocation >-----#
    handoverResourceAllocation = CLASS(name=u'handoverResourceAllocation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _handoverResourceAllocation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequest')))
    _handoverResourceAllocation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverRequestAcknowledge')))
    _handoverResourceAllocation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverFailure')))
    handoverResourceAllocation._val = dict([(u'InitiatingMessage', _handoverResourceAllocation_val_InitiatingMessage), (u'SuccessfulOutcome', _handoverResourceAllocation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _handoverResourceAllocation_val_UnsuccessfulOutcome), (u'procedureCode', 1), (u'criticality', u'reject')])
    
    #-----< handoverNotification >-----#
    handoverNotification = CLASS(name=u'handoverNotification', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _handoverNotification_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverNotify')))
    handoverNotification._val = dict([(u'InitiatingMessage', _handoverNotification_val_InitiatingMessage), (u'procedureCode', 2), (u'criticality', u'ignore')])
    
    #-----< pathSwitchRequest >-----#
    pathSwitchRequest = CLASS(name=u'pathSwitchRequest', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _pathSwitchRequest_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequest')))
    _pathSwitchRequest_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestAcknowledge')))
    _pathSwitchRequest_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PathSwitchRequestFailure')))
    pathSwitchRequest._val = dict([(u'InitiatingMessage', _pathSwitchRequest_val_InitiatingMessage), (u'SuccessfulOutcome', _pathSwitchRequest_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _pathSwitchRequest_val_UnsuccessfulOutcome), (u'procedureCode', 3), (u'criticality', u'reject')])
    
    #-----< e-RABSetup >-----#
    e_RABSetup = CLASS(name=u'e-RABSetup', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _e_RABSetup_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupRequest')))
    _e_RABSetup_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABSetupResponse')))
    e_RABSetup._val = dict([(u'InitiatingMessage', _e_RABSetup_val_InitiatingMessage), (u'SuccessfulOutcome', _e_RABSetup_val_SuccessfulOutcome), (u'procedureCode', 5), (u'criticality', u'reject')])
    
    #-----< e-RABModify >-----#
    e_RABModify = CLASS(name=u'e-RABModify', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _e_RABModify_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyRequest')))
    _e_RABModify_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModifyResponse')))
    e_RABModify._val = dict([(u'InitiatingMessage', _e_RABModify_val_InitiatingMessage), (u'SuccessfulOutcome', _e_RABModify_val_SuccessfulOutcome), (u'procedureCode', 6), (u'criticality', u'reject')])
    
    #-----< e-RABRelease >-----#
    e_RABRelease = CLASS(name=u'e-RABRelease', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _e_RABRelease_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseCommand')))
    _e_RABRelease_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseResponse')))
    e_RABRelease._val = dict([(u'InitiatingMessage', _e_RABRelease_val_InitiatingMessage), (u'SuccessfulOutcome', _e_RABRelease_val_SuccessfulOutcome), (u'procedureCode', 7), (u'criticality', u'reject')])
    
    #-----< e-RABReleaseIndication >-----#
    e_RABReleaseIndication = CLASS(name=u'e-RABReleaseIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _e_RABReleaseIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABReleaseIndication')))
    e_RABReleaseIndication._val = dict([(u'InitiatingMessage', _e_RABReleaseIndication_val_InitiatingMessage), (u'procedureCode', 8), (u'criticality', u'ignore')])
    
    #-----< initialContextSetup >-----#
    initialContextSetup = CLASS(name=u'initialContextSetup', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _initialContextSetup_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupRequest')))
    _initialContextSetup_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupResponse')))
    _initialContextSetup_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialContextSetupFailure')))
    initialContextSetup._val = dict([(u'InitiatingMessage', _initialContextSetup_val_InitiatingMessage), (u'SuccessfulOutcome', _initialContextSetup_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _initialContextSetup_val_UnsuccessfulOutcome), (u'procedureCode', 9), (u'criticality', u'reject')])
    
    #-----< uEContextReleaseRequest >-----#
    uEContextReleaseRequest = CLASS(name=u'uEContextReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uEContextReleaseRequest_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseRequest')))
    uEContextReleaseRequest._val = dict([(u'InitiatingMessage', _uEContextReleaseRequest_val_InitiatingMessage), (u'procedureCode', 18), (u'criticality', u'ignore')])
    
    #-----< paging >-----#
    paging = CLASS(name=u'paging', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _paging_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Paging')))
    paging._val = dict([(u'InitiatingMessage', _paging_val_InitiatingMessage), (u'procedureCode', 10), (u'criticality', u'ignore')])
    
    #-----< downlinkNASTransport >-----#
    downlinkNASTransport = CLASS(name=u'downlinkNASTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _downlinkNASTransport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNASTransport')))
    downlinkNASTransport._val = dict([(u'InitiatingMessage', _downlinkNASTransport_val_InitiatingMessage), (u'procedureCode', 11), (u'criticality', u'ignore')])
    
    #-----< initialUEMessage >-----#
    initialUEMessage = CLASS(name=u'initialUEMessage', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _initialUEMessage_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'InitialUEMessage')))
    initialUEMessage._val = dict([(u'InitiatingMessage', _initialUEMessage_val_InitiatingMessage), (u'procedureCode', 12), (u'criticality', u'ignore')])
    
    #-----< uplinkNASTransport >-----#
    uplinkNASTransport = CLASS(name=u'uplinkNASTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uplinkNASTransport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNASTransport')))
    uplinkNASTransport._val = dict([(u'InitiatingMessage', _uplinkNASTransport_val_InitiatingMessage), (u'procedureCode', 13), (u'criticality', u'ignore')])
    
    #-----< nASNonDeliveryIndication >-----#
    nASNonDeliveryIndication = CLASS(name=u'nASNonDeliveryIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _nASNonDeliveryIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASNonDeliveryIndication')))
    nASNonDeliveryIndication._val = dict([(u'InitiatingMessage', _nASNonDeliveryIndication_val_InitiatingMessage), (u'procedureCode', 16), (u'criticality', u'ignore')])
    
    #-----< handoverCancel >-----#
    handoverCancel = CLASS(name=u'handoverCancel', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _handoverCancel_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancel')))
    _handoverCancel_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverCancelAcknowledge')))
    handoverCancel._val = dict([(u'InitiatingMessage', _handoverCancel_val_InitiatingMessage), (u'SuccessfulOutcome', _handoverCancel_val_SuccessfulOutcome), (u'procedureCode', 4), (u'criticality', u'reject')])
    
    #-----< reset >-----#
    reset = CLASS(name=u'reset', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _reset_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'Reset')))
    _reset_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ResetAcknowledge')))
    reset._val = dict([(u'InitiatingMessage', _reset_val_InitiatingMessage), (u'SuccessfulOutcome', _reset_val_SuccessfulOutcome), (u'procedureCode', 14), (u'criticality', u'reject')])
    
    #-----< errorIndication >-----#
    errorIndication = CLASS(name=u'errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _errorIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ErrorIndication')))
    errorIndication._val = dict([(u'InitiatingMessage', _errorIndication_val_InitiatingMessage), (u'procedureCode', 15), (u'criticality', u'ignore')])
    
    #-----< s1Setup >-----#
    s1Setup = CLASS(name=u's1Setup', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _s1Setup_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupRequest')))
    _s1Setup_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupResponse')))
    _s1Setup_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'S1SetupFailure')))
    s1Setup._val = dict([(u'InitiatingMessage', _s1Setup_val_InitiatingMessage), (u'SuccessfulOutcome', _s1Setup_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _s1Setup_val_UnsuccessfulOutcome), (u'procedureCode', 17), (u'criticality', u'reject')])
    
    #-----< eNBConfigurationUpdate >-----#
    eNBConfigurationUpdate = CLASS(name=u'eNBConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _eNBConfigurationUpdate_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdate')))
    _eNBConfigurationUpdate_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateAcknowledge')))
    _eNBConfigurationUpdate_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationUpdateFailure')))
    eNBConfigurationUpdate._val = dict([(u'InitiatingMessage', _eNBConfigurationUpdate_val_InitiatingMessage), (u'SuccessfulOutcome', _eNBConfigurationUpdate_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _eNBConfigurationUpdate_val_UnsuccessfulOutcome), (u'procedureCode', 29), (u'criticality', u'reject')])
    
    #-----< mMEConfigurationUpdate >-----#
    mMEConfigurationUpdate = CLASS(name=u'mMEConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _mMEConfigurationUpdate_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdate')))
    _mMEConfigurationUpdate_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateAcknowledge')))
    _mMEConfigurationUpdate_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationUpdateFailure')))
    mMEConfigurationUpdate._val = dict([(u'InitiatingMessage', _mMEConfigurationUpdate_val_InitiatingMessage), (u'SuccessfulOutcome', _mMEConfigurationUpdate_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _mMEConfigurationUpdate_val_UnsuccessfulOutcome), (u'procedureCode', 30), (u'criticality', u'reject')])
    
    #-----< downlinkS1cdma2000tunnelling >-----#
    downlinkS1cdma2000tunnelling = CLASS(name=u'downlinkS1cdma2000tunnelling', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _downlinkS1cdma2000tunnelling_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkS1cdma2000tunnelling')))
    downlinkS1cdma2000tunnelling._val = dict([(u'InitiatingMessage', _downlinkS1cdma2000tunnelling_val_InitiatingMessage), (u'procedureCode', 19), (u'criticality', u'ignore')])
    
    #-----< uplinkS1cdma2000tunnelling >-----#
    uplinkS1cdma2000tunnelling = CLASS(name=u'uplinkS1cdma2000tunnelling', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uplinkS1cdma2000tunnelling_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkS1cdma2000tunnelling')))
    uplinkS1cdma2000tunnelling._val = dict([(u'InitiatingMessage', _uplinkS1cdma2000tunnelling_val_InitiatingMessage), (u'procedureCode', 20), (u'criticality', u'ignore')])
    
    #-----< uEContextModification >-----#
    uEContextModification = CLASS(name=u'uEContextModification', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uEContextModification_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationRequest')))
    _uEContextModification_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationResponse')))
    _uEContextModification_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationFailure')))
    uEContextModification._val = dict([(u'InitiatingMessage', _uEContextModification_val_InitiatingMessage), (u'SuccessfulOutcome', _uEContextModification_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _uEContextModification_val_UnsuccessfulOutcome), (u'procedureCode', 21), (u'criticality', u'reject')])
    
    #-----< uECapabilityInfoIndication >-----#
    uECapabilityInfoIndication = CLASS(name=u'uECapabilityInfoIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uECapabilityInfoIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UECapabilityInfoIndication')))
    uECapabilityInfoIndication._val = dict([(u'InitiatingMessage', _uECapabilityInfoIndication_val_InitiatingMessage), (u'procedureCode', 22), (u'criticality', u'ignore')])
    
    #-----< uEContextRelease >-----#
    uEContextRelease = CLASS(name=u'uEContextRelease', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uEContextRelease_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseCommand')))
    _uEContextRelease_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextReleaseComplete')))
    uEContextRelease._val = dict([(u'InitiatingMessage', _uEContextRelease_val_InitiatingMessage), (u'SuccessfulOutcome', _uEContextRelease_val_SuccessfulOutcome), (u'procedureCode', 23), (u'criticality', u'reject')])
    
    #-----< eNBStatusTransfer >-----#
    eNBStatusTransfer = CLASS(name=u'eNBStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _eNBStatusTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBStatusTransfer')))
    eNBStatusTransfer._val = dict([(u'InitiatingMessage', _eNBStatusTransfer_val_InitiatingMessage), (u'procedureCode', 24), (u'criticality', u'ignore')])
    
    #-----< mMEStatusTransfer >-----#
    mMEStatusTransfer = CLASS(name=u'mMEStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _mMEStatusTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEStatusTransfer')))
    mMEStatusTransfer._val = dict([(u'InitiatingMessage', _mMEStatusTransfer_val_InitiatingMessage), (u'procedureCode', 25), (u'criticality', u'ignore')])
    
    #-----< deactivateTrace >-----#
    deactivateTrace = CLASS(name=u'deactivateTrace', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _deactivateTrace_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DeactivateTrace')))
    deactivateTrace._val = dict([(u'InitiatingMessage', _deactivateTrace_val_InitiatingMessage), (u'procedureCode', 26), (u'criticality', u'ignore')])
    
    #-----< traceStart >-----#
    traceStart = CLASS(name=u'traceStart', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _traceStart_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceStart')))
    traceStart._val = dict([(u'InitiatingMessage', _traceStart_val_InitiatingMessage), (u'procedureCode', 27), (u'criticality', u'ignore')])
    
    #-----< traceFailureIndication >-----#
    traceFailureIndication = CLASS(name=u'traceFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _traceFailureIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'TraceFailureIndication')))
    traceFailureIndication._val = dict([(u'InitiatingMessage', _traceFailureIndication_val_InitiatingMessage), (u'procedureCode', 28), (u'criticality', u'ignore')])
    
    #-----< cellTrafficTrace >-----#
    cellTrafficTrace = CLASS(name=u'cellTrafficTrace', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _cellTrafficTrace_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'CellTrafficTrace')))
    cellTrafficTrace._val = dict([(u'InitiatingMessage', _cellTrafficTrace_val_InitiatingMessage), (u'procedureCode', 42), (u'criticality', u'ignore')])
    
    #-----< locationReportingControl >-----#
    locationReportingControl = CLASS(name=u'locationReportingControl', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _locationReportingControl_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingControl')))
    locationReportingControl._val = dict([(u'InitiatingMessage', _locationReportingControl_val_InitiatingMessage), (u'procedureCode', 31), (u'criticality', u'ignore')])
    
    #-----< locationReportingFailureIndication >-----#
    locationReportingFailureIndication = CLASS(name=u'locationReportingFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _locationReportingFailureIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReportingFailureIndication')))
    locationReportingFailureIndication._val = dict([(u'InitiatingMessage', _locationReportingFailureIndication_val_InitiatingMessage), (u'procedureCode', 32), (u'criticality', u'ignore')])
    
    #-----< locationReport >-----#
    locationReport = CLASS(name=u'locationReport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _locationReport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'LocationReport')))
    locationReport._val = dict([(u'InitiatingMessage', _locationReport_val_InitiatingMessage), (u'procedureCode', 33), (u'criticality', u'ignore')])
    
    #-----< overloadStart >-----#
    overloadStart = CLASS(name=u'overloadStart', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _overloadStart_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStart')))
    overloadStart._val = dict([(u'InitiatingMessage', _overloadStart_val_InitiatingMessage), (u'procedureCode', 34), (u'criticality', u'ignore')])
    
    #-----< overloadStop >-----#
    overloadStop = CLASS(name=u'overloadStop', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _overloadStop_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'OverloadStop')))
    overloadStop._val = dict([(u'InitiatingMessage', _overloadStop_val_InitiatingMessage), (u'procedureCode', 35), (u'criticality', u'reject')])
    
    #-----< writeReplaceWarning >-----#
    writeReplaceWarning = CLASS(name=u'writeReplaceWarning', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _writeReplaceWarning_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningRequest')))
    _writeReplaceWarning_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'WriteReplaceWarningResponse')))
    writeReplaceWarning._val = dict([(u'InitiatingMessage', _writeReplaceWarning_val_InitiatingMessage), (u'SuccessfulOutcome', _writeReplaceWarning_val_SuccessfulOutcome), (u'procedureCode', 36), (u'criticality', u'reject')])
    
    #-----< eNBDirectInformationTransfer >-----#
    eNBDirectInformationTransfer = CLASS(name=u'eNBDirectInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _eNBDirectInformationTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBDirectInformationTransfer')))
    eNBDirectInformationTransfer._val = dict([(u'InitiatingMessage', _eNBDirectInformationTransfer_val_InitiatingMessage), (u'procedureCode', 37), (u'criticality', u'ignore')])
    
    #-----< mMEDirectInformationTransfer >-----#
    mMEDirectInformationTransfer = CLASS(name=u'mMEDirectInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _mMEDirectInformationTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEDirectInformationTransfer')))
    mMEDirectInformationTransfer._val = dict([(u'InitiatingMessage', _mMEDirectInformationTransfer_val_InitiatingMessage), (u'procedureCode', 38), (u'criticality', u'ignore')])
    
    #-----< eNBConfigurationTransfer >-----#
    eNBConfigurationTransfer = CLASS(name=u'eNBConfigurationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _eNBConfigurationTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBConfigurationTransfer')))
    eNBConfigurationTransfer._val = dict([(u'InitiatingMessage', _eNBConfigurationTransfer_val_InitiatingMessage), (u'procedureCode', 40), (u'criticality', u'ignore')])
    
    #-----< mMEConfigurationTransfer >-----#
    mMEConfigurationTransfer = CLASS(name=u'mMEConfigurationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _mMEConfigurationTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEConfigurationTransfer')))
    mMEConfigurationTransfer._val = dict([(u'InitiatingMessage', _mMEConfigurationTransfer_val_InitiatingMessage), (u'procedureCode', 41), (u'criticality', u'ignore')])
    
    #-----< privateMessage >-----#
    privateMessage = CLASS(name=u'privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _privateMessage_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PrivateMessage')))
    privateMessage._val = dict([(u'InitiatingMessage', _privateMessage_val_InitiatingMessage), (u'procedureCode', 39), (u'criticality', u'ignore')])
    
    #-----< pWSRestartIndication >-----#
    pWSRestartIndication = CLASS(name=u'pWSRestartIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _pWSRestartIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSRestartIndication')))
    pWSRestartIndication._val = dict([(u'InitiatingMessage', _pWSRestartIndication_val_InitiatingMessage), (u'procedureCode', 49), (u'criticality', u'ignore')])
    
    #-----< kill >-----#
    kill = CLASS(name=u'kill', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _kill_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillRequest')))
    _kill_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'KillResponse')))
    kill._val = dict([(u'InitiatingMessage', _kill_val_InitiatingMessage), (u'SuccessfulOutcome', _kill_val_SuccessfulOutcome), (u'procedureCode', 43), (u'criticality', u'reject')])
    
    #-----< downlinkUEAssociatedLPPaTransport >-----#
    downlinkUEAssociatedLPPaTransport = CLASS(name=u'downlinkUEAssociatedLPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _downlinkUEAssociatedLPPaTransport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkUEAssociatedLPPaTransport')))
    downlinkUEAssociatedLPPaTransport._val = dict([(u'InitiatingMessage', _downlinkUEAssociatedLPPaTransport_val_InitiatingMessage), (u'procedureCode', 44), (u'criticality', u'ignore')])
    
    #-----< uplinkUEAssociatedLPPaTransport >-----#
    uplinkUEAssociatedLPPaTransport = CLASS(name=u'uplinkUEAssociatedLPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uplinkUEAssociatedLPPaTransport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkUEAssociatedLPPaTransport')))
    uplinkUEAssociatedLPPaTransport._val = dict([(u'InitiatingMessage', _uplinkUEAssociatedLPPaTransport_val_InitiatingMessage), (u'procedureCode', 45), (u'criticality', u'ignore')])
    
    #-----< downlinkNonUEAssociatedLPPaTransport >-----#
    downlinkNonUEAssociatedLPPaTransport = CLASS(name=u'downlinkNonUEAssociatedLPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _downlinkNonUEAssociatedLPPaTransport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'DownlinkNonUEAssociatedLPPaTransport')))
    downlinkNonUEAssociatedLPPaTransport._val = dict([(u'InitiatingMessage', _downlinkNonUEAssociatedLPPaTransport_val_InitiatingMessage), (u'procedureCode', 46), (u'criticality', u'ignore')])
    
    #-----< uplinkNonUEAssociatedLPPaTransport >-----#
    uplinkNonUEAssociatedLPPaTransport = CLASS(name=u'uplinkNonUEAssociatedLPPaTransport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uplinkNonUEAssociatedLPPaTransport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UplinkNonUEAssociatedLPPaTransport')))
    uplinkNonUEAssociatedLPPaTransport._val = dict([(u'InitiatingMessage', _uplinkNonUEAssociatedLPPaTransport_val_InitiatingMessage), (u'procedureCode', 47), (u'criticality', u'ignore')])
    
    #-----< uERadioCapabilityMatch >-----#
    uERadioCapabilityMatch = CLASS(name=u'uERadioCapabilityMatch', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uERadioCapabilityMatch_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchRequest')))
    _uERadioCapabilityMatch_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityMatchResponse')))
    uERadioCapabilityMatch._val = dict([(u'InitiatingMessage', _uERadioCapabilityMatch_val_InitiatingMessage), (u'SuccessfulOutcome', _uERadioCapabilityMatch_val_SuccessfulOutcome), (u'procedureCode', 48), (u'criticality', u'reject')])
    
    #-----< e-RABModificationIndication >-----#
    e_RABModificationIndication = CLASS(name=u'e-RABModificationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _e_RABModificationIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationIndication')))
    _e_RABModificationIndication_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'E-RABModificationConfirm')))
    e_RABModificationIndication._val = dict([(u'InitiatingMessage', _e_RABModificationIndication_val_InitiatingMessage), (u'SuccessfulOutcome', _e_RABModificationIndication_val_SuccessfulOutcome), (u'procedureCode', 50), (u'criticality', u'reject')])
    
    #-----< uEContextModificationIndication >-----#
    uEContextModificationIndication = CLASS(name=u'uEContextModificationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uEContextModificationIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationIndication')))
    _uEContextModificationIndication_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextModificationConfirm')))
    uEContextModificationIndication._val = dict([(u'InitiatingMessage', _uEContextModificationIndication_val_InitiatingMessage), (u'SuccessfulOutcome', _uEContextModificationIndication_val_SuccessfulOutcome), (u'procedureCode', 53), (u'criticality', u'reject')])
    
    #-----< rerouteNASRequest >-----#
    rerouteNASRequest = CLASS(name=u'rerouteNASRequest', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _rerouteNASRequest_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RerouteNASRequest')))
    rerouteNASRequest._val = dict([(u'InitiatingMessage', _rerouteNASRequest_val_InitiatingMessage), (u'procedureCode', 52), (u'criticality', u'reject')])
    
    #-----< pWSFailureIndication >-----#
    pWSFailureIndication = CLASS(name=u'pWSFailureIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _pWSFailureIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'PWSFailureIndication')))
    pWSFailureIndication._val = dict([(u'InitiatingMessage', _pWSFailureIndication_val_InitiatingMessage), (u'procedureCode', 51), (u'criticality', u'ignore')])
    
    #-----< uEContextSuspend >-----#
    uEContextSuspend = CLASS(name=u'uEContextSuspend', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uEContextSuspend_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendRequest')))
    _uEContextSuspend_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextSuspendResponse')))
    uEContextSuspend._val = dict([(u'InitiatingMessage', _uEContextSuspend_val_InitiatingMessage), (u'SuccessfulOutcome', _uEContextSuspend_val_SuccessfulOutcome), (u'procedureCode', 55), (u'criticality', u'reject')])
    
    #-----< uEContextResume >-----#
    uEContextResume = CLASS(name=u'uEContextResume', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uEContextResume_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeRequest')))
    _uEContextResume_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeResponse')))
    _uEContextResume_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEContextResumeFailure')))
    uEContextResume._val = dict([(u'InitiatingMessage', _uEContextResume_val_InitiatingMessage), (u'SuccessfulOutcome', _uEContextResume_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _uEContextResume_val_UnsuccessfulOutcome), (u'procedureCode', 56), (u'criticality', u'reject')])
    
    #-----< connectionEstablishmentIndication >-----#
    connectionEstablishmentIndication = CLASS(name=u'connectionEstablishmentIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _connectionEstablishmentIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ConnectionEstablishmentIndication')))
    connectionEstablishmentIndication._val = dict([(u'InitiatingMessage', _connectionEstablishmentIndication_val_InitiatingMessage), (u'procedureCode', 54), (u'criticality', u'reject')])
    
    #-----< nASDeliveryIndication >-----#
    nASDeliveryIndication = CLASS(name=u'nASDeliveryIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _nASDeliveryIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'NASDeliveryIndication')))
    nASDeliveryIndication._val = dict([(u'InitiatingMessage', _nASDeliveryIndication_val_InitiatingMessage), (u'procedureCode', 57), (u'criticality', u'ignore')])
    
    #-----< retrieveUEInformation >-----#
    retrieveUEInformation = CLASS(name=u'retrieveUEInformation', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _retrieveUEInformation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'RetrieveUEInformation')))
    retrieveUEInformation._val = dict([(u'InitiatingMessage', _retrieveUEInformation_val_InitiatingMessage), (u'procedureCode', 58), (u'criticality', u'reject')])
    
    #-----< uEInformationTransfer >-----#
    uEInformationTransfer = CLASS(name=u'uEInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uEInformationTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UEInformationTransfer')))
    uEInformationTransfer._val = dict([(u'InitiatingMessage', _uEInformationTransfer_val_InitiatingMessage), (u'procedureCode', 59), (u'criticality', u'reject')])
    
    #-----< eNBCPRelocationIndication >-----#
    eNBCPRelocationIndication = CLASS(name=u'eNBCPRelocationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _eNBCPRelocationIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBCPRelocationIndication')))
    eNBCPRelocationIndication._val = dict([(u'InitiatingMessage', _eNBCPRelocationIndication_val_InitiatingMessage), (u'procedureCode', 60), (u'criticality', u'reject')])
    
    #-----< mMECPRelocationIndication >-----#
    mMECPRelocationIndication = CLASS(name=u'mMECPRelocationIndication', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _mMECPRelocationIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMECPRelocationIndication')))
    mMECPRelocationIndication._val = dict([(u'InitiatingMessage', _mMECPRelocationIndication_val_InitiatingMessage), (u'procedureCode', 61), (u'criticality', u'reject')])
    
    #-----< secondaryRATDataUsageReport >-----#
    secondaryRATDataUsageReport = CLASS(name=u'secondaryRATDataUsageReport', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _secondaryRATDataUsageReport_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'SecondaryRATDataUsageReport')))
    secondaryRATDataUsageReport._val = dict([(u'InitiatingMessage', _secondaryRATDataUsageReport_val_InitiatingMessage), (u'procedureCode', 62), (u'criticality', u'ignore')])
    
    #-----< uERadioCapabilityIDMapping >-----#
    uERadioCapabilityIDMapping = CLASS(name=u'uERadioCapabilityIDMapping', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _uERadioCapabilityIDMapping_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingRequest')))
    _uERadioCapabilityIDMapping_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'UERadioCapabilityIDMappingResponse')))
    uERadioCapabilityIDMapping._val = dict([(u'InitiatingMessage', _uERadioCapabilityIDMapping_val_InitiatingMessage), (u'SuccessfulOutcome', _uERadioCapabilityIDMapping_val_SuccessfulOutcome), (u'procedureCode', 63), (u'criticality', u'reject')])
    
    #-----< handoverSuccess >-----#
    handoverSuccess = CLASS(name=u'handoverSuccess', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _handoverSuccess_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'HandoverSuccess')))
    handoverSuccess._val = dict([(u'InitiatingMessage', _handoverSuccess_val_InitiatingMessage), (u'procedureCode', 64), (u'criticality', u'ignore')])
    
    #-----< eNBEarlyStatusTransfer >-----#
    eNBEarlyStatusTransfer = CLASS(name=u'eNBEarlyStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _eNBEarlyStatusTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'ENBEarlyStatusTransfer')))
    eNBEarlyStatusTransfer._val = dict([(u'InitiatingMessage', _eNBEarlyStatusTransfer_val_InitiatingMessage), (u'procedureCode', 65), (u'criticality', u'reject')])
    
    #-----< mMEEarlyStatusTransfer >-----#
    mMEEarlyStatusTransfer = CLASS(name=u'mMEEarlyStatusTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('S1AP-PDU-Descriptions', 'S1AP-ELEMENTARY-PROCEDURE')))
    _mMEEarlyStatusTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('S1AP-PDU-Contents', 'MMEEarlyStatusTransfer')))
    mMEEarlyStatusTransfer._val = dict([(u'InitiatingMessage', _mMEEarlyStatusTransfer_val_InitiatingMessage), (u'procedureCode', 66), (u'criticality', u'ignore')])
    
    _all_ = [
        _S1AP_ELEMENTARY_PROCEDURE_InitiatingMessage,
        _S1AP_ELEMENTARY_PROCEDURE_SuccessfulOutcome,
        _S1AP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome,
        _S1AP_ELEMENTARY_PROCEDURE_procedureCode,
        _S1AP_ELEMENTARY_PROCEDURE_criticality,
        S1AP_ELEMENTARY_PROCEDURE,
        _S1AP_PDU_initiatingMessage,
        _S1AP_PDU_successfulOutcome,
        _S1AP_PDU_unsuccessfulOutcome,
        S1AP_PDU,
        __InitiatingMessage_procedureCode_tab,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_10,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_11,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_11,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_12,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_13,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_13,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_14,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_14,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_15,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_44,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_45,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_46,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_47,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_48,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_48,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_49,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_49,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_50,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_51,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_52,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_53,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_54,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_55,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_56,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_57,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_58,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_59,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_60,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_61,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_62,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_63,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_64,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_65,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_66,
        _InitiatingMessage_procedureCode,
        _InitiatingMessage_criticality,
        _InitiatingMessage_value,
        InitiatingMessage,
        __SuccessfulOutcome_procedureCode_tab,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_44,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_45,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_46,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_47,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_48,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_48,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_49,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66,
        _SuccessfulOutcome_procedureCode,
        _SuccessfulOutcome_criticality,
        _SuccessfulOutcome_value,
        SuccessfulOutcome,
        __UnsuccessfulOutcome_procedureCode_tab,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_44,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_45,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_46,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_47,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_48,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_48,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_49,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_49,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_50,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_51,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_52,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_53,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_54,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_55,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_56,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_57,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_58,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_59,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_60,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_61,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_62,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_63,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_64,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_65,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_66,
        _UnsuccessfulOutcome_procedureCode,
        _UnsuccessfulOutcome_criticality,
        _UnsuccessfulOutcome_value,
        UnsuccessfulOutcome,
        S1AP_ELEMENTARY_PROCEDURES,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0,
        _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1,
        _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2,
        _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6,
        _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10,
        _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_10,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11,
        _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13,
        _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_14,
        _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_14,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_15,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_44,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_45,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_46,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_47,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_48,
        _S1AP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_48,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49,
        _S1AP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_49,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_59,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_60,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_61,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_62,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_63,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_64,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_65,
        _S1AP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_66,
        S1AP_ELEMENTARY_PROCEDURES_CLASS_1,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_20,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_21,
        S1AP_ELEMENTARY_PROCEDURES_CLASS_2,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_36,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_37,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_38,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_39,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_40,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_41,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_42,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_43,
        _S1AP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_44,
        handoverPreparation,
        _handoverPreparation_val_InitiatingMessage,
        _handoverPreparation_val_SuccessfulOutcome,
        _handoverPreparation_val_UnsuccessfulOutcome,
        handoverResourceAllocation,
        _handoverResourceAllocation_val_InitiatingMessage,
        _handoverResourceAllocation_val_SuccessfulOutcome,
        _handoverResourceAllocation_val_UnsuccessfulOutcome,
        handoverNotification,
        _handoverNotification_val_InitiatingMessage,
        pathSwitchRequest,
        _pathSwitchRequest_val_InitiatingMessage,
        _pathSwitchRequest_val_SuccessfulOutcome,
        _pathSwitchRequest_val_UnsuccessfulOutcome,
        e_RABSetup,
        _e_RABSetup_val_InitiatingMessage,
        _e_RABSetup_val_SuccessfulOutcome,
        e_RABModify,
        _e_RABModify_val_InitiatingMessage,
        _e_RABModify_val_SuccessfulOutcome,
        e_RABRelease,
        _e_RABRelease_val_InitiatingMessage,
        _e_RABRelease_val_SuccessfulOutcome,
        e_RABReleaseIndication,
        _e_RABReleaseIndication_val_InitiatingMessage,
        initialContextSetup,
        _initialContextSetup_val_InitiatingMessage,
        _initialContextSetup_val_SuccessfulOutcome,
        _initialContextSetup_val_UnsuccessfulOutcome,
        uEContextReleaseRequest,
        _uEContextReleaseRequest_val_InitiatingMessage,
        paging,
        _paging_val_InitiatingMessage,
        downlinkNASTransport,
        _downlinkNASTransport_val_InitiatingMessage,
        initialUEMessage,
        _initialUEMessage_val_InitiatingMessage,
        uplinkNASTransport,
        _uplinkNASTransport_val_InitiatingMessage,
        nASNonDeliveryIndication,
        _nASNonDeliveryIndication_val_InitiatingMessage,
        handoverCancel,
        _handoverCancel_val_InitiatingMessage,
        _handoverCancel_val_SuccessfulOutcome,
        reset,
        _reset_val_InitiatingMessage,
        _reset_val_SuccessfulOutcome,
        errorIndication,
        _errorIndication_val_InitiatingMessage,
        s1Setup,
        _s1Setup_val_InitiatingMessage,
        _s1Setup_val_SuccessfulOutcome,
        _s1Setup_val_UnsuccessfulOutcome,
        eNBConfigurationUpdate,
        _eNBConfigurationUpdate_val_InitiatingMessage,
        _eNBConfigurationUpdate_val_SuccessfulOutcome,
        _eNBConfigurationUpdate_val_UnsuccessfulOutcome,
        mMEConfigurationUpdate,
        _mMEConfigurationUpdate_val_InitiatingMessage,
        _mMEConfigurationUpdate_val_SuccessfulOutcome,
        _mMEConfigurationUpdate_val_UnsuccessfulOutcome,
        downlinkS1cdma2000tunnelling,
        _downlinkS1cdma2000tunnelling_val_InitiatingMessage,
        uplinkS1cdma2000tunnelling,
        _uplinkS1cdma2000tunnelling_val_InitiatingMessage,
        uEContextModification,
        _uEContextModification_val_InitiatingMessage,
        _uEContextModification_val_SuccessfulOutcome,
        _uEContextModification_val_UnsuccessfulOutcome,
        uECapabilityInfoIndication,
        _uECapabilityInfoIndication_val_InitiatingMessage,
        uEContextRelease,
        _uEContextRelease_val_InitiatingMessage,
        _uEContextRelease_val_SuccessfulOutcome,
        eNBStatusTransfer,
        _eNBStatusTransfer_val_InitiatingMessage,
        mMEStatusTransfer,
        _mMEStatusTransfer_val_InitiatingMessage,
        deactivateTrace,
        _deactivateTrace_val_InitiatingMessage,
        traceStart,
        _traceStart_val_InitiatingMessage,
        traceFailureIndication,
        _traceFailureIndication_val_InitiatingMessage,
        cellTrafficTrace,
        _cellTrafficTrace_val_InitiatingMessage,
        locationReportingControl,
        _locationReportingControl_val_InitiatingMessage,
        locationReportingFailureIndication,
        _locationReportingFailureIndication_val_InitiatingMessage,
        locationReport,
        _locationReport_val_InitiatingMessage,
        overloadStart,
        _overloadStart_val_InitiatingMessage,
        overloadStop,
        _overloadStop_val_InitiatingMessage,
        writeReplaceWarning,
        _writeReplaceWarning_val_InitiatingMessage,
        _writeReplaceWarning_val_SuccessfulOutcome,
        eNBDirectInformationTransfer,
        _eNBDirectInformationTransfer_val_InitiatingMessage,
        mMEDirectInformationTransfer,
        _mMEDirectInformationTransfer_val_InitiatingMessage,
        eNBConfigurationTransfer,
        _eNBConfigurationTransfer_val_InitiatingMessage,
        mMEConfigurationTransfer,
        _mMEConfigurationTransfer_val_InitiatingMessage,
        privateMessage,
        _privateMessage_val_InitiatingMessage,
        pWSRestartIndication,
        _pWSRestartIndication_val_InitiatingMessage,
        kill,
        _kill_val_InitiatingMessage,
        _kill_val_SuccessfulOutcome,
        downlinkUEAssociatedLPPaTransport,
        _downlinkUEAssociatedLPPaTransport_val_InitiatingMessage,
        uplinkUEAssociatedLPPaTransport,
        _uplinkUEAssociatedLPPaTransport_val_InitiatingMessage,
        downlinkNonUEAssociatedLPPaTransport,
        _downlinkNonUEAssociatedLPPaTransport_val_InitiatingMessage,
        uplinkNonUEAssociatedLPPaTransport,
        _uplinkNonUEAssociatedLPPaTransport_val_InitiatingMessage,
        uERadioCapabilityMatch,
        _uERadioCapabilityMatch_val_InitiatingMessage,
        _uERadioCapabilityMatch_val_SuccessfulOutcome,
        e_RABModificationIndication,
        _e_RABModificationIndication_val_InitiatingMessage,
        _e_RABModificationIndication_val_SuccessfulOutcome,
        uEContextModificationIndication,
        _uEContextModificationIndication_val_InitiatingMessage,
        _uEContextModificationIndication_val_SuccessfulOutcome,
        rerouteNASRequest,
        _rerouteNASRequest_val_InitiatingMessage,
        pWSFailureIndication,
        _pWSFailureIndication_val_InitiatingMessage,
        uEContextSuspend,
        _uEContextSuspend_val_InitiatingMessage,
        _uEContextSuspend_val_SuccessfulOutcome,
        uEContextResume,
        _uEContextResume_val_InitiatingMessage,
        _uEContextResume_val_SuccessfulOutcome,
        _uEContextResume_val_UnsuccessfulOutcome,
        connectionEstablishmentIndication,
        _connectionEstablishmentIndication_val_InitiatingMessage,
        nASDeliveryIndication,
        _nASDeliveryIndication_val_InitiatingMessage,
        retrieveUEInformation,
        _retrieveUEInformation_val_InitiatingMessage,
        uEInformationTransfer,
        _uEInformationTransfer_val_InitiatingMessage,
        eNBCPRelocationIndication,
        _eNBCPRelocationIndication_val_InitiatingMessage,
        mMECPRelocationIndication,
        _mMECPRelocationIndication_val_InitiatingMessage,
        secondaryRATDataUsageReport,
        _secondaryRATDataUsageReport_val_InitiatingMessage,
        uERadioCapabilityIDMapping,
        _uERadioCapabilityIDMapping_val_InitiatingMessage,
        _uERadioCapabilityIDMapping_val_SuccessfulOutcome,
        handoverSuccess,
        _handoverSuccess_val_InitiatingMessage,
        eNBEarlyStatusTransfer,
        _eNBEarlyStatusTransfer_val_InitiatingMessage,
        mMEEarlyStatusTransfer,
        _mMEEarlyStatusTransfer_val_InitiatingMessage,
    ]

class SonTransfer_IEs:

    _name_  = u'SonTransfer-IEs'
    _oid_   = []
    
    _obj_ = [
        u'SONtransferApplicationIdentity',
        u'SONtransferRequestContainer',
        u'SONtransferResponseContainer',
        u'SONtransferCause',
        u'CellLoadReportingCause',
        u'HOReportingCause',
        u'CellActivationCause',
        u'CellStateIndicationCause',
        u'FailureEventReportingCause',
        u'CellLoadReportingResponse',
        u'CompositeAvailableCapacityGroup',
        u'EUTRANcellLoadReportingResponse',
        u'EUTRANResponse',
        u'EHRPD-Sector-ID',
        u'IRAT-Cell-ID',
        u'RequestedCellList',
        u'MultiCellLoadReportingRequest',
        u'ReportingCellList-Item',
        u'ReportingCellList',
        u'MultiCellLoadReportingResponse',
        u'MultiCellLoadReportingResponse-Item',
        u'NumberOfMeasurementReportingLevels',
        u'EventTriggeredCellLoadReportingRequest',
        u'OverloadFlag',
        u'EventTriggeredCellLoadReportingResponse',
        u'HOReport',
        u'HoType',
        u'HoReportType',
        u'CandidateCellList',
        u'CandidatePCIList',
        u'CandidatePCI',
        u'CellActivationRequest',
        u'CellsToActivateList',
        u'CellsToActivateList-Item',
        u'CellActivationResponse',
        u'ActivatedCellsList',
        u'ActivatedCellsList-Item',
        u'CellStateIndication',
        u'NotificationCellList',
        u'NotificationCellList-Item',
        u'NotifyFlag',
        u'FailureEventReport',
        u'TooEarlyInterRATHOReportReportFromEUTRAN',
        u'MobilityInformation',
        u'EHRPDCapacityValue',
        u'EHRPDSectorCapacityClassValue',
        u'EHRPDSectorLoadReportingResponse',
        u'EHRPDCompositeAvailableCapacity',
        u'EHRPDMultiSectorLoadReportingResponseItem',
        u'maxnoofIRATReportingCells',
        u'maxnoofcandidateCells',
        u'maxnoofCellineNB',
        ]
    _type_ = [
        u'SONtransferApplicationIdentity',
        u'SONtransferRequestContainer',
        u'SONtransferResponseContainer',
        u'SONtransferCause',
        u'CellLoadReportingCause',
        u'HOReportingCause',
        u'CellActivationCause',
        u'CellStateIndicationCause',
        u'FailureEventReportingCause',
        u'CellLoadReportingResponse',
        u'CompositeAvailableCapacityGroup',
        u'EUTRANcellLoadReportingResponse',
        u'EUTRANResponse',
        u'EHRPD-Sector-ID',
        u'IRAT-Cell-ID',
        u'RequestedCellList',
        u'MultiCellLoadReportingRequest',
        u'ReportingCellList-Item',
        u'ReportingCellList',
        u'MultiCellLoadReportingResponse',
        u'MultiCellLoadReportingResponse-Item',
        u'NumberOfMeasurementReportingLevels',
        u'EventTriggeredCellLoadReportingRequest',
        u'OverloadFlag',
        u'EventTriggeredCellLoadReportingResponse',
        u'HOReport',
        u'HoType',
        u'HoReportType',
        u'CandidateCellList',
        u'CandidatePCIList',
        u'CandidatePCI',
        u'CellActivationRequest',
        u'CellsToActivateList',
        u'CellsToActivateList-Item',
        u'CellActivationResponse',
        u'ActivatedCellsList',
        u'ActivatedCellsList-Item',
        u'CellStateIndication',
        u'NotificationCellList',
        u'NotificationCellList-Item',
        u'NotifyFlag',
        u'FailureEventReport',
        u'TooEarlyInterRATHOReportReportFromEUTRAN',
        u'MobilityInformation',
        u'EHRPDCapacityValue',
        u'EHRPDSectorCapacityClassValue',
        u'EHRPDSectorLoadReportingResponse',
        u'EHRPDCompositeAvailableCapacity',
        u'EHRPDMultiSectorLoadReportingResponseItem',
        ]
    _set_ = [
        ]
    _val_ = [
        u'maxnoofIRATReportingCells',
        u'maxnoofcandidateCells',
        u'maxnoofCellineNB',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< SONtransferApplicationIdentity >-----#
    SONtransferApplicationIdentity = ENUM(name=u'SONtransferApplicationIdentity', mode=MODE_TYPE)
    SONtransferApplicationIdentity._cont = ASN1Dict([(u'cell-load-reporting', 0), (u'multi-cell-load-reporting', 1), (u'event-triggered-cell-load-reporting', 2), (u'ho-reporting', 3), (u'eutran-cell-activation', 4), (u'energy-savings-indication', 5), (u'failure-event-reporting', 6)])
    SONtransferApplicationIdentity._ext = [u'multi-cell-load-reporting', u'event-triggered-cell-load-reporting', u'ho-reporting', u'eutran-cell-activation', u'energy-savings-indication', u'failure-event-reporting']
    
    #-----< SONtransferRequestContainer >-----#
    SONtransferRequestContainer = CHOICE(name=u'SONtransferRequestContainer', mode=MODE_TYPE)
    _SONtransferRequestContainer_cellLoadReporting = NULL(name=u'cellLoadReporting', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SONtransferRequestContainer_multiCellLoadReporting = SEQ(name=u'multiCellLoadReporting', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'MultiCellLoadReportingRequest')))
    _SONtransferRequestContainer_eventTriggeredCellLoadReporting = SEQ(name=u'eventTriggeredCellLoadReporting', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EventTriggeredCellLoadReportingRequest')))
    _SONtransferRequestContainer_hOReporting = SEQ(name=u'hOReporting', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'HOReport')))
    _SONtransferRequestContainer_eutranCellActivation = SEQ(name=u'eutranCellActivation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellActivationRequest')))
    _SONtransferRequestContainer_energySavingsIndication = SEQ(name=u'energySavingsIndication', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellStateIndication')))
    _SONtransferRequestContainer_failureEventReporting = CHOICE(name=u'failureEventReporting', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'FailureEventReport')))
    SONtransferRequestContainer._cont = ASN1Dict([
        (u'cellLoadReporting', _SONtransferRequestContainer_cellLoadReporting),
        (u'multiCellLoadReporting', _SONtransferRequestContainer_multiCellLoadReporting),
        (u'eventTriggeredCellLoadReporting', _SONtransferRequestContainer_eventTriggeredCellLoadReporting),
        (u'hOReporting', _SONtransferRequestContainer_hOReporting),
        (u'eutranCellActivation', _SONtransferRequestContainer_eutranCellActivation),
        (u'energySavingsIndication', _SONtransferRequestContainer_energySavingsIndication),
        (u'failureEventReporting', _SONtransferRequestContainer_failureEventReporting),
        ])
    SONtransferRequestContainer._ext = [u'multiCellLoadReporting', u'eventTriggeredCellLoadReporting', u'hOReporting', u'eutranCellActivation', u'energySavingsIndication', u'failureEventReporting']
    
    #-----< SONtransferResponseContainer >-----#
    SONtransferResponseContainer = CHOICE(name=u'SONtransferResponseContainer', mode=MODE_TYPE)
    _SONtransferResponseContainer_cellLoadReporting = CHOICE(name=u'cellLoadReporting', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellLoadReportingResponse')))
    _SONtransferResponseContainer_multiCellLoadReporting = SEQ_OF(name=u'multiCellLoadReporting', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'MultiCellLoadReportingResponse')))
    _SONtransferResponseContainer_eventTriggeredCellLoadReporting = SEQ(name=u'eventTriggeredCellLoadReporting', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EventTriggeredCellLoadReportingResponse')))
    _SONtransferResponseContainer_hOReporting = NULL(name=u'hOReporting', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SONtransferResponseContainer_eutranCellActivation = SEQ(name=u'eutranCellActivation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellActivationResponse')))
    _SONtransferResponseContainer_energySavingsIndication = NULL(name=u'energySavingsIndication', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SONtransferResponseContainer_failureEventReporting = NULL(name=u'failureEventReporting', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SONtransferResponseContainer._cont = ASN1Dict([
        (u'cellLoadReporting', _SONtransferResponseContainer_cellLoadReporting),
        (u'multiCellLoadReporting', _SONtransferResponseContainer_multiCellLoadReporting),
        (u'eventTriggeredCellLoadReporting', _SONtransferResponseContainer_eventTriggeredCellLoadReporting),
        (u'hOReporting', _SONtransferResponseContainer_hOReporting),
        (u'eutranCellActivation', _SONtransferResponseContainer_eutranCellActivation),
        (u'energySavingsIndication', _SONtransferResponseContainer_energySavingsIndication),
        (u'failureEventReporting', _SONtransferResponseContainer_failureEventReporting),
        ])
    SONtransferResponseContainer._ext = [u'multiCellLoadReporting', u'eventTriggeredCellLoadReporting', u'hOReporting', u'eutranCellActivation', u'energySavingsIndication', u'failureEventReporting']
    
    #-----< SONtransferCause >-----#
    SONtransferCause = CHOICE(name=u'SONtransferCause', mode=MODE_TYPE)
    _SONtransferCause_cellLoadReporting = ENUM(name=u'cellLoadReporting', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellLoadReportingCause')))
    _SONtransferCause_multiCellLoadReporting = ENUM(name=u'multiCellLoadReporting', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellLoadReportingCause')))
    _SONtransferCause_eventTriggeredCellLoadReporting = ENUM(name=u'eventTriggeredCellLoadReporting', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellLoadReportingCause')))
    _SONtransferCause_hOReporting = ENUM(name=u'hOReporting', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'HOReportingCause')))
    _SONtransferCause_eutranCellActivation = ENUM(name=u'eutranCellActivation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellActivationCause')))
    _SONtransferCause_energySavingsIndication = ENUM(name=u'energySavingsIndication', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellStateIndicationCause')))
    _SONtransferCause_failureEventReporting = ENUM(name=u'failureEventReporting', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'FailureEventReportingCause')))
    SONtransferCause._cont = ASN1Dict([
        (u'cellLoadReporting', _SONtransferCause_cellLoadReporting),
        (u'multiCellLoadReporting', _SONtransferCause_multiCellLoadReporting),
        (u'eventTriggeredCellLoadReporting', _SONtransferCause_eventTriggeredCellLoadReporting),
        (u'hOReporting', _SONtransferCause_hOReporting),
        (u'eutranCellActivation', _SONtransferCause_eutranCellActivation),
        (u'energySavingsIndication', _SONtransferCause_energySavingsIndication),
        (u'failureEventReporting', _SONtransferCause_failureEventReporting),
        ])
    SONtransferCause._ext = [u'multiCellLoadReporting', u'eventTriggeredCellLoadReporting', u'hOReporting', u'eutranCellActivation', u'energySavingsIndication', u'failureEventReporting']
    
    #-----< CellLoadReportingCause >-----#
    CellLoadReportingCause = ENUM(name=u'CellLoadReportingCause', mode=MODE_TYPE)
    CellLoadReportingCause._cont = ASN1Dict([(u'application-container-syntax-error', 0), (u'inconsistent-reporting-cell-identifier', 1), (u'unspecified', 2)])
    CellLoadReportingCause._ext = []
    
    #-----< HOReportingCause >-----#
    HOReportingCause = ENUM(name=u'HOReportingCause', mode=MODE_TYPE)
    HOReportingCause._cont = ASN1Dict([(u'application-container-syntax-error', 0), (u'inconsistent-reporting-cell-identifier', 1), (u'unspecified', 2)])
    HOReportingCause._ext = []
    
    #-----< CellActivationCause >-----#
    CellActivationCause = ENUM(name=u'CellActivationCause', mode=MODE_TYPE)
    CellActivationCause._cont = ASN1Dict([(u'application-container-syntax-error', 0), (u'inconsistent-reporting-cell-identifier', 1), (u'unspecified', 2)])
    CellActivationCause._ext = []
    
    #-----< CellStateIndicationCause >-----#
    CellStateIndicationCause = ENUM(name=u'CellStateIndicationCause', mode=MODE_TYPE)
    CellStateIndicationCause._cont = ASN1Dict([(u'application-container-syntax-error', 0), (u'inconsistent-reporting-cell-identifier', 1), (u'unspecified', 2)])
    CellStateIndicationCause._ext = []
    
    #-----< FailureEventReportingCause >-----#
    FailureEventReportingCause = ENUM(name=u'FailureEventReportingCause', mode=MODE_TYPE)
    FailureEventReportingCause._cont = ASN1Dict([(u'application-container-syntax-error', 0), (u'inconsistent-reporting-cell-identifier', 1), (u'unspecified', 2)])
    FailureEventReportingCause._ext = []
    
    #-----< CellLoadReportingResponse >-----#
    CellLoadReportingResponse = CHOICE(name=u'CellLoadReportingResponse', mode=MODE_TYPE)
    _CellLoadReportingResponse_eUTRAN = SEQ(name=u'eUTRAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EUTRANcellLoadReportingResponse')))
    _CellLoadReportingResponse_uTRAN = OCT_STR(name=u'uTRAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CellLoadReportingResponse_gERAN = OCT_STR(name=u'gERAN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CellLoadReportingResponse_eHRPD = SEQ(name=u'eHRPD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EHRPDSectorLoadReportingResponse')))
    CellLoadReportingResponse._cont = ASN1Dict([
        (u'eUTRAN', _CellLoadReportingResponse_eUTRAN),
        (u'uTRAN', _CellLoadReportingResponse_uTRAN),
        (u'gERAN', _CellLoadReportingResponse_gERAN),
        (u'eHRPD', _CellLoadReportingResponse_eHRPD),
        ])
    CellLoadReportingResponse._ext = [u'eHRPD']
    
    #-----< CompositeAvailableCapacityGroup >-----#
    CompositeAvailableCapacityGroup = OCT_STR(name=u'CompositeAvailableCapacityGroup', mode=MODE_TYPE)
    
    #-----< EUTRANcellLoadReportingResponse >-----#
    EUTRANcellLoadReportingResponse = SEQ(name=u'EUTRANcellLoadReportingResponse', mode=MODE_TYPE)
    _EUTRANcellLoadReportingResponse_compositeAvailableCapacityGroup = OCT_STR(name=u'compositeAvailableCapacityGroup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CompositeAvailableCapacityGroup')))
    EUTRANcellLoadReportingResponse._cont = ASN1Dict([
        (u'compositeAvailableCapacityGroup', _EUTRANcellLoadReportingResponse_compositeAvailableCapacityGroup),
        ])
    EUTRANcellLoadReportingResponse._ext = []
    
    #-----< EUTRANResponse >-----#
    EUTRANResponse = SEQ(name=u'EUTRANResponse', mode=MODE_TYPE)
    _EUTRANResponse_cell_ID = OCT_STR(name=u'cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EUTRANResponse_eUTRANcellLoadReportingResponse = SEQ(name=u'eUTRANcellLoadReportingResponse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EUTRANcellLoadReportingResponse')))
    EUTRANResponse._cont = ASN1Dict([
        (u'cell-ID', _EUTRANResponse_cell_ID),
        (u'eUTRANcellLoadReportingResponse', _EUTRANResponse_eUTRANcellLoadReportingResponse),
        ])
    EUTRANResponse._ext = []
    
    #-----< EHRPD-Sector-ID >-----#
    EHRPD_Sector_ID = OCT_STR(name=u'EHRPD-Sector-ID', mode=MODE_TYPE)
    EHRPD_Sector_ID._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< IRAT-Cell-ID >-----#
    IRAT_Cell_ID = CHOICE(name=u'IRAT-Cell-ID', mode=MODE_TYPE)
    _IRAT_Cell_ID_eUTRAN = OCT_STR(name=u'eUTRAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IRAT_Cell_ID_uTRAN = OCT_STR(name=u'uTRAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IRAT_Cell_ID_gERAN = OCT_STR(name=u'gERAN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IRAT_Cell_ID_eHRPD = OCT_STR(name=u'eHRPD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EHRPD-Sector-ID')))
    IRAT_Cell_ID._cont = ASN1Dict([
        (u'eUTRAN', _IRAT_Cell_ID_eUTRAN),
        (u'uTRAN', _IRAT_Cell_ID_uTRAN),
        (u'gERAN', _IRAT_Cell_ID_gERAN),
        (u'eHRPD', _IRAT_Cell_ID_eHRPD),
        ])
    IRAT_Cell_ID._ext = [u'eHRPD']
    
    #-----< RequestedCellList >-----#
    RequestedCellList = SEQ_OF(name=u'RequestedCellList', mode=MODE_TYPE)
    _RequestedCellList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SonTransfer-IEs', 'IRAT-Cell-ID')))
    RequestedCellList._cont = _RequestedCellList__item_
    RequestedCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< MultiCellLoadReportingRequest >-----#
    MultiCellLoadReportingRequest = SEQ(name=u'MultiCellLoadReportingRequest', mode=MODE_TYPE)
    _MultiCellLoadReportingRequest_requestedCellList = SEQ_OF(name=u'requestedCellList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'RequestedCellList')))
    MultiCellLoadReportingRequest._cont = ASN1Dict([
        (u'requestedCellList', _MultiCellLoadReportingRequest_requestedCellList),
        ])
    MultiCellLoadReportingRequest._ext = []
    
    #-----< ReportingCellList-Item >-----#
    ReportingCellList_Item = SEQ(name=u'ReportingCellList-Item', mode=MODE_TYPE)
    _ReportingCellList_Item_cell_ID = CHOICE(name=u'cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'IRAT-Cell-ID')))
    ReportingCellList_Item._cont = ASN1Dict([
        (u'cell-ID', _ReportingCellList_Item_cell_ID),
        ])
    ReportingCellList_Item._ext = []
    
    #-----< ReportingCellList >-----#
    ReportingCellList = SEQ_OF(name=u'ReportingCellList', mode=MODE_TYPE)
    _ReportingCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SonTransfer-IEs', 'ReportingCellList-Item')))
    ReportingCellList._cont = _ReportingCellList__item_
    ReportingCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< MultiCellLoadReportingResponse >-----#
    MultiCellLoadReportingResponse = SEQ_OF(name=u'MultiCellLoadReportingResponse', mode=MODE_TYPE)
    _MultiCellLoadReportingResponse__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SonTransfer-IEs', 'MultiCellLoadReportingResponse-Item')))
    MultiCellLoadReportingResponse._cont = _MultiCellLoadReportingResponse__item_
    MultiCellLoadReportingResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< MultiCellLoadReportingResponse-Item >-----#
    MultiCellLoadReportingResponse_Item = CHOICE(name=u'MultiCellLoadReportingResponse-Item', mode=MODE_TYPE)
    _MultiCellLoadReportingResponse_Item_eUTRANResponse = SEQ(name=u'eUTRANResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EUTRANResponse')))
    _MultiCellLoadReportingResponse_Item_uTRANResponse = OCT_STR(name=u'uTRANResponse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MultiCellLoadReportingResponse_Item_gERANResponse = OCT_STR(name=u'gERANResponse', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MultiCellLoadReportingResponse_Item_eHRPD = SEQ(name=u'eHRPD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EHRPDMultiSectorLoadReportingResponseItem')))
    MultiCellLoadReportingResponse_Item._cont = ASN1Dict([
        (u'eUTRANResponse', _MultiCellLoadReportingResponse_Item_eUTRANResponse),
        (u'uTRANResponse', _MultiCellLoadReportingResponse_Item_uTRANResponse),
        (u'gERANResponse', _MultiCellLoadReportingResponse_Item_gERANResponse),
        (u'eHRPD', _MultiCellLoadReportingResponse_Item_eHRPD),
        ])
    MultiCellLoadReportingResponse_Item._ext = [u'eHRPD']
    
    #-----< NumberOfMeasurementReportingLevels >-----#
    NumberOfMeasurementReportingLevels = ENUM(name=u'NumberOfMeasurementReportingLevels', mode=MODE_TYPE)
    NumberOfMeasurementReportingLevels._cont = ASN1Dict([(u'rl2', 0), (u'rl3', 1), (u'rl4', 2), (u'rl5', 3), (u'rl10', 4)])
    NumberOfMeasurementReportingLevels._ext = []
    
    #-----< EventTriggeredCellLoadReportingRequest >-----#
    EventTriggeredCellLoadReportingRequest = SEQ(name=u'EventTriggeredCellLoadReportingRequest', mode=MODE_TYPE)
    _EventTriggeredCellLoadReportingRequest_numberOfMeasurementReportingLevels = ENUM(name=u'numberOfMeasurementReportingLevels', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'NumberOfMeasurementReportingLevels')))
    EventTriggeredCellLoadReportingRequest._cont = ASN1Dict([
        (u'numberOfMeasurementReportingLevels', _EventTriggeredCellLoadReportingRequest_numberOfMeasurementReportingLevels),
        ])
    EventTriggeredCellLoadReportingRequest._ext = []
    
    #-----< OverloadFlag >-----#
    OverloadFlag = ENUM(name=u'OverloadFlag', mode=MODE_TYPE)
    OverloadFlag._cont = ASN1Dict([(u'overload', 0)])
    OverloadFlag._ext = []
    
    #-----< EventTriggeredCellLoadReportingResponse >-----#
    EventTriggeredCellLoadReportingResponse = SEQ(name=u'EventTriggeredCellLoadReportingResponse', mode=MODE_TYPE)
    _EventTriggeredCellLoadReportingResponse_cellLoadReportingResponse = CHOICE(name=u'cellLoadReportingResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellLoadReportingResponse')))
    _EventTriggeredCellLoadReportingResponse_overloadFlag = ENUM(name=u'overloadFlag', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'OverloadFlag')), opt=True)
    EventTriggeredCellLoadReportingResponse._cont = ASN1Dict([
        (u'cellLoadReportingResponse', _EventTriggeredCellLoadReportingResponse_cellLoadReportingResponse),
        (u'overloadFlag', _EventTriggeredCellLoadReportingResponse_overloadFlag),
        ])
    EventTriggeredCellLoadReportingResponse._ext = []
    
    #-----< HOReport >-----#
    HOReport = SEQ(name=u'HOReport', mode=MODE_TYPE)
    _HOReport_hoType = ENUM(name=u'hoType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'HoType')))
    _HOReport_hoReportType = ENUM(name=u'hoReportType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'HoReportType')))
    _HOReport_hosourceID = CHOICE(name=u'hosourceID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'IRAT-Cell-ID')))
    _HOReport_hoTargetID = CHOICE(name=u'hoTargetID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'IRAT-Cell-ID')))
    _HOReport_candidateCellList = SEQ_OF(name=u'candidateCellList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CandidateCellList')))
    _HOReport_candidatePCIList = SEQ_OF(name=u'candidatePCIList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CandidatePCIList')), opt=True)
    HOReport._cont = ASN1Dict([
        (u'hoType', _HOReport_hoType),
        (u'hoReportType', _HOReport_hoReportType),
        (u'hosourceID', _HOReport_hosourceID),
        (u'hoTargetID', _HOReport_hoTargetID),
        (u'candidateCellList', _HOReport_candidateCellList),
        (u'candidatePCIList', _HOReport_candidatePCIList),
        ])
    HOReport._ext = [u'candidatePCIList']
    
    #-----< HoType >-----#
    HoType = ENUM(name=u'HoType', mode=MODE_TYPE)
    HoType._cont = ASN1Dict([(u'ltetoutran', 0), (u'ltetogeran', 1)])
    HoType._ext = []
    
    #-----< HoReportType >-----#
    HoReportType = ENUM(name=u'HoReportType', mode=MODE_TYPE)
    HoReportType._cont = ASN1Dict([(u'unnecessaryhotoanotherrat', 0), (u'earlyirathandover', 1)])
    HoReportType._ext = [u'earlyirathandover']
    
    #-----< CandidateCellList >-----#
    CandidateCellList = SEQ_OF(name=u'CandidateCellList', mode=MODE_TYPE)
    _CandidateCellList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SonTransfer-IEs', 'IRAT-Cell-ID')))
    CandidateCellList._cont = _CandidateCellList__item_
    CandidateCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CandidatePCIList >-----#
    CandidatePCIList = SEQ_OF(name=u'CandidatePCIList', mode=MODE_TYPE)
    _CandidatePCIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SonTransfer-IEs', 'CandidatePCI')))
    CandidatePCIList._cont = _CandidatePCIList__item_
    CandidatePCIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CandidatePCI >-----#
    CandidatePCI = SEQ(name=u'CandidatePCI', mode=MODE_TYPE)
    _CandidatePCI_pCI = INT(name=u'pCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CandidatePCI_pCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=503)], ev=None, er=[])
    _CandidatePCI_eARFCN = OCT_STR(name=u'eARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    CandidatePCI._cont = ASN1Dict([
        (u'pCI', _CandidatePCI_pCI),
        (u'eARFCN', _CandidatePCI_eARFCN),
        ])
    CandidatePCI._ext = []
    
    #-----< CellActivationRequest >-----#
    CellActivationRequest = SEQ(name=u'CellActivationRequest', mode=MODE_TYPE)
    _CellActivationRequest_cellsToActivateList = SEQ_OF(name=u'cellsToActivateList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'CellsToActivateList')))
    _CellActivationRequest_minimumActivationTime = INT(name=u'minimumActivationTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CellActivationRequest_minimumActivationTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=60)], ev=None, er=[])
    CellActivationRequest._cont = ASN1Dict([
        (u'cellsToActivateList', _CellActivationRequest_cellsToActivateList),
        (u'minimumActivationTime', _CellActivationRequest_minimumActivationTime),
        ])
    CellActivationRequest._ext = []
    
    #-----< CellsToActivateList >-----#
    CellsToActivateList = SEQ_OF(name=u'CellsToActivateList', mode=MODE_TYPE)
    _CellsToActivateList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SonTransfer-IEs', 'CellsToActivateList-Item')))
    CellsToActivateList._cont = _CellsToActivateList__item_
    CellsToActivateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CellsToActivateList-Item >-----#
    CellsToActivateList_Item = SEQ(name=u'CellsToActivateList-Item', mode=MODE_TYPE)
    _CellsToActivateList_Item_cell_ID = OCT_STR(name=u'cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    CellsToActivateList_Item._cont = ASN1Dict([
        (u'cell-ID', _CellsToActivateList_Item_cell_ID),
        ])
    CellsToActivateList_Item._ext = []
    
    #-----< CellActivationResponse >-----#
    CellActivationResponse = SEQ(name=u'CellActivationResponse', mode=MODE_TYPE)
    _CellActivationResponse_activatedCellsList = SEQ_OF(name=u'activatedCellsList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'ActivatedCellsList')))
    CellActivationResponse._cont = ASN1Dict([
        (u'activatedCellsList', _CellActivationResponse_activatedCellsList),
        ])
    CellActivationResponse._ext = []
    
    #-----< ActivatedCellsList >-----#
    ActivatedCellsList = SEQ_OF(name=u'ActivatedCellsList', mode=MODE_TYPE)
    _ActivatedCellsList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SonTransfer-IEs', 'ActivatedCellsList-Item')))
    ActivatedCellsList._cont = _ActivatedCellsList__item_
    ActivatedCellsList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    
    #-----< ActivatedCellsList-Item >-----#
    ActivatedCellsList_Item = SEQ(name=u'ActivatedCellsList-Item', mode=MODE_TYPE)
    _ActivatedCellsList_Item_cell_ID = OCT_STR(name=u'cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ActivatedCellsList_Item._cont = ASN1Dict([
        (u'cell-ID', _ActivatedCellsList_Item_cell_ID),
        ])
    ActivatedCellsList_Item._ext = []
    
    #-----< CellStateIndication >-----#
    CellStateIndication = SEQ(name=u'CellStateIndication', mode=MODE_TYPE)
    _CellStateIndication_notificationCellList = SEQ_OF(name=u'notificationCellList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'NotificationCellList')))
    CellStateIndication._cont = ASN1Dict([
        (u'notificationCellList', _CellStateIndication_notificationCellList),
        ])
    CellStateIndication._ext = []
    
    #-----< NotificationCellList >-----#
    NotificationCellList = SEQ_OF(name=u'NotificationCellList', mode=MODE_TYPE)
    _NotificationCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SonTransfer-IEs', 'NotificationCellList-Item')))
    NotificationCellList._cont = _NotificationCellList__item_
    NotificationCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< NotificationCellList-Item >-----#
    NotificationCellList_Item = SEQ(name=u'NotificationCellList-Item', mode=MODE_TYPE)
    _NotificationCellList_Item_cell_ID = OCT_STR(name=u'cell-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NotificationCellList_Item_notifyFlag = ENUM(name=u'notifyFlag', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'NotifyFlag')))
    NotificationCellList_Item._cont = ASN1Dict([
        (u'cell-ID', _NotificationCellList_Item_cell_ID),
        (u'notifyFlag', _NotificationCellList_Item_notifyFlag),
        ])
    NotificationCellList_Item._ext = []
    
    #-----< NotifyFlag >-----#
    NotifyFlag = ENUM(name=u'NotifyFlag', mode=MODE_TYPE)
    NotifyFlag._cont = ASN1Dict([(u'activated', 0), (u'deactivated', 1)])
    NotifyFlag._ext = []
    
    #-----< FailureEventReport >-----#
    FailureEventReport = CHOICE(name=u'FailureEventReport', mode=MODE_TYPE)
    _FailureEventReport_tooEarlyInterRATHOReportFromEUTRAN = SEQ(name=u'tooEarlyInterRATHOReportFromEUTRAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'TooEarlyInterRATHOReportReportFromEUTRAN')))
    FailureEventReport._cont = ASN1Dict([
        (u'tooEarlyInterRATHOReportFromEUTRAN', _FailureEventReport_tooEarlyInterRATHOReportFromEUTRAN),
        ])
    FailureEventReport._ext = []
    
    #-----< TooEarlyInterRATHOReportReportFromEUTRAN >-----#
    TooEarlyInterRATHOReportReportFromEUTRAN = SEQ(name=u'TooEarlyInterRATHOReportReportFromEUTRAN', mode=MODE_TYPE)
    _TooEarlyInterRATHOReportReportFromEUTRAN_uERLFReportContainer = OCT_STR(name=u'uERLFReportContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TooEarlyInterRATHOReportReportFromEUTRAN_mobilityInformation = BIT_STR(name=u'mobilityInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'MobilityInformation')), opt=True)
    TooEarlyInterRATHOReportReportFromEUTRAN._cont = ASN1Dict([
        (u'uERLFReportContainer', _TooEarlyInterRATHOReportReportFromEUTRAN_uERLFReportContainer),
        (u'mobilityInformation', _TooEarlyInterRATHOReportReportFromEUTRAN_mobilityInformation),
        ])
    TooEarlyInterRATHOReportReportFromEUTRAN._ext = []
    
    #-----< MobilityInformation >-----#
    MobilityInformation = BIT_STR(name=u'MobilityInformation', mode=MODE_TYPE)
    MobilityInformation._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< EHRPDCapacityValue >-----#
    EHRPDCapacityValue = INT(name=u'EHRPDCapacityValue', mode=MODE_TYPE)
    EHRPDCapacityValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< EHRPDSectorCapacityClassValue >-----#
    EHRPDSectorCapacityClassValue = INT(name=u'EHRPDSectorCapacityClassValue', mode=MODE_TYPE)
    EHRPDSectorCapacityClassValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=[], er=[])
    
    #-----< EHRPDSectorLoadReportingResponse >-----#
    EHRPDSectorLoadReportingResponse = SEQ(name=u'EHRPDSectorLoadReportingResponse', mode=MODE_TYPE)
    _EHRPDSectorLoadReportingResponse_dL_EHRPD_CompositeAvailableCapacity = SEQ(name=u'dL-EHRPD-CompositeAvailableCapacity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EHRPDCompositeAvailableCapacity')))
    _EHRPDSectorLoadReportingResponse_uL_EHRPD_CompositeAvailableCapacity = SEQ(name=u'uL-EHRPD-CompositeAvailableCapacity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EHRPDCompositeAvailableCapacity')))
    EHRPDSectorLoadReportingResponse._cont = ASN1Dict([
        (u'dL-EHRPD-CompositeAvailableCapacity', _EHRPDSectorLoadReportingResponse_dL_EHRPD_CompositeAvailableCapacity),
        (u'uL-EHRPD-CompositeAvailableCapacity', _EHRPDSectorLoadReportingResponse_uL_EHRPD_CompositeAvailableCapacity),
        ])
    EHRPDSectorLoadReportingResponse._ext = []
    
    #-----< EHRPDCompositeAvailableCapacity >-----#
    EHRPDCompositeAvailableCapacity = SEQ(name=u'EHRPDCompositeAvailableCapacity', mode=MODE_TYPE)
    _EHRPDCompositeAvailableCapacity_eHRPDSectorCapacityClassValue = INT(name=u'eHRPDSectorCapacityClassValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EHRPDSectorCapacityClassValue')))
    _EHRPDCompositeAvailableCapacity_eHRPDCapacityValue = INT(name=u'eHRPDCapacityValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EHRPDCapacityValue')))
    EHRPDCompositeAvailableCapacity._cont = ASN1Dict([
        (u'eHRPDSectorCapacityClassValue', _EHRPDCompositeAvailableCapacity_eHRPDSectorCapacityClassValue),
        (u'eHRPDCapacityValue', _EHRPDCompositeAvailableCapacity_eHRPDCapacityValue),
        ])
    EHRPDCompositeAvailableCapacity._ext = []
    
    #-----< EHRPDMultiSectorLoadReportingResponseItem >-----#
    EHRPDMultiSectorLoadReportingResponseItem = SEQ(name=u'EHRPDMultiSectorLoadReportingResponseItem', mode=MODE_TYPE)
    _EHRPDMultiSectorLoadReportingResponseItem_eHRPD_Sector_ID = OCT_STR(name=u'eHRPD-Sector-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EHRPD-Sector-ID')))
    _EHRPDMultiSectorLoadReportingResponseItem_eHRPDSectorLoadReportingResponse = SEQ(name=u'eHRPDSectorLoadReportingResponse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SonTransfer-IEs', 'EHRPDSectorLoadReportingResponse')))
    EHRPDMultiSectorLoadReportingResponseItem._cont = ASN1Dict([
        (u'eHRPD-Sector-ID', _EHRPDMultiSectorLoadReportingResponseItem_eHRPD_Sector_ID),
        (u'eHRPDSectorLoadReportingResponse', _EHRPDMultiSectorLoadReportingResponseItem_eHRPDSectorLoadReportingResponse),
        ])
    EHRPDMultiSectorLoadReportingResponseItem._ext = []
    
    #-----< maxnoofIRATReportingCells >-----#
    maxnoofIRATReportingCells = INT(name=u'maxnoofIRATReportingCells', mode=MODE_VALUE)
    maxnoofIRATReportingCells._val = 128
    
    #-----< maxnoofcandidateCells >-----#
    maxnoofcandidateCells = INT(name=u'maxnoofcandidateCells', mode=MODE_VALUE)
    maxnoofcandidateCells._val = 16
    
    #-----< maxnoofCellineNB >-----#
    maxnoofCellineNB = INT(name=u'maxnoofCellineNB', mode=MODE_VALUE)
    maxnoofCellineNB._val = 256
    
    _all_ = [
        SONtransferApplicationIdentity,
        _SONtransferRequestContainer_cellLoadReporting,
        _SONtransferRequestContainer_multiCellLoadReporting,
        _SONtransferRequestContainer_eventTriggeredCellLoadReporting,
        _SONtransferRequestContainer_hOReporting,
        _SONtransferRequestContainer_eutranCellActivation,
        _SONtransferRequestContainer_energySavingsIndication,
        _SONtransferRequestContainer_failureEventReporting,
        SONtransferRequestContainer,
        _SONtransferResponseContainer_cellLoadReporting,
        _SONtransferResponseContainer_multiCellLoadReporting,
        _SONtransferResponseContainer_eventTriggeredCellLoadReporting,
        _SONtransferResponseContainer_hOReporting,
        _SONtransferResponseContainer_eutranCellActivation,
        _SONtransferResponseContainer_energySavingsIndication,
        _SONtransferResponseContainer_failureEventReporting,
        SONtransferResponseContainer,
        _SONtransferCause_cellLoadReporting,
        _SONtransferCause_multiCellLoadReporting,
        _SONtransferCause_eventTriggeredCellLoadReporting,
        _SONtransferCause_hOReporting,
        _SONtransferCause_eutranCellActivation,
        _SONtransferCause_energySavingsIndication,
        _SONtransferCause_failureEventReporting,
        SONtransferCause,
        CellLoadReportingCause,
        HOReportingCause,
        CellActivationCause,
        CellStateIndicationCause,
        FailureEventReportingCause,
        _CellLoadReportingResponse_eUTRAN,
        _CellLoadReportingResponse_uTRAN,
        _CellLoadReportingResponse_gERAN,
        _CellLoadReportingResponse_eHRPD,
        CellLoadReportingResponse,
        CompositeAvailableCapacityGroup,
        _EUTRANcellLoadReportingResponse_compositeAvailableCapacityGroup,
        EUTRANcellLoadReportingResponse,
        _EUTRANResponse_cell_ID,
        _EUTRANResponse_eUTRANcellLoadReportingResponse,
        EUTRANResponse,
        EHRPD_Sector_ID,
        _IRAT_Cell_ID_eUTRAN,
        _IRAT_Cell_ID_uTRAN,
        _IRAT_Cell_ID_gERAN,
        _IRAT_Cell_ID_eHRPD,
        IRAT_Cell_ID,
        _RequestedCellList__item_,
        RequestedCellList,
        _MultiCellLoadReportingRequest_requestedCellList,
        MultiCellLoadReportingRequest,
        _ReportingCellList_Item_cell_ID,
        ReportingCellList_Item,
        _ReportingCellList__item_,
        ReportingCellList,
        _MultiCellLoadReportingResponse__item_,
        MultiCellLoadReportingResponse,
        _MultiCellLoadReportingResponse_Item_eUTRANResponse,
        _MultiCellLoadReportingResponse_Item_uTRANResponse,
        _MultiCellLoadReportingResponse_Item_gERANResponse,
        _MultiCellLoadReportingResponse_Item_eHRPD,
        MultiCellLoadReportingResponse_Item,
        NumberOfMeasurementReportingLevels,
        _EventTriggeredCellLoadReportingRequest_numberOfMeasurementReportingLevels,
        EventTriggeredCellLoadReportingRequest,
        OverloadFlag,
        _EventTriggeredCellLoadReportingResponse_cellLoadReportingResponse,
        _EventTriggeredCellLoadReportingResponse_overloadFlag,
        EventTriggeredCellLoadReportingResponse,
        _HOReport_hoType,
        _HOReport_hoReportType,
        _HOReport_hosourceID,
        _HOReport_hoTargetID,
        _HOReport_candidateCellList,
        _HOReport_candidatePCIList,
        HOReport,
        HoType,
        HoReportType,
        _CandidateCellList__item_,
        CandidateCellList,
        _CandidatePCIList__item_,
        CandidatePCIList,
        _CandidatePCI_pCI,
        _CandidatePCI_eARFCN,
        CandidatePCI,
        _CellActivationRequest_cellsToActivateList,
        _CellActivationRequest_minimumActivationTime,
        CellActivationRequest,
        _CellsToActivateList__item_,
        CellsToActivateList,
        _CellsToActivateList_Item_cell_ID,
        CellsToActivateList_Item,
        _CellActivationResponse_activatedCellsList,
        CellActivationResponse,
        _ActivatedCellsList__item_,
        ActivatedCellsList,
        _ActivatedCellsList_Item_cell_ID,
        ActivatedCellsList_Item,
        _CellStateIndication_notificationCellList,
        CellStateIndication,
        _NotificationCellList__item_,
        NotificationCellList,
        _NotificationCellList_Item_cell_ID,
        _NotificationCellList_Item_notifyFlag,
        NotificationCellList_Item,
        NotifyFlag,
        _FailureEventReport_tooEarlyInterRATHOReportFromEUTRAN,
        FailureEventReport,
        _TooEarlyInterRATHOReportReportFromEUTRAN_uERLFReportContainer,
        _TooEarlyInterRATHOReportReportFromEUTRAN_mobilityInformation,
        TooEarlyInterRATHOReportReportFromEUTRAN,
        MobilityInformation,
        EHRPDCapacityValue,
        EHRPDSectorCapacityClassValue,
        _EHRPDSectorLoadReportingResponse_dL_EHRPD_CompositeAvailableCapacity,
        _EHRPDSectorLoadReportingResponse_uL_EHRPD_CompositeAvailableCapacity,
        EHRPDSectorLoadReportingResponse,
        _EHRPDCompositeAvailableCapacity_eHRPDSectorCapacityClassValue,
        _EHRPDCompositeAvailableCapacity_eHRPDCapacityValue,
        EHRPDCompositeAvailableCapacity,
        _EHRPDMultiSectorLoadReportingResponseItem_eHRPD_Sector_ID,
        _EHRPDMultiSectorLoadReportingResponseItem_eHRPDSectorLoadReportingResponse,
        EHRPDMultiSectorLoadReportingResponseItem,
        maxnoofIRATReportingCells,
        maxnoofcandidateCells,
        maxnoofCellineNB,
    ]

init_modules(S1AP_CommonDataTypes, S1AP_Constants, S1AP_Containers, S1AP_IEs, S1AP_PDU_Contents, S1AP_PDU_Descriptions, SonTransfer_IEs)
