# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class XwAP_CommonDataTypes:

    _name_  = u'XwAP-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 21, 3, 8, 1, 3]
    
    _obj_ = [
        u'Criticality',
        u'Presence',
        u'PrivateIE-ID',
        u'ProcedureCode',
        u'ProtocolExtensionID',
        u'ProtocolIE-ID',
        u'TriggeringMessage',
        ]
    _type_ = [
        u'Criticality',
        u'Presence',
        u'PrivateIE-ID',
        u'ProcedureCode',
        u'ProtocolExtensionID',
        u'ProtocolIE-ID',
        u'TriggeringMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Criticality >-----#
    Criticality = ENUM(name=u'Criticality', mode=MODE_TYPE)
    Criticality._cont = ASN1Dict([(u'reject', 0), (u'ignore', 1), (u'notify', 2)])
    Criticality._ext = None
    
    #-----< Presence >-----#
    Presence = ENUM(name=u'Presence', mode=MODE_TYPE)
    Presence._cont = ASN1Dict([(u'optional', 0), (u'conditional', 1), (u'mandatory', 2)])
    Presence._ext = None
    
    #-----< PrivateIE-ID >-----#
    PrivateIE_ID = CHOICE(name=u'PrivateIE-ID', mode=MODE_TYPE)
    _PrivateIE_ID_local = INT(name=u'local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrivateIE_ID_local._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PrivateIE_ID_global_ = OID(name=u'global', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PrivateIE_ID._cont = ASN1Dict([
        (u'local', _PrivateIE_ID_local),
        (u'global', _PrivateIE_ID_global_),
        ])
    PrivateIE_ID._ext = None
    
    #-----< ProcedureCode >-----#
    ProcedureCode = INT(name=u'ProcedureCode', mode=MODE_TYPE)
    ProcedureCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ProtocolExtensionID >-----#
    ProtocolExtensionID = INT(name=u'ProtocolExtensionID', mode=MODE_TYPE)
    ProtocolExtensionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< ProtocolIE-ID >-----#
    ProtocolIE_ID = INT(name=u'ProtocolIE-ID', mode=MODE_TYPE)
    ProtocolIE_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TriggeringMessage >-----#
    TriggeringMessage = ENUM(name=u'TriggeringMessage', mode=MODE_TYPE)
    TriggeringMessage._cont = ASN1Dict([(u'initiating-message', 0), (u'successful-outcome', 1), (u'unsuccessful-outcome', 2)])
    TriggeringMessage._ext = None
    
    _all_ = [
        Criticality,
        Presence,
        _PrivateIE_ID_local,
        _PrivateIE_ID_global_,
        PrivateIE_ID,
        ProcedureCode,
        ProtocolExtensionID,
        ProtocolIE_ID,
        TriggeringMessage,
    ]

class XwAP_Constants:

    _name_  = u'XwAP-Constants'
    _oid_   = [0, 4, 0, 0, 21, 3, 8, 1, 4]
    
    _obj_ = [
        u'id-xwSetup',
        u'id-wTConfigurationUpdate',
        u'id-wTStatusReportingInitiation',
        u'id-wTStatusReporting',
        u'id-errorIndication',
        u'id-reset',
        u'id-wTAdditionPreparation',
        u'id-eNBInitiatedWTModification',
        u'id-wTInitiatedWTModification',
        u'id-eNBInitiatedWTRelease',
        u'id-wTInitiatedWTRelease',
        u'id-wTAssociationConfirmation',
        u'id-privateMessage',
        u'id-lWIPAdditionPreparation',
        u'id-eNBInitiatedLWIPModification',
        u'id-eNBInitiatedLWIPRelease',
        u'id-wTInitiatedLWIPRelease',
        u'maxPrivateIEs',
        u'maxProtocolExtensions',
        u'maxProtocolIEs',
        u'maxnoofBands',
        u'maxnoofBearers',
        u'maxnoofBSSs',
        u'maxnoofErrors',
        u'maxnoofFailedMeasObjects',
        u'maxnoofMobilitySetItems',
        u'maxnoofWLANIdentifierItems',
        u'maxnoofeNBNeighbours',
        u'id-BSSMeasurementResult-Item',
        u'id-BSSMeasurementResult-List',
        u'id-BSSToReport-Item',
        u'id-BSSToReport-List',
        u'id-Cause',
        u'id-CompleteFailureCauseInformation-Item',
        u'id-CompleteFailureCauseInformation-List',
        u'id-CriticalityDiagnostics',
        u'id-ENB-Measurement-ID',
        u'id-Global-ENB-ID',
        u'id-MeasurementFailureCause-Item',
        u'id-MeasurementInitiationResult-Item',
        u'id-MeasurementInitiationResult-List',
        u'id-PartialSuccessIndicator',
        u'id-Registration-Request',
        u'id-ReportCharacteristics',
        u'id-ReportingPeriodicity',
        u'id-WLANIdentifier-Item',
        u'id-WLANIdentifier-List',
        u'id-WLANIdentifiersToAdd-List',
        u'id-WLANIdentifiersToDelete-Item',
        u'id-WLANIdentifiersToDelete-List',
        u'id-WLANIdentifiersToModify-List',
        u'id-WTID',
        u'id-WT-Measurement-ID',
        u'id-ENB-UE-XwAP-ID',
        u'id-WT-UE-XwAP-ID',
        u'id-BSS-Item',
        u'id-E-RABs-ToBeAdded-List',
        u'id-E-RABs-ToBeAdded-Item',
        u'id-UE-Identity',
        u'id-WLANSecurityInfo',
        u'id-E-RABs-Admitted-ToBeAdded-List',
        u'id-E-RABs-Admitted-ToBeAdded-Item',
        u'id-E-RABs-NotAdmitted-List',
        u'id-E-RAB-Item',
        u'id-UE-ContextInformationWTModReq',
        u'id-E-RABs-ToBeAdded-ModReqItem',
        u'id-E-RABs-ToBeModified-ModReqItem',
        u'id-E-RABs-ToBeReleased-ModReqItem',
        u'id-E-RABs-Admitted-ToBeAdded-ModAckList',
        u'id-E-RABs-Admitted-ToBeAdded-ModAckItem',
        u'id-E-RABs-Admitted-ToBeModified-ModAckList',
        u'id-E-RABs-Admitted-ToBeModified-ModAckItem',
        u'id-E-RABs-Admitted-ToBeReleased-ModAckList',
        u'id-E-RABs-Admitted-ToBeReleased-ModAckItem',
        u'id-E-RABs-ToBeReleased-ModReqdList',
        u'id-E-RABs-ToBeReleased-ModReqdItem',
        u'id-E-RABs-ToBeReleased-List-RelReq',
        u'id-E-RABs-ToBeReleased-RelReqItem',
        u'id-E-RABs-ToBeReleased-List-RelConf',
        u'id-E-RABs-ToBeReleased-RelConfItem',
        u'id-E-RABs-Confirmed-ToBeReleased-ModReqdList',
        u'id-E-RABs-Confirmed-ToBeReleased-ModReqdItem',
        u'id-MobilitySet',
        u'id-ServingPLMN',
        u'id-E-RABs-ToBeModified-ModReqdList',
        u'id-E-RABs-ToBeModified-ModReqdItem',
        u'id-E-RABs-Confirmed-ToBeModified-ModReqdList',
        u'id-E-RABs-Confirmed-ToBeModified-ModReqdItem',
        u'id-wLANBandInformation',
        u'id-WLANIdentifiersToDeleteExtension-Item',
        u'id-WLANIdentifiersToDeleteExtension-List',
        u'id-TimeToWait',
        u'id-UE-ContextKeptIndicator',
        u'id-DRB-Identity',
        u'id-LWA-WLAN-AC',
        u'id-eNBNeighbour-List',
        u'id-eNBNeighbour-Item',
        u'id-LWIP-SeGWSecurityInfo',
        u'id-eNBGTPtunnelEndpoint',
        u'id-LWIP-SeGWGTPtunnelEndpoint',
        u'id-WLANUsage',
        u'id-WT-MAC-Address',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        u'id-xwSetup',
        u'id-wTConfigurationUpdate',
        u'id-wTStatusReportingInitiation',
        u'id-wTStatusReporting',
        u'id-errorIndication',
        u'id-reset',
        u'id-wTAdditionPreparation',
        u'id-eNBInitiatedWTModification',
        u'id-wTInitiatedWTModification',
        u'id-eNBInitiatedWTRelease',
        u'id-wTInitiatedWTRelease',
        u'id-wTAssociationConfirmation',
        u'id-privateMessage',
        u'id-lWIPAdditionPreparation',
        u'id-eNBInitiatedLWIPModification',
        u'id-eNBInitiatedLWIPRelease',
        u'id-wTInitiatedLWIPRelease',
        u'maxPrivateIEs',
        u'maxProtocolExtensions',
        u'maxProtocolIEs',
        u'maxnoofBands',
        u'maxnoofBearers',
        u'maxnoofBSSs',
        u'maxnoofErrors',
        u'maxnoofFailedMeasObjects',
        u'maxnoofMobilitySetItems',
        u'maxnoofWLANIdentifierItems',
        u'maxnoofeNBNeighbours',
        u'id-BSSMeasurementResult-Item',
        u'id-BSSMeasurementResult-List',
        u'id-BSSToReport-Item',
        u'id-BSSToReport-List',
        u'id-Cause',
        u'id-CompleteFailureCauseInformation-Item',
        u'id-CompleteFailureCauseInformation-List',
        u'id-CriticalityDiagnostics',
        u'id-ENB-Measurement-ID',
        u'id-Global-ENB-ID',
        u'id-MeasurementFailureCause-Item',
        u'id-MeasurementInitiationResult-Item',
        u'id-MeasurementInitiationResult-List',
        u'id-PartialSuccessIndicator',
        u'id-Registration-Request',
        u'id-ReportCharacteristics',
        u'id-ReportingPeriodicity',
        u'id-WLANIdentifier-Item',
        u'id-WLANIdentifier-List',
        u'id-WLANIdentifiersToAdd-List',
        u'id-WLANIdentifiersToDelete-Item',
        u'id-WLANIdentifiersToDelete-List',
        u'id-WLANIdentifiersToModify-List',
        u'id-WTID',
        u'id-WT-Measurement-ID',
        u'id-ENB-UE-XwAP-ID',
        u'id-WT-UE-XwAP-ID',
        u'id-BSS-Item',
        u'id-E-RABs-ToBeAdded-List',
        u'id-E-RABs-ToBeAdded-Item',
        u'id-UE-Identity',
        u'id-WLANSecurityInfo',
        u'id-E-RABs-Admitted-ToBeAdded-List',
        u'id-E-RABs-Admitted-ToBeAdded-Item',
        u'id-E-RABs-NotAdmitted-List',
        u'id-E-RAB-Item',
        u'id-UE-ContextInformationWTModReq',
        u'id-E-RABs-ToBeAdded-ModReqItem',
        u'id-E-RABs-ToBeModified-ModReqItem',
        u'id-E-RABs-ToBeReleased-ModReqItem',
        u'id-E-RABs-Admitted-ToBeAdded-ModAckList',
        u'id-E-RABs-Admitted-ToBeAdded-ModAckItem',
        u'id-E-RABs-Admitted-ToBeModified-ModAckList',
        u'id-E-RABs-Admitted-ToBeModified-ModAckItem',
        u'id-E-RABs-Admitted-ToBeReleased-ModAckList',
        u'id-E-RABs-Admitted-ToBeReleased-ModAckItem',
        u'id-E-RABs-ToBeReleased-ModReqdList',
        u'id-E-RABs-ToBeReleased-ModReqdItem',
        u'id-E-RABs-ToBeReleased-List-RelReq',
        u'id-E-RABs-ToBeReleased-RelReqItem',
        u'id-E-RABs-ToBeReleased-List-RelConf',
        u'id-E-RABs-ToBeReleased-RelConfItem',
        u'id-E-RABs-Confirmed-ToBeReleased-ModReqdList',
        u'id-E-RABs-Confirmed-ToBeReleased-ModReqdItem',
        u'id-MobilitySet',
        u'id-ServingPLMN',
        u'id-E-RABs-ToBeModified-ModReqdList',
        u'id-E-RABs-ToBeModified-ModReqdItem',
        u'id-E-RABs-Confirmed-ToBeModified-ModReqdList',
        u'id-E-RABs-Confirmed-ToBeModified-ModReqdItem',
        u'id-wLANBandInformation',
        u'id-WLANIdentifiersToDeleteExtension-Item',
        u'id-WLANIdentifiersToDeleteExtension-List',
        u'id-TimeToWait',
        u'id-UE-ContextKeptIndicator',
        u'id-DRB-Identity',
        u'id-LWA-WLAN-AC',
        u'id-eNBNeighbour-List',
        u'id-eNBNeighbour-Item',
        u'id-LWIP-SeGWSecurityInfo',
        u'id-eNBGTPtunnelEndpoint',
        u'id-LWIP-SeGWGTPtunnelEndpoint',
        u'id-WLANUsage',
        u'id-WT-MAC-Address',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-xwSetup >-----#
    id_xwSetup = INT(name=u'id-xwSetup', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProcedureCode')))
    id_xwSetup._val = 0
    
    #-----< id-wTConfigurationUpdate >-----#
    id_wTConfigurationUpdate = INT(name=u'id-wTConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProcedureCode')))
    id_wTConfigurationUpdate._val = 1
    
    #-----< id-wTStatusReportingInitiation >-----#
    id_wTStatusReportingInitiation = INT(name=u'id-wTStatusReportingInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProcedureCode')))
    id_wTStatusReportingInitiation._val = 2
    
    #-----< id-wTStatusReporting >-----#
    id_wTStatusReporting = INT(name=u'id-wTStatusReporting', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProcedureCode')))
    id_wTStatusReporting._val = 3
    
    #-----< id-errorIndication >-----#
    id_errorIndication = INT(name=u'id-errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProcedureCode')))
    id_errorIndication._val = 4
    
    #-----< id-reset >-----#
    id_reset = INT(name=u'id-reset', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProcedureCode')))
    id_reset._val = 5
    
    #-----< id-wTAdditionPreparation >-----#
    id_wTAdditionPreparation = INT(name=u'id-wTAdditionPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProcedureCode')))
    id_wTAdditionPreparation._val = 6
    
    #-----< id-eNBInitiatedWTModification >-----#
    id_eNBInitiatedWTModification = INT(name=u'id-eNBInitiatedWTModification', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProcedureCode')))
    id_eNBInitiatedWTModification._val = 7
    
    #-----< id-wTInitiatedWTModification >-----#
    id_wTInitiatedWTModification = INT(name=u'id-wTInitiatedWTModification', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProcedureCode')))
    id_wTInitiatedWTModification._val = 8
    
    #-----< id-eNBInitiatedWTRelease >-----#
    id_eNBInitiatedWTRelease = INT(name=u'id-eNBInitiatedWTRelease', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProcedureCode')))
    id_eNBInitiatedWTRelease._val = 9
    
    #-----< id-wTInitiatedWTRelease >-----#
    id_wTInitiatedWTRelease = INT(name=u'id-wTInitiatedWTRelease', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProcedureCode')))
    id_wTInitiatedWTRelease._val = 10
    
    #-----< id-wTAssociationConfirmation >-----#
    id_wTAssociationConfirmation = INT(name=u'id-wTAssociationConfirmation', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProcedureCode')))
    id_wTAssociationConfirmation._val = 11
    
    #-----< id-privateMessage >-----#
    id_privateMessage = INT(name=u'id-privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProcedureCode')))
    id_privateMessage._val = 12
    
    #-----< id-lWIPAdditionPreparation >-----#
    id_lWIPAdditionPreparation = INT(name=u'id-lWIPAdditionPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProcedureCode')))
    id_lWIPAdditionPreparation._val = 13
    
    #-----< id-eNBInitiatedLWIPModification >-----#
    id_eNBInitiatedLWIPModification = INT(name=u'id-eNBInitiatedLWIPModification', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProcedureCode')))
    id_eNBInitiatedLWIPModification._val = 14
    
    #-----< id-eNBInitiatedLWIPRelease >-----#
    id_eNBInitiatedLWIPRelease = INT(name=u'id-eNBInitiatedLWIPRelease', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProcedureCode')))
    id_eNBInitiatedLWIPRelease._val = 15
    
    #-----< id-wTInitiatedLWIPRelease >-----#
    id_wTInitiatedLWIPRelease = INT(name=u'id-wTInitiatedLWIPRelease', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProcedureCode')))
    id_wTInitiatedLWIPRelease._val = 16
    
    #-----< maxPrivateIEs >-----#
    maxPrivateIEs = INT(name=u'maxPrivateIEs', mode=MODE_VALUE)
    maxPrivateIEs._val = 65535
    
    #-----< maxProtocolExtensions >-----#
    maxProtocolExtensions = INT(name=u'maxProtocolExtensions', mode=MODE_VALUE)
    maxProtocolExtensions._val = 65535
    
    #-----< maxProtocolIEs >-----#
    maxProtocolIEs = INT(name=u'maxProtocolIEs', mode=MODE_VALUE)
    maxProtocolIEs._val = 65535
    
    #-----< maxnoofBands >-----#
    maxnoofBands = INT(name=u'maxnoofBands', mode=MODE_VALUE)
    maxnoofBands._val = 256
    
    #-----< maxnoofBearers >-----#
    maxnoofBearers = INT(name=u'maxnoofBearers', mode=MODE_VALUE)
    maxnoofBearers._val = 256
    
    #-----< maxnoofBSSs >-----#
    maxnoofBSSs = INT(name=u'maxnoofBSSs', mode=MODE_VALUE)
    maxnoofBSSs._val = 4096
    
    #-----< maxnoofErrors >-----#
    maxnoofErrors = INT(name=u'maxnoofErrors', mode=MODE_VALUE)
    maxnoofErrors._val = 256
    
    #-----< maxnoofFailedMeasObjects >-----#
    maxnoofFailedMeasObjects = INT(name=u'maxnoofFailedMeasObjects', mode=MODE_VALUE)
    maxnoofFailedMeasObjects._val = 32
    
    #-----< maxnoofMobilitySetItems >-----#
    maxnoofMobilitySetItems = INT(name=u'maxnoofMobilitySetItems', mode=MODE_VALUE)
    maxnoofMobilitySetItems._val = 1024
    
    #-----< maxnoofWLANIdentifierItems >-----#
    maxnoofWLANIdentifierItems = INT(name=u'maxnoofWLANIdentifierItems', mode=MODE_VALUE)
    maxnoofWLANIdentifierItems._val = 4096
    
    #-----< maxnoofeNBNeighbours >-----#
    maxnoofeNBNeighbours = INT(name=u'maxnoofeNBNeighbours', mode=MODE_VALUE)
    maxnoofeNBNeighbours._val = 256
    
    #-----< id-BSSMeasurementResult-Item >-----#
    id_BSSMeasurementResult_Item = INT(name=u'id-BSSMeasurementResult-Item', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BSSMeasurementResult_Item._val = 0
    
    #-----< id-BSSMeasurementResult-List >-----#
    id_BSSMeasurementResult_List = INT(name=u'id-BSSMeasurementResult-List', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BSSMeasurementResult_List._val = 1
    
    #-----< id-BSSToReport-Item >-----#
    id_BSSToReport_Item = INT(name=u'id-BSSToReport-Item', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BSSToReport_Item._val = 2
    
    #-----< id-BSSToReport-List >-----#
    id_BSSToReport_List = INT(name=u'id-BSSToReport-List', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BSSToReport_List._val = 3
    
    #-----< id-Cause >-----#
    id_Cause = INT(name=u'id-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cause._val = 4
    
    #-----< id-CompleteFailureCauseInformation-Item >-----#
    id_CompleteFailureCauseInformation_Item = INT(name=u'id-CompleteFailureCauseInformation-Item', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CompleteFailureCauseInformation_Item._val = 5
    
    #-----< id-CompleteFailureCauseInformation-List >-----#
    id_CompleteFailureCauseInformation_List = INT(name=u'id-CompleteFailureCauseInformation-List', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CompleteFailureCauseInformation_List._val = 6
    
    #-----< id-CriticalityDiagnostics >-----#
    id_CriticalityDiagnostics = INT(name=u'id-CriticalityDiagnostics', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CriticalityDiagnostics._val = 7
    
    #-----< id-ENB-Measurement-ID >-----#
    id_ENB_Measurement_ID = INT(name=u'id-ENB-Measurement-ID', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENB_Measurement_ID._val = 8
    
    #-----< id-Global-ENB-ID >-----#
    id_Global_ENB_ID = INT(name=u'id-Global-ENB-ID', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Global_ENB_ID._val = 9
    
    #-----< id-MeasurementFailureCause-Item >-----#
    id_MeasurementFailureCause_Item = INT(name=u'id-MeasurementFailureCause-Item', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementFailureCause_Item._val = 10
    
    #-----< id-MeasurementInitiationResult-Item >-----#
    id_MeasurementInitiationResult_Item = INT(name=u'id-MeasurementInitiationResult-Item', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementInitiationResult_Item._val = 11
    
    #-----< id-MeasurementInitiationResult-List >-----#
    id_MeasurementInitiationResult_List = INT(name=u'id-MeasurementInitiationResult-List', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementInitiationResult_List._val = 12
    
    #-----< id-PartialSuccessIndicator >-----#
    id_PartialSuccessIndicator = INT(name=u'id-PartialSuccessIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PartialSuccessIndicator._val = 13
    
    #-----< id-Registration-Request >-----#
    id_Registration_Request = INT(name=u'id-Registration-Request', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Registration_Request._val = 14
    
    #-----< id-ReportCharacteristics >-----#
    id_ReportCharacteristics = INT(name=u'id-ReportCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportCharacteristics._val = 15
    
    #-----< id-ReportingPeriodicity >-----#
    id_ReportingPeriodicity = INT(name=u'id-ReportingPeriodicity', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportingPeriodicity._val = 16
    
    #-----< id-WLANIdentifier-Item >-----#
    id_WLANIdentifier_Item = INT(name=u'id-WLANIdentifier-Item', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WLANIdentifier_Item._val = 17
    
    #-----< id-WLANIdentifier-List >-----#
    id_WLANIdentifier_List = INT(name=u'id-WLANIdentifier-List', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WLANIdentifier_List._val = 18
    
    #-----< id-WLANIdentifiersToAdd-List >-----#
    id_WLANIdentifiersToAdd_List = INT(name=u'id-WLANIdentifiersToAdd-List', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WLANIdentifiersToAdd_List._val = 19
    
    #-----< id-WLANIdentifiersToDelete-Item >-----#
    id_WLANIdentifiersToDelete_Item = INT(name=u'id-WLANIdentifiersToDelete-Item', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WLANIdentifiersToDelete_Item._val = 20
    
    #-----< id-WLANIdentifiersToDelete-List >-----#
    id_WLANIdentifiersToDelete_List = INT(name=u'id-WLANIdentifiersToDelete-List', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WLANIdentifiersToDelete_List._val = 21
    
    #-----< id-WLANIdentifiersToModify-List >-----#
    id_WLANIdentifiersToModify_List = INT(name=u'id-WLANIdentifiersToModify-List', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WLANIdentifiersToModify_List._val = 22
    
    #-----< id-WTID >-----#
    id_WTID = INT(name=u'id-WTID', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WTID._val = 23
    
    #-----< id-WT-Measurement-ID >-----#
    id_WT_Measurement_ID = INT(name=u'id-WT-Measurement-ID', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WT_Measurement_ID._val = 24
    
    #-----< id-ENB-UE-XwAP-ID >-----#
    id_ENB_UE_XwAP_ID = INT(name=u'id-ENB-UE-XwAP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ENB_UE_XwAP_ID._val = 25
    
    #-----< id-WT-UE-XwAP-ID >-----#
    id_WT_UE_XwAP_ID = INT(name=u'id-WT-UE-XwAP-ID', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WT_UE_XwAP_ID._val = 26
    
    #-----< id-BSS-Item >-----#
    id_BSS_Item = INT(name=u'id-BSS-Item', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BSS_Item._val = 27
    
    #-----< id-E-RABs-ToBeAdded-List >-----#
    id_E_RABs_ToBeAdded_List = INT(name=u'id-E-RABs-ToBeAdded-List', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeAdded_List._val = 28
    
    #-----< id-E-RABs-ToBeAdded-Item >-----#
    id_E_RABs_ToBeAdded_Item = INT(name=u'id-E-RABs-ToBeAdded-Item', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeAdded_Item._val = 29
    
    #-----< id-UE-Identity >-----#
    id_UE_Identity = INT(name=u'id-UE-Identity', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_Identity._val = 30
    
    #-----< id-WLANSecurityInfo >-----#
    id_WLANSecurityInfo = INT(name=u'id-WLANSecurityInfo', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WLANSecurityInfo._val = 31
    
    #-----< id-E-RABs-Admitted-ToBeAdded-List >-----#
    id_E_RABs_Admitted_ToBeAdded_List = INT(name=u'id-E-RABs-Admitted-ToBeAdded-List', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeAdded_List._val = 32
    
    #-----< id-E-RABs-Admitted-ToBeAdded-Item >-----#
    id_E_RABs_Admitted_ToBeAdded_Item = INT(name=u'id-E-RABs-Admitted-ToBeAdded-Item', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeAdded_Item._val = 33
    
    #-----< id-E-RABs-NotAdmitted-List >-----#
    id_E_RABs_NotAdmitted_List = INT(name=u'id-E-RABs-NotAdmitted-List', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_NotAdmitted_List._val = 34
    
    #-----< id-E-RAB-Item >-----#
    id_E_RAB_Item = INT(name=u'id-E-RAB-Item', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RAB_Item._val = 35
    
    #-----< id-UE-ContextInformationWTModReq >-----#
    id_UE_ContextInformationWTModReq = INT(name=u'id-UE-ContextInformationWTModReq', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_ContextInformationWTModReq._val = 36
    
    #-----< id-E-RABs-ToBeAdded-ModReqItem >-----#
    id_E_RABs_ToBeAdded_ModReqItem = INT(name=u'id-E-RABs-ToBeAdded-ModReqItem', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeAdded_ModReqItem._val = 37
    
    #-----< id-E-RABs-ToBeModified-ModReqItem >-----#
    id_E_RABs_ToBeModified_ModReqItem = INT(name=u'id-E-RABs-ToBeModified-ModReqItem', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeModified_ModReqItem._val = 38
    
    #-----< id-E-RABs-ToBeReleased-ModReqItem >-----#
    id_E_RABs_ToBeReleased_ModReqItem = INT(name=u'id-E-RABs-ToBeReleased-ModReqItem', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_ModReqItem._val = 39
    
    #-----< id-E-RABs-Admitted-ToBeAdded-ModAckList >-----#
    id_E_RABs_Admitted_ToBeAdded_ModAckList = INT(name=u'id-E-RABs-Admitted-ToBeAdded-ModAckList', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeAdded_ModAckList._val = 40
    
    #-----< id-E-RABs-Admitted-ToBeAdded-ModAckItem >-----#
    id_E_RABs_Admitted_ToBeAdded_ModAckItem = INT(name=u'id-E-RABs-Admitted-ToBeAdded-ModAckItem', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeAdded_ModAckItem._val = 41
    
    #-----< id-E-RABs-Admitted-ToBeModified-ModAckList >-----#
    id_E_RABs_Admitted_ToBeModified_ModAckList = INT(name=u'id-E-RABs-Admitted-ToBeModified-ModAckList', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeModified_ModAckList._val = 42
    
    #-----< id-E-RABs-Admitted-ToBeModified-ModAckItem >-----#
    id_E_RABs_Admitted_ToBeModified_ModAckItem = INT(name=u'id-E-RABs-Admitted-ToBeModified-ModAckItem', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeModified_ModAckItem._val = 43
    
    #-----< id-E-RABs-Admitted-ToBeReleased-ModAckList >-----#
    id_E_RABs_Admitted_ToBeReleased_ModAckList = INT(name=u'id-E-RABs-Admitted-ToBeReleased-ModAckList', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeReleased_ModAckList._val = 44
    
    #-----< id-E-RABs-Admitted-ToBeReleased-ModAckItem >-----#
    id_E_RABs_Admitted_ToBeReleased_ModAckItem = INT(name=u'id-E-RABs-Admitted-ToBeReleased-ModAckItem', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Admitted_ToBeReleased_ModAckItem._val = 45
    
    #-----< id-E-RABs-ToBeReleased-ModReqdList >-----#
    id_E_RABs_ToBeReleased_ModReqdList = INT(name=u'id-E-RABs-ToBeReleased-ModReqdList', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_ModReqdList._val = 46
    
    #-----< id-E-RABs-ToBeReleased-ModReqdItem >-----#
    id_E_RABs_ToBeReleased_ModReqdItem = INT(name=u'id-E-RABs-ToBeReleased-ModReqdItem', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_ModReqdItem._val = 47
    
    #-----< id-E-RABs-ToBeReleased-List-RelReq >-----#
    id_E_RABs_ToBeReleased_List_RelReq = INT(name=u'id-E-RABs-ToBeReleased-List-RelReq', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_List_RelReq._val = 48
    
    #-----< id-E-RABs-ToBeReleased-RelReqItem >-----#
    id_E_RABs_ToBeReleased_RelReqItem = INT(name=u'id-E-RABs-ToBeReleased-RelReqItem', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_RelReqItem._val = 49
    
    #-----< id-E-RABs-ToBeReleased-List-RelConf >-----#
    id_E_RABs_ToBeReleased_List_RelConf = INT(name=u'id-E-RABs-ToBeReleased-List-RelConf', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_List_RelConf._val = 50
    
    #-----< id-E-RABs-ToBeReleased-RelConfItem >-----#
    id_E_RABs_ToBeReleased_RelConfItem = INT(name=u'id-E-RABs-ToBeReleased-RelConfItem', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeReleased_RelConfItem._val = 51
    
    #-----< id-E-RABs-Confirmed-ToBeReleased-ModReqdList >-----#
    id_E_RABs_Confirmed_ToBeReleased_ModReqdList = INT(name=u'id-E-RABs-Confirmed-ToBeReleased-ModReqdList', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Confirmed_ToBeReleased_ModReqdList._val = 52
    
    #-----< id-E-RABs-Confirmed-ToBeReleased-ModReqdItem >-----#
    id_E_RABs_Confirmed_ToBeReleased_ModReqdItem = INT(name=u'id-E-RABs-Confirmed-ToBeReleased-ModReqdItem', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Confirmed_ToBeReleased_ModReqdItem._val = 53
    
    #-----< id-MobilitySet >-----#
    id_MobilitySet = INT(name=u'id-MobilitySet', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MobilitySet._val = 54
    
    #-----< id-ServingPLMN >-----#
    id_ServingPLMN = INT(name=u'id-ServingPLMN', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ServingPLMN._val = 55
    
    #-----< id-E-RABs-ToBeModified-ModReqdList >-----#
    id_E_RABs_ToBeModified_ModReqdList = INT(name=u'id-E-RABs-ToBeModified-ModReqdList', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeModified_ModReqdList._val = 56
    
    #-----< id-E-RABs-ToBeModified-ModReqdItem >-----#
    id_E_RABs_ToBeModified_ModReqdItem = INT(name=u'id-E-RABs-ToBeModified-ModReqdItem', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_ToBeModified_ModReqdItem._val = 57
    
    #-----< id-E-RABs-Confirmed-ToBeModified-ModReqdList >-----#
    id_E_RABs_Confirmed_ToBeModified_ModReqdList = INT(name=u'id-E-RABs-Confirmed-ToBeModified-ModReqdList', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Confirmed_ToBeModified_ModReqdList._val = 58
    
    #-----< id-E-RABs-Confirmed-ToBeModified-ModReqdItem >-----#
    id_E_RABs_Confirmed_ToBeModified_ModReqdItem = INT(name=u'id-E-RABs-Confirmed-ToBeModified-ModReqdItem', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RABs_Confirmed_ToBeModified_ModReqdItem._val = 59
    
    #-----< id-wLANBandInformation >-----#
    id_wLANBandInformation = INT(name=u'id-wLANBandInformation', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_wLANBandInformation._val = 60
    
    #-----< id-WLANIdentifiersToDeleteExtension-Item >-----#
    id_WLANIdentifiersToDeleteExtension_Item = INT(name=u'id-WLANIdentifiersToDeleteExtension-Item', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WLANIdentifiersToDeleteExtension_Item._val = 61
    
    #-----< id-WLANIdentifiersToDeleteExtension-List >-----#
    id_WLANIdentifiersToDeleteExtension_List = INT(name=u'id-WLANIdentifiersToDeleteExtension-List', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WLANIdentifiersToDeleteExtension_List._val = 62
    
    #-----< id-TimeToWait >-----#
    id_TimeToWait = INT(name=u'id-TimeToWait', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeToWait._val = 63
    
    #-----< id-UE-ContextKeptIndicator >-----#
    id_UE_ContextKeptIndicator = INT(name=u'id-UE-ContextKeptIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_ContextKeptIndicator._val = 64
    
    #-----< id-DRB-Identity >-----#
    id_DRB_Identity = INT(name=u'id-DRB-Identity', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRB_Identity._val = 65
    
    #-----< id-LWA-WLAN-AC >-----#
    id_LWA_WLAN_AC = INT(name=u'id-LWA-WLAN-AC', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LWA_WLAN_AC._val = 66
    
    #-----< id-eNBNeighbour-List >-----#
    id_eNBNeighbour_List = INT(name=u'id-eNBNeighbour-List', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_eNBNeighbour_List._val = 67
    
    #-----< id-eNBNeighbour-Item >-----#
    id_eNBNeighbour_Item = INT(name=u'id-eNBNeighbour-Item', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_eNBNeighbour_Item._val = 68
    
    #-----< id-LWIP-SeGWSecurityInfo >-----#
    id_LWIP_SeGWSecurityInfo = INT(name=u'id-LWIP-SeGWSecurityInfo', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LWIP_SeGWSecurityInfo._val = 69
    
    #-----< id-eNBGTPtunnelEndpoint >-----#
    id_eNBGTPtunnelEndpoint = INT(name=u'id-eNBGTPtunnelEndpoint', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_eNBGTPtunnelEndpoint._val = 70
    
    #-----< id-LWIP-SeGWGTPtunnelEndpoint >-----#
    id_LWIP_SeGWGTPtunnelEndpoint = INT(name=u'id-LWIP-SeGWGTPtunnelEndpoint', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LWIP_SeGWGTPtunnelEndpoint._val = 71
    
    #-----< id-WLANUsage >-----#
    id_WLANUsage = INT(name=u'id-WLANUsage', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WLANUsage._val = 72
    
    #-----< id-WT-MAC-Address >-----#
    id_WT_MAC_Address = INT(name=u'id-WT-MAC-Address', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_WT_MAC_Address._val = 73
    
    _all_ = [
        id_xwSetup,
        id_wTConfigurationUpdate,
        id_wTStatusReportingInitiation,
        id_wTStatusReporting,
        id_errorIndication,
        id_reset,
        id_wTAdditionPreparation,
        id_eNBInitiatedWTModification,
        id_wTInitiatedWTModification,
        id_eNBInitiatedWTRelease,
        id_wTInitiatedWTRelease,
        id_wTAssociationConfirmation,
        id_privateMessage,
        id_lWIPAdditionPreparation,
        id_eNBInitiatedLWIPModification,
        id_eNBInitiatedLWIPRelease,
        id_wTInitiatedLWIPRelease,
        maxPrivateIEs,
        maxProtocolExtensions,
        maxProtocolIEs,
        maxnoofBands,
        maxnoofBearers,
        maxnoofBSSs,
        maxnoofErrors,
        maxnoofFailedMeasObjects,
        maxnoofMobilitySetItems,
        maxnoofWLANIdentifierItems,
        maxnoofeNBNeighbours,
        id_BSSMeasurementResult_Item,
        id_BSSMeasurementResult_List,
        id_BSSToReport_Item,
        id_BSSToReport_List,
        id_Cause,
        id_CompleteFailureCauseInformation_Item,
        id_CompleteFailureCauseInformation_List,
        id_CriticalityDiagnostics,
        id_ENB_Measurement_ID,
        id_Global_ENB_ID,
        id_MeasurementFailureCause_Item,
        id_MeasurementInitiationResult_Item,
        id_MeasurementInitiationResult_List,
        id_PartialSuccessIndicator,
        id_Registration_Request,
        id_ReportCharacteristics,
        id_ReportingPeriodicity,
        id_WLANIdentifier_Item,
        id_WLANIdentifier_List,
        id_WLANIdentifiersToAdd_List,
        id_WLANIdentifiersToDelete_Item,
        id_WLANIdentifiersToDelete_List,
        id_WLANIdentifiersToModify_List,
        id_WTID,
        id_WT_Measurement_ID,
        id_ENB_UE_XwAP_ID,
        id_WT_UE_XwAP_ID,
        id_BSS_Item,
        id_E_RABs_ToBeAdded_List,
        id_E_RABs_ToBeAdded_Item,
        id_UE_Identity,
        id_WLANSecurityInfo,
        id_E_RABs_Admitted_ToBeAdded_List,
        id_E_RABs_Admitted_ToBeAdded_Item,
        id_E_RABs_NotAdmitted_List,
        id_E_RAB_Item,
        id_UE_ContextInformationWTModReq,
        id_E_RABs_ToBeAdded_ModReqItem,
        id_E_RABs_ToBeModified_ModReqItem,
        id_E_RABs_ToBeReleased_ModReqItem,
        id_E_RABs_Admitted_ToBeAdded_ModAckList,
        id_E_RABs_Admitted_ToBeAdded_ModAckItem,
        id_E_RABs_Admitted_ToBeModified_ModAckList,
        id_E_RABs_Admitted_ToBeModified_ModAckItem,
        id_E_RABs_Admitted_ToBeReleased_ModAckList,
        id_E_RABs_Admitted_ToBeReleased_ModAckItem,
        id_E_RABs_ToBeReleased_ModReqdList,
        id_E_RABs_ToBeReleased_ModReqdItem,
        id_E_RABs_ToBeReleased_List_RelReq,
        id_E_RABs_ToBeReleased_RelReqItem,
        id_E_RABs_ToBeReleased_List_RelConf,
        id_E_RABs_ToBeReleased_RelConfItem,
        id_E_RABs_Confirmed_ToBeReleased_ModReqdList,
        id_E_RABs_Confirmed_ToBeReleased_ModReqdItem,
        id_MobilitySet,
        id_ServingPLMN,
        id_E_RABs_ToBeModified_ModReqdList,
        id_E_RABs_ToBeModified_ModReqdItem,
        id_E_RABs_Confirmed_ToBeModified_ModReqdList,
        id_E_RABs_Confirmed_ToBeModified_ModReqdItem,
        id_wLANBandInformation,
        id_WLANIdentifiersToDeleteExtension_Item,
        id_WLANIdentifiersToDeleteExtension_List,
        id_TimeToWait,
        id_UE_ContextKeptIndicator,
        id_DRB_Identity,
        id_LWA_WLAN_AC,
        id_eNBNeighbour_List,
        id_eNBNeighbour_Item,
        id_LWIP_SeGWSecurityInfo,
        id_eNBGTPtunnelEndpoint,
        id_LWIP_SeGWGTPtunnelEndpoint,
        id_WLANUsage,
        id_WT_MAC_Address,
    ]

class XwAP_Containers:

    _name_  = u'XwAP-Containers'
    _oid_   = [0, 4, 0, 0, 21, 3, 8, 1, 5]
    
    _obj_ = [
        u'XWAP-PROTOCOL-IES',
        u'XWAP-PROTOCOL-IES-PAIR',
        u'XWAP-PROTOCOL-EXTENSION',
        u'XWAP-PRIVATE-IES',
        u'ProtocolIE-Container',
        u'ProtocolIE-SingleContainer',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerPair',
        u'ProtocolIE-FieldPair',
        u'ProtocolIE-ContainerList',
        u'ProtocolIE-ContainerPairList',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    _type_ = [
        u'XWAP-PROTOCOL-IES',
        u'XWAP-PROTOCOL-IES-PAIR',
        u'XWAP-PROTOCOL-EXTENSION',
        u'XWAP-PRIVATE-IES',
        u'ProtocolIE-Container',
        u'ProtocolIE-SingleContainer',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerPair',
        u'ProtocolIE-FieldPair',
        u'ProtocolIE-ContainerList',
        u'ProtocolIE-ContainerPairList',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        u'XWAP-PROTOCOL-IES',
        u'XWAP-PROTOCOL-IES-PAIR',
        u'XWAP-PROTOCOL-EXTENSION',
        u'XWAP-PRIVATE-IES',
        ]
    _param_ = [
        u'ProtocolIE-Container',
        u'ProtocolIE-SingleContainer',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerPair',
        u'ProtocolIE-FieldPair',
        u'ProtocolIE-ContainerList',
        u'ProtocolIE-ContainerPairList',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    
    #-----< XWAP-PROTOCOL-IES >-----#
    XWAP_PROTOCOL_IES = CLASS(name=u'XWAP-PROTOCOL-IES', mode=MODE_TYPE)
    _XWAP_PROTOCOL_IES_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _XWAP_PROTOCOL_IES_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'Criticality')))
    _XWAP_PROTOCOL_IES_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    _XWAP_PROTOCOL_IES_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'Presence')))
    XWAP_PROTOCOL_IES._cont = ASN1Dict([
        (u'id', _XWAP_PROTOCOL_IES_id),
        (u'criticality', _XWAP_PROTOCOL_IES_criticality),
        (u'Value', _XWAP_PROTOCOL_IES_Value),
        (u'presence', _XWAP_PROTOCOL_IES_presence),
        ])
    
    #-----< XWAP-PROTOCOL-IES-PAIR >-----#
    XWAP_PROTOCOL_IES_PAIR = CLASS(name=u'XWAP-PROTOCOL-IES-PAIR', mode=MODE_TYPE)
    _XWAP_PROTOCOL_IES_PAIR_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _XWAP_PROTOCOL_IES_PAIR_firstCriticality = ENUM(name=u'firstCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'Criticality')))
    _XWAP_PROTOCOL_IES_PAIR_FirstValue = OPEN(name=u'FirstValue', mode=MODE_TYPE)
    _XWAP_PROTOCOL_IES_PAIR_secondCriticality = ENUM(name=u'secondCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'Criticality')))
    _XWAP_PROTOCOL_IES_PAIR_SecondValue = OPEN(name=u'SecondValue', mode=MODE_TYPE)
    _XWAP_PROTOCOL_IES_PAIR_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'Presence')))
    XWAP_PROTOCOL_IES_PAIR._cont = ASN1Dict([
        (u'id', _XWAP_PROTOCOL_IES_PAIR_id),
        (u'firstCriticality', _XWAP_PROTOCOL_IES_PAIR_firstCriticality),
        (u'FirstValue', _XWAP_PROTOCOL_IES_PAIR_FirstValue),
        (u'secondCriticality', _XWAP_PROTOCOL_IES_PAIR_secondCriticality),
        (u'SecondValue', _XWAP_PROTOCOL_IES_PAIR_SecondValue),
        (u'presence', _XWAP_PROTOCOL_IES_PAIR_presence),
        ])
    
    #-----< XWAP-PROTOCOL-EXTENSION >-----#
    XWAP_PROTOCOL_EXTENSION = CLASS(name=u'XWAP-PROTOCOL-EXTENSION', mode=MODE_TYPE)
    _XWAP_PROTOCOL_EXTENSION_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolExtensionID')), uniq=True)
    _XWAP_PROTOCOL_EXTENSION_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'Criticality')))
    _XWAP_PROTOCOL_EXTENSION_Extension = OPEN(name=u'Extension', mode=MODE_TYPE)
    _XWAP_PROTOCOL_EXTENSION_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'Presence')))
    XWAP_PROTOCOL_EXTENSION._cont = ASN1Dict([
        (u'id', _XWAP_PROTOCOL_EXTENSION_id),
        (u'criticality', _XWAP_PROTOCOL_EXTENSION_criticality),
        (u'Extension', _XWAP_PROTOCOL_EXTENSION_Extension),
        (u'presence', _XWAP_PROTOCOL_EXTENSION_presence),
        ])
    
    #-----< XWAP-PRIVATE-IES >-----#
    XWAP_PRIVATE_IES = CLASS(name=u'XWAP-PRIVATE-IES', mode=MODE_TYPE)
    _XWAP_PRIVATE_IES_id = CHOICE(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'PrivateIE-ID')))
    _XWAP_PRIVATE_IES_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'Criticality')))
    _XWAP_PRIVATE_IES_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    _XWAP_PRIVATE_IES_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'Presence')))
    XWAP_PRIVATE_IES._cont = ASN1Dict([
        (u'id', _XWAP_PRIVATE_IES_id),
        (u'criticality', _XWAP_PRIVATE_IES_criticality),
        (u'Value', _XWAP_PRIVATE_IES_Value),
        (u'presence', _XWAP_PRIVATE_IES_presence),
        ])
    
    #-----< ProtocolIE-Container >-----#
    ProtocolIE_Container = SEQ_OF(name=u'ProtocolIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-SingleContainer >-----#
    ProtocolIE_SingleContainer = SEQ(name=u'ProtocolIE-SingleContainer', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')), param=True)
    
    #-----< ProtocolIE-Field >-----#
    ProtocolIE_Field = SEQ(name=u'ProtocolIE-Field', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPair >-----#
    ProtocolIE_ContainerPair = SEQ_OF(name=u'ProtocolIE-ContainerPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-FieldPair >-----#
    ProtocolIE_FieldPair = SEQ(name=u'ProtocolIE-FieldPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerList >-----#
    ProtocolIE_ContainerList = SEQ_OF(name=u'ProtocolIE-ContainerList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPairList >-----#
    ProtocolIE_ContainerPairList = SEQ_OF(name=u'ProtocolIE-ContainerPairList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionContainer >-----#
    ProtocolExtensionContainer = SEQ_OF(name=u'ProtocolExtensionContainer', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionField >-----#
    ProtocolExtensionField = SEQ(name=u'ProtocolExtensionField', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Container >-----#
    PrivateIE_Container = SEQ_OF(name=u'PrivateIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Field >-----#
    PrivateIE_Field = SEQ(name=u'PrivateIE-Field', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _XWAP_PROTOCOL_IES_id,
        _XWAP_PROTOCOL_IES_criticality,
        _XWAP_PROTOCOL_IES_Value,
        _XWAP_PROTOCOL_IES_presence,
        XWAP_PROTOCOL_IES,
        _XWAP_PROTOCOL_IES_PAIR_id,
        _XWAP_PROTOCOL_IES_PAIR_firstCriticality,
        _XWAP_PROTOCOL_IES_PAIR_FirstValue,
        _XWAP_PROTOCOL_IES_PAIR_secondCriticality,
        _XWAP_PROTOCOL_IES_PAIR_SecondValue,
        _XWAP_PROTOCOL_IES_PAIR_presence,
        XWAP_PROTOCOL_IES_PAIR,
        _XWAP_PROTOCOL_EXTENSION_id,
        _XWAP_PROTOCOL_EXTENSION_criticality,
        _XWAP_PROTOCOL_EXTENSION_Extension,
        _XWAP_PROTOCOL_EXTENSION_presence,
        XWAP_PROTOCOL_EXTENSION,
        _XWAP_PRIVATE_IES_id,
        _XWAP_PRIVATE_IES_criticality,
        _XWAP_PRIVATE_IES_Value,
        _XWAP_PRIVATE_IES_presence,
        XWAP_PRIVATE_IES,
    ]

class XwAP_IEs:

    _name_  = u'XwAP-IEs'
    _oid_   = [0, 4, 0, 0, 21, 3, 8, 1, 2]
    
    _obj_ = [
        u'AllocationAndRetentionPriority',
        u'AllocationAndRetentionPriority-ExtIEs',
        u'AvailableChUtilization',
        u'AvailableChUtilization-ExtIEs',
        u'BitRate',
        u'BSSID',
        u'BSSLoad',
        u'BSSLoad-Item-ExtIEs',
        u'BSS-Item',
        u'BSS-Item-ExtIEs',
        u'BSSMeasurementResult-List',
        u'BSSMeasurementResult-ItemIEs',
        u'BSSMeasurementResult-Item',
        u'BSSMeasurementResult-Item-ExtIEs',
        u'BSSToReport-List',
        u'BSSToReport-ItemIEs',
        u'BSSToReport-Item',
        u'BSSToReport-Item-ExtIEs',
        u'CapacityValue',
        u'Cause',
        u'CauseMisc',
        u'CauseProtocol',
        u'CauseRadioNetwork',
        u'CauseTransport',
        u'ChannelUtilization',
        u'CompleteFailureCauseInformation-List',
        u'CompleteFailureCauseInformation-ItemIEs',
        u'CompleteFailureCauseInformation-Item',
        u'CompleteFailureCauseInformation-Item-ExtIEs',
        u'CriticalityDiagnostics',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-List',
        u'CriticalityDiagnostics-IE-Item',
        u'CriticalityDiagnostics-IE-Item-ExtIEs',
        u'DRB-Identity',
        u'ENB-ID',
        u'ENBNeighbour-List',
        u'ENBNeighbour-ItemIEs',
        u'ENBNeighbour-Item',
        u'ENBNeighbour-Item-ExtIEs',
        u'E-RAB-ID',
        u'E-RAB-List',
        u'E-RAB-ItemIEs',
        u'E-RAB-Item',
        u'E-RAB-Item-ExtIEs',
        u'E-RAB-QoS-Parameters',
        u'E-RAB-QoS-Parameters-ExtIEs',
        u'GBR-QosInformation',
        u'GBR-QosInformation-ExtIEs',
        u'Global-ENB-ID',
        u'GlobalENB-ID-ExtIEs',
        u'GTPtunnelEndpoint',
        u'GTPtunnelEndpoint-ExtIEs',
        u'GTP-TEID',
        u'HESSID',
        u'IKE-Initiator-Identity',
        u'LWA-WLAN-AC',
        u'LWIP-SeGWSecurityInfo',
        u'LWIP-SeGWSecurityInfo-ExtIEs',
        u'LWIP-PSK',
        u'Measurement-ID',
        u'MeasurementInitiationResult-List',
        u'MeasurementInitiationResult-ItemIEs',
        u'MeasurementInitiationResult-Item',
        u'MeasurementInitiationResult-Item-ExtIEs',
        u'MeasurementFailureCause-List',
        u'MeasurementFailureCause-ItemIEs',
        u'MeasurementFailureCause-Item',
        u'MeasurementFailureCause-Item-ExtIEs',
        u'MobilitySet',
        u'MobilitySetItem',
        u'MobilitySetItem-ExtIEs',
        u'OtherENB-IDIEs',
        u'PartialSuccessIndicator',
        u'PLMN-Identity',
        u'Pre-emptionCapability',
        u'Pre-emptionVulnerability',
        u'PriorityLevel',
        u'QCI',
        u'Registration-Request',
        u'ReportCharacteristics',
        u'ReportingPeriodicity',
        u'SSID',
        u'StationCount',
        u'TransportLayerAddress',
        u'TypeOfError',
        u'TimeToWait',
        u'UE-ContextKeptIndicator',
        u'UE-Identity',
        u'UE-XwAP-ID',
        u'WANMetrics',
        u'WANMetrics-Item-ExtIEs',
        u'WLAN-Backhaul-Rate',
        u'WLANband',
        u'WLANBandInformationList',
        u'WLANBandInformation-ItemIEs',
        u'WLANBandInformation',
        u'WLANchannelnumber',
        u'WLANOperatingClass',
        u'WLANCountryCode',
        u'WLANIdentifier-List',
        u'WLANIdentifier-ItemIEs',
        u'WLANIdentifier-Item',
        u'WLANIdentifier-Item-ExtIEs',
        u'WLANIdentifiersToDelete-List',
        u'WLANIdentifiersToDelete-ItemIEs',
        u'WLANIdentifiersToDelete-Item',
        u'WLANIdentifiersToDelete-Item-ExtIEs',
        u'WLANIdentifiersToDeleteExtension-List',
        u'WLANIdentifiersToDeleteExtension-ItemIEs',
        u'WLANIdentifiersToDeleteExtension-Item',
        u'WLANIdentifiersToDeleteExtension-Item-ExtIEs',
        u'WLANInformation',
        u'WLANInformation-ExtIEs',
        u'WLANSecurityInfo',
        u'WLANSecurityInfo-Item-ExtIEs',
        u'WLANUsage',
        u'WT-MAC-Address',
        u'WTID',
        u'WTID-Type1',
        u'WTID-Long-Type2',
        ]
    _type_ = [
        u'AllocationAndRetentionPriority',
        u'AvailableChUtilization',
        u'BitRate',
        u'BSSID',
        u'BSSLoad',
        u'BSS-Item',
        u'BSSMeasurementResult-List',
        u'BSSMeasurementResult-Item',
        u'BSSToReport-List',
        u'BSSToReport-Item',
        u'CapacityValue',
        u'Cause',
        u'CauseMisc',
        u'CauseProtocol',
        u'CauseRadioNetwork',
        u'CauseTransport',
        u'ChannelUtilization',
        u'CompleteFailureCauseInformation-List',
        u'CompleteFailureCauseInformation-Item',
        u'CriticalityDiagnostics',
        u'CriticalityDiagnostics-IE-List',
        u'CriticalityDiagnostics-IE-Item',
        u'DRB-Identity',
        u'ENB-ID',
        u'ENBNeighbour-List',
        u'ENBNeighbour-Item',
        u'E-RAB-ID',
        u'E-RAB-List',
        u'E-RAB-Item',
        u'E-RAB-QoS-Parameters',
        u'GBR-QosInformation',
        u'Global-ENB-ID',
        u'GTPtunnelEndpoint',
        u'GTP-TEID',
        u'HESSID',
        u'IKE-Initiator-Identity',
        u'LWA-WLAN-AC',
        u'LWIP-SeGWSecurityInfo',
        u'LWIP-PSK',
        u'Measurement-ID',
        u'MeasurementInitiationResult-List',
        u'MeasurementInitiationResult-Item',
        u'MeasurementFailureCause-List',
        u'MeasurementFailureCause-Item',
        u'MobilitySet',
        u'MobilitySetItem',
        u'PartialSuccessIndicator',
        u'PLMN-Identity',
        u'Pre-emptionCapability',
        u'Pre-emptionVulnerability',
        u'PriorityLevel',
        u'QCI',
        u'Registration-Request',
        u'ReportCharacteristics',
        u'ReportingPeriodicity',
        u'SSID',
        u'StationCount',
        u'TransportLayerAddress',
        u'TypeOfError',
        u'TimeToWait',
        u'UE-ContextKeptIndicator',
        u'UE-Identity',
        u'UE-XwAP-ID',
        u'WANMetrics',
        u'WLAN-Backhaul-Rate',
        u'WLANband',
        u'WLANBandInformationList',
        u'WLANBandInformation',
        u'WLANchannelnumber',
        u'WLANOperatingClass',
        u'WLANCountryCode',
        u'WLANIdentifier-List',
        u'WLANIdentifier-Item',
        u'WLANIdentifiersToDelete-List',
        u'WLANIdentifiersToDelete-Item',
        u'WLANIdentifiersToDeleteExtension-List',
        u'WLANIdentifiersToDeleteExtension-Item',
        u'WLANInformation',
        u'WLANSecurityInfo',
        u'WLANUsage',
        u'WT-MAC-Address',
        u'WTID',
        u'WTID-Type1',
        u'WTID-Long-Type2',
        ]
    _set_ = [
        u'AllocationAndRetentionPriority-ExtIEs',
        u'AvailableChUtilization-ExtIEs',
        u'BSSLoad-Item-ExtIEs',
        u'BSS-Item-ExtIEs',
        u'BSSMeasurementResult-ItemIEs',
        u'BSSMeasurementResult-Item-ExtIEs',
        u'BSSToReport-ItemIEs',
        u'BSSToReport-Item-ExtIEs',
        u'CompleteFailureCauseInformation-ItemIEs',
        u'CompleteFailureCauseInformation-Item-ExtIEs',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-Item-ExtIEs',
        u'ENBNeighbour-ItemIEs',
        u'ENBNeighbour-Item-ExtIEs',
        u'E-RAB-ItemIEs',
        u'E-RAB-Item-ExtIEs',
        u'E-RAB-QoS-Parameters-ExtIEs',
        u'GBR-QosInformation-ExtIEs',
        u'GlobalENB-ID-ExtIEs',
        u'GTPtunnelEndpoint-ExtIEs',
        u'LWIP-SeGWSecurityInfo-ExtIEs',
        u'MeasurementInitiationResult-ItemIEs',
        u'MeasurementInitiationResult-Item-ExtIEs',
        u'MeasurementFailureCause-ItemIEs',
        u'MeasurementFailureCause-Item-ExtIEs',
        u'MobilitySetItem-ExtIEs',
        u'OtherENB-IDIEs',
        u'WANMetrics-Item-ExtIEs',
        u'WLANBandInformation-ItemIEs',
        u'WLANIdentifier-ItemIEs',
        u'WLANIdentifier-Item-ExtIEs',
        u'WLANIdentifiersToDelete-ItemIEs',
        u'WLANIdentifiersToDelete-Item-ExtIEs',
        u'WLANIdentifiersToDeleteExtension-ItemIEs',
        u'WLANIdentifiersToDeleteExtension-Item-ExtIEs',
        u'WLANInformation-ExtIEs',
        u'WLANSecurityInfo-Item-ExtIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        u'AllocationAndRetentionPriority-ExtIEs',
        u'AvailableChUtilization-ExtIEs',
        u'BSSLoad-Item-ExtIEs',
        u'BSS-Item-ExtIEs',
        u'BSSMeasurementResult-ItemIEs',
        u'BSSMeasurementResult-Item-ExtIEs',
        u'BSSToReport-ItemIEs',
        u'BSSToReport-Item-ExtIEs',
        u'CompleteFailureCauseInformation-ItemIEs',
        u'CompleteFailureCauseInformation-Item-ExtIEs',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-Item-ExtIEs',
        u'ENBNeighbour-ItemIEs',
        u'ENBNeighbour-Item-ExtIEs',
        u'E-RAB-ItemIEs',
        u'E-RAB-Item-ExtIEs',
        u'E-RAB-QoS-Parameters-ExtIEs',
        u'GBR-QosInformation-ExtIEs',
        u'GlobalENB-ID-ExtIEs',
        u'GTPtunnelEndpoint-ExtIEs',
        u'LWIP-SeGWSecurityInfo-ExtIEs',
        u'MeasurementInitiationResult-ItemIEs',
        u'MeasurementInitiationResult-Item-ExtIEs',
        u'MeasurementFailureCause-ItemIEs',
        u'MeasurementFailureCause-Item-ExtIEs',
        u'MobilitySetItem-ExtIEs',
        u'OtherENB-IDIEs',
        u'WANMetrics-Item-ExtIEs',
        u'WLANBandInformation-ItemIEs',
        u'WLANIdentifier-ItemIEs',
        u'WLANIdentifier-Item-ExtIEs',
        u'WLANIdentifiersToDelete-ItemIEs',
        u'WLANIdentifiersToDelete-Item-ExtIEs',
        u'WLANIdentifiersToDeleteExtension-ItemIEs',
        u'WLANIdentifiersToDeleteExtension-Item-ExtIEs',
        u'WLANInformation-ExtIEs',
        u'WLANSecurityInfo-Item-ExtIEs',
        ]
    _param_ = [
        ]
    
    #-----< AllocationAndRetentionPriority >-----#
    AllocationAndRetentionPriority = SEQ(name=u'AllocationAndRetentionPriority', mode=MODE_TYPE)
    _AllocationAndRetentionPriority_priorityLevel = INT(name=u'priorityLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'PriorityLevel')))
    _AllocationAndRetentionPriority_pre_emptionCapability = ENUM(name=u'pre-emptionCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'Pre-emptionCapability')))
    _AllocationAndRetentionPriority_pre_emptionVulnerability = ENUM(name=u'pre-emptionVulnerability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'Pre-emptionVulnerability')))
    _AllocationAndRetentionPriority_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AllocationAndRetentionPriority_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___AllocationAndRetentionPriority_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_at = None
    ___AllocationAndRetentionPriority_iE_Extensions__item__id._const_tab_id = u'id'
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AllocationAndRetentionPriority_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab = ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AllocationAndRetentionPriority_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AllocationAndRetentionPriority_iE_Extensions__item__id),
        (u'criticality', ___AllocationAndRetentionPriority_iE_Extensions__item__criticality),
        (u'extensionValue', ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue),
        ])
    __AllocationAndRetentionPriority_iE_Extensions__item_._ext = None
    _AllocationAndRetentionPriority_iE_Extensions._cont = __AllocationAndRetentionPriority_iE_Extensions__item_
    _AllocationAndRetentionPriority_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AllocationAndRetentionPriority._cont = ASN1Dict([
        (u'priorityLevel', _AllocationAndRetentionPriority_priorityLevel),
        (u'pre-emptionCapability', _AllocationAndRetentionPriority_pre_emptionCapability),
        (u'pre-emptionVulnerability', _AllocationAndRetentionPriority_pre_emptionVulnerability),
        (u'iE-Extensions', _AllocationAndRetentionPriority_iE_Extensions),
        ])
    AllocationAndRetentionPriority._ext = []
    
    #-----< AllocationAndRetentionPriority-ExtIEs >-----#
    AllocationAndRetentionPriority_ExtIEs = CLASS(name=u'AllocationAndRetentionPriority-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    AllocationAndRetentionPriority_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AvailableChUtilization >-----#
    AvailableChUtilization = SEQ(name=u'AvailableChUtilization', mode=MODE_TYPE)
    _AvailableChUtilization_capacityValue = INT(name=u'capacityValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'CapacityValue')))
    _AvailableChUtilization_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AvailableChUtilization_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___AvailableChUtilization_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AvailableChUtilization_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____AvailableChUtilization_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AvailableChUtilization_iE_Extensions__item__id._const_tab = ____AvailableChUtilization_iE_Extensions__item__id_tab
    ___AvailableChUtilization_iE_Extensions__item__id._const_tab_at = None
    ___AvailableChUtilization_iE_Extensions__item__id._const_tab_id = u'id'
    ___AvailableChUtilization_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AvailableChUtilization_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____AvailableChUtilization_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AvailableChUtilization_iE_Extensions__item__criticality._const_tab = ____AvailableChUtilization_iE_Extensions__item__criticality_tab
    ___AvailableChUtilization_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AvailableChUtilization_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AvailableChUtilization_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AvailableChUtilization_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____AvailableChUtilization_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AvailableChUtilization_iE_Extensions__item__extensionValue._const_tab = ____AvailableChUtilization_iE_Extensions__item__extensionValue_tab
    ___AvailableChUtilization_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AvailableChUtilization_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AvailableChUtilization_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AvailableChUtilization_iE_Extensions__item__id),
        (u'criticality', ___AvailableChUtilization_iE_Extensions__item__criticality),
        (u'extensionValue', ___AvailableChUtilization_iE_Extensions__item__extensionValue),
        ])
    __AvailableChUtilization_iE_Extensions__item_._ext = None
    _AvailableChUtilization_iE_Extensions._cont = __AvailableChUtilization_iE_Extensions__item_
    _AvailableChUtilization_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AvailableChUtilization._cont = ASN1Dict([
        (u'capacityValue', _AvailableChUtilization_capacityValue),
        (u'iE-Extensions', _AvailableChUtilization_iE_Extensions),
        ])
    AvailableChUtilization._ext = []
    
    #-----< AvailableChUtilization-ExtIEs >-----#
    AvailableChUtilization_ExtIEs = CLASS(name=u'AvailableChUtilization-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    AvailableChUtilization_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BitRate >-----#
    BitRate = INT(name=u'BitRate', mode=MODE_TYPE)
    BitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10000000000)], ev=None, er=[])
    
    #-----< BSSID >-----#
    BSSID = OCT_STR(name=u'BSSID', mode=MODE_TYPE)
    BSSID._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< BSSLoad >-----#
    BSSLoad = SEQ(name=u'BSSLoad', mode=MODE_TYPE)
    _BSSLoad_channelUtilization = INT(name=u'channelUtilization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'ChannelUtilization')))
    _BSSLoad_stationCount = INT(name=u'stationCount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'StationCount')), opt=True)
    _BSSLoad_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BSSLoad_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___BSSLoad_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____BSSLoad_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____BSSLoad_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BSSLoad_iE_Extensions__item__id._const_tab = ____BSSLoad_iE_Extensions__item__id_tab
    ___BSSLoad_iE_Extensions__item__id._const_tab_at = None
    ___BSSLoad_iE_Extensions__item__id._const_tab_id = u'id'
    ___BSSLoad_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BSSLoad_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____BSSLoad_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BSSLoad_iE_Extensions__item__criticality._const_tab = ____BSSLoad_iE_Extensions__item__criticality_tab
    ___BSSLoad_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BSSLoad_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BSSLoad_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BSSLoad_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____BSSLoad_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BSSLoad_iE_Extensions__item__extensionValue._const_tab = ____BSSLoad_iE_Extensions__item__extensionValue_tab
    ___BSSLoad_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BSSLoad_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BSSLoad_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BSSLoad_iE_Extensions__item__id),
        (u'criticality', ___BSSLoad_iE_Extensions__item__criticality),
        (u'extensionValue', ___BSSLoad_iE_Extensions__item__extensionValue),
        ])
    __BSSLoad_iE_Extensions__item_._ext = None
    _BSSLoad_iE_Extensions._cont = __BSSLoad_iE_Extensions__item_
    _BSSLoad_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BSSLoad._cont = ASN1Dict([
        (u'channelUtilization', _BSSLoad_channelUtilization),
        (u'stationCount', _BSSLoad_stationCount),
        (u'iE-Extensions', _BSSLoad_iE_Extensions),
        ])
    BSSLoad._ext = []
    
    #-----< BSSLoad-Item-ExtIEs >-----#
    BSSLoad_Item_ExtIEs = CLASS(name=u'BSSLoad-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    BSSLoad_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BSS-Item >-----#
    BSS_Item = SEQ(name=u'BSS-Item', mode=MODE_TYPE)
    _BSS_Item_bSSID = OCT_STR(name=u'bSSID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'BSSID')))
    _BSS_Item_wLANOperatingClass = INT(name=u'wLANOperatingClass', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'WLANOperatingClass')), opt=True)
    _BSS_Item_wLANCountryCode = ENUM(name=u'wLANCountryCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'WLANCountryCode')), opt=True)
    _BSS_Item_maximumCapacity = INT(name=u'maximumCapacity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'BitRate')), opt=True)
    _BSS_Item_wLANBandInformationList = SEQ_OF(name=u'wLANBandInformationList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'WLANBandInformationList')), opt=True)
    _BSS_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BSS_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___BSS_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____BSS_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____BSS_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BSS_Item_iE_Extensions__item__id._const_tab = ____BSS_Item_iE_Extensions__item__id_tab
    ___BSS_Item_iE_Extensions__item__id._const_tab_at = None
    ___BSS_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___BSS_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BSS_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____BSS_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BSS_Item_iE_Extensions__item__criticality._const_tab = ____BSS_Item_iE_Extensions__item__criticality_tab
    ___BSS_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BSS_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BSS_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BSS_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____BSS_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BSS_Item_iE_Extensions__item__extensionValue._const_tab = ____BSS_Item_iE_Extensions__item__extensionValue_tab
    ___BSS_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BSS_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BSS_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BSS_Item_iE_Extensions__item__id),
        (u'criticality', ___BSS_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___BSS_Item_iE_Extensions__item__extensionValue),
        ])
    __BSS_Item_iE_Extensions__item_._ext = None
    _BSS_Item_iE_Extensions._cont = __BSS_Item_iE_Extensions__item_
    _BSS_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BSS_Item._cont = ASN1Dict([
        (u'bSSID', _BSS_Item_bSSID),
        (u'wLANOperatingClass', _BSS_Item_wLANOperatingClass),
        (u'wLANCountryCode', _BSS_Item_wLANCountryCode),
        (u'maximumCapacity', _BSS_Item_maximumCapacity),
        (u'wLANBandInformationList', _BSS_Item_wLANBandInformationList),
        (u'iE-Extensions', _BSS_Item_iE_Extensions),
        ])
    BSS_Item._ext = []
    
    #-----< BSS-Item-ExtIEs >-----#
    BSS_Item_ExtIEs = CLASS(name=u'BSS-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    BSS_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BSSMeasurementResult-List >-----#
    BSSMeasurementResult_List = SEQ_OF(name=u'BSSMeasurementResult-List', mode=MODE_TYPE)
    _BSSMeasurementResult_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __BSSMeasurementResult_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___BSSMeasurementResult_List__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____BSSMeasurementResult_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'BSSMeasurementResult-Item')))
    ___BSSMeasurementResult_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', ____BSSMeasurementResult_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __BSSMeasurementResult_List__item__id._const_tab = ___BSSMeasurementResult_List__item__id_tab
    __BSSMeasurementResult_List__item__id._const_tab_at = None
    __BSSMeasurementResult_List__item__id._const_tab_id = u'id'
    __BSSMeasurementResult_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __BSSMeasurementResult_List__item__criticality._const_tab = ___BSSMeasurementResult_List__item__id_tab
    __BSSMeasurementResult_List__item__criticality._const_tab_at = ('..', u'id')
    __BSSMeasurementResult_List__item__criticality._const_tab_id = u'criticality'
    __BSSMeasurementResult_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __BSSMeasurementResult_List__item__value._const_tab = ___BSSMeasurementResult_List__item__id_tab
    __BSSMeasurementResult_List__item__value._const_tab_at = ('..', u'id')
    __BSSMeasurementResult_List__item__value._const_tab_id = u'Value'
    _BSSMeasurementResult_List__item_._cont = ASN1Dict([
        (u'id', __BSSMeasurementResult_List__item__id),
        (u'criticality', __BSSMeasurementResult_List__item__criticality),
        (u'value', __BSSMeasurementResult_List__item__value),
        ])
    _BSSMeasurementResult_List__item_._ext = None
    BSSMeasurementResult_List._cont = _BSSMeasurementResult_List__item_
    BSSMeasurementResult_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    
    #-----< BSSMeasurementResult-ItemIEs >-----#
    BSSMeasurementResult_ItemIEs = CLASS(name=u'BSSMeasurementResult-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _BSSMeasurementResult_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'BSSMeasurementResult-Item')))
    BSSMeasurementResult_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 0), (u'criticality', u'ignore'), (u'Value', _BSSMeasurementResult_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< BSSMeasurementResult-Item >-----#
    BSSMeasurementResult_Item = SEQ(name=u'BSSMeasurementResult-Item', mode=MODE_TYPE)
    _BSSMeasurementResult_Item_bSSID = OCT_STR(name=u'bSSID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'BSSID')))
    _BSSMeasurementResult_Item_bSSLoad = SEQ(name=u'bSSLoad', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'BSSLoad')), opt=True)
    _BSSMeasurementResult_Item_wANMetrics = SEQ(name=u'wANMetrics', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'WANMetrics')), opt=True)
    _BSSMeasurementResult_Item_availableChUtilization = SEQ(name=u'availableChUtilization', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'AvailableChUtilization')), opt=True)
    _BSSMeasurementResult_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BSSMeasurementResult_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___BSSMeasurementResult_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____BSSMeasurementResult_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____BSSMeasurementResult_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BSSMeasurementResult_Item_iE_Extensions__item__id._const_tab = ____BSSMeasurementResult_Item_iE_Extensions__item__id_tab
    ___BSSMeasurementResult_Item_iE_Extensions__item__id._const_tab_at = None
    ___BSSMeasurementResult_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___BSSMeasurementResult_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BSSMeasurementResult_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____BSSMeasurementResult_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BSSMeasurementResult_Item_iE_Extensions__item__criticality._const_tab = ____BSSMeasurementResult_Item_iE_Extensions__item__criticality_tab
    ___BSSMeasurementResult_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BSSMeasurementResult_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BSSMeasurementResult_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BSSMeasurementResult_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____BSSMeasurementResult_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BSSMeasurementResult_Item_iE_Extensions__item__extensionValue._const_tab = ____BSSMeasurementResult_Item_iE_Extensions__item__extensionValue_tab
    ___BSSMeasurementResult_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BSSMeasurementResult_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BSSMeasurementResult_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BSSMeasurementResult_Item_iE_Extensions__item__id),
        (u'criticality', ___BSSMeasurementResult_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___BSSMeasurementResult_Item_iE_Extensions__item__extensionValue),
        ])
    __BSSMeasurementResult_Item_iE_Extensions__item_._ext = None
    _BSSMeasurementResult_Item_iE_Extensions._cont = __BSSMeasurementResult_Item_iE_Extensions__item_
    _BSSMeasurementResult_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BSSMeasurementResult_Item._cont = ASN1Dict([
        (u'bSSID', _BSSMeasurementResult_Item_bSSID),
        (u'bSSLoad', _BSSMeasurementResult_Item_bSSLoad),
        (u'wANMetrics', _BSSMeasurementResult_Item_wANMetrics),
        (u'availableChUtilization', _BSSMeasurementResult_Item_availableChUtilization),
        (u'iE-Extensions', _BSSMeasurementResult_Item_iE_Extensions),
        ])
    BSSMeasurementResult_Item._ext = []
    
    #-----< BSSMeasurementResult-Item-ExtIEs >-----#
    BSSMeasurementResult_Item_ExtIEs = CLASS(name=u'BSSMeasurementResult-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    BSSMeasurementResult_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BSSToReport-List >-----#
    BSSToReport_List = SEQ_OF(name=u'BSSToReport-List', mode=MODE_TYPE)
    _BSSToReport_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __BSSToReport_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___BSSToReport_List__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____BSSToReport_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'BSSToReport-Item')))
    ___BSSToReport_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', ____BSSToReport_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __BSSToReport_List__item__id._const_tab = ___BSSToReport_List__item__id_tab
    __BSSToReport_List__item__id._const_tab_at = None
    __BSSToReport_List__item__id._const_tab_id = u'id'
    __BSSToReport_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __BSSToReport_List__item__criticality._const_tab = ___BSSToReport_List__item__id_tab
    __BSSToReport_List__item__criticality._const_tab_at = ('..', u'id')
    __BSSToReport_List__item__criticality._const_tab_id = u'criticality'
    __BSSToReport_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __BSSToReport_List__item__value._const_tab = ___BSSToReport_List__item__id_tab
    __BSSToReport_List__item__value._const_tab_at = ('..', u'id')
    __BSSToReport_List__item__value._const_tab_id = u'Value'
    _BSSToReport_List__item_._cont = ASN1Dict([
        (u'id', __BSSToReport_List__item__id),
        (u'criticality', __BSSToReport_List__item__criticality),
        (u'value', __BSSToReport_List__item__value),
        ])
    _BSSToReport_List__item_._ext = None
    BSSToReport_List._cont = _BSSToReport_List__item_
    BSSToReport_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    
    #-----< BSSToReport-ItemIEs >-----#
    BSSToReport_ItemIEs = CLASS(name=u'BSSToReport-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _BSSToReport_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'BSSToReport-Item')))
    BSSToReport_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _BSSToReport_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< BSSToReport-Item >-----#
    BSSToReport_Item = SEQ(name=u'BSSToReport-Item', mode=MODE_TYPE)
    _BSSToReport_Item_bSSID = OCT_STR(name=u'bSSID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'BSSID')))
    _BSSToReport_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BSSToReport_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___BSSToReport_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____BSSToReport_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____BSSToReport_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BSSToReport_Item_iE_Extensions__item__id._const_tab = ____BSSToReport_Item_iE_Extensions__item__id_tab
    ___BSSToReport_Item_iE_Extensions__item__id._const_tab_at = None
    ___BSSToReport_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___BSSToReport_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BSSToReport_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____BSSToReport_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BSSToReport_Item_iE_Extensions__item__criticality._const_tab = ____BSSToReport_Item_iE_Extensions__item__criticality_tab
    ___BSSToReport_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BSSToReport_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BSSToReport_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BSSToReport_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____BSSToReport_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BSSToReport_Item_iE_Extensions__item__extensionValue._const_tab = ____BSSToReport_Item_iE_Extensions__item__extensionValue_tab
    ___BSSToReport_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BSSToReport_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BSSToReport_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BSSToReport_Item_iE_Extensions__item__id),
        (u'criticality', ___BSSToReport_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___BSSToReport_Item_iE_Extensions__item__extensionValue),
        ])
    __BSSToReport_Item_iE_Extensions__item_._ext = None
    _BSSToReport_Item_iE_Extensions._cont = __BSSToReport_Item_iE_Extensions__item_
    _BSSToReport_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BSSToReport_Item._cont = ASN1Dict([
        (u'bSSID', _BSSToReport_Item_bSSID),
        (u'iE-Extensions', _BSSToReport_Item_iE_Extensions),
        ])
    BSSToReport_Item._ext = []
    
    #-----< BSSToReport-Item-ExtIEs >-----#
    BSSToReport_Item_ExtIEs = CLASS(name=u'BSSToReport-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    BSSToReport_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CapacityValue >-----#
    CapacityValue = INT(name=u'CapacityValue', mode=MODE_TYPE)
    CapacityValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< Cause >-----#
    Cause = CHOICE(name=u'Cause', mode=MODE_TYPE)
    _Cause_radioNetwork = ENUM(name=u'radioNetwork', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'CauseRadioNetwork')))
    _Cause_transport = ENUM(name=u'transport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'CauseTransport')))
    _Cause_protocol = ENUM(name=u'protocol', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'CauseProtocol')))
    _Cause_misc = ENUM(name=u'misc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'CauseMisc')))
    Cause._cont = ASN1Dict([
        (u'radioNetwork', _Cause_radioNetwork),
        (u'transport', _Cause_transport),
        (u'protocol', _Cause_protocol),
        (u'misc', _Cause_misc),
        ])
    Cause._ext = []
    
    #-----< CauseMisc >-----#
    CauseMisc = ENUM(name=u'CauseMisc', mode=MODE_TYPE)
    CauseMisc._cont = ASN1Dict([(u'control-processing-overload', 0), (u'hardware-failure', 1), (u'om-intervention', 2), (u'not-enough-user-plane-processing-resources', 3), (u'unspecified', 4)])
    CauseMisc._ext = []
    
    #-----< CauseProtocol >-----#
    CauseProtocol = ENUM(name=u'CauseProtocol', mode=MODE_TYPE)
    CauseProtocol._cont = ASN1Dict([(u'transfer-syntax-error', 0), (u'abstract-syntax-error-reject', 1), (u'abstract-syntax-error-ignore-and-notify', 2), (u'message-not-compatible-with-receiver-state', 3), (u'semantic-error', 4), (u'unspecified', 5), (u'abstract-syntax-error-falsely-constructed-message', 6)])
    CauseProtocol._ext = []
    
    #-----< CauseRadioNetwork >-----#
    CauseRadioNetwork = ENUM(name=u'CauseRadioNetwork', mode=MODE_TYPE)
    CauseRadioNetwork._cont = ASN1Dict([(u'unknown-eNB-UE-XwAP-ID', 0), (u'unknown-WT-UE-XwAP-ID', 1), (u'unknown-pair-of-UE-XwAP-ID', 2), (u'wLAN-not-available', 3), (u'security-failure', 4), (u'reportCharacteristicsEmpty', 5), (u'existing-Measurement-ID', 6), (u'unknown-Measurement-ID', 7), (u'measurement-temporarily-not-available', 8), (u'unspecified', 9), (u'multiple-E-RAB-ID-instances', 10), (u'switch-off-ongoing', 11), (u'not-supported-QCI-value', 12), (u'measurement-not-supported-for-the-object', 13), (u'reduce-load', 14), (u'resource-optimisation', 15), (u'target-not-allowed', 16), (u'no-radio-resources-available', 17), (u'invalid-QoS-combination', 18), (u'procedure-cancelled', 19), (u'radio-connection-with-UE-lost', 20), (u'failure-in-the-radio-interface-procedure', 21), (u'no-report-periodicity', 22), (u'wrong-wlan-interworking-mode', 23)])
    CauseRadioNetwork._ext = [u'no-report-periodicity', u'wrong-wlan-interworking-mode']
    
    #-----< CauseTransport >-----#
    CauseTransport = ENUM(name=u'CauseTransport', mode=MODE_TYPE)
    CauseTransport._cont = ASN1Dict([(u'transport-resource-unavailable', 0), (u'unspecified', 1)])
    CauseTransport._ext = []
    
    #-----< ChannelUtilization >-----#
    ChannelUtilization = INT(name=u'ChannelUtilization', mode=MODE_TYPE)
    ChannelUtilization._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< CompleteFailureCauseInformation-List >-----#
    CompleteFailureCauseInformation_List = SEQ_OF(name=u'CompleteFailureCauseInformation-List', mode=MODE_TYPE)
    _CompleteFailureCauseInformation_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __CompleteFailureCauseInformation_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___CompleteFailureCauseInformation_List__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____CompleteFailureCauseInformation_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CompleteFailureCauseInformation-Item')))
    ___CompleteFailureCauseInformation_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', ____CompleteFailureCauseInformation_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __CompleteFailureCauseInformation_List__item__id._const_tab = ___CompleteFailureCauseInformation_List__item__id_tab
    __CompleteFailureCauseInformation_List__item__id._const_tab_at = None
    __CompleteFailureCauseInformation_List__item__id._const_tab_id = u'id'
    __CompleteFailureCauseInformation_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __CompleteFailureCauseInformation_List__item__criticality._const_tab = ___CompleteFailureCauseInformation_List__item__id_tab
    __CompleteFailureCauseInformation_List__item__criticality._const_tab_at = ('..', u'id')
    __CompleteFailureCauseInformation_List__item__criticality._const_tab_id = u'criticality'
    __CompleteFailureCauseInformation_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __CompleteFailureCauseInformation_List__item__value._const_tab = ___CompleteFailureCauseInformation_List__item__id_tab
    __CompleteFailureCauseInformation_List__item__value._const_tab_at = ('..', u'id')
    __CompleteFailureCauseInformation_List__item__value._const_tab_id = u'Value'
    _CompleteFailureCauseInformation_List__item_._cont = ASN1Dict([
        (u'id', __CompleteFailureCauseInformation_List__item__id),
        (u'criticality', __CompleteFailureCauseInformation_List__item__criticality),
        (u'value', __CompleteFailureCauseInformation_List__item__value),
        ])
    _CompleteFailureCauseInformation_List__item_._ext = None
    CompleteFailureCauseInformation_List._cont = _CompleteFailureCauseInformation_List__item_
    CompleteFailureCauseInformation_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    
    #-----< CompleteFailureCauseInformation-ItemIEs >-----#
    CompleteFailureCauseInformation_ItemIEs = CLASS(name=u'CompleteFailureCauseInformation-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _CompleteFailureCauseInformation_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CompleteFailureCauseInformation-Item')))
    CompleteFailureCauseInformation_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _CompleteFailureCauseInformation_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CompleteFailureCauseInformation-Item >-----#
    CompleteFailureCauseInformation_Item = SEQ(name=u'CompleteFailureCauseInformation-Item', mode=MODE_TYPE)
    _CompleteFailureCauseInformation_Item_bSSID = OCT_STR(name=u'bSSID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'BSSID')))
    _CompleteFailureCauseInformation_Item_measurementFailureCause_List = SEQ_OF(name=u'measurementFailureCause-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'MeasurementFailureCause-List')))
    _CompleteFailureCauseInformation_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompleteFailureCauseInformation_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CompleteFailureCauseInformation_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____CompleteFailureCauseInformation_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__id._const_tab = ____CompleteFailureCauseInformation_Item_iE_Extensions__item__id_tab
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__id._const_tab_at = None
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality._const_tab = ____CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality_tab
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue._const_tab = ____CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue_tab
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CompleteFailureCauseInformation_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CompleteFailureCauseInformation_Item_iE_Extensions__item__id),
        (u'criticality', ___CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue),
        ])
    __CompleteFailureCauseInformation_Item_iE_Extensions__item_._ext = None
    _CompleteFailureCauseInformation_Item_iE_Extensions._cont = __CompleteFailureCauseInformation_Item_iE_Extensions__item_
    _CompleteFailureCauseInformation_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompleteFailureCauseInformation_Item._cont = ASN1Dict([
        (u'bSSID', _CompleteFailureCauseInformation_Item_bSSID),
        (u'measurementFailureCause-List', _CompleteFailureCauseInformation_Item_measurementFailureCause_List),
        (u'iE-Extensions', _CompleteFailureCauseInformation_Item_iE_Extensions),
        ])
    CompleteFailureCauseInformation_Item._ext = []
    
    #-----< CompleteFailureCauseInformation-Item-ExtIEs >-----#
    CompleteFailureCauseInformation_Item_ExtIEs = CLASS(name=u'CompleteFailureCauseInformation-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    CompleteFailureCauseInformation_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics >-----#
    CriticalityDiagnostics = SEQ(name=u'CriticalityDiagnostics', mode=MODE_TYPE)
    _CriticalityDiagnostics_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProcedureCode')), opt=True)
    _CriticalityDiagnostics_triggeringMessage = ENUM(name=u'triggeringMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-CommonDataTypes', 'TriggeringMessage')), opt=True)
    _CriticalityDiagnostics_procedureCriticality = ENUM(name=u'procedureCriticality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-CommonDataTypes', 'Criticality')), opt=True)
    _CriticalityDiagnostics_iEsCriticalityDiagnostics = SEQ_OF(name=u'iEsCriticalityDiagnostics', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics-IE-List')), opt=True)
    _CriticalityDiagnostics_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_id = u'id'
    ___CriticalityDiagnostics_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CriticalityDiagnostics_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CriticalityDiagnostics_iE_Extensions__item__id),
        (u'criticality', ___CriticalityDiagnostics_iE_Extensions__item__criticality),
        (u'extensionValue', ___CriticalityDiagnostics_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_iE_Extensions._cont = __CriticalityDiagnostics_iE_Extensions__item_
    _CriticalityDiagnostics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics._cont = ASN1Dict([
        (u'procedureCode', _CriticalityDiagnostics_procedureCode),
        (u'triggeringMessage', _CriticalityDiagnostics_triggeringMessage),
        (u'procedureCriticality', _CriticalityDiagnostics_procedureCriticality),
        (u'iEsCriticalityDiagnostics', _CriticalityDiagnostics_iEsCriticalityDiagnostics),
        (u'iE-Extensions', _CriticalityDiagnostics_iE_Extensions),
        ])
    CriticalityDiagnostics._ext = []
    
    #-----< CriticalityDiagnostics-ExtIEs >-----#
    CriticalityDiagnostics_ExtIEs = CLASS(name=u'CriticalityDiagnostics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics-IE-List >-----#
    CriticalityDiagnostics_IE_List = SEQ_OF(name=u'CriticalityDiagnostics-IE-List', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics-IE-Item')))
    CriticalityDiagnostics_IE_List._cont = _CriticalityDiagnostics_IE_List__item_
    CriticalityDiagnostics_IE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CriticalityDiagnostics-IE-Item >-----#
    CriticalityDiagnostics_IE_Item = SEQ(name=u'CriticalityDiagnostics-IE-Item', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_Item_iECriticality = ENUM(name=u'iECriticality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-CommonDataTypes', 'Criticality')))
    _CriticalityDiagnostics_IE_Item_iE_ID = INT(name=u'iE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProtocolIE-ID')))
    _CriticalityDiagnostics_IE_Item_typeOfError = ENUM(name=u'typeOfError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'TypeOfError')))
    _CriticalityDiagnostics_IE_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_IE_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CriticalityDiagnostics_IE_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id),
        (u'criticality', ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_IE_Item_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_IE_Item_iE_Extensions._cont = __CriticalityDiagnostics_IE_Item_iE_Extensions__item_
    _CriticalityDiagnostics_IE_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics_IE_Item._cont = ASN1Dict([
        (u'iECriticality', _CriticalityDiagnostics_IE_Item_iECriticality),
        (u'iE-ID', _CriticalityDiagnostics_IE_Item_iE_ID),
        (u'typeOfError', _CriticalityDiagnostics_IE_Item_typeOfError),
        (u'iE-Extensions', _CriticalityDiagnostics_IE_Item_iE_Extensions),
        ])
    CriticalityDiagnostics_IE_Item._ext = []
    
    #-----< CriticalityDiagnostics-IE-Item-ExtIEs >-----#
    CriticalityDiagnostics_IE_Item_ExtIEs = CLASS(name=u'CriticalityDiagnostics-IE-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_IE_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRB-Identity >-----#
    DRB_Identity = INT(name=u'DRB-Identity', mode=MODE_TYPE)
    DRB_Identity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    
    #-----< ENB-ID >-----#
    ENB_ID = CHOICE(name=u'ENB-ID', mode=MODE_TYPE)
    _ENB_ID_macroENB_ID = BIT_STR(name=u'macroENB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_macroENB_ID._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _ENB_ID_otherENB_ID = SEQ(name=u'otherENB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __ENB_ID_otherENB_ID_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___ENB_ID_otherENB_ID_id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ___ENB_ID_otherENB_ID_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ENB_ID_otherENB_ID_id._const_tab = ___ENB_ID_otherENB_ID_id_tab
    __ENB_ID_otherENB_ID_id._const_tab_at = None
    __ENB_ID_otherENB_ID_id._const_tab_id = u'id'
    __ENB_ID_otherENB_ID_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___ENB_ID_otherENB_ID_criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ___ENB_ID_otherENB_ID_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ENB_ID_otherENB_ID_criticality._const_tab = ___ENB_ID_otherENB_ID_criticality_tab
    __ENB_ID_otherENB_ID_criticality._const_tab_at = ('..', u'id')
    __ENB_ID_otherENB_ID_criticality._const_tab_id = u'criticality'
    __ENB_ID_otherENB_ID_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___ENB_ID_otherENB_ID_value_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ___ENB_ID_otherENB_ID_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ENB_ID_otherENB_ID_value._const_tab = ___ENB_ID_otherENB_ID_value_tab
    __ENB_ID_otherENB_ID_value._const_tab_at = ('..', u'id')
    __ENB_ID_otherENB_ID_value._const_tab_id = u'Value'
    _ENB_ID_otherENB_ID._cont = ASN1Dict([
        (u'id', __ENB_ID_otherENB_ID_id),
        (u'criticality', __ENB_ID_otherENB_ID_criticality),
        (u'value', __ENB_ID_otherENB_ID_value),
        ])
    _ENB_ID_otherENB_ID._ext = None
    _ENB_ID_short_macroENB_ID = BIT_STR(name=u'short-macroENB-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_short_macroENB_ID._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _ENB_ID_long_macroENB_ID = BIT_STR(name=u'long-macroENB-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_long_macroENB_ID._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    ENB_ID._cont = ASN1Dict([
        (u'macroENB-ID', _ENB_ID_macroENB_ID),
        (u'otherENB-ID', _ENB_ID_otherENB_ID),
        (u'short-macroENB-ID', _ENB_ID_short_macroENB_ID),
        (u'long-macroENB-ID', _ENB_ID_long_macroENB_ID),
        ])
    ENB_ID._ext = [u'short-macroENB-ID', u'long-macroENB-ID']
    
    #-----< ENBNeighbour-List >-----#
    ENBNeighbour_List = SEQ_OF(name=u'ENBNeighbour-List', mode=MODE_TYPE)
    _ENBNeighbour_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __ENBNeighbour_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___ENBNeighbour_List__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____ENBNeighbour_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'ENBNeighbour-Item')))
    ___ENBNeighbour_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 68), (u'criticality', u'ignore'), (u'Value', ____ENBNeighbour_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __ENBNeighbour_List__item__id._const_tab = ___ENBNeighbour_List__item__id_tab
    __ENBNeighbour_List__item__id._const_tab_at = None
    __ENBNeighbour_List__item__id._const_tab_id = u'id'
    __ENBNeighbour_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __ENBNeighbour_List__item__criticality._const_tab = ___ENBNeighbour_List__item__id_tab
    __ENBNeighbour_List__item__criticality._const_tab_at = ('..', u'id')
    __ENBNeighbour_List__item__criticality._const_tab_id = u'criticality'
    __ENBNeighbour_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __ENBNeighbour_List__item__value._const_tab = ___ENBNeighbour_List__item__id_tab
    __ENBNeighbour_List__item__value._const_tab_at = ('..', u'id')
    __ENBNeighbour_List__item__value._const_tab_id = u'Value'
    _ENBNeighbour_List__item_._cont = ASN1Dict([
        (u'id', __ENBNeighbour_List__item__id),
        (u'criticality', __ENBNeighbour_List__item__criticality),
        (u'value', __ENBNeighbour_List__item__value),
        ])
    _ENBNeighbour_List__item_._ext = None
    ENBNeighbour_List._cont = _ENBNeighbour_List__item_
    ENBNeighbour_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    
    #-----< ENBNeighbour-ItemIEs >-----#
    ENBNeighbour_ItemIEs = CLASS(name=u'ENBNeighbour-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _ENBNeighbour_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'ENBNeighbour-Item')))
    ENBNeighbour_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 68), (u'criticality', u'ignore'), (u'Value', _ENBNeighbour_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ENBNeighbour-Item >-----#
    ENBNeighbour_Item = SEQ(name=u'ENBNeighbour-Item', mode=MODE_TYPE)
    _ENBNeighbour_Item_glogal_eNB_ID = SEQ(name=u'glogal-eNB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'Global-ENB-ID')))
    _ENBNeighbour_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ENBNeighbour_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___ENBNeighbour_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ENBNeighbour_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____ENBNeighbour_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ENBNeighbour_Item_iE_Extensions__item__id._const_tab = ____ENBNeighbour_Item_iE_Extensions__item__id_tab
    ___ENBNeighbour_Item_iE_Extensions__item__id._const_tab_at = None
    ___ENBNeighbour_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___ENBNeighbour_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ENBNeighbour_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____ENBNeighbour_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ENBNeighbour_Item_iE_Extensions__item__criticality._const_tab = ____ENBNeighbour_Item_iE_Extensions__item__criticality_tab
    ___ENBNeighbour_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ENBNeighbour_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ENBNeighbour_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ENBNeighbour_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____ENBNeighbour_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ENBNeighbour_Item_iE_Extensions__item__extensionValue._const_tab = ____ENBNeighbour_Item_iE_Extensions__item__extensionValue_tab
    ___ENBNeighbour_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ENBNeighbour_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ENBNeighbour_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ENBNeighbour_Item_iE_Extensions__item__id),
        (u'criticality', ___ENBNeighbour_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___ENBNeighbour_Item_iE_Extensions__item__extensionValue),
        ])
    __ENBNeighbour_Item_iE_Extensions__item_._ext = None
    _ENBNeighbour_Item_iE_Extensions._cont = __ENBNeighbour_Item_iE_Extensions__item_
    _ENBNeighbour_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ENBNeighbour_Item._cont = ASN1Dict([
        (u'glogal-eNB-ID', _ENBNeighbour_Item_glogal_eNB_ID),
        (u'iE-Extensions', _ENBNeighbour_Item_iE_Extensions),
        ])
    ENBNeighbour_Item._ext = []
    
    #-----< ENBNeighbour-Item-ExtIEs >-----#
    ENBNeighbour_Item_ExtIEs = CLASS(name=u'ENBNeighbour-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ENBNeighbour_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RAB-ID >-----#
    E_RAB_ID = INT(name=u'E-RAB-ID', mode=MODE_TYPE)
    E_RAB_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    
    #-----< E-RAB-List >-----#
    E_RAB_List = SEQ_OF(name=u'E-RAB-List', mode=MODE_TYPE)
    _E_RAB_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RAB_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___E_RAB_List__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____E_RAB_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-Item')))
    ___E_RAB_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 35), (u'criticality', u'ignore'), (u'Value', ____E_RAB_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RAB_List__item__id._const_tab = ___E_RAB_List__item__id_tab
    __E_RAB_List__item__id._const_tab_at = None
    __E_RAB_List__item__id._const_tab_id = u'id'
    __E_RAB_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __E_RAB_List__item__criticality._const_tab = ___E_RAB_List__item__id_tab
    __E_RAB_List__item__criticality._const_tab_at = ('..', u'id')
    __E_RAB_List__item__criticality._const_tab_id = u'criticality'
    __E_RAB_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __E_RAB_List__item__value._const_tab = ___E_RAB_List__item__id_tab
    __E_RAB_List__item__value._const_tab_at = ('..', u'id')
    __E_RAB_List__item__value._const_tab_id = u'Value'
    _E_RAB_List__item_._cont = ASN1Dict([
        (u'id', __E_RAB_List__item__id),
        (u'criticality', __E_RAB_List__item__criticality),
        (u'value', __E_RAB_List__item__value),
        ])
    _E_RAB_List__item_._ext = None
    E_RAB_List._cont = _E_RAB_List__item_
    E_RAB_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RAB-ItemIEs >-----#
    E_RAB_ItemIEs = CLASS(name=u'E-RAB-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _E_RAB_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-Item')))
    E_RAB_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 35), (u'criticality', u'ignore'), (u'Value', _E_RAB_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RAB-Item >-----#
    E_RAB_Item = SEQ(name=u'E-RAB-Item', mode=MODE_TYPE)
    _E_RAB_Item_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-ID')))
    _E_RAB_Item_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _E_RAB_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RAB_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___E_RAB_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RAB_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RAB_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RAB_Item_iE_Extensions__item__id._const_tab = ____E_RAB_Item_iE_Extensions__item__id_tab
    ___E_RAB_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RAB_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RAB_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RAB_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RAB_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RAB_Item_iE_Extensions__item__criticality._const_tab = ____E_RAB_Item_iE_Extensions__item__criticality_tab
    ___E_RAB_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RAB_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RAB_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RAB_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RAB_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RAB_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RAB_Item_iE_Extensions__item__extensionValue_tab
    ___E_RAB_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RAB_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RAB_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RAB_Item_iE_Extensions__item__id),
        (u'criticality', ___E_RAB_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RAB_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RAB_Item_iE_Extensions__item_._ext = None
    _E_RAB_Item_iE_Extensions._cont = __E_RAB_Item_iE_Extensions__item_
    _E_RAB_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RAB_Item._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RAB_Item_e_RAB_ID),
        (u'cause', _E_RAB_Item_cause),
        (u'iE-Extensions', _E_RAB_Item_iE_Extensions),
        ])
    E_RAB_Item._ext = []
    
    #-----< E-RAB-Item-ExtIEs >-----#
    E_RAB_Item_ExtIEs = CLASS(name=u'E-RAB-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    E_RAB_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RAB-QoS-Parameters >-----#
    E_RAB_QoS_Parameters = SEQ(name=u'E-RAB-QoS-Parameters', mode=MODE_TYPE)
    _E_RAB_QoS_Parameters_qCI = INT(name=u'qCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'QCI')))
    _E_RAB_QoS_Parameters_allocationRetentionPriority = SEQ(name=u'allocationRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'AllocationAndRetentionPriority')))
    _E_RAB_QoS_Parameters_gbrQosInformation = SEQ(name=u'gbrQosInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'GBR-QosInformation')), opt=True)
    _E_RAB_QoS_Parameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RAB_QoS_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___E_RAB_QoS_Parameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RAB_QoS_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RAB_QoS_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RAB_QoS_Parameters_iE_Extensions__item__id._const_tab = ____E_RAB_QoS_Parameters_iE_Extensions__item__id_tab
    ___E_RAB_QoS_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___E_RAB_QoS_Parameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RAB_QoS_Parameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RAB_QoS_Parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RAB_QoS_Parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RAB_QoS_Parameters_iE_Extensions__item__criticality._const_tab = ____E_RAB_QoS_Parameters_iE_Extensions__item__criticality_tab
    ___E_RAB_QoS_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RAB_QoS_Parameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RAB_QoS_Parameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RAB_QoS_Parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RAB_QoS_Parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RAB_QoS_Parameters_iE_Extensions__item__extensionValue._const_tab = ____E_RAB_QoS_Parameters_iE_Extensions__item__extensionValue_tab
    ___E_RAB_QoS_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RAB_QoS_Parameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RAB_QoS_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RAB_QoS_Parameters_iE_Extensions__item__id),
        (u'criticality', ___E_RAB_QoS_Parameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RAB_QoS_Parameters_iE_Extensions__item__extensionValue),
        ])
    __E_RAB_QoS_Parameters_iE_Extensions__item_._ext = None
    _E_RAB_QoS_Parameters_iE_Extensions._cont = __E_RAB_QoS_Parameters_iE_Extensions__item_
    _E_RAB_QoS_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RAB_QoS_Parameters._cont = ASN1Dict([
        (u'qCI', _E_RAB_QoS_Parameters_qCI),
        (u'allocationRetentionPriority', _E_RAB_QoS_Parameters_allocationRetentionPriority),
        (u'gbrQosInformation', _E_RAB_QoS_Parameters_gbrQosInformation),
        (u'iE-Extensions', _E_RAB_QoS_Parameters_iE_Extensions),
        ])
    E_RAB_QoS_Parameters._ext = []
    
    #-----< E-RAB-QoS-Parameters-ExtIEs >-----#
    E_RAB_QoS_Parameters_ExtIEs = CLASS(name=u'E-RAB-QoS-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    E_RAB_QoS_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GBR-QosInformation >-----#
    GBR_QosInformation = SEQ(name=u'GBR-QosInformation', mode=MODE_TYPE)
    _GBR_QosInformation_e_RAB_MaximumBitrateDL = INT(name=u'e-RAB-MaximumBitrateDL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'BitRate')))
    _GBR_QosInformation_e_RAB_GuaranteedBitrateDL = INT(name=u'e-RAB-GuaranteedBitrateDL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'BitRate')))
    _GBR_QosInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GBR_QosInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___GBR_QosInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GBR_QosInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____GBR_QosInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab = ____GBR_QosInformation_iE_Extensions__item__id_tab
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab_at = None
    ___GBR_QosInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___GBR_QosInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GBR_QosInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____GBR_QosInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab = ____GBR_QosInformation_iE_Extensions__item__criticality_tab
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GBR_QosInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GBR_QosInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GBR_QosInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____GBR_QosInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab = ____GBR_QosInformation_iE_Extensions__item__extensionValue_tab
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GBR_QosInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GBR_QosInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GBR_QosInformation_iE_Extensions__item__id),
        (u'criticality', ___GBR_QosInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___GBR_QosInformation_iE_Extensions__item__extensionValue),
        ])
    __GBR_QosInformation_iE_Extensions__item_._ext = None
    _GBR_QosInformation_iE_Extensions._cont = __GBR_QosInformation_iE_Extensions__item_
    _GBR_QosInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GBR_QosInformation._cont = ASN1Dict([
        (u'e-RAB-MaximumBitrateDL', _GBR_QosInformation_e_RAB_MaximumBitrateDL),
        (u'e-RAB-GuaranteedBitrateDL', _GBR_QosInformation_e_RAB_GuaranteedBitrateDL),
        (u'iE-Extensions', _GBR_QosInformation_iE_Extensions),
        ])
    GBR_QosInformation._ext = []
    
    #-----< GBR-QosInformation-ExtIEs >-----#
    GBR_QosInformation_ExtIEs = CLASS(name=u'GBR-QosInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    GBR_QosInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Global-ENB-ID >-----#
    Global_ENB_ID = SEQ(name=u'Global-ENB-ID', mode=MODE_TYPE)
    _Global_ENB_ID_pLMNidentity = OCT_STR(name=u'pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'PLMN-Identity')))
    _Global_ENB_ID_eNB_ID = CHOICE(name=u'eNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'ENB-ID')))
    _Global_ENB_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Global_ENB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___Global_ENB_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Global_ENB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____Global_ENB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Global_ENB_ID_iE_Extensions__item__id._const_tab = ____Global_ENB_ID_iE_Extensions__item__id_tab
    ___Global_ENB_ID_iE_Extensions__item__id._const_tab_at = None
    ___Global_ENB_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___Global_ENB_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Global_ENB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____Global_ENB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Global_ENB_ID_iE_Extensions__item__criticality._const_tab = ____Global_ENB_ID_iE_Extensions__item__criticality_tab
    ___Global_ENB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Global_ENB_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Global_ENB_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Global_ENB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____Global_ENB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Global_ENB_ID_iE_Extensions__item__extensionValue._const_tab = ____Global_ENB_ID_iE_Extensions__item__extensionValue_tab
    ___Global_ENB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Global_ENB_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Global_ENB_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Global_ENB_ID_iE_Extensions__item__id),
        (u'criticality', ___Global_ENB_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___Global_ENB_ID_iE_Extensions__item__extensionValue),
        ])
    __Global_ENB_ID_iE_Extensions__item_._ext = None
    _Global_ENB_ID_iE_Extensions._cont = __Global_ENB_ID_iE_Extensions__item_
    _Global_ENB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Global_ENB_ID._cont = ASN1Dict([
        (u'pLMNidentity', _Global_ENB_ID_pLMNidentity),
        (u'eNB-ID', _Global_ENB_ID_eNB_ID),
        (u'iE-Extensions', _Global_ENB_ID_iE_Extensions),
        ])
    Global_ENB_ID._ext = []
    
    #-----< GlobalENB-ID-ExtIEs >-----#
    GlobalENB_ID_ExtIEs = CLASS(name=u'GlobalENB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    GlobalENB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GTPtunnelEndpoint >-----#
    GTPtunnelEndpoint = SEQ(name=u'GTPtunnelEndpoint', mode=MODE_TYPE)
    _GTPtunnelEndpoint_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'TransportLayerAddress')))
    _GTPtunnelEndpoint_gTP_TEID = OCT_STR(name=u'gTP-TEID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'GTP-TEID')))
    _GTPtunnelEndpoint_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GTPtunnelEndpoint_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___GTPtunnelEndpoint_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GTPtunnelEndpoint_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____GTPtunnelEndpoint_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPtunnelEndpoint_iE_Extensions__item__id._const_tab = ____GTPtunnelEndpoint_iE_Extensions__item__id_tab
    ___GTPtunnelEndpoint_iE_Extensions__item__id._const_tab_at = None
    ___GTPtunnelEndpoint_iE_Extensions__item__id._const_tab_id = u'id'
    ___GTPtunnelEndpoint_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GTPtunnelEndpoint_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____GTPtunnelEndpoint_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPtunnelEndpoint_iE_Extensions__item__criticality._const_tab = ____GTPtunnelEndpoint_iE_Extensions__item__criticality_tab
    ___GTPtunnelEndpoint_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GTPtunnelEndpoint_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GTPtunnelEndpoint_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GTPtunnelEndpoint_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____GTPtunnelEndpoint_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GTPtunnelEndpoint_iE_Extensions__item__extensionValue._const_tab = ____GTPtunnelEndpoint_iE_Extensions__item__extensionValue_tab
    ___GTPtunnelEndpoint_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GTPtunnelEndpoint_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GTPtunnelEndpoint_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GTPtunnelEndpoint_iE_Extensions__item__id),
        (u'criticality', ___GTPtunnelEndpoint_iE_Extensions__item__criticality),
        (u'extensionValue', ___GTPtunnelEndpoint_iE_Extensions__item__extensionValue),
        ])
    __GTPtunnelEndpoint_iE_Extensions__item_._ext = None
    _GTPtunnelEndpoint_iE_Extensions._cont = __GTPtunnelEndpoint_iE_Extensions__item_
    _GTPtunnelEndpoint_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GTPtunnelEndpoint._cont = ASN1Dict([
        (u'transportLayerAddress', _GTPtunnelEndpoint_transportLayerAddress),
        (u'gTP-TEID', _GTPtunnelEndpoint_gTP_TEID),
        (u'iE-Extensions', _GTPtunnelEndpoint_iE_Extensions),
        ])
    GTPtunnelEndpoint._ext = []
    
    #-----< GTPtunnelEndpoint-ExtIEs >-----#
    GTPtunnelEndpoint_ExtIEs = CLASS(name=u'GTPtunnelEndpoint-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    GTPtunnelEndpoint_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GTP-TEID >-----#
    GTP_TEID = OCT_STR(name=u'GTP-TEID', mode=MODE_TYPE)
    GTP_TEID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< HESSID >-----#
    HESSID = OCT_STR(name=u'HESSID', mode=MODE_TYPE)
    HESSID._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< IKE-Initiator-Identity >-----#
    IKE_Initiator_Identity = OCT_STR(name=u'IKE-Initiator-Identity', mode=MODE_TYPE)
    
    #-----< LWA-WLAN-AC >-----#
    LWA_WLAN_AC = ENUM(name=u'LWA-WLAN-AC', mode=MODE_TYPE)
    LWA_WLAN_AC._cont = ASN1Dict([(u'ac-bk', 0), (u'ac-be', 1), (u'ac-vi', 2), (u'ac-vo', 3)])
    LWA_WLAN_AC._ext = []
    
    #-----< LWIP-SeGWSecurityInfo >-----#
    LWIP_SeGWSecurityInfo = SEQ(name=u'LWIP-SeGWSecurityInfo', mode=MODE_TYPE)
    _LWIP_SeGWSecurityInfo_lWIP_PSK = BIT_STR(name=u'lWIP-PSK', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'LWIP-PSK')))
    _LWIP_SeGWSecurityInfo_iKE_Initiator_Identity = OCT_STR(name=u'iKE-Initiator-Identity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'IKE-Initiator-Identity')))
    _LWIP_SeGWSecurityInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LWIP_SeGWSecurityInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___LWIP_SeGWSecurityInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LWIP_SeGWSecurityInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____LWIP_SeGWSecurityInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LWIP_SeGWSecurityInfo_iE_Extensions__item__id._const_tab = ____LWIP_SeGWSecurityInfo_iE_Extensions__item__id_tab
    ___LWIP_SeGWSecurityInfo_iE_Extensions__item__id._const_tab_at = None
    ___LWIP_SeGWSecurityInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___LWIP_SeGWSecurityInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LWIP_SeGWSecurityInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____LWIP_SeGWSecurityInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LWIP_SeGWSecurityInfo_iE_Extensions__item__criticality._const_tab = ____LWIP_SeGWSecurityInfo_iE_Extensions__item__criticality_tab
    ___LWIP_SeGWSecurityInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LWIP_SeGWSecurityInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LWIP_SeGWSecurityInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LWIP_SeGWSecurityInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____LWIP_SeGWSecurityInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LWIP_SeGWSecurityInfo_iE_Extensions__item__extensionValue._const_tab = ____LWIP_SeGWSecurityInfo_iE_Extensions__item__extensionValue_tab
    ___LWIP_SeGWSecurityInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LWIP_SeGWSecurityInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LWIP_SeGWSecurityInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LWIP_SeGWSecurityInfo_iE_Extensions__item__id),
        (u'criticality', ___LWIP_SeGWSecurityInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___LWIP_SeGWSecurityInfo_iE_Extensions__item__extensionValue),
        ])
    __LWIP_SeGWSecurityInfo_iE_Extensions__item_._ext = None
    _LWIP_SeGWSecurityInfo_iE_Extensions._cont = __LWIP_SeGWSecurityInfo_iE_Extensions__item_
    _LWIP_SeGWSecurityInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LWIP_SeGWSecurityInfo._cont = ASN1Dict([
        (u'lWIP-PSK', _LWIP_SeGWSecurityInfo_lWIP_PSK),
        (u'iKE-Initiator-Identity', _LWIP_SeGWSecurityInfo_iKE_Initiator_Identity),
        (u'iE-Extensions', _LWIP_SeGWSecurityInfo_iE_Extensions),
        ])
    LWIP_SeGWSecurityInfo._ext = []
    
    #-----< LWIP-SeGWSecurityInfo-ExtIEs >-----#
    LWIP_SeGWSecurityInfo_ExtIEs = CLASS(name=u'LWIP-SeGWSecurityInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    LWIP_SeGWSecurityInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LWIP-PSK >-----#
    LWIP_PSK = BIT_STR(name=u'LWIP-PSK', mode=MODE_TYPE)
    LWIP_PSK._const_sz = ASN1Set(rv=[256], rr=[], ev=None, er=[])
    
    #-----< Measurement-ID >-----#
    Measurement_ID = INT(name=u'Measurement-ID', mode=MODE_TYPE)
    Measurement_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4095)], ev=[], er=[])
    
    #-----< MeasurementInitiationResult-List >-----#
    MeasurementInitiationResult_List = SEQ_OF(name=u'MeasurementInitiationResult-List', mode=MODE_TYPE)
    _MeasurementInitiationResult_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __MeasurementInitiationResult_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___MeasurementInitiationResult_List__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____MeasurementInitiationResult_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'MeasurementInitiationResult-Item')))
    ___MeasurementInitiationResult_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', ____MeasurementInitiationResult_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __MeasurementInitiationResult_List__item__id._const_tab = ___MeasurementInitiationResult_List__item__id_tab
    __MeasurementInitiationResult_List__item__id._const_tab_at = None
    __MeasurementInitiationResult_List__item__id._const_tab_id = u'id'
    __MeasurementInitiationResult_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __MeasurementInitiationResult_List__item__criticality._const_tab = ___MeasurementInitiationResult_List__item__id_tab
    __MeasurementInitiationResult_List__item__criticality._const_tab_at = ('..', u'id')
    __MeasurementInitiationResult_List__item__criticality._const_tab_id = u'criticality'
    __MeasurementInitiationResult_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __MeasurementInitiationResult_List__item__value._const_tab = ___MeasurementInitiationResult_List__item__id_tab
    __MeasurementInitiationResult_List__item__value._const_tab_at = ('..', u'id')
    __MeasurementInitiationResult_List__item__value._const_tab_id = u'Value'
    _MeasurementInitiationResult_List__item_._cont = ASN1Dict([
        (u'id', __MeasurementInitiationResult_List__item__id),
        (u'criticality', __MeasurementInitiationResult_List__item__criticality),
        (u'value', __MeasurementInitiationResult_List__item__value),
        ])
    _MeasurementInitiationResult_List__item_._ext = None
    MeasurementInitiationResult_List._cont = _MeasurementInitiationResult_List__item_
    MeasurementInitiationResult_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    
    #-----< MeasurementInitiationResult-ItemIEs >-----#
    MeasurementInitiationResult_ItemIEs = CLASS(name=u'MeasurementInitiationResult-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _MeasurementInitiationResult_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'MeasurementInitiationResult-Item')))
    MeasurementInitiationResult_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _MeasurementInitiationResult_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< MeasurementInitiationResult-Item >-----#
    MeasurementInitiationResult_Item = SEQ(name=u'MeasurementInitiationResult-Item', mode=MODE_TYPE)
    _MeasurementInitiationResult_Item_bSSID = OCT_STR(name=u'bSSID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'BSSID')))
    _MeasurementInitiationResult_Item_measurementFailureCause_List = SEQ_OF(name=u'measurementFailureCause-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'MeasurementFailureCause-List')), opt=True)
    _MeasurementInitiationResult_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MeasurementInitiationResult_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___MeasurementInitiationResult_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MeasurementInitiationResult_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____MeasurementInitiationResult_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementInitiationResult_Item_iE_Extensions__item__id._const_tab = ____MeasurementInitiationResult_Item_iE_Extensions__item__id_tab
    ___MeasurementInitiationResult_Item_iE_Extensions__item__id._const_tab_at = None
    ___MeasurementInitiationResult_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___MeasurementInitiationResult_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MeasurementInitiationResult_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____MeasurementInitiationResult_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementInitiationResult_Item_iE_Extensions__item__criticality._const_tab = ____MeasurementInitiationResult_Item_iE_Extensions__item__criticality_tab
    ___MeasurementInitiationResult_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MeasurementInitiationResult_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue._const_tab = ____MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue_tab
    ___MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MeasurementInitiationResult_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MeasurementInitiationResult_Item_iE_Extensions__item__id),
        (u'criticality', ___MeasurementInitiationResult_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue),
        ])
    __MeasurementInitiationResult_Item_iE_Extensions__item_._ext = None
    _MeasurementInitiationResult_Item_iE_Extensions._cont = __MeasurementInitiationResult_Item_iE_Extensions__item_
    _MeasurementInitiationResult_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MeasurementInitiationResult_Item._cont = ASN1Dict([
        (u'bSSID', _MeasurementInitiationResult_Item_bSSID),
        (u'measurementFailureCause-List', _MeasurementInitiationResult_Item_measurementFailureCause_List),
        (u'iE-Extensions', _MeasurementInitiationResult_Item_iE_Extensions),
        ])
    MeasurementInitiationResult_Item._ext = []
    
    #-----< MeasurementInitiationResult-Item-ExtIEs >-----#
    MeasurementInitiationResult_Item_ExtIEs = CLASS(name=u'MeasurementInitiationResult-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    MeasurementInitiationResult_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MeasurementFailureCause-List >-----#
    MeasurementFailureCause_List = SEQ_OF(name=u'MeasurementFailureCause-List', mode=MODE_TYPE)
    _MeasurementFailureCause_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __MeasurementFailureCause_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___MeasurementFailureCause_List__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____MeasurementFailureCause_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'MeasurementFailureCause-Item')))
    ___MeasurementFailureCause_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', ____MeasurementFailureCause_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __MeasurementFailureCause_List__item__id._const_tab = ___MeasurementFailureCause_List__item__id_tab
    __MeasurementFailureCause_List__item__id._const_tab_at = None
    __MeasurementFailureCause_List__item__id._const_tab_id = u'id'
    __MeasurementFailureCause_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __MeasurementFailureCause_List__item__criticality._const_tab = ___MeasurementFailureCause_List__item__id_tab
    __MeasurementFailureCause_List__item__criticality._const_tab_at = ('..', u'id')
    __MeasurementFailureCause_List__item__criticality._const_tab_id = u'criticality'
    __MeasurementFailureCause_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __MeasurementFailureCause_List__item__value._const_tab = ___MeasurementFailureCause_List__item__id_tab
    __MeasurementFailureCause_List__item__value._const_tab_at = ('..', u'id')
    __MeasurementFailureCause_List__item__value._const_tab_id = u'Value'
    _MeasurementFailureCause_List__item_._cont = ASN1Dict([
        (u'id', __MeasurementFailureCause_List__item__id),
        (u'criticality', __MeasurementFailureCause_List__item__criticality),
        (u'value', __MeasurementFailureCause_List__item__value),
        ])
    _MeasurementFailureCause_List__item_._ext = None
    MeasurementFailureCause_List._cont = _MeasurementFailureCause_List__item_
    MeasurementFailureCause_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MeasurementFailureCause-ItemIEs >-----#
    MeasurementFailureCause_ItemIEs = CLASS(name=u'MeasurementFailureCause-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _MeasurementFailureCause_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'MeasurementFailureCause-Item')))
    MeasurementFailureCause_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _MeasurementFailureCause_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< MeasurementFailureCause-Item >-----#
    MeasurementFailureCause_Item = SEQ(name=u'MeasurementFailureCause-Item', mode=MODE_TYPE)
    _MeasurementFailureCause_Item_measurementFailedReportCharacteristics = BIT_STR(name=u'measurementFailedReportCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'ReportCharacteristics')))
    _MeasurementFailureCause_Item_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _MeasurementFailureCause_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MeasurementFailureCause_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___MeasurementFailureCause_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MeasurementFailureCause_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____MeasurementFailureCause_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementFailureCause_Item_iE_Extensions__item__id._const_tab = ____MeasurementFailureCause_Item_iE_Extensions__item__id_tab
    ___MeasurementFailureCause_Item_iE_Extensions__item__id._const_tab_at = None
    ___MeasurementFailureCause_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___MeasurementFailureCause_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MeasurementFailureCause_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____MeasurementFailureCause_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementFailureCause_Item_iE_Extensions__item__criticality._const_tab = ____MeasurementFailureCause_Item_iE_Extensions__item__criticality_tab
    ___MeasurementFailureCause_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MeasurementFailureCause_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MeasurementFailureCause_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MeasurementFailureCause_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____MeasurementFailureCause_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementFailureCause_Item_iE_Extensions__item__extensionValue._const_tab = ____MeasurementFailureCause_Item_iE_Extensions__item__extensionValue_tab
    ___MeasurementFailureCause_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MeasurementFailureCause_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MeasurementFailureCause_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MeasurementFailureCause_Item_iE_Extensions__item__id),
        (u'criticality', ___MeasurementFailureCause_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___MeasurementFailureCause_Item_iE_Extensions__item__extensionValue),
        ])
    __MeasurementFailureCause_Item_iE_Extensions__item_._ext = None
    _MeasurementFailureCause_Item_iE_Extensions._cont = __MeasurementFailureCause_Item_iE_Extensions__item_
    _MeasurementFailureCause_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MeasurementFailureCause_Item._cont = ASN1Dict([
        (u'measurementFailedReportCharacteristics', _MeasurementFailureCause_Item_measurementFailedReportCharacteristics),
        (u'cause', _MeasurementFailureCause_Item_cause),
        (u'iE-Extensions', _MeasurementFailureCause_Item_iE_Extensions),
        ])
    MeasurementFailureCause_Item._ext = []
    
    #-----< MeasurementFailureCause-Item-ExtIEs >-----#
    MeasurementFailureCause_Item_ExtIEs = CLASS(name=u'MeasurementFailureCause-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    MeasurementFailureCause_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MobilitySet >-----#
    MobilitySet = SEQ_OF(name=u'MobilitySet', mode=MODE_TYPE)
    _MobilitySet__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'MobilitySetItem')))
    MobilitySet._cont = _MobilitySet__item_
    MobilitySet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< MobilitySetItem >-----#
    MobilitySetItem = SEQ(name=u'MobilitySetItem', mode=MODE_TYPE)
    _MobilitySetItem_bSSID = OCT_STR(name=u'bSSID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'BSSID')), opt=True)
    _MobilitySetItem_sSID = OCT_STR(name=u'sSID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'SSID')), opt=True)
    _MobilitySetItem_hESSID = OCT_STR(name=u'hESSID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'HESSID')), opt=True)
    _MobilitySetItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MobilitySetItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___MobilitySetItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MobilitySetItem_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____MobilitySetItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MobilitySetItem_iE_Extensions__item__id._const_tab = ____MobilitySetItem_iE_Extensions__item__id_tab
    ___MobilitySetItem_iE_Extensions__item__id._const_tab_at = None
    ___MobilitySetItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___MobilitySetItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MobilitySetItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____MobilitySetItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MobilitySetItem_iE_Extensions__item__criticality._const_tab = ____MobilitySetItem_iE_Extensions__item__criticality_tab
    ___MobilitySetItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MobilitySetItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MobilitySetItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MobilitySetItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____MobilitySetItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MobilitySetItem_iE_Extensions__item__extensionValue._const_tab = ____MobilitySetItem_iE_Extensions__item__extensionValue_tab
    ___MobilitySetItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MobilitySetItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MobilitySetItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MobilitySetItem_iE_Extensions__item__id),
        (u'criticality', ___MobilitySetItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___MobilitySetItem_iE_Extensions__item__extensionValue),
        ])
    __MobilitySetItem_iE_Extensions__item_._ext = None
    _MobilitySetItem_iE_Extensions._cont = __MobilitySetItem_iE_Extensions__item_
    _MobilitySetItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MobilitySetItem._cont = ASN1Dict([
        (u'bSSID', _MobilitySetItem_bSSID),
        (u'sSID', _MobilitySetItem_sSID),
        (u'hESSID', _MobilitySetItem_hESSID),
        (u'iE-Extensions', _MobilitySetItem_iE_Extensions),
        ])
    MobilitySetItem._ext = []
    
    #-----< MobilitySetItem-ExtIEs >-----#
    MobilitySetItem_ExtIEs = CLASS(name=u'MobilitySetItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    MobilitySetItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< OtherENB-IDIEs >-----#
    OtherENB_IDIEs = CLASS(name=u'OtherENB-IDIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    OtherENB_IDIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PartialSuccessIndicator >-----#
    PartialSuccessIndicator = ENUM(name=u'PartialSuccessIndicator', mode=MODE_TYPE)
    PartialSuccessIndicator._cont = ASN1Dict([(u'partial-success-allowed', 0)])
    PartialSuccessIndicator._ext = []
    
    #-----< PLMN-Identity >-----#
    PLMN_Identity = OCT_STR(name=u'PLMN-Identity', mode=MODE_TYPE)
    PLMN_Identity._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< Pre-emptionCapability >-----#
    Pre_emptionCapability = ENUM(name=u'Pre-emptionCapability', mode=MODE_TYPE)
    Pre_emptionCapability._cont = ASN1Dict([(u'shall-not-trigger-pre-emption', 0), (u'may-trigger-pre-emption', 1)])
    Pre_emptionCapability._ext = None
    
    #-----< Pre-emptionVulnerability >-----#
    Pre_emptionVulnerability = ENUM(name=u'Pre-emptionVulnerability', mode=MODE_TYPE)
    Pre_emptionVulnerability._cont = ASN1Dict([(u'not-pre-emptable', 0), (u'pre-emptable', 1)])
    Pre_emptionVulnerability._ext = None
    
    #-----< PriorityLevel >-----#
    PriorityLevel = INT(name=u'PriorityLevel', mode=MODE_TYPE)
    PriorityLevel._cont = ASN1Dict([(u'spare', 0), (u'highest', 1), (u'lowest', 14), (u'no-priority', 15)])
    PriorityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< QCI >-----#
    QCI = INT(name=u'QCI', mode=MODE_TYPE)
    QCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< Registration-Request >-----#
    Registration_Request = ENUM(name=u'Registration-Request', mode=MODE_TYPE)
    Registration_Request._cont = ASN1Dict([(u'start', 0), (u'stop', 1)])
    Registration_Request._ext = []
    
    #-----< ReportCharacteristics >-----#
    ReportCharacteristics = BIT_STR(name=u'ReportCharacteristics', mode=MODE_TYPE)
    ReportCharacteristics._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< ReportingPeriodicity >-----#
    ReportingPeriodicity = ENUM(name=u'ReportingPeriodicity', mode=MODE_TYPE)
    ReportingPeriodicity._cont = ASN1Dict([(u'ms10', 0), (u'ms50', 1), (u'ms100', 2), (u'ms200', 3), (u'ms500', 4), (u's1', 5), (u's5', 6), (u's10', 7)])
    ReportingPeriodicity._ext = []
    
    #-----< SSID >-----#
    SSID = OCT_STR(name=u'SSID', mode=MODE_TYPE)
    SSID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< StationCount >-----#
    StationCount = INT(name=u'StationCount', mode=MODE_TYPE)
    StationCount._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TransportLayerAddress >-----#
    TransportLayerAddress = BIT_STR(name=u'TransportLayerAddress', mode=MODE_TYPE)
    TransportLayerAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=[], er=[])
    
    #-----< TypeOfError >-----#
    TypeOfError = ENUM(name=u'TypeOfError', mode=MODE_TYPE)
    TypeOfError._cont = ASN1Dict([(u'not-understood', 0), (u'missing', 1)])
    TypeOfError._ext = []
    
    #-----< TimeToWait >-----#
    TimeToWait = ENUM(name=u'TimeToWait', mode=MODE_TYPE)
    TimeToWait._cont = ASN1Dict([(u'v1s', 0), (u'v2s', 1), (u'v5s', 2), (u'v10s', 3), (u'v20s', 4), (u'v60s', 5)])
    TimeToWait._ext = []
    
    #-----< UE-ContextKeptIndicator >-----#
    UE_ContextKeptIndicator = ENUM(name=u'UE-ContextKeptIndicator', mode=MODE_TYPE)
    UE_ContextKeptIndicator._cont = ASN1Dict([(u'true', 0)])
    UE_ContextKeptIndicator._ext = []
    
    #-----< UE-Identity >-----#
    UE_Identity = OCT_STR(name=u'UE-Identity', mode=MODE_TYPE)
    UE_Identity._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< UE-XwAP-ID >-----#
    UE_XwAP_ID = OCT_STR(name=u'UE-XwAP-ID', mode=MODE_TYPE)
    UE_XwAP_ID._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< WANMetrics >-----#
    WANMetrics = SEQ(name=u'WANMetrics', mode=MODE_TYPE)
    _WANMetrics_wAN_Backhaul_Rate_DL = ENUM(name=u'wAN-Backhaul-Rate-DL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'WLAN-Backhaul-Rate')))
    _WANMetrics_wAN_Backhaul_Rate_UL = ENUM(name=u'wAN-Backhaul-Rate-UL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'WLAN-Backhaul-Rate')))
    _WANMetrics_wANBackhaulLoad_DL = INT(name=u'wANBackhaulLoad-DL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'ChannelUtilization')))
    _WANMetrics_wANBackhaulLoad_UL = INT(name=u'wANBackhaulLoad-UL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'ChannelUtilization')))
    _WANMetrics_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WANMetrics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___WANMetrics_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____WANMetrics_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____WANMetrics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WANMetrics_iE_Extensions__item__id._const_tab = ____WANMetrics_iE_Extensions__item__id_tab
    ___WANMetrics_iE_Extensions__item__id._const_tab_at = None
    ___WANMetrics_iE_Extensions__item__id._const_tab_id = u'id'
    ___WANMetrics_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____WANMetrics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____WANMetrics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WANMetrics_iE_Extensions__item__criticality._const_tab = ____WANMetrics_iE_Extensions__item__criticality_tab
    ___WANMetrics_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___WANMetrics_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___WANMetrics_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____WANMetrics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____WANMetrics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WANMetrics_iE_Extensions__item__extensionValue._const_tab = ____WANMetrics_iE_Extensions__item__extensionValue_tab
    ___WANMetrics_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___WANMetrics_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __WANMetrics_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___WANMetrics_iE_Extensions__item__id),
        (u'criticality', ___WANMetrics_iE_Extensions__item__criticality),
        (u'extensionValue', ___WANMetrics_iE_Extensions__item__extensionValue),
        ])
    __WANMetrics_iE_Extensions__item_._ext = None
    _WANMetrics_iE_Extensions._cont = __WANMetrics_iE_Extensions__item_
    _WANMetrics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WANMetrics._cont = ASN1Dict([
        (u'wAN-Backhaul-Rate-DL', _WANMetrics_wAN_Backhaul_Rate_DL),
        (u'wAN-Backhaul-Rate-UL', _WANMetrics_wAN_Backhaul_Rate_UL),
        (u'wANBackhaulLoad-DL', _WANMetrics_wANBackhaulLoad_DL),
        (u'wANBackhaulLoad-UL', _WANMetrics_wANBackhaulLoad_UL),
        (u'iE-Extensions', _WANMetrics_iE_Extensions),
        ])
    WANMetrics._ext = []
    
    #-----< WANMetrics-Item-ExtIEs >-----#
    WANMetrics_Item_ExtIEs = CLASS(name=u'WANMetrics-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    WANMetrics_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WLAN-Backhaul-Rate >-----#
    WLAN_Backhaul_Rate = ENUM(name=u'WLAN-Backhaul-Rate', mode=MODE_TYPE)
    WLAN_Backhaul_Rate._cont = ASN1Dict([(u'r0', 0), (u'r4', 1), (u'r8', 2), (u'r16', 3), (u'r32', 4), (u'r64', 5), (u'r128', 6), (u'r256', 7), (u'r512', 8), (u'r1024', 9), (u'r2048', 10), (u'r4096', 11), (u'r8192', 12), (u'r16384', 13), (u'r32768', 14), (u'r65536', 15), (u'r131072', 16), (u'r262144', 17), (u'r524288', 18), (u'r1048576', 19), (u'r2097152', 20), (u'r4194304', 21), (u'r8388608', 22), (u'r16777216', 23), (u'r33554432', 24), (u'r67108864', 25), (u'r134217728', 26), (u'r268435456', 27), (u'r536870912', 28), (u'r1073741824', 29), (u'r2147483648', 30), (u'r4294967296', 31)])
    WLAN_Backhaul_Rate._ext = None
    
    #-----< WLANband >-----#
    WLANband = ENUM(name=u'WLANband', mode=MODE_TYPE)
    WLANband._cont = ASN1Dict([(u'band2dot4', 0), (u'band5', 1), (u'band60', 2)])
    WLANband._ext = [u'band60']
    
    #-----< WLANBandInformationList >-----#
    WLANBandInformationList = SEQ_OF(name=u'WLANBandInformationList', mode=MODE_TYPE)
    _WLANBandInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __WLANBandInformationList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___WLANBandInformationList__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____WLANBandInformationList__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANBandInformation')))
    ___WLANBandInformationList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 60), (u'criticality', u'ignore'), (u'Value', ____WLANBandInformationList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __WLANBandInformationList__item__id._const_tab = ___WLANBandInformationList__item__id_tab
    __WLANBandInformationList__item__id._const_tab_at = None
    __WLANBandInformationList__item__id._const_tab_id = u'id'
    __WLANBandInformationList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __WLANBandInformationList__item__criticality._const_tab = ___WLANBandInformationList__item__id_tab
    __WLANBandInformationList__item__criticality._const_tab_at = ('..', u'id')
    __WLANBandInformationList__item__criticality._const_tab_id = u'criticality'
    __WLANBandInformationList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __WLANBandInformationList__item__value._const_tab = ___WLANBandInformationList__item__id_tab
    __WLANBandInformationList__item__value._const_tab_at = ('..', u'id')
    __WLANBandInformationList__item__value._const_tab_id = u'Value'
    _WLANBandInformationList__item_._cont = ASN1Dict([
        (u'id', __WLANBandInformationList__item__id),
        (u'criticality', __WLANBandInformationList__item__criticality),
        (u'value', __WLANBandInformationList__item__value),
        ])
    _WLANBandInformationList__item_._ext = None
    WLANBandInformationList._cont = _WLANBandInformationList__item_
    WLANBandInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< WLANBandInformation-ItemIEs >-----#
    WLANBandInformation_ItemIEs = CLASS(name=u'WLANBandInformation-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WLANBandInformation_ItemIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANBandInformation')))
    WLANBandInformation_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 60), (u'criticality', u'ignore'), (u'Value', _WLANBandInformation_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< WLANBandInformation >-----#
    WLANBandInformation = CHOICE(name=u'WLANBandInformation', mode=MODE_TYPE)
    _WLANBandInformation_band = ENUM(name=u'band', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'WLANband')))
    _WLANBandInformation_channelnumber = INT(name=u'channelnumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'WLANchannelnumber')))
    WLANBandInformation._cont = ASN1Dict([
        (u'band', _WLANBandInformation_band),
        (u'channelnumber', _WLANBandInformation_channelnumber),
        ])
    WLANBandInformation._ext = []
    
    #-----< WLANchannelnumber >-----#
    WLANchannelnumber = INT(name=u'WLANchannelnumber', mode=MODE_TYPE)
    WLANchannelnumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< WLANOperatingClass >-----#
    WLANOperatingClass = INT(name=u'WLANOperatingClass', mode=MODE_TYPE)
    WLANOperatingClass._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< WLANCountryCode >-----#
    WLANCountryCode = ENUM(name=u'WLANCountryCode', mode=MODE_TYPE)
    WLANCountryCode._cont = ASN1Dict([(u'unitedStates', 0), (u'europe', 1), (u'japan', 2), (u'global', 3)])
    WLANCountryCode._ext = []
    
    #-----< WLANIdentifier-List >-----#
    WLANIdentifier_List = SEQ_OF(name=u'WLANIdentifier-List', mode=MODE_TYPE)
    _WLANIdentifier_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __WLANIdentifier_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___WLANIdentifier_List__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____WLANIdentifier_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANIdentifier-Item')))
    ___WLANIdentifier_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', ____WLANIdentifier_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __WLANIdentifier_List__item__id._const_tab = ___WLANIdentifier_List__item__id_tab
    __WLANIdentifier_List__item__id._const_tab_at = None
    __WLANIdentifier_List__item__id._const_tab_id = u'id'
    __WLANIdentifier_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __WLANIdentifier_List__item__criticality._const_tab = ___WLANIdentifier_List__item__id_tab
    __WLANIdentifier_List__item__criticality._const_tab_at = ('..', u'id')
    __WLANIdentifier_List__item__criticality._const_tab_id = u'criticality'
    __WLANIdentifier_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __WLANIdentifier_List__item__value._const_tab = ___WLANIdentifier_List__item__id_tab
    __WLANIdentifier_List__item__value._const_tab_at = ('..', u'id')
    __WLANIdentifier_List__item__value._const_tab_id = u'Value'
    _WLANIdentifier_List__item_._cont = ASN1Dict([
        (u'id', __WLANIdentifier_List__item__id),
        (u'criticality', __WLANIdentifier_List__item__criticality),
        (u'value', __WLANIdentifier_List__item__value),
        ])
    _WLANIdentifier_List__item_._ext = None
    WLANIdentifier_List._cont = _WLANIdentifier_List__item_
    WLANIdentifier_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    
    #-----< WLANIdentifier-ItemIEs >-----#
    WLANIdentifier_ItemIEs = CLASS(name=u'WLANIdentifier-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WLANIdentifier_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANIdentifier-Item')))
    WLANIdentifier_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 17), (u'criticality', u'ignore'), (u'Value', _WLANIdentifier_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< WLANIdentifier-Item >-----#
    WLANIdentifier_Item = SEQ(name=u'WLANIdentifier-Item', mode=MODE_TYPE)
    _WLANIdentifier_Item_wLANInformation = SEQ(name=u'wLANInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'WLANInformation')))
    _WLANIdentifier_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WLANIdentifier_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___WLANIdentifier_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____WLANIdentifier_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____WLANIdentifier_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANIdentifier_Item_iE_Extensions__item__id._const_tab = ____WLANIdentifier_Item_iE_Extensions__item__id_tab
    ___WLANIdentifier_Item_iE_Extensions__item__id._const_tab_at = None
    ___WLANIdentifier_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___WLANIdentifier_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____WLANIdentifier_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____WLANIdentifier_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANIdentifier_Item_iE_Extensions__item__criticality._const_tab = ____WLANIdentifier_Item_iE_Extensions__item__criticality_tab
    ___WLANIdentifier_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___WLANIdentifier_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___WLANIdentifier_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____WLANIdentifier_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____WLANIdentifier_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANIdentifier_Item_iE_Extensions__item__extensionValue._const_tab = ____WLANIdentifier_Item_iE_Extensions__item__extensionValue_tab
    ___WLANIdentifier_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___WLANIdentifier_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __WLANIdentifier_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___WLANIdentifier_Item_iE_Extensions__item__id),
        (u'criticality', ___WLANIdentifier_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___WLANIdentifier_Item_iE_Extensions__item__extensionValue),
        ])
    __WLANIdentifier_Item_iE_Extensions__item_._ext = None
    _WLANIdentifier_Item_iE_Extensions._cont = __WLANIdentifier_Item_iE_Extensions__item_
    _WLANIdentifier_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WLANIdentifier_Item._cont = ASN1Dict([
        (u'wLANInformation', _WLANIdentifier_Item_wLANInformation),
        (u'iE-Extensions', _WLANIdentifier_Item_iE_Extensions),
        ])
    WLANIdentifier_Item._ext = []
    
    #-----< WLANIdentifier-Item-ExtIEs >-----#
    WLANIdentifier_Item_ExtIEs = CLASS(name=u'WLANIdentifier-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    WLANIdentifier_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WLANIdentifiersToDelete-List >-----#
    WLANIdentifiersToDelete_List = SEQ_OF(name=u'WLANIdentifiersToDelete-List', mode=MODE_TYPE)
    _WLANIdentifiersToDelete_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __WLANIdentifiersToDelete_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___WLANIdentifiersToDelete_List__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____WLANIdentifiersToDelete_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANIdentifiersToDelete-Item')))
    ___WLANIdentifiersToDelete_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', ____WLANIdentifiersToDelete_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __WLANIdentifiersToDelete_List__item__id._const_tab = ___WLANIdentifiersToDelete_List__item__id_tab
    __WLANIdentifiersToDelete_List__item__id._const_tab_at = None
    __WLANIdentifiersToDelete_List__item__id._const_tab_id = u'id'
    __WLANIdentifiersToDelete_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __WLANIdentifiersToDelete_List__item__criticality._const_tab = ___WLANIdentifiersToDelete_List__item__id_tab
    __WLANIdentifiersToDelete_List__item__criticality._const_tab_at = ('..', u'id')
    __WLANIdentifiersToDelete_List__item__criticality._const_tab_id = u'criticality'
    __WLANIdentifiersToDelete_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __WLANIdentifiersToDelete_List__item__value._const_tab = ___WLANIdentifiersToDelete_List__item__id_tab
    __WLANIdentifiersToDelete_List__item__value._const_tab_at = ('..', u'id')
    __WLANIdentifiersToDelete_List__item__value._const_tab_id = u'Value'
    _WLANIdentifiersToDelete_List__item_._cont = ASN1Dict([
        (u'id', __WLANIdentifiersToDelete_List__item__id),
        (u'criticality', __WLANIdentifiersToDelete_List__item__criticality),
        (u'value', __WLANIdentifiersToDelete_List__item__value),
        ])
    _WLANIdentifiersToDelete_List__item_._ext = None
    WLANIdentifiersToDelete_List._cont = _WLANIdentifiersToDelete_List__item_
    WLANIdentifiersToDelete_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    
    #-----< WLANIdentifiersToDelete-ItemIEs >-----#
    WLANIdentifiersToDelete_ItemIEs = CLASS(name=u'WLANIdentifiersToDelete-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WLANIdentifiersToDelete_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANIdentifiersToDelete-Item')))
    WLANIdentifiersToDelete_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _WLANIdentifiersToDelete_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< WLANIdentifiersToDelete-Item >-----#
    WLANIdentifiersToDelete_Item = SEQ(name=u'WLANIdentifiersToDelete-Item', mode=MODE_TYPE)
    _WLANIdentifiersToDelete_Item_bSSID = OCT_STR(name=u'bSSID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'BSSID')))
    _WLANIdentifiersToDelete_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WLANIdentifiersToDelete_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___WLANIdentifiersToDelete_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____WLANIdentifiersToDelete_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____WLANIdentifiersToDelete_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANIdentifiersToDelete_Item_iE_Extensions__item__id._const_tab = ____WLANIdentifiersToDelete_Item_iE_Extensions__item__id_tab
    ___WLANIdentifiersToDelete_Item_iE_Extensions__item__id._const_tab_at = None
    ___WLANIdentifiersToDelete_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___WLANIdentifiersToDelete_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____WLANIdentifiersToDelete_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____WLANIdentifiersToDelete_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANIdentifiersToDelete_Item_iE_Extensions__item__criticality._const_tab = ____WLANIdentifiersToDelete_Item_iE_Extensions__item__criticality_tab
    ___WLANIdentifiersToDelete_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___WLANIdentifiersToDelete_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___WLANIdentifiersToDelete_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____WLANIdentifiersToDelete_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____WLANIdentifiersToDelete_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANIdentifiersToDelete_Item_iE_Extensions__item__extensionValue._const_tab = ____WLANIdentifiersToDelete_Item_iE_Extensions__item__extensionValue_tab
    ___WLANIdentifiersToDelete_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___WLANIdentifiersToDelete_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __WLANIdentifiersToDelete_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___WLANIdentifiersToDelete_Item_iE_Extensions__item__id),
        (u'criticality', ___WLANIdentifiersToDelete_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___WLANIdentifiersToDelete_Item_iE_Extensions__item__extensionValue),
        ])
    __WLANIdentifiersToDelete_Item_iE_Extensions__item_._ext = None
    _WLANIdentifiersToDelete_Item_iE_Extensions._cont = __WLANIdentifiersToDelete_Item_iE_Extensions__item_
    _WLANIdentifiersToDelete_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WLANIdentifiersToDelete_Item._cont = ASN1Dict([
        (u'bSSID', _WLANIdentifiersToDelete_Item_bSSID),
        (u'iE-Extensions', _WLANIdentifiersToDelete_Item_iE_Extensions),
        ])
    WLANIdentifiersToDelete_Item._ext = []
    
    #-----< WLANIdentifiersToDelete-Item-ExtIEs >-----#
    WLANIdentifiersToDelete_Item_ExtIEs = CLASS(name=u'WLANIdentifiersToDelete-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    WLANIdentifiersToDelete_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WLANIdentifiersToDeleteExtension-List >-----#
    WLANIdentifiersToDeleteExtension_List = SEQ_OF(name=u'WLANIdentifiersToDeleteExtension-List', mode=MODE_TYPE)
    _WLANIdentifiersToDeleteExtension_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __WLANIdentifiersToDeleteExtension_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___WLANIdentifiersToDeleteExtension_List__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____WLANIdentifiersToDeleteExtension_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANIdentifiersToDeleteExtension-Item')))
    ___WLANIdentifiersToDeleteExtension_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 61), (u'criticality', u'ignore'), (u'Value', ____WLANIdentifiersToDeleteExtension_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __WLANIdentifiersToDeleteExtension_List__item__id._const_tab = ___WLANIdentifiersToDeleteExtension_List__item__id_tab
    __WLANIdentifiersToDeleteExtension_List__item__id._const_tab_at = None
    __WLANIdentifiersToDeleteExtension_List__item__id._const_tab_id = u'id'
    __WLANIdentifiersToDeleteExtension_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __WLANIdentifiersToDeleteExtension_List__item__criticality._const_tab = ___WLANIdentifiersToDeleteExtension_List__item__id_tab
    __WLANIdentifiersToDeleteExtension_List__item__criticality._const_tab_at = ('..', u'id')
    __WLANIdentifiersToDeleteExtension_List__item__criticality._const_tab_id = u'criticality'
    __WLANIdentifiersToDeleteExtension_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __WLANIdentifiersToDeleteExtension_List__item__value._const_tab = ___WLANIdentifiersToDeleteExtension_List__item__id_tab
    __WLANIdentifiersToDeleteExtension_List__item__value._const_tab_at = ('..', u'id')
    __WLANIdentifiersToDeleteExtension_List__item__value._const_tab_id = u'Value'
    _WLANIdentifiersToDeleteExtension_List__item_._cont = ASN1Dict([
        (u'id', __WLANIdentifiersToDeleteExtension_List__item__id),
        (u'criticality', __WLANIdentifiersToDeleteExtension_List__item__criticality),
        (u'value', __WLANIdentifiersToDeleteExtension_List__item__value),
        ])
    _WLANIdentifiersToDeleteExtension_List__item_._ext = None
    WLANIdentifiersToDeleteExtension_List._cont = _WLANIdentifiersToDeleteExtension_List__item_
    WLANIdentifiersToDeleteExtension_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    
    #-----< WLANIdentifiersToDeleteExtension-ItemIEs >-----#
    WLANIdentifiersToDeleteExtension_ItemIEs = CLASS(name=u'WLANIdentifiersToDeleteExtension-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WLANIdentifiersToDeleteExtension_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANIdentifiersToDeleteExtension-Item')))
    WLANIdentifiersToDeleteExtension_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 61), (u'criticality', u'ignore'), (u'Value', _WLANIdentifiersToDeleteExtension_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< WLANIdentifiersToDeleteExtension-Item >-----#
    WLANIdentifiersToDeleteExtension_Item = SEQ(name=u'WLANIdentifiersToDeleteExtension-Item', mode=MODE_TYPE)
    _WLANIdentifiersToDeleteExtension_Item_sSID = OCT_STR(name=u'sSID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'SSID')), opt=True)
    _WLANIdentifiersToDeleteExtension_Item_hESSID = OCT_STR(name=u'hESSID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'HESSID')), opt=True)
    _WLANIdentifiersToDeleteExtension_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__id._const_tab = ____WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__id_tab
    ___WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__id._const_tab_at = None
    ___WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__criticality._const_tab = ____WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__criticality_tab
    ___WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__extensionValue._const_tab = ____WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__extensionValue_tab
    ___WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__id),
        (u'criticality', ___WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__extensionValue),
        ])
    __WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item_._ext = None
    _WLANIdentifiersToDeleteExtension_Item_iE_Extensions._cont = __WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item_
    _WLANIdentifiersToDeleteExtension_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WLANIdentifiersToDeleteExtension_Item._cont = ASN1Dict([
        (u'sSID', _WLANIdentifiersToDeleteExtension_Item_sSID),
        (u'hESSID', _WLANIdentifiersToDeleteExtension_Item_hESSID),
        (u'iE-Extensions', _WLANIdentifiersToDeleteExtension_Item_iE_Extensions),
        ])
    WLANIdentifiersToDeleteExtension_Item._ext = []
    
    #-----< WLANIdentifiersToDeleteExtension-Item-ExtIEs >-----#
    WLANIdentifiersToDeleteExtension_Item_ExtIEs = CLASS(name=u'WLANIdentifiersToDeleteExtension-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    WLANIdentifiersToDeleteExtension_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WLANInformation >-----#
    WLANInformation = SEQ(name=u'WLANInformation', mode=MODE_TYPE)
    _WLANInformation_bSS_Item = SEQ(name=u'bSS-Item', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'BSS-Item')), opt=True)
    _WLANInformation_sSID = OCT_STR(name=u'sSID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'SSID')), opt=True)
    _WLANInformation_hESSID = OCT_STR(name=u'hESSID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'HESSID')), opt=True)
    _WLANInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WLANInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___WLANInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____WLANInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    _____WLANInformation_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANUsage')))
    ____WLANInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 72), (u'criticality', u'reject'), (u'Extension', _____WLANInformation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WLANInformation_iE_Extensions__item__id._const_tab = ____WLANInformation_iE_Extensions__item__id_tab
    ___WLANInformation_iE_Extensions__item__id._const_tab_at = None
    ___WLANInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___WLANInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___WLANInformation_iE_Extensions__item__criticality._const_tab = ____WLANInformation_iE_Extensions__item__id_tab
    ___WLANInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___WLANInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___WLANInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___WLANInformation_iE_Extensions__item__extensionValue._const_tab = ____WLANInformation_iE_Extensions__item__id_tab
    ___WLANInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___WLANInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __WLANInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___WLANInformation_iE_Extensions__item__id),
        (u'criticality', ___WLANInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___WLANInformation_iE_Extensions__item__extensionValue),
        ])
    __WLANInformation_iE_Extensions__item_._ext = None
    _WLANInformation_iE_Extensions._cont = __WLANInformation_iE_Extensions__item_
    _WLANInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WLANInformation._cont = ASN1Dict([
        (u'bSS-Item', _WLANInformation_bSS_Item),
        (u'sSID', _WLANInformation_sSID),
        (u'hESSID', _WLANInformation_hESSID),
        (u'iE-Extensions', _WLANInformation_iE_Extensions),
        ])
    WLANInformation._ext = []
    
    #-----< WLANInformation-ExtIEs >-----#
    WLANInformation_ExtIEs = CLASS(name=u'WLANInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    _WLANInformation_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANUsage')))
    WLANInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 72), (u'criticality', u'reject'), (u'Extension', _WLANInformation_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< WLANSecurityInfo >-----#
    WLANSecurityInfo = SEQ(name=u'WLANSecurityInfo', mode=MODE_TYPE)
    _WLANSecurityInfo_wT_Security_Key = BIT_STR(name=u'wT-Security-Key', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WLANSecurityInfo_wT_Security_Key._const_sz = ASN1Set(rv=[256], rr=[], ev=None, er=[])
    _WLANSecurityInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WLANSecurityInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___WLANSecurityInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____WLANSecurityInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____WLANSecurityInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANSecurityInfo_iE_Extensions__item__id._const_tab = ____WLANSecurityInfo_iE_Extensions__item__id_tab
    ___WLANSecurityInfo_iE_Extensions__item__id._const_tab_at = None
    ___WLANSecurityInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___WLANSecurityInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____WLANSecurityInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____WLANSecurityInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANSecurityInfo_iE_Extensions__item__criticality._const_tab = ____WLANSecurityInfo_iE_Extensions__item__criticality_tab
    ___WLANSecurityInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___WLANSecurityInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___WLANSecurityInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____WLANSecurityInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____WLANSecurityInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANSecurityInfo_iE_Extensions__item__extensionValue._const_tab = ____WLANSecurityInfo_iE_Extensions__item__extensionValue_tab
    ___WLANSecurityInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___WLANSecurityInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __WLANSecurityInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___WLANSecurityInfo_iE_Extensions__item__id),
        (u'criticality', ___WLANSecurityInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___WLANSecurityInfo_iE_Extensions__item__extensionValue),
        ])
    __WLANSecurityInfo_iE_Extensions__item_._ext = None
    _WLANSecurityInfo_iE_Extensions._cont = __WLANSecurityInfo_iE_Extensions__item_
    _WLANSecurityInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WLANSecurityInfo._cont = ASN1Dict([
        (u'wT-Security-Key', _WLANSecurityInfo_wT_Security_Key),
        (u'iE-Extensions', _WLANSecurityInfo_iE_Extensions),
        ])
    WLANSecurityInfo._ext = []
    
    #-----< WLANSecurityInfo-Item-ExtIEs >-----#
    WLANSecurityInfo_Item_ExtIEs = CLASS(name=u'WLANSecurityInfo-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    WLANSecurityInfo_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WLANUsage >-----#
    WLANUsage = ENUM(name=u'WLANUsage', mode=MODE_TYPE)
    WLANUsage._cont = ASN1Dict([(u'lWAandLWIP', 0), (u'lWIPonly', 1)])
    WLANUsage._ext = []
    
    #-----< WT-MAC-Address >-----#
    WT_MAC_Address = OCT_STR(name=u'WT-MAC-Address', mode=MODE_TYPE)
    WT_MAC_Address._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< WTID >-----#
    WTID = CHOICE(name=u'WTID', mode=MODE_TYPE)
    _WTID_wTID_Type1 = SEQ(name=u'wTID-Type1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'WTID-Type1')))
    _WTID_wTID_Type2 = BIT_STR(name=u'wTID-Type2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'WTID-Long-Type2')))
    WTID._cont = ASN1Dict([
        (u'wTID-Type1', _WTID_wTID_Type1),
        (u'wTID-Type2', _WTID_wTID_Type2),
        ])
    WTID._ext = []
    
    #-----< WTID-Type1 >-----#
    WTID_Type1 = SEQ(name=u'WTID-Type1', mode=MODE_TYPE)
    _WTID_Type1_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'PLMN-Identity')))
    _WTID_Type1_shortWTID = BIT_STR(name=u'shortWTID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WTID_Type1_shortWTID._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    WTID_Type1._cont = ASN1Dict([
        (u'pLMN-Identity', _WTID_Type1_pLMN_Identity),
        (u'shortWTID', _WTID_Type1_shortWTID),
        ])
    WTID_Type1._ext = []
    
    #-----< WTID-Long-Type2 >-----#
    WTID_Long_Type2 = BIT_STR(name=u'WTID-Long-Type2', mode=MODE_TYPE)
    WTID_Long_Type2._const_sz = ASN1Set(rv=[48], rr=[], ev=None, er=[])
    
    _all_ = [
        _AllocationAndRetentionPriority_priorityLevel,
        _AllocationAndRetentionPriority_pre_emptionCapability,
        _AllocationAndRetentionPriority_pre_emptionVulnerability,
        ____AllocationAndRetentionPriority_iE_Extensions__item__id_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__id,
        ____AllocationAndRetentionPriority_iE_Extensions__item__criticality_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__criticality,
        ____AllocationAndRetentionPriority_iE_Extensions__item__extensionValue_tab,
        ___AllocationAndRetentionPriority_iE_Extensions__item__extensionValue,
        __AllocationAndRetentionPriority_iE_Extensions__item_,
        _AllocationAndRetentionPriority_iE_Extensions,
        AllocationAndRetentionPriority,
        AllocationAndRetentionPriority_ExtIEs,
        _AvailableChUtilization_capacityValue,
        ____AvailableChUtilization_iE_Extensions__item__id_tab,
        ___AvailableChUtilization_iE_Extensions__item__id,
        ____AvailableChUtilization_iE_Extensions__item__criticality_tab,
        ___AvailableChUtilization_iE_Extensions__item__criticality,
        ____AvailableChUtilization_iE_Extensions__item__extensionValue_tab,
        ___AvailableChUtilization_iE_Extensions__item__extensionValue,
        __AvailableChUtilization_iE_Extensions__item_,
        _AvailableChUtilization_iE_Extensions,
        AvailableChUtilization,
        AvailableChUtilization_ExtIEs,
        BitRate,
        BSSID,
        _BSSLoad_channelUtilization,
        _BSSLoad_stationCount,
        ____BSSLoad_iE_Extensions__item__id_tab,
        ___BSSLoad_iE_Extensions__item__id,
        ____BSSLoad_iE_Extensions__item__criticality_tab,
        ___BSSLoad_iE_Extensions__item__criticality,
        ____BSSLoad_iE_Extensions__item__extensionValue_tab,
        ___BSSLoad_iE_Extensions__item__extensionValue,
        __BSSLoad_iE_Extensions__item_,
        _BSSLoad_iE_Extensions,
        BSSLoad,
        BSSLoad_Item_ExtIEs,
        _BSS_Item_bSSID,
        _BSS_Item_wLANOperatingClass,
        _BSS_Item_wLANCountryCode,
        _BSS_Item_maximumCapacity,
        _BSS_Item_wLANBandInformationList,
        ____BSS_Item_iE_Extensions__item__id_tab,
        ___BSS_Item_iE_Extensions__item__id,
        ____BSS_Item_iE_Extensions__item__criticality_tab,
        ___BSS_Item_iE_Extensions__item__criticality,
        ____BSS_Item_iE_Extensions__item__extensionValue_tab,
        ___BSS_Item_iE_Extensions__item__extensionValue,
        __BSS_Item_iE_Extensions__item_,
        _BSS_Item_iE_Extensions,
        BSS_Item,
        BSS_Item_ExtIEs,
        ___BSSMeasurementResult_List__item__id_tab,
        ____BSSMeasurementResult_List__item__id_tab_val_Value_0,
        __BSSMeasurementResult_List__item__id,
        __BSSMeasurementResult_List__item__criticality,
        __BSSMeasurementResult_List__item__value,
        _BSSMeasurementResult_List__item_,
        BSSMeasurementResult_List,
        BSSMeasurementResult_ItemIEs,
        _BSSMeasurementResult_ItemIEs_val_Value_0,
        _BSSMeasurementResult_Item_bSSID,
        _BSSMeasurementResult_Item_bSSLoad,
        _BSSMeasurementResult_Item_wANMetrics,
        _BSSMeasurementResult_Item_availableChUtilization,
        ____BSSMeasurementResult_Item_iE_Extensions__item__id_tab,
        ___BSSMeasurementResult_Item_iE_Extensions__item__id,
        ____BSSMeasurementResult_Item_iE_Extensions__item__criticality_tab,
        ___BSSMeasurementResult_Item_iE_Extensions__item__criticality,
        ____BSSMeasurementResult_Item_iE_Extensions__item__extensionValue_tab,
        ___BSSMeasurementResult_Item_iE_Extensions__item__extensionValue,
        __BSSMeasurementResult_Item_iE_Extensions__item_,
        _BSSMeasurementResult_Item_iE_Extensions,
        BSSMeasurementResult_Item,
        BSSMeasurementResult_Item_ExtIEs,
        ___BSSToReport_List__item__id_tab,
        ____BSSToReport_List__item__id_tab_val_Value_0,
        __BSSToReport_List__item__id,
        __BSSToReport_List__item__criticality,
        __BSSToReport_List__item__value,
        _BSSToReport_List__item_,
        BSSToReport_List,
        BSSToReport_ItemIEs,
        _BSSToReport_ItemIEs_val_Value_0,
        _BSSToReport_Item_bSSID,
        ____BSSToReport_Item_iE_Extensions__item__id_tab,
        ___BSSToReport_Item_iE_Extensions__item__id,
        ____BSSToReport_Item_iE_Extensions__item__criticality_tab,
        ___BSSToReport_Item_iE_Extensions__item__criticality,
        ____BSSToReport_Item_iE_Extensions__item__extensionValue_tab,
        ___BSSToReport_Item_iE_Extensions__item__extensionValue,
        __BSSToReport_Item_iE_Extensions__item_,
        _BSSToReport_Item_iE_Extensions,
        BSSToReport_Item,
        BSSToReport_Item_ExtIEs,
        CapacityValue,
        _Cause_radioNetwork,
        _Cause_transport,
        _Cause_protocol,
        _Cause_misc,
        Cause,
        CauseMisc,
        CauseProtocol,
        CauseRadioNetwork,
        CauseTransport,
        ChannelUtilization,
        ___CompleteFailureCauseInformation_List__item__id_tab,
        ____CompleteFailureCauseInformation_List__item__id_tab_val_Value_0,
        __CompleteFailureCauseInformation_List__item__id,
        __CompleteFailureCauseInformation_List__item__criticality,
        __CompleteFailureCauseInformation_List__item__value,
        _CompleteFailureCauseInformation_List__item_,
        CompleteFailureCauseInformation_List,
        CompleteFailureCauseInformation_ItemIEs,
        _CompleteFailureCauseInformation_ItemIEs_val_Value_0,
        _CompleteFailureCauseInformation_Item_bSSID,
        _CompleteFailureCauseInformation_Item_measurementFailureCause_List,
        ____CompleteFailureCauseInformation_Item_iE_Extensions__item__id_tab,
        ___CompleteFailureCauseInformation_Item_iE_Extensions__item__id,
        ____CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality_tab,
        ___CompleteFailureCauseInformation_Item_iE_Extensions__item__criticality,
        ____CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue_tab,
        ___CompleteFailureCauseInformation_Item_iE_Extensions__item__extensionValue,
        __CompleteFailureCauseInformation_Item_iE_Extensions__item_,
        _CompleteFailureCauseInformation_Item_iE_Extensions,
        CompleteFailureCauseInformation_Item,
        CompleteFailureCauseInformation_Item_ExtIEs,
        _CriticalityDiagnostics_procedureCode,
        _CriticalityDiagnostics_triggeringMessage,
        _CriticalityDiagnostics_procedureCriticality,
        _CriticalityDiagnostics_iEsCriticalityDiagnostics,
        ____CriticalityDiagnostics_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__id,
        ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_iE_Extensions__item_,
        _CriticalityDiagnostics_iE_Extensions,
        CriticalityDiagnostics,
        CriticalityDiagnostics_ExtIEs,
        _CriticalityDiagnostics_IE_List__item_,
        CriticalityDiagnostics_IE_List,
        _CriticalityDiagnostics_IE_Item_iECriticality,
        _CriticalityDiagnostics_IE_Item_iE_ID,
        _CriticalityDiagnostics_IE_Item_typeOfError,
        ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__id,
        ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_IE_Item_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_IE_Item_iE_Extensions__item_,
        _CriticalityDiagnostics_IE_Item_iE_Extensions,
        CriticalityDiagnostics_IE_Item,
        CriticalityDiagnostics_IE_Item_ExtIEs,
        DRB_Identity,
        _ENB_ID_macroENB_ID,
        ___ENB_ID_otherENB_ID_id_tab,
        __ENB_ID_otherENB_ID_id,
        ___ENB_ID_otherENB_ID_criticality_tab,
        __ENB_ID_otherENB_ID_criticality,
        ___ENB_ID_otherENB_ID_value_tab,
        __ENB_ID_otherENB_ID_value,
        _ENB_ID_otherENB_ID,
        _ENB_ID_short_macroENB_ID,
        _ENB_ID_long_macroENB_ID,
        ENB_ID,
        ___ENBNeighbour_List__item__id_tab,
        ____ENBNeighbour_List__item__id_tab_val_Value_0,
        __ENBNeighbour_List__item__id,
        __ENBNeighbour_List__item__criticality,
        __ENBNeighbour_List__item__value,
        _ENBNeighbour_List__item_,
        ENBNeighbour_List,
        ENBNeighbour_ItemIEs,
        _ENBNeighbour_ItemIEs_val_Value_0,
        _ENBNeighbour_Item_glogal_eNB_ID,
        ____ENBNeighbour_Item_iE_Extensions__item__id_tab,
        ___ENBNeighbour_Item_iE_Extensions__item__id,
        ____ENBNeighbour_Item_iE_Extensions__item__criticality_tab,
        ___ENBNeighbour_Item_iE_Extensions__item__criticality,
        ____ENBNeighbour_Item_iE_Extensions__item__extensionValue_tab,
        ___ENBNeighbour_Item_iE_Extensions__item__extensionValue,
        __ENBNeighbour_Item_iE_Extensions__item_,
        _ENBNeighbour_Item_iE_Extensions,
        ENBNeighbour_Item,
        ENBNeighbour_Item_ExtIEs,
        E_RAB_ID,
        ___E_RAB_List__item__id_tab,
        ____E_RAB_List__item__id_tab_val_Value_0,
        __E_RAB_List__item__id,
        __E_RAB_List__item__criticality,
        __E_RAB_List__item__value,
        _E_RAB_List__item_,
        E_RAB_List,
        E_RAB_ItemIEs,
        _E_RAB_ItemIEs_val_Value_0,
        _E_RAB_Item_e_RAB_ID,
        _E_RAB_Item_cause,
        ____E_RAB_Item_iE_Extensions__item__id_tab,
        ___E_RAB_Item_iE_Extensions__item__id,
        ____E_RAB_Item_iE_Extensions__item__criticality_tab,
        ___E_RAB_Item_iE_Extensions__item__criticality,
        ____E_RAB_Item_iE_Extensions__item__extensionValue_tab,
        ___E_RAB_Item_iE_Extensions__item__extensionValue,
        __E_RAB_Item_iE_Extensions__item_,
        _E_RAB_Item_iE_Extensions,
        E_RAB_Item,
        E_RAB_Item_ExtIEs,
        _E_RAB_QoS_Parameters_qCI,
        _E_RAB_QoS_Parameters_allocationRetentionPriority,
        _E_RAB_QoS_Parameters_gbrQosInformation,
        ____E_RAB_QoS_Parameters_iE_Extensions__item__id_tab,
        ___E_RAB_QoS_Parameters_iE_Extensions__item__id,
        ____E_RAB_QoS_Parameters_iE_Extensions__item__criticality_tab,
        ___E_RAB_QoS_Parameters_iE_Extensions__item__criticality,
        ____E_RAB_QoS_Parameters_iE_Extensions__item__extensionValue_tab,
        ___E_RAB_QoS_Parameters_iE_Extensions__item__extensionValue,
        __E_RAB_QoS_Parameters_iE_Extensions__item_,
        _E_RAB_QoS_Parameters_iE_Extensions,
        E_RAB_QoS_Parameters,
        E_RAB_QoS_Parameters_ExtIEs,
        _GBR_QosInformation_e_RAB_MaximumBitrateDL,
        _GBR_QosInformation_e_RAB_GuaranteedBitrateDL,
        ____GBR_QosInformation_iE_Extensions__item__id_tab,
        ___GBR_QosInformation_iE_Extensions__item__id,
        ____GBR_QosInformation_iE_Extensions__item__criticality_tab,
        ___GBR_QosInformation_iE_Extensions__item__criticality,
        ____GBR_QosInformation_iE_Extensions__item__extensionValue_tab,
        ___GBR_QosInformation_iE_Extensions__item__extensionValue,
        __GBR_QosInformation_iE_Extensions__item_,
        _GBR_QosInformation_iE_Extensions,
        GBR_QosInformation,
        GBR_QosInformation_ExtIEs,
        _Global_ENB_ID_pLMNidentity,
        _Global_ENB_ID_eNB_ID,
        ____Global_ENB_ID_iE_Extensions__item__id_tab,
        ___Global_ENB_ID_iE_Extensions__item__id,
        ____Global_ENB_ID_iE_Extensions__item__criticality_tab,
        ___Global_ENB_ID_iE_Extensions__item__criticality,
        ____Global_ENB_ID_iE_Extensions__item__extensionValue_tab,
        ___Global_ENB_ID_iE_Extensions__item__extensionValue,
        __Global_ENB_ID_iE_Extensions__item_,
        _Global_ENB_ID_iE_Extensions,
        Global_ENB_ID,
        GlobalENB_ID_ExtIEs,
        _GTPtunnelEndpoint_transportLayerAddress,
        _GTPtunnelEndpoint_gTP_TEID,
        ____GTPtunnelEndpoint_iE_Extensions__item__id_tab,
        ___GTPtunnelEndpoint_iE_Extensions__item__id,
        ____GTPtunnelEndpoint_iE_Extensions__item__criticality_tab,
        ___GTPtunnelEndpoint_iE_Extensions__item__criticality,
        ____GTPtunnelEndpoint_iE_Extensions__item__extensionValue_tab,
        ___GTPtunnelEndpoint_iE_Extensions__item__extensionValue,
        __GTPtunnelEndpoint_iE_Extensions__item_,
        _GTPtunnelEndpoint_iE_Extensions,
        GTPtunnelEndpoint,
        GTPtunnelEndpoint_ExtIEs,
        GTP_TEID,
        HESSID,
        IKE_Initiator_Identity,
        LWA_WLAN_AC,
        _LWIP_SeGWSecurityInfo_lWIP_PSK,
        _LWIP_SeGWSecurityInfo_iKE_Initiator_Identity,
        ____LWIP_SeGWSecurityInfo_iE_Extensions__item__id_tab,
        ___LWIP_SeGWSecurityInfo_iE_Extensions__item__id,
        ____LWIP_SeGWSecurityInfo_iE_Extensions__item__criticality_tab,
        ___LWIP_SeGWSecurityInfo_iE_Extensions__item__criticality,
        ____LWIP_SeGWSecurityInfo_iE_Extensions__item__extensionValue_tab,
        ___LWIP_SeGWSecurityInfo_iE_Extensions__item__extensionValue,
        __LWIP_SeGWSecurityInfo_iE_Extensions__item_,
        _LWIP_SeGWSecurityInfo_iE_Extensions,
        LWIP_SeGWSecurityInfo,
        LWIP_SeGWSecurityInfo_ExtIEs,
        LWIP_PSK,
        Measurement_ID,
        ___MeasurementInitiationResult_List__item__id_tab,
        ____MeasurementInitiationResult_List__item__id_tab_val_Value_0,
        __MeasurementInitiationResult_List__item__id,
        __MeasurementInitiationResult_List__item__criticality,
        __MeasurementInitiationResult_List__item__value,
        _MeasurementInitiationResult_List__item_,
        MeasurementInitiationResult_List,
        MeasurementInitiationResult_ItemIEs,
        _MeasurementInitiationResult_ItemIEs_val_Value_0,
        _MeasurementInitiationResult_Item_bSSID,
        _MeasurementInitiationResult_Item_measurementFailureCause_List,
        ____MeasurementInitiationResult_Item_iE_Extensions__item__id_tab,
        ___MeasurementInitiationResult_Item_iE_Extensions__item__id,
        ____MeasurementInitiationResult_Item_iE_Extensions__item__criticality_tab,
        ___MeasurementInitiationResult_Item_iE_Extensions__item__criticality,
        ____MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue_tab,
        ___MeasurementInitiationResult_Item_iE_Extensions__item__extensionValue,
        __MeasurementInitiationResult_Item_iE_Extensions__item_,
        _MeasurementInitiationResult_Item_iE_Extensions,
        MeasurementInitiationResult_Item,
        MeasurementInitiationResult_Item_ExtIEs,
        ___MeasurementFailureCause_List__item__id_tab,
        ____MeasurementFailureCause_List__item__id_tab_val_Value_0,
        __MeasurementFailureCause_List__item__id,
        __MeasurementFailureCause_List__item__criticality,
        __MeasurementFailureCause_List__item__value,
        _MeasurementFailureCause_List__item_,
        MeasurementFailureCause_List,
        MeasurementFailureCause_ItemIEs,
        _MeasurementFailureCause_ItemIEs_val_Value_0,
        _MeasurementFailureCause_Item_measurementFailedReportCharacteristics,
        _MeasurementFailureCause_Item_cause,
        ____MeasurementFailureCause_Item_iE_Extensions__item__id_tab,
        ___MeasurementFailureCause_Item_iE_Extensions__item__id,
        ____MeasurementFailureCause_Item_iE_Extensions__item__criticality_tab,
        ___MeasurementFailureCause_Item_iE_Extensions__item__criticality,
        ____MeasurementFailureCause_Item_iE_Extensions__item__extensionValue_tab,
        ___MeasurementFailureCause_Item_iE_Extensions__item__extensionValue,
        __MeasurementFailureCause_Item_iE_Extensions__item_,
        _MeasurementFailureCause_Item_iE_Extensions,
        MeasurementFailureCause_Item,
        MeasurementFailureCause_Item_ExtIEs,
        _MobilitySet__item_,
        MobilitySet,
        _MobilitySetItem_bSSID,
        _MobilitySetItem_sSID,
        _MobilitySetItem_hESSID,
        ____MobilitySetItem_iE_Extensions__item__id_tab,
        ___MobilitySetItem_iE_Extensions__item__id,
        ____MobilitySetItem_iE_Extensions__item__criticality_tab,
        ___MobilitySetItem_iE_Extensions__item__criticality,
        ____MobilitySetItem_iE_Extensions__item__extensionValue_tab,
        ___MobilitySetItem_iE_Extensions__item__extensionValue,
        __MobilitySetItem_iE_Extensions__item_,
        _MobilitySetItem_iE_Extensions,
        MobilitySetItem,
        MobilitySetItem_ExtIEs,
        OtherENB_IDIEs,
        PartialSuccessIndicator,
        PLMN_Identity,
        Pre_emptionCapability,
        Pre_emptionVulnerability,
        PriorityLevel,
        QCI,
        Registration_Request,
        ReportCharacteristics,
        ReportingPeriodicity,
        SSID,
        StationCount,
        TransportLayerAddress,
        TypeOfError,
        TimeToWait,
        UE_ContextKeptIndicator,
        UE_Identity,
        UE_XwAP_ID,
        _WANMetrics_wAN_Backhaul_Rate_DL,
        _WANMetrics_wAN_Backhaul_Rate_UL,
        _WANMetrics_wANBackhaulLoad_DL,
        _WANMetrics_wANBackhaulLoad_UL,
        ____WANMetrics_iE_Extensions__item__id_tab,
        ___WANMetrics_iE_Extensions__item__id,
        ____WANMetrics_iE_Extensions__item__criticality_tab,
        ___WANMetrics_iE_Extensions__item__criticality,
        ____WANMetrics_iE_Extensions__item__extensionValue_tab,
        ___WANMetrics_iE_Extensions__item__extensionValue,
        __WANMetrics_iE_Extensions__item_,
        _WANMetrics_iE_Extensions,
        WANMetrics,
        WANMetrics_Item_ExtIEs,
        WLAN_Backhaul_Rate,
        WLANband,
        ___WLANBandInformationList__item__id_tab,
        ____WLANBandInformationList__item__id_tab_val_Value_0,
        __WLANBandInformationList__item__id,
        __WLANBandInformationList__item__criticality,
        __WLANBandInformationList__item__value,
        _WLANBandInformationList__item_,
        WLANBandInformationList,
        WLANBandInformation_ItemIEs,
        _WLANBandInformation_ItemIEs_val_Value_0,
        _WLANBandInformation_band,
        _WLANBandInformation_channelnumber,
        WLANBandInformation,
        WLANchannelnumber,
        WLANOperatingClass,
        WLANCountryCode,
        ___WLANIdentifier_List__item__id_tab,
        ____WLANIdentifier_List__item__id_tab_val_Value_0,
        __WLANIdentifier_List__item__id,
        __WLANIdentifier_List__item__criticality,
        __WLANIdentifier_List__item__value,
        _WLANIdentifier_List__item_,
        WLANIdentifier_List,
        WLANIdentifier_ItemIEs,
        _WLANIdentifier_ItemIEs_val_Value_0,
        _WLANIdentifier_Item_wLANInformation,
        ____WLANIdentifier_Item_iE_Extensions__item__id_tab,
        ___WLANIdentifier_Item_iE_Extensions__item__id,
        ____WLANIdentifier_Item_iE_Extensions__item__criticality_tab,
        ___WLANIdentifier_Item_iE_Extensions__item__criticality,
        ____WLANIdentifier_Item_iE_Extensions__item__extensionValue_tab,
        ___WLANIdentifier_Item_iE_Extensions__item__extensionValue,
        __WLANIdentifier_Item_iE_Extensions__item_,
        _WLANIdentifier_Item_iE_Extensions,
        WLANIdentifier_Item,
        WLANIdentifier_Item_ExtIEs,
        ___WLANIdentifiersToDelete_List__item__id_tab,
        ____WLANIdentifiersToDelete_List__item__id_tab_val_Value_0,
        __WLANIdentifiersToDelete_List__item__id,
        __WLANIdentifiersToDelete_List__item__criticality,
        __WLANIdentifiersToDelete_List__item__value,
        _WLANIdentifiersToDelete_List__item_,
        WLANIdentifiersToDelete_List,
        WLANIdentifiersToDelete_ItemIEs,
        _WLANIdentifiersToDelete_ItemIEs_val_Value_0,
        _WLANIdentifiersToDelete_Item_bSSID,
        ____WLANIdentifiersToDelete_Item_iE_Extensions__item__id_tab,
        ___WLANIdentifiersToDelete_Item_iE_Extensions__item__id,
        ____WLANIdentifiersToDelete_Item_iE_Extensions__item__criticality_tab,
        ___WLANIdentifiersToDelete_Item_iE_Extensions__item__criticality,
        ____WLANIdentifiersToDelete_Item_iE_Extensions__item__extensionValue_tab,
        ___WLANIdentifiersToDelete_Item_iE_Extensions__item__extensionValue,
        __WLANIdentifiersToDelete_Item_iE_Extensions__item_,
        _WLANIdentifiersToDelete_Item_iE_Extensions,
        WLANIdentifiersToDelete_Item,
        WLANIdentifiersToDelete_Item_ExtIEs,
        ___WLANIdentifiersToDeleteExtension_List__item__id_tab,
        ____WLANIdentifiersToDeleteExtension_List__item__id_tab_val_Value_0,
        __WLANIdentifiersToDeleteExtension_List__item__id,
        __WLANIdentifiersToDeleteExtension_List__item__criticality,
        __WLANIdentifiersToDeleteExtension_List__item__value,
        _WLANIdentifiersToDeleteExtension_List__item_,
        WLANIdentifiersToDeleteExtension_List,
        WLANIdentifiersToDeleteExtension_ItemIEs,
        _WLANIdentifiersToDeleteExtension_ItemIEs_val_Value_0,
        _WLANIdentifiersToDeleteExtension_Item_sSID,
        _WLANIdentifiersToDeleteExtension_Item_hESSID,
        ____WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__id_tab,
        ___WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__id,
        ____WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__criticality_tab,
        ___WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__criticality,
        ____WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__extensionValue_tab,
        ___WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item__extensionValue,
        __WLANIdentifiersToDeleteExtension_Item_iE_Extensions__item_,
        _WLANIdentifiersToDeleteExtension_Item_iE_Extensions,
        WLANIdentifiersToDeleteExtension_Item,
        WLANIdentifiersToDeleteExtension_Item_ExtIEs,
        _WLANInformation_bSS_Item,
        _WLANInformation_sSID,
        _WLANInformation_hESSID,
        ____WLANInformation_iE_Extensions__item__id_tab,
        _____WLANInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___WLANInformation_iE_Extensions__item__id,
        ___WLANInformation_iE_Extensions__item__criticality,
        ___WLANInformation_iE_Extensions__item__extensionValue,
        __WLANInformation_iE_Extensions__item_,
        _WLANInformation_iE_Extensions,
        WLANInformation,
        WLANInformation_ExtIEs,
        _WLANInformation_ExtIEs_val_Extension_0,
        _WLANSecurityInfo_wT_Security_Key,
        ____WLANSecurityInfo_iE_Extensions__item__id_tab,
        ___WLANSecurityInfo_iE_Extensions__item__id,
        ____WLANSecurityInfo_iE_Extensions__item__criticality_tab,
        ___WLANSecurityInfo_iE_Extensions__item__criticality,
        ____WLANSecurityInfo_iE_Extensions__item__extensionValue_tab,
        ___WLANSecurityInfo_iE_Extensions__item__extensionValue,
        __WLANSecurityInfo_iE_Extensions__item_,
        _WLANSecurityInfo_iE_Extensions,
        WLANSecurityInfo,
        WLANSecurityInfo_Item_ExtIEs,
        WLANUsage,
        WT_MAC_Address,
        _WTID_wTID_Type1,
        _WTID_wTID_Type2,
        WTID,
        _WTID_Type1_pLMN_Identity,
        _WTID_Type1_shortWTID,
        WTID_Type1,
        WTID_Long_Type2,
    ]

class XwAP_PDU_Contents:

    _name_  = u'XwAP-PDU-Contents'
    _oid_   = [0, 4, 0, 0, 21, 3, 8, 1, 1]
    
    _obj_ = [
        u'XwSetupRequest',
        u'XwSetupRequestIEs',
        u'XwSetupResponse',
        u'XwSetupResponseIEs',
        u'XwSetupFailure',
        u'XwSetupFailureIEs',
        u'WTConfigurationUpdate',
        u'WTConfigurationUpdateIEs',
        u'WTConfigurationUpdateAcknowledge',
        u'WTConfigurationUpdateAcknowledgeIEs',
        u'WTConfigurationUpdateFailure',
        u'WTConfigurationUpdateFailureIEs',
        u'WTStatusRequest',
        u'WTStatusRequest-IEs',
        u'WTStatusResponse',
        u'WTStatusResponse-IEs',
        u'WTStatusFailure',
        u'WTStatusFailure-IEs',
        u'WTStatusReport',
        u'WTStatusReport-IEs',
        u'ErrorIndication',
        u'ErrorIndication-IEs',
        u'Reset',
        u'Reset-IEs',
        u'ResetResponse',
        u'ResetResponse-IEs',
        u'WTAdditionRequest',
        u'WTAdditionRequestIEs',
        u'E-RABs-ToBeAdded-List',
        u'E-RABs-ToBeAdded-ItemIEs',
        u'E-RABs-ToBeAdded-Item',
        u'E-RABs-ToBeAdded-ItemExtIEs',
        u'WTAdditionRequestAcknowledge',
        u'WTAdditionRequestAcknowledgeIEs',
        u'E-RABs-Admitted-ToBeAdded-List',
        u'E-RABs-Admitted-ToBeAdded-ItemIEs',
        u'E-RABs-Admitted-ToBeAdded-Item',
        u'E-RABs-Admitted-ToBeAdded-ItemExtIEs',
        u'WTAdditionRequestReject',
        u'WTAdditionRequestRejectIEs',
        u'WTModificationRequest',
        u'WTModificationRequestIEs',
        u'UE-ContextInformationWTModReq',
        u'UE-ContextInformationWTModReqExtIEs',
        u'E-RABs-ToBeAdded-List-ModReq',
        u'E-RABs-ToBeAdded-ModReqItemIEs',
        u'E-RABs-ToBeAdded-ModReqItem',
        u'E-RABs-ToBeAdded-ModReqItemExtIEs',
        u'E-RABs-ToBeModified-List-ModReq',
        u'E-RABs-ToBeModified-ModReqItemIEs',
        u'E-RABs-ToBeModified-ModReqItem',
        u'E-RABs-ToBeModified-ModReqItemExtIEs',
        u'E-RABs-ToBeReleased-List-ModReq',
        u'E-RABs-ToBeReleased-ModReqItemIEs',
        u'E-RABs-ToBeReleased-ModReqItem',
        u'E-RABs-ToBeReleased-ModReqItemExtIEs',
        u'WTModificationRequestAcknowledge',
        u'WTModificationRequestAcknowledgeIEs',
        u'E-RABs-Admitted-ToBeAdded-ModAckList',
        u'E-RABs-Admitted-ToBeAdded-ModAckItemIEs',
        u'E-RABs-Admitted-ToBeAdded-ModAckItem',
        u'E-RABs-Admitted-ToBeAdded-ModAckItemExtIEs',
        u'E-RABs-Admitted-ToBeModified-ModAckList',
        u'E-RABs-Admitted-ToBeModified-ModAckItemIEs',
        u'E-RABs-Admitted-ToBeModified-ModAckItem',
        u'E-RABs-Admitted-ToBeModified-ModAckItemExtIEs',
        u'E-RABs-Admitted-ToBeReleased-ModAckList',
        u'E-RABs-Admitted-ToBeReleased-ModAckItemIEs',
        u'E-RABs-Admitted-ToBeReleased-ModAckItem',
        u'E-RABs-Admitted-ToBeReleased-ModAckItemExtIEs',
        u'WTModificationRequestReject',
        u'WTModificationRequestRejectIEs',
        u'WTModificationRequired',
        u'WTModificationRequiredIEs',
        u'E-RABs-ToBeReleased-ModReqdList',
        u'E-RABs-ToBeReleased-ModReqdItemIEs',
        u'E-RABs-ToBeReleased-ModReqdItem',
        u'E-RABs-ToBeReleased-ModReqdItemExtIEs',
        u'E-RABs-ToBeModified-ModReqdList',
        u'E-RABs-ToBeModified-ModReqdItemIEs',
        u'E-RABs-ToBeModified-ModReqdItem',
        u'E-RABs-ToBeModified-ModReqdItemExtIEs',
        u'WTModificationConfirm',
        u'WTModificationConfirmIEs',
        u'E-RABs-Confirmed-ToBeReleased-ModReqdList',
        u'E-RABs-Confirmed-ToBeReleased-ModReqdItemIEs',
        u'E-RABs-Confirmed-ToBeReleased-ModReqdItem',
        u'E-RABs-Confirmed-ToBeReleased-ModReqdItemExtIEs',
        u'E-RABs-Confirmed-ToBeModified-ModReqdList',
        u'E-RABs-Confirmed-ToBeModified-ModReqdItemIEs',
        u'E-RABs-Confirmed-ToBeModified-ModReqdItem',
        u'E-RABs-Confirmed-ToBeModified-ModReqdItemExtIEs',
        u'WTModificationRefuse',
        u'WTModificationRefuseIEs',
        u'WTReleaseRequest',
        u'WTReleaseRequest-IEs',
        u'E-RABs-ToBeReleased-List-RelReq',
        u'E-RABs-ToBeReleased-RelReqItemIEs',
        u'E-RABs-ToBeReleased-RelReqItem',
        u'E-RABs-ToBeReleased-RelReqItemExtIEs',
        u'WTReleaseRequired',
        u'WTReleaseRequiredIEs',
        u'WTReleaseConfirm',
        u'WTReleaseConfirmIEs',
        u'E-RABs-ToBeReleased-List-RelConf',
        u'E-RABs-ToBeReleased-RelConfItemIEs',
        u'E-RABs-ToBeReleased-RelConfItem',
        u'E-RABs-ToBeReleased-RelConfItemExtIEs',
        u'WTAssociationConfirmation',
        u'WTAssociationConfirmationIEs',
        u'PrivateMessage',
        u'PrivateMessage-IEs',
        u'LWIPAdditionRequest',
        u'LWIPAdditionRequestIEs',
        u'LWIPAdditionRequestAcknowledge',
        u'LWIPAdditionRequestAcknowledgeIEs',
        u'LWIPAdditionRequestReject',
        u'LWIPAdditionRequestRejectIEs',
        u'LWIPModificationRequest',
        u'LWIPModificationRequestIEs',
        u'LWIPModificationRequestAcknowledge',
        u'LWIPModificationRequestAcknowledgeIEs',
        u'LWIPModificationRequestReject',
        u'LWIPModificationRequestRejectIEs',
        u'LWIPReleaseRequest',
        u'LWIPReleaseRequest-IEs',
        u'LWIPReleaseRequired',
        u'LWIPReleaseRequiredIEs',
        u'LWIPReleaseConfirm',
        u'LWIPReleaseConfirmIEs',
        ]
    _type_ = [
        u'XwSetupRequest',
        u'XwSetupResponse',
        u'XwSetupFailure',
        u'WTConfigurationUpdate',
        u'WTConfigurationUpdateAcknowledge',
        u'WTConfigurationUpdateFailure',
        u'WTStatusRequest',
        u'WTStatusResponse',
        u'WTStatusFailure',
        u'WTStatusReport',
        u'ErrorIndication',
        u'Reset',
        u'ResetResponse',
        u'WTAdditionRequest',
        u'E-RABs-ToBeAdded-List',
        u'E-RABs-ToBeAdded-Item',
        u'WTAdditionRequestAcknowledge',
        u'E-RABs-Admitted-ToBeAdded-List',
        u'E-RABs-Admitted-ToBeAdded-Item',
        u'WTAdditionRequestReject',
        u'WTModificationRequest',
        u'UE-ContextInformationWTModReq',
        u'E-RABs-ToBeAdded-List-ModReq',
        u'E-RABs-ToBeAdded-ModReqItem',
        u'E-RABs-ToBeModified-List-ModReq',
        u'E-RABs-ToBeModified-ModReqItem',
        u'E-RABs-ToBeReleased-List-ModReq',
        u'E-RABs-ToBeReleased-ModReqItem',
        u'WTModificationRequestAcknowledge',
        u'E-RABs-Admitted-ToBeAdded-ModAckList',
        u'E-RABs-Admitted-ToBeAdded-ModAckItem',
        u'E-RABs-Admitted-ToBeModified-ModAckList',
        u'E-RABs-Admitted-ToBeModified-ModAckItem',
        u'E-RABs-Admitted-ToBeReleased-ModAckList',
        u'E-RABs-Admitted-ToBeReleased-ModAckItem',
        u'WTModificationRequestReject',
        u'WTModificationRequired',
        u'E-RABs-ToBeReleased-ModReqdList',
        u'E-RABs-ToBeReleased-ModReqdItem',
        u'E-RABs-ToBeModified-ModReqdList',
        u'E-RABs-ToBeModified-ModReqdItem',
        u'WTModificationConfirm',
        u'E-RABs-Confirmed-ToBeReleased-ModReqdList',
        u'E-RABs-Confirmed-ToBeReleased-ModReqdItem',
        u'E-RABs-Confirmed-ToBeModified-ModReqdList',
        u'E-RABs-Confirmed-ToBeModified-ModReqdItem',
        u'WTModificationRefuse',
        u'WTReleaseRequest',
        u'E-RABs-ToBeReleased-List-RelReq',
        u'E-RABs-ToBeReleased-RelReqItem',
        u'WTReleaseRequired',
        u'WTReleaseConfirm',
        u'E-RABs-ToBeReleased-List-RelConf',
        u'E-RABs-ToBeReleased-RelConfItem',
        u'WTAssociationConfirmation',
        u'PrivateMessage',
        u'LWIPAdditionRequest',
        u'LWIPAdditionRequestAcknowledge',
        u'LWIPAdditionRequestReject',
        u'LWIPModificationRequest',
        u'LWIPModificationRequestAcknowledge',
        u'LWIPModificationRequestReject',
        u'LWIPReleaseRequest',
        u'LWIPReleaseRequired',
        u'LWIPReleaseConfirm',
        ]
    _set_ = [
        u'XwSetupRequestIEs',
        u'XwSetupResponseIEs',
        u'XwSetupFailureIEs',
        u'WTConfigurationUpdateIEs',
        u'WTConfigurationUpdateAcknowledgeIEs',
        u'WTConfigurationUpdateFailureIEs',
        u'WTStatusRequest-IEs',
        u'WTStatusResponse-IEs',
        u'WTStatusFailure-IEs',
        u'WTStatusReport-IEs',
        u'ErrorIndication-IEs',
        u'Reset-IEs',
        u'ResetResponse-IEs',
        u'WTAdditionRequestIEs',
        u'E-RABs-ToBeAdded-ItemIEs',
        u'E-RABs-ToBeAdded-ItemExtIEs',
        u'WTAdditionRequestAcknowledgeIEs',
        u'E-RABs-Admitted-ToBeAdded-ItemIEs',
        u'E-RABs-Admitted-ToBeAdded-ItemExtIEs',
        u'WTAdditionRequestRejectIEs',
        u'WTModificationRequestIEs',
        u'UE-ContextInformationWTModReqExtIEs',
        u'E-RABs-ToBeAdded-ModReqItemIEs',
        u'E-RABs-ToBeAdded-ModReqItemExtIEs',
        u'E-RABs-ToBeModified-ModReqItemIEs',
        u'E-RABs-ToBeModified-ModReqItemExtIEs',
        u'E-RABs-ToBeReleased-ModReqItemIEs',
        u'E-RABs-ToBeReleased-ModReqItemExtIEs',
        u'WTModificationRequestAcknowledgeIEs',
        u'E-RABs-Admitted-ToBeAdded-ModAckItemIEs',
        u'E-RABs-Admitted-ToBeAdded-ModAckItemExtIEs',
        u'E-RABs-Admitted-ToBeModified-ModAckItemIEs',
        u'E-RABs-Admitted-ToBeModified-ModAckItemExtIEs',
        u'E-RABs-Admitted-ToBeReleased-ModAckItemIEs',
        u'E-RABs-Admitted-ToBeReleased-ModAckItemExtIEs',
        u'WTModificationRequestRejectIEs',
        u'WTModificationRequiredIEs',
        u'E-RABs-ToBeReleased-ModReqdItemIEs',
        u'E-RABs-ToBeReleased-ModReqdItemExtIEs',
        u'E-RABs-ToBeModified-ModReqdItemIEs',
        u'E-RABs-ToBeModified-ModReqdItemExtIEs',
        u'WTModificationConfirmIEs',
        u'E-RABs-Confirmed-ToBeReleased-ModReqdItemIEs',
        u'E-RABs-Confirmed-ToBeReleased-ModReqdItemExtIEs',
        u'E-RABs-Confirmed-ToBeModified-ModReqdItemIEs',
        u'E-RABs-Confirmed-ToBeModified-ModReqdItemExtIEs',
        u'WTModificationRefuseIEs',
        u'WTReleaseRequest-IEs',
        u'E-RABs-ToBeReleased-RelReqItemIEs',
        u'E-RABs-ToBeReleased-RelReqItemExtIEs',
        u'WTReleaseRequiredIEs',
        u'WTReleaseConfirmIEs',
        u'E-RABs-ToBeReleased-RelConfItemIEs',
        u'E-RABs-ToBeReleased-RelConfItemExtIEs',
        u'WTAssociationConfirmationIEs',
        u'PrivateMessage-IEs',
        u'LWIPAdditionRequestIEs',
        u'LWIPAdditionRequestAcknowledgeIEs',
        u'LWIPAdditionRequestRejectIEs',
        u'LWIPModificationRequestIEs',
        u'LWIPModificationRequestAcknowledgeIEs',
        u'LWIPModificationRequestRejectIEs',
        u'LWIPReleaseRequest-IEs',
        u'LWIPReleaseRequiredIEs',
        u'LWIPReleaseConfirmIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        u'XwSetupRequestIEs',
        u'XwSetupResponseIEs',
        u'XwSetupFailureIEs',
        u'WTConfigurationUpdateIEs',
        u'WTConfigurationUpdateAcknowledgeIEs',
        u'WTConfigurationUpdateFailureIEs',
        u'WTStatusRequest-IEs',
        u'WTStatusResponse-IEs',
        u'WTStatusFailure-IEs',
        u'WTStatusReport-IEs',
        u'ErrorIndication-IEs',
        u'Reset-IEs',
        u'ResetResponse-IEs',
        u'WTAdditionRequestIEs',
        u'E-RABs-ToBeAdded-ItemIEs',
        u'E-RABs-ToBeAdded-ItemExtIEs',
        u'WTAdditionRequestAcknowledgeIEs',
        u'E-RABs-Admitted-ToBeAdded-ItemIEs',
        u'E-RABs-Admitted-ToBeAdded-ItemExtIEs',
        u'WTAdditionRequestRejectIEs',
        u'WTModificationRequestIEs',
        u'UE-ContextInformationWTModReqExtIEs',
        u'E-RABs-ToBeAdded-ModReqItemIEs',
        u'E-RABs-ToBeAdded-ModReqItemExtIEs',
        u'E-RABs-ToBeModified-ModReqItemIEs',
        u'E-RABs-ToBeModified-ModReqItemExtIEs',
        u'E-RABs-ToBeReleased-ModReqItemIEs',
        u'E-RABs-ToBeReleased-ModReqItemExtIEs',
        u'WTModificationRequestAcknowledgeIEs',
        u'E-RABs-Admitted-ToBeAdded-ModAckItemIEs',
        u'E-RABs-Admitted-ToBeAdded-ModAckItemExtIEs',
        u'E-RABs-Admitted-ToBeModified-ModAckItemIEs',
        u'E-RABs-Admitted-ToBeModified-ModAckItemExtIEs',
        u'E-RABs-Admitted-ToBeReleased-ModAckItemIEs',
        u'E-RABs-Admitted-ToBeReleased-ModAckItemExtIEs',
        u'WTModificationRequestRejectIEs',
        u'WTModificationRequiredIEs',
        u'E-RABs-ToBeReleased-ModReqdItemIEs',
        u'E-RABs-ToBeReleased-ModReqdItemExtIEs',
        u'E-RABs-ToBeModified-ModReqdItemIEs',
        u'E-RABs-ToBeModified-ModReqdItemExtIEs',
        u'WTModificationConfirmIEs',
        u'E-RABs-Confirmed-ToBeReleased-ModReqdItemIEs',
        u'E-RABs-Confirmed-ToBeReleased-ModReqdItemExtIEs',
        u'E-RABs-Confirmed-ToBeModified-ModReqdItemIEs',
        u'E-RABs-Confirmed-ToBeModified-ModReqdItemExtIEs',
        u'WTModificationRefuseIEs',
        u'WTReleaseRequest-IEs',
        u'E-RABs-ToBeReleased-RelReqItemIEs',
        u'E-RABs-ToBeReleased-RelReqItemExtIEs',
        u'WTReleaseRequiredIEs',
        u'WTReleaseConfirmIEs',
        u'E-RABs-ToBeReleased-RelConfItemIEs',
        u'E-RABs-ToBeReleased-RelConfItemExtIEs',
        u'WTAssociationConfirmationIEs',
        u'PrivateMessage-IEs',
        u'LWIPAdditionRequestIEs',
        u'LWIPAdditionRequestAcknowledgeIEs',
        u'LWIPAdditionRequestRejectIEs',
        u'LWIPModificationRequestIEs',
        u'LWIPModificationRequestAcknowledgeIEs',
        u'LWIPModificationRequestRejectIEs',
        u'LWIPReleaseRequest-IEs',
        u'LWIPReleaseRequiredIEs',
        u'LWIPReleaseConfirmIEs',
        ]
    _param_ = [
        ]
    
    #-----< XwSetupRequest >-----#
    XwSetupRequest = SEQ(name=u'XwSetupRequest', mode=MODE_TYPE)
    _XwSetupRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __XwSetupRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___XwSetupRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____XwSetupRequest_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____XwSetupRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Global-ENB-ID')))
    ____XwSetupRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 9), (u'criticality', u'reject'), (u'Value', _____XwSetupRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___XwSetupRequest_protocolIEs__item__id._const_tab = ____XwSetupRequest_protocolIEs__item__id_tab
    ___XwSetupRequest_protocolIEs__item__id._const_tab_at = None
    ___XwSetupRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___XwSetupRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___XwSetupRequest_protocolIEs__item__criticality._const_tab = ____XwSetupRequest_protocolIEs__item__id_tab
    ___XwSetupRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___XwSetupRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___XwSetupRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___XwSetupRequest_protocolIEs__item__value._const_tab = ____XwSetupRequest_protocolIEs__item__id_tab
    ___XwSetupRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___XwSetupRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __XwSetupRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___XwSetupRequest_protocolIEs__item__id),
        (u'criticality', ___XwSetupRequest_protocolIEs__item__criticality),
        (u'value', ___XwSetupRequest_protocolIEs__item__value),
        ])
    __XwSetupRequest_protocolIEs__item_._ext = None
    _XwSetupRequest_protocolIEs._cont = __XwSetupRequest_protocolIEs__item_
    _XwSetupRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    XwSetupRequest._cont = ASN1Dict([
        (u'protocolIEs', _XwSetupRequest_protocolIEs),
        ])
    XwSetupRequest._ext = []
    
    #-----< XwSetupRequestIEs >-----#
    XwSetupRequestIEs = CLASS(name=u'XwSetupRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _XwSetupRequestIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Global-ENB-ID')))
    XwSetupRequestIEs._val = ASN1Set(rv=[dict([(u'id', 9), (u'criticality', u'reject'), (u'Value', _XwSetupRequestIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< XwSetupResponse >-----#
    XwSetupResponse = SEQ(name=u'XwSetupResponse', mode=MODE_TYPE)
    _XwSetupResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __XwSetupResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___XwSetupResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____XwSetupResponse_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____XwSetupResponse_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WTID')))
    _____XwSetupResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANIdentifier-List')))
    _____XwSetupResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    _____XwSetupResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'ENBNeighbour-List')))
    ____XwSetupResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 23), (u'criticality', u'reject'), (u'Value', _____XwSetupResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 18), (u'criticality', u'reject'), (u'Value', _____XwSetupResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____XwSetupResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 67), (u'criticality', u'reject'), (u'Value', _____XwSetupResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___XwSetupResponse_protocolIEs__item__id._const_tab = ____XwSetupResponse_protocolIEs__item__id_tab
    ___XwSetupResponse_protocolIEs__item__id._const_tab_at = None
    ___XwSetupResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___XwSetupResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___XwSetupResponse_protocolIEs__item__criticality._const_tab = ____XwSetupResponse_protocolIEs__item__id_tab
    ___XwSetupResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___XwSetupResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___XwSetupResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___XwSetupResponse_protocolIEs__item__value._const_tab = ____XwSetupResponse_protocolIEs__item__id_tab
    ___XwSetupResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___XwSetupResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __XwSetupResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___XwSetupResponse_protocolIEs__item__id),
        (u'criticality', ___XwSetupResponse_protocolIEs__item__criticality),
        (u'value', ___XwSetupResponse_protocolIEs__item__value),
        ])
    __XwSetupResponse_protocolIEs__item_._ext = None
    _XwSetupResponse_protocolIEs._cont = __XwSetupResponse_protocolIEs__item_
    _XwSetupResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    XwSetupResponse._cont = ASN1Dict([
        (u'protocolIEs', _XwSetupResponse_protocolIEs),
        ])
    XwSetupResponse._ext = []
    
    #-----< XwSetupResponseIEs >-----#
    XwSetupResponseIEs = CLASS(name=u'XwSetupResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _XwSetupResponseIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WTID')))
    _XwSetupResponseIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANIdentifier-List')))
    _XwSetupResponseIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    _XwSetupResponseIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'ENBNeighbour-List')))
    XwSetupResponseIEs._val = ASN1Set(rv=[dict([(u'id', 23), (u'criticality', u'reject'), (u'Value', _XwSetupResponseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 18), (u'criticality', u'reject'), (u'Value', _XwSetupResponseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _XwSetupResponseIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 67), (u'criticality', u'reject'), (u'Value', _XwSetupResponseIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< XwSetupFailure >-----#
    XwSetupFailure = SEQ(name=u'XwSetupFailure', mode=MODE_TYPE)
    _XwSetupFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __XwSetupFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___XwSetupFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____XwSetupFailure_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____XwSetupFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _____XwSetupFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    _____XwSetupFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'TimeToWait')))
    ____XwSetupFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____XwSetupFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____XwSetupFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 63), (u'criticality', u'ignore'), (u'Value', _____XwSetupFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___XwSetupFailure_protocolIEs__item__id._const_tab = ____XwSetupFailure_protocolIEs__item__id_tab
    ___XwSetupFailure_protocolIEs__item__id._const_tab_at = None
    ___XwSetupFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___XwSetupFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___XwSetupFailure_protocolIEs__item__criticality._const_tab = ____XwSetupFailure_protocolIEs__item__id_tab
    ___XwSetupFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___XwSetupFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___XwSetupFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___XwSetupFailure_protocolIEs__item__value._const_tab = ____XwSetupFailure_protocolIEs__item__id_tab
    ___XwSetupFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___XwSetupFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __XwSetupFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___XwSetupFailure_protocolIEs__item__id),
        (u'criticality', ___XwSetupFailure_protocolIEs__item__criticality),
        (u'value', ___XwSetupFailure_protocolIEs__item__value),
        ])
    __XwSetupFailure_protocolIEs__item_._ext = None
    _XwSetupFailure_protocolIEs._cont = __XwSetupFailure_protocolIEs__item_
    _XwSetupFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    XwSetupFailure._cont = ASN1Dict([
        (u'protocolIEs', _XwSetupFailure_protocolIEs),
        ])
    XwSetupFailure._ext = []
    
    #-----< XwSetupFailureIEs >-----#
    XwSetupFailureIEs = CLASS(name=u'XwSetupFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _XwSetupFailureIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _XwSetupFailureIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    _XwSetupFailureIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'TimeToWait')))
    XwSetupFailureIEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _XwSetupFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _XwSetupFailureIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 63), (u'criticality', u'ignore'), (u'Value', _XwSetupFailureIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< WTConfigurationUpdate >-----#
    WTConfigurationUpdate = SEQ(name=u'WTConfigurationUpdate', mode=MODE_TYPE)
    _WTConfigurationUpdate_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __WTConfigurationUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___WTConfigurationUpdate_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____WTConfigurationUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____WTConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANIdentifier-List')))
    _____WTConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANIdentifier-List')))
    _____WTConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANIdentifiersToDelete-List')))
    _____WTConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANIdentifiersToDeleteExtension-List')))
    _____WTConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'ENBNeighbour-List')))
    ____WTConfigurationUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 19), (u'criticality', u'reject'), (u'Value', _____WTConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 22), (u'criticality', u'reject'), (u'Value', _____WTConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 21), (u'criticality', u'reject'), (u'Value', _____WTConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 62), (u'criticality', u'reject'), (u'Value', _____WTConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 67), (u'criticality', u'reject'), (u'Value', _____WTConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WTConfigurationUpdate_protocolIEs__item__id._const_tab = ____WTConfigurationUpdate_protocolIEs__item__id_tab
    ___WTConfigurationUpdate_protocolIEs__item__id._const_tab_at = None
    ___WTConfigurationUpdate_protocolIEs__item__id._const_tab_id = u'id'
    ___WTConfigurationUpdate_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___WTConfigurationUpdate_protocolIEs__item__criticality._const_tab = ____WTConfigurationUpdate_protocolIEs__item__id_tab
    ___WTConfigurationUpdate_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WTConfigurationUpdate_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WTConfigurationUpdate_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___WTConfigurationUpdate_protocolIEs__item__value._const_tab = ____WTConfigurationUpdate_protocolIEs__item__id_tab
    ___WTConfigurationUpdate_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WTConfigurationUpdate_protocolIEs__item__value._const_tab_id = u'Value'
    __WTConfigurationUpdate_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WTConfigurationUpdate_protocolIEs__item__id),
        (u'criticality', ___WTConfigurationUpdate_protocolIEs__item__criticality),
        (u'value', ___WTConfigurationUpdate_protocolIEs__item__value),
        ])
    __WTConfigurationUpdate_protocolIEs__item_._ext = None
    _WTConfigurationUpdate_protocolIEs._cont = __WTConfigurationUpdate_protocolIEs__item_
    _WTConfigurationUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WTConfigurationUpdate._cont = ASN1Dict([
        (u'protocolIEs', _WTConfigurationUpdate_protocolIEs),
        ])
    WTConfigurationUpdate._ext = []
    
    #-----< WTConfigurationUpdateIEs >-----#
    WTConfigurationUpdateIEs = CLASS(name=u'WTConfigurationUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WTConfigurationUpdateIEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANIdentifier-List')))
    _WTConfigurationUpdateIEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANIdentifier-List')))
    _WTConfigurationUpdateIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANIdentifiersToDelete-List')))
    _WTConfigurationUpdateIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANIdentifiersToDeleteExtension-List')))
    _WTConfigurationUpdateIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'ENBNeighbour-List')))
    WTConfigurationUpdateIEs._val = ASN1Set(rv=[dict([(u'id', 19), (u'criticality', u'reject'), (u'Value', _WTConfigurationUpdateIEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 22), (u'criticality', u'reject'), (u'Value', _WTConfigurationUpdateIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 21), (u'criticality', u'reject'), (u'Value', _WTConfigurationUpdateIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 62), (u'criticality', u'reject'), (u'Value', _WTConfigurationUpdateIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 67), (u'criticality', u'reject'), (u'Value', _WTConfigurationUpdateIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< WTConfigurationUpdateAcknowledge >-----#
    WTConfigurationUpdateAcknowledge = SEQ(name=u'WTConfigurationUpdateAcknowledge', mode=MODE_TYPE)
    _WTConfigurationUpdateAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __WTConfigurationUpdateAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___WTConfigurationUpdateAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____WTConfigurationUpdateAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____WTConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    ____WTConfigurationUpdateAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____WTConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WTConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab = ____WTConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___WTConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___WTConfigurationUpdateAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___WTConfigurationUpdateAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___WTConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab = ____WTConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___WTConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WTConfigurationUpdateAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WTConfigurationUpdateAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___WTConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab = ____WTConfigurationUpdateAcknowledge_protocolIEs__item__id_tab
    ___WTConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WTConfigurationUpdateAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __WTConfigurationUpdateAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WTConfigurationUpdateAcknowledge_protocolIEs__item__id),
        (u'criticality', ___WTConfigurationUpdateAcknowledge_protocolIEs__item__criticality),
        (u'value', ___WTConfigurationUpdateAcknowledge_protocolIEs__item__value),
        ])
    __WTConfigurationUpdateAcknowledge_protocolIEs__item_._ext = None
    _WTConfigurationUpdateAcknowledge_protocolIEs._cont = __WTConfigurationUpdateAcknowledge_protocolIEs__item_
    _WTConfigurationUpdateAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WTConfigurationUpdateAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _WTConfigurationUpdateAcknowledge_protocolIEs),
        ])
    WTConfigurationUpdateAcknowledge._ext = []
    
    #-----< WTConfigurationUpdateAcknowledgeIEs >-----#
    WTConfigurationUpdateAcknowledgeIEs = CLASS(name=u'WTConfigurationUpdateAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WTConfigurationUpdateAcknowledgeIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    WTConfigurationUpdateAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _WTConfigurationUpdateAcknowledgeIEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< WTConfigurationUpdateFailure >-----#
    WTConfigurationUpdateFailure = SEQ(name=u'WTConfigurationUpdateFailure', mode=MODE_TYPE)
    _WTConfigurationUpdateFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __WTConfigurationUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___WTConfigurationUpdateFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____WTConfigurationUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____WTConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _____WTConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    _____WTConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'TimeToWait')))
    ____WTConfigurationUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____WTConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____WTConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 63), (u'criticality', u'ignore'), (u'Value', _____WTConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WTConfigurationUpdateFailure_protocolIEs__item__id._const_tab = ____WTConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___WTConfigurationUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___WTConfigurationUpdateFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___WTConfigurationUpdateFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___WTConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab = ____WTConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___WTConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WTConfigurationUpdateFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WTConfigurationUpdateFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___WTConfigurationUpdateFailure_protocolIEs__item__value._const_tab = ____WTConfigurationUpdateFailure_protocolIEs__item__id_tab
    ___WTConfigurationUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WTConfigurationUpdateFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __WTConfigurationUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WTConfigurationUpdateFailure_protocolIEs__item__id),
        (u'criticality', ___WTConfigurationUpdateFailure_protocolIEs__item__criticality),
        (u'value', ___WTConfigurationUpdateFailure_protocolIEs__item__value),
        ])
    __WTConfigurationUpdateFailure_protocolIEs__item_._ext = None
    _WTConfigurationUpdateFailure_protocolIEs._cont = __WTConfigurationUpdateFailure_protocolIEs__item_
    _WTConfigurationUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WTConfigurationUpdateFailure._cont = ASN1Dict([
        (u'protocolIEs', _WTConfigurationUpdateFailure_protocolIEs),
        ])
    WTConfigurationUpdateFailure._ext = []
    
    #-----< WTConfigurationUpdateFailureIEs >-----#
    WTConfigurationUpdateFailureIEs = CLASS(name=u'WTConfigurationUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WTConfigurationUpdateFailureIEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _WTConfigurationUpdateFailureIEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    _WTConfigurationUpdateFailureIEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'TimeToWait')))
    WTConfigurationUpdateFailureIEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _WTConfigurationUpdateFailureIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _WTConfigurationUpdateFailureIEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 63), (u'criticality', u'ignore'), (u'Value', _WTConfigurationUpdateFailureIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< WTStatusRequest >-----#
    WTStatusRequest = SEQ(name=u'WTStatusRequest', mode=MODE_TYPE)
    _WTStatusRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __WTStatusRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___WTStatusRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____WTStatusRequest_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____WTStatusRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Measurement-ID')))
    _____WTStatusRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Measurement-ID')))
    _____WTStatusRequest_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Registration-Request')))
    _____WTStatusRequest_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'ReportCharacteristics')))
    _____WTStatusRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'BSSToReport-List')))
    _____WTStatusRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'ReportingPeriodicity')))
    _____WTStatusRequest_protocolIEs__item__id_tab_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'PartialSuccessIndicator')))
    ____WTStatusRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____WTStatusRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 24), (u'criticality', u'ignore'), (u'Value', _____WTStatusRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'conditional')]), dict([(u'id', 14), (u'criticality', u'reject'), (u'Value', _____WTStatusRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'reject'), (u'Value', _____WTStatusRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _____WTStatusRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 16), (u'criticality', u'ignore'), (u'Value', _____WTStatusRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 13), (u'criticality', u'ignore'), (u'Value', _____WTStatusRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WTStatusRequest_protocolIEs__item__id._const_tab = ____WTStatusRequest_protocolIEs__item__id_tab
    ___WTStatusRequest_protocolIEs__item__id._const_tab_at = None
    ___WTStatusRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___WTStatusRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___WTStatusRequest_protocolIEs__item__criticality._const_tab = ____WTStatusRequest_protocolIEs__item__id_tab
    ___WTStatusRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WTStatusRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WTStatusRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___WTStatusRequest_protocolIEs__item__value._const_tab = ____WTStatusRequest_protocolIEs__item__id_tab
    ___WTStatusRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WTStatusRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __WTStatusRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WTStatusRequest_protocolIEs__item__id),
        (u'criticality', ___WTStatusRequest_protocolIEs__item__criticality),
        (u'value', ___WTStatusRequest_protocolIEs__item__value),
        ])
    __WTStatusRequest_protocolIEs__item_._ext = None
    _WTStatusRequest_protocolIEs._cont = __WTStatusRequest_protocolIEs__item_
    _WTStatusRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WTStatusRequest._cont = ASN1Dict([
        (u'protocolIEs', _WTStatusRequest_protocolIEs),
        ])
    WTStatusRequest._ext = []
    
    #-----< WTStatusRequest-IEs >-----#
    WTStatusRequest_IEs = CLASS(name=u'WTStatusRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WTStatusRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Measurement-ID')))
    _WTStatusRequest_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Measurement-ID')))
    _WTStatusRequest_IEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Registration-Request')))
    _WTStatusRequest_IEs_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'ReportCharacteristics')))
    _WTStatusRequest_IEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'BSSToReport-List')))
    _WTStatusRequest_IEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'ReportingPeriodicity')))
    _WTStatusRequest_IEs_val_Value_6 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'PartialSuccessIndicator')))
    WTStatusRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _WTStatusRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 24), (u'criticality', u'ignore'), (u'Value', _WTStatusRequest_IEs_val_Value_1), (u'presence', u'conditional')]), dict([(u'id', 14), (u'criticality', u'reject'), (u'Value', _WTStatusRequest_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 15), (u'criticality', u'reject'), (u'Value', _WTStatusRequest_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 3), (u'criticality', u'ignore'), (u'Value', _WTStatusRequest_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 16), (u'criticality', u'ignore'), (u'Value', _WTStatusRequest_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 13), (u'criticality', u'ignore'), (u'Value', _WTStatusRequest_IEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< WTStatusResponse >-----#
    WTStatusResponse = SEQ(name=u'WTStatusResponse', mode=MODE_TYPE)
    _WTStatusResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __WTStatusResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___WTStatusResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____WTStatusResponse_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____WTStatusResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Measurement-ID')))
    _____WTStatusResponse_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Measurement-ID')))
    _____WTStatusResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'MeasurementInitiationResult-List')))
    _____WTStatusResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    ____WTStatusResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____WTStatusResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 24), (u'criticality', u'reject'), (u'Value', _____WTStatusResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 12), (u'criticality', u'ignore'), (u'Value', _____WTStatusResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____WTStatusResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WTStatusResponse_protocolIEs__item__id._const_tab = ____WTStatusResponse_protocolIEs__item__id_tab
    ___WTStatusResponse_protocolIEs__item__id._const_tab_at = None
    ___WTStatusResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___WTStatusResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___WTStatusResponse_protocolIEs__item__criticality._const_tab = ____WTStatusResponse_protocolIEs__item__id_tab
    ___WTStatusResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WTStatusResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WTStatusResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___WTStatusResponse_protocolIEs__item__value._const_tab = ____WTStatusResponse_protocolIEs__item__id_tab
    ___WTStatusResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WTStatusResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __WTStatusResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WTStatusResponse_protocolIEs__item__id),
        (u'criticality', ___WTStatusResponse_protocolIEs__item__criticality),
        (u'value', ___WTStatusResponse_protocolIEs__item__value),
        ])
    __WTStatusResponse_protocolIEs__item_._ext = None
    _WTStatusResponse_protocolIEs._cont = __WTStatusResponse_protocolIEs__item_
    _WTStatusResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WTStatusResponse._cont = ASN1Dict([
        (u'protocolIEs', _WTStatusResponse_protocolIEs),
        ])
    WTStatusResponse._ext = []
    
    #-----< WTStatusResponse-IEs >-----#
    WTStatusResponse_IEs = CLASS(name=u'WTStatusResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WTStatusResponse_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Measurement-ID')))
    _WTStatusResponse_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Measurement-ID')))
    _WTStatusResponse_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'MeasurementInitiationResult-List')))
    _WTStatusResponse_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    WTStatusResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _WTStatusResponse_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 24), (u'criticality', u'reject'), (u'Value', _WTStatusResponse_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 12), (u'criticality', u'ignore'), (u'Value', _WTStatusResponse_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _WTStatusResponse_IEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< WTStatusFailure >-----#
    WTStatusFailure = SEQ(name=u'WTStatusFailure', mode=MODE_TYPE)
    _WTStatusFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __WTStatusFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___WTStatusFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____WTStatusFailure_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____WTStatusFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Measurement-ID')))
    _____WTStatusFailure_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Measurement-ID')))
    _____WTStatusFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CompleteFailureCauseInformation-List')))
    _____WTStatusFailure_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _____WTStatusFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    ____WTStatusFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____WTStatusFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 24), (u'criticality', u'reject'), (u'Value', _____WTStatusFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 6), (u'criticality', u'ignore'), (u'Value', _____WTStatusFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____WTStatusFailure_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____WTStatusFailure_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WTStatusFailure_protocolIEs__item__id._const_tab = ____WTStatusFailure_protocolIEs__item__id_tab
    ___WTStatusFailure_protocolIEs__item__id._const_tab_at = None
    ___WTStatusFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___WTStatusFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___WTStatusFailure_protocolIEs__item__criticality._const_tab = ____WTStatusFailure_protocolIEs__item__id_tab
    ___WTStatusFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WTStatusFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WTStatusFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___WTStatusFailure_protocolIEs__item__value._const_tab = ____WTStatusFailure_protocolIEs__item__id_tab
    ___WTStatusFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WTStatusFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __WTStatusFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WTStatusFailure_protocolIEs__item__id),
        (u'criticality', ___WTStatusFailure_protocolIEs__item__criticality),
        (u'value', ___WTStatusFailure_protocolIEs__item__value),
        ])
    __WTStatusFailure_protocolIEs__item_._ext = None
    _WTStatusFailure_protocolIEs._cont = __WTStatusFailure_protocolIEs__item_
    _WTStatusFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WTStatusFailure._cont = ASN1Dict([
        (u'protocolIEs', _WTStatusFailure_protocolIEs),
        ])
    WTStatusFailure._ext = []
    
    #-----< WTStatusFailure-IEs >-----#
    WTStatusFailure_IEs = CLASS(name=u'WTStatusFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WTStatusFailure_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Measurement-ID')))
    _WTStatusFailure_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Measurement-ID')))
    _WTStatusFailure_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CompleteFailureCauseInformation-List')))
    _WTStatusFailure_IEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _WTStatusFailure_IEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    WTStatusFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _WTStatusFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 24), (u'criticality', u'reject'), (u'Value', _WTStatusFailure_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 6), (u'criticality', u'ignore'), (u'Value', _WTStatusFailure_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _WTStatusFailure_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _WTStatusFailure_IEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< WTStatusReport >-----#
    WTStatusReport = SEQ(name=u'WTStatusReport', mode=MODE_TYPE)
    _WTStatusReport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __WTStatusReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___WTStatusReport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____WTStatusReport_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____WTStatusReport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Measurement-ID')))
    _____WTStatusReport_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Measurement-ID')))
    _____WTStatusReport_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'BSSMeasurementResult-List')))
    ____WTStatusReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____WTStatusReport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 24), (u'criticality', u'reject'), (u'Value', _____WTStatusReport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _____WTStatusReport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___WTStatusReport_protocolIEs__item__id._const_tab = ____WTStatusReport_protocolIEs__item__id_tab
    ___WTStatusReport_protocolIEs__item__id._const_tab_at = None
    ___WTStatusReport_protocolIEs__item__id._const_tab_id = u'id'
    ___WTStatusReport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___WTStatusReport_protocolIEs__item__criticality._const_tab = ____WTStatusReport_protocolIEs__item__id_tab
    ___WTStatusReport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WTStatusReport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WTStatusReport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___WTStatusReport_protocolIEs__item__value._const_tab = ____WTStatusReport_protocolIEs__item__id_tab
    ___WTStatusReport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WTStatusReport_protocolIEs__item__value._const_tab_id = u'Value'
    __WTStatusReport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WTStatusReport_protocolIEs__item__id),
        (u'criticality', ___WTStatusReport_protocolIEs__item__criticality),
        (u'value', ___WTStatusReport_protocolIEs__item__value),
        ])
    __WTStatusReport_protocolIEs__item_._ext = None
    _WTStatusReport_protocolIEs._cont = __WTStatusReport_protocolIEs__item_
    _WTStatusReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WTStatusReport._cont = ASN1Dict([
        (u'protocolIEs', _WTStatusReport_protocolIEs),
        ])
    WTStatusReport._ext = []
    
    #-----< WTStatusReport-IEs >-----#
    WTStatusReport_IEs = CLASS(name=u'WTStatusReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WTStatusReport_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Measurement-ID')))
    _WTStatusReport_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Measurement-ID')))
    _WTStatusReport_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'BSSMeasurementResult-List')))
    WTStatusReport_IEs._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _WTStatusReport_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 24), (u'criticality', u'reject'), (u'Value', _WTStatusReport_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _WTStatusReport_IEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication >-----#
    ErrorIndication = SEQ(name=u'ErrorIndication', mode=MODE_TYPE)
    _ErrorIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __ErrorIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___ErrorIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____ErrorIndication_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    ____ErrorIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolIEs__item__id._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__id._const_tab_at = None
    ___ErrorIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___ErrorIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___ErrorIndication_protocolIEs__item__criticality._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ErrorIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___ErrorIndication_protocolIEs__item__value._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ErrorIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __ErrorIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ErrorIndication_protocolIEs__item__id),
        (u'criticality', ___ErrorIndication_protocolIEs__item__criticality),
        (u'value', ___ErrorIndication_protocolIEs__item__value),
        ])
    __ErrorIndication_protocolIEs__item_._ext = None
    _ErrorIndication_protocolIEs._cont = __ErrorIndication_protocolIEs__item_
    _ErrorIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ErrorIndication._cont = ASN1Dict([
        (u'protocolIEs', _ErrorIndication_protocolIEs),
        ])
    ErrorIndication._ext = []
    
    #-----< ErrorIndication-IEs >-----#
    ErrorIndication_IEs = CLASS(name=u'ErrorIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _ErrorIndication_IEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _ErrorIndication_IEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _ErrorIndication_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _ErrorIndication_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    ErrorIndication_IEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _ErrorIndication_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _ErrorIndication_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _ErrorIndication_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _ErrorIndication_IEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Reset >-----#
    Reset = SEQ(name=u'Reset', mode=MODE_TYPE)
    _Reset_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __Reset_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___Reset_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____Reset_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____Reset_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    ____Reset_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____Reset_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___Reset_protocolIEs__item__id._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__id._const_tab_at = None
    ___Reset_protocolIEs__item__id._const_tab_id = u'id'
    ___Reset_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___Reset_protocolIEs__item__criticality._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___Reset_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___Reset_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___Reset_protocolIEs__item__value._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___Reset_protocolIEs__item__value._const_tab_id = u'Value'
    __Reset_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___Reset_protocolIEs__item__id),
        (u'criticality', ___Reset_protocolIEs__item__criticality),
        (u'value', ___Reset_protocolIEs__item__value),
        ])
    __Reset_protocolIEs__item_._ext = None
    _Reset_protocolIEs._cont = __Reset_protocolIEs__item_
    _Reset_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    Reset._cont = ASN1Dict([
        (u'protocolIEs', _Reset_protocolIEs),
        ])
    Reset._ext = []
    
    #-----< Reset-IEs >-----#
    Reset_IEs = CLASS(name=u'Reset-IEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _Reset_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    Reset_IEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _Reset_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ResetResponse >-----#
    ResetResponse = SEQ(name=u'ResetResponse', mode=MODE_TYPE)
    _ResetResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __ResetResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___ResetResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____ResetResponse_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____ResetResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    ____ResetResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____ResetResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResetResponse_protocolIEs__item__id._const_tab = ____ResetResponse_protocolIEs__item__id_tab
    ___ResetResponse_protocolIEs__item__id._const_tab_at = None
    ___ResetResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___ResetResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___ResetResponse_protocolIEs__item__criticality._const_tab = ____ResetResponse_protocolIEs__item__id_tab
    ___ResetResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ResetResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ResetResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___ResetResponse_protocolIEs__item__value._const_tab = ____ResetResponse_protocolIEs__item__id_tab
    ___ResetResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ResetResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __ResetResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ResetResponse_protocolIEs__item__id),
        (u'criticality', ___ResetResponse_protocolIEs__item__criticality),
        (u'value', ___ResetResponse_protocolIEs__item__value),
        ])
    __ResetResponse_protocolIEs__item_._ext = None
    _ResetResponse_protocolIEs._cont = __ResetResponse_protocolIEs__item_
    _ResetResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResetResponse._cont = ASN1Dict([
        (u'protocolIEs', _ResetResponse_protocolIEs),
        ])
    ResetResponse._ext = []
    
    #-----< ResetResponse-IEs >-----#
    ResetResponse_IEs = CLASS(name=u'ResetResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _ResetResponse_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    ResetResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _ResetResponse_IEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< WTAdditionRequest >-----#
    WTAdditionRequest = SEQ(name=u'WTAdditionRequest', mode=MODE_TYPE)
    _WTAdditionRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __WTAdditionRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___WTAdditionRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____WTAdditionRequest_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____WTAdditionRequest_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTAdditionRequest_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-Identity')))
    _____WTAdditionRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANSecurityInfo')))
    _____WTAdditionRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'PLMN-Identity')))
    _____WTAdditionRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeAdded-List')))
    _____WTAdditionRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'MobilitySet')))
    _____WTAdditionRequest_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    ____WTAdditionRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _____WTAdditionRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 30), (u'criticality', u'reject'), (u'Value', _____WTAdditionRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 31), (u'criticality', u'reject'), (u'Value', _____WTAdditionRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 55), (u'criticality', u'ignore'), (u'Value', _____WTAdditionRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 28), (u'criticality', u'reject'), (u'Value', _____WTAdditionRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 54), (u'criticality', u'reject'), (u'Value', _____WTAdditionRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _____WTAdditionRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WTAdditionRequest_protocolIEs__item__id._const_tab = ____WTAdditionRequest_protocolIEs__item__id_tab
    ___WTAdditionRequest_protocolIEs__item__id._const_tab_at = None
    ___WTAdditionRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___WTAdditionRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___WTAdditionRequest_protocolIEs__item__criticality._const_tab = ____WTAdditionRequest_protocolIEs__item__id_tab
    ___WTAdditionRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WTAdditionRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WTAdditionRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___WTAdditionRequest_protocolIEs__item__value._const_tab = ____WTAdditionRequest_protocolIEs__item__id_tab
    ___WTAdditionRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WTAdditionRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __WTAdditionRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WTAdditionRequest_protocolIEs__item__id),
        (u'criticality', ___WTAdditionRequest_protocolIEs__item__criticality),
        (u'value', ___WTAdditionRequest_protocolIEs__item__value),
        ])
    __WTAdditionRequest_protocolIEs__item_._ext = None
    _WTAdditionRequest_protocolIEs._cont = __WTAdditionRequest_protocolIEs__item_
    _WTAdditionRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WTAdditionRequest._cont = ASN1Dict([
        (u'protocolIEs', _WTAdditionRequest_protocolIEs),
        ])
    WTAdditionRequest._ext = []
    
    #-----< WTAdditionRequestIEs >-----#
    WTAdditionRequestIEs = CLASS(name=u'WTAdditionRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WTAdditionRequestIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTAdditionRequestIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-Identity')))
    _WTAdditionRequestIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WLANSecurityInfo')))
    _WTAdditionRequestIEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'PLMN-Identity')))
    _WTAdditionRequestIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeAdded-List')))
    _WTAdditionRequestIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'MobilitySet')))
    _WTAdditionRequestIEs_val_Value_6 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    WTAdditionRequestIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _WTAdditionRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 30), (u'criticality', u'reject'), (u'Value', _WTAdditionRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 31), (u'criticality', u'reject'), (u'Value', _WTAdditionRequestIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 55), (u'criticality', u'ignore'), (u'Value', _WTAdditionRequestIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 28), (u'criticality', u'reject'), (u'Value', _WTAdditionRequestIEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 54), (u'criticality', u'reject'), (u'Value', _WTAdditionRequestIEs_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _WTAdditionRequestIEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-List >-----#
    E_RABs_ToBeAdded_List = SEQ_OF(name=u'E-RABs-ToBeAdded-List', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABs_ToBeAdded_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_ToBeAdded_List__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____E_RABs_ToBeAdded_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeAdded-Item')))
    ___E_RABs_ToBeAdded_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 29), (u'criticality', u'reject'), (u'Value', ____E_RABs_ToBeAdded_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeAdded_List__item__id._const_tab = ___E_RABs_ToBeAdded_List__item__id_tab
    __E_RABs_ToBeAdded_List__item__id._const_tab_at = None
    __E_RABs_ToBeAdded_List__item__id._const_tab_id = u'id'
    __E_RABs_ToBeAdded_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_ToBeAdded_List__item__criticality._const_tab = ___E_RABs_ToBeAdded_List__item__id_tab
    __E_RABs_ToBeAdded_List__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_ToBeAdded_List__item__criticality._const_tab_id = u'criticality'
    __E_RABs_ToBeAdded_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_ToBeAdded_List__item__value._const_tab = ___E_RABs_ToBeAdded_List__item__id_tab
    __E_RABs_ToBeAdded_List__item__value._const_tab_at = ('..', u'id')
    __E_RABs_ToBeAdded_List__item__value._const_tab_id = u'Value'
    _E_RABs_ToBeAdded_List__item_._cont = ASN1Dict([
        (u'id', __E_RABs_ToBeAdded_List__item__id),
        (u'criticality', __E_RABs_ToBeAdded_List__item__criticality),
        (u'value', __E_RABs_ToBeAdded_List__item__value),
        ])
    _E_RABs_ToBeAdded_List__item_._ext = None
    E_RABs_ToBeAdded_List._cont = _E_RABs_ToBeAdded_List__item_
    E_RABs_ToBeAdded_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeAdded-ItemIEs >-----#
    E_RABs_ToBeAdded_ItemIEs = CLASS(name=u'E-RABs-ToBeAdded-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _E_RABs_ToBeAdded_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeAdded-Item')))
    E_RABs_ToBeAdded_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 29), (u'criticality', u'reject'), (u'Value', _E_RABs_ToBeAdded_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-Item >-----#
    E_RABs_ToBeAdded_Item = SEQ(name=u'E-RABs-ToBeAdded-Item', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_Item_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeAdded_Item_e_RAB_QoS_Parameters = SEQ(name=u'e-RAB-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-QoS-Parameters')))
    _E_RABs_ToBeAdded_Item_eNB_GTPtunnelEndpoint = SEQ(name=u'eNB-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_ToBeAdded_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeAdded_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeAdded_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeAdded_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeAdded_Item_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'DRB-Identity')))
    ____E_RABs_ToBeAdded_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 65), (u'criticality', u'reject'), (u'Extension', _____E_RABs_ToBeAdded_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeAdded_Item_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeAdded_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeAdded_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeAdded_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_ToBeAdded_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeAdded_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeAdded_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeAdded_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_ToBeAdded_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeAdded_Item_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeAdded_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeAdded_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeAdded_Item_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeAdded_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeAdded_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeAdded_Item_iE_Extensions__item_._ext = None
    _E_RABs_ToBeAdded_Item_iE_Extensions._cont = __E_RABs_ToBeAdded_Item_iE_Extensions__item_
    _E_RABs_ToBeAdded_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeAdded_Item._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeAdded_Item_e_RAB_ID),
        (u'e-RAB-QoS-Parameters', _E_RABs_ToBeAdded_Item_e_RAB_QoS_Parameters),
        (u'eNB-GTPtunnelEndpoint', _E_RABs_ToBeAdded_Item_eNB_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_ToBeAdded_Item_iE_Extensions),
        ])
    E_RABs_ToBeAdded_Item._ext = []
    
    #-----< E-RABs-ToBeAdded-ItemExtIEs >-----#
    E_RABs_ToBeAdded_ItemExtIEs = CLASS(name=u'E-RABs-ToBeAdded-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeAdded_ItemExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'DRB-Identity')))
    E_RABs_ToBeAdded_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 65), (u'criticality', u'reject'), (u'Extension', _E_RABs_ToBeAdded_ItemExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< WTAdditionRequestAcknowledge >-----#
    WTAdditionRequestAcknowledge = SEQ(name=u'WTAdditionRequestAcknowledge', mode=MODE_TYPE)
    _WTAdditionRequestAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __WTAdditionRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___WTAdditionRequestAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-List')))
    _____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-List')))
    _____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    _____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WT-MAC-Address')))
    ____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 32), (u'criticality', u'ignore'), (u'Value', _____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 34), (u'criticality', u'ignore'), (u'Value', _____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 73), (u'criticality', u'ignore'), (u'Value', _____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WTAdditionRequestAcknowledge_protocolIEs__item__id._const_tab = ____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab
    ___WTAdditionRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___WTAdditionRequestAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___WTAdditionRequestAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___WTAdditionRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab
    ___WTAdditionRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WTAdditionRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WTAdditionRequestAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___WTAdditionRequestAcknowledge_protocolIEs__item__value._const_tab = ____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab
    ___WTAdditionRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WTAdditionRequestAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __WTAdditionRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WTAdditionRequestAcknowledge_protocolIEs__item__id),
        (u'criticality', ___WTAdditionRequestAcknowledge_protocolIEs__item__criticality),
        (u'value', ___WTAdditionRequestAcknowledge_protocolIEs__item__value),
        ])
    __WTAdditionRequestAcknowledge_protocolIEs__item_._ext = None
    _WTAdditionRequestAcknowledge_protocolIEs._cont = __WTAdditionRequestAcknowledge_protocolIEs__item_
    _WTAdditionRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WTAdditionRequestAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _WTAdditionRequestAcknowledge_protocolIEs),
        ])
    WTAdditionRequestAcknowledge._ext = []
    
    #-----< WTAdditionRequestAcknowledgeIEs >-----#
    WTAdditionRequestAcknowledgeIEs = CLASS(name=u'WTAdditionRequestAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WTAdditionRequestAcknowledgeIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTAdditionRequestAcknowledgeIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTAdditionRequestAcknowledgeIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-List')))
    _WTAdditionRequestAcknowledgeIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-List')))
    _WTAdditionRequestAcknowledgeIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    _WTAdditionRequestAcknowledgeIEs_val_Value_5 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'WT-MAC-Address')))
    WTAdditionRequestAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _WTAdditionRequestAcknowledgeIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _WTAdditionRequestAcknowledgeIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 32), (u'criticality', u'ignore'), (u'Value', _WTAdditionRequestAcknowledgeIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 34), (u'criticality', u'ignore'), (u'Value', _WTAdditionRequestAcknowledgeIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _WTAdditionRequestAcknowledgeIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 73), (u'criticality', u'ignore'), (u'Value', _WTAdditionRequestAcknowledgeIEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-List >-----#
    E_RABs_Admitted_ToBeAdded_List = SEQ_OF(name=u'E-RABs-Admitted-ToBeAdded-List', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABs_Admitted_ToBeAdded_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_Admitted_ToBeAdded_List__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____E_RABs_Admitted_ToBeAdded_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-Item')))
    ___E_RABs_Admitted_ToBeAdded_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 33), (u'criticality', u'ignore'), (u'Value', ____E_RABs_Admitted_ToBeAdded_List__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_Admitted_ToBeAdded_List__item__id._const_tab = ___E_RABs_Admitted_ToBeAdded_List__item__id_tab
    __E_RABs_Admitted_ToBeAdded_List__item__id._const_tab_at = None
    __E_RABs_Admitted_ToBeAdded_List__item__id._const_tab_id = u'id'
    __E_RABs_Admitted_ToBeAdded_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_Admitted_ToBeAdded_List__item__criticality._const_tab = ___E_RABs_Admitted_ToBeAdded_List__item__id_tab
    __E_RABs_Admitted_ToBeAdded_List__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_Admitted_ToBeAdded_List__item__criticality._const_tab_id = u'criticality'
    __E_RABs_Admitted_ToBeAdded_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_Admitted_ToBeAdded_List__item__value._const_tab = ___E_RABs_Admitted_ToBeAdded_List__item__id_tab
    __E_RABs_Admitted_ToBeAdded_List__item__value._const_tab_at = ('..', u'id')
    __E_RABs_Admitted_ToBeAdded_List__item__value._const_tab_id = u'Value'
    _E_RABs_Admitted_ToBeAdded_List__item_._cont = ASN1Dict([
        (u'id', __E_RABs_Admitted_ToBeAdded_List__item__id),
        (u'criticality', __E_RABs_Admitted_ToBeAdded_List__item__criticality),
        (u'value', __E_RABs_Admitted_ToBeAdded_List__item__value),
        ])
    _E_RABs_Admitted_ToBeAdded_List__item_._ext = None
    E_RABs_Admitted_ToBeAdded_List._cont = _E_RABs_Admitted_ToBeAdded_List__item_
    E_RABs_Admitted_ToBeAdded_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-ItemIEs >-----#
    E_RABs_Admitted_ToBeAdded_ItemIEs = CLASS(name=u'E-RABs-Admitted-ToBeAdded-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _E_RABs_Admitted_ToBeAdded_ItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-Item')))
    E_RABs_Admitted_ToBeAdded_ItemIEs._val = ASN1Set(rv=[dict([(u'id', 33), (u'criticality', u'ignore'), (u'Value', _E_RABs_Admitted_ToBeAdded_ItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-Item >-----#
    E_RABs_Admitted_ToBeAdded_Item = SEQ(name=u'E-RABs-Admitted-ToBeAdded-Item', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_Item_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeAdded_Item_wT_GTPtunnelEndpoint = SEQ(name=u'wT-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_Admitted_ToBeAdded_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    _____E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'LWA-WLAN-AC')))
    ____E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 66), (u'criticality', u'ignore'), (u'Extension', _____E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeAdded_Item_iE_Extensions._cont = __E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item_
    _E_RABs_Admitted_ToBeAdded_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeAdded_Item._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_Admitted_ToBeAdded_Item_e_RAB_ID),
        (u'wT-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_Item_wT_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_Admitted_ToBeAdded_Item_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeAdded_Item._ext = []
    
    #-----< E-RABs-Admitted-ToBeAdded-ItemExtIEs >-----#
    E_RABs_Admitted_ToBeAdded_ItemExtIEs = CLASS(name=u'E-RABs-Admitted-ToBeAdded-ItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    _E_RABs_Admitted_ToBeAdded_ItemExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'LWA-WLAN-AC')))
    E_RABs_Admitted_ToBeAdded_ItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 66), (u'criticality', u'ignore'), (u'Extension', _E_RABs_Admitted_ToBeAdded_ItemExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< WTAdditionRequestReject >-----#
    WTAdditionRequestReject = SEQ(name=u'WTAdditionRequestReject', mode=MODE_TYPE)
    _WTAdditionRequestReject_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __WTAdditionRequestReject_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___WTAdditionRequestReject_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____WTAdditionRequestReject_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____WTAdditionRequestReject_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTAdditionRequestReject_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _____WTAdditionRequestReject_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    ____WTAdditionRequestReject_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _____WTAdditionRequestReject_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____WTAdditionRequestReject_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____WTAdditionRequestReject_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WTAdditionRequestReject_protocolIEs__item__id._const_tab = ____WTAdditionRequestReject_protocolIEs__item__id_tab
    ___WTAdditionRequestReject_protocolIEs__item__id._const_tab_at = None
    ___WTAdditionRequestReject_protocolIEs__item__id._const_tab_id = u'id'
    ___WTAdditionRequestReject_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___WTAdditionRequestReject_protocolIEs__item__criticality._const_tab = ____WTAdditionRequestReject_protocolIEs__item__id_tab
    ___WTAdditionRequestReject_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WTAdditionRequestReject_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WTAdditionRequestReject_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___WTAdditionRequestReject_protocolIEs__item__value._const_tab = ____WTAdditionRequestReject_protocolIEs__item__id_tab
    ___WTAdditionRequestReject_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WTAdditionRequestReject_protocolIEs__item__value._const_tab_id = u'Value'
    __WTAdditionRequestReject_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WTAdditionRequestReject_protocolIEs__item__id),
        (u'criticality', ___WTAdditionRequestReject_protocolIEs__item__criticality),
        (u'value', ___WTAdditionRequestReject_protocolIEs__item__value),
        ])
    __WTAdditionRequestReject_protocolIEs__item_._ext = None
    _WTAdditionRequestReject_protocolIEs._cont = __WTAdditionRequestReject_protocolIEs__item_
    _WTAdditionRequestReject_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WTAdditionRequestReject._cont = ASN1Dict([
        (u'protocolIEs', _WTAdditionRequestReject_protocolIEs),
        ])
    WTAdditionRequestReject._ext = []
    
    #-----< WTAdditionRequestRejectIEs >-----#
    WTAdditionRequestRejectIEs = CLASS(name=u'WTAdditionRequestRejectIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WTAdditionRequestRejectIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTAdditionRequestRejectIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _WTAdditionRequestRejectIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    WTAdditionRequestRejectIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _WTAdditionRequestRejectIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _WTAdditionRequestRejectIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _WTAdditionRequestRejectIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< WTModificationRequest >-----#
    WTModificationRequest = SEQ(name=u'WTModificationRequest', mode=MODE_TYPE)
    _WTModificationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __WTModificationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___WTModificationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____WTModificationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____WTModificationRequest_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTModificationRequest_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTModificationRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _____WTModificationRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'PLMN-Identity')))
    _____WTModificationRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'UE-ContextInformationWTModReq')))
    _____WTModificationRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'MobilitySet')))
    ____WTModificationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _____WTModificationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _____WTModificationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____WTModificationRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 55), (u'criticality', u'ignore'), (u'Value', _____WTModificationRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 36), (u'criticality', u'reject'), (u'Value', _____WTModificationRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 54), (u'criticality', u'reject'), (u'Value', _____WTModificationRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WTModificationRequest_protocolIEs__item__id._const_tab = ____WTModificationRequest_protocolIEs__item__id_tab
    ___WTModificationRequest_protocolIEs__item__id._const_tab_at = None
    ___WTModificationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___WTModificationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___WTModificationRequest_protocolIEs__item__criticality._const_tab = ____WTModificationRequest_protocolIEs__item__id_tab
    ___WTModificationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WTModificationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WTModificationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___WTModificationRequest_protocolIEs__item__value._const_tab = ____WTModificationRequest_protocolIEs__item__id_tab
    ___WTModificationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WTModificationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __WTModificationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WTModificationRequest_protocolIEs__item__id),
        (u'criticality', ___WTModificationRequest_protocolIEs__item__criticality),
        (u'value', ___WTModificationRequest_protocolIEs__item__value),
        ])
    __WTModificationRequest_protocolIEs__item_._ext = None
    _WTModificationRequest_protocolIEs._cont = __WTModificationRequest_protocolIEs__item_
    _WTModificationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WTModificationRequest._cont = ASN1Dict([
        (u'protocolIEs', _WTModificationRequest_protocolIEs),
        ])
    WTModificationRequest._ext = []
    
    #-----< WTModificationRequestIEs >-----#
    WTModificationRequestIEs = CLASS(name=u'WTModificationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WTModificationRequestIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTModificationRequestIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTModificationRequestIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _WTModificationRequestIEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'PLMN-Identity')))
    _WTModificationRequestIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'UE-ContextInformationWTModReq')))
    _WTModificationRequestIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'MobilitySet')))
    WTModificationRequestIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _WTModificationRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _WTModificationRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _WTModificationRequestIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 55), (u'criticality', u'ignore'), (u'Value', _WTModificationRequestIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 36), (u'criticality', u'reject'), (u'Value', _WTModificationRequestIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 54), (u'criticality', u'reject'), (u'Value', _WTModificationRequestIEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UE-ContextInformationWTModReq >-----#
    UE_ContextInformationWTModReq = SEQ(name=u'UE-ContextInformationWTModReq', mode=MODE_TYPE)
    _UE_ContextInformationWTModReq_wLANSecurityInfo = SEQ(name=u'wLANSecurityInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'WLANSecurityInfo')), opt=True)
    _UE_ContextInformationWTModReq_e_RABs_ToBeAdded = SEQ_OF(name=u'e-RABs-ToBeAdded', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeAdded-List-ModReq')), opt=True)
    _UE_ContextInformationWTModReq_e_RABs_ToBeModified = SEQ_OF(name=u'e-RABs-ToBeModified', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeModified-List-ModReq')), opt=True)
    _UE_ContextInformationWTModReq_e_RABs_ToBeReleased = SEQ_OF(name=u'e-RABs-ToBeReleased', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeReleased-List-ModReq')), opt=True)
    _UE_ContextInformationWTModReq_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_ContextInformationWTModReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___UE_ContextInformationWTModReq_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UE_ContextInformationWTModReq_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____UE_ContextInformationWTModReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_ContextInformationWTModReq_iE_Extensions__item__id._const_tab = ____UE_ContextInformationWTModReq_iE_Extensions__item__id_tab
    ___UE_ContextInformationWTModReq_iE_Extensions__item__id._const_tab_at = None
    ___UE_ContextInformationWTModReq_iE_Extensions__item__id._const_tab_id = u'id'
    ___UE_ContextInformationWTModReq_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UE_ContextInformationWTModReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____UE_ContextInformationWTModReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_ContextInformationWTModReq_iE_Extensions__item__criticality._const_tab = ____UE_ContextInformationWTModReq_iE_Extensions__item__criticality_tab
    ___UE_ContextInformationWTModReq_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UE_ContextInformationWTModReq_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UE_ContextInformationWTModReq_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UE_ContextInformationWTModReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____UE_ContextInformationWTModReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_ContextInformationWTModReq_iE_Extensions__item__extensionValue._const_tab = ____UE_ContextInformationWTModReq_iE_Extensions__item__extensionValue_tab
    ___UE_ContextInformationWTModReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UE_ContextInformationWTModReq_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UE_ContextInformationWTModReq_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UE_ContextInformationWTModReq_iE_Extensions__item__id),
        (u'criticality', ___UE_ContextInformationWTModReq_iE_Extensions__item__criticality),
        (u'extensionValue', ___UE_ContextInformationWTModReq_iE_Extensions__item__extensionValue),
        ])
    __UE_ContextInformationWTModReq_iE_Extensions__item_._ext = None
    _UE_ContextInformationWTModReq_iE_Extensions._cont = __UE_ContextInformationWTModReq_iE_Extensions__item_
    _UE_ContextInformationWTModReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_ContextInformationWTModReq._cont = ASN1Dict([
        (u'wLANSecurityInfo', _UE_ContextInformationWTModReq_wLANSecurityInfo),
        (u'e-RABs-ToBeAdded', _UE_ContextInformationWTModReq_e_RABs_ToBeAdded),
        (u'e-RABs-ToBeModified', _UE_ContextInformationWTModReq_e_RABs_ToBeModified),
        (u'e-RABs-ToBeReleased', _UE_ContextInformationWTModReq_e_RABs_ToBeReleased),
        (u'iE-Extensions', _UE_ContextInformationWTModReq_iE_Extensions),
        ])
    UE_ContextInformationWTModReq._ext = []
    
    #-----< UE-ContextInformationWTModReqExtIEs >-----#
    UE_ContextInformationWTModReqExtIEs = CLASS(name=u'UE-ContextInformationWTModReqExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    UE_ContextInformationWTModReqExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-List-ModReq >-----#
    E_RABs_ToBeAdded_List_ModReq = SEQ_OF(name=u'E-RABs-ToBeAdded-List-ModReq', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_List_ModReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABs_ToBeAdded_List_ModReq__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_ToBeAdded_List_ModReq__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____E_RABs_ToBeAdded_List_ModReq__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeAdded-ModReqItem')))
    ___E_RABs_ToBeAdded_List_ModReq__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 37), (u'criticality', u'ignore'), (u'Value', ____E_RABs_ToBeAdded_List_ModReq__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeAdded_List_ModReq__item__id._const_tab = ___E_RABs_ToBeAdded_List_ModReq__item__id_tab
    __E_RABs_ToBeAdded_List_ModReq__item__id._const_tab_at = None
    __E_RABs_ToBeAdded_List_ModReq__item__id._const_tab_id = u'id'
    __E_RABs_ToBeAdded_List_ModReq__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_ToBeAdded_List_ModReq__item__criticality._const_tab = ___E_RABs_ToBeAdded_List_ModReq__item__id_tab
    __E_RABs_ToBeAdded_List_ModReq__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_ToBeAdded_List_ModReq__item__criticality._const_tab_id = u'criticality'
    __E_RABs_ToBeAdded_List_ModReq__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_ToBeAdded_List_ModReq__item__value._const_tab = ___E_RABs_ToBeAdded_List_ModReq__item__id_tab
    __E_RABs_ToBeAdded_List_ModReq__item__value._const_tab_at = ('..', u'id')
    __E_RABs_ToBeAdded_List_ModReq__item__value._const_tab_id = u'Value'
    _E_RABs_ToBeAdded_List_ModReq__item_._cont = ASN1Dict([
        (u'id', __E_RABs_ToBeAdded_List_ModReq__item__id),
        (u'criticality', __E_RABs_ToBeAdded_List_ModReq__item__criticality),
        (u'value', __E_RABs_ToBeAdded_List_ModReq__item__value),
        ])
    _E_RABs_ToBeAdded_List_ModReq__item_._ext = None
    E_RABs_ToBeAdded_List_ModReq._cont = _E_RABs_ToBeAdded_List_ModReq__item_
    E_RABs_ToBeAdded_List_ModReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeAdded-ModReqItemIEs >-----#
    E_RABs_ToBeAdded_ModReqItemIEs = CLASS(name=u'E-RABs-ToBeAdded-ModReqItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _E_RABs_ToBeAdded_ModReqItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeAdded-ModReqItem')))
    E_RABs_ToBeAdded_ModReqItemIEs._val = ASN1Set(rv=[dict([(u'id', 37), (u'criticality', u'ignore'), (u'Value', _E_RABs_ToBeAdded_ModReqItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeAdded-ModReqItem >-----#
    E_RABs_ToBeAdded_ModReqItem = SEQ(name=u'E-RABs-ToBeAdded-ModReqItem', mode=MODE_TYPE)
    _E_RABs_ToBeAdded_ModReqItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeAdded_ModReqItem_e_RAB_QoS_Parameters = SEQ(name=u'e-RAB-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-QoS-Parameters')))
    _E_RABs_ToBeAdded_ModReqItem_eNB_GTPtunnelEndpoint = SEQ(name=u'eNB-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_ToBeAdded_ModReqItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'DRB-Identity')))
    ____E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 65), (u'criticality', u'reject'), (u'Extension', _____E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__id_tab
    ___E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item_._ext = None
    _E_RABs_ToBeAdded_ModReqItem_iE_Extensions._cont = __E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item_
    _E_RABs_ToBeAdded_ModReqItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeAdded_ModReqItem._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeAdded_ModReqItem_e_RAB_ID),
        (u'e-RAB-QoS-Parameters', _E_RABs_ToBeAdded_ModReqItem_e_RAB_QoS_Parameters),
        (u'eNB-GTPtunnelEndpoint', _E_RABs_ToBeAdded_ModReqItem_eNB_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_ToBeAdded_ModReqItem_iE_Extensions),
        ])
    E_RABs_ToBeAdded_ModReqItem._ext = []
    
    #-----< E-RABs-ToBeAdded-ModReqItemExtIEs >-----#
    E_RABs_ToBeAdded_ModReqItemExtIEs = CLASS(name=u'E-RABs-ToBeAdded-ModReqItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeAdded_ModReqItemExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'DRB-Identity')))
    E_RABs_ToBeAdded_ModReqItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 65), (u'criticality', u'reject'), (u'Extension', _E_RABs_ToBeAdded_ModReqItemExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeModified-List-ModReq >-----#
    E_RABs_ToBeModified_List_ModReq = SEQ_OF(name=u'E-RABs-ToBeModified-List-ModReq', mode=MODE_TYPE)
    _E_RABs_ToBeModified_List_ModReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABs_ToBeModified_List_ModReq__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_ToBeModified_List_ModReq__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____E_RABs_ToBeModified_List_ModReq__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeModified-ModReqItem')))
    ___E_RABs_ToBeModified_List_ModReq__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 38), (u'criticality', u'ignore'), (u'Value', ____E_RABs_ToBeModified_List_ModReq__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeModified_List_ModReq__item__id._const_tab = ___E_RABs_ToBeModified_List_ModReq__item__id_tab
    __E_RABs_ToBeModified_List_ModReq__item__id._const_tab_at = None
    __E_RABs_ToBeModified_List_ModReq__item__id._const_tab_id = u'id'
    __E_RABs_ToBeModified_List_ModReq__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_ToBeModified_List_ModReq__item__criticality._const_tab = ___E_RABs_ToBeModified_List_ModReq__item__id_tab
    __E_RABs_ToBeModified_List_ModReq__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_ToBeModified_List_ModReq__item__criticality._const_tab_id = u'criticality'
    __E_RABs_ToBeModified_List_ModReq__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_ToBeModified_List_ModReq__item__value._const_tab = ___E_RABs_ToBeModified_List_ModReq__item__id_tab
    __E_RABs_ToBeModified_List_ModReq__item__value._const_tab_at = ('..', u'id')
    __E_RABs_ToBeModified_List_ModReq__item__value._const_tab_id = u'Value'
    _E_RABs_ToBeModified_List_ModReq__item_._cont = ASN1Dict([
        (u'id', __E_RABs_ToBeModified_List_ModReq__item__id),
        (u'criticality', __E_RABs_ToBeModified_List_ModReq__item__criticality),
        (u'value', __E_RABs_ToBeModified_List_ModReq__item__value),
        ])
    _E_RABs_ToBeModified_List_ModReq__item_._ext = None
    E_RABs_ToBeModified_List_ModReq._cont = _E_RABs_ToBeModified_List_ModReq__item_
    E_RABs_ToBeModified_List_ModReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeModified-ModReqItemIEs >-----#
    E_RABs_ToBeModified_ModReqItemIEs = CLASS(name=u'E-RABs-ToBeModified-ModReqItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _E_RABs_ToBeModified_ModReqItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeModified-ModReqItem')))
    E_RABs_ToBeModified_ModReqItemIEs._val = ASN1Set(rv=[dict([(u'id', 38), (u'criticality', u'ignore'), (u'Value', _E_RABs_ToBeModified_ModReqItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeModified-ModReqItem >-----#
    E_RABs_ToBeModified_ModReqItem = SEQ(name=u'E-RABs-ToBeModified-ModReqItem', mode=MODE_TYPE)
    _E_RABs_ToBeModified_ModReqItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeModified_ModReqItem_e_RAB_QoS_Parameters = SEQ(name=u'e-RAB-QoS-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-QoS-Parameters')), opt=True)
    _E_RABs_ToBeModified_ModReqItem_eNB_GTPtunnelEndpoint = SEQ(name=u'eNB-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeModified_ModReqItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeModified_ModReqItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeModified_ModReqItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeModified_ModReqItem_iE_Extensions__item_._ext = None
    _E_RABs_ToBeModified_ModReqItem_iE_Extensions._cont = __E_RABs_ToBeModified_ModReqItem_iE_Extensions__item_
    _E_RABs_ToBeModified_ModReqItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeModified_ModReqItem._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeModified_ModReqItem_e_RAB_ID),
        (u'e-RAB-QoS-Parameters', _E_RABs_ToBeModified_ModReqItem_e_RAB_QoS_Parameters),
        (u'eNB-GTPtunnelEndpoint', _E_RABs_ToBeModified_ModReqItem_eNB_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_ToBeModified_ModReqItem_iE_Extensions),
        ])
    E_RABs_ToBeModified_ModReqItem._ext = []
    
    #-----< E-RABs-ToBeModified-ModReqItemExtIEs >-----#
    E_RABs_ToBeModified_ModReqItemExtIEs = CLASS(name=u'E-RABs-ToBeModified-ModReqItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeModified_ModReqItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-List-ModReq >-----#
    E_RABs_ToBeReleased_List_ModReq = SEQ_OF(name=u'E-RABs-ToBeReleased-List-ModReq', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_List_ModReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABs_ToBeReleased_List_ModReq__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_ToBeReleased_List_ModReq__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____E_RABs_ToBeReleased_List_ModReq__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqItem')))
    ___E_RABs_ToBeReleased_List_ModReq__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'ignore'), (u'Value', ____E_RABs_ToBeReleased_List_ModReq__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeReleased_List_ModReq__item__id._const_tab = ___E_RABs_ToBeReleased_List_ModReq__item__id_tab
    __E_RABs_ToBeReleased_List_ModReq__item__id._const_tab_at = None
    __E_RABs_ToBeReleased_List_ModReq__item__id._const_tab_id = u'id'
    __E_RABs_ToBeReleased_List_ModReq__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_ToBeReleased_List_ModReq__item__criticality._const_tab = ___E_RABs_ToBeReleased_List_ModReq__item__id_tab
    __E_RABs_ToBeReleased_List_ModReq__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_ToBeReleased_List_ModReq__item__criticality._const_tab_id = u'criticality'
    __E_RABs_ToBeReleased_List_ModReq__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_ToBeReleased_List_ModReq__item__value._const_tab = ___E_RABs_ToBeReleased_List_ModReq__item__id_tab
    __E_RABs_ToBeReleased_List_ModReq__item__value._const_tab_at = ('..', u'id')
    __E_RABs_ToBeReleased_List_ModReq__item__value._const_tab_id = u'Value'
    _E_RABs_ToBeReleased_List_ModReq__item_._cont = ASN1Dict([
        (u'id', __E_RABs_ToBeReleased_List_ModReq__item__id),
        (u'criticality', __E_RABs_ToBeReleased_List_ModReq__item__criticality),
        (u'value', __E_RABs_ToBeReleased_List_ModReq__item__value),
        ])
    _E_RABs_ToBeReleased_List_ModReq__item_._ext = None
    E_RABs_ToBeReleased_List_ModReq._cont = _E_RABs_ToBeReleased_List_ModReq__item_
    E_RABs_ToBeReleased_List_ModReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeReleased-ModReqItemIEs >-----#
    E_RABs_ToBeReleased_ModReqItemIEs = CLASS(name=u'E-RABs-ToBeReleased-ModReqItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _E_RABs_ToBeReleased_ModReqItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqItem')))
    E_RABs_ToBeReleased_ModReqItemIEs._val = ASN1Set(rv=[dict([(u'id', 39), (u'criticality', u'ignore'), (u'Value', _E_RABs_ToBeReleased_ModReqItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-ModReqItem >-----#
    E_RABs_ToBeReleased_ModReqItem = SEQ(name=u'E-RABs-ToBeReleased-ModReqItem', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_ModReqItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_ModReqItem_dL_GTPtunnelEndpoint = SEQ(name=u'dL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_ModReqItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_ModReqItem_iE_Extensions._cont = __E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item_
    _E_RABs_ToBeReleased_ModReqItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_ModReqItem._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeReleased_ModReqItem_e_RAB_ID),
        (u'dL-GTPtunnelEndpoint', _E_RABs_ToBeReleased_ModReqItem_dL_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_ToBeReleased_ModReqItem_iE_Extensions),
        ])
    E_RABs_ToBeReleased_ModReqItem._ext = []
    
    #-----< E-RABs-ToBeReleased-ModReqItemExtIEs >-----#
    E_RABs_ToBeReleased_ModReqItemExtIEs = CLASS(name=u'E-RABs-ToBeReleased-ModReqItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_ModReqItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WTModificationRequestAcknowledge >-----#
    WTModificationRequestAcknowledge = SEQ(name=u'WTModificationRequestAcknowledge', mode=MODE_TYPE)
    _WTModificationRequestAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __WTModificationRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___WTModificationRequestAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____WTModificationRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____WTModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-ModAckList')))
    _____WTModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-ModAckList')))
    _____WTModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Admitted-ToBeReleased-ModAckList')))
    _____WTModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-List')))
    _____WTModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    ____WTModificationRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _____WTModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _____WTModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'ignore'), (u'Value', _____WTModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 42), (u'criticality', u'ignore'), (u'Value', _____WTModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 44), (u'criticality', u'ignore'), (u'Value', _____WTModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 34), (u'criticality', u'ignore'), (u'Value', _____WTModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____WTModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WTModificationRequestAcknowledge_protocolIEs__item__id._const_tab = ____WTModificationRequestAcknowledge_protocolIEs__item__id_tab
    ___WTModificationRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___WTModificationRequestAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___WTModificationRequestAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___WTModificationRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____WTModificationRequestAcknowledge_protocolIEs__item__id_tab
    ___WTModificationRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WTModificationRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WTModificationRequestAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___WTModificationRequestAcknowledge_protocolIEs__item__value._const_tab = ____WTModificationRequestAcknowledge_protocolIEs__item__id_tab
    ___WTModificationRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WTModificationRequestAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __WTModificationRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WTModificationRequestAcknowledge_protocolIEs__item__id),
        (u'criticality', ___WTModificationRequestAcknowledge_protocolIEs__item__criticality),
        (u'value', ___WTModificationRequestAcknowledge_protocolIEs__item__value),
        ])
    __WTModificationRequestAcknowledge_protocolIEs__item_._ext = None
    _WTModificationRequestAcknowledge_protocolIEs._cont = __WTModificationRequestAcknowledge_protocolIEs__item_
    _WTModificationRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WTModificationRequestAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _WTModificationRequestAcknowledge_protocolIEs),
        ])
    WTModificationRequestAcknowledge._ext = []
    
    #-----< WTModificationRequestAcknowledgeIEs >-----#
    WTModificationRequestAcknowledgeIEs = CLASS(name=u'WTModificationRequestAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WTModificationRequestAcknowledgeIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTModificationRequestAcknowledgeIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTModificationRequestAcknowledgeIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-ModAckList')))
    _WTModificationRequestAcknowledgeIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-ModAckList')))
    _WTModificationRequestAcknowledgeIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Admitted-ToBeReleased-ModAckList')))
    _WTModificationRequestAcknowledgeIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-List')))
    _WTModificationRequestAcknowledgeIEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    WTModificationRequestAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _WTModificationRequestAcknowledgeIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _WTModificationRequestAcknowledgeIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 40), (u'criticality', u'ignore'), (u'Value', _WTModificationRequestAcknowledgeIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 42), (u'criticality', u'ignore'), (u'Value', _WTModificationRequestAcknowledgeIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 44), (u'criticality', u'ignore'), (u'Value', _WTModificationRequestAcknowledgeIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 34), (u'criticality', u'ignore'), (u'Value', _WTModificationRequestAcknowledgeIEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _WTModificationRequestAcknowledgeIEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-ModAckList >-----#
    E_RABs_Admitted_ToBeAdded_ModAckList = SEQ_OF(name=u'E-RABs-Admitted-ToBeAdded-ModAckList', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_ModAckList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-ModAckItem')))
    ___E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 41), (u'criticality', u'ignore'), (u'Value', ____E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__id._const_tab = ___E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__id._const_tab_at = None
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__id._const_tab_id = u'id'
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__criticality._const_tab = ___E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__criticality._const_tab_id = u'criticality'
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__value._const_tab = ___E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__value._const_tab_at = ('..', u'id')
    __E_RABs_Admitted_ToBeAdded_ModAckList__item__value._const_tab_id = u'Value'
    _E_RABs_Admitted_ToBeAdded_ModAckList__item_._cont = ASN1Dict([
        (u'id', __E_RABs_Admitted_ToBeAdded_ModAckList__item__id),
        (u'criticality', __E_RABs_Admitted_ToBeAdded_ModAckList__item__criticality),
        (u'value', __E_RABs_Admitted_ToBeAdded_ModAckList__item__value),
        ])
    _E_RABs_Admitted_ToBeAdded_ModAckList__item_._ext = None
    E_RABs_Admitted_ToBeAdded_ModAckList._cont = _E_RABs_Admitted_ToBeAdded_ModAckList__item_
    E_RABs_Admitted_ToBeAdded_ModAckList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-ModAckItemIEs >-----#
    E_RABs_Admitted_ToBeAdded_ModAckItemIEs = CLASS(name=u'E-RABs-Admitted-ToBeAdded-ModAckItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _E_RABs_Admitted_ToBeAdded_ModAckItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-ModAckItem')))
    E_RABs_Admitted_ToBeAdded_ModAckItemIEs._val = ASN1Set(rv=[dict([(u'id', 41), (u'criticality', u'ignore'), (u'Value', _E_RABs_Admitted_ToBeAdded_ModAckItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeAdded-ModAckItem >-----#
    E_RABs_Admitted_ToBeAdded_ModAckItem = SEQ(name=u'E-RABs-Admitted-ToBeAdded-ModAckItem', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeAdded_ModAckItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeAdded_ModAckItem_wT_GTPtunnelEndpoint = SEQ(name=u'wT-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'GTPtunnelEndpoint')))
    _E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    _____E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'LWA-WLAN-AC')))
    ____E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 66), (u'criticality', u'ignore'), (u'Extension', _____E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions._cont = __E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item_
    _E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeAdded_ModAckItem._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_Admitted_ToBeAdded_ModAckItem_e_RAB_ID),
        (u'wT-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeAdded_ModAckItem_wT_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeAdded_ModAckItem._ext = []
    
    #-----< E-RABs-Admitted-ToBeAdded-ModAckItemExtIEs >-----#
    E_RABs_Admitted_ToBeAdded_ModAckItemExtIEs = CLASS(name=u'E-RABs-Admitted-ToBeAdded-ModAckItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    _E_RABs_Admitted_ToBeAdded_ModAckItemExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'LWA-WLAN-AC')))
    E_RABs_Admitted_ToBeAdded_ModAckItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 66), (u'criticality', u'ignore'), (u'Extension', _E_RABs_Admitted_ToBeAdded_ModAckItemExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeModified-ModAckList >-----#
    E_RABs_Admitted_ToBeModified_ModAckList = SEQ_OF(name=u'E-RABs-Admitted-ToBeModified-ModAckList', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeModified_ModAckList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABs_Admitted_ToBeModified_ModAckList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-ModAckItem')))
    ___E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', ____E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_Admitted_ToBeModified_ModAckList__item__id._const_tab = ___E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeModified_ModAckList__item__id._const_tab_at = None
    __E_RABs_Admitted_ToBeModified_ModAckList__item__id._const_tab_id = u'id'
    __E_RABs_Admitted_ToBeModified_ModAckList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_Admitted_ToBeModified_ModAckList__item__criticality._const_tab = ___E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeModified_ModAckList__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_Admitted_ToBeModified_ModAckList__item__criticality._const_tab_id = u'criticality'
    __E_RABs_Admitted_ToBeModified_ModAckList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_Admitted_ToBeModified_ModAckList__item__value._const_tab = ___E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeModified_ModAckList__item__value._const_tab_at = ('..', u'id')
    __E_RABs_Admitted_ToBeModified_ModAckList__item__value._const_tab_id = u'Value'
    _E_RABs_Admitted_ToBeModified_ModAckList__item_._cont = ASN1Dict([
        (u'id', __E_RABs_Admitted_ToBeModified_ModAckList__item__id),
        (u'criticality', __E_RABs_Admitted_ToBeModified_ModAckList__item__criticality),
        (u'value', __E_RABs_Admitted_ToBeModified_ModAckList__item__value),
        ])
    _E_RABs_Admitted_ToBeModified_ModAckList__item_._ext = None
    E_RABs_Admitted_ToBeModified_ModAckList._cont = _E_RABs_Admitted_ToBeModified_ModAckList__item_
    E_RABs_Admitted_ToBeModified_ModAckList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeModified-ModAckItemIEs >-----#
    E_RABs_Admitted_ToBeModified_ModAckItemIEs = CLASS(name=u'E-RABs-Admitted-ToBeModified-ModAckItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _E_RABs_Admitted_ToBeModified_ModAckItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Admitted-ToBeModified-ModAckItem')))
    E_RABs_Admitted_ToBeModified_ModAckItemIEs._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', _E_RABs_Admitted_ToBeModified_ModAckItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeModified-ModAckItem >-----#
    E_RABs_Admitted_ToBeModified_ModAckItem = SEQ(name=u'E-RABs-Admitted-ToBeModified-ModAckItem', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeModified_ModAckItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeModified_ModAckItem_wT_GTPtunnelEndpoint = SEQ(name=u'wT-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    _____E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'LWA-WLAN-AC')))
    ____E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 66), (u'criticality', u'ignore'), (u'Extension', _____E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions._cont = __E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item_
    _E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeModified_ModAckItem._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_Admitted_ToBeModified_ModAckItem_e_RAB_ID),
        (u'wT-GTPtunnelEndpoint', _E_RABs_Admitted_ToBeModified_ModAckItem_wT_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeModified_ModAckItem._ext = []
    
    #-----< E-RABs-Admitted-ToBeModified-ModAckItemExtIEs >-----#
    E_RABs_Admitted_ToBeModified_ModAckItemExtIEs = CLASS(name=u'E-RABs-Admitted-ToBeModified-ModAckItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    _E_RABs_Admitted_ToBeModified_ModAckItemExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'LWA-WLAN-AC')))
    E_RABs_Admitted_ToBeModified_ModAckItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 66), (u'criticality', u'ignore'), (u'Extension', _E_RABs_Admitted_ToBeModified_ModAckItemExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Admitted-ToBeReleased-ModAckList >-----#
    E_RABs_Admitted_ToBeReleased_ModAckList = SEQ_OF(name=u'E-RABs-Admitted-ToBeReleased-ModAckList', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeReleased_ModAckList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Admitted-ToBeReleased-ModAckItem')))
    ___E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 45), (u'criticality', u'ignore'), (u'Value', ____E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__id._const_tab = ___E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__id._const_tab_at = None
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__id._const_tab_id = u'id'
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__criticality._const_tab = ___E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__criticality._const_tab_id = u'criticality'
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__value._const_tab = ___E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__value._const_tab_at = ('..', u'id')
    __E_RABs_Admitted_ToBeReleased_ModAckList__item__value._const_tab_id = u'Value'
    _E_RABs_Admitted_ToBeReleased_ModAckList__item_._cont = ASN1Dict([
        (u'id', __E_RABs_Admitted_ToBeReleased_ModAckList__item__id),
        (u'criticality', __E_RABs_Admitted_ToBeReleased_ModAckList__item__criticality),
        (u'value', __E_RABs_Admitted_ToBeReleased_ModAckList__item__value),
        ])
    _E_RABs_Admitted_ToBeReleased_ModAckList__item_._ext = None
    E_RABs_Admitted_ToBeReleased_ModAckList._cont = _E_RABs_Admitted_ToBeReleased_ModAckList__item_
    E_RABs_Admitted_ToBeReleased_ModAckList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeReleased-ModAckItemIEs >-----#
    E_RABs_Admitted_ToBeReleased_ModAckItemIEs = CLASS(name=u'E-RABs-Admitted-ToBeReleased-ModAckItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _E_RABs_Admitted_ToBeReleased_ModAckItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Admitted-ToBeReleased-ModAckItem')))
    E_RABs_Admitted_ToBeReleased_ModAckItemIEs._val = ASN1Set(rv=[dict([(u'id', 45), (u'criticality', u'ignore'), (u'Value', _E_RABs_Admitted_ToBeReleased_ModAckItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< E-RABs-Admitted-ToBeReleased-ModAckItem >-----#
    E_RABs_Admitted_ToBeReleased_ModAckItem = SEQ(name=u'E-RABs-Admitted-ToBeReleased-ModAckItem', mode=MODE_TYPE)
    _E_RABs_Admitted_ToBeReleased_ModAckItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-ID')))
    _E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__id._const_tab = ____E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__id_tab
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__criticality._const_tab = ____E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__criticality_tab
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__extensionValue_tab
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item_._ext = None
    _E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions._cont = __E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item_
    _E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Admitted_ToBeReleased_ModAckItem._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_Admitted_ToBeReleased_ModAckItem_e_RAB_ID),
        (u'iE-Extensions', _E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions),
        ])
    E_RABs_Admitted_ToBeReleased_ModAckItem._ext = []
    
    #-----< E-RABs-Admitted-ToBeReleased-ModAckItemExtIEs >-----#
    E_RABs_Admitted_ToBeReleased_ModAckItemExtIEs = CLASS(name=u'E-RABs-Admitted-ToBeReleased-ModAckItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    E_RABs_Admitted_ToBeReleased_ModAckItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WTModificationRequestReject >-----#
    WTModificationRequestReject = SEQ(name=u'WTModificationRequestReject', mode=MODE_TYPE)
    _WTModificationRequestReject_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __WTModificationRequestReject_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___WTModificationRequestReject_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____WTModificationRequestReject_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____WTModificationRequestReject_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTModificationRequestReject_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTModificationRequestReject_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _____WTModificationRequestReject_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    ____WTModificationRequestReject_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _____WTModificationRequestReject_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _____WTModificationRequestReject_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____WTModificationRequestReject_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____WTModificationRequestReject_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WTModificationRequestReject_protocolIEs__item__id._const_tab = ____WTModificationRequestReject_protocolIEs__item__id_tab
    ___WTModificationRequestReject_protocolIEs__item__id._const_tab_at = None
    ___WTModificationRequestReject_protocolIEs__item__id._const_tab_id = u'id'
    ___WTModificationRequestReject_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___WTModificationRequestReject_protocolIEs__item__criticality._const_tab = ____WTModificationRequestReject_protocolIEs__item__id_tab
    ___WTModificationRequestReject_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WTModificationRequestReject_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WTModificationRequestReject_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___WTModificationRequestReject_protocolIEs__item__value._const_tab = ____WTModificationRequestReject_protocolIEs__item__id_tab
    ___WTModificationRequestReject_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WTModificationRequestReject_protocolIEs__item__value._const_tab_id = u'Value'
    __WTModificationRequestReject_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WTModificationRequestReject_protocolIEs__item__id),
        (u'criticality', ___WTModificationRequestReject_protocolIEs__item__criticality),
        (u'value', ___WTModificationRequestReject_protocolIEs__item__value),
        ])
    __WTModificationRequestReject_protocolIEs__item_._ext = None
    _WTModificationRequestReject_protocolIEs._cont = __WTModificationRequestReject_protocolIEs__item_
    _WTModificationRequestReject_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WTModificationRequestReject._cont = ASN1Dict([
        (u'protocolIEs', _WTModificationRequestReject_protocolIEs),
        ])
    WTModificationRequestReject._ext = []
    
    #-----< WTModificationRequestRejectIEs >-----#
    WTModificationRequestRejectIEs = CLASS(name=u'WTModificationRequestRejectIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WTModificationRequestRejectIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTModificationRequestRejectIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTModificationRequestRejectIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _WTModificationRequestRejectIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    WTModificationRequestRejectIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _WTModificationRequestRejectIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _WTModificationRequestRejectIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _WTModificationRequestRejectIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _WTModificationRequestRejectIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< WTModificationRequired >-----#
    WTModificationRequired = SEQ(name=u'WTModificationRequired', mode=MODE_TYPE)
    _WTModificationRequired_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __WTModificationRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___WTModificationRequired_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____WTModificationRequired_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____WTModificationRequired_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTModificationRequired_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTModificationRequired_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _____WTModificationRequired_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqdList')))
    _____WTModificationRequired_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeModified-ModReqdList')))
    ____WTModificationRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _____WTModificationRequired_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _____WTModificationRequired_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____WTModificationRequired_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 46), (u'criticality', u'ignore'), (u'Value', _____WTModificationRequired_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 56), (u'criticality', u'ignore'), (u'Value', _____WTModificationRequired_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WTModificationRequired_protocolIEs__item__id._const_tab = ____WTModificationRequired_protocolIEs__item__id_tab
    ___WTModificationRequired_protocolIEs__item__id._const_tab_at = None
    ___WTModificationRequired_protocolIEs__item__id._const_tab_id = u'id'
    ___WTModificationRequired_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___WTModificationRequired_protocolIEs__item__criticality._const_tab = ____WTModificationRequired_protocolIEs__item__id_tab
    ___WTModificationRequired_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WTModificationRequired_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WTModificationRequired_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___WTModificationRequired_protocolIEs__item__value._const_tab = ____WTModificationRequired_protocolIEs__item__id_tab
    ___WTModificationRequired_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WTModificationRequired_protocolIEs__item__value._const_tab_id = u'Value'
    __WTModificationRequired_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WTModificationRequired_protocolIEs__item__id),
        (u'criticality', ___WTModificationRequired_protocolIEs__item__criticality),
        (u'value', ___WTModificationRequired_protocolIEs__item__value),
        ])
    __WTModificationRequired_protocolIEs__item_._ext = None
    _WTModificationRequired_protocolIEs._cont = __WTModificationRequired_protocolIEs__item_
    _WTModificationRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WTModificationRequired._cont = ASN1Dict([
        (u'protocolIEs', _WTModificationRequired_protocolIEs),
        ])
    WTModificationRequired._ext = []
    
    #-----< WTModificationRequiredIEs >-----#
    WTModificationRequiredIEs = CLASS(name=u'WTModificationRequiredIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WTModificationRequiredIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTModificationRequiredIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTModificationRequiredIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _WTModificationRequiredIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqdList')))
    _WTModificationRequiredIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeModified-ModReqdList')))
    WTModificationRequiredIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _WTModificationRequiredIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _WTModificationRequiredIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _WTModificationRequiredIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 46), (u'criticality', u'ignore'), (u'Value', _WTModificationRequiredIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 56), (u'criticality', u'ignore'), (u'Value', _WTModificationRequiredIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-ModReqdList >-----#
    E_RABs_ToBeReleased_ModReqdList = SEQ_OF(name=u'E-RABs-ToBeReleased-ModReqdList', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_ModReqdList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABs_ToBeReleased_ModReqdList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_ToBeReleased_ModReqdList__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____E_RABs_ToBeReleased_ModReqdList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqdItem')))
    ___E_RABs_ToBeReleased_ModReqdList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 47), (u'criticality', u'ignore'), (u'Value', ____E_RABs_ToBeReleased_ModReqdList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeReleased_ModReqdList__item__id._const_tab = ___E_RABs_ToBeReleased_ModReqdList__item__id_tab
    __E_RABs_ToBeReleased_ModReqdList__item__id._const_tab_at = None
    __E_RABs_ToBeReleased_ModReqdList__item__id._const_tab_id = u'id'
    __E_RABs_ToBeReleased_ModReqdList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_ToBeReleased_ModReqdList__item__criticality._const_tab = ___E_RABs_ToBeReleased_ModReqdList__item__id_tab
    __E_RABs_ToBeReleased_ModReqdList__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_ToBeReleased_ModReqdList__item__criticality._const_tab_id = u'criticality'
    __E_RABs_ToBeReleased_ModReqdList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_ToBeReleased_ModReqdList__item__value._const_tab = ___E_RABs_ToBeReleased_ModReqdList__item__id_tab
    __E_RABs_ToBeReleased_ModReqdList__item__value._const_tab_at = ('..', u'id')
    __E_RABs_ToBeReleased_ModReqdList__item__value._const_tab_id = u'Value'
    _E_RABs_ToBeReleased_ModReqdList__item_._cont = ASN1Dict([
        (u'id', __E_RABs_ToBeReleased_ModReqdList__item__id),
        (u'criticality', __E_RABs_ToBeReleased_ModReqdList__item__criticality),
        (u'value', __E_RABs_ToBeReleased_ModReqdList__item__value),
        ])
    _E_RABs_ToBeReleased_ModReqdList__item_._ext = None
    E_RABs_ToBeReleased_ModReqdList._cont = _E_RABs_ToBeReleased_ModReqdList__item_
    E_RABs_ToBeReleased_ModReqdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeReleased-ModReqdItemIEs >-----#
    E_RABs_ToBeReleased_ModReqdItemIEs = CLASS(name=u'E-RABs-ToBeReleased-ModReqdItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _E_RABs_ToBeReleased_ModReqdItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeReleased-ModReqdItem')))
    E_RABs_ToBeReleased_ModReqdItemIEs._val = ASN1Set(rv=[dict([(u'id', 47), (u'criticality', u'ignore'), (u'Value', _E_RABs_ToBeReleased_ModReqdItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-ModReqdItem >-----#
    E_RABs_ToBeReleased_ModReqdItem = SEQ(name=u'E-RABs-ToBeReleased-ModReqdItem', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_ModReqdItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_ModReqdItem_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _E_RABs_ToBeReleased_ModReqdItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_ModReqdItem_iE_Extensions._cont = __E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item_
    _E_RABs_ToBeReleased_ModReqdItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_ModReqdItem._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeReleased_ModReqdItem_e_RAB_ID),
        (u'cause', _E_RABs_ToBeReleased_ModReqdItem_cause),
        (u'iE-Extensions', _E_RABs_ToBeReleased_ModReqdItem_iE_Extensions),
        ])
    E_RABs_ToBeReleased_ModReqdItem._ext = []
    
    #-----< E-RABs-ToBeReleased-ModReqdItemExtIEs >-----#
    E_RABs_ToBeReleased_ModReqdItemExtIEs = CLASS(name=u'E-RABs-ToBeReleased-ModReqdItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_ModReqdItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeModified-ModReqdList >-----#
    E_RABs_ToBeModified_ModReqdList = SEQ_OF(name=u'E-RABs-ToBeModified-ModReqdList', mode=MODE_TYPE)
    _E_RABs_ToBeModified_ModReqdList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABs_ToBeModified_ModReqdList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_ToBeModified_ModReqdList__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____E_RABs_ToBeModified_ModReqdList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeModified-ModReqdItem')))
    ___E_RABs_ToBeModified_ModReqdList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 57), (u'criticality', u'ignore'), (u'Value', ____E_RABs_ToBeModified_ModReqdList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeModified_ModReqdList__item__id._const_tab = ___E_RABs_ToBeModified_ModReqdList__item__id_tab
    __E_RABs_ToBeModified_ModReqdList__item__id._const_tab_at = None
    __E_RABs_ToBeModified_ModReqdList__item__id._const_tab_id = u'id'
    __E_RABs_ToBeModified_ModReqdList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_ToBeModified_ModReqdList__item__criticality._const_tab = ___E_RABs_ToBeModified_ModReqdList__item__id_tab
    __E_RABs_ToBeModified_ModReqdList__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_ToBeModified_ModReqdList__item__criticality._const_tab_id = u'criticality'
    __E_RABs_ToBeModified_ModReqdList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_ToBeModified_ModReqdList__item__value._const_tab = ___E_RABs_ToBeModified_ModReqdList__item__id_tab
    __E_RABs_ToBeModified_ModReqdList__item__value._const_tab_at = ('..', u'id')
    __E_RABs_ToBeModified_ModReqdList__item__value._const_tab_id = u'Value'
    _E_RABs_ToBeModified_ModReqdList__item_._cont = ASN1Dict([
        (u'id', __E_RABs_ToBeModified_ModReqdList__item__id),
        (u'criticality', __E_RABs_ToBeModified_ModReqdList__item__criticality),
        (u'value', __E_RABs_ToBeModified_ModReqdList__item__value),
        ])
    _E_RABs_ToBeModified_ModReqdList__item_._ext = None
    E_RABs_ToBeModified_ModReqdList._cont = _E_RABs_ToBeModified_ModReqdList__item_
    E_RABs_ToBeModified_ModReqdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeModified-ModReqdItemIEs >-----#
    E_RABs_ToBeModified_ModReqdItemIEs = CLASS(name=u'E-RABs-ToBeModified-ModReqdItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _E_RABs_ToBeModified_ModReqdItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeModified-ModReqdItem')))
    E_RABs_ToBeModified_ModReqdItemIEs._val = ASN1Set(rv=[dict([(u'id', 57), (u'criticality', u'ignore'), (u'Value', _E_RABs_ToBeModified_ModReqdItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeModified-ModReqdItem >-----#
    E_RABs_ToBeModified_ModReqdItem = SEQ(name=u'E-RABs-ToBeModified-ModReqdItem', mode=MODE_TYPE)
    _E_RABs_ToBeModified_ModReqdItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeModified_ModReqdItem_wT_GTPtunnelEndpoint = SEQ(name=u'wT-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeModified_ModReqdItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    _____E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'LWA-WLAN-AC')))
    ____E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 66), (u'criticality', u'ignore'), (u'Extension', _____E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__id_tab
    ___E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item_._ext = None
    _E_RABs_ToBeModified_ModReqdItem_iE_Extensions._cont = __E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item_
    _E_RABs_ToBeModified_ModReqdItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeModified_ModReqdItem._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeModified_ModReqdItem_e_RAB_ID),
        (u'wT-GTPtunnelEndpoint', _E_RABs_ToBeModified_ModReqdItem_wT_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_ToBeModified_ModReqdItem_iE_Extensions),
        ])
    E_RABs_ToBeModified_ModReqdItem._ext = []
    
    #-----< E-RABs-ToBeModified-ModReqdItemExtIEs >-----#
    E_RABs_ToBeModified_ModReqdItemExtIEs = CLASS(name=u'E-RABs-ToBeModified-ModReqdItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    _E_RABs_ToBeModified_ModReqdItemExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'LWA-WLAN-AC')))
    E_RABs_ToBeModified_ModReqdItemExtIEs._val = ASN1Set(rv=[dict([(u'id', 66), (u'criticality', u'ignore'), (u'Extension', _E_RABs_ToBeModified_ModReqdItemExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< WTModificationConfirm >-----#
    WTModificationConfirm = SEQ(name=u'WTModificationConfirm', mode=MODE_TYPE)
    _WTModificationConfirm_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __WTModificationConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___WTModificationConfirm_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____WTModificationConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____WTModificationConfirm_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTModificationConfirm_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTModificationConfirm_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Confirmed-ToBeReleased-ModReqdList')))
    _____WTModificationConfirm_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Confirmed-ToBeModified-ModReqdList')))
    _____WTModificationConfirm_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    ____WTModificationConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _____WTModificationConfirm_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _____WTModificationConfirm_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 52), (u'criticality', u'ignore'), (u'Value', _____WTModificationConfirm_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _____WTModificationConfirm_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____WTModificationConfirm_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WTModificationConfirm_protocolIEs__item__id._const_tab = ____WTModificationConfirm_protocolIEs__item__id_tab
    ___WTModificationConfirm_protocolIEs__item__id._const_tab_at = None
    ___WTModificationConfirm_protocolIEs__item__id._const_tab_id = u'id'
    ___WTModificationConfirm_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___WTModificationConfirm_protocolIEs__item__criticality._const_tab = ____WTModificationConfirm_protocolIEs__item__id_tab
    ___WTModificationConfirm_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WTModificationConfirm_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WTModificationConfirm_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___WTModificationConfirm_protocolIEs__item__value._const_tab = ____WTModificationConfirm_protocolIEs__item__id_tab
    ___WTModificationConfirm_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WTModificationConfirm_protocolIEs__item__value._const_tab_id = u'Value'
    __WTModificationConfirm_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WTModificationConfirm_protocolIEs__item__id),
        (u'criticality', ___WTModificationConfirm_protocolIEs__item__criticality),
        (u'value', ___WTModificationConfirm_protocolIEs__item__value),
        ])
    __WTModificationConfirm_protocolIEs__item_._ext = None
    _WTModificationConfirm_protocolIEs._cont = __WTModificationConfirm_protocolIEs__item_
    _WTModificationConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WTModificationConfirm._cont = ASN1Dict([
        (u'protocolIEs', _WTModificationConfirm_protocolIEs),
        ])
    WTModificationConfirm._ext = []
    
    #-----< WTModificationConfirmIEs >-----#
    WTModificationConfirmIEs = CLASS(name=u'WTModificationConfirmIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WTModificationConfirmIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTModificationConfirmIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTModificationConfirmIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Confirmed-ToBeReleased-ModReqdList')))
    _WTModificationConfirmIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Confirmed-ToBeModified-ModReqdList')))
    _WTModificationConfirmIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    WTModificationConfirmIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _WTModificationConfirmIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _WTModificationConfirmIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 52), (u'criticality', u'ignore'), (u'Value', _WTModificationConfirmIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 58), (u'criticality', u'ignore'), (u'Value', _WTModificationConfirmIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _WTModificationConfirmIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Confirmed-ToBeReleased-ModReqdList >-----#
    E_RABs_Confirmed_ToBeReleased_ModReqdList = SEQ_OF(name=u'E-RABs-Confirmed-ToBeReleased-ModReqdList', mode=MODE_TYPE)
    _E_RABs_Confirmed_ToBeReleased_ModReqdList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABs_Confirmed_ToBeReleased_ModReqdList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_Confirmed_ToBeReleased_ModReqdList__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____E_RABs_Confirmed_ToBeReleased_ModReqdList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Confirmed-ToBeReleased-ModReqdItem')))
    ___E_RABs_Confirmed_ToBeReleased_ModReqdList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 53), (u'criticality', u'ignore'), (u'Value', ____E_RABs_Confirmed_ToBeReleased_ModReqdList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_Confirmed_ToBeReleased_ModReqdList__item__id._const_tab = ___E_RABs_Confirmed_ToBeReleased_ModReqdList__item__id_tab
    __E_RABs_Confirmed_ToBeReleased_ModReqdList__item__id._const_tab_at = None
    __E_RABs_Confirmed_ToBeReleased_ModReqdList__item__id._const_tab_id = u'id'
    __E_RABs_Confirmed_ToBeReleased_ModReqdList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_Confirmed_ToBeReleased_ModReqdList__item__criticality._const_tab = ___E_RABs_Confirmed_ToBeReleased_ModReqdList__item__id_tab
    __E_RABs_Confirmed_ToBeReleased_ModReqdList__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_Confirmed_ToBeReleased_ModReqdList__item__criticality._const_tab_id = u'criticality'
    __E_RABs_Confirmed_ToBeReleased_ModReqdList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_Confirmed_ToBeReleased_ModReqdList__item__value._const_tab = ___E_RABs_Confirmed_ToBeReleased_ModReqdList__item__id_tab
    __E_RABs_Confirmed_ToBeReleased_ModReqdList__item__value._const_tab_at = ('..', u'id')
    __E_RABs_Confirmed_ToBeReleased_ModReqdList__item__value._const_tab_id = u'Value'
    _E_RABs_Confirmed_ToBeReleased_ModReqdList__item_._cont = ASN1Dict([
        (u'id', __E_RABs_Confirmed_ToBeReleased_ModReqdList__item__id),
        (u'criticality', __E_RABs_Confirmed_ToBeReleased_ModReqdList__item__criticality),
        (u'value', __E_RABs_Confirmed_ToBeReleased_ModReqdList__item__value),
        ])
    _E_RABs_Confirmed_ToBeReleased_ModReqdList__item_._ext = None
    E_RABs_Confirmed_ToBeReleased_ModReqdList._cont = _E_RABs_Confirmed_ToBeReleased_ModReqdList__item_
    E_RABs_Confirmed_ToBeReleased_ModReqdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-Confirmed-ToBeReleased-ModReqdItemIEs >-----#
    E_RABs_Confirmed_ToBeReleased_ModReqdItemIEs = CLASS(name=u'E-RABs-Confirmed-ToBeReleased-ModReqdItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _E_RABs_Confirmed_ToBeReleased_ModReqdItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Confirmed-ToBeReleased-ModReqdItem')))
    E_RABs_Confirmed_ToBeReleased_ModReqdItemIEs._val = ASN1Set(rv=[dict([(u'id', 53), (u'criticality', u'ignore'), (u'Value', _E_RABs_Confirmed_ToBeReleased_ModReqdItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Confirmed-ToBeReleased-ModReqdItem >-----#
    E_RABs_Confirmed_ToBeReleased_ModReqdItem = SEQ(name=u'E-RABs-Confirmed-ToBeReleased-ModReqdItem', mode=MODE_TYPE)
    _E_RABs_Confirmed_ToBeReleased_ModReqdItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-ID')))
    _E_RABs_Confirmed_ToBeReleased_ModReqdItem_dL_GTPtunnelEndpoint = SEQ(name=u'dL-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__id._const_tab = ____E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__id_tab
    ___E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality._const_tab = ____E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality_tab
    ___E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue_tab
    ___E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item_._ext = None
    _E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions._cont = __E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item_
    _E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Confirmed_ToBeReleased_ModReqdItem._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_Confirmed_ToBeReleased_ModReqdItem_e_RAB_ID),
        (u'dL-GTPtunnelEndpoint', _E_RABs_Confirmed_ToBeReleased_ModReqdItem_dL_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions),
        ])
    E_RABs_Confirmed_ToBeReleased_ModReqdItem._ext = []
    
    #-----< E-RABs-Confirmed-ToBeReleased-ModReqdItemExtIEs >-----#
    E_RABs_Confirmed_ToBeReleased_ModReqdItemExtIEs = CLASS(name=u'E-RABs-Confirmed-ToBeReleased-ModReqdItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    E_RABs_Confirmed_ToBeReleased_ModReqdItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Confirmed-ToBeModified-ModReqdList >-----#
    E_RABs_Confirmed_ToBeModified_ModReqdList = SEQ_OF(name=u'E-RABs-Confirmed-ToBeModified-ModReqdList', mode=MODE_TYPE)
    _E_RABs_Confirmed_ToBeModified_ModReqdList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABs_Confirmed_ToBeModified_ModReqdList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_Confirmed_ToBeModified_ModReqdList__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____E_RABs_Confirmed_ToBeModified_ModReqdList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Confirmed-ToBeModified-ModReqdItem')))
    ___E_RABs_Confirmed_ToBeModified_ModReqdList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 59), (u'criticality', u'ignore'), (u'Value', ____E_RABs_Confirmed_ToBeModified_ModReqdList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_Confirmed_ToBeModified_ModReqdList__item__id._const_tab = ___E_RABs_Confirmed_ToBeModified_ModReqdList__item__id_tab
    __E_RABs_Confirmed_ToBeModified_ModReqdList__item__id._const_tab_at = None
    __E_RABs_Confirmed_ToBeModified_ModReqdList__item__id._const_tab_id = u'id'
    __E_RABs_Confirmed_ToBeModified_ModReqdList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_Confirmed_ToBeModified_ModReqdList__item__criticality._const_tab = ___E_RABs_Confirmed_ToBeModified_ModReqdList__item__id_tab
    __E_RABs_Confirmed_ToBeModified_ModReqdList__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_Confirmed_ToBeModified_ModReqdList__item__criticality._const_tab_id = u'criticality'
    __E_RABs_Confirmed_ToBeModified_ModReqdList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_Confirmed_ToBeModified_ModReqdList__item__value._const_tab = ___E_RABs_Confirmed_ToBeModified_ModReqdList__item__id_tab
    __E_RABs_Confirmed_ToBeModified_ModReqdList__item__value._const_tab_at = ('..', u'id')
    __E_RABs_Confirmed_ToBeModified_ModReqdList__item__value._const_tab_id = u'Value'
    _E_RABs_Confirmed_ToBeModified_ModReqdList__item_._cont = ASN1Dict([
        (u'id', __E_RABs_Confirmed_ToBeModified_ModReqdList__item__id),
        (u'criticality', __E_RABs_Confirmed_ToBeModified_ModReqdList__item__criticality),
        (u'value', __E_RABs_Confirmed_ToBeModified_ModReqdList__item__value),
        ])
    _E_RABs_Confirmed_ToBeModified_ModReqdList__item_._ext = None
    E_RABs_Confirmed_ToBeModified_ModReqdList._cont = _E_RABs_Confirmed_ToBeModified_ModReqdList__item_
    E_RABs_Confirmed_ToBeModified_ModReqdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-Confirmed-ToBeModified-ModReqdItemIEs >-----#
    E_RABs_Confirmed_ToBeModified_ModReqdItemIEs = CLASS(name=u'E-RABs-Confirmed-ToBeModified-ModReqdItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _E_RABs_Confirmed_ToBeModified_ModReqdItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Confirmed-ToBeModified-ModReqdItem')))
    E_RABs_Confirmed_ToBeModified_ModReqdItemIEs._val = ASN1Set(rv=[dict([(u'id', 59), (u'criticality', u'ignore'), (u'Value', _E_RABs_Confirmed_ToBeModified_ModReqdItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-Confirmed-ToBeModified-ModReqdItem >-----#
    E_RABs_Confirmed_ToBeModified_ModReqdItem = SEQ(name=u'E-RABs-Confirmed-ToBeModified-ModReqdItem', mode=MODE_TYPE)
    _E_RABs_Confirmed_ToBeModified_ModReqdItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-ID')))
    _E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__id._const_tab = ____E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__id_tab
    ___E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__criticality._const_tab = ____E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__criticality_tab
    ___E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__extensionValue_tab
    ___E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item_._ext = None
    _E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions._cont = __E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item_
    _E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_Confirmed_ToBeModified_ModReqdItem._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_Confirmed_ToBeModified_ModReqdItem_e_RAB_ID),
        (u'iE-Extensions', _E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions),
        ])
    E_RABs_Confirmed_ToBeModified_ModReqdItem._ext = []
    
    #-----< E-RABs-Confirmed-ToBeModified-ModReqdItemExtIEs >-----#
    E_RABs_Confirmed_ToBeModified_ModReqdItemExtIEs = CLASS(name=u'E-RABs-Confirmed-ToBeModified-ModReqdItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    E_RABs_Confirmed_ToBeModified_ModReqdItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WTModificationRefuse >-----#
    WTModificationRefuse = SEQ(name=u'WTModificationRefuse', mode=MODE_TYPE)
    _WTModificationRefuse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __WTModificationRefuse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___WTModificationRefuse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____WTModificationRefuse_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____WTModificationRefuse_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTModificationRefuse_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTModificationRefuse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _____WTModificationRefuse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    ____WTModificationRefuse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _____WTModificationRefuse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _____WTModificationRefuse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____WTModificationRefuse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____WTModificationRefuse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WTModificationRefuse_protocolIEs__item__id._const_tab = ____WTModificationRefuse_protocolIEs__item__id_tab
    ___WTModificationRefuse_protocolIEs__item__id._const_tab_at = None
    ___WTModificationRefuse_protocolIEs__item__id._const_tab_id = u'id'
    ___WTModificationRefuse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___WTModificationRefuse_protocolIEs__item__criticality._const_tab = ____WTModificationRefuse_protocolIEs__item__id_tab
    ___WTModificationRefuse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WTModificationRefuse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WTModificationRefuse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___WTModificationRefuse_protocolIEs__item__value._const_tab = ____WTModificationRefuse_protocolIEs__item__id_tab
    ___WTModificationRefuse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WTModificationRefuse_protocolIEs__item__value._const_tab_id = u'Value'
    __WTModificationRefuse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WTModificationRefuse_protocolIEs__item__id),
        (u'criticality', ___WTModificationRefuse_protocolIEs__item__criticality),
        (u'value', ___WTModificationRefuse_protocolIEs__item__value),
        ])
    __WTModificationRefuse_protocolIEs__item_._ext = None
    _WTModificationRefuse_protocolIEs._cont = __WTModificationRefuse_protocolIEs__item_
    _WTModificationRefuse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WTModificationRefuse._cont = ASN1Dict([
        (u'protocolIEs', _WTModificationRefuse_protocolIEs),
        ])
    WTModificationRefuse._ext = []
    
    #-----< WTModificationRefuseIEs >-----#
    WTModificationRefuseIEs = CLASS(name=u'WTModificationRefuseIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WTModificationRefuseIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTModificationRefuseIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTModificationRefuseIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _WTModificationRefuseIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    WTModificationRefuseIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _WTModificationRefuseIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _WTModificationRefuseIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _WTModificationRefuseIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _WTModificationRefuseIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< WTReleaseRequest >-----#
    WTReleaseRequest = SEQ(name=u'WTReleaseRequest', mode=MODE_TYPE)
    _WTReleaseRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __WTReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___WTReleaseRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____WTReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____WTReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTReleaseRequest_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTReleaseRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _____WTReleaseRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeReleased-List-RelReq')))
    _____WTReleaseRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-ContextKeptIndicator')))
    ____WTReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _____WTReleaseRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _____WTReleaseRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____WTReleaseRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 48), (u'criticality', u'ignore'), (u'Value', _____WTReleaseRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 64), (u'criticality', u'ignore'), (u'Value', _____WTReleaseRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WTReleaseRequest_protocolIEs__item__id._const_tab = ____WTReleaseRequest_protocolIEs__item__id_tab
    ___WTReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___WTReleaseRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___WTReleaseRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___WTReleaseRequest_protocolIEs__item__criticality._const_tab = ____WTReleaseRequest_protocolIEs__item__id_tab
    ___WTReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WTReleaseRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WTReleaseRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___WTReleaseRequest_protocolIEs__item__value._const_tab = ____WTReleaseRequest_protocolIEs__item__id_tab
    ___WTReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WTReleaseRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __WTReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WTReleaseRequest_protocolIEs__item__id),
        (u'criticality', ___WTReleaseRequest_protocolIEs__item__criticality),
        (u'value', ___WTReleaseRequest_protocolIEs__item__value),
        ])
    __WTReleaseRequest_protocolIEs__item_._ext = None
    _WTReleaseRequest_protocolIEs._cont = __WTReleaseRequest_protocolIEs__item_
    _WTReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WTReleaseRequest._cont = ASN1Dict([
        (u'protocolIEs', _WTReleaseRequest_protocolIEs),
        ])
    WTReleaseRequest._ext = []
    
    #-----< WTReleaseRequest-IEs >-----#
    WTReleaseRequest_IEs = CLASS(name=u'WTReleaseRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WTReleaseRequest_IEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTReleaseRequest_IEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTReleaseRequest_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _WTReleaseRequest_IEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeReleased-List-RelReq')))
    _WTReleaseRequest_IEs_val_Value_4 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-ContextKeptIndicator')))
    WTReleaseRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _WTReleaseRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _WTReleaseRequest_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _WTReleaseRequest_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 48), (u'criticality', u'ignore'), (u'Value', _WTReleaseRequest_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 64), (u'criticality', u'ignore'), (u'Value', _WTReleaseRequest_IEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-List-RelReq >-----#
    E_RABs_ToBeReleased_List_RelReq = SEQ_OF(name=u'E-RABs-ToBeReleased-List-RelReq', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_List_RelReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABs_ToBeReleased_List_RelReq__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_ToBeReleased_List_RelReq__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____E_RABs_ToBeReleased_List_RelReq__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeReleased-RelReqItem')))
    ___E_RABs_ToBeReleased_List_RelReq__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', ____E_RABs_ToBeReleased_List_RelReq__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeReleased_List_RelReq__item__id._const_tab = ___E_RABs_ToBeReleased_List_RelReq__item__id_tab
    __E_RABs_ToBeReleased_List_RelReq__item__id._const_tab_at = None
    __E_RABs_ToBeReleased_List_RelReq__item__id._const_tab_id = u'id'
    __E_RABs_ToBeReleased_List_RelReq__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_ToBeReleased_List_RelReq__item__criticality._const_tab = ___E_RABs_ToBeReleased_List_RelReq__item__id_tab
    __E_RABs_ToBeReleased_List_RelReq__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_ToBeReleased_List_RelReq__item__criticality._const_tab_id = u'criticality'
    __E_RABs_ToBeReleased_List_RelReq__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_ToBeReleased_List_RelReq__item__value._const_tab = ___E_RABs_ToBeReleased_List_RelReq__item__id_tab
    __E_RABs_ToBeReleased_List_RelReq__item__value._const_tab_at = ('..', u'id')
    __E_RABs_ToBeReleased_List_RelReq__item__value._const_tab_id = u'Value'
    _E_RABs_ToBeReleased_List_RelReq__item_._cont = ASN1Dict([
        (u'id', __E_RABs_ToBeReleased_List_RelReq__item__id),
        (u'criticality', __E_RABs_ToBeReleased_List_RelReq__item__criticality),
        (u'value', __E_RABs_ToBeReleased_List_RelReq__item__value),
        ])
    _E_RABs_ToBeReleased_List_RelReq__item_._ext = None
    E_RABs_ToBeReleased_List_RelReq._cont = _E_RABs_ToBeReleased_List_RelReq__item_
    E_RABs_ToBeReleased_List_RelReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeReleased-RelReqItemIEs >-----#
    E_RABs_ToBeReleased_RelReqItemIEs = CLASS(name=u'E-RABs-ToBeReleased-RelReqItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _E_RABs_ToBeReleased_RelReqItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeReleased-RelReqItem')))
    E_RABs_ToBeReleased_RelReqItemIEs._val = ASN1Set(rv=[dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _E_RABs_ToBeReleased_RelReqItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-RelReqItem >-----#
    E_RABs_ToBeReleased_RelReqItem = SEQ(name=u'E-RABs-ToBeReleased-RelReqItem', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_RelReqItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_RelReqItem_wT_GTPtunnelEndpoint = SEQ(name=u'wT-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_RelReqItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_RelReqItem_iE_Extensions._cont = __E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item_
    _E_RABs_ToBeReleased_RelReqItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_RelReqItem._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeReleased_RelReqItem_e_RAB_ID),
        (u'wT-GTPtunnelEndpoint', _E_RABs_ToBeReleased_RelReqItem_wT_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_ToBeReleased_RelReqItem_iE_Extensions),
        ])
    E_RABs_ToBeReleased_RelReqItem._ext = []
    
    #-----< E-RABs-ToBeReleased-RelReqItemExtIEs >-----#
    E_RABs_ToBeReleased_RelReqItemExtIEs = CLASS(name=u'E-RABs-ToBeReleased-RelReqItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_RelReqItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WTReleaseRequired >-----#
    WTReleaseRequired = SEQ(name=u'WTReleaseRequired', mode=MODE_TYPE)
    _WTReleaseRequired_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __WTReleaseRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___WTReleaseRequired_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____WTReleaseRequired_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____WTReleaseRequired_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTReleaseRequired_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTReleaseRequired_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    ____WTReleaseRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _____WTReleaseRequired_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _____WTReleaseRequired_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____WTReleaseRequired_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___WTReleaseRequired_protocolIEs__item__id._const_tab = ____WTReleaseRequired_protocolIEs__item__id_tab
    ___WTReleaseRequired_protocolIEs__item__id._const_tab_at = None
    ___WTReleaseRequired_protocolIEs__item__id._const_tab_id = u'id'
    ___WTReleaseRequired_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___WTReleaseRequired_protocolIEs__item__criticality._const_tab = ____WTReleaseRequired_protocolIEs__item__id_tab
    ___WTReleaseRequired_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WTReleaseRequired_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WTReleaseRequired_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___WTReleaseRequired_protocolIEs__item__value._const_tab = ____WTReleaseRequired_protocolIEs__item__id_tab
    ___WTReleaseRequired_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WTReleaseRequired_protocolIEs__item__value._const_tab_id = u'Value'
    __WTReleaseRequired_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WTReleaseRequired_protocolIEs__item__id),
        (u'criticality', ___WTReleaseRequired_protocolIEs__item__criticality),
        (u'value', ___WTReleaseRequired_protocolIEs__item__value),
        ])
    __WTReleaseRequired_protocolIEs__item_._ext = None
    _WTReleaseRequired_protocolIEs._cont = __WTReleaseRequired_protocolIEs__item_
    _WTReleaseRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WTReleaseRequired._cont = ASN1Dict([
        (u'protocolIEs', _WTReleaseRequired_protocolIEs),
        ])
    WTReleaseRequired._ext = []
    
    #-----< WTReleaseRequiredIEs >-----#
    WTReleaseRequiredIEs = CLASS(name=u'WTReleaseRequiredIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WTReleaseRequiredIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTReleaseRequiredIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTReleaseRequiredIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    WTReleaseRequiredIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _WTReleaseRequiredIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _WTReleaseRequiredIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _WTReleaseRequiredIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< WTReleaseConfirm >-----#
    WTReleaseConfirm = SEQ(name=u'WTReleaseConfirm', mode=MODE_TYPE)
    _WTReleaseConfirm_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __WTReleaseConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___WTReleaseConfirm_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____WTReleaseConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____WTReleaseConfirm_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTReleaseConfirm_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTReleaseConfirm_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeReleased-List-RelConf')))
    _____WTReleaseConfirm_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    ____WTReleaseConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _____WTReleaseConfirm_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _____WTReleaseConfirm_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', _____WTReleaseConfirm_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____WTReleaseConfirm_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___WTReleaseConfirm_protocolIEs__item__id._const_tab = ____WTReleaseConfirm_protocolIEs__item__id_tab
    ___WTReleaseConfirm_protocolIEs__item__id._const_tab_at = None
    ___WTReleaseConfirm_protocolIEs__item__id._const_tab_id = u'id'
    ___WTReleaseConfirm_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___WTReleaseConfirm_protocolIEs__item__criticality._const_tab = ____WTReleaseConfirm_protocolIEs__item__id_tab
    ___WTReleaseConfirm_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WTReleaseConfirm_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WTReleaseConfirm_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___WTReleaseConfirm_protocolIEs__item__value._const_tab = ____WTReleaseConfirm_protocolIEs__item__id_tab
    ___WTReleaseConfirm_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WTReleaseConfirm_protocolIEs__item__value._const_tab_id = u'Value'
    __WTReleaseConfirm_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WTReleaseConfirm_protocolIEs__item__id),
        (u'criticality', ___WTReleaseConfirm_protocolIEs__item__criticality),
        (u'value', ___WTReleaseConfirm_protocolIEs__item__value),
        ])
    __WTReleaseConfirm_protocolIEs__item_._ext = None
    _WTReleaseConfirm_protocolIEs._cont = __WTReleaseConfirm_protocolIEs__item_
    _WTReleaseConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WTReleaseConfirm._cont = ASN1Dict([
        (u'protocolIEs', _WTReleaseConfirm_protocolIEs),
        ])
    WTReleaseConfirm._ext = []
    
    #-----< WTReleaseConfirmIEs >-----#
    WTReleaseConfirmIEs = CLASS(name=u'WTReleaseConfirmIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WTReleaseConfirmIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTReleaseConfirmIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTReleaseConfirmIEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeReleased-List-RelConf')))
    _WTReleaseConfirmIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    WTReleaseConfirmIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _WTReleaseConfirmIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _WTReleaseConfirmIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', _WTReleaseConfirmIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _WTReleaseConfirmIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-List-RelConf >-----#
    E_RABs_ToBeReleased_List_RelConf = SEQ_OF(name=u'E-RABs-ToBeReleased-List-RelConf', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_List_RelConf__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-SingleContainer')))
    __E_RABs_ToBeReleased_List_RelConf__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ___E_RABs_ToBeReleased_List_RelConf__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    ____E_RABs_ToBeReleased_List_RelConf__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeReleased-RelConfItem')))
    ___E_RABs_ToBeReleased_List_RelConf__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 51), (u'criticality', u'ignore'), (u'Value', ____E_RABs_ToBeReleased_List_RelConf__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __E_RABs_ToBeReleased_List_RelConf__item__id._const_tab = ___E_RABs_ToBeReleased_List_RelConf__item__id_tab
    __E_RABs_ToBeReleased_List_RelConf__item__id._const_tab_at = None
    __E_RABs_ToBeReleased_List_RelConf__item__id._const_tab_id = u'id'
    __E_RABs_ToBeReleased_List_RelConf__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    __E_RABs_ToBeReleased_List_RelConf__item__criticality._const_tab = ___E_RABs_ToBeReleased_List_RelConf__item__id_tab
    __E_RABs_ToBeReleased_List_RelConf__item__criticality._const_tab_at = ('..', u'id')
    __E_RABs_ToBeReleased_List_RelConf__item__criticality._const_tab_id = u'criticality'
    __E_RABs_ToBeReleased_List_RelConf__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    __E_RABs_ToBeReleased_List_RelConf__item__value._const_tab = ___E_RABs_ToBeReleased_List_RelConf__item__id_tab
    __E_RABs_ToBeReleased_List_RelConf__item__value._const_tab_at = ('..', u'id')
    __E_RABs_ToBeReleased_List_RelConf__item__value._const_tab_id = u'Value'
    _E_RABs_ToBeReleased_List_RelConf__item_._cont = ASN1Dict([
        (u'id', __E_RABs_ToBeReleased_List_RelConf__item__id),
        (u'criticality', __E_RABs_ToBeReleased_List_RelConf__item__criticality),
        (u'value', __E_RABs_ToBeReleased_List_RelConf__item__value),
        ])
    _E_RABs_ToBeReleased_List_RelConf__item_._ext = None
    E_RABs_ToBeReleased_List_RelConf._cont = _E_RABs_ToBeReleased_List_RelConf__item_
    E_RABs_ToBeReleased_List_RelConf._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< E-RABs-ToBeReleased-RelConfItemIEs >-----#
    E_RABs_ToBeReleased_RelConfItemIEs = CLASS(name=u'E-RABs-ToBeReleased-RelConfItemIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _E_RABs_ToBeReleased_RelConfItemIEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-ToBeReleased-RelConfItem')))
    E_RABs_ToBeReleased_RelConfItemIEs._val = ASN1Set(rv=[dict([(u'id', 51), (u'criticality', u'ignore'), (u'Value', _E_RABs_ToBeReleased_RelConfItemIEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-RABs-ToBeReleased-RelConfItem >-----#
    E_RABs_ToBeReleased_RelConfItem = SEQ(name=u'E-RABs-ToBeReleased-RelConfItem', mode=MODE_TYPE)
    _E_RABs_ToBeReleased_RelConfItem_e_RAB_ID = INT(name=u'e-RAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-ID')))
    _E_RABs_ToBeReleased_RelConfItem_wT_GTPtunnelEndpoint = SEQ(name=u'wT-GTPtunnelEndpoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-IEs', 'GTPtunnelEndpoint')), opt=True)
    _E_RABs_ToBeReleased_RelConfItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolExtensionField')))
    ___E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__id._const_tab = ____E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__id_tab
    ___E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__id._const_tab_at = None
    ___E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__criticality._const_tab = ____E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__criticality_tab
    ___E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_XWAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    ____E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__extensionValue._const_tab = ____E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__extensionValue_tab
    ___E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__id),
        (u'criticality', ___E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__extensionValue),
        ])
    __E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item_._ext = None
    _E_RABs_ToBeReleased_RelConfItem_iE_Extensions._cont = __E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item_
    _E_RABs_ToBeReleased_RelConfItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_RABs_ToBeReleased_RelConfItem._cont = ASN1Dict([
        (u'e-RAB-ID', _E_RABs_ToBeReleased_RelConfItem_e_RAB_ID),
        (u'wT-GTPtunnelEndpoint', _E_RABs_ToBeReleased_RelConfItem_wT_GTPtunnelEndpoint),
        (u'iE-Extensions', _E_RABs_ToBeReleased_RelConfItem_iE_Extensions),
        ])
    E_RABs_ToBeReleased_RelConfItem._ext = []
    
    #-----< E-RABs-ToBeReleased-RelConfItemExtIEs >-----#
    E_RABs_ToBeReleased_RelConfItemExtIEs = CLASS(name=u'E-RABs-ToBeReleased-RelConfItemExtIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-EXTENSION')))
    E_RABs_ToBeReleased_RelConfItemExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WTAssociationConfirmation >-----#
    WTAssociationConfirmation = SEQ(name=u'WTAssociationConfirmation', mode=MODE_TYPE)
    _WTAssociationConfirmation_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __WTAssociationConfirmation_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___WTAssociationConfirmation_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____WTAssociationConfirmation_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____WTAssociationConfirmation_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____WTAssociationConfirmation_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    ____WTAssociationConfirmation_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _____WTAssociationConfirmation_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _____WTAssociationConfirmation_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___WTAssociationConfirmation_protocolIEs__item__id._const_tab = ____WTAssociationConfirmation_protocolIEs__item__id_tab
    ___WTAssociationConfirmation_protocolIEs__item__id._const_tab_at = None
    ___WTAssociationConfirmation_protocolIEs__item__id._const_tab_id = u'id'
    ___WTAssociationConfirmation_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___WTAssociationConfirmation_protocolIEs__item__criticality._const_tab = ____WTAssociationConfirmation_protocolIEs__item__id_tab
    ___WTAssociationConfirmation_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___WTAssociationConfirmation_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___WTAssociationConfirmation_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___WTAssociationConfirmation_protocolIEs__item__value._const_tab = ____WTAssociationConfirmation_protocolIEs__item__id_tab
    ___WTAssociationConfirmation_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___WTAssociationConfirmation_protocolIEs__item__value._const_tab_id = u'Value'
    __WTAssociationConfirmation_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___WTAssociationConfirmation_protocolIEs__item__id),
        (u'criticality', ___WTAssociationConfirmation_protocolIEs__item__criticality),
        (u'value', ___WTAssociationConfirmation_protocolIEs__item__value),
        ])
    __WTAssociationConfirmation_protocolIEs__item_._ext = None
    _WTAssociationConfirmation_protocolIEs._cont = __WTAssociationConfirmation_protocolIEs__item_
    _WTAssociationConfirmation_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    WTAssociationConfirmation._cont = ASN1Dict([
        (u'protocolIEs', _WTAssociationConfirmation_protocolIEs),
        ])
    WTAssociationConfirmation._ext = []
    
    #-----< WTAssociationConfirmationIEs >-----#
    WTAssociationConfirmationIEs = CLASS(name=u'WTAssociationConfirmationIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _WTAssociationConfirmationIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _WTAssociationConfirmationIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    WTAssociationConfirmationIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _WTAssociationConfirmationIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _WTAssociationConfirmationIEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< PrivateMessage >-----#
    PrivateMessage = SEQ(name=u'PrivateMessage', mode=MODE_TYPE)
    _PrivateMessage_privateIEs = SEQ_OF(name=u'privateIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'PrivateIE-Container')))
    __PrivateMessage_privateIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'PrivateIE-Field')))
    ___PrivateMessage_privateIEs__item__id = CHOICE(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PRIVATE-IES'), [u'id']))
    ____PrivateMessage_privateIEs__item__id_tab = CLASS(name='_tab_XWAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__id._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__id._const_tab_at = None
    ___PrivateMessage_privateIEs__item__id._const_tab_id = u'id'
    ___PrivateMessage_privateIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PRIVATE-IES'), [u'criticality']))
    ____PrivateMessage_privateIEs__item__criticality_tab = CLASS(name='_tab_XWAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__criticality._const_tab = ____PrivateMessage_privateIEs__item__criticality_tab
    ___PrivateMessage_privateIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PrivateMessage_privateIEs__item__criticality._const_tab_id = u'criticality'
    ___PrivateMessage_privateIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PRIVATE-IES'), [u'Value']))
    ____PrivateMessage_privateIEs__item__value_tab = CLASS(name='_tab_XWAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__value._const_tab = ____PrivateMessage_privateIEs__item__value_tab
    ___PrivateMessage_privateIEs__item__value._const_tab_at = ('..', u'id')
    ___PrivateMessage_privateIEs__item__value._const_tab_id = u'Value'
    __PrivateMessage_privateIEs__item_._cont = ASN1Dict([
        (u'id', ___PrivateMessage_privateIEs__item__id),
        (u'criticality', ___PrivateMessage_privateIEs__item__criticality),
        (u'value', ___PrivateMessage_privateIEs__item__value),
        ])
    __PrivateMessage_privateIEs__item_._ext = None
    _PrivateMessage_privateIEs._cont = __PrivateMessage_privateIEs__item_
    _PrivateMessage_privateIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrivateMessage._cont = ASN1Dict([
        (u'privateIEs', _PrivateMessage_privateIEs),
        ])
    PrivateMessage._ext = []
    
    #-----< PrivateMessage-IEs >-----#
    PrivateMessage_IEs = CLASS(name=u'PrivateMessage-IEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PRIVATE-IES')))
    PrivateMessage_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LWIPAdditionRequest >-----#
    LWIPAdditionRequest = SEQ(name=u'LWIPAdditionRequest', mode=MODE_TYPE)
    _LWIPAdditionRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __LWIPAdditionRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___LWIPAdditionRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____LWIPAdditionRequest_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____LWIPAdditionRequest_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____LWIPAdditionRequest_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-Identity')))
    _____LWIPAdditionRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'LWIP-SeGWSecurityInfo')))
    _____LWIPAdditionRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'PLMN-Identity')))
    _____LWIPAdditionRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'GTPtunnelEndpoint')))
    _____LWIPAdditionRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'MobilitySet')))
    ____LWIPAdditionRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _____LWIPAdditionRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 30), (u'criticality', u'reject'), (u'Value', _____LWIPAdditionRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 69), (u'criticality', u'reject'), (u'Value', _____LWIPAdditionRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 55), (u'criticality', u'ignore'), (u'Value', _____LWIPAdditionRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 70), (u'criticality', u'reject'), (u'Value', _____LWIPAdditionRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 54), (u'criticality', u'reject'), (u'Value', _____LWIPAdditionRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___LWIPAdditionRequest_protocolIEs__item__id._const_tab = ____LWIPAdditionRequest_protocolIEs__item__id_tab
    ___LWIPAdditionRequest_protocolIEs__item__id._const_tab_at = None
    ___LWIPAdditionRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___LWIPAdditionRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___LWIPAdditionRequest_protocolIEs__item__criticality._const_tab = ____LWIPAdditionRequest_protocolIEs__item__id_tab
    ___LWIPAdditionRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___LWIPAdditionRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___LWIPAdditionRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___LWIPAdditionRequest_protocolIEs__item__value._const_tab = ____LWIPAdditionRequest_protocolIEs__item__id_tab
    ___LWIPAdditionRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___LWIPAdditionRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __LWIPAdditionRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___LWIPAdditionRequest_protocolIEs__item__id),
        (u'criticality', ___LWIPAdditionRequest_protocolIEs__item__criticality),
        (u'value', ___LWIPAdditionRequest_protocolIEs__item__value),
        ])
    __LWIPAdditionRequest_protocolIEs__item_._ext = None
    _LWIPAdditionRequest_protocolIEs._cont = __LWIPAdditionRequest_protocolIEs__item_
    _LWIPAdditionRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LWIPAdditionRequest._cont = ASN1Dict([
        (u'protocolIEs', _LWIPAdditionRequest_protocolIEs),
        ])
    LWIPAdditionRequest._ext = []
    
    #-----< LWIPAdditionRequestIEs >-----#
    LWIPAdditionRequestIEs = CLASS(name=u'LWIPAdditionRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _LWIPAdditionRequestIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _LWIPAdditionRequestIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-Identity')))
    _LWIPAdditionRequestIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'LWIP-SeGWSecurityInfo')))
    _LWIPAdditionRequestIEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'PLMN-Identity')))
    _LWIPAdditionRequestIEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'GTPtunnelEndpoint')))
    _LWIPAdditionRequestIEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'MobilitySet')))
    LWIPAdditionRequestIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _LWIPAdditionRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 30), (u'criticality', u'reject'), (u'Value', _LWIPAdditionRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 69), (u'criticality', u'reject'), (u'Value', _LWIPAdditionRequestIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 55), (u'criticality', u'ignore'), (u'Value', _LWIPAdditionRequestIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 70), (u'criticality', u'reject'), (u'Value', _LWIPAdditionRequestIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 54), (u'criticality', u'reject'), (u'Value', _LWIPAdditionRequestIEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< LWIPAdditionRequestAcknowledge >-----#
    LWIPAdditionRequestAcknowledge = SEQ(name=u'LWIPAdditionRequestAcknowledge', mode=MODE_TYPE)
    _LWIPAdditionRequestAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __LWIPAdditionRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___LWIPAdditionRequestAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'GTPtunnelEndpoint')))
    _____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-List')))
    _____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-List')))
    _____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    ____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 71), (u'criticality', u'reject'), (u'Value', _____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 32), (u'criticality', u'ignore'), (u'Value', _____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 34), (u'criticality', u'ignore'), (u'Value', _____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___LWIPAdditionRequestAcknowledge_protocolIEs__item__id._const_tab = ____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab
    ___LWIPAdditionRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___LWIPAdditionRequestAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___LWIPAdditionRequestAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___LWIPAdditionRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab
    ___LWIPAdditionRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___LWIPAdditionRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___LWIPAdditionRequestAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___LWIPAdditionRequestAcknowledge_protocolIEs__item__value._const_tab = ____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab
    ___LWIPAdditionRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___LWIPAdditionRequestAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __LWIPAdditionRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___LWIPAdditionRequestAcknowledge_protocolIEs__item__id),
        (u'criticality', ___LWIPAdditionRequestAcknowledge_protocolIEs__item__criticality),
        (u'value', ___LWIPAdditionRequestAcknowledge_protocolIEs__item__value),
        ])
    __LWIPAdditionRequestAcknowledge_protocolIEs__item_._ext = None
    _LWIPAdditionRequestAcknowledge_protocolIEs._cont = __LWIPAdditionRequestAcknowledge_protocolIEs__item_
    _LWIPAdditionRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LWIPAdditionRequestAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _LWIPAdditionRequestAcknowledge_protocolIEs),
        ])
    LWIPAdditionRequestAcknowledge._ext = []
    
    #-----< LWIPAdditionRequestAcknowledgeIEs >-----#
    LWIPAdditionRequestAcknowledgeIEs = CLASS(name=u'LWIPAdditionRequestAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _LWIPAdditionRequestAcknowledgeIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _LWIPAdditionRequestAcknowledgeIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _LWIPAdditionRequestAcknowledgeIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'GTPtunnelEndpoint')))
    _LWIPAdditionRequestAcknowledgeIEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'E-RABs-Admitted-ToBeAdded-List')))
    _LWIPAdditionRequestAcknowledgeIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'E-RAB-List')))
    _LWIPAdditionRequestAcknowledgeIEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    LWIPAdditionRequestAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _LWIPAdditionRequestAcknowledgeIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _LWIPAdditionRequestAcknowledgeIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 71), (u'criticality', u'reject'), (u'Value', _LWIPAdditionRequestAcknowledgeIEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 32), (u'criticality', u'ignore'), (u'Value', _LWIPAdditionRequestAcknowledgeIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 34), (u'criticality', u'ignore'), (u'Value', _LWIPAdditionRequestAcknowledgeIEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _LWIPAdditionRequestAcknowledgeIEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< LWIPAdditionRequestReject >-----#
    LWIPAdditionRequestReject = SEQ(name=u'LWIPAdditionRequestReject', mode=MODE_TYPE)
    _LWIPAdditionRequestReject_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __LWIPAdditionRequestReject_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___LWIPAdditionRequestReject_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____LWIPAdditionRequestReject_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____LWIPAdditionRequestReject_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____LWIPAdditionRequestReject_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _____LWIPAdditionRequestReject_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    ____LWIPAdditionRequestReject_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _____LWIPAdditionRequestReject_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____LWIPAdditionRequestReject_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____LWIPAdditionRequestReject_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___LWIPAdditionRequestReject_protocolIEs__item__id._const_tab = ____LWIPAdditionRequestReject_protocolIEs__item__id_tab
    ___LWIPAdditionRequestReject_protocolIEs__item__id._const_tab_at = None
    ___LWIPAdditionRequestReject_protocolIEs__item__id._const_tab_id = u'id'
    ___LWIPAdditionRequestReject_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___LWIPAdditionRequestReject_protocolIEs__item__criticality._const_tab = ____LWIPAdditionRequestReject_protocolIEs__item__id_tab
    ___LWIPAdditionRequestReject_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___LWIPAdditionRequestReject_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___LWIPAdditionRequestReject_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___LWIPAdditionRequestReject_protocolIEs__item__value._const_tab = ____LWIPAdditionRequestReject_protocolIEs__item__id_tab
    ___LWIPAdditionRequestReject_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___LWIPAdditionRequestReject_protocolIEs__item__value._const_tab_id = u'Value'
    __LWIPAdditionRequestReject_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___LWIPAdditionRequestReject_protocolIEs__item__id),
        (u'criticality', ___LWIPAdditionRequestReject_protocolIEs__item__criticality),
        (u'value', ___LWIPAdditionRequestReject_protocolIEs__item__value),
        ])
    __LWIPAdditionRequestReject_protocolIEs__item_._ext = None
    _LWIPAdditionRequestReject_protocolIEs._cont = __LWIPAdditionRequestReject_protocolIEs__item_
    _LWIPAdditionRequestReject_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LWIPAdditionRequestReject._cont = ASN1Dict([
        (u'protocolIEs', _LWIPAdditionRequestReject_protocolIEs),
        ])
    LWIPAdditionRequestReject._ext = []
    
    #-----< LWIPAdditionRequestRejectIEs >-----#
    LWIPAdditionRequestRejectIEs = CLASS(name=u'LWIPAdditionRequestRejectIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _LWIPAdditionRequestRejectIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _LWIPAdditionRequestRejectIEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _LWIPAdditionRequestRejectIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    LWIPAdditionRequestRejectIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _LWIPAdditionRequestRejectIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _LWIPAdditionRequestRejectIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _LWIPAdditionRequestRejectIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< LWIPModificationRequest >-----#
    LWIPModificationRequest = SEQ(name=u'LWIPModificationRequest', mode=MODE_TYPE)
    _LWIPModificationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __LWIPModificationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___LWIPModificationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____LWIPModificationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____LWIPModificationRequest_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____LWIPModificationRequest_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____LWIPModificationRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _____LWIPModificationRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'PLMN-Identity')))
    _____LWIPModificationRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'MobilitySet')))
    ____LWIPModificationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _____LWIPModificationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _____LWIPModificationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____LWIPModificationRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 55), (u'criticality', u'ignore'), (u'Value', _____LWIPModificationRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 54), (u'criticality', u'reject'), (u'Value', _____LWIPModificationRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___LWIPModificationRequest_protocolIEs__item__id._const_tab = ____LWIPModificationRequest_protocolIEs__item__id_tab
    ___LWIPModificationRequest_protocolIEs__item__id._const_tab_at = None
    ___LWIPModificationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___LWIPModificationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___LWIPModificationRequest_protocolIEs__item__criticality._const_tab = ____LWIPModificationRequest_protocolIEs__item__id_tab
    ___LWIPModificationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___LWIPModificationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___LWIPModificationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___LWIPModificationRequest_protocolIEs__item__value._const_tab = ____LWIPModificationRequest_protocolIEs__item__id_tab
    ___LWIPModificationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___LWIPModificationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __LWIPModificationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___LWIPModificationRequest_protocolIEs__item__id),
        (u'criticality', ___LWIPModificationRequest_protocolIEs__item__criticality),
        (u'value', ___LWIPModificationRequest_protocolIEs__item__value),
        ])
    __LWIPModificationRequest_protocolIEs__item_._ext = None
    _LWIPModificationRequest_protocolIEs._cont = __LWIPModificationRequest_protocolIEs__item_
    _LWIPModificationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LWIPModificationRequest._cont = ASN1Dict([
        (u'protocolIEs', _LWIPModificationRequest_protocolIEs),
        ])
    LWIPModificationRequest._ext = []
    
    #-----< LWIPModificationRequestIEs >-----#
    LWIPModificationRequestIEs = CLASS(name=u'LWIPModificationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _LWIPModificationRequestIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _LWIPModificationRequestIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _LWIPModificationRequestIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _LWIPModificationRequestIEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'PLMN-Identity')))
    _LWIPModificationRequestIEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'MobilitySet')))
    LWIPModificationRequestIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _LWIPModificationRequestIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _LWIPModificationRequestIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _LWIPModificationRequestIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 55), (u'criticality', u'ignore'), (u'Value', _LWIPModificationRequestIEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 54), (u'criticality', u'reject'), (u'Value', _LWIPModificationRequestIEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< LWIPModificationRequestAcknowledge >-----#
    LWIPModificationRequestAcknowledge = SEQ(name=u'LWIPModificationRequestAcknowledge', mode=MODE_TYPE)
    _LWIPModificationRequestAcknowledge_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __LWIPModificationRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___LWIPModificationRequestAcknowledge_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____LWIPModificationRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____LWIPModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____LWIPModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____LWIPModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    ____LWIPModificationRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _____LWIPModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _____LWIPModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____LWIPModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___LWIPModificationRequestAcknowledge_protocolIEs__item__id._const_tab = ____LWIPModificationRequestAcknowledge_protocolIEs__item__id_tab
    ___LWIPModificationRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___LWIPModificationRequestAcknowledge_protocolIEs__item__id._const_tab_id = u'id'
    ___LWIPModificationRequestAcknowledge_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___LWIPModificationRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____LWIPModificationRequestAcknowledge_protocolIEs__item__id_tab
    ___LWIPModificationRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___LWIPModificationRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___LWIPModificationRequestAcknowledge_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___LWIPModificationRequestAcknowledge_protocolIEs__item__value._const_tab = ____LWIPModificationRequestAcknowledge_protocolIEs__item__id_tab
    ___LWIPModificationRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___LWIPModificationRequestAcknowledge_protocolIEs__item__value._const_tab_id = u'Value'
    __LWIPModificationRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___LWIPModificationRequestAcknowledge_protocolIEs__item__id),
        (u'criticality', ___LWIPModificationRequestAcknowledge_protocolIEs__item__criticality),
        (u'value', ___LWIPModificationRequestAcknowledge_protocolIEs__item__value),
        ])
    __LWIPModificationRequestAcknowledge_protocolIEs__item_._ext = None
    _LWIPModificationRequestAcknowledge_protocolIEs._cont = __LWIPModificationRequestAcknowledge_protocolIEs__item_
    _LWIPModificationRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LWIPModificationRequestAcknowledge._cont = ASN1Dict([
        (u'protocolIEs', _LWIPModificationRequestAcknowledge_protocolIEs),
        ])
    LWIPModificationRequestAcknowledge._ext = []
    
    #-----< LWIPModificationRequestAcknowledgeIEs >-----#
    LWIPModificationRequestAcknowledgeIEs = CLASS(name=u'LWIPModificationRequestAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _LWIPModificationRequestAcknowledgeIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _LWIPModificationRequestAcknowledgeIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _LWIPModificationRequestAcknowledgeIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    LWIPModificationRequestAcknowledgeIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _LWIPModificationRequestAcknowledgeIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _LWIPModificationRequestAcknowledgeIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _LWIPModificationRequestAcknowledgeIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< LWIPModificationRequestReject >-----#
    LWIPModificationRequestReject = SEQ(name=u'LWIPModificationRequestReject', mode=MODE_TYPE)
    _LWIPModificationRequestReject_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __LWIPModificationRequestReject_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___LWIPModificationRequestReject_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____LWIPModificationRequestReject_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____LWIPModificationRequestReject_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____LWIPModificationRequestReject_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____LWIPModificationRequestReject_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _____LWIPModificationRequestReject_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    ____LWIPModificationRequestReject_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _____LWIPModificationRequestReject_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _____LWIPModificationRequestReject_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____LWIPModificationRequestReject_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____LWIPModificationRequestReject_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___LWIPModificationRequestReject_protocolIEs__item__id._const_tab = ____LWIPModificationRequestReject_protocolIEs__item__id_tab
    ___LWIPModificationRequestReject_protocolIEs__item__id._const_tab_at = None
    ___LWIPModificationRequestReject_protocolIEs__item__id._const_tab_id = u'id'
    ___LWIPModificationRequestReject_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___LWIPModificationRequestReject_protocolIEs__item__criticality._const_tab = ____LWIPModificationRequestReject_protocolIEs__item__id_tab
    ___LWIPModificationRequestReject_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___LWIPModificationRequestReject_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___LWIPModificationRequestReject_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___LWIPModificationRequestReject_protocolIEs__item__value._const_tab = ____LWIPModificationRequestReject_protocolIEs__item__id_tab
    ___LWIPModificationRequestReject_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___LWIPModificationRequestReject_protocolIEs__item__value._const_tab_id = u'Value'
    __LWIPModificationRequestReject_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___LWIPModificationRequestReject_protocolIEs__item__id),
        (u'criticality', ___LWIPModificationRequestReject_protocolIEs__item__criticality),
        (u'value', ___LWIPModificationRequestReject_protocolIEs__item__value),
        ])
    __LWIPModificationRequestReject_protocolIEs__item_._ext = None
    _LWIPModificationRequestReject_protocolIEs._cont = __LWIPModificationRequestReject_protocolIEs__item_
    _LWIPModificationRequestReject_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LWIPModificationRequestReject._cont = ASN1Dict([
        (u'protocolIEs', _LWIPModificationRequestReject_protocolIEs),
        ])
    LWIPModificationRequestReject._ext = []
    
    #-----< LWIPModificationRequestRejectIEs >-----#
    LWIPModificationRequestRejectIEs = CLASS(name=u'LWIPModificationRequestRejectIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _LWIPModificationRequestRejectIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _LWIPModificationRequestRejectIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _LWIPModificationRequestRejectIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    _LWIPModificationRequestRejectIEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    LWIPModificationRequestRejectIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _LWIPModificationRequestRejectIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _LWIPModificationRequestRejectIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _LWIPModificationRequestRejectIEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _LWIPModificationRequestRejectIEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< LWIPReleaseRequest >-----#
    LWIPReleaseRequest = SEQ(name=u'LWIPReleaseRequest', mode=MODE_TYPE)
    _LWIPReleaseRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __LWIPReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___LWIPReleaseRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____LWIPReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____LWIPReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____LWIPReleaseRequest_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____LWIPReleaseRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    ____LWIPReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _____LWIPReleaseRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _____LWIPReleaseRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____LWIPReleaseRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___LWIPReleaseRequest_protocolIEs__item__id._const_tab = ____LWIPReleaseRequest_protocolIEs__item__id_tab
    ___LWIPReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___LWIPReleaseRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___LWIPReleaseRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___LWIPReleaseRequest_protocolIEs__item__criticality._const_tab = ____LWIPReleaseRequest_protocolIEs__item__id_tab
    ___LWIPReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___LWIPReleaseRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___LWIPReleaseRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___LWIPReleaseRequest_protocolIEs__item__value._const_tab = ____LWIPReleaseRequest_protocolIEs__item__id_tab
    ___LWIPReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___LWIPReleaseRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __LWIPReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___LWIPReleaseRequest_protocolIEs__item__id),
        (u'criticality', ___LWIPReleaseRequest_protocolIEs__item__criticality),
        (u'value', ___LWIPReleaseRequest_protocolIEs__item__value),
        ])
    __LWIPReleaseRequest_protocolIEs__item_._ext = None
    _LWIPReleaseRequest_protocolIEs._cont = __LWIPReleaseRequest_protocolIEs__item_
    _LWIPReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LWIPReleaseRequest._cont = ASN1Dict([
        (u'protocolIEs', _LWIPReleaseRequest_protocolIEs),
        ])
    LWIPReleaseRequest._ext = []
    
    #-----< LWIPReleaseRequest-IEs >-----#
    LWIPReleaseRequest_IEs = CLASS(name=u'LWIPReleaseRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _LWIPReleaseRequest_IEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _LWIPReleaseRequest_IEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _LWIPReleaseRequest_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    LWIPReleaseRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _LWIPReleaseRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _LWIPReleaseRequest_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _LWIPReleaseRequest_IEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< LWIPReleaseRequired >-----#
    LWIPReleaseRequired = SEQ(name=u'LWIPReleaseRequired', mode=MODE_TYPE)
    _LWIPReleaseRequired_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __LWIPReleaseRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___LWIPReleaseRequired_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____LWIPReleaseRequired_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____LWIPReleaseRequired_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____LWIPReleaseRequired_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____LWIPReleaseRequired_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    ____LWIPReleaseRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _____LWIPReleaseRequired_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _____LWIPReleaseRequired_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _____LWIPReleaseRequired_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___LWIPReleaseRequired_protocolIEs__item__id._const_tab = ____LWIPReleaseRequired_protocolIEs__item__id_tab
    ___LWIPReleaseRequired_protocolIEs__item__id._const_tab_at = None
    ___LWIPReleaseRequired_protocolIEs__item__id._const_tab_id = u'id'
    ___LWIPReleaseRequired_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___LWIPReleaseRequired_protocolIEs__item__criticality._const_tab = ____LWIPReleaseRequired_protocolIEs__item__id_tab
    ___LWIPReleaseRequired_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___LWIPReleaseRequired_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___LWIPReleaseRequired_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___LWIPReleaseRequired_protocolIEs__item__value._const_tab = ____LWIPReleaseRequired_protocolIEs__item__id_tab
    ___LWIPReleaseRequired_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___LWIPReleaseRequired_protocolIEs__item__value._const_tab_id = u'Value'
    __LWIPReleaseRequired_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___LWIPReleaseRequired_protocolIEs__item__id),
        (u'criticality', ___LWIPReleaseRequired_protocolIEs__item__criticality),
        (u'value', ___LWIPReleaseRequired_protocolIEs__item__value),
        ])
    __LWIPReleaseRequired_protocolIEs__item_._ext = None
    _LWIPReleaseRequired_protocolIEs._cont = __LWIPReleaseRequired_protocolIEs__item_
    _LWIPReleaseRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LWIPReleaseRequired._cont = ASN1Dict([
        (u'protocolIEs', _LWIPReleaseRequired_protocolIEs),
        ])
    LWIPReleaseRequired._ext = []
    
    #-----< LWIPReleaseRequiredIEs >-----#
    LWIPReleaseRequiredIEs = CLASS(name=u'LWIPReleaseRequiredIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _LWIPReleaseRequiredIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _LWIPReleaseRequiredIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _LWIPReleaseRequiredIEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'Cause')))
    LWIPReleaseRequiredIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'reject'), (u'Value', _LWIPReleaseRequiredIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _LWIPReleaseRequiredIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'ignore'), (u'Value', _LWIPReleaseRequiredIEs_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< LWIPReleaseConfirm >-----#
    LWIPReleaseConfirm = SEQ(name=u'LWIPReleaseConfirm', mode=MODE_TYPE)
    _LWIPReleaseConfirm_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Container')))
    __LWIPReleaseConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-Containers', 'ProtocolIE-Field')))
    ___LWIPReleaseConfirm_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'id']))
    ____LWIPReleaseConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_XWAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _____LWIPReleaseConfirm_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____LWIPReleaseConfirm_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _____LWIPReleaseConfirm_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    ____LWIPReleaseConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _____LWIPReleaseConfirm_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _____LWIPReleaseConfirm_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____LWIPReleaseConfirm_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___LWIPReleaseConfirm_protocolIEs__item__id._const_tab = ____LWIPReleaseConfirm_protocolIEs__item__id_tab
    ___LWIPReleaseConfirm_protocolIEs__item__id._const_tab_at = None
    ___LWIPReleaseConfirm_protocolIEs__item__id._const_tab_id = u'id'
    ___LWIPReleaseConfirm_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'criticality']))
    ___LWIPReleaseConfirm_protocolIEs__item__criticality._const_tab = ____LWIPReleaseConfirm_protocolIEs__item__id_tab
    ___LWIPReleaseConfirm_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___LWIPReleaseConfirm_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___LWIPReleaseConfirm_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-Containers', 'XWAP-PROTOCOL-IES'), [u'Value']))
    ___LWIPReleaseConfirm_protocolIEs__item__value._const_tab = ____LWIPReleaseConfirm_protocolIEs__item__id_tab
    ___LWIPReleaseConfirm_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___LWIPReleaseConfirm_protocolIEs__item__value._const_tab_id = u'Value'
    __LWIPReleaseConfirm_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___LWIPReleaseConfirm_protocolIEs__item__id),
        (u'criticality', ___LWIPReleaseConfirm_protocolIEs__item__criticality),
        (u'value', ___LWIPReleaseConfirm_protocolIEs__item__value),
        ])
    __LWIPReleaseConfirm_protocolIEs__item_._ext = None
    _LWIPReleaseConfirm_protocolIEs._cont = __LWIPReleaseConfirm_protocolIEs__item_
    _LWIPReleaseConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    LWIPReleaseConfirm._cont = ASN1Dict([
        (u'protocolIEs', _LWIPReleaseConfirm_protocolIEs),
        ])
    LWIPReleaseConfirm._ext = []
    
    #-----< LWIPReleaseConfirmIEs >-----#
    LWIPReleaseConfirmIEs = CLASS(name=u'LWIPReleaseConfirmIEs', mode=MODE_SET, typeref=ASN1RefType(('XwAP-Containers', 'XWAP-PROTOCOL-IES')))
    _LWIPReleaseConfirmIEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _LWIPReleaseConfirmIEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'UE-XwAP-ID')))
    _LWIPReleaseConfirmIEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-IEs', 'CriticalityDiagnostics')))
    LWIPReleaseConfirmIEs._val = ASN1Set(rv=[dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _LWIPReleaseConfirmIEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 26), (u'criticality', u'ignore'), (u'Value', _LWIPReleaseConfirmIEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _LWIPReleaseConfirmIEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    _all_ = [
        ____XwSetupRequest_protocolIEs__item__id_tab,
        _____XwSetupRequest_protocolIEs__item__id_tab_val_Value_0,
        ___XwSetupRequest_protocolIEs__item__id,
        ___XwSetupRequest_protocolIEs__item__criticality,
        ___XwSetupRequest_protocolIEs__item__value,
        __XwSetupRequest_protocolIEs__item_,
        _XwSetupRequest_protocolIEs,
        XwSetupRequest,
        XwSetupRequestIEs,
        _XwSetupRequestIEs_val_Value_0,
        ____XwSetupResponse_protocolIEs__item__id_tab,
        _____XwSetupResponse_protocolIEs__item__id_tab_val_Value_0,
        _____XwSetupResponse_protocolIEs__item__id_tab_val_Value_1,
        _____XwSetupResponse_protocolIEs__item__id_tab_val_Value_2,
        _____XwSetupResponse_protocolIEs__item__id_tab_val_Value_3,
        ___XwSetupResponse_protocolIEs__item__id,
        ___XwSetupResponse_protocolIEs__item__criticality,
        ___XwSetupResponse_protocolIEs__item__value,
        __XwSetupResponse_protocolIEs__item_,
        _XwSetupResponse_protocolIEs,
        XwSetupResponse,
        XwSetupResponseIEs,
        _XwSetupResponseIEs_val_Value_0,
        _XwSetupResponseIEs_val_Value_1,
        _XwSetupResponseIEs_val_Value_2,
        _XwSetupResponseIEs_val_Value_3,
        ____XwSetupFailure_protocolIEs__item__id_tab,
        _____XwSetupFailure_protocolIEs__item__id_tab_val_Value_0,
        _____XwSetupFailure_protocolIEs__item__id_tab_val_Value_1,
        _____XwSetupFailure_protocolIEs__item__id_tab_val_Value_2,
        ___XwSetupFailure_protocolIEs__item__id,
        ___XwSetupFailure_protocolIEs__item__criticality,
        ___XwSetupFailure_protocolIEs__item__value,
        __XwSetupFailure_protocolIEs__item_,
        _XwSetupFailure_protocolIEs,
        XwSetupFailure,
        XwSetupFailureIEs,
        _XwSetupFailureIEs_val_Value_0,
        _XwSetupFailureIEs_val_Value_1,
        _XwSetupFailureIEs_val_Value_2,
        ____WTConfigurationUpdate_protocolIEs__item__id_tab,
        _____WTConfigurationUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____WTConfigurationUpdate_protocolIEs__item__id_tab_val_Value_1,
        _____WTConfigurationUpdate_protocolIEs__item__id_tab_val_Value_2,
        _____WTConfigurationUpdate_protocolIEs__item__id_tab_val_Value_3,
        _____WTConfigurationUpdate_protocolIEs__item__id_tab_val_Value_4,
        ___WTConfigurationUpdate_protocolIEs__item__id,
        ___WTConfigurationUpdate_protocolIEs__item__criticality,
        ___WTConfigurationUpdate_protocolIEs__item__value,
        __WTConfigurationUpdate_protocolIEs__item_,
        _WTConfigurationUpdate_protocolIEs,
        WTConfigurationUpdate,
        WTConfigurationUpdateIEs,
        _WTConfigurationUpdateIEs_val_Value_0,
        _WTConfigurationUpdateIEs_val_Value_1,
        _WTConfigurationUpdateIEs_val_Value_2,
        _WTConfigurationUpdateIEs_val_Value_3,
        _WTConfigurationUpdateIEs_val_Value_4,
        ____WTConfigurationUpdateAcknowledge_protocolIEs__item__id_tab,
        _____WTConfigurationUpdateAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        ___WTConfigurationUpdateAcknowledge_protocolIEs__item__id,
        ___WTConfigurationUpdateAcknowledge_protocolIEs__item__criticality,
        ___WTConfigurationUpdateAcknowledge_protocolIEs__item__value,
        __WTConfigurationUpdateAcknowledge_protocolIEs__item_,
        _WTConfigurationUpdateAcknowledge_protocolIEs,
        WTConfigurationUpdateAcknowledge,
        WTConfigurationUpdateAcknowledgeIEs,
        _WTConfigurationUpdateAcknowledgeIEs_val_Value_0,
        ____WTConfigurationUpdateFailure_protocolIEs__item__id_tab,
        _____WTConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____WTConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____WTConfigurationUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        ___WTConfigurationUpdateFailure_protocolIEs__item__id,
        ___WTConfigurationUpdateFailure_protocolIEs__item__criticality,
        ___WTConfigurationUpdateFailure_protocolIEs__item__value,
        __WTConfigurationUpdateFailure_protocolIEs__item_,
        _WTConfigurationUpdateFailure_protocolIEs,
        WTConfigurationUpdateFailure,
        WTConfigurationUpdateFailureIEs,
        _WTConfigurationUpdateFailureIEs_val_Value_0,
        _WTConfigurationUpdateFailureIEs_val_Value_1,
        _WTConfigurationUpdateFailureIEs_val_Value_2,
        ____WTStatusRequest_protocolIEs__item__id_tab,
        _____WTStatusRequest_protocolIEs__item__id_tab_val_Value_0,
        _____WTStatusRequest_protocolIEs__item__id_tab_val_Value_1,
        _____WTStatusRequest_protocolIEs__item__id_tab_val_Value_2,
        _____WTStatusRequest_protocolIEs__item__id_tab_val_Value_3,
        _____WTStatusRequest_protocolIEs__item__id_tab_val_Value_4,
        _____WTStatusRequest_protocolIEs__item__id_tab_val_Value_5,
        _____WTStatusRequest_protocolIEs__item__id_tab_val_Value_6,
        ___WTStatusRequest_protocolIEs__item__id,
        ___WTStatusRequest_protocolIEs__item__criticality,
        ___WTStatusRequest_protocolIEs__item__value,
        __WTStatusRequest_protocolIEs__item_,
        _WTStatusRequest_protocolIEs,
        WTStatusRequest,
        WTStatusRequest_IEs,
        _WTStatusRequest_IEs_val_Value_0,
        _WTStatusRequest_IEs_val_Value_1,
        _WTStatusRequest_IEs_val_Value_2,
        _WTStatusRequest_IEs_val_Value_3,
        _WTStatusRequest_IEs_val_Value_4,
        _WTStatusRequest_IEs_val_Value_5,
        _WTStatusRequest_IEs_val_Value_6,
        ____WTStatusResponse_protocolIEs__item__id_tab,
        _____WTStatusResponse_protocolIEs__item__id_tab_val_Value_0,
        _____WTStatusResponse_protocolIEs__item__id_tab_val_Value_1,
        _____WTStatusResponse_protocolIEs__item__id_tab_val_Value_2,
        _____WTStatusResponse_protocolIEs__item__id_tab_val_Value_3,
        ___WTStatusResponse_protocolIEs__item__id,
        ___WTStatusResponse_protocolIEs__item__criticality,
        ___WTStatusResponse_protocolIEs__item__value,
        __WTStatusResponse_protocolIEs__item_,
        _WTStatusResponse_protocolIEs,
        WTStatusResponse,
        WTStatusResponse_IEs,
        _WTStatusResponse_IEs_val_Value_0,
        _WTStatusResponse_IEs_val_Value_1,
        _WTStatusResponse_IEs_val_Value_2,
        _WTStatusResponse_IEs_val_Value_3,
        ____WTStatusFailure_protocolIEs__item__id_tab,
        _____WTStatusFailure_protocolIEs__item__id_tab_val_Value_0,
        _____WTStatusFailure_protocolIEs__item__id_tab_val_Value_1,
        _____WTStatusFailure_protocolIEs__item__id_tab_val_Value_2,
        _____WTStatusFailure_protocolIEs__item__id_tab_val_Value_3,
        _____WTStatusFailure_protocolIEs__item__id_tab_val_Value_4,
        ___WTStatusFailure_protocolIEs__item__id,
        ___WTStatusFailure_protocolIEs__item__criticality,
        ___WTStatusFailure_protocolIEs__item__value,
        __WTStatusFailure_protocolIEs__item_,
        _WTStatusFailure_protocolIEs,
        WTStatusFailure,
        WTStatusFailure_IEs,
        _WTStatusFailure_IEs_val_Value_0,
        _WTStatusFailure_IEs_val_Value_1,
        _WTStatusFailure_IEs_val_Value_2,
        _WTStatusFailure_IEs_val_Value_3,
        _WTStatusFailure_IEs_val_Value_4,
        ____WTStatusReport_protocolIEs__item__id_tab,
        _____WTStatusReport_protocolIEs__item__id_tab_val_Value_0,
        _____WTStatusReport_protocolIEs__item__id_tab_val_Value_1,
        _____WTStatusReport_protocolIEs__item__id_tab_val_Value_2,
        ___WTStatusReport_protocolIEs__item__id,
        ___WTStatusReport_protocolIEs__item__criticality,
        ___WTStatusReport_protocolIEs__item__value,
        __WTStatusReport_protocolIEs__item_,
        _WTStatusReport_protocolIEs,
        WTStatusReport,
        WTStatusReport_IEs,
        _WTStatusReport_IEs_val_Value_0,
        _WTStatusReport_IEs_val_Value_1,
        _WTStatusReport_IEs_val_Value_2,
        ____ErrorIndication_protocolIEs__item__id_tab,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3,
        ___ErrorIndication_protocolIEs__item__id,
        ___ErrorIndication_protocolIEs__item__criticality,
        ___ErrorIndication_protocolIEs__item__value,
        __ErrorIndication_protocolIEs__item_,
        _ErrorIndication_protocolIEs,
        ErrorIndication,
        ErrorIndication_IEs,
        _ErrorIndication_IEs_val_Value_0,
        _ErrorIndication_IEs_val_Value_1,
        _ErrorIndication_IEs_val_Value_2,
        _ErrorIndication_IEs_val_Value_3,
        ____Reset_protocolIEs__item__id_tab,
        _____Reset_protocolIEs__item__id_tab_val_Value_0,
        ___Reset_protocolIEs__item__id,
        ___Reset_protocolIEs__item__criticality,
        ___Reset_protocolIEs__item__value,
        __Reset_protocolIEs__item_,
        _Reset_protocolIEs,
        Reset,
        Reset_IEs,
        _Reset_IEs_val_Value_0,
        ____ResetResponse_protocolIEs__item__id_tab,
        _____ResetResponse_protocolIEs__item__id_tab_val_Value_0,
        ___ResetResponse_protocolIEs__item__id,
        ___ResetResponse_protocolIEs__item__criticality,
        ___ResetResponse_protocolIEs__item__value,
        __ResetResponse_protocolIEs__item_,
        _ResetResponse_protocolIEs,
        ResetResponse,
        ResetResponse_IEs,
        _ResetResponse_IEs_val_Value_0,
        ____WTAdditionRequest_protocolIEs__item__id_tab,
        _____WTAdditionRequest_protocolIEs__item__id_tab_val_Value_0,
        _____WTAdditionRequest_protocolIEs__item__id_tab_val_Value_1,
        _____WTAdditionRequest_protocolIEs__item__id_tab_val_Value_2,
        _____WTAdditionRequest_protocolIEs__item__id_tab_val_Value_3,
        _____WTAdditionRequest_protocolIEs__item__id_tab_val_Value_4,
        _____WTAdditionRequest_protocolIEs__item__id_tab_val_Value_5,
        _____WTAdditionRequest_protocolIEs__item__id_tab_val_Value_6,
        ___WTAdditionRequest_protocolIEs__item__id,
        ___WTAdditionRequest_protocolIEs__item__criticality,
        ___WTAdditionRequest_protocolIEs__item__value,
        __WTAdditionRequest_protocolIEs__item_,
        _WTAdditionRequest_protocolIEs,
        WTAdditionRequest,
        WTAdditionRequestIEs,
        _WTAdditionRequestIEs_val_Value_0,
        _WTAdditionRequestIEs_val_Value_1,
        _WTAdditionRequestIEs_val_Value_2,
        _WTAdditionRequestIEs_val_Value_3,
        _WTAdditionRequestIEs_val_Value_4,
        _WTAdditionRequestIEs_val_Value_5,
        _WTAdditionRequestIEs_val_Value_6,
        ___E_RABs_ToBeAdded_List__item__id_tab,
        ____E_RABs_ToBeAdded_List__item__id_tab_val_Value_0,
        __E_RABs_ToBeAdded_List__item__id,
        __E_RABs_ToBeAdded_List__item__criticality,
        __E_RABs_ToBeAdded_List__item__value,
        _E_RABs_ToBeAdded_List__item_,
        E_RABs_ToBeAdded_List,
        E_RABs_ToBeAdded_ItemIEs,
        _E_RABs_ToBeAdded_ItemIEs_val_Value_0,
        _E_RABs_ToBeAdded_Item_e_RAB_ID,
        _E_RABs_ToBeAdded_Item_e_RAB_QoS_Parameters,
        _E_RABs_ToBeAdded_Item_eNB_GTPtunnelEndpoint,
        ____E_RABs_ToBeAdded_Item_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeAdded_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABs_ToBeAdded_Item_iE_Extensions__item__id,
        ___E_RABs_ToBeAdded_Item_iE_Extensions__item__criticality,
        ___E_RABs_ToBeAdded_Item_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeAdded_Item_iE_Extensions__item_,
        _E_RABs_ToBeAdded_Item_iE_Extensions,
        E_RABs_ToBeAdded_Item,
        E_RABs_ToBeAdded_ItemExtIEs,
        _E_RABs_ToBeAdded_ItemExtIEs_val_Extension_0,
        ____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab,
        _____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____WTAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        ___WTAdditionRequestAcknowledge_protocolIEs__item__id,
        ___WTAdditionRequestAcknowledge_protocolIEs__item__criticality,
        ___WTAdditionRequestAcknowledge_protocolIEs__item__value,
        __WTAdditionRequestAcknowledge_protocolIEs__item_,
        _WTAdditionRequestAcknowledge_protocolIEs,
        WTAdditionRequestAcknowledge,
        WTAdditionRequestAcknowledgeIEs,
        _WTAdditionRequestAcknowledgeIEs_val_Value_0,
        _WTAdditionRequestAcknowledgeIEs_val_Value_1,
        _WTAdditionRequestAcknowledgeIEs_val_Value_2,
        _WTAdditionRequestAcknowledgeIEs_val_Value_3,
        _WTAdditionRequestAcknowledgeIEs_val_Value_4,
        _WTAdditionRequestAcknowledgeIEs_val_Value_5,
        ___E_RABs_Admitted_ToBeAdded_List__item__id_tab,
        ____E_RABs_Admitted_ToBeAdded_List__item__id_tab_val_Value_0,
        __E_RABs_Admitted_ToBeAdded_List__item__id,
        __E_RABs_Admitted_ToBeAdded_List__item__criticality,
        __E_RABs_Admitted_ToBeAdded_List__item__value,
        _E_RABs_Admitted_ToBeAdded_List__item_,
        E_RABs_Admitted_ToBeAdded_List,
        E_RABs_Admitted_ToBeAdded_ItemIEs,
        _E_RABs_Admitted_ToBeAdded_ItemIEs_val_Value_0,
        _E_RABs_Admitted_ToBeAdded_Item_e_RAB_ID,
        _E_RABs_Admitted_ToBeAdded_Item_wT_GTPtunnelEndpoint,
        ____E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__id_tab,
        _____E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__id,
        ___E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeAdded_Item_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeAdded_Item_iE_Extensions,
        E_RABs_Admitted_ToBeAdded_Item,
        E_RABs_Admitted_ToBeAdded_ItemExtIEs,
        _E_RABs_Admitted_ToBeAdded_ItemExtIEs_val_Extension_0,
        ____WTAdditionRequestReject_protocolIEs__item__id_tab,
        _____WTAdditionRequestReject_protocolIEs__item__id_tab_val_Value_0,
        _____WTAdditionRequestReject_protocolIEs__item__id_tab_val_Value_1,
        _____WTAdditionRequestReject_protocolIEs__item__id_tab_val_Value_2,
        ___WTAdditionRequestReject_protocolIEs__item__id,
        ___WTAdditionRequestReject_protocolIEs__item__criticality,
        ___WTAdditionRequestReject_protocolIEs__item__value,
        __WTAdditionRequestReject_protocolIEs__item_,
        _WTAdditionRequestReject_protocolIEs,
        WTAdditionRequestReject,
        WTAdditionRequestRejectIEs,
        _WTAdditionRequestRejectIEs_val_Value_0,
        _WTAdditionRequestRejectIEs_val_Value_1,
        _WTAdditionRequestRejectIEs_val_Value_2,
        ____WTModificationRequest_protocolIEs__item__id_tab,
        _____WTModificationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____WTModificationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____WTModificationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____WTModificationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____WTModificationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____WTModificationRequest_protocolIEs__item__id_tab_val_Value_5,
        ___WTModificationRequest_protocolIEs__item__id,
        ___WTModificationRequest_protocolIEs__item__criticality,
        ___WTModificationRequest_protocolIEs__item__value,
        __WTModificationRequest_protocolIEs__item_,
        _WTModificationRequest_protocolIEs,
        WTModificationRequest,
        WTModificationRequestIEs,
        _WTModificationRequestIEs_val_Value_0,
        _WTModificationRequestIEs_val_Value_1,
        _WTModificationRequestIEs_val_Value_2,
        _WTModificationRequestIEs_val_Value_3,
        _WTModificationRequestIEs_val_Value_4,
        _WTModificationRequestIEs_val_Value_5,
        _UE_ContextInformationWTModReq_wLANSecurityInfo,
        _UE_ContextInformationWTModReq_e_RABs_ToBeAdded,
        _UE_ContextInformationWTModReq_e_RABs_ToBeModified,
        _UE_ContextInformationWTModReq_e_RABs_ToBeReleased,
        ____UE_ContextInformationWTModReq_iE_Extensions__item__id_tab,
        ___UE_ContextInformationWTModReq_iE_Extensions__item__id,
        ____UE_ContextInformationWTModReq_iE_Extensions__item__criticality_tab,
        ___UE_ContextInformationWTModReq_iE_Extensions__item__criticality,
        ____UE_ContextInformationWTModReq_iE_Extensions__item__extensionValue_tab,
        ___UE_ContextInformationWTModReq_iE_Extensions__item__extensionValue,
        __UE_ContextInformationWTModReq_iE_Extensions__item_,
        _UE_ContextInformationWTModReq_iE_Extensions,
        UE_ContextInformationWTModReq,
        UE_ContextInformationWTModReqExtIEs,
        ___E_RABs_ToBeAdded_List_ModReq__item__id_tab,
        ____E_RABs_ToBeAdded_List_ModReq__item__id_tab_val_Value_0,
        __E_RABs_ToBeAdded_List_ModReq__item__id,
        __E_RABs_ToBeAdded_List_ModReq__item__criticality,
        __E_RABs_ToBeAdded_List_ModReq__item__value,
        _E_RABs_ToBeAdded_List_ModReq__item_,
        E_RABs_ToBeAdded_List_ModReq,
        E_RABs_ToBeAdded_ModReqItemIEs,
        _E_RABs_ToBeAdded_ModReqItemIEs_val_Value_0,
        _E_RABs_ToBeAdded_ModReqItem_e_RAB_ID,
        _E_RABs_ToBeAdded_ModReqItem_e_RAB_QoS_Parameters,
        _E_RABs_ToBeAdded_ModReqItem_eNB_GTPtunnelEndpoint,
        ____E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__id,
        ___E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__criticality,
        ___E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeAdded_ModReqItem_iE_Extensions__item_,
        _E_RABs_ToBeAdded_ModReqItem_iE_Extensions,
        E_RABs_ToBeAdded_ModReqItem,
        E_RABs_ToBeAdded_ModReqItemExtIEs,
        _E_RABs_ToBeAdded_ModReqItemExtIEs_val_Extension_0,
        ___E_RABs_ToBeModified_List_ModReq__item__id_tab,
        ____E_RABs_ToBeModified_List_ModReq__item__id_tab_val_Value_0,
        __E_RABs_ToBeModified_List_ModReq__item__id,
        __E_RABs_ToBeModified_List_ModReq__item__criticality,
        __E_RABs_ToBeModified_List_ModReq__item__value,
        _E_RABs_ToBeModified_List_ModReq__item_,
        E_RABs_ToBeModified_List_ModReq,
        E_RABs_ToBeModified_ModReqItemIEs,
        _E_RABs_ToBeModified_ModReqItemIEs_val_Value_0,
        _E_RABs_ToBeModified_ModReqItem_e_RAB_ID,
        _E_RABs_ToBeModified_ModReqItem_e_RAB_QoS_Parameters,
        _E_RABs_ToBeModified_ModReqItem_eNB_GTPtunnelEndpoint,
        ____E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__id,
        ____E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__criticality,
        ____E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeModified_ModReqItem_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeModified_ModReqItem_iE_Extensions__item_,
        _E_RABs_ToBeModified_ModReqItem_iE_Extensions,
        E_RABs_ToBeModified_ModReqItem,
        E_RABs_ToBeModified_ModReqItemExtIEs,
        ___E_RABs_ToBeReleased_List_ModReq__item__id_tab,
        ____E_RABs_ToBeReleased_List_ModReq__item__id_tab_val_Value_0,
        __E_RABs_ToBeReleased_List_ModReq__item__id,
        __E_RABs_ToBeReleased_List_ModReq__item__criticality,
        __E_RABs_ToBeReleased_List_ModReq__item__value,
        _E_RABs_ToBeReleased_List_ModReq__item_,
        E_RABs_ToBeReleased_List_ModReq,
        E_RABs_ToBeReleased_ModReqItemIEs,
        _E_RABs_ToBeReleased_ModReqItemIEs_val_Value_0,
        _E_RABs_ToBeReleased_ModReqItem_e_RAB_ID,
        _E_RABs_ToBeReleased_ModReqItem_dL_GTPtunnelEndpoint,
        ____E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_ModReqItem_iE_Extensions__item_,
        _E_RABs_ToBeReleased_ModReqItem_iE_Extensions,
        E_RABs_ToBeReleased_ModReqItem,
        E_RABs_ToBeReleased_ModReqItemExtIEs,
        ____WTModificationRequestAcknowledge_protocolIEs__item__id_tab,
        _____WTModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____WTModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____WTModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____WTModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____WTModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____WTModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        _____WTModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_6,
        ___WTModificationRequestAcknowledge_protocolIEs__item__id,
        ___WTModificationRequestAcknowledge_protocolIEs__item__criticality,
        ___WTModificationRequestAcknowledge_protocolIEs__item__value,
        __WTModificationRequestAcknowledge_protocolIEs__item_,
        _WTModificationRequestAcknowledge_protocolIEs,
        WTModificationRequestAcknowledge,
        WTModificationRequestAcknowledgeIEs,
        _WTModificationRequestAcknowledgeIEs_val_Value_0,
        _WTModificationRequestAcknowledgeIEs_val_Value_1,
        _WTModificationRequestAcknowledgeIEs_val_Value_2,
        _WTModificationRequestAcknowledgeIEs_val_Value_3,
        _WTModificationRequestAcknowledgeIEs_val_Value_4,
        _WTModificationRequestAcknowledgeIEs_val_Value_5,
        _WTModificationRequestAcknowledgeIEs_val_Value_6,
        ___E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab,
        ____E_RABs_Admitted_ToBeAdded_ModAckList__item__id_tab_val_Value_0,
        __E_RABs_Admitted_ToBeAdded_ModAckList__item__id,
        __E_RABs_Admitted_ToBeAdded_ModAckList__item__criticality,
        __E_RABs_Admitted_ToBeAdded_ModAckList__item__value,
        _E_RABs_Admitted_ToBeAdded_ModAckList__item_,
        E_RABs_Admitted_ToBeAdded_ModAckList,
        E_RABs_Admitted_ToBeAdded_ModAckItemIEs,
        _E_RABs_Admitted_ToBeAdded_ModAckItemIEs_val_Value_0,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_e_RAB_ID,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_wT_GTPtunnelEndpoint,
        ____E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__id_tab,
        _____E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__id,
        ___E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeAdded_ModAckItem_iE_Extensions,
        E_RABs_Admitted_ToBeAdded_ModAckItem,
        E_RABs_Admitted_ToBeAdded_ModAckItemExtIEs,
        _E_RABs_Admitted_ToBeAdded_ModAckItemExtIEs_val_Extension_0,
        ___E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab,
        ____E_RABs_Admitted_ToBeModified_ModAckList__item__id_tab_val_Value_0,
        __E_RABs_Admitted_ToBeModified_ModAckList__item__id,
        __E_RABs_Admitted_ToBeModified_ModAckList__item__criticality,
        __E_RABs_Admitted_ToBeModified_ModAckList__item__value,
        _E_RABs_Admitted_ToBeModified_ModAckList__item_,
        E_RABs_Admitted_ToBeModified_ModAckList,
        E_RABs_Admitted_ToBeModified_ModAckItemIEs,
        _E_RABs_Admitted_ToBeModified_ModAckItemIEs_val_Value_0,
        _E_RABs_Admitted_ToBeModified_ModAckItem_e_RAB_ID,
        _E_RABs_Admitted_ToBeModified_ModAckItem_wT_GTPtunnelEndpoint,
        ____E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__id_tab,
        _____E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__id,
        ___E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__criticality,
        ___E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeModified_ModAckItem_iE_Extensions,
        E_RABs_Admitted_ToBeModified_ModAckItem,
        E_RABs_Admitted_ToBeModified_ModAckItemExtIEs,
        _E_RABs_Admitted_ToBeModified_ModAckItemExtIEs_val_Extension_0,
        ___E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab,
        ____E_RABs_Admitted_ToBeReleased_ModAckList__item__id_tab_val_Value_0,
        __E_RABs_Admitted_ToBeReleased_ModAckList__item__id,
        __E_RABs_Admitted_ToBeReleased_ModAckList__item__criticality,
        __E_RABs_Admitted_ToBeReleased_ModAckList__item__value,
        _E_RABs_Admitted_ToBeReleased_ModAckList__item_,
        E_RABs_Admitted_ToBeReleased_ModAckList,
        E_RABs_Admitted_ToBeReleased_ModAckItemIEs,
        _E_RABs_Admitted_ToBeReleased_ModAckItemIEs_val_Value_0,
        _E_RABs_Admitted_ToBeReleased_ModAckItem_e_RAB_ID,
        ____E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__id_tab,
        ___E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__id,
        ____E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__criticality_tab,
        ___E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__criticality,
        ____E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item__extensionValue,
        __E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions__item_,
        _E_RABs_Admitted_ToBeReleased_ModAckItem_iE_Extensions,
        E_RABs_Admitted_ToBeReleased_ModAckItem,
        E_RABs_Admitted_ToBeReleased_ModAckItemExtIEs,
        ____WTModificationRequestReject_protocolIEs__item__id_tab,
        _____WTModificationRequestReject_protocolIEs__item__id_tab_val_Value_0,
        _____WTModificationRequestReject_protocolIEs__item__id_tab_val_Value_1,
        _____WTModificationRequestReject_protocolIEs__item__id_tab_val_Value_2,
        _____WTModificationRequestReject_protocolIEs__item__id_tab_val_Value_3,
        ___WTModificationRequestReject_protocolIEs__item__id,
        ___WTModificationRequestReject_protocolIEs__item__criticality,
        ___WTModificationRequestReject_protocolIEs__item__value,
        __WTModificationRequestReject_protocolIEs__item_,
        _WTModificationRequestReject_protocolIEs,
        WTModificationRequestReject,
        WTModificationRequestRejectIEs,
        _WTModificationRequestRejectIEs_val_Value_0,
        _WTModificationRequestRejectIEs_val_Value_1,
        _WTModificationRequestRejectIEs_val_Value_2,
        _WTModificationRequestRejectIEs_val_Value_3,
        ____WTModificationRequired_protocolIEs__item__id_tab,
        _____WTModificationRequired_protocolIEs__item__id_tab_val_Value_0,
        _____WTModificationRequired_protocolIEs__item__id_tab_val_Value_1,
        _____WTModificationRequired_protocolIEs__item__id_tab_val_Value_2,
        _____WTModificationRequired_protocolIEs__item__id_tab_val_Value_3,
        _____WTModificationRequired_protocolIEs__item__id_tab_val_Value_4,
        ___WTModificationRequired_protocolIEs__item__id,
        ___WTModificationRequired_protocolIEs__item__criticality,
        ___WTModificationRequired_protocolIEs__item__value,
        __WTModificationRequired_protocolIEs__item_,
        _WTModificationRequired_protocolIEs,
        WTModificationRequired,
        WTModificationRequiredIEs,
        _WTModificationRequiredIEs_val_Value_0,
        _WTModificationRequiredIEs_val_Value_1,
        _WTModificationRequiredIEs_val_Value_2,
        _WTModificationRequiredIEs_val_Value_3,
        _WTModificationRequiredIEs_val_Value_4,
        ___E_RABs_ToBeReleased_ModReqdList__item__id_tab,
        ____E_RABs_ToBeReleased_ModReqdList__item__id_tab_val_Value_0,
        __E_RABs_ToBeReleased_ModReqdList__item__id,
        __E_RABs_ToBeReleased_ModReqdList__item__criticality,
        __E_RABs_ToBeReleased_ModReqdList__item__value,
        _E_RABs_ToBeReleased_ModReqdList__item_,
        E_RABs_ToBeReleased_ModReqdList,
        E_RABs_ToBeReleased_ModReqdItemIEs,
        _E_RABs_ToBeReleased_ModReqdItemIEs_val_Value_0,
        _E_RABs_ToBeReleased_ModReqdItem_e_RAB_ID,
        _E_RABs_ToBeReleased_ModReqdItem_cause,
        ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_ModReqdItem_iE_Extensions__item_,
        _E_RABs_ToBeReleased_ModReqdItem_iE_Extensions,
        E_RABs_ToBeReleased_ModReqdItem,
        E_RABs_ToBeReleased_ModReqdItemExtIEs,
        ___E_RABs_ToBeModified_ModReqdList__item__id_tab,
        ____E_RABs_ToBeModified_ModReqdList__item__id_tab_val_Value_0,
        __E_RABs_ToBeModified_ModReqdList__item__id,
        __E_RABs_ToBeModified_ModReqdList__item__criticality,
        __E_RABs_ToBeModified_ModReqdList__item__value,
        _E_RABs_ToBeModified_ModReqdList__item_,
        E_RABs_ToBeModified_ModReqdList,
        E_RABs_ToBeModified_ModReqdItemIEs,
        _E_RABs_ToBeModified_ModReqdItemIEs_val_Value_0,
        _E_RABs_ToBeModified_ModReqdItem_e_RAB_ID,
        _E_RABs_ToBeModified_ModReqdItem_wT_GTPtunnelEndpoint,
        ____E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__id_tab,
        _____E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__id,
        ___E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__criticality,
        ___E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeModified_ModReqdItem_iE_Extensions__item_,
        _E_RABs_ToBeModified_ModReqdItem_iE_Extensions,
        E_RABs_ToBeModified_ModReqdItem,
        E_RABs_ToBeModified_ModReqdItemExtIEs,
        _E_RABs_ToBeModified_ModReqdItemExtIEs_val_Extension_0,
        ____WTModificationConfirm_protocolIEs__item__id_tab,
        _____WTModificationConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____WTModificationConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____WTModificationConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____WTModificationConfirm_protocolIEs__item__id_tab_val_Value_3,
        _____WTModificationConfirm_protocolIEs__item__id_tab_val_Value_4,
        ___WTModificationConfirm_protocolIEs__item__id,
        ___WTModificationConfirm_protocolIEs__item__criticality,
        ___WTModificationConfirm_protocolIEs__item__value,
        __WTModificationConfirm_protocolIEs__item_,
        _WTModificationConfirm_protocolIEs,
        WTModificationConfirm,
        WTModificationConfirmIEs,
        _WTModificationConfirmIEs_val_Value_0,
        _WTModificationConfirmIEs_val_Value_1,
        _WTModificationConfirmIEs_val_Value_2,
        _WTModificationConfirmIEs_val_Value_3,
        _WTModificationConfirmIEs_val_Value_4,
        ___E_RABs_Confirmed_ToBeReleased_ModReqdList__item__id_tab,
        ____E_RABs_Confirmed_ToBeReleased_ModReqdList__item__id_tab_val_Value_0,
        __E_RABs_Confirmed_ToBeReleased_ModReqdList__item__id,
        __E_RABs_Confirmed_ToBeReleased_ModReqdList__item__criticality,
        __E_RABs_Confirmed_ToBeReleased_ModReqdList__item__value,
        _E_RABs_Confirmed_ToBeReleased_ModReqdList__item_,
        E_RABs_Confirmed_ToBeReleased_ModReqdList,
        E_RABs_Confirmed_ToBeReleased_ModReqdItemIEs,
        _E_RABs_Confirmed_ToBeReleased_ModReqdItemIEs_val_Value_0,
        _E_RABs_Confirmed_ToBeReleased_ModReqdItem_e_RAB_ID,
        _E_RABs_Confirmed_ToBeReleased_ModReqdItem_dL_GTPtunnelEndpoint,
        ____E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__id_tab,
        ___E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__id,
        ____E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality_tab,
        ___E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__criticality,
        ____E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item__extensionValue,
        __E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions__item_,
        _E_RABs_Confirmed_ToBeReleased_ModReqdItem_iE_Extensions,
        E_RABs_Confirmed_ToBeReleased_ModReqdItem,
        E_RABs_Confirmed_ToBeReleased_ModReqdItemExtIEs,
        ___E_RABs_Confirmed_ToBeModified_ModReqdList__item__id_tab,
        ____E_RABs_Confirmed_ToBeModified_ModReqdList__item__id_tab_val_Value_0,
        __E_RABs_Confirmed_ToBeModified_ModReqdList__item__id,
        __E_RABs_Confirmed_ToBeModified_ModReqdList__item__criticality,
        __E_RABs_Confirmed_ToBeModified_ModReqdList__item__value,
        _E_RABs_Confirmed_ToBeModified_ModReqdList__item_,
        E_RABs_Confirmed_ToBeModified_ModReqdList,
        E_RABs_Confirmed_ToBeModified_ModReqdItemIEs,
        _E_RABs_Confirmed_ToBeModified_ModReqdItemIEs_val_Value_0,
        _E_RABs_Confirmed_ToBeModified_ModReqdItem_e_RAB_ID,
        ____E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__id_tab,
        ___E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__id,
        ____E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__criticality_tab,
        ___E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__criticality,
        ____E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item__extensionValue,
        __E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions__item_,
        _E_RABs_Confirmed_ToBeModified_ModReqdItem_iE_Extensions,
        E_RABs_Confirmed_ToBeModified_ModReqdItem,
        E_RABs_Confirmed_ToBeModified_ModReqdItemExtIEs,
        ____WTModificationRefuse_protocolIEs__item__id_tab,
        _____WTModificationRefuse_protocolIEs__item__id_tab_val_Value_0,
        _____WTModificationRefuse_protocolIEs__item__id_tab_val_Value_1,
        _____WTModificationRefuse_protocolIEs__item__id_tab_val_Value_2,
        _____WTModificationRefuse_protocolIEs__item__id_tab_val_Value_3,
        ___WTModificationRefuse_protocolIEs__item__id,
        ___WTModificationRefuse_protocolIEs__item__criticality,
        ___WTModificationRefuse_protocolIEs__item__value,
        __WTModificationRefuse_protocolIEs__item_,
        _WTModificationRefuse_protocolIEs,
        WTModificationRefuse,
        WTModificationRefuseIEs,
        _WTModificationRefuseIEs_val_Value_0,
        _WTModificationRefuseIEs_val_Value_1,
        _WTModificationRefuseIEs_val_Value_2,
        _WTModificationRefuseIEs_val_Value_3,
        ____WTReleaseRequest_protocolIEs__item__id_tab,
        _____WTReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        _____WTReleaseRequest_protocolIEs__item__id_tab_val_Value_1,
        _____WTReleaseRequest_protocolIEs__item__id_tab_val_Value_2,
        _____WTReleaseRequest_protocolIEs__item__id_tab_val_Value_3,
        _____WTReleaseRequest_protocolIEs__item__id_tab_val_Value_4,
        ___WTReleaseRequest_protocolIEs__item__id,
        ___WTReleaseRequest_protocolIEs__item__criticality,
        ___WTReleaseRequest_protocolIEs__item__value,
        __WTReleaseRequest_protocolIEs__item_,
        _WTReleaseRequest_protocolIEs,
        WTReleaseRequest,
        WTReleaseRequest_IEs,
        _WTReleaseRequest_IEs_val_Value_0,
        _WTReleaseRequest_IEs_val_Value_1,
        _WTReleaseRequest_IEs_val_Value_2,
        _WTReleaseRequest_IEs_val_Value_3,
        _WTReleaseRequest_IEs_val_Value_4,
        ___E_RABs_ToBeReleased_List_RelReq__item__id_tab,
        ____E_RABs_ToBeReleased_List_RelReq__item__id_tab_val_Value_0,
        __E_RABs_ToBeReleased_List_RelReq__item__id,
        __E_RABs_ToBeReleased_List_RelReq__item__criticality,
        __E_RABs_ToBeReleased_List_RelReq__item__value,
        _E_RABs_ToBeReleased_List_RelReq__item_,
        E_RABs_ToBeReleased_List_RelReq,
        E_RABs_ToBeReleased_RelReqItemIEs,
        _E_RABs_ToBeReleased_RelReqItemIEs_val_Value_0,
        _E_RABs_ToBeReleased_RelReqItem_e_RAB_ID,
        _E_RABs_ToBeReleased_RelReqItem_wT_GTPtunnelEndpoint,
        ____E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_RelReqItem_iE_Extensions__item_,
        _E_RABs_ToBeReleased_RelReqItem_iE_Extensions,
        E_RABs_ToBeReleased_RelReqItem,
        E_RABs_ToBeReleased_RelReqItemExtIEs,
        ____WTReleaseRequired_protocolIEs__item__id_tab,
        _____WTReleaseRequired_protocolIEs__item__id_tab_val_Value_0,
        _____WTReleaseRequired_protocolIEs__item__id_tab_val_Value_1,
        _____WTReleaseRequired_protocolIEs__item__id_tab_val_Value_2,
        ___WTReleaseRequired_protocolIEs__item__id,
        ___WTReleaseRequired_protocolIEs__item__criticality,
        ___WTReleaseRequired_protocolIEs__item__value,
        __WTReleaseRequired_protocolIEs__item_,
        _WTReleaseRequired_protocolIEs,
        WTReleaseRequired,
        WTReleaseRequiredIEs,
        _WTReleaseRequiredIEs_val_Value_0,
        _WTReleaseRequiredIEs_val_Value_1,
        _WTReleaseRequiredIEs_val_Value_2,
        ____WTReleaseConfirm_protocolIEs__item__id_tab,
        _____WTReleaseConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____WTReleaseConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____WTReleaseConfirm_protocolIEs__item__id_tab_val_Value_2,
        _____WTReleaseConfirm_protocolIEs__item__id_tab_val_Value_3,
        ___WTReleaseConfirm_protocolIEs__item__id,
        ___WTReleaseConfirm_protocolIEs__item__criticality,
        ___WTReleaseConfirm_protocolIEs__item__value,
        __WTReleaseConfirm_protocolIEs__item_,
        _WTReleaseConfirm_protocolIEs,
        WTReleaseConfirm,
        WTReleaseConfirmIEs,
        _WTReleaseConfirmIEs_val_Value_0,
        _WTReleaseConfirmIEs_val_Value_1,
        _WTReleaseConfirmIEs_val_Value_2,
        _WTReleaseConfirmIEs_val_Value_3,
        ___E_RABs_ToBeReleased_List_RelConf__item__id_tab,
        ____E_RABs_ToBeReleased_List_RelConf__item__id_tab_val_Value_0,
        __E_RABs_ToBeReleased_List_RelConf__item__id,
        __E_RABs_ToBeReleased_List_RelConf__item__criticality,
        __E_RABs_ToBeReleased_List_RelConf__item__value,
        _E_RABs_ToBeReleased_List_RelConf__item_,
        E_RABs_ToBeReleased_List_RelConf,
        E_RABs_ToBeReleased_RelConfItemIEs,
        _E_RABs_ToBeReleased_RelConfItemIEs_val_Value_0,
        _E_RABs_ToBeReleased_RelConfItem_e_RAB_ID,
        _E_RABs_ToBeReleased_RelConfItem_wT_GTPtunnelEndpoint,
        ____E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__id_tab,
        ___E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__id,
        ____E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__criticality_tab,
        ___E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__criticality,
        ____E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__extensionValue_tab,
        ___E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item__extensionValue,
        __E_RABs_ToBeReleased_RelConfItem_iE_Extensions__item_,
        _E_RABs_ToBeReleased_RelConfItem_iE_Extensions,
        E_RABs_ToBeReleased_RelConfItem,
        E_RABs_ToBeReleased_RelConfItemExtIEs,
        ____WTAssociationConfirmation_protocolIEs__item__id_tab,
        _____WTAssociationConfirmation_protocolIEs__item__id_tab_val_Value_0,
        _____WTAssociationConfirmation_protocolIEs__item__id_tab_val_Value_1,
        ___WTAssociationConfirmation_protocolIEs__item__id,
        ___WTAssociationConfirmation_protocolIEs__item__criticality,
        ___WTAssociationConfirmation_protocolIEs__item__value,
        __WTAssociationConfirmation_protocolIEs__item_,
        _WTAssociationConfirmation_protocolIEs,
        WTAssociationConfirmation,
        WTAssociationConfirmationIEs,
        _WTAssociationConfirmationIEs_val_Value_0,
        _WTAssociationConfirmationIEs_val_Value_1,
        ____PrivateMessage_privateIEs__item__id_tab,
        ___PrivateMessage_privateIEs__item__id,
        ____PrivateMessage_privateIEs__item__criticality_tab,
        ___PrivateMessage_privateIEs__item__criticality,
        ____PrivateMessage_privateIEs__item__value_tab,
        ___PrivateMessage_privateIEs__item__value,
        __PrivateMessage_privateIEs__item_,
        _PrivateMessage_privateIEs,
        PrivateMessage,
        PrivateMessage_IEs,
        ____LWIPAdditionRequest_protocolIEs__item__id_tab,
        _____LWIPAdditionRequest_protocolIEs__item__id_tab_val_Value_0,
        _____LWIPAdditionRequest_protocolIEs__item__id_tab_val_Value_1,
        _____LWIPAdditionRequest_protocolIEs__item__id_tab_val_Value_2,
        _____LWIPAdditionRequest_protocolIEs__item__id_tab_val_Value_3,
        _____LWIPAdditionRequest_protocolIEs__item__id_tab_val_Value_4,
        _____LWIPAdditionRequest_protocolIEs__item__id_tab_val_Value_5,
        ___LWIPAdditionRequest_protocolIEs__item__id,
        ___LWIPAdditionRequest_protocolIEs__item__criticality,
        ___LWIPAdditionRequest_protocolIEs__item__value,
        __LWIPAdditionRequest_protocolIEs__item_,
        _LWIPAdditionRequest_protocolIEs,
        LWIPAdditionRequest,
        LWIPAdditionRequestIEs,
        _LWIPAdditionRequestIEs_val_Value_0,
        _LWIPAdditionRequestIEs_val_Value_1,
        _LWIPAdditionRequestIEs_val_Value_2,
        _LWIPAdditionRequestIEs_val_Value_3,
        _LWIPAdditionRequestIEs_val_Value_4,
        _LWIPAdditionRequestIEs_val_Value_5,
        ____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab,
        _____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____LWIPAdditionRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        ___LWIPAdditionRequestAcknowledge_protocolIEs__item__id,
        ___LWIPAdditionRequestAcknowledge_protocolIEs__item__criticality,
        ___LWIPAdditionRequestAcknowledge_protocolIEs__item__value,
        __LWIPAdditionRequestAcknowledge_protocolIEs__item_,
        _LWIPAdditionRequestAcknowledge_protocolIEs,
        LWIPAdditionRequestAcknowledge,
        LWIPAdditionRequestAcknowledgeIEs,
        _LWIPAdditionRequestAcknowledgeIEs_val_Value_0,
        _LWIPAdditionRequestAcknowledgeIEs_val_Value_1,
        _LWIPAdditionRequestAcknowledgeIEs_val_Value_2,
        _LWIPAdditionRequestAcknowledgeIEs_val_Value_3,
        _LWIPAdditionRequestAcknowledgeIEs_val_Value_4,
        _LWIPAdditionRequestAcknowledgeIEs_val_Value_5,
        ____LWIPAdditionRequestReject_protocolIEs__item__id_tab,
        _____LWIPAdditionRequestReject_protocolIEs__item__id_tab_val_Value_0,
        _____LWIPAdditionRequestReject_protocolIEs__item__id_tab_val_Value_1,
        _____LWIPAdditionRequestReject_protocolIEs__item__id_tab_val_Value_2,
        ___LWIPAdditionRequestReject_protocolIEs__item__id,
        ___LWIPAdditionRequestReject_protocolIEs__item__criticality,
        ___LWIPAdditionRequestReject_protocolIEs__item__value,
        __LWIPAdditionRequestReject_protocolIEs__item_,
        _LWIPAdditionRequestReject_protocolIEs,
        LWIPAdditionRequestReject,
        LWIPAdditionRequestRejectIEs,
        _LWIPAdditionRequestRejectIEs_val_Value_0,
        _LWIPAdditionRequestRejectIEs_val_Value_1,
        _LWIPAdditionRequestRejectIEs_val_Value_2,
        ____LWIPModificationRequest_protocolIEs__item__id_tab,
        _____LWIPModificationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____LWIPModificationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____LWIPModificationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____LWIPModificationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____LWIPModificationRequest_protocolIEs__item__id_tab_val_Value_4,
        ___LWIPModificationRequest_protocolIEs__item__id,
        ___LWIPModificationRequest_protocolIEs__item__criticality,
        ___LWIPModificationRequest_protocolIEs__item__value,
        __LWIPModificationRequest_protocolIEs__item_,
        _LWIPModificationRequest_protocolIEs,
        LWIPModificationRequest,
        LWIPModificationRequestIEs,
        _LWIPModificationRequestIEs_val_Value_0,
        _LWIPModificationRequestIEs_val_Value_1,
        _LWIPModificationRequestIEs_val_Value_2,
        _LWIPModificationRequestIEs_val_Value_3,
        _LWIPModificationRequestIEs_val_Value_4,
        ____LWIPModificationRequestAcknowledge_protocolIEs__item__id_tab,
        _____LWIPModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____LWIPModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____LWIPModificationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        ___LWIPModificationRequestAcknowledge_protocolIEs__item__id,
        ___LWIPModificationRequestAcknowledge_protocolIEs__item__criticality,
        ___LWIPModificationRequestAcknowledge_protocolIEs__item__value,
        __LWIPModificationRequestAcknowledge_protocolIEs__item_,
        _LWIPModificationRequestAcknowledge_protocolIEs,
        LWIPModificationRequestAcknowledge,
        LWIPModificationRequestAcknowledgeIEs,
        _LWIPModificationRequestAcknowledgeIEs_val_Value_0,
        _LWIPModificationRequestAcknowledgeIEs_val_Value_1,
        _LWIPModificationRequestAcknowledgeIEs_val_Value_2,
        ____LWIPModificationRequestReject_protocolIEs__item__id_tab,
        _____LWIPModificationRequestReject_protocolIEs__item__id_tab_val_Value_0,
        _____LWIPModificationRequestReject_protocolIEs__item__id_tab_val_Value_1,
        _____LWIPModificationRequestReject_protocolIEs__item__id_tab_val_Value_2,
        _____LWIPModificationRequestReject_protocolIEs__item__id_tab_val_Value_3,
        ___LWIPModificationRequestReject_protocolIEs__item__id,
        ___LWIPModificationRequestReject_protocolIEs__item__criticality,
        ___LWIPModificationRequestReject_protocolIEs__item__value,
        __LWIPModificationRequestReject_protocolIEs__item_,
        _LWIPModificationRequestReject_protocolIEs,
        LWIPModificationRequestReject,
        LWIPModificationRequestRejectIEs,
        _LWIPModificationRequestRejectIEs_val_Value_0,
        _LWIPModificationRequestRejectIEs_val_Value_1,
        _LWIPModificationRequestRejectIEs_val_Value_2,
        _LWIPModificationRequestRejectIEs_val_Value_3,
        ____LWIPReleaseRequest_protocolIEs__item__id_tab,
        _____LWIPReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        _____LWIPReleaseRequest_protocolIEs__item__id_tab_val_Value_1,
        _____LWIPReleaseRequest_protocolIEs__item__id_tab_val_Value_2,
        ___LWIPReleaseRequest_protocolIEs__item__id,
        ___LWIPReleaseRequest_protocolIEs__item__criticality,
        ___LWIPReleaseRequest_protocolIEs__item__value,
        __LWIPReleaseRequest_protocolIEs__item_,
        _LWIPReleaseRequest_protocolIEs,
        LWIPReleaseRequest,
        LWIPReleaseRequest_IEs,
        _LWIPReleaseRequest_IEs_val_Value_0,
        _LWIPReleaseRequest_IEs_val_Value_1,
        _LWIPReleaseRequest_IEs_val_Value_2,
        ____LWIPReleaseRequired_protocolIEs__item__id_tab,
        _____LWIPReleaseRequired_protocolIEs__item__id_tab_val_Value_0,
        _____LWIPReleaseRequired_protocolIEs__item__id_tab_val_Value_1,
        _____LWIPReleaseRequired_protocolIEs__item__id_tab_val_Value_2,
        ___LWIPReleaseRequired_protocolIEs__item__id,
        ___LWIPReleaseRequired_protocolIEs__item__criticality,
        ___LWIPReleaseRequired_protocolIEs__item__value,
        __LWIPReleaseRequired_protocolIEs__item_,
        _LWIPReleaseRequired_protocolIEs,
        LWIPReleaseRequired,
        LWIPReleaseRequiredIEs,
        _LWIPReleaseRequiredIEs_val_Value_0,
        _LWIPReleaseRequiredIEs_val_Value_1,
        _LWIPReleaseRequiredIEs_val_Value_2,
        ____LWIPReleaseConfirm_protocolIEs__item__id_tab,
        _____LWIPReleaseConfirm_protocolIEs__item__id_tab_val_Value_0,
        _____LWIPReleaseConfirm_protocolIEs__item__id_tab_val_Value_1,
        _____LWIPReleaseConfirm_protocolIEs__item__id_tab_val_Value_2,
        ___LWIPReleaseConfirm_protocolIEs__item__id,
        ___LWIPReleaseConfirm_protocolIEs__item__criticality,
        ___LWIPReleaseConfirm_protocolIEs__item__value,
        __LWIPReleaseConfirm_protocolIEs__item_,
        _LWIPReleaseConfirm_protocolIEs,
        LWIPReleaseConfirm,
        LWIPReleaseConfirmIEs,
        _LWIPReleaseConfirmIEs_val_Value_0,
        _LWIPReleaseConfirmIEs_val_Value_1,
        _LWIPReleaseConfirmIEs_val_Value_2,
    ]

class XwAP_PDU_Descriptions:

    _name_  = u'XwAP-PDU-Descriptions'
    _oid_   = [0, 4, 0, 0, 21, 3, 8, 1, 0]
    
    _obj_ = [
        u'XWAP-ELEMENTARY-PROCEDURE',
        u'XwAP-PDU',
        u'InitiatingMessage',
        u'SuccessfulOutcome',
        u'UnsuccessfulOutcome',
        u'XWAP-ELEMENTARY-PROCEDURES',
        u'XWAP-ELEMENTARY-PROCEDURES-CLASS-1',
        u'XWAP-ELEMENTARY-PROCEDURES-CLASS-2',
        u'xwSetup',
        u'wTConfigurationUpdate',
        u'wTStatusReportingInitiation',
        u'wTStatusReporting',
        u'errorIndication',
        u'reset',
        u'wTAdditionPreparation',
        u'eNBInitiatedWTModification',
        u'wTInitiatedWTModification',
        u'eNBInitiatedWTRelease',
        u'wTInitiatedWTRelease',
        u'wTAssociationConfirmation',
        u'privateMessage',
        u'lWIPAdditionPreparation',
        u'eNBInitiatedLWIPModification',
        u'eNBInitiatedLWIPRelease',
        u'wTInitiatedLWIPRelease',
        ]
    _type_ = [
        u'XWAP-ELEMENTARY-PROCEDURE',
        u'XwAP-PDU',
        u'InitiatingMessage',
        u'SuccessfulOutcome',
        u'UnsuccessfulOutcome',
        ]
    _set_ = [
        u'XWAP-ELEMENTARY-PROCEDURES',
        u'XWAP-ELEMENTARY-PROCEDURES-CLASS-1',
        u'XWAP-ELEMENTARY-PROCEDURES-CLASS-2',
        ]
    _val_ = [
        u'xwSetup',
        u'wTConfigurationUpdate',
        u'wTStatusReportingInitiation',
        u'wTStatusReporting',
        u'errorIndication',
        u'reset',
        u'wTAdditionPreparation',
        u'eNBInitiatedWTModification',
        u'wTInitiatedWTModification',
        u'eNBInitiatedWTRelease',
        u'wTInitiatedWTRelease',
        u'wTAssociationConfirmation',
        u'privateMessage',
        u'lWIPAdditionPreparation',
        u'eNBInitiatedLWIPModification',
        u'eNBInitiatedLWIPRelease',
        u'wTInitiatedLWIPRelease',
        ]
    _class_ = [
        u'XWAP-ELEMENTARY-PROCEDURE',
        u'XWAP-ELEMENTARY-PROCEDURES',
        u'XWAP-ELEMENTARY-PROCEDURES-CLASS-1',
        u'XWAP-ELEMENTARY-PROCEDURES-CLASS-2',
        u'xwSetup',
        u'wTConfigurationUpdate',
        u'wTStatusReportingInitiation',
        u'wTStatusReporting',
        u'errorIndication',
        u'reset',
        u'wTAdditionPreparation',
        u'eNBInitiatedWTModification',
        u'wTInitiatedWTModification',
        u'eNBInitiatedWTRelease',
        u'wTInitiatedWTRelease',
        u'wTAssociationConfirmation',
        u'privateMessage',
        u'lWIPAdditionPreparation',
        u'eNBInitiatedLWIPModification',
        u'eNBInitiatedLWIPRelease',
        u'wTInitiatedLWIPRelease',
        ]
    _param_ = [
        ]
    
    #-----< XWAP-ELEMENTARY-PROCEDURE >-----#
    XWAP_ELEMENTARY_PROCEDURE = CLASS(name=u'XWAP-ELEMENTARY-PROCEDURE', mode=MODE_TYPE)
    _XWAP_ELEMENTARY_PROCEDURE_InitiatingMessage = OPEN(name=u'InitiatingMessage', mode=MODE_TYPE)
    _XWAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome = OPEN(name=u'SuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _XWAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome = OPEN(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _XWAP_ELEMENTARY_PROCEDURE_procedureCode = INT(name=u'procedureCode', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'ProcedureCode')), uniq=True)
    _XWAP_ELEMENTARY_PROCEDURE_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-CommonDataTypes', 'Criticality')), default=u'ignore')
    XWAP_ELEMENTARY_PROCEDURE._cont = ASN1Dict([
        (u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURE_InitiatingMessage),
        (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome),
        (u'UnsuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome),
        (u'procedureCode', _XWAP_ELEMENTARY_PROCEDURE_procedureCode),
        (u'criticality', _XWAP_ELEMENTARY_PROCEDURE_criticality),
        ])
    
    #-----< XwAP-PDU >-----#
    XwAP_PDU = CHOICE(name=u'XwAP-PDU', mode=MODE_TYPE)
    _XwAP_PDU_initiatingMessage = SEQ(name=u'initiatingMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'InitiatingMessage')))
    _XwAP_PDU_successfulOutcome = SEQ(name=u'successfulOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'SuccessfulOutcome')))
    _XwAP_PDU_unsuccessfulOutcome = SEQ(name=u'unsuccessfulOutcome', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'UnsuccessfulOutcome')))
    XwAP_PDU._cont = ASN1Dict([
        (u'initiatingMessage', _XwAP_PDU_initiatingMessage),
        (u'successfulOutcome', _XwAP_PDU_successfulOutcome),
        (u'unsuccessfulOutcome', _XwAP_PDU_unsuccessfulOutcome),
        ])
    XwAP_PDU._ext = []
    
    #-----< InitiatingMessage >-----#
    InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE)
    _InitiatingMessage_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __InitiatingMessage_procedureCode_tab = CLASS(name='_tab_XWAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'XwSetupRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'XwSetupResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'XwSetupFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTConfigurationUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTConfigurationUpdateAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTConfigurationUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'Reset')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'ResetResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAdditionRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAdditionRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAdditionRequestReject')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequestReject')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRefuse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTReleaseRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTReleaseConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPAdditionRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPAdditionRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_8 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPAdditionRequestReject')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPModificationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPModificationRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_9 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPModificationRequestReject')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPReleaseRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPReleaseConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAssociationConfirmation')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'PrivateMessage')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPReleaseRequest')))
    __InitiatingMessage_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1), (u'procedureCode', 1), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 2), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6), (u'procedureCode', 8), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7), (u'procedureCode', 10), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_8), (u'procedureCode', 13), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_9), (u'procedureCode', 14), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10), (u'SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10), (u'procedureCode', 16), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11), (u'procedureCode', 3), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12), (u'procedureCode', 4), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13), (u'procedureCode', 9), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16), (u'procedureCode', 15), (u'criticality', u'ignore')])], rr=[], ev=None, er=[])
    _InitiatingMessage_procedureCode._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_procedureCode._const_tab_at = None
    _InitiatingMessage_procedureCode._const_tab_id = u'procedureCode'
    _InitiatingMessage_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _InitiatingMessage_criticality._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_criticality._const_tab_at = ('..', u'procedureCode')
    _InitiatingMessage_criticality._const_tab_id = u'criticality'
    _InitiatingMessage_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE'), [u'InitiatingMessage']))
    _InitiatingMessage_value._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_value._const_tab_at = ('..', u'procedureCode')
    _InitiatingMessage_value._const_tab_id = u'InitiatingMessage'
    InitiatingMessage._cont = ASN1Dict([
        (u'procedureCode', _InitiatingMessage_procedureCode),
        (u'criticality', _InitiatingMessage_criticality),
        (u'value', _InitiatingMessage_value),
        ])
    InitiatingMessage._ext = None
    
    #-----< SuccessfulOutcome >-----#
    SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE)
    _SuccessfulOutcome_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __SuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_XWAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'XwSetupRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'XwSetupResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'XwSetupFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTConfigurationUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTConfigurationUpdateAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTConfigurationUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'Reset')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'ResetResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAdditionRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAdditionRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAdditionRequestReject')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequestReject')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRefuse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTReleaseRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTReleaseConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPAdditionRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPAdditionRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPAdditionRequestReject')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPModificationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPModificationRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPModificationRequestReject')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPReleaseRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPReleaseConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAssociationConfirmation')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'PrivateMessage')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPReleaseRequest')))
    __SuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), (u'procedureCode', 1), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 2), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), (u'procedureCode', 8), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), (u'procedureCode', 10), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8), (u'procedureCode', 13), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9), (u'procedureCode', 14), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), (u'procedureCode', 16), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), (u'procedureCode', 3), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), (u'procedureCode', 4), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), (u'procedureCode', 9), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), (u'procedureCode', 15), (u'criticality', u'ignore')])], rr=[], ev=None, er=[])
    _SuccessfulOutcome_procedureCode._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_procedureCode._const_tab_at = None
    _SuccessfulOutcome_procedureCode._const_tab_id = u'procedureCode'
    _SuccessfulOutcome_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _SuccessfulOutcome_criticality._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_criticality._const_tab_at = ('..', u'procedureCode')
    _SuccessfulOutcome_criticality._const_tab_id = u'criticality'
    _SuccessfulOutcome_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE'), [u'SuccessfulOutcome']))
    _SuccessfulOutcome_value._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_value._const_tab_at = ('..', u'procedureCode')
    _SuccessfulOutcome_value._const_tab_id = u'SuccessfulOutcome'
    SuccessfulOutcome._cont = ASN1Dict([
        (u'procedureCode', _SuccessfulOutcome_procedureCode),
        (u'criticality', _SuccessfulOutcome_criticality),
        (u'value', _SuccessfulOutcome_value),
        ])
    SuccessfulOutcome._ext = None
    
    #-----< UnsuccessfulOutcome >-----#
    UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE)
    _UnsuccessfulOutcome_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE'), [u'procedureCode']))
    __UnsuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_XWAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'XwSetupRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'XwSetupResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'XwSetupFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTConfigurationUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTConfigurationUpdateAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTConfigurationUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'Reset')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'ResetResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAdditionRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAdditionRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAdditionRequestReject')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequestReject')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRefuse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTReleaseRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTReleaseConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPAdditionRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPAdditionRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPAdditionRequestReject')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPModificationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPModificationRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPModificationRequestReject')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPReleaseRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPReleaseConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAssociationConfirmation')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'PrivateMessage')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPReleaseRequest')))
    __UnsuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), (u'procedureCode', 1), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), (u'procedureCode', 2), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6), (u'procedureCode', 8), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), (u'procedureCode', 10), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8), (u'procedureCode', 13), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9), (u'procedureCode', 14), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10), (u'procedureCode', 16), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), (u'procedureCode', 3), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), (u'procedureCode', 4), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), (u'procedureCode', 9), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), (u'procedureCode', 15), (u'criticality', u'ignore')])], rr=[], ev=None, er=[])
    _UnsuccessfulOutcome_procedureCode._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_procedureCode._const_tab_at = None
    _UnsuccessfulOutcome_procedureCode._const_tab_id = u'procedureCode'
    _UnsuccessfulOutcome_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _UnsuccessfulOutcome_criticality._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_criticality._const_tab_at = ('..', u'procedureCode')
    _UnsuccessfulOutcome_criticality._const_tab_id = u'criticality'
    _UnsuccessfulOutcome_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE'), [u'UnsuccessfulOutcome']))
    _UnsuccessfulOutcome_value._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_value._const_tab_at = ('..', u'procedureCode')
    _UnsuccessfulOutcome_value._const_tab_id = u'UnsuccessfulOutcome'
    UnsuccessfulOutcome._cont = ASN1Dict([
        (u'procedureCode', _UnsuccessfulOutcome_procedureCode),
        (u'criticality', _UnsuccessfulOutcome_criticality),
        (u'value', _UnsuccessfulOutcome_value),
        ])
    UnsuccessfulOutcome._ext = None
    
    #-----< XWAP-ELEMENTARY-PROCEDURES >-----#
    XWAP_ELEMENTARY_PROCEDURES = CLASS(name=u'XWAP-ELEMENTARY-PROCEDURES', mode=MODE_SET, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'XwSetupRequest')))
    _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'XwSetupResponse')))
    _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'XwSetupFailure')))
    _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTConfigurationUpdate')))
    _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTConfigurationUpdateAcknowledge')))
    _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTConfigurationUpdateFailure')))
    _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusRequest')))
    _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusResponse')))
    _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusFailure')))
    _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'Reset')))
    _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'ResetResponse')))
    _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAdditionRequest')))
    _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAdditionRequestAcknowledge')))
    _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAdditionRequestReject')))
    _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequest')))
    _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequestAcknowledge')))
    _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequestReject')))
    _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequired')))
    _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationConfirm')))
    _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRefuse')))
    _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTReleaseRequired')))
    _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTReleaseConfirm')))
    _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPAdditionRequest')))
    _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPAdditionRequestAcknowledge')))
    _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPAdditionRequestReject')))
    _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPModificationRequest')))
    _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPModificationRequestAcknowledge')))
    _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_9 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPModificationRequestReject')))
    _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPReleaseRequired')))
    _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPReleaseConfirm')))
    _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusReport')))
    _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'ErrorIndication')))
    _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTReleaseRequest')))
    _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAssociationConfirmation')))
    _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'PrivateMessage')))
    _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPReleaseRequest')))
    XWAP_ELEMENTARY_PROCEDURES._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1), (u'procedureCode', 1), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2), (u'procedureCode', 2), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6), (u'procedureCode', 8), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7), (u'procedureCode', 10), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8), (u'UnsuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8), (u'procedureCode', 13), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9), (u'UnsuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_9), (u'procedureCode', 14), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10), (u'procedureCode', 16), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11), (u'procedureCode', 3), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12), (u'procedureCode', 4), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13), (u'procedureCode', 9), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16), (u'procedureCode', 15), (u'criticality', u'ignore')])], rr=[], ev=[], er=[])
    
    #-----< XWAP-ELEMENTARY-PROCEDURES-CLASS-1 >-----#
    XWAP_ELEMENTARY_PROCEDURES_CLASS_1 = CLASS(name=u'XWAP-ELEMENTARY-PROCEDURES-CLASS-1', mode=MODE_SET, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'XwSetupRequest')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'XwSetupResponse')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'XwSetupFailure')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTConfigurationUpdate')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTConfigurationUpdateAcknowledge')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTConfigurationUpdateFailure')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusRequest')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusResponse')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusFailure')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'Reset')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'ResetResponse')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAdditionRequest')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAdditionRequestAcknowledge')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAdditionRequestReject')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequest')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequestAcknowledge')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequestReject')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequired')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationConfirm')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRefuse')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTReleaseRequired')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTReleaseConfirm')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPAdditionRequest')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPAdditionRequestAcknowledge')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_8 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPAdditionRequestReject')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPModificationRequest')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPModificationRequestAcknowledge')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPModificationRequestReject')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPReleaseRequired')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPReleaseConfirm')))
    XWAP_ELEMENTARY_PROCEDURES_CLASS_1._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0), (u'procedureCode', 0), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1), (u'procedureCode', 1), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2), (u'procedureCode', 2), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3), (u'procedureCode', 5), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4), (u'UnsuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4), (u'procedureCode', 6), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5), (u'procedureCode', 7), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6), (u'procedureCode', 8), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7), (u'procedureCode', 10), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8), (u'UnsuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_8), (u'procedureCode', 13), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9), (u'UnsuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9), (u'procedureCode', 14), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10), (u'SuccessfulOutcome', _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10), (u'procedureCode', 16), (u'criticality', u'reject')])], rr=[], ev=[], er=[])
    
    #-----< XWAP-ELEMENTARY-PROCEDURES-CLASS-2 >-----#
    XWAP_ELEMENTARY_PROCEDURES_CLASS_2 = CLASS(name=u'XWAP-ELEMENTARY-PROCEDURES-CLASS-2', mode=MODE_SET, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusReport')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'ErrorIndication')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTReleaseRequest')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAssociationConfirmation')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'PrivateMessage')))
    _XWAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPReleaseRequest')))
    XWAP_ELEMENTARY_PROCEDURES_CLASS_2._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0), (u'procedureCode', 3), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1), (u'procedureCode', 4), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2), (u'procedureCode', 9), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3), (u'procedureCode', 11), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4), (u'procedureCode', 12), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _XWAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5), (u'procedureCode', 15), (u'criticality', u'ignore')])], rr=[], ev=[], er=[])
    
    #-----< xwSetup >-----#
    xwSetup = CLASS(name=u'xwSetup', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    _xwSetup_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'XwSetupRequest')))
    _xwSetup_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'XwSetupResponse')))
    _xwSetup_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'XwSetupFailure')))
    xwSetup._val = dict([(u'InitiatingMessage', _xwSetup_val_InitiatingMessage), (u'SuccessfulOutcome', _xwSetup_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _xwSetup_val_UnsuccessfulOutcome), (u'procedureCode', 0), (u'criticality', u'reject')])
    
    #-----< wTConfigurationUpdate >-----#
    wTConfigurationUpdate = CLASS(name=u'wTConfigurationUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    _wTConfigurationUpdate_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTConfigurationUpdate')))
    _wTConfigurationUpdate_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTConfigurationUpdateAcknowledge')))
    _wTConfigurationUpdate_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTConfigurationUpdateFailure')))
    wTConfigurationUpdate._val = dict([(u'InitiatingMessage', _wTConfigurationUpdate_val_InitiatingMessage), (u'SuccessfulOutcome', _wTConfigurationUpdate_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _wTConfigurationUpdate_val_UnsuccessfulOutcome), (u'procedureCode', 1), (u'criticality', u'reject')])
    
    #-----< wTStatusReportingInitiation >-----#
    wTStatusReportingInitiation = CLASS(name=u'wTStatusReportingInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    _wTStatusReportingInitiation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusRequest')))
    _wTStatusReportingInitiation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusResponse')))
    _wTStatusReportingInitiation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusFailure')))
    wTStatusReportingInitiation._val = dict([(u'InitiatingMessage', _wTStatusReportingInitiation_val_InitiatingMessage), (u'SuccessfulOutcome', _wTStatusReportingInitiation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _wTStatusReportingInitiation_val_UnsuccessfulOutcome), (u'procedureCode', 2), (u'criticality', u'reject')])
    
    #-----< wTStatusReporting >-----#
    wTStatusReporting = CLASS(name=u'wTStatusReporting', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    _wTStatusReporting_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTStatusReport')))
    wTStatusReporting._val = dict([(u'InitiatingMessage', _wTStatusReporting_val_InitiatingMessage), (u'procedureCode', 3), (u'criticality', u'ignore')])
    
    #-----< errorIndication >-----#
    errorIndication = CLASS(name=u'errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    _errorIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'ErrorIndication')))
    errorIndication._val = dict([(u'InitiatingMessage', _errorIndication_val_InitiatingMessage), (u'procedureCode', 4), (u'criticality', u'ignore')])
    
    #-----< reset >-----#
    reset = CLASS(name=u'reset', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    _reset_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'Reset')))
    _reset_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'ResetResponse')))
    reset._val = dict([(u'InitiatingMessage', _reset_val_InitiatingMessage), (u'SuccessfulOutcome', _reset_val_SuccessfulOutcome), (u'procedureCode', 5), (u'criticality', u'reject')])
    
    #-----< wTAdditionPreparation >-----#
    wTAdditionPreparation = CLASS(name=u'wTAdditionPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    _wTAdditionPreparation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAdditionRequest')))
    _wTAdditionPreparation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAdditionRequestAcknowledge')))
    _wTAdditionPreparation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAdditionRequestReject')))
    wTAdditionPreparation._val = dict([(u'InitiatingMessage', _wTAdditionPreparation_val_InitiatingMessage), (u'SuccessfulOutcome', _wTAdditionPreparation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _wTAdditionPreparation_val_UnsuccessfulOutcome), (u'procedureCode', 6), (u'criticality', u'reject')])
    
    #-----< eNBInitiatedWTModification >-----#
    eNBInitiatedWTModification = CLASS(name=u'eNBInitiatedWTModification', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    _eNBInitiatedWTModification_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequest')))
    _eNBInitiatedWTModification_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequestAcknowledge')))
    _eNBInitiatedWTModification_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequestReject')))
    eNBInitiatedWTModification._val = dict([(u'InitiatingMessage', _eNBInitiatedWTModification_val_InitiatingMessage), (u'SuccessfulOutcome', _eNBInitiatedWTModification_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _eNBInitiatedWTModification_val_UnsuccessfulOutcome), (u'procedureCode', 7), (u'criticality', u'reject')])
    
    #-----< wTInitiatedWTModification >-----#
    wTInitiatedWTModification = CLASS(name=u'wTInitiatedWTModification', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    _wTInitiatedWTModification_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRequired')))
    _wTInitiatedWTModification_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationConfirm')))
    _wTInitiatedWTModification_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTModificationRefuse')))
    wTInitiatedWTModification._val = dict([(u'InitiatingMessage', _wTInitiatedWTModification_val_InitiatingMessage), (u'SuccessfulOutcome', _wTInitiatedWTModification_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _wTInitiatedWTModification_val_UnsuccessfulOutcome), (u'procedureCode', 8), (u'criticality', u'reject')])
    
    #-----< eNBInitiatedWTRelease >-----#
    eNBInitiatedWTRelease = CLASS(name=u'eNBInitiatedWTRelease', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    _eNBInitiatedWTRelease_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTReleaseRequest')))
    eNBInitiatedWTRelease._val = dict([(u'InitiatingMessage', _eNBInitiatedWTRelease_val_InitiatingMessage), (u'procedureCode', 9), (u'criticality', u'ignore')])
    
    #-----< wTInitiatedWTRelease >-----#
    wTInitiatedWTRelease = CLASS(name=u'wTInitiatedWTRelease', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    _wTInitiatedWTRelease_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTReleaseRequired')))
    _wTInitiatedWTRelease_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTReleaseConfirm')))
    wTInitiatedWTRelease._val = dict([(u'InitiatingMessage', _wTInitiatedWTRelease_val_InitiatingMessage), (u'SuccessfulOutcome', _wTInitiatedWTRelease_val_SuccessfulOutcome), (u'procedureCode', 10), (u'criticality', u'reject')])
    
    #-----< wTAssociationConfirmation >-----#
    wTAssociationConfirmation = CLASS(name=u'wTAssociationConfirmation', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    _wTAssociationConfirmation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'WTAssociationConfirmation')))
    wTAssociationConfirmation._val = dict([(u'InitiatingMessage', _wTAssociationConfirmation_val_InitiatingMessage), (u'procedureCode', 11), (u'criticality', u'ignore')])
    
    #-----< privateMessage >-----#
    privateMessage = CLASS(name=u'privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    _privateMessage_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'PrivateMessage')))
    privateMessage._val = dict([(u'InitiatingMessage', _privateMessage_val_InitiatingMessage), (u'procedureCode', 12), (u'criticality', u'ignore')])
    
    #-----< lWIPAdditionPreparation >-----#
    lWIPAdditionPreparation = CLASS(name=u'lWIPAdditionPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    _lWIPAdditionPreparation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPAdditionRequest')))
    _lWIPAdditionPreparation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPAdditionRequestAcknowledge')))
    _lWIPAdditionPreparation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPAdditionRequestReject')))
    lWIPAdditionPreparation._val = dict([(u'InitiatingMessage', _lWIPAdditionPreparation_val_InitiatingMessage), (u'SuccessfulOutcome', _lWIPAdditionPreparation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _lWIPAdditionPreparation_val_UnsuccessfulOutcome), (u'procedureCode', 13), (u'criticality', u'reject')])
    
    #-----< eNBInitiatedLWIPModification >-----#
    eNBInitiatedLWIPModification = CLASS(name=u'eNBInitiatedLWIPModification', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    _eNBInitiatedLWIPModification_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPModificationRequest')))
    _eNBInitiatedLWIPModification_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPModificationRequestAcknowledge')))
    _eNBInitiatedLWIPModification_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPModificationRequestReject')))
    eNBInitiatedLWIPModification._val = dict([(u'InitiatingMessage', _eNBInitiatedLWIPModification_val_InitiatingMessage), (u'SuccessfulOutcome', _eNBInitiatedLWIPModification_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _eNBInitiatedLWIPModification_val_UnsuccessfulOutcome), (u'procedureCode', 14), (u'criticality', u'reject')])
    
    #-----< eNBInitiatedLWIPRelease >-----#
    eNBInitiatedLWIPRelease = CLASS(name=u'eNBInitiatedLWIPRelease', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    _eNBInitiatedLWIPRelease_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPReleaseRequest')))
    eNBInitiatedLWIPRelease._val = dict([(u'InitiatingMessage', _eNBInitiatedLWIPRelease_val_InitiatingMessage), (u'procedureCode', 15), (u'criticality', u'ignore')])
    
    #-----< wTInitiatedLWIPRelease >-----#
    wTInitiatedLWIPRelease = CLASS(name=u'wTInitiatedLWIPRelease', mode=MODE_VALUE, typeref=ASN1RefType(('XwAP-PDU-Descriptions', 'XWAP-ELEMENTARY-PROCEDURE')))
    _wTInitiatedLWIPRelease_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPReleaseRequired')))
    _wTInitiatedLWIPRelease_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('XwAP-PDU-Contents', 'LWIPReleaseConfirm')))
    wTInitiatedLWIPRelease._val = dict([(u'InitiatingMessage', _wTInitiatedLWIPRelease_val_InitiatingMessage), (u'SuccessfulOutcome', _wTInitiatedLWIPRelease_val_SuccessfulOutcome), (u'procedureCode', 16), (u'criticality', u'reject')])
    
    _all_ = [
        _XWAP_ELEMENTARY_PROCEDURE_InitiatingMessage,
        _XWAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome,
        _XWAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome,
        _XWAP_ELEMENTARY_PROCEDURE_procedureCode,
        _XWAP_ELEMENTARY_PROCEDURE_criticality,
        XWAP_ELEMENTARY_PROCEDURE,
        _XwAP_PDU_initiatingMessage,
        _XwAP_PDU_successfulOutcome,
        _XwAP_PDU_unsuccessfulOutcome,
        XwAP_PDU,
        __InitiatingMessage_procedureCode_tab,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_8,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_9,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_9,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_10,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16,
        _InitiatingMessage_procedureCode,
        _InitiatingMessage_criticality,
        _InitiatingMessage_value,
        InitiatingMessage,
        __SuccessfulOutcome_procedureCode_tab,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        _SuccessfulOutcome_procedureCode,
        _SuccessfulOutcome_criticality,
        _SuccessfulOutcome_value,
        SuccessfulOutcome,
        __UnsuccessfulOutcome_procedureCode_tab,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        _UnsuccessfulOutcome_procedureCode,
        _UnsuccessfulOutcome_criticality,
        _UnsuccessfulOutcome_value,
        UnsuccessfulOutcome,
        XWAP_ELEMENTARY_PROCEDURES,
        _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0,
        _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0,
        _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0,
        _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1,
        _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1,
        _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1,
        _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2,
        _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2,
        _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2,
        _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3,
        _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3,
        _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4,
        _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4,
        _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_4,
        _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5,
        _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5,
        _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5,
        _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6,
        _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6,
        _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6,
        _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7,
        _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7,
        _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8,
        _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8,
        _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8,
        _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9,
        _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9,
        _XWAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_9,
        _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10,
        _XWAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10,
        _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11,
        _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12,
        _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13,
        _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14,
        _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15,
        _XWAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16,
        XWAP_ELEMENTARY_PROCEDURES_CLASS_1,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_4,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_8,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10,
        XWAP_ELEMENTARY_PROCEDURES_CLASS_2,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4,
        _XWAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5,
        xwSetup,
        _xwSetup_val_InitiatingMessage,
        _xwSetup_val_SuccessfulOutcome,
        _xwSetup_val_UnsuccessfulOutcome,
        wTConfigurationUpdate,
        _wTConfigurationUpdate_val_InitiatingMessage,
        _wTConfigurationUpdate_val_SuccessfulOutcome,
        _wTConfigurationUpdate_val_UnsuccessfulOutcome,
        wTStatusReportingInitiation,
        _wTStatusReportingInitiation_val_InitiatingMessage,
        _wTStatusReportingInitiation_val_SuccessfulOutcome,
        _wTStatusReportingInitiation_val_UnsuccessfulOutcome,
        wTStatusReporting,
        _wTStatusReporting_val_InitiatingMessage,
        errorIndication,
        _errorIndication_val_InitiatingMessage,
        reset,
        _reset_val_InitiatingMessage,
        _reset_val_SuccessfulOutcome,
        wTAdditionPreparation,
        _wTAdditionPreparation_val_InitiatingMessage,
        _wTAdditionPreparation_val_SuccessfulOutcome,
        _wTAdditionPreparation_val_UnsuccessfulOutcome,
        eNBInitiatedWTModification,
        _eNBInitiatedWTModification_val_InitiatingMessage,
        _eNBInitiatedWTModification_val_SuccessfulOutcome,
        _eNBInitiatedWTModification_val_UnsuccessfulOutcome,
        wTInitiatedWTModification,
        _wTInitiatedWTModification_val_InitiatingMessage,
        _wTInitiatedWTModification_val_SuccessfulOutcome,
        _wTInitiatedWTModification_val_UnsuccessfulOutcome,
        eNBInitiatedWTRelease,
        _eNBInitiatedWTRelease_val_InitiatingMessage,
        wTInitiatedWTRelease,
        _wTInitiatedWTRelease_val_InitiatingMessage,
        _wTInitiatedWTRelease_val_SuccessfulOutcome,
        wTAssociationConfirmation,
        _wTAssociationConfirmation_val_InitiatingMessage,
        privateMessage,
        _privateMessage_val_InitiatingMessage,
        lWIPAdditionPreparation,
        _lWIPAdditionPreparation_val_InitiatingMessage,
        _lWIPAdditionPreparation_val_SuccessfulOutcome,
        _lWIPAdditionPreparation_val_UnsuccessfulOutcome,
        eNBInitiatedLWIPModification,
        _eNBInitiatedLWIPModification_val_InitiatingMessage,
        _eNBInitiatedLWIPModification_val_SuccessfulOutcome,
        _eNBInitiatedLWIPModification_val_UnsuccessfulOutcome,
        eNBInitiatedLWIPRelease,
        _eNBInitiatedLWIPRelease_val_InitiatingMessage,
        wTInitiatedLWIPRelease,
        _wTInitiatedLWIPRelease_val_InitiatingMessage,
        _wTInitiatedLWIPRelease_val_SuccessfulOutcome,
    ]

init_modules(XwAP_CommonDataTypes, XwAP_Constants, XwAP_Containers, XwAP_IEs, XwAP_PDU_Contents, XwAP_PDU_Descriptions)
